package com.geocities.sbridgesgeo.debug;

/*
 * Copyright (C) 2000 Sean Bridges
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */



import java.lang.reflect.Modifier;
import java.util.Comparator;

class FieldAndNameComparator implements Comparator
{
public int compare(Object o1, Object o2)
{
	if(o1 == o2)
	{
		return 0;
	}

	FieldAndName f1 = (FieldAndName) o1;
	FieldAndName f2 = (FieldAndName) o2;

	//first is based on depth in hierarchy
	//find where the dots are, the larger index of the last dot
	//the higher in the hierarchy
	int l1 = f1.name.lastIndexOf('.');
	int l2 = f2.name.lastIndexOf('.');
	if(l1 != l2)
	{
		return l1 - l2;
	}

	//second comparison, finals are lower
	boolean s1 = Modifier.isFinal((f1.field.getModifiers()));
	boolean s2 = Modifier.isFinal((f2.field.getModifiers()));
	if(s1 != s2)
	{
		if(s1)
			return 1;
		else
			return -1;
	}

	//third is name
	return f1.field.getName().compareTo(f2.field.getName());

}
public boolean equals(Object obj)
{
	return obj == this;
}
}
