package com.ibm.aboutbeaneditor;
import java.awt.*;
import java.awt.event.MouseEvent;
import java.util.Vector;

// Referenced classes of package com.ibm.aboutbeaneditor:
//            ExtBaseTabbedPanel

public class ExtTabPanel extends ExtBaseTabbedPanel {

   Vector vPanels;
   String labels[];
   boolean bOsHack;

public ExtTabPanel() {
   this(0, 0, false);
}


public ExtTabPanel(int i) {
   this(i, 0, false);
}


public ExtTabPanel(int i, int j) {
   this(i, j, false);
}


public ExtTabPanel(int i, int j, boolean flag) {
   super(i, j, flag);
   labels = null;
   vPanels = new Vector();
   String s = System.getProperty("os.name");
   if (s.equals("Windows 95"))
      bOsHack = true;
   else
      bOsHack = false;
}


public ExtTabPanel(boolean flag) {
   this(0, 0, flag);
}


public Component add(Component component) {
   return add(component, -1);
}


public synchronized Component add(Component component, int i) {
   showTabPanel(addTabPanel(createDefaultLabel(vPanels.size()), true, component));
   updatePanelLabels();
   return component;
}


public synchronized Component add(String s, Component component) {
   return component;
}


public int addTabPanel(String s, boolean flag, Component component) {
   vPanels.addElement(component);
   return addTab(s, flag);
}


private String createDefaultLabel(int i) {
   String s = "tab - ";
   s = s + String.valueOf(i);
   return s;
}


public synchronized void enableTabPanel(boolean flag, int i) {
   if (i < 0 || i >= vPanels.size() || i == super.curIndex) {
      return;
   } else {
      enableTab(flag, i);
      return;
   }
}


public int getCurrentPanelNdx() {
   return super.curIndex;
}


public Dimension getMinimumSize() {
   Dimension dimension1 = new Dimension(0, 0);
   int i = vPanels.size();
   for (int j = 0; j < i; j++) {
      Component component = (Component) vPanels.elementAt(j);
      if (component != null) {
         Dimension dimension = component.getMinimumSize();
         if (dimension.width > dimension1.width)
            dimension1.width = dimension.width;
         if (dimension.height > dimension1.height)
            dimension1.height = dimension.height;
      }
   }

   Insets insets = getInsets();
   dimension1.width += insets.left + insets.right;
   dimension1.height += insets.top + insets.bottom;
   return dimension1;
}


public String[] getPanelLabels() {
   return labels;
}


public synchronized int getPanelTabIndex(Component component) {
   return vPanels.indexOf(component);
}


public Dimension getPreferredSize() {
   Dimension dimension1 = getSize();
   int i = vPanels.size();
   Insets insets = getInsets();
   dimension1.width -= insets.left + insets.right;
   dimension1.height -= insets.top + insets.bottom;
   if (dimension1.width < 0)
      dimension1.width = 0;
   if (dimension1.height < 0)
      dimension1.height = 0;
   for (int j = 0; j < i; j++) {
      Component component = (Component) vPanels.elementAt(j);
      if (component != null) {
         Dimension dimension = component.getMinimumSize();
         if (dimension.width > dimension1.width)
            dimension1.width = dimension.width;
         if (dimension.height > dimension1.height)
            dimension1.height = dimension.height;
         dimension = component.getPreferredSize();
         if (dimension.width > dimension1.width)
            dimension1.width = dimension.width;
         if (dimension.height > dimension1.height)
            dimension1.height = dimension.height;
      }
   }

   dimension1.width += insets.left + insets.right;
   dimension1.height += insets.top + insets.bottom;
   return dimension1;
}


public synchronized Component getTabPanel(int i) {
   if (i < 0 || i >= vPanels.size())
      return null;
   Component component = null;
   try {
      component = (Component) vPanels.elementAt(i);
   } catch (ArrayIndexOutOfBoundsException _ex) {
   }
   return component;
}


public int getTabsCount() {
   return vPanels.size();
}


public boolean getTabsOnBottom() {
   return getTabsPosition() != 0;
}


public void mousePressed(MouseEvent mouseevent) {
   super.mousePressed(mouseevent);
   showTabPanel(getCurrentPanelNdx());
}


public synchronized void remove(Component component) {
   int i = getPanelTabIndex(component);
   if (getTabsCount() == 1) {
      removeAllTabPanels();
   } else {
      if (i == 0)
         showTabPanel(1);
      else
         showTabPanel(i - 1);
      removeTabPanel(i);
   }
}


public synchronized void removeAllTabPanels() {
   vPanels = new Vector();
   super.curIndex = -1;
   removeAllTabs();
}


public synchronized void removeTabPanel(int i) {
   if (i < 0 || i >= vPanels.size() || i == super.curIndex)
      return;
   try {
      Component component = (Component) vPanels.elementAt(i);
      super.remove(component);
      vPanels.removeElementAt(i);
   } catch (ArrayIndexOutOfBoundsException _ex) {
   }
   removeTab(i);
}


public void setCurrentPanelNdx(int i) {
   showTabPanel(i);
}


public void setPanelLabels(String as[]) {
   labels = as;
   updatePanelLabels();
}


public synchronized void setTabPanel(String s, boolean flag, Component component, int i) {
   if (i < 0 || i >= vPanels.size())
      return;
   if (i == getCurrentPanelNdx() && !flag)
      return;
   try {
      vPanels.setElementAt(component, i);
      setTab(s, flag, i);
   } catch (ArrayIndexOutOfBoundsException _ex) {
   }
}


public void setTabsOnBottom(boolean flag) {
   setTabsInfo(flag ? 1 : 0, flag ? 1 : 0);
   doLayout();
}


public void setVisible(boolean flag) {
   if (isVisible() == flag) {
      return;
   } else {
      super.setVisible(flag);
      showTabPanel(getCurrentPanelNdx());
      return;
   }
}


public synchronized void showTabPanel(int i) {
   if (tabIsEnabled(i))
      try {
         Component component = (Component) vPanels.elementAt(i);
         showTab(i);
         showPanel(component);
         if (component instanceof Container) {
            Container container = (Container) component;
            for (int j = 0; j < container.getComponentCount(); j++)
               if (container.getComponent(j) instanceof ScrollPane)
                  container.getComponent(j).setVisible(true);

         }
      } catch (ArrayIndexOutOfBoundsException _ex) {
      }
}


public void updatePanelLabels() {
   try {
      for (int i = 0; i < vPanels.size(); i++) {
         String s;
         if (labels != null)
            try {
               s = labels[i];
            } catch (ArrayIndexOutOfBoundsException _ex) {
               s = createDefaultLabel(i);
            } else
            s = createDefaultLabel(i);
         setLabel(s, i);
      }

   } catch (Throwable _ex) {
   }
}
}