package com.ibm.aboutbeaneditor;
import java.awt.*;

public class ImageComponent extends Component {

   private Image image;
   private boolean elastic;
   private boolean frame;
   private float correlation;

public ImageComponent(Image image1) {
   this(image1, false);
}


public ImageComponent(Image image1, boolean flag) {
   elastic = false;
   frame = false;
   elastic = flag;
   setImage(image1);
}


public ImageComponent(Image image1, boolean flag, boolean flag1) {
   elastic = false;
   frame = false;
   elastic = flag;
   frame = flag1;
   setImage(image1);
}


public Image getImage() {
   return image;
}


public Dimension getPreferredSize() {
   if (image == null)
      return super.getPreferredSize();
   if (frame)
      return new Dimension(image.getWidth(this) + 4, image.getHeight(this) + 4);
   else
      return new Dimension(image.getWidth(this), image.getHeight(this));
}


public void paint(Graphics g) {
   if (image != null) {
      if (elastic) {
         int i = getPreferredSize().width;
         int j = getPreferredSize().height;
         Dimension dimension = getSize();
         if (dimension.width > i && dimension.height > j)
            if ((float) dimension.width / (float) dimension.height > correlation) {
               j = dimension.height;
               i = (int) ((float) j * correlation);
            } else {
               i = dimension.width;
               j = (int) ((float) i / correlation);
            }
         if (frame) {
            g.drawImage(image, 2, 2, i - 4, j - 4, this);
            g.drawRect(0, 0, i - 1, j - 1);
         } else {
            g.drawImage(image, 0, 0, i, j, this);
         }
      } else if (frame) {
         g.drawImage(image, 2, 2, this);
         g.drawRect(0, 0, getSize().width - 1, getSize().height - 1);
      } else {
         g.drawImage(image, 0, 0, this);
      }
   } else {
      super.paint(g);
   }
}


public void setImage(Image image1) {
   if (image1 == null)
      return;
   MediaTracker mediatracker = new MediaTracker(this);
   mediatracker.addImage(image1, 1);
   try {
      mediatracker.waitForAll();
      image = image1;
      correlation = (float) getPreferredSize().width / (float) getPreferredSize().height;
      if (!elastic)
         setSize(getPreferredSize());
   } catch (Exception exception) {
      exception.printStackTrace();
   }
}
}