package com.ibm.easyswing;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

import javax.swing.*;

import com.ibm.easyswing.event.AdditionalItemStateChangedEvent;
import com.ibm.easyswing.event.AdditionalItemStateChangedListener;

public class BoundJCheckBox extends JCheckBox implements ItemListener {

	private boolean _selected;

	public BoundJCheckBox() {
		_selected = false;
	}

	public BoundJCheckBox(String s) {
		super(s);
		_selected = false;
	}

	public BoundJCheckBox(String s, Icon icon) {
		super(s, icon);
		_selected = false;
	}

	public BoundJCheckBox(String s, Icon icon, boolean flag) {
		super(s, icon, flag);
		_selected = false;
	}

	public BoundJCheckBox(String s, boolean flag) {
		super(s, flag);
		_selected = false;
	}

	public BoundJCheckBox(Icon icon) {
		super(icon);
		_selected = false;
	}

	public BoundJCheckBox(Icon icon, boolean flag) {
		super(icon, flag);
		_selected = false;
	}

	public void addAdditionalItemStateChangedListener(AdditionalItemStateChangedListener additionalitemstatechangedlistener) {
		super.listenerList.add(AdditionalItemStateChangedListener.class, additionalitemstatechangedlistener);
	}

	protected void fireAdditionalItemStateChanged(AdditionalItemStateChangedEvent additionalitemstatechangedevent) {
		Object aobj[] = super.listenerList.getListenerList();
		for (int i = aobj.length - 2; i >= 0; i -= 2)
			if ((AdditionalItemStateChangedListener.class) == aobj[i])
				if (additionalitemstatechangedevent.getState())
					((AdditionalItemStateChangedListener) aobj[i + 1]).changedToSelected(
						additionalitemstatechangedevent);
				else
					((AdditionalItemStateChangedListener) aobj[i + 1]).changedToUnselected(
						additionalitemstatechangedevent);

	}

	public String getAboutThisBean() {
		return getClass().getName() + "^BoundJCheckBox^2.0^/easyswing/docs/index.html";
	}

	public void itemStateChanged(ItemEvent itemevent) {
		if (getModel() == itemevent.getSource() && _selected != getModel().isSelected()) {
			_selected = !_selected;
			firePropertyChange("selected", Boolean.valueOf(!_selected), Boolean.valueOf(_selected));
			fireAdditionalItemStateChanged(new AdditionalItemStateChangedEvent(this, _selected));
		}
	}

	public void removeAdditionalItemStateChangedListener(AdditionalItemStateChangedListener additionalitemstatechangedlistener) {
		super.listenerList.remove(
			AdditionalItemStateChangedListener.class,
			additionalitemstatechangedlistener);
	}

	public void setAboutThisBean(String s) {
	}

	public void setModel(ButtonModel buttonmodel) throws IllegalArgumentException {
		if (buttonmodel == null)
			throw new IllegalArgumentException("null model");
		if (getModel() != null)
			getModel().removeItemListener(this);
		super.setModel(buttonmodel);
		buttonmodel.addItemListener(this);
	}
}