package com.ibm.easyswing;
import javax.swing.JTextField;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.text.Document;

public class BoundJTextField extends JTextField implements DocumentListener {

	private String currentText;
	private String oldLast;
	private boolean setText;
	private boolean b;

	public BoundJTextField() {
		currentText = "";
		oldLast = "";

		setText = false;
		b = false;
	}

	public BoundJTextField(int i) {
		super(i);
		currentText = "";
		oldLast = "";

		setText = false;
		b = false;
	}

	public BoundJTextField(String s) {
		super(s);
		currentText = "";
		oldLast = "";

		setText = false;
		b = false;
	}

	public BoundJTextField(String s, int i) {
		super(s, i);
		currentText = "";
		oldLast = "";

		setText = false;
		b = false;
	}

	public BoundJTextField(Document document, String s, int i) {
		super(document, s, i);
		currentText = "";
		oldLast = "";

		setText = false;
		b = false;
	}

	public void changedUpdate(DocumentEvent documentevent) {
		checkTextChanges();
	}

	private void checkTextChanges() {
		String s = super.getText();
		String s1 = currentText;
		if (currentText == null && s != null || currentText != null && !currentText.equals(s)) {
			currentText = s;
			if (!setText) {
				firePropertyChange("text", s1, currentText);
				return;
			}
			if (!b)
				firePropertyChange("text", s1, currentText);
			b = true;
		}
	}

	public String getAboutThisBean() {
		return getClass().getName() + "^BoundJTextField^2.0^/easyswing/docs/index.html";
	}

	public void insertUpdate(DocumentEvent documentevent) {
		checkTextChanges();
	}

	public void removeUpdate(DocumentEvent documentevent) {
		checkTextChanges();
	}

	public void setAboutThisBean(String s) {
	}

	public void setDocument(Document document) {
		if (document == null)
			document = createDefaultModel();
		if (getDocument() != null)
			getDocument().removeDocumentListener(this);
		super.setDocument(document);
		document.addDocumentListener(this);
	}

	public void setText(String s) {
		oldLast = getText();
		if (oldLast.equals(s)) {
			return;
		} else {
			setText = true;
			super.setText(s);
			b = false;
			setText = false;
			return;
		}
	}
}