package com.ibm.easyswing;
import java.io.Serializable;
import java.util.Vector;

import javax.swing.*;

public class CBDefModel extends AbstractListModel implements ComboBoxModel, Serializable {

   Vector objects;
   Object selectedObject;

public CBDefModel() {
   objects = new Vector();
}


public CBDefModel(Object aobj[]) {
   objects = new Vector();
   if (aobj == null)
      throw new IllegalArgumentException("items is null");
   int i = 0;
   for (int j = aobj.length; i < j; i++)
      objects.addElement(aobj[i]);

}


public CBDefModel(Vector vector) {
   objects = new Vector();
   if (vector == null || vector.size() == 0)
      throw new IllegalArgumentException("v is null");
   int i = 0;
   for (int j = vector.size(); i < j; i++)
      objects.addElement(vector.elementAt(i));

}


void addObject(Object obj) {
   objects.addElement(obj);
   fireIntervalAdded(this, objects.size(), objects.size());
}


public Object getElementAt(int i) {
   if (i >= 0 && i < objects.size())
      return objects.elementAt(i);
   else
      return null;
}


public int getIndexOf(Object obj) {
   return objects.indexOf(obj);
}


public Object getSelectedItem() {
   return selectedObject;
}


public int getSize() {
   return objects.size();
}


void insertObjectAt(Object obj, int i) {
   if (i < 0 || i > objects.size()) {
      return;
   } else {
      objects.insertElementAt(obj, i);
      fireIntervalAdded(this, i, i);
      return;
   }
}


void removeAllObjects() {
   int i = 0;
   int j = objects.size() - 1;
   objects.removeAllElements();
   fireIntervalRemoved(this, i, j);
}


void removeObject(Object obj) {
   int i = objects.indexOf(obj);
   if (i != -1)
      removeObjectAt(i);
}


void removeObjectAt(int i) {
   if (i < 0 || i >= objects.size()) {
      return;
   } else {
      objects.removeElementAt(i);
      fireIntervalRemoved(this, i, i);
      return;
   }
}


public void setSelectedItem(Object obj) {
   selectedObject = obj;
   fireContentsChanged(this, -1, -1);
}
}