package com.jgoodies.animation;

/*
 * Copyright (c) 2003 JGoodies Karsten Lentzsch. All Rights Reserved.
 *
 * This software is the proprietary information of JGoodies Karsten Lentzsch.
 * Use is subject to license terms.
 *
 */

/**
 * An abstract adapter that implements the <code>AnimationListener</code> 
 * interface; consists only of methods with empty bodies - that do nothing.
 * This class minimizes the effort required to write animation listeners.
 *
 * @author Karsten Lentzsch
 */
public class AnimationAdapter implements AnimationListener {

    /**
     * Invoked if the animation has been started.
     * 
     * @param e  the related <code>AnimationEvent</code>
     */
    public void animationStarted(AnimationEvent e) {}

    /**
     * Invoked if the animation has been stopped.
     * 
     * @param e  the related <code>AnimationEvent</code>
     */
    public void animationStopped(AnimationEvent e) {}
    
}