package com.jgoodies.animation;

/*
 * Copyright (c) 2003 JGoodies Karsten Lentzsch. All Rights Reserved.
 *
 * This software is the proprietary information of JGoodies Karsten Lentzsch.
 * Use is subject to license terms.
 *
 */

import java.util.EventListener;

/**
 * Defines an interface for objects that listen to animation events.
 *
 * @author Karsten Lentzsch
 */
public interface AnimationListener extends EventListener {

    /**
     * Invoked, if the animation has been started.
     * 
     * @param e  the related <code>AnimationEvent</code>
     */
    void animationStarted(AnimationEvent e);

    /**
     * Invoked, if the animation has been stopped.
     * 
     * @param e  the related <code>AnimationEvent</code>
     */
    void animationStopped(AnimationEvent e);
}