package com.jgoodies.animation;

/*
 * Copyright (c) 2003 JGoodies Karsten Lentzsch. All Rights Reserved.
 *
 * This software is the proprietary information of JGoodies Karsten Lentzsch.
 * Use is subject to license terms.
 *
 */

import java.awt.Graphics2D;

/**
 * This interface describes renderers for use in animations and so helps build
 * render containers and animated panels.
 *
 * @author Karsten Lentzsch
 */
public interface AnimationRenderer {

    /**
     * Renders the animation on the specified graphics object
     * using the given width and height.
     * 
     * @param g2     the graphics to render on
     * @param width  the used width of the render surface
     * @param height the used height of the render surface
     */
    void render(Graphics2D g2, int width, int height);
    
}