package com.jgoodies.animation.renderer;

/*
 * Copyright (c) 2002 Karsten Lentzsch. All Rights Reserved.
 *
 * This software is the proprietary information of Karsten Lentzsch.  
 * Use is subject to license terms.
 *
 */
 
/**
 * Used to vertically align texts by using the capital or text ascent,
 * or the text's height.
 *
 * @author Karsten Lentzsch
 */
public final class HeightMode {
	
	private final String name;

	public static final HeightMode CAPITAL_ASCENT =
		new HeightMode("Capital ascent");
		
	public static final HeightMode TEXT_ASCENT = 
		new HeightMode("Text ascent");
		
	public static final HeightMode TEXT_HEIGHT = 
		new HeightMode("Text height");

	private HeightMode(String name) {
		this.name = name;
	}

	public String toString() {
		return name;
	}

}