package com.magelang.box;

import java.awt.*;
import java.beans.Beans;

public class BoxAdapter extends Container {
	private static Dimension empty = new Dimension(0, 0);
	private static Dimension dummy = new Dimension(20, 20);
	private static Dimension max = new Dimension(Short.MAX_VALUE, Short.MAX_VALUE);
	private Dimension dim = new Dimension(0, 0);
	private boolean fieldStretchVertical = false;
	private boolean fieldStretchHorizontal = false;
	private boolean fieldShrinkVertical = false;
	private boolean fieldShrinkHorizontal = false;
	public BoxAdapter() {
		super();
		setLayout(new GridLayout(1, 0));
	}
	public Dimension getMaximumSize() {
		if (getStretchVertical() && getStretchHorizontal())
			return max;
		Dimension pref = getPreferredSize();
		dim.height = getStretchVertical() ? Short.MAX_VALUE : pref.height;
		dim.width = getStretchHorizontal() ? Short.MAX_VALUE : pref.width;
		return dim;
	}
	public Dimension getMinimumSize() {
		if (getShrinkVertical() && getShrinkHorizontal())
			return empty;
		Dimension pref = getPreferredSize();
		dim.height = getShrinkVertical() ? 0 : pref.height;
		dim.width = getShrinkHorizontal() ? 0 : pref.width;
		return dim;
	}
	public Dimension getPreferredSize() {
		if (Beans.isDesignTime() && getComponentCount() == 0)
			return dummy;
		return super.getPreferredSize();
	}
	public boolean getShrinkHorizontal() {
		return fieldShrinkHorizontal;
	}
	public boolean getShrinkVertical() {
		return fieldShrinkVertical;
	}
	public boolean getStretchHorizontal() {
		return fieldStretchHorizontal;
	}
	public boolean getStretchVertical() {
		return fieldStretchVertical;
	}
	public void paint(Graphics g) {
		if (Beans.isDesignTime() && getComponentCount() == 0) {
			Color oldColor = g.getColor();
			g.setColor(Color.red);
			g.drawRect(1, 7, 12, 12);
			g.drawLine(1, 7, 7, 1);
			g.drawLine(13, 7, 19, 1);
			g.drawLine(13, 19, 19, 13);
			g.drawLine(7, 1, 19, 1);
			g.drawLine(19, 1, 19, 13);
			g.setColor(oldColor);
		} else
			super.paint(g);
	}
	public void setShrinkHorizontal(boolean shrinkHorizontal) {
		fieldShrinkHorizontal = shrinkHorizontal;
	}
	public void setShrinkVertical(boolean shrinkVertical) {
		fieldShrinkVertical = shrinkVertical;
	}
	public void setStretchHorizontal(boolean stretchHorizontal) {
		fieldStretchHorizontal = stretchHorizontal;
	}
	public void setStretchVertical(boolean stretchVertical) {
		fieldStretchVertical = stretchVertical;
	}
}
