package de.uniwue.ki.gui.mas.application;
import java.awt.Component;
import java.io.File;

import javax.swing.*;

import junit.framework.Assert;
import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.util.IFrameFactory;
import de.uniwue.ki.gui.util.mdi.MDIDesktopPane;
/**
 * Creation date: (17.10.2000 14:23:28)
 * 
 * @author Christoph Oechslein
 */

public class SeSAmDesktopPane extends JPanel implements IFrameFactory {
	private MDIDesktopPane ivjDesktopPaneIntern = null;
	private SeSAmDesktopPaneHelper ivjSeSAmDesktopPaneHelper = null;
	private SeSAmMainDesktopFrame _seSAmMainDesktopFrame;
	private JScrollPane ivjJScrollPane = null;

	public SeSAmDesktopPane() {
		super();
		initialize();
	}

	public void addInternalFrame(JInternalFrame internalFrame) {
		getDesktopPaneIntern().add(internalFrame);
	}

	public void addModalPanel(Component parent, String title, JOptionPane optionPane) {
		getSeSAmDesktopPaneHelper().getFrameFactory().addModalPanel(parent, title, optionPane);
	}

	public JRootPane addPanel(
		Component parent,
		String title,
		Component component,
		boolean shouldTheFrameBeShown) {
		return getSeSAmDesktopPaneHelper().getFrameFactory().addPanel(
			parent,
			title,
			component,
			shouldTheFrameBeShown);
	}

	public JRootPane addPanel(
		Component parent,
		String title,
		Component component,
		boolean shouldTheFrameBeShown,
		int windowCloseOperation) {
		return getSeSAmDesktopPaneHelper().getFrameFactory().addPanel(
			parent,
			title,
			component,
			shouldTheFrameBeShown,
			windowCloseOperation);
	}

	public JRootPane addPanel(
		Component parent,
		String title,
		Component component,
		boolean shouldTheFrameBeShown,
		int windowCloseOperation,
		Runnable windowCloseFunction) {
		return getSeSAmDesktopPaneHelper().getFrameFactory().addPanel(
			parent,
			title,
			component,
			shouldTheFrameBeShown,
			windowCloseOperation,
			windowCloseFunction);
	}

	private void connEtoM1() {
		try {

			setSeSAmDesktopPaneHelper(this.createNewSeSAmDesktopPaneHelper());

		} catch (Throwable ivjExc) {

			handleException(ivjExc);
		}
	}

	protected SeSAmDesktopPaneHelper createNewSeSAmDesktopPaneHelper() {
		return new SeSAmDesktopPaneHelper(this);
	}

	public MDIDesktopPane getDesktopPane() {
		return getDesktopPaneIntern();
	}

	private MDIDesktopPane getDesktopPaneIntern() {
		if (ivjDesktopPaneIntern == null) {
			try {
				ivjDesktopPaneIntern = new de.uniwue.ki.gui.util.mdi.MDIDesktopPane();
				ivjDesktopPaneIntern.setName("DesktopPaneIntern");
				ivjDesktopPaneIntern.setBounds(0, 0, 315, 302);

				// ghost moving on @see
				// http://java.sun.com/products/jfc/tsc/articles/performance/index.html
				ivjDesktopPaneIntern.putClientProperty("JDesktopPane.dragMode", "outline");

			} catch (Throwable ivjExc) {

				handleException(ivjExc);
			}
		}
		return ivjDesktopPaneIntern;
	}

	public IGUISeSAmDeclaration getGUISeSAmDeclaration() {
		return getSeSAmDesktopPaneHelper().getGUISeSAmDeclaration();
	}

	private javax.swing.JScrollPane getJScrollPane() {
		if (ivjJScrollPane == null) {
			try {
				ivjJScrollPane = new javax.swing.JScrollPane();
				ivjJScrollPane.setName("JScrollPane");
				getJScrollPane().setViewportView(getDesktopPaneIntern());

			} catch (Throwable ivjExc) {

				handleException(ivjExc);
			}
		}
		return ivjJScrollPane;
	}

	private SeSAmDesktopPaneHelper getSeSAmDesktopPaneHelper() {

		return ivjSeSAmDesktopPaneHelper;
	}
	
	public SeSAmMainDesktopFrame getSeSAmMainDesktopFrame() {
		return _seSAmMainDesktopFrame;
	}

	private void handleException(Throwable exception) {

		exception.printStackTrace(System.out);
	}

	private void initConnections() throws Exception {

	}

	private void initialize() {
		try {

			setName("SeSAmDesktopPane");
			setPreferredSize(new java.awt.Dimension(320, 200));
			setLayout(new javax.swing.BoxLayout(this, javax.swing.BoxLayout.X_AXIS));
			setSize(315, 302);
			setMinimumSize(new java.awt.Dimension(320, 200));
			add(getJScrollPane(), getJScrollPane().getName());
			initConnections();
			connEtoM1();
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}

	}

	public void loadModel(File file) {
		getSeSAmDesktopPaneHelper().loadModel(file);
	}

	public static void main(String[] args) {
		try {
			JFrame frame = new javax.swing.JFrame();
			SeSAmDesktopPane aSeSAmDesktopPane;
			aSeSAmDesktopPane = new SeSAmDesktopPane();
			frame.setContentPane(aSeSAmDesktopPane);
			frame.setSize(aSeSAmDesktopPane.getSize());
			frame.addWindowListener(new java.awt.event.WindowAdapter() {
				public void windowClosing(java.awt.event.WindowEvent e) {
					System.exit(0);
				}
			});

			aSeSAmDesktopPane.showAgentClassDeclarationList();
			aSeSAmDesktopPane.showWorldClassDeclarationList();

			frame.show();
			java.awt.Insets insets = frame.getInsets();
			frame.setSize(
				frame.getWidth() + insets.left + insets.right,
				frame.getHeight() + insets.top + insets.bottom);
			frame.setVisible(true);
		} catch (Exception exception) {
			System.err.println("Exception occurred in main() of javax.swing.JPanel");
			exception.printStackTrace(System.out);
		}
	}

	public void newModel() {

		getSeSAmDesktopPaneHelper().newModel();
	}

	public boolean openModel() {
		return getSeSAmDesktopPaneHelper().openModel();
	}

	public boolean saveAsModel() {
		return getSeSAmDesktopPaneHelper().saveAsModel();
	}

	public boolean saveModel() {
		return getSeSAmDesktopPaneHelper().saveModel();
	}

	private void setSeSAmDesktopPaneHelper(SeSAmDesktopPaneHelper newValue) {
		if (ivjSeSAmDesktopPaneHelper != newValue) {
			try {
				ivjSeSAmDesktopPaneHelper = newValue;

			} catch (Throwable ivjExc) {

				handleException(ivjExc);
			}
		}
	}

	protected String getDirectory() {
		return getSeSAmDesktopPaneHelper().getDirectory();
	}

	public void setSeSAmMainDesktopFrame(SeSAmMainDesktopFrame newSeSAmMainDesktopFrame) {
		if (Assert.ASSERTION_ON)
			Assert.assertNotNull(newSeSAmMainDesktopFrame);

		_seSAmMainDesktopFrame = newSeSAmMainDesktopFrame;
	}

	public void showAgentClassDeclarationList() {
		getSeSAmDesktopPaneHelper().showAgentClassDeclarationList();
	}

	public void showAnalysisDeclarationList() {
		getSeSAmDesktopPaneHelper().showAnalysisDeclarationList();
	}
	
	public void showUserInterfaceDeclarationList() {
		getSeSAmDesktopPaneHelper().showUserInterfaceDeclarationList();
	}

	public void showExperimentDeclarationList() {
		getSeSAmDesktopPaneHelper().showExperimentDeclarationList();
	}

	public void showExperimentList() {
		getSeSAmDesktopPaneHelper().showExperimentList();
	}

	public void showRemoteSimTaskList() {
		getSeSAmDesktopPaneHelper().showRemoteSimTaskList();
	}

	public void showRessourceClassDeclarationList() {
		getSeSAmDesktopPaneHelper().showRessourceClassDeclarationList();
	}

	public void showSimulationDeclarationList() {
		getSeSAmDesktopPaneHelper().showSimulationDeclarationList();
	}

	public void showSituationDeclarationList() {
		getSeSAmDesktopPaneHelper().showSituationDeclarationList();
	}

	public void showUserFeatureDeclarationList() {
		getSeSAmDesktopPaneHelper().showUserFeatureDeclarationList();
	}

	public void showUserFunctionDeclarationList() {
		getSeSAmDesktopPaneHelper().showUserFunctionDeclarationList();
	}

	public void showUserTypeDeclarationList() {
		getSeSAmDesktopPaneHelper().showUserTypeDeclarationList();
	}

	public void showWorldClassDeclarationList() {
		getSeSAmDesktopPaneHelper().showWorldClassDeclarationList();
	}
	public void showModelLibrary() {
		getSeSAmDesktopPaneHelper().showModelLibrary(this);
	}

	public void showTestRunner() {
		getSeSAmDesktopPaneHelper().showTestRunner();
	}

	public void setMakeJIFsInspectable(boolean enabled){
		getSeSAmDesktopPaneHelper().setMakeJIFsInspectable(enabled);
	}
	
	public boolean getMakeJIFsInspectable(){
		return getSeSAmDesktopPaneHelper().getMakeJIFsInspectable();
	}
	
	public void exportModel(){
		getSeSAmDesktopPaneHelper().exportModel();	
	}
	
	public void importModel(){
		getSeSAmDesktopPaneHelper().importModel();	
	}	
	
    public boolean askToSaveChanges(String title, String[] options) {
        return ivjSeSAmDesktopPaneHelper.askToSaveChanges(title, options);
    }
}