package de.uniwue.ki.gui.mas.application.importExport;

import java.awt.Component;
import java.io.File;

import javax.swing.Box;
import javax.swing.BoxLayout;

import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTree;
import javax.swing.tree.DefaultTreeCellRenderer;


public class CheckTreeCellRenderer extends DefaultTreeCellRenderer{
	
	protected JCheckBox _checkBox;
	protected JLabel _iconLabel;
	protected JLabel _nameLabel;
	protected JPanel _panel;
	protected JTree _tree;
	
	public CheckTreeCellRenderer(JTree tree) {
		_tree = tree;
		initialize();
	}
	
	private void initialize(){
		_panel = new JPanel();
		_nameLabel = new JLabel();
		_iconLabel = new JLabel();
		_checkBox = new JCheckBox();
		_nameLabel.setOpaque(true);		 
	
		_panel.setOpaque(false);
		_panel.setLayout(new BoxLayout(_panel, BoxLayout.X_AXIS));

		_panel.add(_checkBox);
		_panel.add(Box.createHorizontalStrut(3));
		_panel.add(_iconLabel);
		_panel.add(Box.createHorizontalStrut(3));
		_panel.add(_nameLabel);	
	}

	public Component getTreeCellRendererComponent(
		JTree tree,Object value,boolean sel,boolean expanded,boolean leaf,int row,boolean hasFocus) {
		
		CheckableTreeNode node = (CheckableTreeNode) value;
	
		String name = ((File) node.getUserObject()).getName();
	
		_nameLabel.setText(name);
		_checkBox.setOpaque(false);
	
		_checkBox.setSelected(((CheckableTreeNode) value).isSelected());
								
		if (sel){
			_nameLabel.setForeground(getTextSelectionColor());
			_nameLabel.setBackground(getBackgroundSelectionColor());
		}
		else{
			_nameLabel.setForeground(getTextNonSelectionColor());
			_nameLabel.setBackground(getBackgroundNonSelectionColor());
		}
	
		if (!tree.isEnabled()) {
			_panel.setEnabled(false);
			if (leaf) {
				_iconLabel.setDisabledIcon(getClosedIcon());
			} else if (expanded) {
				_iconLabel.setDisabledIcon(getOpenIcon());
			} else {
				_iconLabel.setDisabledIcon(getClosedIcon());
			}
		} else {
			_panel.setEnabled(true);
			if (leaf) {
				_iconLabel.setIcon(getClosedIcon());
			} else if (expanded) {
				_iconLabel.setIcon(getOpenIcon());
			} else {
				_iconLabel.setIcon(getClosedIcon());
			}
		}

		return _panel;
	}
}

