package de.uniwue.ki.gui.mas.application.remote;

import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.Locale;
import java.util.logging.Level;
import java.util.logging.Logger;

import javax.swing.*;

import de.uniwue.ki.gui.mas.application.remote.server.RemoteSimulationControlPanel;

/**
 * Creation date: 10.09.2002, 15:25:38
 * @author oechslein
 */
public class RemoteSimulationControlFrame extends JFrame {
	private final RemoteSimulationControlPanel _remoteSimulationControlPanel =
		new RemoteSimulationControlPanel();

	public RemoteSimulationControlFrame() {
		super("Remote Simulation Control");

		initialize();
	}

	private static void setKunststoffLookAndFeel() {
		try {
			//KunststoffLookAndFeel.setCurrentTheme(new KunststoffDesktopTheme());
			UIManager.setLookAndFeel("com.incors.plaf.kunststoff.KunststoffLookAndFeel");

		} catch (ClassNotFoundException exception) {
			System.err.println("Exception occurred in main() of SeSAm");
			exception.printStackTrace(System.out);

		} catch (InstantiationException exception) {
			throw new InstantiationError(exception.getMessage());

		} catch (UnsupportedLookAndFeelException exception) {
			System.err.println("Exception occurred in main() of SeSAm");
			exception.printStackTrace(System.out);

		} catch (IllegalAccessException exception) {
			throw new IllegalAccessError(exception.getMessage());
		}
	}

	public static void main(String[] args) {
		Locale.setDefault(Locale.ENGLISH);
		System.setProperty("user.language", "");
		setKunststoffLookAndFeel();

		Logger.getLogger("de.uniwue.ki.mas.application.remote").setLevel(Level.FINER);

		RemoteSimulationControlFrame remoteSimulationControlFrame = new RemoteSimulationControlFrame();
		remoteSimulationControlFrame._remoteSimulationControlPanel.updateClientList();
	}

	private void initialize() {
		setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
		
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent evt) {
				weAreQuiting();
				super.windowClosing(evt);
				System.exit(0);
			}
		});

		getContentPane().setLayout(new BoxLayout(getContentPane(), BoxLayout.X_AXIS));
		getContentPane().add(_remoteSimulationControlPanel);

		pack();
		show();
	}

	protected final void weAreQuiting() {
		_remoteSimulationControlPanel.dispose();
	}
}