package de.uniwue.ki.gui.mas.basics.action;
import java.awt.Color;
import java.awt.Component;

import javax.swing.*;

import de.uniwue.ki.gui.mas.basics.functionCall.FunctionCallDeclarationPanelActionFactory;
import de.uniwue.ki.gui.util.SwingMoreUtilities;
import de.uniwue.ki.mas.basics.functionCall.IComposedFunctionCallInternDeclaration;
import de.uniwue.ki.mas.basics.functionCall.IFunctionCallDeclaration;
/**
 * Rainer Herrler
 */
public class FunctionActionDeclarationCellRendererAdapter implements ListCellRenderer {
	private final ListCellRenderer _listCellRenderer;

	public FunctionActionDeclarationCellRendererAdapter(ListCellRenderer listCellRenderer) {
		super();

		_listCellRenderer = listCellRenderer;
	}

	public static final ImageIcon COMMENTICON =
			SwingMoreUtilities.createImageIcon("others/comment.gif");
			
	public Component getListCellRendererComponent(
		JList list,
		Object value,
		int index,
		boolean isSelected,
		boolean cellHasFocus) {

		if (!(value instanceof IFunctionCallDeclaration))
			return _listCellRenderer.getListCellRendererComponent(
				list,
				value,
				index,
				isSelected,
				cellHasFocus);

		IFunctionCallDeclaration named = (IFunctionCallDeclaration)value;
		if (!(FunctionCallDeclarationPanelActionFactory.isComment(named)))
			return _listCellRenderer.getListCellRendererComponent(
				list,
				value,
				index,
				isSelected,
				cellHasFocus);
		else {
			Component comp =_listCellRenderer.getListCellRendererComponent(
				list,
				((IComposedFunctionCallInternDeclaration)named.getFunctionCallInternDeclaration()).getChild(
					1),
				index,
				isSelected,
				cellHasFocus);
			((JLabel)comp).setForeground(Color.DARK_GRAY);
			((JLabel)comp).setIcon(COMMENTICON);
			return comp;
		}
	}
}