package de.uniwue.ki.gui.mas.basics.feature;
import de.uniwue.ki.gui.mas.model.IDeclarationPanelAndActionFactory;
import de.uniwue.ki.gui.mas.util.IActionFactory;
import de.uniwue.ki.gui.mas.util.declaration.*;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: (13.12.2000 18:26:47)
 * @author Christoph Oechslein
 */
public class FeatureInstanceDeclarationListPanel extends DeclarationListPanel {

	public FeatureInstanceDeclarationListPanel() {
		super();
		initialize();
	}

	protected IDeclarationPanel createDeclarationPanel(IDeclaration declaration) {
		IActionFactory panelActionFactory = getGUISeSAmDeclaration().getPanelActionFactoryManager().getPanelActionFactoryFor(this, declaration);
		if (panelActionFactory instanceof IDeclarationPanelAndActionFactory)  {
			IDeclarationPanelFactory declarationPanelFactory = ((IDeclarationPanelAndActionFactory)panelActionFactory).getDeclarationPanelFactory(this, declaration);
			if (declarationPanelFactory != null)  {
				return declarationPanelFactory.createDeclarationPanel(declaration);
			}
		}
		return null;
	}

	protected String getDeclarationFrameTitle(IDeclaration declaration) {
		return "Features";
	}

	/**
	 * Called whenever the part throws an exception.
	 * @param exception Throwable
	 */
	private void handleException(Throwable exception) {
		exception.printStackTrace(System.out);
	}

	/**
	 * Initialize the class.
	 */
	private void initialize() {
		try {
					setName("FeatureInstanceDeclarationListPanel");
			setSize(156, 228);
			setEditable(false);
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	public static void main(String[] args) {
		try {
			javax.swing.JFrame frame = new javax.swing.JFrame();
			FeatureInstanceDeclarationListPanel aFeatureInstanceDeclarationListPanel;
			aFeatureInstanceDeclarationListPanel = new FeatureInstanceDeclarationListPanel();
			frame.setContentPane(aFeatureInstanceDeclarationListPanel);
			frame.setSize(aFeatureInstanceDeclarationListPanel.getSize());
			frame.addWindowListener(new java.awt.event.WindowAdapter() {
				public void windowClosing(java.awt.event.WindowEvent e) {
					System.exit(0);
				}
			});
			frame.show();
			java.awt.Insets insets = frame.getInsets();
			frame.setSize(
				frame.getWidth() + insets.left + insets.right,
				frame.getHeight() + insets.top + insets.bottom);
			frame.setVisible(true);
		} catch (Throwable exception) {
			System.err.println(
				"Exception occurred in main() of de.uniwue.ki.gui.mas.model.basics.feature.FeatureInstanceDeclarationListPanel");
			exception.printStackTrace(System.out);
		}
	}

	protected boolean shouldUseOkCancelDeclarationPanelFor(IDeclaration declaration) {
		return false;
	}
}