package de.uniwue.ki.gui.mas.basics.feature;
import java.awt.Container;
import java.util.*;

import de.uniwue.ki.gui.mas.model.DefaultMutableListModelActionFactory;
import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.model.tree.SeSAmDeclarationTreePanel;
import de.uniwue.ki.gui.util.actions.InspectAction;
import de.uniwue.ki.mas.basics.featureList.ObjectFeatureInstanceDeclarationList;
/**
 * Creation date: (08.02.2002 11:10:43)
 * @author Christoph Oechslein
 */
public class ObjectFeatureInstanceDeclarationListActionFactory extends DefaultMutableListModelActionFactory {
	public ObjectFeatureInstanceDeclarationListActionFactory(IGUISeSAmDeclaration guiSeSAmDeclaration) {
		super(guiSeSAmDeclaration);
	}

	public boolean getCanProduceActions(Container parent, Object anObject) {
		return super.getCanProduceActions(parent, anObject) && (anObject instanceof ObjectFeatureInstanceDeclarationList);
	}

	public Iterator getMoreActions(Container parent, Object anObject) {
		ObjectFeatureInstanceDeclarationList objectFeatureInstanceDeclarationList = (ObjectFeatureInstanceDeclarationList) anObject;

		List actions = new LinkedList();

		if (parent instanceof SeSAmDeclarationTreePanel)
			actions.add(createRefreshAction(getSeSAmDeclarationTreeModel(), objectFeatureInstanceDeclarationList));

		actions.add(new InspectAction(objectFeatureInstanceDeclarationList));

		return actions.iterator();
	}
}