package de.uniwue.ki.gui.mas.basics.feature;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;

import javax.swing.*;

import de.uniwue.ki.gui.mas.util.declaration.*;
import de.uniwue.ki.mas.basics.feature.IFeatureClassDeclaration;
import de.uniwue.ki.mas.basics.feature.IObjectFeatureClassDeclaration;
import de.uniwue.ki.mas.util.declaration.IDeclaration;
import de.uniwue.ki.util.list.EnhancedListModel;

/**
 * Creation date: (01.02.2004)
 * @author Rainer herrler
 */
public class SystemFeatureClassDeclarationPanel extends AbstractDeclarationPanel {
	private IFeatureClassDeclaration ivjFeatureClassDeclarationIntern = null;
	private DeclarationListPanel ivjVariableClassDeclarationListPanel = null;
	private boolean ivjConnPtoP10Aligning = false;
	private JPanel ivjJPanelVariablesAndFunctions = null;
	private boolean ivjConnPtoP3Aligning = false;
	private NameDeclarationWithDocumentationPanel ivjNameDeclarationWithDocumentationPanel = null;
	private boolean ivjConnPtoP4Aligning = false;
	private DeclarationListPanel ivjUserDefinedFunctionDeclarationListForUserFeaturePanel = null;

	private boolean ivjConnPtoP1Aligning = false;

	public SystemFeatureClassDeclarationPanel() {
		super();
		initialize();
	}

	public SystemFeatureClassDeclarationPanel(IFeatureClassDeclaration decl) {
		super();
		initialize();
		setFeatureClassDeclaration(decl);
	}

	private void connPtoP10SetSource() {
		try {
			if (ivjConnPtoP10Aligning == false) {
				ivjConnPtoP10Aligning = true;
				this.setGUISeSAmDeclaration(getVariableClassDeclarationListPanel().getGUISeSAmDeclaration());
				ivjConnPtoP10Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP10Aligning = false;
			handleException(ivjExc);
		}
	}

	private void connPtoP10SetTarget() {
		try {
			if (ivjConnPtoP10Aligning == false) {
				ivjConnPtoP10Aligning = true;
				getVariableClassDeclarationListPanel().setGUISeSAmDeclaration(this.getGUISeSAmDeclaration());
				ivjConnPtoP10Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP10Aligning = false;
			handleException(ivjExc);
		}
	}

	private void connPtoP3SetSource() {
		try {
			if (ivjConnPtoP3Aligning == false) {
				ivjConnPtoP3Aligning = true;
				this.setGUISeSAmDeclaration(
					getFunctionDeclarationListFeaturePanel().getGUISeSAmDeclaration());
				ivjConnPtoP3Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP3Aligning = false;
			handleException(ivjExc);
		}
	}

	private void connPtoP3SetTarget() {
		try {
			if (ivjConnPtoP3Aligning == false) {
				ivjConnPtoP3Aligning = true;
				getFunctionDeclarationListFeaturePanel().setGUISeSAmDeclaration(
					this.getGUISeSAmDeclaration());
				ivjConnPtoP3Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP3Aligning = false;
			handleException(ivjExc);
		}
	}

	private void connPtoP7SetTarget() {
		try {
			if ((getFeatureClassDeclarationIntern() != null)) {
				getNameDeclarationWithDocumentationPanel().setDeclaration(getFeatureClassDeclarationIntern());

			}
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	public void dispose() {
		super.dispose();

		getVariableClassDeclarationListPanel().dispose();
		getFunctionDeclarationListFeaturePanel().dispose();
	}

	public IDeclaration getDeclaration() {
		return getUserFeatureClassDeclaration();
	}

	private JPanel getJPanelVariablesAndFunctions() {
		if (ivjJPanelVariablesAndFunctions == null) {
			ivjJPanelVariablesAndFunctions = new JPanel();
			ivjJPanelVariablesAndFunctions.setLayout(
				new BoxLayout(getJPanelVariablesAndFunctions(), BoxLayout.X_AXIS));

			JTabbedPane tabbedPanel = new JTabbedPane();

			tabbedPanel.add("Functions", getFunctionDeclarationListFeaturePanel());
			tabbedPanel.add("Variables", getVariableClassDeclarationListPanel());
			getJPanelVariablesAndFunctions().add(tabbedPanel);
		}
		return ivjJPanelVariablesAndFunctions;
	}

	private NameDeclarationWithDocumentationPanel getNameDeclarationWithDocumentationPanel() {
		if (ivjNameDeclarationWithDocumentationPanel == null) {
			try {
				ivjNameDeclarationWithDocumentationPanel = new NameDeclarationWithDocumentationPanel();
				ivjNameDeclarationWithDocumentationPanel.setName("NameDeclarationWithDocumentationPanel1");
				ivjNameDeclarationWithDocumentationPanel.setEditable(false);
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjNameDeclarationWithDocumentationPanel;
	}

	private DeclarationListPanel getFunctionDeclarationListFeaturePanel() {
		if (ivjUserDefinedFunctionDeclarationListForUserFeaturePanel == null) {
			ivjUserDefinedFunctionDeclarationListForUserFeaturePanel = new DeclarationListPanel();
			ivjUserDefinedFunctionDeclarationListForUserFeaturePanel.setEditable(false);
		}
		return ivjUserDefinedFunctionDeclarationListForUserFeaturePanel;
	}

	public IFeatureClassDeclaration getUserFeatureClassDeclaration() {
		return getFeatureClassDeclarationIntern();
	}

	private IFeatureClassDeclaration getFeatureClassDeclarationIntern() {
		return ivjFeatureClassDeclarationIntern;
	}

	private DeclarationListPanel getVariableClassDeclarationListPanel() {
		if (ivjVariableClassDeclarationListPanel == null) {
			try {
				ivjVariableClassDeclarationListPanel = new DeclarationListPanel();
				ivjVariableClassDeclarationListPanel.setName("VariableClassDeclarationListPanel");
				ivjVariableClassDeclarationListPanel.setEditable(false);
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjVariableClassDeclarationListPanel;
	}

	private void handleException(Throwable exception) {
		exception.printStackTrace(System.out);
	}

	private void initConnections() {
		//connPtoP7SetTarget();
		connPtoP3SetTarget();
		connPtoP10SetTarget();
	}

	private void initialize() {
		setLayout(new GridBagLayout());

		GridBagConstraints constraintsNameDeclarationWithDocumentationPanel1 = new GridBagConstraints();
		constraintsNameDeclarationWithDocumentationPanel1.gridx = 0;
		constraintsNameDeclarationWithDocumentationPanel1.gridy = 0;
		constraintsNameDeclarationWithDocumentationPanel1.fill = java.awt.GridBagConstraints.HORIZONTAL;
		constraintsNameDeclarationWithDocumentationPanel1.weightx = 1.0;
		add(getNameDeclarationWithDocumentationPanel(), constraintsNameDeclarationWithDocumentationPanel1);

		GridBagConstraints constraintsJPanelVariablesAndFunctions = new GridBagConstraints();
		constraintsJPanelVariablesAndFunctions.gridx = 0;
		constraintsJPanelVariablesAndFunctions.gridy = 1;
		constraintsJPanelVariablesAndFunctions.fill = java.awt.GridBagConstraints.BOTH;
		constraintsJPanelVariablesAndFunctions.weightx = 1.0;
		constraintsJPanelVariablesAndFunctions.weighty = 1.0;
		add(getJPanelVariablesAndFunctions(), constraintsJPanelVariablesAndFunctions);


		initConnections();
	}

	public void setDeclaration(IDeclaration declaration) {
		setFeatureClassDeclaration((IFeatureClassDeclaration)declaration);
	}

	public void setFeatureClassDeclaration(IFeatureClassDeclaration arg1) {
		setFeatureClassDeclarationIntern(arg1);
	}

	private void setFeatureClassDeclarationIntern(IFeatureClassDeclaration newValue) {
		if (ivjFeatureClassDeclarationIntern != newValue) {
			try {
				//IFeatureClassDeclaration oldValue = getFeatureClassDeclarationIntern();
				ivjFeatureClassDeclarationIntern = newValue;
				if ((newValue != null)) {
					getNameDeclarationWithDocumentationPanel().setDeclaration(newValue);
					getFunctionDeclarationListFeaturePanel().setModel(
						new EnhancedListModel(newValue.getDefaultFunctionDeclarations()));
					if (newValue instanceof IObjectFeatureClassDeclaration) {
						getVariableClassDeclarationListPanel().setModel(
							new EnhancedListModel(
								((IObjectFeatureClassDeclaration)newValue).getVariableClassDeclarations()));
					}
				}
				//firePropertyChange("userFeatureClassDeclaration", oldValue, newValue);
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		getNameDeclarationWithDocumentationPanel().setEditable(false);
		getNameDeclarationWithDocumentationPanel().setDocumentationEditable(false);
	}
}