package de.uniwue.ki.gui.mas.basics.feature.evolution;
import java.awt.Container;

import de.uniwue.ki.gui.mas.model.AbstractDeclarationPanelAndActionFactory;
import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.util.declaration.*;

import de.uniwue.ki.mas.basics.feature.evolution.EvolutionObjectFeatureClassDeclaration;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: (11.10.2001 15:13:45)
 * @author Christoph Oechslein
 */
public class EvolutionObjectFeatureClassDeclarationPanelActionFactory
	extends AbstractDeclarationPanelAndActionFactory {
	private final IDeclarationPanelFactory _editPropertiesDeclarationPanelFactory =
		new EditPropertiesDeclarationPanelFactory();

	private class EditPropertiesDeclarationPanelFactory extends AbstractDeclarationPanelFactory {

		public IDeclarationPanel createDeclarationPanel(IDeclaration declaration) {
			EvolutionObjectFeatureClassDeclarationPanel evolutionObjectFeatureClassDeclarationPanel =
				new EvolutionObjectFeatureClassDeclarationPanel();

			evolutionObjectFeatureClassDeclarationPanel.setGUISeSAmDeclaration(getGUISeSAmDeclaration());

			return evolutionObjectFeatureClassDeclarationPanel;
		}
		public String getDeclarationTitle(IDeclaration declaration) {
			return "Evolution Feature";
		}
	}

	public EvolutionObjectFeatureClassDeclarationPanelActionFactory() {
		super();
	}

	public EvolutionObjectFeatureClassDeclarationPanelActionFactory(IGUISeSAmDeclaration guiSeSAmDeclaration) {
		super(guiSeSAmDeclaration);
	}

	protected boolean getCanProduceDeclarationActions(Container parent, IDeclaration anDeclaration) {
		return anDeclaration instanceof EvolutionObjectFeatureClassDeclaration;
	}

	public IDeclarationPanelFactory getDeclarationPanelFactory(
		Container parent,
		IDeclaration anDeclaration) {
		return _editPropertiesDeclarationPanelFactory;
	}

}