package de.uniwue.ki.gui.mas.basics.feature.spatial;

import java.awt.event.MouseEvent;

import javax.swing.Icon;

import de.uniwue.ki.gui.util.SwingMoreUtilities;
import de.uniwue.ki.mas.basics.feature.spatial.*;
import de.uniwue.ki.mas.entity.objectclass.IObjectClassDeclaration;

/**
 * @author oechslein
 * 
 * Creation date: 23.07.2003
 */
public class AddSpatialInfoSpatialMapPanelState extends AbstractSpatialMapPanelState {
	private IObjectClassDeclaration _objectClassDeclaration;

	public Icon getIcon() {
		return SwingMoreUtilities.getJavaSunIcon(24, "general/User24.gif");
	}

	public String getName() {
		return "Add";
	}

	public void mouseClicked(MouseEvent e) {
		if ((e.getClickCount() > 1) && (e.getButton() == MouseEvent.BUTTON1)) {
			mouseDoubleClicked(e);
		}
	}

	private DefaultSpatialMapModel getModel() {
		return (DefaultSpatialMapModel)getSpatialMapPanel().getSpatialMapModel();
	}

	private double getXFactor() {
		return getModel().getWidth() / (double)getSpatialMapPanel().getWidth();
	}

	private double getYFactor() {
		return getModel().getHeight() / (double)getSpatialMapPanel().getHeight();
	}

	protected void mouseDoubleClicked(MouseEvent e) {
		if (_objectClassDeclaration != null) {
			ISpatialInfo spatialInfo =
				SpatialInfoObjectFeatureHelper.getSpatialInfo(
					_objectClassDeclaration.createObjectInstanceDeclaration());

			if (getModel().isDiscrete()) {
				double getGridWidth = getModel().getWidth() / (double)getModel().getGridCols();
				double getGridHeight = getModel().getHeight() / (double)getModel().getGridRows();

				double centerFactor = 0.0;
				if (getModel().isCenteredPos()) {
					centerFactor = 0.5;
				}

				double col =
					(Math.floor(getSpatialMapPanel().convertPanelPositionX(e.getPoint().x) / getGridWidth)
						+ centerFactor)
						* getGridWidth;
				double row =
					(Math.floor(getSpatialMapPanel().convertPanelPositionX(e.getPoint().y) / getGridHeight)
						+ centerFactor)
						* getGridHeight;

				spatialInfo.getPosition().x = col;
				spatialInfo.getPosition().y = row;

			} else {
				spatialInfo.getPosition().x = e.getPoint().x * getXFactor();
				spatialInfo.getPosition().y = e.getPoint().y * getYFactor();
			}

			getModel().addSpatialInfo(spatialInfo);
		}
	}

	protected void setItem(Object object) {
		//if (object != null) {
			_objectClassDeclaration = (IObjectClassDeclaration)object;
		//}
	}
}
