package de.uniwue.ki.gui.mas.basics.feature.spatial;
import java.awt.Insets;
import java.util.Iterator;
import javax.swing.JFrame;
import javax.swing.JTabbedPane;
import com.jgoodies.forms.builder.PanelBuilder;
import com.jgoodies.forms.layout.FormLayout;
import de.uniwue.ki.gui.mas.entity.object.AbstractObjectPanel;
import de.uniwue.ki.gui.mas.entity.object.ObjectPanel;
import de.uniwue.ki.gui.mas.model.*;
import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.util.IActionFactory;
import de.uniwue.ki.gui.util.IObjectPanelFactory;
import de.uniwue.ki.gui.util.JDisposeablePanel;
import de.uniwue.ki.mas.basics.feature.IObjectFeature;
import de.uniwue.ki.mas.basics.feature.spatial.*;
import de.uniwue.ki.mas.entity.object.IObject;
/**
 * Creation date: (12.09.2001 15:54:13)
 * 
 * @author Christoph Oechslein
 * 
 */
//TODO generisch machen
public class ObjectWithSpatialInfoPanel extends AbstractObjectPanel {
	private boolean _automaticUpdate = false;
	private final IvjEventHandler ivjEventHandler = new IvjEventHandler();
	private ObjectPanel ivjObjectPanel = null;
	private SpatialInfoPanel ivjSpatialInfoPanel = null;
	private boolean ivjConnPtoP2Aligning = false;
	private boolean ivjConnPtoP3Aligning = false;
	private final class IvjEventHandler implements java.beans.PropertyChangeListener {
		public void propertyChange(java.beans.PropertyChangeEvent evt) {
			if (evt.getSource() == ObjectWithSpatialInfoPanel.this.getObjectPanel()
					&& (evt.getPropertyName().equals("object")))
				connEtoC1(evt);
			if (evt.getSource() == ObjectWithSpatialInfoPanel.this
					&& (evt.getPropertyName().equals("object")))
				connEtoC3(evt);
			if (evt.getSource() == ObjectWithSpatialInfoPanel.this.getSpatialInfoPanel()
					&& (evt.getPropertyName().equals("SpatialMapModel")))
				connEtoC4(evt);
			if (evt.getSource() == ObjectWithSpatialInfoPanel.this
					&& (evt.getPropertyName().equals("gUISeSAmDeclaration")))
				connPtoP2SetTarget();
			if (evt.getSource() == ObjectWithSpatialInfoPanel.this.getObjectPanel()
					&& (evt.getPropertyName().equals("gUISeSAmDeclaration")))
				connPtoP2SetSource();
			if (evt.getSource() == ObjectWithSpatialInfoPanel.this
					&& (evt.getPropertyName().equals("gUISeSAmDeclaration")))
				connPtoP3SetTarget();
			if (evt.getSource() == ObjectWithSpatialInfoPanel.this.getSpatialInfoPanel()
					&& (evt.getPropertyName().equals("gUISeSAmDeclaration")))
				connPtoP3SetSource();
		}
	}
	public ObjectWithSpatialInfoPanel() {
		super();
		initialize();
	}
	/**
	 * connEtoC1: (ObjectPanel.object -->
	 * ObjectWithSpatialInfoPanel.firePropertyChange(LString;LObject;LObject;)V)
	 * 
	 * @param arg1
	 *            java.beans.PropertyChangeEvent
	 */
	private void connEtoC1(java.beans.PropertyChangeEvent arg1) {
		try {
			this.firePropertyChange("object", arg1.getOldValue(), arg1.getNewValue());
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}
	/**
	 * connEtoC3: (ObjectPanel.object -->
	 * ObjectWithSpatialInfoPanel.eventObjectChanged()V)
	 * 
	 * @param arg1
	 *            java.beans.PropertyChangeEvent
	 */
	private void connEtoC3(java.beans.PropertyChangeEvent arg1) {
		try {
			this.eventObjectChanged();
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}
	/**
	 * connEtoC4: (SpatialInfoPanel.SpatialMapModel -->
	 * ObjectWithSpatialInfoPanel.firePropertyChange(LString;LObject;LObject;)V)
	 * 
	 * @param arg1
	 *            java.beans.PropertyChangeEvent
	 */
	private void connEtoC4(java.beans.PropertyChangeEvent arg1) {
		try {
			this.firePropertyChange("SpatialMapModel", arg1.getOldValue(), arg1.getNewValue());
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}
	/**
	 * connPtoP2SetSource: (ObjectWithSpatialInfoPanel.gUISeSAmDeclaration <-->
	 * ObjectPanel.gUISeSAmDeclaration)
	 */
	private void connPtoP2SetSource() {
		try {
			if (ivjConnPtoP2Aligning == false) {
				ivjConnPtoP2Aligning = true;
				this.setGUISeSAmDeclaration(getObjectPanel().getGUISeSAmDeclaration());
				ivjConnPtoP2Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP2Aligning = false;
			handleException(ivjExc);
		}
	}
	/**
	 * connPtoP2SetTarget: (ObjectWithSpatialInfoPanel.gUISeSAmDeclaration <-->
	 * ObjectPanel.gUISeSAmDeclaration)
	 */
	private void connPtoP2SetTarget() {
		try {
			if (ivjConnPtoP2Aligning == false) {
				ivjConnPtoP2Aligning = true;
				getObjectPanel().setGUISeSAmDeclaration(this.getGUISeSAmDeclaration());
				ivjConnPtoP2Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP2Aligning = false;
			handleException(ivjExc);
		}
	}
	/**
	 * connPtoP3SetSource: (ObjectWithSpatialInfoPanel.gUISeSAmDeclaration <-->
	 * SpatialInfoPanel.gUISeSAmDeclaration)
	 */
	private void connPtoP3SetSource() {
		try {
			if (ivjConnPtoP3Aligning == false) {
				ivjConnPtoP3Aligning = true;
				this.setGUISeSAmDeclaration(getSpatialInfoPanel().getGUISeSAmDeclaration());
				ivjConnPtoP3Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP3Aligning = false;
			handleException(ivjExc);
		}
	}
	/**
	 * connPtoP3SetTarget: (ObjectWithSpatialInfoPanel.gUISeSAmDeclaration <-->
	 * SpatialInfoPanel.gUISeSAmDeclaration)
	 */
	private void connPtoP3SetTarget() {
		try {
			if (ivjConnPtoP3Aligning == false) {
				ivjConnPtoP3Aligning = true;
				getSpatialInfoPanel().setGUISeSAmDeclaration(this.getGUISeSAmDeclaration());
				ivjConnPtoP3Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP3Aligning = false;
			handleException(ivjExc);
		}
	}
	public void dispose() {
		getObjectPanel().dispose();
		getSpatialInfoPanel().dispose();
		super.dispose();
	}
	protected void eventObjectChanged() {
		if (hasSpatialInfo()) {
			getSpatialInfoPanel().setSpatialInfo(getSpatialInfo());
		} else {
			getSpatialInfoPanel().setSpatialInfo(null);
		}
	}
	public ISpatialMapModel getSpatialMapModel() {
		return getSpatialInfoPanel().getSpatialMapModel();
	}
	public IObject getObject() {
		return getObjectPanel().getObject();
	}
	private ObjectPanel getObjectPanel() {
		if (ivjObjectPanel == null) {
			try {
				ivjObjectPanel = new ObjectPanel();
				ivjObjectPanel.setName("ObjectPanel");
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjObjectPanel;
	}
	protected ISpatialInfo getSpatialInfo() {
		if (getObject() == null) {
			return null;
		} else {
			return SpatialInfoObjectFeatureHelper.getSpatialInfo(getObject());
		}
	}
	private JTabbedPane ivjTabbedPane = null;
	private JTabbedPane getTabbedPane() {
		if (ivjTabbedPane == null) {
			ivjTabbedPane = new JTabbedPane();
			ivjTabbedPane.add(getSpatialInfoPanel());
		}
		return ivjTabbedPane;
	}
	private SpatialInfoPanel getSpatialInfoPanel() {
		if (ivjSpatialInfoPanel == null) {
			try {
				ivjSpatialInfoPanel = new SpatialInfoPanel();
				ivjSpatialInfoPanel.setName("SpatialInfoPanel");
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjSpatialInfoPanel;
	}
	private void handleException(Throwable exception) {
		exception.printStackTrace(System.out);
	}
	protected boolean hasSpatialInfo() {
		return getSpatialInfo() != null;
	}
	private void initConnections() {
		getObjectPanel().addPropertyChangeListener(ivjEventHandler);
		addPropertyChangeListener(ivjEventHandler);
		getSpatialInfoPanel().addPropertyChangeListener(ivjEventHandler);
	}
	private void initialize() {
		PanelBuilder builder = new PanelBuilder(this, new FormLayout("fill:default:grow",
				"default, min, default"));
		builder.add(getObjectPanel());
		builder.nextLine();
		builder.addSeparator("Feature Properties");
		builder.nextLine();
		builder.add(getTabbedPane());
		initConnections();
	}
	public static void main(String[] args) {
		try {
			JFrame frame = new JFrame();
			ObjectWithSpatialInfoPanel aObjectWithSpatialInfoPanel;
			aObjectWithSpatialInfoPanel = new ObjectWithSpatialInfoPanel();
			frame.setContentPane(aObjectWithSpatialInfoPanel);
			frame.setSize(aObjectWithSpatialInfoPanel.getSize());
			frame.addWindowListener(new java.awt.event.WindowAdapter() {
				public void windowClosing(java.awt.event.WindowEvent e) {
					System.exit(0);
				}
			});
			frame.show();
			Insets insets = frame.getInsets();
			frame.setSize(frame.getWidth() + insets.left + insets.right, frame.getHeight() + insets.top
					+ insets.bottom);
			frame.setVisible(true);
		} catch (Throwable exception) {
			System.err.println("Exception occurred in main() of javax.swing.JPanel");
			exception.printStackTrace(System.out);
		}
	}
	public void refresh() {
		getObjectPanel().refresh();
		getSpatialInfoPanel().refresh();
	}
	public void setSpatialMapModel(ISpatialMapModel arg1) {
		getSpatialInfoPanel().setSpatialMapModel(arg1);
	}
	public void setObject(IObject simObject) {
		getObjectPanel().setObject(simObject);
		//remove all tabs except the first (spatial info)
		while (getTabbedPane().getTabCount() > 1) {
			getTabbedPane().remove(1);
		}
		//add new tabs for features
		if (simObject != null) {
			Iterator it = simObject.getObjectFeatures();
			while (it.hasNext()) {
				IObjectFeature feature = (IObjectFeature) it.next();
				if (getGUISeSAmDeclaration().getPanelActionFactoryManager().getPanelActionFactoryFor(null,
						feature) != null) {
					IActionFactory actionFactory = getGUISeSAmDeclaration().getPanelActionFactoryManager()
							.getPanelActionFactoryFor(null, feature);
					if (actionFactory instanceof IObjectPanelAndActionFactory) {
						IObjectPanelFactory panelFactory = ((IObjectPanelAndActionFactory) actionFactory)
								.getPanelFactory(null, feature);
						if (panelFactory != null) {
							JDisposeablePanel panel = panelFactory.createObjectPanel(feature);
							if (panel != null)
								getTabbedPane().add(panelFactory.getObjectTitle(feature), panel);
						}
					}
				}
			}
		}
		eventObjectChanged();
	}
	public boolean isAutomaticUpdate() {
		return _automaticUpdate;
	}
	public void setAutomaticUpdate(boolean automaticUpdate) {
		_automaticUpdate = automaticUpdate;
		getObjectPanel().setAutomaticUpdate(automaticUpdate);
		getSpatialInfoPanel().setAutomaticUpdate(automaticUpdate);
	}
	public void setGUISeSAmDeclaration(IGUISeSAmDeclaration seSAmDeclaration) {
		super.setGUISeSAmDeclaration(seSAmDeclaration);
		getObjectPanel().setGUISeSAmDeclaration(seSAmDeclaration);
		getSpatialInfoPanel().setGUISeSAmDeclaration(seSAmDeclaration);
	}
}