package de.uniwue.ki.gui.mas.basics.feature.spatial;
import javax.swing.JFrame;
import javax.swing.JLabel;

import de.uniwue.ki.gui.mas.basics.type.argument.AbstractArgumentDeclarationEditor;
import de.uniwue.ki.gui.mas.basics.type.argument.IArgumentDeclarationEditor;
import de.uniwue.ki.gui.util.bound.BoundJDoubleTextField;
import de.uniwue.ki.mas.basics.feature.spatial.position.Position2DType;
import de.uniwue.ki.mas.basics.type.argument.ArgumentDeclarationFactory;
import de.uniwue.ki.mas.basics.type.argument.IArgumentDeclaration;
import de.uniwue.ki.util.Position2D;

/**
 * Creation date: (30.05.00 14:01:01)
 * @author Christoph Oechslein
 */
public class Position2DArgumentDeclarationEditor
	extends AbstractArgumentDeclarationEditor
	implements IArgumentDeclarationEditor {

	private JLabel ivjJLabel1 = null;
	private final IvjEventHandler ivjEventHandler = new IvjEventHandler();
	private IArgumentDeclaration ivjArgumentDeclarationIntern = null;
	private JLabel ivjJLabel2 = null;
	private BoundJDoubleTextField ivjBoundJNumberTextField1 = null;
	private BoundJDoubleTextField ivjBoundJNumberTextField2 = null;

	private final class IvjEventHandler implements java.beans.PropertyChangeListener {
		public void propertyChange(java.beans.PropertyChangeEvent evt) {
			if (evt.getSource() == Position2DArgumentDeclarationEditor.this.getBoundJNumberTextField2()
				&& (evt.getPropertyName().equals("doubleValue")))
				connEtoC1(evt);
			if (evt.getSource() == Position2DArgumentDeclarationEditor.this.getBoundJNumberTextField1()
				&& (evt.getPropertyName().equals("doubleValue")))
				connEtoC2(evt);
		}
	}

	/**
	 * ArgumentEditor constructor comment.
	 */
	public Position2DArgumentDeclarationEditor() {
		super();
		initialize();
	}

	public static void main(String[] args) {
		try {
			JFrame frame = new javax.swing.JFrame();
			Position2DArgumentDeclarationEditor aPosition2DArgumentDeclarationEditor;
			aPosition2DArgumentDeclarationEditor = new Position2DArgumentDeclarationEditor();
			frame.setContentPane(aPosition2DArgumentDeclarationEditor);
			frame.setSize(aPosition2DArgumentDeclarationEditor.getSize());
			frame.addWindowListener(new java.awt.event.WindowAdapter() {
				public void windowClosing(java.awt.event.WindowEvent e) {
					System.exit(0);
				}
			});
			frame.setVisible(true);
		} catch (Throwable exception) {
			System.err.println("Exception occurred in main() of javax.swing.JPanel");
			exception.printStackTrace(System.out);
		}
	}

	public de.uniwue.ki.mas.basics.type.argument.IArgumentDeclaration getArgumentDeclaration() {
		return getArgumentDeclarationIntern();
	}

	protected void setArgumentDeclaration(
		de.uniwue.ki.mas.basics.type.argument.IArgumentDeclaration argumentDeclaration) {
		setArgumentDeclarationIntern(argumentDeclaration);
	}

	/**
	 * Return the ArgumentDeclarationIntern property value.
	 * @return de.uniwue.ki.mas.model.basics.type.IArgumentDeclaration
	 */
	private de.uniwue.ki.mas.basics.type.argument.IArgumentDeclaration getArgumentDeclarationIntern() {
		return ivjArgumentDeclarationIntern;
	}

	/**
	 * Set the ArgumentDeclarationIntern to a new value.
	 * @param newValue de.uniwue.ki.mas.model.basics.type.IArgumentDeclaration
	 */
	private void setArgumentDeclarationIntern(
		de.uniwue.ki.mas.basics.type.argument.IArgumentDeclaration newValue) {
		if (ivjArgumentDeclarationIntern != newValue) {
			try {
				de.uniwue.ki.mas.basics.type.argument.IArgumentDeclaration oldValue =
					getArgumentDeclarationIntern();
				ivjArgumentDeclarationIntern = newValue;
				connEtoC3(ivjArgumentDeclarationIntern);
				firePropertyChange("argumentDeclaration", oldValue, newValue);
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
	}

	/**
	 * Return the BoundJNumberTextField1 property value.
	 * @return BoundJDoubleTextField
	 */
	private BoundJDoubleTextField getBoundJNumberTextField1() {
		if (ivjBoundJNumberTextField1 == null) {
			try {
				ivjBoundJNumberTextField1 = new BoundJDoubleTextField();
				ivjBoundJNumberTextField1.setName("BoundJNumberTextField1");
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjBoundJNumberTextField1;
	}

	/**
	 * Return the BoundJNumberTextField2 property value.
	 * @return BoundJDoubleTextField
	 */
	private BoundJDoubleTextField getBoundJNumberTextField2() {
		if (ivjBoundJNumberTextField2 == null) {
			try {
				ivjBoundJNumberTextField2 = new BoundJDoubleTextField();
				ivjBoundJNumberTextField2.setName("BoundJNumberTextField2");
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjBoundJNumberTextField2;
	}

	/**
	 * Return the JLabel1 property value.
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel1() {
		if (ivjJLabel1 == null) {
			try {
				ivjJLabel1 = new javax.swing.JLabel();
				ivjJLabel1.setName("JLabel1");
				ivjJLabel1.setText("X:");
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjJLabel1;
	}

	/**
	 * Return the JLabel2 property value.
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel2() {
		if (ivjJLabel2 == null) {
			try {
				ivjJLabel2 = new javax.swing.JLabel();
				ivjJLabel2.setName("JLabel2");
				ivjJLabel2.setText("Y:");
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjJLabel2;
	}

	/**
	 * connEtoC1:  (BoundJNumberTextField2.doubleValue --> Position2DArgumentDeclarationEditor.eventTextFieldValueChanged()V)
	 * @param arg1 java.beans.PropertyChangeEvent
	 */
	private void connEtoC1(java.beans.PropertyChangeEvent arg1) {
		try {
					this.eventTextFieldValueChanged();
				} catch (Throwable ivjExc) {
					handleException(ivjExc);
		}
	}

	/**
	 * connEtoC2:  (BoundJNumberTextField1.doubleValue --> Position2DArgumentDeclarationEditor.eventTextFieldValueChanged()V)
	 * @param arg1 java.beans.PropertyChangeEvent
	 */
	private void connEtoC2(java.beans.PropertyChangeEvent arg1) {
		try {
					this.eventTextFieldValueChanged();
				} catch (Throwable ivjExc) {
					handleException(ivjExc);
		}
	}

	/**
	 * connEtoC3:  (ArgumentDeclarationIntern.this --> Position2DArgumentDeclarationEditor.eventArgumentDeclarationChanged()V)
	 * @param value de.uniwue.ki.mas.model.basics.type.IArgumentDeclaration
	 */
	private void connEtoC3(de.uniwue.ki.mas.basics.type.argument.IArgumentDeclaration value) {
		try {
					this.eventArgumentDeclarationChanged();
				} catch (Throwable ivjExc) {
					handleException(ivjExc);
		}
	}

	/**
	 * connEtoM1:  (NumberArgumentDeclarationEditor.initialize() --> ArgumentDeclarationIntern.this)
	 */
	private void connEtoM1() {
		try {
					setArgumentDeclarationIntern(
				ArgumentDeclarationFactory.getInstance().createArgumentDeclaration(
					Position2DType.getInstance()));
				} catch (Throwable ivjExc) {
					handleException(ivjExc);
		}
	}

	protected void eventArgumentDeclarationChanged() {
		Position2D position2D = (Position2D) getArgumentDeclaration().getObject();

		getBoundJNumberTextField1().setDoubleValue(position2D.getX());
		getBoundJNumberTextField2().setDoubleValue(position2D.getY());
	}

	protected void eventTextFieldValueChanged() {
		setPosition2D(
			getBoundJNumberTextField1().getDoubleValue(),
			getBoundJNumberTextField2().getDoubleValue());
	}

	/**
	 * Called whenever the part throws an exception.
	 * @param exception Throwable
	 */
	private void handleException(Throwable exception) {

		exception.printStackTrace(System.out);
	}

	/**
	 * Initializes connections
	 * @exception Exception The exception description.
	 */
	private void initConnections() {
		getBoundJNumberTextField2().addPropertyChangeListener(ivjEventHandler);
		getBoundJNumberTextField1().addPropertyChangeListener(ivjEventHandler);
	}

	/**
	 * Initialize the class.
	 */
	private void initialize() {
		try {
					setName("ArgumentEditor");
			setLayout(new java.awt.GridBagLayout());
			setSize(140, 36);

			java.awt.GridBagConstraints constraintsJLabel1 = new java.awt.GridBagConstraints();
			constraintsJLabel1.gridx = 0;
			constraintsJLabel1.gridy = 0;
			constraintsJLabel1.anchor = java.awt.GridBagConstraints.WEST;
			constraintsJLabel1.insets = new java.awt.Insets(0, 0, 0, 10);
			add(getJLabel1(), constraintsJLabel1);

			java.awt.GridBagConstraints constraintsJLabel2 = new java.awt.GridBagConstraints();
			constraintsJLabel2.gridx = 0;
			constraintsJLabel2.gridy = 1;
			constraintsJLabel2.anchor = java.awt.GridBagConstraints.WEST;
			constraintsJLabel2.insets = new java.awt.Insets(0, 0, 0, 10);
			add(getJLabel2(), constraintsJLabel2);

			java.awt.GridBagConstraints constraintsBoundJNumberTextField1 = new java.awt.GridBagConstraints();
			constraintsBoundJNumberTextField1.gridx = 1;
			constraintsBoundJNumberTextField1.gridy = 0;
			constraintsBoundJNumberTextField1.fill = java.awt.GridBagConstraints.BOTH;
			constraintsBoundJNumberTextField1.weightx = 1.0;
			constraintsBoundJNumberTextField1.weighty = 1.0;
			add(getBoundJNumberTextField1(), constraintsBoundJNumberTextField1);

			java.awt.GridBagConstraints constraintsBoundJNumberTextField2 = new java.awt.GridBagConstraints();
			constraintsBoundJNumberTextField2.gridx = 1;
			constraintsBoundJNumberTextField2.gridy = 1;
			constraintsBoundJNumberTextField2.fill = java.awt.GridBagConstraints.BOTH;
			constraintsBoundJNumberTextField2.weightx = 1.0;
			constraintsBoundJNumberTextField2.weighty = 1.0;
			add(getBoundJNumberTextField2(), constraintsBoundJNumberTextField2);
			initConnections();
			connEtoM1();
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	protected void setPosition2D(double x, double y) {

		de.uniwue.ki.util.Position2D position2D =
			(de.uniwue.ki.util.Position2D) getArgumentDeclaration().getObject();

		if ((position2D.getX() != x) || (position2D.getY() != y)) {
			getArgumentDeclaration().setObject(new de.uniwue.ki.util.Position2D(x, y));
		}
	}

	public String getTitle() {
		return "Insert Position";
	}
}