package de.uniwue.ki.gui.mas.basics.feature.spatial;

import java.awt.event.MouseEvent;

import javax.swing.Icon;

import de.uniwue.ki.gui.util.SwingMoreUtilities;
import de.uniwue.ki.mas.basics.feature.spatial.DefaultSpatialMapModel;
import de.uniwue.ki.util.Position2D;

/**
 * @author oechslein
 * 
 * Creation date: 23.07.2003
 */
public class RemoveSpatialInfoSpatialMapPanelState extends AbstractSpatialMapPanelState {

	public Icon getIcon() {
		return SwingMoreUtilities.getJavaSunIcon(24, "general/UserDelete24.gif");
	}

	public String getName() {
		return "Remove";
	}

	public void mousePressed(MouseEvent e) {
		if ((e.getClickCount() > 1) && (e.getButton() == MouseEvent.BUTTON1)) {
			mouseDoubleClicked(e);
		}
	}

	private DefaultSpatialMapModel getModel() {
		return (DefaultSpatialMapModel) getSpatialMapPanel().getSpatialMapModel();
	}

	private double getXFactor() {
		return getModel().getWidth() / getSpatialMapPanel().getWidth();
	}

	private double getYFactor() {
		return getModel().getHeight() / getSpatialMapPanel().getHeight();
	}

	// TODO hier wird der Suchradius allmhlich verringert, falls auch schon Agenten im kleineren Suchradius liegen; Mhlberger 30.10.03 
	protected void mouseDoubleClicked(MouseEvent e) {
		// minRadius is 1/3 * sqrt(gridWidth*gridHeight) -> removeOperation is 3-steps-sensitive
		double minRadius =
			Math.sqrt(
				(getModel().getHeight() / getModel().getGridRows())
					* (getModel().getWidth() / getModel().getGridCols()))
				/ 3.0;

		Position2D pos = new Position2D(e.getPoint().x, e.getPoint().y);
		Position2D curPos = new Position2D(pos.x * getXFactor(), pos.y * getYFactor());

		double radius = 3 * minRadius;

		if (getModel().getSpatialInfoCount(curPos, radius) > 0) {
			if (getModel().getSpatialInfoCount(curPos, radius - minRadius) > 0) {
				radius -= minRadius;
				if (getModel().getSpatialInfoCount(curPos, minRadius) > 0) {
					radius = minRadius;
				}
			}
			//getModel().undoableMapEventHappened(new UndoableSpatialInfoRemovedEdit(getModel().getSpatialInfoAt(curPos, radius, 0), getModel()));
			getModel().removeSpatialInfo(getModel().getSpatialInfoAt(curPos, radius, 0));
		}
	}
}
