package de.uniwue.ki.gui.mas.basics.feature.spatial;
import de.uniwue.ki.gui.mas.basics.type.argument.IArgumentDeclarationEditor;
import de.uniwue.ki.gui.mas.basics.type.argument.IArgumentDeclarationEditorParameter;
import de.uniwue.ki.mas.basics.feature.spatial.ISpatialInfo;
import de.uniwue.ki.mas.basics.feature.spatial.SpatialInfoType;

/**
 * Creation date: (05.10.2001 16:22:38)
 * @author Christoph Oechslein
 */
public class SpatialInfoTypeArgumentEditorPanel
	extends WriteableSpatialInfoPanel
	implements IArgumentDeclarationEditor {

	public SpatialInfoTypeArgumentEditorPanel() {
		super();
		initialize();
	}

	protected void eventButtonPressed() {
	}

	public de.uniwue.ki.mas.basics.type.argument.IArgumentDeclaration getArgumentDeclaration() {
		if (getSpatialInfo() != null) {
			return de
				.uniwue
				.ki
				.mas
				.basics
				.type
				.argument
				.ArgumentDeclarationFactory
				.getInstance()
				.createArgumentDeclaration(SpatialInfoType.getInstance(), getSpatialInfo());
		} else {
			return null;
		}
	}

	public String getTitle() {
		return "Insert Spatialinfo";
	}

	/**
	 * Called whenever the part throws an exception.
	 * @param exception Throwable
	 */
	private void handleException(Throwable exception) {

		exception.printStackTrace(System.out);
	}

	/**
	 * Initializes connections
	 * @exception Exception The exception description.
	 */
	private void initConnections() {
	}

	/**
	 * Initialize the class.
	 */
	private void initialize() {
		try {
					setName("ImageTypeArgumentEditorPanel");
			setSize(217, 25);
			initConnections();
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	public static void main(String[] args) {
		try {
			javax.swing.JFrame frame = new javax.swing.JFrame();
			SpatialInfoTypeArgumentEditorPanel aImageTypeArgumentEditorPanel;
			aImageTypeArgumentEditorPanel = new SpatialInfoTypeArgumentEditorPanel();
			frame.setContentPane(aImageTypeArgumentEditorPanel);
			frame.setSize(aImageTypeArgumentEditorPanel.getSize());
			frame.addWindowListener(new java.awt.event.WindowAdapter() {
				public void windowClosing(java.awt.event.WindowEvent e) {
					System.exit(0);
				}
			});
			frame.show();
			java.awt.Insets insets = frame.getInsets();
			frame.setSize(
				frame.getWidth() + insets.left + insets.right,
				frame.getHeight() + insets.top + insets.bottom);
			frame.setVisible(true);
		} catch (Throwable exception) {
			System.err.println(
				"Exception occurred in main() of de.uniwue.ki.gui.mas.model.basics.feature.spatial.ImageTypeArgumentEditorPanel");
			exception.printStackTrace(System.out);
		}
	}

	public void setArgumentDeclarationEditorParameter(IArgumentDeclarationEditorParameter argumentDeclarationEditorParameter) {
		setGUISeSAmDeclaration(argumentDeclarationEditorParameter.getGUISeSAmDeclaration());

		Object obj = argumentDeclarationEditorParameter.getArgumentDeclaration().getObject();

		if (obj == null) {

		} else {
			setSpatialInfo((ISpatialInfo) obj);
		}

	}

	public boolean inModalPanel() {
		return true;
	}
}