package de.uniwue.ki.gui.mas.basics.feature.spatial;
import java.awt.Container;

import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.model.IObjectPanelAndActionFactory;
import de.uniwue.ki.gui.mas.util.AbstractActionFactory;
import de.uniwue.ki.gui.util.IObjectPanelFactory;
import de.uniwue.ki.gui.util.JDisposeablePanel;
import de.uniwue.ki.mas.basics.feature.IObjectFeature;
import de.uniwue.ki.mas.basics.feature.spatial.SpatialMapObjectFeature;

/**
 * Creation date: Nov 2003
 * @author Rainer Herrler
 */

public class SpatialMapObjectFeaturePanelAndActionFactory
extends AbstractActionFactory
	implements IObjectPanelAndActionFactory {

	private final IObjectPanelFactory  _objectFeaturePanelFactory =
		new ObjectFeaturePanelFactory();

	private class ObjectFeaturePanelFactory implements IObjectPanelFactory {

		public JDisposeablePanel createObjectPanel(Object feature) {
			JSpatialMapPanelWithSelectedIObjects objectFeaturePanel =
				new JSpatialMapPanelWithSelectedIObjects();

			objectFeaturePanel.setGUISeSAmDeclaration(getGUISeSAmDeclaration());
			objectFeaturePanel.setObjectFeature((IObjectFeature)feature);

			return objectFeaturePanel;
		}
		
		public String getObjectTitle(Object anObject) {
			return "Map";
		}
	}

	public SpatialMapObjectFeaturePanelAndActionFactory(IGUISeSAmDeclaration guiSDecl) {
		super(guiSDecl);
	}
	
	public boolean getCanProduceActions(Container parent, Object anObject) {
		return anObject instanceof SpatialMapObjectFeature;
	}

	public IObjectPanelFactory getPanelFactory(
		Container parent,
		Object anDeclaration) {
		return _objectFeaturePanelFactory;
	}
}