package de.uniwue.ki.gui.mas.basics.feature.spatial;

import java.util.HashMap;

import javax.swing.undo.*;

import de.uniwue.ki.mas.basics.feature.spatial.*;
import de.uniwue.ki.mas.entity.object.IObjectInstanceDeclaration;
import de.uniwue.ki.util.copy.ICopyable;

/**
 * @author Reinhard Hatko
 * 
 * 25.11.2003
 */
public class UndoableSpatialInfoAddedEdit extends AbstractUndoableEdit {
	
	private ISpatialInfo _spatialInfoToRemoveWhenUndo;
	private ISpatialInfo _spatialInfoToAddWhenRedo;
	private ISpatialMapModel _mapModel;
	private IObjectInstanceDeclaration _objInstDec;
	
	public UndoableSpatialInfoAddedEdit(ISpatialInfo spatialInfo, ISpatialMapModel mapModel){
		_spatialInfoToRemoveWhenUndo = spatialInfo;
		_mapModel = mapModel;
		_objInstDec = (IObjectInstanceDeclaration) ((ICopyable) _spatialInfoToRemoveWhenUndo.getObject()).copy(new HashMap());
		
		_spatialInfoToAddWhenRedo =
		((IHasSpatialInfoDeclaration) _objInstDec.getObjectFeatureInstanceDeclarationList().getDeclarationByName("SpatialInfo")).getSpatialInfo();
		
	}
	
	public String getRedoPresentationName() {
		return "Add Agent";
	}
	
	public String getUndoPresentationName() {
		return "Add Agent";
	}

	public void undo() throws CannotUndoException {
		super.undo();
		_mapModel.removeSpatialInfo(_spatialInfoToRemoveWhenUndo);
	}
		
	public void redo() throws CannotRedoException {
		super.redo();
		_spatialInfoToAddWhenRedo.setObject(_objInstDec);
		_mapModel.addSpatialInfo(_spatialInfoToAddWhenRedo);
		_spatialInfoToRemoveWhenUndo =_spatialInfoToAddWhenRedo;
		_objInstDec = (IObjectInstanceDeclaration) ((ICopyable) _spatialInfoToRemoveWhenUndo.getObject()).copy(new HashMap());
		
		_spatialInfoToAddWhenRedo=
		((IHasSpatialInfoDeclaration) _objInstDec.getObjectFeatureInstanceDeclarationList().getDeclarationByName("SpatialInfo")).getSpatialInfo();
	}
	
	
	
}
