package de.uniwue.ki.gui.mas.basics.feature.spatial;

import java.util.HashMap;

import javax.swing.undo.*;

import de.uniwue.ki.mas.basics.feature.spatial.*;
import de.uniwue.ki.mas.entity.object.IObjectInstanceDeclaration;
import de.uniwue.ki.util.copy.ICopyable;

/**
 * @author Reinhard Hatko
 * 
 * 25.11.2003
 */
public class UndoableSpatialInfoRemovedEdit extends AbstractUndoableEdit {
	
	private ISpatialInfo _spatialInfoToAddWhenUndo;
	private ISpatialInfo _spatialInfoToRemoveWhenRedo;
	private ISpatialMapModel _mapModel;
	private IObjectInstanceDeclaration _objInstDec;
	
	public UndoableSpatialInfoRemovedEdit(ISpatialInfo spatialInfo, ISpatialMapModel mapModel){
		_mapModel = mapModel;
		_objInstDec = (IObjectInstanceDeclaration) ((ICopyable) spatialInfo.getObject()).copy(new HashMap());
		_spatialInfoToAddWhenUndo =
			((IHasSpatialInfoDeclaration) _objInstDec.getObjectFeatureInstanceDeclarationList().getDeclarationByName("SpatialInfo")).getSpatialInfo();
	}
	
	public String getRedoPresentationName() {
		return "Remove Agent";
	}
	
	public String getUndoPresentationName() {
		return "Remove Agent";
	}

	public void undo() throws CannotUndoException {
		super.undo();
		_spatialInfoToAddWhenUndo.setObject(_objInstDec);
		_mapModel.addSpatialInfo(_spatialInfoToAddWhenUndo);	
		_spatialInfoToRemoveWhenRedo = _spatialInfoToAddWhenUndo;
	
	}
		
	public void redo() throws CannotRedoException{
		super.redo();
		_objInstDec = (IObjectInstanceDeclaration) ((ICopyable) _spatialInfoToRemoveWhenRedo.getObject()).copy(new HashMap());
		_spatialInfoToAddWhenUndo = ((IHasSpatialInfoDeclaration) _objInstDec.getObjectFeatureInstanceDeclarationList().getDeclarationByName("SpatialInfo")).getSpatialInfo();
		_mapModel.removeSpatialInfo(_spatialInfoToRemoveWhenRedo);
		

	}
}