package de.uniwue.ki.gui.mas.basics.feature.spatial;

import javax.swing.undo.AbstractUndoableEdit;
import javax.swing.undo.CannotUndoException;

import de.uniwue.ki.mas.basics.feature.spatial.ISpatialInfo;
import de.uniwue.ki.util.Position2D;

/**
 * @author Reinhard Hatko
 * 
 * 25.11.2003
 */
public class UndoableSpatialInfosMovedEdit extends AbstractUndoableEdit {
	
	ISpatialInfo[] _spatialInfos;
	Position2D[] _oldPositions;
	Position2D[] _newPositions;
	
	public UndoableSpatialInfosMovedEdit(ISpatialInfo[] spatialInfos, Position2D[] oldPositions){
		_spatialInfos = spatialInfos;
		_oldPositions = oldPositions;
		_newPositions = new Position2D[oldPositions.length];
	}
	
	public String getRedoPresentationName() {
		return "Move " + _spatialInfos.length + " Agent" + (_spatialInfos.length > 1 ? "s" : "");
	}
	
	public String getUndoPresentationName() {
		return "Move " + _spatialInfos.length + " Agent" + (_spatialInfos.length > 1 ? "s" : "");
	}

	public void undo() throws CannotUndoException {
		super.undo();
		for (int i = 0; i < _spatialInfos.length; i++){ 
			_newPositions[i] = (Position2D) _spatialInfos[i].getPosition().clone();
			_spatialInfos[i].setPosition(_oldPositions[i]);
		}
	}
		
	public void redo() throws CannotUndoException {
		super.redo();
		for (int i = 0; i < _spatialInfos.length; i++){ 
			_spatialInfos[i].setPosition(_newPositions[i]);
		}
	}
}
