package de.uniwue.ki.gui.mas.basics.feature.spatial;
import java.awt.*;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import java.io.File;

import javax.swing.*;

import com.jgoodies.forms.extras.DefaultFormBuilder;
import com.jgoodies.forms.layout.CellConstraints;

import de.uniwue.ki.gui.util.ExtensionsFileFilter;
import de.uniwue.ki.gui.util.SwingMoreUtilities;
import de.uniwue.ki.gui.util.actions.AbstractBoundAction;
import de.uniwue.ki.gui.util.border.BetterTitledBorder;
import de.uniwue.ki.gui.util.bound.BetterBoundJTextField;
import de.uniwue.ki.gui.util.bound.BoundJDoubleTextField;
import de.uniwue.ki.mas.basics.feature.spatial.*;

public class WriteableSpatialInfoPanel extends SpatialInfoPanel {
	private boolean _inSettingEvent = false;
	private final IvjEventHandler ivjEventHandler = new IvjEventHandler();
	private JButton ivjJButtonImage;
	private JLabel ivjJLabelImageIcon;
	private BetterBoundJTextField ivjJTextFieldImage;
	private BoundJDoubleTextField _JTextFieldDrawPriority;
	private ISpatialMapModel ivjSpatialMapModelIntern;

	private final class IvjEventHandler implements java.beans.PropertyChangeListener {
		public void propertyChange(java.beans.PropertyChangeEvent evt) {
			if (evt.getSource() == WriteableSpatialInfoPanel.this.getJTextFieldPosX()
				&& (evt.getPropertyName().equals("doubleValue")))
				connEtoC3(evt);
			if (evt.getSource() == WriteableSpatialInfoPanel.this.getJTextFieldPosY()
				&& (evt.getPropertyName().equals("doubleValue")))
				connEtoC4(evt);
			if (evt.getSource() == WriteableSpatialInfoPanel.this.getJTextFieldSpeed()
				&& (evt.getPropertyName().equals("doubleValue")))
				connEtoC6(evt);
			if (evt.getSource() == WriteableSpatialInfoPanel.this.getJTextFieldRadius()
				&& (evt.getPropertyName().equals("doubleValue")))
				connEtoC8(evt);
			if (evt.getSource() == WriteableSpatialInfoPanel.this.getJTextFieldDirection()
				&& (evt.getPropertyName().equals("doubleValue")))
				connEtoC5(evt);
			if (evt.getSource() == WriteableSpatialInfoPanel.this.getJTextFieldDrawPriority()
				&& (evt.getPropertyName().equals("doubleValue")))
				eventDrawPriorityChanged();
			if (evt.getSource() == WriteableSpatialInfoPanel.this.getJTextFieldImage()
				&& (evt.getPropertyName().equals("text")))
				connEtoC_ImageTextFieldChanged(evt);
		}
	}

	/**
	 * SpatialInfoFeatureInstanceDeclarationPanel constructor comment.
	 */
	public WriteableSpatialInfoPanel() {
		super();
		initialize();
	}

	private void connEtoC_ImageTextFieldChanged(java.beans.PropertyChangeEvent arg1) {
		try {
			this.eventImageTextFieldChanged();			
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	protected void eventSpatialInfoChanged() {
		if (_inSettingEvent == false) {
			_inSettingEvent = true;
			try {
				super.eventSpatialInfoChanged();
				getJTextFieldDrawPriority().setDoubleValue(getSpatialInfo().getDrawPriority());
			} finally {
				_inSettingEvent = false;
			}
		}

		updateImageIcon();
	}

	/**
	 * connEtoC3:  (JTextFieldPosX.doubleValue --> SpatialInfoFeatureInstanceDeclarationPanel.positionChanged()V)
	 * @param arg1 java.beans.PropertyChangeEvent
	 */
	private void connEtoC3(java.beans.PropertyChangeEvent arg1) {
		try {
					this.eventPositionChanged();
				} catch (Throwable ivjExc) {
					handleException(ivjExc);
		}
	}

	/**
	 * connEtoC4:  (JTextFieldPosY.doubleValue --> SpatialInfoFeatureInstanceDeclarationPanel.positionChanged()V)
	 * @param arg1 java.beans.PropertyChangeEvent
	 */
	private void connEtoC4(java.beans.PropertyChangeEvent arg1) {
		try {
					this.eventPositionChanged();
				} catch (Throwable ivjExc) {
					handleException(ivjExc);
		}
	}

	/**
	 * connEtoC5:  (JTextFieldDirection.doubleValue --> SpatialInfoFeatureInstanceDeclarationPanel.directionChanged()V)
	 * @param arg1 java.beans.PropertyChangeEvent
	 */
	private void connEtoC5(java.beans.PropertyChangeEvent arg1) {
		try {
					this.eventDirectionChanged();
				} catch (Throwable ivjExc) {
					handleException(ivjExc);
		}
	}

	/**
	 * connEtoC6:  (JTextFieldSpeed.doubleValue --> SpatialInfoFeatureInstanceDeclarationPanel.directionChanged()V)
	 * @param arg1 java.beans.PropertyChangeEvent
	 */
	private void connEtoC6(java.beans.PropertyChangeEvent arg1) {
		try {
					this.eventSpeedChanged();
				} catch (Throwable ivjExc) {
					handleException(ivjExc);
		}
	}



	/**
	 * connEtoC8:  (JTextFieldRadius.doubleValue --> SpatialInfoFeatureInstanceDeclarationPanel.radiusChanged()V)
	 * @param arg1 java.beans.PropertyChangeEvent
	 */
	private void connEtoC8(java.beans.PropertyChangeEvent arg1) {
		try {
					this.eventRadiusChanged();
				} catch (Throwable ivjExc) {
					handleException(ivjExc);
		}
	}

	protected void eventBrowseImagePath() {
		if (getSpatialInfo() != null) {
			JFileChooser fileChooser = new JFileChooser(getSpatialInfo().getImagePath());
			fileChooser.addChoosableFileFilter(
				new ExtensionsFileFilter("Image (*.gif;*.jpg;*.png)", new String[] { "gif", "jpg", "png" }));
			if (fileChooser.showOpenDialog(null) != JFileChooser.APPROVE_OPTION)
				return;

			getJTextFieldImage().setText(fileChooser.getSelectedFile().toString());
		}
	}

	protected void eventDirectionChanged() {
		if (_inSettingEvent == false) {
			_inSettingEvent = true;
			try {

				if (getSpatialInfo() != null) {
					double newDirection = Math.toRadians(getJTextFieldDirection().getDoubleValue());

					if (getSpatialMapModel() != null) {
						getSpatialMapModel().changeDirection(getSpatialInfo(), newDirection);

					} else {
						getSpatialInfo().setDirection(newDirection);
					}
				}

			} finally {
				_inSettingEvent = false;
			}
		}
	}

	protected void eventSpatialMapModelChanged() {
		if (_inSettingEvent == false) {
			_inSettingEvent = true;
			try {

				// setEditable(getSpatialMapModel() != null);
			} finally {
				_inSettingEvent = false;
			}
		}
	}

	protected void eventImageTextFieldChanged() {
		if (_inSettingEvent == false) {
			_inSettingEvent = true;
			try {

				if (getSpatialInfo() != null) {

					String fileString = getJTextFieldImage().getText();

					File newImagePath = null;

					if (fileString.length() > 0) {
						File newFile = new File(fileString);
						if (!newFile.equals(getSpatialInfo().getImagePath())) {
							if (newFile.exists()) {
								newImagePath = newFile;
							} else if (getSpatialInfo().getImagePath() == null) {
								getJTextFieldImage().setText("");
							} else {
								getJTextFieldImage().setText(getSpatialInfo().getImagePath().toString());
							}
						}
					}

					if (getSpatialMapModel() != null) {
						getSpatialMapModel().changeImagePath(getSpatialInfo(), newImagePath);
					} else {
						getSpatialInfo().setImagePath(newImagePath);
					}
				}

			} finally {
				_inSettingEvent = false;
			}
		}

		updateImageIcon();
	}

	protected void eventPositionChanged() {
		if (_inSettingEvent == false) {
			_inSettingEvent = true;
			try {

				if (getSpatialInfo() != null) {

					if (getSpatialMapModel() != null) {
						getSpatialMapModel().changePosition(
							getSpatialInfo(),
							getJTextFieldPosX().getDoubleValue(),
							getJTextFieldPosY().getDoubleValue());

					} else {
						getSpatialInfo().getPosition().setLocation(
							getJTextFieldPosX().getDoubleValue(),
							getJTextFieldPosY().getDoubleValue());
					}
				}

			} finally {
				_inSettingEvent = false;
			}
		}
	}

	protected void eventRadiusChanged() {
		if (_inSettingEvent == false) {
			_inSettingEvent = true;
			try {
				if (getSpatialInfo() != null) {

					if (getSpatialMapModel() != null) {
						getSpatialMapModel().changeRadius(
							getSpatialInfo(),
							getJTextFieldRadius().getDoubleValue());
					} else {
						getSpatialInfo().setRadius(getJTextFieldRadius().getDoubleValue());
					}
				}

			} finally {
				_inSettingEvent = false;
			}
		}
	}

	protected void updateImageIcon() {
		ISpatialInfo spatialInfo = getSpatialInfo();

		if (spatialInfo == null)
			return;

		if (_inSettingEvent == false) {
			_inSettingEvent = true;
			try {

				getAgentImageIconLabel().setText(null);

				Image image;

				if (spatialInfo.getImagePath() == null) {
					image = ImageType.getDefaultAgentImage();

					getJTextFieldImage().setText("");

				} else {
					image = Toolkit.getDefaultToolkit().getImage(spatialInfo.getImagePath().toString());

					getJTextFieldImage().setText(spatialInfo.getImagePath().toString());
				}

				int width = Math.max(100, getAgentImageIconLabel().getWidth());
				int height = Math.max(100, getAgentImageIconLabel().getWidth());

				SwingMoreUtilities.waitForImage(image, width, height);

				Image scaledImage =
					SwingMoreUtilities.scaleImageIfToLarge(image, width, height, getAgentImageIconLabel());

				getAgentImageIconLabel().setIcon(new ImageIcon(scaledImage));

			} finally {
				_inSettingEvent = false;
			}
		}
	}

	protected void eventSpeedChanged() {
		if (_inSettingEvent == false) {
			_inSettingEvent = true;
			try {

				if (getSpatialInfo() != null) {

					if (getSpatialMapModel() != null) {
						getSpatialMapModel().changeSpeed(
							getSpatialInfo(),
							getJTextFieldSpeed().getDoubleValue());
					} else {
						getSpatialInfo().setSpeed(getJTextFieldSpeed().getDoubleValue());
					}
				}

			} finally {
				_inSettingEvent = false;
			}
		}
	}
	
	private void eventDrawPriorityChanged(){
		if (_inSettingEvent == false) {
			_inSettingEvent = true;
			try {

				if (getSpatialInfo() != null) {
					double newPriority = getJTextFieldDrawPriority().getDoubleValue();

					if (getSpatialMapModel() != null) {
						getSpatialMapModel().changeDrawPriority(getSpatialInfo(), newPriority);

					} else {
						getSpatialInfo().setDrawPriority(newPriority);
					}
				}

			} finally {
				_inSettingEvent = false;
			}
		}
		
	}


	/**
	 * Method generated to support the promotion of the SpatialMapModel attribute.
	 * @return de.uniwue.ki.mas.model.basics.feature.spatial.ISpatialMapModel
	 */
	public ISpatialMapModel getSpatialMapModel() {
		return getSpatialMapModelIntern();
	}

	private ISpatialMapModel getSpatialMapModelIntern() {
		return ivjSpatialMapModelIntern;
	}

	private JButton getBrowseImageButton() {
		if (ivjJButtonImage == null) {
			ivjJButtonImage = new javax.swing.JButton(new AbstractBoundAction("Browse ...") {
				public void doit() {
					eventBrowseImagePath();
				}
			});
		}
		return ivjJButtonImage;
	}

	private JLabel getAgentImageIconLabel() {
		if (ivjJLabelImageIcon == null) {
			try {
				ivjJLabelImageIcon = new javax.swing.JLabel();
				ivjJLabelImageIcon.setName("getJLabelImageIcon");
				ivjJLabelImageIcon.setBorder(new BetterTitledBorder());
				ivjJLabelImageIcon.setText("No image");
				ivjJLabelImageIcon.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
				ivjJLabelImageIcon.setVerticalTextPosition(javax.swing.SwingConstants.CENTER);
				ivjJLabelImageIcon.setVerticalAlignment(javax.swing.SwingConstants.CENTER);
				ivjJLabelImageIcon.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
				ivjJLabelImageIcon.setPreferredSize(new Dimension(0, 0));
				ivjJLabelImageIcon.addComponentListener(new ComponentAdapter() {
					public void componentResized(ComponentEvent e) {
						updateImageIcon();
					}
				});
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjJLabelImageIcon;
	}

	private BetterBoundJTextField getJTextFieldImage() {
		if (ivjJTextFieldImage == null) {
			try {
				ivjJTextFieldImage = new BetterBoundJTextField();
				ivjJTextFieldImage.setName("JTextFieldImage");
				//ivjJTextFieldImage.setMinimumSize(new java.awt.Dimension(100, 20));
				ivjJTextFieldImage.setColumns(20);
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjJTextFieldImage;
	}
	
	private BoundJDoubleTextField getJTextFieldDrawPriority() {
		if (_JTextFieldDrawPriority == null) {
			try {
				_JTextFieldDrawPriority = new BoundJDoubleTextField();
				_JTextFieldDrawPriority.setName("JTextFieldDrawPriority");
				_JTextFieldDrawPriority.setColumns(10);
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return _JTextFieldDrawPriority;
	}

	private void handleException(Throwable exception) {
		exception.printStackTrace(System.out);
	}

	private void initConnections() {
		getJTextFieldPosX().addPropertyChangeListener(ivjEventHandler);
		getJTextFieldPosY().addPropertyChangeListener(ivjEventHandler);
		getJTextFieldSpeed().addPropertyChangeListener(ivjEventHandler);
		getJTextFieldRadius().addPropertyChangeListener(ivjEventHandler);
		getJTextFieldDirection().addPropertyChangeListener(ivjEventHandler);
		getJTextFieldDrawPriority().addPropertyChangeListener(ivjEventHandler);
		getJTextFieldImage().addPropertyChangeListener(ivjEventHandler);
	}

	private void initialize() {
		getJTextFieldSpeed().setEditable(true);
		getJTextFieldDirection().setEditable(true);
		getJTextFieldRadius().setEditable(true);
		getJTextFieldPosX().setEditable(true);
		getJTextFieldPosY().setEditable(true);

		initConnections();
	}

	protected String getFormLayoutString() {
		return super.getFormLayoutString() + ", 4dlu, fill:pref";
	}

	protected void addComponents(DefaultFormBuilder builder) {
		super.addComponents(builder);

		builder.nextLine();
		builder.append("DrawPriority:", getJTextFieldDrawPriority());
		builder.append("Image:", getJTextFieldImage());
		builder.append(getBrowseImageButton());
		builder.add(getAgentImageIconLabel(), new CellConstraints().xywh(9, 1, 1, 3, "fill, fill"));
	}

	public void refresh() {
		eventSpatialInfoChanged();
	}

	/**
	 * Method generated to support the promotion of the SpatialMapModel attribute.
	 * @param arg1 de.uniwue.ki.mas.model.basics.feature.spatial.ISpatialMapModel
	 */
	public void setSpatialMapModel(ISpatialMapModel arg1) {
		setSpatialMapModelIntern(arg1);
	}

	/**
	 * Set the SpatialMapModelIntern to a new value.
	 * @param newValue de.uniwue.ki.mas.model.basics.feature.spatial.ISpatialMapModel
	 */
	private void setSpatialMapModelIntern(ISpatialMapModel newValue) {
		if (ivjSpatialMapModelIntern != newValue) {
			try {
				ISpatialMapModel oldValue = getSpatialMapModelIntern();
				ivjSpatialMapModelIntern = newValue;
				firePropertyChange("spatialMapModel", oldValue, newValue);
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
	}

	public void setEnabled(boolean isEnabled) {
		super.setEnabled(isEnabled);

		getJTextFieldImage().setEnabled(isEnabled);
		getBrowseImageButton().setEnabled(isEnabled);
	}
}