package de.uniwue.ki.gui.mas.basics.feature.user;
import de.uniwue.ki.gui.mas.util.declaration.DeclarationListPanel;
import de.uniwue.ki.gui.util.dnd.ObjectDataFlavor;
import de.uniwue.ki.mas.basics.feature.user.*;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: (13.12.2000 18:26:47)
 * @author Christoph Oechslein
 */
public class UserFeatureClassDeclarationListPanel extends DeclarationListPanel {

	/**
	 * UserDefinedFunctionDeclarationListPanel constructor comment.
	 */
	public UserFeatureClassDeclarationListPanel() {
		super();
		initialize();
	}


	/**
	 * Called whenever the part throws an exception.
	 * @param exception Throwable
	 */
	private void handleException(Throwable exception) {
		exception.printStackTrace(System.out);
	}

	/**
	 * Initialize the class.
	 */
	private void initialize() {
		try {
					setName("UserFeatureClassDeclarationListPanel");
			setDeclarationFactory(new UserFeatureClassDeclarationFactory());
			setSize(210, 282);
			setDeclarationListModel(new UserFeatureClassDeclarationList());
			setCellRenderer(new UserFeatureClassDeclarationCellRenderer(getCellRenderer()));
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
		enableDnDSupport(ObjectDataFlavor.getDataFlavor(IUserFeatureClassDeclaration.class));
	}

	public static void main(String[] args) {
		try {
			javax.swing.JFrame frame = new javax.swing.JFrame();
			UserFeatureClassDeclarationListPanel aUserFeatureClassDeclarationListPanel;
			aUserFeatureClassDeclarationListPanel = new UserFeatureClassDeclarationListPanel();
			frame.setContentPane(aUserFeatureClassDeclarationListPanel);
			frame.setSize(aUserFeatureClassDeclarationListPanel.getSize());
			frame.addWindowListener(new java.awt.event.WindowAdapter() {
				public void windowClosing(java.awt.event.WindowEvent e) {
					System.exit(0);
				}
			});
			frame.show();
			java.awt.Insets insets = frame.getInsets();
			frame.setSize(
				frame.getWidth() + insets.left + insets.right,
				frame.getHeight() + insets.top + insets.bottom);
			frame.setVisible(true);
		} catch (Throwable exception) {
			System.err.println(
				"Exception occurred in main() of de.uniwue.ki.gui.mas.model.basics.feature.user.UserFeatureClassDeclarationListPanel");
			exception.printStackTrace(System.out);
		}
	}

	protected boolean shouldUseOkCancelDeclarationPanelFor(IDeclaration declaration) {
		return false;
	}
}