package de.uniwue.ki.gui.mas.basics.feature.user;
import java.awt.*;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.*;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import de.uniwue.ki.gui.mas.util.declaration.AbstractDeclarationPanel;
import de.uniwue.ki.gui.mas.util.declaration.NameDeclarationWithDocumentationPanel;
import de.uniwue.ki.mas.basics.feature.user.IUserFeatureClassDeclaration;
import de.uniwue.ki.mas.entity.variableclass.FeatureVariableClassDeclarationFactory;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: (15.12.2000 14:15:54)
 * @author Christoph Oechslein
 */
public class UserFeatureClassDeclarationPanel extends AbstractDeclarationPanel {
	private IUserFeatureClassDeclaration ivjUserFeatureClassDeclarationIntern = null;
	private UserFeatureVariableClassDeclarationListPanel ivjVariableClassDeclarationListPanel = null;
	private final IvjEventHandler ivjEventHandler = new IvjEventHandler();
	private boolean ivjConnPtoP10Aligning = false;
	private JPanel ivjJPanelVariablesAndFunctions = null;
	private boolean ivjConnPtoP3Aligning = false;
	private NameDeclarationWithDocumentationPanel ivjNameDeclarationWithDocumentationPanel1 = null;
	private boolean ivjConnPtoP4Aligning = false;
	private UserFeatureFunctionDeclarationListPanel ivjUserDefinedFunctionDeclarationListForUserFeaturePanel =
		null;

	private final class IvjEventHandler
		implements java.beans.PropertyChangeListener,ChangeListener {
		public void propertyChange(java.beans.PropertyChangeEvent evt) {
			if (evt.getSource() == UserFeatureClassDeclarationPanel.this
				&& (evt.getPropertyName().equals("gUISeSAmDeclaration")))
				connPtoP3SetTarget();
			if (evt.getSource()
				== UserFeatureClassDeclarationPanel
					.this
					.getUserDefinedFunctionDeclarationListForUserFeaturePanel()
				&& (evt.getPropertyName().equals("gUISeSAmDeclaration")))
				connPtoP3SetSource();
			if (evt.getSource()
				== UserFeatureClassDeclarationPanel
					.this
					.getUserDefinedFunctionDeclarationListForUserFeaturePanel()
				&& (evt.getPropertyName().equals("userFeatureClassDeclaration")))
				connPtoP4SetSource();
			if (evt.getSource() == UserFeatureClassDeclarationPanel.this
				&& (evt.getPropertyName().equals("gUISeSAmDeclaration")))
				connPtoP10SetTarget();
			if (evt.getSource()
				== UserFeatureClassDeclarationPanel.this.getVariableClassDeclarationListPanel()
				&& (evt.getPropertyName().equals("gUISeSAmDeclaration")))
				connPtoP10SetSource();
			if (evt.getSource()
				== UserFeatureClassDeclarationPanel.this.getVariableClassDeclarationListPanel()
				&& (evt.getPropertyName().equals("userFeatureClassDeclaration")))
				connPtoP1SetSource();
		}
		public void stateChanged(ChangeEvent e) {
			if (e.getSource()
				== UserFeatureClassDeclarationPanel.this.getUserFeatureClassDeclarationIntern())
				connPtoP7SetTarget();
		}
	}
	private boolean ivjConnPtoP1Aligning = false;

	public UserFeatureClassDeclarationPanel() {
		super();
		initialize();
	}

	private void connPtoP10SetSource() {
		try {
			if (ivjConnPtoP10Aligning == false) {
				ivjConnPtoP10Aligning = true;
				this.setGUISeSAmDeclaration(getVariableClassDeclarationListPanel().getGUISeSAmDeclaration());
				ivjConnPtoP10Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP10Aligning = false;
			handleException(ivjExc);
		}
	}

	private void connPtoP10SetTarget() {
		try {
			if (ivjConnPtoP10Aligning == false) {
				ivjConnPtoP10Aligning = true;
				getVariableClassDeclarationListPanel().setGUISeSAmDeclaration(this.getGUISeSAmDeclaration());
				ivjConnPtoP10Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP10Aligning = false;
			handleException(ivjExc);
		}
	}

	private void connPtoP1SetSource() {
		try {
			if (ivjConnPtoP1Aligning == false) {
				ivjConnPtoP1Aligning = true;
				setUserFeatureClassDeclarationIntern(
					getVariableClassDeclarationListPanel().getUserFeatureClassDeclaration());
				ivjConnPtoP1Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP1Aligning = false;
			handleException(ivjExc);
		}
	}

	private void connPtoP1SetTarget() {
		try {
			if (ivjConnPtoP1Aligning == false) {
				ivjConnPtoP1Aligning = true;
				if ((getUserFeatureClassDeclarationIntern() != null)) {
					getVariableClassDeclarationListPanel().setUserFeatureClassDeclaration(
						getUserFeatureClassDeclarationIntern());
				}
				ivjConnPtoP1Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP1Aligning = false;
			handleException(ivjExc);
		}
	}

	private void connPtoP3SetSource() {
		try {
			if (ivjConnPtoP3Aligning == false) {
				ivjConnPtoP3Aligning = true;
				this.setGUISeSAmDeclaration(
					getUserDefinedFunctionDeclarationListForUserFeaturePanel().getGUISeSAmDeclaration());
				ivjConnPtoP3Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP3Aligning = false;
			handleException(ivjExc);
		}
	}

	private void connPtoP3SetTarget() {
		try {
			if (ivjConnPtoP3Aligning == false) {
				ivjConnPtoP3Aligning = true;
				getUserDefinedFunctionDeclarationListForUserFeaturePanel().setGUISeSAmDeclaration(
					this.getGUISeSAmDeclaration());
				ivjConnPtoP3Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP3Aligning = false;
			handleException(ivjExc);
		}
	}

	private void connPtoP4SetSource() {
		try {
			if (ivjConnPtoP4Aligning == false) {
				ivjConnPtoP4Aligning = true;
				setUserFeatureClassDeclarationIntern(
					getUserDefinedFunctionDeclarationListForUserFeaturePanel()
						.getUserFeatureClassDeclaration());
				ivjConnPtoP4Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP4Aligning = false;
			handleException(ivjExc);
		}
	}

	private void connPtoP4SetTarget() {
		try {
			if (ivjConnPtoP4Aligning == false) {
				ivjConnPtoP4Aligning = true;
				if ((getUserFeatureClassDeclarationIntern() != null)) {
					getUserDefinedFunctionDeclarationListForUserFeaturePanel()
						.setUserFeatureClassDeclaration(
						getUserFeatureClassDeclarationIntern());
				}
				ivjConnPtoP4Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP4Aligning = false;
			handleException(ivjExc);
		}
	}

	private void connPtoP7SetTarget() {
		try {
			if ((getUserFeatureClassDeclarationIntern() != null)) {
				getNameDeclarationWithDocumentationPanel().setDeclaration(
					getUserFeatureClassDeclarationIntern());
			}
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	public void dispose() {
		super.dispose();

		if (getUserFeatureClassDeclaration() != null)
			getUserFeatureClassDeclaration().removePropertyChangeListener(ivjEventHandler);

		getVariableClassDeclarationListPanel().dispose();
		getUserDefinedFunctionDeclarationListForUserFeaturePanel().dispose();
	}

	public IDeclaration getDeclaration() {
		return getUserFeatureClassDeclaration();
	}

	private JPanel getJPanelVariablesAndFunctions() {
		if (ivjJPanelVariablesAndFunctions == null) {
			ivjJPanelVariablesAndFunctions = new JPanel();
			ivjJPanelVariablesAndFunctions.setLayout(
				new BoxLayout(getJPanelVariablesAndFunctions(), BoxLayout.X_AXIS));

			JTabbedPane tabbedPanel = new JTabbedPane();

			tabbedPanel.add("Variables", getVariableClassDeclarationListPanel());
			tabbedPanel.add("Functions", getUserDefinedFunctionDeclarationListForUserFeaturePanel());
			getJPanelVariablesAndFunctions().add(tabbedPanel);
		}
		return ivjJPanelVariablesAndFunctions;
	}

	private NameDeclarationWithDocumentationPanel getNameDeclarationWithDocumentationPanel() {
		if (ivjNameDeclarationWithDocumentationPanel1 == null) {
			try {
				ivjNameDeclarationWithDocumentationPanel1 = new NameDeclarationWithDocumentationPanel();
				ivjNameDeclarationWithDocumentationPanel1.setName("NameDeclarationWithDocumentationPanel1");
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjNameDeclarationWithDocumentationPanel1;
	}

	private UserFeatureFunctionDeclarationListPanel getUserDefinedFunctionDeclarationListForUserFeaturePanel() {
		if (ivjUserDefinedFunctionDeclarationListForUserFeaturePanel == null) {
			ivjUserDefinedFunctionDeclarationListForUserFeaturePanel =
				new UserFeatureFunctionDeclarationListPanel();
		}
		return ivjUserDefinedFunctionDeclarationListForUserFeaturePanel;
	}

	public IUserFeatureClassDeclaration getUserFeatureClassDeclaration() {
		return getUserFeatureClassDeclarationIntern();
	}

	private IUserFeatureClassDeclaration getUserFeatureClassDeclarationIntern() {
		return ivjUserFeatureClassDeclarationIntern;
	}

	private UserFeatureVariableClassDeclarationListPanel getVariableClassDeclarationListPanel() {
		if (ivjVariableClassDeclarationListPanel == null) {
			try {
				ivjVariableClassDeclarationListPanel = new UserFeatureVariableClassDeclarationListPanel();
				ivjVariableClassDeclarationListPanel.setName("VariableClassDeclarationListPanel");
				ivjVariableClassDeclarationListPanel.setDeclarationFactory(
					new FeatureVariableClassDeclarationFactory());
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjVariableClassDeclarationListPanel;
	}

	private void handleException(Throwable exception) {
		exception.printStackTrace(System.out);
	}

	private void initConnections() {
		addPropertyChangeListener(ivjEventHandler);
		getUserDefinedFunctionDeclarationListForUserFeaturePanel().addPropertyChangeListener(ivjEventHandler);
		getVariableClassDeclarationListPanel().addPropertyChangeListener(ivjEventHandler);
		connPtoP7SetTarget();
		connPtoP3SetTarget();
		connPtoP4SetTarget();
		connPtoP10SetTarget();
		connPtoP1SetTarget();
	}

	private void initialize() {
		setLayout(new GridBagLayout());

		GridBagConstraints constraintsJPanelVariablesAndFunctions =
			new GridBagConstraints();
		constraintsJPanelVariablesAndFunctions.gridx = 0;
		constraintsJPanelVariablesAndFunctions.gridy = 1;
		constraintsJPanelVariablesAndFunctions.fill = java.awt.GridBagConstraints.BOTH;
		constraintsJPanelVariablesAndFunctions.weightx = 1.0;
		constraintsJPanelVariablesAndFunctions.weighty = 1.0;
		add(getJPanelVariablesAndFunctions(), constraintsJPanelVariablesAndFunctions);

		GridBagConstraints constraintsNameDeclarationWithDocumentationPanel1 =
			new GridBagConstraints();
		constraintsNameDeclarationWithDocumentationPanel1.gridx = 0;
		constraintsNameDeclarationWithDocumentationPanel1.gridy = 0;
		constraintsNameDeclarationWithDocumentationPanel1.fill = java.awt.GridBagConstraints.HORIZONTAL;
		constraintsNameDeclarationWithDocumentationPanel1.weightx = 1.0;
		add(getNameDeclarationWithDocumentationPanel(), constraintsNameDeclarationWithDocumentationPanel1);

		initConnections();
	}

	public static void main(String[] args) {
		try {
			JFrame frame = new JFrame();
			UserFeatureClassDeclarationPanel aUserFeatureClassDeclarationPanel;
			aUserFeatureClassDeclarationPanel = new UserFeatureClassDeclarationPanel();
			frame.setContentPane(aUserFeatureClassDeclarationPanel);
			frame.setSize(aUserFeatureClassDeclarationPanel.getSize());
			frame.addWindowListener(new WindowAdapter() {
				public void windowClosing(WindowEvent e) {
					System.exit(0);
				}
			});
			frame.show();
			Insets insets = frame.getInsets();
			frame.setSize(
				frame.getWidth() + insets.left + insets.right,
				frame.getHeight() + insets.top + insets.bottom);
			frame.setVisible(true);
		} catch (Throwable exception) {
			System.err.println("Exception occurred in main() of JPanel");
			exception.printStackTrace(System.out);
		}
	}

	public void setDeclaration(IDeclaration declaration) {
		setUserFeatureClassDeclaration((IUserFeatureClassDeclaration)declaration);
	}

	public void setUserFeatureClassDeclaration(IUserFeatureClassDeclaration arg1) {
		setUserFeatureClassDeclarationIntern(arg1);
	}

	private void setUserFeatureClassDeclarationIntern(IUserFeatureClassDeclaration newValue) {
		if (ivjUserFeatureClassDeclarationIntern != newValue) {
			try {
				IUserFeatureClassDeclaration oldValue = getUserFeatureClassDeclarationIntern();
				/* Stop listening for events from the current object */
				if (ivjUserFeatureClassDeclarationIntern != null) {
					ivjUserFeatureClassDeclarationIntern.removeChangeListener(ivjEventHandler);
				}
				ivjUserFeatureClassDeclarationIntern = newValue;

				/* Listen for events from the new object */
				if (ivjUserFeatureClassDeclarationIntern != null) {
					ivjUserFeatureClassDeclarationIntern.addChangeListener(ivjEventHandler);
				}
				connPtoP7SetTarget();
				connPtoP4SetTarget();
				connPtoP1SetTarget();
				firePropertyChange("userFeatureClassDeclaration", oldValue, newValue);
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
	}
}