package de.uniwue.ki.gui.mas.basics.feature.user;
import javax.swing.Icon;

import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.model.tree.SeSAmDeclarationTreeCellRenderer;
import de.uniwue.ki.gui.mas.util.declaration.AbstractDeclarationPanelFactory;
import de.uniwue.ki.gui.mas.util.declaration.IDeclarationPanel;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: (12.10.2001 17:40:16)
 * @author Christoph Oechslein
 */

public class UserFeatureClassDeclarationPanelFactory extends AbstractDeclarationPanelFactory {

	private IGUISeSAmDeclaration _guiSeSAmDeclaration;

	public IDeclarationPanel createDeclarationPanel(final IDeclaration declaration) {
		IDeclarationPanel declarationPanel = new UserFeatureClassDeclarationPanel();

		declarationPanel.setGUISeSAmDeclaration(getGUISeSAmDeclaration());

		return declarationPanel;
	}

	public String getDeclarationTitle(IDeclaration declaration) {
		return "User Feature";
	}
	
    public Icon getIcon(IDeclaration declaration) {
        return SeSAmDeclarationTreeCellRenderer.FEATURE_CLASS_LIST_ICON;
    }

	public IGUISeSAmDeclaration getGUISeSAmDeclaration() {
		return _guiSeSAmDeclaration;
	}

	public void setGUISeSAmDeclaration(IGUISeSAmDeclaration newGUISeSAmDeclaration) {
		_guiSeSAmDeclaration = newGUISeSAmDeclaration;
	}
}