package de.uniwue.ki.gui.mas.basics.feature.user;
import java.awt.Container;
import java.util.Iterator;

import de.uniwue.ki.gui.mas.basics.functionCall.ExpertFilterUserFeatureFunctionDeclarationListAble;
import de.uniwue.ki.gui.mas.basics.functionUser.UserFunctionDeclarationPanel;
import de.uniwue.ki.gui.mas.basics.search.SearchDeclarationPanelAction;
import de.uniwue.ki.gui.mas.model.AbstractDeclarationPanelAndActionFactory;
import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.util.declaration.*;
import de.uniwue.ki.mas.basics.feature.user.IUserFeatureClassDeclaration;
import de.uniwue.ki.mas.basics.functionUser.IUserFunctionDeclaration;
import de.uniwue.ki.mas.util.declaration.IDeclaration;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Creation date: (10.10.2001 11:09:49)
 * @author Christoph Oechslein
 */

public final class UserFeatureFunctionDeclarationPanelActionFactory
	extends AbstractDeclarationPanelAndActionFactory {
	public final class FeatureUserFunctionClassDeclarationPanelFactory
		extends AbstractDeclarationPanelFactory {
		private final IUserFeatureClassDeclaration _userFeatureClassDeclaration;

		public FeatureUserFunctionClassDeclarationPanelFactory(IUserFeatureClassDeclaration userFeatureClassDeclaration) {
			super();

			_userFeatureClassDeclaration = userFeatureClassDeclaration;
		}

		public IDeclarationPanel createDeclarationPanel(IDeclaration declaration) {
			UserFunctionDeclarationPanel userFunctionDeclarationPanel = new UserFunctionDeclarationPanel();

			ExpertFilterUserFeatureFunctionDeclarationListAble expertFilterUserFeatureFunctionDeclarationListAble =
				new ExpertFilterUserFeatureFunctionDeclarationListAble();

			userFunctionDeclarationPanel.setExpertFilterFunctionDeclarationListAble(
				expertFilterUserFeatureFunctionDeclarationListAble);

			userFunctionDeclarationPanel.setGUISeSAmDeclaration(getGUISeSAmDeclaration());

			expertFilterUserFeatureFunctionDeclarationListAble.setUserFeatureClassDeclaration(
				getUserFeatureClassDeclaration());

			return userFunctionDeclarationPanel;
		}

		public String getDeclarationTitle(IDeclaration declaration) {
			return "Feature Function";
		}

		protected final IUserFeatureClassDeclaration getUserFeatureClassDeclaration() {
			return _userFeatureClassDeclaration;
		}
	}

	public UserFeatureFunctionDeclarationPanelActionFactory() {
		super();
	}

	public UserFeatureFunctionDeclarationPanelActionFactory(IGUISeSAmDeclaration guiSeSAmDeclaration) {

		super();

		setGUISeSAmDeclaration(guiSeSAmDeclaration);
	}

	protected boolean getCanProduceDeclarationActions(Container parent, IDeclaration anDeclaration) {
		if (!(anDeclaration instanceof IUserFunctionDeclaration))
			return false;

		if (parent instanceof UserFeatureFunctionDeclarationListPanel)
			return true;

		return getSeSAmDeclarationTreeModel().getUserObjectParentOf(
			getSeSAmDeclarationTreeModel().getUserObjectParentOf(anDeclaration))
			instanceof IUserFeatureClassDeclaration;
	}

	public IDeclarationPanelFactory getDeclarationPanelFactory(
		Container parent,
		IDeclaration anDeclaration) {
		IUserFeatureClassDeclaration userFeatureClassDeclaration =
			(IUserFeatureClassDeclaration)getSeSAmDeclarationTreeModel().getUserObjectParentOf(
				getSeSAmDeclarationTreeModel().getUserObjectParentOf(anDeclaration));

		return new FeatureUserFunctionClassDeclarationPanelFactory(userFeatureClassDeclaration);
	}

	protected Iterator getImportantDeclarationActions(Container parent, IDeclaration anDeclaration) {
		return CollectionsHelper.createIterator(
			new SearchDeclarationPanelAction(parent, anDeclaration, getGUISeSAmDeclaration()));
	}
}