package de.uniwue.ki.gui.mas.basics.feature.user;
import java.awt.Container;
import java.util.Iterator;

import de.uniwue.ki.gui.mas.basics.functionCall.ExpertFilterUserFeatureFunctionDeclarationListAble;
import de.uniwue.ki.gui.mas.basics.search.SearchDeclarationPanelAction;
import de.uniwue.ki.gui.mas.entity.variableclass.VariableClassDeclarationPanel;
import de.uniwue.ki.gui.mas.model.AbstractDeclarationPanelAndActionFactory;
import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.util.declaration.*;
import de.uniwue.ki.mas.basics.feature.user.IUserFeatureClassDeclaration;
import de.uniwue.ki.mas.entity.variableclass.IFeatureVariableClassDeclaration;
import de.uniwue.ki.mas.util.declaration.IDeclaration;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Creation date: (10.10.2001 11:09:49)
 * @author Christoph Oechslein
 */

public final class UserFeatureVariableClassDeclarationPanelActionFactory
	extends AbstractDeclarationPanelAndActionFactory {
	public final class UserFeatureVariableClassDeclarationPanelFactory
		extends AbstractDeclarationPanelFactory {
		private final IUserFeatureClassDeclaration _userFeatureClassDeclaration;

		public UserFeatureVariableClassDeclarationPanelFactory(IUserFeatureClassDeclaration userFeatureClassDeclaration) {
			super();

			_userFeatureClassDeclaration = userFeatureClassDeclaration;
		}

		public String getDeclarationTitle(IDeclaration declaration) {
			return "Feature Variable";
		}

		public IDeclarationPanel createDeclarationPanel(IDeclaration declaration) {
			VariableClassDeclarationPanel variableClassDeclarationPanel = new VariableClassDeclarationPanel();

			variableClassDeclarationPanel.setExpertFilterFunctionDeclarationListAble(
				new ExpertFilterUserFeatureFunctionDeclarationListAble(getUserFeatureClassDeclaration()));

			variableClassDeclarationPanel.setGUISeSAmDeclaration(getGUISeSAmDeclaration());

			return variableClassDeclarationPanel;
		}

		protected final IUserFeatureClassDeclaration getUserFeatureClassDeclaration() {
			return _userFeatureClassDeclaration;
		}
	}

	public UserFeatureVariableClassDeclarationPanelActionFactory() {
		super();
	}

	public UserFeatureVariableClassDeclarationPanelActionFactory(IGUISeSAmDeclaration guiSeSAmDeclaration) {

		super();

		setGUISeSAmDeclaration(guiSeSAmDeclaration);
	}

	protected boolean getCanProduceDeclarationActions(Container parent, IDeclaration anDeclaration) {
		if (!(anDeclaration instanceof IFeatureVariableClassDeclaration))
			return false;

		if (parent instanceof UserFeatureVariableClassDeclarationListPanel)
			return true;

		return getSeSAmDeclarationTreeModel().getUserObjectParentOf(
			getSeSAmDeclarationTreeModel().getUserObjectParentOf(anDeclaration))
			instanceof IUserFeatureClassDeclaration;
	}

	public IDeclarationPanelFactory getDeclarationPanelFactory(
		Container parent,
		IDeclaration anDeclaration) {
					IUserFeatureClassDeclaration userFeatureClassDeclaration =
			(IUserFeatureClassDeclaration)getSeSAmDeclarationTreeModel().getUserObjectParentOf(
				getSeSAmDeclarationTreeModel().getUserObjectParentOf(anDeclaration));

		return new UserFeatureVariableClassDeclarationPanelFactory(userFeatureClassDeclaration);
	}

	protected Iterator getImportantDeclarationActions(Container parent, IDeclaration anDeclaration) {
		return CollectionsHelper.createIterator(
			new SearchDeclarationPanelAction(parent, anDeclaration, getGUISeSAmDeclaration()));
	}
}