package de.uniwue.ki.gui.mas.basics.functionArgument;
import java.awt.event.*;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.List;

import javax.swing.*;

import com.jgoodies.forms.layout.CellConstraints;
import com.jgoodies.forms.layout.FormLayout;
import com.magelang.box.HorizontalStrut;

import de.uniwue.ki.gui.mas.basics.type.SpecificTypeDefinePanel;
import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.model.JPanelWithGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.util.declaration.DeclarationListPanel;
import de.uniwue.ki.gui.util.bound.BestBoundJTextField;
import de.uniwue.ki.mas.basics.functionArgument.*;
import de.uniwue.ki.mas.basics.type.ISpecificType;
import de.uniwue.ki.mas.basics.type.TypeManager;
import de.uniwue.ki.util.Utils;

/**
 * Creation date: (25.06.2001 16:18:06)
 * @author Christoph Oechslein
 */
public class ArgumentDeclarationForFunctionDeclarationPanel extends JPanelWithGUISeSAmDeclaration {

	private boolean _isSignatureConstant = false;
	private boolean _inToggleMode = false;
	private JToggleButton ivjJButtonOutputArg = null;
	private JLabel ivjJLabelInputArguments = null;
	private JLabel ivjJLabelOutputArg = null;
	private JPanel ivjJPanelArguments = null;
	private JPanel ivjJPanelType = null;
	private SpecificTypeDefinePanel ivjTypeDefinePanel = null;
	private final IvjEventHandler ivjEventHandler = new IvjEventHandler();
	private ISpecificType fieldOutputType = TypeManager.getInstance().getDefaultType();
	private IFunctionArgumentDeclarationList ivjFunctionArgumentDeclarationListIntern = null;
	private boolean ivjConnPtoP2Aligning = false;
	private DeclarationListPanel ivjFunctionArgumentDeclarationListPanel = null;
	private HorizontalStrut ivjHorizontalStrut1 = null;
	private JPanel ivjJPanelName = null;
	private BestBoundJTextField ivjJTextFieldName = null;

	private final class IvjEventHandler
		implements java.awt.event.ActionListener, java.beans.PropertyChangeListener {
		public void actionPerformed(ActionEvent e) {
			if (e.getSource() == ArgumentDeclarationForFunctionDeclarationPanel.this.getJButtonOutputArg())
				connEtoC1(e);
		}
		public void propertyChange(java.beans.PropertyChangeEvent evt) {
			if (evt.getSource()
				== ArgumentDeclarationForFunctionDeclarationPanel.this.getFunctionArgumentDeclarationListPanel()
				&& (evt.getPropertyName().equals("selectedDeclaration")))
				connEtoC2(evt);
			if (evt.getSource()
				== ArgumentDeclarationForFunctionDeclarationPanel.this.getFunctionArgumentDeclarationListPanel()
				&& (evt.getPropertyName().equals("declarationListModel")))
				connPtoP2SetSource();
			if (evt.getSource() == ArgumentDeclarationForFunctionDeclarationPanel.this.getJTextFieldName()
				&& (evt.getPropertyName().equals("text")))
				connEtoC3(evt);
			if (evt.getSource() == ArgumentDeclarationForFunctionDeclarationPanel.this.getTypeDefinePanel()
				&& (evt.getPropertyName().equals("specificType")))
				connEtoC5(evt);
		}
	}

	public void setGUISeSAmDeclaration(IGUISeSAmDeclaration guiSeSAmDeclaration) {
		super.setGUISeSAmDeclaration(guiSeSAmDeclaration);

		getTypeDefinePanel().setGUISeSAmDeclaration(guiSeSAmDeclaration);
		getFunctionArgumentDeclarationListPanel().setGUISeSAmDeclaration(guiSeSAmDeclaration);
	}

	public ArgumentDeclarationForFunctionDeclarationPanel() {
		super();
		initialize();
	}

	private void connEtoC1(ActionEvent arg1) {
		try {
			this.toggleButtonChanged();
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	private void connEtoC2(java.beans.PropertyChangeEvent arg1) {
		try {
			this.selectionChanged();
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	private void connEtoC3(java.beans.PropertyChangeEvent arg1) {
		try {
			this.textChanged(String.valueOf(getJTextFieldName().getText()));
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	private void connEtoC5(java.beans.PropertyChangeEvent arg1) {
		try {
			this.specificTypeChanged(getTypeDefinePanel().getSpecificType());
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	private void connEtoM1(IFunctionArgumentDeclarationList value) {
		try {
			getJButtonOutputArg().setSelected(true);
			getFunctionArgumentDeclarationListPanel().clearSelection();
			toggleButtonChanged();
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	private void connEtoM2() {
		try {
			setFunctionArgumentDeclarationListIntern(new FunctionArgumentDeclarationList());
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	private void connEtoM4() {
		try {
			getJButtonOutputArg().setText(this.getOutputTypeName());
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	private void connPtoP2SetSource() {
		if (ivjConnPtoP2Aligning == false) {
			ivjConnPtoP2Aligning = true;
			setFunctionArgumentDeclarationListIntern(
				(IFunctionArgumentDeclarationList)getFunctionArgumentDeclarationListPanel()
					.getDeclarationListModel());
			ivjConnPtoP2Aligning = false;
		}
	}

	private void connPtoP2SetTarget() {
		try {
			if (ivjConnPtoP2Aligning == false) {
				ivjConnPtoP2Aligning = true;
				if ((getFunctionArgumentDeclarationListIntern() != null)) {
					getFunctionArgumentDeclarationListPanel().setDeclarationListModel(
						getFunctionArgumentDeclarationListIntern());
				}
				ivjConnPtoP2Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP2Aligning = false;
			handleException(ivjExc);
		}
	}

	public void dispose() {
		super.dispose();

		getJButtonOutputArg().removeActionListener(ivjEventHandler);
		getFunctionArgumentDeclarationListPanel().removePropertyChangeListener(ivjEventHandler);
		getJTextFieldName().removePropertyChangeListener(ivjEventHandler);
		this.removePropertyChangeListener(ivjEventHandler);
		getTypeDefinePanel().removePropertyChangeListener(ivjEventHandler);

		getFunctionArgumentDeclarationListPanel().dispose();
		getTypeDefinePanel().dispose();
	}

	public IFunctionArgumentDeclarationList getFunctionArgumentDeclarationList() {
		return getFunctionArgumentDeclarationListIntern();
	}

	private IFunctionArgumentDeclarationList getFunctionArgumentDeclarationListIntern() {
		return ivjFunctionArgumentDeclarationListIntern;
	}

	private DeclarationListPanel getFunctionArgumentDeclarationListPanel() {
		if (ivjFunctionArgumentDeclarationListPanel == null) {
			ivjFunctionArgumentDeclarationListPanel = new DeclarationListPanel();
			ivjFunctionArgumentDeclarationListPanel.setCellRenderer(
				new ArgumentDeclarationWithTypeCellRendererAdapter(
					ivjFunctionArgumentDeclarationListPanel.getCellRenderer()));
			ivjFunctionArgumentDeclarationListPanel.setDeclarationFactory(
				new FunctionArgumentDeclarationFactory());
			ivjFunctionArgumentDeclarationListPanel.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
			ivjFunctionArgumentDeclarationListPanel.setArrowsAvailible(true);
			ivjFunctionArgumentDeclarationListPanel.setVisibleRowCount(3);
		}
		return ivjFunctionArgumentDeclarationListPanel;
	}

	private HorizontalStrut getHorizontalStrut1() {
		if (ivjHorizontalStrut1 == null) {
			try {
				ivjHorizontalStrut1 = new HorizontalStrut();
				ivjHorizontalStrut1.setName("HorizontalStrut1");
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjHorizontalStrut1;
	}

	private JToggleButton getJButtonOutputArg() {
		if (ivjJButtonOutputArg == null) {
			try {
				ivjJButtonOutputArg = new JToggleButton();
				ivjJButtonOutputArg.setName("JButtonOutputArg");
				ivjJButtonOutputArg.setSelected(false);
				ivjJButtonOutputArg.setText("==>");
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjJButtonOutputArg;
	}

	private JLabel getJLabelInputArguments() {
		if (ivjJLabelInputArguments == null) {
			try {
				ivjJLabelInputArguments = new JLabel();
				ivjJLabelInputArguments.setName("JLabelInputArguments");
				ivjJLabelInputArguments.setText("Input:");
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjJLabelInputArguments;
	}

	private JLabel getJLabelOutputArg() {
		if (ivjJLabelOutputArg == null) {
			try {
				ivjJLabelOutputArg = new JLabel();
				ivjJLabelOutputArg.setName("JLabelOutputArg");
				ivjJLabelOutputArg.setText("Output:");
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjJLabelOutputArg;
	}

	private JPanel getJPanelArguments() {
		if (ivjJPanelArguments == null) {
			ivjJPanelArguments =
				new JPanel(
					new FormLayout(
						"default, 3dlu, fill:default:grow, 5dlu",
						"default, 3dlu, fill:default:grow"));

			CellConstraints cc = new CellConstraints();

			getJPanelArguments().add(getJLabelOutputArg(), cc.xy(1, 1, "right, center"));
			getJPanelArguments().add(getJButtonOutputArg(), cc.xy(3, 1));

			getJPanelArguments().add(getJLabelInputArguments(), cc.xy(1, 3, "right, top"));
			getJPanelArguments().add(getFunctionArgumentDeclarationListPanel(), cc.xy(3, 3));
		}
		return ivjJPanelArguments;
	}

	private JPanel getJPanelType() {
		if (ivjJPanelType == null) {

			ivjJPanelType = new JPanel(new FormLayout("fill:default", "default, 4dlu, default"));
			ivjJPanelType.setBorder(BorderFactory.createTitledBorder("Selected Argument"));

			CellConstraints cc = new CellConstraints();

			getJPanelType().add(getJPanelName(), cc.xy(1, 1));
			getJPanelType().add(getTypeDefinePanel(), cc.xy(1, 3));
		}
		return ivjJPanelType;
	}

	private BestBoundJTextField getJTextFieldName() {
		if (ivjJTextFieldName == null) {
			try {
				ivjJTextFieldName = new BestBoundJTextField();
				ivjJTextFieldName.setName("JTextFieldName");
				ivjJTextFieldName.setEditable(false);
				ivjJTextFieldName.setEnabled(false);
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjJTextFieldName;
	}

	public ISpecificType getOutputType() {
		return fieldOutputType;
	}

	protected String getOutputTypeName() {
		return getOutputType().getName();
	}

	private SpecificTypeDefinePanel getTypeDefinePanel() {
		if (ivjTypeDefinePanel == null) {
			try {
				ivjTypeDefinePanel = new SpecificTypeDefinePanel();
				ivjTypeDefinePanel.setName("TypeDefinePanel");
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjTypeDefinePanel;
	}

	public List getTypeList() {
		return getTypeDefinePanel().getTypeList();
	}

	private void handleException(Throwable exception) {
		exception.printStackTrace(System.out);
	}

	private void initConnections() {
		getJButtonOutputArg().addActionListener(ivjEventHandler);
		getFunctionArgumentDeclarationListPanel().addPropertyChangeListener(ivjEventHandler);
		this.addPropertyChangeListener(ivjEventHandler);
		getJTextFieldName().addPropertyChangeListener(ivjEventHandler);
		getTypeDefinePanel().addPropertyChangeListener(ivjEventHandler);
		connPtoP2SetTarget();
	}

	private void initialize() {
		try {
			setName("ArgumentDeclarationForFunctionDeclarationPanel");
			setLayout(new BoxLayout(this, BoxLayout.X_AXIS));
			setSize(497, 352);
			add(getJPanelArguments());
			add(getJPanelType());
			initConnections();
			connEtoM2();
			connEtoM4();
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	public boolean isSignatureConstant() {
		return _isSignatureConstant;
	}

	public static void main(String[] args) {
		try {
			JFrame frame = new JFrame();
			ArgumentDeclarationForFunctionDeclarationPanel aArgumentDeclarationForFunctionDeclarationPanel;
			aArgumentDeclarationForFunctionDeclarationPanel =
				new ArgumentDeclarationForFunctionDeclarationPanel();
			frame.setContentPane(aArgumentDeclarationForFunctionDeclarationPanel);
			frame.setSize(aArgumentDeclarationForFunctionDeclarationPanel.getSize());
			frame.addWindowListener(new WindowAdapter() {
				public void windowClosing(WindowEvent e) {
					System.exit(0);
				}
			});
			frame.show();
			java.awt.Insets insets = frame.getInsets();
			frame.setSize(
				frame.getWidth() + insets.left + insets.right,
				frame.getHeight() + insets.top + insets.bottom);
			frame.setVisible(true);
		} catch (Throwable exception) {
			System.err.println("Exception occurred in main() of JPanel");
			exception.printStackTrace(System.out);
		}
	}

	protected void selectionChanged() {
		if (!_inToggleMode) {
			try {
				_inToggleMode = true;

				getJButtonOutputArg().setSelected(false);

				if (getFunctionArgumentDeclarationListPanel().getSelectedDeclaration() != null) {
					IFunctionArgumentDeclaration functionArgDecl =
						(IFunctionArgumentDeclaration)getFunctionArgumentDeclarationListPanel()
							.getSelectedDeclaration();
					getTypeDefinePanel().setSpecificType(functionArgDecl.getSpecificType());

					getJTextFieldName().setEnabled(true);
					getJTextFieldName().setEditable(true);
					getJTextFieldName().setText(functionArgDecl.getName());

				} else {
					_inToggleMode = false;
					getJButtonOutputArg().setSelected(true);
				}
			} finally {
				_inToggleMode = false;
			}
		}
	}

	public void setEnabled(boolean newIsEnabled) {
		super.setEnabled(newIsEnabled);

		getFunctionArgumentDeclarationListPanel().setEnabled(newIsEnabled);
		getTypeDefinePanel().setEnabled(newIsEnabled);
		getJButtonOutputArg().setEnabled(newIsEnabled);
		getJTextFieldName().setEnabled(newIsEnabled);
		setSignatureConstant(isSignatureConstant());
	}

	public void setFunctionArgumentDeclarationList(IFunctionArgumentDeclarationList arg1) {
		setFunctionArgumentDeclarationListIntern(arg1);
	}

	private void setFunctionArgumentDeclarationListIntern(IFunctionArgumentDeclarationList newValue) {
		if (ivjFunctionArgumentDeclarationListIntern != newValue) {
			try {
				IFunctionArgumentDeclarationList oldValue = getFunctionArgumentDeclarationListIntern();
				ivjFunctionArgumentDeclarationListIntern = newValue;
				connPtoP2SetTarget();
				connEtoM1(ivjFunctionArgumentDeclarationListIntern);
				firePropertyChange("functionArgumentDeclarationList", oldValue, newValue);
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
	}

	public void setOutputType(ISpecificType outputType) {
		ISpecificType oldValue = fieldOutputType;

		if (!Utils.equals(oldValue, outputType)) {

			fieldOutputType = outputType;

			getJButtonOutputArg().setText(getOutputTypeName());

			firePropertyChange("outputType", oldValue, outputType);
		}

		if (!_inToggleMode) {
			getJButtonOutputArg().setSelected(true);
			getFunctionArgumentDeclarationListPanel().clearSelection();
			toggleButtonChanged();
		}
	}

	public void setSignatureConstant(boolean newIsSignatureConstant) {
		_isSignatureConstant = newIsSignatureConstant;

		getFunctionArgumentDeclarationListPanel().setEditable(!newIsSignatureConstant);
		getTypeDefinePanel().setEnabled(!newIsSignatureConstant);
		// getJTextFieldName().setEditable(newIsSignatureConstant);

		revalidate();
	}

	public void setTypeList(List typeList) {
		getTypeDefinePanel().setTypeList(typeList);
	}

	protected void specificTypeChanged(ISpecificType newSpecificType) {
		if (!_inToggleMode) {
			try {
				_inToggleMode = true;

				if (getJButtonOutputArg().isSelected()) {
					setOutputType(newSpecificType);

				} else if (getFunctionArgumentDeclarationListPanel().getSelectedDeclaration() != null) {

					IFunctionArgumentDeclaration functionArgDecl =
						(IFunctionArgumentDeclaration)getFunctionArgumentDeclarationListPanel()
							.getSelectedDeclaration();

					if (functionArgDecl.canChangeSpecificTypeTo(newSpecificType))
						functionArgDecl.setSpecificType(newSpecificType);
					else {
						getTypeDefinePanel().setSpecificType(functionArgDecl.getSpecificType());
					}

				}
			} finally {
				_inToggleMode = false;
			}
		}
	}

	protected void textChanged(String text) {
		if (!_inToggleMode) {
			try {
				_inToggleMode = true;

				if ((getFunctionArgumentDeclarationListPanel().getSelectedDeclaration() != null)) {

					IFunctionArgumentDeclaration functionArgDecl =
						(IFunctionArgumentDeclaration)getFunctionArgumentDeclarationListPanel()
							.getSelectedDeclaration();

					functionArgDecl.setShortDescription(text);
					functionArgDecl.setUsesShortDescription(true);
				}
			} finally {
				_inToggleMode = false;
			}
		}
	}

	protected void toggleButtonChanged() {
		if (!_inToggleMode) {
			try {
				_inToggleMode = true;

				if (getJButtonOutputArg().isSelected()) {
					getFunctionArgumentDeclarationListPanel().clearSelection();
					getTypeDefinePanel().setSpecificType(getOutputType());
					getJTextFieldName().setEnabled(false);
					getJTextFieldName().setEditable(false);
					getJTextFieldName().setText("");
				} else {
					_inToggleMode = false;
					getJButtonOutputArg().setSelected(true);
				}
			} finally {
				_inToggleMode = false;
			}
		}
	}

	private JPanel getJPanelName() {
		if (ivjJPanelName == null) {
			ivjJPanelName = new JPanel();
			ivjJPanelName.setLayout(new BoxLayout(getJPanelName(), BoxLayout.X_AXIS));
			getJPanelName().add(new JLabel("Name:"), "Name");
			getJPanelName().add(getHorizontalStrut1(), getHorizontalStrut1().getName());
			getJPanelName().add(getJTextFieldName(), getJTextFieldName().getName());
		}
		return ivjJPanelName;
	}
}