package de.uniwue.ki.gui.mas.basics.functionArgument;
import de.uniwue.ki.gui.mas.basics.functionCall.FunctionCallDeclarationTreeListPanel;
import de.uniwue.ki.mas.basics.functionArgument.IFunctionArgumentDeclarationList;
import de.uniwue.ki.mas.basics.functionArgument.TwoUnmodifiableFunctionArgumentDeclarationList;

/**
 * Creation date: (26.06.2001 11:07:21)
 * @author Christoph Oechslein
 */
public class FunctionCallDeclarationTreeListPanelWithArgsDecl extends FunctionCallDeclarationTreeListPanel {
	private static final class OuterAndInnerFunctionArgumentDeclarationList
		extends TwoUnmodifiableFunctionArgumentDeclarationList {

		private final FunctionCallDeclarationTreeListPanelWithArgsDecl _functionCallDeclarationTreeListPanelWithArgsDecl;

		public OuterAndInnerFunctionArgumentDeclarationList(FunctionCallDeclarationTreeListPanelWithArgsDecl functionCallDeclarationTreeListPanelWithArgsDecl) {
			super(
				functionCallDeclarationTreeListPanelWithArgsDecl.getFunctionArgumentDeclarationList(),
				functionCallDeclarationTreeListPanelWithArgsDecl.getOuterFunctionArgumentDeclarationList(),
				false);

			_functionCallDeclarationTreeListPanelWithArgsDecl =
				functionCallDeclarationTreeListPanelWithArgsDecl;
		}

	}
	private IFunctionArgumentDeclarationList ivjFunctionArgumentDeclarationListIntern = null;

	public IFunctionArgumentDeclarationList getFunctionArgumentDeclarationList() {
		return ivjFunctionArgumentDeclarationListIntern;
	}

	public void setFunctionArgumentDeclarationList(IFunctionArgumentDeclarationList newValue) {
		if (ivjFunctionArgumentDeclarationListIntern != newValue) {
			ivjFunctionArgumentDeclarationListIntern = newValue;

			eventSetFunctionArgumentDeclarationList();
		}
	}

	protected void eventSetFunctionArgumentDeclarationList() {
		if (getOuterFunctionArgumentDeclarationList() != null) {
			if (getFunctionArgumentDeclarationList() != null) {
				setAllFunctionArgumentDeclarationList(new OuterAndInnerFunctionArgumentDeclarationList(this));

			} else {
				setAllFunctionArgumentDeclarationList(getOuterFunctionArgumentDeclarationList());
			}

		} else if (getFunctionArgumentDeclarationList() != null) {
			setAllFunctionArgumentDeclarationList(getFunctionArgumentDeclarationList());

		} else {
			setAllFunctionArgumentDeclarationList(null);
		}
	}

	protected void setAllFunctionArgumentDeclarationList(IFunctionArgumentDeclarationList functionArgumentDeclarationList) {
		IFunctionArgumentDeclarationList oldAllFunctionArgumentDeclarationList =
			getAllFunctionArgumentDeclarationList();

		if ((oldAllFunctionArgumentDeclarationList instanceof OuterAndInnerFunctionArgumentDeclarationList)
			&& (((OuterAndInnerFunctionArgumentDeclarationList) oldAllFunctionArgumentDeclarationList)
				._functionCallDeclarationTreeListPanelWithArgsDecl
				== this)) {
			oldAllFunctionArgumentDeclarationList.remove();
		}

		super.setAllFunctionArgumentDeclarationList(functionArgumentDeclarationList);
	}
}