package de.uniwue.ki.gui.mas.basics.functionArgument;
import javax.swing.ListCellRenderer;

import de.uniwue.ki.gui.util.NamedCellRendererAdapter;
import de.uniwue.ki.mas.basics.functionArgument.ISpecificFunctionDeclarationWithArgDeclBinds;
import de.uniwue.ki.mas.basics.type.VoidType;
import de.uniwue.ki.mas.basics.type.argument.IArgumentDeclaration;
import de.uniwue.ki.util.name.INamed;

/**
 * Creation date: (12.07.2001 13:41:30)
 * @author Christoph Oechslein
 */

public class SpecificFunctionDeclarationWithArgDeclBindsCellRendererAdapter extends NamedCellRendererAdapter {

	public SpecificFunctionDeclarationWithArgDeclBindsCellRendererAdapter(ListCellRenderer cellRenderer) {
		super(cellRenderer);
	}

	protected String getName(INamed value) {

		if (!(value instanceof ISpecificFunctionDeclarationWithArgDeclBinds)) {
			return super.getName(value) + "ERROR";

		} else {
			return getSpecificFunctionDeclarationWithArgDeclBindsName(
				(ISpecificFunctionDeclarationWithArgDeclBinds) value);
		}
	}

	public static String getSpecificFunctionDeclarationWithArgDeclBindsName(ISpecificFunctionDeclarationWithArgDeclBinds specificFunctionDeclarationWithArgDeclBinds) {
		StringBuffer buff = new StringBuffer();

		appendSpecificFunctionDeclarationWithArgDeclBindsName(
			specificFunctionDeclarationWithArgDeclBinds,
			buff);

		return buff.toString();
	}

	public static void appendSpecificFunctionDeclarationWithArgDeclBindsName(
		ISpecificFunctionDeclarationWithArgDeclBinds specificFunctionDeclarationWithArgDeclBinds,
		StringBuffer buff) {

		buff.append("<html><strong>");

		if (specificFunctionDeclarationWithArgDeclBinds.getUsesShortDescription()) {
			buff.append(specificFunctionDeclarationWithArgDeclBinds.getShortDescription());

			buff.append("</strong> (");

			java.util.Iterator it =
				specificFunctionDeclarationWithArgDeclBinds.getFunctionArgumentDeclarationList().iterator();
			while (it.hasNext()) {
				IArgumentDeclaration currArgumentDeclaration = (IArgumentDeclaration) it.next();
				buff.append(currArgumentDeclaration.getSpecificType().getName());
				if (it.hasNext()) {
					buff.append(", ");
				}
			}

			buff.append(")");

			if (!specificFunctionDeclarationWithArgDeclBinds
				.getOutputType()
				.equals(VoidType.getInstance())) {
				buff.append(" -> ");
				buff.append(specificFunctionDeclarationWithArgDeclBinds.getOutputType().getName());

			}

		} else {
			buff.append(specificFunctionDeclarationWithArgDeclBinds.getName());
			buff.append("</strong>");
		}
	}
}