package de.uniwue.ki.gui.mas.basics.functionCall;

import java.util.Iterator;
import java.util.Map;

import junit.framework.Assert;
import de.uniwue.ki.mas.basics.feature.user.IUserFeatureClassDeclaration;
import de.uniwue.ki.mas.basics.functionDeclaration.list.IFunctionDeclarationListAble;

/**
 * Creation date: 31.07.2002, 15:38:00
 * @author oechslein
 */
public class ExpertFilterUserFeatureFunctionDeclarationListAble
	extends ExpertFilterFunctionDeclarationListAble {

	private IUserFeatureClassDeclaration _userFeatureClassDeclaration = null;

	public ExpertFilterUserFeatureFunctionDeclarationListAble() {
		super();
	}

	public ExpertFilterUserFeatureFunctionDeclarationListAble(IUserFeatureClassDeclaration userFeatureClassDeclaration) {
		super();
		_userFeatureClassDeclaration = userFeatureClassDeclaration;
	}

	protected IFunctionDeclarationListAble calculateFunctionDeclarationList() {
		if (getSeSAmModelDeclaration() == null) {
			return null;

		} else if ((getUserFeatureClassDeclaration() != null) && (getObjectClassDeclaration() == null)) {
			return getSeSAmModelDeclaration().getAvailibleFunctionDeclarationListFor(
				getUserFeatureClassDeclaration());

		} else {
			return super.calculateFunctionDeclarationList();
		}
	}

	public void setUserFeatureClassDeclaration(IUserFeatureClassDeclaration userFeatureClassDeclaration) {
		if (userFeatureClassDeclaration == _userFeatureClassDeclaration)
			return;

		Assert.assertNotNull(getSeSAmModelDeclaration());

		_userFeatureClassDeclaration = userFeatureClassDeclaration;

		updateDelegate();
	}

	public IUserFeatureClassDeclaration getUserFeatureClassDeclaration() {
		return _userFeatureClassDeclaration;
	}

	public void copyInto(Object dstObject, Map objectMapping) {
		super.copyInto(dstObject, objectMapping);

		((ExpertFilterUserFeatureFunctionDeclarationListAble) dstObject).setUserFeatureClassDeclaration(
			getUserFeatureClassDeclaration());
	}

	protected ExpertFilterFunctionDeclarationListAble createInstance() {
		Assert.assertSame(ExpertFilterUserFeatureFunctionDeclarationListAble.class, getClass());
		return new ExpertFilterUserFeatureFunctionDeclarationListAble();
	}

	public Iterator getFeatureVariableClassDeclarations() {
		if (getUserFeatureClassDeclaration() != null) {
			return getUserFeatureClassDeclaration()
				.getFeatureVariableClassDeclarationListAndFactory()
				.getVariableClassDeclarationList()
				.iterator();
		} else {
			return null;
		}
	}
}
