package de.uniwue.ki.gui.mas.basics.functionCall;

import junit.framework.Assert;
import de.uniwue.ki.mas.basics.functionDeclaration.list.*;
import de.uniwue.ki.mas.basics.functionUser.IUserFunctionDeclaration;
import de.uniwue.ki.util.functions.IPredicateFunction;

/**
 * Creation date: 31.07.2002, 15:38:00
 * @author oechslein
 */
public class ExpertFilterUserFunctionDeclarationListAble extends ExpertFilterFunctionDeclarationListAble {
	public ExpertFilterUserFunctionDeclarationListAble() {
		super();
	}

	protected IFunctionDeclarationListAble calculateFunctionDeclarationList() {
		if ((getSeSAmModelDeclaration() != null) && (getObjectClassDeclaration() == null)) {
			return new ConcatenateFunctionDeclarationListAble(
				getSeSAmModelDeclaration().getAvailibleFunctionDeclarationList(),
				new FilterFunctionDeclarationListAble(
					getSeSAmModelDeclaration()
						.getSeSAmModelBasicsDeclaration()
						.getUserFunctionDeclarationListAndFactory()
						.getUserFunctionDeclarationList(),
					filterUserFunctions(false),
					false),
				true);

		} else {
			return super.calculateFunctionDeclarationList();
		}
	}

	private IPredicateFunction filterUserFunctions(final boolean external) {
		return new IPredicateFunction() {
			public boolean isElementOk(Object obj) throws Exception {
				if (obj instanceof IUserFunctionDeclaration) {
					IUserFunctionDeclaration userFunctionDeclaration = (IUserFunctionDeclaration) obj;
					return userFunctionDeclaration.isExternal() == external;

				} else
					return true;
			}
		};
	}

	protected ExpertFilterFunctionDeclarationListAble createInstance() {
		Assert.assertSame(ExpertFilterUserFunctionDeclarationListAble.class, getClass());
		return new ExpertFilterUserFunctionDeclarationListAble();
	}
}