package de.uniwue.ki.gui.mas.basics.functionCall;
import java.awt.BorderLayout;
import java.util.List;

import javax.swing.JPanel;
import javax.swing.JSplitPane;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import com.jgoodies.forms.factories.Borders;
import com.jgoodies.forms.layout.CellConstraints;
import com.jgoodies.forms.layout.FormLayout;

import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.model.JPanelWithGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.util.declaration.DeclarationListPanel;
import de.uniwue.ki.gui.mas.util.declaration.NameDeclarationWithDocumentationPanel;
import de.uniwue.ki.mas.basics.functionArgument.IFunctionArgumentDeclarationList;
import de.uniwue.ki.mas.basics.functionCall.FunctionCallDeclarationFactory;
import de.uniwue.ki.mas.basics.functionCall.NamedFunctionCallDeclaration;
import de.uniwue.ki.mas.basics.type.ISpecificType;
import de.uniwue.ki.mas.util.declaration.*;
/**
 * Creation date: (27.11.2001 15:16:39)
 * @author Christoph Oechslein
 */
public class FunctionCallDeclarationListWithSelectionPanel extends JPanelWithGUISeSAmDeclaration {
	private final IvjEventHandler ivjEventHandler = new IvjEventHandler();
	private DeclarationListPanel ivjFunctionCallDeclarationListPanel = null;
	private FunctionCallDeclarationTreeListPanel ivjFunctionCallDeclarationTreeListPanel = null;
	private NameDeclarationWithDocumentationPanel ivjNameDeclarationWithDocumentationPanel = null;
	private JSplitPane _splitPanel;

	private final class IvjEventHandler implements ListSelectionListener {
		public void valueChanged(ListSelectionEvent e) {
			if (e.getSource()
				== FunctionCallDeclarationListWithSelectionPanel.this.getFunctionCallDeclarationListPanel())
				eventSelectionChanged();
		}
	}

	public int getOrientation() {
		return _splitPanel.getOrientation();
	}

	public void setOrientation(int orientation) {
		_splitPanel.setOrientation(orientation);
	}

	public IExpertFilterFunctionDeclarationListAble getExpertFilterFunctionDeclarationListAble() {
		return ivjFunctionCallDeclarationTreeListPanel.getExpertFilterFunctionDeclarationListAble();
	}

	public List getTypeList() {
		return ivjFunctionCallDeclarationTreeListPanel.getTypeList();
	}

	public void setExpertFilterFunctionDeclarationListAble(IExpertFilterFunctionDeclarationListAble expertFilterFunctionDeclarationListAble) {
		ivjFunctionCallDeclarationTreeListPanel.setExpertFilterFunctionDeclarationListAble(
			expertFilterFunctionDeclarationListAble);
	}

	public void setTypeList(List newTypeList) {
		ivjFunctionCallDeclarationTreeListPanel.setTypeList(newTypeList);
	}

	public IDeclarationFactory getDeclarationFactory() {
		return ivjFunctionCallDeclarationListPanel.getDeclarationFactory();
	}

	public IDeclarationList getDeclarationListModel() {
		return ivjFunctionCallDeclarationListPanel.getDeclarationListModel();
	}

	public void setDeclarationFactory(IDeclarationFactory newDeclarationFactory) {
		ivjFunctionCallDeclarationListPanel.setDeclarationFactory(newDeclarationFactory);
		eventSelectionChanged();
	}

	public void setDeclarationListAndFactory(IDeclarationListAndFactory declarationListAndFactory) {
		ivjFunctionCallDeclarationListPanel.setDeclarationListAndFactory(declarationListAndFactory);
		eventSelectionChanged();
	}

	public void setDeclarationListModel(IDeclarationList newDeclarationList) {
		ivjFunctionCallDeclarationListPanel.setDeclarationListModel(newDeclarationList);
		eventSelectionChanged();
	}

	public FunctionCallDeclarationListWithSelectionPanel() {
		super();
		initialize();
	}

	public void dispose() {
		getFunctionCallDeclarationListPanel().dispose();
		getFunctionCallDeclarationTreeListPanel().dispose();

		super.dispose();
	}

	protected void eventSelectionChanged() {
		if (getFunctionCallDeclarationListPanel().getSelectedDeclaration() != null) {
			//			getFunctionCallDeclarationTreeListPanel().setVisible(true);
			//			getNameDeclarationWithDocumentationPanel().setVisible(true);
			getFunctionCallDeclarationTreeListPanel().setEnabled(true);
			getNameDeclarationWithDocumentationPanel().setEnabled(true);

			NamedFunctionCallDeclaration namedFunctionCallDeclaration =
				(NamedFunctionCallDeclaration)getFunctionCallDeclarationListPanel().getSelectedDeclaration();

			getFunctionCallDeclarationTreeListPanel().setFunctionCallDeclaration(
				namedFunctionCallDeclaration);
			getNameDeclarationWithDocumentationPanel().setDeclaration(namedFunctionCallDeclaration);

		} else {
			//			getFunctionCallDeclarationTreeListPanel().setVisible(false);
			//			getNameDeclarationWithDocumentationPanel().setVisible(false);
			getFunctionCallDeclarationTreeListPanel().setEnabled(false);
			getNameDeclarationWithDocumentationPanel().setEnabled(false);

			//			getFunctionCallDeclarationTreeListPanel().setFunctionCallDeclaration(null);
			//			getNameDeclarationWithDocumentationPanel().setDeclaration(null);
		}
	}

	private DeclarationListPanel getFunctionCallDeclarationListPanel() {
		if (ivjFunctionCallDeclarationListPanel == null) {
			ivjFunctionCallDeclarationListPanel = new DeclarationListPanel();

		}
		return ivjFunctionCallDeclarationListPanel;
	}

	private FunctionCallDeclarationTreeListPanel getFunctionCallDeclarationTreeListPanel() {
		if (ivjFunctionCallDeclarationTreeListPanel == null) {
			ivjFunctionCallDeclarationTreeListPanel = new FunctionCallDeclarationTreeListPanel();

		}
		return ivjFunctionCallDeclarationTreeListPanel;
	}

	private NameDeclarationWithDocumentationPanel getNameDeclarationWithDocumentationPanel() {
		if (ivjNameDeclarationWithDocumentationPanel == null) {
			ivjNameDeclarationWithDocumentationPanel = new NameDeclarationWithDocumentationPanel();
			ivjNameDeclarationWithDocumentationPanel.setShowCheckBox(true);

		}
		return ivjNameDeclarationWithDocumentationPanel;
	}

	private void initialize() {
		setLayout(new BorderLayout());

		add(getJSplitPanel());

		getFunctionCallDeclarationListPanel().addListSelectionListener(ivjEventHandler);
	}

	private JSplitPane getJSplitPanel() {
		if (_splitPanel == null) {
			JPanel panel = new JPanel();
			panel.setBorder(Borders.createEmptyBorder("1dlu, 1dlu, 1dlu, 1dlu"));
			panel.setLayout(new FormLayout("fill:default:grow", "default, 3dlu, fill:default:grow"));

			CellConstraints cc = new CellConstraints();

			panel.add(getNameDeclarationWithDocumentationPanel(), cc.xy(1, 1));
			panel.add(getFunctionCallDeclarationTreeListPanel(), cc.xy(1, 3));

			_splitPanel =
				new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, getFunctionCallDeclarationListPanel(), panel);
			_splitPanel.setOneTouchExpandable(true);
			//splitPanel.setBorder(null);
		}

		return _splitPanel;
	}

	public void setSpecificType(ISpecificType specificType) {
		getFunctionCallDeclarationTreeListPanel().setFunctionCallDeclaration(
			FunctionCallDeclarationFactory.getInstance().createFunctionCallDeclaration(specificType));
	}

	public void setGUISeSAmDeclaration(IGUISeSAmDeclaration guiSeSAmDeclaration) {
		super.setGUISeSAmDeclaration(guiSeSAmDeclaration);

		getFunctionCallDeclarationListPanel().setGUISeSAmDeclaration(guiSeSAmDeclaration);
		getFunctionCallDeclarationTreeListPanel().setGUISeSAmDeclaration(guiSeSAmDeclaration);
		getNameDeclarationWithDocumentationPanel().setGUISeSAmDeclaration(guiSeSAmDeclaration);
	}

	public IFunctionArgumentDeclarationList getOuterFunctionArgumentDeclarationList() {
		return getFunctionCallDeclarationTreeListPanel().getOuterFunctionArgumentDeclarationList();
	}

	public void setOuterFunctionArgumentDeclarationList(IFunctionArgumentDeclarationList functionArgumentDeclarationList) {
		getFunctionCallDeclarationTreeListPanel().setOuterFunctionArgumentDeclarationList(
			functionArgumentDeclarationList);
	}
}