package de.uniwue.ki.gui.mas.basics.functionCall;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.*;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.*;
import java.util.HashMap;
import java.util.Iterator;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.tree.TreeModel;
import javax.swing.tree.TreePath;

import junit.framework.Assert;

import com.ibm.easyswing.BoundJCheckBox;
import com.jgoodies.forms.factories.DefaultComponentFactory;
import com.jgoodies.forms.layout.CellConstraints;
import com.jgoodies.forms.layout.FormLayout;

import de.uniwue.ki.gui.mas.basics.type.argument.*;
import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.refactoring.RefactoringMenuFactory;
import de.uniwue.ki.gui.mas.util.declaration.AbstractDeclarationPanel;
import de.uniwue.ki.gui.util.JAutoscrollTree;
import de.uniwue.ki.gui.util.SwingMoreUtilities;
import de.uniwue.ki.gui.util.actions.AbstractBoundAction;
import de.uniwue.ki.gui.util.actions.InspectAction;
import de.uniwue.ki.gui.util.bound.BestBoundJTextField;
import de.uniwue.ki.mas.basics.function.object.FunctionDeclarationObjectFactory;
import de.uniwue.ki.mas.basics.functionArgument.*;
import de.uniwue.ki.mas.basics.functionCall.*;
import de.uniwue.ki.mas.basics.functionDeclaration.*;
import de.uniwue.ki.mas.basics.functionDeclaration.list.*;
import de.uniwue.ki.mas.basics.functionDeclaration.list.FunctionDeclarationNameFilter;
import de.uniwue.ki.mas.basics.functionDeclaration.list.FunctionDeclarationListModel;
import de.uniwue.ki.mas.basics.functionUser.IUserFunctionDeclaration;
import de.uniwue.ki.mas.basics.functionUser.UserFunctionDeclarationFactory;
import de.uniwue.ki.mas.basics.type.*;
import de.uniwue.ki.mas.basics.type.argument.*;
import de.uniwue.ki.mas.util.declaration.IDeclaration;
import de.uniwue.ki.util.collection.CollectionsHelper;
import de.uniwue.ki.util.functions.AndPredicateFunction;
import de.uniwue.ki.util.functions.IPredicateFunction;

/**
 * Creation date: (26.05.00 11:56:32)
 * 
 * @author Christoph Oechslein
 */
public class FunctionCallDeclarationTreeListPanel
		extends
			AbstractDeclarationPanel {

	private IFunctionArgumentDeclarationList ivjOuterFunctionArgumentDeclarationListIntern = null;

	private java.util.List _typeList = CollectionsHelper
			.asLinkedList(TypeManager.getInstance().getAllTypes());

	private IExpertFilterFunctionDeclarationListAble _expertFilterFunctionDeclarationListAble;

	private IFunctionCallDeclaration ivjFunctionCallDeclarationIntern = null;

	private JPanel ivjJPanelArgumentList = null;

	private JPanel ivjFunctionListPanelWithFastTypeField = null;

	private JAutoscrollTree ivjJTreeFCall = null;

	private boolean ivjConnPtoP1Aligning = false;

	private TreeModel ivjTreeModel = null;

	private boolean ivjConnPtoP5Aligning = false;

	private BoundJCheckBox ivjFilterExpertSetting = null;

	private JList ivjArgumentListPanel = null;

	private JList ivjFunctionListPanel = null;

	private BestBoundJTextField selectField = null;

	private final IvjEventHandler ivjEventHandler = new IvjEventHandler();

	class IvjEventHandler
			implements
				ItemListener,
				MouseListener,
				PropertyChangeListener,
				TreeModelListener,
				TreeSelectionListener {

		public void itemStateChanged(ItemEvent e) {
			if (e.getSource() == FunctionCallDeclarationTreeListPanel.this
					.getFilterExpertSettingCheckBox())
				eventFilterExpertSettingChanged();
		}

		public void mouseClicked(MouseEvent e) {
			if (e.getSource() == FunctionCallDeclarationTreeListPanel.this
					.getArgumentListPanel())
				eventTypeListMouseClicked(e);
			if (e.getSource() == FunctionCallDeclarationTreeListPanel.this
					.getFunctionListPanel())
				eventFunctionListMouseClicked(e);
			if (e.getSource() == FunctionCallDeclarationTreeListPanel.this
					.getJTreeFCall())
				eventmouseEvent(e);
		}

		public void mouseEntered(MouseEvent e) {
		}

		public void mouseExited(MouseEvent e) {
		}

		public void mousePressed(MouseEvent e) {
			if (e.getSource() == FunctionCallDeclarationTreeListPanel.this
					.getJTreeFCall())
				eventmouseEvent(e);
		}

		public void mouseReleased(MouseEvent e) {
			if (e.getSource() == FunctionCallDeclarationTreeListPanel.this
					.getJTreeFCall())
				eventmouseEvent(e);
		}

		public void propertyChange(PropertyChangeEvent evt) {
			if (evt.getSource() == FunctionCallDeclarationTreeListPanel.this
					.getFunctionCallDeclarationIntern())
				connPtoP5UpdateTreemodel();
			if (evt.getSource() == FunctionCallDeclarationTreeListPanel.this
					.getFunctionCallDeclarationIntern()
					&& (evt.getPropertyName()
							.equals("functionCallInternDeclaration"))) {
				selectFunctionCallInternDeclaration(getFunctionCallDeclarationIntern()
						.getFunctionCallInternDeclaration());
			}
			if (evt.getSource() == FunctionCallDeclarationTreeListPanel.this
					.getJTreeFCall()
					&& (evt.getPropertyName().equals("model")))
				connPtoP1SetTarget();
		}

		public void treeNodesChanged(TreeModelEvent e) {
		}

		public void treeNodesInserted(TreeModelEvent e) {
		}

		public void treeNodesRemoved(TreeModelEvent e) {
		}

		public void treeStructureChanged(TreeModelEvent e) {
			if (e.getSource() == FunctionCallDeclarationTreeListPanel.this
					.getTreeModel())
				eventTreeStructureChanged(e);
		}

		public void valueChanged(TreeSelectionEvent e) {
			if (e.getSource() == FunctionCallDeclarationTreeListPanel.this
					.getJTreeFCall())
				eventTreeSelectionModelValueChanged(e);
		}
	}

	public FunctionCallDeclarationTreeListPanel() {
		super();
		initialize();
	}

	protected void changeFunctionCall(IFunctionCallInternDeclaration newCall) {

		IFunctionCallInternDeclaration currentFunctionCallInternDecl = getCurrentSelectedFunctionCallInternDeclaration();

		if (currentFunctionCallInternDecl != null) {
			changeFunctionCall(newCall, currentFunctionCallInternDecl);
		}
	}

	protected void changeFunctionCall(IFunctionCallInternDeclaration newCall,
			IFunctionCallInternDeclaration currentFunctionCallInternDecl) {

		if (Assert.ASSERTION_ON)
			currentFunctionCallInternDecl.checkInvariants();

		getFunctionCallDeclaration().replaceFunctionCallInternDeclarationTo(
				newCall, currentFunctionCallInternDecl);

		if (newCall instanceof IComposedFunctionCallInternDeclaration) {
			IComposedFunctionCallInternDeclaration composedFunctionCallInternDeclaration = (IComposedFunctionCallInternDeclaration) newCall;

			if (composedFunctionCallInternDeclaration.getChildCount() > 0) {
				selectFunctionCallInternDeclaration(composedFunctionCallInternDeclaration
						.getChild(0));

			} else {
				selectFunctionCallInternDeclaration(newCall);
			}

		} else {
			selectFunctionCallInternDeclaration(newCall);
		}
	}

	private void connPtoP1SetSource() {
		if (ivjConnPtoP1Aligning == false) {

			ivjConnPtoP1Aligning = true;
			if ((getTreeModel() != null)) {
				getJTreeFCall().setModel(getTreeModel());
			}

			ivjConnPtoP1Aligning = false;
		}

		ivjConnPtoP1Aligning = false;
	}

	private void connPtoP1SetTarget() {
		if (ivjConnPtoP1Aligning == false) {

			ivjConnPtoP1Aligning = true;
			setTreeModel(getJTreeFCall().getModel());

			ivjConnPtoP1Aligning = false;
		}

		ivjConnPtoP1Aligning = false;
	}

	private void connPtoP5UpdateTreemodel() {
		if (ivjConnPtoP5Aligning == false) {

			ivjConnPtoP5Aligning = true;
			setTreeModel(getFunctionCallDeclarationIntern().getTreeModel());

			ivjConnPtoP5Aligning = false;
		}

		ivjConnPtoP5Aligning = false;
	}

	public void dispose() {
		if (getFunctionCallDeclaration() != null)
			getFunctionCallDeclaration().removePropertyChangeListener(
					ivjEventHandler);

		setAllFunctionArgumentDeclarationList(null);
		setExpertFilterFunctionDeclarationListAble(null);

		getArgumentDeclarationListModel().remove();
		getFunctionListModel().remove();

		setTreeModel(null);

		super.dispose();
	}

	protected void eventFilterExpertSettingChanged() {
		getExpertFilterFunctionDeclarationListAble().setExpert(
				isFilterExpertSettings());
	}

	protected void eventFunctionCallDeclarationInternChanged() {
		updateFunctionListPanel();
		selectFunctionCallInternDeclaration(getFunctionCallDeclaration()
				.getFunctionCallInternDeclaration());
	}

	protected void eventFunctionListDoubleClicked(
			IFunctionDeclaration functionDeclaration) {
		IFunctionCallInternDeclaration currentFunctionCallInternDecl = getCurrentSelectedFunctionCallInternDeclaration();

		if (currentFunctionCallInternDecl != null) {
			if (Assert.ASSERTION_ON)
				currentFunctionCallInternDecl.checkInvariants();

			IComposedFunctionCallInternDeclaration parent = currentFunctionCallInternDecl
					.getParent();

			IFunctionCallInternDeclaration functionCallInternDeclaration = FunctionCallInternDeclarationGUIFactory
					.createFunctionCallInternDeclaration(functionDeclaration,
							currentFunctionCallInternDecl, this,
							getGUISeSAmDeclaration());

			if (functionCallInternDeclaration != null) {
				functionCallInternDeclaration.checkInvariants();

				Assert.assertSame(parent, functionCallInternDeclaration
						.getParent());
				changeFunctionCall(functionCallInternDeclaration);
			}
		}
	}

	protected void eventFunctionListMouseClicked(MouseEvent mouseEvent) {
		if (isEnabled() && !mouseEvent.isConsumed()
				&& mouseEvent.getClickCount() == 2
				&& SwingUtilities.isLeftMouseButton(mouseEvent)) {
			int index = ((JList) mouseEvent.getSource())
					.locationToIndex(mouseEvent.getPoint());
			if (index >= 0) {
				eventFunctionListDoubleClicked((IFunctionDeclaration) getFunctionListModel()
						.getElementAt(index));
				mouseEvent.consume();
			}
		}
	}

	protected void eventGUISeSAmDeclarationChanged() {
	}

	protected void eventMouseClickedDouble(TreePath treePath,
			IFunctionCallInternDeclaration functionCallInternDeclaration,
			MouseEvent mouseEvent) {

		if (functionCallInternDeclaration == null) {
			return;

		} else if (functionCallInternDeclaration instanceof IAtomicFunctionCallInternDeclaration) {
			eventMouseClickedDoubleAtomic(
					treePath,
					(IAtomicFunctionCallInternDeclaration) functionCallInternDeclaration,
					mouseEvent);

		} else if (functionCallInternDeclaration instanceof IComposedFunctionCallInternDeclaration) {
			eventMouseClickedDoubleComposed(
					treePath,
					(IComposedFunctionCallInternDeclaration) functionCallInternDeclaration,
					mouseEvent);

		} else {
			Assert.fail();
		}
	}

	protected void eventMouseClickedDoubleAtomic(
			final TreePath treePath,
			final IAtomicFunctionCallInternDeclaration atomicFunctionCallInternDeclaration,
			MouseEvent mouseEvent) {

		createAndChangeToFunCall(atomicFunctionCallInternDeclaration
				.getArgumentDeclaration());

		mouseEvent.consume();
	}

	protected void eventMouseClickedDoubleComposed(
			final TreePath treePath,
			IComposedFunctionCallInternDeclaration composedFunctionCallInternDeclaration,
			MouseEvent mouseEvent) {
	}

	protected void eventMouseClickedPopup(TreePath treePath,
			IFunctionCallInternDeclaration functionCallInternDeclaration,
			MouseEvent mouseEvent) {

		if (functionCallInternDeclaration == null) {
			return;

		} else if (functionCallInternDeclaration instanceof IAtomicFunctionCallInternDeclaration) {
			eventMouseClickedPopupAtomic(
					treePath,
					(IAtomicFunctionCallInternDeclaration) functionCallInternDeclaration,
					mouseEvent);

		} else if (functionCallInternDeclaration instanceof IComposedFunctionCallInternDeclaration) {
			eventMouseClickedPopupComposed(
					treePath,
					(IComposedFunctionCallInternDeclaration) functionCallInternDeclaration,
					mouseEvent);

		} else {
			Assert.fail();
		}
	}

	protected void eventMouseClickedPopupAtomic(
			final TreePath treePath,
			final IAtomicFunctionCallInternDeclaration atomicFunctionCallInternDeclaration,
			MouseEvent mouseEvent) {

		JPopupMenu popup = new JPopupMenu();

		final IArgumentDeclaration argumentDeclaration = atomicFunctionCallInternDeclaration
				.getArgumentDeclaration();

		popup.add(AbstractBoundAction.createJMenuItem(new AbstractBoundAction(
				"Change Value") {

			public void doit() {
				createAndChangeToFunCall(argumentDeclaration);
			}
		}, true));

		popup.add(AbstractBoundAction.createJMenuItem(new AbstractBoundAction(
				"To Default Value") {

			public void doit() {
				argumentDeclaration
						.setObject(argumentDeclaration.getSpecificType()
								.getArgumentDeclarationDefaultValue());
				getFunctionCallDeclaration().getTreeModel()
						.valueForPathChanged(treePath,
								atomicFunctionCallInternDeclaration);
			}
		}));

		insertRemoveAndInsertActions(treePath,
				atomicFunctionCallInternDeclaration, popup);

		popup.add(AbstractBoundAction.createJMenuItem(new InspectAction(
				atomicFunctionCallInternDeclaration)));

		insertRefactoringActions(treePath, atomicFunctionCallInternDeclaration,
				popup);

		popup.show(getJTreeFCall(), mouseEvent.getX(), mouseEvent.getY());
		mouseEvent.consume();
	}

	protected void eventMouseClickedPopupComposed(
			final TreePath treePath,
			final IComposedFunctionCallInternDeclaration composedFunctionCallInternDeclaration,
			MouseEvent mouseEvent) {

		JPopupMenu popup = new JPopupMenu();

		final IComposedFunctionCallInternDeclaration parent = composedFunctionCallInternDeclaration
				.getParent();
		final ISpecificFunctionDeclaration specificFunctionDeclaration = composedFunctionCallInternDeclaration
				.getSpecificFunctionDeclaration();
		final IGenericFunctionDeclaration genericlFunctionDeclaration = specificFunctionDeclaration
				.getGenericFunctionDeclaration();

		popup.add(AbstractBoundAction.createJMenuItem(new AbstractBoundAction(
				"To Default Value") {

			public void doit() {
				IFunctionCallInternDeclaration functionCallInternDeclaration;
				if (genericlFunctionDeclaration == null) {
					functionCallInternDeclaration = FunctionCallDeclarationFactory
							.getInstance()
							.createComposedFunctionCallInternDeclaration(
									parent, specificFunctionDeclaration);

				} else {
					functionCallInternDeclaration = FunctionCallInternDeclarationGUIFactory
							.createFunctionCallInternDeclaration(
									genericlFunctionDeclaration,
									composedFunctionCallInternDeclaration,
									FunctionCallDeclarationTreeListPanel.this,
									false, getGUISeSAmDeclaration());
				}

				if (functionCallInternDeclaration != null)
					changeFunctionCall(functionCallInternDeclaration);
			}
		}));

		if (composedFunctionCallInternDeclaration.getSpecificOutputType()
				.isAtomicDefaultValue()) {
			popup
					.add(AbstractBoundAction
							.createJMenuItem(new AbstractBoundAction(
									"To Atomic Values") {

								public void doit() {
									//					IArgumentDeclaration newArgument =
									//						createArgumentDeclarationFor(
									//							ArgumentDeclarationFactory.getInstance().createArgumentDeclaration(
									//								composedFunctionCallInternDeclaration.getSpecificOutputType()));
									IArgumentDeclaration newArgument = ArgumentDeclarationFactory
											.getInstance()
											.createArgumentDeclaration(
													composedFunctionCallInternDeclaration
															.getSpecificOutputType());

									if (newArgument != null) {
										changeFunctionCall(FunctionCallDeclarationFactory
												.getInstance()
												.createAtomicFunctionCallInternDeclaration(
														parent, newArgument));
									}
								}
							}));
		}

		insertRemoveAndInsertActions(treePath,
				composedFunctionCallInternDeclaration, popup);

		if (specificFunctionDeclaration.getSpecificInputMinArgsLength() < composedFunctionCallInternDeclaration
				.getChildCount()) {
			popup.add(AbstractBoundAction
					.createJMenuItem(new AbstractBoundAction("Remove Child") {

						public void doit() {
							composedFunctionCallInternDeclaration
									.removeChild(composedFunctionCallInternDeclaration
											.getChildCount() - 1);
							getFunctionCallDeclaration()
									.getTreeModel()
									.valueForPathChanged(treePath,
											composedFunctionCallInternDeclaration);
						}
					}));
		}

		if ((composedFunctionCallInternDeclaration.getChildCount() < specificFunctionDeclaration
				.getSpecificInputMaxArgsLength())
				|| (specificFunctionDeclaration.getSpecificInputMaxArgsLength() == ISpecificFunctionDeclaration.UNLIMITED_ARGUMENT_COUNT)) {
			popup.add(AbstractBoundAction
					.createJMenuItem(new AbstractBoundAction("Add Child") {

						public void doit() {
							composedFunctionCallInternDeclaration.addChild();
							getFunctionCallDeclaration()
									.getTreeModel()
									.valueForPathChanged(treePath,
											composedFunctionCallInternDeclaration);
						}
					}));
		}

		popup.add(AbstractBoundAction.createJMenuItem(new InspectAction(
				composedFunctionCallInternDeclaration)));

		insertRefactoringActions(treePath,
				composedFunctionCallInternDeclaration, popup);

		mouseEvent.consume();
		popup.show(getJTreeFCall(), mouseEvent.getX(), mouseEvent.getY());
	}

	protected void eventMouseClickedPopupNull(MouseEvent mouseEvent) {
	}

	protected void eventmouseEvent(MouseEvent mouseEvent) {

		if (isEnabled() && (mouseEvent.getSource() == getJTreeFCall())) {
			getSelectTextField().setText("");

			TreePath treePath = getJTreeFCall().getClosestPathForLocation(
					mouseEvent.getX(), mouseEvent.getY());
			IFunctionCallInternDeclaration clickedFunctionCallInternDeclaration = (treePath == null)
					? null
					: (IFunctionCallInternDeclaration) treePath
							.getLastPathComponent();

			if (mouseEvent.isPopupTrigger()) {
				eventMouseClickedPopup(treePath,
						clickedFunctionCallInternDeclaration, mouseEvent);

			} else if ((mouseEvent.getClickCount() == 2)
					&& (mouseEvent.getID() == MouseEvent.MOUSE_CLICKED)
					&& (SwingUtilities.isLeftMouseButton(mouseEvent))) {

				eventMouseClickedDouble(treePath,
						clickedFunctionCallInternDeclaration, mouseEvent);
			}
		}

	}

	protected void eventTreeSelectionModelValueChanged(
			TreeSelectionEvent treeSelectionEvent) {
		if (treeSelectionEvent.getSource() == getJTreeFCall()) {

			if (treeSelectionEvent.isAddedPath()) {
				updateArgumentAndFunctionListPanel();

			} else {
				// getTreeSelectionModel().setSelectionPath(path);
			}
		}
	}

	protected void eventTreeStructureChanged(TreeModelEvent e) {
		selectPath(e.getTreePath());
	}

	protected void eventTypeListDoubleClicked(
			IArgumentDeclaration newArgumentDeclaration) {
		if ((newArgumentDeclaration instanceof IFunctionArgumentDeclaration)
				|| !isUnnamedFuncOrOtherArgDecl(newArgumentDeclaration)) {

			IComposedFunctionCallInternDeclaration parent = getCurrentSelectedFunctionCallInternDeclaration()
					.getParent();

			changeFunctionCall(FunctionCallDeclarationFactory.getInstance()
					.createAtomicFunctionCallInternDeclaration(parent,
							newArgumentDeclaration));

		} else {
			IFunctionCallInternDeclaration currentFunctionCallInternDecl = getCurrentSelectedFunctionCallInternDeclaration();
			if (currentFunctionCallInternDecl != null) {
				createAndChangeToFunCall(newArgumentDeclaration);
			}
		}
	}

	protected static boolean isUnnamedFuncOrOtherArgDecl(
			IArgumentDeclaration argumentDeclaration) {
		if (!(argumentDeclaration.getSpecificType() instanceof ISpecificFunctionType)) {
			return true;
		}

		Object argObj = argumentDeclaration.getObject();

		if (argObj instanceof IUserFunctionDeclaration) {
			return false;
		}

		return (argObj instanceof SpecificFunctionDeclarationWithArgDeclBinds);
	}

	static void test() {
		Assert
				.assertTrue(isUnnamedFuncOrOtherArgDecl(ArgumentDeclarationFactory
						.getInstance().createArgumentDeclaration(
								IntegerType.getInstance())));
		Assert
				.assertTrue(isUnnamedFuncOrOtherArgDecl(ArgumentDeclarationFactory
						.getInstance().createArgumentDeclaration(
								BooleanType.getInstance())));
		Assert
				.assertTrue(isUnnamedFuncOrOtherArgDecl(ArgumentDeclarationFactory
						.getInstance().createArgumentDeclaration(
								GenericFunctionType.getInstance()
										.createDefaultSpecificType())));
		// returns a SpecificFunctionDeclarationWithArgDeclBinds
		Assert
				.assertTrue(isUnnamedFuncOrOtherArgDecl(ArgumentDeclarationFactory
						.getInstance()
						.createArgumentDeclaration(
								GenericFunctionType
										.getInstance()
										.createSpecificFunctionType(
												BooleanType.getInstance(),
												CollectionsHelper.createList(
														BooleanType
																.getInstance(),
														BooleanType
																.getInstance())))));
		// returns an ISpecificFunctionDecl, since unlimited arg function
		// cannot be edited
		Assert
				.assertFalse(isUnnamedFuncOrOtherArgDecl(ArgumentDeclarationFactory
						.getInstance().createArgumentDeclaration(
								GenericFunctionType.getInstance()
										.createSpecificFunctionType(
												BooleanType.getInstance(),
												BooleanType.getInstance()))));
		Assert
				.assertTrue(isUnnamedFuncOrOtherArgDecl(ArgumentDeclarationFactory
						.getInstance()
						.createArgumentDeclaration(
								GenericFunctionType.getInstance()
										.createSpecificFunctionType(
												BooleanType.getInstance(),
												CollectionsHelper.EMPTY_LIST),
								SpecificFunctionDeclarationWithArgDeclBindsFactory
										.createSpecificFunctionDeclarationWithArgDeclBinds(BooleanType
												.getInstance()))));

		Assert
				.assertFalse(isUnnamedFuncOrOtherArgDecl(ArgumentDeclarationFactory
						.getInstance().createArgumentDeclaration(
								GenericFunctionType.getInstance()
										.createSpecificFunctionType(
												BooleanType.getInstance(),
												CollectionsHelper.EMPTY_LIST),
								UserFunctionDeclarationFactory
										.getInstance(true)
										.createUserFunctionDeclaration(
												BooleanType.getInstance()))));
		Assert
				.assertFalse(isUnnamedFuncOrOtherArgDecl(ArgumentDeclarationFactory
						.getInstance()
						.createArgumentDeclaration(
								GenericFunctionType.getInstance()
										.createSpecificFunctionType(
												IntegerType.getInstance(),
												CollectionsHelper.EMPTY_LIST),
								FunctionDeclarationObjectFactory.GET_TIME_FUNCTION_DECLARATION)));
	}

	protected void createAndChangeToFunCall(
			final IArgumentDeclaration argumentDeclaration) {
		if (!(argumentDeclaration instanceof IFunctionArgumentDeclaration)
				&& isUnnamedFuncOrOtherArgDecl(argumentDeclaration)) {

			final IFunctionCallInternDeclaration currentFunctionCallInternDecl = getCurrentSelectedFunctionCallInternDeclaration();

			if (currentFunctionCallInternDecl != null) {
				ArgumentDeclarationEditorPaneFactoryManager.ISetArgumentDeclarationFunction doitFunction = new ArgumentDeclarationEditorPaneFactoryManager.ISetArgumentDeclarationFunction() {

					public void setArgumentDeclaration(
							IArgumentDeclaration newArgumentDeclaration) {
						if ((newArgumentDeclaration != null)
								&& (newArgumentDeclaration != argumentDeclaration)) {

							changeFunctionCall(FunctionCallDeclarationFactory
									.getInstance()
									.createAtomicFunctionCallInternDeclaration(
											currentFunctionCallInternDecl
													.getParent(),
											newArgumentDeclaration),
									currentFunctionCallInternDecl);
						}
					}
				};

				ArgumentDeclarationEditorPaneFactoryManager
						.askArgumentDeclarationFor(
								new ArgumentDeclarationEditorParameter(
										(IArgumentDeclaration) argumentDeclaration
												.copy(new HashMap()),
										getGUISeSAmDeclaration(), this), this,
								getGUISeSAmDeclaration(), doitFunction);
			}
		}
	}

	protected void eventTypeListMouseClicked(MouseEvent mouseEvent) {
		if (isEnabled() && !mouseEvent.isConsumed()
				&& mouseEvent.getClickCount() == 2
				&& SwingUtilities.isLeftMouseButton(mouseEvent)) {
			int index = ((JList) mouseEvent.getSource())
					.locationToIndex(mouseEvent.getPoint());
			if (index != -1) {
				eventTypeListDoubleClicked((IArgumentDeclaration) getArgumentDeclarationListModel()
						.getElementAt(index));
				mouseEvent.consume();
			}
		}
	}

	public ArgumentDeclarationListModel getArgumentDeclarationListModel() {
		return (ArgumentDeclarationListModel) getArgumentListPanel().getModel();
	}

	private JList getArgumentListPanel() {
		if (ivjArgumentListPanel == null) {

			final FunctionCallDeclarationTreeListPanel panel = this;

			ivjArgumentListPanel = new JList();
			ivjArgumentListPanel.setName("ArgumentListPanel");
			ivjArgumentListPanel.setModel(new ArgumentDeclarationListModel(
					new IPredicateFunction() {

						public boolean isElementOk(Object obj) throws Exception {
							IArgumentDeclaration decl = (IArgumentDeclaration) obj;
							return ((decl instanceof IFunctionArgumentDeclaration) || (ArgumentDeclarationEditorPaneFactoryManager
									.getArgumentDeclarationEditorFor(new ArgumentDeclarationEditorParameter(
											(IArgumentDeclaration) decl
													.copy(new HashMap()),
											getGUISeSAmDeclaration(), panel)) != null));
						}
					}));

			ivjArgumentListPanel
					.setCellRenderer(new ArgumentDeclarationListOnlyTypeNameCellRendererAdapter(
							ivjArgumentListPanel.getCellRenderer()));
			ivjArgumentListPanel.setVisibleRowCount(4);
			ivjArgumentListPanel
					.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		}
		return ivjArgumentListPanel;
	}

	public IFunctionCallInternDeclaration getCurrentSelectedFunctionCallInternDeclaration() {
		TreePath treePath = getJTreeFCall().getSelectionPath();
		if (treePath == null) {
			return null;

		} else {
			return (IFunctionCallInternDeclaration) treePath
					.getLastPathComponent();
		}
	}

	public IDeclaration getDeclaration() {
		return getFunctionCallDeclaration();
	}

	private BoundJCheckBox getFilterExpertSettingCheckBox() {
		if (ivjFilterExpertSetting == null) {

			ivjFilterExpertSetting = new BoundJCheckBox();
			ivjFilterExpertSetting.setName("FilterExpertSetting");
			ivjFilterExpertSetting.setText("Expert");
		}
		return ivjFilterExpertSetting;
	}

	public IFunctionCallDeclaration getFunctionCallDeclaration() {
		return getFunctionCallDeclarationIntern();
	}

	private IFunctionCallDeclaration getFunctionCallDeclarationIntern() {

		if (ivjFunctionCallDeclarationIntern == null)
			ivjFunctionCallDeclarationIntern = FunctionCallDeclarationFactory
					.getInstance().createFunctionCallDeclaration();

		return ivjFunctionCallDeclarationIntern;
	}

	public FunctionDeclarationListModel getFunctionListModel() {
		return (FunctionDeclarationListModel) getFunctionListPanel().getModel();
	}

	private JList getFunctionListPanel() {
		if (ivjFunctionListPanel == null) {

			ivjFunctionListPanel = new JList();
			ivjFunctionListPanel.setName("FunctionListPanel");
			ivjFunctionListPanel.setModel(new FunctionDeclarationListModel());
			ivjFunctionListPanel
					.setCellRenderer(new FunctionDeclarationCellRendererAdapter(
							ivjFunctionListPanel.getCellRenderer()));
			ivjFunctionListPanel.setVisibleRowCount(8);
			ivjFunctionListPanel.setSelectionMode(0);
		}

		return ivjFunctionListPanel;
	}

	private JPanel getJPanelArgumentList() {
		if (ivjJPanelArgumentList == null) {

			ivjJPanelArgumentList = new JPanel();
			//			ivjJPanelArgumentList.setName("JPanelArgumentList");
			//			ivjJPanelArgumentList.setBorder(BorderFactory.createTitledBorder("Arguments"));
			ivjJPanelArgumentList.setLayout(new BorderLayout());
			getJPanelArgumentList().add(
					DefaultComponentFactory.getInstance().createTitle(
							"Arguments:"), BorderLayout.NORTH);
			getJPanelArgumentList().add(
					new JScrollPane(getArgumentListPanel()),
					BorderLayout.CENTER);
		}
		return ivjJPanelArgumentList;
	}

	private void updateFunctionListPanel() {
		IPredicateFunction myFilterFunction = null;

		if (getGUISeSAmDeclaration() != null)
				 {
			myFilterFunction = new FunctionDeclarationOutputTypeFilter(
					getTypeForCurrentSelFunCallIntDecl(), getGUISeSAmDeclaration()
							.getSeSAmDeclaration());
		}
		if (!selectField.getText().trim().equals("")) {
			FunctionDeclarationNameFilter nameFilter = new FunctionDeclarationNameFilter(
					selectField.getText());
			if (myFilterFunction == null)
				myFilterFunction = nameFilter;
			else
				myFilterFunction = new AndPredicateFunction(myFilterFunction,
						nameFilter);
		}

		//Assert.assertNotNull(getExpertFilterFunctionDeclarationListAble());
		// //remove because of null in dispose
		if (getExpertFilterFunctionDeclarationListAble() != null)
			getExpertFilterFunctionDeclarationListAble().setAdditionalFilter(
					myFilterFunction);

		//select first
		if (getFunctionListModel().getSize() > 0)
			getFunctionListPanel().setSelectedIndex(0);
		else
			try {
				selectField.setText(selectField.getText().substring(0,
						selectField.getText().length() - 1));
			} catch (RuntimeException e) {
			}
	}

	private BestBoundJTextField getSelectTextField() {
		if (selectField == null) {
			selectField = new BestBoundJTextField();
			selectField.addPropertyChangeListener("text",
					new PropertyChangeListener() {

						public void propertyChange(PropertyChangeEvent arg0) {
							updateFunctionListPanel();
						}
					});

			selectField.addActionListener(new ActionListener() {

				public void actionPerformed(ActionEvent e) {
					if ((getFunctionListModel().getSize() > 0)
							&& (getFunctionListPanel().getSelectedValue() != null))
						eventFunctionListDoubleClicked((IFunctionDeclaration) getFunctionListPanel()
								.getSelectedValue());

					if (e.getSource() == selectField)
						selectField.setText("");
				}
			});

			selectField.addKeyListener(new KeyListener() {

				public void keyPressed(KeyEvent e) {
					if ((e.getKeyCode() == KeyEvent.VK_DOWN)
							|| (e.getKeyCode() == KeyEvent.VK_KP_DOWN)) {
						if ((getFunctionListPanel().getSelectedIndex() > -1)
								&& (getFunctionListPanel().getModel().getSize() > (getFunctionListPanel()
										.getSelectedIndex() + 1)))
							getFunctionListPanel()
									.setSelectedIndex(
											getFunctionListPanel()
													.getSelectedIndex() + 1);
						else
							getFunctionListPanel().setSelectedIndex(0);
					}

					if ((e.getKeyCode() == KeyEvent.VK_UP)
							|| (e.getKeyCode() == KeyEvent.VK_KP_UP)) {
						if ((getFunctionListPanel().getSelectedIndex() > -1)
								&& (getFunctionListPanel().getSelectedIndex() > 0))
							getFunctionListPanel()
									.setSelectedIndex(
											getFunctionListPanel()
													.getSelectedIndex() - 1);
						else
							getFunctionListPanel().setSelectedIndex(0);
					}
				}

				public void keyReleased(KeyEvent e) {
				}

				public void keyTyped(KeyEvent e) {
				}
			});
		}
		return selectField;
	}

	private JPanel getFunctionListPanelWithFastTypeField() {
		if (ivjFunctionListPanelWithFastTypeField == null) {
			ivjFunctionListPanelWithFastTypeField = new JPanel();
			ivjFunctionListPanelWithFastTypeField.setLayout(new BorderLayout());
			getFunctionListPanelWithFastTypeField().add(
					DefaultComponentFactory.getInstance().createTitle(
							"Functions:"), BorderLayout.NORTH);
			getFunctionListPanelWithFastTypeField().add(
					new JScrollPane(getFunctionListPanel()),
					BorderLayout.CENTER);
			getFunctionListPanelWithFastTypeField().add(getSelectTextField(),
					BorderLayout.SOUTH);

			//redirect KeyStrokes to FastTypeField
			getFunctionListPanel().addKeyListener(new KeyAdapter() {

				public void keyPressed(KeyEvent e) {

					int type = Character.getType(e.getKeyChar());
					if (Character.isLetterOrDigit(e.getKeyChar())
							|| (type == Character.MATH_SYMBOL)
							|| (type == Character.OTHER_PUNCTUATION)
							|| (type == Character.CURRENCY_SYMBOL)
							|| (type == Character.START_PUNCTUATION)
							|| (type == Character.DASH_PUNCTUATION)) {

						getSelectTextField().replaceSelection(
								Character.toString(e.getKeyChar()));
						updateFunctionListPanel();
					}
				}
			});
		}
		return ivjFunctionListPanelWithFastTypeField;
	}

	private JAutoscrollTree getJTreeFCall() {
		if (ivjJTreeFCall == null) {
			ivjJTreeFCall = new JAutoscrollTree();
			ivjJTreeFCall.setName("JTreeFCall");
			ivjJTreeFCall.setModel(getFunctionCallDeclaration().getTreeModel());
			ivjJTreeFCall
					.setCellRenderer(new FunctionCallInternDeclarationCellRenderer());
			ivjJTreeFCall.addKeyListener(new KeyListener() {

				public void keyPressed(KeyEvent e) {
					if (e.getKeyCode() == KeyEvent.VK_DELETE) {
						Object comp = ivjJTreeFCall.getSelectionPath()
								.getLastPathComponent();
						if (comp instanceof IFunctionCallInternDeclaration) {
							IFunctionCallInternDeclaration oldFunCall = ((IComposedFunctionCallInternDeclaration) comp);
							IFunctionCallInternDeclaration newFunCall = oldFunCall
									.getSpecificOutputType()
									.createDefaultFunctionCallInternDeclaration();
							newFunCall.setParent(oldFunCall.getParent());
							changeFunctionCall(newFunCall, oldFunCall);
						}
					}
				}

				public void keyReleased(KeyEvent e) {
				}

				public void keyTyped(KeyEvent e) {
				}
			});
		}
		return ivjJTreeFCall;
	}

	protected IFunctionCallInternDeclaration getRootFunctionCallInternDecl() {
		return getFunctionCallDeclaration().getFunctionCallInternDeclaration();
	}

	private TreeModel getTreeModel() {
		return ivjTreeModel;
	}

	protected TreePath getTreePathToFunctionCallInternDecl(
			IFunctionCallInternDeclaration functionCallInternDeclaration) {
		return new TreePath(getFunctionCallDeclaration().getPathToRoot(
				functionCallInternDeclaration));
	}

	protected TreePath getTreePathToRootFunctionCallInternDecl() {
		return getTreePathToFunctionCallInternDecl(getFunctionCallDeclaration()
				.getFunctionCallInternDeclaration());
	}

	protected ISpecificType getTypeForCurrentSelFunCallIntDecl() {
		IFunctionCallInternDeclaration currfunCall = getCurrentSelectedFunctionCallInternDeclaration();
		if (currfunCall == null)
			return null;
		else {
			IComposedFunctionCallInternDeclaration parent = currfunCall
					.getParent();
			if ((parent == null) || (parent.getIndexOfChild(currfunCall) == -1)) {
				return getFunctionCallDeclaration().getMostGeneralOutputType();
			} else {
				return parent.getSpecificFunctionDeclaration()
						.getSpecificInputTypeAt(
								parent.getIndexOfChild(currfunCall));
			}
		}
	}

	public List getTypeList() {
		return _typeList;
	}

	protected void ignoreException(Throwable arg1) {
		return;
	}

	private void initConnections() {
		getArgumentListPanel().addMouseListener(ivjEventHandler);
		getFunctionListPanel().addMouseListener(ivjEventHandler);
		getFilterExpertSettingCheckBox().addItemListener(ivjEventHandler);
		getJTreeFCall().addTreeSelectionListener(ivjEventHandler);
		getJTreeFCall().addMouseListener(ivjEventHandler);
		getJTreeFCall().addPropertyChangeListener(ivjEventHandler);
		connPtoP5UpdateTreemodel();
		connPtoP1SetTarget();
	}

	private void initialize() {

		setLayout(new FormLayout("min(20dlu;default):grow(1.0), 3dlu, "
				+ "min(60dlu;min):grow(0.25), 2dlu, "
				+ "max(100dlu;min):grow(0.5)",
				"fill:default:grow, 1dlu, fill:default"));

		CellConstraints cc = new CellConstraints();

		JScrollPane scrollTreePanel = new JScrollPane(getJTreeFCall());
		scrollTreePanel.setPreferredSize(new Dimension(200, 100));

		add(scrollTreePanel, cc.xywh(1, 1, 1, 1));
		add(getJPanelArgumentList(), cc.xy(3, 1));
		add(getFunctionListPanelWithFastTypeField(), cc.xy(5, 1));
		add(getFilterExpertSettingCheckBox(), cc.xy(5, 3, "right, fill"));

		getJPanelArgumentList().setMinimumSize(new Dimension(0, 0));
		getFunctionListPanelWithFastTypeField().setMinimumSize(
				new Dimension(0, 0));
		getFilterExpertSettingCheckBox().setMinimumSize(new Dimension(0, 0));
		getJTreeFCall().setMinimumSize(new Dimension(0, 0));

		initConnections();

		ToolTipManager.sharedInstance().registerComponent(getJTreeFCall());
		ToolTipManager.sharedInstance().registerComponent(
				getArgumentListPanel());
		ToolTipManager.sharedInstance().registerComponent(
				getFunctionListPanel());

		// drag and drop
		new FunctionCallDeclarationTreeListPanelDnDListenerAdapter(this,
				getJTreeFCall());

		// copy & paste
		getJTreeFCall().setTransferHandler(
				new FunctionCallPanelTransferHandler());

		setExpertFilterFunctionDeclarationListAble(new ExpertFilterFunctionDeclarationListAble());
	}

	protected void insertRemoveAndInsertActions(final TreePath treePath,
			final IFunctionCallInternDeclaration functionCallInternDeclaration,
			JPopupMenu popup) {

		final IComposedFunctionCallInternDeclaration parent = functionCallInternDeclaration
				.getParent();

		if ((parent != null)
				&& (parent.getSpecificFunctionDeclaration()
						.getSpecificInputMaxArgsLength() == ISpecificFunctionDeclaration.UNLIMITED_ARGUMENT_COUNT)) {
			if (parent.getSpecificFunctionDeclaration()
					.getSpecificInputMinArgsLength() < parent.getChildCount()) {

				popup.add(AbstractBoundAction
						.createJMenuItem(new AbstractBoundAction("Remove") {

							public void doit() {
								parent
										.removeChild(functionCallInternDeclaration);
								getFunctionCallDeclaration().getTreeModel()
										.valueForPathChanged(
												treePath.getParentPath(),
												parent);
							}
						}));
			}

			popup.add(AbstractBoundAction
					.createJMenuItem(new AbstractBoundAction("Insert") {

						public void doit() {
							parent
									.addChild(parent
											.getIndexOfChild(functionCallInternDeclaration));
							getFunctionCallDeclaration().getTreeModel()
									.valueForPathChanged(
											treePath.getParentPath(), parent);
						}
					}));
		}
	}

	protected void insertRefactoringActions(final TreePath treePath,
			final IFunctionCallInternDeclaration functionCallInternDeclaration,
			JPopupMenu popup) {
		popup.addSeparator();
		popup.add(RefactoringMenuFactory.getInstance().createMenu(this,
				getGUISeSAmDeclaration(), functionCallInternDeclaration));
	}

	protected void selectFunctionCallInternDeclaration(
			IFunctionCallInternDeclaration functionCallInternDeclaration) {
		if (functionCallInternDeclaration != null) {
			selectPath(getTreePathToFunctionCallInternDecl(functionCallInternDeclaration));
		}
	}

	protected void selectPath(TreePath path) {
		if (!path.equals(getJTreeFCall().getSelectionPath())) {
			getJTreeFCall().expandPath(path);
			getJTreeFCall().setSelectionPath(path);
		}
	}

	public void setDeclaration(IDeclaration newDeclaration) {
		setFunctionCallDeclaration((IFunctionCallDeclaration) newDeclaration);
	}

	public void setEnabled(boolean enabled) {
		super.setEnabled(enabled);

		SwingMoreUtilities.setEnableAllComponentsRecursive(this, enabled);
	}

	public void setFunctionCallDeclaration(IFunctionCallDeclaration arg1) {
		setFunctionCallDeclarationIntern(arg1);
	}

	private void setFunctionCallDeclarationIntern(
			IFunctionCallDeclaration newValue) {
		if (ivjFunctionCallDeclarationIntern != newValue) {

			IFunctionCallDeclaration oldValue = getFunctionCallDeclarationIntern();
			/* Stop listening for events from the current object */
			if (ivjFunctionCallDeclarationIntern != null) {
				ivjFunctionCallDeclarationIntern
						.removePropertyChangeListener(ivjEventHandler);
			}
			ivjFunctionCallDeclarationIntern = newValue;

			/* Listen for events from the new object */
			if (ivjFunctionCallDeclarationIntern != null) {
				ivjFunctionCallDeclarationIntern
						.addPropertyChangeListener(ivjEventHandler);
			}
			connPtoP5UpdateTreemodel();
			eventFunctionCallDeclarationInternChanged();

			firePropertyChange("functionCallDeclaration", oldValue, newValue);
		}
	}

	public void setExpertFilterFunctionDeclarationListAble(
			IExpertFilterFunctionDeclarationListAble expertFilterFunctionDeclarationListAble) {
		IExpertFilterFunctionDeclarationListAble oldValue = _expertFilterFunctionDeclarationListAble;

		if (oldValue != expertFilterFunctionDeclarationListAble) {

			if (oldValue != null) {
				oldValue.remove();
			}

			_expertFilterFunctionDeclarationListAble = expertFilterFunctionDeclarationListAble;

			getArgumentDeclarationListModel().setFunctionDeclarationListAble(
					expertFilterFunctionDeclarationListAble);
			getFunctionListModel().setFunctionDeclarationListAble(
					expertFilterFunctionDeclarationListAble);
		}
	}

	public void setGUISeSAmDeclaration(
			IGUISeSAmDeclaration newGUISeSAmDeclaration) {
		super.setGUISeSAmDeclaration(newGUISeSAmDeclaration);

		getFunctionDeclarationCellRendererAdapter().setGUISeSAmDeclaration(
				newGUISeSAmDeclaration);

		IExpertFilterFunctionDeclarationListAble expertFilterFunctionDeclarationListAble = getExpertFilterFunctionDeclarationListAble();

		if (expertFilterFunctionDeclarationListAble == null) {
			// do nothing
		} else if (newGUISeSAmDeclaration == null) {
			expertFilterFunctionDeclarationListAble
					.setSeSAmModelDeclaration(null);
			setTypeList(CollectionsHelper.EMPTY_LIST);

		} else {
			expertFilterFunctionDeclarationListAble
					.setSeSAmModelDeclaration(newGUISeSAmDeclaration
							.getSeSAmModelDeclaration());

			setTypeList(newGUISeSAmDeclaration.getSeSAmModelDeclaration()
					.getAvailibleTypeList());
		}
	}

	private FunctionDeclarationCellRendererAdapter getFunctionDeclarationCellRendererAdapter() {
		return ((FunctionDeclarationCellRendererAdapter) getFunctionListPanel()
				.getCellRenderer());
	}

	public IExpertFilterFunctionDeclarationListAble getExpertFilterFunctionDeclarationListAble() {
		return _expertFilterFunctionDeclarationListAble;
	}

	private void setTreeModel(TreeModel newValue) {
		if (ivjTreeModel != newValue) {

			/* Stop listening for events from the current object */
			if (ivjTreeModel != null) {
				ivjTreeModel.removeTreeModelListener(ivjEventHandler);
			}
			ivjTreeModel = newValue;

			/* Listen for events from the new object */
			if (ivjTreeModel != null) {
				ivjTreeModel.addTreeModelListener(ivjEventHandler);
			}

			connPtoP1SetSource();
		}
	}

	public void setTypeList(java.util.List newTypeList) {
		_typeList = newTypeList;
	}
	
	protected void updateArgumentAndFunctionListPanel() {

		IFunctionCallInternDeclaration functionCallInternDeclaration = getCurrentSelectedFunctionCallInternDeclaration();

		if (functionCallInternDeclaration != null) {

			ISpecificType outputType = getTypeForCurrentSelFunCallIntDecl();

			getFunctionDeclarationCellRendererAdapter().setOutputType(
					outputType);

			getArgumentDeclarationListModel().setSpecificType(outputType);
			getFunctionListModel().setSpecificType(outputType);
			updateFunctionListPanel(); // respect filters 

			if (functionCallInternDeclaration instanceof IComposedFunctionCallInternDeclaration) {
				ISpecificFunctionDeclaration funcDecl = ((IComposedFunctionCallInternDeclaration) functionCallInternDeclaration)
						.getSpecificFunctionDeclaration();

				selectDeclarationIfPossible(funcDecl);
				getArgumentListPanel().clearSelection();

			} else {
				IArgumentDeclaration selectedArgumentDeclaration = ((IAtomicFunctionCallInternDeclaration) functionCallInternDeclaration)
						.getArgumentDeclaration();

				int index = getArgumentDeclarationListModel().indexOf(
						selectedArgumentDeclaration);

				if ((index == -1)
						&& !(selectedArgumentDeclaration instanceof IFunctionArgumentDeclaration)) {
					index = getArgumentDeclarationListModel().indexOf(
							selectedArgumentDeclaration.getSpecificType());
				}

				if (index != -1)
					getArgumentListPanel().setSelectedValue(
							getArgumentDeclarationListModel().getElementAt(
									index), true);
				else
					getArgumentListPanel().clearSelection();

				getFunctionListPanel().clearSelection();
			}

		}
	}

	/**
	 * Selects a given declaration in the FunctionDecelarationList if this is 
	 * possible
	 */
	private void selectDeclarationIfPossible(ISpecificFunctionDeclaration funcDecl) {
		if (getExpertFilterFunctionDeclarationListAble() == null)
			return;

		// Find same declaration
		Iterator it = getExpertFilterFunctionDeclarationListAble()
				.getFunctionDeclarations();
		IFunctionDeclaration foundFunctionDeclaration = null;
		while (it.hasNext()) {
			IFunctionDeclaration currFunctionDeclaration = (IFunctionDeclaration) it
					.next();

			if ((currFunctionDeclaration.equals(funcDecl))
					|| (currFunctionDeclaration.equals(funcDecl
							.getGenericFunctionDeclaration()))) {
				foundFunctionDeclaration = currFunctionDeclaration;
				break;
			}
		}

		//dind declaration with same name
		if (foundFunctionDeclaration == null) {
			Iterator it2 = getExpertFilterFunctionDeclarationListAble()
					.getFunctionDeclarations();
			while (it2.hasNext()) {
				IFunctionDeclaration currFunctionDeclaration = (IFunctionDeclaration) it2
						.next();

				if (currFunctionDeclaration.getName().equals(
						funcDecl.getName())) {
					foundFunctionDeclaration = currFunctionDeclaration;
					break;
				}
			}
		}

		if (foundFunctionDeclaration != null) {
			getFunctionListPanel().setSelectedValue(
					foundFunctionDeclaration, true);
			// could be non visible (e.g. expert)
			// Assert.assertEquals(currFunctionDeclaration,
			// getFunctionListPanel().getSelectedValue());

		} else {
			getFunctionListPanel().clearSelection();
		}
	}

	public void setFilterExpertSettings(boolean expert) {
		getFilterExpertSettingCheckBox().setSelected(expert);
	}

	public boolean isFilterExpertSettings() {
		return getFilterExpertSettingCheckBox().isSelected();
	}

	public IFunctionArgumentDeclarationList getOuterFunctionArgumentDeclarationList() {
		return ivjOuterFunctionArgumentDeclarationListIntern;
	}

	protected void eventSetFunctionArgumentDeclarationList() {
		setAllFunctionArgumentDeclarationList(getOuterFunctionArgumentDeclarationList());
	}

	public void setOuterFunctionArgumentDeclarationList(
			IFunctionArgumentDeclarationList newValue) {
		if (getOuterFunctionArgumentDeclarationList() != newValue) {
			ivjOuterFunctionArgumentDeclarationListIntern = newValue;

			this.eventSetFunctionArgumentDeclarationList();
		}
	}

	public IFunctionArgumentDeclarationList getAllFunctionArgumentDeclarationList() {
		return getArgumentDeclarationListModel()
				.getFunctionArgumentDeclarationList();
	}

	protected void setAllFunctionArgumentDeclarationList(
			IFunctionArgumentDeclarationList functionArgumentDeclarationList) {
		IFunctionArgumentDeclarationList oldAllFunctionArgumentDeclarationList = getAllFunctionArgumentDeclarationList();

		getArgumentDeclarationListModel().setFunctionArgumentDeclarationList(
				functionArgumentDeclarationList);

		firePropertyChange("allFunctionArgumentDeclarationList",
				oldAllFunctionArgumentDeclarationList,
				getAllFunctionArgumentDeclarationList());
	}

	public static void main(String[] arguments) {
		JAutoscrollTree tree = new JAutoscrollTree();
		tree.setCellRenderer(new FunctionCallInternDeclarationCellRenderer());
		IUserFunctionDeclaration decl1 = (IUserFunctionDeclaration) UserFunctionDeclarationFactory
				.getInstance(true).createDeclaration();
		IUserFunctionDeclaration decl2 = (IUserFunctionDeclaration) UserFunctionDeclarationFactory
				.getInstance(true).createUserFunctionDeclaration(
						StringType.getInstance());

		tree.setModel(decl1.getParametricFunctionCallDeclaration()
				.getFunctionCallDeclaration().getTreeModel());
		tree.setModel(decl2.getParametricFunctionCallDeclaration()
				.getFunctionCallDeclaration().getTreeModel());
		JFrame frame = new JFrame();
		frame.getContentPane().add(tree);
		frame.pack();
		frame.show();
		DoubleType.getInstance().getArgumentDeclarationDefaultValue();
	}
}