package de.uniwue.ki.gui.mas.basics.functionUser;
import de.uniwue.ki.gui.mas.util.declaration.DeclarationListPanel;
import de.uniwue.ki.gui.util.dnd.ObjectDataFlavor;
import de.uniwue.ki.mas.basics.functionUser.IUserFunctionDeclaration;
import de.uniwue.ki.mas.basics.functionUser.UserFunctionDeclarationListAndFactory;
import de.uniwue.ki.mas.util.declaration.IDeclarationList;

/**
 * Creation date: (13.12.2000 18:26:47)
 * @author Christoph Oechslein
 */
public class UserFunctionDeclarationListPanel extends DeclarationListPanel {

	public UserFunctionDeclarationListPanel() {
		super();
		initialize();
	}

	public String getDeclarationFrameTitle(de.uniwue.ki.mas.util.declaration.IDeclaration declaration) {
		return "User Function";
	}

	private void handleException(Throwable exception) {
		exception.printStackTrace(System.out);
	}

	private void initialize() {
		try {
			setName("UserDefinedFunctionDeclarationListPanel");
			setSize(193, 226);
			setDeclarationListAndFactory(new UserFunctionDeclarationListAndFactory(true));
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
		enableDnDSupport(ObjectDataFlavor.getDataFlavor(IUserFunctionDeclaration.class));
		setCellRenderer(new UserFunctionDeclarationCellRendererAdapter(getCellRenderer()));
	}

	public static void main(String[] args) {
		try {
			javax.swing.JFrame frame = new javax.swing.JFrame();
			UserFunctionDeclarationListPanel aUserDefinedFunctionDeclarationListPanel;
			aUserDefinedFunctionDeclarationListPanel = new UserFunctionDeclarationListPanel();
			frame.setContentPane(aUserDefinedFunctionDeclarationListPanel);
			frame.setSize(aUserDefinedFunctionDeclarationListPanel.getSize());
			frame.addWindowListener(new java.awt.event.WindowAdapter() {
				public void windowClosing(java.awt.event.WindowEvent e) {
					System.exit(0);
				}
			});
			frame.show();
			java.awt.Insets insets = frame.getInsets();
			frame.setSize(
				frame.getWidth() + insets.left + insets.right,
				frame.getHeight() + insets.top + insets.bottom);
			frame.setVisible(true);
		} catch (Throwable exception) {
			System.err.println(
				"Exception occurred in main() of de.uniwue.ki.gui.mas.model.basics.functionUser.UserDefinedFunctionDeclarationListPanel");
			exception.printStackTrace(System.out);
		}
	}

	public void setDeclarationListModel(IDeclarationList newDeclarationList) {
		super.setDeclarationListModel(newDeclarationList);
	}

}