package de.uniwue.ki.gui.mas.basics.functionUser;
import java.awt.*;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

import javax.swing.*;

import de.uniwue.ki.gui.mas.basics.functionArgument.SpecificFunctionDeclarationWithArgDeclBindsPanel;
import de.uniwue.ki.gui.mas.basics.functionCall.ExpertFilterUserFunctionDeclarationListAble;
import de.uniwue.ki.gui.mas.basics.functionCall.IExpertFilterFunctionDeclarationListAble;
import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.util.declaration.AbstractDeclarationPanel;
import de.uniwue.ki.gui.mas.util.declaration.NameDeclarationWithDocumentationPanel;
import de.uniwue.ki.mas.basics.functionArgument.IFunctionArgumentDeclarationList;
import de.uniwue.ki.mas.basics.functionUser.IUserFunctionDeclaration;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: (13.07.2001 15:03:37)
 * @author Christoph Oechslein
 */
public class UserFunctionDeclarationPanel extends AbstractDeclarationPanel {

	private SpecificFunctionDeclarationWithArgDeclBindsPanel _specificFunctionDeclarationWithArgDeclBindsPanel =
		null;

	private NameDeclarationWithDocumentationPanel _declarationWithDocumentationPanel =
		new NameDeclarationWithDocumentationPanel();

	private JCheckBox _externalCheckBox = new JCheckBox("external");
	private JCheckBox _expertCheckBox = new JCheckBox("expert");

	public UserFunctionDeclarationPanel() {
		super();

		setLayout(new GridBagLayout());
		setPreferredSize(new Dimension(600,400));
		
		addNameDeclarationWithDocumentationPanel();
		addCheckBoxPanel();
		addFunctionPanel();
	}

	private void addFunctionPanel() {
		GridBagConstraints functionGridBagConstraints = new GridBagConstraints();

		functionGridBagConstraints.gridx = 0;
		functionGridBagConstraints.gridy = 2;
		functionGridBagConstraints.weightx = 1;
		functionGridBagConstraints.weighty = 1;
		functionGridBagConstraints.gridwidth = 2;
		functionGridBagConstraints.fill = GridBagConstraints.BOTH;

		add(getSpecificFunctionDeclarationWithArgDeclBindsPanel(), functionGridBagConstraints);
	}

	private void addCheckBoxPanel() {
		JPanel panel = new JPanel();

		panel.setLayout(new FlowLayout(FlowLayout.RIGHT, 0, 0));

		addExternalCheckBox(panel);
		panel.add(Box.createHorizontalStrut(7));
		addExpertCheckBox(panel);

		GridBagConstraints checkBoxGridBagConstraints = new GridBagConstraints();

		checkBoxGridBagConstraints.gridx = 1;
		checkBoxGridBagConstraints.gridy = 0;
		checkBoxGridBagConstraints.insets.left = 11;
		checkBoxGridBagConstraints.anchor = GridBagConstraints.EAST;

		add(panel, checkBoxGridBagConstraints);
	}

	private void addExternalCheckBox(JPanel panel) {
		_externalCheckBox.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				if (getUserFunctionDeclaration() != null)
					getUserFunctionDeclaration().setExternal(e.getStateChange() == ItemEvent.SELECTED);
			}
		});

		panel.add(_externalCheckBox);
	}

	private void addExpertCheckBox(JPanel panel) {
		_expertCheckBox.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				if (getUserFunctionDeclaration() != null)
					getUserFunctionDeclaration().setExpertFunctionDeclaration(
						e.getStateChange() == ItemEvent.SELECTED);
			}
		});

		panel.add(_expertCheckBox);
	}

	private void addNameDeclarationWithDocumentationPanel() {
		GridBagConstraints nameGridBagConstraints = new GridBagConstraints();

		nameGridBagConstraints.gridx = 0;
		nameGridBagConstraints.gridy = 0;
		nameGridBagConstraints.weightx = 1;
		nameGridBagConstraints.fill = GridBagConstraints.HORIZONTAL;

		add(_declarationWithDocumentationPanel, nameGridBagConstraints);
	}

	public IFunctionArgumentDeclarationList getOuterFunctionArgumentDeclarationList() {
		return getSpecificFunctionDeclarationWithArgDeclBindsPanel()
			.getOuterFunctionArgumentDeclarationList();
	}

	public void setOuterFunctionArgumentDeclarationList(IFunctionArgumentDeclarationList arg1) {
		getSpecificFunctionDeclarationWithArgDeclBindsPanel().setOuterFunctionArgumentDeclarationList(arg1);
	}

	public void setUserFunctionDeclaration(IUserFunctionDeclaration userFunctionDeclaration) {
		getSpecificFunctionDeclarationWithArgDeclBindsPanel().setDeclaration(userFunctionDeclaration);
		getNameDeclarationWithDocumentationPanel().setDeclaration(userFunctionDeclaration);

		if (userFunctionDeclaration != null) {
			_externalCheckBox.setSelected(userFunctionDeclaration.isExternal());
			_expertCheckBox.setSelected(userFunctionDeclaration.isExpertFunctionDeclaration());
		}
	}

	public IUserFunctionDeclaration getUserFunctionDeclaration() {
		return (IUserFunctionDeclaration)getSpecificFunctionDeclarationWithArgDeclBindsPanel()
			.getDeclaration();
	}

	public void setDeclaration(IDeclaration declaration) {
		setUserFunctionDeclaration((IUserFunctionDeclaration)declaration);
	}

	public IDeclaration getDeclaration() {
		return getUserFunctionDeclaration();
	}

	public void setGUISeSAmDeclaration(IGUISeSAmDeclaration guiSeSAmDeclaration) {
		super.setGUISeSAmDeclaration(guiSeSAmDeclaration);

		getSpecificFunctionDeclarationWithArgDeclBindsPanel().setGUISeSAmDeclaration(guiSeSAmDeclaration);
		getNameDeclarationWithDocumentationPanel().setGUISeSAmDeclaration(guiSeSAmDeclaration);
	}

	public void setExpertFilterFunctionDeclarationListAble(IExpertFilterFunctionDeclarationListAble expertFilterFunctionDeclarationListAble) {
		getSpecificFunctionDeclarationWithArgDeclBindsPanel().setExpertFilterFunctionDeclarationListAble(
			expertFilterFunctionDeclarationListAble);
	}

	private NameDeclarationWithDocumentationPanel getNameDeclarationWithDocumentationPanel() {
		return _declarationWithDocumentationPanel;
	}

	private SpecificFunctionDeclarationWithArgDeclBindsPanel getSpecificFunctionDeclarationWithArgDeclBindsPanel() {
		if (_specificFunctionDeclarationWithArgDeclBindsPanel == null) {

			_specificFunctionDeclarationWithArgDeclBindsPanel =
				new SpecificFunctionDeclarationWithArgDeclBindsPanel();

			_specificFunctionDeclarationWithArgDeclBindsPanel.setExpertFilterFunctionDeclarationListAble(
				new ExpertFilterUserFunctionDeclarationListAble());
		}

		return _specificFunctionDeclarationWithArgDeclBindsPanel;
	}

	public void dispose() {
		getSpecificFunctionDeclarationWithArgDeclBindsPanel().dispose();
		getNameDeclarationWithDocumentationPanel().dispose();

		super.dispose();
	}
}