package de.uniwue.ki.gui.mas.basics.functionUser;
import java.awt.Container;
import java.util.Iterator;

import de.uniwue.ki.gui.mas.basics.search.SearchDeclarationPanelAction;
import de.uniwue.ki.gui.mas.model.AbstractDeclarationPanelAndActionFactory;
import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.util.declaration.*;
import de.uniwue.ki.mas.basics.functionUser.IUserFunctionDeclaration;
import de.uniwue.ki.mas.util.declaration.IDeclaration;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Creation date: (10.10.2001 11:09:49)
 * @author Christoph Oechslein
 */

public class UserFunctionDeclarationPanelActionFactory extends AbstractDeclarationPanelAndActionFactory {
	private final UserFunctionClassDeclarationPanelFactory _editPropertiesDeclarationPanelFactory =
		new UserFunctionClassDeclarationPanelFactory();

	private final class UserFunctionClassDeclarationPanelFactory extends AbstractDeclarationPanelFactory {
		public IDeclarationPanel createDeclarationPanel(IDeclaration declaration) {
			UserFunctionDeclarationPanel userFunctionDeclarationPanel = new UserFunctionDeclarationPanel();

			userFunctionDeclarationPanel.setGUISeSAmDeclaration(getGUISeSAmDeclaration());

			return userFunctionDeclarationPanel;
		}

		public String getDeclarationTitle(IDeclaration declaration) {
			return "User Function";
		}
	}

	public UserFunctionDeclarationPanelActionFactory() {
		super();
	}

	public UserFunctionDeclarationPanelActionFactory(IGUISeSAmDeclaration guiSeSAmDeclaration) {
		super();

		setGUISeSAmDeclaration(guiSeSAmDeclaration);
	}

	protected boolean getCanProduceDeclarationActions(Container parent, IDeclaration anDeclaration) {
		return anDeclaration instanceof IUserFunctionDeclaration;
	}

	public IDeclarationPanelFactory getDeclarationPanelFactory(
		Container parent,
		IDeclaration anDeclaration) {
		return _editPropertiesDeclarationPanelFactory;
	}

	protected Iterator getImportantDeclarationActions(Container parent, IDeclaration anDeclaration) {
		return CollectionsHelper.createIterator(
			new SearchDeclarationPanelAction(parent, anDeclaration, getGUISeSAmDeclaration()));
	}

	//TODO inline
	public void setGUISeSAmDeclaration(IGUISeSAmDeclaration newGUISeSAmDeclaration) {
		super.setGUISeSAmDeclaration(newGUISeSAmDeclaration);
	}
}