package de.uniwue.ki.gui.mas.basics.search;

import java.awt.Container;

import javax.swing.WindowConstants;

import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.model.JInternalFrameFactory;
import de.uniwue.ki.gui.mas.util.declaration.DeclarationListPanel;
import de.uniwue.ki.gui.util.SwingMoreUtilities;
import de.uniwue.ki.gui.util.actions.AbstractBoundAction;
import de.uniwue.ki.mas.basics.search.SearchReferencesHelper;
import de.uniwue.ki.mas.util.declaration.DefaultDeclarationList;
import de.uniwue.ki.mas.util.declaration.IDeclaration;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * @author herrler
 */

public class SearchDeclarationPanelAction extends AbstractBoundAction {
	private IGUISeSAmDeclaration _guiSeSAmDeclaration;
	private Container _parent;
	private IDeclaration _declaration;

	public SearchDeclarationPanelAction(
		Container parent,
		IDeclaration anDeclaration,
		IGUISeSAmDeclaration guiSeSAmDeclaration) {
		super("Find References", SwingMoreUtilities.getJavaSunIcon(16, "general/Properties16.gif"));
		_guiSeSAmDeclaration = guiSeSAmDeclaration;
		_parent = parent;
		_declaration = anDeclaration;
	}

	public void doit() {

		SwingMoreUtilities
			.invokeWithIndeterminateProgressbar(
				_parent,
				"Searching for " + _declaration.getName(),
				"Searching for " + _declaration.getName(),
				new Runnable() {
			public void run() {
				DefaultDeclarationList decList = new DefaultDeclarationList();
				CollectionsHelper.addAll(
					decList,
					SearchReferencesHelper.findReferences(_declaration, _guiSeSAmDeclaration.getSeSAmDeclaration()));

				final DeclarationListPanel declarationListPanel = new DeclarationListPanel();
				declarationListPanel.setGUISeSAmDeclaration(_guiSeSAmDeclaration);
				declarationListPanel.setDeclarationListModel(decList);
				declarationListPanel.setButtonPaneAvailible(false);

				((JInternalFrameFactory) (_guiSeSAmDeclaration.getFrameFactory())).addInternalFrame(
					_parent,
					getDeclarationFrameTitle(_declaration),
					declarationListPanel,
					true,
					WindowConstants.DISPOSE_ON_CLOSE);
			}
		});
	}

	private String getDeclarationFrameTitle(IDeclaration declaration) {
		return "Search References for " + declaration.getName();
	}

}
