package de.uniwue.ki.gui.mas.basics.type;

import java.util.List;

import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.mas.basics.type.*;
import de.uniwue.ki.mas.basics.type.composed.GenericComposedType;
import de.uniwue.ki.mas.basics.type.composed.GenericComposedTypeAttributeType;
import de.uniwue.ki.mas.basics.type.enum.GenericEnumType;

/**
 * Creation date: (31.08.2000 15:06:01)
 * @author Christoph Oechslein
 */

public final class GenericArgumentDefinePanelFactory {

	private static IGenericTypeDefinePanel createGenericTypeDefinePanelFor(IGenericType type, IGUISeSAmDeclaration guiSeSAmDeclaration) {
		if (type instanceof GenericIteratorType) {
			return new GenericIteratorTypeDefinePanel();}
			
		if (type instanceof GenericListType) {
			return new GenericListTypeDefinePanel();
		}

		if (type instanceof IGenericGroupType) {
			return new GenericGroupTypeDefinePanel((IGenericGroupType)type, guiSeSAmDeclaration);
		}

		if (type instanceof GenericFunctionType) {
			return new GenericFunctionTypeDefinePanel();
		}

		if (type instanceof GenericVariableClassDeclarationType) {
			return new GenericVariableDefinePanel();
		}

		if (type instanceof GenericHashtableType) {
			return new GenericHashTableTypeDefinePanel();
		}

		if (type instanceof GenericComposedTypeAttributeType) {
			return new GenericComposedTypeAttributeTypeDefinePanel();
		}

		if ((type instanceof GenericComposedType) || (type instanceof GenericEnumType)) {
			return new GenericUserTypeDefinePanel();
		}
		
		if (type instanceof GenericSimObjectType){
			return new GenericSimObjectTypeDefinePanel();
		}
		
		

		//
		//throw new UnsupportedOperationException("GenericTypeDefinePanel not defined for " + type);
		return null;
	}

	public static IGenericTypeDefinePanel createGenericTypeDefinePanelFor(
		IGenericType type,
		IGUISeSAmDeclaration guiSeSAmDeclaration,
		List typeList) {

		IGenericTypeDefinePanel genericTypeDefinePanel = createGenericTypeDefinePanelFor(type, guiSeSAmDeclaration);

		if (genericTypeDefinePanel == null)
			return null;

		genericTypeDefinePanel.setGUISeSAmDeclaration(guiSeSAmDeclaration);
		genericTypeDefinePanel.setTypeList(typeList);

		return genericTypeDefinePanel;
	}

}