package de.uniwue.ki.gui.mas.basics.type;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.event.*;

import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import de.uniwue.ki.gui.mas.model.JPanelWithGUISeSAmDeclaration;
import de.uniwue.ki.gui.util.NamedCellRendererAdapter;
import de.uniwue.ki.mas.basics.type.*;
import de.uniwue.ki.util.collection.CollectionsHelper;
import de.uniwue.ki.util.functions.IMapFunction;
import de.uniwue.ki.util.name.INamedObjectWrapper;

/**
 * Creation date: (05.09.2000 14:11:02)
 * @author Rainer Herrler
 */
public class GenericFunctionTypeDefinePanel
	extends JPanelWithGUISeSAmDeclaration
	implements IGenericTypeDefinePanel {
	private javax.swing.JCheckBox ivjCheckBoxUnlimitedArguments = null;
	private javax.swing.JPanel ivjJPanel1 = null;
	private javax.swing.JPanel ivjJPanel2 = null;
	private javax.swing.JPanel ivjJPanel3 = null;
	private javax.swing.JList ivjArgumenList = null;
	private javax.swing.JPanel ivjJPanel4 = null;
	private javax.swing.JPanel ivjJPanel5 = null;
	private javax.swing.JLabel ivjLabelArgList = null;
	private javax.swing.JLabel ivjLabelInputType = null;
	private SpecificTypeDefinePanel ivjSpecificTypeDefinePanel1 = null;
	private final IvjEventHandler ivjEventHandler = new IvjEventHandler();
	private javax.swing.JPanel ivjJPanel6 = null;
	private javax.swing.JPanel ivjJPanel7 = null;
	private javax.swing.JButton ivjJButton3 = null;
	private javax.swing.JButton ivjJButton4 = null;
	private javax.swing.JPanel ivjJPanel8 = null;
	private boolean fieldUnlimitedArguments = false;
	private javax.swing.JLabel ivjTypeLabel = null;
	private boolean ivjConnPtoP1Aligning = false;

	class IvjEventHandler
		implements ActionListener, java.beans.PropertyChangeListener, ListSelectionListener {
		public void actionPerformed(ActionEvent e) {
			if (e.getSource() == GenericFunctionTypeDefinePanel.this.getCheckBoxUnlimitedArguments())
				connEtoC2(e);
			if (e.getSource() == GenericFunctionTypeDefinePanel.this.getCheckBoxUnlimitedArguments())
				connEtoM3(e);
			if (e.getSource() == GenericFunctionTypeDefinePanel.this.getCheckBoxUnlimitedArguments())
				connEtoM4(e);
			if (e.getSource() == GenericFunctionTypeDefinePanel.this.getJButton3())
				connEtoC3(e);
			if (e.getSource() == GenericFunctionTypeDefinePanel.this.getJButton4())
				connEtoC4(e);
			if (e.getSource() == GenericFunctionTypeDefinePanel.this.getJButton4())
				connEtoM5(e);
			if (e.getSource() == GenericFunctionTypeDefinePanel.this.getJButton3())
				connEtoM6(e);
		}
		public void propertyChange(java.beans.PropertyChangeEvent evt) {
			if (evt.getSource() == GenericFunctionTypeDefinePanel.this.getSpecificTypeDefinePanel1()
				&& (evt.getPropertyName().equals("specificType")))
				connEtoC5(evt);
			if (evt.getSource() == GenericFunctionTypeDefinePanel.this
				&& (evt.getPropertyName().equals("gUISeSAmDeclaration")))
				connPtoP1SetTarget();
			if (evt.getSource() == GenericFunctionTypeDefinePanel.this.getSpecificTypeDefinePanel1()
				&& (evt.getPropertyName().equals("gUISeSAmDeclaration")))
				connPtoP1SetSource();
		}
		public void valueChanged(ListSelectionEvent e) {
			if (e.getSource() == GenericFunctionTypeDefinePanel.this.getArgumenList())
				connEtoC6(e);
		}
	}

	public GenericFunctionTypeDefinePanel() {
		super();
		initialize();
	}

	/**
	 * This add's a new input-arg if possible (that means that we habe limited args)
	 */
	public void actionPerformedAddButton(ActionEvent actionEvent) {
		if (!isUnlimitedArgumentFunction()) {
			ISpecificType oldValue = getSpecificType();
			((javax.swing.DefaultListModel)getArgumenList().getModel()).addElement(
			//heres the element to add
			new INamedObjectWrapper(
				"InputType " + getArgumenList().getModel().getSize(),
				ObjectType.getInstance()));
			firePropertyChange("specificType", oldValue, getSpecificType());
			//now select the newly created item
			getArgumenList().setSelectedIndex(getArgumenList().getModel().getSize() - 1);
		}
		return;
	}

	/**
	 * The checkbox is armed ?
	 */
	public void actionPerformedCheckBoxUnlimitedArguments(ActionEvent actionEvent) {
		//turn the switch
		fieldUnlimitedArguments = !fieldUnlimitedArguments;
		//other consequences
		ISpecificType oldValue = getSpecificType();
		if (isUnlimitedArgumentFunction()) {
			//just one input and one output-Argument
			while (getArgumenList().getModel().getSize() > 2) {
				((javax.swing.DefaultListModel)getArgumenList().getModel()).remove(2);
			}
			((INamedObjectWrapper)getArgumenList().getModel().getElementAt(1)).setName("InputType");
			getArgumenList().repaint();
		} else {
			((INamedObjectWrapper)getArgumenList().getModel().getElementAt(1)).setName("InputType 1");
			getArgumenList().repaint();
		}
		firePropertyChange("specificType", oldValue, getSpecificType());
		//do we have removed the selected item -> select a new one
		if (getArgumenList().getSelectedValue() == null) {
			getArgumenList().setSelectedIndex(0);
		}
		return;
	}

	/**
	 * The remove-Button has been pressed... so now let's remove one input-arg
	 * if possible.
	 */
	public void actionPerformedRemoveButton(ActionEvent actionEvent) {
		if (getArgumenList().getModel().getSize() > 2) {
			ISpecificType oldValue = getSpecificType();
			((javax.swing.DefaultListModel)getArgumenList().getModel()).remove(
				getArgumenList().getModel().getSize() - 1);
			firePropertyChange("specificType", oldValue, getSpecificType());
			//did we remove the currently selcted item ?
			if (getArgumenList().getSelectedValue() == null) {
				getArgumenList().setSelectedIndex(0);
			}
		}
		return;
	}

	public boolean addButtonPossible() {
		return !isUnlimitedArgumentFunction();
	}

	private void connEtoC2(ActionEvent arg1) {
		try {
			this.actionPerformedCheckBoxUnlimitedArguments(arg1);
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	private void connEtoC3(ActionEvent arg1) {
		try {
			this.actionPerformedRemoveButton(arg1);
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	private void connEtoC4(ActionEvent arg1) {
		try {
			this.actionPerformedAddButton(arg1);
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	private void connEtoC5(java.beans.PropertyChangeEvent arg1) {
		try {
			this.notifySpecificTypeChanged(getSpecificTypeDefinePanel1().getSpecificType());
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	private void connEtoC6(ListSelectionEvent arg1) {
		try {
			this.eventArgumenListSelectionValueChanged();
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	private void connEtoM3(ActionEvent arg1) {
		try {
			getJButton4().setEnabled(this.addButtonPossible());
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	private void connEtoM4(ActionEvent arg1) {
		try {
			getJButton3().setEnabled(this.removeButtonPossible());
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	private void connEtoM5(ActionEvent arg1) {
		try {
			getJButton3().setEnabled(this.removeButtonPossible());
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	private void connEtoM6(ActionEvent arg1) {
		try {
			getJButton3().setEnabled(this.removeButtonPossible());
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	private void connPtoP1SetSource() {
		try {
			if (ivjConnPtoP1Aligning == false) {
				ivjConnPtoP1Aligning = true;
				this.setGUISeSAmDeclaration(getSpecificTypeDefinePanel1().getGUISeSAmDeclaration());
				ivjConnPtoP1Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP1Aligning = false;
			handleException(ivjExc);
		}
	}

	private void connPtoP1SetTarget() {
		try {
			if (ivjConnPtoP1Aligning == false) {
				ivjConnPtoP1Aligning = true;
				getSpecificTypeDefinePanel1().setGUISeSAmDeclaration(this.getGUISeSAmDeclaration());
				ivjConnPtoP1Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP1Aligning = false;
			handleException(ivjExc);
		}
	}

	/**
	 * This Function creates a ListBoxModel from a given Specific Type that must be
	 * either
	 *     - SpecificFunctionUnlimitedType (or)
	 *     - SpecificFunctionType
	 *
	 * The Function has noc side-effects..the caller has to take care that the listbox
	 * knows of the newly created model.
	 *
	 * Creation date: (05.09.2000 20:54:49)
	 * @return javax.swing.DefaultListModel
	 * @param param de.uniwue.ki.mas.model.basics.type.ISpecificType
	 */
	protected javax.swing.DefaultListModel createLocalListBoxModel(ISpecificType param) {
		javax.swing.DefaultListModel thisListModel = new javax.swing.DefaultListModel();

		if (param instanceof SpecificFunctionUnlimitedType) {
			thisListModel.addElement(
				new INamedObjectWrapper(
					"OutputType",
					((SpecificFunctionUnlimitedType)param).getSpecificOutputType()));
			thisListModel.addElement(
				new INamedObjectWrapper(
					"InputType",
					((SpecificFunctionUnlimitedType)param).getSpecificInputType()));
		}

		if (param instanceof SpecificFunctionType) {
			thisListModel.addElement(
				new INamedObjectWrapper("OutputType", ((SpecificFunctionType)param).getSpecificOutputType()));

			java.util.Iterator it = ((SpecificFunctionType)param).getSpecificInputTypes();
			ISpecificType localInputType = null;

			int localCounter = 0;
			while (it.hasNext()) {
				localCounter = localCounter + 1;
				localInputType = (ISpecificType)it.next();
				thisListModel.addElement(
					new INamedObjectWrapper("InputType " + localCounter, localInputType));
			}
		}
		return thisListModel;
	}

	protected void eventArgumenListSelectionValueChanged() {
		INamedObjectWrapper namedObjectWrapper = (INamedObjectWrapper)getArgumenList().getSelectedValue();

		if (namedObjectWrapper == null) {
			getSpecificTypeDefinePanel1().setEnabled(false);
		} else {
			getSpecificTypeDefinePanel1().setEnabled(true);
			getSpecificTypeDefinePanel1().setSpecificType(typeDefinitionFromWrapper(namedObjectWrapper));
		}
	}

	private javax.swing.JList getArgumenList() {
		if (ivjArgumenList == null) {
			try {
				javax.swing.DefaultListModel ivjLocalModel;
				ivjLocalModel = new javax.swing.DefaultListModel();
				ivjLocalModel.setSize(2);
				ivjArgumenList = new javax.swing.JList();
				ivjArgumenList.setName("ArgumenList");
				ivjArgumenList.setModel(ivjLocalModel);
				ivjArgumenList.setCellRenderer(
					new NamedCellRendererAdapter(ivjArgumenList.getCellRenderer()));
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjArgumenList;
	}

	private javax.swing.JCheckBox getCheckBoxUnlimitedArguments() {
		if (ivjCheckBoxUnlimitedArguments == null) {
			try {
				ivjCheckBoxUnlimitedArguments = new javax.swing.JCheckBox();
				ivjCheckBoxUnlimitedArguments.setName("CheckBoxUnlimitedArguments");
				ivjCheckBoxUnlimitedArguments.setText("unlimited arguments");
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjCheckBoxUnlimitedArguments;
	}

	private ISpecificType getDefaultSpecificFunctionType() {
		java.util.ArrayList inputargs = new java.util.ArrayList();
		inputargs.add(DoubleType.getInstance());
		inputargs.add(BooleanType.getInstance());

		return GenericFunctionType.getInstance().createSpecificFunctionType(
			DoubleType.getInstance(),
			inputargs);
	}

	private ISpecificType getInputType(int param) {
		return (ISpecificType) ((INamedObjectWrapper)getArgumenList().getModel().getElementAt(param))
			.getObject();
	}

	private javax.swing.JButton getJButton3() {
		if (ivjJButton3 == null) {
			try {
				ivjJButton3 = new javax.swing.JButton();
				ivjJButton3.setName("JButton3");
				ivjJButton3.setText("Remove");
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjJButton3;
	}

	private javax.swing.JButton getJButton4() {
		if (ivjJButton4 == null) {
			try {
				ivjJButton4 = new javax.swing.JButton();
				ivjJButton4.setName("JButton4");
				ivjJButton4.setText("New");
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjJButton4;
	}

	private javax.swing.JPanel getJPanel1() {
		if (ivjJPanel1 == null) {
			try {
				ivjJPanel1 = new javax.swing.JPanel();
				ivjJPanel1.setName("JPanel1");
				ivjJPanel1.setLayout(new java.awt.BorderLayout());
				getJPanel1().add(getCheckBoxUnlimitedArguments(), "South");
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjJPanel1;
	}

	private javax.swing.JPanel getJPanel2() {
		if (ivjJPanel2 == null) {
			try {
				ivjJPanel2 = new javax.swing.JPanel();
				ivjJPanel2.setName("JPanel2");
				ivjJPanel2.setLayout(new java.awt.BorderLayout());
				getJPanel2().add(getJPanel3(), "North");
				getJPanel2().add(getJPanel4(), "Center");
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjJPanel2;
	}

	private javax.swing.JPanel getJPanel3() {
		if (ivjJPanel3 == null) {
			try {
				ivjJPanel3 = new javax.swing.JPanel();
				ivjJPanel3.setName("JPanel3");
				ivjJPanel3.setLayout(getJPanel3GridLayout());
				getJPanel3().add(getLabelArgList(), getLabelArgList().getName());
				getJPanel3().add(getLabelInputType(), getLabelInputType().getName());
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjJPanel3;
	}

	private java.awt.GridLayout getJPanel3GridLayout() {
		java.awt.GridLayout ivjJPanel3GridLayout = null;
		try {
			/* Create part */
			ivjJPanel3GridLayout = new java.awt.GridLayout();
			ivjJPanel3GridLayout.setColumns(2);
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		};
		return ivjJPanel3GridLayout;
	}

	private javax.swing.JPanel getJPanel4() {
		if (ivjJPanel4 == null) {
			try {
				ivjJPanel4 = new javax.swing.JPanel();
				ivjJPanel4.setName("JPanel4");
				ivjJPanel4.setLayout(getJPanel4GridLayout());
				getJPanel4().add(getJPanel5(), getJPanel5().getName());
				getJPanel4().add(getJPanel6(), getJPanel6().getName());
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjJPanel4;
	}

	private java.awt.GridLayout getJPanel4GridLayout() {
		java.awt.GridLayout ivjJPanel4GridLayout = null;
		try {
			/* Create part */
			ivjJPanel4GridLayout = new java.awt.GridLayout();
			ivjJPanel4GridLayout.setColumns(2);
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		};
		return ivjJPanel4GridLayout;
	}

	private javax.swing.JPanel getJPanel5() {
		if (ivjJPanel5 == null) {
			try {
				ivjJPanel5 = new javax.swing.JPanel();
				ivjJPanel5.setName("JPanel5");
				ivjJPanel5.setBorder(new javax.swing.border.EtchedBorder());
				ivjJPanel5.setLayout(new java.awt.BorderLayout());
				getJPanel5().add(getArgumenList(), "Center");
				getJPanel5().add(getJPanel8(), "South");
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjJPanel5;
	}

	private javax.swing.JPanel getJPanel6() {
		if (ivjJPanel6 == null) {
			try {
				ivjJPanel6 = new javax.swing.JPanel();
				ivjJPanel6.setName("JPanel6");
				ivjJPanel6.setLayout(new java.awt.BorderLayout());
				getJPanel6().add(getSpecificTypeDefinePanel1(), "Center");
				getJPanel6().add(getJPanel7(), "South");
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjJPanel6;
	}

	private javax.swing.JPanel getJPanel7() {
		if (ivjJPanel7 == null) {
			try {
				ivjJPanel7 = new javax.swing.JPanel();
				ivjJPanel7.setName("JPanel7");
				ivjJPanel7.setLayout(getJPanel7GridLayout());
				getJPanel7().add(getTypeLabel(), getTypeLabel().getName());
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjJPanel7;
	}

	private GridLayout getJPanel7GridLayout() {
		GridLayout ivjJPanel7GridLayout = null;
		try {
			/* Create part */
			ivjJPanel7GridLayout = new java.awt.GridLayout();
			ivjJPanel7GridLayout.setColumns(2);
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		};
		return ivjJPanel7GridLayout;
	}

	private javax.swing.JPanel getJPanel8() {
		if (ivjJPanel8 == null) {
			try {
				ivjJPanel8 = new javax.swing.JPanel();
				ivjJPanel8.setName("JPanel8");
				ivjJPanel8.setLayout(getJPanel8FlowLayout());
				getJPanel8().add(getJButton4(), getJButton4().getName());
				getJPanel8().add(getJButton3(), getJButton3().getName());
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjJPanel8;
	}

	private FlowLayout getJPanel8FlowLayout() {
		FlowLayout ivjJPanel8FlowLayout = null;
		try {
			/* Create part */
			ivjJPanel8FlowLayout = new java.awt.FlowLayout();
			ivjJPanel8FlowLayout.setAlignment(java.awt.FlowLayout.RIGHT);
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		};
		return ivjJPanel8FlowLayout;
	}

	private javax.swing.JLabel getLabelArgList() {
		if (ivjLabelArgList == null) {
			try {
				ivjLabelArgList = new javax.swing.JLabel();
				ivjLabelArgList.setName("LabelArgList");
				ivjLabelArgList.setText("selected argument");
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjLabelArgList;
	}

	private javax.swing.JLabel getLabelInputType() {
		if (ivjLabelInputType == null) {
			try {
				ivjLabelInputType = new javax.swing.JLabel();
				ivjLabelInputType.setName("LabelInputType");
				ivjLabelInputType.setText("type of argument");
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjLabelInputType;
	}

	private ISpecificType getOutputType() {
		return (ISpecificType) ((INamedObjectWrapper)getArgumenList().getModel().getElementAt(0)).getObject();
	}

	/**
	 * This makes a SpecificFunctionType derived from the given internal
	 * representation, that is ....
	 *
	 *     - boolean flag if this should be a function with unlimited args
	 *     - the listmodel
	 *
	 * Creation date: (05.09.2000 20:08:35)
	 * @return de.uniwue.ki.mas.model.basics.type.ISpecificType
	 */
	public ISpecificType getSpecificType() {
		//there is less stuff to avoid bugs, anyway, i hope that the internal representation is always
		//correct, then nothings happens

		//do we have a internal modell till now ?
		if ((getArgumenList() == null)
			|| (getArgumenList().getModel() == null)
			|| !(getArgumenList().getModel().getElementAt(0) instanceof INamedObjectWrapper)) {
			return null;
		}

		if (isUnlimitedArgumentFunction()) {
			return GenericFunctionType.getInstance().createSpecificFunctionType(
				getOutputType(),
				getInputType(0));
		}

		javax.swing.DefaultListModel listModel = (javax.swing.DefaultListModel)getArgumenList().getModel();
		java.util.Iterator wrappedObjectsIterator =
			CollectionsHelper.enumerationToIterator(listModel.elements());

		//now unwrap the wrapped Objects
		java.util.Iterator unwrappedObjectsIterator =
			CollectionsHelper.map(wrappedObjectsIterator, new IMapFunction() {
			public Object map(Object nix) {
				return ((INamedObjectWrapper)nix).getObject();
			}
		}
		//null
		);

		return GenericFunctionType.getInstance().createSpecificFunctionType(
			(ISpecificType)unwrappedObjectsIterator.next(),
			CollectionsHelper.asLinkedList(unwrappedObjectsIterator));
	}

	private SpecificTypeDefinePanel getSpecificTypeDefinePanel1() {
		if (ivjSpecificTypeDefinePanel1 == null) {
			try {
				ivjSpecificTypeDefinePanel1 = new de.uniwue.ki.gui.mas.basics.type.SpecificTypeDefinePanel();
				ivjSpecificTypeDefinePanel1.setName("SpecificTypeDefinePanel1");
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjSpecificTypeDefinePanel1;
	}

	private javax.swing.JLabel getTypeLabel() {
		if (ivjTypeLabel == null) {
			try {
				ivjTypeLabel = new javax.swing.JLabel();
				ivjTypeLabel.setName("TypeLabel");
				ivjTypeLabel.setText("undefined");
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjTypeLabel;
	}

	/**
	 * Method generated to support the promotion of the typeList attribute.
	 * @return java.util.List
	 */
	public java.util.List getTypeList() {
		return getSpecificTypeDefinePanel1().getTypeList();
	}

	/**
	 * Called whenever the bean information class throws an exception.
	 * @param exception Throwable
	 */
	private void handleException(Throwable exception) {
		exception.printStackTrace(System.out);
	}

	private void initConnections() {
		getCheckBoxUnlimitedArguments().addActionListener(ivjEventHandler);
		getJButton3().addActionListener(ivjEventHandler);
		getJButton4().addActionListener(ivjEventHandler);
		getSpecificTypeDefinePanel1().addPropertyChangeListener(ivjEventHandler);
		getArgumenList().addListSelectionListener(ivjEventHandler);
		this.addPropertyChangeListener(ivjEventHandler);
		connPtoP1SetTarget();
	}

	private void initialize() {
		try {
			setName("GenericFunctionTypeDefinePanel");
			setLayout(new java.awt.BorderLayout());
			setSize(459, 316);
			add(getJPanel1(), "North");
			add(getJPanel2(), "Center");
			initConnections();
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
		setBorder(javax.swing.BorderFactory.createTitledBorder("Function arguments"));
		//this defines the specific standard function
		setSpecificType(getDefaultSpecificFunctionType());
	}

	private boolean isUnlimitedArgumentFunction() {
		return fieldUnlimitedArguments;
	}

	public static void main(String[] args) {
		//old main
		try {
			javax.swing.JFrame frame = new javax.swing.JFrame();
			GenericFunctionTypeDefinePanel aGenericFunctionTypeDefinePanel;
			aGenericFunctionTypeDefinePanel = new GenericFunctionTypeDefinePanel();
			frame.setContentPane(aGenericFunctionTypeDefinePanel);
			frame.setSize(aGenericFunctionTypeDefinePanel.getSize());
			frame.addWindowListener(new WindowAdapter() {
				public void windowClosing(WindowEvent e) {
					System.exit(0);
				};
			});
			//try to set from extren
			aGenericFunctionTypeDefinePanel.setSpecificType(
				GenericFunctionType.getInstance().createSpecificFunctionType(
					BooleanType.getInstance(),
					CollectionsHelper.createList(DoubleType.getInstance(), ObjectType.getInstance())));
			frame.setVisible(true);
		} catch (Throwable exception) {
			System.err.println("Exception occurred in main() of javax.swing.JPanel");
			exception.printStackTrace(System.out);
		}
	}

	/**
	 * Updates the internal modell in the listbox AND the text of the label
	 */
	public void notifySpecificTypeChanged(ISpecificType arg1) {
		//do we have a selected wrapper to write into ?
		if (getArgumenList().getSelectedValue() != null) {
			//write it down and fire PropertyChange
			ISpecificType oldValue = getSpecificType();
			((INamedObjectWrapper)getArgumenList().getSelectedValue()).setObject(arg1);
			firePropertyChange("specificType", oldValue, getSpecificType());
		}
		getTypeLabel().setText(getSpecificTypeDefinePanel1().getSpecificType().getName());
	}

	/**
	 * Should it be possible to press the remove-button ?
	 * this is true if these things are true
	 *    - we have more than two explizit arguments
	 *    - we have limited args (follows from the above condition)
	 */
	public boolean removeButtonPossible() {
		return (getArgumenList().getModel().getSize() > 2);
	}

	/**
	 * here you can set any defined specificFunctionType to be displayed
	 * in this window
	 * Creation date: (05.09.2000 20:08:35)
	 * @param newDefinedFunctionType de.uniwue.ki.mas.model.basics.type.ISpecificType
	 */
	public void setSpecificType(ISpecificType newDefinedFunctionType) {
		//save old value
		ISpecificType oldValue = getSpecificType();

		//set the checkbox and the variable
		fieldUnlimitedArguments = (newDefinedFunctionType instanceof SpecificFunctionUnlimitedType);
		getCheckBoxUnlimitedArguments().getModel().setPressed(fieldUnlimitedArguments);

		//set the listbox
		getArgumenList().setModel(createLocalListBoxModel(newDefinedFunctionType));
		getArgumenList().setSelectedIndex(0); //default selection goes along with a update of the right panel

		//the property changed!!
		firePropertyChange("specificType", oldValue, newDefinedFunctionType);
	}

	public void setTypeList(java.util.List arg1) {
		getSpecificTypeDefinePanel1().setTypeList(arg1);
	}

	public ISpecificType typeDefinitionFromWrapper(INamedObjectWrapper wrapped) {
		if (wrapped == null)
			return null;
		else
			return (ISpecificType)wrapped.getObject();
	}

	public void typeDefinitionToWrapper(ActionEvent actionEvent) {
		return;
	}

	public void typeDefinitionToWrapper(
		ActionEvent actionEvent,
		INamedObjectWrapper wrapper,
		ISpecificType typeDefinition) {
		wrapper.setObject(typeDefinition);
		return;
	}
}