package de.uniwue.ki.gui.mas.basics.type;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.List;

import junit.framework.Assert;
import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.model.JPanelWithGUISeSAmDeclaration;
import de.uniwue.ki.mas.basics.type.*;
import de.uniwue.ki.util.Utils;

/**
 * Creation date: (29.04.2002 12:49:28)
 * @author: Christoph Oechslein
 */
public class GenericHashTableTypeDefinePanel
	extends JPanelWithGUISeSAmDeclaration
	implements IGenericTypeDefinePanel {
	private SpecificHashtableType _hashTableSpecificType;

	private final class IvjEventHandler implements PropertyChangeListener {
		public void propertyChange(PropertyChangeEvent evt) {
			if (((evt.getSource() == getKeySpecificTypeDefinePanel())
				|| (evt.getSource() == getValueSpecificTypeDefinePanel()))
				&& (evt.getPropertyName().equals("specificType")))
				eventKeyOrValueTypeChanged();
		}
	}
	private final IvjEventHandler ivjEventHandler = new IvjEventHandler();
	private javax.swing.JLabel ivjJLabel1 = null;
	private javax.swing.JLabel ivjJLabel11 = null;
	private SpecificTypeDefinePanel ivjKeySpecificTypeDefinePanel = null;
	private SpecificTypeDefinePanel ivjValueSpecificTypeDefinePanel = null;
	public GenericHashTableTypeDefinePanel() {
		super();
		initialize();
	}

	public static void main(String[] args) {
		javax.swing.JFrame frame = new javax.swing.JFrame();
		GenericHashTableTypeDefinePanel aGenericHashTableTypeDefinePanel;
		aGenericHashTableTypeDefinePanel = new GenericHashTableTypeDefinePanel();
		frame.setContentPane(aGenericHashTableTypeDefinePanel);
		frame.setSize(aGenericHashTableTypeDefinePanel.getSize());
		frame.addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent e) {
				System.exit(0);
			};
		});
		frame.show();
		java.awt.Insets insets = frame.getInsets();
		frame.setSize(
			frame.getWidth() + insets.left + insets.right,
			frame.getHeight() + insets.top + insets.bottom);
		frame.setVisible(true);
	}

	public SpecificHashtableType getHashTableSpecificType() {
		return _hashTableSpecificType;
	}

	public void setHashTableSpecificType(ISpecificType keyType, ISpecificType valueType) {
		Assert.assertNotNull(valueType);
		Assert.assertNotNull(keyType);
		setHashTableSpecificType(
			GenericHashtableType.getInstance().createSpecificHashtableType(keyType, valueType));
	}

	public void setHashTableSpecificType(SpecificHashtableType newHashTableSpecificType) {
		SpecificHashtableType oldSpecificHashtableType = getHashTableSpecificType();
		if (!Utils.equals(oldSpecificHashtableType, newHashTableSpecificType)) {
			_hashTableSpecificType = newHashTableSpecificType;
			if (!Utils
				.equals(
					newHashTableSpecificType.getKeyType(),
					getKeySpecificTypeDefinePanel().getSpecificType())) {
				getKeySpecificTypeDefinePanel().setSpecificType(newHashTableSpecificType.getKeyType());
			}

			if (!Utils
				.equals(
					newHashTableSpecificType.getValueType(),
					getValueSpecificTypeDefinePanel().getSpecificType())) {
				getValueSpecificTypeDefinePanel().setSpecificType(newHashTableSpecificType.getValueType());
			}
		}
	}

	public ISpecificType getSpecificType() {
		return getHashTableSpecificType();
	}

	public List getTypeList() {
		return getKeySpecificTypeDefinePanel().getTypeList();
	}

	public void setSpecificType(ISpecificType arg1) {
		if (arg1 == null)
			setHashTableSpecificType(
				GenericHashtableType.getInstance().createSpecificHashtableType(
					StringType.getInstance(),
					ObjectType.getInstance()));
		else
			setHashTableSpecificType((SpecificHashtableType) arg1);
	}

	public void setTypeList(List typeList) {
		getKeySpecificTypeDefinePanel().setTypeList(typeList);
		getValueSpecificTypeDefinePanel().setTypeList(typeList);
	}

	public void setGUISeSAmDeclaration(IGUISeSAmDeclaration guiSeSAmDeclaration) {
		super.setGUISeSAmDeclaration(guiSeSAmDeclaration);

		getKeySpecificTypeDefinePanel().setGUISeSAmDeclaration(guiSeSAmDeclaration);
		getValueSpecificTypeDefinePanel().setGUISeSAmDeclaration(guiSeSAmDeclaration);
	}

	private javax.swing.JLabel getJLabel1() {
		if (ivjJLabel1 == null) {
			ivjJLabel1 = new javax.swing.JLabel();
			ivjJLabel1.setName("JLabel1");
			ivjJLabel1.setText("Key Type: ");
		}
		return ivjJLabel1;
	} 


	private javax.swing.JLabel getJLabel11() {
		if (ivjJLabel11 == null) {
			ivjJLabel11 = new javax.swing.JLabel();
			ivjJLabel11.setName("JLabel11");
			ivjJLabel11.setText("Value Type: ");
		}
		return ivjJLabel11;
	} 

	private SpecificTypeDefinePanel getKeySpecificTypeDefinePanel() {
		if (ivjKeySpecificTypeDefinePanel == null) {
			ivjKeySpecificTypeDefinePanel = new SpecificTypeDefinePanel();
			ivjKeySpecificTypeDefinePanel.setName("KeySpecificTypeDefinePanel");
			ivjKeySpecificTypeDefinePanel.setSpecificType(StringType.getInstance());
		}
		return ivjKeySpecificTypeDefinePanel;
	}

	private SpecificTypeDefinePanel getValueSpecificTypeDefinePanel() {
		if (ivjValueSpecificTypeDefinePanel == null) {
			ivjValueSpecificTypeDefinePanel = new SpecificTypeDefinePanel();
			ivjValueSpecificTypeDefinePanel.setName("ValueSpecificTypeDefinePanel");
			ivjValueSpecificTypeDefinePanel.setSpecificType(ObjectType.getInstance());
		}
		return ivjValueSpecificTypeDefinePanel;
	}

	protected void eventKeyOrValueTypeChanged() {
		if ((getHashTableSpecificType() == null)
			|| (!Utils
				.equals(
					getHashTableSpecificType().getKeyType(),
					getKeySpecificTypeDefinePanel().getSpecificType()))
			|| (!Utils
				.equals(
					getHashTableSpecificType().getValueType(),
					getValueSpecificTypeDefinePanel().getSpecificType()))) {

			setHashTableSpecificType(
				getKeySpecificTypeDefinePanel().getSpecificType(),
				getValueSpecificTypeDefinePanel().getSpecificType());
		}
	}

	private void initConnections() {
		getKeySpecificTypeDefinePanel().addPropertyChangeListener(ivjEventHandler);
		getValueSpecificTypeDefinePanel().addPropertyChangeListener(ivjEventHandler);
	}

	private void initialize() {
		setName("GenericHashTableTypeDefinePanel");
		setLayout(new java.awt.GridBagLayout());
		setSize(390, 140);
		java.awt.GridBagConstraints constraintsJLabel1 = new java.awt.GridBagConstraints();
		constraintsJLabel1.gridx = 0;
		constraintsJLabel1.gridy = 0;
		constraintsJLabel1.anchor = java.awt.GridBagConstraints.WEST;
		constraintsJLabel1.insets = new java.awt.Insets(0, 0, 4, 0);
		add(getJLabel1(), constraintsJLabel1);
		java.awt.GridBagConstraints constraintsKeySpecificTypeDefinePanel = new java.awt.GridBagConstraints();
		constraintsKeySpecificTypeDefinePanel.gridx = 1;
		constraintsKeySpecificTypeDefinePanel.gridy = 0;
		constraintsKeySpecificTypeDefinePanel.fill = java.awt.GridBagConstraints.HORIZONTAL;
		constraintsKeySpecificTypeDefinePanel.weightx = 1.0;
		constraintsKeySpecificTypeDefinePanel.insets = new java.awt.Insets(0, 0, 4, 0);
		add(getKeySpecificTypeDefinePanel(), constraintsKeySpecificTypeDefinePanel);
		java.awt.GridBagConstraints constraintsJLabel11 = new java.awt.GridBagConstraints();
		constraintsJLabel11.gridx = 0;
		constraintsJLabel11.gridy = 1;
		constraintsJLabel11.anchor = java.awt.GridBagConstraints.WEST;
		add(getJLabel11(), constraintsJLabel11);
		java.awt.GridBagConstraints constraintsValueSpecificTypeDefinePanel =
			new java.awt.GridBagConstraints();
		constraintsValueSpecificTypeDefinePanel.gridx = 1;
		constraintsValueSpecificTypeDefinePanel.gridy = 1;
		constraintsValueSpecificTypeDefinePanel.fill = java.awt.GridBagConstraints.HORIZONTAL;
		constraintsValueSpecificTypeDefinePanel.weightx = 1.0;
		add(getValueSpecificTypeDefinePanel(), constraintsValueSpecificTypeDefinePanel);
		initConnections();
	}
}