package de.uniwue.ki.gui.mas.basics.type;

import java.awt.BorderLayout;
import java.util.*;

import de.uniwue.ki.gui.mas.model.JPanelWithGUISeSAmDeclaration;

import de.uniwue.ki.mas.basics.type.ISpecificType;
import de.uniwue.ki.mas.basics.type.TypeManager;
import de.uniwue.ki.mas.basics.type.composed.GenericComposedType;
import de.uniwue.ki.util.collection.CollectionsHelper;
import de.uniwue.ki.util.comparator.NamedComparator;

import de.uniwue.ki.util.list.MuteableFilerableListModel;


/**
 * Creation date: (30.05.00 14:01:01)
 * @author Christoph Oechslein
 */
public class GenericUserTypeDefinePanel
	extends JPanelWithGUISeSAmDeclaration
	implements IGenericTypeDefinePanel {

	private List _typeList;
	private JListWithFastTypeField _flist;
	
	public GenericUserTypeDefinePanel() {
		super();
		initialize();
	}

	public ISpecificType getSpecificType() {
		return (ISpecificType) _flist.getSelectedValue();
	}

	private ArrayList getListDataArrayList(ISpecificType specificType) {
		if (getGUISeSAmDeclaration() == null) {
			return new ArrayList();
		} else {

			boolean composed = specificType.getGenericType() == GenericComposedType.getInstance();

			Iterator specificTypes =
				(composed)
					? TypeManager.getInstance().getAllComposedTypes(getGUISeSAmDeclaration().getSeSAmDeclaration())
					: TypeManager.getInstance().getAllEnumTypes(getGUISeSAmDeclaration().getSeSAmDeclaration());
			return CollectionsHelper.asSortedArrayList(specificTypes, NamedComparator.getInstance());
		}
	}

	public String getTitle() {
		return "Choice User Type";
	}

	private void initialize() {
		setName("GenericUserTypeDefinePanel");
		setSize(294, 214);
		setLayout(new BorderLayout());

		add(getFastTypeList());
	}
	
	private JListWithFastTypeField getFastTypeList(){
	    if (_flist == null) {
            _flist = new JListWithFastTypeField();
	    }
       
        return _flist;
	}

	public void setSpecificType(ISpecificType newValue) {
		setListDataAndSelectedItem(newValue);
	}

	protected void setListDataAndSelectedItem(ISpecificType specificType) {
	    ((MuteableFilerableListModel)_flist.getModel()).clear();
		((MuteableFilerableListModel)_flist.getModel()).addAll(getListDataArrayList(specificType));

	    if (_flist.getModel().getSize() > 0) 
	        _flist.setSelectedValue(specificType);

	}
	
	public List getTypeList() {
		return _typeList;
	}

	public void setTypeList(List typeList) {
		_typeList = typeList;
	}
}