package de.uniwue.ki.gui.mas.basics.type;
import de.uniwue.ki.gui.mas.model.JPanelWithGUISeSAmDeclaration;
import de.uniwue.ki.mas.basics.type.*;

/**
 * Creation date: (08.09.2000 10:27:12)
 * @author Rainer Herrler
 */
public class GenericVariableDefinePanel
	extends JPanelWithGUISeSAmDeclaration
	implements IGenericTypeDefinePanel {
	private ISpecificType ivjanSpecificType = null;
	private final IvjEventHandler ivjEventHandler = new IvjEventHandler();
	private SpecificTypeDefinePanel ivjSpecificTypeDefinePanel = null;
	private javax.swing.JPanel ivjJPanel1 = null;
	private boolean ivjConnPtoP1Aligning = false;

	private final class IvjEventHandler
		implements java.awt.event.ActionListener, java.beans.PropertyChangeListener {
		public void actionPerformed(java.awt.event.ActionEvent e) {
			if (e.getSource() == GenericVariableDefinePanel.this.getJCheckBoxWriteable())
				connEtoC1(e);
			if (e.getSource() == GenericVariableDefinePanel.this.getJCheckBoxExternal())
				connEtoC2(e);
		}
		public void propertyChange(java.beans.PropertyChangeEvent evt) {
			if (evt.getSource() == GenericVariableDefinePanel.this
				&& (evt.getPropertyName().equals("gUISeSAmDeclaration")))
				connPtoP1SetTarget();
			if (evt.getSource() == GenericVariableDefinePanel.this.getSpecificTypeDefinePanel()
				&& (evt.getPropertyName().equals("gUISeSAmDeclaration")))
				connPtoP1SetSource();
			if (evt.getSource() == GenericVariableDefinePanel.this.getSpecificTypeDefinePanel()
				&& (evt.getPropertyName().equals("specificType")))
				connEtoC3(evt);
		}
	}
	private javax.swing.JCheckBox ivjJCheckBoxExternal = null;
	private javax.swing.JCheckBox ivjJCheckBoxWriteable = null;

	/**
	 * GenericVariableDefinePanel constructor comment.
	 */
	public GenericVariableDefinePanel() {
		super();
		initialize();
	}

	/**
	 * connEtoC1:  (JCheckBox1.action.actionPerformed(java.awt.event.ActionEvent) --> GenericVariableDefinePanel.eventUserSettingsChanged()V)
	 * @param arg1 java.awt.event.ActionEvent
	 */
	private void connEtoC1(java.awt.event.ActionEvent arg1) {
		try {
					this.eventUserSettingsChanged();
				} catch (Throwable ivjExc) {
					handleException(ivjExc);
		}
	}

	/**
	 * connEtoC2:  (JCheckBox2.action.actionPerformed(java.awt.event.ActionEvent) --> GenericVariableDefinePanel.eventUserSettingsChanged()V)
	 * @param arg1 java.awt.event.ActionEvent
	 */
	private void connEtoC2(java.awt.event.ActionEvent arg1) {
		try {
					this.eventUserSettingsChanged();
				} catch (Throwable ivjExc) {
					handleException(ivjExc);
		}
	}

	/**
	 * connEtoC3:  (SpecificTypeDefinePanel.specificType --> GenericVariableDefinePanel.eventUserSettingsChanged()V)
	 * @param arg1 java.beans.PropertyChangeEvent
	 */
	private void connEtoC3(java.beans.PropertyChangeEvent arg1) {
		try {
					this.eventUserSettingsChanged();
				} catch (Throwable ivjExc) {
					handleException(ivjExc);
		}
	}

	/**
	 * connPtoP1SetSource:  (GenericVariableDefinePanel.gUISeSAmDeclaration <--> SpecificTypeDefinePanel.gUISeSAmDeclaration)
	 */
	private void connPtoP1SetSource() {
		try {
			if (ivjConnPtoP1Aligning == false) {
								ivjConnPtoP1Aligning = true;
				this.setGUISeSAmDeclaration(getSpecificTypeDefinePanel().getGUISeSAmDeclaration());
								ivjConnPtoP1Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP1Aligning = false;
					handleException(ivjExc);
		}
	}

	/**
	 * connPtoP1SetTarget:  (GenericVariableDefinePanel.gUISeSAmDeclaration <--> SpecificTypeDefinePanel.gUISeSAmDeclaration)
	 */
	private void connPtoP1SetTarget() {
		try {
			if (ivjConnPtoP1Aligning == false) {
								ivjConnPtoP1Aligning = true;
				getSpecificTypeDefinePanel().setGUISeSAmDeclaration(this.getGUISeSAmDeclaration());
								ivjConnPtoP1Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP1Aligning = false;
					handleException(ivjExc);
		}
	}

	protected void eventUserSettingsChanged() {
		setSpecificType(getSpecificVariableType());
	}

	/**
	 * Return the anSpecificType property value.
	 * @return de.uniwue.ki.mas.model.basics.type.ISpecificType
	 */
	private ISpecificType getanSpecificType() {
		return ivjanSpecificType;
	}

	/**
	 * Return the JCheckBox2 property value.
	 * @return javax.swing.JCheckBox
	 */
	private javax.swing.JCheckBox getJCheckBoxExternal() {
		if (ivjJCheckBoxExternal == null) {
			try {
				ivjJCheckBoxExternal = new javax.swing.JCheckBox();
				ivjJCheckBoxExternal.setName("JCheckBoxExternal");
				ivjJCheckBoxExternal.setText("external");
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjJCheckBoxExternal;
	}

	/**
	 * Return the JCheckBox1 property value.
	 * @return javax.swing.JCheckBox
	 */
	private javax.swing.JCheckBox getJCheckBoxWriteable() {
		if (ivjJCheckBoxWriteable == null) {
			try {
				ivjJCheckBoxWriteable = new javax.swing.JCheckBox();
				ivjJCheckBoxWriteable.setName("JCheckBoxWriteable");
				ivjJCheckBoxWriteable.setText("writeable");
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjJCheckBoxWriteable;
	}

	/**
	 * Return the JPanel1 property value.
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanel1() {
		if (ivjJPanel1 == null) {
			try {
				ivjJPanel1 = new javax.swing.JPanel();
				ivjJPanel1.setName("JPanel1");
				ivjJPanel1.setLayout(getJPanel1BoxLayout());
				getJPanel1().add(getJCheckBoxExternal(), getJCheckBoxExternal().getName());
				getJPanel1().add(getJCheckBoxWriteable(), getJCheckBoxWriteable().getName());
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjJPanel1;
	}

	/**
	 * Return the JPanel1BoxLayout property value.
	 * @return javax.swing.BoxLayout
	 */
	private javax.swing.BoxLayout getJPanel1BoxLayout() {
		javax.swing.BoxLayout ivjJPanel1BoxLayout = null;
		try {
			/* Create part */
			ivjJPanel1BoxLayout = new javax.swing.BoxLayout(getJPanel1(), javax.swing.BoxLayout.X_AXIS);
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
		return ivjJPanel1BoxLayout;
	}

	/**
	 * Method generated to support the promotion of the specificType attribute.
	 * @return de.uniwue.ki.mas.model.basics.type.ISpecificType
	 */
	public ISpecificType getSpecificType() {
		return getanSpecificType();
	}

	/**
	 * Return the SpecificTypeDefinePanel property value.
	 * @return basics.type.SpecificTypeDefinePanel
	 */
	private SpecificTypeDefinePanel getSpecificTypeDefinePanel() {
		if (ivjSpecificTypeDefinePanel == null) {
			try {
				ivjSpecificTypeDefinePanel = new de.uniwue.ki.gui.mas.basics.type.SpecificTypeDefinePanel();
				ivjSpecificTypeDefinePanel.setName("SpecificTypeDefinePanel");
				ivjSpecificTypeDefinePanel.setBorder(
					javax.swing.BorderFactory.createTitledBorder("VariableDeclaration argument"));
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjSpecificTypeDefinePanel;
	}

	protected ISpecificType getSpecificVariableType() {

		ISpecificType type = getSpecificTypeDefinePanel().getSpecificType();
		boolean external = getJCheckBoxExternal().isSelected();
		boolean writeable = getJCheckBoxWriteable().isSelected();

		return GenericVariableClassDeclarationType.getInstance(
			external,
			writeable).createSpecificVariableType(
			type);
	}

	/**
	 * Method generated to support the promotion of the typeList attribute.
	 * @return java.util.List
	 */
	public java.util.List getTypeList() {
		return getSpecificTypeDefinePanel().getTypeList();
	}

	/**
	 * Called whenever the bean information class throws an exception.
	 * @param exception Throwable
	 */
	private void handleException(Throwable exception) {

		exception.printStackTrace(System.out);
	}

	/**
	 * Initializes connections
	 * @exception Exception The exception description.
	 */
	private void initConnections() {
		this.addPropertyChangeListener(ivjEventHandler);
		getSpecificTypeDefinePanel().addPropertyChangeListener(ivjEventHandler);
		getJCheckBoxWriteable().addActionListener(ivjEventHandler);
		getJCheckBoxExternal().addActionListener(ivjEventHandler);
		connPtoP1SetTarget();
	}

	/**
	 * Initialize the class.
	 */
	private void initialize() {
		try {
					setName("GenericVariableDefinePanel");
			setAlignmentX(java.awt.Component.CENTER_ALIGNMENT);
			setAlignmentY(java.awt.Component.CENTER_ALIGNMENT);
			setLayout(new java.awt.BorderLayout());
			setSize(242, 128);
			setMaximumSize(new java.awt.Dimension(147483647, 2147483647));
			add(getSpecificTypeDefinePanel(), "Center");
			add(getJPanel1(), "North");
			initConnections();
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	public static void main(String[] args) {
		try {
			javax.swing.JFrame frame = new javax.swing.JFrame();
			GenericVariableDefinePanel aGenericVariableDefinePanel;
			aGenericVariableDefinePanel = new GenericVariableDefinePanel();
			frame.setContentPane(aGenericVariableDefinePanel);
			frame.setSize(aGenericVariableDefinePanel.getSize());
			frame.addWindowListener(new java.awt.event.WindowAdapter() {
				public void windowClosing(java.awt.event.WindowEvent e) {
					System.exit(0);
				};
			});
			frame.setVisible(true);
		} catch (Throwable exception) {
			System.err.println("Exception occurred in main() of javax.swing.JPanel");
			exception.printStackTrace(System.out);
		}
	}

	/**
	 * Set the anSpecificType to a new value.
	 * @param newValue de.uniwue.ki.mas.model.basics.type.ISpecificType
	 */
	private void setanSpecificType(ISpecificType newValue) {
		if (ivjanSpecificType != newValue) {
			try {
				ISpecificType oldValue = getanSpecificType();
				ivjanSpecificType = newValue;
				firePropertyChange("specificType", oldValue, newValue);
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
	}

	/**
	 * Method generated to support the promotion of the specificType attribute.
	 * @param arg1 de.uniwue.ki.mas.model.basics.type.ISpecificType
	 */
	public void setSpecificType(ISpecificType newType) {
		if (!de.uniwue.ki.util.Utils.equals(newType, getSpecificType())) {
			setanSpecificType(newType);

			SpecificVariableClassDeclarationType specificVariableClassDeclarationType =
				(SpecificVariableClassDeclarationType)newType;

			getSpecificTypeDefinePanel().setSpecificType(
				specificVariableClassDeclarationType.getVariableClassDeclarationType());

			getJCheckBoxExternal().setSelected(specificVariableClassDeclarationType.isExternal());
			getJCheckBoxWriteable().setSelected(specificVariableClassDeclarationType.isWriteable());

			junit.framework.Assert.assertEquals(
				getSpecificTypeDefinePanel().getSpecificType(),
				specificVariableClassDeclarationType.getVariableClassDeclarationType());
		}
	}

	/**
	 * Method generated to support the promotion of the typeList attribute.
	 * @param arg1 java.util.List
	 */
	public void setTypeList(java.util.List arg1) {
		getSpecificTypeDefinePanel().setTypeList(arg1);
	}
}