package de.uniwue.ki.gui.mas.basics.type.argument;
import de.uniwue.ki.gui.mas.basics.type.AbstractTreeTypeEditor;
import de.uniwue.ki.mas.basics.type.argument.ArgumentDeclarationFactory;
import de.uniwue.ki.mas.basics.type.argument.IArgumentDeclaration;

/**
 * Creation date: (30.05.00 14:01:01)
 * @author Christoph Oechslein
 */
public abstract class AbstractTreeArgumentDeclarationEditor
	extends AbstractTreeTypeEditor
	implements IArgumentDeclarationEditor {

	private IArgumentDeclaration _argumentDeclaration;

	public AbstractTreeArgumentDeclarationEditor() {
		super();
	}

	public IArgumentDeclaration getArgumentDeclaration() {
		if (getSelectedTreeNode() == null) {
			return getArgumentDeclarationIntern();

		} else if (getArgumentDeclarationIntern() == null) {
			return null;

		} else {
			return ArgumentDeclarationFactory.getInstance().createArgumentDeclaration(
				getArgumentDeclarationIntern().getSpecificType(),
				getSelectedTreeNode().getUserObject());
		}
	}

	public void setArgumentDeclarationEditorParameter(IArgumentDeclarationEditorParameter argumentDeclarationEditorParameter) {
		setGUISeSAmDeclaration(argumentDeclarationEditorParameter.getGUISeSAmDeclaration());
		setArgumentDeclaration(
			argumentDeclarationEditorParameter.getArgumentDeclaration());
	}

	protected IArgumentDeclaration getArgumentDeclarationIntern() {
		return _argumentDeclaration;
	}

	protected final void setArgumentDeclaration(IArgumentDeclaration newArgumentDeclaration) {
		_argumentDeclaration = newArgumentDeclaration;

		createAndSetTreeModel();

		if (newArgumentDeclaration.getObject() != null) {
			setSelectedTreeNodeTo(newArgumentDeclaration.getObject());
		}

		revalidate();
	}

	public boolean inModalPanel() {
		return true;
	}

}