package de.uniwue.ki.gui.mas.basics.type.argument;
import javax.swing.ListCellRenderer;

import de.uniwue.ki.gui.util.NamedCellRendererAdapter;
import de.uniwue.ki.mas.basics.functionArgument.IFunctionArgumentDeclaration;
import de.uniwue.ki.mas.basics.functionArgument.SpecificFunctionDeclarationWithArgDeclBinds;
import de.uniwue.ki.mas.basics.functionUser.IUserFunctionDeclaration;
import de.uniwue.ki.mas.basics.type.ISpecificFunctionType;
import de.uniwue.ki.mas.basics.type.argument.IArgumentDeclaration;
import de.uniwue.ki.util.name.INamed;
/**
 * Creation date: (25.06.2001 20:13:14)
 * @author Christoph Oechslein
 */
public class ArgumentDeclarationListOnlyTypeNameCellRendererAdapter extends NamedCellRendererAdapter {

	public ArgumentDeclarationListOnlyTypeNameCellRendererAdapter(ListCellRenderer cellRenderer) {
		super(cellRenderer);
	}

	protected String getName(INamed value) {
		if (!(value instanceof IArgumentDeclaration)) {
			return super.getName(value);

		} else if (value instanceof IFunctionArgumentDeclaration) {
			return ((IFunctionArgumentDeclaration) value).getName() + " (Input Argument)";

		} else {
			IArgumentDeclaration argDecl = (IArgumentDeclaration) value;

			if (argDecl.getSpecificType() instanceof ISpecificFunctionType) {
				if (!(argDecl instanceof IFunctionArgumentDeclaration)
					&& (argDecl.getObject() instanceof IUserFunctionDeclaration)) {
					return argDecl.getName();

				} else if (
					!(argDecl instanceof IFunctionArgumentDeclaration)
						&& (argDecl.getObject() instanceof SpecificFunctionDeclarationWithArgDeclBinds)) {
					return argDecl.getSpecificType().getName();

				} else {
					return super.getName(argDecl);
				}

			} else {
				return argDecl.getSpecificType().getName();
			}
		}
	}
}