package de.uniwue.ki.gui.mas.basics.type.argument;
import javax.swing.JFrame;

import de.uniwue.ki.mas.basics.type.BooleanType;
import de.uniwue.ki.mas.basics.type.argument.ArgumentDeclarationFactory;
import de.uniwue.ki.mas.basics.type.argument.IArgumentDeclaration;
/**
 * Creation date: (30.05.00 14:01:01)
 * @author Christoph Oechslein
 */
public class BooleanArgumentDeclarationEditor extends AbstractArgumentDeclarationEditor implements IArgumentDeclarationEditor {

	private final class IvjEventHandler implements com.ibm.easyswing.event.AdditionalItemStateChangedListener {
		public void changedToSelected(com.ibm.easyswing.event.AdditionalItemStateChangedEvent arg1) {
			if (arg1.getSource() == BooleanArgumentDeclarationEditor.this.getValue())
				connEtoM2(arg1);
		}
		public void changedToUnselected(com.ibm.easyswing.event.AdditionalItemStateChangedEvent arg1) {
			if (arg1.getSource() == BooleanArgumentDeclarationEditor.this.getValue())
				connEtoM3(arg1);
		}
	}
	private com.ibm.easyswing.BoundJCheckBox ivjValue = null;
	private final IvjEventHandler ivjEventHandler = new IvjEventHandler();
	private IArgumentDeclaration ivjArgumentDeclarationIntern = null;

/**
 * ArgumentEditor constructor comment.
 */
public BooleanArgumentDeclarationEditor() {
    super();
    initialize();
}


/**
 * connEtoM1:  (BooleanArgumentDeclarationEditor.initialize() --> ArgumentDeclaration.this)
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoM1() {
    try {
        // user code begin {1}
        // user code end
        setArgumentDeclarationIntern(
            ArgumentDeclarationFactory.getInstance().createArgumentDeclaration(BooleanType.getInstance()));
        // user code begin {2}
        // user code end
    } catch (Throwable ivjExc) {
        // user code begin {3}
        // user code end
        handleException(ivjExc);
    }
}


/**
 * connEtoM2:  (Value.additionalItemStateChanged.changedToSelected(com.ibm.easyswing.event.AdditionalItemStateChangedEvent) --> ArgumentDeclaration.setObject(LObject;)V)
 * @param arg1 com.ibm.easyswing.event.AdditionalItemStateChangedEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoM2(com.ibm.easyswing.event.AdditionalItemStateChangedEvent arg1) {
    try {
        // user code begin {1}
        // user code end
        getArgumentDeclarationIntern().setObject(Boolean.TRUE);
        // user code begin {2}
        // user code end
    } catch (Throwable ivjExc) {
        // user code begin {3}
        // user code end
        handleException(ivjExc);
    }
}


/**
 * connEtoM3:  (Value.additionalItemStateChanged.changedToUnselected(com.ibm.easyswing.event.AdditionalItemStateChangedEvent) --> ArgumentDeclaration.setObject(LObject;)V)
 * @param arg1 com.ibm.easyswing.event.AdditionalItemStateChangedEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoM3(com.ibm.easyswing.event.AdditionalItemStateChangedEvent arg1) {
    try {
        // user code begin {1}
        // user code end
        getArgumentDeclarationIntern().setObject(Boolean.FALSE);
        // user code begin {2}
        // user code end
    } catch (Throwable ivjExc) {
        // user code begin {3}
        // user code end
        handleException(ivjExc);
    }
}


/**
 * connEtoM4:  (ArgumentDeclaration.this --> Value.selected)
 * @param value de.uniwue.ki.mas.model.basics.type.IArgumentDeclaration
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoM4(de.uniwue.ki.mas.basics.type.argument.IArgumentDeclaration value) {
    try {
        // user code begin {1}
        // user code end
        getValue().setSelected(this.getBooleanValue());
        // user code begin {2}
        // user code end
    } catch (Throwable ivjExc) {
        // user code begin {3}
        // user code end
        handleException(ivjExc);
    }
}


public de.uniwue.ki.mas.basics.type.argument.IArgumentDeclaration getArgumentDeclaration() {
    return getArgumentDeclarationIntern();
}


/**
 * Return the ArgumentDeclarationIntern property value.
 * @return de.uniwue.ki.mas.model.basics.type.IArgumentDeclaration
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private de.uniwue.ki.mas.basics.type.argument.IArgumentDeclaration getArgumentDeclarationIntern() {
    // user code begin {1}
    // user code end
    return ivjArgumentDeclarationIntern;
}


/**
 * Return the ArgumentEditorBorderLayout property value.
 * @return java.awt.BorderLayout
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private java.awt.BorderLayout getArgumentEditorBorderLayout() {
    java.awt.BorderLayout ivjArgumentEditorBorderLayout = null;
    try {
        /* Create part */
        ivjArgumentEditorBorderLayout = new java.awt.BorderLayout();
        ivjArgumentEditorBorderLayout.setVgap(5);
        ivjArgumentEditorBorderLayout.setHgap(5);
    } catch (Throwable ivjExc) {
        handleException(ivjExc);
    };
    return ivjArgumentEditorBorderLayout;
}


/**
 * Comment
 */
protected boolean getBooleanValue() {
    return ((Boolean) getArgumentDeclaration().getObject()).booleanValue();
}




public String getTitle() {
   return "Choice Boolean Value";
}


/**
 * Return the Value property value.
 * @return com.ibm.easyswing.BoundJCheckBox
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private com.ibm.easyswing.BoundJCheckBox getValue() {
    if (ivjValue == null) {
        try {
            ivjValue = new com.ibm.easyswing.BoundJCheckBox();
            ivjValue.setName("Value");
            ivjValue.setText("Value");
            // user code begin {1}
            // user code end
        } catch (Throwable ivjExc) {
            // user code begin {2}
            // user code end
            handleException(ivjExc);
        }
    }
    return ivjValue;
}


/**
 * Called whenever the part throws an exception.
 * @param exception Throwable
 */
private void handleException(Throwable exception) {

    /* Uncomment the following lines to print uncaught exceptions to stdout */
    System.out.println("--------- UNCAUGHT EXCEPTION ---------");
    exception.printStackTrace(System.out);
}


/**
 * Initializes connections
 * @exception Exception The exception description.
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void initConnections() {
    // user code begin {1}
    // user code end
    getValue().addAdditionalItemStateChangedListener(ivjEventHandler);
}


/**
 * Initialize the class.
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void initialize() {
    try {
        // user code begin {1}
        // user code end
        setName("ArgumentEditor");
        setLayout(getArgumentEditorBorderLayout());
        setSize(314, 17);
        add(getValue(), "West");
        initConnections();
        connEtoM1();
    } catch (Throwable ivjExc) {
        handleException(ivjExc);
    }
    // user code begin {2}
    // user code end
}


/**
 * main entrypoint - starts the part when it is run as an application
 * @param args String[]
 */
public static void main(String[] args) {
    try {
        JFrame frame = new javax.swing.JFrame();
        BooleanArgumentDeclarationEditor aArgumentBooleanEditor;
        aArgumentBooleanEditor = new BooleanArgumentDeclarationEditor();
        frame.setContentPane(aArgumentBooleanEditor);
        frame.setSize(aArgumentBooleanEditor.getSize());
        frame.addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent e) {
                System.exit(0);
            }
        });
        frame.setVisible(true);
    } catch (Throwable exception) {
        System.err.println("Exception occurred in main() of javax.swing.JPanel");
        exception.printStackTrace(System.out);
    }
}


protected void setArgumentDeclaration(de.uniwue.ki.mas.basics.type.argument.IArgumentDeclaration newValue) {
   setArgumentDeclarationIntern(newValue);
}


/**
 * Set the ArgumentDeclarationIntern to a new value.
 * @param newValue de.uniwue.ki.mas.model.basics.type.IArgumentDeclaration
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void setArgumentDeclarationIntern(de.uniwue.ki.mas.basics.type.argument.IArgumentDeclaration newValue) {
    if (ivjArgumentDeclarationIntern != newValue) {
        try {
            de.uniwue.ki.mas.basics.type.argument.IArgumentDeclaration oldValue = getArgumentDeclarationIntern();
            ivjArgumentDeclarationIntern = newValue;
            connEtoM4(ivjArgumentDeclarationIntern);
            firePropertyChange("argumentDeclaration", oldValue, newValue);
            // user code begin {1}
            // user code end
        } catch (Throwable ivjExc) {
            // user code begin {2}
            // user code end
            handleException(ivjExc);
        }
    }
    // user code begin {3}
    // user code end
}
}