package de.uniwue.ki.gui.mas.basics.type.argument;
import java.awt.BorderLayout;

import javax.swing.JLabel;

import de.uniwue.ki.gui.util.bound.BoundJDoubleTextField;
import de.uniwue.ki.mas.basics.type.DoubleType;
import de.uniwue.ki.mas.basics.type.argument.ArgumentDeclarationFactory;
import de.uniwue.ki.mas.basics.type.argument.IArgumentDeclaration;

/**
 * Creation date: (30.05.00 14:01:01)
 * @author: Christoph Oechslein
 */
public class DoubleArgumentDeclarationEditor
		extends
			AbstractArgumentDeclarationEditor
		implements
			IArgumentDeclarationEditor {

	private JLabel ivjJLabel1 = null;
	private final IvjEventHandler ivjEventHandler = new IvjEventHandler();
	private IArgumentDeclaration ivjArgumentDeclarationIntern = null;

	private final class IvjEventHandler
			implements
				java.beans.PropertyChangeListener {
		public void propertyChange(java.beans.PropertyChangeEvent evt) {
			if (evt.getSource() == DoubleArgumentDeclarationEditor.this
					.getJDoubleTextField()
					&& (evt.getPropertyName().equals("double")))
				connPtoP1SetSource();
		}
	}

	private boolean ivjConnPtoP1Aligning = false;
	private BoundJDoubleTextField ivjJDoubleTextField = null;

	public DoubleArgumentDeclarationEditor() {
		super();
		initialize();
	}

	public IArgumentDeclaration getArgumentDeclaration() {
		return getArgumentDeclarationIntern();
	}

	protected void setArgumentDeclaration(
			IArgumentDeclaration argumentDeclaration) {
		setArgumentDeclarationIntern(argumentDeclaration);
	}

	/**
	 * Return the ArgumentDeclarationIntern property value.
	 * 
	 * @return de.uniwue.ki.mas.model.basics.type.argument.IArgumentDeclaration
	 */
	private IArgumentDeclaration getArgumentDeclarationIntern() {
		return ivjArgumentDeclarationIntern;
	}

	/**
	 * Set the ArgumentDeclarationIntern to a new value.
	 * 
	 * @param newValue
	 *                de.uniwue.ki.mas.model.basics.type.argument.IArgumentDeclaration
	 */
	private void setArgumentDeclarationIntern(IArgumentDeclaration newValue) {
		if (ivjArgumentDeclarationIntern != newValue) {
			try {
				IArgumentDeclaration oldValue = getArgumentDeclarationIntern();
				ivjArgumentDeclarationIntern = newValue;
				connPtoP1SetTarget();
				selectAll();
				firePropertyChange("argumentDeclaration", oldValue, newValue);
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		};
	}

	/**
	 * Return the ArgumentEditorBorderLayout property value.
	 * 
	 * @return java.awt.BorderLayout
	 */
	private BorderLayout getArgumentEditorBorderLayout() {
		BorderLayout ivjArgumentEditorBorderLayout = null;
		try {
			/* Create part */
			ivjArgumentEditorBorderLayout = new BorderLayout();
			ivjArgumentEditorBorderLayout.setVgap(5);
			ivjArgumentEditorBorderLayout.setHgap(5);
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
		return ivjArgumentEditorBorderLayout;
	}

	/**
	 * Return the JDoubleTextField property value.
	 * 
	 * @return BoundJDoubleTextField
	 */
	private BoundJDoubleTextField getJDoubleTextField() {
		if (ivjJDoubleTextField == null) {
			try {
				ivjJDoubleTextField = new BoundJDoubleTextField();
				ivjJDoubleTextField.setName("JDoubleTextField");

				// removed setDocument!!

			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjJDoubleTextField;
	}

	private JLabel getJLabel1() {
		if (ivjJLabel1 == null) {
			try {
				ivjJLabel1 = new JLabel();
				ivjJLabel1.setName("ValueLabel");
				ivjJLabel1.setText("Value:");
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjJLabel1;
	}

	private void connEtoM1() {
		try {
			setArgumentDeclarationIntern(ArgumentDeclarationFactory
					.getInstance().createArgumentDeclaration(
							DoubleType.getInstance()));
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	/**
	 * connPtoP1SetSource: (ArgumentDeclarationIntern.object <-->
	 * JNumberTextField.double)
	 */
	private void connPtoP1SetSource() {
		try {
			if (ivjConnPtoP1Aligning == false) {
				ivjConnPtoP1Aligning = true;
				if ((getArgumentDeclarationIntern() != null)) {
					getArgumentDeclarationIntern().setObject(
							getJDoubleTextField().getDouble());
				}
				ivjConnPtoP1Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP1Aligning = false;
			handleException(ivjExc);
		}
	}

	/**
	 * connPtoP1SetTarget: (ArgumentDeclarationIntern.object <-->
	 * JNumberTextField.double)
	 */
	private void connPtoP1SetTarget() {
		try {
			if (ivjConnPtoP1Aligning == false) {
				ivjConnPtoP1Aligning = true;
				if ((getArgumentDeclarationIntern() != null)) {
					getJDoubleTextField()
							.setDouble(
									(Double) getArgumentDeclarationIntern()
											.getObject());
				}
				ivjConnPtoP1Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP1Aligning = false;
			handleException(ivjExc);
		}
	}

	/**
	 * Called whenever the part throws an exception.
	 * 
	 * @param exception
	 *                Throwable
	 */
	private void handleException(Throwable exception) {

		exception.printStackTrace(System.out);
	}

	/**
	 * Initializes connections
	 * 
	 * @exception Exception
	 *                     The exception description.
	 */
	private void initConnections() {
		getJDoubleTextField().addPropertyChangeListener(ivjEventHandler);
		connPtoP1SetTarget();
	}

	/**
	 * Initialize the class.
	 */
	private void initialize() {
		try {
			setName("ArgumentEditor");
			setLayout(getArgumentEditorBorderLayout());
			setSize(314, 17);
			add(getJDoubleTextField(), "Center");
			add(getJLabel1(), "West");
			initConnections();
			connEtoM1();
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	public String getTitle() {
		return "Insert Double";
	}

	public void selectAll() {
		getJDoubleTextField().selectAll();
	}
	
	
}