package de.uniwue.ki.gui.mas.basics.type.argument;
import java.util.Iterator;

import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.util.declaration.DeclarationListPanel;
import de.uniwue.ki.mas.basics.feature.user.IUserFeatureClassDeclaration;
import de.uniwue.ki.mas.basics.type.FeatureClassDeclarationType;
import de.uniwue.ki.mas.basics.type.argument.ArgumentDeclarationFactory;
import de.uniwue.ki.mas.basics.type.argument.IArgumentDeclaration;
import de.uniwue.ki.mas.util.declaration.DefaultDeclarationList;
import de.uniwue.ki.mas.util.declaration.IDeclarationList;

/**
 * Creation date: (10.07.2001 10:58:46)
 * @author Christoph Oechslein
 */
public class FeatureClassDeclarationArgumentDeclarationEditor extends DeclarationListPanel implements IArgumentDeclarationEditor {
    /**
     * FeatureClassDeclarationArgumentDeclarationEditor constructor comment.
     */
    public FeatureClassDeclarationArgumentDeclarationEditor() {
        super();
        initialize();
    }


public IArgumentDeclaration getArgumentDeclaration() {
    if (getSelectedValue() != null) {
        return ArgumentDeclarationFactory.getInstance().createArgumentDeclaration(FeatureClassDeclarationType.getInstance(), getSelectedValue());

    } else {
        return null;
    }
}



public static IDeclarationList getFeatureClassDeclarationList(IGUISeSAmDeclaration guiSeSAmDeclaration) {
    IDeclarationList newFeatureClassDeclarationList = new DefaultDeclarationList();

    Iterator it =
        guiSeSAmDeclaration
            .getSeSAmModelDeclaration()
            .getSeSAmModelBasicsDeclaration()
            .getUserFeatureClassDeclarationListAndFactory()
            .getUserFeatureClassDeclarationList()
            .iterator();

    while (it.hasNext()) {
        IUserFeatureClassDeclaration currIFeatureClassDeclaration = (IUserFeatureClassDeclaration) it.next();

        if (!currIFeatureClassDeclaration.getFeatureVariableClassDeclarationListAndFactory().getVariableClassDeclarationList().isEmpty()) {
            newFeatureClassDeclarationList.add(currIFeatureClassDeclaration);
        }
    }

    return newFeatureClassDeclarationList;
}


public String getTitle() {
    return "Choice Feature Class";
}


    /**
     * Called whenever the part throws an exception.
     * @param exception Throwable
     */
    private void handleException(Throwable exception) {

        /* Uncomment the following lines to print uncaught exceptions to stdout */
        System.out.println("--------- UNCAUGHT EXCEPTION ---------");
        exception.printStackTrace(System.out);
    }


    /**
     * Initialize the class.
     */
    /* WARNING: THIS METHOD WILL BE REGENERATED. */
    private void initialize() {
        try {
            // user code begin {1}
            // user code end
            setName("FeatureClassDeclarationArgumentDeclarationEditor");
            setSize(294, 312);
            setEditable(false);
        } catch (Throwable ivjExc) {
            handleException(ivjExc);
        }
        // user code begin {2}
        // user code end
    }


protected void initializeDeclList() {
    if (getGUISeSAmDeclaration() != null) {
        setDeclarationListModel(getFeatureClassDeclarationList(getGUISeSAmDeclaration()));

        if (!getDeclarationListModel().isEmpty()) {
            setSelectedValue(getDeclarationListModel().get(0));
        }
    }
}


    /**
     * main entrypoint - starts the part when it is run as an application
     * @param args String[]
     */
    public static void main(String[] args) {
        try {
            javax.swing.JFrame frame = new javax.swing.JFrame();
            FeatureClassDeclarationArgumentDeclarationEditor aFeatureClassDeclarationArgumentDeclarationEditor;
            aFeatureClassDeclarationArgumentDeclarationEditor = new FeatureClassDeclarationArgumentDeclarationEditor();
            frame.setContentPane(aFeatureClassDeclarationArgumentDeclarationEditor);
            frame.setSize(aFeatureClassDeclarationArgumentDeclarationEditor.getSize());
            frame.addWindowListener(new java.awt.event.WindowAdapter() {
                public void windowClosing(java.awt.event.WindowEvent e) {
                    System.exit(0);
                }
            });
            frame.show();
            java.awt.Insets insets = frame.getInsets();
            frame.setSize(frame.getWidth() + insets.left + insets.right, frame.getHeight() + insets.top + insets.bottom);
            frame.setVisible(true);
        } catch (Throwable exception) {
            System.err.println("Exception occurred in main() of JPanelWithGUISeSAmDeclaration");
            exception.printStackTrace(System.out);
        }
    }


    public void setArgumentDeclarationEditorParameter(IArgumentDeclarationEditorParameter argumentDeclarationEditorParameter) {
        setGUISeSAmDeclaration(argumentDeclarationEditorParameter.getGUISeSAmDeclaration());

        IArgumentDeclaration argumentDeclaration = argumentDeclarationEditorParameter.getArgumentDeclaration();

        if (argumentDeclaration.getObject() != null) {
            setSelectedValue(argumentDeclaration.getObject());
        }

        initializeDeclList();
    }

	public boolean inModalPanel() {
		return true;
	}
}