package de.uniwue.ki.gui.mas.basics.type.argument;
import java.util.HashMap;

import de.uniwue.ki.gui.mas.basics.functionArgument.SpecificFunctionDeclarationWithArgDeclBindsPanel;
import de.uniwue.ki.gui.mas.basics.functionCall.FunctionCallDeclarationTreeListPanel;
import de.uniwue.ki.gui.mas.basics.functionCall.IExpertFilterFunctionDeclarationListAble;
import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.model.JPanelWithGUISeSAmDeclaration;
import de.uniwue.ki.mas.basics.functionArgument.*;
import de.uniwue.ki.mas.basics.type.ISpecificType;
import de.uniwue.ki.mas.basics.type.SpecificFunctionType;
import de.uniwue.ki.mas.basics.type.argument.ArgumentDeclarationFactory;
import de.uniwue.ki.mas.basics.type.argument.IArgumentDeclaration;

/**
 * Creation date: (06.07.2001 14:50:15)
 * @author Christoph Oechslein
 */
public class FunctionArgumentDeclarationEditor
	extends JPanelWithGUISeSAmDeclaration
	implements IArgumentDeclarationEditor {

	protected static ISpecificFunctionDeclarationWithArgDeclBinds createSpecificFunctionDeclarationWithArgDeclBinds(ISpecificType specificType) {
		ISpecificFunctionDeclarationWithArgDeclBinds specificFunctionDeclarationWithArgDeclBinds =
			SpecificFunctionDeclarationWithArgDeclBindsFactory
				.createSpecificFunctionDeclarationWithArgDeclBinds();

		SpecificFunctionType specificFunctionType = (SpecificFunctionType)specificType;

		java.util.Iterator it = specificFunctionType.getSpecificInputTypes();
		int i = 1;
		while (it.hasNext()) {
			specificFunctionDeclarationWithArgDeclBinds.getFunctionArgumentDeclarationList().add(
				FunctionArgumentDeclarationFactory.getInstance().createArgumentDeclaration(
					"Parameter" + i,
					(ISpecificType)it.next()));
			i++;
		}

		specificFunctionDeclarationWithArgDeclBinds.setSpecificOutputType(
			specificFunctionType.getSpecificOutputType());

		return specificFunctionDeclarationWithArgDeclBinds;
	}

	private SpecificFunctionDeclarationWithArgDeclBindsPanel _argDeclBindsPanel = null;
	private ISpecificType _specificType = null;

	public FunctionArgumentDeclarationEditor() {
		super();
		initialize();
	}

	public void dispose() {
		getSpecificFunctionDeclarationWithArgDeclBindsPanel().dispose();

		super.dispose();
	}

	public IArgumentDeclaration getArgumentDeclaration() {
		ISpecificFunctionDeclarationWithArgDeclBinds specificFunctionDeclarationWithArgDeclBinds =
			getSpecificFunctionDeclarationWithArgDeclBinds();

		if (specificFunctionDeclarationWithArgDeclBinds == null) {
			return null;

		} else {
			return ArgumentDeclarationFactory.getInstance().createArgumentDeclaration(
				getSpecificType(),
				specificFunctionDeclarationWithArgDeclBinds);
		}
	}

	private ISpecificFunctionDeclarationWithArgDeclBinds getSpecificFunctionDeclarationWithArgDeclBinds() {
		return (ISpecificFunctionDeclarationWithArgDeclBinds)getSpecificFunctionDeclarationWithArgDeclBindsPanel()
			.getDeclaration();
	}

	private SpecificFunctionDeclarationWithArgDeclBindsPanel getSpecificFunctionDeclarationWithArgDeclBindsPanel() {
		if (_argDeclBindsPanel == null) {
			_argDeclBindsPanel = new SpecificFunctionDeclarationWithArgDeclBindsPanel();
			_argDeclBindsPanel.setName("SpecificFunctionDeclarationWithArgDeclBindsPanel1");
			_argDeclBindsPanel.setSignatureConstant(true);
		}
		return _argDeclBindsPanel;
	}

	private ISpecificType getSpecificType() {
		return _specificType;
	}

	public String getTitle() {
		return "Create Function";
	}

	private void initialize() {
		setLayout(new javax.swing.BoxLayout(this, javax.swing.BoxLayout.X_AXIS));
		add(
			getSpecificFunctionDeclarationWithArgDeclBindsPanel(),
			getSpecificFunctionDeclarationWithArgDeclBindsPanel().getName());
	}

	public boolean inModalPanel() {
		return false;
	}

	public void setArgumentDeclarationEditorParameter(IArgumentDeclarationEditorParameter argumentDeclarationEditorParameter) {
		setGUISeSAmDeclaration(argumentDeclarationEditorParameter.getGUISeSAmDeclaration());

		FunctionCallDeclarationTreeListPanel functionCallDeclarationTreeListPanel =
			argumentDeclarationEditorParameter.getFunctionCallDeclarationTreeListPanel();

		// needs a copy since it calls remove when it is disposed (and it would also share the expert setting)
		IExpertFilterFunctionDeclarationListAble oldExpertFilterFunctionDeclarationListAble =
			functionCallDeclarationTreeListPanel.getExpertFilterFunctionDeclarationListAble();

		getSpecificFunctionDeclarationWithArgDeclBindsPanel().setObjectClassDeclaration(
			oldExpertFilterFunctionDeclarationListAble.getObjectClassDeclaration());

		getSpecificFunctionDeclarationWithArgDeclBindsPanel().setExpertFilterFunctionDeclarationListAble(
			(IExpertFilterFunctionDeclarationListAble)oldExpertFilterFunctionDeclarationListAble.copy(
				new HashMap()));

		getSpecificFunctionDeclarationWithArgDeclBindsPanel().setTypeList(
			functionCallDeclarationTreeListPanel.getTypeList());

		getSpecificFunctionDeclarationWithArgDeclBindsPanel().setFilterExpertSettings(
			functionCallDeclarationTreeListPanel.isFilterExpertSettings());

		getSpecificFunctionDeclarationWithArgDeclBindsPanel().setOuterFunctionArgumentDeclarationList(
			functionCallDeclarationTreeListPanel.getAllFunctionArgumentDeclarationList());

		IArgumentDeclaration argumentDeclaration =
			argumentDeclarationEditorParameter.getArgumentDeclaration();

		setSpecificType(argumentDeclaration.getSpecificType());

		if (argumentDeclaration.getObject() != null) {
			setSpecificFunctionDeclarationWithArgDeclBindsIntern(
				(SpecificFunctionDeclarationWithArgDeclBinds)argumentDeclaration.getObject());
		}
	}

	public void setGUISeSAmDeclaration(IGUISeSAmDeclaration guiSeSAmDeclaration) {
		getSpecificFunctionDeclarationWithArgDeclBindsPanel().setGUISeSAmDeclaration(guiSeSAmDeclaration);

		super.setGUISeSAmDeclaration(guiSeSAmDeclaration);
	}

	private void setSpecificFunctionDeclarationWithArgDeclBindsIntern(ISpecificFunctionDeclarationWithArgDeclBinds newValue) {
		if (getSpecificFunctionDeclarationWithArgDeclBinds() != newValue) {
			getSpecificFunctionDeclarationWithArgDeclBindsPanel().setDeclaration(newValue);
		}
	}

	protected void setSpecificType(ISpecificType newSpecificType) {
		if (getSpecificType() != newSpecificType) {
			_specificType = newSpecificType;
			setSpecificFunctionDeclarationWithArgDeclBindsIntern(
				createSpecificFunctionDeclarationWithArgDeclBinds(newSpecificType));
		}
	}
}