package de.uniwue.ki.gui.mas.basics.type.argument;
import javax.swing.JLabel;

import de.uniwue.ki.gui.util.bound.BoundJIntegerTextField;
import de.uniwue.ki.mas.basics.type.IntegerType;
import de.uniwue.ki.mas.basics.type.argument.ArgumentDeclarationFactory;
import de.uniwue.ki.mas.basics.type.argument.IArgumentDeclaration;

/**
 * Creation date: (30.05.00 14:01:01)
 * @author: Christoph Oechslein
 */
public class IntegerArgumentDeclarationEditor
	extends AbstractArgumentDeclarationEditor
	implements IArgumentDeclarationEditor {
	private JLabel ivjJLabel1 = null;
	private final IvjEventHandler ivjEventHandler = new IvjEventHandler();
	private IArgumentDeclaration ivjArgumentDeclarationIntern = null;

	private final class IvjEventHandler implements java.beans.PropertyChangeListener {
		public void propertyChange(java.beans.PropertyChangeEvent evt) {
			if (evt.getSource() == IntegerArgumentDeclarationEditor.this.getJIntegerTextField()
				&& (evt.getPropertyName().equals("integer")))
				connPtoP1SetSource();
		};
	};
	private boolean ivjConnPtoP1Aligning = false;
	private BoundJIntegerTextField ivjJIntegerTextField = null;

	/**
	 * ArgumentEditor constructor comment.
	 */
	public IntegerArgumentDeclarationEditor() {
		super();
		initialize();
	}

	public de.uniwue.ki.mas.basics.type.argument.IArgumentDeclaration getArgumentDeclaration() {
		return getArgumentDeclarationIntern();
	}

	protected void setArgumentDeclaration(
		de.uniwue.ki.mas.basics.type.argument.IArgumentDeclaration argumentDeclaration) {
		setArgumentDeclarationIntern(argumentDeclaration);
	}


	/**
	 * Return the ArgumentDeclarationIntern property value.
	 * @return de.uniwue.ki.mas.model.basics.type.argument.IArgumentDeclaration
	 */
	private de.uniwue.ki.mas.basics.type.argument.IArgumentDeclaration getArgumentDeclarationIntern() {
		return ivjArgumentDeclarationIntern;
	}

	/**
	 * Set the ArgumentDeclarationIntern to a new value.
	 * @param newValue de.uniwue.ki.mas.model.basics.type.argument.IArgumentDeclaration
	 */
	private void setArgumentDeclarationIntern(
		de.uniwue.ki.mas.basics.type.argument.IArgumentDeclaration newValue) {
		if (ivjArgumentDeclarationIntern != newValue) {
			try {
				de.uniwue.ki.mas.basics.type.argument.IArgumentDeclaration oldValue =
					getArgumentDeclarationIntern();
				ivjArgumentDeclarationIntern = newValue;
				connPtoP1SetTarget();
				firePropertyChange("argumentDeclaration", oldValue, newValue);
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		};
	}

	/**
	 * Return the ArgumentEditorBorderLayout property value.
	 * @return java.awt.BorderLayout
	 */
	private java.awt.BorderLayout getArgumentEditorBorderLayout() {
		java.awt.BorderLayout ivjArgumentEditorBorderLayout = null;
		try {
			/* Create part */
			ivjArgumentEditorBorderLayout = new java.awt.BorderLayout();
			ivjArgumentEditorBorderLayout.setVgap(5);
			ivjArgumentEditorBorderLayout.setHgap(5);
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		};
		return ivjArgumentEditorBorderLayout;
	}

	/**
	 * Return the JIntegerTextField property value.
	 * @return BoundJIntegerTextField
	 */
	private BoundJIntegerTextField getJIntegerTextField() {
		if (ivjJIntegerTextField == null) {
			try {
				ivjJIntegerTextField = new BoundJIntegerTextField();
				ivjJIntegerTextField.setName("JIntegerTextField");
		
				// removed setDocument!!

					} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjJIntegerTextField;
	}

	/**
	 * Return the JLabel1 property value.
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel1() {
		if (ivjJLabel1 == null) {
			try {
				ivjJLabel1 = new javax.swing.JLabel();
				ivjJLabel1.setName("JLabel1");
				ivjJLabel1.setText("Value:");
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjJLabel1;
	}

	/**
	 * connEtoM1:  (Position2DArgumentDeclarationEditor.initialize() --> ArgumentDeclarationIntern.this)
	 */
	private void connEtoM1() {
		try {
					setArgumentDeclarationIntern(
				ArgumentDeclarationFactory.getInstance().createArgumentDeclaration(
					IntegerType.getInstance()));
				} catch (Throwable ivjExc) {
					handleException(ivjExc);
		}
	}

	/**
	 * connPtoP1SetSource:  (ArgumentDeclarationIntern.object <--> JNumberTextField.Integer)
	 */
	private void connPtoP1SetSource() {
		try {
			if (ivjConnPtoP1Aligning == false) {
								ivjConnPtoP1Aligning = true;
				if ((getArgumentDeclarationIntern() != null)) {
					getArgumentDeclarationIntern().setObject(getJIntegerTextField().getInteger());
				}
								ivjConnPtoP1Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP1Aligning = false;
					handleException(ivjExc);
		}
	}

	/**
	 * connPtoP1SetTarget:  (ArgumentDeclarationIntern.object <--> JNumberTextField.Integer)
	 */
	private void connPtoP1SetTarget() {
		try {
			if (ivjConnPtoP1Aligning == false) {
								ivjConnPtoP1Aligning = true;
				if ((getArgumentDeclarationIntern() != null)) {
					getJIntegerTextField().setInteger((Integer) getArgumentDeclarationIntern().getObject());
				}
								ivjConnPtoP1Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP1Aligning = false;
					handleException(ivjExc);
		}
	}

	/**
	 * Called whenever the part throws an exception.
	 * @param exception Throwable
	 */
	private void handleException(Throwable exception) {

		exception.printStackTrace(System.out);
	}

	/**
	 * Initializes connections
	 * @exception Exception The exception description.
	 */
	private void initConnections() {
		getJIntegerTextField().addPropertyChangeListener(ivjEventHandler);
		connPtoP1SetTarget();
	}

	/**
	 * Initialize the class.
	 */
	private void initialize() {
		try {
					setName("ArgumentEditor");
			setLayout(getArgumentEditorBorderLayout());
			setSize(314, 17);
			add(getJIntegerTextField(), "Center");
			add(getJLabel1(), "West");
			initConnections();
			connEtoM1();
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	public String getTitle() {
		return "Insert Integer";
	}
}