package de.uniwue.ki.gui.mas.basics.type.argument;
import de.uniwue.ki.gui.mas.util.declaration.DeclarationListPanel;
import de.uniwue.ki.mas.basics.type.ObjectClassDeclarationType;
import de.uniwue.ki.mas.basics.type.argument.ArgumentDeclarationFactory;
import de.uniwue.ki.mas.basics.type.argument.IArgumentDeclaration;
import de.uniwue.ki.mas.entity.objectclass.IObjectClassDeclarationList;

/**
 * Creation date: (10.07.2001 10:58:46)
 * @author Christoph Oechslein
 */
public class ObjectClassDeclarationArgumentDeclarationEditor
   extends DeclarationListPanel
   implements IArgumentDeclarationEditor {
   /**
    * ObjectClassDeclarationArgumentDeclarationEditor constructor comment.
    */
   public ObjectClassDeclarationArgumentDeclarationEditor() {
      super();
      initialize();
   }


public IArgumentDeclaration getArgumentDeclaration() {
    if (getSelectedValue() != null) {
        return ArgumentDeclarationFactory.getInstance().createArgumentDeclaration(ObjectClassDeclarationType.getInstance(), getSelectedValue());
    } else {
        return null;
    }
}



protected IObjectClassDeclarationList getObjectClassDeclarationList() {
    return getGUISeSAmDeclaration().getSeSAmModelDeclaration().getAvailibleObjectClassDeclarationList();
}


public String getTitle() {
   return "Choice Object Class";
}


   /**
    * Called whenever the part throws an exception.
    * @param exception Throwable
    */
   private void handleException(Throwable exception) {

      /* Uncomment the following lines to print uncaught exceptions to stdout */
      System.out.println("--------- UNCAUGHT EXCEPTION ---------");
      exception.printStackTrace(System.out);
   }


   /**
    * Initialize the class.
    */
   /* WARNING: THIS METHOD WILL BE REGENERATED. */
   private void initialize() {
      try {
         // user code begin {1}
         // user code end
         setName("ObjectClassDeclarationArgumentDeclarationEditor");
         setSize(294, 312);
         setEditable(false);
      } catch (Throwable ivjExc) {
         handleException(ivjExc);
      }
      // user code begin {2}
      // user code end
   }


   protected void initializeDeclList() {
      if (getGUISeSAmDeclaration() != null) {
         setDeclarationListModel(getObjectClassDeclarationList());
         
         if (!getObjectClassDeclarationList().isEmpty()) {
            setSelectedValue(getObjectClassDeclarationList().get(0));
         }
      }
   }


   /**
    * main entrypoint - starts the part when it is run as an application
    * @param args String[]
    */
   public static void main(String[] args) {
      try {
         javax.swing.JFrame frame = new javax.swing.JFrame();
         ObjectClassDeclarationArgumentDeclarationEditor aObjectClassDeclarationArgumentDeclarationEditor;
         aObjectClassDeclarationArgumentDeclarationEditor = new ObjectClassDeclarationArgumentDeclarationEditor();
         frame.setContentPane(aObjectClassDeclarationArgumentDeclarationEditor);
         frame.setSize(aObjectClassDeclarationArgumentDeclarationEditor.getSize());
         frame.addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent e) {
               System.exit(0);
            };
         });
         frame.show();
         java.awt.Insets insets = frame.getInsets();
         frame.setSize(frame.getWidth() + insets.left + insets.right, frame.getHeight() + insets.top + insets.bottom);
         frame.setVisible(true);
      } catch (Throwable exception) {
         System.err.println("Exception occurred in main() of JPanelWithGUISeSAmDeclaration");
         exception.printStackTrace(System.out);
      }
   }


public void setArgumentDeclarationEditorParameter(IArgumentDeclarationEditorParameter argumentDeclarationEditorParameter) {
    setGUISeSAmDeclaration(argumentDeclarationEditorParameter.getGUISeSAmDeclaration());

    IArgumentDeclaration argumentDeclaration = argumentDeclarationEditorParameter.getArgumentDeclaration();

    if (argumentDeclaration.getObject() != null) {
        setSelectedValue(argumentDeclaration.getObject());
    }

    initializeDeclList();
}

   	public boolean inModalPanel() {
   		return true;
   	}
}