package de.uniwue.ki.gui.mas.basics.type.argument;
import java.util.HashMap;

import de.uniwue.ki.gui.mas.entity.object.ObjectInstanceDeclarationPanel;
import de.uniwue.ki.gui.mas.model.JPanelWithGUISeSAmDeclaration;
import de.uniwue.ki.mas.basics.type.ObjectInstanceDeclarationType;
import de.uniwue.ki.mas.basics.type.argument.ArgumentDeclarationFactory;
import de.uniwue.ki.mas.basics.type.argument.IArgumentDeclaration;
import de.uniwue.ki.mas.entity.object.IObjectInstanceDeclaration;
import de.uniwue.ki.mas.entity.objectclass.IObjectClassDeclarationList;
import de.uniwue.ki.mas.entity.objectclass.IRessourceClassDeclarationListAndFactory;
import de.uniwue.ki.mas.entity.objectclass.agentclass.IAgentClassDeclarationListAndFactory;
import de.uniwue.ki.mas.model.ISeSAmModelDeclaration;

/**
 * Creation date: (10.07.2001 10:58:46)
 * @author Christoph Oechslein
 */
public class ObjectInstanceDeclarationArgumentDeclarationEditor
	extends JPanelWithGUISeSAmDeclaration
	implements IArgumentDeclarationEditor {

	private final class IvjEventHandler implements java.beans.PropertyChangeListener {
		public void propertyChange(java.beans.PropertyChangeEvent evt) {
			if (evt.getSource()
				== ObjectInstanceDeclarationArgumentDeclarationEditor.this.getObjectInstanceDeclarationPanel()
				&& (evt.getPropertyName().equals("objectInstanceDeclaration")))
				connPtoP1SetSource();
			if (evt.getSource() == ObjectInstanceDeclarationArgumentDeclarationEditor.this
				&& (evt.getPropertyName().equals("gUISeSAmDeclaration")))
				connPtoP2SetTarget();
			if (evt.getSource()
				== ObjectInstanceDeclarationArgumentDeclarationEditor.this.getObjectInstanceDeclarationPanel()
				&& (evt.getPropertyName().equals("gUISeSAmDeclaration")))
				connPtoP2SetSource();
			if (evt.getSource() == ObjectInstanceDeclarationArgumentDeclarationEditor.this
				&& (evt.getPropertyName().equals("gUISeSAmDeclaration")))
				connEtoM1(evt);
		}
	}
	private boolean ivjConnPtoP1Aligning = false;
	private boolean ivjConnPtoP2Aligning = false;
	private final IvjEventHandler ivjEventHandler = new IvjEventHandler();
	private IObjectInstanceDeclaration ivjObjectInstanceDeclaration = null;
	private ObjectInstanceDeclarationPanel ivjObjectInstanceDeclarationPanel = null;

	/**
	 * ObjectClassDeclarationArgumentDeclarationEditor constructor comment.
	 */
	public ObjectInstanceDeclarationArgumentDeclarationEditor() {
		super();
		initialize();
	}

	/**
	 * connEtoM1:  (ObjectInstanceDeclarationArgumentDeclarationEditor.gUISeSAmDeclaration --> ObjectInstanceDeclarationPanel.objectClassDeclarationList)
	 * @param arg1 java.beans.PropertyChangeEvent
	 */
	private void connEtoM1(java.beans.PropertyChangeEvent arg1) {
		try {
					getObjectInstanceDeclarationPanel().setObjectClassDeclarationList(
				this.getObjectClassDeclarationList());
				} catch (Throwable ivjExc) {
					handleException(ivjExc);
		}
	}

	/**
	 * connPtoP1SetSource:  (ObjectInstanceDeclaration.this <--> ObjectInstanceDeclarationPanel.objectInstanceDeclaration)
	 */
	private void connPtoP1SetSource() {
		try {
			if (ivjConnPtoP1Aligning == false) {
								ivjConnPtoP1Aligning = true;
				setObjectInstanceDeclaration(
					getObjectInstanceDeclarationPanel().getObjectInstanceDeclaration());
								ivjConnPtoP1Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP1Aligning = false;
					handleException(ivjExc);
		}
	}

	/**
	 * connPtoP1SetTarget:  (ObjectInstanceDeclaration.this <--> ObjectInstanceDeclarationPanel.objectInstanceDeclaration)
	 */
	private void connPtoP1SetTarget() {
		try {
			if (ivjConnPtoP1Aligning == false) {
								ivjConnPtoP1Aligning = true;
				if ((getObjectInstanceDeclaration() != null)) {
					getObjectInstanceDeclarationPanel().setObjectInstanceDeclaration(
						getObjectInstanceDeclaration());
				}
								ivjConnPtoP1Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP1Aligning = false;
					handleException(ivjExc);
		}
	}

	/**
	 * connPtoP2SetSource:  (ObjectInstanceDeclarationArgumentDeclarationEditor.gUISeSAmDeclaration <--> ObjectInstanceDeclarationPanel.gUISeSAmDeclaration)
	 */
	private void connPtoP2SetSource() {
		try {
			if (ivjConnPtoP2Aligning == false) {
								ivjConnPtoP2Aligning = true;
				this.setGUISeSAmDeclaration(getObjectInstanceDeclarationPanel().getGUISeSAmDeclaration());
								ivjConnPtoP2Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP2Aligning = false;
					handleException(ivjExc);
		}
	}

	/**
	 * connPtoP2SetTarget:  (ObjectInstanceDeclarationArgumentDeclarationEditor.gUISeSAmDeclaration <--> ObjectInstanceDeclarationPanel.gUISeSAmDeclaration)
	 */
	private void connPtoP2SetTarget() {
		try {
			if (ivjConnPtoP2Aligning == false) {
								ivjConnPtoP2Aligning = true;
				getObjectInstanceDeclarationPanel().setGUISeSAmDeclaration(this.getGUISeSAmDeclaration());
								ivjConnPtoP2Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP2Aligning = false;
					handleException(ivjExc);
		}
	}

	public void dispose() {
		if ((getObjectInstanceDeclaration() != null) && getObjectInstanceDeclaration().canBeRemoved()) {
			getObjectInstanceDeclaration().remove();
			setObjectInstanceDeclaration(null);
		}

		super.dispose();
	}

	public IArgumentDeclaration getArgumentDeclaration() {
		if (getObjectInstanceDeclaration() != null) {
			return ArgumentDeclarationFactory.getInstance().createArgumentDeclaration(
				ObjectInstanceDeclarationType.getInstance(),
				getObjectInstanceDeclaration().copy(new HashMap()));

		} else {
			return null;
		}
	}

	protected IObjectClassDeclarationList getObjectClassDeclarationList() {
		if (getGUISeSAmDeclaration() != null)
			return getGUISeSAmDeclaration()
				.getSeSAmModelDeclaration()
				.getAvailibleObjectClassDeclarationList();
		else
			return null;
	}

	/**
	 * Return the ObjectInstanceDeclaration property value.
	 * @return de.uniwue.ki.mas.model.entity.object.IObjectInstanceDeclaration
	 */
	private de.uniwue.ki.mas.entity.object.IObjectInstanceDeclaration getObjectInstanceDeclaration() {
		return ivjObjectInstanceDeclaration;
	}

	/**
	 * Return the ObjectInstanceDeclarationPanel property value.
	 * @return de.uniwue.ki.gui.mas.model.entity.object.ObjectInstanceDeclarationPanel
	 */
	private de
		.uniwue
		.ki
		.gui
		.mas
		.entity
		.object
		.ObjectInstanceDeclarationPanel getObjectInstanceDeclarationPanel() {
		if (ivjObjectInstanceDeclarationPanel == null) {
			try {
				ivjObjectInstanceDeclarationPanel =
					new de.uniwue.ki.gui.mas.entity.object.ObjectInstanceDeclarationPanel();
				ivjObjectInstanceDeclarationPanel.setName("ObjectInstanceDeclarationPanel");
				ivjObjectInstanceDeclarationPanel.setChangeClassButtonEnabled(true);
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjObjectInstanceDeclarationPanel;
	}

	public String getTitle() {
		return "Choice Object Class";
	}

	/**
	 * Called whenever the part throws an exception.
	 * @param exception Throwable
	 */
	private void handleException(Throwable exception) {

		exception.printStackTrace(System.out);
	}

	/**
	 * Initializes connections
	 * @exception Exception The exception description.
	 */
	private void initConnections() {
		getObjectInstanceDeclarationPanel().addPropertyChangeListener(ivjEventHandler);
		this.addPropertyChangeListener(ivjEventHandler);
		connPtoP1SetTarget();
		connPtoP2SetTarget();
	}

	/**
	 * Initialize the class.
	 */
	private void initialize() {
		try {
					setName("ObjectInstanceDeclarationArgumentDeclarationEditor");
			setSize(359, 412);
			add(getObjectInstanceDeclarationPanel(), getObjectInstanceDeclarationPanel().getName());
			initConnections();
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	public static void main(String[] args) {
		try {
			javax.swing.JFrame frame = new javax.swing.JFrame();
			ObjectClassDeclarationArgumentDeclarationEditor aObjectClassDeclarationArgumentDeclarationEditor;
			aObjectClassDeclarationArgumentDeclarationEditor =
				new ObjectClassDeclarationArgumentDeclarationEditor();
			frame.setContentPane(aObjectClassDeclarationArgumentDeclarationEditor);
			frame.setSize(aObjectClassDeclarationArgumentDeclarationEditor.getSize());
			frame.addWindowListener(new java.awt.event.WindowAdapter() {
				public void windowClosing(java.awt.event.WindowEvent e) {
					System.exit(0);
				};
			});
			frame.show();
			java.awt.Insets insets = frame.getInsets();
			frame.setSize(
				frame.getWidth() + insets.left + insets.right,
				frame.getHeight() + insets.top + insets.bottom);
			frame.setVisible(true);
		} catch (Throwable exception) {
			System.err.println("Exception occurred in main() of JPanelWithGUISeSAmDeclaration");
			exception.printStackTrace(System.out);
		}
	}

	public void setArgumentDeclarationEditorParameter(IArgumentDeclarationEditorParameter argumentDeclarationEditorParameter) {
		setGUISeSAmDeclaration(argumentDeclarationEditorParameter.getGUISeSAmDeclaration());

		IArgumentDeclaration argumentDeclaration =
			argumentDeclarationEditorParameter.getArgumentDeclaration();

		getObjectInstanceDeclarationPanel().setOuterFunctionArgumentDeclarationList(
			argumentDeclarationEditorParameter
				.getFunctionCallDeclarationTreeListPanel()
				.getAllFunctionArgumentDeclarationList());

		if (argumentDeclaration.getObject() != null) {
			setObjectInstanceDeclaration((IObjectInstanceDeclaration)argumentDeclaration.getObject());

		} else {
			ISeSAmModelDeclaration seSAmModelDeclaration =
				getGUISeSAmDeclaration().getSeSAmModelDeclaration();
			IRessourceClassDeclarationListAndFactory ressourceClassDeclarationListAndFactory =
				seSAmModelDeclaration.getRessourceClassDeclarationListAndFactory();
			IAgentClassDeclarationListAndFactory agentClassDeclarationListAndFactory =
				seSAmModelDeclaration.getAgentClassDeclarationListAndFactory();

			if (!ressourceClassDeclarationListAndFactory.getObjectClassDeclarationList().isEmpty()
				&& agentClassDeclarationListAndFactory.getAgentClassDeclarationList().isEmpty()) {
				setObjectInstanceDeclaration(
					ressourceClassDeclarationListAndFactory
						.getRessourceClassDeclarationFactory()
						.createObjectInstanceDeclarationFactory()
						.createObjectInstanceDeclaration());

			} else {
				setObjectInstanceDeclaration(
					agentClassDeclarationListAndFactory
						.getAgentClassDeclarationFactory()
						.createAgentInstanceDeclarationFactory()
						.createAgentInstanceDeclaration());
			}
		}
	}

	/**
	 * Set the ObjectInstanceDeclaration to a new value.
	 * @param newValue de.uniwue.ki.mas.model.entity.object.IObjectInstanceDeclaration
	 */
	private void setObjectInstanceDeclaration(IObjectInstanceDeclaration newValue) {
		if (ivjObjectInstanceDeclaration != newValue) {
			try {
				ivjObjectInstanceDeclaration = newValue;
				connPtoP1SetTarget();
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
	}

	public boolean inModalPanel() {
		return false;
	}
}