package de.uniwue.ki.gui.mas.basics.type.argument;
import java.awt.Dimension;

import javax.swing.*;
import javax.swing.text.JTextComponent;

import de.uniwue.ki.gui.util.bound.BetterBoundJTextArea;
import de.uniwue.ki.mas.basics.type.StringType;
import de.uniwue.ki.mas.basics.type.argument.ArgumentDeclarationFactory;
import de.uniwue.ki.mas.basics.type.argument.IArgumentDeclaration;

/**
 * Creation date: (30.05.00 14:01:01)
 * @author Christoph Oechslein
 */
public class StringArgumentDeclarationEditor
	extends AbstractArgumentDeclarationEditor
	implements IArgumentDeclarationEditor {
	private JLabel ivjJLabel1 = null;
	private JTextComponent ivjJTextField1 = null;
	private final IvjEventHandler ivjEventHandler = new IvjEventHandler();

	private final class IvjEventHandler implements java.beans.PropertyChangeListener {
		public void propertyChange(java.beans.PropertyChangeEvent evt) {
			if (evt.getSource() == StringArgumentDeclarationEditor.this.getJTextField1()
				&& (evt.getPropertyName().equals("text")))
				connPtoP1SetTarget();
		}
	}
	private IArgumentDeclaration ivjArgumentDeclarationIntern = null;

	/**
	 * ArgumentEditor constructor comment.
	 */
	public StringArgumentDeclarationEditor() {
		super();
		initialize();
	}

	public static void main(String[] args) {
		try {
			JFrame frame = new javax.swing.JFrame();
			StringArgumentDeclarationEditor aArgumentStringEditor;
			aArgumentStringEditor = new StringArgumentDeclarationEditor();
			frame.setContentPane(aArgumentStringEditor);
			frame.setSize(aArgumentStringEditor.getSize());
			frame.addWindowListener(new java.awt.event.WindowAdapter() {
				public void windowClosing(java.awt.event.WindowEvent e) {
					System.exit(0);
				}
			});
			frame.setVisible(true);
		} catch (Throwable exception) {
			System.err.println("Exception occurred in main() of javax.swing.JPanel");
			exception.printStackTrace(System.out);
		}
	}

	public IArgumentDeclaration getArgumentDeclaration() {
		return getArgumentDeclarationIntern();
	}

	protected void setArgumentDeclaration(IArgumentDeclaration argumentDeclaration) {

		setArgumentDeclarationIntern(argumentDeclaration);
	}

	/**
	 * Return the ArgumentDeclarationIntern property value.
	 * @return de.uniwue.ki.mas.model.basics.type.IArgumentDeclaration
	 */
	private IArgumentDeclaration getArgumentDeclarationIntern() {
		return ivjArgumentDeclarationIntern;
	}

	/**
	 * Set the ArgumentDeclarationIntern to a new value.
	 * @param newValue de.uniwue.ki.mas.model.basics.type.IArgumentDeclaration
	 */
	private void setArgumentDeclarationIntern(IArgumentDeclaration newValue) {
		if (ivjArgumentDeclarationIntern != newValue) {
			try {
				ivjArgumentDeclarationIntern = newValue;
				connEtoM2(ivjArgumentDeclarationIntern);
				connPtoP1SetTarget();
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		};
	}

	/**
	 * Return the ArgumentEditorBorderLayout property value.
	 * @return java.awt.BorderLayout
	 */
	private java.awt.BorderLayout getArgumentEditorBorderLayout() {
		java.awt.BorderLayout ivjArgumentEditorBorderLayout = null;
		try {
			/* Create part */
			ivjArgumentEditorBorderLayout = new java.awt.BorderLayout();
			ivjArgumentEditorBorderLayout.setVgap(5);
			ivjArgumentEditorBorderLayout.setHgap(5);
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
		return ivjArgumentEditorBorderLayout;
	}

	/**
	 * Return the JLabel1 property value.
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel1() {
		if (ivjJLabel1 == null) {
			try {
				ivjJLabel1 = new javax.swing.JLabel();
				ivjJLabel1.setName("JLabel1");
				ivjJLabel1.setText("Value:");
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjJLabel1;
	}

	private JTextComponent getJTextField1() {
		if (ivjJTextField1 == null) {
			try {
				ivjJTextField1 = new BetterBoundJTextArea();
				ivjJTextField1.setName("JTextField1");
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjJTextField1;
	}

	private void connEtoM1() {
		try {
			setArgumentDeclarationIntern(
				ArgumentDeclarationFactory.getInstance().createArgumentDeclaration(StringType.getInstance()));
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	private void connEtoM2(IArgumentDeclaration value) {
		try {
			if ((getArgumentDeclarationIntern() != null)) {
				getJTextField1().setText((String) getArgumentDeclarationIntern().getObject());
			}
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	private void connPtoP1SetTarget() {
		try {
			if ((getArgumentDeclarationIntern() != null)) {
				getArgumentDeclarationIntern().setObject(getJTextField1().getText());
			}
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	protected String getText() {
		return getJTextField1().getText();
	}

	private void handleException(Throwable exception) {
		exception.printStackTrace(System.out);
	}

	private void initConnections() {
		getJTextField1().addPropertyChangeListener(ivjEventHandler);
		connPtoP1SetTarget();
	}

	private void initialize() {
		try {
			setName("ArgumentEditor");
			setLayout(getArgumentEditorBorderLayout());
			setSize(314, 17);
			JScrollPane pane = new JScrollPane();
			pane.setSize(200,100);
			pane.setPreferredSize(new Dimension(200,100));
			pane.setViewportView(getJTextField1());
			add(pane, "Center");
			add(getJLabel1(), "West");
			initConnections();
			connEtoM1();
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	public String getTitle() {
		return "Insert String";
	}
}