package de.uniwue.ki.gui.mas.basics.type.argument;
import java.util.*;

import javax.swing.JFrame;
import javax.swing.JScrollPane;

import junit.framework.Assert;
import de.uniwue.ki.gui.mas.basics.functionCall.FunctionCallDeclarationTreeListPanel;
import de.uniwue.ki.gui.mas.basics.functionCall.IExpertFilterFunctionDeclarationListAble;
import de.uniwue.ki.gui.util.NamedCellRendererAdapter;
import de.uniwue.ki.mas.basics.type.SpecificVariableClassDeclarationType;
import de.uniwue.ki.mas.basics.type.TypeManager;
import de.uniwue.ki.mas.basics.type.argument.IArgumentDeclaration;
import de.uniwue.ki.mas.entity.variableclass.IBodyVariableClassDeclaration;
import de.uniwue.ki.mas.entity.variableclass.IVariableClassDeclaration;
import de.uniwue.ki.util.collection.CollectionsHelper;
import de.uniwue.ki.util.comparator.NamedComparator;
import de.uniwue.ki.util.functions.IPredicateFunction;

/**
 * Creation date: (30.05.00 14:01:01)
 * @author Christoph Oechslein
 */
public class VariableClassDeclarationArgumentDeclarationEditor
	extends de.uniwue.ki.gui.mas.model.JPanelWithGUISeSAmDeclaration
	implements IArgumentDeclarationEditor {

	private final class IvjEventHandler implements java.beans.PropertyChangeListener {
		public void propertyChange(java.beans.PropertyChangeEvent evt) {
			if (evt.getSource()
				== VariableClassDeclarationArgumentDeclarationEditor.this.getBetterBoundJList()
				&& (evt.getPropertyName().equals("selectedValue")))
				connPtoP1SetTarget();
		}
	}
	public static void main(String[] args) {
		try {
			JFrame frame = new javax.swing.JFrame();
			VariableClassDeclarationArgumentDeclarationEditor aVariableClassDeclarationArgumentDeclarationEditor;
			aVariableClassDeclarationArgumentDeclarationEditor =
				new VariableClassDeclarationArgumentDeclarationEditor();
			frame.setContentPane(aVariableClassDeclarationArgumentDeclarationEditor);
			frame.setSize(aVariableClassDeclarationArgumentDeclarationEditor.getSize());
			frame.addWindowListener(new java.awt.event.WindowAdapter() {
				public void windowClosing(java.awt.event.WindowEvent e) {
					System.exit(0);
				}
			});
			frame.setVisible(true);
		} catch (Throwable exception) {
			System.err.println("Exception occurred in main() of javax.swing.JPanel");
			exception.printStackTrace(System.out);
		}
	}

	private FunctionCallDeclarationTreeListPanel _parentFunctionCallDeclarationTreeListPanel;
	private IArgumentDeclaration ivjArgumentDeclarationIntern = null;
	private de.uniwue.ki.gui.util.bound.BetterBoundJList ivjBetterBoundJList = null;
	private boolean ivjConnPtoP1Aligning = false;
	private final IvjEventHandler ivjEventHandler = new IvjEventHandler();
	private JScrollPane ivjJScrollPane1 = null;
	private Object ivjSelectedVariableDeclaration = null;

	/**
	 * ArgumentEditor constructor comment.
	 */
	public VariableClassDeclarationArgumentDeclarationEditor() {
		super();
		initialize();
	}

	/**
	 * connEtoC2:  (ArgumentDeclarationIntern.this --> VariableClassDeclarationArgumentDeclarationEditor.setListDataAndSelectedItem()V)
	 * @param value de.uniwue.ki.mas.model.basics.type.IArgumentDeclaration
	 */
	private void connEtoC2(de.uniwue.ki.mas.basics.type.argument.IArgumentDeclaration value) {
		try {
					this.setListDataAndSelectedItem();
				} catch (Throwable ivjExc) {
					handleException(ivjExc);
		}
	}

	/**
	 * connEtoM3:  (SelectedVariableDeclaration.this --> ArgumentDeclarationIntern.object)
	 * @param value Object
	 */
	private void connEtoM3(Object value) {
		try {
					if ((getSelectedVariableDeclaration() != null)) {
				getArgumentDeclarationIntern().setObject(getSelectedVariableDeclaration());
			}
				} catch (Throwable ivjExc) {
					handleException(ivjExc);
		}
	}

	/**
	 * connPtoP1SetSource:  (VariableDeclarationComboBox.selectedItem <--> SelectedVariableDeclaration.this)
	 */
	private void connPtoP1SetSource() {
		try {
			if (ivjConnPtoP1Aligning == false) {
								ivjConnPtoP1Aligning = true;
				if ((getSelectedVariableDeclaration() != null)) {
					getBetterBoundJList().setSelectedValue(getSelectedVariableDeclaration());
				}
								ivjConnPtoP1Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP1Aligning = false;
					handleException(ivjExc);
		}
	}

	/**
	 * connPtoP1SetTarget:  (VariableDeclarationComboBox.selectedItem <--> SelectedVariableDeclaration.this)
	 */
	private void connPtoP1SetTarget() {
		try {
			if (ivjConnPtoP1Aligning == false) {
								ivjConnPtoP1Aligning = true;
				setSelectedVariableDeclaration(getBetterBoundJList().getSelectedValue());
								ivjConnPtoP1Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP1Aligning = false;
					handleException(ivjExc);
		}
	}

	public de.uniwue.ki.mas.basics.type.argument.IArgumentDeclaration getArgumentDeclaration() {
		return getArgumentDeclarationIntern();
	}

	/**
	 * Return the IArgumentDeclarationIntern property value.
	 * @return de.uniwue.ki.mas.model.basics.type.IArgumentDeclaration
	 */
	private de.uniwue.ki.mas.basics.type.argument.IArgumentDeclaration getArgumentDeclarationIntern() {
		return ivjArgumentDeclarationIntern;
	}

	/**
	 * Return the BetterBoundJList property value.
	 * @return de.uniwue.ki.gui.util.bound.BetterBoundJList
	 */
	private de.uniwue.ki.gui.util.bound.BetterBoundJList getBetterBoundJList() {
		if (ivjBetterBoundJList == null) {
			try {
				ivjBetterBoundJList = new de.uniwue.ki.gui.util.bound.BetterBoundJList();
				ivjBetterBoundJList.setName("BetterBoundJList");
				ivjBetterBoundJList.setCellRenderer(
					new NamedCellRendererAdapter(ivjBetterBoundJList.getCellRenderer()));
				ivjBetterBoundJList.setBounds(0, 0, 160, 120);
				ivjBetterBoundJList.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjBetterBoundJList;
	}

	private IExpertFilterFunctionDeclarationListAble getExpertFilterFunctionDeclarationListAble() {
		FunctionCallDeclarationTreeListPanel functionCallDeclarationTreeListPanel =
			getParentFunctionCallDeclarationTreeListPanel();

		IExpertFilterFunctionDeclarationListAble expertFilterFunctionDeclarationListAble =
			functionCallDeclarationTreeListPanel.getExpertFilterFunctionDeclarationListAble();

		return expertFilterFunctionDeclarationListAble;
	}

	protected Iterator getFeatureClassDeclarationVariableIterator() {
		IExpertFilterFunctionDeclarationListAble expertFilterFunctionDeclarationListAble =
			getExpertFilterFunctionDeclarationListAble();
		return expertFilterFunctionDeclarationListAble.getFeatureVariableClassDeclarations();
	}

	protected IPredicateFunction getFilterFunction(final SpecificVariableClassDeclarationType type) {
		return new IPredicateFunction() {
			private boolean areSettingsOK(IVariableClassDeclaration variableClassDeclaration) {
				if (type.isExternal() && !variableClassDeclaration.isExternal())
					return false;
				//
				if (type.isWriteable())
					return variableClassDeclaration.isWriteable();
				else
					return true;
			}
			private boolean hasRightType(IVariableClassDeclaration variableClassDeclaration) {
				return TypeManager.getInstance().isMoreGeneral(
					type.getVariableClassDeclarationType(),
					variableClassDeclaration.getSpecificType());
			}
			public boolean isElementOk(Object obj) {
				if (type == null)
					return true;
				else {
					IVariableClassDeclaration variableClassDeclaration;
					if (obj instanceof IBodyVariableClassDeclaration)
						variableClassDeclaration =
							((IBodyVariableClassDeclaration)obj).getVariableClassDeclaration();
					else
						variableClassDeclaration = (IVariableClassDeclaration)obj;
					return hasRightType(variableClassDeclaration) && areSettingsOK(variableClassDeclaration);
				}
			}
		};
	}

	/**
	 * Return the JScrollPane1 property value.
	 * @return javax.swing.JScrollPane
	 */
	private javax.swing.JScrollPane getJScrollPane1() {
		if (ivjJScrollPane1 == null) {
			try {
				ivjJScrollPane1 = new javax.swing.JScrollPane();
				ivjJScrollPane1.setName("JScrollPane1");
				getJScrollPane1().setViewportView(getBetterBoundJList());
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjJScrollPane1;
	}

	protected Iterator getListDataIterator() {
		if ((getArgumentDeclaration() == null)
			|| (getGUISeSAmDeclaration() == null)
			|| (getParentFunctionCallDeclarationTreeListPanel() == null)) {
			return CollectionsHelper.EMPTY_ITERATOR;

		} else {
			SpecificVariableClassDeclarationType type =
				(SpecificVariableClassDeclarationType)getArgumentDeclaration().getSpecificType();

			if (type == null) {
				return CollectionsHelper.EMPTY_ITERATOR;

			} else {
				Iterator bodyVariableClassDeclarations = getObjectClassDeclarationBodyVariables();

				Iterator featureVariableClassDeclarations = getFeatureClassDeclarationVariableIterator();

				Iterator it;

				if (featureVariableClassDeclarations != null) {
					if (Assert.ASSERTION_ON)
						Assert.assertNull(bodyVariableClassDeclarations);

					it = featureVariableClassDeclarations;

				} else if (bodyVariableClassDeclarations != null) {
					Assert.assertNull(featureVariableClassDeclarations);

					it = bodyVariableClassDeclarations;

				} else {
					return CollectionsHelper.EMPTY_ITERATOR;
				}

				List variables =
					CollectionsHelper.asLinkedList(CollectionsHelper.select(it, getFilterFunction(type)));

				Collections.sort(variables, NamedComparator.getInstance());

				return variables.iterator();
			}
		}
	}

	protected Iterator getObjectClassDeclarationBodyVariables() {
		IExpertFilterFunctionDeclarationListAble expertFilterFunctionDeclarationListAble =
			getExpertFilterFunctionDeclarationListAble();

		return expertFilterFunctionDeclarationListAble.getBodyVariableClassDeclarations();
	}

	protected FunctionCallDeclarationTreeListPanel getParentFunctionCallDeclarationTreeListPanel() {
		return _parentFunctionCallDeclarationTreeListPanel;
	}

	/**
	 * Return the SelectedVariableDeclaration property value.
	 * @return Object
	 */
	private Object getSelectedVariableDeclaration() {
		return ivjSelectedVariableDeclaration;
	}

	public String getTitle() {
		return "Choice Variable";
	}

	/**
	 * Called whenever the part throws an exception.
	 * @param exception Throwable
	 */
	private void handleException(Throwable exception) {

		exception.printStackTrace(System.out);
	}

	/**
	     * Initializes connections
	     * @exception Exception The exception description.
	     */
	private void initConnections() {
		getBetterBoundJList().addPropertyChangeListener(ivjEventHandler);
		connPtoP1SetTarget();
	}

	/**
	     * Initialize the class.
	     */
	private void initialize() {
		try {
					setName("ArgumentEditor");
			setSize(294, 214);
			add(getJScrollPane1(), getJScrollPane1().getName());
			initConnections();
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	public boolean inModalPanel() {
		return true;
	}

	protected void setArgumentDeclaration(IArgumentDeclaration newValue) {
		setArgumentDeclarationIntern(newValue);
	}

	public void setArgumentDeclarationEditorParameter(IArgumentDeclarationEditorParameter argumentDeclarationEditorParameter) {

		setGUISeSAmDeclaration(argumentDeclarationEditorParameter.getGUISeSAmDeclaration());
		setParentFunctionCallDeclarationTreeListPanel(
			argumentDeclarationEditorParameter.getFunctionCallDeclarationTreeListPanel());

		setArgumentDeclaration(argumentDeclarationEditorParameter.getArgumentDeclaration());

	}

	/**
	 * Set the ArgumentDeclarationIntern to a new value.
	 * @param newValue de.uniwue.ki.mas.model.basics.type.IArgumentDeclaration
	 */
	private void setArgumentDeclarationIntern(IArgumentDeclaration newValue) {
		if (ivjArgumentDeclarationIntern != newValue) {
			try {
				IArgumentDeclaration oldValue = getArgumentDeclarationIntern();
				ivjArgumentDeclarationIntern = newValue;
				connEtoC2(ivjArgumentDeclarationIntern);
				firePropertyChange("argumentDeclaration", oldValue, newValue);
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
	}

	protected void setListDataAndSelectedItem() {
		getBetterBoundJList().removeAllItems();
		getBetterBoundJList().setListData(getListDataIterator());

		if (getArgumentDeclaration() != null) {
			if (getArgumentDeclaration().getObject() != null) {
				setSelectedVariableDeclaration(getArgumentDeclaration().getObject());

			} else if (getBetterBoundJList().getModel().getSize() > 0) {
				setSelectedVariableDeclaration(getBetterBoundJList().getModel().getElementAt(0));
			}
		}
	}

	protected void setParentFunctionCallDeclarationTreeListPanel(FunctionCallDeclarationTreeListPanel newFunctionCallDeclarationTreeListPanel) {
		_parentFunctionCallDeclarationTreeListPanel = newFunctionCallDeclarationTreeListPanel;
	}

	/**
	 * Set the SelectedVariableDeclaration to a new value.
	 * @param newValue Object
	 */
	private void setSelectedVariableDeclaration(Object newValue) {
		if (ivjSelectedVariableDeclaration != newValue) {
			try {
				ivjSelectedVariableDeclaration = newValue;
				connEtoM3(ivjSelectedVariableDeclaration);
				connPtoP1SetSource();
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
	}
}