package de.uniwue.ki.gui.mas.basics.type.dependent;

import java.util.List;

import javax.swing.table.AbstractTableModel;

import junit.framework.Assert;
import de.uniwue.ki.mas.basics.type.ISpecificType;
import de.uniwue.ki.mas.basics.type.dependent.DependentTypeBindings;
import de.uniwue.ki.mas.basics.type.dependent.IDependentType;

/**
 * Creation date: (31.05.00 17:31:06)
 * @author Christoph Oechslein
 */
class BindingTableModel extends AbstractTableModel {
	private DependentTypeBindings dependentTypeBindings;
	private List dependentTypes;

	public BindingTableModel() {
		super();
	}

	public BindingTableModel(DependentTypeBindings dependentTypeBindings, List dependentTypes) {
		super();
		this.dependentTypeBindings = dependentTypeBindings;
		this.dependentTypes = dependentTypes;
	}

	public DependentTypeBindings getDependentTypeBindings() {
		return dependentTypeBindings;
	}

	public void setDependentTypeBindings(DependentTypeBindings newDependentTypeBindings) {
		dependentTypeBindings = newDependentTypeBindings;
	}

	public java.util.List getDependentTypes() {
		return dependentTypes;
	}

	public void setDependentTypes(java.util.List newDependentTypes) {
		dependentTypes = newDependentTypes;
		fireTableStructureChanged();
		fireTableDataChanged();
	}

	public Class getColumnClass(int columnIndex) {
		return super.getColumnClass(columnIndex);
	}

	public int getColumnCount() {
		return 2;
	}

	public String getColumnName(int column) {
		if (column == 0) {
			return "Name";
		} else if (column == 1)
			return "Argument name";
		else
			return null;
	}

	public int getRowCount() {
		if (dependentTypes == null)
			return 0;
		else
			return dependentTypes.size();
	}

	public Object getValueAt(int row, int col) {
		if (col == 0)
			return ((IDependentType) dependentTypes.get(row)).getName();

		else if (col == 1) {
			ISpecificType arg = dependentTypeBindings.getBindingFor((IDependentType) dependentTypes.get(row));

			Assert.assertNotNull(arg);

			return arg.getName();
		} else
			throw new RuntimeException("col must be in [0,1]");
	}

	public boolean isCellEditable(int rowIndex, int columnIndex) {
		// return columnIndex == 1;
		return false;
	}

	public void setValueAt(Object newObject, int row, int col) {
		if (col != 1)
			Assert.fail();

		if (newObject instanceof ISpecificType)
			dependentTypeBindings.setBindingFor(
				(IDependentType) dependentTypes.get(row),
				(ISpecificType) newObject);
	}
}
