package de.uniwue.ki.gui.mas.basics.type.dependent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.Iterator;
import java.util.List;

import javax.swing.*;

import com.ibm.easyswing.BoundJComboBox;

import de.uniwue.ki.gui.mas.model.JPanelWithGUISeSAmDeclaration;
import de.uniwue.ki.mas.basics.type.ISpecificType;
import de.uniwue.ki.mas.basics.type.dependent.IDependentType;
import de.uniwue.ki.util.collection.CollectionsHelper;
import de.uniwue.ki.util.functions.IPredicateFunction;
/**
 * Creation date: (31.05.00 16:59:20)
 * @author Christoph Oechslein
 */
public class DependentTypeBindingsPanel extends JPanelWithGUISeSAmDeclaration {
	private BoundJComboBox _jComboBox;
	private java.util.List _typeList = null;
	private JScrollPane ivjJScrollPane1 = null;
	private JTable ivjScrollPaneTable = null;
	private BindingTableModel ivjBindingTableModel = null;
	private boolean ivjConnPtoP1Aligning = false;
	private boolean fieldEveryThingBound = false;
	private final IvjEventHandler ivjEventHandler = new IvjEventHandler();
	private javax.swing.table.TableColumn ivjTableColumnArgumentName = null;
	private javax.swing.table.TableColumn ivjTableColumnName = null;

	private final class IvjEventHandler implements java.beans.PropertyChangeListener {
		public void propertyChange(java.beans.PropertyChangeEvent evt) {
			if (evt.getSource() == DependentTypeBindingsPanel.this.getScrollPaneTable()
				&& (evt.getPropertyName().equals("model")))
				connPtoP1SetTarget();
		};
	};

	/**
	 * ArgumentDependentBindings constructor comment.
	 */
	public DependentTypeBindingsPanel() {
		super();
		initialize();
	}

	/**
	 * Comment
	 */
	protected void checkIsEveryThingBound() {
		java.util.Iterator it = getBindingTableModelDependentTypes().iterator();
		boolean everyThingBound = true;
		while (it.hasNext()) {
			ISpecificType argSpec =
				getBindingTableModelDependentTypeBindings().getBindingFor((IDependentType) it.next());
			if (argSpec == null) {
				everyThingBound = false;
				break;
			}
		}
		setEveryThingBound(everyThingBound);
	}

	/**
	 * connPtoP1SetSource:  (ScrollPaneTable.model <--> BindingTableModel.this)
	 */
	private void connPtoP1SetSource() {
		try {
			if (ivjConnPtoP1Aligning == false) {
								ivjConnPtoP1Aligning = true;
				if ((getBindingTableModel() != null)) {
					getScrollPaneTable().setModel(getBindingTableModel());
				}
								ivjConnPtoP1Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP1Aligning = false;
					handleException(ivjExc);
		}
	}

	/**
	 * connPtoP1SetTarget:  (ScrollPaneTable.model <--> BindingTableModel.this)
	 */
	private void connPtoP1SetTarget() {
		try {
			if (ivjConnPtoP1Aligning == false) {
								ivjConnPtoP1Aligning = true;
				setBindingTableModel(
					(de.uniwue.ki.gui.mas.basics.type.dependent.BindingTableModel) getScrollPaneTable()
						.getModel());
								ivjConnPtoP1Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP1Aligning = false;
					handleException(ivjExc);
		}
	}

	protected Iterator createCorrectTypeList(List newTypeList) {
		return CollectionsHelper.select(newTypeList.iterator(), new IPredicateFunction() {
			public boolean isElementOk(Object obj) {
				return obj instanceof ISpecificType;
			}
		});
	}

	/**
	 * Return the BindingTableModel property value.
	 * @return de.uniwue.ki.gui.mas.model.basics.function.BindingTableModel
	 */
	private BindingTableModel getBindingTableModel() {
		return ivjBindingTableModel;
	}

	/**
	 * Method generated to support the promotion of the bindingTableModelDependentTypeBindings attribute.
	 * @return de.uniwue.ki.mas.model.basics.type.IDependentTypeBindings
	 */
	public de
		.uniwue
		.ki
		.mas
		.basics
		.type
		.dependent
		.DependentTypeBindings getBindingTableModelDependentTypeBindings() {
		return getBindingTableModel().getDependentTypeBindings();
	}

	/**
	 * Method generated to support the promotion of the bindingTableModelDependentTypes attribute.
	 * @return java.util.List
	 */
	public java.util.List getBindingTableModelDependentTypes() {
		return getBindingTableModel().getDependentTypes();
	}

	/**
	 * Gets the everyThingBound property (boolean) value.
	 * @return The everyThingBound property value.
	 * @see #setEveryThingBound
	 */
	public boolean getEveryThingBound() {
		return fieldEveryThingBound;
	}

	/**
	 * Return the JScrollPane1 property value.
	 * @return javax.swing.JScrollPane
	 */
	private javax.swing.JScrollPane getJScrollPane1() {
		if (ivjJScrollPane1 == null) {
			try {
				ivjJScrollPane1 = new javax.swing.JScrollPane();
				ivjJScrollPane1.setName("JScrollPane1");
				getJScrollPane1().setViewportView(getScrollPaneTable());
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjJScrollPane1;
	}

	/**
	 * Return the ScrollPaneTable property value.
	 * @return javax.swing.JTable
	 */
	private javax.swing.JTable getScrollPaneTable() {
		if (ivjScrollPaneTable == null) {
			try {
				ivjScrollPaneTable = new javax.swing.JTable();
				ivjScrollPaneTable.setName("ScrollPaneTable");
				getJScrollPane1().setColumnHeaderView(ivjScrollPaneTable.getTableHeader());
				ivjScrollPaneTable.setBounds(0, 0, 200, 200);
				ivjScrollPaneTable.setRowSelectionAllowed(false);
				ivjScrollPaneTable.setAutoCreateColumnsFromModel(false);
				ivjScrollPaneTable.addColumn(getTableColumnName());
				ivjScrollPaneTable.addColumn(getTableColumnArgumentName());
						//ivjScrollPaneTable.setCellEditor(new BindingsCellEditor());
				ivjScrollPaneTable.setModel(new BindingTableModel());
				ivjScrollPaneTable.addMouseListener(new MouseAdapter() {
					public void mouseClicked(MouseEvent e) {
						if ((getBindingTableModel() != null)
							&& (e.getClickCount() == 2)
							&& (SwingUtilities.isLeftMouseButton(e))) {
							int col = ivjScrollPaneTable.columnAtPoint(e.getPoint());

							if (col == 1) {
								int row = ivjScrollPaneTable.rowAtPoint(e.getPoint());

								if ((row >= 0) && (row < getBindingTableModel().getRowCount())) {
									ISpecificType specificType =
										getTypeForBinding(
											(IDependentType) getBindingTableModelDependentTypes().get(row));
									if (specificType != null)
										getBindingTableModel().setValueAt(specificType, row, col);
								}
							}
						}
					}
				});
					} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjScrollPaneTable;
	}

	/**
	 * Return the TableColumnArgumentName property value.
	 * @return javax.swing.table.TableColumn
	 */
	private javax.swing.table.TableColumn getTableColumnArgumentName() {
		if (ivjTableColumnArgumentName == null) {
			try {
				ivjTableColumnArgumentName = new javax.swing.table.TableColumn();
				ivjTableColumnArgumentName.setModelIndex(1);
				ivjTableColumnArgumentName.setHeaderValue("Type");
						/*
				_jComboBox = new BoundJComboBox();
				_jComboBox.setRenderer(new de.uniwue.ki.gui.util.NamedCellRenderer());
				ivjTableColumnArgumentName.setCellEditor(new DefaultCellEditor(_jComboBox));
				*/
				ivjTableColumnArgumentName.setCellEditor(null);
					} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjTableColumnArgumentName;
	}

	/**
	 * Return the TableColumnName property value.
	 * @return javax.swing.table.TableColumn
	 */
	private javax.swing.table.TableColumn getTableColumnName() {
		if (ivjTableColumnName == null) {
			try {
				ivjTableColumnName = new javax.swing.table.TableColumn();
				ivjTableColumnName.setHeaderValue("Name");
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjTableColumnName;
	}

	protected ISpecificType getTypeForBinding(IDependentType argDep) {
			return DependentTypeBindingsDialog.askForSpecificTypeFor(
				argDep,
				getTypeList(),
				getGUISeSAmDeclaration(),
				this);
	}

	public java.util.List getTypeList() {
		return _typeList;
	}

	/**
	 * Called whenever the part throws an exception.
	 * @param exception Throwable
	 */
	private void handleException(Throwable exception) {

		exception.printStackTrace(System.out);
	}

	/**
	 * Initializes connections
	 * @exception Exception The exception description.
	 */
	private void initConnections() {
		getScrollPaneTable().addPropertyChangeListener(ivjEventHandler);
		connPtoP1SetTarget();
	}

	/**
	 * Initialize the class.
	 */
	private void initialize() {
		try {
					setName("ArgumentDependentBindings");
			setPreferredSize(new java.awt.Dimension(250, 100));
			setLayout(new java.awt.BorderLayout());
			setSize(250, 100);
			add(getJScrollPane1(), "Center");
			initConnections();
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	public static void main(String[] args) {
		try {
			JFrame frame = new javax.swing.JFrame();
			DependentTypeBindingsPanel aArgumentDependentBindings;
			aArgumentDependentBindings = new DependentTypeBindingsPanel();
			frame.setContentPane(aArgumentDependentBindings);
			frame.setSize(aArgumentDependentBindings.getSize());
			frame.addWindowListener(new java.awt.event.WindowAdapter() {
				public void windowClosing(java.awt.event.WindowEvent e) {
					System.exit(0);
				};
			});
			frame.setVisible(true);
		} catch (Throwable exception) {
			System.err.println("Exception occurred in main() of javax.swing.JPanel");
			exception.printStackTrace(System.out);
		}
	}

	/**
	 * Set the BindingTableModel to a new value.
	 * @param newValue de.uniwue.ki.gui.mas.model.basics.function.BindingTableModel
	 */
	private void setBindingTableModel(BindingTableModel newValue) {
		if (ivjBindingTableModel != newValue) {
			try {
				ivjBindingTableModel = newValue;
				connPtoP1SetSource();
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
	}

	/**
	 * Method generated to support the promotion of the bindingTableModelDependentTypeBindings attribute.
	 * @param arg1 de.uniwue.ki.mas.model.basics.type.DependentTypeBindings
	 */
	public void setBindingTableModelDependentTypeBindings(
		de.uniwue.ki.mas.basics.type.dependent.DependentTypeBindings arg1) {
		getBindingTableModel().setDependentTypeBindings(arg1);
	}

	/**
	 * Method generated to support the promotion of the bindingTableModelDependentTypes attribute.
	 * @param arg1 java.util.List
	 */
	public void setBindingTableModelDependentTypes(java.util.List arg1) {
		getBindingTableModel().setDependentTypes(arg1);
	}

	/**
	 * Sets the everyThingBound property (boolean) value.
	 * @param everyThingBound The new value for the property.
	 * @see #getEveryThingBound
	 */
	public void setEveryThingBound(boolean everyThingBound) {
		boolean oldValue = fieldEveryThingBound;
		fieldEveryThingBound = everyThingBound;
		firePropertyChange("everyThingBound", Boolean.valueOf(oldValue), Boolean.valueOf(everyThingBound));
	}

	public void setTypeList(List newTypeList) {
		_typeList = newTypeList;

		if (_jComboBox != null)
			_jComboBox.setListData(createCorrectTypeList(newTypeList));
	}
}
