package de.uniwue.ki.gui.mas.basics.type.dependent;

import javax.swing.JFrame;
import javax.swing.JPanel;

import de.uniwue.ki.mas.basics.type.GenericListType;
import de.uniwue.ki.mas.basics.type.dependent.*;
/**
 * Creation date: (31.05.00 19:01:10)
 * @author Christoph Oechslein
 */
class TestBindingPanel extends JPanel {
	private DependentTypeBindingsPanel ivjDependentTypeBindings = null;

	/**
	 * TestBindingPanel constructor comment.
	 */
	public TestBindingPanel() {
		super();
		initialize();
	}

	public static void main(String[] args) {
		try {
			JFrame frame = new javax.swing.JFrame();
			TestBindingPanel aTestBindingPanel;
			aTestBindingPanel = new TestBindingPanel();
			frame.setContentPane(aTestBindingPanel);
			frame.setSize(aTestBindingPanel.getSize());
			frame.addWindowListener(new java.awt.event.WindowAdapter() {
				public void windowClosing(java.awt.event.WindowEvent e) {
					System.exit(0);
				}
			});
			frame.setVisible(true);
		} catch (Throwable exception) {
			System.err.println("Exception occurred in main() of javax.swing.JPanel");
			exception.printStackTrace(System.out);
		}
	}

	/**
	 * Return the DependentTypeBindings property value.
	 * @return de.uniwue.ki.gui.mas.model.basics.function.DependentTypeBindings
	 */
	private DependentTypeBindingsPanel getDependentTypeBindings() {
		if (ivjDependentTypeBindings == null) {
			try {
				ivjDependentTypeBindings = new DependentTypeBindingsPanel();
				ivjDependentTypeBindings.setName("DependentTypeBindings");
				ivjDependentTypeBindings.setBindingTableModelDependentTypes(
					java.util.Arrays.asList(
						new Object[] {
							new UnconstraintDependentType("first Arg to function"),
							new UnconstraintDependentType("second Arg to function"),
							new ConstraintGenericDependentType(
								"third Arg to function",
								GenericListType.getInstance())}));
				ivjDependentTypeBindings.setBindingTableModelDependentTypeBindings(
					new DependentTypeBindings(
						ivjDependentTypeBindings.getBindingTableModelDependentTypes().iterator()));
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjDependentTypeBindings;
	}

	/**
	 * Called whenever the bean information class throws an exception.
	 * @param exception Throwable
	 */
	private void handleException(Throwable exception) {

		exception.printStackTrace(System.out);
	}

	/**
	 * Initialize the class.
	 */
	private void initialize() {
		try {
					setName("TestBindingPanel");
			setLayout(new java.awt.BorderLayout());
			setSize(243, 199);
			add(getDependentTypeBindings(), "Center");
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}
}