package de.uniwue.ki.gui.mas.basics.type.user;

import java.awt.Container;

import javax.swing.WindowConstants;

import de.uniwue.ki.gui.mas.basics.type.ComposedTypeHierarchicalViewPanel;
import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.model.JInternalFrameFactory;
import de.uniwue.ki.gui.util.SwingMoreUtilities;
import de.uniwue.ki.gui.util.actions.AbstractBoundAction;
import de.uniwue.ki.mas.basics.type.composed.ISpecificComposedType;
import de.uniwue.ki.mas.basics.type.user.IUserTypeDeclaration;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * @author Reinhard Hatko
 * 
 * 16.01.2004
 */
public class ComposedTypeHierarchicalViewAction extends AbstractBoundAction{
	
	private IGUISeSAmDeclaration _guiSeSAmDeclaration;
	private Container _parent;
	private ISpecificComposedType _comType;

	public ComposedTypeHierarchicalViewAction(
	  Container parent,
	  IDeclaration anDeclaration,
	  IGUISeSAmDeclaration guiSeSAmDeclaration) {

		this(parent, ((IUserTypeDeclaration) anDeclaration).getSpecificComposedType(), guiSeSAmDeclaration);

	}
	
	public ComposedTypeHierarchicalViewAction(
		Container parent,
		ISpecificComposedType comType,
		IGUISeSAmDeclaration guiSeSAmDeclaration) {
	
	  super("View Hierarchy", SwingMoreUtilities.getJavaSunIcon(16, "general/Properties16.gif"));
		
	  _guiSeSAmDeclaration = guiSeSAmDeclaration;
	  _parent = parent;
	  _comType = comType;
	  
	}
	
	public void doit() {
	    final ComposedTypeHierarchicalViewPanel panel = new ComposedTypeHierarchicalViewPanel(
				_comType, _guiSeSAmDeclaration.getSeSAmDeclaration());
	    
	    
		SwingMoreUtilities.invokeWithIndeterminateProgressbar(_parent,
                "Hierarchy of " + _comType.getName(),
                "Hierarchy of " + _comType.getName(), 
                new Runnable() {
                    public void run() {
                        ((JInternalFrameFactory) (_guiSeSAmDeclaration
                                .getFrameFactory())).addPanel(_parent,
                                "Hierarchy of " + _comType.getName(),
                                panel, true, WindowConstants.DISPOSE_ON_CLOSE,
                                new Runnable() {
                                    public void run() {
                                        panel.dispose();
                                    }
                                });
                    }
			}
		);
	}

	private String getDeclarationFrameTitle(IDeclaration declaration) {
		return "Hierarchical view for " + declaration.getName();
	}
}