package de.uniwue.ki.gui.mas.basics.type.user;

import java.awt.Container;
import java.util.Iterator;

import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.util.SwingMoreUtilities;
import de.uniwue.ki.gui.util.actions.AbstractBoundAction;
import de.uniwue.ki.mas.basics.type.composed.IComposedTypeAttribute;
import de.uniwue.ki.mas.basics.type.composed.SpecificComposedType;
import de.uniwue.ki.mas.basics.type.user.IUserTypeDeclaration;
import de.uniwue.ki.mas.entity.objectclass.IRessourceClassDeclaration;
import de.uniwue.ki.mas.entity.objectclass.IRessourceClassDeclarationListAndFactory;
import de.uniwue.ki.mas.entity.variableclass.*;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * @author herrler
 */

public class ConvertToRessourcePanelAction extends AbstractBoundAction {
	private IGUISeSAmDeclaration _guiSeSAmDeclaration;
	private IDeclaration _declaration;

	public ConvertToRessourcePanelAction(
		Container parent,
		IDeclaration anDeclaration,
		IGUISeSAmDeclaration guiSeSAmDeclaration) {

		super("Convert Type to Ressource", SwingMoreUtilities.getJavaSunIcon(16, "general/Properties16.gif"));
		_guiSeSAmDeclaration = guiSeSAmDeclaration;
		_declaration = anDeclaration;
	}

	public void doit() {	
		IUserTypeDeclaration userType = (IUserTypeDeclaration)_declaration;
		if (!userType.isComposedType()) return;
		
		SpecificComposedType composedType = userType.getSpecificComposedType();
		
		// Create new Agent and add him to Model
		IRessourceClassDeclarationListAndFactory agentClassFactoryAndList = _guiSeSAmDeclaration.getSeSAmDeclaration().getSeSAmModelDeclaration().getRessourceClassDeclarationListAndFactory();
		IRessourceClassDeclaration agentDecl = agentClassFactoryAndList.getRessourceClassDeclarationFactory().createRessourceClassDeclaration();
		agentClassFactoryAndList.getRessourceClassDeclarationList().add(agentDecl);
		agentDecl.setShortDescription(userType.getName()+"Ressource");
		agentDecl.setDocumentation("Ressource automatically generated from the ComposedType "+userType.getName());
		
		
		// Add Attributes of the Composed Type to the new Agent 
		BodyVariableClassDeclarationListAndFactory variableListAndFactory = agentDecl.getBodyClassDeclaration().getBodyVariableClassDeclarationListAndFactory();
		BodyVariableClassDeclarationFactory variableFactory = variableListAndFactory.getBodyVariableClassDeclarationFactory();
		BodyVariableClassDeclarationList variableList = variableListAndFactory.getBodyVariableClassDeclarationList();
		
		Iterator it = composedType.getAttributes();
		
		while (it.hasNext()) {
			IComposedTypeAttribute attribute = (IComposedTypeAttribute) it.next();
			IBodyVariableClassDeclaration variable = variableFactory.createBodyVariableClassDeclaration();
			variable.getVariableClassDeclaration().setShortDescription(attribute.getAttributeName());
			variable.getVariableClassDeclaration().setSpecificType(attribute.getAttributeType());
			variableList.add(variable);
		}
	}
}
