package de.uniwue.ki.gui.mas.basics.type.user;

import javax.swing.BoxLayout;
import javax.swing.JOptionPane;

import com.magelang.box.VerticalStrut;

import de.uniwue.ki.gui.mas.util.declaration.AbstractDeclarationPanel;
import de.uniwue.ki.gui.mas.util.declaration.NameDeclarationWithDocumentationPanel;
import de.uniwue.ki.gui.util.JEditMutableListPanel;
import de.uniwue.ki.gui.util.NamedCellRendererAdapter;
import de.uniwue.ki.gui.util.dnd.ObjectDataFlavor;
import de.uniwue.ki.mas.basics.type.enum.EnumItem;
import de.uniwue.ki.mas.basics.type.user.IUserTypeDeclaration;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: 04.07.2002, 18:19:54
 * @author oechslein
 */
public class EnumTypeDeclarationPanel extends AbstractDeclarationPanel {
	private IUserTypeDeclaration _userTypeDeclaration;

	private final JEditMutableListPanel _editList = new JEditMutableListPanel() {
		public void editItem(Object obj) {
			EnumItem enumItem = (EnumItem) obj;

			String result =
				JOptionPane.showInputDialog(EnumTypeDeclarationPanel.this, "New Name", enumItem.getName());

			if (result != null)
				enumItem.setName(result);

		}

		public void popupItem(Object clickedObject, int x, int y) {
		}
	};

	private final NameDeclarationWithDocumentationPanel _nameDeclarationWithDocumentationPanel =
		new NameDeclarationWithDocumentationPanel();

	public EnumTypeDeclarationPanel() {
		super();

		setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));

		add(_nameDeclarationWithDocumentationPanel);

		add(new VerticalStrut(5));

		add(_editList);

		_editList.setCellRenderer(new NamedCellRendererAdapter(_editList.getCellRenderer()));
		_editList.enableDnDSupport(ObjectDataFlavor.getDataFlavor(EnumItem.class));
	}

	public IDeclaration getDeclaration() {
		return getUserTypeDeclaration();
	}

	public void setDeclaration(IDeclaration declaration) {
		setUserTypeDeclaration((IUserTypeDeclaration) declaration);
	}

	public IUserTypeDeclaration getUserTypeDeclaration() {
		return _userTypeDeclaration;
	}

	public void setUserTypeDeclaration(IUserTypeDeclaration userTypeDeclaration) {
		_userTypeDeclaration = userTypeDeclaration;

		if (userTypeDeclaration != null) {
			_editList.setMutableListModelAndFactory(
				userTypeDeclaration.getSpecificEnumType().getItemListAndFactory());

			_nameDeclarationWithDocumentationPanel.setDeclaration(userTypeDeclaration);
		}
	}

}
