package de.uniwue.ki.gui.mas.basics.type.user;
import java.awt.Container;
import java.util.Iterator;

import de.uniwue.ki.gui.mas.model.DefaultMutableListModelAndFactoryPanelActionFactory;
import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.util.actions.AbstractBoundAction;
import de.uniwue.ki.mas.basics.type.TypeManager;
import de.uniwue.ki.mas.basics.type.composed.ISpecificComposedType;
import de.uniwue.ki.mas.basics.type.user.UserTypeDeclarationListAndFactory;
import de.uniwue.ki.util.collection.CollectionsHelper;
import de.uniwue.ki.util.list.IMutableListModelAndFactory;
/**
 * Creation date: (21.01.2002 20:09:18)
 * @author Christoph Oechslein
 */
public class UserTypeDeclarationListActionFactory
	extends DefaultMutableListModelAndFactoryPanelActionFactory {
	public UserTypeDeclarationListActionFactory(IGUISeSAmDeclaration guiSeSAmDeclaration) {
		super(guiSeSAmDeclaration);
	}

	protected Object createNewObject(
		Container parent,
		IMutableListModelAndFactory mutableListModelAndFactory)
		throws Exception {

		return UserTypeDeclarationListPanel.createUserDefinedTypeDeclaration(
			parent,
			getGUISeSAmDeclaration());
	}

	public boolean getCanProduceActions(Container parent, Object anObject) {
		return (getGUISeSAmDeclaration() != null)
			&& (anObject instanceof UserTypeDeclarationListAndFactory);
	}

	protected AbstractBoundAction createNewAction(
		Container parent,
		IMutableListModelAndFactory mutableListModelAndFactory) {
		return null;
	}

	private AbstractBoundAction createNewUserTypeAction(
		final Container parent,
		final UserTypeDeclarationListAndFactory userDefinedTypeDeclarationListAndFactory,
		final boolean composedType) {

		return new AbstractBoundAction(composedType ? "New Comp." : "New Enum.", _newIcon) {
			public void doit() {
				userDefinedTypeDeclarationListAndFactory.getUserTypeDeclarationList().add(
					userDefinedTypeDeclarationListAndFactory
						.getUserTypeDeclarationFactory()
						.createUserTypeDeclaration(composedType));
			}
		};
	}
	
	private AbstractBoundAction viewComposedTypeHierarchyAction(Container parent){
		ISpecificComposedType rootType =
			(ISpecificComposedType) TypeManager.getSpecificTypeByName(
				"RootType",
				TypeManager.getInstance().getSystemComposedTypes());
				 
		return new ComposedTypeHierarchicalViewAction(parent, rootType, getGUISeSAmDeclaration());
	}

	public Iterator getMoreActions(Container parent, Object anObject) {
		return CollectionsHelper.createConsIterator(
			createNewUserTypeAction(parent, (UserTypeDeclarationListAndFactory) anObject, true),
			createNewUserTypeAction(parent, (UserTypeDeclarationListAndFactory) anObject, false),
			viewComposedTypeHierarchyAction(parent),
			super.getMoreActions(parent, anObject));
	}

}