package de.uniwue.ki.gui.mas.basics.type.user;

import java.awt.Component;

import javax.swing.JOptionPane;

import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.util.declaration.DeclarationListPanel;
import de.uniwue.ki.gui.util.dnd.ObjectDataFlavor;
import de.uniwue.ki.mas.basics.type.user.*;
import de.uniwue.ki.util.Utils;

/**
 * Creation date: 04.07.2002, 17:34:08
 * @author oechslein
 */
public class UserTypeDeclarationListPanel extends DeclarationListPanel {

	public UserTypeDeclarationListPanel() {
		super();
		initialize();
	}

	private void initialize() {
		setDeclarationFactory(new UserTypeDeclarationFactory());
		setDeclarationListModel(new UserTypeDeclarationList());

		enableDnDSupport(ObjectDataFlavor.getDataFlavor(IUserTypeDeclaration.class));
		setCellRenderer(new UserTypeDeclarationCellRendererAdapter(getCellRenderer()));
	}

	protected Object createItem() throws Exception {
		return createUserDefinedTypeDeclaration(
			this,
			getUserDefinedTypeDeclarationFactory(),
			getGUISeSAmDeclaration());
	}

	public static IUserTypeDeclaration createUserDefinedTypeDeclaration(
		Component parent,
		IGUISeSAmDeclaration guiSeSAmDeclaration) {

		if (guiSeSAmDeclaration == null)
			return null;
		else
			return createUserDefinedTypeDeclaration(
				parent,
				guiSeSAmDeclaration
					.getSeSAmModelDeclaration()
					.getSeSAmModelBasicsDeclaration()
					.getUserTypeDeclarationListAndFactory()
					.getUserTypeDeclarationFactory(),
				guiSeSAmDeclaration);

	}

	public static IUserTypeDeclaration createUserDefinedTypeDeclaration(
		Component parent,
		UserTypeDeclarationFactory userDefinedTypeDeclarationFactory,
		IGUISeSAmDeclaration guiSeSAmDeclaration) {

		if (userDefinedTypeDeclarationFactory == null)
			return null;

		Object result =
			JOptionPane.showInputDialog(
				parent,
				null,
				"Choose User Type",
				JOptionPane.QUESTION_MESSAGE,
				null,
				new Object[] { "Composed", "Enumeration" },
				"Composed");

		if (Utils.equals("Composed", result)) {
			return userDefinedTypeDeclarationFactory.createUserTypeDeclaration(true);

		} else if (Utils.equals("Enumeration", result)) {
			return userDefinedTypeDeclarationFactory.createUserTypeDeclaration(false);

		} else {
			return null;
		}
	}

	public UserTypeDeclarationFactory getUserDefinedTypeDeclarationFactory() {
		return (UserTypeDeclarationFactory)getDeclarationFactory();
	}

}
