package de.uniwue.ki.gui.mas.basics.type.user;
import java.awt.Container;
import java.util.Iterator;
import java.util.LinkedList;

import de.uniwue.ki.gui.mas.basics.search.SearchChildrenDeclarationPanelAction;
import de.uniwue.ki.gui.mas.basics.search.SearchDeclarationPanelAction;
import de.uniwue.ki.gui.mas.model.AbstractDeclarationPanelAndActionFactory;
import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.util.declaration.IDeclarationPanelFactory;
import de.uniwue.ki.mas.basics.type.user.IUserTypeDeclaration;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: (10.10.2001 11:09:49)
 * @author Christoph Oechslein
 */

public class UserTypeDeclarationPanelActionFactory extends AbstractDeclarationPanelAndActionFactory {

	private final UserTypeDeclarationPanelFactory _userTypeDeclarationPanelFactory =
		new UserTypeDeclarationPanelFactory();

	public UserTypeDeclarationPanelActionFactory() {
		super();
	}

	public UserTypeDeclarationPanelActionFactory(IGUISeSAmDeclaration guiSeSAmDeclaration) {
		super();

		setGUISeSAmDeclaration(guiSeSAmDeclaration);
	}

	protected boolean getCanProduceDeclarationActions(Container parent, IDeclaration anDeclaration) {
		return (anDeclaration instanceof IUserTypeDeclaration);
	}

	public IDeclarationPanelFactory getDeclarationPanelFactory(
		Container parent,
		IDeclaration anDeclaration) {
		return _userTypeDeclarationPanelFactory;
	}

	protected Iterator getImportantDeclarationActions(Container parent, IDeclaration anDeclaration) {
		LinkedList importantActions = new LinkedList();
		importantActions.add(
			new SearchDeclarationPanelAction(parent, anDeclaration, getGUISeSAmDeclaration()));
		if (((IUserTypeDeclaration)anDeclaration).isComposedType()) {
			importantActions.add(
				new ConvertToAgentPanelAction(parent, anDeclaration, getGUISeSAmDeclaration()));
			importantActions.add(
				new ConvertToRessourcePanelAction(parent, anDeclaration, getGUISeSAmDeclaration()));
			importantActions.add(
				new SearchChildrenDeclarationPanelAction(parent, anDeclaration, getGUISeSAmDeclaration()));
			importantActions.add(
				new ComposedTypeHierarchicalViewAction(parent, anDeclaration, getGUISeSAmDeclaration()));
		}
		return importantActions.iterator();
	}

	public void setGUISeSAmDeclaration(IGUISeSAmDeclaration newGUISeSAmDeclaration) {
		super.setGUISeSAmDeclaration(newGUISeSAmDeclaration);

		_userTypeDeclarationPanelFactory.setGUISeSAmDeclaration(newGUISeSAmDeclaration);
	}

	protected boolean shouldUseOkCancelDeclarationPanel(Container parent, IDeclaration anDeclaration) {
		return false;
	}
}