package de.uniwue.ki.gui.mas.basics.type.user;
import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.util.declaration.*;
import de.uniwue.ki.mas.basics.type.user.IUserTypeDeclaration;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: (12.10.2001 17:40:16)
 * @author Christoph Oechslein
 */

public class UserTypeDeclarationPanelFactory extends AbstractDeclarationPanelFactory {
	private IGUISeSAmDeclaration _guiSeSAmDeclaration;

	public IDeclarationPanel createDeclarationPanel(IDeclaration declaration) {
		IUserTypeDeclaration userTypeDeclaration = (IUserTypeDeclaration)declaration;

		IDeclarationPanel userTypePanel = createUserTypeDeclarationPanel(userTypeDeclaration);

		userTypePanel.setGUISeSAmDeclaration(getGUISeSAmDeclaration());
		userTypePanel.setDeclaration(userTypeDeclaration);

		return userTypePanel;
	}

	private IDeclarationPanel createUserTypeDeclarationPanel(IUserTypeDeclaration userTypeDeclaration) {
		if (userTypeDeclaration.isComposedType()) {
			return new NameDeclarationWithDocumentationAdapterPanel(
				new ComposedTypeDeclarationPanel(getGUISeSAmDeclaration()));
		} else
			return new EnumTypeDeclarationPanel();

	}

	public String getDeclarationTitle(IDeclaration declaration) {
		if (((IUserTypeDeclaration)declaration).isComposedType())
			return "Composed Type";
		else
			return "Enum Type";
	}

	public IGUISeSAmDeclaration getGUISeSAmDeclaration() {
		return _guiSeSAmDeclaration;
	}

	public void setGUISeSAmDeclaration(IGUISeSAmDeclaration newGUISeSAmDeclaration) {
		_guiSeSAmDeclaration = newGUISeSAmDeclaration;
	}
}