package de.uniwue.ki.gui.mas.behaviour.activityGraph;
import mygale.mcge.core.JGraph;
import mygale.mcge.core.JGraphEditor;
import mygale.mcge.undoredo.UndoRedoManager;
import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.mas.behaviour.activityGraphDeclaration.IActivityGraphDeclaration;
import de.uniwue.ki.mas.entity.objectclass.agentclass.IActivityAgentClassDeclaration;

/**
 * Creation date: (21.03.2001 17:37:53)
 * @author Christoph Oechslein
 */

public class ActivityGraphDeclarationGraphEditor extends JGraphEditor {
	private IActivityAgentClassDeclaration _activityAgentClassDeclarationIntern = null;
	private IGUISeSAmDeclaration _guiSeSAmDeclaration = null;

	public ActivityGraphDeclarationGraphEditor() {
		super();
		initialize();
	}

	public ActivityGraphDeclarationGraphEditor(UndoRedoManager undoredo) {
		super(undoredo);

		initialize();
	}

	public void dispose() {
		setActivityAgentClassDeclaration(null);

		super.dispose();
	}

	public IActivityAgentClassDeclaration getActivityAgentClassDeclaration() {
		return _activityAgentClassDeclarationIntern;
	}

	public IActivityGraphDeclaration getComposedActivityDeclaration() {
		if (getComposedActivityDeclarationGraph() != null) {
			return getComposedActivityDeclarationGraph().getActivityGraphDeclaration();
		} else {
			return null;
		}
	}

	protected ActivityGraphDeclarationGraph getComposedActivityDeclarationGraph() {
		return (ActivityGraphDeclarationGraph) getGraph();
	}

	public IGUISeSAmDeclaration getGUISeSAmDeclaration() {
		return _guiSeSAmDeclaration;
	}

	private void initialize() {
		setName("ComposedActivityDeclarationGraphEditor");
		setSize(500, 561);
	}

	protected JGraph makeGraph() {
		return new ActivityGraphDeclarationGraph(this);
	}

	public void setActivityAgentClassDeclaration(IActivityAgentClassDeclaration newValue) {
		if (_activityAgentClassDeclarationIntern != newValue) {
			IActivityAgentClassDeclaration oldValue = getActivityAgentClassDeclaration();
			_activityAgentClassDeclarationIntern = newValue;
			firePropertyChange("activityAgentClassDeclaration", oldValue, newValue);
		}
	}

	public void setComposedActivityDeclaration(IActivityGraphDeclaration composedActivityDeclaration) {
		getComposedActivityDeclarationGraph().setActivityGraphDeclaration(composedActivityDeclaration);
		invalidate();
		repaint();
	}

	public void setGUISeSAmDeclaration(IGUISeSAmDeclaration gUISeSAmDeclaration) {
		if (gUISeSAmDeclaration != getGUISeSAmDeclaration()) {
			IGUISeSAmDeclaration oldGUISeSAmDeclaration = getGUISeSAmDeclaration();
			_guiSeSAmDeclaration = gUISeSAmDeclaration;

			if (getGUISeSAmDeclaration() != null) {
				getGraph().setFigMapper(getGUISeSAmDeclaration().getFigMapper());
			}

			firePropertyChange("gUISeSAmDeclaration()", oldGUISeSAmDeclaration, getGUISeSAmDeclaration());
		}
	}
}