package de.uniwue.ki.gui.mas.behaviour.activityGraph;
import java.awt.*;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import javax.swing.JFrame;
import javax.swing.JLabel;

import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.util.declaration.AbstractDeclarationPanel;
import de.uniwue.ki.mas.behaviour.activityGraphDeclaration.IActivityGraphDeclaration;
import de.uniwue.ki.mas.entity.objectclass.agentclass.IActivityAgentClassDeclaration;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: (22.03.2001 13:44:30)
 * 
 * @author Christoph Oechslein
 */

public class ActivityGraphDeclarationGraphPanel extends AbstractDeclarationPanel {

    private ActivityGraphDeclarationGraphEditor _composedActivityDeclarationGraphEditor;
    private final EventHandler _eventHandler = new EventHandler();
    private boolean ivjConnPtoP1Aligning;
    private JLabel _statusBar;

    private final class EventHandler implements PropertyChangeListener {
        public void propertyChange(PropertyChangeEvent evt) {
            if (evt.getSource()
                == ActivityGraphDeclarationGraphPanel.this.getComposedActivityDeclarationGraphEditor()
                && (evt.getPropertyName().equals("statusMsg")))
                connEtoC2(evt);
            if (evt.getSource()
                == ActivityGraphDeclarationGraphPanel.this.getComposedActivityDeclarationGraphEditor()
                && (evt.getPropertyName().equals("composedActivityDeclaration")))
                connEtoC3(evt);
            if (evt.getSource()
                == ActivityGraphDeclarationGraphPanel.this.getComposedActivityDeclarationGraphEditor()
                && (evt.getPropertyName().equals("activityAgentClassDeclaration")))
                connEtoC5(evt);
            if (evt.getSource()
                == ActivityGraphDeclarationGraphPanel.this.getComposedActivityDeclarationGraphEditor()
                && (evt.getPropertyName().equals("gUISeSAmDeclaration")))
                connPtoP1SetTarget();
            if (evt.getSource() == ActivityGraphDeclarationGraphPanel.this
                && (evt.getPropertyName().equals("gUISeSAmDeclaration")))
                connPtoP1SetSource();
        }
    }

    public ActivityGraphDeclarationGraphPanel() {
        super();
        initialize();
    }

    private void connEtoC2(PropertyChangeEvent arg1) {
        try {

            this.firePropertyChange("statusMsg", arg1.getOldValue(), arg1.getNewValue());

        } catch (Throwable ivjExc) {

            handleException(ivjExc);
        }
    }

    private void connEtoC3(PropertyChangeEvent arg1) {
        try {

            this.firePropertyChange("composedActivityDeclaration", arg1.getOldValue(), arg1.getNewValue());

        } catch (Throwable ivjExc) {

            handleException(ivjExc);
        }
    }

    private void connEtoC5(PropertyChangeEvent arg1) {
        try {

            this.firePropertyChange("activityAgentClassDeclaration", arg1.getOldValue(), arg1.getNewValue());

        } catch (Throwable ivjExc) {

            handleException(ivjExc);
        }
    }

    private void connPtoP1SetSource() {

        try {
            if (ivjConnPtoP1Aligning == false) {

                ivjConnPtoP1Aligning = true;
                getComposedActivityDeclarationGraphEditor().setGUISeSAmDeclaration(
                    this.getGUISeSAmDeclaration());

                ivjConnPtoP1Aligning = false;
            }
        } catch (Throwable ivjExc) {
            ivjConnPtoP1Aligning = false;

            handleException(ivjExc);
        }
    }

    private void connPtoP1SetTarget() {

        try {
            if (ivjConnPtoP1Aligning == false) {

                ivjConnPtoP1Aligning = true;
                this.setGUISeSAmDeclaration(
                    getComposedActivityDeclarationGraphEditor().getGUISeSAmDeclaration());

                ivjConnPtoP1Aligning = false;
            }
        } catch (Throwable ivjExc) {
            ivjConnPtoP1Aligning = false;

            handleException(ivjExc);
        }
    }

    private void connPtoP2SetTarget() {

        try {
            getComposedActivityDeclarationGraphEditor().setStatusBar(getJStatusBar());

        } catch (Throwable ivjExc) {

            handleException(ivjExc);
        }
    }

    public void dispose() {
        getComposedActivityDeclarationGraphEditor().dispose();

        super.dispose();
    }

    public IActivityAgentClassDeclaration getActivityAgentClassDeclaration() {
        return getComposedActivityDeclarationGraphEditor().getActivityAgentClassDeclaration();
    }

    public IActivityGraphDeclaration getComposedActivityDeclaration() {
        return getComposedActivityDeclarationGraphEditor().getComposedActivityDeclaration();
    }

    private ActivityGraphDeclarationGraphEditor getComposedActivityDeclarationGraphEditor() {
        if (_composedActivityDeclarationGraphEditor == null) {
            _composedActivityDeclarationGraphEditor = new ActivityGraphDeclarationGraphEditor();
        }
        return _composedActivityDeclarationGraphEditor;
    }

    public IDeclaration getDeclaration() {
        return getComposedActivityDeclaration();
    }

    public IGUISeSAmDeclaration getGUISeSAmDeclaration() {
        return getComposedActivityDeclarationGraphEditor().getGUISeSAmDeclaration();
    }

    private JLabel getJStatusBar() {
        if (_statusBar == null) {
            try {
                _statusBar = new JLabel();
                _statusBar.setName("JStatusBar");
                _statusBar.setBorder(new de.uniwue.ki.gui.util.border.BetterBevelBorder());
                _statusBar.setText(" ");

            } catch (Throwable ivjExc) {

                handleException(ivjExc);
            }
        }
        return _statusBar;
    }

    private void handleException(Throwable exception) {

        exception.printStackTrace(System.out);
    }

    private void initConnections() {

        getComposedActivityDeclarationGraphEditor().addPropertyChangeListener(_eventHandler);
        this.addPropertyChangeListener(_eventHandler);
        connPtoP1SetTarget();
        connPtoP2SetTarget();
    }

    private void initialize() {
        setLayout(new GridBagLayout());
        setSize(571, 479);

        GridBagConstraints constraintsComposedActivityDeclarationGraphEditor = new GridBagConstraints();
        constraintsComposedActivityDeclarationGraphEditor.gridx = 0;
        constraintsComposedActivityDeclarationGraphEditor.gridy = 0;
        constraintsComposedActivityDeclarationGraphEditor.fill = GridBagConstraints.BOTH;
        constraintsComposedActivityDeclarationGraphEditor.weightx = 1.0;
        constraintsComposedActivityDeclarationGraphEditor.weighty = 1.0;
        add(getComposedActivityDeclarationGraphEditor(), constraintsComposedActivityDeclarationGraphEditor);

        GridBagConstraints constraintsJStatusBar = new GridBagConstraints();
        constraintsJStatusBar.gridx = 0;
        constraintsJStatusBar.gridy = 1;
        constraintsJStatusBar.fill = GridBagConstraints.HORIZONTAL;
        constraintsJStatusBar.weightx = 1.0;
        add(getJStatusBar(), constraintsJStatusBar);
        initConnections();
    }

    public static void main(String[] args) {
        try {
            JFrame frame = new JFrame();
            ActivityGraphDeclarationGraphPanel aComposedActivityDeclarationGraphPanel =
                new ActivityGraphDeclarationGraphPanel();
            frame.setContentPane(aComposedActivityDeclarationGraphPanel);
            frame.setSize(aComposedActivityDeclarationGraphPanel.getSize());
            frame.addWindowListener(new WindowAdapter() {
                public void windowClosing(WindowEvent e) {
                    System.exit(0);
                }
            });
            frame.show();
            Insets insets = frame.getInsets();
            frame.setSize(
                frame.getWidth() + insets.left + insets.right,
                frame.getHeight() + insets.top + insets.bottom);
            frame.setVisible(true);
        } catch (Throwable exception) {
            System.err.println("Exception occurred in main() of JPanel");
            exception.printStackTrace(System.out);
        }
    }

    public void setActivityAgentClassDeclaration(IActivityAgentClassDeclaration arg1) {
        getComposedActivityDeclarationGraphEditor().setActivityAgentClassDeclaration(arg1);
    }

    public void setComposedActivityDeclaration(IActivityGraphDeclaration arg1) {
        getComposedActivityDeclarationGraphEditor().setComposedActivityDeclaration(arg1);
    }

    public void setDeclaration(IDeclaration declaration) {
        setComposedActivityDeclaration((IActivityGraphDeclaration) declaration);
    }

    public void setGUISeSAmDeclaration(IGUISeSAmDeclaration guiSeSAmDeclaration) {
        getComposedActivityDeclarationGraphEditor().setGUISeSAmDeclaration(guiSeSAmDeclaration);
    }

    public void setStatusMsg(String arg1) {
        getComposedActivityDeclarationGraphEditor().setStatusMsg(arg1);
    }
}