package de.uniwue.ki.gui.mas.behaviour.activityGraph;
import java.awt.FlowLayout;

import javax.swing.ComboBoxModel;
import javax.swing.DefaultComboBoxModel;

import de.uniwue.ki.gui.mas.util.declaration.AbstractDeclarationPanel;
import de.uniwue.ki.gui.util.NamedCellRendererAdapter;
import de.uniwue.ki.mas.behaviour.activityGraphDeclaration.IActivityGraphNodeDeclarationTypeable;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: (15.03.2002 10:23:07)
 * @author Christoph Oechslein
 */
public class ActivityGraphNodeTypeableComboBoxPanel extends AbstractDeclarationPanel {
	private static ComboBoxModel _allTypesComboBoxModel =
		new DefaultComboBoxModel(
			new Object[] {
				IActivityGraphNodeDeclarationTypeable.ACTIVITY_LIKE,
				IActivityGraphNodeDeclarationTypeable.STATE_LIKE,
				IActivityGraphNodeDeclarationTypeable.SIGNAL_IN_LIKE,
				IActivityGraphNodeDeclarationTypeable.SIGNAL_OUT_LIKE });
	private IActivityGraphNodeDeclarationTypeable ivjActivityDeclarationTypeableIntern = null;
	private boolean ivjConnPtoP1Aligning = false;
	private final IvjEventHandler ivjEventHandler = new IvjEventHandler();
	private com.ibm.easyswing.BoundJComboBox ivjTypeComboBox = null;

	private final class IvjEventHandler implements java.beans.PropertyChangeListener {
		public void propertyChange(java.beans.PropertyChangeEvent evt) {
			if (evt.getSource()
				== ActivityGraphNodeTypeableComboBoxPanel.this.getActivityDeclarationTypeableIntern())
				connPtoP1SetTarget();
			if (evt.getSource() == ActivityGraphNodeTypeableComboBoxPanel.this.getTypeComboBox()
				&& (evt.getPropertyName().equals("selectedItem")))
				connPtoP1SetSource();
		};
	};

	public ActivityGraphNodeTypeableComboBoxPanel() {
		super();
		initialize();
	}

	private void connPtoP1SetSource() {
		try {
			if (ivjConnPtoP1Aligning == false) {
				ivjConnPtoP1Aligning = true;
				if ((getActivityDeclarationTypeableIntern() != null)) {
					getActivityDeclarationTypeableIntern().setType(
						(de
							.uniwue
							.ki
							.mas
							.behaviour
							.activityGraphDeclaration
							.IActivityGraphNodeDeclarationTypeable
							.Type) getTypeComboBox()
							.getSelectedItem());
				}
				ivjConnPtoP1Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP1Aligning = false;
			handleException(ivjExc);
		}
	}

	private void connPtoP1SetTarget() {
		try {
			if (ivjConnPtoP1Aligning == false) {
				ivjConnPtoP1Aligning = true;
				if ((getActivityDeclarationTypeableIntern() != null)) {
					getTypeComboBox().setSelectedItem(getActivityDeclarationTypeableIntern().getType());
				}
				ivjConnPtoP1Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP1Aligning = false;
			handleException(ivjExc);
		}
	}

	public IActivityGraphNodeDeclarationTypeable getActivityDeclarationTypeable() {
		return getActivityDeclarationTypeableIntern();
	}

	private IActivityGraphNodeDeclarationTypeable getActivityDeclarationTypeableIntern() {
		return ivjActivityDeclarationTypeableIntern;
	}

	private FlowLayout getActivityTypeableComboBoxPanelFlowLayout() {
		java.awt.FlowLayout ivjActivityTypeableComboBoxPanelFlowLayout = null;
		try {
			/* Create part */
			ivjActivityTypeableComboBoxPanelFlowLayout = new java.awt.FlowLayout();
			ivjActivityTypeableComboBoxPanelFlowLayout.setAlignment(java.awt.FlowLayout.RIGHT);
			ivjActivityTypeableComboBoxPanelFlowLayout.setVgap(0);
			ivjActivityTypeableComboBoxPanelFlowLayout.setHgap(0);
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		};
		return ivjActivityTypeableComboBoxPanelFlowLayout;
	}

	public de.uniwue.ki.mas.util.declaration.IDeclaration getDeclaration() {
		return null;
	}

	private com.ibm.easyswing.BoundJComboBox getTypeComboBox() {
		if (ivjTypeComboBox == null) {
			try {
				ivjTypeComboBox = new com.ibm.easyswing.BoundJComboBox();
				ivjTypeComboBox.setName("TypeComboBox");
				ivjTypeComboBox.setRenderer(new NamedCellRendererAdapter(ivjTypeComboBox.getRenderer()));
				ivjTypeComboBox.setModel(_allTypesComboBoxModel);
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjTypeComboBox;
	}

	private void handleException(Throwable exception) {
		exception.printStackTrace(System.out);
	}

	private void initConnections() {
		getTypeComboBox().addPropertyChangeListener(ivjEventHandler);
		connPtoP1SetTarget();
	}

	private void initialize() {
		try {
			setName("ActivityTypeableComboBoxPanel");
			setLayout(getActivityTypeableComboBoxPanelFlowLayout());
			setSize(133, 25);
			add(getTypeComboBox(), getTypeComboBox().getName());
			initConnections();
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	public static void main(String[] args) {
		try {
			javax.swing.JFrame frame = new javax.swing.JFrame();
			ActivityGraphNodeTypeableComboBoxPanel aActivityTypeableComboBoxPanel;
			aActivityTypeableComboBoxPanel = new ActivityGraphNodeTypeableComboBoxPanel();
			frame.setContentPane(aActivityTypeableComboBoxPanel);
			frame.setSize(aActivityTypeableComboBoxPanel.getSize());
			frame.addWindowListener(new java.awt.event.WindowAdapter() {
				public void windowClosing(java.awt.event.WindowEvent e) {
					System.exit(0);
				}
			});
			frame.show();
			java.awt.Insets insets = frame.getInsets();
			frame.setSize(
				frame.getWidth() + insets.left + insets.right,
				frame.getHeight() + insets.top + insets.bottom);
			frame.setVisible(true);
		} catch (Throwable exception) {
			System.err.println(
				"Exception occurred in main() of de.uniwue.ki.gui.mas.model.util.declaration.AbstractDeclarationPanel");
			exception.printStackTrace(System.out);
		}
	}

	public void setActivityDeclarationTypeable(
		de.uniwue.ki.mas.behaviour.activityGraphDeclaration.IActivityGraphNodeDeclarationTypeable arg1) {
		setActivityDeclarationTypeableIntern(arg1);
	}

	private void setActivityDeclarationTypeableIntern(
		de.uniwue.ki.mas.behaviour.activityGraphDeclaration.IActivityGraphNodeDeclarationTypeable newValue) {
		if (ivjActivityDeclarationTypeableIntern != newValue) {
			try {
				IActivityGraphNodeDeclarationTypeable oldValue =
					getActivityDeclarationTypeableIntern();
				/* Stop listening for events from the current object */
				if (ivjActivityDeclarationTypeableIntern != null) {
					ivjActivityDeclarationTypeableIntern.removePropertyChangeListener(ivjEventHandler);
				}
				ivjActivityDeclarationTypeableIntern = newValue;

				/* Listen for events from the new object */
				if (ivjActivityDeclarationTypeableIntern != null) {
					ivjActivityDeclarationTypeableIntern.addPropertyChangeListener(ivjEventHandler);
				}
				connPtoP1SetTarget();
				firePropertyChange("activityDeclarationTypeable", oldValue, newValue);
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		};
	}

	public void setDeclaration(IDeclaration declaration) {
	}
}