package de.uniwue.ki.gui.mas.behaviour.activityGraph.action;
import java.util.Iterator;

import mygale.mcge.core.JGraph;
import mygale.mcge.fig.IFigObject;
import de.uniwue.ki.gui.util.actions.AbstractBoundAction;
import de.uniwue.ki.mas.behaviour.activityGraphDeclaration.IActivityGraphNodeDeclarationTypeable;

/**
 * Creation date: (05.11.2001 20:48:18)
 * @author Christoph Oechslein
 */
public class ChangeActivityTypeAction extends AbstractBoundAction {
    private final JGraph _graph;
    private final IActivityGraphNodeDeclarationTypeable.Type _type;

    public ChangeActivityTypeAction(IActivityGraphNodeDeclarationTypeable.Type type, JGraph graph) {
        super(type.getName());

        _graph = graph;
        _type = type;
    }

    public void doit() {

        Iterator it = _graph.getSelection().getAllFigs();
        while (it.hasNext()) {
            IFigObject currFigObject = (IFigObject) it.next();
            if (currFigObject.getNetObject() instanceof IActivityGraphNodeDeclarationTypeable) {
                ((IActivityGraphNodeDeclarationTypeable) currFigObject.getNetObject()).setType(_type);
            }

        }

    }
}