/**
 * Created on 24.03.2003
 *
 * This class is responsible for //insert purpose//.
 * 
 * @author glueckselig
 */
package de.uniwue.ki.gui.mas.behaviour.activityGraph.action;

import java.awt.Color;
import java.util.Iterator;

import javax.swing.Icon;
import javax.swing.JColorChooser;

import mygale.mcge.fig.AbstractFigNode;
import mygale.mcge.fig.IFigLayered;
import de.uniwue.ki.gui.util.SwingMoreUtilities;
import de.uniwue.ki.gui.util.actions.AbstractBoundAction;

public class ColorChooseAction extends AbstractBoundAction {

	public static final Icon COLOR_CHOOSE_ICON = SwingMoreUtilities.createImageIcon("others/colors.gif");

	private Iterator _selNodes;

	public ColorChooseAction(Iterator selectedNodes) {

		super("Choose Color", COLOR_CHOOSE_ICON);
		_selNodes = selectedNodes;
	}

	public void doit() {

		Color chosenColor = JColorChooser.showDialog(null, "Choose Color of Activity", Color.WHITE);
		if (chosenColor != null) {
			while (_selNodes.hasNext()) {

				IFigLayered figElement = (IFigLayered) _selNodes.next();

				if (figElement instanceof AbstractFigNode) {

					AbstractFigNode absNode = (AbstractFigNode) figElement;
					absNode.setBackgroundColor(chosenColor);
				}
			}
		}
	}

}
