package de.uniwue.ki.gui.mas.behaviour.activityGraph.action;
import java.awt.Rectangle;
import java.util.*;

import mygale.mcge.fig.*;
import mygale.mcge.sel.Selection;
import de.uniwue.ki.gui.mas.behaviour.activityGraph.ActivityGraphDeclarationGraph;
import de.uniwue.ki.mas.behaviour.activityGraphDeclaration.IActivityGraphComposedNodeDeclaration;
import de.uniwue.ki.mas.behaviour.activityGraphDeclaration.IActivityGraphNodeDeclaration;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Creation date: (05.11.2001 20:48:18)
 * @author Christoph Oechslein
 */
public class ComposeActivityDeclarationsAction
	extends ComposeActivitiesToAComposedActivityDeclarationAction {
	private final ActivityGraphDeclarationGraph _graph;

	public ComposeActivityDeclarationsAction(ActivityGraphDeclarationGraph graph) {
		super(getSelectedActivities(graph));

		_graph = graph;
	}

	public void doit() {
		if (isPossibleToCompose()) {

			Selection sel = _graph.getSelection();

			Iterator it = CollectionsHelper.asLinkedList(sel.getAllFigs()).iterator();

			IActivityGraphComposedNodeDeclaration newActivityGraphComposedNodeDeclaration = compose();

			Rectangle rect = null;

			while (it.hasNext()) {
				IFigLayered currFigLayered = (IFigLayered)it.next();

				currFigLayered.setSelected(false);

				if (rect == null) {
					rect = new Rectangle(currFigLayered.getBounds());

				} else {
					rect.add(currFigLayered.getBounds());
				}
			}

			IFigNode figNode = _graph.createFigNode(newActivityGraphComposedNodeDeclaration);

			figNode.setLocation(
				(int) (rect.getCenterX() - figNode.getWidth()),
				(int) (rect.getCenterY() - figNode.getHeight()));
		}
	}

	private static List getSelectedActivities(ActivityGraphDeclarationGraph graph) {
		List activityDeclarationList = new LinkedList();

		Iterator it = graph.getSelection().getAllFigs();
		while (it.hasNext()) {
			IFigObject currFigObject = (IFigObject)it.next();

			if (currFigObject.getNetObject() instanceof IActivityGraphNodeDeclaration)
				activityDeclarationList.add(currFigObject.getNetObject());
		}

		return activityDeclarationList;
	}
}