package de.uniwue.ki.gui.mas.behaviour.activityGraph.action;
import java.util.HashMap;

import junit.framework.Assert;
import de.uniwue.ki.gui.util.actions.AbstractBoundAction;
import de.uniwue.ki.mas.behaviour.activityGraphDeclaration.IActivityGraphNodeDeclaration;
import de.uniwue.ki.util.name.IDocumentable;

/**
 * Creation date: (13.07.2001 09:30:02)
 * @author Christoph Oechslein
 */

public class DuplicateActivityDeclarationAction extends AbstractBoundAction {
	private final IActivityGraphNodeDeclaration _activityDeclaration;

	public DuplicateActivityDeclarationAction(IActivityGraphNodeDeclaration activityDeclaration) {
		super("Duplicate");

		Assert.assertNotNull(activityDeclaration.getActivityGraphDeclaration());

		_activityDeclaration = activityDeclaration;
	}

	public void doit() {
		IActivityGraphNodeDeclaration copiedActivityDeclaration =
			(IActivityGraphNodeDeclaration) _activityDeclaration.copy(new HashMap());

		if (copiedActivityDeclaration instanceof IDocumentable) {
			((IDocumentable) copiedActivityDeclaration).setShortDescription(
				"Copy of " + _activityDeclaration.getName());
		}

		_activityDeclaration.getActivityGraphDeclaration().addActivityGraphNodeDeclaration(copiedActivityDeclaration);
	}
}