/**
 * Created on 04.12.2002
 *
 * This class is responsible for //insert purpose here//
 * 
 * @author glueckselig
 */
package de.uniwue.ki.gui.mas.behaviour.activityGraph.fig;

import java.awt.*;

import javax.swing.*;

public class CommentDialogPanel extends JPanel {

	private JTextField _titleField;
	private JTextArea _commentArea;

	public CommentDialogPanel(String title, String comment) {
		super();

		_titleField = new JTextField(title);
		_commentArea = new JTextArea();
		_commentArea.setText(comment);
		_commentArea.setBorder(_titleField.getBorder());

		layoutPane();
	}

	private void layoutPane() {

		setLayout(new BorderLayout());

		GridBagConstraints constraintsPanel = new GridBagConstraints();

		JPanel panel = new JPanel();
		panel.setLayout(new GridBagLayout());
		panel.setBorder(BorderFactory.createTitledBorder("Title"));

		constraintsPanel = new GridBagConstraints();
		constraintsPanel.weightx = 1;
		constraintsPanel.fill = GridBagConstraints.HORIZONTAL;
		panel.add(_titleField, constraintsPanel);
		add(panel, BorderLayout.NORTH);

		panel = new JPanel();
		panel.setLayout(new GridBagLayout());
		panel.setBorder(BorderFactory.createTitledBorder("Comment"));

		constraintsPanel = new GridBagConstraints();
		constraintsPanel.weightx = 1;
		constraintsPanel.weighty = 1;
		constraintsPanel.fill = GridBagConstraints.BOTH;
		panel.add(new JScrollPane(_commentArea), constraintsPanel);

		add(panel, BorderLayout.CENTER);

		setPreferredSize(new Dimension(100, 200));
	}

	public String getTitle() {
		return _titleField.getText();
	}

	public String getComment() {
		return _commentArea.getText();
	}
}
