package de.uniwue.ki.gui.mas.behaviour.activityGraph.fig;
import java.awt.*;
import java.util.Iterator;

import javax.swing.ImageIcon;

import mygale.mcge.core.JGraph;
import mygale.mcge.fig.IFigObject;
import de.uniwue.ki.gui.mas.behaviour.activityGraph.ActivityGraphDeclarationGraph;
import de.uniwue.ki.gui.mas.behaviour.activityGraph.action.DecomposeComposedActivityDeclarationAction;
import de.uniwue.ki.gui.util.SwingMoreUtilities;
import de.uniwue.ki.mas.behaviour.activityGraphDeclaration.IActivityGraphComposedNodeDeclaration;
import de.uniwue.ki.mas.behaviour.activityGraphDeclaration.IActivityGraphDeclaration;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Creation date: (22.03.2001 13:39:26)
 * @author Christoph Oechslein
 */
public class FigActivityGraphComposedNodeDeclaration extends FigTypeableActivityGraphNodeDeclaration {

	public FigActivityGraphComposedNodeDeclaration() {
		super();
	}

	public void editProperties(Container parent) {
		ActivityGraphDeclarationGraph composedActivityDeclarationGraph =
			(ActivityGraphDeclarationGraph)parent;

		composedActivityDeclarationGraph
			.getGUISeSAmDeclaration()
			.getPanelActionFactoryManager()
			.callPropertyAction(
			composedActivityDeclarationGraph,
			((IActivityGraphComposedNodeDeclaration)getNetObject()).getInnerActivityGraphDeclaration());
	}

	protected IActivityGraphDeclaration getComposedActivityDeclaration() {
		return ((IActivityGraphComposedNodeDeclaration)getActivityDeclaration())
			.getInnerActivityGraphDeclaration();
	}

	protected Iterator getPopupMenuImportantActions(final JGraph graph, boolean forOnlyOneFig) {
		if (forOnlyOneFig) {
			IFigObject currFigObject = (IFigObject)graph.getSelection().getAllFigs().next();
			final IActivityGraphComposedNodeDeclaration composedActivityDeclaration =
				(IActivityGraphComposedNodeDeclaration)currFigObject.getNetObject();

			return CollectionsHelper.createConsIterator(
				new DecomposeComposedActivityDeclarationAction(
					composedActivityDeclaration,
					(ActivityGraphDeclarationGraph)graph),
				super.getPopupMenuImportantActions(graph, forOnlyOneFig));

		} else {
			return super.getPopupMenuImportantActions(graph, forOnlyOneFig);
		}
	}

	//	public void paintContent(Graphics2D g2d, Prefs prefs) {
	//		Stroke oldStroke = g2d.getStroke();
	//
	//		g2d.setStroke(new BasicStroke(2));
	//		super.paintContent(g2d, prefs);
	//
	//		g2d.setStroke(oldStroke);
	//
	//	}

	private static final int COMPOSED_ICON_BORDER_WIDTH = 5;
	private static final int COMPOSED_ICON_BORDER_HEIGHT = 10;

	private static final ImageIcon COMPOSED_ICON = SwingMoreUtilities.createImageIcon("others/composed.jpg");

	protected Rectangle paintBottom(Graphics2D g2d, Rectangle interiorPaintRect) {

		if ((COMPOSED_ICON != null) && (COMPOSED_ICON.getImage() != null))
			g2d.drawImage(
				COMPOSED_ICON.getImage(),
				interiorPaintRect.x + COMPOSED_ICON_BORDER_WIDTH,
				interiorPaintRect.y + COMPOSED_ICON_BORDER_HEIGHT,
				interiorPaintRect.width - 2 * COMPOSED_ICON_BORDER_WIDTH,
				interiorPaintRect.height - COMPOSED_ICON_BORDER_HEIGHT,
				COMPOSED_ICON.getImageObserver());

		return super.paintBottom(g2d, interiorPaintRect);
	}
}