/**
 * Created on 23.07.2003
 *
 * This class is responsible for //insert purpose//.
 * 
 * @author glueckselig
 */
package de.uniwue.ki.gui.mas.behaviour.activityGraph.fig;

import java.util.Iterator;

import mygale.mcge.core.JGraph;
import mygale.mcge.fig.FigNodePolygon;
import mygale.mcge.fig.IFigObject;
import mygale.mcge.net.INetObject;
import de.uniwue.ki.gui.mas.behaviour.activityGraph.ActivityGraphDeclarationGraph;
import de.uniwue.ki.gui.mas.behaviour.activityGraph.action.ColorChooseAction;
import de.uniwue.ki.gui.mas.behaviour.activityGraph.action.ComposeActivityDeclarationsAction;
import de.uniwue.ki.gui.mas.util.declaration.action.CopyToClipboardAction;
import de.uniwue.ki.gui.util.actions.InspectAction;
import de.uniwue.ki.mas.behaviour.activityGraphDeclaration.IActivityGraphNodeDeclaration;
import de.uniwue.ki.mas.util.declaration.IDeclaration;
import de.uniwue.ki.util.collection.CollectionsHelper;

public abstract class FigActivityGraphNodeDeclaration extends FigNodePolygon {

	public String getName() {
		return getActivityDeclaration().getName();
	}

	public void cleanUp() {
		if (getActivityDeclaration() != null)
			getActivityDeclaration().removeChangeListener(this);
	}

	public void setNetObject(INetObject netObject) {

		IDeclaration oldDeclaration = (IDeclaration) getNetObject();
		if (oldDeclaration != null) {
			oldDeclaration.removeChangeListener(this);
		}

		super.setNetObject(netObject);

		IDeclaration newDeclaration = (IDeclaration) netObject;
		if (newDeclaration != null) {
			newDeclaration.addChangeListener(this);
		}

	}

	protected IActivityGraphNodeDeclaration getActivityDeclaration() {
		return ((IActivityGraphNodeDeclaration) getNetObject());
	}

	protected Iterator getPopupMenuImportantActions(final JGraph graph, boolean forOnlyOneFig) {
		ActivityGraphDeclarationGraph activityGraph = (ActivityGraphDeclarationGraph) graph;
		return CollectionsHelper.createConsIterator(
			new ComposeActivityDeclarationsAction(activityGraph),
			new ColorChooseAction(activityGraph.getSelection().getAllFigs()),
			new InspectAction(this),
			super.getPopupMenuImportantActions(activityGraph, forOnlyOneFig));
	}

	protected Iterator getPopupMenuMoreActions(JGraph graph, boolean forOnlyOneFig) {
		ActivityGraphDeclarationGraph activityGraph = (ActivityGraphDeclarationGraph) graph;

		if (forOnlyOneFig) {
			Iterator it = (activityGraph).getSelection().getAllFigs();
			while (it.hasNext()) {
				return CollectionsHelper.createConsIterator(
					new CopyToClipboardAction(
						(IDeclaration) ((IFigObject) it.next()).getNetObject(),
						activityGraph.getGUISeSAmDeclaration().getClipboard()),
					super.getPopupMenuImportantActions(activityGraph, forOnlyOneFig));
			}
		}

		return super.getPopupMenuImportantActions(activityGraph, forOnlyOneFig);
	}
	
    public String toString() {
        return super.toString() + " ["+ getName() + "]";
    }
}
