package de.uniwue.ki.gui.mas.behaviour.activityGraph.fig;
import mygale.mcge.fig.AbstractFigEdgeFactory;
import mygale.mcge.fig.IFigEdge;
import mygale.mcge.net.INetEdge;
import de.uniwue.ki.mas.behaviour.rule.IGraphDocumentEdgeDeclaration;
import de.uniwue.ki.mas.behaviour.rule.IOtherwiseActivityGraphEdgeDeclaration;

/**
 * Creation date: (11.06.2001 13:20:29)
 * @author Christoph Oechslein
 */

public class FigActivityGraphRuleDeclarationFactory extends AbstractFigEdgeFactory {
	private static final FigActivityGraphRuleDeclarationFactory _instance =
		new FigActivityGraphRuleDeclarationFactory();

	private FigActivityGraphRuleDeclarationFactory() {
		super();
	}

	public IFigEdge createFigEdge(INetEdge netObject) {

		if (netObject instanceof IGraphDocumentEdgeDeclaration) {

			FigDocumentGraphEdgeDeclaration figDocDeclaration = new FigDocumentGraphEdgeDeclaration();
			figDocDeclaration.setNetObject(netObject);

			return figDocDeclaration;
		} else if (netObject instanceof IOtherwiseActivityGraphEdgeDeclaration) {
			FigOtherwiseActivityGraphEdgeDeclaration figActivityRuleDeclaration =
				new FigOtherwiseActivityGraphEdgeDeclaration();
			figActivityRuleDeclaration.setNetObject(netObject);
			return figActivityRuleDeclaration;

		} else {
			FigActivityGraphRuleDeclaration figActivityRuleDeclaration =
				new FigActivityGraphRuleDeclaration();
			figActivityRuleDeclaration.setNetObject(netObject);
			return figActivityRuleDeclaration;

		}
	}

	public static final FigActivityGraphRuleDeclarationFactory getInstance() {
		return _instance;
	}
}