package de.uniwue.ki.gui.mas.behaviour.activityGraph.fig;
import java.awt.*;

import junit.framework.Assert;
import de.uniwue.ki.gui.mas.behaviour.activityGraph.ActivityGraphDeclarationGraph;
import de.uniwue.ki.gui.mas.util.declaration.action.RenameDocumentableDeclarationAction;
import de.uniwue.ki.mas.behaviour.activityGraphDeclaration.IDecisionGraphLeafDeclaration;

/**
 * Creation date: (03.05.2001 11:09:31)
 * @author Christoph Oechslein
 */
public class FigDecisionActivityGraphNodeDeclaration extends FigInstantlyActivityGraphNodeDeclaration {

	public FigDecisionActivityGraphNodeDeclaration() {
		super();
	}

	public void editProperties(Container parent) {

		Assert.assertTrue(parent instanceof ActivityGraphDeclarationGraph);

		new RenameDocumentableDeclarationAction(parent, getActivityDeclaration()).doit();
	}

	protected Rectangle paintTitle(Graphics2D g2d, Rectangle interiorPaintRect) {
		FigInstantlyIconHelper.drawInstantlyIconCenterTop(
			g2d,
			interiorPaintRect,
			((IDecisionGraphLeafDeclaration)getActivityDeclaration()).isInstantly()
				? FigInstantlyIconHelper.INSTANTLY
				: FigInstantlyIconHelper.NOT_INSTANTLY);

		return super.paintTitle(g2d, interiorPaintRect,true, true);
	}

	protected void updatePolygon() {
		setPolygon(new Polygon());

		getPolygon().addPoint(getX() + getWidth() / 2, getY());
		getPolygon().addPoint(getX() + getWidth(), getY() + getHeight() / 2);
		getPolygon().addPoint(getX() + getWidth() / 2, getY() + getHeight());
		getPolygon().addPoint(getX(), getY() + getHeight() / 2);
	}

	protected Rectangle calculateInteriorPaintRect() {
		final int BORDER = 12;

		Rectangle rectForString = super.calculateInteriorPaintRect();

		rectForString.setBounds(getX() + BORDER, getY(), getWidth() - 2 * BORDER, getHeight());

		return rectForString;
	}
}