package de.uniwue.ki.gui.mas.behaviour.activityGraph.fig;
import java.awt.*;

import javax.swing.ImageIcon;

import de.uniwue.ki.gui.util.SwingMoreUtilities;

/**
 * Creation date: (03.05.2001 11:09:31)
 * @author Christoph Oechslein
 */
public class FigEmergencyActivityGraphLeafDeclaration extends FigActivityGraphNodeDeclaration {

	private static final ImageIcon _lightningIcon =
		SwingMoreUtilities.createImageIcon("others/lightning24.gif");

	public FigEmergencyActivityGraphLeafDeclaration() {
		super();

		setWidthIntern(130);
		setHeightIntern(50);
	}

	public int getMinimalHeight() {
		return 50;
	}

	public int getMinimalWidth() {
		return 120;
	}

	protected Rectangle paintTitle(Graphics2D g2d, Rectangle interiorPaintRect) {
		if (_lightningIcon.getImageLoadStatus() == MediaTracker.COMPLETE) {
			g2d.drawImage(
				_lightningIcon.getImage(),
				interiorPaintRect.x + interiorPaintRect.width - _lightningIcon.getIconWidth() - 1,
				interiorPaintRect.y + 1,
				_lightningIcon.getImageObserver());
		}

		return super.paintTitle(g2d, interiorPaintRect);
	}

	protected void setWidthIntern(int width) {

		setWidth(width);
	}

	protected void setHeightIntern(int height) {

		setHeight(height);
	}

	public String getName() {
		return "Emergency";
	}

//	public Shape getShape() {
//		return getBounds();
//	}

}