package de.uniwue.ki.gui.mas.behaviour.activityGraph.fig;
import java.awt.Graphics2D;
import java.awt.geom.Ellipse2D;

import mygale.mcge.fig.FigNodeEllipse;
import mygale.mcge.util.prefs.Prefs;

/**
 * Creation date: (03.05.2001 11:09:31)
 * @author Christoph Oechslein
 */
public class FigEntryActivityGraphLeafDeclaration extends FigNodeEllipse {
	private static final int _width = 15;

	/**
	 * FigEntryActivityGraphLeafDeclaration constructor comment.
	 */
	public FigEntryActivityGraphLeafDeclaration() {
		super();

		setWidth(_width);
		setHeight(_width);
	}

	/** Set the width of this Fig.
	     *
	     * @param width width.
	     */
	public void setWidth(int width) {
		super.setWidth(_width);
	}

	/** Reply <code>true</code> if this Fig can be
	     *  reshaped by the user
	     *
	     * @return <code>true</code> if this Fig can be reshaped,
	     *         <code>false</code> otherwise.
	     */
	public boolean isReshapable() {
		return false;
	}

	//////////////////////////////////
	// Painting methods

	/** Method to paint this Fig.
	 *
	 * @param g2d the graphic context.
	 */
	public void paintContent(Graphics2D g2d, Prefs prefs) {
		g2d.setColor(prefs.getFigForegroundColor());

		paintCircle(g2d);
	}

	/** Change the position and the dimension of this Fig.
	     *
	     * @param x horizontal position of this Fig.
	     * @param y vertical position of this Fig.
	     * @param width width of this Fig.
	     * @param height height of this Fig.
	     */
	public void setBounds(int x, int y, int width, int height) {
		super.setBounds(x, y, _width, _width);
	}

	/** Set the height of this Fig.
	     *
	     * @param height height.
	     */
	public void setHeight(int height) {
		super.setHeight(_width);
	}

	private void paintCircle(Graphics2D g2d) {
		paintCircle(g2d, 0, 0);
	}

	private void paintCircle(Graphics2D g2d, int dx, int dy) {

		// Paint the background
		Ellipse2D.Double ellipse = new Ellipse2D.Double(getX() + dx, getY() + dy, getWidth(), getHeight());

		g2d.draw(ellipse);
		g2d.fill(ellipse);
	}
}