package de.uniwue.ki.gui.mas.behaviour.activityGraph.fig;
import java.awt.Graphics2D;
import java.awt.geom.Ellipse2D;

import mygale.mcge.util.prefs.Prefs;

/**
 * Creation date: (03.05.2001 11:09:31)
 * @author Christoph Oechslein
 */
public class FigExitActivityGraphLeafDeclaration extends FigEntryActivityGraphLeafDeclaration {

	/**
	 * FigEntryActivityGraphLeafDeclaration constructor comment.
	 */
	public FigExitActivityGraphLeafDeclaration() {
		super();
	}

	/** Reply <code>true</code> if this Fig can be
	     *  reshaped by the user
	     *
	     * @return <code>true</code> if this Fig can be reshaped,
	     *         <code>false</code> otherwise.
	     */
	public boolean isReshapable() {
		return false;
	}

	/**
	 * @see mygale.mcge.fig.FigLayeredImpl
	 */
	public void paintContent(Graphics2D g2d, Prefs prefs) {
		g2d.setColor(prefs.getFigForegroundColor());

		paintCircle(g2d);
	}

	private void paintCircle(Graphics2D g2) {
		paintCircle(g2, 0, 0);
	}

	private void paintCircle(Graphics2D g2, int dx, int dy) {
		int distanceBetweenCircles = 4;

		// Paint the background
		Ellipse2D.Double ellipse = new Ellipse2D.Double(getX() + dx, getY() + dy, getWidth(), getHeight());

		g2.draw(ellipse);

		ellipse.x += distanceBetweenCircles;
		ellipse.y += distanceBetweenCircles;
		ellipse.width -= 2 * distanceBetweenCircles;
		ellipse.height -= 2 * distanceBetweenCircles;

		//   g2.setColor(getPrefs().getFigBackgroundColor());
		g2.fill(ellipse);
		g2.draw(ellipse);
	}
}