/*
 * Created on 13.02.2003
 *
 * @author glueckselig
 */
package de.uniwue.ki.gui.mas.behaviour.reasoning;

import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import de.uniwue.ki.gui.mas.util.declaration.*;
import de.uniwue.ki.mas.behaviour.reasoning.*;
import de.uniwue.ki.mas.entity.objectclass.agentclass.IActivityAgentClassDeclaration;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

public class ActivityReasoningEngineDeclarationPanelContainer extends
        AbstractSplittedDeclarationPanel implements ListSelectionListener {

    private ReasoningEngineDeclarationListPanel _reasoningEngineDeclarationListPanel;

    private ActivityReasoningEngineDeclarationPanel _reasoningPanel;

    public ActivityReasoningEngineDeclarationPanelContainer() {

        super();

        initialize(ActivityReasoningEngineDeclarationFactory.getInstance());
    }

    public void setDeclaration(IDeclaration declaration) {
        setActivityAgentClassDeclaration((IActivityAgentClassDeclaration) declaration);
    }

    public void setActivityAgentClassDeclaration(
            IActivityAgentClassDeclaration activityAgentClassDeclaration) {

        getActivityReasoningEngineDeclarationPanel()
                .setActivityAgentClassDeclaration(activityAgentClassDeclaration);

        if (activityAgentClassDeclaration != null) {
            ReasoningEngineDeclarationListAndFactory reasoningEngineDeclarationListAndFactory = activityAgentClassDeclaration
                    .getReasoningEngineDeclarationListAndFactory();

            getReasoningEngineDeclarationListPanel()
                    .setDeclarationListAndFactory(
                            reasoningEngineDeclarationListAndFactory);
            getReasoningEngineDeclarationListPanel().setObjectClassDeclaration(
                    activityAgentClassDeclaration);

            if (reasoningEngineDeclarationListAndFactory.getDeclarationList()
                    .size() > 0) {

                getListPanel().setSelectedIndex(0);

                checkSplitPaneDividerLocation();

            } else {
                getListPanel().setSelectedIndex(0);
            }

        } else {
            getListPanel().setDeclarationListAndFactory(null);
            getListPanel().clearSelection();
        }
    }

    public IDeclaration getDeclaration() {
        return getActivityAgentClassDeclaration();
    }

    public IActivityAgentClassDeclaration getActivityAgentClassDeclaration() {
        return getActivityReasoningEngineDeclarationPanel()
                .getActivityAgentClassDeclaration();
    }

    public void valueChanged(ListSelectionEvent e) {

        if (e.getValueIsAdjusting()) {
            // do nothing

        } else if (!getListPanel().isSelectionEmpty()) {
            IActivityReasoningEngineDeclaration newActivityReasoningEngineDeclaration = (IActivityReasoningEngineDeclaration) getListPanel()
                    .getSelectedValue();

            if (newActivityReasoningEngineDeclaration != getActivityReasoningEngineDeclarationPanel()
                    .getActivityReasoningEngineDeclaration()) {
                getActivityReasoningEngineDeclarationPanel()
                        .setActivityReasoningEngineDeclaration(
                                newActivityReasoningEngineDeclaration);
                getNamePanel().setDeclaration(
                        newActivityReasoningEngineDeclaration
                                .getRootActivityGraphDeclaration());
            }

        } else if (getListPanel().getDeclarationListModel() != null) {
            int oldIndex = getListPanel().getDeclarationListModel().indexOf(
                    getActivityReasoningEngineDeclarationPanel()
                            .getActivityReasoningEngineDeclaration());

            if (oldIndex != -1) {
                getListPanel().setSelectedIndex(oldIndex);
            }
        }
    }

    protected DeclarationListPanel getListPanel() {
        return getReasoningEngineDeclarationListPanel();
    }

    private ReasoningEngineDeclarationListPanel getReasoningEngineDeclarationListPanel() {

        if (_reasoningEngineDeclarationListPanel == null) {
            _reasoningEngineDeclarationListPanel = new ReasoningEngineDeclarationListPanel();
            _reasoningEngineDeclarationListPanel.addListSelectionListener(this);
            _reasoningEngineDeclarationListPanel
                    .setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
            _reasoningEngineDeclarationListPanel.setEditable(true);
            _reasoningEngineDeclarationListPanel.setArrowsAvailible(true);
        }
        return _reasoningEngineDeclarationListPanel;
    }

    protected IDeclarationPanel getDeclarationPanel() {
        return getActivityReasoningEngineDeclarationPanel();
    }

    private ActivityReasoningEngineDeclarationPanel getActivityReasoningEngineDeclarationPanel() {
        if (_reasoningPanel == null) {
            _reasoningPanel = new ActivityReasoningEngineDeclarationPanel();
        }
        return _reasoningPanel;
    }

}
