package de.uniwue.ki.gui.mas.behaviour.rule;
import javax.swing.JFrame;
import javax.swing.JSeparator;

import de.uniwue.ki.gui.mas.util.declaration.AbstractDeclarationPanel;
import de.uniwue.ki.gui.mas.util.declaration.NameDeclarationWithDocumentationPanel;
import de.uniwue.ki.mas.behaviour.rule.IActivityGraphRuleDeclaration;

/**
 * Creation date: (20.09.2000 16:27:03)
 * @author Christoph Oechslein
 */

public class ActivityRuleDeclarationPanel extends AbstractDeclarationPanel {
	private ActivityRuleDeclaratonSettingsPanel ivjActivityRuleDeclaratonSettingsPanel = null;
	private final IvjEventHandler ivjEventHandler = new IvjEventHandler();
	private boolean ivjConnPtoP1Aligning = false;
	private NameDeclarationWithDocumentationPanel ivjNameDeclarationWithDocumentationPanel = null;

	private final class IvjEventHandler implements java.beans.PropertyChangeListener {
		public void propertyChange(java.beans.PropertyChangeEvent evt) {
			if (evt.getSource() == ActivityRuleDeclarationPanel.this.getActivityRuleDeclaratonSettingsPanel()
				&& (evt.getPropertyName().equals("activityArgumentRuleDeclaration")))
				connEtoC1(evt);
			if (evt.getSource() == ActivityRuleDeclarationPanel.this.getActivityRuleDeclaratonSettingsPanel()
				&& (evt.getPropertyName().equals("activityAgentClassDeclaration")))
				connEtoC2(evt);
			if (evt.getSource() == ActivityRuleDeclarationPanel.this.getActivityRuleDeclaratonSettingsPanel()
				&& (evt.getPropertyName().equals("gUISeSAmDeclaration")))
				connPtoP1SetTarget();
			if (evt.getSource() == ActivityRuleDeclarationPanel.this
				&& (evt.getPropertyName().equals("gUISeSAmDeclaration")))
				connPtoP1SetSource();
			if (evt.getSource() == ActivityRuleDeclarationPanel.this
				&& (evt.getPropertyName().equals("gUISeSAmDeclaration")))
				connPtoP3SetTarget();
		}
	}

	public ActivityRuleDeclarationPanel() {
		super();
		initialize();
	}

	private void connEtoC1(java.beans.PropertyChangeEvent arg1) {
		try {
			this.firePropertyChange("ActivityRuleDeclaration", arg1.getOldValue(), arg1.getNewValue());
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	private void connEtoC2(java.beans.PropertyChangeEvent arg1) {
		try {
			this.firePropertyChange("activityAgentClassDeclaration", arg1.getOldValue(), arg1.getNewValue());
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	private void connPtoP1SetSource() {
		try {
			if (ivjConnPtoP1Aligning == false) {
				ivjConnPtoP1Aligning = true;
				getActivityRuleDeclaratonSettingsPanel().setGUISeSAmDeclaration(
					this.getGUISeSAmDeclaration());
				ivjConnPtoP1Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP1Aligning = false;
			handleException(ivjExc);
		}
	}

	private void connPtoP1SetTarget() {
		try {
			if (ivjConnPtoP1Aligning == false) {
				ivjConnPtoP1Aligning = true;
				this.setGUISeSAmDeclaration(
					getActivityRuleDeclaratonSettingsPanel().getGUISeSAmDeclaration());
				ivjConnPtoP1Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP1Aligning = false;
			handleException(ivjExc);
		}
	}

	/**
	 * connPtoP2SetTarget:  (ActivityRuleDeclaratonSettingsPanel.activityArgumentRuleDeclaration <--> NameDeclarationWithDocumentationPanel.declaration)
	 */
	private void connPtoP2SetTarget() {
		try {
			getNameDeclarationWithDocumentationPanel().setDeclaration(
				getActivityRuleDeclaratonSettingsPanel().getDeclaration());
				} catch (Throwable ivjExc) {
					handleException(ivjExc);
		}
	}

	/**
	 * connPtoP3SetTarget:  (ActivityRuleDeclarationPanel.gUISeSAmDeclaration <--> NameDeclarationWithDocumentationPanel.guiSeSAmDeclaration)
	 */
	private void connPtoP3SetTarget() {
		try {
			getNameDeclarationWithDocumentationPanel().setGUISeSAmDeclaration(this.getGUISeSAmDeclaration());
				} catch (Throwable ivjExc) {
					handleException(ivjExc);
		}
	}

	public void dispose() {
		getActivityRuleDeclaratonSettingsPanel().dispose();

		super.dispose();
	}

	/**
	 * Method generated to support the promotion of the activityAgentClassDeclaration attribute.
	 * @return de.uniwue.ki.mas.model.entity.objectclass.IActivityAgentClassDeclaration
	 */
	public de
		.uniwue
		.ki
		.mas
		.entity
		.objectclass
		.agentclass
		.IActivityAgentClassDeclaration getActivityAgentClassDeclaration() {
		return getActivityRuleDeclaratonSettingsPanel().getActivityAgentClassDeclaration();
	}

	/**
	 * Method generated to support the promotion of the ActivityRuleDeclaration attribute.
	 * @return de.uniwue.ki.mas.model.behaviour.rule.IArgumentRuleDeclaration
	 */
	public de.uniwue.ki.mas.behaviour.rule.IActivityGraphRuleDeclaration getActivityRuleDeclaration() {
		return getActivityRuleDeclaratonSettingsPanel().getActivityRuleDeclaration();
	}

	/**
	 * Return the ActivityRuleDeclaratonSettingsPanel property value.
	 * @return de.uniwue.ki.gui.mas.model.behaviour.rule.ActivityRuleDeclaratonSettingsPanel
	 */
	private ActivityRuleDeclaratonSettingsPanel getActivityRuleDeclaratonSettingsPanel() {
		if (ivjActivityRuleDeclaratonSettingsPanel == null) {
			try {
				ivjActivityRuleDeclaratonSettingsPanel =
					new de.uniwue.ki.gui.mas.behaviour.rule.ActivityRuleDeclaratonSettingsPanel();
				ivjActivityRuleDeclaratonSettingsPanel.setName("ActivityRuleDeclaratonSettingsPanel");
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjActivityRuleDeclaratonSettingsPanel;
	}

	public de.uniwue.ki.mas.util.declaration.IDeclaration getDeclaration() {
		return getActivityRuleDeclaration();
	} /**
	   * Method generated to support the promotion of the abstractDeclarationFactoryThis attribute.
	   * @param arg1 de.uniwue.ki.mas.model.util.declaration.IDeclarationFactory
	   */

	public de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration getGUISeSAmDeclaration() {
		return getActivityRuleDeclaratonSettingsPanel().getGUISeSAmDeclaration();
	} /**
	   * Method generated to support the promotion of the declarationFactory attribute.
	   * @param arg1 Object
	   */

	/**
	 * Return the NameDeclarationWithDocumentationPanel property value.
	 * @return de.uniwue.ki.gui.mas.model.util.declaration.NameDeclarationWithDocumentationPanel
	 */
	private NameDeclarationWithDocumentationPanel getNameDeclarationWithDocumentationPanel() {
		if (ivjNameDeclarationWithDocumentationPanel == null) {
			try {
				ivjNameDeclarationWithDocumentationPanel = new NameDeclarationWithDocumentationPanel();
				ivjNameDeclarationWithDocumentationPanel.setName("NameDeclarationWithDocumentationPanel");
				ivjNameDeclarationWithDocumentationPanel.setShowCheckBox(true);
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjNameDeclarationWithDocumentationPanel;
	}

	/**
	 * Called whenever the bean information class throws an exception.
	 * @param exception Throwable
	 */
	private void handleException(Throwable exception) {

		exception.printStackTrace(System.out);
	}

	/**
	 * Initializes connections
	 * @exception Exception The exception description.
	 */
	private void initConnections() {
		getActivityRuleDeclaratonSettingsPanel().addPropertyChangeListener(ivjEventHandler);
		this.addPropertyChangeListener(ivjEventHandler);
		connPtoP1SetTarget();
		connPtoP2SetTarget();
		connPtoP3SetTarget();
	}

	/**
	     * Initialize the class.
	     */
	private void initialize() {
		try {
					setName("ActivityRuleDeclarationPanel");
			setLayout(new java.awt.GridBagLayout());
			setSize(445, 664);

			java.awt.GridBagConstraints constraintsNameDeclarationWithDocumentationPanel =
				new java.awt.GridBagConstraints();
			constraintsNameDeclarationWithDocumentationPanel.gridx = 0;
			constraintsNameDeclarationWithDocumentationPanel.gridy = 0;
			constraintsNameDeclarationWithDocumentationPanel.fill = java.awt.GridBagConstraints.HORIZONTAL;
			add(getNameDeclarationWithDocumentationPanel(), constraintsNameDeclarationWithDocumentationPanel);

			java.awt.GridBagConstraints constraintsLinePanel1 = new java.awt.GridBagConstraints();
			constraintsLinePanel1.gridx = 0;
			constraintsLinePanel1.gridy = 1;
			constraintsLinePanel1.fill = java.awt.GridBagConstraints.BOTH;
			constraintsLinePanel1.insets = new java.awt.Insets(3, 0, 3, 0);
			add(new JSeparator(), constraintsLinePanel1);

			java.awt.GridBagConstraints constraintsActivityRuleDeclaratonSettingsPanel =
				new java.awt.GridBagConstraints();
			constraintsActivityRuleDeclaratonSettingsPanel.gridx = 0;
			constraintsActivityRuleDeclaratonSettingsPanel.gridy = 2;
			constraintsActivityRuleDeclaratonSettingsPanel.fill = java.awt.GridBagConstraints.BOTH;
			constraintsActivityRuleDeclaratonSettingsPanel.weightx = 1.0;
			constraintsActivityRuleDeclaratonSettingsPanel.weighty = 1.0;
			add(getActivityRuleDeclaratonSettingsPanel(), constraintsActivityRuleDeclaratonSettingsPanel);
			initConnections();
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	public static void main(String[] args) {
		try {
			JFrame frame = new javax.swing.JFrame();
			ActivityRuleDeclarationPanel aActivityRuleDeclarationPanel;
			aActivityRuleDeclarationPanel = new ActivityRuleDeclarationPanel();
			frame.setContentPane(aActivityRuleDeclarationPanel);
			frame.setSize(aActivityRuleDeclarationPanel.getSize());
			frame.addWindowListener(new java.awt.event.WindowAdapter() {
				public void windowClosing(java.awt.event.WindowEvent e) {
					System.exit(0);
				};
			});
			frame.setVisible(true);
		} catch (Throwable exception) {
			System.err.println("Exception occurred in main() of javax.swing.JPanel");
			exception.printStackTrace(System.out);
		}
	}

	/**
	 * Method generated to support the promotion of the activityAgentClassDeclaration attribute.
	 * @param arg1 de.uniwue.ki.mas.model.entity.objectclass.IActivityAgentClassDeclaration
	 */
	public void setActivityAgentClassDeclaration(
		de.uniwue.ki.mas.entity.objectclass.agentclass.IActivityAgentClassDeclaration arg1) {
		getActivityRuleDeclaratonSettingsPanel().setActivityAgentClassDeclaration(arg1);
	}

	/**
	 * Method generated to support the promotion of the ActivityRuleDeclaration attribute.
	 * @param arg1 de.uniwue.ki.mas.model.behaviour.rule.IArgumentRuleDeclaration
	 */
	public void setActivityRuleDeclaration(IActivityGraphRuleDeclaration activityArgumentRuleDeclaration) {
		getActivityRuleDeclaratonSettingsPanel().setActivityRuleDeclaration(activityArgumentRuleDeclaration);
		getNameDeclarationWithDocumentationPanel().setDeclaration(activityArgumentRuleDeclaration);
	}

	public void setDeclaration(de.uniwue.ki.mas.util.declaration.IDeclaration declaration) {
		setActivityRuleDeclaration(
			(de.uniwue.ki.mas.behaviour.rule.IActivityGraphRuleDeclaration)declaration);
	} /**
	   * connEtoC6:  (ActivityRuleDeclaratonSettingsPanel.frameFactory --> ActivityRuleDeclarationPanel.firePropertyChange(LString;LObject;LObject;)V)
	   * @param arg1 java.beans.PropertyChangeEvent
	   */

	public void setGUISeSAmDeclaration(de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration guiSeSAmDeclaration) {
		getActivityRuleDeclaratonSettingsPanel().setGUISeSAmDeclaration(guiSeSAmDeclaration);
	}
}