package de.uniwue.ki.gui.mas.behaviour.rule;
import java.awt.Container;

import de.uniwue.ki.gui.mas.model.DefaultDeclarationPanelActionFactory;
import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.util.declaration.*;
import de.uniwue.ki.mas.behaviour.activityGraphDeclaration.IActivityGraphDeclaration;
import de.uniwue.ki.mas.behaviour.rule.IActivityGraphRuleDeclaration;
import de.uniwue.ki.mas.entity.objectclass.agentclass.IActivityAgentClassDeclaration;
import de.uniwue.ki.mas.util.declaration.IDeclaration;
/**
 * Creation date: (05.02.2002 11:38:36)
 * @author Christoph Oechslein
 */
public class ActivityRuleDeclarationPanelActionFactory extends DefaultDeclarationPanelActionFactory {

	private final class ActivityRuleDeclarationPanelFactory extends AbstractDeclarationPanelFactory {
		private final IActivityAgentClassDeclaration _activityAgentClassDeclaration;

		public ActivityRuleDeclarationPanelFactory(IActivityAgentClassDeclaration activityAgentClassDeclaration) {
			super();

			_activityAgentClassDeclaration = activityAgentClassDeclaration;
		}

		public IDeclarationPanel createDeclarationPanel(final IDeclaration declaration) {
			ActivityRuleDeclarationPanel actionAtomicActivityDeclarationPanel =
				new ActivityRuleDeclarationPanel();

			actionAtomicActivityDeclarationPanel.setGUISeSAmDeclaration(getGUISeSAmDeclaration());
			actionAtomicActivityDeclarationPanel.setActivityAgentClassDeclaration(
				_activityAgentClassDeclaration);

			return actionAtomicActivityDeclarationPanel;
		}

		public String getDeclarationTitle(IDeclaration declaration) {
			return "Rule";
		}
	}

	public ActivityRuleDeclarationPanelActionFactory(IGUISeSAmDeclaration guiSeSAmDeclaration) {
		super(guiSeSAmDeclaration);
	}

	public boolean getCanProduceDeclarationActions(Container parent, IDeclaration anObject) {
		if (!(anObject instanceof IActivityGraphRuleDeclaration))
			return false;

		return getSeSAmDeclarationTreeModel().getUserObjectParentOf(
			getSeSAmDeclarationTreeModel().getUserObjectParentOf(anObject))
			instanceof IActivityGraphDeclaration;
	}

	public IDeclarationPanelFactory getDeclarationPanelFactory(Container parent, IDeclaration anObject) {
		IActivityGraphDeclaration composedActivityDeclaration =
			(IActivityGraphDeclaration)getSeSAmDeclarationTreeModel().getUserObjectParentOf(
				getSeSAmDeclarationTreeModel().getUserObjectParentOf(anObject));

		IActivityAgentClassDeclaration activityAgentClassDeclaration =
			searchActivityAgentClassDeclaration(composedActivityDeclaration);

		return new ActivityRuleDeclarationPanelFactory(activityAgentClassDeclaration);
	}

	private IActivityAgentClassDeclaration searchActivityAgentClassDeclaration(IActivityGraphDeclaration composedActivityDeclaration) {
		if (composedActivityDeclaration.getParentActivityGraphComposedNodeDeclaration() == null)
			return (IActivityAgentClassDeclaration)getSeSAmDeclarationTreeModel().getUserObjectParentOf(
				getSeSAmDeclarationTreeModel().getUserObjectParentOf(composedActivityDeclaration));
		else
			return searchActivityAgentClassDeclaration(
				composedActivityDeclaration
					.getParentActivityGraphComposedNodeDeclaration()
					.getInnerActivityGraphDeclaration());
	}
}