package de.uniwue.ki.gui.mas.behaviour.rule;
import javax.swing.*;

import com.ibm.easyswing.BoundJTextField;

import de.uniwue.ki.gui.mas.basics.functionCall.FunctionCallDeclarationTreeListPanel;
import de.uniwue.ki.gui.mas.basics.functionCall.IExpertFilterFunctionDeclarationListAble;
import de.uniwue.ki.gui.mas.util.declaration.AbstractDeclarationPanel;
import de.uniwue.ki.mas.behaviour.activityGraphDeclaration.IActivityGraphNodeDeclaration;
import de.uniwue.ki.mas.behaviour.rule.IActivityGraphRuleDeclaration;
import de.uniwue.ki.mas.entity.objectclass.agentclass.IActivityAgentClassDeclaration;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: (20.09.2000 15:00:52)
 * @author Christoph Oechslein
 */
public class ActivityRuleDeclaratonSettingsPanel extends AbstractDeclarationPanel {

	private final IvjEventHandler ivjEventHandler = new IvjEventHandler();
	private JPanel ivjJPanel1 = null;
	private FunctionCallDeclarationTreeListPanel ivjPreconditionFunctionCallDeclarationPanel = null;
	private JLabel ivjFromActivityLabel = null;
	private JLabel ivjToActivityLabel = null;
	private boolean ivjConnPtoP4Aligning = false;
	private IActivityGraphRuleDeclaration ivjActivityRuleDeclarationIntern = null;
	private IActivityGraphNodeDeclaration ivjFromActivityDeclaration = null;
	private IActivityGraphNodeDeclaration ivjToActivityDeclaration = null;
	private BoundJTextField ivjFromActivityTextField = null;
	private BoundJTextField ivjToActivityTextField = null;
	private IActivityAgentClassDeclaration ivjActivityAgentClassDeclarationIntern = null;
	private boolean ivjConnPtoP13Aligning = false;
	private boolean ivjConnPtoP5Aligning = false;
	private boolean ivjConnPtoP6Aligning = false;
	private boolean ivjConnPtoP9Aligning = false;

	private final class IvjEventHandler implements java.beans.PropertyChangeListener {
		public void propertyChange(java.beans.PropertyChangeEvent evt) {
			if (evt.getSource()
				== ActivityRuleDeclaratonSettingsPanel.this.getPreconditionFunctionCallDeclarationPanel()
				&& (evt.getPropertyName().equals("objectClassDeclaration")));
			if (evt.getSource()
				== ActivityRuleDeclaratonSettingsPanel.this.getActivityRuleDeclarationIntern())
				connPtoP4SetTarget();
			if (evt.getSource() == ActivityRuleDeclaratonSettingsPanel.this.getFromActivityDeclaration()
				&& (evt.getPropertyName().equals("name")))
				connPtoP5SetTarget();
			if (evt.getSource() == ActivityRuleDeclaratonSettingsPanel.this.getToActivityDeclaration()
				&& (evt.getPropertyName().equals("name")))
				connPtoP6SetTarget();
			if (evt.getSource() == ActivityRuleDeclaratonSettingsPanel.this
				&& (evt.getPropertyName().equals("gUISeSAmDeclaration")))
				connPtoP9SetTarget();
			if (evt.getSource()
				== ActivityRuleDeclaratonSettingsPanel.this.getPreconditionFunctionCallDeclarationPanel()
				&& (evt.getPropertyName().equals("gUISeSAmDeclaration")))
				connPtoP9SetSource();
		}
	};

	/**
	 * ActivityRuleDeclaratonSettingsPanel constructor comment.
	 */
	public ActivityRuleDeclaratonSettingsPanel() {
		super();
		initialize();
	}

	private void connEtoM3(IActivityGraphRuleDeclaration value) {
		try {
			if ((getActivityRuleDeclarationIntern() != null)) {
				setFromActivityDeclaration(
					getActivityRuleDeclarationIntern().getFromActivityGraphNodeDeclaration());
			}
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	private void connEtoM4(IActivityGraphRuleDeclaration value) {
		try {
			if ((getActivityRuleDeclarationIntern() != null)) {
				setToActivityDeclaration(
					getActivityRuleDeclarationIntern().getToActivityGraphNodeDeclaration());
			}
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	private void connPtoP13SetTarget() {
		try {
			if (ivjConnPtoP13Aligning == false) {
				ivjConnPtoP13Aligning = true;
				if ((getActivityAgentClassDeclarationIntern() != null)) {
					IExpertFilterFunctionDeclarationListAble expertFilterFunctionDeclarationListAble =
						getPreconditionFunctionCallDeclarationPanel()
							.getExpertFilterFunctionDeclarationListAble();

					if (expertFilterFunctionDeclarationListAble != null)
						expertFilterFunctionDeclarationListAble.setObjectClassDeclaration(
							getActivityAgentClassDeclarationIntern());
				}
				ivjConnPtoP13Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP13Aligning = false;
			handleException(ivjExc);
		}
	}

	private void connPtoP4SetTarget() {
		try {
			if (ivjConnPtoP4Aligning == false) {
				ivjConnPtoP4Aligning = true;
				if ((getActivityRuleDeclarationIntern() != null)) {
					getPreconditionFunctionCallDeclarationPanel().setFunctionCallDeclaration(
						getActivityRuleDeclarationIntern().getConditionFunctionCallDeclaration());
				}
				ivjConnPtoP4Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP4Aligning = false;
			handleException(ivjExc);
		}
	}

	private void connPtoP5SetTarget() {
		try {
			if (ivjConnPtoP5Aligning == false) {
				ivjConnPtoP5Aligning = true;
				if ((getFromActivityDeclaration() != null)) {
					getFromActivityTextField().setText(getFromActivityDeclaration().getName());
				}
				ivjConnPtoP5Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP5Aligning = false;
			handleException(ivjExc);
		}
	}

	private void connPtoP6SetTarget() {
		try {
			if (ivjConnPtoP6Aligning == false) {
				ivjConnPtoP6Aligning = true;
				if ((getToActivityDeclaration() != null)) {
					getToActivityTextField().setText(getToActivityDeclaration().getName());
				}
				ivjConnPtoP6Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP6Aligning = false;
			handleException(ivjExc);
		}
	}

	private void connPtoP9SetSource() {
		try {
			if (ivjConnPtoP9Aligning == false) {
				ivjConnPtoP9Aligning = true;
				this.setGUISeSAmDeclaration(
					getPreconditionFunctionCallDeclarationPanel().getGUISeSAmDeclaration());
				ivjConnPtoP9Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP9Aligning = false;
			handleException(ivjExc);
		}
	}

	private void connPtoP9SetTarget() {
		try {
			if (ivjConnPtoP9Aligning == false) {
				ivjConnPtoP9Aligning = true;
				getPreconditionFunctionCallDeclarationPanel().setGUISeSAmDeclaration(
					this.getGUISeSAmDeclaration());
				ivjConnPtoP9Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP9Aligning = false;
			handleException(ivjExc);
		}
	}

	public void dispose() {
		if (getActivityRuleDeclaration() != null)
			getActivityRuleDeclaration().removePropertyChangeListener(ivjEventHandler);
		if (getToActivityDeclaration() != null)
			getToActivityDeclaration().removePropertyChangeListener(ivjEventHandler);
		if (getFromActivityDeclaration() != null)
			getFromActivityDeclaration().removePropertyChangeListener(ivjEventHandler);

		getPreconditionFunctionCallDeclarationPanel().dispose();

		super.dispose();
	}

	public IActivityAgentClassDeclaration getActivityAgentClassDeclaration() {
		return getActivityAgentClassDeclarationIntern();
	}

	private IActivityAgentClassDeclaration getActivityAgentClassDeclarationIntern() {
		return ivjActivityAgentClassDeclarationIntern;
	}

	public IActivityGraphRuleDeclaration getActivityRuleDeclaration() {
		return getActivityRuleDeclarationIntern();
	}

	private IActivityGraphRuleDeclaration getActivityRuleDeclarationIntern() {
		return ivjActivityRuleDeclarationIntern;
	}

	private java.awt.BorderLayout getActivityRuleDeclaratonSettingsPanelBorderLayout() {
		java.awt.BorderLayout ivjActivityRuleDeclaratonSettingsPanelBorderLayout = null;
		try {
			/* Create part */
			ivjActivityRuleDeclaratonSettingsPanelBorderLayout = new java.awt.BorderLayout();
			ivjActivityRuleDeclaratonSettingsPanelBorderLayout.setVgap(0);
			ivjActivityRuleDeclaratonSettingsPanelBorderLayout.setHgap(0);
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		};
		return ivjActivityRuleDeclaratonSettingsPanelBorderLayout;
	}

	/**
	 * @see de.uniwue.ki.gui.mas.model.util.declaration.IDeclarationPanel
	 */
	public IDeclaration getDeclaration() {
		return getActivityRuleDeclaration();
	}

	/**
	 * Return the FromActivityDeclaration property value.
	 * @return de.uniwue.ki.mas.model.behaviour.activity.IActivityGraphNodeDeclaration
	 */
	private IActivityGraphNodeDeclaration getFromActivityDeclaration() {
		return ivjFromActivityDeclaration;
	}

	/**
	 * Return the FromActivityLabel property value.
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getFromActivityLabel() {
		if (ivjFromActivityLabel == null) {
			try {
				ivjFromActivityLabel = new javax.swing.JLabel();
				ivjFromActivityLabel.setName("FromActivityLabel");
				ivjFromActivityLabel.setText("From:");
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjFromActivityLabel;
	}

	/**
	     * Return the FromActivityComboBox property value.
	     * @return de.uniwue.ki.gui.mas.model.util.declaration.DeclarationComboBox
	     */
	private BoundJTextField getFromActivityTextField() {
		if (ivjFromActivityTextField == null) {
			try {
				ivjFromActivityTextField = new BoundJTextField();
				ivjFromActivityTextField.setName("FromActivityTextField");
				ivjFromActivityTextField.setEditable(false);
				ivjFromActivityTextField.setMaximumSize(new java.awt.Dimension(250, 20));
				ivjFromActivityTextField.setMinimumSize(new java.awt.Dimension(100, 20));
				ivjFromActivityTextField.setColumns(20);
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjFromActivityTextField;
	}

	/**
	     * Return the JPanel1 property value.
	     * @return javax.swing.JPanel
	     */
	private javax.swing.JPanel getJPanel1() {
		if (ivjJPanel1 == null) {
			try {
				ivjJPanel1 = new javax.swing.JPanel();
				ivjJPanel1.setName("JPanel1");
				ivjJPanel1.setBorder(BorderFactory.createEmptyBorder(0, 5, 0, 0));
				ivjJPanel1.setLayout(new java.awt.GridBagLayout());

				java.awt.GridBagConstraints constraintsFromActivityLabel = new java.awt.GridBagConstraints();
				constraintsFromActivityLabel.gridx = 0;
				constraintsFromActivityLabel.gridy = 0;
				constraintsFromActivityLabel.anchor = java.awt.GridBagConstraints.WEST;
				constraintsFromActivityLabel.insets = new java.awt.Insets(0, 5, 0, 5);
				getJPanel1().add(getFromActivityLabel(), constraintsFromActivityLabel);

				java.awt.GridBagConstraints constraintsToActivityLabel = new java.awt.GridBagConstraints();
				constraintsToActivityLabel.gridx = 0;
				constraintsToActivityLabel.gridy = 1;
				constraintsToActivityLabel.anchor = java.awt.GridBagConstraints.WEST;
				constraintsToActivityLabel.insets = new java.awt.Insets(0, 5, 0, 5);
				getJPanel1().add(getToActivityLabel(), constraintsToActivityLabel);

				java.awt.GridBagConstraints constraintsToActivityTextField =
					new java.awt.GridBagConstraints();
				constraintsToActivityTextField.gridx = 1;
				constraintsToActivityTextField.gridy = 1;
				constraintsToActivityTextField.fill = java.awt.GridBagConstraints.HORIZONTAL;
				constraintsToActivityTextField.anchor = java.awt.GridBagConstraints.WEST;
				constraintsToActivityTextField.weightx = 1.0;
				constraintsToActivityTextField.insets = new java.awt.Insets(0, 0, 5, 5);
				getJPanel1().add(getToActivityTextField(), constraintsToActivityTextField);

				java.awt.GridBagConstraints constraintsFromActivityTextField =
					new java.awt.GridBagConstraints();
				constraintsFromActivityTextField.gridx = 1;
				constraintsFromActivityTextField.gridy = 0;
				constraintsFromActivityTextField.fill = java.awt.GridBagConstraints.HORIZONTAL;
				constraintsFromActivityTextField.anchor = java.awt.GridBagConstraints.WEST;
				constraintsFromActivityTextField.weightx = 1.0;
				constraintsFromActivityTextField.insets = new java.awt.Insets(0, 0, 5, 5);
				getJPanel1().add(getFromActivityTextField(), constraintsFromActivityTextField);
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjJPanel1;
	}

	/**
	     * Return the PreconditionFunctionCallDeclarationPanel property value.
	     * @return de.uniwue.ki.gui.mas.model.basics.functionCall.FunctionCallDeclarationTreeListPanel
	     */
	private FunctionCallDeclarationTreeListPanel getPreconditionFunctionCallDeclarationPanel() {
		if (ivjPreconditionFunctionCallDeclarationPanel == null) {
			try {
				ivjPreconditionFunctionCallDeclarationPanel = new FunctionCallDeclarationTreeListPanel();
				ivjPreconditionFunctionCallDeclarationPanel.setName(
					"PreconditionFunctionCallDeclarationPanel");
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjPreconditionFunctionCallDeclarationPanel;
	}

	/**
	 * Return the ToActivityDeclaration property value.
	 * @return de.uniwue.ki.mas.model.behaviour.activity.IActivityGraphNodeDeclaration
	 */
	private IActivityGraphNodeDeclaration getToActivityDeclaration() {
		return ivjToActivityDeclaration;
	}

	/**
	 * Return the ToActivityLabel property value.
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getToActivityLabel() {
		if (ivjToActivityLabel == null) {
			try {
				ivjToActivityLabel = new javax.swing.JLabel();
				ivjToActivityLabel.setName("ToActivityLabel");
				ivjToActivityLabel.setText("To:");
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjToActivityLabel;
	}

	/**
	     * Return the ToActivityComboBox property value.
	     * @return de.uniwue.ki.gui.mas.model.util.declaration.DeclarationComboBox
	     */
	private BoundJTextField getToActivityTextField() {
		if (ivjToActivityTextField == null) {
			try {
				ivjToActivityTextField = new BoundJTextField();
				ivjToActivityTextField.setName("ToActivityTextField");
				ivjToActivityTextField.setEditable(false);
				ivjToActivityTextField.setMaximumSize(new java.awt.Dimension(250, 20));
				ivjToActivityTextField.setMinimumSize(new java.awt.Dimension(50, 20));
				ivjToActivityTextField.setColumns(20);
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjToActivityTextField;
	}

	/**
	 * Called whenever the part throws an exception.
	 * @param exception Throwable
	 */
	private void handleException(Throwable exception) {

		exception.printStackTrace(System.out);
	}

	/**
	     * Initializes connections
	     * @exception Exception The exception description.
	     */
	private void initConnections() {
		getPreconditionFunctionCallDeclarationPanel().addPropertyChangeListener(ivjEventHandler);
		this.addPropertyChangeListener(ivjEventHandler);
		connPtoP13SetTarget();
		connPtoP4SetTarget();
		connPtoP5SetTarget();
		connPtoP6SetTarget();
		connPtoP9SetTarget();
	}

	/**
	     * Initialize the class.
	     */
	private void initialize() {
		try {
					setName("ActivityRuleDeclaratonSettingsPanel");
			setLayout(getActivityRuleDeclaratonSettingsPanelBorderLayout());
			setSize(392, 242);
			add(getJPanel1(), "North");
			add(getPreconditionFunctionCallDeclarationPanel(), "Center");
			initConnections();
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	public void setActivityAgentClassDeclaration(IActivityAgentClassDeclaration arg1) {
		setActivityAgentClassDeclarationIntern(arg1);
	}

	/**
	     * Set the AgentClassDeclarationIntern to a new value.
	     * @param newValue de.uniwue.ki.mas.model.entity.objectclass.IAgentClassDeclaration
	     */
	private void setActivityAgentClassDeclarationIntern(IActivityAgentClassDeclaration newValue) {
		if (ivjActivityAgentClassDeclarationIntern != newValue) {
			try {
				IActivityAgentClassDeclaration oldValue = getActivityAgentClassDeclarationIntern();
				ivjActivityAgentClassDeclarationIntern = newValue;
				connPtoP13SetTarget();
				firePropertyChange("activityAgentClassDeclaration", oldValue, newValue);
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		};
	}

	/**
	 * Method generated to support the promotion of the activityArgumentRuleDeclaration attribute.
	 * @param arg1 de.uniwue.ki.mas.model.behaviour.rule.IActivityGraphRuleDeclaration
	 */
	public void setActivityRuleDeclaration(IActivityGraphRuleDeclaration arg1) {
		setActivityRuleDeclarationIntern(arg1);
	}

	/**
	     * Set the ActivityRuleDeclaration to a new value.
	     * @param newValue de.uniwue.ki.mas.model.behaviour.rule.IArgumentRuleDeclaration
	     */
	private void setActivityRuleDeclarationIntern(IActivityGraphRuleDeclaration newValue) {
		if (ivjActivityRuleDeclarationIntern != newValue) {
			try {
				IActivityGraphRuleDeclaration oldValue = getActivityRuleDeclarationIntern();
				/* Stop listening for events from the current object */
				if (ivjActivityRuleDeclarationIntern != null) {
					ivjActivityRuleDeclarationIntern.removePropertyChangeListener(ivjEventHandler);
				}
				ivjActivityRuleDeclarationIntern = newValue;

				/* Listen for events from the new object */
				if (ivjActivityRuleDeclarationIntern != null) {
					ivjActivityRuleDeclarationIntern.addPropertyChangeListener(ivjEventHandler);
				}
				connPtoP4SetTarget();
				connEtoM3(ivjActivityRuleDeclarationIntern);
				connEtoM4(ivjActivityRuleDeclarationIntern);
				firePropertyChange("activityArgumentRuleDeclaration", oldValue, newValue);
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		};
	}

	/**
	 * @see de.uniwue.ki.gui.mas.model.util.declaration.IDeclarationPanel
	 */
	public void setDeclaration(IDeclaration declaration) {
		setActivityRuleDeclaration((IActivityGraphRuleDeclaration)declaration);
	}

	/**
	 * Set the FromActivityDeclaration to a new value.
	 * @param newValue de.uniwue.ki.mas.model.behaviour.activity.IActivityGraphNodeDeclaration
	 */
	private void setFromActivityDeclaration(IActivityGraphNodeDeclaration newValue) {
		if (ivjFromActivityDeclaration != newValue) {
			try {
				/* Stop listening for events from the current object */
				if (ivjFromActivityDeclaration != null) {
					ivjFromActivityDeclaration.removePropertyChangeListener(ivjEventHandler);
				}
				ivjFromActivityDeclaration = newValue;

				/* Listen for events from the new object */
				if (ivjFromActivityDeclaration != null) {
					ivjFromActivityDeclaration.addPropertyChangeListener(ivjEventHandler);
				}
				connPtoP5SetTarget();
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		};
	}

	/**
	 * Set the ToActivityDeclaration to a new value.
	 * @param newValue de.uniwue.ki.mas.model.behaviour.activity.IActivityGraphNodeDeclaration
	 */
	private void setToActivityDeclaration(IActivityGraphNodeDeclaration newValue) {
		if (ivjToActivityDeclaration != newValue) {
			try {
				/* Stop listening for events from the current object */
				if (ivjToActivityDeclaration != null) {
					ivjToActivityDeclaration.removePropertyChangeListener(ivjEventHandler);
				}
				ivjToActivityDeclaration = newValue;

				/* Listen for events from the new object */
				if (ivjToActivityDeclaration != null) {
					ivjToActivityDeclaration.addPropertyChangeListener(ivjEventHandler);
				}
				connPtoP6SetTarget();
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		};
	}
}