package de.uniwue.ki.gui.mas.entity.body;
import java.beans.PropertyChangeEvent;

import javax.swing.JFrame;
import javax.swing.JPanel;

import de.uniwue.ki.gui.mas.entity.variable.BodyVariableTablePanel;

/**
 * Creation date: (12.10.2000 14:14:39)
 * @author Christoph Oechslein
 */
public class BodyPanel extends JPanel {
	private final IvjEventHandler ivjEventHandler = new IvjEventHandler();
	private BodyVariableTablePanel ivjBodyVariableListPanel = null;

	private final class IvjEventHandler implements java.beans.PropertyChangeListener {
		public void propertyChange(java.beans.PropertyChangeEvent evt) {
			if (evt.getSource() == BodyPanel.this.getBodyVariableListPanel()
				&& (evt.getPropertyName().equals("gUISeSAmDeclaration")))
				connEtoC1(evt);
			if (evt.getSource() == BodyPanel.this.getBodyVariableListPanel()
				&& (evt.getPropertyName().equals("body")))
				connEtoC2(evt);
		}
	}

	public BodyPanel() {
		super();
		initialize();
	}

	/**
	 * BodyPanel constructor comment.
	 * @param layout java.awt.LayoutManager
	 */
	public BodyPanel(java.awt.LayoutManager layout) {
		super(layout);
	}

	public BodyPanel(java.awt.LayoutManager layout, boolean isDoubleBuffered) {
		super(layout, isDoubleBuffered);
	}

	public BodyPanel(boolean isDoubleBuffered) {
		super(isDoubleBuffered);
	}

	private void connEtoC1(PropertyChangeEvent arg1) {
		try {
					this.firePropertyChange("gUISeSAmDeclaration", arg1.getOldValue(), arg1.getNewValue());
				} catch (Throwable ivjExc) {
					handleException(ivjExc);
		}
	}

	private void connEtoC2(java.beans.PropertyChangeEvent arg1) {
		try {
					this.firePropertyChange("body", arg1.getOldValue(), arg1.getNewValue());
				} catch (Throwable ivjExc) {
					handleException(ivjExc);
		}
	}

	public de.uniwue.ki.mas.entity.body.IBody getBody() {
		return getBodyVariableListPanel().getBody();
	}

	private BodyVariableTablePanel getBodyVariableListPanel() {
		if (ivjBodyVariableListPanel == null) {
			try {
				ivjBodyVariableListPanel = new BodyVariableTablePanel();
				ivjBodyVariableListPanel.setName("BodyVariableTablePanel");
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjBodyVariableListPanel;
	}

	public de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration getGUISeSAmDeclaration() {
		return getBodyVariableListPanel().getGUISeSAmDeclaration();
	}

	private void handleException(Throwable exception) {
		exception.printStackTrace(System.out);
	}

	private void initConnections() {
		getBodyVariableListPanel().addPropertyChangeListener(ivjEventHandler);
	}

	private void initialize() {
		try {
			setName("BodyPanel");
			setLayout(new java.awt.BorderLayout());
			setSize(191, 181);
			add(getBodyVariableListPanel(), "Center");
			initConnections();
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	public static void main(String[] args) {
		try {
			JFrame frame = new javax.swing.JFrame();
			BodyPanel aBodyPanel;
			aBodyPanel = new BodyPanel();
			frame.setContentPane(aBodyPanel);
			frame.setSize(aBodyPanel.getSize());
			frame.addWindowListener(new java.awt.event.WindowAdapter() {
				public void windowClosing(java.awt.event.WindowEvent e) {
					System.exit(0);
				}
			});
			frame.show();
			java.awt.Insets insets = frame.getInsets();
			frame.setSize(
				frame.getWidth() + insets.left + insets.right,
				frame.getHeight() + insets.top + insets.bottom);
			frame.setVisible(true);
		} catch (Throwable exception) {
			System.err.println("Exception occurred in main() of javax.swing.JPanel");
			exception.printStackTrace(System.out);
		}
	}

	public void refresh() {
		getBodyVariableListPanel().refresh();
	}

	public void setBody(de.uniwue.ki.mas.entity.body.IBody arg1) {
		getBodyVariableListPanel().setBody(arg1);
	}

	public void setGUISeSAmDeclaration(de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration arg1) {
		getBodyVariableListPanel().setGUISeSAmDeclaration(arg1);
	}
}