package de.uniwue.ki.gui.mas.entity.bodyclass;
import java.awt.BorderLayout;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import javax.swing.*;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import com.jgoodies.forms.factories.Borders;

import de.uniwue.ki.gui.mas.entity.variableclass.*;
import de.uniwue.ki.gui.mas.util.declaration.AbstractDeclarationPanel;
import de.uniwue.ki.mas.basics.functionArgument.IFunctionArgumentDeclarationList;
import de.uniwue.ki.mas.entity.objectclass.IObjectClassDeclaration;
import de.uniwue.ki.mas.entity.variableclass.*;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: (20.06.00 18:53:19)
 * @author Christoph Oechslein
 */
public class BodyClassDeclarationSettingsWithTabsPanel extends AbstractDeclarationPanel {

	private final class IvjEventHandler implements PropertyChangeListener, ListSelectionListener {
		public void propertyChange(PropertyChangeEvent evt) {
			if (evt.getSource() == BodyClassDeclarationSettingsWithTabsPanel.this
				&& (evt.getPropertyName().equals("gUISeSAmDeclaration")))
				connPtoP4SetTarget();
			if (evt.getSource()
				== BodyClassDeclarationSettingsWithTabsPanel.this.getBodyVariableClassDeclarationListPanel()
				&& (evt.getPropertyName().equals("gUISeSAmDeclaration")))
				connPtoP4SetSource();
			if (evt.getSource()
				== BodyClassDeclarationSettingsWithTabsPanel.this.getBodyVariableClassDeclarationListPanel()
				&& (evt.getPropertyName().equals("objectClassDeclaration")))
				connPtoP3SetSource();
			if (evt.getSource() == BodyClassDeclarationSettingsWithTabsPanel.this
				&& (evt.getPropertyName().equals("gUISeSAmDeclaration")))
				connPtoP1SetTarget();
			if (evt.getSource()
				== BodyClassDeclarationSettingsWithTabsPanel
					.this
					.getBodyVariableOrBodyFeatureVariableClassDeclarationPanel()
				&& (evt.getPropertyName().equals("gUISeSAmDeclaration")))
				connPtoP1SetSource();
			if (evt.getSource()
				== BodyClassDeclarationSettingsWithTabsPanel
					.this
					.getBodyVariableOrBodyFeatureVariableClassDeclarationPanel()
				&& (evt.getPropertyName().equals("objectClassDeclaration")));
		}
		public void valueChanged(ListSelectionEvent e) {
			if (e.getSource()
				== BodyClassDeclarationSettingsWithTabsPanel.this.getBodyVariableClassDeclarationListPanel())
				connEtoC1(e);
		}
	}
	private final IvjEventHandler ivjEventHandler = new IvjEventHandler();
	private boolean ivjConnPtoP3Aligning = false;
	private BodyVariableClassDeclarationListPanel ivjBodyVariableClassDeclarationListPanel = null;
	private boolean ivjConnPtoP4Aligning = false;
	private JPanel ivjJPanelSelectedVariable = null;
	private boolean ivjConnPtoP1Aligning = false;
	private boolean ivjConnPtoP6Aligning = false;
	private boolean ivjConnPtoP7Aligning = false;
	private BodyVariableOrBodyFeatureVariableClassDeclarationPanel ivjBodyVariableOrBodyFeatureVariableClassDeclarationPanel =
		null;
	private IObjectClassDeclaration ivjObjectClassDeclarationIntern = null;

	/**
	 * BodyClassDeclarationPanel constructor comment.
	 */
	public BodyClassDeclarationSettingsWithTabsPanel() {
		super();
		initialize();
	}

	/**
	 * connEtoC1:  (BodyVariableClassDeclarationListPanel.listSelection.valueChanged(ListSelectionEvent) --> BodyClassDeclarationSettingsWithTabsPanel.eventSelectionChanged()V)
	 * @param arg1 ListSelectionEvent
	 */
	private void connEtoC1(ListSelectionEvent arg1) {
		try {
					this.eventSelectionChanged();
				} catch (Throwable ivjExc) {
					handleException(ivjExc);
		}
	}

	/**
	 * connEtoM1:  (ObjectClassDeclarationIntern.this --> BodyVariableClassDeclarationListPanel.declarationListModel)
	 * @param value de.uniwue.ki.mas.model.entity.objectclass.ActivityObjectClassDeclaration
	 */
	private void connEtoM1(IObjectClassDeclaration value) {
		try {
					getBodyVariableClassDeclarationListPanel().setDeclarationListModel(
				this.getBodyVariableClassDeclarationList());
				} catch (Throwable ivjExc) {
					handleException(ivjExc);
		}
	}

	/**
	 * connPtoP1SetSource:  (BodyClassDeclarationSettingsWithTabsPanel.gUISeSAmDeclaration <--> BodyFeatureVariableClassDeclarationPanel.gUISeSAmDeclaration)
	 */
	private void connPtoP1SetSource() {
		try {
			if (ivjConnPtoP1Aligning == false) {
								ivjConnPtoP1Aligning = true;
				this.setGUISeSAmDeclaration(
					getBodyVariableOrBodyFeatureVariableClassDeclarationPanel().getGUISeSAmDeclaration());
								ivjConnPtoP1Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP1Aligning = false;
					handleException(ivjExc);
		}
	}

	/**
	 * connPtoP1SetTarget:  (BodyClassDeclarationSettingsWithTabsPanel.gUISeSAmDeclaration <--> BodyFeatureVariableClassDeclarationPanel.gUISeSAmDeclaration)
	 */
	private void connPtoP1SetTarget() {
		try {
			if (ivjConnPtoP1Aligning == false) {
								ivjConnPtoP1Aligning = true;
				getBodyVariableOrBodyFeatureVariableClassDeclarationPanel().setGUISeSAmDeclaration(
					this.getGUISeSAmDeclaration());
								ivjConnPtoP1Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP1Aligning = false;
					handleException(ivjExc);
		}
	}

	/**
	 * connPtoP3SetSource:  (ObjectClassDeclarationIntern.this <--> VariableClassDeclarationListToDeclarationListPanel.objectClassDeclaration)
	 */
	private void connPtoP3SetSource() {
		try {
			if (ivjConnPtoP3Aligning == false) {
								ivjConnPtoP3Aligning = true;
				setObjectClassDeclarationIntern(
					getBodyVariableClassDeclarationListPanel().getObjectClassDeclaration());
								ivjConnPtoP3Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP3Aligning = false;
					handleException(ivjExc);
		}
	}

	/**
	 * connPtoP3SetTarget:  (ObjectClassDeclarationIntern.this <--> VariableClassDeclarationListToDeclarationListPanel.objectClassDeclaration)
	 */
	private void connPtoP3SetTarget() {
		try {
			if (ivjConnPtoP3Aligning == false) {
								ivjConnPtoP3Aligning = true;
				if ((getObjectClassDeclarationIntern() != null)) {
					getBodyVariableClassDeclarationListPanel().setObjectClassDeclaration(
						getObjectClassDeclarationIntern());
				}
								ivjConnPtoP3Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP3Aligning = false;
					handleException(ivjExc);
		}
	}

	/**
	 * connPtoP4SetSource:  (BodyClassDeclarationSettingsPanel.gUISeSAmDeclaration <--> BodyVariableClassDeclarationListPanel.gUISeSAmDeclaration)
	 */
	private void connPtoP4SetSource() {
		try {
			if (ivjConnPtoP4Aligning == false) {
								ivjConnPtoP4Aligning = true;
				this.setGUISeSAmDeclaration(
					getBodyVariableClassDeclarationListPanel().getGUISeSAmDeclaration());
								ivjConnPtoP4Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP4Aligning = false;
					handleException(ivjExc);
		}
	}

	/**
	 * connPtoP4SetTarget:  (BodyClassDeclarationSettingsPanel.gUISeSAmDeclaration <--> BodyVariableClassDeclarationListPanel.gUISeSAmDeclaration)
	 */
	private void connPtoP4SetTarget() {
		try {
			if (ivjConnPtoP4Aligning == false) {
								ivjConnPtoP4Aligning = true;
				getBodyVariableClassDeclarationListPanel().setGUISeSAmDeclaration(
					this.getGUISeSAmDeclaration());
								ivjConnPtoP4Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP4Aligning = false;
					handleException(ivjExc);
		}
	}

	/**
	 * connPtoP6SetTarget:  (ObjectClassDeclarationIntern.this <--> BodyFeatureVariableClassDeclarationPanel.objectClassDeclaration)
	 */
	private void connPtoP6SetTarget() {
		try {
			if (ivjConnPtoP6Aligning == false) {
								ivjConnPtoP6Aligning = true;
				if ((getObjectClassDeclarationIntern() != null)) {
					getBodyVariableOrBodyFeatureVariableClassDeclarationPanel().setObjectClassDeclaration(getObjectClassDeclarationIntern());
					/*
						.getExpertFilterUserFeatureFunctionDeclarationListAble()
						.setObjectClassDeclaration(getObjectClassDeclarationIntern());
						*/
				}
								ivjConnPtoP6Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP6Aligning = false;
					handleException(ivjExc);
		}
	}

	private BodyVariableClassDeclarationCellRendererAdapter getBodyVariableClassDeclarationCellRenderer() {
		return (BodyVariableClassDeclarationCellRendererAdapter)getBodyVariableClassDeclarationListPanel()
			.getCellRenderer();
	}

	/**
	 * connPtoP7SetTarget:  (ObjectClassDeclarationIntern.this <--> BodyVariableClassDeclarationCellRenderer.objectClassDeclaration)
	 */
	private void connPtoP7SetTarget() {
		try {
			if (ivjConnPtoP7Aligning == false) {
								ivjConnPtoP7Aligning = true;
				if ((getObjectClassDeclarationIntern() != null)) {
					getBodyVariableClassDeclarationCellRenderer().setObjectClassDeclaration(
						getObjectClassDeclarationIntern());
				}
								ivjConnPtoP7Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP7Aligning = false;
					handleException(ivjExc);
		}
	}

	public void dispose() {

		getBodyVariableClassDeclarationListPanel().dispose();
		getBodyVariableOrBodyFeatureVariableClassDeclarationPanel().dispose();

		super.dispose();
	}

	protected void eventSelectionChanged() {
		IBodyVariableClassDeclaration bodyVariableClassDeclaration =
			(IBodyVariableClassDeclaration)getBodyVariableClassDeclarationListPanel()
				.getSelectedDeclaration();

		if (bodyVariableClassDeclaration == null) {
			//			getBodyVariableOrBodyFeatureVariableClassDeclarationPanel().setVisible(false);
			getBodyVariableOrBodyFeatureVariableClassDeclarationPanel().setEnabled(false);

		} else if (bodyVariableClassDeclaration instanceof IBodyFeatureVariableClassDeclaration) {
			getBodyVariableOrBodyFeatureVariableClassDeclarationPanel().setBodyVariableClassDeclaration(
				bodyVariableClassDeclaration);

			//			IObjectFeatureClassDeclaration objectFeatureClassDeclaration =
			//				searchFeatureClassDeclaration(
			//					(IBodyFeatureVariableClassDeclaration) bodyVariableClassDeclaration);
			//
			//			if (objectFeatureClassDeclaration != null) {
			//				((BetterTitledBorder) getJPanelSelectedVariable().getBorder()).setTitle(
			//					"Selected Feature Variable <" + objectFeatureClassDeclaration.getName() + ">");
			//				getJPanelSelectedVariable().repaint();
			//			}

			getBodyVariableOrBodyFeatureVariableClassDeclarationPanel().setEnabled(true);
			getBodyVariableOrBodyFeatureVariableClassDeclarationPanel().setVisible(true);

		} else {
			getBodyVariableOrBodyFeatureVariableClassDeclarationPanel().setBodyVariableClassDeclaration(
				bodyVariableClassDeclaration);

			//			((BetterTitledBorder) getJPanelSelectedVariable().getBorder()).setTitle("Selected Variable");
			//			getJPanelSelectedVariable().repaint();

			getBodyVariableOrBodyFeatureVariableClassDeclarationPanel().setEnabled(true);
			//			getBodyVariableOrBodyFeatureVariableClassDeclarationPanel().setVisible(true);
		}
	}

	protected BodyVariableClassDeclarationList getBodyVariableClassDeclarationList() {
		if ((getObjectClassDeclaration() == null)
			|| (getObjectClassDeclaration().getBodyClassDeclaration() == null)) {
			return null;
		} else {
			return getObjectClassDeclaration()
				.getBodyClassDeclaration()
				.getBodyVariableClassDeclarationListAndFactory()
				.getBodyVariableClassDeclarationList();
		}
	}

	/**
	 * Return the BodyVariableClassDeclarationListPanel property value.
	 * @return de.uniwue.ki.gui.mas.model.entity.variableclass.BodyVariableClassDeclarationListPanel
	 */
	private BodyVariableClassDeclarationListPanel getBodyVariableClassDeclarationListPanel() {
		if (ivjBodyVariableClassDeclarationListPanel == null) {
			try {
				ivjBodyVariableClassDeclarationListPanel = new BodyVariableClassDeclarationListPanel();
				ivjBodyVariableClassDeclarationListPanel.setName("BodyVariableClassDeclarationListPanel");
						getBodyVariableClassDeclarationListPanel().setCellRenderer(
					new BodyVariableClassDeclarationCellRendererAdapter(
						getBodyVariableClassDeclarationListPanel().getCellRenderer()));
					} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjBodyVariableClassDeclarationListPanel;
	}

	/**
	 * Return the BodyVariableOrBodyFeatureVariableClassDeclarationPanel property value.
	 * @return de.uniwue.ki.gui.mas.model.entity.variableclass.BodyVariableOrBodyFeatureVariableClassDeclarationPanel
	 */
	private BodyVariableOrBodyFeatureVariableClassDeclarationPanel getBodyVariableOrBodyFeatureVariableClassDeclarationPanel() {
		if (ivjBodyVariableOrBodyFeatureVariableClassDeclarationPanel == null) {
			try {
				ivjBodyVariableOrBodyFeatureVariableClassDeclarationPanel =
					new BodyVariableOrBodyFeatureVariableClassDeclarationPanel();
				ivjBodyVariableOrBodyFeatureVariableClassDeclarationPanel.setName(
					"BodyVariableOrBodyFeatureVariableClassDeclarationPanel");
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjBodyVariableOrBodyFeatureVariableClassDeclarationPanel;
	}

	/**
	 * @see de.uniwue.ki.gui.mas.model.util.declaration.IDeclarationPanel
	 */
	public IDeclaration getDeclaration() {
		return getObjectClassDeclaration();
	}

	/**
	 * Return the JPanel1 property value.
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanelSelectedVariable() {
		if (ivjJPanelSelectedVariable == null) {
			ivjJPanelSelectedVariable = new javax.swing.JPanel();
			ivjJPanelSelectedVariable.setBorder(Borders.createEmptyBorder("1dlu, 1dlu, 0dlu, 0dlu"));
			ivjJPanelSelectedVariable.setLayout(new BoxLayout(ivjJPanelSelectedVariable, BoxLayout.X_AXIS));
			getJPanelSelectedVariable().add(getBodyVariableOrBodyFeatureVariableClassDeclarationPanel());
		}
		return ivjJPanelSelectedVariable;
	}

	/**
	 * Method generated to support the promotion of the objectClassDeclaration attribute.
	 * @return de.uniwue.ki.mas.model.entity.objectclass.IObjectClassDeclaration
	 */
	public IObjectClassDeclaration getObjectClassDeclaration() {
		return getObjectClassDeclarationIntern();
	}

	/**
	 * Return the ObjectClassDeclarationIntern property value.
	 * @return de.uniwue.ki.mas.model.entity.objectclass.IObjectClassDeclaration
	 */
	private IObjectClassDeclaration getObjectClassDeclarationIntern() {
		return ivjObjectClassDeclarationIntern;
	}

	/**
	 * Called whenever the bean information class throws an exception.
	 * @param exception Throwable
	 */
	private void handleException(Throwable exception) {

		exception.printStackTrace(System.out);
	}

	/**
	 * Initializes connections
	 * @exception Exception The exception description.
	 */
	private void initConnections() {
		addPropertyChangeListener(ivjEventHandler);
		getBodyVariableClassDeclarationListPanel().addPropertyChangeListener(ivjEventHandler);
		getBodyVariableOrBodyFeatureVariableClassDeclarationPanel().addPropertyChangeListener(
			ivjEventHandler);
		getBodyVariableClassDeclarationListPanel().addListSelectionListener(ivjEventHandler);
		connPtoP4SetTarget();
		connPtoP3SetTarget();
		connPtoP1SetTarget();
		connPtoP6SetTarget();
		connPtoP7SetTarget();
	}

	/**
	 * Initialize the class.
	 */
	private void initialize() {

		setLayout(new BorderLayout());

		JSplitPane spitPanel =
			new JSplitPane(
				JSplitPane.HORIZONTAL_SPLIT,
				getBodyVariableClassDeclarationListPanel(),
				getJPanelSelectedVariable());
		spitPanel.setOneTouchExpandable(true);
		//spitPanel.setBorder(null);
		add(spitPanel, BorderLayout.CENTER);

		//		CellConstraints cc = new CellConstraints();
		//
		//		add(getBodyVariableClassDeclarationListPanel(), cc.xy(1, 1));
		//		add(getJPanelSelectedVariable(), cc.xy(2, 1));
		//
		//		System.out.println(getBodyVariableClassDeclarationListPanel().getMinimumSize());
		//		System.out.println(getBodyVariableClassDeclarationListPanel().getPreferredSize());
		//		System.out.println();

		initConnections();

		eventSelectionChanged();

	}

	public static void main(String[] args) {
		try {
			JFrame frame = new javax.swing.JFrame();
			BodyClassDeclarationSettingsWithTabsPanel aBodyClassDeclarationSettingsWithTabsPanel;
			aBodyClassDeclarationSettingsWithTabsPanel = new BodyClassDeclarationSettingsWithTabsPanel();
			frame.setContentPane(aBodyClassDeclarationSettingsWithTabsPanel);
			frame.setSize(aBodyClassDeclarationSettingsWithTabsPanel.getSize());
			frame.addWindowListener(new java.awt.event.WindowAdapter() {
				public void windowClosing(java.awt.event.WindowEvent e) {
					System.exit(0);
				}
			});
			frame.pack();
			frame.show();
			java.awt.Insets insets = frame.getInsets();
			frame.setSize(
				frame.getWidth() + insets.left + insets.right,
				frame.getHeight() + insets.top + insets.bottom);
			frame.setVisible(true);

			System.out.println(
				aBodyClassDeclarationSettingsWithTabsPanel.getJPanelSelectedVariable().getPreferredSize());

			System.out.println(aBodyClassDeclarationSettingsWithTabsPanel.getSize());

		} catch (Throwable exception) {
			System.err.println(
				"Exception occurred in main() of de.uniwue.ki.gui.mas.model.util.declaration.AbstractDeclarationPanel");
			exception.printStackTrace(System.out);
		}
	}

	public void setDeclaration(IDeclaration declaration) {
		setObjectClassDeclaration((IObjectClassDeclaration)declaration);
	}

	/**
	 * Method generated to support the promotion of the objectClassDeclaration attribute.
	 * @param arg1 de.uniwue.ki.mas.model.entity.objectclass.IObjectClassDeclaration
	 */
	public void setObjectClassDeclaration(IObjectClassDeclaration arg1) {
		setObjectClassDeclarationIntern(arg1);
	}

	/**
	 * Set the ObjectClassDeclarationIntern to a new value.
	 * @param newValue de.uniwue.ki.mas.model.entity.objectclass.IObjectClassDeclaration
	 */
	private void setObjectClassDeclarationIntern(IObjectClassDeclaration newValue) {
		if (ivjObjectClassDeclarationIntern != newValue) {
			try {
				IObjectClassDeclaration oldValue = getObjectClassDeclarationIntern();
				ivjObjectClassDeclarationIntern = newValue;
				connPtoP3SetTarget();
				connEtoM1(ivjObjectClassDeclarationIntern);
				connPtoP6SetTarget();
				connPtoP7SetTarget();
				firePropertyChange("objectClassDeclaration", oldValue, newValue);
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
	}

	public IFunctionArgumentDeclarationList getOuterFunctionArgumentDeclarationList() {
		return getBodyVariableOrBodyFeatureVariableClassDeclarationPanel()
			.getOuterFunctionArgumentDeclarationList();
	}

	public void setOuterFunctionArgumentDeclarationList(IFunctionArgumentDeclarationList functionArgumentDeclarationList) {
		getBodyVariableOrBodyFeatureVariableClassDeclarationPanel().setOuterFunctionArgumentDeclarationList(
			functionArgumentDeclarationList);
	}
}