package de.uniwue.ki.gui.mas.entity.object;
import javax.swing.*;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import de.uniwue.ki.gui.mas.basics.feature.spatial.ObjectWithSpatialInfoPanel;
import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.model.JPanelWithGUISeSAmDeclaration;
import de.uniwue.ki.mas.basics.feature.spatial.ISpatialMapModel;
import de.uniwue.ki.mas.entity.object.IObject;
import de.uniwue.ki.mas.entity.object.world.IWorld;
import de.uniwue.ki.mas.entity.objectclass.worldclass.IWorldClassDeclaration;
import de.uniwue.ki.mas.sim.situation.ISituation;
import de.uniwue.ki.util.list.IMutableListModel;
/**
 * Creation date: (12.10.2000 11:10:07)
 * @author Christoph Oechslein
 */
public class ObjectGroupObjectSettingPanel extends JPanelWithGUISeSAmDeclaration implements IObjectPanel {
	private int _orientation = JSplitPane.VERTICAL_SPLIT;
	private final IvjEventHandler ivjEventHandler = new IvjEventHandler();
	private ObjectGroupPanel ivjObjectGroupPanel = null;
	private JPanel ivjJPanelSelectedObject = null;
	private boolean ivjConnPtoP5Aligning = false;
	private ObjectWithSpatialInfoPanel ivjSelectedObjectPanel = null;

	private final class IvjEventHandler implements ListSelectionListener {
		public void valueChanged(ListSelectionEvent e) {
			if (e.getSource() == getObjectGroupPanel())
				eventSelectionChanged();
		}
	};

	public ObjectGroupObjectSettingPanel() {
		super();
		initialize();
	}

	public void dispose() {
		getSelectedObjectPanel().dispose();
		getObjectGroupPanel().dispose();

		super.dispose();
	}

	protected void eventSelectionChanged() {
		if (getObjectGroupPanel().isSelectionEmpty()) {
			getSelectedObjectPanel().setEnabled(false);

			getSelectedObjectPanel().setObject(null);

		} else if (getSelectedObjectPanel().getObject() != getObjectGroupPanel().getSelectedValue()) {

			getSelectedObjectPanel().setObject((IObject)getObjectGroupPanel().getSelectedValue());

			getSelectedObjectPanel().setEnabled(true);
		}
	}

	private JPanel getJPanelSelectedObject() {
		if (ivjJPanelSelectedObject == null) {
			//			ivjJPanelSelectedObject = new JPanel();
			//			ivjJPanelSelectedObject.setLayout(
			//				new FormLayout("fill:default:grow", "fill:default, fill:default:grow"));
			//
			//			CellConstraints cc = new CellConstraints();
			//
			//			ivjJPanelSelectedObject.setBorder(Borders.createEmptyBorder("0dlu, 1dlu, 0dlu, 0dlu"));
			////			getJPanelSelectedObject().add(
			////				DefaultComponentFactory.getInstance().createSeparator("Selected Object"),
			////				cc.xy(1, 1));
			//			getJPanelSelectedObject().add(getSelectedObjectPanel(), cc.xy(1, 2));

			ivjJPanelSelectedObject = getSelectedObjectPanel();
		}
		return ivjJPanelSelectedObject;
	}

	private ObjectGroupPanel getObjectGroupPanel() {
		if (ivjObjectGroupPanel == null) {
			ivjObjectGroupPanel = new ObjectGroupPanel();
			ivjObjectGroupPanel.setName("ObjectGroupPanel");

		}
		return ivjObjectGroupPanel;
	}

	public int getOrientation() {
		return _orientation;
	}

	public Object getSelectedValue() {
		return getObjectGroupPanel().getSelectedValue();
	}

	public int getSelectedIndex() {
		return getObjectGroupPanel().getSelectedIndex();
	}

	private ObjectWithSpatialInfoPanel getSelectedObjectPanel() {
		if (ivjSelectedObjectPanel == null) {
			ivjSelectedObjectPanel = new ObjectWithSpatialInfoPanel();
			ivjSelectedObjectPanel.setName("SelectedObjectPanel");
		}
		return ivjSelectedObjectPanel;
	}

	protected IWorldClassDeclaration getWorldClassDeclaration(ISituation situation) {
		return (IWorldClassDeclaration)situation.getWorld().getObjectInstanceDeclaration();
	}

	private void initConnections() {
		getObjectGroupPanel().addListSelectionListener(ivjEventHandler);
		if (ivjConnPtoP5Aligning == false) {
			ivjConnPtoP5Aligning = true;
			setGUISeSAmDeclaration(getObjectGroupPanel().getGUISeSAmDeclaration());
			ivjConnPtoP5Aligning = false;
		}
	}

	private void initialize() {
		setOrientation(JSplitPane.HORIZONTAL_SPLIT);
		initConnections();
		eventSelectionChanged();
	}

	public void refresh() {
		getObjectGroupPanel().refresh();
		getSelectedObjectPanel().refresh();
	}

	public IWorld getWorld() {
		return getObjectGroupPanel().getWorld();
	}

	public void setWorld(IWorld world) {
		getObjectGroupPanel().setWorld(world);
	}

	public IMutableListModel getObjectGroup() {
		return getObjectGroupPanel().getObjectGroup();
	}

	public void setObjectGroup(IMutableListModel objectGroup) {
		getObjectGroupPanel().setObjectGroup(objectGroup);
	}

	public void setOrientation(int newOrientation) {
		if (_orientation != newOrientation) {
			_orientation = newOrientation;

			removeAll();

			boolean isHorizontal = (newOrientation == JSplitPane.HORIZONTAL_SPLIT);

			setLayout(new BoxLayout(this, isHorizontal ? BoxLayout.X_AXIS : BoxLayout.Y_AXIS));

			add(getObjectGroupPanel());
			add(getJPanelSelectedObject());
		}
	}

	public void setSelectedIndex(int newIndex) {
		getObjectGroupPanel().setSelectedIndex(newIndex);
	}

	public void setSelectedValue(Object newObject) {
		getObjectGroupPanel().setSelectedValue(newObject);
	}

	public ISpatialMapModel getSpatialMapModel() {
		return getObjectGroupPanel().getSpatialMapModel();
	}

	public void setSpatialMapModel(ISpatialMapModel SpatialMapModel) {
		getObjectGroupPanel().setSpatialMapModel(SpatialMapModel);
		getSelectedObjectPanel().setSpatialMapModel(SpatialMapModel);
	}

	public boolean isAutomaticUpdate() {
		return getSelectedObjectPanel().isAutomaticUpdate();
	}

	public void setAutomaticUpdate(boolean automaticUpdate) {
		getSelectedObjectPanel().setAutomaticUpdate(automaticUpdate);
	}

	public void setGUISeSAmDeclaration(IGUISeSAmDeclaration guiSeSAmDeclaration) {
		super.setGUISeSAmDeclaration(guiSeSAmDeclaration);

		getObjectGroupPanel().setGUISeSAmDeclaration(guiSeSAmDeclaration);
		getSelectedObjectPanel().setGUISeSAmDeclaration(guiSeSAmDeclaration);
	}

	public void setSortedList(boolean sortedList) {
		getObjectGroupPanel().setSortedList(sortedList);
	}

	public boolean isSortedList() {
		return getObjectGroupPanel().isSortedList();
	}
}