package de.uniwue.ki.gui.mas.entity.object;
import java.awt.Container;
import java.util.Iterator;

import de.uniwue.ki.gui.mas.model.DefaultMutableListModelActionFactory;
import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.util.declaration.DeclarationListPanel;
import de.uniwue.ki.gui.util.actions.AbstractBoundAction;
import de.uniwue.ki.mas.entity.object.IObjectInstanceDeclaration;
import de.uniwue.ki.mas.entity.object.ObjectInstanceDeclarationList;
import de.uniwue.ki.mas.entity.objectclass.IObjectClassDeclaration;
import de.uniwue.ki.mas.entity.objectclass.IObjectClassDeclarationList;
import de.uniwue.ki.mas.entity.objectclass.agentclass.IAgentClassDeclaration;
import de.uniwue.ki.mas.model.ISeSAmModelDeclaration;
import de.uniwue.ki.util.collection.CollectionsHelper;
/**
 * Creation date: (08.02.2002 14:59:09)
 * @author Christoph Oechslein
 */
public class ObjectInstanceDeclarationListActionFactory
	extends DefaultMutableListModelActionFactory {

	public ObjectInstanceDeclarationListActionFactory(IGUISeSAmDeclaration guiSeSAmDeclaration) {
		super(guiSeSAmDeclaration);
	}

	public static AbstractBoundAction createNewAction(
		final Container parent,
		final ObjectInstanceDeclarationList objectInstanceDeclarationList,
		final IGUISeSAmDeclaration guiSeSAmDeclaration) {

		return new AbstractBoundAction("New", _newIcon) {
			public void doit() {
				IObjectInstanceDeclaration objectInstanceDeclaration =
					createNewObjectInstanceDeclaration(parent, guiSeSAmDeclaration);

				if (objectInstanceDeclaration != null)
					objectInstanceDeclarationList.add(objectInstanceDeclaration);
			}
		};
	}

	public static IObjectInstanceDeclaration createNewObjectInstanceDeclaration(
		final Container parent,
		final IGUISeSAmDeclaration guiSeSAmDeclaration) {

		IObjectClassDeclarationList objectClassDeclarationList =
			guiSeSAmDeclaration.getSeSAmModelDeclaration().getAvailibleObjectClassDeclarationList();

		if (objectClassDeclarationList.isEmpty()) {
			return (
				(IAgentClassDeclaration) guiSeSAmDeclaration
					.getSeSAmModelDeclaration()
					.getAgentClassDeclarationListAndFactory()
					.getFirstDeclarationOrCreateNewIfEmpty())
				.createAgentInstanceDeclaration();

		} else {
			IObjectClassDeclaration objectClassDeclaration =
				(IObjectClassDeclaration) DeclarationListPanel.choiceDeclarationList(
					parent,
					guiSeSAmDeclaration,
					objectClassDeclarationList,
					"Choice an Object Class",
					"Which Object Class:");

			if (objectClassDeclaration != null)
				return objectClassDeclaration.createObjectInstanceDeclaration();

			else
				return null;
		}
	}

	public boolean getCanProduceActions(Container parent, Object anObject) {
		return super.getCanProduceActions(parent, anObject)
			&& (anObject instanceof ObjectInstanceDeclarationList);
	}

	public Iterator getMoreActions(Container parent, Object anObject) {
		return CollectionsHelper.createConsIterator(
			createNewAction(parent, (ObjectInstanceDeclarationList) anObject, getGUISeSAmDeclaration()),
			super.getMoreActions(parent, anObject));
	}

	protected ISeSAmModelDeclaration getSeSAmModelDeclaration() {
		return super.getSeSAmModelDeclaration();
	}
}