package de.uniwue.ki.gui.mas.entity.object;

import de.uniwue.ki.gui.mas.util.declaration.DeclarationListPanel;
import de.uniwue.ki.gui.mas.util.declaration.IDeclarationPanel;
import de.uniwue.ki.mas.entity.object.ObjectInstanceDeclarationList;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: (13.12.2000 18:26:47)
 * @author Christoph Oechslein
 */
public class ObjectInstanceDeclarationListPanel extends DeclarationListPanel {
	/**
	 * UserDefinedFunctionDeclarationListPanel constructor comment.
	 */
	public ObjectInstanceDeclarationListPanel() {
		super();
		initialize();
	}

	protected IDeclarationPanel createDeclarationPanel(IDeclaration declaration) {
		ObjectInstanceDeclarationPanel objectInstanceDeclarationPanel = new ObjectInstanceDeclarationPanel();

		return objectInstanceDeclarationPanel;
	}

	protected Object createItem() throws Exception {
		return ObjectInstanceDeclarationListActionFactory.createNewObjectInstanceDeclaration(
			this,
			getGUISeSAmDeclaration());
	}

	protected String getDeclarationFrameTitle(IDeclaration declaration) {
		return "Object Instance";
	}

	private void handleException(Throwable exception) {
		exception.printStackTrace(System.out);
	}
	

	private void initialize() {
		try {
			setName("ObjectInstanceDeclarationListPanel");
			setSize(155, 201);
			setDeclarationListModel(new ObjectInstanceDeclarationList());
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	public static void main(String[] args) {
		try {
			javax.swing.JFrame frame = new javax.swing.JFrame();
			ObjectInstanceDeclarationListPanel aObjectInstanceDeclarationListPanel;
			aObjectInstanceDeclarationListPanel = new ObjectInstanceDeclarationListPanel();
			frame.setContentPane(aObjectInstanceDeclarationListPanel);
			frame.setSize(aObjectInstanceDeclarationListPanel.getSize());
			frame.addWindowListener(new java.awt.event.WindowAdapter() {
				public void windowClosing(java.awt.event.WindowEvent e) {
					System.exit(0);
				};
			});
			frame.show();
			java.awt.Insets insets = frame.getInsets();
			frame.setSize(
				frame.getWidth() + insets.left + insets.right,
				frame.getHeight() + insets.top + insets.bottom);
			frame.setVisible(true);
		} catch (Throwable exception) {
			System.err.println(
				"Exception occurred in main() of de.uniwue.ki.gui.mas.model.entity.object.ObjectInstanceDeclarationListPanel");
			exception.printStackTrace(System.out);
		}
	}
}