package de.uniwue.ki.gui.mas.entity.object;
import java.awt.BorderLayout;

import javax.swing.JPanel;
import javax.swing.JSplitPane;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import com.jgoodies.forms.factories.Borders;
import com.jgoodies.forms.factories.DefaultComponentFactory;

import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.model.JPanelWithGUISeSAmDeclaration;
import de.uniwue.ki.mas.basics.functionArgument.IFunctionArgumentDeclarationList;
import de.uniwue.ki.mas.entity.object.IObjectInstanceDeclaration;
import de.uniwue.ki.mas.entity.object.ObjectInstanceDeclarationList;
import de.uniwue.ki.mas.entity.objectclass.IObjectClassDeclarationList;
import de.uniwue.ki.mas.model.ISeSAmModelDeclaration;
/**
 * Creation date: (30.10.2000 16:33:00)
 * @author Christoph Oechslein
 */
public class ObjectInstanceDeclarationListWithSelectionPanel extends JPanelWithGUISeSAmDeclaration {
	private JSplitPane _splitPane;
	private JPanel ivjJPanelSelected = null;
	private ObjectInstanceDeclarationListPanel ivjObjectInstanceDeclarationListPanel = null;
	private ObjectInstanceDeclarationPanel ivjSelectedObjectInstanceDeclarationPanel = null;

	public ObjectInstanceDeclarationListWithSelectionPanel() {
		super();
		initialize();
	}

	public void dispose() {

		getObjectInstanceDeclarationListPanel().dispose();
		if (getSelectedObjectInstanceDeclarationPanel() != null)
			getSelectedObjectInstanceDeclarationPanel().dispose();

		super.dispose();
	}

	protected void eventObjectInstanceDeclarationListPanelSelectionChaged() {
		getSelectedObjectInstanceDeclarationPanel().setEnabled(
			!getObjectInstanceDeclarationListPanel().isSelectionEmpty());

		getSelectedObjectInstanceDeclarationPanel().setObjectInstanceDeclaration(
			(IObjectInstanceDeclaration)getObjectInstanceDeclarationListPanel().getSelectedDeclaration());
	}

	private javax.swing.JPanel getJPanelSelected() {
		if (ivjJPanelSelected == null) {
			ivjJPanelSelected = new javax.swing.JPanel();
			ivjJPanelSelected.setLayout(new BorderLayout());
			getJPanelSelected().add(
				DefaultComponentFactory.getInstance().createTitle("Selected Object:"),
				BorderLayout.NORTH);
			ivjJPanelSelected.setBorder(Borders.createEmptyBorder("0dlu, 3dlu, 2dlu, 1dlu"));
			getJPanelSelected().add(getSelectedObjectInstanceDeclarationPanel(), BorderLayout.CENTER);
		}
		return ivjJPanelSelected;
	}

	public ObjectInstanceDeclarationList getObjectInstanceDeclarationList() {
		return (ObjectInstanceDeclarationList)getObjectInstanceDeclarationListPanel()
			.getDeclarationListModel();
	}

	private ObjectInstanceDeclarationListPanel getObjectInstanceDeclarationListPanel() {
		if (ivjObjectInstanceDeclarationListPanel == null) {
			ivjObjectInstanceDeclarationListPanel = new ObjectInstanceDeclarationListPanel();
			ivjObjectInstanceDeclarationListPanel.setName("ObjectInstanceDeclarationListPanel");

			ivjObjectInstanceDeclarationListPanel.addListSelectionListener(new ListSelectionListener() {
				public void valueChanged(ListSelectionEvent e) {
					eventObjectInstanceDeclarationListPanelSelectionChaged();
				}
			});
		}
		return ivjObjectInstanceDeclarationListPanel;
	}

	public int getOrientation() {
		return _splitPane.getOrientation();
	}

	public IFunctionArgumentDeclarationList getOuterFunctionArgumentDeclarationList() {
		return getSelectedObjectInstanceDeclarationPanel().getOuterFunctionArgumentDeclarationList();
	}

	private ObjectInstanceDeclarationPanel getSelectedObjectInstanceDeclarationPanel() {
		if (ivjSelectedObjectInstanceDeclarationPanel == null) {
			ivjSelectedObjectInstanceDeclarationPanel = new ObjectInstanceDeclarationPanel();
			ivjSelectedObjectInstanceDeclarationPanel.setEnabled(false);
		}
		return ivjSelectedObjectInstanceDeclarationPanel;
	}

	private void initialize() {
		setLayout(new BorderLayout());

		_splitPane =
			new JSplitPane(
				JSplitPane.HORIZONTAL_SPLIT,
				getObjectInstanceDeclarationListPanel(),
				getJPanelSelected());
		_splitPane.setOneTouchExpandable(true);
		add(_splitPane);
	}

	public boolean isArrowsAvailible() {
		return ivjObjectInstanceDeclarationListPanel.isArrowsAvailible();
	}

	public boolean isButtonPaneAvailible() {
		return ivjObjectInstanceDeclarationListPanel.isButtonPaneAvailible();
	}

	public void setArrowsAvailible(boolean arrowsAvailible) {
		ivjObjectInstanceDeclarationListPanel.setArrowsAvailible(arrowsAvailible);
	}

	public void setButtonPaneAvailible(boolean buttonPaneAvailible) {
		ivjObjectInstanceDeclarationListPanel.setButtonPaneAvailible(buttonPaneAvailible);
	}

	public void setGUISeSAmDeclaration(IGUISeSAmDeclaration guiSeSAmDeclaration) {
		super.setGUISeSAmDeclaration(guiSeSAmDeclaration);

		getSelectedObjectInstanceDeclarationPanel().setGUISeSAmDeclaration(guiSeSAmDeclaration);
		getObjectInstanceDeclarationListPanel().setGUISeSAmDeclaration(guiSeSAmDeclaration);

		if (guiSeSAmDeclaration != null) {
			ISeSAmModelDeclaration seSAmModelDeclaration =
				getGUISeSAmDeclaration().getSeSAmModelDeclaration();
			IObjectClassDeclarationList objectClassDeclarationList =
				seSAmModelDeclaration.getAvailibleObjectClassDeclarationList();

			getSelectedObjectInstanceDeclarationPanel().setObjectClassDeclarationList(
				objectClassDeclarationList);
		}
	}

	public void setObjectInstanceDeclarationList(ObjectInstanceDeclarationList objectInstanceDeclarationList) {
		getObjectInstanceDeclarationListPanel().setDeclarationListModel(objectInstanceDeclarationList);
	}

	public void setOrientation(int orientation) {
		_splitPane.setOrientation(orientation);
	}

	public void setOuterFunctionArgumentDeclarationList(IFunctionArgumentDeclarationList functionArgumentDeclarationList) {
		getSelectedObjectInstanceDeclarationPanel().setOuterFunctionArgumentDeclarationList(
			functionArgumentDeclarationList);
	}
}