package de.uniwue.ki.gui.mas.entity.object;
import java.awt.*;
import java.util.*;

import javax.swing.*;

import com.jgoodies.forms.builder.PanelBuilder;
import com.jgoodies.forms.layout.FormLayout;

import de.uniwue.ki.gui.mas.basics.feature.FeatureInstanceDeclarationListPanel;
import de.uniwue.ki.gui.mas.entity.variable.BodyVariableInstanceDeclarationListWithSelectionPanel;
import de.uniwue.ki.gui.mas.model.GUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.model.IDeclarationPanelAndActionFactory;
import de.uniwue.ki.gui.mas.util.declaration.*;
import de.uniwue.ki.gui.util.*;
import de.uniwue.ki.gui.util.actions.AbstractBoundAction;
import de.uniwue.ki.mas.basics.feature.IObjectFeatureInstanceDeclaration;
import de.uniwue.ki.mas.basics.functionArgument.IFunctionArgumentDeclarationList;
import de.uniwue.ki.mas.entity.body.IBodyInstanceDeclaration;
import de.uniwue.ki.mas.entity.object.IObjectInstanceDeclaration;
import de.uniwue.ki.mas.entity.objectclass.IObjectClassDeclaration;
import de.uniwue.ki.mas.entity.objectclass.IObjectClassDeclarationList;
import de.uniwue.ki.mas.entity.variable.BodyVariableInstanceDeclarationList;
import de.uniwue.ki.mas.util.declaration.IDeclaration;
import de.uniwue.ki.util.collection.CollectionsHelper;
import de.uniwue.ki.util.comparator.NamedComparator;
import de.uniwue.ki.util.functions.IMapFunction;
import de.uniwue.ki.util.name.NamedToStringMethodWrapper;

/**
 * Creation date: (02.11.2000 17:28:37)
 * @author Christoph Oechslein
 */
public class ObjectInstanceDeclarationPanel extends AbstractDeclarationPanel {
	private boolean _changeClassButtonEnabled;
	private JLabel ivjJLabelClass = null;
	private JLabel ivjJLabelName = null;
	private JPanel ivjJPanel = null;
	private IObjectInstanceDeclaration ivjObjectInstanceDeclarationIntern = null;
	private boolean ivjConnPtoP1Aligning = false;
	private final IvjEventHandler ivjEventHandler = new IvjEventHandler();
	private boolean ivjConnPtoP3Aligning = false;
	private boolean ivjConnPtoP8Aligning = false;
	private JDocumentablePanel ivjJDocumentablePanel = null;
	private JNamedPanel ivjObjectClassDeclarationNamePanel = null;
	private JButton ivjChangeClassButton = null;
	private IObjectClassDeclarationList fieldObjectClassDeclarationList = null;
	private BodyVariableInstanceDeclarationListWithSelectionPanel ivjBodyVariableInstanceDeclarationListWithSelectionPanel =
		null;
	private FeatureInstanceDeclarationListPanel ivjFeatureInstanceDeclarationListPanel = null;
	private boolean _showObjectInstanceDeclarationFeatures = true;

	private final class IvjEventHandler
		implements java.awt.event.ActionListener, java.beans.PropertyChangeListener {
		public void actionPerformed(java.awt.event.ActionEvent e) {
			if (e.getSource() == ObjectInstanceDeclarationPanel.this.getChangeClassButton())
				connEtoC1(e);
		}
		public void propertyChange(java.beans.PropertyChangeEvent evt) {
			if (evt.getSource() == ObjectInstanceDeclarationPanel.this
				&& (evt.getPropertyName().equals("gUISeSAmDeclaration")))
				connPtoP3SetTarget();
			if (evt.getSource()
				== ObjectInstanceDeclarationPanel.this.getFeatureInstanceDeclarationListPanel()
				&& (evt.getPropertyName().equals("gUISeSAmDeclaration")))
				connPtoP3SetSource();
			if (evt.getSource() == ObjectInstanceDeclarationPanel.this
				&& (evt.getPropertyName().equals("gUISeSAmDeclaration")))
				connPtoP8SetTarget();
			if (evt.getSource()
				== ObjectInstanceDeclarationPanel
					.this
					.getBodyVariableInstanceDeclarationListWithSelectionPanel()
				&& (evt.getPropertyName().equals("gUISeSAmDeclaration")))
				connPtoP8SetSource();
			if (evt.getSource() == ObjectInstanceDeclarationPanel.this.getJDocumentablePanel()
				&& (evt.getPropertyName().equals("documentable")))
				connPtoP1SetSource();
		}
	}

	/**
	 * ObjectInstanceDeclarationPanel constructor comment.
	 */
	public ObjectInstanceDeclarationPanel() {
		super();
		initialize();
	}

	protected void changeObjectClassDeclaration() {
		if (getObjectClassDeclarationList() != null) {

			IObjectClassDeclaration objectClassDeclaration = choiceObjectClassDeclaration();

			if ((objectClassDeclaration != null)
				&& (!objectClassDeclaration
					.equals(getObjectInstanceDeclaration().getObjectClassDeclaration()))) {

				if ((getObjectInstanceDeclaration() != null)
					&& getObjectInstanceDeclaration().canBeRemoved()) {
					getObjectInstanceDeclaration().remove();
				}

				setObjectInstanceDeclaration(objectClassDeclaration.createObjectInstanceDeclaration());
			}
		}
	}

	protected IObjectClassDeclaration choiceObjectClassDeclaration() {

		IObjectClassDeclarationList objectClassDeclarationList = getObjectClassDeclarationList();

		if ((objectClassDeclarationList == null) || (objectClassDeclarationList.isEmpty())) {
			return null;

		} else if (objectClassDeclarationList.size() == 1) {
			return (IObjectClassDeclaration)objectClassDeclarationList.get(0);

		} else {

			ArrayList selectionValues = new ArrayList(objectClassDeclarationList);

			Collections.sort(selectionValues, NamedComparator.getInstance());

			int selectedIndex = 0;
			if (getObjectInstanceDeclaration() != null) {
				int index =
					selectionValues.indexOf(getObjectInstanceDeclaration().getObjectClassDeclaration());
				if (index != -1)
					selectedIndex = index;
			}

			JOptionPane optionPane =
				new JOptionPane(
					"Choice Object Class: ",
					JOptionPane.QUESTION_MESSAGE,
					JOptionPane.OK_CANCEL_OPTION);

			Object[] namedWrapperList =
				CollectionsHelper
					.asArray(CollectionsHelper.map(selectionValues.iterator(), new IMapFunction() {
				public Object map(Object obj) {
					return new NamedToStringMethodWrapper((IObjectClassDeclaration)obj);
				}
			}));

			optionPane.setSelectionValues(namedWrapperList);

			optionPane.setInitialSelectionValue(namedWrapperList[selectedIndex]);

			optionPane.setWantsInput(true);

			GUISeSAmDeclaration.getDeclarationFrameFactory(getGUISeSAmDeclaration()).addModalPanel(
				this,
				"Which Class:",
				optionPane);

			if (!SwingMoreUtilities.userChoiceOption(optionPane, JOptionPane.OK_OPTION)) {
				return null;
			} else {
				return (IObjectClassDeclaration) ((NamedToStringMethodWrapper)optionPane.getInputValue())
					.getNamedObject();
			}
		}
	}

	/**
	 * connEtoC1:  (ChangeClassButton.action.actionPerformed(java.awt.event.ActionEvent) --> ObjectInstanceDeclarationPanel.changeObjectClassDeclaration()V)
	 * @param arg1 java.awt.event.ActionEvent
	 */
	private void connEtoC1(java.awt.event.ActionEvent arg1) {
		try {
					this.changeObjectClassDeclaration();
				} catch (Throwable ivjExc) {
					handleException(ivjExc);
		}
	}

	/**
	 * connEtoC2:  (ObjectInstanceDeclarationIntern.this --> ObjectInstanceDeclarationPanel.eventObjectInstanceDeclarationChanged()V)
	 * @param value de.uniwue.ki.mas.model.entity.object.IObjectInstanceDeclaration
	 */
	private void connEtoC2(IObjectInstanceDeclaration value) {
		try {
					this.eventObjectInstanceDeclarationChanged();
				} catch (Throwable ivjExc) {
					handleException(ivjExc);
		}
	}

	/**
	 * connEtoM1:  (ObjectInstanceDeclarationIntern.this --> BodyVariableInstanceDeclarationListPanel1.declarationListModel)
	 * @param value IObjectInstanceDeclaration
	 */
	private void connEtoM1(IObjectInstanceDeclaration value) {
		try {
				if (getObjectInstanceDeclarationIntern() == null) {
				return;
			}
				getBodyVariableInstanceDeclarationListWithSelectionPanel()
				.setBodyVariableInstanceDeclarationList(
				this.getBodyVariableInstanceDeclarationList(
					getObjectInstanceDeclarationIntern().getBodyInstanceDeclaration()));
				} catch (Throwable ivjExc) {
					handleException(ivjExc);
		}
	}

	/**
	 * connPtoP1SetSource:  (ObjectInstanceDeclarationIntern.this <--> JDocumentablePanel.documentable)
	 */
	private void connPtoP1SetSource() {
		try {
			if (ivjConnPtoP1Aligning == false) {
								ivjConnPtoP1Aligning = true;
				setObjectInstanceDeclarationIntern(
					(IObjectInstanceDeclaration)getJDocumentablePanel().getDocumentable());
								ivjConnPtoP1Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP1Aligning = false;
					handleException(ivjExc);
		}
	}

	/**
	 * connPtoP1SetTarget:  (ObjectInstanceDeclarationIntern.name <--> JTextFieldName.text)
	 */
	private void connPtoP1SetTarget() {
		try {
			if (ivjConnPtoP1Aligning == false) {
								ivjConnPtoP1Aligning = true;
				if ((getObjectInstanceDeclarationIntern() != null)) {
					getJDocumentablePanel().setDocumentable(getObjectInstanceDeclarationIntern());
				}
								ivjConnPtoP1Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP1Aligning = false;
					handleException(ivjExc);
		}
	}

	private void connPtoP2SetTarget() {
		try {
			if ((getObjectInstanceDeclarationIntern() != null)) {
				getObjectClassDeclarationNamePanel().setNamed(
					getObjectInstanceDeclarationIntern().getObjectClassDeclaration());
			}
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	private void connPtoP3SetSource() {
		try {
			if (ivjConnPtoP3Aligning == false) {
				ivjConnPtoP3Aligning = true;
				this.setGUISeSAmDeclaration(
					getFeatureInstanceDeclarationListPanel().getGUISeSAmDeclaration());
				ivjConnPtoP3Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP3Aligning = false;
			handleException(ivjExc);
		}
	}

	private void connPtoP3SetTarget() {
		try {
			if (ivjConnPtoP3Aligning == false) {
				ivjConnPtoP3Aligning = true;
				getFeatureInstanceDeclarationListPanel().setGUISeSAmDeclaration(
					this.getGUISeSAmDeclaration());
				ivjConnPtoP3Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP3Aligning = false;
			handleException(ivjExc);
		}
	}

	private void connPtoP4SetTarget() {
		try {
			if ((getObjectInstanceDeclarationIntern() != null)) {
				getFeatureInstanceDeclarationListPanel().setDeclarationListModel(
					getObjectInstanceDeclarationIntern().getObjectFeatureInstanceDeclarationList());
			}
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	private void connPtoP5SetTarget() {
		try {
			if ((getObjectInstanceDeclarationIntern() != null)) {
				getBodyVariableInstanceDeclarationListWithSelectionPanel().setObjectClassDeclaration(
					getObjectInstanceDeclarationIntern().getObjectClassDeclaration());
			}
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	private void connPtoP8SetSource() {
		try {
			if (ivjConnPtoP8Aligning == false) {
				ivjConnPtoP8Aligning = true;
				this.setGUISeSAmDeclaration(
					getBodyVariableInstanceDeclarationListWithSelectionPanel().getGUISeSAmDeclaration());
				ivjConnPtoP8Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP8Aligning = false;
			handleException(ivjExc);
		}
	}

	private void connPtoP8SetTarget() {
		try {
			if (ivjConnPtoP8Aligning == false) {
				ivjConnPtoP8Aligning = true;
				getBodyVariableInstanceDeclarationListWithSelectionPanel().setGUISeSAmDeclaration(
					this.getGUISeSAmDeclaration());
				ivjConnPtoP8Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP8Aligning = false;
			handleException(ivjExc);
		}
	}

	public void dispose() {
		getBodyVariableInstanceDeclarationListWithSelectionPanel().dispose();
		getFeatureInstanceDeclarationListPanel().dispose();
		getObjectClassDeclarationNamePanel().dispose();
		disposeFeatureDeclarationPanel();

		super.dispose();
	}

	protected void eventObjectInstanceDeclarationChanged() {
		updateFeatureDeclarationPanel();
	}

	protected BodyVariableInstanceDeclarationList getBodyVariableInstanceDeclarationList(IBodyInstanceDeclaration bodyInstanceDeclaration) {
		return bodyInstanceDeclaration.getBodyVariableInstanceDeclarationList();
	}

	private BodyVariableInstanceDeclarationListWithSelectionPanel getBodyVariableInstanceDeclarationListWithSelectionPanel() {
		if (ivjBodyVariableInstanceDeclarationListWithSelectionPanel == null) {
			try {
				ivjBodyVariableInstanceDeclarationListWithSelectionPanel =
					new BodyVariableInstanceDeclarationListWithSelectionPanel();
				ivjBodyVariableInstanceDeclarationListWithSelectionPanel.setName(
					"BodyVariableInstanceDeclarationListWithSelectionPanel");
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjBodyVariableInstanceDeclarationListWithSelectionPanel;
	}

	private javax.swing.JButton getChangeClassButton() {
		if (ivjChangeClassButton == null) {
			try {
				ivjChangeClassButton = new javax.swing.JButton();
				ivjChangeClassButton.setName("ChangeClassButton");
				ivjChangeClassButton.setText("Change Class ...");
				ivjChangeClassButton.setEnabled(false);
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjChangeClassButton;
	}

	public boolean getChangeClassButtonEnabled() {
		return _changeClassButtonEnabled;
	}

	public IDeclaration getDeclaration() {
		return getObjectInstanceDeclaration();
	}

	private FeatureInstanceDeclarationListPanel getFeatureInstanceDeclarationListPanel() {
		if (ivjFeatureInstanceDeclarationListPanel == null) {
			try {
				ivjFeatureInstanceDeclarationListPanel = new FeatureInstanceDeclarationListPanel();
				ivjFeatureInstanceDeclarationListPanel.setName("FeatureInstanceDeclarationListPanel");
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjFeatureInstanceDeclarationListPanel;
	}

	private JDocumentablePanel getJDocumentablePanel() {
		if (ivjJDocumentablePanel == null) {
			try {
				ivjJDocumentablePanel = new JDocumentablePanel();
				ivjJDocumentablePanel.setName("JDocumentablePanel");
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjJDocumentablePanel;
	}

	private javax.swing.JLabel getJLabelClass() {
		if (ivjJLabelClass == null) {
			try {
				ivjJLabelClass = new javax.swing.JLabel();
				ivjJLabelClass.setName("JLabelClass");
				ivjJLabelClass.setText("Class:");
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjJLabelClass;
	}

	private javax.swing.JLabel getJLabelName() {
		if (ivjJLabelName == null) {
			try {
				ivjJLabelName = new javax.swing.JLabel();
				ivjJLabelName.setName("JLabelName");
				ivjJLabelName.setText("Name:");
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjJLabelName;
	}

	private javax.swing.JPanel getJPanel() {
		if (ivjJPanel == null) {
			try {
				ivjJPanel = new javax.swing.JPanel();
				ivjJPanel.setName("JPanel");
				ivjJPanel.setLayout(new java.awt.GridBagLayout());

				java.awt.GridBagConstraints constraintsJLabelName = new java.awt.GridBagConstraints();
				constraintsJLabelName.gridx = 0;
				constraintsJLabelName.gridy = 0;
				constraintsJLabelName.anchor = java.awt.GridBagConstraints.EAST;
				constraintsJLabelName.insets.right = 5;
				getJPanel().add(getJLabelName(), constraintsJLabelName);

				java.awt.GridBagConstraints constraintsJDocumentablePanel = new java.awt.GridBagConstraints();
				constraintsJDocumentablePanel.gridx = 1;
				constraintsJDocumentablePanel.gridy = 0;
				//constraintsJDocumentablePanel.gridwidth = 2;
				constraintsJDocumentablePanel.fill = java.awt.GridBagConstraints.HORIZONTAL;
				constraintsJDocumentablePanel.weightx = 1.0;
				constraintsJDocumentablePanel.insets.right = 4;
				getJPanel().add(getJDocumentablePanel(), constraintsJDocumentablePanel);

				java.awt.GridBagConstraints constraintsJLabelClass = new java.awt.GridBagConstraints();
				constraintsJLabelClass.gridx = 0;
				constraintsJLabelClass.gridy = 1;
				constraintsJLabelClass.anchor = java.awt.GridBagConstraints.EAST;
				constraintsJLabelClass.insets.right = 5;
				getJPanel().add(getJLabelClass(), constraintsJLabelClass);

				java.awt.GridBagConstraints constraintsObjectClassDeclarationNamePanel =
					new java.awt.GridBagConstraints();
				constraintsObjectClassDeclarationNamePanel.gridx = 1;
				constraintsObjectClassDeclarationNamePanel.gridy = 1;
				constraintsObjectClassDeclarationNamePanel.fill = java.awt.GridBagConstraints.HORIZONTAL;
				constraintsObjectClassDeclarationNamePanel.weightx = 1.0;
				constraintsObjectClassDeclarationNamePanel.insets.top = 4;
				constraintsObjectClassDeclarationNamePanel.insets.right = 4;
				getJPanel().add(
					getObjectClassDeclarationNamePanel(),
					constraintsObjectClassDeclarationNamePanel);

				java.awt.GridBagConstraints constraintsChangeClassButton = new java.awt.GridBagConstraints();
				constraintsChangeClassButton.gridx = 2;
				constraintsChangeClassButton.gridy = 1;
				constraintsChangeClassButton.fill = GridBagConstraints.HORIZONTAL;
				constraintsChangeClassButton.insets = new java.awt.Insets(4, 4, 0, 4);
				getJPanel().add(getChangeClassButton(), constraintsChangeClassButton);

				java.awt.GridBagConstraints constraintsFeaturesButton = new java.awt.GridBagConstraints();
				constraintsFeaturesButton.gridx = 2;
				constraintsFeaturesButton.gridy = 0;
				constraintsFeaturesButton.fill = GridBagConstraints.HORIZONTAL;
				constraintsFeaturesButton.insets = new java.awt.Insets(4, 4, 0, 4);
				getJPanel().add(new JButton(new AbstractBoundAction("Features ...") {
					public void doit() {
						getGUISeSAmDeclaration().getFrameFactory().addPanel(
							ObjectInstanceDeclarationPanel.this,
							"Features",
							getFeatureInstanceDeclarationListPanel(),
							true,
							WindowConstants.HIDE_ON_CLOSE);
					}
				}), constraintsFeaturesButton);

				PanelBuilder builder =
					new PanelBuilder(new FormLayout("fill:default:grow", "default, fill:default:grow"));

				builder.addSeparator("Variables");
				builder.nextLine();
				builder.add(getBodyVariableInstanceDeclarationListWithSelectionPanel());

				java.awt.GridBagConstraints constraintsJTabbedPane = new java.awt.GridBagConstraints();
				constraintsJTabbedPane.gridx = 0;
				constraintsJTabbedPane.gridy = 2;
				constraintsJTabbedPane.gridwidth = 3;
				constraintsJTabbedPane.fill = java.awt.GridBagConstraints.BOTH;
				constraintsJTabbedPane.weightx = 1.0;
				constraintsJTabbedPane.weighty = 1.0;
				//getJPanel().add(getJTabbedPane(), constraintsJTabbedPane);
				getJPanel().add(builder.getPanel(), constraintsJTabbedPane);

			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjJPanel;
	}

	public IObjectClassDeclarationList getObjectClassDeclarationList() {
		return fieldObjectClassDeclarationList;
	}

	private JNamedPanel getObjectClassDeclarationNamePanel() {
		if (ivjObjectClassDeclarationNamePanel == null) {
			try {
				ivjObjectClassDeclarationNamePanel = new JNamedPanel();
				ivjObjectClassDeclarationNamePanel.setName("ObjectClassDeclarationNamePanel");
				ivjObjectClassDeclarationNamePanel.setEditable(false);
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjObjectClassDeclarationNamePanel;
	}

	public IObjectInstanceDeclaration getObjectInstanceDeclaration() {
		return getObjectInstanceDeclarationIntern();
	}

	private IObjectInstanceDeclaration getObjectInstanceDeclarationIntern() {
		return ivjObjectInstanceDeclarationIntern;
	}

	private BoxLayout getObjectInstanceDeclarationPanelBoxLayout() {
		javax.swing.BoxLayout ivjObjectInstanceDeclarationPanelBoxLayout = null;
		try {
			/* Create part */
			ivjObjectInstanceDeclarationPanelBoxLayout =
				new javax.swing.BoxLayout(this, javax.swing.BoxLayout.Y_AXIS);
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		};
		return ivjObjectInstanceDeclarationPanelBoxLayout;
	}

	private void handleException(Throwable exception) {
		exception.printStackTrace(System.out);
	}

	private void initConnections() {
		addPropertyChangeListener(ivjEventHandler);
		getFeatureInstanceDeclarationListPanel().addPropertyChangeListener(ivjEventHandler);
		getBodyVariableInstanceDeclarationListWithSelectionPanel().addPropertyChangeListener(ivjEventHandler);
		getChangeClassButton().addActionListener(ivjEventHandler);
		getJDocumentablePanel().addPropertyChangeListener(ivjEventHandler);
		connPtoP4SetTarget();
		connPtoP3SetTarget();
		connPtoP8SetTarget();
		connPtoP1SetTarget();
		connPtoP2SetTarget();
		connPtoP5SetTarget();
	}

	private void initialize() {
		setName("ObjectInstanceDeclarationPanel");
		setLayout(getObjectInstanceDeclarationPanelBoxLayout());
		setSize(623, 728);
		add(getJPanel(), getJPanel().getName());
		initConnections();

		eventObjectInstanceDeclarationChanged();
	}

	private void updateFeatureDeclarationPanel() {
		Component oldFeatureDeclarationPanel = _featureDeclarationPanel;

		Component newFeatureDeclarationPanel = getFeatureDeclarationPanel();

		if (newFeatureDeclarationPanel != null) {
			_featureDeclarationPanel = newFeatureDeclarationPanel;
			if (oldFeatureDeclarationPanel != null) {
				remove(oldFeatureDeclarationPanel);
			}
			add(newFeatureDeclarationPanel);

		} else {
			if (oldFeatureDeclarationPanel != null) {
				SwingMoreUtilities.setEnableAllComponentsRecursive(
					(Container)oldFeatureDeclarationPanel,
					false);
			}
		}

		revalidate();
	}

	private Component _featureDeclarationPanel;

	public static void main(String[] args) {
		try {
			JFrame frame = new javax.swing.JFrame();
			ObjectInstanceDeclarationPanel aObjectInstanceDeclarationPanel;
			aObjectInstanceDeclarationPanel = new ObjectInstanceDeclarationPanel();
			frame.setContentPane(aObjectInstanceDeclarationPanel);
			frame.setSize(aObjectInstanceDeclarationPanel.getSize());
			frame.addWindowListener(new java.awt.event.WindowAdapter() {
				public void windowClosing(java.awt.event.WindowEvent e) {
					System.exit(0);
				};
			});
			frame.show();
			java.awt.Insets insets = frame.getInsets();
			frame.setSize(
				frame.getWidth() + insets.left + insets.right,
				frame.getHeight() + insets.top + insets.bottom);
			frame.setVisible(true);
		} catch (Throwable exception) {
			System.err.println("Exception occurred in main() of javax.swing.JPanel");
			exception.printStackTrace(System.out);
		}
	}

	public void setChangeClassButtonEnabled(boolean arg1) {
		_changeClassButtonEnabled = arg1;
		getChangeClassButton().setEnabled(arg1);
	}

	public void setDeclaration(IDeclaration arg1) {
		setObjectInstanceDeclaration((IObjectInstanceDeclaration)arg1);
	}

	public void setEnabled(boolean newValue) {
		if (newValue != isEnabled()) {
			super.setEnabled(newValue);
			getChangeClassButton().setEnabled(getChangeClassButtonEnabled());
		}
	}

	/**
	 * Sets the objectClassDeclarationList property (de.uniwue.ki.mas.model.entity.objectclass.IObjectClassDeclarationList) value.
	 * @param objectClassDeclarationList The new value for the property.
	 * @see #getObjectClassDeclarationList
	 */
	public void setObjectClassDeclarationList(IObjectClassDeclarationList objectClassDeclarationList) {
		IObjectClassDeclarationList oldValue = fieldObjectClassDeclarationList;
		fieldObjectClassDeclarationList = objectClassDeclarationList;
		firePropertyChange("objectClassDeclarationList", oldValue, objectClassDeclarationList);
	}

	/**
	 * Method generated to support the promotion of the objectInstanceDeclaration attribute.
	 * @param arg1 IObjectInstanceDeclaration
	 */
	public void setObjectInstanceDeclaration(IObjectInstanceDeclaration arg1) {
		setObjectInstanceDeclarationIntern(arg1);
	}

	private void setObjectInstanceDeclarationIntern(IObjectInstanceDeclaration newValue) {
		if (ivjObjectInstanceDeclarationIntern != newValue) {
			try {
				IObjectInstanceDeclaration oldValue = getObjectInstanceDeclarationIntern();
				ivjObjectInstanceDeclarationIntern = newValue;
				connPtoP4SetTarget();
				connEtoM1(ivjObjectInstanceDeclarationIntern);
				connPtoP1SetTarget();
				connPtoP2SetTarget();
				connPtoP5SetTarget();
				connEtoC2(ivjObjectInstanceDeclarationIntern);
				
				//ToDo: Ich musste das nochmal einkommentieren, da sonst Vaterfenster
				//      keine nderung mitbekommen: Beispiel: Erschaffen einer 
				// 		ObjectInstanceDeclaration bei CreateObjectAndRemember				
				firePropertyChange("objectInstanceDeclaration", oldValue, newValue);
				//Disabled, because it causes JSpatialMapBuildinObjectFeatureInstDeclPanel 
				//to be instantiated twice when openening the "Edit Situation"-dialog.
				//Enabling it causes NPEs when adding or removing Agents in the "Edit Situation"-dialog.
								
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		};
	}

	public IFunctionArgumentDeclarationList getOuterFunctionArgumentDeclarationList() {
		return getBodyVariableInstanceDeclarationListWithSelectionPanel()
			.getOuterFunctionArgumentDeclarationList();
	}

	public void setOuterFunctionArgumentDeclarationList(IFunctionArgumentDeclarationList functionArgumentDeclarationList) {
		getBodyVariableInstanceDeclarationListWithSelectionPanel().setOuterFunctionArgumentDeclarationList(
			functionArgumentDeclarationList);
	}

	private final java.util.List _featureDeclPanelList = new LinkedList();

	private Component getFeatureDeclarationPanel() {
		disposeFeatureDeclarationPanel();

		if (!isShowObjectInstanceDeclarationFeatures() || (getObjectInstanceDeclaration() == null)) {
			return null;

		} else {
			String lastDeclarationTitle = null;
			JTabbedPane tabbedPane = new JTabbedPane();
			Iterator it = getObjectInstanceDeclaration().getObjectFeatureInstanceDeclarationList().iterator();
			while (it.hasNext()) {
				IObjectFeatureInstanceDeclaration objectFeatureInstanceDeclaration =
					(IObjectFeatureInstanceDeclaration)it.next();
				IDeclarationPanelAndActionFactory panelActionFactory =
					(IDeclarationPanelAndActionFactory)getGUISeSAmDeclaration()
						.getPanelActionFactoryManager()
						.getPanelActionFactoryFor(this, objectFeatureInstanceDeclaration);

				if (panelActionFactory != null) {
					IDeclarationPanelFactory declarationPanelFactory =
						panelActionFactory.getDeclarationPanelFactory(this, objectFeatureInstanceDeclaration);
					if (declarationPanelFactory != null) {
						IDeclarationPanel declarationPanel =
							declarationPanelFactory.createDeclarationPanel(objectFeatureInstanceDeclaration);
						declarationPanel.setGUISeSAmDeclaration(getGUISeSAmDeclaration());
						declarationPanel.setDeclaration(objectFeatureInstanceDeclaration);

						lastDeclarationTitle =
							declarationPanelFactory.getDeclarationTitle(objectFeatureInstanceDeclaration);

						tabbedPane.addTab(lastDeclarationTitle, (Component)declarationPanel);
						_featureDeclPanelList.add(declarationPanel);
					}
				}
			}

			if (tabbedPane.getComponentCount() == 0) {
				return null;
			} else if (tabbedPane.getComponentCount() == 1) {
				PanelBuilder builder =
					new PanelBuilder(new FormLayout("fill:default:grow", "default, fill:default:grow"));
				builder.addSeparator(lastDeclarationTitle);
				builder.nextLine();
				builder.add(tabbedPane.getComponent(0));
				return builder.getPanel();
			} else {
				return tabbedPane;
			}
		}
	}

	private void disposeFeatureDeclarationPanel() {
		Iterator it = _featureDeclPanelList.iterator();

		while (it.hasNext()) {
			((IDeclarationPanel)it.next()).dispose();
			it.remove();
		}
	}

	public void setShowObjectInstanceDeclarationFeatures(boolean showObjectInstanceDeclarationFeatures) {
		if (showObjectInstanceDeclarationFeatures != _showObjectInstanceDeclarationFeatures) {
			_showObjectInstanceDeclarationFeatures = showObjectInstanceDeclarationFeatures;

			updateFeatureDeclarationPanel();
		}
	}

	public boolean isShowObjectInstanceDeclarationFeatures() {
		return _showObjectInstanceDeclarationFeatures;
	}
}