package de.uniwue.ki.gui.mas.entity.objectclass;
import java.awt.Insets;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.ImageIcon;
import javax.swing.JFrame;

import de.uniwue.ki.gui.mas.util.declaration.DeclarationListPanel;
import de.uniwue.ki.gui.util.SwingMoreUtilities;
import de.uniwue.ki.gui.util.dnd.ObjectDataFlavor;
import de.uniwue.ki.mas.entity.objectclass.agentclass.AgentClassDeclarationList;
import de.uniwue.ki.mas.entity.objectclass.agentclass.IActivityAgentClassDeclaration;

/**
 * Creation date: (13.12.2000 18:26:47)
 * @author Christoph Oechslein
 */
public class ActivityAgentClassDeclarationListPanel extends DeclarationListPanel {

	public ActivityAgentClassDeclarationListPanel() {
		super();
		initialize();
	}

	public ObjectDataFlavor getDeclarationDataFlavor() {
		return ObjectDataFlavor.getDataFlavor(IActivityAgentClassDeclaration.class);
	}

	private void handleException(Throwable exception) {
		exception.printStackTrace(System.out);
	}

	private void initialize() {
		try {
			setName("ActivityAgentClassDeclarationListPanel");
			setSize(259, 160);
			setDeclarationListModel(new AgentClassDeclarationList());
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
		enableDnDSupport(ObjectDataFlavor.getDataFlavor(IActivityAgentClassDeclaration.class));
		setCellRenderer(new ObjectClassDeclarationCellRendererAdapter(getCellRenderer()));
	}

	public static void main(String[] args) {
		try {
			JFrame frame = new JFrame();
			ActivityAgentClassDeclarationListPanel aActivityAgentClassDeclarationListPanel;
			aActivityAgentClassDeclarationListPanel = new ActivityAgentClassDeclarationListPanel();
			frame.setContentPane(aActivityAgentClassDeclarationListPanel);
			frame.setSize(aActivityAgentClassDeclarationListPanel.getSize());
			frame.addWindowListener(new WindowAdapter() {
				public void windowClosing(WindowEvent e) {
					System.exit(0);
				}
			});
			frame.show();
			Insets insets = frame.getInsets();
			frame.setSize(
				frame.getWidth() + insets.left + insets.right,
				frame.getHeight() + insets.top + insets.bottom);
			frame.setVisible(true);
		} catch (Throwable exception) {
			System.err.println(
				"Exception occurred in main() of de.uniwue.ki.gui.mas.model.entity.objectclass.ActivityAgentClassDeclarationListPanel");
			exception.printStackTrace(System.out);
		}
	}
	public static final ImageIcon AGENT_CLASS_LIST_ICON =
		SwingMoreUtilities.getJavaSunIcon(16, "general/Users16.gif");
}