package de.uniwue.ki.gui.mas.entity.objectclass;
import de.uniwue.ki.gui.mas.behaviour.reasoning.ActivityReasoningEngineDeclarationPanelContainer;
import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.mas.entity.objectclass.agentclass.IActivityAgentClassDeclaration;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: (16.06.2000 16:51:25)
 * @author Christoph Oechslein
 */
public class ActivityAgentClassDeclarationPanel extends ObjectClassDeclarationPanel {

	private ActivityReasoningEngineDeclarationPanelContainer ivjActivityReasoningEngineDeclarationPanelContainer;

	public ActivityAgentClassDeclarationPanel() {
		super();
	}

	public void dispose() {
		getActivityReasoningEngineDeclarationPanelContainer().dispose();

		super.dispose();
	}

	public IActivityAgentClassDeclaration getActivityAgentClassDeclaration() {
		return (IActivityAgentClassDeclaration)getDeclaration();
	}

	private ActivityReasoningEngineDeclarationPanelContainer getActivityReasoningEngineDeclarationPanelContainer() {
		if (ivjActivityReasoningEngineDeclarationPanelContainer == null) {
			ivjActivityReasoningEngineDeclarationPanelContainer =
				new ActivityReasoningEngineDeclarationPanelContainer();
		}
		return ivjActivityReasoningEngineDeclarationPanelContainer;
	}

	protected void insertTabs() {
		super.insertTabs();

		insertTab("Reasoning Engine", null, getActivityReasoningEngineDeclarationPanelContainer(), null, 0);
	}

	public void setActivityAgentClassDeclaration(IActivityAgentClassDeclaration activityAgentClassDeclaration) {
		setObjectClassDeclaration(activityAgentClassDeclaration);
	}

	public void setDeclaration(IDeclaration declaration) {
		super.setDeclaration(declaration);

		getActivityReasoningEngineDeclarationPanelContainer().setActivityAgentClassDeclaration(
			(IActivityAgentClassDeclaration)declaration);
	}

	public void setGUISeSAmDeclaration(IGUISeSAmDeclaration guiSeSAmDeclaration) {
		super.setGUISeSAmDeclaration(guiSeSAmDeclaration);

		getActivityReasoningEngineDeclarationPanelContainer().setGUISeSAmDeclaration(guiSeSAmDeclaration);
	}
}