package de.uniwue.ki.gui.mas.entity.objectclass;
import de.uniwue.ki.gui.util.dnd.ObjectDataFlavor;
import de.uniwue.ki.mas.entity.objectclass.agentclass.AgentClassDeclarationList;
import de.uniwue.ki.mas.entity.objectclass.agentclass.IActivityWorldClassDeclaration;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: (13.12.2000 18:26:47)
 * @author Christoph Oechslein
 */
public class ActivityWorldClassDeclarationListPanel extends ActivityAgentClassDeclarationListPanel {

	public ActivityWorldClassDeclarationListPanel() {
		super();
		initialize();
	}

	public ObjectDataFlavor getDeclarationDataFlavor() {
		return ObjectDataFlavor.getDataFlavor(IActivityWorldClassDeclaration.class);
	}

	protected String getDeclarationFrameTitle(IDeclaration declaration) {
		return "World Class";
	}

	private void handleException(Throwable exception) {
		exception.printStackTrace(System.out);
	}

	private void initialize() {
		try {
			setName("ActivityAgentClassDeclarationListPanel");
			setSize(259, 160);
			setDeclarationListModel(new AgentClassDeclarationList());
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	public static void main(String[] args) {
		try {
			javax.swing.JFrame frame = new javax.swing.JFrame();
			ActivityAgentClassDeclarationListPanel aActivityAgentClassDeclarationListPanel;
			aActivityAgentClassDeclarationListPanel = new ActivityAgentClassDeclarationListPanel();
			frame.setContentPane(aActivityAgentClassDeclarationListPanel);
			frame.setSize(aActivityAgentClassDeclarationListPanel.getSize());
			frame.addWindowListener(new java.awt.event.WindowAdapter() {
				public void windowClosing(java.awt.event.WindowEvent e) {
					System.exit(0);
				}
			});
			frame.show();
			java.awt.Insets insets = frame.getInsets();
			frame.setSize(
				frame.getWidth() + insets.left + insets.right,
				frame.getHeight() + insets.top + insets.bottom);
			frame.setVisible(true);
		} catch (Throwable exception) {
			System.err.println(
				"Exception occurred in main() of de.uniwue.ki.gui.mas.model.entity.objectclass.ActivityAgentClassDeclarationListPanel");
			exception.printStackTrace(System.out);
		}
	}
}