package de.uniwue.ki.gui.mas.entity.objectclass;

import javax.swing.*;

import de.uniwue.ki.gui.util.actions.AbstractBoundAction;
import de.uniwue.ki.mas.entity.objectclass.agentclass.IActivityAgentClassDeclaration;
import de.uniwue.ki.mas.entity.objectclass.agentclass.IActivityWorldClassDeclaration;
import de.uniwue.ki.mas.entity.objectclass.worldclass.IWorldClassDeclaration;

/**
 * @author oechslein
 * 
 * Creation date: 18.02.2003
 */
public class ActivityWorldClassDeclarationPanel extends ActivityAgentClassDeclarationPanel {

	private JCheckBox _updateBeforeCheckBox;

	public ActivityWorldClassDeclarationPanel() {
		super();
	}

	protected void insertTabs() {
		super.insertTabs();

		Box box = Box.createVerticalBox();

		box.add(getUpdateBeforeCheckBox());
		box.add(Box.createVerticalGlue());
		box.setBorder(BorderFactory.createEmptyBorder(3, 3, 3, 3));

		insertTab("Settings", null, box, null, 2);
	}

	private JCheckBox getUpdateBeforeCheckBox() {
		if (_updateBeforeCheckBox == null) {
			_updateBeforeCheckBox =
				new JCheckBox(new AbstractBoundAction("Update World before other objects") {
				public void doit() {
					if (getActivityWorldClassDeclaration() != null) {
						getActivityWorldClassDeclaration().setUpdateBeforeAllObjects(
							getUpdateBeforeCheckBox().isSelected());
					}
				}
			});
		}

		return _updateBeforeCheckBox;
	}

	public IActivityWorldClassDeclaration getActivityWorldClassDeclaration() {
		return (IActivityWorldClassDeclaration) getActivityAgentClassDeclaration();
	}

	public void setActivityAgentClassDeclaration(IActivityAgentClassDeclaration activityAgentClassDeclaration) {
		super.setActivityAgentClassDeclaration(activityAgentClassDeclaration);
		
		if (activityAgentClassDeclaration != null) {
			getUpdateBeforeCheckBox().setSelected(
				((IWorldClassDeclaration) activityAgentClassDeclaration).isUpdateBeforeAllObjects());
				
		}
		
		
	}

}
