package de.uniwue.ki.gui.mas.entity.objectclass;

import javax.swing.Icon;
import javax.swing.ListCellRenderer;

import de.uniwue.ki.gui.util.NamedCellRendererAdapter;
import de.uniwue.ki.gui.util.SwingMoreUtilities;
import de.uniwue.ki.mas.entity.objectclass.IRessourceClassDeclaration;
import de.uniwue.ki.mas.entity.objectclass.agentclass.IActivityWorldClassDeclaration;
import de.uniwue.ki.util.name.INamed;

public class ObjectClassDeclarationCellRendererAdapter extends NamedCellRendererAdapter {

	public static final Icon AGENT_CLASS_ICON = SwingMoreUtilities.getJavaSunIcon(16, "general/User16.gif");
	public static final Icon WORLD_CLASS_ICON =
		SwingMoreUtilities.createImageIcon("others/sesam-world-class-icon.gif");
	public static final Icon RESSOURCE_CLASS_ICON =
		SwingMoreUtilities.createImageIcon("others/sesam-resource-icon.gif");

	public ObjectClassDeclarationCellRendererAdapter(ListCellRenderer cellRenderer) {
		super(cellRenderer);
	}

	protected Icon getIcon(INamed value) {
		if (value instanceof IActivityWorldClassDeclaration)
			return WORLD_CLASS_ICON;
		if (value instanceof IRessourceClassDeclaration)
			return RESSOURCE_CLASS_ICON;
		return AGENT_CLASS_ICON;
	}

	// the treepanel also wants to get this icon
	public static Icon getWorldIcon() {
		return WORLD_CLASS_ICON;
	}

	public static Icon getActivityAgentIcon() {
		return AGENT_CLASS_ICON;
	}

	public static Icon getRessourceIcon() {
		return RESSOURCE_CLASS_ICON;
	}

}