package de.uniwue.ki.gui.mas.entity.objectclass;

import de.uniwue.ki.gui.mas.util.declaration.DeclarationListPanel;
import de.uniwue.ki.gui.util.dnd.ObjectDataFlavor;
import de.uniwue.ki.mas.entity.objectclass.*;

/**
 * Creation date: (13.12.2000 18:26:47)
 * @author Christoph Oechslein
 */
public class RessourceClassDeclarationListPanel extends DeclarationListPanel {

	/**
	 * UserDefinedFunctionDeclarationListPanel constructor comment.
	 */
	public RessourceClassDeclarationListPanel() {
		super();
		initialize();
	}

	public ObjectDataFlavor getDeclarationDataFlavor() {
		return ObjectDataFlavor.getDataFlavor(IRessourceClassDeclaration.class);
	}
	/**
	 * Called whenever the part throws an exception.
	 * @param exception Throwable
	 */
	private void handleException(Throwable exception) {
		exception.printStackTrace(System.out);
	}
	/**
	 * Initialize the class.
	 */
	private void initialize() {
		try {
					setName("RessourceClassDeclarationListPanel");
			setSize(259, 160);
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
		setDeclarationListModel(new RessourceClassDeclarationList());
		setDeclarationFactory(
			new RessourceClassDeclarationFactory((RessourceClassDeclarationList) getDeclarationListModel()));
		setCellRenderer(new ObjectClassDeclarationCellRendererAdapter(getCellRenderer()));
		enableDnDSupport(ObjectDataFlavor.getDataFlavor(IRessourceClassDeclaration.class));
	}
	public static void main(String[] args) {
		try {
			javax.swing.JFrame frame = new javax.swing.JFrame();
			RessourceClassDeclarationListPanel aRessourceClassDeclarationListPanel;
			aRessourceClassDeclarationListPanel = new RessourceClassDeclarationListPanel();
			frame.setContentPane(aRessourceClassDeclarationListPanel);
			frame.setSize(aRessourceClassDeclarationListPanel.getSize());
			frame.addWindowListener(new java.awt.event.WindowAdapter() {
				public void windowClosing(java.awt.event.WindowEvent e) {
					System.exit(0);
				}
			});
			frame.show();
			java.awt.Insets insets = frame.getInsets();
			frame.setSize(
				frame.getWidth() + insets.left + insets.right,
				frame.getHeight() + insets.top + insets.bottom);
			frame.setVisible(true);
		} catch (Throwable exception) {
			System.err.println(
				"Exception occurred in main() of de.uniwue.ki.gui.mas.model.entity.objectclass.RessourceClassDeclarationListPanel");
			exception.printStackTrace(System.out);
		}
	}
}