package de.uniwue.ki.gui.mas.entity.objectclass.factory;
import java.awt.Container;

import de.uniwue.ki.gui.mas.model.DefaultDeclarationPanelActionFactory;
import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.util.declaration.action.PropertiesDeclarationAction;
import de.uniwue.ki.gui.util.actions.AbstractBoundAction;
import de.uniwue.ki.mas.behaviour.activityGraphDeclaration.IActivityGraphDeclaration;
import de.uniwue.ki.mas.behaviour.reasoning.IActivityReasoningEngineDeclaration;
import de.uniwue.ki.mas.entity.objectclass.agentclass.IActivityAgentClassDeclaration;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: (05.02.2002 11:38:36)
 * @author Christoph Oechslein
 */

public class ActivityGraphDeclarationPanelActionFactory extends DefaultDeclarationPanelActionFactory {
	public ActivityGraphDeclarationPanelActionFactory(IGUISeSAmDeclaration guiSeSAmDeclaration) {
		super(guiSeSAmDeclaration);
	}

	private IActivityAgentClassDeclaration findActivityAgent(Object anObject) {
		if (anObject == null) {
			return null;

		} else if (anObject instanceof IActivityAgentClassDeclaration) {
			return (IActivityAgentClassDeclaration) anObject;

		} else if (anObject instanceof IActivityReasoningEngineDeclaration) {
			return findActivityAgent(
				getSeSAmDeclarationTreeModel().getUserObjectParentOf(
					((IActivityReasoningEngineDeclaration) anObject).getRootActivityGraphDeclaration()));

		} else {
			return findActivityAgent(getSeSAmDeclarationTreeModel().getUserObjectParentOf(anObject));
		}
	}

	public boolean getCanProduceDeclarationActions(Container parent, IDeclaration anObject) {
		return (
			(anObject instanceof IActivityGraphDeclaration)
				|| anObject instanceof IActivityReasoningEngineDeclaration)
			&& (findActivityAgent(anObject) != null);
	}

	public AbstractBoundAction getPropertyDeclarationAction(Container parent, IDeclaration anObject) {
		IActivityAgentClassDeclaration activityAgentClassDeclaration = findActivityAgent(anObject);

		IActivityGraphDeclaration activityGraphDeclaration;

		if (anObject instanceof IActivityGraphDeclaration) {
			activityGraphDeclaration = (IActivityGraphDeclaration) anObject;
		} else {
			activityGraphDeclaration =
				((IActivityReasoningEngineDeclaration) anObject).getRootActivityGraphDeclaration();
		}

		return new DeclarationPanelAction(
			parent,
			"Properties",
			PropertiesDeclarationAction.PROPERTIES_ICON,
			activityGraphDeclaration,
			new EditActivityGraphDeclarationPanelFactory(
				activityAgentClassDeclaration,
				getGUISeSAmDeclaration()),
			false);
	}
}