package de.uniwue.ki.gui.mas.entity.objectclass.factory;

import javax.swing.Icon;

import de.uniwue.ki.gui.mas.entity.objectclass.ActivityAgentClassDeclarationPanel;
import de.uniwue.ki.gui.mas.entity.objectclass.ActivityWorldClassDeclarationPanel;
import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.model.tree.SeSAmDeclarationTreeCellRenderer;
import de.uniwue.ki.gui.mas.util.declaration.AbstractDeclarationPanelFactory;
import de.uniwue.ki.gui.mas.util.declaration.IDeclarationPanel;
import de.uniwue.ki.mas.entity.objectclass.agentclass.IActivityWorldClassDeclaration;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: (12.10.2001 17:40:16)
 * @author Christoph Oechslein
 */

public class EditActivityAgentClassDeclarationPanelFactory
	extends AbstractDeclarationPanelFactory {
	private IGUISeSAmDeclaration _guiSeSAmDeclaration;

	public EditActivityAgentClassDeclarationPanelFactory() {
		super();
	}

	public EditActivityAgentClassDeclarationPanelFactory(IGUISeSAmDeclaration guiSeSAmDeclaration) {
		super();

		setGUISeSAmDeclaration(guiSeSAmDeclaration);
	}

	public IDeclarationPanel createDeclarationPanel(final IDeclaration declaration) {
		ActivityAgentClassDeclarationPanel activityAgentClassDeclarationPanel;
		
		if (declaration instanceof IActivityWorldClassDeclaration){
			activityAgentClassDeclarationPanel = new ActivityWorldClassDeclarationPanel();
			activityAgentClassDeclarationPanel.setGUISeSAmDeclaration(getGUISeSAmDeclaration());
			activityAgentClassDeclarationPanel.setActivityAgentClassDeclaration(
				(IActivityWorldClassDeclaration) declaration);
		}
		else{
			activityAgentClassDeclarationPanel =  new ActivityAgentClassDeclarationPanel();
			activityAgentClassDeclarationPanel.setGUISeSAmDeclaration(getGUISeSAmDeclaration());
		}
		
		return activityAgentClassDeclarationPanel;
	}

	public String getDeclarationTitle(IDeclaration declaration) {
		return "Agent";
	}
	
    public Icon getIcon(IDeclaration declaration) {
        return SeSAmDeclarationTreeCellRenderer.AGENT_CLASS_ICON;
    }

	public IGUISeSAmDeclaration getGUISeSAmDeclaration() {
		return _guiSeSAmDeclaration;
	}

	public void setGUISeSAmDeclaration(IGUISeSAmDeclaration newGUISeSAmDeclaration) {
		_guiSeSAmDeclaration = newGUISeSAmDeclaration;
	}
}