package de.uniwue.ki.gui.mas.entity.objectclass.factory;
import de.uniwue.ki.gui.mas.behaviour.activityGraph.ActivityGraphDeclarationGraphPanel;
import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.util.declaration.*;
import de.uniwue.ki.mas.entity.objectclass.agentclass.IActivityAgentClassDeclaration;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: (12.10.2001 17:40:16)
 * @author Christoph Oechslein
 */

public class EditActivityGraphDeclarationPanelFactory extends AbstractDeclarationPanelFactory {
	private final IGUISeSAmDeclaration _guiSeSAmDeclaration;
	private final IActivityAgentClassDeclaration _activityAgentClassDeclaration;

	public EditActivityGraphDeclarationPanelFactory(
		IActivityAgentClassDeclaration activityAgentClassDeclaration,
		IGUISeSAmDeclaration guiSeSAmDeclaration) {
		super();

		_activityAgentClassDeclaration = activityAgentClassDeclaration;
		_guiSeSAmDeclaration = guiSeSAmDeclaration;
	}

	public IDeclarationPanel createDeclarationPanel(IDeclaration declaration) {
		ActivityGraphDeclarationGraphPanel composedActivityDeclarationPanel =
			new ActivityGraphDeclarationGraphPanel();

		composedActivityDeclarationPanel.setActivityAgentClassDeclaration(_activityAgentClassDeclaration);

		NameDeclarationWithDocumentationAdapterPanel nameDeclarationWithDocumentationAdapterPanel =
			new NameDeclarationWithDocumentationAdapterPanel();

		nameDeclarationWithDocumentationAdapterPanel.setDeclarationPanel(composedActivityDeclarationPanel);

		nameDeclarationWithDocumentationAdapterPanel.setGUISeSAmDeclaration(getGUISeSAmDeclaration());
		nameDeclarationWithDocumentationAdapterPanel.setDeclaration(declaration);

		return nameDeclarationWithDocumentationAdapterPanel;
	}

	public String getDeclarationTitle(IDeclaration declaration) {
		return "Activity Graph";
	}

	public IGUISeSAmDeclaration getGUISeSAmDeclaration() {
		return _guiSeSAmDeclaration;
	}
}