package de.uniwue.ki.gui.mas.entity.objectclass.factory;
import de.uniwue.ki.gui.mas.entity.objectclass.ObjectFeatureListSettingsPanel;
import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.util.declaration.*;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: (12.10.2001 17:40:16)
 * @author Christoph Oechslein
 */

public class EditFeaturesObjectClassDeclarationPanelFactory extends AbstractDeclarationPanelFactory {
	private IGUISeSAmDeclaration _guiSeSAmDeclaration;

	public EditFeaturesObjectClassDeclarationPanelFactory() {
		super();
	}

	public EditFeaturesObjectClassDeclarationPanelFactory(IGUISeSAmDeclaration guiSeSAmDeclaration) {
		super();

		setGUISeSAmDeclaration(guiSeSAmDeclaration);
	}

	public IDeclarationPanel createDeclarationPanel(final IDeclaration declaration) {
		NameDeclarationWithDocumentationAdapterPanel nameDeclarationWithDocumentationAdapterPanel =
			new NameDeclarationWithDocumentationAdapterPanel();

		nameDeclarationWithDocumentationAdapterPanel.setGUISeSAmDeclaration(getGUISeSAmDeclaration());
		nameDeclarationWithDocumentationAdapterPanel.setDeclarationPanel(
			new ObjectFeatureListSettingsPanel());

		return nameDeclarationWithDocumentationAdapterPanel;
	}

	public String getDeclarationTitle(IDeclaration declaration) {
		return "Features";
	}

	public IGUISeSAmDeclaration getGUISeSAmDeclaration() {
		return _guiSeSAmDeclaration;
	}

	public void setGUISeSAmDeclaration(IGUISeSAmDeclaration newGUISeSAmDeclaration) {
		_guiSeSAmDeclaration = newGUISeSAmDeclaration;
	}
}