package de.uniwue.ki.gui.mas.entity.objectclass.factory;

import junit.framework.Assert;
import de.uniwue.ki.gui.mas.behaviour.reasoning.ActivityReasoningEngineDeclarationPanelContainer;
import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.util.declaration.*;
import de.uniwue.ki.mas.entity.objectclass.agentclass.IActivityAgentClassDeclaration;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Insert the class' description here. Creation date: (12.10.2001 17:40:16)
 * 
 * @author Christoph Oechslein
 */

public class EditReasoningActivityAgentClassDeclarationPanelFactory extends
        AbstractDeclarationPanelFactory {

    private IGUISeSAmDeclaration _guiSeSAmDeclaration;

    public EditReasoningActivityAgentClassDeclarationPanelFactory() {
        super();
    }

    public EditReasoningActivityAgentClassDeclarationPanelFactory(
            IGUISeSAmDeclaration guiSeSAmDeclaration) {
        super();

        setGUISeSAmDeclaration(guiSeSAmDeclaration);
    }

    public IDeclarationPanel createDeclarationPanel(IDeclaration declaration) {

        NameDeclarationWithDocumentationAdapterPanel nameDeclarationWithDocumentationAdapterPanel = new NameDeclarationWithDocumentationAdapterPanel();

        nameDeclarationWithDocumentationAdapterPanel
                .setGUISeSAmDeclaration(getGUISeSAmDeclaration());

        final IActivityAgentClassDeclaration activityAgentClassDeclaration = (IActivityAgentClassDeclaration) declaration;

        // Panel -> Container bergang hier interessant
        nameDeclarationWithDocumentationAdapterPanel
                .setDeclarationPanel(new ActivityReasoningEngineDeclarationPanelContainer() {

                    public void setDeclaration(IDeclaration declaration2) {
                        Assert
                                .assertTrue((declaration2 == activityAgentClassDeclaration)
                                        || (declaration2 == null));

                        setActivityAgentClassDeclaration(activityAgentClassDeclaration);
                    }

                    public IDeclaration getDeclaration() {
                        return activityAgentClassDeclaration;
                    }
                });

        return nameDeclarationWithDocumentationAdapterPanel;
    }

    public String getDeclarationTitle(IDeclaration declaration) {
        return "Reasoning";
    }

    public IGUISeSAmDeclaration getGUISeSAmDeclaration() {
        return _guiSeSAmDeclaration;
    }

    public void setGUISeSAmDeclaration(
            IGUISeSAmDeclaration newGUISeSAmDeclaration) {
        _guiSeSAmDeclaration = newGUISeSAmDeclaration;
    }
}
