package de.uniwue.ki.gui.mas.entity.objectclass.factory;
import javax.swing.Icon;

import de.uniwue.ki.gui.mas.entity.objectclass.ObjectClassDeclarationPanel;
import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.model.tree.SeSAmDeclarationTreeCellRenderer;
import de.uniwue.ki.gui.mas.util.declaration.AbstractDeclarationPanelFactory;
import de.uniwue.ki.gui.mas.util.declaration.IDeclarationPanel;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: (12.10.2001 17:40:16)
 * @author Christoph Oechslein
 */

public class EditRessourceClassDeclarationPanelFactory extends AbstractDeclarationPanelFactory {
	private IGUISeSAmDeclaration _guiSeSAmDeclaration;

	public EditRessourceClassDeclarationPanelFactory() {
		super();
	}

	public EditRessourceClassDeclarationPanelFactory(IGUISeSAmDeclaration guiSeSAmDeclaration) {
		super();

		setGUISeSAmDeclaration(guiSeSAmDeclaration);
	}

	public IDeclarationPanel createDeclarationPanel(final IDeclaration declaration) {
		ObjectClassDeclarationPanel activityRessourceClassDeclarationPanel =
			new ObjectClassDeclarationPanel();

		activityRessourceClassDeclarationPanel.setGUISeSAmDeclaration(getGUISeSAmDeclaration());

		return activityRessourceClassDeclarationPanel;
	}

	public String getDeclarationTitle(IDeclaration declaration) {
		return "Ressource";
	}
	
    public Icon getIcon(IDeclaration declaration) {
        return SeSAmDeclarationTreeCellRenderer.RESSOURCES_CLASS_LIST_ICON;
    }

	public IGUISeSAmDeclaration getGUISeSAmDeclaration() {
		return _guiSeSAmDeclaration;
	}

	public void setGUISeSAmDeclaration(IGUISeSAmDeclaration newGUISeSAmDeclaration) {
		_guiSeSAmDeclaration = newGUISeSAmDeclaration;
	}
}