package de.uniwue.ki.gui.mas.entity.objectclass.factory;
import java.awt.Container;

import de.uniwue.ki.gui.mas.model.*;
import de.uniwue.ki.gui.mas.util.declaration.action.PropertiesDeclarationAction;
import de.uniwue.ki.gui.util.actions.AbstractBoundAction;
import de.uniwue.ki.mas.entity.objectclass.IObjectClassDeclaration;
import de.uniwue.ki.mas.entity.variableclass.BodyVariableClassDeclarationListAndFactory;
/**
 * Creation date: (05.02.2002 11:38:36)
 * @author Christoph Oechslein
 */
public class ObjectBodyVariableDeclarationListAndFactoryActionFactory extends DefaultMutableListModelAndFactoryPanelActionFactory {
public ObjectBodyVariableDeclarationListAndFactoryActionFactory(IGUISeSAmDeclaration guiSeSAmDeclaration) {
	super(guiSeSAmDeclaration);
}


public boolean getCanProduceActions(Container parent, Object anObject) {
    return (anObject instanceof BodyVariableClassDeclarationListAndFactory)
        && (getSeSAmDeclarationTreeModel().getUserObjectParentOf(anObject) instanceof IObjectClassDeclaration);
}


public AbstractBoundAction getPropertyAction(final Container parent, Object anObject) {
    IObjectClassDeclaration objectClassDeclaration = (IObjectClassDeclaration) getSeSAmDeclarationTreeModel().getUserObjectParentOf(anObject);

    return new AbstractDeclarationPanelAction(
        parent,
        "Properties",
        PropertiesDeclarationAction.PROPERTIES_ICON,
        objectClassDeclaration,
        new EditVariablesObjectClassDeclarationPanelFactory(getGUISeSAmDeclaration()),
        false) {
        public IGUISeSAmDeclaration getGUISeSAmDeclaration() {
            return ObjectBodyVariableDeclarationListAndFactoryActionFactory.this.getGUISeSAmDeclaration();
        }
    };
}
}