package de.uniwue.ki.gui.mas.entity.objectclass.factory;
import java.awt.Container;
import java.util.Iterator;

import de.uniwue.ki.gui.mas.basics.search.SearchDeclarationPanelAction;
import de.uniwue.ki.gui.mas.entity.variableclass.BodyVariableOrBodyFeatureVariableClassDeclarationPanel;
import de.uniwue.ki.gui.mas.model.AbstractDeclarationPanelAndActionFactory;
import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.util.declaration.*;
import de.uniwue.ki.mas.entity.objectclass.IObjectClassDeclaration;
import de.uniwue.ki.mas.entity.variableclass.IBodyVariableClassDeclaration;
import de.uniwue.ki.mas.util.declaration.IDeclaration;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Creation date: (10.10.2001 11:09:49)
 * @author Christoph Oechslein
 */

public final class ObjectBodyVariablesClassDeclarationPanelActionFactory
	extends AbstractDeclarationPanelAndActionFactory {
	private final class BodyVariableClassDeclarationPanelFactory extends AbstractDeclarationPanelFactory {
		private final IObjectClassDeclaration _objectClassDeclaration;

		public BodyVariableClassDeclarationPanelFactory(IObjectClassDeclaration objectClassDeclaration) {
			super();

			_objectClassDeclaration = objectClassDeclaration;
		}

		public IDeclarationPanel createDeclarationPanel(IDeclaration declaration) {
			BodyVariableOrBodyFeatureVariableClassDeclarationPanel bodyVariableClassDeclarationPanel =
				new BodyVariableOrBodyFeatureVariableClassDeclarationPanel();

			bodyVariableClassDeclarationPanel.setGUISeSAmDeclaration(getGUISeSAmDeclaration());
			IObjectClassDeclaration newValue = _objectClassDeclaration;

			bodyVariableClassDeclarationPanel.setObjectClassDeclaration(newValue);

			return bodyVariableClassDeclarationPanel;
		}

		public String getDeclarationTitle(IDeclaration declaration) {
			return "Agent Variable";
		}
	}

	public ObjectBodyVariablesClassDeclarationPanelActionFactory(IGUISeSAmDeclaration guiSeSAmDeclaration) {

		super();

		setGUISeSAmDeclaration(guiSeSAmDeclaration);
	}

	protected boolean getCanProduceDeclarationActions(Container parent, IDeclaration anDeclaration) {
		if (!(anDeclaration instanceof IBodyVariableClassDeclaration))
			return false;

		return getSeSAmDeclarationTreeModel().getUserObjectParentOf(
			getSeSAmDeclarationTreeModel().getUserObjectParentOf(anDeclaration))
			instanceof IObjectClassDeclaration;
	}

	public IDeclarationPanelFactory getDeclarationPanelFactory(
		Container parent,
		IDeclaration anDeclaration) {
		IObjectClassDeclaration objectClassDeclaration =
			(IObjectClassDeclaration)getSeSAmDeclarationTreeModel().getUserObjectParentOf(
				getSeSAmDeclarationTreeModel().getUserObjectParentOf(anDeclaration));

		return new BodyVariableClassDeclarationPanelFactory(objectClassDeclaration);
	}

	protected Iterator getImportantDeclarationActions(Container parent, IDeclaration anDeclaration) {
		return CollectionsHelper.createIterator(
			new SearchDeclarationPanelAction(parent, anDeclaration, getGUISeSAmDeclaration()));
	}

}