package de.uniwue.ki.gui.mas.entity.objectclass.factory;
import java.awt.Container;
import java.util.*;

import de.uniwue.ki.gui.mas.model.*;
import de.uniwue.ki.gui.mas.model.tree.SeSAmDeclarationTreePanel;
import de.uniwue.ki.gui.mas.util.declaration.action.PropertiesDeclarationAction;
import de.uniwue.ki.gui.util.actions.AbstractBoundAction;
import de.uniwue.ki.gui.util.actions.InspectAction;
import de.uniwue.ki.mas.basics.featureList.IObjectFeatureClassDeclarationList;
import de.uniwue.ki.mas.entity.objectclass.IObjectClassDeclaration;
/**
 * Creation date: (05.02.2002 11:38:36)
 * @author Christoph Oechslein
 */
public class ObjectFeatureFeatueClassDeclarationListActionFactory extends DefaultMutableListModelActionFactory {
public ObjectFeatureFeatueClassDeclarationListActionFactory(IGUISeSAmDeclaration guiSeSAmDeclaration) {
	super(guiSeSAmDeclaration);
}


public boolean getCanProduceActions(Container parent, Object anObject) {
    return (anObject instanceof IObjectFeatureClassDeclarationList)
        && (getSeSAmDeclarationTreeModel().getUserObjectParentOf(anObject) instanceof IObjectClassDeclaration);
}


public Iterator getMoreActions(Container parent, Object anObject) {
    IObjectFeatureClassDeclarationList objectFeatureClassDeclarationList = (IObjectFeatureClassDeclarationList) anObject;

    List actions = new LinkedList();

    if (parent instanceof SeSAmDeclarationTreePanel)
        actions.add(createRefreshAction(getSeSAmDeclarationTreeModel(), objectFeatureClassDeclarationList));

    actions.add(new InspectAction(objectFeatureClassDeclarationList));

    return actions.iterator();
}


public AbstractBoundAction getPropertyAction(final Container parent, Object anObject) {
    IObjectClassDeclaration objectClassDeclaration = (IObjectClassDeclaration) getSeSAmDeclarationTreeModel().getUserObjectParentOf(anObject);

    return new AbstractDeclarationPanelAction(
        parent,
        "Properties",
        PropertiesDeclarationAction.PROPERTIES_ICON,
        objectClassDeclaration,
        new EditFeaturesObjectClassDeclarationPanelFactory(getGUISeSAmDeclaration()),
        false) {
        public IGUISeSAmDeclaration getGUISeSAmDeclaration() {
            return ObjectFeatureFeatueClassDeclarationListActionFactory.this.getGUISeSAmDeclaration();
        }
    };
}
}