package de.uniwue.ki.gui.mas.entity.objectclass.factory;

import java.awt.Container;
import java.util.Iterator;

import de.uniwue.ki.gui.mas.basics.search.SearchDeclarationPanelAction;
import de.uniwue.ki.gui.mas.model.AbstractDeclarationPanelAndActionFactory;
import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.util.declaration.IDeclarationPanelFactory;
import de.uniwue.ki.gui.util.SwingMoreUtilities;
import de.uniwue.ki.mas.entity.objectclass.IRessourceClassDeclaration;
import de.uniwue.ki.mas.util.declaration.IDeclaration;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Creation date: (10.10.2001 11:09:49)
 * @author Christoph Oechslein
 */

public class RessourceClassDeclarationPanelActionFactory extends AbstractDeclarationPanelAndActionFactory {
	private final EditRessourceClassDeclarationPanelFactory _editPropertiesDeclarationPanelFactory =
		new EditRessourceClassDeclarationPanelFactory();

	private final EditVariablesObjectClassDeclarationPanelFactory _editVariablesDeclarationPanelFactory =
		new EditVariablesObjectClassDeclarationPanelFactory();

	private final EditFeaturesObjectClassDeclarationPanelFactory _editFeaturesDeclarationPanelFactory =
		new EditFeaturesObjectClassDeclarationPanelFactory();

	public RessourceClassDeclarationPanelActionFactory() {
		super();
	}
	public RessourceClassDeclarationPanelActionFactory(IGUISeSAmDeclaration guiSeSAmDeclaration) {

		super();

		setGUISeSAmDeclaration(guiSeSAmDeclaration);
	}
	protected boolean getCanProduceDeclarationActions(Container parent, IDeclaration anDeclaration) {
		return anDeclaration instanceof IRessourceClassDeclaration;
	}
	protected Iterator getImportantDeclarationActions(Container parent, IDeclaration anDeclaration) {
		return CollectionsHelper.createIterator(
			new DeclarationPanelAction(
				parent,
				"Variables",
				SwingMoreUtilities.getJavaSunIcon(16, "general/Properties16.gif"),
				anDeclaration,
				_editVariablesDeclarationPanelFactory,
				false),
			new DeclarationPanelAction(
				parent,
				"Features",
				SwingMoreUtilities.getJavaSunIcon(16, "general/Properties16.gif"),
				anDeclaration,
				_editFeaturesDeclarationPanelFactory,
				false),
			new SearchDeclarationPanelAction(parent, anDeclaration, getGUISeSAmDeclaration()));
	}

	public IDeclarationPanelFactory getDeclarationPanelFactory(
		Container parent,
		IDeclaration anDeclaration) {
		return _editPropertiesDeclarationPanelFactory;
	}
	
	protected boolean shouldUseOkCancelDeclarationPanel(Container parent, IDeclaration anDeclaration) {
		return false;
	}

	public void setGUISeSAmDeclaration(IGUISeSAmDeclaration newGUISeSAmDeclaration) {
		super.setGUISeSAmDeclaration(newGUISeSAmDeclaration);

		_editPropertiesDeclarationPanelFactory.setGUISeSAmDeclaration(newGUISeSAmDeclaration);
		_editVariablesDeclarationPanelFactory.setGUISeSAmDeclaration(newGUISeSAmDeclaration);
		_editFeaturesDeclarationPanelFactory.setGUISeSAmDeclaration(newGUISeSAmDeclaration);
	}
}
