package de.uniwue.ki.gui.mas.entity.variable;
import java.awt.Container;
import java.util.*;

import de.uniwue.ki.gui.mas.model.DefaultMutableListModelActionFactory;
import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.model.tree.SeSAmDeclarationTreePanel;
import de.uniwue.ki.gui.util.actions.InspectAction;
import de.uniwue.ki.mas.entity.variable.BodyVariableInstanceDeclarationList;
import de.uniwue.ki.mas.model.ISeSAmModelDeclaration;
/**
 * Creation date: (08.02.2002 14:59:09)
 * @author Christoph Oechslein
 */
public class BodyVariableInstanceDeclarationListActionFactory
	extends DefaultMutableListModelActionFactory {

	public BodyVariableInstanceDeclarationListActionFactory(IGUISeSAmDeclaration guiSeSAmDeclaration) {
		super(guiSeSAmDeclaration);
	}

	public boolean getCanProduceActions(Container parent, Object anObject) {
		return super.getCanProduceActions(parent, anObject)
			&& (anObject instanceof BodyVariableInstanceDeclarationList);
	}

	protected ISeSAmModelDeclaration getSeSAmModelDeclaration() {
		return super.getSeSAmModelDeclaration();
	}

	public Iterator getMoreActions(Container parent, Object anObject) {
		BodyVariableInstanceDeclarationList bodyVariableInstanceDeclarationList =
			(BodyVariableInstanceDeclarationList) anObject;

		List actions = new LinkedList();

		if (parent instanceof SeSAmDeclarationTreePanel)
			actions.add(
				createRefreshAction(getSeSAmDeclarationTreeModel(), bodyVariableInstanceDeclarationList));

		actions.add(new InspectAction(bodyVariableInstanceDeclarationList));

		return actions.iterator();
	}
}