package de.uniwue.ki.gui.mas.entity.variable;
import java.util.HashMap;

import de.uniwue.ki.gui.mas.basics.functionCall.IExpertFilterFunctionDeclarationListAble;
import de.uniwue.ki.gui.mas.entity.variableclass.BodyVariableClassDeclarationPanel;
import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.util.OwnDefaultValueFunctionCallDeclarationPanel;
import de.uniwue.ki.gui.mas.util.declaration.*;
import de.uniwue.ki.mas.basics.functionArgument.IFunctionArgumentDeclarationList;
import de.uniwue.ki.mas.entity.objectclass.IObjectClassDeclaration;
import de.uniwue.ki.mas.entity.variable.IBodyVariableInstanceDeclaration;
import de.uniwue.ki.mas.entity.variableclass.IBodyFeatureVariableClassDeclaration;
import de.uniwue.ki.mas.entity.variableclass.IBodyVariableClassDeclaration;
import de.uniwue.ki.mas.util.declaration.IDeclaration;
/**
 * Creation date: (03.12.2001 10:54:39)
 * @author Christoph Oechslein
 */
public class BodyVariableInstanceDeclarationPanel extends AbstractDeclarationPanel {
	private IBodyVariableInstanceDeclaration ivjBodyVariableInstanceDeclarationIntern = null;

	private final IvjEventHandler ivjEventHandler = new IvjEventHandler();
	private IObjectClassDeclaration ivjObjectClassDeclarationIntern = null;
	private OwnDefaultValueFunctionCallDeclarationPanel ivjOwnDefaultValueFunctionCallDeclarationPanel = null;
	private javax.swing.JButton ivjJButtonEditBodyVar = null;

	private final class IvjEventHandler
		implements java.awt.event.ActionListener, javax.swing.event.ChangeListener {
		public void actionPerformed(java.awt.event.ActionEvent e) {
			if (e.getSource() == BodyVariableInstanceDeclarationPanel.this.getJButtonEditBodyVar())
				eventEditBodyVarButtonPressed();
		}
		public void stateChanged(javax.swing.event.ChangeEvent e) {
			if (e.getSource()
				== BodyVariableInstanceDeclarationPanel.this.getBodyVariableInstanceDeclaration())
				updateDefaultValueText();
		}
	}
	private javax.swing.JLabel _jLabelDefaultValue = null;
	private javax.swing.JTextField ivjJTextFieldDefaultValue = null;

	public BodyVariableInstanceDeclarationPanel() {
		super();
		initialize();
	}

	public void dispose() {
		getOwnDefaultValueFunctionCallDeclarationPanel().dispose();

		super.dispose();
	}

	public IBodyVariableInstanceDeclaration getBodyVariableInstanceDeclaration() {
		return ivjBodyVariableInstanceDeclarationIntern;
	}

	public IDeclaration getDeclaration() {
		return getBodyVariableInstanceDeclaration();
	}

	public IObjectClassDeclaration getObjectClassDeclaration() {
		return ivjObjectClassDeclarationIntern;
	}

	private OwnDefaultValueFunctionCallDeclarationPanel getOwnDefaultValueFunctionCallDeclarationPanel() {
		if (ivjOwnDefaultValueFunctionCallDeclarationPanel == null) {
			ivjOwnDefaultValueFunctionCallDeclarationPanel =
				new OwnDefaultValueFunctionCallDeclarationPanel();
			ivjOwnDefaultValueFunctionCallDeclarationPanel.setName(
				"OwnDefaultValueFunctionCallDeclarationPanel");

		}
		return ivjOwnDefaultValueFunctionCallDeclarationPanel;
	}

	private void initConnections() {
		getJButtonEditBodyVar().addActionListener(ivjEventHandler);
		getOwnDefaultValueFunctionCallDeclarationPanel().setOwnDefaultValueFunctionCallDeclarationAble(
			getBodyVariableInstanceDeclaration());
	}

	private void initialize() {
		setLayout(new java.awt.GridBagLayout());

		java.awt.GridBagConstraints constraintsOwnDefaultValueFunctionCallDeclarationPanel =
			new java.awt.GridBagConstraints();
		constraintsOwnDefaultValueFunctionCallDeclarationPanel.gridx = 0;
		constraintsOwnDefaultValueFunctionCallDeclarationPanel.gridy = 1;
		constraintsOwnDefaultValueFunctionCallDeclarationPanel.gridwidth = 4;
		constraintsOwnDefaultValueFunctionCallDeclarationPanel.fill = java.awt.GridBagConstraints.BOTH;
		constraintsOwnDefaultValueFunctionCallDeclarationPanel.weightx = 1.0;
		constraintsOwnDefaultValueFunctionCallDeclarationPanel.weighty = 1.0;
		constraintsOwnDefaultValueFunctionCallDeclarationPanel.insets = new java.awt.Insets(4, 0, 0, 0);
		add(
			getOwnDefaultValueFunctionCallDeclarationPanel(),
			constraintsOwnDefaultValueFunctionCallDeclarationPanel);

		java.awt.GridBagConstraints constraintsJButtonEditBodyVar = new java.awt.GridBagConstraints();
		constraintsJButtonEditBodyVar.gridx = 2;
		constraintsJButtonEditBodyVar.gridy = 0;
		constraintsJButtonEditBodyVar.anchor = java.awt.GridBagConstraints.WEST;
		constraintsJButtonEditBodyVar.insets = new java.awt.Insets(0, 7, 0, 4);
		add(getJButtonEditBodyVar(), constraintsJButtonEditBodyVar);

		java.awt.GridBagConstraints constraintsJLabel1 = new java.awt.GridBagConstraints();
		constraintsJLabel1.gridx = 0;
		constraintsJLabel1.gridy = 0;
		constraintsJLabel1.insets = new java.awt.Insets(0, 0, 0, 4);
		add(getJLabelDefaultValue(), constraintsJLabel1);

		java.awt.GridBagConstraints constraintsJTextFieldDefaultValue = new java.awt.GridBagConstraints();
		constraintsJTextFieldDefaultValue.gridx = 1;
		constraintsJTextFieldDefaultValue.gridy = 0;
		constraintsJTextFieldDefaultValue.fill = java.awt.GridBagConstraints.HORIZONTAL;
		constraintsJTextFieldDefaultValue.weightx = 1.0;
		add(getJTextFieldDefaultValue(), constraintsJTextFieldDefaultValue);

		initConnections();
	}

	public void setBodyVariableInstanceDeclaration(IBodyVariableInstanceDeclaration newValue) {
		IBodyVariableInstanceDeclaration oldValue = getBodyVariableInstanceDeclaration();

		if (oldValue != newValue) {
			/* Stop listening for events from the current object */
			if (ivjBodyVariableInstanceDeclarationIntern != null) {
				ivjBodyVariableInstanceDeclarationIntern.removeChangeListener(ivjEventHandler);
			}
			ivjBodyVariableInstanceDeclarationIntern = newValue;

			/* Listen for events from the new object */
			if (ivjBodyVariableInstanceDeclarationIntern != null) {
				ivjBodyVariableInstanceDeclarationIntern.addChangeListener(ivjEventHandler);
			}
			getOwnDefaultValueFunctionCallDeclarationPanel().setOwnDefaultValueFunctionCallDeclarationAble(
				getBodyVariableInstanceDeclaration());
			updateDefaultValueText();
			firePropertyChange("bodyVariableInstanceDeclaration", oldValue, newValue);
		}
	}

	public void setDeclaration(IDeclaration declaration) {
		setBodyVariableInstanceDeclaration((IBodyVariableInstanceDeclaration)declaration);
	}

	public IExpertFilterFunctionDeclarationListAble getExpertFilterFunctionDeclarationListAble() {
		return ivjOwnDefaultValueFunctionCallDeclarationPanel.getExpertFilterFunctionDeclarationListAble();
	}

	private javax.swing.JButton getJButtonEditBodyVar() {
		if (ivjJButtonEditBodyVar == null) {
			ivjJButtonEditBodyVar = new javax.swing.JButton();
			ivjJButtonEditBodyVar.setText("Edit Variable ...");
		}
		return ivjJButtonEditBodyVar;
	}

	private javax.swing.JLabel getJLabelDefaultValue() {
		if (_jLabelDefaultValue == null) {
			_jLabelDefaultValue = new javax.swing.JLabel();
			_jLabelDefaultValue.setText("Default Value:");

		}
		return _jLabelDefaultValue;
	}

	private javax.swing.JTextField getJTextFieldDefaultValue() {
		if (ivjJTextFieldDefaultValue == null) {
			ivjJTextFieldDefaultValue = new javax.swing.JTextField();
			ivjJTextFieldDefaultValue.setName("JTextFieldDefaultValue");
			ivjJTextFieldDefaultValue.setEditable(false);
			ivjJTextFieldDefaultValue.setColumns(30);
		}
		return ivjJTextFieldDefaultValue;
	}

	protected void eventEditBodyVarButtonPressed() {
		if ((getGUISeSAmDeclaration() != null) && (getBodyVariableInstanceDeclaration() != null)) {

			IDeclarationPanelFactory bodyVarDeclarationPanelFactory = new AbstractDeclarationPanelFactory() {
				public IDeclarationPanel createDeclarationPanel(IDeclaration declaration) {
					BodyVariableClassDeclarationPanel bodyVariableClassDeclarationPanel =
						new BodyVariableClassDeclarationPanel();

					bodyVariableClassDeclarationPanel.setGUISeSAmDeclaration(getGUISeSAmDeclaration());
					getExpertFilterFunctionDeclarationListAble().copyInto(
						bodyVariableClassDeclarationPanel.getExpertFilterFunctionDeclarationListAble(),
						new HashMap());

					return bodyVariableClassDeclarationPanel;
				}

				public String getDeclarationTitle(IDeclaration declaration) {
					return "Edit Variable";
				}
			};

			getGUISeSAmDeclaration().getFrameFactory().addPanel(
				this,
				getBodyVariableInstanceDeclaration().getBodyVariableClassDeclaration(),
				bodyVarDeclarationPanelFactory,
				true,
				true);
		}
	}

	protected void updateDefaultValueText() {
		if (getBodyVariableInstanceDeclaration() == null) {
			getJTextFieldDefaultValue().setText("");

		} else {
			IBodyVariableClassDeclaration bodyVariableClassDeclaration =
				getBodyVariableInstanceDeclaration().getBodyVariableClassDeclaration();

			String name = null;

			if (bodyVariableClassDeclaration instanceof IBodyFeatureVariableClassDeclaration) {
				IBodyFeatureVariableClassDeclaration bodyFeatureVariableClassDeclaration =
					(IBodyFeatureVariableClassDeclaration)bodyVariableClassDeclaration;

				if (bodyFeatureVariableClassDeclaration.getUsesOwnDefaulValueFunctionCallDeclaration()) {
					name =
						bodyFeatureVariableClassDeclaration
							.getDefaultValueFunctionCallDeclaration()
							.getName();
				}
			}

			if (name == null) {
				name =
					bodyVariableClassDeclaration
						.getVariableClassDeclaration()
						.getDefaultValueFunctionCallDeclaration()
						.getName();
			}

			getJTextFieldDefaultValue().setText(name);
			getJTextFieldDefaultValue().setToolTipText(name);
		}
	}

	public IFunctionArgumentDeclarationList getOuterFunctionArgumentDeclarationList() {
		return getOwnDefaultValueFunctionCallDeclarationPanel().getOuterFunctionArgumentDeclarationList();
	}

	public void setOuterFunctionArgumentDeclarationList(IFunctionArgumentDeclarationList functionArgumentDeclarationList) {
		getOwnDefaultValueFunctionCallDeclarationPanel().setOuterFunctionArgumentDeclarationList(
			functionArgumentDeclarationList);
	}

	public void setGUISeSAmDeclaration(IGUISeSAmDeclaration guiSeSAmDeclaration) {
		super.setGUISeSAmDeclaration(guiSeSAmDeclaration);

		getOwnDefaultValueFunctionCallDeclarationPanel().setGUISeSAmDeclaration(guiSeSAmDeclaration);
	}
}