package de.uniwue.ki.gui.mas.entity.variable;

import java.awt.Component;

import javax.swing.JTable;
import javax.swing.table.TableModel;

import junit.framework.Assert;
import de.uniwue.ki.mas.entity.variable.IBodyVariable;
import de.uniwue.ki.mas.entity.variable.IBodyVariableInstanceDeclaration;
import de.uniwue.ki.mas.entity.variableclass.IVariableClassDeclaration;
import de.uniwue.ki.util.name.INamed;

/**
 * @author herrler
 *
 */
public class BodyVariableTablePanelCellRenderer extends DefaultWithTooltipTableCellRenderer {

	public BodyVariableTablePanelCellRenderer(boolean withToolTip) {
		super(withToolTip);
	}

	private static String getVariableValueName(TableModel tableModel, int index) {
		TableModelVariableListAdapter tableModelVariableListAdapter =
			(TableModelVariableListAdapter)tableModel;
		IVariableClassDeclaration variableClassDeclaration =
			tableModelVariableListAdapter.getVariableClassDeclarationAt(index);

		if (variableClassDeclaration == null)
			return "var value at index " + index + "vanished";

		else {
			StringBuffer buff = new StringBuffer();

			variableClassDeclaration.getSpecificType().appendNameForArgumentObject(
				buff,
				tableModelVariableListAdapter.getVariableValueAt(index),
				0,
				5);

			return buff.toString();
		}
	}

	public static String getStringValue(TableModel tableModel, int row, int col) {
		Object value = tableModel.getValueAt(row, col);

		if (value instanceof IBodyVariable) {
			return getVariableValueName(tableModel, row);
		}

		if (value instanceof IVariableClassDeclaration) {
			return ((IVariableClassDeclaration)value).getName();
		}

		if (value instanceof IBodyVariableInstanceDeclaration) {
			return ((IBodyVariableInstanceDeclaration)value)
				.getBodyVariableClassDeclaration()
				.getVariableClassDeclaration()
				.getSpecificType()
				.getName();
		}

		if (value instanceof INamed) {
			return ((INamed)value).getName();
		}

		if (Assert.ASSERTION_ON)
			Assert.assertTrue(value instanceof String);
		return value.toString();
	}

	public Component getTableCellRendererComponent(
		JTable table,
		Object value,
		boolean isSelected,
		boolean hasFocus,
		int row,
		int col) {

		return super.getTableCellRendererComponent(
			table,
			getStringValue(table.getModel(), row, table.convertColumnIndexToModel(col)),
			isSelected,
			hasFocus,
			row,
			col);
	}

}
