package de.uniwue.ki.gui.mas.entity.variable;

import javax.swing.table.DefaultTableCellRenderer;

import de.uniwue.ki.gui.util.NamedCellRendererAdapter;

/**
 * Creation date: 01.10.2002, 15:02:26
 * @author oechslein
 */
public class DefaultWithTooltipTableCellRenderer extends DefaultTableCellRenderer {
	private final boolean _updateTooltip;

	public DefaultWithTooltipTableCellRenderer() {
		this(false);
	}

	public DefaultWithTooltipTableCellRenderer(boolean updateTooltip) {
		super();

		_updateTooltip = updateTooltip;
	}

	protected void setValue(Object value) {
		super.setValue(value);

		if (_updateTooltip)
			setToolTipText(NamedCellRendererAdapter.insertLineBreaks(value + "", 255, false));
	}
}
