package de.uniwue.ki.gui.mas.entity.variable.viewer;

import java.awt.Component;

import javax.swing.DefaultListCellRenderer;
import javax.swing.JList;

import de.uniwue.ki.mas.basics.type.ISpecificType;

public class ArgumentCellRenderer extends DefaultListCellRenderer {
	private ISpecificType _specificType;

	public Component getListCellRendererComponent(
		JList list,
		Object value,
		int index,
		boolean isSelected,
		boolean cellHasFocus) {

		setOpaque(isSelected);

		if (getSpecificType() == null) {
			return super.getListCellRendererComponent(list, value, index, isSelected, cellHasFocus);

		} else {
			StringBuffer buff = new StringBuffer();
			getSpecificType().appendNameForArgumentObject(buff, value, 0, 5);

			String name = buff.toString();

			return super.getListCellRendererComponent(list, name, index, isSelected, cellHasFocus);
		}
	}

	public void setSpecificType(ISpecificType specificType) {
		_specificType = specificType;
	}

	public ISpecificType getSpecificType() {
		return _specificType;
	}

}
