package de.uniwue.ki.gui.mas.entity.variable.viewer;

import java.awt.BorderLayout;

import javax.swing.JLabel;

import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.model.JPanelWithGUISeSAmDeclaration;
import de.uniwue.ki.mas.basics.type.ISpecificType;
import de.uniwue.ki.mas.basics.type.enum.EnumItem;

/**
 * @author herrler
 */
public class ObjectValueViewerEnumItem extends JPanelWithGUISeSAmDeclaration implements IObjectValueViewer {

	private JLabel _label = null;
	
	public boolean canShow(ISpecificType type, Object obj) {
		return (obj instanceof EnumItem);
	}

	public ObjectValueViewerEnumItem(IGUISeSAmDeclaration sesamDeclaration) {
		setGUISeSAmDeclaration(sesamDeclaration);
	}

	public ObjectValueViewerEnumItem(IGUISeSAmDeclaration sesamDeclaration, Object obj) {
		super();
		setGUISeSAmDeclaration(sesamDeclaration);
		
		_label = new javax.swing.JLabel();
	    _label.setName("JLabelImageIcon");
		_label.setBorder(new de.uniwue.ki.gui.util.border.BetterTitledBorder());
		_label.setText(((EnumItem)obj).getName());
		_label.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
		_label.setVerticalTextPosition(javax.swing.SwingConstants.CENTER);
		_label.setVerticalAlignment(javax.swing.SwingConstants.CENTER);
		_label.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);

		this.setLayout(new BorderLayout());
		this.add(_label, BorderLayout.CENTER);
	}

	public final JPanelWithGUISeSAmDeclaration getBodyVariableValueViewerPanel(ISpecificType type, Object obj) {
		return new ObjectValueViewerEnumItem(getGUISeSAmDeclaration(), obj);
	}
	
	/**
	 * @see de.uniwue.ki.gui.mas.entity.variable.viewer.IValueViewer#getContextMenuString()
	 */
	public String getContextMenuString() {
		return "View Enumitem";
	}
}
