package de.uniwue.ki.gui.mas.entity.variable.viewer;

import java.awt.BorderLayout;

import javax.swing.ImageIcon;
import javax.swing.JLabel;

import sun.awt.image.Image;
import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.model.JPanelWithGUISeSAmDeclaration;
import de.uniwue.ki.mas.basics.type.ISpecificType;
import de.uniwue.ki.mas.entity.variable.IBodyVariable;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * @author herrler
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class ObjectValueViewerImage extends JPanelWithGUISeSAmDeclaration implements IObjectValueViewer {
	private JLabel _label = null;
	
	public boolean canShow(ISpecificType type, Object obj) {
		return (obj instanceof Image);
	}

	public ObjectValueViewerImage(IGUISeSAmDeclaration sesamDeclaration) {
		setGUISeSAmDeclaration(sesamDeclaration);
	}

	public ObjectValueViewerImage(IGUISeSAmDeclaration sesamDeclaration, Object obj) {
		super();
		setGUISeSAmDeclaration(sesamDeclaration);
		
		_label = new javax.swing.JLabel();
	    _label.setName("JLabelImageIcon");
		_label.setBorder(new de.uniwue.ki.gui.util.border.BetterTitledBorder());
		_label.setText("No image");
		_label.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
		_label.setVerticalTextPosition(javax.swing.SwingConstants.CENTER);
		_label.setVerticalAlignment(javax.swing.SwingConstants.CENTER);
		_label.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);

		Image img = null;
		try {
			if (obj instanceof IBodyVariable)
				img = (Image)(((IBodyVariable)obj).getValue());
			else if (obj instanceof Image)
				img = (Image)obj;
		} catch (SimulationRuntimeException e) {

		}

		if (img!=null) {
		_label.setIcon(new ImageIcon(img)); }
		
		this.setLayout(new BorderLayout());
		this.add(_label, BorderLayout.CENTER);
	}

	public final JPanelWithGUISeSAmDeclaration getBodyVariableValueViewerPanel(ISpecificType type, Object obj) {
		return new ObjectValueViewerImage(getGUISeSAmDeclaration(), obj);
	}
	
	/**
	 * @see de.uniwue.ki.gui.mas.entity.variable.viewer.IValueViewer#getContextMenuString()
	 */
	public String getContextMenuString() {
		return "View Image";
	}

}
