package de.uniwue.ki.gui.mas.entity.variable.viewer;

import java.awt.BorderLayout;
import java.awt.event.*;
import java.util.Collection;

import javax.swing.*;

import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.model.JPanelWithGUISeSAmDeclaration;
import de.uniwue.ki.mas.basics.type.ISpecificType;
import de.uniwue.ki.mas.basics.type.SpecificListType;

/**
 * @author herrler
 */
public class ObjectValueViewerListType extends JPanelWithGUISeSAmDeclaration implements IObjectValueViewer {

	private static final class IvjEventHandler extends MouseAdapter implements MouseListener {
		private ObjectValueViewerListType _parent = null;

		public IvjEventHandler(ObjectValueViewerListType parent) {
			_parent = parent;
		}

		private JPopupMenu getPopupMenu(ISpecificType type, Object object) {
			return _parent.getGUISeSAmDeclaration().getPanelActionFactoryManager().createPopup(
				_parent,
				new ObjectTypePair(type, object));
		}

		public void mouseClicked(MouseEvent mouseEvent) {
			//rechte Maustaste
			if (mouseEvent.getModifiers() == 4) {
				JList source = (JList) mouseEvent.getComponent();
				JPopupMenu popup =
					getPopupMenu(
						((ArgumentCellRenderer) source.getCellRenderer()).getSpecificType(),
						source.getModel().getElementAt(source.locationToIndex(mouseEvent.getPoint())));
				if (popup != null)
					popup.show(mouseEvent.getComponent(), mouseEvent.getX(), mouseEvent.getY());
			}
		}
	}

	public String getContextMenuString() {
		return "View List";
	}

	public boolean canShow(ISpecificType type, Object obj) {
		return (type instanceof SpecificListType) && (obj instanceof Collection);
	}

	public ObjectValueViewerListType(IGUISeSAmDeclaration seSAmDeclaration) {
		super();
		setGUISeSAmDeclaration(seSAmDeclaration);
		//init(null);
	}

	public ObjectValueViewerListType(
		IGUISeSAmDeclaration seSAmDeclaration,
		SpecificListType type,
		Object obj) {

		super();
		setGUISeSAmDeclaration(seSAmDeclaration);
		JList list = new JList();

		list.setListData(((Collection) obj).toArray());
		list.addMouseListener(new IvjEventHandler(this));

		ArgumentCellRenderer renderer = new ArgumentCellRenderer();
		renderer.setSpecificType(type.getListSpecificType());
		list.setCellRenderer(renderer);

		JScrollPane scroller = new JScrollPane(list);

		this.setLayout(new BorderLayout());
		this.add(scroller, BorderLayout.CENTER);
	}

	public final JPanelWithGUISeSAmDeclaration getBodyVariableValueViewerPanel(
		ISpecificType type,
		Object obj) {

		return new ObjectValueViewerListType(getGUISeSAmDeclaration(), (SpecificListType) type, obj);
	}
}
