package de.uniwue.ki.gui.mas.entity.variable.viewer;

import java.util.Iterator;
import java.util.LinkedList;

import junit.framework.Assert;
import de.uniwue.ki.gui.mas.model.JPanelWithGUISeSAmDeclaration;
import de.uniwue.ki.mas.basics.type.ISpecificType;

/**
 * @author herrler
 */
public class ObjectValueViewerManager implements IObjectValueViewer {
	private LinkedList _objectValueViewerList = new LinkedList();

	public void addObjectValueViewer(IObjectValueViewer viewer) {
		_objectValueViewerList.add(viewer);
	}

	public JPanelWithGUISeSAmDeclaration getBodyVariableValueViewerPanel(ISpecificType type, Object obj) {
		Iterator iter = _objectValueViewerList.iterator();

		while (iter.hasNext()) {
			IObjectValueViewer element = (IObjectValueViewer) iter.next();
			if (element.canShow(type, obj))
				return element.getBodyVariableValueViewerPanel(type, obj);
		}

		return null;
	}

	public boolean canShow(ISpecificType type, Object obj) {
		Iterator iter = _objectValueViewerList.iterator();

		while (iter.hasNext()) {
			IObjectValueViewer element = (IObjectValueViewer) iter.next();
			if (element.canShow(type, obj))
				return true;
		}

		Assert.fail();
		return false;
	}

	public String getContextMenuString() {
		return "unimportant";
	}

}
