package de.uniwue.ki.gui.mas.entity.variable.viewer;

import de.uniwue.ki.gui.mas.basics.feature.spatial.ObjectWithSpatialInfoPanel;
import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.model.JPanelWithGUISeSAmDeclaration;
import de.uniwue.ki.mas.basics.type.GenericSimObjectType;
import de.uniwue.ki.mas.basics.type.ISpecificType;
import de.uniwue.ki.mas.entity.object.IObject;

public class ObjectValueViewerSimObject implements IObjectValueViewer {
	private final IGUISeSAmDeclaration _guiSeSAmDeclaration;

	public ObjectValueViewerSimObject(IGUISeSAmDeclaration guiSeSAmDeclaration) {
		_guiSeSAmDeclaration = guiSeSAmDeclaration;
	}

	public JPanelWithGUISeSAmDeclaration getBodyVariableValueViewerPanel(ISpecificType type, Object obj) {
		ObjectWithSpatialInfoPanel infoPanel = new ObjectWithSpatialInfoPanel();

		infoPanel.setGUISeSAmDeclaration(_guiSeSAmDeclaration);
		infoPanel.setObject((IObject)obj);

		return infoPanel;
	}

	public boolean canShow(ISpecificType type, Object obj) {
		return GenericSimObjectType.getGeneralSimObjectType().equals(type) && (obj instanceof IObject);
	}

	public String getContextMenuString() {
		return "View Object";
	}
}
