package de.uniwue.ki.gui.mas.entity.variableclass;
import java.util.HashMap;
import java.util.Iterator;

import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import de.uniwue.ki.gui.mas.basics.functionCall.ExpertFilterUserFeatureFunctionDeclarationListAble;
import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.util.OwnDefaultValueFunctionCallDeclarationPanel;
import de.uniwue.ki.gui.mas.util.declaration.*;
import de.uniwue.ki.gui.util.actions.AbstractBoundAction;
import de.uniwue.ki.mas.basics.feature.user.IUserFeatureClassDeclaration;
import de.uniwue.ki.mas.basics.functionArgument.IFunctionArgumentDeclarationList;
import de.uniwue.ki.mas.entity.variableclass.IBodyFeatureVariableClassDeclaration;
import de.uniwue.ki.mas.entity.variableclass.IFeatureVariableClassDeclaration;
import de.uniwue.ki.mas.util.declaration.IDeclaration;
/**
 * Creation date: (20.06.00 20:00:58)
 * @author Christoph Oechslein
 */
public class BodyFeatureVariableClassDeclarationPanel extends AbstractDeclarationPanel {
	private final transient ChangeListener _variableChangeListener = new ChangeListener() {
		public void stateChanged(ChangeEvent e) {
			updateDefaultValueText();
		}
	};

	private IBodyFeatureVariableClassDeclaration _bodyFeatureVariableClassDeclaration = null;

	private boolean _editable;

	private javax.swing.JLabel _jLabelDefaultValue = null;
	private OwnDefaultValueFunctionCallDeclarationPanel _ownDefaultValueFunctionCallDeclarationPanel = null;
	private javax.swing.JButton ivjJButtonEditBodyVar = null;
	private javax.swing.JTextField ivjJTextFieldDefaultValue = null;

	public BodyFeatureVariableClassDeclarationPanel() {
		super();
		initialize();
	}

	public void dispose() {
		getOwnDefaultValueFunctionCallDeclarationPanel().dispose();

		super.dispose();
	}

	public IBodyFeatureVariableClassDeclaration getBodyFeatureVariableClassDeclaration() {
		return _bodyFeatureVariableClassDeclaration;
	}

	public IDeclaration getDeclaration() {
		return getBodyFeatureVariableClassDeclaration();
	}

	public ExpertFilterUserFeatureFunctionDeclarationListAble getExpertFilterUserFeatureFunctionDeclarationListAble() {
		return (ExpertFilterUserFeatureFunctionDeclarationListAble)getOwnDefaultValueFunctionCallDeclarationPanel()
			.getExpertFilterFunctionDeclarationListAble();
	}

	private javax.swing.JButton getJButtonEditBodyVar() {
		if (ivjJButtonEditBodyVar == null) {
			ivjJButtonEditBodyVar =
				new javax.swing.JButton(new AbstractBoundAction("Edit Feature Variable ...") {
				public void doit() {
					eventEditBodyVarButtonPressed();
				}
			});
		}
		return ivjJButtonEditBodyVar;
	}

	private javax.swing.JLabel getJLabelDefaultValue() {
		if (_jLabelDefaultValue == null) {
			_jLabelDefaultValue = new javax.swing.JLabel();
			_jLabelDefaultValue.setText("Default Value:");

		}
		return _jLabelDefaultValue;
	}

	private javax.swing.JTextField getJTextFieldDefaultValue() {
		if (ivjJTextFieldDefaultValue == null) {
			ivjJTextFieldDefaultValue = new javax.swing.JTextField();
			ivjJTextFieldDefaultValue.setName("JTextFieldDefaultValue");
			ivjJTextFieldDefaultValue.setEditable(false);
			ivjJTextFieldDefaultValue.setColumns(30);
		}
		return ivjJTextFieldDefaultValue;
	}

	public IFunctionArgumentDeclarationList getOuterFunctionArgumentDeclarationList() {
		return getOwnDefaultValueFunctionCallDeclarationPanel().getOuterFunctionArgumentDeclarationList();
	}

	private OwnDefaultValueFunctionCallDeclarationPanel getOwnDefaultValueFunctionCallDeclarationPanel() {
		if (_ownDefaultValueFunctionCallDeclarationPanel == null) {
			_ownDefaultValueFunctionCallDeclarationPanel = new OwnDefaultValueFunctionCallDeclarationPanel();
			_ownDefaultValueFunctionCallDeclarationPanel.setName(
				"OwnDefaultValueFunctionCallDeclarationPanel1");
		}
		return _ownDefaultValueFunctionCallDeclarationPanel;
	}

	private void initialize() {
		setLayout(new java.awt.GridBagLayout());

		java.awt.GridBagConstraints constraintsOwnDefaultValueFunctionCallDeclarationPanel =
			new java.awt.GridBagConstraints();
		constraintsOwnDefaultValueFunctionCallDeclarationPanel.gridx = 0;
		constraintsOwnDefaultValueFunctionCallDeclarationPanel.gridy = 1;
		constraintsOwnDefaultValueFunctionCallDeclarationPanel.gridwidth = 4;
		constraintsOwnDefaultValueFunctionCallDeclarationPanel.fill = java.awt.GridBagConstraints.BOTH;
		constraintsOwnDefaultValueFunctionCallDeclarationPanel.weightx = 1.0;
		constraintsOwnDefaultValueFunctionCallDeclarationPanel.weighty = 1.0;
		constraintsOwnDefaultValueFunctionCallDeclarationPanel.insets = new java.awt.Insets(4, 0, 0, 0);
		add(
			getOwnDefaultValueFunctionCallDeclarationPanel(),
			constraintsOwnDefaultValueFunctionCallDeclarationPanel);

		java.awt.GridBagConstraints constraintsJButtonEditBodyVar = new java.awt.GridBagConstraints();
		constraintsJButtonEditBodyVar.gridx = 2;
		constraintsJButtonEditBodyVar.gridy = 0;
		constraintsJButtonEditBodyVar.anchor = java.awt.GridBagConstraints.WEST;
		constraintsJButtonEditBodyVar.insets = new java.awt.Insets(0, 7, 0, 4);
		add(getJButtonEditBodyVar(), constraintsJButtonEditBodyVar);

		java.awt.GridBagConstraints constraintsJLabel1 = new java.awt.GridBagConstraints();
		constraintsJLabel1.gridx = 0;
		constraintsJLabel1.gridy = 0;
		constraintsJLabel1.insets = new java.awt.Insets(0, 0, 0, 4);
		add(getJLabelDefaultValue(), constraintsJLabel1);

		java.awt.GridBagConstraints constraintsJTextFieldDefaultValue = new java.awt.GridBagConstraints();
		constraintsJTextFieldDefaultValue.gridx = 1;
		constraintsJTextFieldDefaultValue.gridy = 0;
		constraintsJTextFieldDefaultValue.fill = java.awt.GridBagConstraints.HORIZONTAL;
		constraintsJTextFieldDefaultValue.weightx = 1.0;
		add(getJTextFieldDefaultValue(), constraintsJTextFieldDefaultValue);

		setExpertFilterUserFeatureFunctionDeclarationListAble(
			new ExpertFilterUserFeatureFunctionDeclarationListAble());
		setEnabled(true);
	}

	public boolean isEditable() {
		return _editable;
	}

	public void setBodyFeatureVariableClassDeclaration(IBodyFeatureVariableClassDeclaration newValue) {
		IBodyFeatureVariableClassDeclaration oldValue = getBodyFeatureVariableClassDeclaration();

		if (oldValue != newValue) {

			if (oldValue != null) {
				oldValue.removeChangeListener(_variableChangeListener);
			}

			_bodyFeatureVariableClassDeclaration = newValue;

			if (newValue != null) {
				newValue.addChangeListener(_variableChangeListener);
			}

			getOwnDefaultValueFunctionCallDeclarationPanel().setOwnDefaultValueFunctionCallDeclarationAble(
				getBodyFeatureVariableClassDeclaration());
			updateDefaultValueText();

			firePropertyChange("bodyFeatureVariableClassDeclaration", oldValue, newValue);
		}
	}

	public void setDeclaration(IDeclaration declaration) {
		setBodyFeatureVariableClassDeclaration((IBodyFeatureVariableClassDeclaration)declaration);
	}

	public void setEditable(boolean newIsEditable) {
		_editable = newIsEditable;

		setEnabled(newIsEditable && isEnabled());
	}

	public void setEnabled(boolean newValue) {
		super.setEnabled(newValue);

		getOwnDefaultValueFunctionCallDeclarationPanel().setEnabled(newValue);
	}

	public void setExpertFilterUserFeatureFunctionDeclarationListAble(ExpertFilterUserFeatureFunctionDeclarationListAble expertFilterUserFeatureFunctionDeclarationListAble) {
		getOwnDefaultValueFunctionCallDeclarationPanel().setExpertFilterFunctionDeclarationListAble(
			expertFilterUserFeatureFunctionDeclarationListAble);
	}

	public void setGUISeSAmDeclaration(IGUISeSAmDeclaration guiSeSAmDeclaration) {
		super.setGUISeSAmDeclaration(guiSeSAmDeclaration);

		getOwnDefaultValueFunctionCallDeclarationPanel().setGUISeSAmDeclaration(guiSeSAmDeclaration);
	}

	public void setOuterFunctionArgumentDeclarationList(IFunctionArgumentDeclarationList functionArgumentDeclarationList) {
		getOwnDefaultValueFunctionCallDeclarationPanel().setOuterFunctionArgumentDeclarationList(
			functionArgumentDeclarationList);
	}

	protected void eventEditBodyVarButtonPressed() {
		if ((getGUISeSAmDeclaration() != null) && (getBodyFeatureVariableClassDeclaration() != null)) {

			IDeclarationPanelFactory bodyVarDeclarationPanelFactory = new AbstractDeclarationPanelFactory() {
				public IDeclarationPanel createDeclarationPanel(IDeclaration declaration) {
					VariableClassDeclarationPanel variableClassDeclarationPanel =
						new VariableClassDeclarationPanel();

					variableClassDeclarationPanel.setGUISeSAmDeclaration(getGUISeSAmDeclaration());

					ExpertFilterUserFeatureFunctionDeclarationListAble declarationListAble =
						(ExpertFilterUserFeatureFunctionDeclarationListAble)getExpertFilterUserFeatureFunctionDeclarationListAble()
							.copy(
							new HashMap());

					declarationListAble.setObjectClassDeclaration(null);
					declarationListAble.setUserFeatureClassDeclaration(
						searchUserFeatureClassDeclaration(
							(IFeatureVariableClassDeclaration)getBodyFeatureVariableClassDeclaration()
								.getVariableClassDeclaration()));

					variableClassDeclarationPanel.setExpertFilterFunctionDeclarationListAble(
						declarationListAble);

					return variableClassDeclarationPanel;
				}

				public String getDeclarationTitle(IDeclaration declaration) {
					return "Edit Variable";
				}
			};

			getGUISeSAmDeclaration().getFrameFactory().addPanel(
				this,
				getBodyFeatureVariableClassDeclaration().getVariableClassDeclaration(),
				bodyVarDeclarationPanelFactory,
				true,
				true);
		}
	}

	private IUserFeatureClassDeclaration searchUserFeatureClassDeclaration(IFeatureVariableClassDeclaration featureVariableClassDeclaration) {

		Iterator it =
			getGUISeSAmDeclaration()
				.getSeSAmModelDeclaration()
				.getSeSAmModelBasicsDeclaration()
				.getUserFeatureClassDeclarationListAndFactory()
				.getDeclarationList()
				.iterator();

		while (it.hasNext()) {
			IUserFeatureClassDeclaration userFeatureClassDeclaration =
				(IUserFeatureClassDeclaration)it.next();

			if (userFeatureClassDeclaration
				.getFeatureVariableClassDeclarationListAndFactory()
				.getDeclarationList()
				.contains(featureVariableClassDeclaration)) {
				return userFeatureClassDeclaration;
			}
		}

		return null;
	}

	protected void updateDefaultValueText() {
		if (getBodyFeatureVariableClassDeclaration() == null) {
			getJTextFieldDefaultValue().setText("");

		} else {
			IFeatureVariableClassDeclaration featureVariableClassDeclaration =
				(IFeatureVariableClassDeclaration)getBodyFeatureVariableClassDeclaration()
					.getVariableClassDeclaration();

			String name = featureVariableClassDeclaration.getDefaultValueFunctionCallDeclaration().getName();

			getJTextFieldDefaultValue().setText(name);
			getJTextFieldDefaultValue().setToolTipText(name);
		}
	}
}