package de.uniwue.ki.gui.mas.entity.variableclass;
import de.uniwue.ki.gui.mas.util.declaration.DeclarationListPanel;
import de.uniwue.ki.gui.mas.util.declaration.IDeclarationPanel;
import de.uniwue.ki.gui.util.dnd.ObjectDataFlavor;
import de.uniwue.ki.mas.entity.objectclass.IObjectClassDeclaration;
import de.uniwue.ki.mas.entity.variableclass.*;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: (13.12.2000 18:26:47)
 * @author Christoph Oechslein
 */
public class BodyVariableClassDeclarationListPanel extends DeclarationListPanel {
	private IObjectClassDeclaration _objectClassDeclaration;

	public BodyVariableClassDeclarationListPanel() {
		super();
		initialize();
	}

	protected IDeclarationPanel createDeclarationPanel(IDeclaration declaration) {
		BodyVariableOrBodyFeatureVariableClassDeclarationPanel bodyVariableOrBodyFeatureVariableClassDeclarationPanel =
			new BodyVariableOrBodyFeatureVariableClassDeclarationPanel();

		bodyVariableOrBodyFeatureVariableClassDeclarationPanel
			.getExpertFilterUserFeatureFunctionDeclarationListAble()
			.setObjectClassDeclaration(getObjectClassDeclaration());

		return bodyVariableOrBodyFeatureVariableClassDeclarationPanel;
	}

	public IObjectClassDeclaration getObjectClassDeclaration() {
		return _objectClassDeclaration;
	}

	protected String getDeclarationFrameTitle(IDeclaration declaration) {
		return "Body Variable";
	}

	private void initialize() {
		setDeclarationFactory(new BodyVariableClassDeclarationFactory());
		setDeclarationListModel(new BodyVariableClassDeclarationList());

		enableDnDSupport(ObjectDataFlavor.getDataFlavor(IBodyVariableClassDeclaration.class));
		setArrowsAvailible(true);
	}

	public void setObjectClassDeclaration(IObjectClassDeclaration newObjectClassDeclaration) {
		_objectClassDeclaration = newObjectClassDeclaration;
	}
}