package de.uniwue.ki.gui.mas.entity.variableclass;
import de.uniwue.ki.gui.mas.basics.functionCall.IExpertFilterFunctionDeclarationListAble;
import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.util.declaration.AbstractDeclarationPanel;
import de.uniwue.ki.mas.basics.functionArgument.IFunctionArgumentDeclarationList;
import de.uniwue.ki.mas.entity.objectclass.IObjectClassDeclaration;
import de.uniwue.ki.mas.entity.variableclass.IBodyVariableClassDeclaration;
import de.uniwue.ki.mas.util.declaration.IDeclaration;
/**
 * Creation date: (20.06.00 20:00:58)
 * @author Christoph Oechslein
 */
public class BodyVariableClassDeclarationPanel extends AbstractDeclarationPanel {

	private IBodyVariableClassDeclaration _bodyVariableClassDeclarationIntern = null;
	private VariableClassDeclarationPanel _variableDeclarationPanel = null;

	public BodyVariableClassDeclarationPanel() {
		super();
		initialize();
	}

	public void dispose() {
		getVariableDeclarationPanel().dispose();

		super.dispose();
	}

	public IBodyVariableClassDeclaration getBodyVariableClassDeclaration() {
		return _bodyVariableClassDeclarationIntern;
	}

	public IDeclaration getDeclaration() {
		return getBodyVariableClassDeclaration();
	}

	private VariableClassDeclarationPanel getVariableDeclarationPanel() {
		if (_variableDeclarationPanel == null) {
			_variableDeclarationPanel = new VariableClassDeclarationPanel();
			_variableDeclarationPanel.setName("VariableDeclarationPanel");
		}
		return _variableDeclarationPanel;
	}

	private void initialize() {
		setLayout(new javax.swing.BoxLayout(this, javax.swing.BoxLayout.X_AXIS));
		setEnabled(true);
		add(getVariableDeclarationPanel(), getVariableDeclarationPanel().getName());
	}

	public boolean isEditable() {
		return getVariableDeclarationPanel().isEditable();
	}

	public void setBodyVariableClassDeclaration(IBodyVariableClassDeclaration newValue) {

		IBodyVariableClassDeclaration oldValue = getBodyVariableClassDeclaration();

		if (oldValue != newValue) {
			_bodyVariableClassDeclarationIntern = newValue;

			if (getBodyVariableClassDeclaration() != null)
				getVariableDeclarationPanel().setVariableClassDeclaration(
					getBodyVariableClassDeclaration().getVariableClassDeclaration());

			firePropertyChange("bodyVariableClassDeclaration", oldValue, newValue);
		}
	}

	public void setDeclaration(IDeclaration declaration) {
		setBodyVariableClassDeclaration((IBodyVariableClassDeclaration)declaration);
	}

	public void setEditable(boolean newEditable) {
		getVariableDeclarationPanel().setEditable(newEditable);
	}

	public void setEnabled(boolean newValue) {
		if (newValue != isEnabled()) {
			super.setEnabled(newValue);

			getVariableDeclarationPanel().setEnabled(newValue);
		}
	}

	public IFunctionArgumentDeclarationList getOuterFunctionArgumentDeclarationList() {
		return getVariableDeclarationPanel().getOuterFunctionArgumentDeclarationList();
	}

	public void setOuterFunctionArgumentDeclarationList(IFunctionArgumentDeclarationList functionArgumentDeclarationList) {
		getVariableDeclarationPanel().setOuterFunctionArgumentDeclarationList(
			functionArgumentDeclarationList);
	}

	public IExpertFilterFunctionDeclarationListAble getExpertFilterFunctionDeclarationListAble() {
		return getVariableDeclarationPanel().getExpertFilterFunctionDeclarationListAble();
	}
	
	public void setObjectClassDeclaration(IObjectClassDeclaration declaration) {
		getVariableDeclarationPanel().setObjectClassDeclaration(declaration);
	}

	public void setExpertFilterFunctionDeclarationListAble(IExpertFilterFunctionDeclarationListAble expertFilterFunctionDeclarationListAble) {
		getVariableDeclarationPanel().setExpertFilterFunctionDeclarationListAble(
			expertFilterFunctionDeclarationListAble);
	}

	public void setGUISeSAmDeclaration(IGUISeSAmDeclaration guiSeSAmDeclaration) {
		super.setGUISeSAmDeclaration(guiSeSAmDeclaration);

		getVariableDeclarationPanel().setGUISeSAmDeclaration(guiSeSAmDeclaration);
	}
}