package de.uniwue.ki.gui.mas.entity.variableclass;
import java.awt.CardLayout;

import junit.framework.Assert;
import de.uniwue.ki.gui.mas.basics.functionCall.ExpertFilterUserFeatureFunctionDeclarationListAble;
import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.util.declaration.AbstractDeclarationPanel;
import de.uniwue.ki.mas.basics.functionArgument.IFunctionArgumentDeclarationList;
import de.uniwue.ki.mas.entity.objectclass.IObjectClassDeclaration;
import de.uniwue.ki.mas.entity.variableclass.IBodyFeatureVariableClassDeclaration;
import de.uniwue.ki.mas.entity.variableclass.IBodyVariableClassDeclaration;
import de.uniwue.ki.mas.util.declaration.IDeclaration;
/**
 * Creation date: (03.12.2001 11:07:34)
 * @author Christoph Oechslein
 */
public class BodyVariableOrBodyFeatureVariableClassDeclarationPanel extends AbstractDeclarationPanel {
	private BodyFeatureVariableClassDeclarationPanel _bodyFeatureVariableClassDeclarationPanel = null;
	private IBodyVariableClassDeclaration _bodyVariableClassDeclarationIntern = null;
	private BodyVariableClassDeclarationPanel _bodyVariableClassDeclarationPanel = null;

	public BodyVariableOrBodyFeatureVariableClassDeclarationPanel() {
		super();
		initialize();
	}

	public void dispose() {
		setBodyVariableClassDeclaration(null);

		getBodyVariableClassDeclarationPanel().dispose();
		getBodyFeatureVariableClassDeclarationPanel().dispose();

		super.dispose();
	}

	protected void eventBodyVariableClassDeclarationChanged() {
		if (getBodyVariableClassDeclaration() instanceof IBodyFeatureVariableClassDeclaration) {
			getBodyFeatureVariableClassDeclarationPanel().setBodyFeatureVariableClassDeclaration(
				(IBodyFeatureVariableClassDeclaration)getBodyVariableClassDeclaration());

			((CardLayout)getLayout()).show(this, getBodyFeatureVariableClassDeclarationPanel().getName());

		} else if (getBodyVariableClassDeclaration() != null) {
			getBodyVariableClassDeclarationPanel().setBodyVariableClassDeclaration(
				getBodyVariableClassDeclaration());

			((CardLayout)getLayout()).show(this, getBodyVariableClassDeclarationPanel().getName());
		}
	}

	private BodyFeatureVariableClassDeclarationPanel getBodyFeatureVariableClassDeclarationPanel() {
		if (_bodyFeatureVariableClassDeclarationPanel == null) {
			_bodyFeatureVariableClassDeclarationPanel = new BodyFeatureVariableClassDeclarationPanel();
			_bodyFeatureVariableClassDeclarationPanel.setName("BodyFeatureVariableClassDeclarationPanel");
		}
		return _bodyFeatureVariableClassDeclarationPanel;
	}

	public IBodyVariableClassDeclaration getBodyVariableClassDeclaration() {
		return _bodyVariableClassDeclarationIntern;
	}

	private BodyVariableClassDeclarationPanel getBodyVariableClassDeclarationPanel() {
		if (_bodyVariableClassDeclarationPanel == null) {
			_bodyVariableClassDeclarationPanel = new BodyVariableClassDeclarationPanel();
			_bodyVariableClassDeclarationPanel.setName("BodyVariableClassDeclarationPanel");
		}
		return _bodyVariableClassDeclarationPanel;
	}

	public IDeclaration getDeclaration() {
		return getBodyVariableClassDeclaration();
	}

	public ExpertFilterUserFeatureFunctionDeclarationListAble getExpertFilterUserFeatureFunctionDeclarationListAble() {
		Assert.assertSame(
			getBodyFeatureVariableClassDeclarationPanel()
				.getExpertFilterUserFeatureFunctionDeclarationListAble(),
			getBodyVariableClassDeclarationPanel().getExpertFilterFunctionDeclarationListAble());

		return getBodyFeatureVariableClassDeclarationPanel()
			.getExpertFilterUserFeatureFunctionDeclarationListAble();
	}
	
	public void setObjectClassDeclaration(IObjectClassDeclaration declaration){
		getBodyFeatureVariableClassDeclarationPanel().getExpertFilterUserFeatureFunctionDeclarationListAble().setObjectClassDeclaration(declaration);
		getBodyVariableClassDeclarationPanel().setObjectClassDeclaration(declaration);
	}

	public void setExpertFilterUserFeatureFunctionDeclarationListAble(ExpertFilterUserFeatureFunctionDeclarationListAble expertFilterUserFeatureFunctionDeclarationListAble) {
		getBodyFeatureVariableClassDeclarationPanel().setExpertFilterUserFeatureFunctionDeclarationListAble(
			expertFilterUserFeatureFunctionDeclarationListAble);
		getBodyVariableClassDeclarationPanel().setExpertFilterFunctionDeclarationListAble(
			expertFilterUserFeatureFunctionDeclarationListAble);
	}

	public IFunctionArgumentDeclarationList getOuterFunctionArgumentDeclarationList() {
		Assert.assertSame(
			getBodyFeatureVariableClassDeclarationPanel().getOuterFunctionArgumentDeclarationList(),
			getBodyVariableClassDeclarationPanel().getOuterFunctionArgumentDeclarationList());
		return getBodyFeatureVariableClassDeclarationPanel().getOuterFunctionArgumentDeclarationList();
	}

	private void initialize() {
		setLayout(new CardLayout());
		add(getBodyVariableClassDeclarationPanel(), getBodyVariableClassDeclarationPanel().getName());
		add(
			getBodyFeatureVariableClassDeclarationPanel(),
			getBodyFeatureVariableClassDeclarationPanel().getName());

		setExpertFilterUserFeatureFunctionDeclarationListAble(
			new ExpertFilterUserFeatureFunctionDeclarationListAble());
	}

	public boolean isEditable() {
		return getBodyVariableClassDeclarationPanel().isEditable();
	}

	public void setBodyVariableClassDeclaration(IBodyVariableClassDeclaration newValue) {
		IBodyVariableClassDeclaration oldValue = getBodyVariableClassDeclaration();
		if (oldValue != newValue) {
			_bodyVariableClassDeclarationIntern = newValue;
			eventBodyVariableClassDeclarationChanged();
			firePropertyChange("bodyVariableClassDeclaration", oldValue, newValue);
		}
	}

	public void setDeclaration(IDeclaration declaration) {
		setBodyVariableClassDeclaration((IBodyVariableClassDeclaration)declaration);
	}

	public void setEditable(boolean newEditable) {
		getBodyVariableClassDeclarationPanel().setEditable(newEditable);
		getBodyFeatureVariableClassDeclarationPanel().setEditable(newEditable);
	}

	public void setGUISeSAmDeclaration(IGUISeSAmDeclaration guiSeSAmDeclaration) {
		super.setGUISeSAmDeclaration(guiSeSAmDeclaration);

		getBodyFeatureVariableClassDeclarationPanel().setGUISeSAmDeclaration(guiSeSAmDeclaration);
		getBodyVariableClassDeclarationPanel().setGUISeSAmDeclaration(guiSeSAmDeclaration);
	}

	public void setOuterFunctionArgumentDeclarationList(IFunctionArgumentDeclarationList functionArgumentDeclarationList) {
		getBodyFeatureVariableClassDeclarationPanel().setOuterFunctionArgumentDeclarationList(
			functionArgumentDeclarationList);
		getBodyVariableClassDeclarationPanel().setOuterFunctionArgumentDeclarationList(
			functionArgumentDeclarationList);
	}
}