package de.uniwue.ki.gui.mas.entity.variableclass;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import de.uniwue.ki.gui.mas.util.declaration.DeclarationListPanel;
import de.uniwue.ki.gui.mas.util.declaration.IDeclarationPanel;
import de.uniwue.ki.gui.util.dnd.ObjectDataFlavor;
import de.uniwue.ki.mas.entity.variableclass.*;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: (13.12.2000 18:26:47)
 * @author Christoph Oechslein
 */
public class VariableClassDeclarationListPanel extends DeclarationListPanel {

	/**
	 * UserDefinedFunctionDeclarationListPanel constructor comment.
	 */
	public VariableClassDeclarationListPanel() {
		super();
		initialize();
	}

	protected IDeclarationPanel createDeclarationPanel(IDeclaration declaration) {
		IDeclarationPanel declarationPanel = new VariableClassDeclarationPanel();

		return declarationPanel;
	}

	protected String getDeclarationFrameTitle(IDeclaration declaration) {
		return "Variable";
	}

	private void handleException(Throwable exception) {
		exception.printStackTrace(System.out);
	}

	/**
	 * Initialize the class.
	 */
	private void initialize() {
		try {
					setName("VariableClassDeclarationListPanel");
			setDeclarationFactory(new VariableClassDeclarationFactory());
			setSize(259, 160);
			setDeclarationListModel(new VariableClassDeclarationList());
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
		enableDnDSupport(ObjectDataFlavor.getDataFlavor(IVariableClassDeclaration.class));
		setCellRenderer(new VariableClassDeclarationCellRendererAdapter(getCellRenderer()));
	}

	public static void main(String[] args) {
		try {
			javax.swing.JFrame frame = new javax.swing.JFrame();
			VariableClassDeclarationListPanel aVariableClassDeclarationListPanel;
			aVariableClassDeclarationListPanel = new VariableClassDeclarationListPanel();
			frame.setContentPane(aVariableClassDeclarationListPanel);
			frame.setSize(aVariableClassDeclarationListPanel.getSize());
			frame.addWindowListener(new WindowAdapter() {
				public void windowClosing(WindowEvent e) {
					System.exit(0);
				}
			});
			frame.show();
			java.awt.Insets insets = frame.getInsets();
			frame.setSize(
				frame.getWidth() + insets.left + insets.right,
				frame.getHeight() + insets.top + insets.bottom);
			frame.setVisible(true);
		} catch (Throwable exception) {
			System.err.println(
				"Exception occurred in main() of de.uniwue.ki.gui.mas.model.entity.variableclass.VariableClassDeclarationListPanel");
			exception.printStackTrace(System.out);
		}
	}
}