package de.uniwue.ki.gui.mas.entity.variableclass;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.Iterator;
import java.util.List;

import javax.swing.BoxLayout;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JSeparator;
import javax.swing.JTabbedPane;

import com.ibm.easyswing.BoundJCheckBox;
import com.magelang.box.VerticalStrut;

import de.uniwue.ki.gui.mas.basics.functionCall.FunctionCallDeclarationTreeListPanel;
import de.uniwue.ki.gui.mas.basics.functionCall.IExpertFilterFunctionDeclarationListAble;
import de.uniwue.ki.gui.mas.basics.type.SpecificTypeDefinePanelWithName;
import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.util.declaration.AbstractDeclarationPanel;
import de.uniwue.ki.gui.mas.util.declaration.NameDeclarationWithDocumentationPanel;
import de.uniwue.ki.mas.basics.functionArgument.IFunctionArgumentDeclarationList;
import de.uniwue.ki.mas.basics.type.TypeManager;
import de.uniwue.ki.mas.entity.objectclass.IObjectClassDeclaration;
import de.uniwue.ki.mas.entity.variableclass.IVariableClassDeclaration;
import de.uniwue.ki.mas.util.declaration.IDeclaration;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Creation date: (20.06.00 19:29:46)
 * 
 * @author Christoph Oechslein
 */
public class VariableClassDeclarationPanel extends AbstractDeclarationPanel {
	private BoundJCheckBox ivjExternalJCheckBox = null;
	private BoundJCheckBox ivjWriteableJCheckBox = null;
	private boolean ivjConnPtoP2Aligning = false;
	private final IvjEventHandler ivjEventHandler = new IvjEventHandler();
	private FunctionCallDeclarationTreeListPanel ivjFunctionCallDeclarationTreeListPanel = null;
	private SpecificTypeDefinePanelWithName ivjSpecificArgumentDefinePanel = null;
	private boolean ivjConnPtoP5Aligning = false;
	private boolean ivjConnPtoP4Aligning = false;
	private JPanel ivjSettingsPanel = null;
	private IVariableClassDeclaration ivjVariableClassDeclarationIntern = null;
	private FunctionCallDeclarationTreeListPanel ivjNextValueFunctionCallDeclarationPanel = null;
	private JPanel ivjJPanelNextValue = null;
	private JPanel ivjJPanelStartValue = null;
	private JPanel ivjJPanelSettings = null;
	private JTabbedPane ivjJTabbedPaneValues = null;
	private BoundJCheckBox ivjJCheckBoxHasNextValue = null;
	private boolean ivjConnPtoP3Aligning = false;
	private NameDeclarationWithDocumentationPanel ivjNameDeclarationWithDocumentationPanel1 = null;
	private boolean fieldEditable = true;
	private BoundJCheckBox ivjNamePartJCheckBox;
	private boolean ivjConnNamePartAligning;
	private boolean ivjConnNamePart2Aligning;

	private final class IvjEventHandler
			implements
				ItemListener,
				java.beans.PropertyChangeListener {
		public void itemStateChanged(ItemEvent e) {
			if (e.getSource() == VariableClassDeclarationPanel.this
					.getJCheckBoxHasNextValue())
				connEtoC1(e);
		}
		public void propertyChange(java.beans.PropertyChangeEvent evt) {
			if (evt.getSource() == VariableClassDeclarationPanel.this
					.getVariableClassDeclarationIntern()) {
				connPtoP2SetTarget();
				connNamePartSetTarget();
				connPtoP3SetTarget();
				connPtoP4SetTarget();
				connPtoP5SetTarget();
			}
			if (evt.getSource() == getWriteableCheckBox()
					&& (evt.getPropertyName().equals("selected")))
				connWriteableSetSource();
			if (evt.getSource() == getNameParCheckBox()
					&& (evt.getPropertyName().equals("selected")))
				connNamePartSetSource();
			if (evt.getSource() == getExternalJCheckBox()
					&& (evt.getPropertyName().equals("selected")))
				connExternalSetSource();
			if (evt.getSource() == getSpecificArgumentDefinePanel()
					&& (evt.getPropertyName().equals("specificType")))
				connSpecificTypeSetSource();
			if (evt.getSource() == getJCheckBoxHasNextValue()
					&& (evt.getPropertyName().equals("selected")))
				connPtoP11SetSource();
			if (evt.getSource() == VariableClassDeclarationPanel.this
					&& (evt.getPropertyName().equals("gUISeSAmDeclaration")))
				connGUIDeclSetTarget();

			if (evt.getSource() == VariableClassDeclarationPanel.this
					.getNextValueFunctionCallDeclarationPanel()
					&& (evt.getPropertyName().equals("objectClassDeclaration")))
				;
			if (evt.getSource() == VariableClassDeclarationPanel.this
					.getFunctionCallDeclarationTreeListPanel()
					&& (evt.getPropertyName().equals("objectClassDeclaration")))
				connEtoC2(evt);

		}
	}

	public VariableClassDeclarationPanel() {
		super();
		initialize();
	}

	private void connEtoC1(ItemEvent arg1) {
		try {
			this.eventNextValueStateChanged();
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	private void connEtoC2(java.beans.PropertyChangeEvent arg1) {
		try {
			this.firePropertyChange("objectClassDeclaration", arg1
					.getOldValue(), arg1.getNewValue());
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	private void connPtoP10SetTarget() {
		try {
			if ((getVariableClassDeclarationIntern() != null)) {
				getNextValueFunctionCallDeclarationPanel()
						.setFunctionCallDeclaration(
								getVariableClassDeclarationIntern()
										.getNextValueFunctionCallDeclaration());
			}
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	private void connPtoP11SetSource() {
		try {
			if ((getVariableClassDeclarationIntern() != null)) {
				getVariableClassDeclarationIntern()
						.setHasNextValueFunctionCallDeclaration(
								getJCheckBoxHasNextValue().isSelected());
			}
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	/**
	 * connPtoP11SetTarget:
	 * (VariableClassDeclarationIntern.hasNextValueFunctionCallDeclaration <-->
	 * HasNextValueJCheckBox.selected)
	 */
	private void connPtoP11SetTarget() {
		try {
			if ((getVariableClassDeclarationIntern() != null)) {
				getJCheckBoxHasNextValue().setSelected(
						getVariableClassDeclarationIntern()
								.getHasNextValueFunctionCallDeclaration());
			}
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	/**
	 * connPtoP12SetTarget: (VariableClassDeclarationPanel.gUISeSAmDeclaration
	 * <-->NameDeclarationWithDocumentationPanel1.GUISeSAmDeclaration)
	 */
	private void connGUIDeclSetTarget() {
		try {
			getNameDeclarationWithDocumentationPanel1().setGUISeSAmDeclaration(
					this.getGUISeSAmDeclaration());
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	/**
	 * connPtoP2SetSource: (VariableClassDeclaration.writeable <-->
	 * WriteableJCheckBox1.selected)
	 */
	private void connWriteableSetSource() {
		try {
			if (ivjConnPtoP2Aligning == false) {
				ivjConnPtoP2Aligning = true;
				if ((getVariableClassDeclarationIntern() != null)) {
					getVariableClassDeclarationIntern().setWriteable(
							getWriteableCheckBox().isSelected());
				}
				ivjConnPtoP2Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP2Aligning = false;
			handleException(ivjExc);
		}
	}

	private void connNamePartSetSource() {
		try {
			if (ivjConnNamePartAligning == false) {
				ivjConnNamePartAligning = true;
				if ((getVariableClassDeclarationIntern() != null)) {
					getVariableClassDeclarationIntern().setPartOfName(
							getNameParCheckBox().isSelected());
				}
				ivjConnNamePartAligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnNamePartAligning = false;
			handleException(ivjExc);
		}
	}

	private void connPtoP2SetTarget() {
		try {
			if (ivjConnPtoP2Aligning == false) {
				ivjConnPtoP2Aligning = true;
				if ((getVariableClassDeclarationIntern() != null)) {
					getWriteableCheckBox().setSelected(
							getVariableClassDeclarationIntern().isWriteable());
				}
				ivjConnPtoP2Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP2Aligning = false;
			handleException(ivjExc);
		}
	}

	private void connNamePartSetTarget() {
		try {
			if (ivjConnNamePart2Aligning == false) {
				ivjConnNamePart2Aligning = true;
				if ((getVariableClassDeclarationIntern() != null)) {
					getNameParCheckBox().setSelected(
							getVariableClassDeclarationIntern().isPartOfName());
				}
				ivjConnNamePart2Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnNamePart2Aligning = false;
			handleException(ivjExc);
		}
	}

	/**
	 * connPtoP3SetSource: (VariableClassDeclaration.externalModifiable <-->
	 * ExternalJCheckBox1.selected)
	 */
	private void connExternalSetSource() {
		try {
			if (ivjConnPtoP3Aligning == false) {
				ivjConnPtoP3Aligning = true;
				if ((getVariableClassDeclarationIntern() != null)) {
					getVariableClassDeclarationIntern().setExternal(
							getExternalJCheckBox().isSelected());
				}
				ivjConnPtoP3Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP3Aligning = false;
			handleException(ivjExc);
		}
	}

	private void connPtoP3SetTarget() {
		try {
			if (ivjConnPtoP3Aligning == false) {
				ivjConnPtoP3Aligning = true;
				if ((getVariableClassDeclarationIntern() != null)) {
					getExternalJCheckBox().setSelected(
							getVariableClassDeclarationIntern().isExternal());
				}
				ivjConnPtoP3Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP3Aligning = false;
			handleException(ivjExc);
		}
	}

	private void connSpecificTypeSetSource() {
		try {
			if (ivjConnPtoP4Aligning == false) {
				ivjConnPtoP4Aligning = true;
				if ((getVariableClassDeclarationIntern() != null)) {
					getVariableClassDeclarationIntern().setSpecificType(
							getSpecificArgumentDefinePanel().getSpecificType());
				}
				ivjConnPtoP4Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP4Aligning = false;
			handleException(ivjExc);
		}
	}

	/**
	 * connPtoP4SetTarget: (VariableClassDeclaration.argument <-->
	 * SpecificArgumentDefinePanel.argumentSpecific)
	 */
	private void connPtoP4SetTarget() {
		try {
			if (ivjConnPtoP4Aligning == false) {
				ivjConnPtoP4Aligning = true;
				if ((getVariableClassDeclarationIntern() != null)) {
					getSpecificArgumentDefinePanel().setSpecificType(
							getVariableClassDeclarationIntern()
									.getSpecificType());
				}
				ivjConnPtoP4Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP4Aligning = false;
			handleException(ivjExc);
		}
	}

	/**
	 * connPtoP5SetTarget: (VariableClassDeclaration.defaultValue <-->
	 * FunctionCallDeclarationTreeListPanel.functionCallDeclarationThis)
	 */
	private void connPtoP5SetTarget() {
		try {
			if (ivjConnPtoP5Aligning == false) {
				ivjConnPtoP5Aligning = true;
				if ((getVariableClassDeclarationIntern() != null)) {
					getFunctionCallDeclarationTreeListPanel()
							.setFunctionCallDeclaration(
									getVariableClassDeclarationIntern()
											.getDefaultValueFunctionCallDeclaration());
				}
				ivjConnPtoP5Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP5Aligning = false;
			handleException(ivjExc);
		}
	}

	/**
	 * connPtoP6SetTarget: (VariableClassDeclarationIntern.name <-->
	 * JTextField1.text)
	 */
	private void connPtoP6SetTarget() {
		try {
			if ((getVariableClassDeclarationIntern() != null)) {
				getNameDeclarationWithDocumentationPanel1().setDeclaration(
						getVariableClassDeclarationIntern());
			}
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	public void dispose() {
		setVariableClassDeclaration(null);

		getFunctionCallDeclarationTreeListPanel().dispose();
		getSpecificArgumentDefinePanel().dispose();
		getNextValueFunctionCallDeclarationPanel().dispose();
		getNameDeclarationWithDocumentationPanel1().dispose();

		super.dispose();
	}

	protected void eventNextValueStateChanged() {
		getNextValueFunctionCallDeclarationPanel().setEnabled(
				isEditable() && isEnabled()
						&& getJCheckBoxHasNextValue().isSelected());
	}

	/**
	 * getDeclaration method comment.
	 */
	public IDeclaration getDeclaration() {
		return getVariableClassDeclaration();
	}

	private BoundJCheckBox getExternalJCheckBox() {
		if (ivjExternalJCheckBox == null) {
			try {
				ivjExternalJCheckBox = new BoundJCheckBox();
				ivjExternalJCheckBox.setName("ExternalCheckBox");
				ivjExternalJCheckBox.setText("External");
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
			ivjExternalJCheckBox.setToolTipText("If this flag is set, other agents can see and access this attribute");
		}
		return ivjExternalJCheckBox;
	}

	/**
	 * Return the FunctionCallDeclarationTreeListPanel property value.
	 * 
	 * @return de.uniwue.ki.gui.mas.model.basics.functionCall.FunctionCallDeclarationTreeListPanelWithFeatureDecl
	 */
	private FunctionCallDeclarationTreeListPanel getFunctionCallDeclarationTreeListPanel() {
		if (ivjFunctionCallDeclarationTreeListPanel == null) {
			try {
				ivjFunctionCallDeclarationTreeListPanel = new FunctionCallDeclarationTreeListPanel();
				ivjFunctionCallDeclarationTreeListPanel
						.setName("FunctionCallDeclarationTreeListPanel");

				ivjFunctionCallDeclarationTreeListPanel
						.setExpertFilterFunctionDeclarationListAble(getExpertFilterFunctionDeclarationListAble());

			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjFunctionCallDeclarationTreeListPanel;
	}

	public IExpertFilterFunctionDeclarationListAble getExpertFilterFunctionDeclarationListAble() {
		return getFunctionCallDeclarationTreeListPanel()
				.getExpertFilterFunctionDeclarationListAble();
	}

	public IExpertFilterFunctionDeclarationListAble getNextValueExpertFilterFunctionDeclarationListAble() {
		return getNextValueFunctionCallDeclarationPanel()
				.getExpertFilterFunctionDeclarationListAble();
	}

	public void setObjectClassDeclaration(IObjectClassDeclaration declaration) {
		getFunctionCallDeclarationTreeListPanel()
				.getExpertFilterFunctionDeclarationListAble()
				.setObjectClassDeclaration(declaration);
		getNextValueFunctionCallDeclarationPanel()
				.getExpertFilterFunctionDeclarationListAble()
				.setObjectClassDeclaration(declaration);
	}

	public void setExpertFilterFunctionDeclarationListAble(
			IExpertFilterFunctionDeclarationListAble expertFilterFunctionDeclarationListAble) {
		getFunctionCallDeclarationTreeListPanel()
				.setExpertFilterFunctionDeclarationListAble(
						expertFilterFunctionDeclarationListAble);

		if (getGUISeSAmDeclaration() != null) {
			expertFilterFunctionDeclarationListAble
					.setSeSAmModelDeclaration(getGUISeSAmDeclaration()
							.getSeSAmModelDeclaration());
		}
	}

	/**
	 * Return the HasNextValueJCheckBox property value.
	 * 
	 * @return BoundJCheckBox
	 */
	private com.ibm.easyswing.BoundJCheckBox getJCheckBoxHasNextValue() {
		if (ivjJCheckBoxHasNextValue == null) {
			try {
				ivjJCheckBoxHasNextValue = new com.ibm.easyswing.BoundJCheckBox();
				ivjJCheckBoxHasNextValue.setName("JCheckBoxHasNextValue");
				ivjJCheckBoxHasNextValue.setText("Next Value:");
				ivjJCheckBoxHasNextValue
						.setForeground(new Color(102, 102, 153));
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjJCheckBoxHasNextValue;
	}

	private JPanel getCheckBoxPanel() {
		JPanel ivjCheckBoxPanel = new JPanel();
		ivjCheckBoxPanel.setName("JPanelButton");
		ivjCheckBoxPanel.setLayout(new BoxLayout(ivjCheckBoxPanel,
				BoxLayout.Y_AXIS));
		ivjCheckBoxPanel.add(getExternalJCheckBox(), getExternalJCheckBox()
				.getName());
		//ivjCheckBoxPanel.add(new VerticalStrut(3));
		ivjCheckBoxPanel.add(getWriteableCheckBox(), getWriteableCheckBox()
				.getName());
		ivjCheckBoxPanel.add(getNameParCheckBox(), getNameParCheckBox()
				.getName());
		return ivjCheckBoxPanel;
	}

	private JPanel getJPanelNextValue() {
		if (ivjJPanelNextValue == null) {
			try {
				ivjJPanelNextValue = new JPanel();
				ivjJPanelNextValue.setName("JPanelNextValue");
				ivjJPanelNextValue.setLayout(new GridBagLayout());

				GridBagConstraints constraintsJCheckBoxHasNextValue = new GridBagConstraints();
				constraintsJCheckBoxHasNextValue.gridx = 0;
				constraintsJCheckBoxHasNextValue.gridy = 0;
				constraintsJCheckBoxHasNextValue.anchor = GridBagConstraints.WEST;
				constraintsJCheckBoxHasNextValue.insets = new Insets(0, 4, 0, 0);
				getJPanelNextValue().add(getJCheckBoxHasNextValue(),
						constraintsJCheckBoxHasNextValue);

				GridBagConstraints constraintsNextValueFunctionCallDeclarationPanel = new GridBagConstraints();
				constraintsNextValueFunctionCallDeclarationPanel.gridx = 0;
				constraintsNextValueFunctionCallDeclarationPanel.gridy = 1;
				constraintsNextValueFunctionCallDeclarationPanel.gridwidth = 2;
				constraintsNextValueFunctionCallDeclarationPanel.fill = GridBagConstraints.BOTH;
				constraintsNextValueFunctionCallDeclarationPanel.anchor = GridBagConstraints.WEST;
				constraintsNextValueFunctionCallDeclarationPanel.weightx = 1.0;
				constraintsNextValueFunctionCallDeclarationPanel.weighty = 1.0;
				getJPanelNextValue().add(
						getNextValueFunctionCallDeclarationPanel(),
						constraintsNextValueFunctionCallDeclarationPanel);
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjJPanelNextValue;
	}

	/**
	 * Defines Specific Type of Variable and Buttons
	 *  
	 */
	private JPanel getJPanelSettings() {

		if (ivjJPanelSettings == null) {
			try {
				ivjJPanelSettings = new JPanel();
				ivjJPanelSettings.setName("JPanelSettings");
				ivjJPanelSettings.setLayout(new GridBagLayout());

				GridBagConstraints constraintsSpecificArgumentDefinePanel = new GridBagConstraints();
				constraintsSpecificArgumentDefinePanel.gridx = 0;
				constraintsSpecificArgumentDefinePanel.gridy = 0;
				constraintsSpecificArgumentDefinePanel.anchor = GridBagConstraints.NORTHWEST;
				getJPanelSettings().add(getSpecificArgumentDefinePanel(),
						constraintsSpecificArgumentDefinePanel);

				GridBagConstraints constraintsLinePanel3 = new GridBagConstraints();
				constraintsLinePanel3.gridx = 1;
				constraintsLinePanel3.gridy = 0;
				constraintsLinePanel3.fill = GridBagConstraints.VERTICAL;
				constraintsLinePanel3.insets = new Insets(0, 4, 0, 4);
				getJPanelSettings().add(new JSeparator(JSeparator.VERTICAL),
						constraintsLinePanel3);

				GridBagConstraints constraintsJPanelButton = new GridBagConstraints();
				constraintsJPanelButton.gridx = 2;
				constraintsJPanelButton.gridy = 0;
				constraintsJPanelButton.anchor = GridBagConstraints.NORTHWEST;
				constraintsJPanelButton.weightx = 1.0;
				constraintsJPanelButton.weighty = 1.0;
				getJPanelSettings().add(getCheckBoxPanel(),
						constraintsJPanelButton);
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjJPanelSettings;
	}

	/**
	 * Return the JPanelStartValue property value.
	 * 
	 * @return JPanel
	 */
	private JPanel getJPanelStartValue() {
		if (ivjJPanelStartValue == null) {
			try {
				ivjJPanelStartValue = new JPanel();
				ivjJPanelStartValue.setName("JPanelStartValue");
				ivjJPanelStartValue.setLayout(new javax.swing.BoxLayout(
						getJPanelStartValue(), javax.swing.BoxLayout.X_AXIS));
				getJPanelStartValue().add(
						getFunctionCallDeclarationTreeListPanel(),
						getFunctionCallDeclarationTreeListPanel().getName());
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjJPanelStartValue;
	}

	/**
	 * Return the JTabbedPaneValues property value.
	 * 
	 * @return javax.swing.JTabbedPane
	 */
	private javax.swing.JTabbedPane getJTabbedPaneValues() {
		if (ivjJTabbedPaneValues == null) {
			try {
				ivjJTabbedPaneValues = new javax.swing.JTabbedPane();
				ivjJTabbedPaneValues.setName("JTabbedPaneValues");
				ivjJTabbedPaneValues.insertTab("Start Value", null,
						getJPanelStartValue(), null, 0);
				ivjJTabbedPaneValues.insertTab("Next Value", null,
						getJPanelNextValue(), null, 1);
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjJTabbedPaneValues;
	}

	/**
	 * Return the NameDeclarationWithDocumentationPanel1 property value.
	 * 
	 * @return de.uniwue.ki.gui.mas.model.util.declaration.NameDeclarationWithDocumentationPanel
	 */
	private NameDeclarationWithDocumentationPanel getNameDeclarationWithDocumentationPanel1() {
		if (ivjNameDeclarationWithDocumentationPanel1 == null) {
			try {
				ivjNameDeclarationWithDocumentationPanel1 = new NameDeclarationWithDocumentationPanel();
				ivjNameDeclarationWithDocumentationPanel1
						.setName("NameDeclarationWithDocumentationPanel1");
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjNameDeclarationWithDocumentationPanel1;
	}

	/**
	 * Return the NextValueFunctionCallDeclarationPanel property value.
	 * 
	 * @return de.uniwue.ki.gui.mas.model.basics.functionCall.FunctionCallDeclarationTreeListPanelWithFeatureDecl
	 */
	private FunctionCallDeclarationTreeListPanel getNextValueFunctionCallDeclarationPanel() {
		if (ivjNextValueFunctionCallDeclarationPanel == null) {
			try {
				ivjNextValueFunctionCallDeclarationPanel = new FunctionCallDeclarationTreeListPanel();
				ivjNextValueFunctionCallDeclarationPanel
						.setName("NextValueFunctionCallDeclarationPanel");
				ivjNextValueFunctionCallDeclarationPanel
						.setPreferredSize(new Dimension(0, 0));
				ivjNextValueFunctionCallDeclarationPanel
						.setMinimumSize(new Dimension(0, 0));
				ivjNextValueFunctionCallDeclarationPanel.setEnabled(false);
				ivjNextValueFunctionCallDeclarationPanel
						.setExpertFilterFunctionDeclarationListAble(getNextValueExpertFilterFunctionDeclarationListAble());
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjNextValueFunctionCallDeclarationPanel;
	}

	/**
	 * Return the SettingsPanel property value.
	 * 
	 * @return JPanel
	 */
	private JPanel getSettingsPanel() {
		if (ivjSettingsPanel == null) {
			try {
				ivjSettingsPanel = new JPanel();
				ivjSettingsPanel.setName("SettingsPanel");
				ivjSettingsPanel.setLayout(new GridBagLayout());

				GridBagConstraints constraintsNameDeclarationWithDocumentationPanel1 = new GridBagConstraints();
				constraintsNameDeclarationWithDocumentationPanel1.gridx = 0;
				constraintsNameDeclarationWithDocumentationPanel1.gridy = 0;
				constraintsNameDeclarationWithDocumentationPanel1.fill = GridBagConstraints.BOTH;
				constraintsNameDeclarationWithDocumentationPanel1.weightx = 1.0;
				getSettingsPanel().add(
						getNameDeclarationWithDocumentationPanel1(),
						constraintsNameDeclarationWithDocumentationPanel1);

				GridBagConstraints constraintsJPanelSettings = new GridBagConstraints();
				constraintsJPanelSettings.gridx = 0;
				constraintsJPanelSettings.gridy = 1;
				constraintsJPanelSettings.fill = GridBagConstraints.BOTH;
				constraintsJPanelSettings.insets = new Insets(4, 0, 0, 0);
				getSettingsPanel().add(getJPanelSettings(),
						constraintsJPanelSettings);

				GridBagConstraints constraintsJTabbedPaneValues = new GridBagConstraints();
				constraintsJTabbedPaneValues.gridx = 0;
				constraintsJTabbedPaneValues.gridy = 2;
				constraintsJTabbedPaneValues.fill = GridBagConstraints.BOTH;
				constraintsJTabbedPaneValues.weightx = 1.0;
				constraintsJTabbedPaneValues.weighty = 1.0;
				getSettingsPanel().add(getJTabbedPaneValues(),
						constraintsJTabbedPaneValues);
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjSettingsPanel;
	}

	private SpecificTypeDefinePanelWithName getSpecificArgumentDefinePanel() {
		if (ivjSpecificArgumentDefinePanel == null) {
			try {
				ivjSpecificArgumentDefinePanel = new SpecificTypeDefinePanelWithName();
				ivjSpecificArgumentDefinePanel
						.setName("SpecificArgumentDefinePanel");
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjSpecificArgumentDefinePanel;
	}

	protected Iterator getTypeIteratorForSpecificArgumentDefinePanel() {
		if (getGUISeSAmDeclaration() != null)
			return getGUISeSAmDeclaration().getSeSAmModelDeclaration()
					.getAvailibleTypeListForVariableClassDeclaration()
					.iterator();
		else
			return TypeManager.getInstance()
					.getAllTypesForVariableClassDeclaration();
	}

	protected List getTypeListForSpecificArgumentDefinePanel() {
		if (getGUISeSAmDeclaration() != null)
			return CollectionsHelper.asLinkedList(getGUISeSAmDeclaration()
					.getSeSAmModelDeclaration()
					.getAvailibleTypeListForVariableClassDeclaration()
					.iterator());
		else
			return CollectionsHelper.asArrayList(TypeManager.getInstance()
					.getAllTypesForVariableClassDeclaration());
	}

	/**
	 * Method generated to support the promotion of the variableClassDeclaration
	 * attribute.
	 * 
	 * @return IVariableClassDeclaration
	 */
	public IVariableClassDeclaration getVariableClassDeclaration() {
		return getVariableClassDeclarationIntern();
	}

	/**
	 * Return the VariableDeclarationIntern property value.
	 * 
	 * @return IVariableClassDeclaration
	 */
	private IVariableClassDeclaration getVariableClassDeclarationIntern() {
		return ivjVariableClassDeclarationIntern;
	}

	private BoundJCheckBox getWriteableCheckBox() {
		if (ivjWriteableJCheckBox == null) {
			try {
				ivjWriteableJCheckBox = new BoundJCheckBox();
				ivjWriteableJCheckBox.setName("WriteableJCheckBox1");
				ivjWriteableJCheckBox.setText("Writeable");
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
			ivjWriteableJCheckBox.setToolTipText("If this flag is set, the attribute can be modified during simulation");
		}
		return ivjWriteableJCheckBox;
	}

	private BoundJCheckBox getNameParCheckBox() {
		if (ivjNamePartJCheckBox == null) {
			try {
				ivjNamePartJCheckBox = new BoundJCheckBox();
				ivjNamePartJCheckBox.setText("Part of name");
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
			ivjNamePartJCheckBox.setToolTipText("If this flag is set, this attribute will be part of displayed name for the agent during runtime. This does not affect the process of simulation!");
		}
		return ivjNamePartJCheckBox;
	}

	private void handleException(Throwable exception) {
		exception.printStackTrace(System.out);
	}

	/**
	 * Initializes connections
	 * 
	 * @exception Exception
	 *                     The exception description.
	 */
	private void initConnections() {
		getWriteableCheckBox().addPropertyChangeListener(ivjEventHandler);
		getNameParCheckBox().addPropertyChangeListener(ivjEventHandler);
		getExternalJCheckBox().addPropertyChangeListener(ivjEventHandler);
		getSpecificArgumentDefinePanel().addPropertyChangeListener(
				ivjEventHandler);
		getJCheckBoxHasNextValue().addPropertyChangeListener(ivjEventHandler);
		this.addPropertyChangeListener(ivjEventHandler);
		getFunctionCallDeclarationTreeListPanel().addPropertyChangeListener(
				ivjEventHandler);
		getNextValueFunctionCallDeclarationPanel().addPropertyChangeListener(
				ivjEventHandler);
		getJCheckBoxHasNextValue().addItemListener(ivjEventHandler);
		connPtoP2SetTarget();
		connPtoP3SetTarget();
		connPtoP4SetTarget();
		connPtoP11SetTarget();
		connPtoP6SetTarget();
		connGUIDeclSetTarget();
		connPtoP10SetTarget();
		connPtoP5SetTarget();
		connNamePartSetTarget();
	}

	/**
	 * Initialize the class.
	 */
	private void initialize() {
		try {
			setName("VariableDeclarationPanel");
			setLayout(new javax.swing.BoxLayout(this,
					javax.swing.BoxLayout.X_AXIS));
			setSize(573, 447);
			add(getSettingsPanel(), getSettingsPanel().getName());
			initConnections();
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
		getSpecificArgumentDefinePanel().setTypes(
				getTypeIteratorForSpecificArgumentDefinePanel());
	}

	/**
	 * Gets the editable property (boolean) value.
	 * 
	 * @return The editable property value.
	 * @see #setEditable
	 */
	public boolean isEditable() {
		return fieldEditable;
	}

	public static void main(String[] args) {
		try {
			JFrame frame = new javax.swing.JFrame();
			VariableClassDeclarationPanel aVariableClassDeclarationPanel;
			aVariableClassDeclarationPanel = new VariableClassDeclarationPanel();
			frame.setContentPane(aVariableClassDeclarationPanel);
			frame.setSize(aVariableClassDeclarationPanel.getSize());
			frame.addWindowListener(new WindowAdapter() {
				public void windowClosing(WindowEvent e) {
					System.exit(0);
				}
			});
			frame.setVisible(true);
		} catch (Throwable exception) {
			System.err.println("Exception occurred in main() of JPanel");
			exception.printStackTrace(System.out);
		}
	}

	/**
	 * setDeclaration method comment.
	 */
	public void setDeclaration(IDeclaration declaration) {
		setVariableClassDeclaration((IVariableClassDeclaration) declaration);
	}

	/**
	 * Sets the editable property (boolean) value.
	 * 
	 * @param editable
	 *                The new value for the property.
	 * @see #isEditable
	 */
	public void setEditable(boolean editable) {
		fieldEditable = editable;

		getNameDeclarationWithDocumentationPanel1().setEditable(editable);
		getNameDeclarationWithDocumentationPanel1().setEnabled(
				editable & isEnabled());

		if (getJCheckBoxHasNextValue() != null)
			getNextValueFunctionCallDeclarationPanel().setEnabled(
					editable && isEnabled()
							&& getJCheckBoxHasNextValue().isSelected());
		else
			getNextValueFunctionCallDeclarationPanel().setEnabled(
					editable && isEnabled());

		getSpecificArgumentDefinePanel().setEnabled(editable && isEnabled());
		getFunctionCallDeclarationTreeListPanel().setEnabled(
				editable && isEnabled());
		getJCheckBoxHasNextValue().setEnabled(editable && isEnabled());
		getExternalJCheckBox().setEnabled(editable && isEnabled());
		getWriteableCheckBox().setEnabled(editable && isEnabled());
		getNameParCheckBox().setEnabled(editable && isEnabled());
	}

	public void setEnabled(boolean isEnabled) {
		super.setEnabled(isEnabled);

		if (isEnabled) {
			getNextValueFunctionCallDeclarationPanel().setEnabled(
					getJCheckBoxHasNextValue().isSelected());
		} else {
			getNextValueFunctionCallDeclarationPanel().setEnabled(false);
		}

		setEditable(isEditable());
	}

	public void setGUISeSAmDeclaration(IGUISeSAmDeclaration guiSeSAmDeclaration) {
		super.setGUISeSAmDeclaration(guiSeSAmDeclaration);

		getFunctionCallDeclarationTreeListPanel().setGUISeSAmDeclaration(
				guiSeSAmDeclaration);
		getNextValueFunctionCallDeclarationPanel().setGUISeSAmDeclaration(
				guiSeSAmDeclaration);

		getSpecificArgumentDefinePanel().setGUISeSAmDeclaration(
				guiSeSAmDeclaration);

		if (guiSeSAmDeclaration != null)
			getSpecificArgumentDefinePanel().setTypes(
					getTypeIteratorForSpecificArgumentDefinePanel());
	}

	public void setVariableClassDeclaration(IVariableClassDeclaration arg1) {
		setVariableClassDeclarationIntern(arg1);
	}

	/**
	 * Set the VariableDeclarationIntern to a new value.
	 * 
	 * @param newValue
	 *                IVariableClassDeclaration
	 */
	private void setVariableClassDeclarationIntern(
			IVariableClassDeclaration newValue) {
		if (ivjVariableClassDeclarationIntern != newValue) {
			try {
				IVariableClassDeclaration oldValue = getVariableClassDeclarationIntern();
				/* Stop listening for events from the current object */
				if (ivjVariableClassDeclarationIntern != null) {
					ivjVariableClassDeclarationIntern
							.removePropertyChangeListener(ivjEventHandler);
				}
				ivjVariableClassDeclarationIntern = newValue;

				/* Listen for events from the new object */
				if (ivjVariableClassDeclarationIntern != null) {
					ivjVariableClassDeclarationIntern
							.addPropertyChangeListener(ivjEventHandler);
				}
				connPtoP2SetTarget();
				connPtoP3SetTarget();
				connPtoP4SetTarget();
				connPtoP11SetTarget();
				connPtoP6SetTarget();
				connPtoP10SetTarget();
				connPtoP5SetTarget();
				connNamePartSetTarget();
				firePropertyChange("variableClassDeclaration", oldValue,
						newValue);
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
	}

	public IFunctionArgumentDeclarationList getOuterFunctionArgumentDeclarationList() {
		return getFunctionCallDeclarationTreeListPanel()
				.getOuterFunctionArgumentDeclarationList();
	}

	public void setOuterFunctionArgumentDeclarationList(
			IFunctionArgumentDeclarationList functionArgumentDeclarationList) {
		getFunctionCallDeclarationTreeListPanel()
				.setOuterFunctionArgumentDeclarationList(
						functionArgumentDeclarationList);
	}
}