package de.uniwue.ki.gui.mas.model;
import java.awt.Container;

import javax.swing.Icon;

import de.uniwue.ki.gui.mas.util.declaration.IDeclarationPanelFactory;
import de.uniwue.ki.gui.util.actions.AbstractBoundAction;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: (10.10.2001 10:38:07)
 * @author Christoph Oechslein
 */
public abstract class AbstractDeclarationPanelAction extends AbstractBoundAction {
	private final IDeclaration _declaration;
	private final IDeclarationPanelFactory _declarationPanelFactory;
	private final Container _parent;
	private final boolean _shouldTheFrameBeShown, _shouldUseOkCancelDeclarationPanel;

	public AbstractDeclarationPanelAction(
		Container parent,
		String name,
		Icon icon,
		IDeclaration declaration,
		IDeclarationPanelFactory declarationPanelFactory) {
		this(parent, name, icon, declaration, declarationPanelFactory, true);
	}

	public AbstractDeclarationPanelAction(
		Container parent,
		String name,
		Icon icon,
		IDeclaration declaration,
		IDeclarationPanelFactory declarationPanelFactory,
		boolean shouldUseOkCancelDeclarationPanel) {

		this(
			parent,
			name,
			icon,
			declaration,
			declarationPanelFactory,
			true,
			shouldUseOkCancelDeclarationPanel);
	}

	public AbstractDeclarationPanelAction(
		Container parent,
		String name,
		Icon icon,
		IDeclaration declaration,
		IDeclarationPanelFactory declarationPanelFactory,
		boolean shouldTheFrameBeShown,
		boolean shouldUseOkCancelDeclarationPanel) {

		super(name, icon);

		_parent = parent;
		_declaration = declaration;
		_declarationPanelFactory = declarationPanelFactory;
		_shouldTheFrameBeShown = shouldTheFrameBeShown;
		_shouldUseOkCancelDeclarationPanel = shouldUseOkCancelDeclarationPanel;
	}

	public void doit() {
		GUISeSAmDeclaration.getDeclarationFrameFactory(getGUISeSAmDeclaration()).addPanel(
			_parent,
			_declaration,
			_declarationPanelFactory,
			_shouldTheFrameBeShown,
			_shouldUseOkCancelDeclarationPanel);
	}

	public abstract IGUISeSAmDeclaration getGUISeSAmDeclaration();
}