package de.uniwue.ki.gui.mas.model;
import java.awt.Component;
import java.awt.datatransfer.Clipboard;
import java.io.*;

import mygale.mcge.fig.IFigMapper;
import de.uniwue.ki.gui.mas.entity.variable.viewer.ObjectValueViewerManager;
import de.uniwue.ki.gui.mas.util.declaration.IDeclarationFrameFactory;
import de.uniwue.ki.mas.model.ISeSAmDeclaration;
import de.uniwue.ki.mas.model.ISeSAmModelDeclaration;
import de.uniwue.ki.mas.model.tree.ISeSAmDeclarationTreeModel;
import de.uniwue.ki.mas.sim.simulation.StartPauseFinishEvent;
import de.uniwue.ki.mas.util.declaration.IDeclaration;
import de.uniwue.ki.mas.xml.reader.XMLReadException;
import de.uniwue.ki.mas.xml.writer.XMLWriteException;

/**
 * Creation date: (26.06.2001 14:54:25)
 * @author Christoph Oechslein
 */
public interface IGUISeSAmDeclaration extends IDeclaration {

	Clipboard getClipboard();

	IFigMapper getFigMapper();

	IDeclarationFrameFactory getFrameFactory();

	PanelActionFactoryManager getPanelActionFactoryManager();

	ObjectValueViewerManager getObjectValueViewerManager();

	ISeSAmDeclaration getSeSAmDeclaration();

	ISeSAmDeclarationTreeModel getSeSAmDeclarationTreeModel();

	ISeSAmModelDeclaration getSeSAmModelDeclaration();

	void openModel(File file) throws XMLReadException, IOException;

	void openModel(Reader reader) throws XMLReadException, IOException;

	void saveModel(File file) throws XMLWriteException, IOException;

	void showException(StartPauseFinishEvent startPauseFinishEvent, Component onConponent);

	void showException(String title, Throwable exception, Component onConponent);

	void clear();
}