package de.uniwue.ki.gui.mas.model;
import java.awt.Component;

import javax.swing.BoxLayout;

import de.uniwue.ki.gui.mas.util.IFrameFactory;
import de.uniwue.ki.gui.mas.util.JFrameFactory;
import de.uniwue.ki.gui.util.*;
import de.uniwue.ki.util.Utils;

/**
 * Creation date: (27.06.2001 20:44:15)
 * @author Christoph Oechslein
 */
public class JPanelWithGUISeSAmDeclaration extends JDisposeablePanel implements IDisposeable {
	private IGUISeSAmDeclaration _guiSeSAmDeclaration;

	public JPanelWithGUISeSAmDeclaration() {
		super();

		setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
	}

	public static JPanelWithGUISeSAmDeclaration getLastPanelWithGUISeSAmDeclaration(JPanelWithGUISeSAmDeclaration declarationPanel) {
		if (declarationPanel == null) {
			return null;
		} else if (declarationPanel.getGUISeSAmDeclaration() != null) {
			return declarationPanel;
		} else {
			return getLastPanelWithGUISeSAmDeclaration(((java.awt.Component) declarationPanel).getParent());
		}
	}

	public static JPanelWithGUISeSAmDeclaration getLastPanelWithGUISeSAmDeclaration(
		Component comp) {
		if (comp == null) {
			return null;
		} else if (comp instanceof JPanelWithGUISeSAmDeclaration) {
			return getLastPanelWithGUISeSAmDeclaration((JPanelWithGUISeSAmDeclaration) comp);
		} else {
			return getLastPanelWithGUISeSAmDeclaration(comp.getParent());
		}
	}

	public void dispose() {
		setGUISeSAmDeclaration(null);

		super.dispose();
	}

	public IFrameFactory getFrameFactory() {
		if (getGUISeSAmDeclaration() != null)
			return getGUISeSAmDeclaration().getFrameFactory();
		else
			return JFrameFactory.getInstance();
	}

	public IGUISeSAmDeclaration getGUISeSAmDeclaration() {
		return _guiSeSAmDeclaration;
	}

	public void setEnabled(boolean isEnabled) {
		if (isEnabled() != isEnabled) {
			super.setEnabled(isEnabled);

			SwingMoreUtilities.setEnableAllComponentsRecursive(this, isEnabled);
		}
	}

	public void setGUISeSAmDeclaration(IGUISeSAmDeclaration guiSeSAmDeclaration) {
		if (!Utils.equals(guiSeSAmDeclaration, getGUISeSAmDeclaration())) {
			IGUISeSAmDeclaration oldGUISeSAmDeclaration = getGUISeSAmDeclaration();
			IFrameFactory oldFrameFactory = getFrameFactory();

			_guiSeSAmDeclaration = guiSeSAmDeclaration;

			firePropertyChange("gUISeSAmDeclaration", oldGUISeSAmDeclaration, getGUISeSAmDeclaration());

			if (!Utils.equals(oldFrameFactory, getFrameFactory())) {
				firePropertyChange("frameFactory", oldFrameFactory, getFrameFactory());
			}
		}
	}
}