/**
 * Created on 10.07.2003
 *
 * This class is responsible for //insert purpose//.
 * 
 * @author glueckselig
 */
package de.uniwue.ki.gui.mas.model.graph;

import junit.framework.Assert;
import mygale.mcge.fig.*;
import mygale.mcge.net.INetEdge;
import mygale.mcge.net.INetObject;
import de.uniwue.ki.mas.model.graph.IReflectiveEdge;
import de.uniwue.ki.mas.model.graph.UMLLayoutGraphFeatureEdge;

public class FigUMLGraphEdgeFactory implements IFigEdgeFactory {

    public FigUMLGraphEdgeFactory() {

        super();
    }

    public IFigEdge createFigEdge(INetEdge netEdge) {

        IFigEdge fig;
        if (netEdge instanceof IReflectiveEdge) {

            fig = new FigUMLGraphReflectiveEdge();

        } else if (netEdge instanceof UMLLayoutGraphFeatureEdge) {
            
            fig = new FigUMLGraphFeatureEdge();
        } else {

            fig = new FigUMLGraphEdge();
        }

        fig.setNetObject(netEdge);

        return fig;
    }

    public IFigObject createFigObject(INetObject netObject) {
        //ATT actually we don't need it. Maybe it should assert...
        Assert.fail();
        return null;
        //		return createFigEdge((INetEdge) netObject);
    }

}
