/**
 * Created on 11.02.2004
 *
 * This class is responsible for //insert purpose//.
 * 
 * @author glueckselig
 */
package de.uniwue.ki.gui.mas.model.graph;

import java.awt.*;
import java.util.Iterator;

import de.uniwue.ki.mas.model.graph.*;

public class FigUMLGraphFeatureNode extends FigUMLGraphNode {

    protected Rectangle paintTopContent(Graphics2D g2d, Rectangle rect) {
        return paintFunctions(g2d, rect);
    }

    protected Rectangle paintBottomContent(Graphics2D g2d, Rectangle rect) {

        return rect;
    }

    protected Rectangle paintTitle(Graphics2D g2d, Rectangle interiorPaintRect) {
        Font oldFont = g2d.getFont();
        g2d.setFont(oldFont.deriveFont(Font.ITALIC));

        Rectangle rectangle = super.paintTitle(g2d, interiorPaintRect);

        g2d.setFont(oldFont);

        return rectangle;
    }

    protected Rectangle paintFunctions(Graphics2D g2d, Rectangle interiorPaintRect) {

        Font oldFont = g2d.getFontMetrics().getFont();
        Font smallFont = oldFont.deriveFont(oldFont.getSize() * 0.9f);

        g2d.setFont(smallFont);

        //		Font smallItalicFont = smallFont.deriveFont(Font.ITALIC);

        Iterator functions = ((UMLLayoutGraphFeatureNode) getNetObject()).getFunctionIterator();

        if (functions.hasNext()) {

            drawFunctionList(g2d, interiorPaintRect, functions);
        }

        g2d.setFont(oldFont);

        return interiorPaintRect;
    }

    private void drawFunctionList(Graphics2D g2d, Rectangle interiorPaintRect, Iterator functions) {

        interiorPaintRect.y = (int) interiorPaintRect.getY() + g2d.getFontMetrics().getHeight() + 10;
        FontMetrics fmSmall = g2d.getFontMetrics();

        while (functions.hasNext()) {

            Function func = (Function) functions.next();

            StringBuffer strB = new StringBuffer(func.getName() + " :: ");

            //            strB.append(func.getType().getName());

            String str = strB.toString();

            Rectangle rectForString = calculateRectForStringTopLocation(g2d, fmSmall, str, interiorPaintRect);
            rectForString.setLocation(
                rectForString.getLocation().x + MARGIN_LEFT_FIG_EDGE,
                rectForString.getLocation().y);
            if (interiorPaintRect.height - fmSmall.getHeight() * 1.25 > 0 || !functions.hasNext()) {

                drawStringInRect(g2d, rectForString, fmSmall, str, Math.round(interiorPaintRect.y), false);

            } else {

                drawStringInRect(g2d, rectForString, fmSmall, "...", Math.round(interiorPaintRect.y), false);

                break;
            }

            interiorPaintRect.y += rectForString.getHeight();
            interiorPaintRect.height -= rectForString.getHeight();
        }
    }

}
