/**
 * Created on 23.07.2003
 *
 * This class is responsible for //insert purpose//.
 * 
 * @author glueckselig
 */
package de.uniwue.ki.gui.mas.model.graph;

import java.awt.Graphics2D;
import java.awt.Rectangle;

import mygale.mcge.util.prefs.Prefs;
import de.uniwue.ki.mas.model.graph.UMLLayoutGraphNode;

public abstract class FigUMLGraphNode extends FigRubberGraphNode implements IFigUMLLayoutGraphNode {

    protected static final int MARGIN_LEFT_FIG_EDGE = 5;

    public FigUMLGraphNode() {

        super();

        initRubber(50);

        setWidth(150);
        setHeight(200);
    }

    public String getName() {
        //TODO remove fixed
        return ((UMLLayoutGraphNode) getNetObject()).getName() + (isFixed() ? " :: fixed" : " :: floating");
    }

    public void paintContent(Graphics2D g2d, Prefs prefs) {
        paintSymbol(g2d, prefs);

        Rectangle interiorPaintRect = calculateInteriorPaintRect();

        interiorPaintRect = paintTitle(g2d, interiorPaintRect);
        interiorPaintRect = drawLine(g2d, interiorPaintRect);
        interiorPaintRect = paintTopContent(g2d, interiorPaintRect);

        interiorPaintRect = drawLine(g2d, interiorPaintRect);
        interiorPaintRect = paintBottomContent(g2d, interiorPaintRect);
    }

  
    
    protected abstract Rectangle paintTopContent(Graphics2D g2d, Rectangle rect);
    protected abstract Rectangle paintBottomContent(Graphics2D g2d, Rectangle rect);

    protected Rectangle drawLine(Graphics2D g2d, Rectangle rect) {
        g2d.drawLine(rect.x, rect.y + 10, rect.x + rect.width, rect.y + 10);
        rect.y += 10;
        rect.height -= 10;

        return rect;
    }
}



