/**
 * Created on 10.07.2003
 *
 * This class is responsible for //insert purpose//.
 * 
 * @author glueckselig
 */
package de.uniwue.ki.gui.mas.model.graph;

import de.uniwue.ki.mas.model.graph.UMLLayoutGraphFeatureNode;
import de.uniwue.ki.mas.model.graph.UMLLayoutGraphObjectNode;
import mygale.mcge.fig.*;
import mygale.mcge.net.INetNode;
import mygale.mcge.net.INetObject;

public class FigUMLGraphNodeFactory implements IFigNodeFactory {

    private static final int WIDTH = 1000;
    private static final int HEIGHT = 800;

    public IFigObject createFigObject(INetObject netObject) {

        return createFigNode((INetNode) netObject);
    }

    public IFigNode createFigNode(INetNode netNode) {
        IFigNode fig = null;

        if (netNode instanceof UMLLayoutGraphObjectNode) {
            fig = new FigUMLGraphObjectNode();

        } else if (netNode instanceof UMLLayoutGraphFeatureNode) {
            fig = new FigUMLGraphFeatureNode();

        }

        fig.setNetObject(netNode);

        fig.setLocation(
            (int) (Math.random() * (WIDTH - fig.getWidth())),
            (int) (Math.random() * (HEIGHT - fig.getHeight())));

        return fig;
    }

}
