/**
 * Created on 11.02.2004
 *
 * This class is responsible for //insert purpose//.
 * 
 * @author glueckselig
 */
package de.uniwue.ki.gui.mas.model.graph;

import java.awt.*;
import java.util.Iterator;

import de.uniwue.ki.mas.model.graph.*;

public class FigUMLGraphObjectNode extends FigUMLGraphNode {

    public FigUMLGraphObjectNode() {
        super();
    }

    protected Rectangle paintTopContent(Graphics2D g2d, Rectangle rect) {

        return paintVariables(g2d, rect);
    }

    protected Rectangle paintBottomContent(Graphics2D g2d, Rectangle rect) {

        return paintMethods(g2d, rect);
    }

    private Rectangle paintMethods(Graphics2D g2d, Rectangle interiorPaintRect) {
        // TODO implementieren!!
        return interiorPaintRect;
    }

    //copied from FigActionActivityGraphLeafDeclaration
    protected Rectangle paintVariables(Graphics2D g2d, Rectangle interiorPaintRect) {

        Font oldFont = g2d.getFontMetrics().getFont();
        Font smallFont = oldFont.deriveFont(oldFont.getSize() * 0.9f);

        g2d.setFont(smallFont);

        //		Font smallItalicFont = smallFont.deriveFont(Font.ITALIC);

        Iterator variables = ((UMLLayoutGraphObjectNode) getNetObject()).variableIterator();

        if (variables.hasNext()) {

            drawVariableList(g2d, interiorPaintRect, variables);
        }

        g2d.setFont(oldFont);

        return interiorPaintRect;
    }

    private void drawVariableList(Graphics2D g2d, Rectangle interiorPaintRect, Iterator variables) {

        interiorPaintRect.y = (int) interiorPaintRect.getY() + g2d.getFontMetrics().getHeight() + 10;
        FontMetrics fmSmall = g2d.getFontMetrics();

        while (variables.hasNext()) {

            Variable var = (Variable) variables.next();

            StringBuffer strB = new StringBuffer(var.getName() + " :: ");

            if (var instanceof ListVariable) {
                strB.append("list of ");
            }

            strB.append(var.getType().getName());

            String str = strB.toString();

            Rectangle rectForString = calculateRectForStringTopLocation(g2d, fmSmall, str, interiorPaintRect);
            rectForString.setLocation(
                rectForString.getLocation().x + MARGIN_LEFT_FIG_EDGE,
                rectForString.getLocation().y);
            if (interiorPaintRect.height - fmSmall.getHeight() * 1.25 > 0 || !variables.hasNext()) {

                drawStringInRect(g2d, rectForString, fmSmall, str, Math.round(interiorPaintRect.y), false);

            } else {

                drawStringInRect(g2d, rectForString, fmSmall, "...", Math.round(interiorPaintRect.y), false);

                break;
            }

            interiorPaintRect.y += rectForString.getHeight();
            interiorPaintRect.height -= rectForString.getHeight();
        }
    }
}
