/**
 * Created on 26.01.2004
 *
 * This class is responsible for //insert purpose//.
 * 
 * @author glueckselig
 */
package de.uniwue.ki.gui.mas.model.graph;

import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.util.declaration.*;
import de.uniwue.ki.mas.model.graph.*;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

public class UMLLayoutGraphDeclarationGraphPanelContainer
    extends AbstractSplittedDeclarationPanel {

    private UMLLayoutGraphDeclarationListPanel _listPanel;

    private UMLLayoutGraphDeclarationGraphPanel _graphPanel;

    private ListSelectionListener selectionListener =
        new ListSelectionListener() {
        public void valueChanged(ListSelectionEvent e) {

            if (e.getValueIsAdjusting()) {

                //do nothing
            } else if (!getListPanel().isSelectionEmpty())
                if (getDeclaration() != getListPanel().getSelectedValue()) {
                    setDeclaration(
                        (UMLLayoutGraphDeclaration) getListPanel()
                            .getSelectedValue());
                }
        }
    };

    public UMLLayoutGraphDeclarationGraphPanelContainer(IGUISeSAmDeclaration declaration) {
        setGUISeSAmDeclaration(declaration);
        initialize(
            UMLLayoutGraphDeclarationListAndFactory.getInstance(
                declaration.getSeSAmDeclaration()));
        setSize(598, 192);

    }

    protected IDeclarationPanel getDeclarationPanel() {

        if (_graphPanel == null) {
            _graphPanel = new UMLLayoutGraphDeclarationGraphPanel();
        }

        return _graphPanel;
    }

    protected DeclarationListPanel getListPanel() {
        if (_listPanel == null) {
            _listPanel = new UMLLayoutGraphDeclarationListPanel();
            _listPanel.addListSelectionListener(selectionListener);
            _listPanel.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
            _listPanel.setEditable(true);
            _listPanel.setArrowsAvailible(true); // What's that, by the way? --steffen
        }

        return _listPanel;
    }

    public IDeclaration getDeclaration() {
        return getDeclarationPanel().getDeclaration();
    }

}
