/**
 * Created on 10.03.2003
 *
 * This class is responsible for //insert purpose//.
 * 
 * @author glueckselig
 */
package de.uniwue.ki.gui.mas.model.plugin;

import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.*;
import javax.swing.JMenuItem;

import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.model.JInternalFrameFactory;
import de.uniwue.ki.mas.model.ISeSAmDeclaration;

public abstract class AbstractSeSAmMenuPlugin
	implements ISeSAmMenuPlugin, ActionListener {
	private IGUISeSAmDeclaration _guiSeSAmDeclaration;
	private Component _parent;

	public final void actionPerformed(ActionEvent e) {
		doit();
	}

	public void setGUISeSAmDeclaration(IGUISeSAmDeclaration guiSeSAmDeclaration) {
		_guiSeSAmDeclaration = guiSeSAmDeclaration;
	}

	public void setParent(Component parent) {
		_parent = parent;
	}

	public Component getParent() {
		return _parent;
	}

	/**
	 * gets called when the menuItem got selected
	 */
	abstract public void doit();

	/**
	 * sets THIS as the actionListener for the generated JMenuItem
	 */
	public JMenuItem createJMenuItemForPlugin() {

		JMenuItem item = new JMenuItem();
		item.addActionListener(this);

		initMenuItem(item);

		return item;
	}

	/**
	 * mainly for setting the name of the menu
	 */
	abstract public void initMenuItem(JMenuItem item);

	public ISeSAmDeclaration getSeSAmDeclaration() {
		return _guiSeSAmDeclaration.getSeSAmDeclaration();
	}

	public IGUISeSAmDeclaration getGUISeSAmDeclaration() {
		return _guiSeSAmDeclaration;
	}

	protected JInternalFrame openWindow(JPanel panel, String title) {

		return (
			(JInternalFrameFactory)
				(getGUISeSAmDeclaration().getFrameFactory())).addInternalFrame(
			getParent(),
			title,
			panel,
			true,
			WindowConstants.DISPOSE_ON_CLOSE);
	}

	protected JInternalFrame openWindow(
		JPanel panel,
		String title,
		boolean closeWindow) {

		if (closeWindow) {
			return (
				(JInternalFrameFactory)
					(
						getGUISeSAmDeclaration()
							.getFrameFactory()))
							.addInternalFrame(
				getParent(),
				title,
				panel,
				true,
				WindowConstants.DISPOSE_ON_CLOSE);
		}
		return (
			(JInternalFrameFactory)
				(getGUISeSAmDeclaration().getFrameFactory())).addInternalFrame(
			getParent(),
			title,
			panel,
			true,
			WindowConstants.DO_NOTHING_ON_CLOSE);

	}
	
	protected JRootPane openWindow(
			JPanel panel,
			String title,
			Runnable windowClosingFunction) {

			return (
				(JInternalFrameFactory)
					(getGUISeSAmDeclaration().getFrameFactory())).addPanel(
				getParent(),
				title,
				panel,
				true,
				WindowConstants.DISPOSE_ON_CLOSE,
				windowClosingFunction);

		}
}
