package de.uniwue.ki.gui.mas.refactoring;

import java.awt.BorderLayout;

import javax.swing.BoxLayout;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

import com.jgoodies.forms.layout.CellConstraints;
import com.jgoodies.forms.layout.FormLayout;
import com.magelang.box.HorizontalStrut;

import de.uniwue.ki.gui.mas.basics.type.SpecificTypeDefinePanel;
import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.model.JPanelWithGUISeSAmDeclaration;
import de.uniwue.ki.gui.util.SwingMoreUtilities;
import de.uniwue.ki.gui.util.bound.BestBoundJTextField;
import de.uniwue.ki.mas.basics.type.ISpecificType;
import de.uniwue.ki.mas.refactoring.ArgumentInfo;

/**
 * @author Michael Scherer
 */
public class NewArgumentDeclarationPanel extends JPanelWithGUISeSAmDeclaration {
	private JPanel ivjJPanelType = null;
	private SpecificTypeDefinePanel ivjTypeDefinePanel = null;
	private JPanel ivjJPanelName = null;
	private BestBoundJTextField ivjJTextFieldName = null;
	private HorizontalStrut ivjHorizontalStrut1 = null;
	private ArgumentInfo argInfo = null;

	public static ArgumentInfo getArgument(IGUISeSAmDeclaration guiSeSAmDeclaration,
			ArgumentInfo _default) 
	{
		NewArgumentDeclarationPanel aNewArgumentDeclarationPanel =
			new NewArgumentDeclarationPanel(guiSeSAmDeclaration);
		
		aNewArgumentDeclarationPanel.update(_default);

		JOptionPane optionPane =
			new JOptionPane(
				aNewArgumentDeclarationPanel,
				JOptionPane.QUESTION_MESSAGE,
				JOptionPane.OK_CANCEL_OPTION);
		
		JDialog dialog = optionPane.createDialog(null, "New Argument");
		dialog.show(true);
		
		if (SwingMoreUtilities.userChoiceOption(optionPane, JOptionPane.CANCEL_OPTION))
			return null;

		return new ArgumentInfo(aNewArgumentDeclarationPanel.getName(), 
				aNewArgumentDeclarationPanel.getType());
   }

	public NewArgumentDeclarationPanel(IGUISeSAmDeclaration guiSeSAmDeclaration) {
		super();
		initialize();
		ivjTypeDefinePanel.setGUISeSAmDeclaration(guiSeSAmDeclaration);
	}

	private void initialize() {
		try {
			setName("NewArgumentDeclarationPanel");
			setLayout(new BorderLayout(5, 5));
			add(getJPanelType(), BorderLayout.CENTER);
		} catch (Throwable e) {		
		}
	}
	
	private void update(ArgumentInfo argInfo) {
		this.argInfo = argInfo;
		if (argInfo == null) 
			return;
		
		ivjJTextFieldName.setText(argInfo.getName());
		ivjTypeDefinePanel.setSpecificType(argInfo.getType());
	}
	
	public String getName() {
		return ivjJTextFieldName.getText();
	}
	
	public ISpecificType getType() {
		return ivjTypeDefinePanel.getSpecificType();
	}
	
	private void handleException(Throwable e) {
		e.printStackTrace(System.out);
	}

	private JPanel getJPanelType() {
		if (ivjJPanelType == null) {

			ivjJPanelType = new JPanel(new FormLayout("fill:default", "default, 4dlu, default"));

			CellConstraints cc = new CellConstraints();

			getJPanelType().add(getJPanelName(), cc.xy(1, 1));
			getJPanelType().add(getTypeDefinePanel(), cc.xy(1, 3));
		}
		return ivjJPanelType;
	}	

	private JPanel getJPanelName() {
		if (ivjJPanelName == null) {
			ivjJPanelName = new JPanel();
			ivjJPanelName.setLayout(new BoxLayout(getJPanelName(), BoxLayout.X_AXIS));
			getJPanelName().add(new JLabel("Name:"), "Name");
			getJPanelName().add(getHorizontalStrut1(), getHorizontalStrut1().getName());
			getJPanelName().add(getJTextFieldName(), getJTextFieldName().getName());
		}
		return ivjJPanelName;
	}
	
	private HorizontalStrut getHorizontalStrut1() {
		if (ivjHorizontalStrut1 == null) {
			try {
				ivjHorizontalStrut1 = new HorizontalStrut();
				ivjHorizontalStrut1.setName("HorizontalStrut1");
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjHorizontalStrut1;
	}

	private BestBoundJTextField getJTextFieldName() {
		if (ivjJTextFieldName == null) {
			try {
				ivjJTextFieldName = new BestBoundJTextField();
				ivjJTextFieldName.setName("JTextFieldName");
				ivjJTextFieldName.setEditable(true);
				ivjJTextFieldName.setEnabled(true);
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjJTextFieldName;
	}

	private SpecificTypeDefinePanel getTypeDefinePanel() {
		if (ivjTypeDefinePanel == null) {
			try {
				ivjTypeDefinePanel = new SpecificTypeDefinePanel();
				ivjTypeDefinePanel.setName("TypeDefinePanel");
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjTypeDefinePanel;
	}
}
