package de.uniwue.ki.gui.mas.refactoring;

import java.awt.Container;
import java.util.ArrayList;
import java.util.Iterator;

import javax.swing.JMenu;

import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.util.actions.AbstractBoundAction;
import de.uniwue.ki.mas.refactoring.AbstractRefactoring;
import de.uniwue.ki.mas.refactoring.RefactoringFactory;

public class RefactoringMenuFactory {

	private final static RefactoringMenuFactory instance = new RefactoringMenuFactory();
	private IGUISeSAmDeclaration guiSesamDeclaration = null;
	
	protected RefactoringMenuFactory() {
		super();
	}

	public static RefactoringMenuFactory getInstance() {
		return instance;
	}
	
	public IGUISeSAmDeclaration getGUISeSAmDeclaraion() {
		return guiSesamDeclaration;
	}
	
	public JMenu createMenu(Container parent, IGUISeSAmDeclaration declaration, Object _refactoringSubject) {
		this.guiSesamDeclaration = declaration;

		ArrayList refactorings = RefactoringFactory.getInstance().getApplicableRefactorings(declaration.getSeSAmDeclaration(), _refactoringSubject);
		JMenu refactoringMenu = new JMenu("Refactoring");

		AbstractBoundAction.setFont(refactoringMenu, false);
		refactoringMenu.setEnabled(refactorings.size() > 0); 

		Iterator iter = refactorings.iterator();
		while (iter.hasNext()) 
			refactoringMenu.add(
				new RefactoringAction(declaration, (AbstractRefactoring) iter.next(),
				new SimpleRefactoringUI()));

		return refactoringMenu;
	}
}
