package de.uniwue.ki.gui.mas.sim.analysis;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import de.uniwue.ki.gui.mas.model.JPanelWithGUISeSAmDeclaration;
import de.uniwue.ki.mas.sim.analysis.BlockChartAnalysisTypeDeclaration;
import de.uniwue.ki.mas.sim.analysis.IAnalysisTypeDeclaration;
/**
 * Creation date: (28.11.2001 17:50:02)
 * @author Christoph Oechslein
 */
public abstract class AbstractAnalysisTypeDeclarationPanel
	extends JPanelWithGUISeSAmDeclaration
	implements IAnalysisTypeDeclarationPanel {
	private IAnalysisTypeDeclaration _analysisTypeDeclaration;

	public AbstractAnalysisTypeDeclarationPanel() {
		super();

		initialize();
	}

	public boolean canEdit(IAnalysisTypeDeclaration newAnalysisTypeDeclaration) {
		return newAnalysisTypeDeclaration instanceof BlockChartAnalysisTypeDeclaration;
	}

	protected abstract IAnalysisTypeDeclaration createPrototypeAnalysisTypeDeclaration();

	public IAnalysisTypeDeclaration getAnalysisTypeDeclaration() {
		if (_analysisTypeDeclaration == null) {
			_analysisTypeDeclaration = createPrototypeAnalysisTypeDeclaration();
		}

		return _analysisTypeDeclaration;
	}

	private void handleException(Throwable exception) {
		exception.printStackTrace(System.out);
	}

	/**
	 * Initialize the class.
	 */
	private void initialize() {
		try {
					setName("BlockChartAnalysisDeclarationTypePanel");
			setSize(263, 30);
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	public static void main(String[] args) {
		try {
			javax.swing.JFrame frame = new javax.swing.JFrame();
			BlockChartAnalysisTypeDeclarationPanel aBlockChartAnalysisDeclarationTypePanel;
			aBlockChartAnalysisDeclarationTypePanel = new BlockChartAnalysisTypeDeclarationPanel();
			frame.setContentPane(aBlockChartAnalysisDeclarationTypePanel);
			frame.setSize(aBlockChartAnalysisDeclarationTypePanel.getSize());
			frame.addWindowListener(new WindowAdapter() {
				public void windowClosing(WindowEvent e) {
					System.exit(0);
				}
			});
			frame.pack();
			frame.show();
			java.awt.Insets insets = frame.getInsets();
			frame.setSize(
				frame.getWidth() + insets.left + insets.right,
				frame.getHeight() + insets.top + insets.bottom);
			frame.setVisible(true);
		} catch (Throwable exception) {
			System.err.println(
				"Exception occurred in main() of de.uniwue.ki.gui.mas.model.JPanelWithGUISeSAmDeclaration");
			exception.printStackTrace(System.out);
		}
	}

	public void setAnalysisTypeDeclaration(IAnalysisTypeDeclaration newAnalysisTypeDeclaration) {
		IAnalysisTypeDeclaration oldValue = getAnalysisTypeDeclaration();

		_analysisTypeDeclaration = newAnalysisTypeDeclaration;

		firePropertyChange("analysisTypeDeclaration", oldValue, newAnalysisTypeDeclaration);
	}
}