package de.uniwue.ki.gui.mas.sim.analysis;
import de.uniwue.ki.gui.mas.util.declaration.DeclarationListToDeclarationListPanel;
import de.uniwue.ki.mas.sim.analysis.AnalysisDeclarationList;
import de.uniwue.ki.mas.sim.analysis.IAnalysisDeclaration;
import de.uniwue.ki.util.functions.IMapFunction;

/**
 * Creation date: (23.11.2000 16:37:54)
 * @author Christoph Oechslein
 */
public class AnalysisDeclarationListToAnalysisDeclarationList
	extends de.uniwue.ki.gui.mas.model.JPanelWithGUISeSAmDeclaration {
	private DeclarationListToDeclarationListPanel ivjDeclarationListToDeclarationListPanel1 = null;
	private final IvjEventHandler ivjEventHandler = new IvjEventHandler();

	private final class IvjEventHandler implements java.beans.PropertyChangeListener {
		public void propertyChange(java.beans.PropertyChangeEvent evt) {
			if (evt.getSource() == AnalysisDeclarationListToAnalysisDeclarationList.this
				&& (evt.getPropertyName().equals("gUISeSAmDeclaration")))
				connEtoC1(evt);
		}
	}

	public AnalysisDeclarationListToAnalysisDeclarationList() {
		super();
		initialize();
	}

	private void connEtoC1(java.beans.PropertyChangeEvent arg1) {
		try {
			this.eventGUISeSAmDeclaration();
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	public void dispose() {
		super.dispose();

		getDeclarationListToDeclarationListPanel1().dispose();
	}

	protected void eventGUISeSAmDeclaration() {
		if (getGUISeSAmDeclaration() != null) {
			getDeclarationListToDeclarationListPanel1().setLeftDeclarationListPanelDeclarationListModel(
				getGUISeSAmDeclaration()
					.getSeSAmModelDeclaration()
					.getSimulationElementsDeclaration()
					.getAnalysisDeclarationListAndFactory()
					.getDeclarationList());
		}
	}

	public AnalysisDeclarationList getAnalysisDeclarationList() {
		return (AnalysisDeclarationList) getDeclarationListToDeclarationListPanel1()
			.getRightDeclarationListPanelDeclarationListModel();
	}

	private DeclarationListToDeclarationListPanel getDeclarationListToDeclarationListPanel1() {
		if (ivjDeclarationListToDeclarationListPanel1 == null) {
			try {
				ivjDeclarationListToDeclarationListPanel1 = new DeclarationListToDeclarationListPanel();
				ivjDeclarationListToDeclarationListPanel1.setName("DeclarationListToDeclarationListPanel1");
				ivjDeclarationListToDeclarationListPanel1.setRightDeclarationListPanelButtonPaneAvailible(
					false);
				ivjDeclarationListToDeclarationListPanel1.setLeftDeclarationListPanelButtonPaneAvailible(
					false);
				ivjDeclarationListToDeclarationListPanel1.setRightDeclarationListPanelText(
					"Added Analysis\'");
				ivjDeclarationListToDeclarationListPanel1.setLeftDeclarationListPanelText("All Analysis\'");
						ivjDeclarationListToDeclarationListPanel1.setLeftToRightMapFunction(new IMapFunction() {
					public Object map(Object obj) {
						IAnalysisDeclaration analysisDeclaration = (IAnalysisDeclaration) obj;
						if (getAnalysisDeclarationList().contains(analysisDeclaration)) {
							return null;

						} else {
							return analysisDeclaration;
						}
					}
				});
					} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjDeclarationListToDeclarationListPanel1;
	}

	/**
	 * Called whenever the bean information class throws an exception.
	 * @param exception Throwable
	 */
	private void handleException(Throwable exception) {

		exception.printStackTrace(System.out);
	}

	/**
	 * Initializes connections
	 * @exception Exception The exception description.
	 */
	private void initConnections() {
		this.addPropertyChangeListener(ivjEventHandler);
	}

	/**
	 * Initialize the class.
	 */
	private void initialize() {
		try {
					setName("FeatureDeclarationListToFeatureDeclarationList");
			setLayout(new javax.swing.BoxLayout(this, javax.swing.BoxLayout.X_AXIS));
			setSize(419, 157);
			add(
				getDeclarationListToDeclarationListPanel1(),
				getDeclarationListToDeclarationListPanel1().getName());
			initConnections();
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	public void setAnalysisDeclarationList(AnalysisDeclarationList analysisDeclarationList) {
		getDeclarationListToDeclarationListPanel1().setRightDeclarationListPanelDeclarationListModel(
			analysisDeclarationList);
	}

}