package de.uniwue.ki.gui.mas.sim.analysis;
import java.awt.Container;

import javax.swing.Icon;

import de.uniwue.ki.gui.mas.model.AbstractDeclarationPanelAndActionFactory;
import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.model.tree.SeSAmDeclarationTreeCellRenderer;
import de.uniwue.ki.gui.mas.util.declaration.*;
import de.uniwue.ki.mas.sim.analysis.IAnalysisDeclaration;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: (10.10.2001 11:09:49)
 * @author Christoph Oechslein
 */

public class AnalysisDeclarationPanelActionFactory extends AbstractDeclarationPanelAndActionFactory {

	private final AnalysisDeclarationPanelFactory _analysisDeclarationPanelFactory =
		new AnalysisDeclarationPanelFactory();

	private class AnalysisDeclarationPanelFactory extends AbstractDeclarationPanelFactory {
		public IDeclarationPanel createDeclarationPanel(IDeclaration declaration) {
			NameDeclarationWithDocumentationAdapterPanel adapterPanel =
				new NameDeclarationWithDocumentationAdapterPanel(new AnalysisDeclarationPanel());

			adapterPanel.setGUISeSAmDeclaration(getGUISeSAmDeclaration());
			adapterPanel.setLinePanel(true);

			return adapterPanel;
		}

		public String getDeclarationTitle(IDeclaration declaration) {
			return "Analysis";
		}
		
        public Icon getIcon(IDeclaration declaration) {
            return SeSAmDeclarationTreeCellRenderer.ANALYSIS_ICON;
        }

	}

	public AnalysisDeclarationPanelActionFactory() {
		super();
	}

	public AnalysisDeclarationPanelActionFactory(IGUISeSAmDeclaration guiSeSAmDeclaration) {

		super();

		setGUISeSAmDeclaration(guiSeSAmDeclaration);
	}

	protected boolean getCanProduceDeclarationActions(Container parent, IDeclaration anDeclaration) {
		return (anDeclaration instanceof IAnalysisDeclaration);
	}

	public IDeclarationPanelFactory getDeclarationPanelFactory(
		Container parent,
		IDeclaration anDeclaration) {
		return _analysisDeclarationPanelFactory;
	}

	protected boolean shouldUseOkCancelDeclarationPanel(Container parent, IDeclaration anDeclaration) {
		return false;
	}
}