package de.uniwue.ki.gui.mas.sim.analysis;
import javax.swing.JLabel;

import de.uniwue.ki.gui.mas.basics.functionCall.FunctionCallDeclarationTreeListPanel;
import de.uniwue.ki.gui.mas.util.declaration.AbstractDeclarationPanel;
import de.uniwue.ki.gui.util.bound.BetterBoundJTextField;
import de.uniwue.ki.mas.sim.analysis.IAnalysisItemDeclaration;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: (26.11.2001 12:46:37)
 * @author Christoph Oechslein
 */

public class AnalysisItemDeclarationPanel extends AbstractDeclarationPanel {
	private IAnalysisItemDeclaration ivjAnalysisItemDeclarationIntern = null;
	private BetterBoundJTextField ivjBetterBoundJTextFieldName = null;
	private boolean ivjConnPtoP1Aligning = false;
	private boolean ivjConnPtoP2Aligning = false;
	private boolean ivjConnPtoP3Aligning = false;
	private final IvjEventHandler ivjEventHandler = new IvjEventHandler();
	private FunctionCallDeclarationTreeListPanel ivjFunctionCallDeclarationTreeListPanel1 = null;
	private JLabel ivjJLabelName = null;

	private final class IvjEventHandler implements java.beans.PropertyChangeListener {
		public void propertyChange(java.beans.PropertyChangeEvent evt) {
			if (evt.getSource() == AnalysisItemDeclarationPanel.this
				&& (evt.getPropertyName().equals("gUISeSAmDeclaration")))
				connPtoP1SetTarget();
			if (evt.getSource()
				== AnalysisItemDeclarationPanel.this.getFunctionCallDeclarationTreeListPanel1()
				&& (evt.getPropertyName().equals("gUISeSAmDeclaration")))
				connPtoP1SetSource();
			if (evt.getSource() == AnalysisItemDeclarationPanel.this.getAnalysisItemDeclarationIntern()
				&& (evt.getPropertyName().equals("name")))
				connPtoP2SetTarget();
			if (evt.getSource() == AnalysisItemDeclarationPanel.this.getBetterBoundJTextFieldName()
				&& (evt.getPropertyName().equals("text")))
				connPtoP2SetSource();
			if (evt.getSource() == AnalysisItemDeclarationPanel.this.getAnalysisItemDeclarationIntern()
				&& (evt.getPropertyName().equals("valueFunctionCallDeclaration")))
				connPtoP3SetTarget();
		}
	}

	/**
	 * AnalysisItemDeclarationPanel constructor comment.
	 */
	public AnalysisItemDeclarationPanel() {
		super();
		initialize();
	}

	/**
	 * connPtoP1SetSource:  (AnalysisItemDeclarationPanel.gUISeSAmDeclaration <--> FunctionCallDeclarationTreeListPanel1.gUISeSAmDeclaration)
	 */
	private void connPtoP1SetSource() {
		try {
			if (ivjConnPtoP1Aligning == false) {
								ivjConnPtoP1Aligning = true;
				this.setGUISeSAmDeclaration(
					getFunctionCallDeclarationTreeListPanel1().getGUISeSAmDeclaration());
								ivjConnPtoP1Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP1Aligning = false;
					handleException(ivjExc);
		}
	}

	/**
	 * connPtoP1SetTarget:  (AnalysisItemDeclarationPanel.gUISeSAmDeclaration <--> FunctionCallDeclarationTreeListPanel1.gUISeSAmDeclaration)
	 */
	private void connPtoP1SetTarget() {
		try {
			if (ivjConnPtoP1Aligning == false) {
								ivjConnPtoP1Aligning = true;
				getFunctionCallDeclarationTreeListPanel1().setGUISeSAmDeclaration(
					this.getGUISeSAmDeclaration());
								ivjConnPtoP1Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP1Aligning = false;
					handleException(ivjExc);
		}
	}

	/**
	 * connPtoP2SetSource:  (AnalysisItemDeclarationIntern.name <--> BetterBoundJTextFieldName.text)
	 */
	private void connPtoP2SetSource() {
		try {
			if (ivjConnPtoP2Aligning == false) {
								ivjConnPtoP2Aligning = true;
				if ((getAnalysisItemDeclarationIntern() != null)) {
					getAnalysisItemDeclarationIntern().setName(getBetterBoundJTextFieldName().getText());
				}
								ivjConnPtoP2Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP2Aligning = false;
					handleException(ivjExc);
		}
	}

	/**
	 * connPtoP2SetTarget:  (AnalysisItemDeclarationIntern.name <--> BetterBoundJTextFieldName.text)
	 */
	private void connPtoP2SetTarget() {
		try {
			if (ivjConnPtoP2Aligning == false) {
								ivjConnPtoP2Aligning = true;
				if ((getAnalysisItemDeclarationIntern() != null)) {
					getBetterBoundJTextFieldName().setText(getAnalysisItemDeclarationIntern().getName());
				}
								ivjConnPtoP2Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP2Aligning = false;
					handleException(ivjExc);
		}
	}

	/**
	 * connPtoP3SetTarget:  (AnalysisItemDeclarationIntern.valueFunctionCallDeclaration <--> FunctionCallDeclarationTreeListPanel1.functionCallDeclaration)
	 */
	private void connPtoP3SetTarget() {
		try {
			if (ivjConnPtoP3Aligning == false) {
								ivjConnPtoP3Aligning = true;
				if ((getAnalysisItemDeclarationIntern() != null)) {
					getFunctionCallDeclarationTreeListPanel1().setFunctionCallDeclaration(
						getAnalysisItemDeclarationIntern().getValueFunctionCallDeclaration());
				}
								ivjConnPtoP3Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP3Aligning = false;
					handleException(ivjExc);
		}
	}

	public void dispose() {
		getFunctionCallDeclarationTreeListPanel1().dispose();

		super.dispose();
	}

	/**
	 * Method generated to support the promotion of the analysisItemDeclaration attribute.
	 * @return de.uniwue.ki.mas.model.sim.analysis.IAnalysisItemDeclaration
	 */
	public de.uniwue.ki.mas.sim.analysis.IAnalysisItemDeclaration getAnalysisItemDeclaration() {
		return getAnalysisItemDeclarationIntern();
	}

	/**
	 * Return the AnalysisItemDeclarationIntern property value.
	 * @return de.uniwue.ki.mas.model.sim.analysis.IAnalysisItemDeclaration
	 */
	private de.uniwue.ki.mas.sim.analysis.IAnalysisItemDeclaration getAnalysisItemDeclarationIntern() {
		return ivjAnalysisItemDeclarationIntern;
	}

	/**
	 * Return the BetterBoundJTextFieldName property value.
	 * @return de.uniwue.ki.gui.util.bound.BetterBoundJTextField
	 */
	private de.uniwue.ki.gui.util.bound.BetterBoundJTextField getBetterBoundJTextFieldName() {
		if (ivjBetterBoundJTextFieldName == null) {
			try {
				ivjBetterBoundJTextFieldName = new de.uniwue.ki.gui.util.bound.BetterBoundJTextField();
				ivjBetterBoundJTextFieldName.setName("BetterBoundJTextFieldName");
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjBetterBoundJTextFieldName;
	}

	public IDeclaration getDeclaration() {
		return getAnalysisItemDeclaration();
	}

	/**
	 * Return the FunctionCallDeclarationTreeListPanel1 property value.
	 * @return de.uniwue.ki.gui.mas.model.basics.functionCall.FunctionCallDeclarationTreeListPanel
	 */
	private FunctionCallDeclarationTreeListPanel getFunctionCallDeclarationTreeListPanel1() {
		if (ivjFunctionCallDeclarationTreeListPanel1 == null) {
			try {
				ivjFunctionCallDeclarationTreeListPanel1 = new FunctionCallDeclarationTreeListPanel();
				ivjFunctionCallDeclarationTreeListPanel1.setName("FunctionCallDeclarationTreeListPanel1");
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjFunctionCallDeclarationTreeListPanel1;
	}

	/**
	 * Return the JLabelName property value.
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelName() {
		if (ivjJLabelName == null) {
			try {
				ivjJLabelName = new javax.swing.JLabel();
				ivjJLabelName.setName("JLabelName");
				ivjJLabelName.setText("Name:");
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjJLabelName;
	}

	/**
	 * Called whenever the part throws an exception.
	 * @param exception Throwable
	 */
	private void handleException(Throwable exception) {

		exception.printStackTrace(System.out);
	}

	/**
	 * Initializes connections
	 * @exception Exception The exception description.
	 */
	private void initConnections() {
		this.addPropertyChangeListener(ivjEventHandler);
		getFunctionCallDeclarationTreeListPanel1().addPropertyChangeListener(ivjEventHandler);
		getBetterBoundJTextFieldName().addPropertyChangeListener(ivjEventHandler);
		connPtoP1SetTarget();
		connPtoP2SetTarget();
		connPtoP3SetTarget();
	}

	/**
	 * Initialize the class.
	 */
	private void initialize() {
		try {
					setName("AnalysisItemDeclarationPanel");
			setLayout(new java.awt.GridBagLayout());
			setSize(280, 370);

			java.awt.GridBagConstraints constraintsJLabelName = new java.awt.GridBagConstraints();
			constraintsJLabelName.gridx = 0;
			constraintsJLabelName.gridy = 0;
			add(getJLabelName(), constraintsJLabelName);

			java.awt.GridBagConstraints constraintsBetterBoundJTextFieldName =
				new java.awt.GridBagConstraints();
			constraintsBetterBoundJTextFieldName.gridx = 1;
			constraintsBetterBoundJTextFieldName.gridy = 0;
			constraintsBetterBoundJTextFieldName.fill = java.awt.GridBagConstraints.HORIZONTAL;
			constraintsBetterBoundJTextFieldName.weightx = 1.0;
			constraintsBetterBoundJTextFieldName.insets = new java.awt.Insets(0, 4, 0, 0);
			add(getBetterBoundJTextFieldName(), constraintsBetterBoundJTextFieldName);

			java.awt.GridBagConstraints constraintsFunctionCallDeclarationTreeListPanel1 =
				new java.awt.GridBagConstraints();
			constraintsFunctionCallDeclarationTreeListPanel1.gridx = 0;
			constraintsFunctionCallDeclarationTreeListPanel1.gridy = 1;
			constraintsFunctionCallDeclarationTreeListPanel1.gridwidth = 2;
			constraintsFunctionCallDeclarationTreeListPanel1.fill = java.awt.GridBagConstraints.BOTH;
			constraintsFunctionCallDeclarationTreeListPanel1.weightx = 1.0;
			constraintsFunctionCallDeclarationTreeListPanel1.weighty = 1.0;
			constraintsFunctionCallDeclarationTreeListPanel1.insets = new java.awt.Insets(4, 0, 0, 0);
			add(getFunctionCallDeclarationTreeListPanel1(), constraintsFunctionCallDeclarationTreeListPanel1);
			initConnections();
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	public static void main(String[] args) {
		try {
			javax.swing.JFrame frame = new javax.swing.JFrame();
			AnalysisItemDeclarationPanel aAnalysisItemDeclarationPanel;
			aAnalysisItemDeclarationPanel = new AnalysisItemDeclarationPanel();
			frame.setContentPane(aAnalysisItemDeclarationPanel);
			frame.setSize(aAnalysisItemDeclarationPanel.getSize());
			frame.addWindowListener(new java.awt.event.WindowAdapter() {
				public void windowClosing(java.awt.event.WindowEvent e) {
					System.exit(0);
				};
			});
			frame.show();
			java.awt.Insets insets = frame.getInsets();
			frame.setSize(
				frame.getWidth() + insets.left + insets.right,
				frame.getHeight() + insets.top + insets.bottom);
			frame.setVisible(true);
		} catch (Throwable exception) {
			System.err.println(
				"Exception occurred in main() of de.uniwue.ki.gui.mas.model.JPanelWithGUISeSAmDeclaration");
			exception.printStackTrace(System.out);
		}
	}

	/**
	 * Method generated to support the promotion of the analysisItemDeclaration attribute.
	 * @param arg1 de.uniwue.ki.mas.model.sim.analysis.IAnalysisItemDeclaration
	 */
	public void setAnalysisItemDeclaration(de.uniwue.ki.mas.sim.analysis.IAnalysisItemDeclaration arg1) {
		setAnalysisItemDeclarationIntern(arg1);
	}

	/**
	 * Set the AnalysisItemDeclarationIntern to a new value.
	 * @param newValue de.uniwue.ki.mas.model.sim.analysis.IAnalysisItemDeclaration
	 */
	private void setAnalysisItemDeclarationIntern(
		de.uniwue.ki.mas.sim.analysis.IAnalysisItemDeclaration newValue) {
		if (ivjAnalysisItemDeclarationIntern != newValue) {
			try {
				de.uniwue.ki.mas.sim.analysis.IAnalysisItemDeclaration oldValue =
					getAnalysisItemDeclarationIntern();
				/* Stop listening for events from the current object */
				if (ivjAnalysisItemDeclarationIntern != null) {
					ivjAnalysisItemDeclarationIntern.removePropertyChangeListener(ivjEventHandler);
				}
				ivjAnalysisItemDeclarationIntern = newValue;

				/* Listen for events from the new object */
				if (ivjAnalysisItemDeclarationIntern != null) {
					ivjAnalysisItemDeclarationIntern.addPropertyChangeListener(ivjEventHandler);
				}
				connPtoP2SetTarget();
				connPtoP3SetTarget();
				firePropertyChange("analysisItemDeclaration", oldValue, newValue);
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
	}

	public void setDeclaration(IDeclaration arg1) {
		setAnalysisItemDeclaration((IAnalysisItemDeclaration) arg1);
	}

}