package de.uniwue.ki.gui.mas.sim.analysis;
import java.awt.Color;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import javax.swing.JColorChooser;

import de.uniwue.ki.mas.sim.analysis.ColorAnalysisItemDeclaration;
import de.uniwue.ki.mas.sim.analysis.IAnalysisItemDeclaration;

/**
 * Creation date: (29.11.2001 11:37:06)
 * @author Christoph Oechslein
 */
public class ChartAnalysisItemDeclarationPanel extends AbstractAnalysisItemDeclarationPanel {
	private PropertyChangeListener _colorPropertyListener = new PropertyChangeListener() {
		public void propertyChange(PropertyChangeEvent evt) {
			if (evt.getSource() == getAnalysisItemDeclaration()) {
				eventAnalysisItemColorChanged((Color) evt.getNewValue());
			}
		}
	};
	private final IvjEventHandler ivjEventHandler = new IvjEventHandler();
	private javax.swing.JButton ivjJButton1 = null;

	private final class IvjEventHandler implements java.awt.event.ActionListener {
		public void actionPerformed(java.awt.event.ActionEvent e) {
			if (e.getSource() == ChartAnalysisItemDeclarationPanel.this.getJButton1())
				connEtoC1(e);
		};
	};
	private com.magelang.box.HorizontalStrut ivjBoxLayoutHorizontalStrut1 = null;
	private javax.swing.JLabel ivjJLabel1 = null;

	public ChartAnalysisItemDeclarationPanel() {
		super();
		initialize();
	}

	public boolean canEdit(IAnalysisItemDeclaration newAnalysisItemDeclaration) {
		return newAnalysisItemDeclaration instanceof ColorAnalysisItemDeclaration;
	}

	/**
	 * connEtoC1:  (JButton1.action.actionPerformed(java.awt.event.ActionEvent) --> ChartAnalysisItemDeclarationPanel.eventColorButtonPressed()V)
	 * @param arg1 java.awt.event.ActionEvent
	 */
	private void connEtoC1(java.awt.event.ActionEvent arg1) {
		try {
					this.eventColorButtonPressed();
				} catch (Throwable ivjExc) {
					handleException(ivjExc);
		}
	}

	protected void eventAnalysisItemColorChanged(Color newColor) {
		getJButton1().setBackground(newColor);
	}

	protected void eventColorButtonPressed() {
		if (getAnalysisItemDeclaration() != null) {
			Color newColor =
				JColorChooser.showDialog(this, "Choice Color", getJButton1().getBackground());

			if (newColor != null) {
				((ColorAnalysisItemDeclaration) getAnalysisItemDeclaration()).setColor(newColor);
			}
		}
	}

	/**
	 * Return the ChartAnalysisItemDeclarationPanelBoxLayout property value.
	 * @return javax.swing.BoxLayout
	 */
	private javax.swing.BoxLayout getChartAnalysisItemDeclarationPanelBoxLayout() {
		javax.swing.BoxLayout ivjChartAnalysisItemDeclarationPanelBoxLayout = null;
		try {
			/* Create part */
			ivjChartAnalysisItemDeclarationPanelBoxLayout =
				new javax.swing.BoxLayout(this, javax.swing.BoxLayout.X_AXIS);
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		};
		return ivjChartAnalysisItemDeclarationPanelBoxLayout;
	}

	/**
	 * Return the BoxLayoutHorizontalStrut1 property value.
	 * @return com.magelang.box.BoxLayoutHorizontalStrut
	 */
	private com.magelang.box.HorizontalStrut getBoxLayoutHorizontalStrut1() {
		if (ivjBoxLayoutHorizontalStrut1 == null) {
			try {
				ivjBoxLayoutHorizontalStrut1 = new com.magelang.box.HorizontalStrut();
				ivjBoxLayoutHorizontalStrut1.setName("BoxLayoutHorizontalStrut1");
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjBoxLayoutHorizontalStrut1;
	}


	/**
	 * Return the JButton1 property value.
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButton1() {
		if (ivjJButton1 == null) {
			try {
				ivjJButton1 = new javax.swing.JButton();
				ivjJButton1.setName("JButton1");
				ivjJButton1.setPreferredSize(new java.awt.Dimension(65, 25));
				ivjJButton1.setText("");
				ivjJButton1.setMinimumSize(new java.awt.Dimension(65, 25));
				ivjJButton1.setMaximumSize(new java.awt.Dimension(65, 25));
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjJButton1;
	}

	/**
	 * Return the JLabel1 property value.
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel1() {
		if (ivjJLabel1 == null) {
			try {
				ivjJLabel1 = new javax.swing.JLabel();
				ivjJLabel1.setName("JLabel1");
				ivjJLabel1.setText("Color:");
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjJLabel1;
	}

	/**
	 * Called whenever the part throws an exception.
	 * @param exception Throwable
	 */
	private void handleException(Throwable exception) {

		exception.printStackTrace(System.out);
	}

	/**
	 * Initializes connections
	 * @exception Exception The exception description.
	 */
	private void initConnections() {
		getJButton1().addActionListener(ivjEventHandler);
	}

	/**
	 * Initialize the class.
	 */
	private void initialize() {
		try {
					setName("ChartAnalysisItemDeclarationPanel");
			setLayout(getChartAnalysisItemDeclarationPanelBoxLayout());
			setSize(130, 35);
			add(getJLabel1(), getJLabel1().getName());
			add(getBoxLayoutHorizontalStrut1(), getBoxLayoutHorizontalStrut1().getName());
			add(getJButton1(), getJButton1().getName());
			initConnections();
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	public static void main(String[] args) {
		try {
			javax.swing.JFrame frame = new javax.swing.JFrame();
			ChartAnalysisItemDeclarationPanel aChartAnalysisItemDeclarationPanel;
			aChartAnalysisItemDeclarationPanel = new ChartAnalysisItemDeclarationPanel();
			frame.setContentPane(aChartAnalysisItemDeclarationPanel);
			frame.setSize(aChartAnalysisItemDeclarationPanel.getSize());
			frame.addWindowListener(new java.awt.event.WindowAdapter() {
				public void windowClosing(java.awt.event.WindowEvent e) {
					System.exit(0);
				}
			});
			frame.show();
			java.awt.Insets insets = frame.getInsets();
			frame.setSize(
				frame.getWidth() + insets.left + insets.right,
				frame.getHeight() + insets.top + insets.bottom);
			frame.setVisible(true);
		} catch (Throwable exception) {
			System.err.println(
				"Exception occurred in main() of de.uniwue.ki.gui.mas.model.sim.analysis.AbstractAnalysisItemDeclarationPanel");
			exception.printStackTrace(System.out);
		}
	}

	public void setAnalysisItemDeclaration(IAnalysisItemDeclaration newAnalysisItemDeclaration) {
		IAnalysisItemDeclaration oldAnalysisItemDeclaration = getAnalysisItemDeclaration();

		if (oldAnalysisItemDeclaration != null) {
			oldAnalysisItemDeclaration.removePropertyChangeListener("color", _colorPropertyListener);
		}

		super.setAnalysisItemDeclaration(newAnalysisItemDeclaration);

		if (newAnalysisItemDeclaration != null) {
			getJButton1().setBackground(
				((ColorAnalysisItemDeclaration) newAnalysisItemDeclaration).getColor());

			newAnalysisItemDeclaration.addPropertyChangeListener("color", _colorPropertyListener);
		}
	}
}