package de.uniwue.ki.gui.mas.sim.analysis;
import javax.swing.JLabel;

import de.uniwue.ki.mas.sim.analysis.IAnalysisTypeDeclaration;
import de.uniwue.ki.mas.sim.analysis.SeriesChartAnalysisTypeDeclaration;
/**
 * Creation date: (28.11.2001 17:50:02)
 * @author Christoph Oechslein
 */
public class SeriesChartAnalysisTypeDeclarationPanel extends AbstractAnalysisTypeDeclarationPanel {

	private final class IvjEventHandler implements java.beans.PropertyChangeListener {
		public void propertyChange(java.beans.PropertyChangeEvent evt) {
			if (evt.getSource() == SeriesChartAnalysisTypeDeclarationPanel.this.getBoundJIntegerTextField1()
				&& (evt.getPropertyName().equals("integerValue")))
				connEtoC1(evt);
		}
	}
	private de.uniwue.ki.gui.util.bound.BoundJIntegerTextField ivjBoundJIntegerTextField1 = null;
	private com.magelang.box.Glue ivjBoxLayoutGlue1 = null;
	private final IvjEventHandler ivjEventHandler = new IvjEventHandler();
	private JLabel ivjJLabel1 = null;

	public SeriesChartAnalysisTypeDeclarationPanel() {
		super();
		initialize();
	}

	public boolean canEdit(IAnalysisTypeDeclaration newAnalysisTypeDeclaration) {
		return newAnalysisTypeDeclaration instanceof SeriesChartAnalysisTypeDeclaration;
	}

	/**
	 * connEtoC1:  (BoundJIntegerTextField1.integerValue --> SeriesChartAnalysisTypeDeclarationPanel.eventTextFieldWindowSizeChanged(I)V)
	 * @param arg1 java.beans.PropertyChangeEvent
	 */
	private void connEtoC1(java.beans.PropertyChangeEvent arg1) {
		try {
					eventTextFieldWindowSizeChanged(getBoundJIntegerTextField1().getIntegerValue());
				} catch (Throwable ivjExc) {
					handleException(ivjExc);
		}
	}

	protected IAnalysisTypeDeclaration createPrototypeAnalysisTypeDeclaration() {
		return new SeriesChartAnalysisTypeDeclaration();
	}

	protected void eventTextFieldWindowSizeChanged(int newValue) {
		((SeriesChartAnalysisTypeDeclaration)getAnalysisTypeDeclaration()).setWindowSize(newValue);
	}

	/**
	 * Return the BoundJIntegerTextField1 property value.
	 * @return de.uniwue.ki.gui.util.bound.BoundJIntegerTextField
	 */
	private de.uniwue.ki.gui.util.bound.BoundJIntegerTextField getBoundJIntegerTextField1() {
		if (ivjBoundJIntegerTextField1 == null) {
			try {
				ivjBoundJIntegerTextField1 = new de.uniwue.ki.gui.util.bound.BoundJIntegerTextField();
				ivjBoundJIntegerTextField1.setName("BoundJIntegerTextField1");
				ivjBoundJIntegerTextField1.setColumns(10);
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjBoundJIntegerTextField1;
	}

	/**
	 * Return the BoxLayoutGlue1 property value.
	 * @return com.magelang.box.BoxLayoutGlue
	 */
	private com.magelang.box.Glue getBoxLayoutGlue1() {
		if (ivjBoxLayoutGlue1 == null) {
			try {
				ivjBoxLayoutGlue1 = new com.magelang.box.Glue();
				ivjBoxLayoutGlue1.setName("BoxLayoutGlue1");
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjBoxLayoutGlue1;
	}

	/**
	 * Return the JLabel1 property value.
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel1() {
		if (ivjJLabel1 == null) {
			try {
				ivjJLabel1 = new javax.swing.JLabel();
				ivjJLabel1.setName("JLabel1");
				ivjJLabel1.setText("Window Size:");
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjJLabel1;
	}

	/**
	 * Called whenever the part throws an exception.
	 * @param exception Throwable
	 */
	private void handleException(Throwable exception) {

		exception.printStackTrace(System.out);
	}

	/**
	 * Initializes connections
	 * @exception Exception The exception description.
	 */
	private void initConnections() {
		getBoundJIntegerTextField1().addPropertyChangeListener(ivjEventHandler);
	}

	/**
	 * Initialize the class.
	 */
	private void initialize() {
		try {
					setName("SeriesChartAnalysisTypeDeclarationPanel");
			setLayout(new java.awt.GridBagLayout());
			setSize(194, 47);

			java.awt.GridBagConstraints constraintsJLabel1 = new java.awt.GridBagConstraints();
			constraintsJLabel1.gridx = 0;
			constraintsJLabel1.gridy = 0;
			constraintsJLabel1.anchor = java.awt.GridBagConstraints.WEST;
			constraintsJLabel1.insets = new java.awt.Insets(0, 0, 0, 4);
			add(getJLabel1(), constraintsJLabel1);

			java.awt.GridBagConstraints constraintsBoundJIntegerTextField1 =
				new java.awt.GridBagConstraints();
			constraintsBoundJIntegerTextField1.gridx = 1;
			constraintsBoundJIntegerTextField1.gridy = 0;
			constraintsBoundJIntegerTextField1.anchor = java.awt.GridBagConstraints.WEST;
			add(getBoundJIntegerTextField1(), constraintsBoundJIntegerTextField1);

			java.awt.GridBagConstraints constraintsBoxLayoutGlue1 = new java.awt.GridBagConstraints();
			constraintsBoxLayoutGlue1.gridx = 0;
			constraintsBoxLayoutGlue1.gridy = 1;
			constraintsBoxLayoutGlue1.gridwidth = 2;
			constraintsBoxLayoutGlue1.fill = java.awt.GridBagConstraints.BOTH;
			constraintsBoxLayoutGlue1.weightx = 1.0;
			constraintsBoxLayoutGlue1.weighty = 1.0;
			constraintsBoxLayoutGlue1.insets = new java.awt.Insets(4, 4, 4, 4);
			add(getBoxLayoutGlue1(), constraintsBoxLayoutGlue1);
			initConnections();
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	public static void main(String[] args) {
		try {
			javax.swing.JFrame frame = new javax.swing.JFrame();
			BlockChartAnalysisTypeDeclarationPanel aBlockChartAnalysisDeclarationTypePanel;
			aBlockChartAnalysisDeclarationTypePanel = new BlockChartAnalysisTypeDeclarationPanel();
			frame.setContentPane(aBlockChartAnalysisDeclarationTypePanel);
			frame.setSize(aBlockChartAnalysisDeclarationTypePanel.getSize());
			frame.addWindowListener(new java.awt.event.WindowAdapter() {
				public void windowClosing(java.awt.event.WindowEvent e) {
					System.exit(0);
				};
			});
			frame.pack();
			frame.show();
			java.awt.Insets insets = frame.getInsets();
			frame.setSize(
				frame.getWidth() + insets.left + insets.right,
				frame.getHeight() + insets.top + insets.bottom);
			frame.setVisible(true);
		} catch (Throwable exception) {
			System.err.println(
				"Exception occurred in main() of de.uniwue.ki.gui.mas.model.JPanelWithGUISeSAmDeclaration");
			exception.printStackTrace(System.out);
		}
	}

	public void setAnalysisTypeDeclaration(IAnalysisTypeDeclaration newAnalysisTypeDeclaration) {
		SeriesChartAnalysisTypeDeclaration seriesChartAnalysisTypeDeclaration =
			(SeriesChartAnalysisTypeDeclaration)newAnalysisTypeDeclaration;

		super.setAnalysisTypeDeclaration(seriesChartAnalysisTypeDeclaration);

		if (seriesChartAnalysisTypeDeclaration != null) {
			getBoundJIntegerTextField1().setIntegerValue(seriesChartAnalysisTypeDeclaration.getWindowSize());
		}
	}
}