package de.uniwue.ki.gui.mas.sim.analysis;
import javax.swing.*;
import javax.swing.table.TableColumn;

import de.uniwue.ki.gui.mas.model.JPanelWithGUISeSAmDeclaration;
import de.uniwue.ki.mas.sim.analysis.TableModelAnalysis;
/**
 * Creation date: (21.01.2002 18:16:52)
 * @author Christoph Oechslein
 */
public class TableModelAnalysisPanel extends JPanelWithGUISeSAmDeclaration {
	private JScrollPane ivjJScrollPane = null;
	private JTable ivjJTable = null;
	private TableColumn ivjTableColumnName = null;
	private TableColumn ivjTableColumnValue = null;

	public TableModelAnalysisPanel() {
		super();
		initialize();
	}

	private JScrollPane getJScrollPane() {
		if (ivjJScrollPane == null) {
			ivjJScrollPane = new JScrollPane();
			ivjJScrollPane.setName("JScrollPane");
			ivjJScrollPane.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED);
			ivjJScrollPane.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);
			getJScrollPane().setViewportView(getJTable());
		}
		return ivjJScrollPane;
	}

	private JTable getJTable() {
		if (ivjJTable == null) {
			ivjJTable = new JTable();
			ivjJTable.setAutoResizeMode(JTable.AUTO_RESIZE_LAST_COLUMN);
			ivjJTable.setName("JTable");
			getJScrollPane().setColumnHeaderView(ivjJTable.getTableHeader());
			ivjJTable.setBounds(0, 0, 200, 200);
			ivjJTable.setAutoCreateColumnsFromModel(false);
			ivjJTable.addColumn(getTableColumnName());
			ivjJTable.addColumn(getTableColumnValue());
		}
		return ivjJTable;
	}

	private TableColumn getTableColumnName() {
		if (ivjTableColumnName == null) {
			ivjTableColumnName = new TableColumn();
			ivjTableColumnName.setModelIndex(0);
			ivjTableColumnName.setHeaderValue("Name");
		}
		return ivjTableColumnName;
	}

	private TableColumn getTableColumnValue() {
		if (ivjTableColumnValue == null) {
			ivjTableColumnValue = new TableColumn();
			ivjTableColumnValue.setModelIndex(1);
			ivjTableColumnValue.setHeaderValue("Value");
		}
		return ivjTableColumnValue;
	}

	private void initialize() {
		setName("CSVAnalysisPanel");
		setSize(373, 390);
		add(getJScrollPane(), getJScrollPane().getName());
	}

	public void setTableModelAnalysis(TableModelAnalysis newTableModelAnalysis) {
		if (newTableModelAnalysis != null) {
			getJTable().setModel(newTableModelAnalysis.getTableModel());
		}
	}
}