package de.uniwue.ki.gui.mas.sim.experiment;
import javax.swing.*;

import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.util.JEditMutableListPanel;
import de.uniwue.ki.gui.util.NamedCellRendererAdapter;
import de.uniwue.ki.mas.sim.experiment.ExperimentList;
import de.uniwue.ki.mas.sim.experiment.IExperiment;
import de.uniwue.ki.util.name.INamed;

/**
* Insert the type's description here.
* Creation date: (11.10.2000 15:02:47)
* @author Christoph Oechslein
*/
public class ExperimentListPanel extends JEditMutableListPanel {
	private final IvjEventHandler ivjEventHandler = new IvjEventHandler();
	private boolean ivjConnPtoP1Aligning = false;
	private ExperimentList ivjExperimentList = null;
	private IGUISeSAmDeclaration ivjGUISeSAmDeclarationIntern = null;

	static class ExperimentCellRendererAdapter extends NamedCellRendererAdapter {

		public ExperimentCellRendererAdapter(ListCellRenderer cellRenderer) {
			super(cellRenderer);
		}

		protected Icon getIcon(INamed value) {
			return ExperimentListPanelHelper.getMarkerIcon((IExperiment) value);
		}
	}

	private final class IvjEventHandler implements java.beans.PropertyChangeListener {
		public void propertyChange(java.beans.PropertyChangeEvent evt) {
			if (evt.getSource() == ExperimentListPanel.this && (evt.getPropertyName().equals("model")))
				connPtoP1SetSource();
		};
	};

	/**
	 * WorldList constructor comment.
	 */
	public ExperimentListPanel() {
		super();
		initialize();
		setCellRenderer(new ExperimentCellRendererAdapter(getCellRenderer()));
	}

	public void addItem(Object obj) {
		if (obj != null)
			getExperimentList().add(obj);
	}

	/**
	 * connEtoM1:  (gUISeSAmDeclarationIntern.this --> ExperimentList.this)
	 * @param value IGUISeSAmDeclaration
	 */
	private void connEtoM1(IGUISeSAmDeclaration value) {
		try {
					setExperimentList(this.getExperimentList(getGUISeSAmDeclarationIntern()));
				} catch (Throwable ivjExc) {
					handleException(ivjExc);
		}
	}

	/**
	 * connPtoP1SetSource:  (ExperimentList.this <--> WorldList.model)
	 */
	private void connPtoP1SetSource() {
		try {
			if (ivjConnPtoP1Aligning == false) {
								ivjConnPtoP1Aligning = true;
				setExperimentList((de.uniwue.ki.mas.sim.experiment.ExperimentList) this.getModel());
								ivjConnPtoP1Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP1Aligning = false;
					handleException(ivjExc);
		}
	}

	/**
	 * connPtoP1SetTarget:  (ExperimentList.this <--> WorldList.model)
	 */
	private void connPtoP1SetTarget() {
		try {
			if (ivjConnPtoP1Aligning == false) {
								ivjConnPtoP1Aligning = true;
				if ((getExperimentList() != null)) {
					this.setModel(getExperimentList());
				}
								ivjConnPtoP1Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP1Aligning = false;
					handleException(ivjExc);
		}
	}

	public void addNewItem(boolean editAfterCreate) throws Exception {
		if (isEditable()) {
			ExperimentListPanelHelper.addExperimentInThread(this, getGUISeSAmDeclaration());
		}
	}

	protected void editExperiment(IExperiment experiment) {
		if (getGUISeSAmDeclaration().getPanelActionFactoryManager().getCanProduceActions(this, experiment)) {
			getGUISeSAmDeclaration().getPanelActionFactoryManager().callPropertyAction(this, experiment);
		}
	}

	public void editItem(Object obj) {
		editExperiment((IExperiment) obj);
	}

	private de.uniwue.ki.mas.sim.experiment.ExperimentList getExperimentList() {
		return ivjExperimentList;
	}

	protected ExperimentList getExperimentList(IGUISeSAmDeclaration gUISeSAmDeclaration) {

		return gUISeSAmDeclaration.getSeSAmDeclaration().getExperimentListAndFactory().getExperimentList();
	}

	/**
	 * Method generated to support the promotion of the gUISeSAmDeclaration attribute.
	 * @return IGUISeSAmDeclaration
	 */
	public IGUISeSAmDeclaration getGUISeSAmDeclaration() {
		return getGUISeSAmDeclarationIntern();
	}

	/**
	 * Return the gUISeSAmDeclarationIntern property value.
	 * @return IGUISeSAmDeclaration
	 */
	private IGUISeSAmDeclaration getGUISeSAmDeclarationIntern() {
		return ivjGUISeSAmDeclarationIntern;
	}

	/**
	 * Called whenever the part throws an exception.
	 * @param exception Throwable
	 */
	private void handleException(Throwable exception) {

		exception.printStackTrace(System.out);
	}

	/**
	 * Initializes connections
	 * @exception Exception The exception description.
	 */
	private void initConnections() {
		this.addPropertyChangeListener(ivjEventHandler);
		connPtoP1SetTarget();
	}

	/**
	 * Initialize the class.
	 */
	private void initialize() {
		try {
					setName("WorldList");
			setCellRenderer(new NamedCellRendererAdapter(getCellRenderer()));
			setSize(188, 237);
			initConnections();
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
		//enableDnDSupport();
	}

	public static void main(String[] args) {
		try {
			JFrame frame = new javax.swing.JFrame();
			ExperimentListPanel aExperimentList;
			aExperimentList = new ExperimentListPanel();
			frame.setContentPane(aExperimentList);
			frame.setSize(aExperimentList.getSize());
			frame.addWindowListener(new java.awt.event.WindowAdapter() {
				public void windowClosing(java.awt.event.WindowEvent e) {
					System.exit(0);
				};
			});
			frame.show();
			java.awt.Insets insets = frame.getInsets();
			frame.setSize(
				frame.getWidth() + insets.left + insets.right,
				frame.getHeight() + insets.top + insets.bottom);
			frame.setVisible(true);
		} catch (Throwable exception) {
			System.err.println("Exception occurred in main() of de.uniwue.ki.util.AbstractEditList");
			exception.printStackTrace(System.out);
		}
	}

	protected void popupItemIntern() {
		if (getGUISeSAmDeclaration() != null) {

			int x = getClickedPoint().x;
			int y = getClickedPoint().y;

			JPopupMenu jPopupMenu =
				getGUISeSAmDeclaration().getPanelActionFactoryManager().createPopup(this, getClickedValue());

			jPopupMenu.show(getJList(), x, y);
		}
	}

	public void removeItem(Object obj) {
		getExperimentList().remove(obj);

		((IExperiment) obj).remove();
	}

	private void setExperimentList(de.uniwue.ki.mas.sim.experiment.ExperimentList newValue) {
		if (ivjExperimentList != newValue) {
			try {
				ivjExperimentList = newValue;
				connPtoP1SetTarget();
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		};
	}

	/**
	 * Method generated to support the promotion of the gUISeSAmDeclaration attribute.
	 * @param arg1 IGUISeSAmDeclaration
	 */
	public void setGUISeSAmDeclaration(IGUISeSAmDeclaration arg1) {
		setGUISeSAmDeclarationIntern(arg1);
	}

	/**
	 * Set the gUISeSAmDeclarationIntern to a new value.
	 * @param newValue IGUISeSAmDeclaration
	 */
	private void setGUISeSAmDeclarationIntern(IGUISeSAmDeclaration newValue) {
		if (ivjGUISeSAmDeclarationIntern != newValue) {
			try {
				IGUISeSAmDeclaration oldValue = getGUISeSAmDeclarationIntern();
				ivjGUISeSAmDeclarationIntern = newValue;
				connEtoM1(ivjGUISeSAmDeclarationIntern);
				firePropertyChange("gUISeSAmDeclaration", oldValue, newValue);
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
	}

}