package de.uniwue.ki.gui.mas.sim.experiment;
import java.awt.GridBagConstraints;
import java.awt.event.*;
import java.beans.PropertyChangeListener;

import javax.swing.*;

import com.magelang.box.HorizontalStrut;

import de.uniwue.ki.gui.mas.model.GUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.model.JPanelWithGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.sim.simulation.StartPauseFinishControlPanel;
import de.uniwue.ki.gui.util.SwingMoreUtilities;
import de.uniwue.ki.gui.util.border.BetterTitledBorder;
import de.uniwue.ki.mas.sim.experiment.*;
import de.uniwue.ki.mas.sim.simulation.StartPauseFinishEvent;
import de.uniwue.ki.mas.sim.simulation.StartPauseFinishListener;
/**
 * Creation date: (30.01.2002 08:58:09)
 * @author Christoph Oechslein
 */
public class ExperimentPanel extends JPanelWithGUISeSAmDeclaration {
	private IExperiment ivjExperimentIntern = null;
	private HorizontalStrut ivjBoxLayoutHorizontalStrut1 = null;
	private final IvjEventHandler ivjEventHandler = new IvjEventHandler();
	private JButton ivjJButtonCurrentSimulation = null;
	private JLabel ivjJLabelName = null;
	private JLabel ivjJLabelStatus = null;
	private JTextField ivjJTextFieldName = null;
	private JTextField ivjJTextFieldStatus = null;
	private JTextField ivjJTextFieldConfigurationFile = null;
	private boolean ivjConnPtoP2Aligning = false;
	private boolean ivjConnPtoP3Aligning = false;
	private JLabel ivjJLabelSimName = null;
	private JPanel ivjJPanelSim = null;
	private JTextField ivjJTextFieldSimName = null;
	private com.magelang.box.HorizontalStrut ivjBoxLayoutHorizontalStrut2 = null;
	private JPanel ivjJPanelConfigFile = null;
	private JLabel ivjJLabelConfigFile = null;
	private JPanel ivjJPanelNameAndStatus = null;
	private StartPauseFinishControlPanel ivjStartPauseFinishControlPanel = null;

	class IvjEventHandler
		implements
			ExperimentListener,
			StartPauseFinishListener,
			ActionListener,
			PropertyChangeListener {
		public void actionPerformed(ActionEvent e) {
			if (e.getSource() == ExperimentPanel.this.getJButtonCurrentSimulation())
				connEtoC2(e);
		}
		public void currentSimulationChanged(ExperimentCurrentSimulationChangedEvent event) {
			if (event.getSource() == ExperimentPanel.this.getExperimentIntern())
				connEtoC3(event);
		}
		public void finished(de.uniwue.ki.mas.sim.simulation.StartPauseFinishEvent event) {
			if (event.getSource() == ExperimentPanel.this.getExperimentIntern())
				connEtoC4();
			if (event.getSource() == ExperimentPanel.this.getExperimentIntern())
				connEtoC5(event);
		}
		public void paused(de.uniwue.ki.mas.sim.simulation.StartPauseFinishEvent event) {
			if (event.getSource() == ExperimentPanel.this.getExperimentIntern())
				connEtoC4();
		}
		public void propertyChange(java.beans.PropertyChangeEvent evt) {
			if (evt.getSource() == ExperimentPanel.this
				&& (evt.getPropertyName().equals("gUISeSAmDeclaration")))
				connPtoP2SetTarget();
			if (evt.getSource() == ExperimentPanel.this.getStartPauseFinishControlPanel()
				&& (evt.getPropertyName().equals("gUISeSAmDeclaration")))
				connPtoP2SetSource();
			if (evt.getSource() == ExperimentPanel.this.getStartPauseFinishControlPanel()
				&& (evt.getPropertyName().equals("startPauseFinishInThreadAble")))
				connPtoP3SetSource();
		}
		public void started(de.uniwue.ki.mas.sim.simulation.StartPauseFinishEvent event) {
			if (event.getSource() == ExperimentPanel.this.getExperimentIntern())
				connEtoC4();
		}
	}

	/**
	 * ExperimentPanel constructor comment.
	 */
	public ExperimentPanel() {
		super();
		initialize();
	}

	/**
	 * connEtoC1:  (ExperimentIntern.this --> ExperimentPanel.eventExperimentChanged()V)
	 * @param value de.uniwue.ki.mas.model.sim.experiment.IExperiment
	 */
	private void connEtoC1(IExperiment value) {
		try {
					this.eventExperimentChanged();
				} catch (Throwable ivjExc) {
					handleException(ivjExc);
		}
	}

	/**
	 * connEtoC2:  (JButtonCurrentSimulation.action.actionPerformed(ActionEvent) --> ExperimentPanel.eventShowCurrentSimulation()V)
	 * @param arg1 ActionEvent
	 */
	private void connEtoC2(ActionEvent arg1) {
		try {
					this.eventShowCurrentSimulation();
				} catch (Throwable ivjExc) {
					handleException(ivjExc);
		}
	}

	/**
	 * connEtoC3:  (ExperimentIntern.experiment.currentSimulationChanged(de.uniwue.ki.mas.model.sim.experiment.ExperimentCurrentSimulationChangedEvent) --> ExperimentPanel.eventCurrentSimulationChanged()V)
	 * @param arg1 de.uniwue.ki.mas.model.sim.experiment.ExperimentCurrentSimulationChangedEvent
	 */
	private void connEtoC3(ExperimentCurrentSimulationChangedEvent arg1) {
		try {
					this.eventCurrentSimulationChanged();
				} catch (Throwable ivjExc) {
					handleException(ivjExc);
		}
	}

	/**
	 * connEtoC4:  (ExperimentIntern.experiment. --> ExperimentPanel.eventExperimentStateChanged()V)
	 */
	private void connEtoC4() {
		try {
					this.eventExperimentStateChanged();
				} catch (Throwable ivjExc) {
					handleException(ivjExc);
		}
	}

	/**
	 * connEtoC5:  (ExperimentIntern.experiment.finished(de.uniwue.ki.mas.model.sim.simulation.StartPauseFinishEvent) --> ExperimentPanel.eventExperimentFinished(Lde.uniwue.ki.mas.simulation.StartPauseFinishEvent;)V)
	 * @param arg1 de.uniwue.ki.mas.model.sim.simulation.StartPauseFinishEvent
	 */
	private void connEtoC5(de.uniwue.ki.mas.sim.simulation.StartPauseFinishEvent arg1) {
		try {
					this.eventExperimentFinished(arg1);
				} catch (Throwable ivjExc) {
					handleException(ivjExc);
		}
	}

	/**
	 * connPtoP1SetTarget:  (ExperimentIntern.name <--> JTextFieldName.text)
	 */
	private void connPtoP1SetTarget() {
		try {
			if ((getExperimentIntern() != null)) {
				getJTextFieldName().setText(getExperimentIntern().getName());
			}
				} catch (Throwable ivjExc) {
					handleException(ivjExc);
		}
	}

	/**
	 * connPtoP2SetSource:  (ExperimentPanel.gUISeSAmDeclaration <--> StartPauseFinishControlPanel1.gUISeSAmDeclaration)
	 */
	private void connPtoP2SetSource() {
		try {
			if (ivjConnPtoP2Aligning == false) {
								ivjConnPtoP2Aligning = true;
				this.setGUISeSAmDeclaration(getStartPauseFinishControlPanel().getGUISeSAmDeclaration());
								ivjConnPtoP2Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP2Aligning = false;
					handleException(ivjExc);
		}
	}

	/**
	 * connPtoP2SetTarget:  (ExperimentPanel.gUISeSAmDeclaration <--> StartPauseFinishControlPanel1.gUISeSAmDeclaration)
	 */
	private void connPtoP2SetTarget() {
		try {
			if (ivjConnPtoP2Aligning == false) {
								ivjConnPtoP2Aligning = true;
				getStartPauseFinishControlPanel().setGUISeSAmDeclaration(this.getGUISeSAmDeclaration());
								ivjConnPtoP2Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP2Aligning = false;
					handleException(ivjExc);
		}
	}

	/**
	 * connPtoP3SetSource:  (ExperimentIntern.this <--> StartPauseFinishControlPanel1.startPauseFinishInThreadAble)
	 */
	private void connPtoP3SetSource() {
		try {
			if (ivjConnPtoP3Aligning == false) {
								ivjConnPtoP3Aligning = true;
				setExperimentIntern(
					(IExperiment) getStartPauseFinishControlPanel().getStartPauseFinishInThreadAble());
								ivjConnPtoP3Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP3Aligning = false;
					handleException(ivjExc);
		}
	}

	/**
	 * connPtoP3SetTarget:  (ExperimentIntern.this <--> StartPauseFinishControlPanel1.startPauseFinishInThreadAble)
	 */
	private void connPtoP3SetTarget() {
		try {
			if (ivjConnPtoP3Aligning == false) {
								ivjConnPtoP3Aligning = true;
				if ((getExperimentIntern() != null)) {
					getStartPauseFinishControlPanel().setStartPauseFinishInThreadAble(getExperimentIntern());
				}
								ivjConnPtoP3Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP3Aligning = false;
					handleException(ivjExc);
		}
	}

	protected void eventCurrentSimulationChanged() {
		if (getExperiment() != null) {
			if (getExperiment().getCurrentSimulation() != null) {
				getJButtonCurrentSimulation().setEnabled(true);
				getJTextFieldSimName().setText(getExperiment().getCurrentSimulation().getName());

			} else {
				getJButtonCurrentSimulation().setEnabled(true);
			}
		}
	}

	protected void eventExperimentChanged() {
		if (getExperiment() != null) {

			if (getExperiment().getConfigurationFile() == null) {
				remove(getJPanelConfigFile());

			} else {
				getJTextFieldConfigurationFile().setText(getExperiment().getConfigurationFile() + "");
			}

			updateStatusText();
			eventCurrentSimulationChanged();
		}
	}

	protected void eventExperimentFinished(final StartPauseFinishEvent event) {
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				if (event.getException() != null) {
					GUISeSAmDeclaration.showException(
						getGUISeSAmDeclaration(),
						"Error during simulation",
						event.getException(),
						ExperimentPanel.this);
				}
			}
		});
	}

	protected void eventExperimentStateChanged() {
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				updateStatusText();
			}
		});
	}

	protected void eventShowCurrentSimulation() {
		if ((getExperiment() != null) && (getExperiment().getCurrentSimulation() != null)) {

			if (getGUISeSAmDeclaration()
				.getPanelActionFactoryManager()
				.getCanProduceActions(this, getExperiment().getCurrentSimulation())) {

				getGUISeSAmDeclaration().getPanelActionFactoryManager().callPropertyAction(
					this,
					getExperiment().getCurrentSimulation());
			}
		}
	}

	/**
	 * Return the BoxLayoutHorizontalStrut1 property value.
	 * @return com.magelang.box.BoxLayoutHorizontalStrut
	 */
	private com.magelang.box.HorizontalStrut getBoxLayoutHorizontalStrut1() {
		if (ivjBoxLayoutHorizontalStrut1 == null) {
			try {
				ivjBoxLayoutHorizontalStrut1 = new com.magelang.box.HorizontalStrut();
				ivjBoxLayoutHorizontalStrut1.setName("BoxLayoutHorizontalStrut1");
				ivjBoxLayoutHorizontalStrut1.setPixels(4);
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjBoxLayoutHorizontalStrut1;
	}

	/**
	 * Return the BoxLayoutHorizontalStrut2 property value.
	 * @return com.magelang.box.BoxLayoutHorizontalStrut
	 */
	private com.magelang.box.HorizontalStrut getBoxLayoutHorizontalStrut2() {
		if (ivjBoxLayoutHorizontalStrut2 == null) {
			try {
				ivjBoxLayoutHorizontalStrut2 = new com.magelang.box.HorizontalStrut();
				ivjBoxLayoutHorizontalStrut2.setName("BoxLayoutHorizontalStrut2");
				ivjBoxLayoutHorizontalStrut2.setPixels(4);
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjBoxLayoutHorizontalStrut2;
	}

	/**
	 * Method generated to support the promotion of the experiment attribute.
	 * @return de.uniwue.ki.mas.model.sim.experiment.IExperiment
	 */
	public IExperiment getExperiment() {
		return getExperimentIntern();
	}

	/**
	 * Return the ExperimentIntern property value.
	 * @return de.uniwue.ki.mas.model.sim.experiment.IExperiment
	 */
	private IExperiment getExperimentIntern() {
		return ivjExperimentIntern;
	}

	/**
	 * Return the JButtonCurrentSimulation property value.
	 * @return JButton
	 */
	private JButton getJButtonCurrentSimulation() {
		if (ivjJButtonCurrentSimulation == null) {
			try {
				ivjJButtonCurrentSimulation = new JButton();
				ivjJButtonCurrentSimulation.setName("JButtonCurrentSimulation");
				ivjJButtonCurrentSimulation.setIcon(
					SwingMoreUtilities.getJavaSunIcon(16, "general/Zoom16.gif"));
				ivjJButtonCurrentSimulation.setText("");
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjJButtonCurrentSimulation;
	}

	/**
	 * Return the JLabelConfigFile property value.
	 * @return JLabel
	 */
	private JLabel getJLabelConfigFile() {
		if (ivjJLabelConfigFile == null) {
			try {
				ivjJLabelConfigFile = new JLabel();
				ivjJLabelConfigFile.setName("JLabelConfigFile");
				ivjJLabelConfigFile.setText("Configuration File:  ");
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjJLabelConfigFile;
	}

	/**
	 * Return the JLabelName property value.
	 * @return JLabel
	 */
	private JLabel getJLabelName() {
		if (ivjJLabelName == null) {
			try {
				ivjJLabelName = new JLabel();
				ivjJLabelName.setName("JLabelName");
				ivjJLabelName.setText("Name:  ");
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjJLabelName;
	}

	/**
	 * Return the JLabelSimName property value.
	 * @return JLabel
	 */
	private JLabel getJLabelSimName() {
		if (ivjJLabelSimName == null) {
			try {
				ivjJLabelSimName = new JLabel();
				ivjJLabelSimName.setName("JLabelSimName");
				ivjJLabelSimName.setText("Name:  ");
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjJLabelSimName;
	}

	/**
	 * Return the JLabelStatus property value.
	 * @return JLabel
	 */
	private JLabel getJLabelStatus() {
		if (ivjJLabelStatus == null) {
			try {
				ivjJLabelStatus = new JLabel();
				ivjJLabelStatus.setName("JLabelStatus");
				ivjJLabelStatus.setText("Status:  ");
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjJLabelStatus;
	}

	/**
	 * Return the JPanel2 property value.
	 * @return JPanel
	 */
	private JPanel getJPanelConfigFile() {
		if (ivjJPanelConfigFile == null) {
			try {
				ivjJPanelConfigFile = new JPanel();
				ivjJPanelConfigFile.setName("JPanelConfigFile");
				ivjJPanelConfigFile.setLayout(
					new BoxLayout(getJPanelConfigFile(), BoxLayout.X_AXIS));
				getJPanelConfigFile().add(getJLabelConfigFile(), getJLabelConfigFile().getName());
				getJPanelConfigFile().add(
					getJTextFieldConfigurationFile(),
					getJTextFieldConfigurationFile().getName());
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjJPanelConfigFile;
	}

	/**
	 * Return the JPanelNameAndStatus property value.
	 * @return JPanel
	 */
	private JPanel getJPanelNameAndStatus() {
		if (ivjJPanelNameAndStatus == null) {
			try {
				ivjJPanelNameAndStatus = new JPanel();
				ivjJPanelNameAndStatus.setName("JPanelNameAndStatus");
				ivjJPanelNameAndStatus.setLayout(
					new BoxLayout(getJPanelNameAndStatus(), BoxLayout.X_AXIS));
				getJPanelNameAndStatus().add(getJLabelName(), getJLabelName().getName());
				getJPanelNameAndStatus().add(getJTextFieldName(), getJTextFieldName().getName());
				getJPanelNameAndStatus().add(
					getBoxLayoutHorizontalStrut1(),
					getBoxLayoutHorizontalStrut1().getName());
				getJPanelNameAndStatus().add(getJLabelStatus(), getJLabelStatus().getName());
				getJPanelNameAndStatus().add(getJTextFieldStatus(), getJTextFieldStatus().getName());
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjJPanelNameAndStatus;
	}

	/**
	 * Return the JPanelSim property value.
	 * @return JPanel
	 */
	private JPanel getJPanelSim() {
		if (ivjJPanelSim == null) {
			try {
				BetterTitledBorder ivjLocalBorder;
				ivjLocalBorder = new de.uniwue.ki.gui.util.border.BetterTitledBorder();
				ivjLocalBorder.setTitle("Current Simulation");
				ivjJPanelSim = new JPanel();
				ivjJPanelSim.setName("JPanelSim");
				ivjJPanelSim.setBorder(ivjLocalBorder);
				ivjJPanelSim.setLayout(getJPanelSimFlowLayout());
				getJPanelSim().add(getJLabelSimName(), getJLabelSimName().getName());
				getJPanelSim().add(getJTextFieldSimName(), getJTextFieldSimName().getName());
				getJPanelSim().add(getBoxLayoutHorizontalStrut2(), getBoxLayoutHorizontalStrut2().getName());
				getJPanelSim().add(getJButtonCurrentSimulation(), getJButtonCurrentSimulation().getName());
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjJPanelSim;
	}

	/**
	 * Return the JPanelSimFlowLayout property value.
	 * @return java.awt.FlowLayout
	 */
	private java.awt.FlowLayout getJPanelSimFlowLayout() {
		java.awt.FlowLayout ivjJPanelSimFlowLayout = null;
		try {
			/* Create part */
			ivjJPanelSimFlowLayout = new java.awt.FlowLayout();
			ivjJPanelSimFlowLayout.setAlignment(java.awt.FlowLayout.LEFT);
			ivjJPanelSimFlowLayout.setVgap(0);
			ivjJPanelSimFlowLayout.setHgap(0);
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
		return ivjJPanelSimFlowLayout;
	}

	/**
	 * Return the JTextFieldConfigurationFile property value.
	 * @return JTextField
	 */
	private JTextField getJTextFieldConfigurationFile() {
		if (ivjJTextFieldConfigurationFile == null) {
			try {
				ivjJTextFieldConfigurationFile = new JTextField();
				ivjJTextFieldConfigurationFile.setName("JTextFieldConfigurationFile");
				ivjJTextFieldConfigurationFile.setEditable(false);
				ivjJTextFieldConfigurationFile.setColumns(10);
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjJTextFieldConfigurationFile;
	}

	/**
	 * Return the JTextFieldName property value.
	 * @return JTextField
	 */
	private JTextField getJTextFieldName() {
		if (ivjJTextFieldName == null) {
			try {
				ivjJTextFieldName = new JTextField();
				ivjJTextFieldName.setName("JTextFieldName");
				ivjJTextFieldName.setEditable(false);
				ivjJTextFieldName.setColumns(10);
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjJTextFieldName;
	}

	/**
	 * Return the JTextFieldSimName property value.
	 * @return JTextField
	 */
	private JTextField getJTextFieldSimName() {
		if (ivjJTextFieldSimName == null) {
			try {
				ivjJTextFieldSimName = new JTextField();
				ivjJTextFieldSimName.setName("JTextFieldSimName");
				ivjJTextFieldSimName.setEditable(false);
				ivjJTextFieldSimName.setColumns(10);
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjJTextFieldSimName;
	}

	/**
	 * Return the JTextFieldStatus property value.
	 * @return JTextField
	 */
	private JTextField getJTextFieldStatus() {
		if (ivjJTextFieldStatus == null) {
			try {
				ivjJTextFieldStatus = new JTextField();
				ivjJTextFieldStatus.setName("JTextFieldStatus");
				ivjJTextFieldStatus.setEditable(false);
				ivjJTextFieldStatus.setColumns(10);
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjJTextFieldStatus;
	}

	/**
	 * Return the StartPauseFinishControlPanel property value.
	 * @return de.uniwue.ki.gui.mas.model.sim.simulation.StartPauseFinishControlPanel
	 */
	private StartPauseFinishControlPanel getStartPauseFinishControlPanel() {
		if (ivjStartPauseFinishControlPanel == null) {
			try {
				ivjStartPauseFinishControlPanel = new StartPauseFinishControlPanel();
				ivjStartPauseFinishControlPanel.setName("StartPauseFinishControlPanel");
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjStartPauseFinishControlPanel;
	}

	private void handleException(Throwable exception) {
		exception.printStackTrace(System.out);
	}

	/**
	 * Initializes connections
	 * @exception Exception The exception description.
	 */
	private void initConnections() {
		getJButtonCurrentSimulation().addActionListener(ivjEventHandler);
		this.addPropertyChangeListener(ivjEventHandler);
		getStartPauseFinishControlPanel().addPropertyChangeListener(ivjEventHandler);
		connPtoP1SetTarget();
		connPtoP2SetTarget();
		connPtoP3SetTarget();
	}

	/**
	 * Initialize the class.
	 */
	private void initialize() {
		try {
					setName("ExperimentPanel");
			setLayout(new java.awt.GridBagLayout());
			setSize(421, 111);

			java.awt.GridBagConstraints constraintsJPanelNameAndStatus = new java.awt.GridBagConstraints();
			constraintsJPanelNameAndStatus.gridx = 0;
			constraintsJPanelNameAndStatus.gridy = 0;
			constraintsJPanelNameAndStatus.gridwidth = 2;
			constraintsJPanelNameAndStatus.fill = java.awt.GridBagConstraints.HORIZONTAL;
			constraintsJPanelNameAndStatus.anchor = java.awt.GridBagConstraints.WEST;
			constraintsJPanelNameAndStatus.weightx = 1.0;
			add(getJPanelNameAndStatus(), constraintsJPanelNameAndStatus);

			java.awt.GridBagConstraints constraintsJPanelConfigFile = new java.awt.GridBagConstraints();
			constraintsJPanelConfigFile.gridx = 0;
			constraintsJPanelConfigFile.gridy = 1;
			constraintsJPanelConfigFile.gridwidth = 2;
			constraintsJPanelConfigFile.fill = java.awt.GridBagConstraints.BOTH;
			constraintsJPanelConfigFile.insets = new java.awt.Insets(4, 0, 0, 0);
			add(getJPanelConfigFile(), constraintsJPanelConfigFile);

			java.awt.GridBagConstraints constraintsStartPauseFinishControlPanel =
				new java.awt.GridBagConstraints();
			constraintsStartPauseFinishControlPanel.gridx = 0;
			constraintsStartPauseFinishControlPanel.gridy = 2;
			constraintsStartPauseFinishControlPanel.anchor = java.awt.GridBagConstraints.NORTHWEST;
			constraintsStartPauseFinishControlPanel.weightx = 1.0;
			constraintsStartPauseFinishControlPanel.weighty = 1.0;
			constraintsStartPauseFinishControlPanel.insets = new java.awt.Insets(4, 0, 0, 0);
			add(getStartPauseFinishControlPanel(), constraintsStartPauseFinishControlPanel);

			java.awt.GridBagConstraints constraintsJPanelSim = new java.awt.GridBagConstraints();
			constraintsJPanelSim.gridx = 1;
			constraintsJPanelSim.gridy = 2;
			constraintsJPanelSim.anchor = java.awt.GridBagConstraints.NORTHWEST;
			constraintsJPanelSim.weightx = 1.0;
			constraintsJPanelSim.weighty = 1.0;
			constraintsJPanelSim.fill = GridBagConstraints.HORIZONTAL;
			constraintsJPanelSim.insets = new java.awt.Insets(4, 4, 0, 0);
			add(getJPanelSim(), constraintsJPanelSim);
			initConnections();
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	public static void main(String[] args) {
		try {
			JFrame frame = new JFrame();
			ExperimentPanel aExperimentPanel;
			aExperimentPanel = new ExperimentPanel();
			frame.setContentPane(aExperimentPanel);
			frame.setSize(aExperimentPanel.getSize());
			frame.addWindowListener(new WindowAdapter() {
				public void windowClosing(WindowEvent e) {
					System.exit(0);
				};
			});
			frame.show();
			java.awt.Insets insets = frame.getInsets();
			frame.setSize(
				frame.getWidth() + insets.left + insets.right,
				frame.getHeight() + insets.top + insets.bottom);
			frame.setVisible(true);
		} catch (Throwable exception) {
			System.err.println(
				"Exception occurred in main() of de.uniwue.ki.gui.mas.model.JPanelWithGUISeSAmDeclaration");
			exception.printStackTrace(System.out);
		}
	}

	/**
	 * Method generated to support the promotion of the experiment attribute.
	 * @param arg1 de.uniwue.ki.mas.model.sim.experiment.IExperiment
	 */
	public void setExperiment(IExperiment arg1) {
		setExperimentIntern(arg1);
	}

	/**
	 * Set the ExperimentIntern to a new value.
	 * @param newValue de.uniwue.ki.mas.model.sim.experiment.IExperiment
	 */
	private void setExperimentIntern(IExperiment newValue) {
		if (ivjExperimentIntern != newValue) {
			try {
				IExperiment oldValue = getExperimentIntern();
				/* Stop listening for events from the current object */
				if (ivjExperimentIntern != null) {
					ivjExperimentIntern.removeExperimentListener(ivjEventHandler);
					ivjExperimentIntern.removeStartPauseFinishListener(ivjEventHandler);
				}
				ivjExperimentIntern = newValue;

				/* Listen for events from the new object */
				if (ivjExperimentIntern != null) {
					ivjExperimentIntern.addExperimentListener(ivjEventHandler);
					ivjExperimentIntern.addStartPauseFinishListener(ivjEventHandler);
				}
				connEtoC1(ivjExperimentIntern);
				connPtoP1SetTarget();
				connPtoP3SetTarget();
				firePropertyChange("experiment", oldValue, newValue);
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
	}

	protected void updateStatusText() {
		if (getExperiment() != null) {
			if (getExperiment().isRunning())
				getJTextFieldStatus().setText("Running");

			else if (getExperiment().isFinished())
				getJTextFieldStatus().setText("Finished");

			else if (getExperiment().isFinishedWithErrors())
				getJTextFieldStatus().setText("Finished With Errors");

			else if (getExperiment().isPaused())
				getJTextFieldStatus().setText("Paused");

			else
				getJTextFieldStatus().setText("Initialized");

			if (getExperiment().getCurrentSimulation() != null)
				getJTextFieldSimName().setText(getExperiment().getCurrentSimulation().getName());
			else
				getJTextFieldSimName().setText("");
		}
	}
}