package de.uniwue.ki.gui.mas.sim.simulation;

import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.*;

import junit.framework.Assert;
import de.uniwue.ki.gui.mas.basics.functionArgument.FunctionCallDeclarationTreeListPanelWithArgsDecl;
import de.uniwue.ki.gui.mas.basics.functionCall.FunctionCallDeclarationListWithSelectionPanel;
import de.uniwue.ki.gui.mas.basics.functionCall.FunctionCallDeclarationTreeListPanel;
import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.sim.analysis.AnalysisDeclarationListToAnalysisDeclarationList;
import de.uniwue.ki.gui.mas.util.declaration.AbstractDeclarationPanel;
import de.uniwue.ki.gui.util.actions.AbstractBoundAction;
import de.uniwue.ki.mas.basics.functionArgument.IFunctionArgumentDeclarationList;
import de.uniwue.ki.mas.sim.simulation.ISimulationWithNameFunctionCallDeclDeclaration;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: 17.10.2002, 11:00:51
 * @author oechslein
 */
public class SimulationWithNameFunctionCallDeclDeclarationPanel extends AbstractDeclarationPanel {
	private FunctionCallDeclarationListWithSelectionPanel _afterTestActionFunctionCallDeclListWithSelectionPanel =
		null;

	private FunctionCallDeclarationListWithSelectionPanel _duringTestActionFunctionCallDeclListWithSelectionPanel =
		null;
	private ISimulationWithNameFunctionCallDeclDeclaration _simulationWithNameFunctionCallDeclDeclaration;
	private AnalysisDeclarationListToAnalysisDeclarationList ivjAnalysisDeclarationListToAnalysisDeclarationList =
		null;
	private FunctionCallDeclarationListWithSelectionPanel ivjEndFunctionCallDeclarationListWithSelectionPanel =
		null;
	private FunctionCallDeclarationTreeListPanel ivjFunctionCallDeclarationTreeListPanel = null;
	private JTabbedPane _tabbedPane = null;

	private JCheckBox _checkBoxTest;

	public SimulationWithNameFunctionCallDeclDeclarationPanel() {
		super();
		initialize();
	}

	public void dispose() {
		getFunctionCallDeclarationTreeListPanel().dispose();
		getAnalysisDeclarationListToAnalysisDeclarationList().dispose();
		getEndFunctionCallDeclarationListWithSelectionPanel().dispose();
		getAfterTestActionFunctionCallDeclListWithSelectionPanel().dispose();
		getDuringTestActionFunctionCallDeclListWithSelectionPanel().dispose();

		super.dispose();
	}

	private FunctionCallDeclarationListWithSelectionPanel getAfterTestActionFunctionCallDeclListWithSelectionPanel() {
		if (_afterTestActionFunctionCallDeclListWithSelectionPanel == null) {
			_afterTestActionFunctionCallDeclListWithSelectionPanel =
				SimulationDeclarationPanel.createTestActionFunctionCallDeclListWithSelectionPanel();
		}
		return _afterTestActionFunctionCallDeclListWithSelectionPanel;
	}

	/**
	 * This method initializes ivjAnalysisDeclarationListToAnalysisDeclarationList
	 * 
	 * @return AnalysisDeclarationListToAnalysisDeclarationList
	 */
	private AnalysisDeclarationListToAnalysisDeclarationList getAnalysisDeclarationListToAnalysisDeclarationList() {
		if (ivjAnalysisDeclarationListToAnalysisDeclarationList == null) {
			ivjAnalysisDeclarationListToAnalysisDeclarationList =
				new AnalysisDeclarationListToAnalysisDeclarationList();
		}
		return ivjAnalysisDeclarationListToAnalysisDeclarationList;
	}

	public final IDeclaration getDeclaration() {
		return getSimulationWithNameFunctionCallDeclDeclaration();
	}

	private FunctionCallDeclarationListWithSelectionPanel getDuringTestActionFunctionCallDeclListWithSelectionPanel() {
		if (_duringTestActionFunctionCallDeclListWithSelectionPanel == null) {
			_duringTestActionFunctionCallDeclListWithSelectionPanel =
				SimulationDeclarationPanel.createTestActionFunctionCallDeclListWithSelectionPanel();
		}
		return _duringTestActionFunctionCallDeclListWithSelectionPanel;
	}
	/**
	 * This method initializes ivjEndFunctionCallDeclarationListWithSelectionPanel
	 * 
	 * @return EndFunctionCallDeclarationListWithSelectionPanel
	 */
	private FunctionCallDeclarationListWithSelectionPanel getEndFunctionCallDeclarationListWithSelectionPanel() {
		if (ivjEndFunctionCallDeclarationListWithSelectionPanel == null) {
			ivjEndFunctionCallDeclarationListWithSelectionPanel =
				new FunctionCallDeclarationListWithSelectionPanel();
		}
		return ivjEndFunctionCallDeclarationListWithSelectionPanel;
	}

	/**
	 * This method initializes ivjFunctionCallDeclarationTreeListPanel
	 * 
	 * @return FunctionCallDeclarationTreeListPanel
	 */
	private FunctionCallDeclarationTreeListPanel getFunctionCallDeclarationTreeListPanel() {
		if (ivjFunctionCallDeclarationTreeListPanel == null) {
			ivjFunctionCallDeclarationTreeListPanel = new FunctionCallDeclarationTreeListPanelWithArgsDecl();
		}
		return ivjFunctionCallDeclarationTreeListPanel;
	}

	/**
	 * This method initializes ivjJTabbedPane
	 * 
	 * @return JTabbedPane
	 */
	private JTabbedPane getJTabbedPane() {
		if (_tabbedPane == null) {
			_tabbedPane = new JTabbedPane();

			JPanel panel = new JPanel(new BorderLayout());
			JPanel panel2 = new JPanel(new FlowLayout(FlowLayout.RIGHT));

			panel2.add(getCheckBoxTest());

			panel.add(panel2, BorderLayout.NORTH);
			panel.add(getFunctionCallDeclarationTreeListPanel(), BorderLayout.CENTER);

			_tabbedPane.addTab("Name", panel);
			_tabbedPane.addTab("Analysis", getAnalysisDeclarationListToAnalysisDeclarationList());
			_tabbedPane.addTab("End Functions", getEndFunctionCallDeclarationListWithSelectionPanel());
			_tabbedPane.addTab(
				"During Run Tests",
				getDuringTestActionFunctionCallDeclListWithSelectionPanel());
			_tabbedPane.addTab("After Run Tests", getAfterTestActionFunctionCallDeclListWithSelectionPanel());
		}
		return _tabbedPane;
	}

	public void setEnabled(boolean newEnabled) {
		super.setEnabled(newEnabled);

		updateTestTabsEnabledState();
	}

	public IFunctionArgumentDeclarationList getOuterFunctionArgumentDeclarationList() {
		Assert.assertSame(
			getEndFunctionCallDeclarationListWithSelectionPanel().getOuterFunctionArgumentDeclarationList(),
			getFunctionCallDeclarationTreeListPanel().getOuterFunctionArgumentDeclarationList());

		return getEndFunctionCallDeclarationListWithSelectionPanel()
			.getOuterFunctionArgumentDeclarationList();
	}

	public ISimulationWithNameFunctionCallDeclDeclaration getSimulationWithNameFunctionCallDeclDeclaration() {
		return _simulationWithNameFunctionCallDeclDeclaration;
	}
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		setLayout(new BorderLayout());
		add(getJTabbedPane(), BorderLayout.CENTER);

		updateTestTabsEnabledState();
	}

	private JCheckBox getCheckBoxTest() {
		if (_checkBoxTest == null) {
			_checkBoxTest = new JCheckBox(new AbstractBoundAction("Test") {
				public void doit() {
					if (getSimulationWithNameFunctionCallDeclDeclaration() != null) {
						getSimulationWithNameFunctionCallDeclDeclaration().setTestSimulationDeclaration(
							_checkBoxTest.isSelected());
					}

					updateTestTabsEnabledState();
				}
			});
		}

		return _checkBoxTest;
	}

	private void updateTestTabsEnabledState() {
		getJTabbedPane().setEnabledAt(3, getCheckBoxTest().isSelected() && isEnabled());
		getJTabbedPane().setEnabledAt(4, getCheckBoxTest().isSelected() && isEnabled());

		if (getJTabbedPane().getSelectedIndex() >= 3) {
			getJTabbedPane().setSelectedIndex(0);
		}
	}

	public final void setDeclaration(IDeclaration declaration) {
		setSimulationWithNameFunctionCallDeclDeclaration(
			(ISimulationWithNameFunctionCallDeclDeclaration)declaration);
	}

	public void setGUISeSAmDeclaration(IGUISeSAmDeclaration guiSeSAmDeclaration) {
		super.setGUISeSAmDeclaration(guiSeSAmDeclaration);

		getFunctionCallDeclarationTreeListPanel().setGUISeSAmDeclaration(guiSeSAmDeclaration);
		getAnalysisDeclarationListToAnalysisDeclarationList().setGUISeSAmDeclaration(guiSeSAmDeclaration);
		getEndFunctionCallDeclarationListWithSelectionPanel().setGUISeSAmDeclaration(guiSeSAmDeclaration);
		getAfterTestActionFunctionCallDeclListWithSelectionPanel().setGUISeSAmDeclaration(
			guiSeSAmDeclaration);
		getDuringTestActionFunctionCallDeclListWithSelectionPanel().setGUISeSAmDeclaration(
			guiSeSAmDeclaration);
	}

	public void setOuterFunctionArgumentDeclarationList(IFunctionArgumentDeclarationList functionArgumentDeclarationList) {
		getEndFunctionCallDeclarationListWithSelectionPanel().setOuterFunctionArgumentDeclarationList(
			functionArgumentDeclarationList);
		getFunctionCallDeclarationTreeListPanel().setOuterFunctionArgumentDeclarationList(
			functionArgumentDeclarationList);
	}

	public void setSimulationWithNameFunctionCallDeclDeclaration(ISimulationWithNameFunctionCallDeclDeclaration simulationWithNameFunctionCallDeclDeclaration) {
		_simulationWithNameFunctionCallDeclDeclaration = simulationWithNameFunctionCallDeclDeclaration;

		if (simulationWithNameFunctionCallDeclDeclaration != null) {
			getFunctionCallDeclarationTreeListPanel().setFunctionCallDeclaration(
				simulationWithNameFunctionCallDeclDeclaration.getNameFunctionCallDeclaration());
			getAnalysisDeclarationListToAnalysisDeclarationList().setAnalysisDeclarationList(
				simulationWithNameFunctionCallDeclDeclaration.getAnalysisDeclarationList());
			getEndFunctionCallDeclarationListWithSelectionPanel().setDeclarationListAndFactory(
				simulationWithNameFunctionCallDeclDeclaration.getEndFunctionDeclarationListAndFactory());
			getDuringTestActionFunctionCallDeclListWithSelectionPanel().setDeclarationListModel(
				simulationWithNameFunctionCallDeclDeclaration.getDuringRunTestActionDefinitionList());
			getAfterTestActionFunctionCallDeclListWithSelectionPanel().setDeclarationListModel(
				simulationWithNameFunctionCallDeclDeclaration.getAfterRunTestActionDefinitionList());
		}
	}
}
