package de.uniwue.ki.gui.mas.sim.simulation;
import javax.swing.JToggleButton;
import javax.swing.SwingUtilities;

import junit.framework.Assert;
import de.uniwue.ki.gui.mas.model.JPanelWithGUISeSAmDeclaration;
import de.uniwue.ki.gui.util.SwingMoreUtilities;
import de.uniwue.ki.mas.sim.simulation.*;
/**
 * Creation date: (23.01.2002 13:35:05)
 * @author Chripauseh Oechslein
 */
public class StartPauseFinishControlPanel extends JPanelWithGUISeSAmDeclaration {
	private com.magelang.box.HorizontalStrut ivjBoxLayoutHorizontalStrut12 = null;
	private JToggleButton ivjJToggleButtonPause = null;
	private JToggleButton ivjJToggleButtonPlay = null;
	private final IvjEventHandler ivjEventHandler = new IvjEventHandler();
	private IStartPauseFinishInThreadAble ivjStartPauseFinishInThreadAbleIntern = null;

	private final class IvjEventHandler implements StartPauseFinishListener, java.awt.event.ActionListener {
		public void actionPerformed(java.awt.event.ActionEvent e) {
			if (e.getSource() == StartPauseFinishControlPanel.this.getJToggleButtonPlay())
				connEtoC2(e);
			if (e.getSource() == StartPauseFinishControlPanel.this.getJToggleButtonPause())
				connEtoC3(e);
		}
		public void finished(StartPauseFinishEvent event) {
			if (event.getSource()
				== StartPauseFinishControlPanel.this.getStartPauseFinishInThreadAbleIntern())
				connEtoC1();
			if (event.getSource()
				== StartPauseFinishControlPanel.this.getStartPauseFinishInThreadAbleIntern())
				connEtoC7(event);
		}
		public void paused(StartPauseFinishEvent event) {
			if (event.getSource()
				== StartPauseFinishControlPanel.this.getStartPauseFinishInThreadAbleIntern())
				connEtoC1();
		}
		public void started(StartPauseFinishEvent event) {
			if (event.getSource()
				== StartPauseFinishControlPanel.this.getStartPauseFinishInThreadAbleIntern())
				connEtoC1();
		}
	}

	/**
	 * ThreadedSimulationControlPanel constructor comment.
	 */
	public StartPauseFinishControlPanel() {
		super();
		initialize();
	}

	/**
	 * connEtoC1:  (StartPauseFinishInThreadAbleIntern.startPauseFinish. --> StartPauseFinishControlPanel.eventStartPauseFinishFiredEvent()V)
	 */
	private void connEtoC1() {
		try {
					this.eventStartPauseFinishFiredEvent();
				} catch (Throwable ivjExc) {
					handleException(ivjExc);
		}
	}

	/**
	 * connEtoC2:  (JToggleButtonPlay.action.actionPerformed(java.awt.event.ActionEvent) --> StartPauseFinishControlPanel.eventPlayButtonPressed()V)
	 * @param arg1 java.awt.event.ActionEvent
	 */
	private void connEtoC2(java.awt.event.ActionEvent arg1) {
		try {
					this.eventPlayButtonPressed();
				} catch (Throwable ivjExc) {
					handleException(ivjExc);
		}
	}

	/**
	 * connEtoC3:  (JToggleButtonPause.action.actionPerformed(java.awt.event.ActionEvent) --> StartPauseFinishControlPanel.eventPauseButtonPressed()V)
	 * @param arg1 java.awt.event.ActionEvent
	 */
	private void connEtoC3(java.awt.event.ActionEvent arg1) {
		try {
					this.eventPauseButtonPressed();
				} catch (Throwable ivjExc) {
					handleException(ivjExc);
		}
	}

	/**
	 * connEtoC7:  (StartPauseFinishInThreadAbleIntern.startPauseFinish.finished(de.uniwue.ki.mas.model.sim.simulation.StartPauseFinishEvent) --> StartPauseFinishControlPanel.eventFinished(Lde.uniwue.ki.mas.simulation.StartPauseFinishEvent;)V)
	 * @param arg1 de.uniwue.ki.mas.model.sim.simulation.StartPauseFinishEvent
	 */
	private void connEtoC7(StartPauseFinishEvent arg1) {
		try {
					this.eventFinished(arg1);
				} catch (Throwable ivjExc) {
					handleException(ivjExc);
		}
	}

	public void dispose() {
		setStartPauseFinishInThreadAble(null);

		super.dispose();
	}

	protected void eventFinished(final StartPauseFinishEvent startPauseFinishEvent) {
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				eventFinishedIntern(startPauseFinishEvent);
			}
		});
	}

	protected void eventFinishedIntern(StartPauseFinishEvent startPauseFinishEvent) {
		if (Assert.ASSERTION_ON)
			Assert.assertTrue(SwingUtilities.isEventDispatchThread());

		if (startPauseFinishEvent.getException() != null) {
			// getGUISeSAmDeclaration().showException(startPauseFinishEvent, this);
		}
	}

	protected void eventPauseButtonPressed() {
		if (getStartPauseFinishInThreadAble() != null) {

			if (getStartPauseFinishInThreadAble().isPaused()) {
				getJToggleButtonPause().setSelected(true);

			} else if (
				getStartPauseFinishInThreadAble().isFinished()
					|| getStartPauseFinishInThreadAble().isFinishedWithErrors()) {
				getJToggleButtonPause().setSelected(false);

			} else {
				getStartPauseFinishInThreadAble().pauseInThread();
			}

			getJToggleButtonPlay().setSelected(false);
		}
	}

	protected void eventPlayButtonPressed() {
		if (getStartPauseFinishInThreadAble() != null) {

			if (getStartPauseFinishInThreadAble().isRunning()) {
				getJToggleButtonPlay().setSelected(true);

			} else if (
				getStartPauseFinishInThreadAble().isFinished()
					|| getStartPauseFinishInThreadAble().isFinishedWithErrors()) {
				getJToggleButtonPlay().setSelected(false);

			} else {
				getStartPauseFinishInThreadAble().startInThread();
			}

			getJToggleButtonPause().setSelected(false);
		}
	}

	protected void eventStartPauseFinishFiredEvent() {
		if (getStartPauseFinishInThreadAble() != null) {
			SwingUtilities.invokeLater(new Runnable() {
				public void run() {
					initButtons();
				}
			});
		}
	}

	/**
	 * Return the BoxLayoutHorizontalStrut12 property value.
	 * @return com.magelang.box.BoxLayoutHorizontalStrut
	 */
	private com.magelang.box.HorizontalStrut getBoxLayoutHorizontalStrut12() {
		if (ivjBoxLayoutHorizontalStrut12 == null) {
			try {
				ivjBoxLayoutHorizontalStrut12 = new com.magelang.box.HorizontalStrut();
				ivjBoxLayoutHorizontalStrut12.setName("BoxLayoutHorizontalStrut12");
				ivjBoxLayoutHorizontalStrut12.setPixels(7);
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjBoxLayoutHorizontalStrut12;
	}

	/**
	 * Return the JToggleButtonPause property value.
	 * @return javax.swing.JToggleButton
	 */
	private javax.swing.JToggleButton getJToggleButtonPause() {
		if (ivjJToggleButtonPause == null) {
			try {
				ivjJToggleButtonPause = new javax.swing.JToggleButton();
				ivjJToggleButtonPause.setName("JToggleButtonPause");
				ivjJToggleButtonPause.setText("Pause");
						ivjJToggleButtonPause.setIcon(SwingMoreUtilities.getJavaSunIcon(16, "media/Pause16.gif"));
					} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjJToggleButtonPause;
	}

	/**
	 * Return the JToggleButtonPlay property value.
	 * @return javax.swing.JToggleButton
	 */
	private javax.swing.JToggleButton getJToggleButtonPlay() {
		if (ivjJToggleButtonPlay == null) {
			try {
				ivjJToggleButtonPlay = new javax.swing.JToggleButton();
				ivjJToggleButtonPlay.setName("JToggleButtonPlay");
				ivjJToggleButtonPlay.setText("Play");
						ivjJToggleButtonPlay.setIcon(SwingMoreUtilities.getJavaSunIcon(16, "media/Play16.gif"));
					} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjJToggleButtonPlay;
	}

	/**
	 * Return the SimulationControlPanelFlowLayout property value.
	 * @return java.awt.FlowLayout
	 */
	private java.awt.FlowLayout getSimulationControlPanelFlowLayout() {
		java.awt.FlowLayout ivjSimulationControlPanelFlowLayout = null;
		try {
			/* Create part */
			ivjSimulationControlPanelFlowLayout = new java.awt.FlowLayout();
			ivjSimulationControlPanelFlowLayout.setAlignment(java.awt.FlowLayout.LEFT);
			ivjSimulationControlPanelFlowLayout.setVgap(0);
			ivjSimulationControlPanelFlowLayout.setHgap(0);
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
		return ivjSimulationControlPanelFlowLayout;
	}

	/**
	 * Method generated to support the promotion of the startPauseFinishInThreadAble attribute.
	 * @return de.uniwue.ki.mas.model.sim.simulation.IStartPauseFinishInThreadAble
	 */
	public IStartPauseFinishInThreadAble getStartPauseFinishInThreadAble() {
		return getStartPauseFinishInThreadAbleIntern();
	}

	/**
	 * Return the ThreadedSimulationIntern property value.
	 * @return de.uniwue.ki.mas.model.sim.simulation.IThreadedSimulation
	 */
	private IStartPauseFinishInThreadAble getStartPauseFinishInThreadAbleIntern() {
		return ivjStartPauseFinishInThreadAbleIntern;
	}

	/**
	 * Called whenever the part throws an exception.
	 * @param exception Throwable
	 */
	private void handleException(Throwable exception) {

		exception.printStackTrace(System.out);
	}

	protected void initButtons() {
		getJToggleButtonPause().setEnabled(true);
		getJToggleButtonPlay().setEnabled(true);

		getJToggleButtonPause().setSelected(false);
		getJToggleButtonPlay().setSelected(false);

		if (getStartPauseFinishInThreadAble() != null) {

			if (getStartPauseFinishInThreadAble().isRunning()) {
				getJToggleButtonPlay().setSelected(true);

			} else if (getStartPauseFinishInThreadAble().isPaused()) {
				getJToggleButtonPause().setSelected(true);

			} else if (
				getStartPauseFinishInThreadAble().isFinished()
					|| getStartPauseFinishInThreadAble().isFinishedWithErrors()) {
				getJToggleButtonPause().setEnabled(false);
				getJToggleButtonPlay().setEnabled(false);
			}
		}
	}

	/**
	 * Initializes connections
	 * @exception Exception The exception description.
	 */
	private void initConnections() {
		getJToggleButtonPlay().addActionListener(ivjEventHandler);
		getJToggleButtonPause().addActionListener(ivjEventHandler);
	}

	/**
	 * Initialize the class.
	 */
	private void initialize() {
		try {
					setName("SimulationControlPanel");
			setLayout(getSimulationControlPanelFlowLayout());
			setSize(148, 34);
			add(getJToggleButtonPlay(), getJToggleButtonPlay().getName());
			add(getBoxLayoutHorizontalStrut12());
			add(getJToggleButtonPause());
			initConnections();
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	public static void main(String[] args) {
		try {
			javax.swing.JFrame frame = new javax.swing.JFrame();
			ThreadedSimulationControlPanel aThreadedSimulationControlPanel;
			aThreadedSimulationControlPanel = new ThreadedSimulationControlPanel();
			frame.setContentPane(aThreadedSimulationControlPanel);
			frame.setSize(aThreadedSimulationControlPanel.getSize());
			frame.addWindowListener(new java.awt.event.WindowAdapter() {
				public void windowClosing(java.awt.event.WindowEvent e) {
					System.exit(0);
				}
			});
			frame.show();
			java.awt.Insets insets = frame.getInsets();
			frame.setSize(
				frame.getWidth() + insets.left + insets.right,
				frame.getHeight() + insets.top + insets.bottom);
			frame.setVisible(true);
		} catch (Throwable exception) {
			System.err.println(
				"Exception occurred in main() of de.uniwue.ki.gui.mas.model.JPanelWithGUISeSAmDeclaration");
			exception.printStackTrace(System.out);
		}
	}

	/**
	 * Method generated to support the promotion of the startPauseFinishInThreadAble attribute.
	 * @param arg1 de.uniwue.ki.mas.model.sim.simulation.IStartPauseFinishInThreadAble
	 */
	public void setStartPauseFinishInThreadAble(IStartPauseFinishInThreadAble arg1) {
		setStartPauseFinishInThreadAbleIntern(arg1);
	}

	/**
	 * Set the ThreadedSimulationIntern to a new value.
	 * @param newValue de.uniwue.ki.mas.model.sim.simulation.IThreadedSimulation
	 */
	private void setStartPauseFinishInThreadAbleIntern(IStartPauseFinishInThreadAble newValue) {
		if (ivjStartPauseFinishInThreadAbleIntern != newValue) {
			try {
				IStartPauseFinishInThreadAble oldValue = getStartPauseFinishInThreadAbleIntern();
				/* Stop listening for events from the current object */
				if (ivjStartPauseFinishInThreadAbleIntern != null) {
					ivjStartPauseFinishInThreadAbleIntern.removeStartPauseFinishListener(ivjEventHandler);
				}
				ivjStartPauseFinishInThreadAbleIntern = newValue;

				/* Listen for events from the new object */
				if (ivjStartPauseFinishInThreadAbleIntern != null) {
					ivjStartPauseFinishInThreadAbleIntern.addStartPauseFinishListener(ivjEventHandler);
				}
				firePropertyChange("startPauseFinishInThreadAble", oldValue, newValue);
						eventStartPauseFinishFiredEvent();
					} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
	}

	public void refresh() {
		initButtons();
	}
}