package de.uniwue.ki.gui.mas.sim.simulation;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.lang.reflect.InvocationTargetException;

import javax.swing.*;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import junit.framework.Assert;
import de.uniwue.ki.gui.mas.model.JPanelWithGUISeSAmDeclaration;
import de.uniwue.ki.gui.util.SwingMoreUtilities;
import de.uniwue.ki.gui.util.bound.BoundJIntegerTextField;
import de.uniwue.ki.mas.sim.simulation.*;
import de.uniwue.ki.mas.sim.situation.*;
/**
 * Creation date: (23.01.2002 13:35:05)
 * @author Chripauseh Oechslein
 */
public class ThreadedSimulationControlPanel extends JPanelWithGUISeSAmDeclaration {
	private JSpinner ivjJSpinnerStepSize = null;
	private JLabel ivjJLabelStatus = null;
	private JLabel ivjJLabelStepSize = null;
	private JLabel ivjJLabelTime = null;
	private JPanel ivjJPanel1 = null;
	private JPanel ivjJPanel2 = null;
	private JTextField ivjJTextFieldStatus = null;
	private BoundJIntegerTextField ivjJTextFieldTime = null;
	private JToggleButton ivjJToggleButtonStep = null;
	private ISituation ivjSituationIntern = null;
	private IThreadedSimulation ivjThreadedSimulationIntern = null;
	private JButton ivjJButtonRestet = null;
	private ThreadedSimulationControlStepper ivjThreadedSimulationControlStepperIntern = null;
	private boolean ivjConnPtoP2Aligning = false;
	private boolean ivjConnPtoP3Aligning = false;
	private StartPauseFinishControlPanel ivjStartPauseFinishControlPanel = null;
	private JLabel ivjJLabelObjectCount = null;
	private BoundJIntegerTextField ivjJTextFieldObjectCount = null;

	private final IvjEventHandler ivjEventHandler = new IvjEventHandler();
	class IvjEventHandler
		implements
			SimulationListener,
			StartPauseFinishListener,
			SituationListener,
			ActionListener,
			PropertyChangeListener {

		public void actionPerformed(ActionEvent e) {
			if (e.getSource() == ThreadedSimulationControlPanel.this.getJToggleButtonStep()) {
				eventStepButtonPressed();
			} else if (e.getSource() == ThreadedSimulationControlPanel.this.getJButtonRestet()) {
				eventResetButtonPressed();
			}
		}
		public void finished(StartPauseFinishEvent event) {
			if (event.getSource() == ThreadedSimulationControlPanel.this.getThreadedSimulationIntern()) {
				eventSimulationFiredEvent();
				eventSimulationFinished(event);
			}
		}
		public void nextTimeStep(SituationEvent event) {
			if (event.getSource() == ThreadedSimulationControlPanel.this.getSituationIntern()) {
				updateInformationTextFields();
			}
		}
		public void paused(StartPauseFinishEvent event) {
			if (event.getSource() == ThreadedSimulationControlPanel.this.getThreadedSimulationIntern()) {
				eventSimulationFiredEvent();
			}
		}
		public void propertyChange(PropertyChangeEvent evt) {
			if (evt.getSource() == ThreadedSimulationControlPanel.this
				&& (evt.getPropertyName().equals("gUISeSAmDeclaration"))) {
				if (ivjConnPtoP2Aligning == false) {
					ivjConnPtoP2Aligning = true;
					getStartPauseFinishControlPanel().setGUISeSAmDeclaration(getGUISeSAmDeclaration());
					ivjConnPtoP2Aligning = false;
				}
			} else if (
				evt.getSource() == ThreadedSimulationControlPanel.this.getStartPauseFinishControlPanel()
					&& (evt.getPropertyName().equals("gUISeSAmDeclaration"))) {
				if (ivjConnPtoP2Aligning == false) {
					ivjConnPtoP2Aligning = true;
					setGUISeSAmDeclaration(getStartPauseFinishControlPanel().getGUISeSAmDeclaration());
					ivjConnPtoP2Aligning = false;
				}
			} else if (
				evt.getSource() == ThreadedSimulationControlPanel.this.getStartPauseFinishControlPanel()
					&& (evt.getPropertyName().equals("startPauseFinishInThreadAble"))) {
				if (ivjConnPtoP3Aligning == false) {
					ivjConnPtoP3Aligning = true;
					setThreadedSimulationIntern(
						(IThreadedSimulation) getStartPauseFinishControlPanel()
							.getStartPauseFinishInThreadAble());
					ivjConnPtoP3Aligning = false;
				}
			}
		}
		public void reseted(SimulationEvent event) {
			if (event.getSource() == ThreadedSimulationControlPanel.this.getThreadedSimulationIntern())
				eventSimulationFiredEvent();
		}
		public void started(StartPauseFinishEvent event) {
			if (event.getSource() == ThreadedSimulationControlPanel.this.getThreadedSimulationIntern())
				eventSimulationFiredEvent();
		}
	}

	public ThreadedSimulationControlPanel() {
		super();
		initialize();
	}

	public void dispose() {
		if (getSituationIntern() != null) {
			getSituationIntern().removeSituationListener(getThreadedSimulationControlStepperIntern());
		}

		getThreadedSimulationControlStepperIntern().setThreadedSimulation(null);
		setThreadedSimulation(null);

		super.dispose();
	}

	protected void eventPauseButtonPressed() {
		if (getThreadedSimulationIntern() != null) {

			if (getThreadedSimulationIntern().isPaused()) {

			} else if (
				getThreadedSimulationIntern().isFinished()
					|| getThreadedSimulationIntern().isFinishedWithErrors()
					|| getThreadedSimulationControlStepperIntern().isCurrentlyStepping()) {

			} else {
				getThreadedSimulationIntern().pauseInThread();
			}

		}
	}

	protected void eventPlayButtonPressed() {
		if (getThreadedSimulationIntern() != null) {

			if (getThreadedSimulationIntern().isRunning()) {

			} else if (
				getThreadedSimulationIntern().isFinished()
					|| getThreadedSimulationIntern().isFinishedWithErrors()
					|| getThreadedSimulationControlStepperIntern().isCurrentlyStepping()) {

			} else {
				getThreadedSimulationIntern().startInThread();
			}

		}
	}

	protected void eventResetButtonPressed() {
		if (getThreadedSimulation() != null) {
			getThreadedSimulation().resetSimulation();
			eventSimulationFiredEvent();
			if ((getSituationIntern() != null)) {
				getJTextFieldTime().setText(String.valueOf(getSituationIntern().getTimeDurationInTicks()));
			}
			getStartPauseFinishControlPanel().refresh();
		}
	}

	protected void eventSimulationFinished(final StartPauseFinishEvent simulationEvent) {
		if (SwingUtilities.isEventDispatchThread()) {
			eventSimulationFinishedIntern(simulationEvent);

		} else {
			try {
				SwingUtilities.invokeAndWait(new Runnable() {
					public void run() {
						eventSimulationFinishedIntern(simulationEvent);
					}
				});

			} catch (InvocationTargetException exception) {
				exception.getTargetException().printStackTrace();

			} catch (InterruptedException exception) {
				exception.printStackTrace();
			}
		}
	}

	protected void eventSimulationFinishedIntern(StartPauseFinishEvent simulationEvent) {
		if (Assert.ASSERTION_ON)
			Assert.assertTrue(SwingUtilities.isEventDispatchThread());

		if (simulationEvent.getException() != null) {
			getGUISeSAmDeclaration().showException(simulationEvent, this);
		}
	}

	protected void eventSimulationFiredEvent() {
		if (getThreadedSimulationIntern() != null) {

			if (getThreadedSimulationIntern().isRunning()) {
				getJTextFieldStatus().setText("Running");

			} else if (getThreadedSimulationIntern().isPaused()) {
				getJTextFieldStatus().setText("Pause");

				getThreadedSimulationControlStepperIntern().setCurrentlyStepping(false);

			} else if (
				getThreadedSimulationIntern().isFinished()
					|| getThreadedSimulationIntern().isFinishedWithErrors()) {
				if (getThreadedSimulationIntern().isFinishedWithErrors()) {
					getJTextFieldStatus().setText("Finished With Errors");

				} else {
					getJTextFieldStatus().setText("Finished");
				}

				getThreadedSimulationControlStepperIntern().setCurrentlyStepping(false);

			} else {
				getJTextFieldStatus().setText("Initialized");
			}

			initButtons();
		}
	}

	protected void eventStepButtonPressed() {
		if (getThreadedSimulationIntern() != null) {

			if (getThreadedSimulationIntern().isRunning()) {
				getJToggleButtonStep().setSelected(false);

			} else if (
				getThreadedSimulationIntern().isFinished()
					|| getThreadedSimulationIntern().isFinishedWithErrors()
					|| getThreadedSimulationControlStepperIntern().isCurrentlyStepping()) {
				getJToggleButtonStep().setSelected(false);

			} else {
				getThreadedSimulationControlStepperIntern().setCurrentlyStepping(true);
				getThreadedSimulationControlStepperIntern().setStepsLeftToDo(
					((Number) getJSpinnerStepSize().getModel().getValue()).intValue());
				getThreadedSimulationIntern().startInThread();
			}
		}
	}

	protected void eventStepSizeFieldChanged(int newValue) {
		getThreadedSimulationControlStepperIntern().setStepsLeftToDo(newValue);
	}

	private JSpinner getJSpinnerStepSize() {
		if (ivjJSpinnerStepSize == null) {
			final SpinnerNumberModel spinnerNumberModel =
				new SpinnerNumberModel(new Integer(1), new Integer(1), null, new Integer(1));
			ivjJSpinnerStepSize = new JSpinner(spinnerNumberModel);
			spinnerNumberModel.addChangeListener(new ChangeListener() {
				public void stateChanged(ChangeEvent e) {
					eventStepSizeFieldChanged(((Number) spinnerNumberModel.getValue()).intValue());
				}
			});
			ivjJSpinnerStepSize.setEditor(new JSpinner.NumberEditor(ivjJSpinnerStepSize, "0"));

			ivjJSpinnerStepSize.setPreferredSize(new Dimension(80, 0));
		}

		return ivjJSpinnerStepSize;
	}

	private JButton getJButtonRestet() {
		if (ivjJButtonRestet == null) {
			ivjJButtonRestet = new JButton();
			ivjJButtonRestet.setName("JButtonRestet");
			ivjJButtonRestet.setText("Reset");

			ivjJButtonRestet.setIcon(SwingMoreUtilities.getJavaSunIcon(16, "media/Rewind16.gif"));
		}
		return ivjJButtonRestet;
	}

	private JLabel getJLabelObjectCount() {
		if (ivjJLabelObjectCount == null) {
			ivjJLabelObjectCount = new JLabel();
			ivjJLabelObjectCount.setName("JLabelObjectCount");
			ivjJLabelObjectCount.setText("Object Count: ");
		}
		return ivjJLabelObjectCount;
	}

	private JLabel getJLabelStatus() {
		if (ivjJLabelStatus == null) {
			ivjJLabelStatus = new JLabel();
			ivjJLabelStatus.setName("JLabelStatus");
			ivjJLabelStatus.setText("Status:  ");
		}
		return ivjJLabelStatus;
	}

	private JLabel getJLabelStepSize() {
		if (ivjJLabelStepSize == null) {
			ivjJLabelStepSize = new JLabel();
			ivjJLabelStepSize.setName("JLabelStepSize");
			ivjJLabelStepSize.setText("Step Size:  ");
		}
		return ivjJLabelStepSize;
	}

	private JLabel getJLabelTime() {
		if (ivjJLabelTime == null) {
			ivjJLabelTime = new JLabel();
			ivjJLabelTime.setName("JLabelTime");
			ivjJLabelTime.setText("Time:  ");
		}
		return ivjJLabelTime;
	}

	private JPanel getJPanel1() {
		if (ivjJPanel1 == null) {
			ivjJPanel1 = new JPanel();
			ivjJPanel1.setName("JPanel1");
			ivjJPanel1.setLayout(new FlowLayout(FlowLayout.LEFT));
			getJPanel1().add(getJLabelTime(), getJLabelTime().getName());
			getJPanel1().add(getJTextFieldTime(), getJTextFieldTime().getName());
			getJPanel1().add(Box.createHorizontalStrut(7), Box.createHorizontalStrut(7).getName());
			getJPanel1().add(getJLabelStatus(), getJLabelStatus().getName());
			getJPanel1().add(getJTextFieldStatus(), getJTextFieldStatus().getName());
			getJPanel1().add(Box.createHorizontalStrut(7), Box.createHorizontalStrut(7).getName());
			getJPanel1().add(getJLabelObjectCount(), getJLabelObjectCount().getName());
			getJPanel1().add(getJTextFieldObjectCount(), getJTextFieldObjectCount().getName());
		}
		return ivjJPanel1;
	}

	private JPanel getJPanel2() {
		if (ivjJPanel2 == null) {
			ivjJPanel2 = new JPanel();
			ivjJPanel2.setName("JPanel2");
			//ivjJPanel2.setLayout(new FlowLayout(FlowLayout.LEFT));
			ivjJPanel2.setLayout(new BoxLayout(ivjJPanel2, BoxLayout.LINE_AXIS));

			getJPanel2().add(getStartPauseFinishControlPanel());
			getJPanel2().add(Box.createHorizontalStrut(7));
			getJPanel2().add(getJButtonRestet());
			getJPanel2().add(Box.createHorizontalStrut(10));
			getJPanel2().add(getJToggleButtonStep());
			getJPanel2().add(Box.createHorizontalStrut(7));
			getJPanel2().add(getJLabelStepSize());
			getJPanel2().add(getJSpinnerStepSize());
		}

		return ivjJPanel2;
	}

	private BoundJIntegerTextField getJTextFieldObjectCount() {
		if (ivjJTextFieldObjectCount == null) {
			ivjJTextFieldObjectCount = new BoundJIntegerTextField();
			ivjJTextFieldObjectCount.setName("JTextFieldObjectCount");
			ivjJTextFieldObjectCount.setEditable(false);
			ivjJTextFieldObjectCount.setColumns(10);
		}
		return ivjJTextFieldObjectCount;
	}

	private JTextField getJTextFieldStatus() {
		if (ivjJTextFieldStatus == null) {
			ivjJTextFieldStatus = new JTextField();
			ivjJTextFieldStatus.setName("JTextFieldStatus");
			ivjJTextFieldStatus.setEditable(false);
			ivjJTextFieldStatus.setColumns(10);
		}
		return ivjJTextFieldStatus;
	}

	private BoundJIntegerTextField getJTextFieldTime() {
		if (ivjJTextFieldTime == null) {
			ivjJTextFieldTime = new BoundJIntegerTextField();
			ivjJTextFieldTime.setName("JTextFieldTime");
			ivjJTextFieldTime.setEditable(false);
			ivjJTextFieldTime.setColumns(10);
		}
		return ivjJTextFieldTime;
	}

	private JToggleButton getJToggleButtonStep() {
		if (ivjJToggleButtonStep == null) {
			ivjJToggleButtonStep = new JToggleButton();
			ivjJToggleButtonStep.setName("JToggleButtonStep");
			ivjJToggleButtonStep.setText("Step");

			ivjJToggleButtonStep.setIcon(SwingMoreUtilities.getJavaSunIcon(16, "media/StepForward16.gif"));
		}
		return ivjJToggleButtonStep;
	}

	private ISituation getSituationIntern() {
		return ivjSituationIntern;
	}

	private StartPauseFinishControlPanel getStartPauseFinishControlPanel() {
		if (ivjStartPauseFinishControlPanel == null) {
			ivjStartPauseFinishControlPanel = new StartPauseFinishControlPanel();
			ivjStartPauseFinishControlPanel.setName("StartPauseFinishControlPanel");
		}
		return ivjStartPauseFinishControlPanel;
	}

	public IThreadedSimulation getThreadedSimulation() {
		return getThreadedSimulationIntern();
	}

	private ThreadedSimulationControlStepper getThreadedSimulationControlStepperIntern() {
		if (ivjThreadedSimulationControlStepperIntern == null) {
			ivjThreadedSimulationControlStepperIntern = new ThreadedSimulationControlStepper();
		}
		return ivjThreadedSimulationControlStepperIntern;
	}

	private IThreadedSimulation getThreadedSimulationIntern() {
		return ivjThreadedSimulationIntern;
	}

	protected void initButtons() {
		getJToggleButtonStep().setEnabled(true);
		getJSpinnerStepSize().setEnabled(true);

		getJToggleButtonStep().setSelected(false);

		getJButtonRestet().setEnabled(false);

		if (getThreadedSimulationIntern() != null) {

			if (getThreadedSimulationIntern().isRunning()) {

			} else if (getThreadedSimulationIntern().isPaused()) {
				getJButtonRestet().setEnabled(true);

			} else if (
				getThreadedSimulationIntern().isFinished()
					|| getThreadedSimulationIntern().isFinishedWithErrors()) {
				getJToggleButtonStep().setEnabled(false);
				getJButtonRestet().setEnabled(true);
				getJSpinnerStepSize().setEnabled(false);
			}
		}

		getStartPauseFinishControlPanel().refresh();
	}

	private void initConnections() {

		getJToggleButtonStep().addActionListener(ivjEventHandler);
		getJSpinnerStepSize().addPropertyChangeListener(ivjEventHandler);
		getJButtonRestet().addActionListener(ivjEventHandler);
		this.addPropertyChangeListener(ivjEventHandler);
		getStartPauseFinishControlPanel().addPropertyChangeListener(ivjEventHandler);
		if ((getThreadedSimulationIntern() != null)) {
			getThreadedSimulationControlStepperIntern().setThreadedSimulation(getThreadedSimulationIntern());
		}
		if (ivjConnPtoP2Aligning == false) {
			ivjConnPtoP2Aligning = true;
			getStartPauseFinishControlPanel().setGUISeSAmDeclaration(this.getGUISeSAmDeclaration());
			ivjConnPtoP2Aligning = false;
		}
		if (ivjConnPtoP3Aligning == false) {
			ivjConnPtoP3Aligning = true;
			if ((getThreadedSimulationIntern() != null)) {
				getStartPauseFinishControlPanel().setStartPauseFinishInThreadAble(
					getThreadedSimulationIntern());
			}
			ivjConnPtoP3Aligning = false;
		}
	}

	private void initialize() {
		setLayout(new GridBagLayout());
		setSize(746, 140);

		GridBagConstraints constraintsJPanel1 = new GridBagConstraints();
		constraintsJPanel1.gridx = 0;
		constraintsJPanel1.gridy = 0;
		//		constraintsJPanel1.fill = GridBagConstraints.HORIZONTAL;
		constraintsJPanel1.anchor = GridBagConstraints.NORTHWEST;
		constraintsJPanel1.weightx = 1.0;
		constraintsJPanel1.insets = new Insets(0, 0, 4, 0);
		add(getJPanel1(), constraintsJPanel1);

		GridBagConstraints constraintsJPanel2 = new GridBagConstraints();
		constraintsJPanel2.gridx = 0;
		constraintsJPanel2.gridy = 1;
		//		constraintsJPanel2.fill = GridBagConstraints.HORIZONTAL;
		constraintsJPanel2.anchor = GridBagConstraints.NORTHWEST;
		constraintsJPanel2.weightx = 1.0;
		//		constraintsJPanel2.weighty = 1.0;
		add(getJPanel2(), constraintsJPanel2);

		initConnections();
	}

	private void setSituationIntern(ISituation newValue) {
		if (ivjSituationIntern != newValue) {
			/* Stop listening for events from the current object */
			if (ivjSituationIntern != null) {
				ivjSituationIntern.removeSituationListener(ivjEventHandler);
			}
			ivjSituationIntern = newValue;

			/* Listen for events from the new object */
			if (ivjSituationIntern != null) {
				ivjSituationIntern.addSituationListener(ivjEventHandler);
			}
			getSituationIntern().addSituationListener(getThreadedSimulationControlStepperIntern());
		}
	}

	public void setThreadedSimulation(IThreadedSimulation arg1) {
		setThreadedSimulationIntern(arg1);

		updateInformationTextFields();
	}

	private void setThreadedSimulationIntern(IThreadedSimulation newValue) {
		if (ivjThreadedSimulationIntern != newValue) {
			IThreadedSimulation oldValue = getThreadedSimulationIntern();
			/* Stop listening for events from the current object */
			if (ivjThreadedSimulationIntern != null) {
				ivjThreadedSimulationIntern.removeStartPauseFinishListener(ivjEventHandler);
				ivjThreadedSimulationIntern.removeSimulationListener(ivjEventHandler);
			}
			ivjThreadedSimulationIntern = newValue;

			/* Listen for events from the new object */
			if (ivjThreadedSimulationIntern != null) {
				ivjThreadedSimulationIntern.addStartPauseFinishListener(ivjEventHandler);
				ivjThreadedSimulationIntern.addSimulationListener(ivjEventHandler);
			}
			if ((getThreadedSimulationIntern() != null)) {
				setSituationIntern(getThreadedSimulationIntern().getSituation());
			}
			if ((getThreadedSimulationIntern() != null)) {
				getThreadedSimulationControlStepperIntern().setThreadedSimulation(
					getThreadedSimulationIntern());
			}
			if (ivjConnPtoP3Aligning == false) {
				ivjConnPtoP3Aligning = true;
				if ((getThreadedSimulationIntern() != null)) {
					getStartPauseFinishControlPanel().setStartPauseFinishInThreadAble(
						getThreadedSimulationIntern());
				}
				ivjConnPtoP3Aligning = false;
			}
			firePropertyChange("threadedSimulation", oldValue, newValue);

			eventSimulationFiredEvent();
		}
	}

	protected void updateInformationTextFields() {
		if (getThreadedSimulationIntern() != null) {

			getJTextFieldTime().setIntegerValue(
				getThreadedSimulationIntern().getSituation().getTimeDurationInTicks());

			int newCount = getThreadedSimulationIntern().getSituation().getWorld().getObjectCount(true, true);

			if (newCount != getJTextFieldObjectCount().getIntegerValue())
				getJTextFieldObjectCount().setIntegerValue(newCount);
		}
	}
}