package de.uniwue.ki.gui.mas.sim.simulation;
import junit.framework.Assert;
import de.uniwue.ki.mas.sim.simulation.IThreadedSimulation;
import de.uniwue.ki.mas.sim.situation.SituationEvent;
import de.uniwue.ki.mas.sim.situation.SituationListener;
/**
 * Creation date: (23.01.2002 15:31:35)
 * @author Chripauseh Oechslein
 */
class ThreadedSimulationControlStepper implements SituationListener {
    private IThreadedSimulation _simulation;
    private boolean _currentlyStepping;
    private int _stepsLeftToDo;

    public ThreadedSimulationControlStepper() {
        super();
    }

    public IThreadedSimulation getThreadedSimulation() {
        return _simulation;
    }

    public int getStepsLeftToDo() {
        return _stepsLeftToDo;
    }

    public boolean isCurrentlyStepping() {
        return _currentlyStepping;
    }

public void nextTimeStep(SituationEvent event) {
    if (isCurrentlyStepping()) {
        if (getStepsLeftToDo() <= 1) {
            getThreadedSimulation().pauseInThread();

        } else {
            _stepsLeftToDo--;
        }
    }
}

    public void setCurrentlyStepping(boolean newCurrentlyStepping) {
        _currentlyStepping = newCurrentlyStepping;
    }

    public void setThreadedSimulation(IThreadedSimulation newThreadedSimulation) {
        _simulation = newThreadedSimulation;
    }

    public void setStepsLeftToDo(int newStepsLeftToDo) {
        Assert.assertTrue(newStepsLeftToDo > 0);

        _stepsLeftToDo = newStepsLeftToDo;
    }
}