package de.uniwue.ki.gui.mas.sim.simulation;
import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.event.*;
import java.util.Iterator;

import javax.swing.*;

import com.ibm.easyswing.BoundJCheckBox;

import de.uniwue.ki.gui.mas.model.*;
import de.uniwue.ki.gui.mas.sim.analysis.AnalysisListPanel;
import de.uniwue.ki.gui.mas.sim.situation.SituationPanel;
import de.uniwue.ki.gui.util.SwingMoreUtilities;
import de.uniwue.ki.mas.sim.analysis.AnalysisList;
import de.uniwue.ki.mas.sim.analysis.IAnalysis;
import de.uniwue.ki.mas.sim.simulation.*;

/**
 * Creation date: (18.10.2000 19:44:48)
 * @author Christoph Oechslein
 */
public class ThreadedSimulationPanel extends JPanelWithGUISeSAmDeclaration {
	public static final ImageIcon ANALYSIS_ICON =
		SwingMoreUtilities.getJavaSunIcon(16, "general/BarGraph16.gif");

	private final SimulationLoggingPanel _simulationLoggingPanel = new SimulationLoggingPanel();
	private IThreadedSimulation ivjThreadedSimulationIntern = null;
	private final IvjEventHandler ivjEventHandler = new IvjEventHandler();
	private SituationPanel ivjStartSituationPanel = null;
	private BoundJCheckBox ivjBoundJCheckBoxLogger = null;

	private JPanel ivjJPanelSituation = null;
	private boolean ivjConnPtoP1Aligning = false;
	private JPanel ivjJPanelTop = null;
	private JButton ivjJButtonAnalyse = null;
	private boolean ivjConnPtoP4Aligning = false;
	private ThreadedSimulationControlPanel ivjSimulationControlPanel1 = null;
	private boolean ivjConnPtoP3Aligning = false;

	class IvjEventHandler
		implements SimulationListener, ActionListener, ItemListener, java.beans.PropertyChangeListener {
		public void actionPerformed(ActionEvent e) {
			if (e.getSource() == ThreadedSimulationPanel.this.getJButtonAnalyse())
				eventAnalysisButtonPressed();
		}
		public void finished(StartPauseFinishEvent event) {
		}
		public void itemStateChanged(ItemEvent e) {
			if (e.getSource() == ThreadedSimulationPanel.this.getBoundJCheckBoxLogger())
				eventLoggingSelectionChanged();
		}
		public void paused(StartPauseFinishEvent event) {
		}
		public void propertyChange(java.beans.PropertyChangeEvent evt) {
			if (evt.getSource() == ThreadedSimulationPanel.this
				&& (evt.getPropertyName().equals("gUISeSAmDeclaration")))
				connPtoP1SetTarget();
			if (evt.getSource() == ThreadedSimulationPanel.this.getStartSituationPanel()
				&& (evt.getPropertyName().equals("gUISeSAmDeclaration")))
				connPtoP1SetSource();
			if (evt.getSource() == ThreadedSimulationPanel.this.getSimulationControlPanel1()
				&& (evt.getPropertyName().equals("threadedSimulation")))
				connPtoP3SetSource();
			if (evt.getSource() == ThreadedSimulationPanel.this
				&& (evt.getPropertyName().equals("gUISeSAmDeclaration")))
				connPtoP4SetTarget();
			if (evt.getSource() == ThreadedSimulationPanel.this.getSimulationControlPanel1()
				&& (evt.getPropertyName().equals("gUISeSAmDeclaration")))
				connPtoP4SetSource();
		}
		public void reseted(SimulationEvent event) {
			if (event.getSource() == ThreadedSimulationPanel.this.getThreadedSimulationIntern())
				refresh();
		}
		public void started(StartPauseFinishEvent event) {
		}
	}

	public ThreadedSimulationPanel() {
		super();
		initialize();
	}

	protected void addPanel(java.awt.Component component) {
		GUISeSAmDeclaration.getDeclarationFrameFactory(getGUISeSAmDeclaration()).addPanel(
			this,
			"Situation",
			component,
			true);
	}

	private void connPtoP1SetSource() {
		if (ivjConnPtoP1Aligning == false) {

			ivjConnPtoP1Aligning = true;
			this.setGUISeSAmDeclaration(getStartSituationPanel().getGUISeSAmDeclaration());

			ivjConnPtoP1Aligning = false;
		}
	}

	private void connPtoP1SetTarget() {
		if (ivjConnPtoP1Aligning == false) {

			ivjConnPtoP1Aligning = true;
			getStartSituationPanel().setGUISeSAmDeclaration(this.getGUISeSAmDeclaration());

			ivjConnPtoP1Aligning = false;
		}
	}

	private void connPtoP3SetSource() {
		if (ivjConnPtoP3Aligning == false) {

			ivjConnPtoP3Aligning = true;
			setThreadedSimulationIntern(getSimulationControlPanel1().getThreadedSimulation());

			ivjConnPtoP3Aligning = false;
		}
	}

	private void connPtoP3SetTarget() {
		if (ivjConnPtoP3Aligning == false) {

			ivjConnPtoP3Aligning = true;
			if ((getThreadedSimulationIntern() != null)) {
				getSimulationControlPanel1().setThreadedSimulation(getThreadedSimulationIntern());
			}

			ivjConnPtoP3Aligning = false;
		}
	}

	private void connPtoP4SetSource() {
		if (ivjConnPtoP4Aligning == false) {

			ivjConnPtoP4Aligning = true;
			this.setGUISeSAmDeclaration(getSimulationControlPanel1().getGUISeSAmDeclaration());

			ivjConnPtoP4Aligning = false;
		}

	}

	private void connPtoP4SetTarget() {
		if (ivjConnPtoP4Aligning == false) {

			ivjConnPtoP4Aligning = true;
			getSimulationControlPanel1().setGUISeSAmDeclaration(this.getGUISeSAmDeclaration());

			ivjConnPtoP4Aligning = false;
		}
	}

	public void dispose() {
		_simulationLoggingPanel.setLogging(false);

		getStartSituationPanel().dispose();

		setThreadedSimulation(null);

		getSimulationControlPanel1().dispose();

		super.dispose();
	}

	protected void eventAnalysisButtonPressed() {

		IThreadedSimulation threadedSimulation = getThreadedSimulation();
		IGUISeSAmDeclaration guiSeSAmDeclaration = getGUISeSAmDeclaration();

		showAnalysisPanel(this, threadedSimulation, guiSeSAmDeclaration);
	}

	public static void showAnalysisPanel(
		Container parent,
		ISimulation simulation,
		IGUISeSAmDeclaration guiSeSAmDeclaration) {

		if (guiSeSAmDeclaration != null && simulation != null) {

			AnalysisList newAnalysisList = new AnalysisList(simulation.getAnalysisList().size());
			Iterator it = simulation.getAnalysisList().iterator();
			while (it.hasNext()) {
				IAnalysis element = (IAnalysis) it.next();
				if (AnalysisListPanel.canEdit(element)) {
					newAnalysisList.add(element);
				}
			}

			if (newAnalysisList.size() == 1) {
				AnalysisListPanel.editItem(parent, guiSeSAmDeclaration, (IAnalysis) newAnalysisList.get(0));

			} else {
				AnalysisListPanel analysisListPanel = new AnalysisListPanel();

				analysisListPanel.setAnalysisList(newAnalysisList);
				analysisListPanel.setGUISeSAmDeclaration(guiSeSAmDeclaration);

				GUISeSAmDeclaration.getDeclarationFrameFactory(guiSeSAmDeclaration).addPanel(
					parent,
					"Analysis",
					analysisListPanel,
					true);
			}
		}
	}

	protected void eventLoggingSelectionChanged() {
		if (getThreadedSimulation() == null) {
			return;

		} else {
			if (((_simulationLoggingPanel.getRootPane() == null)
				|| (_simulationLoggingPanel.getRootPane().getParent() == null)
				|| (_simulationLoggingPanel.getRootPane().getParent().getParent() == null))
				&& (getGUISeSAmDeclaration() != null)) {

				getGUISeSAmDeclaration().getFrameFactory().addPanel(
					this,
					"Logging",
					_simulationLoggingPanel,
					false);
			}

			_simulationLoggingPanel.setLogging(getBoundJCheckBoxLogger().isSelected());

		}
	}

	protected void eventSimulationChanged() {
		eventLoggingSelectionChanged();

	}

	private BoundJCheckBox getBoundJCheckBoxLogger() {
		if (ivjBoundJCheckBoxLogger == null) {
			ivjBoundJCheckBoxLogger = new BoundJCheckBox();
			ivjBoundJCheckBoxLogger.setName("BoundJCheckBoxLogger");
			ivjBoundJCheckBoxLogger.setText("Log/Profile");
		}

		return ivjBoundJCheckBoxLogger;
	}

	private JButton getJButtonAnalyse() {
		if (ivjJButtonAnalyse == null) {
			ivjJButtonAnalyse = new JButton();
			ivjJButtonAnalyse.setName("JButtonAnalyse");
			ivjJButtonAnalyse.setText("Analysis ...");

			ivjJButtonAnalyse.setIcon(ANALYSIS_ICON);
		}
		return ivjJButtonAnalyse;
	}

	private JPanel getJPanelSituation() {
		if (ivjJPanelSituation == null) {
			ivjJPanelSituation = new JPanel();
			ivjJPanelSituation.setName("JPanelSituation");
			ivjJPanelSituation.setLayout(new java.awt.BorderLayout());
			getJPanelSituation().add(getStartSituationPanel(), "Center");
		}
		return ivjJPanelSituation;
	}

	private JPanel getJPanelTop() {
		if (ivjJPanelTop == null) {
			ivjJPanelTop = new JPanel();
			ivjJPanelTop.setName("JPanelTop");
			ivjJPanelTop.setLayout(new java.awt.GridBagLayout());

			java.awt.GridBagConstraints constraintsSimulationControlPanel1 =
				new java.awt.GridBagConstraints();
			constraintsSimulationControlPanel1.gridx = 0;
			constraintsSimulationControlPanel1.gridy = 0;
			constraintsSimulationControlPanel1.gridheight = 2;
			constraintsSimulationControlPanel1.fill = java.awt.GridBagConstraints.HORIZONTAL;
			constraintsSimulationControlPanel1.anchor = java.awt.GridBagConstraints.NORTHWEST;
			constraintsSimulationControlPanel1.weightx = 1.0;
			getJPanelTop().add(getSimulationControlPanel1(), constraintsSimulationControlPanel1);

			java.awt.GridBagConstraints constraintsBoundJCheckBoxLogger = new java.awt.GridBagConstraints();
			constraintsBoundJCheckBoxLogger.gridx = 1;
			constraintsBoundJCheckBoxLogger.gridy = 1;
			constraintsBoundJCheckBoxLogger.anchor = java.awt.GridBagConstraints.EAST;
			constraintsBoundJCheckBoxLogger.weightx = 1.0;
			//				constraintsBoundJCheckBoxLogger.insets.left = 3;
			getJPanelTop().add(getBoundJCheckBoxLogger(), constraintsBoundJCheckBoxLogger);

			java.awt.GridBagConstraints constraintsJButtonAnalyse = new java.awt.GridBagConstraints();
			constraintsJButtonAnalyse.gridx = 1;
			constraintsJButtonAnalyse.gridy = 0;
			constraintsJButtonAnalyse.insets.left = 5;
			constraintsJButtonAnalyse.anchor = java.awt.GridBagConstraints.EAST;
			constraintsJButtonAnalyse.weightx = 1.0;
			getJPanelTop().add(getJButtonAnalyse(), constraintsJButtonAnalyse);
		}
		return ivjJPanelTop;
	}

	private ThreadedSimulationControlPanel getSimulationControlPanel1() {
		if (ivjSimulationControlPanel1 == null) {
			ivjSimulationControlPanel1 = new ThreadedSimulationControlPanel();
			ivjSimulationControlPanel1.setName("SimulationControlPanel1");
		}
		return ivjSimulationControlPanel1;
	}

	private SituationPanel getStartSituationPanel() {
		if (ivjStartSituationPanel == null) {
			ivjStartSituationPanel = new SituationPanel();
			ivjStartSituationPanel.setName("StartSituationPanel");
		}
		return ivjStartSituationPanel;
	}

	public IThreadedSimulation getThreadedSimulation() {
		return getThreadedSimulationIntern();
	}

	private IThreadedSimulation getThreadedSimulationIntern() {
		return ivjThreadedSimulationIntern;
	}

	private void initConnections() {

		this.addPropertyChangeListener(ivjEventHandler);
		getStartSituationPanel().addPropertyChangeListener(ivjEventHandler);
		getBoundJCheckBoxLogger().addItemListener(ivjEventHandler);
		getJButtonAnalyse().addActionListener(ivjEventHandler);
		getSimulationControlPanel1().addPropertyChangeListener(ivjEventHandler);
		connPtoP1SetTarget();
		if ((getThreadedSimulationIntern() != null)) {
			getStartSituationPanel().setSituation(getThreadedSimulationIntern().getSituation());
		}
		connPtoP3SetTarget();
		connPtoP4SetTarget();
	}

	private void initialize() {
		setName("SimulationPanel");

		setLayout(new BorderLayout());

		add(getJPanelTop(), BorderLayout.NORTH);
		add(getJPanelSituation(), BorderLayout.CENTER);

		initConnections();
	}

	public void refresh() {
		getStartSituationPanel().refresh();
	}

	public void setThreadedSimulation(IThreadedSimulation threadedSimulation) {
		_simulationLoggingPanel.setSimulation(threadedSimulation);
		setThreadedSimulationIntern(threadedSimulation);
	}

	public void setGUISeSAmDeclaration(IGUISeSAmDeclaration guiSeSAmDeclaration) {
		super.setGUISeSAmDeclaration(guiSeSAmDeclaration);
		
		getStartSituationPanel().setGUISeSAmDeclaration(guiSeSAmDeclaration);

		if (guiSeSAmDeclaration != null) {
			guiSeSAmDeclaration.getFrameFactory().addPanel(
				this,
				"Logging",
				_simulationLoggingPanel,
				false,
				WindowConstants.HIDE_ON_CLOSE);

			_simulationLoggingPanel.setGUISeSAmDeclaration(guiSeSAmDeclaration);
		}
	}

	private void setThreadedSimulationIntern(IThreadedSimulation newValue) {
		if (ivjThreadedSimulationIntern != newValue) {
			IThreadedSimulation oldValue = getThreadedSimulationIntern();
			/* Stop listening for events from the current object */
			if (ivjThreadedSimulationIntern != null) {
				ivjThreadedSimulationIntern.removeSimulationListener(ivjEventHandler);
			}
			ivjThreadedSimulationIntern = newValue;

			/* Listen for events from the new object */
			if (ivjThreadedSimulationIntern != null) {
				ivjThreadedSimulationIntern.addSimulationListener(ivjEventHandler);
			}

			eventSimulationChanged();

			if (ivjThreadedSimulationIntern != null) {
				getStartSituationPanel().setSituation(getThreadedSimulationIntern().getSituation());
			}

			connPtoP3SetTarget();
			firePropertyChange("threadedSimulation", oldValue, newValue);
		}
	}
}