package de.uniwue.ki.gui.mas.sim.simulation;
import javax.swing.*;

import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.util.IDisposeable;
import de.uniwue.ki.mas.sim.simulation.IThreadedSimulation;
/**
 * Creation date: (23.01.2002 16:32:52)
 * @author Christoph Oechslein
 */
public class ThreadedSimulationWithNamePanel extends JPanel implements IDisposeable {
	private boolean _disposed = false;
	private JLabel ivjJLabelName = null;
	private JTextField ivjJNamedPanel1 = null;
	private JPanel ivjJPanelName = null;
	private ThreadedSimulationPanel ivjSimulationPanel = null;

	/**
	 * SimulationWithNamePanel constructor comment.
	 */
	public ThreadedSimulationWithNamePanel() {
		super();
		initialize();
	}

	public void dispose() {
		getSimulationPanel().dispose();

		_disposed = true;
	}

	/**
	 * Method generated to support the promotion of the guiSeSAmDeclaration attribute.
	 * @return IGUISeSAmDeclaration
	 */
	public IGUISeSAmDeclaration getGUISeSAmDeclaration() {
		return getSimulationPanel().getGUISeSAmDeclaration();
	}

	/**
	 * Return the JLabelName property value.
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelName() {
		if (ivjJLabelName == null) {
			try {
				ivjJLabelName = new javax.swing.JLabel();
				ivjJLabelName.setName("JLabelName");
				ivjJLabelName.setText("Name:  ");
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjJLabelName;
	}

	/**
	 * Return the JNamedPanel1 property value.
	 * @return JNamedPanel
	 */
	private JTextField getJNamedPanel1() {
		if (ivjJNamedPanel1 == null) {
			try {
				ivjJNamedPanel1 = new JTextField();
				ivjJNamedPanel1.setName("JNamedPanel1");
				ivjJNamedPanel1.setColumns(30);
				ivjJNamedPanel1.setEditable(false);
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjJNamedPanel1;
	}

	/**
	 * Return the JPanelName property value.
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanelName() {
		if (ivjJPanelName == null) {
			try {
				ivjJPanelName = new javax.swing.JPanel();
				ivjJPanelName.setName("JPanelName");
				ivjJPanelName.setLayout(getJPanelNameFlowLayout());
				getJPanelName().add(getJLabelName(), getJLabelName().getName());
				ivjJPanelName.add(getJNamedPanel1());
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjJPanelName;
	}

	/**
	 * Return the JPanelNameFlowLayout property value.
	 * @return java.awt.FlowLayout
	 */
	private java.awt.FlowLayout getJPanelNameFlowLayout() {
		java.awt.FlowLayout ivjJPanelNameFlowLayout = null;
		try {
			/* Create part */
			ivjJPanelNameFlowLayout = new java.awt.FlowLayout();
			ivjJPanelNameFlowLayout.setAlignment(java.awt.FlowLayout.LEFT);
			ivjJPanelNameFlowLayout.setVgap(0);
			ivjJPanelNameFlowLayout.setHgap(0);
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		};
		return ivjJPanelNameFlowLayout;
	}

	/**
	 * Return the SimulationPanel property value.
	 * @return sim.simulation.SimulationPanel
	 */
	private ThreadedSimulationPanel getSimulationPanel() {
		if (ivjSimulationPanel == null) {
			try {
				ivjSimulationPanel = new de.uniwue.ki.gui.mas.sim.simulation.ThreadedSimulationPanel();
				ivjSimulationPanel.setName("SimulationPanel");
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjSimulationPanel;
	}

	public IThreadedSimulation getThreadedSimulation() {
		return getSimulationPanel().getThreadedSimulation();
	}

	/**
	 * Called whenever the part throws an exception.
	 * @param exception Throwable
	 */
	private void handleException(Throwable exception) {

		exception.printStackTrace(System.out);
	}

	/**
	 * Initialize the class.
	 */
	private void initialize() {
		try {
					setName("SimulationWithNamePanel");
			setLayout(new java.awt.GridBagLayout());
			setSize(650, 698);

			java.awt.GridBagConstraints constraintsJPanelName = new java.awt.GridBagConstraints();
			constraintsJPanelName.gridx = 0;
			constraintsJPanelName.gridy = 0;
			constraintsJPanelName.fill = java.awt.GridBagConstraints.HORIZONTAL;
			constraintsJPanelName.insets = new java.awt.Insets(3, 3, 3, 3);
			add(getJPanelName(), constraintsJPanelName);

			java.awt.GridBagConstraints constraintsLinePanel1 = new java.awt.GridBagConstraints();
			constraintsLinePanel1.gridx = 0;
			constraintsLinePanel1.gridy = 1;
			constraintsLinePanel1.fill = java.awt.GridBagConstraints.HORIZONTAL;
			constraintsLinePanel1.insets = new java.awt.Insets(0, 0, 3, 0);
			add(new JSeparator(), constraintsLinePanel1);

			java.awt.GridBagConstraints constraintsSimulationPanel = new java.awt.GridBagConstraints();
			constraintsSimulationPanel.gridx = 0;
			constraintsSimulationPanel.gridy = 2;
			constraintsSimulationPanel.fill = java.awt.GridBagConstraints.BOTH;
			constraintsSimulationPanel.weightx = 1.0;
			constraintsSimulationPanel.weighty = 1.0;
			constraintsSimulationPanel.insets = new java.awt.Insets(0, 3, 3, 3);
			add(getSimulationPanel(), constraintsSimulationPanel);
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	/**
	 * Insert the method's description here.
	 * Creation date: (23.01.2002 16:41:49)
	 * @return boolean
	 */
	public boolean isDisposed() {
		return _disposed;
	}

	public static void main(String[] args) {
		try {
			JFrame frame = new javax.swing.JFrame();
			ThreadedSimulationWithNamePanel aSimulationWithNamePanel;
			aSimulationWithNamePanel = new ThreadedSimulationWithNamePanel();
			frame.setContentPane(aSimulationWithNamePanel);
			frame.setSize(aSimulationWithNamePanel.getSize());
			frame.addWindowListener(new java.awt.event.WindowAdapter() {
				public void windowClosing(java.awt.event.WindowEvent e) {
					System.exit(0);
				};
			});
			frame.show();
			java.awt.Insets insets = frame.getInsets();
			frame.setSize(
				frame.getWidth() + insets.left + insets.right,
				frame.getHeight() + insets.top + insets.bottom);
			frame.setVisible(true);
		} catch (Throwable exception) {
			System.err.println("Exception occurred in main() of javax.swing.JPanel");
			exception.printStackTrace(System.out);
		}
	}

	public void setGUISeSAmDeclaration(IGUISeSAmDeclaration arg1) {
		getSimulationPanel().setGUISeSAmDeclaration(arg1);
	}

	public void setThreadedSimulation(IThreadedSimulation simulation) {
		if (simulation != null)
			getJNamedPanel1().setText(simulation.getName());

		getSimulationPanel().setThreadedSimulation(simulation);
	}

	public void refresh() {
		getSimulationPanel().refresh();
		if (getSimulationPanel().getThreadedSimulation() != null)
			getJNamedPanel1().setText(getSimulationPanel().getThreadedSimulation().getName());

	}
}