package de.uniwue.ki.gui.mas.sim.situation;
import java.awt.Container;

import javax.swing.Icon;

import de.uniwue.ki.gui.mas.model.AbstractDeclarationPanelAndActionFactory;
import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.model.tree.SeSAmDeclarationTreeCellRenderer;
import de.uniwue.ki.gui.mas.util.declaration.*;
import de.uniwue.ki.mas.sim.situation.ISituationDeclaration;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: (11.10.2001 15:13:45)
 * @author Christoph Oechslein
 */
public class SituationClassDeclarationPanelActionFactory extends AbstractDeclarationPanelAndActionFactory {
	private final IDeclarationPanelFactory _editPropertiesDeclarationPanelFactory =
		new EditPropertiesDeclarationPanelFactory();

	private class EditPropertiesDeclarationPanelFactory extends AbstractDeclarationPanelFactory {

		public IDeclarationPanel createDeclarationPanel(IDeclaration declaration) {
			NameDeclarationWithDocumentationAdapterPanel documentationAdapterPanel =
				new NameDeclarationWithDocumentationAdapterPanel(new SituationDeclarationPanel());

			documentationAdapterPanel.setGUISeSAmDeclaration(getGUISeSAmDeclaration());

			return documentationAdapterPanel;
		}
		public String getDeclarationTitle(IDeclaration declaration) {
			return "Situation";
		}
		
        public Icon getIcon(IDeclaration declaration) {
            return SeSAmDeclarationTreeCellRenderer.SITUATION_ICON;
        }

	}

	public SituationClassDeclarationPanelActionFactory() {
		super();
	}

	public SituationClassDeclarationPanelActionFactory(IGUISeSAmDeclaration guiSeSAmDeclaration) {
		super(guiSeSAmDeclaration);
	}

	protected boolean getCanProduceDeclarationActions(Container parent, IDeclaration anDeclaration) {
		return anDeclaration instanceof ISituationDeclaration;
	}

	public IDeclarationPanelFactory getDeclarationPanelFactory(
		Container parent,
		IDeclaration anDeclaration) {
		return _editPropertiesDeclarationPanelFactory;
	}

	protected boolean shouldUseOkCancelDeclarationPanel(Container parent, IDeclaration anDeclaration) {
		return false;
	}
}