package de.uniwue.ki.gui.mas.sim.situation;
import de.uniwue.ki.gui.mas.util.declaration.DeclarationListPanel;
import de.uniwue.ki.gui.util.dnd.ObjectDataFlavor;
import de.uniwue.ki.mas.sim.situation.ISituationDeclaration;

/**
 * Creation date: (13.12.2000 18:26:47)
 * @author Christoph Oechslein
 */
public class SituationDeclarationListPanel extends DeclarationListPanel {

	/**
	 * UserDefinedFunctionDeclarationListPanel constructor comment.
	 */
	public SituationDeclarationListPanel() {
		super();
		initialize();
	}


	/**
	 * Called whenever the part throws an exception.
	 * @param exception Throwable
	 */
	private void handleException(Throwable exception) {
		exception.printStackTrace(System.out);
	}

	/**
	 * Initialize the class.
	 */
	private void initialize() {
		try {
					setName("SituationDeclarationListPanel");
			setSize(259, 160);
			setDeclarationListModel(new de.uniwue.ki.mas.sim.situation.SituationDeclarationList());
			setCellRenderer(new SituationDeclarationCellRenderer(getCellRenderer()));
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
		enableDnDSupport(ObjectDataFlavor.getDataFlavor(ISituationDeclaration.class));
	}

	public static void main(String[] args) {
		try {
			javax.swing.JFrame frame = new javax.swing.JFrame();
			SituationDeclarationListPanel aSituationDeclarationListPanel;
			aSituationDeclarationListPanel = new SituationDeclarationListPanel();
			frame.setContentPane(aSituationDeclarationListPanel);
			frame.setSize(aSituationDeclarationListPanel.getSize());
			frame.addWindowListener(new java.awt.event.WindowAdapter() {
				public void windowClosing(java.awt.event.WindowEvent e) {
					System.exit(0);
				}
			});
			frame.show();
			java.awt.Insets insets = frame.getInsets();
			frame.setSize(
				frame.getWidth() + insets.left + insets.right,
				frame.getHeight() + insets.top + insets.bottom);
			frame.setVisible(true);
		} catch (Throwable exception) {
			System.err.println(
				"Exception occurred in main() of de.uniwue.ki.gui.mas.model.situation.SituationDeclarationListPanel");
			exception.printStackTrace(System.out);
		}
	}
}