package de.uniwue.ki.gui.mas.sim.userInterface;
import java.awt.Container;

import de.uniwue.ki.gui.mas.model.AbstractDeclarationPanelAndActionFactory;
import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.util.declaration.AbstractDeclarationPanelFactory;
import de.uniwue.ki.gui.mas.util.declaration.IDeclarationPanel;
import de.uniwue.ki.gui.mas.util.declaration.IDeclarationPanelFactory;
import de.uniwue.ki.gui.mas.util.declaration.NameDeclarationWithDocumentationAdapterPanel;
import de.uniwue.ki.mas.model.userInterface.IUserInterfaceDeclaration;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: (11.10.2001 15:13:45)
 * @author Christoph Oechslein
 */
public class UserInterfaceDeclarationPanelActionFactory extends AbstractDeclarationPanelAndActionFactory {
	private final IDeclarationPanelFactory _editPropertiesDeclarationPanelFactory =
		new EditPropertiesDeclarationPanelFactory();

	private class EditPropertiesDeclarationPanelFactory extends AbstractDeclarationPanelFactory {

		public IDeclarationPanel createDeclarationPanel(final IDeclaration declaration) {
			UserInterfaceDeclarationPanel userInterfaceDeclarationPanel = new UserInterfaceDeclarationPanel();

			NameDeclarationWithDocumentationAdapterPanel nameDeclarationWithDocumentationAdapterPanel =
				new NameDeclarationWithDocumentationAdapterPanel();

			nameDeclarationWithDocumentationAdapterPanel.setLinePanel(true);
			nameDeclarationWithDocumentationAdapterPanel.setShowCheckBox(true);

			nameDeclarationWithDocumentationAdapterPanel.setDeclarationPanel(userInterfaceDeclarationPanel);

			nameDeclarationWithDocumentationAdapterPanel.setGUISeSAmDeclaration(getGUISeSAmDeclaration());

			return nameDeclarationWithDocumentationAdapterPanel;
		}

		public String getDeclarationTitle(IDeclaration declaration) {
			return "UserInterface";
		}
	}

	public UserInterfaceDeclarationPanelActionFactory() {
		super();
	}

	public UserInterfaceDeclarationPanelActionFactory(IGUISeSAmDeclaration guiSeSAmDeclaration) {
		super(guiSeSAmDeclaration);
	}

	protected boolean getCanProduceDeclarationActions(Container parent, IDeclaration anDeclaration) {
		return anDeclaration instanceof IUserInterfaceDeclaration;
	}

	public IDeclarationPanelFactory getDeclarationPanelFactory(
		Container parent,
		IDeclaration anDeclaration) {
		return _editPropertiesDeclarationPanelFactory;
	}

//	protected Iterator getImportantDeclarationActions(
//		final Container parent,
//		final IDeclaration anDeclaration) {
//
//		return CollectionsHelper
//			.createConsIterator(new AbstractBoundAction(
//				"Create Simulation Run",
//				NewDeclarationAction.NEW_ICON) {
//			public void doit() {
//				try {
//					ISeSAmDeclaration seSAmDeclaration = getGUISeSAmDeclaration().getSeSAmDeclaration();
//					seSAmDeclaration.getExperimentListAndFactory().getExperimentList().add(
//						ExperimentFactory.createExperiment(
//							seSAmDeclaration,
//							(ISimulationDeclaration)anDeclaration));
//
//				} catch (ModelCompilingException e) {
//					getGUISeSAmDeclaration().showException("During simualtion run creation", e, parent);
//				}
//
//			}
//		}, super.getImportantDeclarationActions(parent, anDeclaration));
//	}

	protected boolean shouldUseOkCancelDeclarationPanel(Container parent, IDeclaration anDeclaration) {
		return false;
	}
}