package de.uniwue.ki.gui.mas.util;

import java.awt.Container;
import java.util.Iterator;

import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.util.actions.AbstractBoundAction;
import de.uniwue.ki.gui.util.actions.InspectAction;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * @author herrler
 * Default that can be used by every Object. it just provides the function Inspect
 */
public abstract class AbstractActionFactory implements IActionFactory {
	public final IGUISeSAmDeclaration _guiSeSAmDeclaration;

	public AbstractActionFactory(IGUISeSAmDeclaration guiSeSAmDeclaration) {
		_guiSeSAmDeclaration = guiSeSAmDeclaration;
	}

	/*
	 * Returns an Iterator with important actions (without property action).
	 */
	public Iterator getImportantActions(Container parent, Object anObject) {
		return CollectionsHelper.EMPTY_ITERATOR;
	}

	/*
	 * Returns an Iterator with not so important actions (may not share actions with #getImportantActions).
	 */
	public Iterator getMoreActions(Container parent, Object anObject) {
		return CollectionsHelper.createIterator(new InspectAction(anObject));
	}

	/*
	 * Returns an Action for editing the properties.
	 */
	public AbstractBoundAction getPropertyAction(Container parent, Object anObject) {
		return null;
	}

	public IGUISeSAmDeclaration getGUISeSAmDeclaration() {
		return _guiSeSAmDeclaration;
	}
}