package de.uniwue.ki.gui.mas.util;
import java.awt.Container;
import java.util.Iterator;

import de.uniwue.ki.gui.util.actions.AbstractBoundAction;

/**
 * Formerly IPanelActionFactory
 * 
 * Creation date: (10.10.2001 10:31:11)
 * @author Christoph Oechslein
 */
public interface IActionFactory {

   /*
    * Can this IActionFactory produce Actions for the given object.
    */
   boolean getCanProduceActions(Container parent, Object anObject);

   /*
    * Returns an Iterator with important actions (without property action).
    */
   Iterator getImportantActions(Container parent, Object anObject);

   /*
    * Returns an Iterator with not so important actions (may not share actions with #getImportantActions).
    */
   Iterator getMoreActions(Container parent, Object anObject);

   /*
    * Returns an Action for editing the properties.
    */
   AbstractBoundAction getPropertyAction(Container parent, Object anObject);
}