package de.uniwue.ki.gui.mas.util.declaration;
import java.awt.BorderLayout;
import java.awt.event.ItemListener;

import javax.swing.JFrame;

import com.ibm.easyswing.BoundJComboBox;

import de.uniwue.ki.gui.util.*;
import de.uniwue.ki.mas.util.declaration.*;

/**
* Insert the type's description here.
* Creation date: (19.06.2000 19:09:02)
* @author Christoph Oechslein
*/
public class DeclarationComboBox extends JDisposeablePanel implements IDisposeable {
	private BoundJComboBox ivjBoundJComboBox = null;
	private DeclarationListMutableComboBoxModel ivjDeclarationListMutableComboBoxModel = null;
	private final IvjEventHandler ivjEventHandler = new IvjEventHandler();
	private DeclarationComboBoxCellEditor ivjBoundDeclarationComboBoxCellEditor = null;
	private IDeclarationFactory ivjDeclarationFactoryIntern = null;
	private IDeclarationList ivjDeclarationListModelIntern = null;

	private final class IvjEventHandler
		implements java.beans.PropertyChangeListener, javax.swing.event.ChangeListener {
		public void propertyChange(java.beans.PropertyChangeEvent evt) {
			if (evt.getSource() == DeclarationComboBox.this.getBoundJComboBox()
				&& (evt.getPropertyName().equals("selectedItem")))
				connEtoC1(evt);
		}
		public void stateChanged(javax.swing.event.ChangeEvent e) {
			if (e.getSource() == DeclarationComboBox.this.getDeclarationListModelIntern())
				connEtoM1(e);
		}
	}

	public Object getPrototypeDisplayValue() {
		return getBoundJComboBox().getPrototypeDisplayValue();
	}

	public void setPrototypeDisplayValue(Object prototypeDisplayValue) {
		getBoundJComboBox().setPrototypeDisplayValue(prototypeDisplayValue);
	}

	/**
	 * DeclarationComboBox constructor comment.
	 */
	public DeclarationComboBox() {
		super();
		initialize();
	}

	public static void main(String[] args) {
		try {
			JFrame frame = new javax.swing.JFrame();
			DeclarationComboBox aDeclarationComboBox;
			aDeclarationComboBox = new DeclarationComboBox();
			frame.setContentPane(aDeclarationComboBox);
			frame.setSize(aDeclarationComboBox.getSize());
			frame.addWindowListener(new java.awt.event.WindowAdapter() {
				public void windowClosing(java.awt.event.WindowEvent e) {
					System.exit(0);
				};
			});
			frame.setVisible(true);
		} catch (Throwable exception) {
			System.err.println("Exception occurred in main() of javax.swing.JPanel");
			exception.printStackTrace(System.out);
		}
	}

	public void dispose() {
		setDeclarationListModel(DeclarationListHelper.EMPTY_DECLARATION_LIST);

		super.dispose();
	}

	public IDeclarationFactory getDeclarationFactory() {
		return getDeclarationFactoryIntern();
	} /**
					  * Return the DeclarationFactoryIntern property value.
					  * @return de.uniwue.ki.mas.model.util.declaration.IDeclarationFactory
					  */

	public IDeclarationList getDeclarationListModel() {
		return getDeclarationListModelIntern();
	} /**
					  * Return the DeclarationListModelIntern property value.
					  * @return de.uniwue.ki.mas.model.util.declaration.IDeclarationList
					  */

	/**
	 * Method generated to support the promotion of the editable attribute.
	 * @return boolean
	 */
	public boolean getEditable() {
		return getBoundJComboBox().isEditable();
	}

	/**
	 * Method generated to support the promotion of the maximumRowCount attribute.
	 * @return int
	 */
	public int getMaximumRowCount() {
		return getBoundJComboBox().getMaximumRowCount();
	}
	
 	

	/**
	 * Method generated to support the promotion of the renderer attribute.
	 * @return javax.swing.ListCellRenderer
	 */
	public javax.swing.ListCellRenderer getRenderer() {
		return getBoundJComboBox().getRenderer();
	}

	/**
	 * Method generated to support the promotion of the selectedItem attribute.
	 * @return Object
	 */
	public Object getSelectedItem() {
		return getBoundJComboBox().getSelectedItem();
	}

	public void setDeclarationFactory(IDeclarationFactory arg1) {
		setDeclarationFactoryIntern(arg1);
	} /**
					  * Set the DeclarationFactoryIntern to a new value.
					  * @param newValue de.uniwue.ki.mas.model.util.declaration.IDeclarationFactory
					  */

	public void setDeclarationListModel(IDeclarationList arg1) {
		setDeclarationListModelIntern(arg1);
	} /**
					  * Set the DeclarationListModelIntern to a new value.
					  * @param newValue de.uniwue.ki.mas.model.util.declaration.IDeclarationList
					  */

	/**
	 * Method generated to support the promotion of the editable attribute.
	 * @param arg1 boolean
	 */
	public void setEditable(boolean arg1) {
		getBoundJComboBox().setEditable(arg1);
	}

	/**
	  * To dis-/enable checkbox.
	  * Creation date: (20.09.2000 16:07:18)
	  * @author Christoph Oechslein
	  */
	public void setEnabled(boolean enabled) {
		super.setEnabled(enabled);
		getBoundJComboBox().setEnabled(enabled);
	}

	/**
	 * Method generated to support the promotion of the maximumRowCount attribute.
	 * @param arg1 int
	 */
	public void setMaximumRowCount(int arg1) {
		getBoundJComboBox().setMaximumRowCount(arg1);
	}

	/**
	 * Method generated to support the promotion of the renderer attribute.
	 * @param arg1 javax.swing.ListCellRenderer
	 */
	public void setRenderer(javax.swing.ListCellRenderer arg1) {
		getBoundJComboBox().setRenderer(arg1);
	}

	/**
	 * Method generated to support the promotion of the selectedItem attribute.
	 * @param arg1 Object
	 */
	public void setSelectedItem(Object arg1) {
		getBoundJComboBox().setSelectedItem(arg1);
	}

	private DeclarationComboBoxCellEditor getBoundDeclarationComboBoxCellEditor() {
		if (ivjBoundDeclarationComboBoxCellEditor == null) {
			try {
				ivjBoundDeclarationComboBoxCellEditor =
					new de.uniwue.ki.gui.mas.util.declaration.DeclarationComboBoxCellEditor();
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjBoundDeclarationComboBoxCellEditor;
	}

	/**
	 * Return the BoundJComboBox property value.
	 * @return BoundJComboBox
	 */
	private BoundJComboBox getBoundJComboBox() {
		if (ivjBoundJComboBox == null) {
			try {
				ivjBoundJComboBox = new BoundJComboBox();
				ivjBoundJComboBox.setName("BoundJComboBox");
				ivjBoundJComboBox.setRenderer(new NamedCellRendererAdapter(ivjBoundJComboBox.getRenderer()));
				ivjBoundJComboBox.setEditable(true);
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjBoundJComboBox;
	}

	private IDeclarationFactory getDeclarationFactoryIntern() {
		return ivjDeclarationFactoryIntern;
	}

	private void setDeclarationFactoryIntern(IDeclarationFactory newValue) {
		if (ivjDeclarationFactoryIntern != newValue) {
			try {
				IDeclarationFactory oldValue = getDeclarationFactoryIntern();
				ivjDeclarationFactoryIntern = newValue;
				connEtoM6(ivjDeclarationFactoryIntern);
				connPtoP3SetSource();
				firePropertyChange("declarationFactory", oldValue, newValue);
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
	}

	private IDeclarationList getDeclarationListModelIntern() {
		return ivjDeclarationListModelIntern;
	}

	private void setDeclarationListModelIntern(IDeclarationList newValue) {
		if (ivjDeclarationListModelIntern != newValue) {
			try {
				IDeclarationList oldValue = getDeclarationListModelIntern();
				/* Stop listening for events from the current object */
				if (ivjDeclarationListModelIntern != null) {
					ivjDeclarationListModelIntern.removeChangeListener(ivjEventHandler);
				}
				ivjDeclarationListModelIntern = newValue;

				/* Listen for events from the new object */
				if (ivjDeclarationListModelIntern != null) {
					ivjDeclarationListModelIntern.addChangeListener(ivjEventHandler);
				}
				connPtoP2SetTarget();
				firePropertyChange("declarationListModel", oldValue, newValue);
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
	}

	private de
		.uniwue
		.ki
		.mas
		.util
		.declaration
		.DeclarationListMutableComboBoxModel getDeclarationListMutableComboBoxModel() {
		if (ivjDeclarationListMutableComboBoxModel == null) {
			try {
				ivjDeclarationListMutableComboBoxModel = new DeclarationListMutableComboBoxModel();
							} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		}
		return ivjDeclarationListMutableComboBoxModel;
	}

	/**
	 * connEtoC1:  (BoundJComboBox.selectedItem --> DeclarationComboBox.firePropertyChange(LString;LObject;LObject;)V)
	 * @param arg1 java.beans.PropertyChangeEvent
	 */
	private void connEtoC1(java.beans.PropertyChangeEvent arg1) {
		try {
					this.firePropertyChange("selectedItem", arg1.getOldValue(), arg1.getNewValue());
				} catch (Throwable ivjExc) {
					handleException(ivjExc);
		}
	}

	/**
	 * connEtoM1:  (DeclarationListModelIntern.change.stateChanged(javax.swing.event.ChangeEvent) --> BoundJComboBox.repaint()V)
	 * @param arg1 javax.swing.event.ChangeEvent
	 */
	private void connEtoM1(javax.swing.event.ChangeEvent arg1) {
		try {
					getBoundJComboBox().repaint();
				} catch (Throwable ivjExc) {
					handleException(ivjExc);
		}
	}

	private void connEtoM6(IDeclarationFactory value) {
		try {
					getBoundJComboBox().setEditor(getBoundDeclarationComboBoxCellEditor());
				} catch (Throwable ivjExc) {
					handleException(ivjExc);
		}
	}

	/**
	 * connPtoP1SetTarget:  (DeclarationListMutableComboBoxModel.this <--> BoundJComboBox.model)
	 */
	private void connPtoP1SetTarget() {
		try {
			getBoundJComboBox().setModel(getDeclarationListMutableComboBoxModel());
				} catch (Throwable ivjExc) {
					handleException(ivjExc);
		}
	}

	/**
	 * connPtoP2SetTarget:  (DefaultDeclarationList.this <--> DeclarationListMutableComboBoxModel.declarationList)
	 */
	private void connPtoP2SetTarget() {
		try {
			if ((getDeclarationListModelIntern() != null)) {
				getDeclarationListMutableComboBoxModel().setDeclarationList(getDeclarationListModelIntern());
			}
				} catch (Throwable ivjExc) {
					handleException(ivjExc);
		}
	}

	/**
	 * connPtoP3SetSource:  (DeclarationComboBoxCellEditor.abstractDeclarationFactory <--> AbstractDeclarationFactory.this)
	 */
	private void connPtoP3SetSource() {
		try {
			if ((getDeclarationFactoryIntern() != null)) {
				getBoundDeclarationComboBoxCellEditor().setAbstractDeclarationFactory(
					getDeclarationFactoryIntern());
			}
				} catch (Throwable ivjExc) {
					handleException(ivjExc);
		}
	}

	/**
	 * connPtoP3SetTarget:  (DeclarationComboBoxCellEditor.abstractDeclarationFactory <--> AbstractDeclarationFactory.this)
	 */
	private void connPtoP3SetTarget() {
		try {
			setDeclarationFactoryIntern(
				getBoundDeclarationComboBoxCellEditor().getAbstractDeclarationFactory());
				} catch (Throwable ivjExc) {
					handleException(ivjExc);
		}
	}

	/**
	 * connPtoP4SetTarget:  (DeclarationListMutableComboBoxModel.this <--> DeclarationComboBoxCellEditor.declarationListMutableComboBoxModel)
	 */
	private void connPtoP4SetTarget() {
		try {
			getBoundDeclarationComboBoxCellEditor().setDeclarationListMutableComboBoxModel(
				getDeclarationListMutableComboBoxModel());
				} catch (Throwable ivjExc) {
					handleException(ivjExc);
		}
	}

	/**
	 * Called whenever the part throws an exception.
	 * @param exception Throwable
	 */
	private void handleException(Throwable exception) {

		exception.printStackTrace(System.out);
	}

	/**
	 * Initializes connections
	 * @exception Exception The exception description.
	 */
	private void initConnections() {
		getBoundJComboBox().addPropertyChangeListener(ivjEventHandler);
		connPtoP1SetTarget();
		connPtoP2SetTarget();
		connPtoP4SetTarget();
		connPtoP3SetTarget();
	}

	/**
	 * Initialize the class.
	 */
	private void initialize() {
		setLayout(new BorderLayout());
		add(getBoundJComboBox());
		initConnections();
	}
    public void addItemListener(ItemListener aListener) {
        getBoundJComboBox().addItemListener(aListener);
    }

}