package de.uniwue.ki.gui.mas.util.declaration;

import javax.swing.plaf.basic.BasicComboBoxEditor;

import de.uniwue.ki.mas.util.declaration.*;

/**
 * Creation date: (19.06.2000 19:48:03)
 * @author Christoph Oechslein
 */
public class DeclarationComboBoxCellEditor extends BasicComboBoxEditor {
   private IDeclarationFactory AbstractDeclarationFactory;
   private DeclarationListMutableComboBoxModel declarationListMutableComboBoxModel;

/**
 * DeclarationComboBoxCellEditor constructor comment.
 */
public DeclarationComboBoxCellEditor() {
   super();
}

/**
 * Insert the method's description here.
 * Creation date: (19.06.2000 19:49:23)
 * @author Christoph Oechslein
 * @return de.uniwue.ki.mas.model.util.declaration.IDeclarationFactory
 */
public IDeclarationFactory getAbstractDeclarationFactory() {
   return AbstractDeclarationFactory;
}

/**
 * Insert the method's description here.
 * Creation date: (19.06.2000 19:49:23)
 * @author Christoph Oechslein
 * @param newAbstractDeclarationFactory de.uniwue.ki.mas.model.util.declaration.IDeclarationFactory
 */
public void setAbstractDeclarationFactory(IDeclarationFactory newAbstractDeclarationFactory) {
   AbstractDeclarationFactory = newAbstractDeclarationFactory;
}

/**
 * Insert the method's description here.
 * Creation date: (21.06.2000 13:55:39)
 * @author Christoph Oechslein
 * @return de.uniwue.ki.mas.model.util.declaration.DeclarationListMutableComboBoxModel
 */
public de.uniwue.ki.mas.util.declaration.DeclarationListMutableComboBoxModel getDeclarationListMutableComboBoxModel() {
   return declarationListMutableComboBoxModel;
} /**
* Insert the method's description here.
* Creation date: (21.06.2000 13:55:39)
* @author Christoph Oechslein
* @param newDeclarationListMutableComboBoxModel de.uniwue.ki.mas.model.util.declaration.DeclarationListMutableComboBoxModel
*/

public void setDeclarationListMutableComboBoxModel(
   de.uniwue.ki.mas.util.declaration.DeclarationListMutableComboBoxModel newDeclarationListMutableComboBoxModel) {
   declarationListMutableComboBoxModel = newDeclarationListMutableComboBoxModel;
}

public Object getItem() {
   String name = (String) super.getItem();
   if (getAbstractDeclarationFactory() == null || getDeclarationListMutableComboBoxModel() == null) {
      return name;
   } else {
      if (getDeclarationListMutableComboBoxModel().getDeclarationList().containsDeclaration(name)) {
         return getDeclarationListMutableComboBoxModel().getDeclarationList().getDeclarationByName(name);
      } else {
         IDeclaration declaration = getAbstractDeclarationFactory().createDeclaration();

         if (declaration instanceof IDocumentableDeclaration)
             ((IDocumentableDeclaration) declaration).setShortDescription(name);

         getDeclarationListMutableComboBoxModel().addElement(declaration);
         return declaration;
      }
   }
}

public void setItem(Object anObject) {
   if (anObject == null)
      super.setItem(null);
   else
      super.setItem(((de.uniwue.ki.mas.util.declaration.IDeclaration) anObject).getName());
}
}
