package de.uniwue.ki.gui.mas.util.declaration;
import java.awt.*;
import java.awt.event.*;
import java.util.Iterator;

import javax.swing.*;

import com.magelang.box.*;
import com.magelang.box.VerticalGlue;
import com.magelang.box.VerticalStrut;

import de.uniwue.ki.gui.mas.model.JPanelWithGUISeSAmDeclaration;
import de.uniwue.ki.gui.util.boxlayout.BoxLayoutRigidArea;
import de.uniwue.ki.mas.util.declaration.*;
import de.uniwue.ki.util.functions.IMapFunction;

/**
 * Creation date: (20.06.00 15:13:37)
 * @author Christoph Oechslein
 */

public class DeclarationListToDeclarationListPanel extends JPanelWithGUISeSAmDeclaration {
	private IMapFunction _leftToRightMapFunction;

	private JPanel ivjButtonJPanel = null;
	private final IvjEventHandler ivjEventHandler = new IvjEventHandler();
	private DeclarationListPanel ivjLeftDeclarationListPanelIntern = null;
	private DeclarationListPanel ivjRightDeclarationListPanelIntern = null;
	private IDeclarationList ivjRightDeclarationListModel = null;
	private HorizontalGlue ivjBoxLayoutHorizontalGlue1 = null;
	private JButton ivjJButtonClear = null;
	private JButton ivjJButtonLeftToRight = null;
	private JButton ivjJButtonRightToLeft = null;
	private JPanel ivjJPanelUpperText = null;
	private JLabel ivjLeftJLabel = null;
	private JLabel ivjRightJLabel = null;
	private VerticalStrut ivjBoxLayoutVerticalStrut1 = null;
	private DeclarationListPanel ivjLeftDeclarationJListPanel = null;
	private DeclarationListPanel ivjRightDeclarationJListPanel = null;
	private boolean ivjConnPtoP3Aligning = false;
	private BoxLayoutRigidArea ivjBoxLayoutRigidArea1 = null;
	private BoxLayoutRigidArea ivjBoxLayoutRigidArea11 = null;
	private HorizontalGlue ivjBoxLayoutHorizontalGlue2 = null;
	private VerticalGlue ivjBoxLayoutVerticalGlue1 = null;
	private JPanel ivjJPanelLists = null;
	private JPanel ivjJPanelY = null;
	private JPanel ivjLeftDeclJPanel = null;
	private JPanel ivjRightDeclJPanel = null;
	private boolean ivjConnPtoP4Aligning = false;
	private boolean ivjConnPtoP7Aligning = false;
	private boolean _overrideRemoveVetoListener = false;


	public void setOverrideRemoveVetoListener(boolean var){
		_overrideRemoveVetoListener = var;
	}

	private final class IvjEventHandler implements ActionListener, java.beans.PropertyChangeListener {
		public void actionPerformed(ActionEvent e) {
			if (e.getSource() == DeclarationListToDeclarationListPanel.this.getJButtonClear())
				connEtoC6(e);
			if (e.getSource() == DeclarationListToDeclarationListPanel.this.getJButtonRightToLeft())
				connEtoC10(e);
			if (e.getSource() == DeclarationListToDeclarationListPanel.this.getJButtonLeftToRight())
				connEtoC11(e);
		};
		public void propertyChange(java.beans.PropertyChangeEvent evt) {
			if (evt.getSource()
				== DeclarationListToDeclarationListPanel.this.getRightDeclarationListPanelIntern()
				&& (evt.getPropertyName().equals("declarationListModel")))
				connPtoP3SetTarget();
			if (evt.getSource() == DeclarationListToDeclarationListPanel.this.getLeftDeclarationJListPanel()
				&& (evt.getPropertyName().equals("declarationFactory")))
				connEtoC1(evt);
			if (evt.getSource() == DeclarationListToDeclarationListPanel.this.getLeftDeclarationJListPanel()
				&& (evt.getPropertyName().equals("declarationListModel")))
				connEtoC7(evt);
			if (evt.getSource() == DeclarationListToDeclarationListPanel.this.getLeftDeclarationJListPanel()
				&& (evt.getPropertyName().equals("buttonPaneAvailible")))
				connEtoC5(evt);
			if (evt.getSource() == DeclarationListToDeclarationListPanel.this.getRightDeclarationJListPanel()
				&& (evt.getPropertyName().equals("buttonPaneAvailible")))
				connEtoC8(evt);
			if (evt.getSource() == DeclarationListToDeclarationListPanel.this.getRightDeclarationJListPanel()
				&& (evt.getPropertyName().equals("declarationFactory")))
				connEtoC4(evt);
			if (evt.getSource() == DeclarationListToDeclarationListPanel.this.getRightDeclarationJListPanel()
				&& (evt.getPropertyName().equals("declarationListModel")))
				connEtoC9(evt);
			if (evt.getSource() == DeclarationListToDeclarationListPanel.this
				&& (evt.getPropertyName().equals("gUISeSAmDeclaration")))
				connPtoP4SetTarget();
			if (evt.getSource()
				== DeclarationListToDeclarationListPanel.this.getRightDeclarationListPanelIntern()
				&& (evt.getPropertyName().equals("gUISeSAmDeclaration")))
				connPtoP4SetSource();
			if (evt.getSource() == DeclarationListToDeclarationListPanel.this
				&& (evt.getPropertyName().equals("gUISeSAmDeclaration")))
				connPtoP7SetTarget();
			if (evt.getSource()
				== DeclarationListToDeclarationListPanel.this.getLeftDeclarationListPanelIntern()
				&& (evt.getPropertyName().equals("gUISeSAmDeclaration")))
				connPtoP7SetSource();
			if (evt.getSource() == DeclarationListToDeclarationListPanel.this.getLeftJLabel()
				&& (evt.getPropertyName().equals("text")))
				connEtoC2(evt);
			if (evt.getSource() == DeclarationListToDeclarationListPanel.this.getRightJLabel()
				&& (evt.getPropertyName().equals("text")))
				connEtoC3(evt);
			if (evt.getSource() == DeclarationListToDeclarationListPanel.this.getLeftDeclarationJListPanel()
				&& (evt.getPropertyName().equals("editable")))
				connEtoC12(evt);
			if (evt.getSource() == DeclarationListToDeclarationListPanel.this.getRightDeclarationJListPanel()
				&& (evt.getPropertyName().equals("editable")))
				connEtoC13(evt);
		};
	};

	public DeclarationListToDeclarationListPanel() {
		super();
		initialize();
	}

	private void connEtoC1(java.beans.PropertyChangeEvent arg1) {
		try {
			this.firePropertyChange("DeclarationFactory", arg1.getOldValue(), arg1.getNewValue());
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	private void connEtoC10(ActionEvent arg1) {
		try {
			this.eventPressedRightToLeftButton();
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	private void connEtoC11(ActionEvent arg1) {
		try {
			this.eventPressedLeftToRightButton();

		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	private void connEtoC12(java.beans.PropertyChangeEvent arg1) {
		try {
			this.firePropertyChange(
				"leftDeclarationListPanelEditable",
				arg1.getOldValue(),
				arg1.getNewValue());
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	private void connEtoC13(java.beans.PropertyChangeEvent arg1) {
		try {
			this.firePropertyChange(
				"rightDeclarationListPanelEditable",
				arg1.getOldValue(),
				arg1.getNewValue());
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	private void connEtoC2(java.beans.PropertyChangeEvent arg1) {
		try {
			this.firePropertyChange("leftDeclarationListPanelText", arg1.getOldValue(), arg1.getNewValue());
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	private void connEtoC3(java.beans.PropertyChangeEvent arg1) {
		try {
			this.firePropertyChange("rightDeclarationListPanelText", arg1.getOldValue(), arg1.getNewValue());
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	private void connEtoC4(java.beans.PropertyChangeEvent arg1) {
		try {
			this.firePropertyChange(
				"rightDeclarationListPanelDeclarationFactory",
				arg1.getOldValue(),
				arg1.getNewValue());
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	private void connEtoC5(java.beans.PropertyChangeEvent arg1) {
		try {
			this.firePropertyChange(
				"leftDeclarationListPanelButtonPaneAvailible",
				arg1.getOldValue(),
				arg1.getNewValue());
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	private void connEtoC6(ActionEvent arg1) {
		try {
			this.eventPressedClearButton();
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	private void connEtoC7(java.beans.PropertyChangeEvent arg1) {
		try {
			this.firePropertyChange(
				"leftDeclarationListPanelDeclarationListModel",
				arg1.getOldValue(),
				arg1.getNewValue());
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	private void connEtoC8(java.beans.PropertyChangeEvent arg1) {
		try {
			this.firePropertyChange(
				"rightDeclarationListPanelButtonPaneAvailible",
				arg1.getOldValue(),
				arg1.getNewValue());
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	private void connEtoC9(java.beans.PropertyChangeEvent arg1) {
		try {
			this.firePropertyChange(
				"rightDeclarationListPanelDeclarationListModel",
				arg1.getOldValue(),
				arg1.getNewValue());
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	private void connPtoP3SetSource() {
		try {
			if (ivjConnPtoP3Aligning == false) {
				ivjConnPtoP3Aligning = true;
				if ((getRightDeclarationListPanelIntern() != null)
					&& (getRightDeclarationListModel() != null)) {
					getRightDeclarationListPanelIntern().setDeclarationListModel(
						getRightDeclarationListModel());
				}
				ivjConnPtoP3Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP3Aligning = false;
			handleException(ivjExc);
		}
	}

	private void connPtoP3SetTarget() {
		try {
			if (ivjConnPtoP3Aligning == false) {
				if (getRightDeclarationListPanelIntern() == null)
					return;
				ivjConnPtoP3Aligning = true;
				setRightDeclarationListModel(getRightDeclarationListPanelIntern().getDeclarationListModel());
				ivjConnPtoP3Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP3Aligning = false;
			handleException(ivjExc);
		}
	}

	private void connPtoP4SetSource() {
		try {
			if (ivjConnPtoP4Aligning == false) {
				ivjConnPtoP4Aligning = true;
				if ((getRightDeclarationListPanelIntern() != null)) {
					this.setGUISeSAmDeclaration(
						getRightDeclarationListPanelIntern().getGUISeSAmDeclaration());
				}
				ivjConnPtoP4Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP4Aligning = false;
			handleException(ivjExc);
		}
	}

	private void connPtoP4SetTarget() {
		try {
			if (ivjConnPtoP4Aligning == false) {
				ivjConnPtoP4Aligning = true;
				if ((getRightDeclarationListPanelIntern() != null)) {
					getRightDeclarationListPanelIntern().setGUISeSAmDeclaration(
						this.getGUISeSAmDeclaration());
				}
				ivjConnPtoP4Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP4Aligning = false;
			handleException(ivjExc);
		}
	}

	private void connPtoP5SetTarget() {
		try {
			setRightDeclarationListPanelIntern(getRightDeclarationJListPanel());
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	private void connPtoP6SetTarget() {
		try {
			setLeftDeclarationListPanelIntern(getLeftDeclarationJListPanel());
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	private void connPtoP7SetSource() {
		try {
			if (ivjConnPtoP7Aligning == false) {
				ivjConnPtoP7Aligning = true;
				if ((getLeftDeclarationListPanelIntern() != null)) {
					this.setGUISeSAmDeclaration(getLeftDeclarationListPanelIntern().getGUISeSAmDeclaration());
				}
				ivjConnPtoP7Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP7Aligning = false;
			handleException(ivjExc);
		}
	}

	private void connPtoP7SetTarget() {
		try {
			if (ivjConnPtoP7Aligning == false) {
				ivjConnPtoP7Aligning = true;
				if ((getLeftDeclarationListPanelIntern() != null)) {
					getLeftDeclarationListPanelIntern().setGUISeSAmDeclaration(this.getGUISeSAmDeclaration());
				}
				ivjConnPtoP7Aligning = false;
			}
		} catch (Throwable ivjExc) {
			ivjConnPtoP7Aligning = false;
			handleException(ivjExc);
		}
	}

	public void dispose() {
		super.dispose();

		getLeftDeclarationJListPanel().removePropertyChangeListener(ivjEventHandler);
		getRightDeclarationJListPanel().removePropertyChangeListener(ivjEventHandler);

		getLeftDeclarationJListPanel().dispose();
		getRightDeclarationJListPanel().dispose();
	}

	protected void eventPressedClearButton() {
		/*Iterator it = getRightDeclarationListPanelDeclarationListModel().iterator();
		
		while (it.hasNext()) {

			IDeclaration currDecl = (IDeclaration)it.next();
			if(_overrideRemoveVetoListener == false){
				if (getRightDeclarationListPanelDeclarationListModel().canBeRemoved(currDecl)) {
					it.remove();
				}
			}
			else{
				it.remove();
			}
		}*/						
		Object[] values = getRightDeclarationListPanelIntern().getListDataAsArray();
		for (int i = 0; i < values.length; i++) {
			IDeclaration currDecl = (IDeclaration)values[i];
	
			if(_overrideRemoveVetoListener == false){
				if (getRightDeclarationListPanelDeclarationListModel().canBeRemoved(currDecl)) {
						getRightDeclarationListPanelDeclarationListModel().remove(currDecl);
					}	
			}
			else{
				getRightDeclarationListPanelDeclarationListModel().remove(currDecl,false);
			}			
		}
	}

	protected void eventPressedLeftToRightButton() {
		Object[] values = getLeftDeclarationListPanelIntern().getSelectedValues();
		for (int i = 0; i < values.length; i++) {
			Object mappedValue = mapLeftToRightButton(values[i]);
			if (mappedValue != null) {
				getRightDeclarationListPanelDeclarationListModel().add(mappedValue);
			}
		}
	}

	protected void eventPressedRightToLeftButton() {
		Object[] values = getRightDeclarationListPanelIntern().getSelectedValues();
		for (int i = 0; i < values.length; i++) {
			IDeclaration currDecl = (IDeclaration)values[i];
			
			if(_overrideRemoveVetoListener == false){
				if (getRightDeclarationListPanelDeclarationListModel().canBeRemoved(currDecl)) {
						getRightDeclarationListPanelDeclarationListModel().remove(currDecl);
					}	
			}
			else{
				getRightDeclarationListPanelDeclarationListModel().remove(currDecl,false);
			}
	
			
		}
	}

	private com.magelang.box.HorizontalGlue getBoxLayoutHorizontalGlue1() {
		if (ivjBoxLayoutHorizontalGlue1 == null) {
			try {
				ivjBoxLayoutHorizontalGlue1 = new com.magelang.box.HorizontalGlue();
				ivjBoxLayoutHorizontalGlue1.setName("BoxLayoutHorizontalGlue1");
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjBoxLayoutHorizontalGlue1;
	}

	private com.magelang.box.HorizontalGlue getBoxLayoutHorizontalGlue2() {
		if (ivjBoxLayoutHorizontalGlue2 == null) {
			try {
				ivjBoxLayoutHorizontalGlue2 = new com.magelang.box.HorizontalGlue();
				ivjBoxLayoutHorizontalGlue2.setName("BoxLayoutHorizontalGlue2");
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjBoxLayoutHorizontalGlue2;
	}

	private BoxLayoutRigidArea getBoxLayoutRigidArea1() {
		if (ivjBoxLayoutRigidArea1 == null) {
			try {
				ivjBoxLayoutRigidArea1 = new BoxLayoutRigidArea();
				ivjBoxLayoutRigidArea1.setName("BoxLayoutRigidArea1");
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjBoxLayoutRigidArea1;
	}

	private de.uniwue.ki.gui.util.boxlayout.BoxLayoutRigidArea getBoxLayoutRigidArea11() {
		if (ivjBoxLayoutRigidArea11 == null) {
			try {
				ivjBoxLayoutRigidArea11 = new de.uniwue.ki.gui.util.boxlayout.BoxLayoutRigidArea();
				ivjBoxLayoutRigidArea11.setName("BoxLayoutRigidArea11");
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjBoxLayoutRigidArea11;
	}

	private VerticalGlue getBoxLayoutVerticalGlue1() {
		if (ivjBoxLayoutVerticalGlue1 == null) {
			try {
				ivjBoxLayoutVerticalGlue1 = new com.magelang.box.VerticalGlue();
				ivjBoxLayoutVerticalGlue1.setName("BoxLayoutVerticalGlue1");
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjBoxLayoutVerticalGlue1;
	}

	private com.magelang.box.VerticalStrut getBoxLayoutVerticalStrut1() {
		if (ivjBoxLayoutVerticalStrut1 == null) {
			try {
				ivjBoxLayoutVerticalStrut1 = new com.magelang.box.VerticalStrut();
				ivjBoxLayoutVerticalStrut1.setName("BoxLayoutVerticalStrut1");
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjBoxLayoutVerticalStrut1;
	}

	private JPanel getButtonJPanel() {
		if (ivjButtonJPanel == null) {
			try {
				ivjButtonJPanel = new JPanel();
				ivjButtonJPanel.setName("ButtonJPanel");
				ivjButtonJPanel.setLayout(new GridBagLayout());
				ivjButtonJPanel.setMaximumSize(new Dimension(1640, 1024));

				GridBagConstraints constraintsJButtonLeftToRight = new GridBagConstraints();
				constraintsJButtonLeftToRight.gridx = 0;
				constraintsJButtonLeftToRight.gridy = 0;
				constraintsJButtonLeftToRight.fill = GridBagConstraints.HORIZONTAL;
				constraintsJButtonLeftToRight.insets = new Insets(0, 0, 5, 0);
				getButtonJPanel().add(getJButtonLeftToRight(), constraintsJButtonLeftToRight);

				GridBagConstraints constraintsJButtonRightToLeft = new GridBagConstraints();
				constraintsJButtonRightToLeft.gridx = 0;
				constraintsJButtonRightToLeft.gridy = 1;
				constraintsJButtonRightToLeft.fill = GridBagConstraints.HORIZONTAL;
				constraintsJButtonRightToLeft.insets = new Insets(0, 0, 11, 0);
				getButtonJPanel().add(getJButtonRightToLeft(), constraintsJButtonRightToLeft);

				GridBagConstraints constraintsJButtonClear = new GridBagConstraints();
				constraintsJButtonClear.gridx = 0;
				constraintsJButtonClear.gridy = 2;
				constraintsJButtonClear.gridheight = 2;
				constraintsJButtonClear.fill = GridBagConstraints.HORIZONTAL;
				getButtonJPanel().add(getJButtonClear(), constraintsJButtonClear);
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjButtonJPanel;
	}

	private BoxLayout getDeclarationListToDeclarationListPanelBoxLayout() {
		BoxLayout ivjDeclarationListToDeclarationListPanelBoxLayout = null;
		try {
			ivjDeclarationListToDeclarationListPanelBoxLayout = new BoxLayout(this, BoxLayout.X_AXIS);
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
		return ivjDeclarationListToDeclarationListPanelBoxLayout;
	}

	private JButton getJButtonClear() {
		if (ivjJButtonClear == null) {
			try {
				ivjJButtonClear = new JButton();
				ivjJButtonClear.setName("JButtonClear");
				ivjJButtonClear.setAlignmentX(Component.CENTER_ALIGNMENT);
				ivjJButtonClear.setText("Clear >>");
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjJButtonClear;
	}

	private JButton getJButtonLeftToRight() {
		if (ivjJButtonLeftToRight == null) {
			try {
				ivjJButtonLeftToRight = new JButton();
				ivjJButtonLeftToRight.setName("JButtonLeftToRight");
				ivjJButtonLeftToRight.setText(">>");
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjJButtonLeftToRight;
	}

	private JButton getJButtonRightToLeft() {
		if (ivjJButtonRightToLeft == null) {
			try {
				ivjJButtonRightToLeft = new JButton();
				ivjJButtonRightToLeft.setName("JButtonRightToLeft");
				ivjJButtonRightToLeft.setText("<<");
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjJButtonRightToLeft;
	}

	private JPanel getJPanelLists() {
		if (ivjJPanelLists == null) {
			try {
				ivjJPanelLists = new JPanel();
				ivjJPanelLists.setName("JPanelLists");
				ivjJPanelLists.setLayout(new BoxLayout(getJPanelLists(), BoxLayout.X_AXIS));
				getJPanelLists().add(getLeftDeclJPanel(), getLeftDeclJPanel().getName());
				getJPanelLists().add(getBoxLayoutRigidArea1(), getBoxLayoutRigidArea1().getName());
				getJPanelLists().add(getButtonJPanel(), getButtonJPanel().getName());
				getJPanelLists().add(getBoxLayoutRigidArea11(), getBoxLayoutRigidArea11().getName());
				getJPanelLists().add(getRightDeclJPanel(), getRightDeclJPanel().getName());
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjJPanelLists;
	}

	private JPanel getJPanelUpperText() {
		if (ivjJPanelUpperText == null) {
			try {
				ivjJPanelUpperText = new JPanel();
				ivjJPanelUpperText.setName("JPanelUpperText");
				ivjJPanelUpperText.setLayout(new BoxLayout(getJPanelUpperText(), BoxLayout.X_AXIS));
				getJPanelUpperText().add(getLeftJLabel(), getLeftJLabel().getName());
				getJPanelUpperText().add(
					getBoxLayoutHorizontalGlue1(),
					getBoxLayoutHorizontalGlue1().getName());
				getJPanelUpperText().add(getRightJLabel(), getRightJLabel().getName());
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjJPanelUpperText;
	}

	private JPanel getJPanelY() {
		if (ivjJPanelY == null) {
			try {
				ivjJPanelY = new JPanel();
				ivjJPanelY.setName("JPanelY");
				ivjJPanelY.setLayout(getJPanelYBoxLayout());
				getJPanelY().add(getJPanelUpperText(), getJPanelUpperText().getName());
				getJPanelY().add(getBoxLayoutVerticalStrut1(), getBoxLayoutVerticalStrut1().getName());
				getJPanelY().add(getJPanelLists(), getJPanelLists().getName());
				getJPanelY().add(getBoxLayoutVerticalGlue1(), getBoxLayoutVerticalGlue1().getName());
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjJPanelY;
	}

	private BoxLayout getJPanelYBoxLayout() {
		BoxLayout ivjJPanelYBoxLayout = null;
		try {
			ivjJPanelYBoxLayout = new BoxLayout(getJPanelY(), BoxLayout.Y_AXIS);
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		};
		return ivjJPanelYBoxLayout;
	}

	private DeclarationListPanel getLeftDeclarationJListPanel() {
		if (ivjLeftDeclarationJListPanel == null) {
			try {
				ivjLeftDeclarationJListPanel =
					new de.uniwue.ki.gui.mas.util.declaration.DeclarationListPanel();
				ivjLeftDeclarationJListPanel.setName("LeftDeclarationJListPanel");
				ivjLeftDeclarationJListPanel.setPreferredSize(new Dimension(160, 20));
				ivjLeftDeclarationJListPanel.setMinimumSize(new Dimension(160, 20));
				ivjLeftDeclarationJListPanel.setEditable(false);
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjLeftDeclarationJListPanel;
	}

	public DeclarationListPanel getLeftDeclarationListPanel() {
		return getLeftDeclarationListPanelIntern();
	}

	public boolean getLeftDeclarationListPanelButtonPaneAvailible() {
		return getLeftDeclarationListPanel().isButtonPaneAvailible();
	}

	public IDeclarationFactory getLeftDeclarationListPanelDeclarationFactory() {
		return getLeftDeclarationListPanel().getDeclarationFactory();
	}

	public IDeclarationList getLeftDeclarationListPanelDeclarationListModel() {
		return getLeftDeclarationListPanel().getDeclarationListModel();
	}

	public boolean getLeftDeclarationListPanelEditable() {
		return getLeftDeclarationJListPanel().isEditable();
	}

	private DeclarationListPanel getLeftDeclarationListPanelIntern() {
		return ivjLeftDeclarationListPanelIntern;
	}

	public String getLeftDeclarationListPanelText() {
		return getLeftJLabel().getText();
	}

	private JPanel getLeftDeclJPanel() {
		if (ivjLeftDeclJPanel == null) {
			try {
				ivjLeftDeclJPanel = new JPanel();
				ivjLeftDeclJPanel.setName("LeftDeclJPanel");
				ivjLeftDeclJPanel.setPreferredSize(new Dimension(160, 200));
				ivjLeftDeclJPanel.setLayout(new BoxLayout(getLeftDeclJPanel(), BoxLayout.X_AXIS));
				ivjLeftDeclJPanel.setMaximumSize(new Dimension(1640, 1024));
				getLeftDeclJPanel().add(
					getLeftDeclarationJListPanel(),
					getLeftDeclarationJListPanel().getName());
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjLeftDeclJPanel;
	}

	private JLabel getLeftJLabel() {
		if (ivjLeftJLabel == null) {
			try {
				ivjLeftJLabel = new JLabel();
				ivjLeftJLabel.setName("LeftJLabel");
				ivjLeftJLabel.setText("Left");
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjLeftJLabel;
	}

	public IMapFunction getLeftToRightMapFunction() {
		return _leftToRightMapFunction;
	}

	private DeclarationListPanel getRightDeclarationJListPanel() {
		if (ivjRightDeclarationJListPanel == null) {
			try {
				ivjRightDeclarationJListPanel =
					new de.uniwue.ki.gui.mas.util.declaration.DeclarationListPanel();
				ivjRightDeclarationJListPanel.setName("RightDeclarationJListPanel");
				ivjRightDeclarationJListPanel.setPreferredSize(new Dimension(160, 20));
				ivjRightDeclarationJListPanel.setMinimumSize(new Dimension(160, 20));
				ivjRightDeclarationJListPanel.setEditable(false);
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjRightDeclarationJListPanel;
	}

	private IDeclarationList getRightDeclarationListModel() {
		return ivjRightDeclarationListModel;
	}

	public DeclarationListPanel getRightDeclarationListPanel() {
		return getRightDeclarationListPanelIntern();
	}

	public boolean getRightDeclarationListPanelButtonPaneAvailible() {
		return getRightDeclarationListPanel().isButtonPaneAvailible();
	}

	public IDeclarationFactory getRightDeclarationListPanelDeclarationFactory() {
		return getRightDeclarationListPanel().getDeclarationFactory();
	}

	public IDeclarationList getRightDeclarationListPanelDeclarationListModel() {
		return getRightDeclarationListPanel().getDeclarationListModel();
	}

	public boolean getRightDeclarationListPanelEditable() {
		return getRightDeclarationJListPanel().isEditable();
	}

	private DeclarationListPanel getRightDeclarationListPanelIntern() {
		return ivjRightDeclarationListPanelIntern;
	}

	public String getRightDeclarationListPanelText() {
		return getRightJLabel().getText();
	}

	private JPanel getRightDeclJPanel() {
		if (ivjRightDeclJPanel == null) {
			try {
				ivjRightDeclJPanel = new JPanel();
				ivjRightDeclJPanel.setName("RightDeclJPanel");
				ivjRightDeclJPanel.setPreferredSize(new Dimension(160, 200));
				ivjRightDeclJPanel.setLayout(new BoxLayout(getRightDeclJPanel(), BoxLayout.X_AXIS));
				ivjRightDeclJPanel.setMaximumSize(new Dimension(1640, 1024));
				getRightDeclJPanel().add(
					getRightDeclarationJListPanel(),
					getRightDeclarationJListPanel().getName());
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjRightDeclJPanel;
	}

	private JLabel getRightJLabel() {
		if (ivjRightJLabel == null) {
			try {
				ivjRightJLabel = new JLabel();
				ivjRightJLabel.setName("RightJLabel");
				ivjRightJLabel.setText("Right");
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjRightJLabel;
	}

	private void handleException(Throwable exception) {
		exception.printStackTrace(System.out);
	}

	private void initConnections() {
		getLeftDeclarationJListPanel().addPropertyChangeListener(ivjEventHandler);
		getRightDeclarationJListPanel().addPropertyChangeListener(ivjEventHandler);
		this.addPropertyChangeListener(ivjEventHandler);
		getLeftJLabel().addPropertyChangeListener(ivjEventHandler);
		getRightJLabel().addPropertyChangeListener(ivjEventHandler);
		getJButtonClear().addActionListener(ivjEventHandler);
		getJButtonRightToLeft().addActionListener(ivjEventHandler);
		getJButtonLeftToRight().addActionListener(ivjEventHandler);
		connPtoP3SetTarget();
		connPtoP6SetTarget();
		connPtoP5SetTarget();
		connPtoP4SetTarget();
		connPtoP7SetTarget();
	}

	private void initialize() {
		try {
			setName("DeclarationListToDeclarationListPanel");
			setLayout(getDeclarationListToDeclarationListPanelBoxLayout());
			setSize(423, 206);
			add(getJPanelY(), getJPanelY().getName());
			add(getBoxLayoutHorizontalGlue2(), getBoxLayoutHorizontalGlue2().getName());
			initConnections();
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	public static void main(String[] args) {
		try {
			JFrame frame = new JFrame();
			DeclarationListToDeclarationListPanel aDeclarationListToDeclarationListPanel;
			aDeclarationListToDeclarationListPanel = new DeclarationListToDeclarationListPanel();
			frame.setContentPane(aDeclarationListToDeclarationListPanel);
			frame.setSize(aDeclarationListToDeclarationListPanel.getSize());
			frame.addWindowListener(new WindowAdapter() {
				public void windowClosing(WindowEvent e) {
					System.exit(0);
				}
			});
			frame.show();
			Insets insets = frame.getInsets();
			frame.setSize(
				frame.getWidth() + insets.left + insets.right,
				frame.getHeight() + insets.top + insets.bottom);
			frame.setVisible(true);
		} catch (Throwable exception) {
			System.err.println("Exception occurred in main() of JPanel");
			exception.printStackTrace(System.out);
		}
	}

	protected Object mapLeftToRightButton(Object obj) {
		if (_leftToRightMapFunction == null)
			return obj;

		else {
			try {
				return _leftToRightMapFunction.map(obj);
			} catch (Exception exception) {
				handleException(exception);

				return null;
			}
		}
	}

	public void setLeftDeclarationListPanel(DeclarationListPanel arg1) {
		setLeftDeclarationListPanelIntern(arg1);
	}

	public void setLeftDeclarationListPanelButtonPaneAvailible(boolean arg1) {
		getLeftDeclarationListPanel().setButtonPaneAvailible(arg1);
	}

	public void setLeftDeclarationListPanelDeclarationFactory(
		de.uniwue.ki.mas.util.declaration.IDeclarationFactory arg1) {
		getLeftDeclarationListPanel().setDeclarationFactory(arg1);
	}

	public void setLeftDeclarationListPanelDeclarationListModel(IDeclarationList arg1) {
		getLeftDeclarationListPanel().setDeclarationListModel(arg1);
	}

	public void setLeftDeclarationListPanelEditable(boolean arg1) {
		getLeftDeclarationJListPanel().setEditable(arg1);
	}

	private void setLeftDeclarationListPanelIntern(DeclarationListPanel newValue) {
		if (ivjLeftDeclarationListPanelIntern != newValue) {
			try {
				de.uniwue.ki.gui.mas.util.declaration.DeclarationListPanel oldValue =
					getLeftDeclarationListPanelIntern();
				/* Stop listening for events from the current object */
				if (ivjLeftDeclarationListPanelIntern != null) {
					ivjLeftDeclarationListPanelIntern.removePropertyChangeListener(ivjEventHandler);
				}
				ivjLeftDeclarationListPanelIntern = newValue;

				/* Listen for events from the new object */
				if (ivjLeftDeclarationListPanelIntern != null) {
					ivjLeftDeclarationListPanelIntern.addPropertyChangeListener(ivjEventHandler);
				}
				connPtoP7SetTarget();
				firePropertyChange("leftDeclarationListPanel", oldValue, newValue);
						// if (newValue != oldValue) {
				ivjLeftDeclarationJListPanel = ivjLeftDeclarationListPanelIntern;

				getLeftDeclJPanel().removeAll();

				if (newValue != null) {
					getLeftDeclJPanel().add(newValue, BorderLayout.CENTER);
				}
				// }
					} catch (Throwable ivjExc) {
								handleException(ivjExc);
			}
		};
	}

	public void setLeftDeclarationListPanelText(String arg1) {
		getLeftJLabel().setText(arg1);
	}

	public void setLeftToRightMapFunction(IMapFunction newLeftToRightMapFunction) {
		_leftToRightMapFunction = newLeftToRightMapFunction;
	}

	private void setRightDeclarationListModel(IDeclarationList newValue) {
		if (ivjRightDeclarationListModel != newValue) {
			try {
				IDeclarationList oldValue = getRightDeclarationListModel();
				ivjRightDeclarationListModel = newValue;
				connPtoP3SetSource();
				firePropertyChange("leftDeclarationListPanelDeclarationListModel", oldValue, newValue);
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
	}

	public void setRightDeclarationListPanel(DeclarationListPanel arg1) {
		setRightDeclarationListPanelIntern(arg1);
	}

	public void setRightDeclarationListPanelButtonPaneAvailible(boolean arg1) {
		getRightDeclarationListPanel().setButtonPaneAvailible(arg1);
	}

	public void setRightDeclarationListPanelDeclarationFactory(IDeclarationFactory arg1) {
		getRightDeclarationListPanel().setDeclarationFactory(arg1);
	}

	public void setRightDeclarationListPanelDeclarationListModel(IDeclarationList arg1) {
		getRightDeclarationListPanel().setDeclarationListModel(arg1);
	}

	public void setRightDeclarationListPanelEditable(boolean arg1) {
		getRightDeclarationJListPanel().setEditable(arg1);
	}

	private void setRightDeclarationListPanelIntern(DeclarationListPanel newValue) {
		if (ivjRightDeclarationListPanelIntern != newValue) {
			try {
				de.uniwue.ki.gui.mas.util.declaration.DeclarationListPanel oldValue =
					getRightDeclarationListPanelIntern();
				/* Stop listening for events from the current object */
				if (ivjRightDeclarationListPanelIntern != null) {
					ivjRightDeclarationListPanelIntern.removePropertyChangeListener(ivjEventHandler);
				}
				ivjRightDeclarationListPanelIntern = newValue;

				/* Listen for events from the new object */
				if (ivjRightDeclarationListPanelIntern != null) {
					ivjRightDeclarationListPanelIntern.addPropertyChangeListener(ivjEventHandler);
				}
				connPtoP3SetTarget();
				connPtoP4SetTarget();
				firePropertyChange("leftDeclarationListPanel", oldValue, newValue);
						//if (newValue != oldValue) {
				ivjRightDeclarationJListPanel = ivjRightDeclarationListPanelIntern;

				getRightDeclJPanel().removeAll();
				if (newValue != null) {
					getRightDeclJPanel().add(newValue, BorderLayout.CENTER);
				}
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
	}

	public void setRightDeclarationListPanelText(String arg1) {
		getRightJLabel().setText(arg1);
	}
}