package de.uniwue.ki.gui.mas.util.declaration;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import javax.swing.JLabel;

import de.uniwue.ki.gui.util.JDocumentablePanel;
import de.uniwue.ki.mas.util.declaration.IDeclaration;
import de.uniwue.ki.mas.util.declaration.IDocumentableDeclaration;

/**
 * Creation date: (13.07.2001 13:15:09)
 * @author Christoph Oechslein
 */
public class NameDeclarationPanel extends AbstractDeclarationPanel {
    
	private JDocumentablePanel ivjJDocumentablePanel1 = null;
	
	private JLabel ivjJLabel1 = null;
	
	private final IvjEventHandler ivjEventHandler = new IvjEventHandler();
	
	private final class IvjEventHandler implements PropertyChangeListener {
	    
		public void propertyChange(PropertyChangeEvent evt) {
			if (evt.getSource() == NameDeclarationPanel.this.getJDocumentablePanel1()
				&& (evt.getPropertyName().equals("showCheckBox")))
				connEtoC1(evt);
		}
	}

	/**
	 * NameDeclarationPanel constructor comment.
	 */
	public NameDeclarationPanel() {
		super();
		initialize();
	}

	/**
	 * connEtoC1:  (JDocumentablePanel1.showCheckBox --> NameDeclarationPanel.firePropertyChange(LString;LObject;LObject;)V)
	 * @param arg1 java.beans.PropertyChangeEvent
	 */
	private void connEtoC1(PropertyChangeEvent arg1) {
		try {
			this.firePropertyChange("showCheckBox", arg1.getOldValue(), arg1.getNewValue());
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	/**
	 * @see de.uniwue.ki.gui.mas.model.util.declaration.IDeclarationPanel
	 */
	public IDeclaration getDeclaration() {
		return (IDocumentableDeclaration) getJDocumentablePanel1().getDocumentable();
	}

	/**
	 * Return the JDocumentablePanel1 property value.
	 * @return JDocumentablePanel
	 */
	private JDocumentablePanel getJDocumentablePanel1() {
		if (ivjJDocumentablePanel1 == null) {
			try {
				ivjJDocumentablePanel1 = new JDocumentablePanel();
				ivjJDocumentablePanel1.setName("JDocumentablePanel1");
				ivjJDocumentablePanel1.setShowCheckBox(false);
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjJDocumentablePanel1;
	}

	/**
	 * Return the JLabel1 property value.
	 * @return JLabel
	 */
	private JLabel getJLabel1() {
		if (ivjJLabel1 == null) {
			try {
				ivjJLabel1 = new JLabel();
				ivjJLabel1.setName("JLabel1");
				ivjJLabel1.setText("Name:");
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjJLabel1;
	}

	/**
	 * Method generated to support the promotion of the showCheckBox attribute.
	 * @return boolean
	 */
	public boolean getShowCheckBox() {
		return getJDocumentablePanel1().isShowCheckBox();
	}

	/**
	 * Called whenever the part throws an exception.
	 * @param exception Throwable
	 */
	private void handleException(Throwable exception) {

		exception.printStackTrace(System.out);
	}

	/**
	 * Initializes connections
	 * @exception Exception The exception description.
	 */
	private void initConnections() {
		getJDocumentablePanel1().addPropertyChangeListener(ivjEventHandler);
	}

	/**
	 * Initialize the class.
	 */
	private void initialize() {
		try {
			setName("NameDeclarationPanel");

			setLayout(new GridBagLayout());

			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.gridx = 0;
			gridBagConstraints.gridy = 0;
			gridBagConstraints.anchor = GridBagConstraints.LINE_START;

			add(getJLabel1(), gridBagConstraints);

			gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.gridx = 1;
			gridBagConstraints.gridy = 0;
			gridBagConstraints.insets.left = 3;
			gridBagConstraints.weightx = 1;
			gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
			gridBagConstraints.anchor = GridBagConstraints.LINE_START;

			add(getJDocumentablePanel1(), gridBagConstraints);

			initConnections();
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	public boolean isEditable() {
		return getJDocumentablePanel1().isEditable();
	}

	public void setDeclaration(IDeclaration declaration) {
		getJDocumentablePanel1().setDocumentable((IDocumentableDeclaration) declaration);
	}

	public void setEditable(boolean newEditable) {
		getJDocumentablePanel1().setEditable(newEditable);
	}

	public void setEnabled(boolean newSettings) {
		super.setEnabled(newSettings);
	}

	/**
	 * Method generated to support the promotion of the showCheckBox attribute.
	 * @param arg1 boolean
	 */
	public void setShowCheckBox(boolean arg1) {
		getJDocumentablePanel1().setShowCheckBox(arg1);
	}

	public void dispose() {
		getJDocumentablePanel1().dispose();

		super.dispose();
	}
}