package de.uniwue.ki.gui.mas.util.declaration;


import java.awt.*;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.*;

import junit.framework.Assert;
import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: (13.07.2001 13:32:56)
 * @author Christoph Oechslein
 */
public class NameDeclarationWithDocumentationAdapterPanel extends JPanel implements IDeclarationPanel {
	boolean _linePanel = true;

	private IDeclarationPanel _declarationPanel;
	private NameDeclarationWithDocumentationPanel ivjNameDeclarationWithDocumentationPanel = null;
	private JPanel ivjJPanelContainer = null;
	private JSeparator ivjLinePanel = null;

	public NameDeclarationWithDocumentationAdapterPanel(IDeclarationPanel declarationPanel) {
		this();

		setDeclarationPanel(declarationPanel);
	}

	public NameDeclarationWithDocumentationAdapterPanel() {
		super();
		initialize();
	}

	public void dispose() {
		getNameDeclarationWithDocumentationPanel().dispose();
		if (getDeclarationPanel() != null) {
			getDeclarationPanel().dispose();
		}
	}

	/**
	 * @see util.declaration.IDeclarationPanel
	 */
	public IDeclaration getDeclaration() {
		return getNameDeclarationWithDocumentationPanel().getDeclaration();
	}

	/**
	 * Insert the method's description here.
	 * Creation date: (13.07.2001 13:35:59)
	 * @return util.declaration.IDeclarationPanel
	 */
	public IDeclarationPanel getDeclarationPanel() {
		return _declarationPanel;
	}

	/**
	 * @see util.declaration.IDeclarationPanel
	 */
	public IGUISeSAmDeclaration getGUISeSAmDeclaration() {
		return getNameDeclarationWithDocumentationPanel().getGUISeSAmDeclaration();
	}

	/**
	 * Return the JPanelContainer property value.
	 * @return JPanel
	 */
	private JPanel getJPanelContainer() {
		if (ivjJPanelContainer == null) {
			try {
				ivjJPanelContainer = new JPanel();
				ivjJPanelContainer.setName("JPanelContainer");
				ivjJPanelContainer.setLayout(new BorderLayout());
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjJPanelContainer;
	}

	/**
	 * Return the LinePanel property value.
	 * @return LinePanel
	 */
	private JSeparator getLinePanel() {
		if (ivjLinePanel == null) {
			ivjLinePanel = new JSeparator();
		}
		return ivjLinePanel;
	}

	/**
	 * Return the NameDeclarationWithDocumentationPanel property value.
	 * @return util.declaration.NameDeclarationWithDocumentationPanel
	 */
	private NameDeclarationWithDocumentationPanel getNameDeclarationWithDocumentationPanel() {
		if (ivjNameDeclarationWithDocumentationPanel == null) {
			try {
				ivjNameDeclarationWithDocumentationPanel =
					new NameDeclarationWithDocumentationPanel();
				ivjNameDeclarationWithDocumentationPanel.setName("NameDeclarationWithDocumentationPanel");
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjNameDeclarationWithDocumentationPanel;
	}

	/**
	 * Called whenever the part throws an exception.
	 * @param exception Throwable
	 */
	private void handleException(Throwable exception) {

		exception.printStackTrace(System.out);
	}

	/**
	 * Initialize the class.
	 */
	private void initialize() {
		try {
			setName("NameDeclarationWithDocumentationAdapterPanel");
			setLayout(new GridBagLayout());
			setSize(598, 92);

			GridBagConstraints constraintsNameDeclarationWithDocumentationPanel =
				new GridBagConstraints();
			constraintsNameDeclarationWithDocumentationPanel.gridx = 1;
			constraintsNameDeclarationWithDocumentationPanel.gridy = 1;
			constraintsNameDeclarationWithDocumentationPanel.fill = GridBagConstraints.HORIZONTAL;
			constraintsNameDeclarationWithDocumentationPanel.weightx = 1.0;
			add(getNameDeclarationWithDocumentationPanel(), constraintsNameDeclarationWithDocumentationPanel);

			GridBagConstraints constraintsLinePanel = new GridBagConstraints();
			constraintsLinePanel.gridx = 1;
			constraintsLinePanel.gridy = 2;
			constraintsLinePanel.fill = GridBagConstraints.HORIZONTAL;
			constraintsLinePanel.insets = new Insets(4, 0, 4, 0);
			add(getLinePanel(), constraintsLinePanel);

			GridBagConstraints constraintsJPanelContainer = new GridBagConstraints();
			constraintsJPanelContainer.gridx = 1;
			constraintsJPanelContainer.gridy = 3;
			constraintsJPanelContainer.fill = GridBagConstraints.BOTH;
			constraintsJPanelContainer.weightx = 1.0;
			constraintsJPanelContainer.weighty = 1.0;
			add(getJPanelContainer(), constraintsJPanelContainer);
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
		setLinePanel(true);
	}

	public boolean isDisposed() {
		return getNameDeclarationWithDocumentationPanel().isDisposed();
	}

	public boolean isEditable() {
		return getNameDeclarationWithDocumentationPanel().isEditable();
	}

	public boolean isLinePanel() {
		return _linePanel;
	}

	public static void main(String[] args) {
		try {
			JFrame frame = new JFrame();
			NameDeclarationWithDocumentationAdapterPanel aNameDeclarationWithDocumentationAdapterPanel;
			aNameDeclarationWithDocumentationAdapterPanel =
				new NameDeclarationWithDocumentationAdapterPanel();
			frame.setContentPane(aNameDeclarationWithDocumentationAdapterPanel);
			frame.setSize(aNameDeclarationWithDocumentationAdapterPanel.getSize());
			frame.addWindowListener(new WindowAdapter() {
				public void windowClosing(WindowEvent e) {
					System.exit(0);
				}
			});
			frame.show();
			Insets insets = frame.getInsets();
			frame.setSize(
				frame.getWidth() + insets.left + insets.right,
				frame.getHeight() + insets.top + insets.bottom);
			frame.setVisible(true);
		} catch (Throwable exception) {
			System.err.println("Exception occurred in main() of JPanel");
			exception.printStackTrace(System.out);
		}
	}

	public void setDeclaration(IDeclaration declaration) {
		getNameDeclarationWithDocumentationPanel().setDeclaration(declaration);
		if (getDeclarationPanel() != null) {
			getDeclarationPanel().setDeclaration(declaration);
		}
	}

	public void setDeclarationPanel(IDeclarationPanel newDeclarationPanel) {
		if (Assert.ASSERTION_ON) {
			Assert.assertNull(_declarationPanel);
			Assert.assertNotNull(newDeclarationPanel);
			Assert.assertTrue(newDeclarationPanel instanceof Component);
		}

		_declarationPanel = newDeclarationPanel;

		getJPanelContainer().add((Component)getDeclarationPanel(), BorderLayout.CENTER);

		if (getDeclarationPanel() != null) {
			getDeclarationPanel().setEnabled(isEnabled());

			if (getDeclaration() != null) {
				getDeclarationPanel().setDeclaration(getDeclaration());
			}
			if (getGUISeSAmDeclaration() != null) {
				getDeclarationPanel().setGUISeSAmDeclaration(getGUISeSAmDeclaration());
			}
		}

		revalidate();
	}

	public void setEditable(boolean newEditable) {
		getNameDeclarationWithDocumentationPanel().setEditable(newEditable);
	}

	public void setEnabled(boolean newEnabled) {
		super.setEnabled(newEnabled);

		getNameDeclarationWithDocumentationPanel().setEnabled(newEnabled);

		if (getDeclarationPanel() != null) {
			getDeclarationPanel().setEnabled(newEnabled);
		}
	}

	/**
	 * @see util.declaration.IDeclarationPanel
	 */
	public void setGUISeSAmDeclaration(IGUISeSAmDeclaration guiSeSAmDeclaration) {
		getNameDeclarationWithDocumentationPanel().setGUISeSAmDeclaration(guiSeSAmDeclaration);
		if (getDeclarationPanel() != null) {
			getDeclarationPanel().setGUISeSAmDeclaration(guiSeSAmDeclaration);
		}
	}

	public void setLinePanel(boolean newSetting) {

		boolean oldSetting = isLinePanel();

		if (oldSetting != newSetting) {
			_linePanel = newSetting;

			if (!newSetting) {
				remove(getLinePanel());

			} else {
				GridBagConstraints constraintsLinePanel = new GridBagConstraints();
				constraintsLinePanel.gridx = 1;
				constraintsLinePanel.gridy = 2;
				constraintsLinePanel.insets.top = 4;
				constraintsLinePanel.insets.bottom = 4;
				constraintsLinePanel.weightx = 1;
				constraintsLinePanel.fill = GridBagConstraints.HORIZONTAL;
				add(getLinePanel(), constraintsLinePanel);
			}
		}
	}

	/**
	 * Method generated to support the promotion of the showCheckBox attribute.
	 * @return boolean
	 */
	public boolean getShowCheckBox() {
		return getNameDeclarationWithDocumentationPanel().getShowCheckBox();
	}

	/**
	 * Method generated to support the promotion of the showCheckBox attribute.
	 * @param arg1 boolean
	 */
	public void setShowCheckBox(boolean arg1) {
		getNameDeclarationWithDocumentationPanel().setShowCheckBox(arg1);
	}
}