package de.uniwue.ki.gui.mas.util.declaration;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import javax.swing.*;

import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: (13.07.2001 13:21:45)
 * @author Christoph Oechslein
 */
public class NameDeclarationWithDocumentationPanel extends JPanel implements IDeclarationPanel {
	private NameDeclarationPanel ivjNameDeclarationPanel = null;
	private DocumentableDeclarationButton ivjDocumentableDeclarationButton = null;
	private final IvjEventHandler _eventHandler = new IvjEventHandler();
	
	private final class IvjEventHandler implements PropertyChangeListener {
		public void propertyChange(PropertyChangeEvent evt) {
			if (evt.getSource() == NameDeclarationWithDocumentationPanel.this.getNameDeclarationPanel()
				&& (evt.getPropertyName().equals("showCheckBox")))
				connEtoC1(evt);
		}
	}

	public NameDeclarationWithDocumentationPanel() {
		super();
		initialize();
	}

	private void connEtoC1(PropertyChangeEvent arg1) {
		try {
			this.firePropertyChange("showCheckBox", arg1.getOldValue(), arg1.getNewValue());
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	public void dispose() {
		getNameDeclarationPanel().dispose();
		getDocumentableDeclarationButton().dispose();
	}

	public IDeclaration getDeclaration() {
		return getNameDeclarationPanel().getDeclaration();
	}

	private DocumentableDeclarationButton getDocumentableDeclarationButton() {
		if (ivjDocumentableDeclarationButton == null) {
			try {
				ivjDocumentableDeclarationButton = new DocumentableDeclarationButton();
				ivjDocumentableDeclarationButton.setName("DocumentableDeclarationButton");
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjDocumentableDeclarationButton;
	}

	public IGUISeSAmDeclaration getGUISeSAmDeclaration() {
		return getNameDeclarationPanel().getGUISeSAmDeclaration();
	}

	private NameDeclarationPanel getNameDeclarationPanel() {
		if (ivjNameDeclarationPanel == null) {
			try {
				ivjNameDeclarationPanel = new NameDeclarationPanel();
				ivjNameDeclarationPanel.setName("NameDeclarationPanel");
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return ivjNameDeclarationPanel;
	}

	public boolean getShowCheckBox() {
		return getNameDeclarationPanel().getShowCheckBox();
	}

	private void handleException(Throwable exception) {
		exception.printStackTrace(System.out);
	}

	private void initConnections() {
		getNameDeclarationPanel().addPropertyChangeListener(_eventHandler);
	}

	private void initialize() {
		try {
			setName("NameDeclarationWithDocumentationPanel");
			setLayout(new BoxLayout(this, BoxLayout.X_AXIS));
			setSize(707, 86);
			add(getNameDeclarationPanel());
			add(Box.createHorizontalStrut(3));
			add(getDocumentableDeclarationButton());
			add(Box.createHorizontalStrut(2));
			initConnections();
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	}

	public boolean isDisposed() {
		return getNameDeclarationPanel().isDisposed();
	}

	public boolean isEditable() {
		return getNameDeclarationPanel().isEditable();
	}

	public static void main(String[] args) {
		try {
			JFrame frame = new JFrame();
			NameDeclarationWithDocumentationPanel aNameDeclarationWithDocumentationPanel;
			aNameDeclarationWithDocumentationPanel = new NameDeclarationWithDocumentationPanel();
			frame.setContentPane(aNameDeclarationWithDocumentationPanel);
			frame.setSize(aNameDeclarationWithDocumentationPanel.getSize());
			frame.addWindowListener(new java.awt.event.WindowAdapter() {
				public void windowClosing(java.awt.event.WindowEvent e) {
					System.exit(0);
				}
			});
			frame.show();
			java.awt.Insets insets = frame.getInsets();
			frame.setSize(
				frame.getWidth() + insets.left + insets.right,
				frame.getHeight() + insets.top + insets.bottom);
			frame.setVisible(true);
		} catch (Throwable exception) {
			System.err.println("Exception occurred in main() of JPanel");
			exception.printStackTrace(System.out);
		}
	}

	public void setDeclaration(IDeclaration declaration) {
		getNameDeclarationPanel().setDeclaration(declaration);
		getDocumentableDeclarationButton().setDeclaration(declaration);
	}

	public void setEditable(boolean newEditable) {
		getNameDeclarationPanel().setEditable(newEditable);
	}
	
	public void setDocumentationEditable(boolean newEditable){
		getDocumentableDeclarationButton().setEnabled(newEditable);
	}

	public void setEnabled(boolean newSettings) {
		super.setEnabled(newSettings);

		getNameDeclarationPanel().setEnabled(newSettings);
		getDocumentableDeclarationButton().setEnabled(newSettings);
	}

	public void setGUISeSAmDeclaration(IGUISeSAmDeclaration guiSeSAmDeclaration) {
		getNameDeclarationPanel().setGUISeSAmDeclaration(guiSeSAmDeclaration);
		getDocumentableDeclarationButton().setGUISeSAmDeclaration(guiSeSAmDeclaration);
	}

	public void setShowCheckBox(boolean arg1) {
		getNameDeclarationPanel().setShowCheckBox(arg1);
	}
}