package de.uniwue.ki.gui.mas.util.declaration;
import java.awt.Component;
import java.awt.event.*;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.HashMap;

import javax.swing.*;
import javax.swing.event.AncestorEvent;
import javax.swing.event.AncestorListener;

import junit.framework.Assert;

import com.jgoodies.forms.factories.Borders;
import com.jgoodies.forms.factories.ButtonBarFactory;

import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.util.SwingMoreUtilities;
import de.uniwue.ki.gui.util.border.*;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Insert the type's description here. Creation date: (21.06.2001 15:49:29)
 * 
 * @author Christoph Oechslein
 */
public class OkCancelDeclarationPanel extends AbstractDeclarationPanel {
    private IDeclaration fieldDeclaration = null;
    private IDeclarationPanel ivjDeclarationPanelIntern = null;
    private final IvjEventHandler ivjEventHandler = new IvjEventHandler();
    private JButton ivjJButtonApply = null;
    private JButton ivjJButtonCancel = null;
    private JButton ivjJButtonOk = null;
    private JPanel ivjJPanelButtons = null;
    private JPanel ivjJPanelMain = null;
    protected transient WindowListener aWindowListener = null;
    private JPanel ivjJPanel = null;

    private final class IvjEventHandler implements ActionListener, PropertyChangeListener {
        public void actionPerformed(ActionEvent e) {
            if (e.getSource() == OkCancelDeclarationPanel.this.getJButtonOk())
                connEtoC1(e);
            if (e.getSource() == OkCancelDeclarationPanel.this.getJButtonApply())
                connEtoC2(e);
            if (e.getSource() == OkCancelDeclarationPanel.this.getJButtonCancel())
                connEtoC3(e);
        }
        public void propertyChange(PropertyChangeEvent evt) {
            if (evt.getSource() == OkCancelDeclarationPanel.this
                && (evt.getPropertyName().equals("declaration")))
                connEtoM2(evt);
            if (evt.getSource() == OkCancelDeclarationPanel.this
                && (evt.getPropertyName().equals("gUISeSAmDeclaration")))
                connEtoM1(evt);
        }
    }

    public OkCancelDeclarationPanel() {
        super();
        initialize();
    }

    private void connEtoC1(ActionEvent arg1) {
        try {
            this.pressedOkButton();
        } catch (Throwable ivjExc) {
            handleException(ivjExc);
        }
    }

    private void connEtoC2(ActionEvent arg1) {
        try {
            this.pressedApplyButton();
        } catch (Throwable ivjExc) {
            handleException(ivjExc);
        }
    }

    private void connEtoC3(ActionEvent arg1) {
        try {
            this.pressedCancelButton();
        } catch (Throwable ivjExc) {
            handleException(ivjExc);
        }
    }

    private void connEtoC4(IDeclarationPanel value) {
        try {
            this.declarationPanelIntern_This(getDeclarationPanelIntern());

        } catch (Throwable ivjExc) {

            handleException(ivjExc);
        }
    }

    /**
     * connEtoC5: (OkCancelDeclarationPanel.initialize() --> OkCancelDeclarationPanel.registerKeyStrokes()V)
     */

    private void connEtoC5() {
        try {

            this.registerKeyStrokes();

        } catch (Throwable ivjExc) {

            handleException(ivjExc);
        }
    }

    /**
     * connEtoM1: (OkCancelDeclarationPanel.gUISeSAmDeclaration --> DeclarationPanelIntern.frameFactory)
     * 
     * @param arg1
     *            PropertyChangeEvent
     */

    private void connEtoM1(PropertyChangeEvent arg1) {
        try {

            getDeclarationPanelIntern().setGUISeSAmDeclaration(this.getGUISeSAmDeclaration());

        } catch (Throwable ivjExc) {

            handleException(ivjExc);
        }
    }

    /**
     * connEtoM2: (OkCancelDeclarationPanel.declaration --> DeclarationPanelIntern.this)
     * 
     * @param arg1
     *            PropertyChangeEvent
     */

    private void connEtoM2(PropertyChangeEvent arg1) {
        try {

            getDeclarationPanelIntern().setDeclaration(this.copyDeclaration(this.getDeclaration()));

        } catch (Throwable ivjExc) {

            handleException(ivjExc);
        }
    }

    protected IDeclaration copyDeclaration(IDeclaration declaration) {

        if (Assert.ASSERTION_ON)
            Assert.assertNotNull(declaration);

        IDeclaration newDeclaration = (IDeclaration) declaration.copy(new HashMap());

        Assert.assertNotNull(newDeclaration);

        return newDeclaration;
    }

    protected void declarationPanelIntern_This(IDeclarationPanel panel) {

        Assert.assertEquals(0, getJPanelMain().getComponentCount());

        getJPanelMain().add((Component) panel, java.awt.BorderLayout.CENTER);

        //		GridBagConstraints gridBagConstraints = new GridBagConstraints();
        //		gridBagConstraints.fill = GridBagConstraints.BOTH;
        //		gridBagConstraints.weightx = 1;
        //		gridBagConstraints.weighty = 1;
        //		
        //		getJPanelMain().add((Component) panel, gridBagConstraints);

        if (getGUISeSAmDeclaration() != null)
            panel.setGUISeSAmDeclaration(getGUISeSAmDeclaration());
    }

    public void dispose() {
        this.removePropertyChangeListener(ivjEventHandler);

        IDeclaration copyDeclaration = getDeclarationPanelIntern().getDeclaration();

        if (copyDeclaration != null) {
            copyDeclaration.remove();
        }

        if (getDeclarationPanelIntern() != null)
            getDeclarationPanelIntern().dispose();

        if (getDeclarationPanel() != null) {
            getDeclarationPanel().setDeclaration(null);
        }

        super.dispose();
    }

    /**
     * Gets the declaration property (de.uniwue.ki.mas.model.util.declaration.IDeclaration) value.
     * 
     * @return The declaration property value.
     * @see #setDeclaration
     */
    public IDeclaration getDeclaration() {
        return fieldDeclaration;
    }

    /**
     * Method generated to support the promotion of the declarationPanel attribute.
     * 
     * @return de.uniwue.ki.gui.mas.model.util.declaration.IDeclarationPanel
     */
    public IDeclarationPanel getDeclarationPanel() {
        return getDeclarationPanelIntern();
    }

    /**
     * Return the DeclarationPanelIntern property value.
     * 
     * @return de.uniwue.ki.gui.mas.model.util.declaration.AbstractDeclarationPanel
     */

    private IDeclarationPanel getDeclarationPanelIntern() {

        return ivjDeclarationPanelIntern;
    }

    /**
     * Return the JButtonApply property value.
     * 
     * @return JButton
     */

    private JButton getJButtonApply() {
        if (ivjJButtonApply == null) {
            try {
                ivjJButtonApply = new JButton();
                ivjJButtonApply.setName("JButtonApply");
                ivjJButtonApply.setMnemonic('a');
                ivjJButtonApply.setText("Apply");

            } catch (Throwable ivjExc) {

                handleException(ivjExc);
            }
        }
        return ivjJButtonApply;
    }

    /**
     * Return the JButtonCancel property value.
     * 
     * @return JButton
     */

    private JButton getJButtonCancel() {
        if (ivjJButtonCancel == null) {
            try {
                ivjJButtonCancel = new JButton();
                ivjJButtonCancel.setName("JButtonCancel");
                ivjJButtonCancel.setMnemonic('c');
                ivjJButtonCancel.setText("Cancel");

            } catch (Throwable ivjExc) {

                handleException(ivjExc);
            }
        }
        return ivjJButtonCancel;
    }

    /**
     * Return the JButtonOk property value.
     * 
     * @return JButton
     */

    private JButton getJButtonOk() {
        if (ivjJButtonOk == null) {
            try {
                ivjJButtonOk = new JButton();
                ivjJButtonOk.setName("JButtonOk");
                ivjJButtonOk.setMnemonic('o');
                ivjJButtonOk.setText("Ok");
                ivjJButtonOk.setRolloverEnabled(true);

            } catch (Throwable ivjExc) {

                handleException(ivjExc);
            }
        }
        return ivjJButtonOk;
    }

    /**
     * Return the JPanel property value.
     * 
     * @return JPanel
     */

    private JPanel getJPanel() {
        if (ivjJPanel == null) {
            try {
                ivjJPanel = new JPanel();
                ivjJPanel.setName("JPanel");
                ivjJPanel.setLayout(new java.awt.BorderLayout());
                getJPanel().add(getJPanelButtons(), java.awt.BorderLayout.SOUTH);
                getJPanel().add(getJPanelMain(), java.awt.BorderLayout.CENTER);

            } catch (Throwable ivjExc) {

                handleException(ivjExc);
            }
        }
        return ivjJPanel;
    }

    /**
     * Return the JPanelButtons property value.
     * 
     * @return JPanel
     */

    private JPanel getJPanelButtons() {
        if (ivjJPanelButtons == null) {

            ivjJPanelButtons =
                ButtonBarFactory.buildOKCancelApplyBar(getJButtonOk(), getJButtonCancel(), getJButtonApply());

            ivjJPanelButtons.setBorder(Borders.createEmptyBorder("1dlu, 0dlu, 2dlu, 2dlu"));

            //			try {
            //				ivjJPanelButtons = new JPanel();
            //				ivjJPanelButtons.setName("JPanelButtons");
            //				ivjJPanelButtons.setLayout(getJPanelButtonsFlowLayout());
            //				getJPanelButtons().add(getJButtonOk(), getJButtonOk().getName());
            //				getJPanelButtons().add(getJButtonApply(), getJButtonApply().getName());
            //				getJPanelButtons().add(getJButtonCancel(), getJButtonCancel().getName());
            //				
            //				
            //			} catch (Throwable ivjExc) {
            //				
            //				
            //				handleException(ivjExc);
            //			}
        }
        return ivjJPanelButtons;
    }

    /**
     * Return the JPanelMain property value.
     * 
     * @return JPanel
     */

    private JPanel getJPanelMain() {
        if (ivjJPanelMain == null) {
            try {
                BetterCompoundBorder ivjLocalBorder;
                ivjLocalBorder = new BetterCompoundBorder();
                ivjLocalBorder.setInsideBorder(new BetterEmptyBorder());
                ivjLocalBorder.setOutsideBorder(new BetterBevelBorder());
                ivjJPanelMain = new JPanel();
                ivjJPanelMain.setName("JPanelMain");
                ivjJPanelMain.setBorder(ivjLocalBorder);
                ivjJPanelMain.setLayout(new java.awt.BorderLayout());

                //ivjJPanelMain.setLayout(new GridBagLayout());

            } catch (Throwable ivjExc) {

                handleException(ivjExc);
            }
        }
        return ivjJPanelMain;
    }

    /**
     * Called whenever the part throws an exception.
     * 
     * @param exception
     *            Throwable
     */
    private void handleException(Throwable exception) {

        exception.printStackTrace(System.out);
    }

    /**
     * Initializes connections
     * 
     * @exception Exception
     *                The exception description.
     */

    private void initConnections() {

        this.addPropertyChangeListener(ivjEventHandler);
        getJButtonOk().addActionListener(ivjEventHandler);
        getJButtonApply().addActionListener(ivjEventHandler);
        getJButtonCancel().addActionListener(ivjEventHandler);
    }

    /**
     * Initialize the class.
     */

    private void initialize() {
        try {

            setName("OkCancelDeclarationPanel");
            setLayout(new java.awt.BorderLayout());
            setSize(284, 337);
            add(getJPanel(), java.awt.BorderLayout.CENTER);
            initConnections();
            connEtoC5();
        } catch (Throwable ivjExc) {
            handleException(ivjExc);
        }

    }

    /**
     * main entrypoint - starts the part when it is run as an application
     * 
     * @param args
     *            String[]
     */
    public static void main(String[] args) {
        try {
            JFrame frame = new JFrame();
            OkCancelDeclarationPanel aOkCancelDeclarationPanel;
            aOkCancelDeclarationPanel = new OkCancelDeclarationPanel();
            frame.setContentPane(aOkCancelDeclarationPanel);
            frame.setSize(aOkCancelDeclarationPanel.getSize());
            frame.addWindowListener(new WindowAdapter() {
                public void windowClosing(WindowEvent e) {
                    System.exit(0);
                }
            });
            frame.show();
            java.awt.Insets insets = frame.getInsets();
            frame.setSize(
                frame.getWidth() + insets.left + insets.right,
                frame.getHeight() + insets.top + insets.bottom);
            frame.setVisible(true);
        } catch (Throwable exception) {
            System.err.println("Exception occurred in main() of JPanel");
            exception.printStackTrace(System.out);
        }
    }

    protected void pressedApplyButton() {
        IDeclaration copyDeclaration = getDeclarationPanelIntern().getDeclaration();
        IDeclaration realDeclaration = getDeclaration();

        copyDeclaration.copyInto(realDeclaration, new HashMap());
    }

    protected void pressedCancelButton() {
        SwingMoreUtilities.closeRootWindow(this);
    }

    protected void pressedOkButton() {
        IDeclaration copyDeclaration = getDeclarationPanelIntern().getDeclaration();
        IDeclaration realDeclaration = getDeclaration();

        Assert.assertNotNull(copyDeclaration);
        copyDeclaration.copyInto(realDeclaration, new HashMap());

        SwingMoreUtilities.closeRootWindow(this);
    }

    protected void registerKeyStrokes() {

        // KeyStroke enterKeyStroke = KeyStroke.getKeyStroke(KeyEvent.VK_ENTER, 0);
        KeyStroke escapeKeyStroke = KeyStroke.getKeyStroke(KeyEvent.VK_ESCAPE, 0);

        /*
         * ActionListener okButtonActionListener = new ActionListener() { public void
         * actionPerformed(ActionEvent evt) { if (evt.getSource() == OkCancelDeclarationPanel.this) {
         * pressedOkButton(); } } };
         */

        ActionListener cancelButtonActionListener = new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                if (evt.getSource() == OkCancelDeclarationPanel.this) {
                    pressedCancelButton();
                }
            }
        };

        /*
         * ActionListener applyButtonActionListener = new ActionListener() { public void
         * actionPerformed(ActionEvent evt) { if (evt.getSource() == OkCancelDeclarationPanel.this) {
         * pressedApplyButton(); } } };
         */

        // better way
        AncestorListener ancestorListener = new AncestorListener() {
            private void setDefaultButton() {
                SwingUtilities.getRootPane(OkCancelDeclarationPanel.this).setDefaultButton(getJButtonOk());
                removeAncestorListener(this);
            }
            public void ancestorAdded(AncestorEvent event) {
                setDefaultButton();
            }
            public void ancestorMoved(AncestorEvent event) {
                setDefaultButton();
            }
            public void ancestorRemoved(AncestorEvent event) {
            }
        };

        addAncestorListener(ancestorListener);

        registerKeyboardAction(
            cancelButtonActionListener,
            escapeKeyStroke,
            JComponent.WHEN_IN_FOCUSED_WINDOW);

    }

    /**
     * Sets the declaration property (de.uniwue.ki.mas.model.util.declaration.IDeclaration) value.
     * 
     * @param declaration
     *            The new value for the property.
     * @see #getDeclaration
     */
    public void setDeclaration(IDeclaration declaration) {
        IDeclaration oldValue = fieldDeclaration;
        fieldDeclaration = declaration;
        firePropertyChange("declaration", oldValue, declaration);
    }

    /**
     * Method generated to support the promotion of the declarationPanel attribute.
     * 
     * @param arg1
     *            de.uniwue.ki.gui.mas.model.util.declaration.IDeclarationPanel
     */
    public void setDeclarationPanel(IDeclarationPanel arg1) {
        setDeclarationPanelIntern(arg1);
    }

    /**
     * Set the DeclarationPanelIntern to a new value.
     * 
     * @param newValue
     *            de.uniwue.ki.gui.mas.model.util.declaration.AbstractDeclarationPanel
     */

    private void setDeclarationPanelIntern(IDeclarationPanel newValue) {
        if (ivjDeclarationPanelIntern != newValue) {
            try {
                de.uniwue.ki.gui.mas.util.declaration.IDeclarationPanel oldValue =
                    getDeclarationPanelIntern();
                ivjDeclarationPanelIntern = newValue;
                connEtoC4(ivjDeclarationPanelIntern);
                firePropertyChange("declarationPanel", oldValue, newValue);

            } catch (Throwable ivjExc) {

                handleException(ivjExc);
            }
        }

    }

    public void setGUISeSAmDeclaration(IGUISeSAmDeclaration guiSeSAmDeclaration) {
        super.setGUISeSAmDeclaration(guiSeSAmDeclaration);

        if (getDeclarationPanel() != null) {
            getDeclarationPanel().setGUISeSAmDeclaration(getGUISeSAmDeclaration());
        }
    }
}