package de.uniwue.ki.gui.mas.util.declaration.action;
import javax.swing.Icon;

import de.uniwue.ki.gui.mas.util.declaration.DeclarationListPanel;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: (13.07.2001 09:30:02)
 * @author Christoph Oechslein
 */

public abstract class AbstractDeclarationListPanelAction extends AbstractDeclarationAction {
   private final DeclarationListPanel _declarationListPanel;

public AbstractDeclarationListPanelAction(String name, DeclarationListPanel declarationListPanel) {
    this(name, declarationListPanel.getClickedDeclaration(), declarationListPanel);
}


public AbstractDeclarationListPanelAction(
   String name,
   IDeclaration declaration,
   DeclarationListPanel declarationListPanel) {
   super(name, declaration);

   _declarationListPanel = declarationListPanel;
}


public AbstractDeclarationListPanelAction(String name, Icon icon, DeclarationListPanel declarationListPanel) {
    this(name, icon, declarationListPanel.getClickedDeclaration(), declarationListPanel);
}


public AbstractDeclarationListPanelAction(String name, Icon icon, IDeclaration declaration, DeclarationListPanel declarationListPanel) {

    super(name, icon, declaration);

    _declarationListPanel = declarationListPanel;
}


public final de.uniwue.ki.gui.mas.util.declaration.DeclarationListPanel getDeclarationListPanel() {
   return _declarationListPanel;
}
}