package de.uniwue.ki.gui.mas.util.declaration.action;
import java.awt.Container;

import javax.swing.Icon;
import javax.swing.JOptionPane;

import de.uniwue.ki.gui.util.SwingMoreUtilities;
import de.uniwue.ki.gui.util.actions.AbstractBoundAction;
import de.uniwue.ki.mas.util.declaration.IDeclaration;
import de.uniwue.ki.mas.util.declaration.IDocumentableDeclaration;

/**
 * Creation date: (13.07.2001 09:30:02)
 * @author Christoph Oechslein
 */

public abstract class AbstractRenameDocumentableDeclarationAction extends AbstractBoundAction {
    public static final Icon RENAME_ICON = SwingMoreUtilities.getJavaSunIcon(16, "general/Edit16.gif");

    private final Container _parent;

    public AbstractRenameDocumentableDeclarationAction(Container parent) {
        super("Rename", RENAME_ICON);

        _parent = parent;
    }


    public void doit() {
        IDeclaration declaration = getDeclaration();

        if ((declaration != null) && (declaration instanceof IDocumentableDeclaration)) {

            Container container = (Container) SwingMoreUtilities.getRootPaneContainer(_parent);

            String newName = null;
            if (container.getParent() != null) {
                newName =
                    (String) JOptionPane.showInternalInputDialog(container, null, "Rename", JOptionPane.QUESTION_MESSAGE, null, null, declaration.getName());
            } else {
                newName = (String) JOptionPane.showInputDialog(container, null, "Rename", JOptionPane.QUESTION_MESSAGE, null, null, declaration.getName());
            }
            if (newName != null) {
                ((IDocumentableDeclaration) declaration).setUsesShortDescription(true);
                ((IDocumentableDeclaration) declaration).setShortDescription(newName);
            }
        }
    }


    protected abstract IDeclaration getDeclaration();
}