/*
 * Created on 06.11.2003
 *
 */
package de.uniwue.ki.gui.mas.util.declaration.action;

import java.util.HashMap;

import javax.swing.Icon;

import de.uniwue.ki.gui.util.SwingMoreUtilities;
import de.uniwue.ki.gui.util.actions.AbstractBoundAction;
import de.uniwue.ki.mas.util.declaration.IDeclaration;
import de.uniwue.ki.util.copy.ICopyable;
import de.uniwue.ki.util.list.IMutableListModel;


/**
 * @author Hatko
 *
 */
public class CopyObjectInstanceDeclarationAction
	extends AbstractBoundAction {

	public static final Icon COPY_ICON = SwingMoreUtilities.getJavaSunIcon(16, "general/Copy16.gif");

	
	final IMutableListModel _mutableListModel;
	final IDeclaration _declaration;


	public CopyObjectInstanceDeclarationAction(IDeclaration declaration, IMutableListModel mutableListModel){
		super("Duplicate", COPY_ICON);

		_mutableListModel = mutableListModel;
		_declaration = declaration;
	
	}

	public void doit() {
		ICopyable copy = getDeclaration().copy(new HashMap());
		_mutableListModel.add(copy);
	}
	
	
	protected final IDeclaration getDeclaration() {
		return _declaration;
	}

}
