package de.uniwue.ki.gui.mas.util.declaration.action;
import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.Transferable;
import java.awt.event.ActionEvent;
import java.util.HashMap;

import javax.swing.AbstractAction;

import de.uniwue.ki.gui.util.dnd.ObjectDataFlavor;
import de.uniwue.ki.gui.util.dnd.ObjectTransferable;
import de.uniwue.ki.util.IRemoveable;
import de.uniwue.ki.util.copy.ICopyable;

/**
 * Creation date: (13.07.2001 09:30:02)
 * @author Christoph Oechslein
 */

public class CopyToClipboardAction extends AbstractAction {

	private ICopyable _copyable;
	private Clipboard _clipboard;

	public CopyToClipboardAction(ICopyable copyable, Clipboard clipboard) {
		super("Copy");

		_clipboard = clipboard;
		_copyable = copyable.copy(new HashMap());
	}

	public void actionPerformed(ActionEvent evt) {
		ObjectTransferable declarationTransferable =
			new ObjectTransferable(ObjectDataFlavor.getDataFlavor(_copyable.getClass()), _copyable) {
			protected Object getTransferredData() {
				return ((ICopyable)super.getTransferredData()).copy(new HashMap());
			}

			public void lostOwnership(Clipboard clipboard, Transferable contents) {
				super.lostOwnership(clipboard, contents);

				if (_copyable instanceof IRemoveable)
					 ((IRemoveable)_copyable).remove();
				_copyable = null;
			}
		};

		_clipboard.setContents(declarationTransferable, declarationTransferable);
	}
}