package de.uniwue.ki.gui.mas.util.declaration.action;
import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.Transferable;

import de.uniwue.ki.gui.mas.util.declaration.DeclarationListPanel;
import de.uniwue.ki.gui.util.dnd.ObjectDataFlavor;
import de.uniwue.ki.gui.util.dnd.ObjectTransferable;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: (13.07.2001 09:30:02)
 * @author Christoph Oechslein
 */

public class CutToClipboardDeclarationListPanelAction extends AbstractDeclarationListPanelAction {

	public CutToClipboardDeclarationListPanelAction(
		IDeclaration declaration,
		DeclarationListPanel declarationListPanel) {
		super("Cut", declaration, declarationListPanel);
	}

	public void doit() {

		ObjectTransferable declarationTransferable =
			new ObjectTransferable(
				ObjectDataFlavor.getDataFlavor(getDeclaration().getClass()),
				getDeclaration()) {
			protected Object getTransferredData() {
				return super.getTransferredData();
			}

			public void lostOwnership(Clipboard clipboard, Transferable contents) {
				super.lostOwnership(clipboard, contents);

				getDeclaration().remove();
			}
		};

		getDeclarationListPanel().getDeclarationListModel().remove(getDeclaration(), false);

		getDeclarationListPanel().getGUISeSAmDeclaration().getClipboard().setContents(
			declarationTransferable,
			declarationTransferable);
	}
}