// $Id: DisposeablePanel.java,v 1.3 2004/05/25 09:27:21 herrler Exp $
package de.uniwue.ki.gui.util;
import java.awt.Component;
import java.awt.Container;
import java.awt.LayoutManager;

import javax.swing.JPanel;

import junit.framework.Assert;

/**
 * Creation date: (13.07.2001 14:29:12)
 * @author Christoph Oechslein
 */
public class DisposeablePanel extends JPanel implements IDisposeable {
	private boolean _disposed = false;

	public DisposeablePanel(LayoutManager layout, boolean isDoubleBuffered) {
		super(layout, isDoubleBuffered);
	}

	public DisposeablePanel(LayoutManager layout) {
		super(layout);
	}

	public DisposeablePanel(boolean isDoubleBuffered) {
		super(isDoubleBuffered);
	}

	public DisposeablePanel() {
		super();
	}


	public void dispose() {
		if (Assert.ASSERTION_ON)
			Assert.assertEquals(false, _disposed);
		_disposed = true;
	}


	protected void disposeAllComponents() {
		disposeAllComponents(this);
	}

	protected static void disposeAllComponents(Container aContainer) {
		for (int i = 0; i < aContainer.getComponentCount(); i++) {
			Component currComponent = aContainer.getComponent(i);

			if (currComponent instanceof IDisposeable) {
				((IDisposeable) currComponent).dispose();
			}

			if (currComponent instanceof DisposeablePanel) {
				return;
			}

			if (currComponent instanceof Container) {
				disposeAllComponents((Container) currComponent);
			}
		}
	}


	public boolean isDisposed() {
		return _disposed;
	}
}