package de.uniwue.ki.gui.util;

import java.io.File;

import javax.swing.filechooser.FileFilter;
/**
 * Creation date: (19.09.2000 11:30:37)
 * @author Christoph Oechslein
 */
public class ExtensionsFileFilter extends FileFilter {
	private final String description;
	private final String[] extensions;

	public ExtensionsFileFilter(String description, String[] extensions) {
		super();

		if (description == null)
			this.description = extensions[0] + "{" + extensions.length + "}";
		else
			this.description = description;

		this.extensions = new String[extensions.length];

		for (int i = 0; i < extensions.length; i++) {
			this.extensions[i] = extensions[i].toLowerCase();
		}
	}

	public ExtensionsFileFilter(String description, String extension) {
		this(description, new String[] { extension });
	}

	public boolean accept(File file) {
		if (file.isDirectory())
			return true;
		//
		String path = file.getAbsolutePath().toLowerCase();
		for (int i = 0; i < extensions.length; i++)
			if (acceptExtension(path, extensions[i]))
				return true;
		return false;
	}

	protected boolean acceptExtension(String path, String extension) {
		if (path.endsWith(extension)) {
			int pointIndex = path.length() - extension.length() - 1;
			if ((pointIndex >= 0) && (path.charAt(pointIndex) == '.'))
				return true;
		}
		return false;
	}

	public String getDescription() {
		return description;
	}
}
