package de.uniwue.ki.gui.util;

import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.beans.PropertyChangeEvent;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import com.ibm.easyswing.BoundJCheckBox;

import de.uniwue.ki.gui.util.bound.BetterBoundJTextField;
import de.uniwue.ki.util.name.IDocumentable;

/**
 * Insert the type's description here. Creation date: (31.05.2001 17:04:48)
 * 
 * @author Christoph Oechslein
 */
public class JDocumentablePanel extends JPanel implements IDisposeable {

    private boolean _disposed = false;

    private boolean _editable = true;

    private boolean ivjConnPtoP1Aligning = false;

    private IDocumentable _documentableIntern = null;

    private final IvjEventHandler ivjEventHandler = new IvjEventHandler();

    private BoundJCheckBox ivjJCheckBox = null;

    private BetterBoundJTextField ivjJTextFieldShortDescription = null;

    private boolean fieldShowCheckBox = true;

    private final class IvjEventHandler implements
            java.beans.PropertyChangeListener, ChangeListener {

        /**
         * @param evt
         *            java.beans.PropertyChangeEvent
         * @see java.beans.PropertyChangeListener#propertyChange(PropertyChangeEvent)
         */
        public void propertyChange(java.beans.PropertyChangeEvent evt) {
            if (evt.getSource() == JDocumentablePanel.this
                    .getDocumentableIntern()
                    && (evt.getPropertyName().equals("usesShortDescription")))
                    connPtoP1SetTarget();
            if (evt.getSource() == JDocumentablePanel.this.getJCheckBox()
                    && (evt.getPropertyName().equals("selected")))
                    connPtoP1SetSource();
            if (evt.getSource() == JDocumentablePanel.this
                    .getJTextFieldShortDescription()
                    && (evt.getPropertyName().equals("text")))
                    connPtoP2SetTarget();
            if (evt.getSource() == JDocumentablePanel.this.getJCheckBox()
                    && (evt.getPropertyName().equals("selected")))
                    connEtoC3(evt);
        }

        /**
         * @param e
         *            ChangeEvent
         * @see ChangeListener#stateChanged(ChangeEvent)
         */
        public void stateChanged(ChangeEvent e) {
            if (e.getSource() == JDocumentablePanel.this
                    .getDocumentableIntern()) connEtoC2();
        }
    }

    /**
     * JDocumentablePanel constructor comment.
     */
    public JDocumentablePanel() {
        super();
        initialize();
    }

    /**
     * connEtoC1: (DocumentableIntern.this -->
     * JDocumentablePanel.documentableChanged()V)
     * 
     * @param value
     *            de.uniwue.ki.util.IDocumentable
     */
    private void connEtoC1(IDocumentable value) {
        try {
            this.documentableChanged();
        } catch (Throwable ivjExc) {
            handleException(ivjExc);
        }
    }

    /**
     * connEtoC2: (DocumentableIntern.change. -->
     * JDocumentablePanel.documentableChanged()V)
     */
    private void connEtoC2() {
        try {
            this.documentableChanged();
        } catch (Throwable ivjExc) {
            handleException(ivjExc);
        }
    }

    /**
     * connEtoC3: (JCheckBox.selected -->
     * JDocumentablePanel.documentableChanged()V)
     * 
     * @param arg1
     *            java.beans.PropertyChangeEvent
     */
    private void connEtoC3(java.beans.PropertyChangeEvent arg1) {
        try {
            this.documentableChanged();
        } catch (Throwable ivjExc) {
            handleException(ivjExc);
        }
    }

    /**
     * connPtoP1SetSource: (DocumentableIntern.usesShortDescription <-->
     * JCheckBox.selected)
     */
    private void connPtoP1SetSource() {
        try {
            if (ivjConnPtoP1Aligning == false) {
                ivjConnPtoP1Aligning = true;
                if ((getDocumentableIntern() != null)) {
                    getDocumentableIntern().setUsesShortDescription(
                            getJCheckBox().isSelected());
                }
                ivjConnPtoP1Aligning = false;
            }
        } catch (Throwable ivjExc) {
            ivjConnPtoP1Aligning = false;
            handleException(ivjExc);
        }
    }

    /**
     * connPtoP1SetTarget: (DocumentableIntern.usesShortDescription <-->
     * JCheckBox.selected)
     */
    private void connPtoP1SetTarget() {
        try {
            if (ivjConnPtoP1Aligning == false) {
                ivjConnPtoP1Aligning = true;
                if ((getDocumentableIntern() != null)) {
                    getJCheckBox().setSelected(
                            getDocumentableIntern().getUsesShortDescription());
                }
                ivjConnPtoP1Aligning = false;
            }
        } catch (Throwable ivjExc) {
            ivjConnPtoP1Aligning = false;
            handleException(ivjExc);
        }
    }

    /**
     * connPtoP2SetTarget: (JTextFieldShortDescription.text <-->
     * DocumentableIntern.shortDescription)
     */
    private void connPtoP2SetTarget() {
        try {
            if ((getDocumentableIntern() != null)) {
                getDocumentableIntern().setShortDescription(
                        getJTextFieldShortDescription().getText());
            }
        } catch (Throwable ivjExc) {
            handleException(ivjExc);
        }
    }

    protected void documentableChanged() {
        if (getDocumentable() == null) {
            getJTextFieldShortDescription().setEditable(false);
            getJTextFieldShortDescription().setText("");

        } else if (getDocumentable().getUsesShortDescription()) {
            getJTextFieldShortDescription().setEditable(isEditable());
            getJTextFieldShortDescription().setText(
                    getDocumentable().getShortDescription());
        } else {
            getJTextFieldShortDescription().setEditable(false);
            getJTextFieldShortDescription()
                    .setText(getDocumentable().getName());
        }
    }

    /**
     * Method generated to support the promotion of the documentable attribute.
     * 
     * @return de.uniwue.ki.util.IDocumentable
     */
    public IDocumentable getDocumentable() {
        return getDocumentableIntern();
    }

    /**
     * Return the DocumentableIntern property value.
     * 
     * @return de.uniwue.ki.util.IDocumentable
     */
    private IDocumentable getDocumentableIntern() {
        return _documentableIntern;
    }

    /**
     * Return the JCheckBox property value.
     * 
     * @return BoundJCheckBox
     */
    private BoundJCheckBox getJCheckBox() {
        if (ivjJCheckBox == null) {
            try {
                ivjJCheckBox = new BoundJCheckBox();
                ivjJCheckBox.setName("JCheckBox");
                ivjJCheckBox.setSelected(true);
                ivjJCheckBox.setText("");
            } catch (Throwable ivjExc) {
                handleException(ivjExc);
            }
        }
        return ivjJCheckBox;
    }

    /**
     * Return the JTextFieldShortDescription property value.
     * 
     * @return de.uniwue.ki.gui.util.BetterBoundJTextField
     */
    private BetterBoundJTextField getJTextFieldShortDescription() {
        if (ivjJTextFieldShortDescription == null) {
            try {
                ivjJTextFieldShortDescription = new BetterBoundJTextField();
                ivjJTextFieldShortDescription
                        .setName("JTextFieldShortDescription");
                ivjJTextFieldShortDescription.setText("");
                ivjJTextFieldShortDescription.setColumns(20);
                ivjJTextFieldShortDescription.setMinimumSize(new Dimension(40,
                        ivjJTextFieldShortDescription.getMinimumSize().height));
            } catch (Throwable ivjExc) {
                handleException(ivjExc);
            }
        }
        return ivjJTextFieldShortDescription;
    }

    /**
     * Called whenever the part throws an exception.
     * 
     * @param exception
     *            Throwable
     */
    private void handleException(Throwable exception) {

        System.out.println("--------- UNCAUGHT EXCEPTION ---------");
        exception.printStackTrace(System.out);
    }

    /**
     * Initializes connections
     * 
     * @exception Exception
     *                The exception description.
     */
    private void initConnections() {
        getJCheckBox().addPropertyChangeListener(ivjEventHandler);
        getJTextFieldShortDescription().addPropertyChangeListener(
                ivjEventHandler);
        connPtoP1SetTarget();
        connPtoP2SetTarget();
    }

    /**
     * Initialize the class.
     */
    private void initialize() {
        try {
            setName("JDocumentablePanel");

            setLayout(new GridBagLayout());

            addComponents();

            initConnections();

        } catch (Throwable ivjExc) {
            handleException(ivjExc);
        }
        setShowCheckBox(false);
    }

    private void addComponents() {
        GridBagConstraints gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.weightx = 1;
        gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = GridBagConstraints.LINE_START;

        add(getJTextFieldShortDescription(), gridBagConstraints);

        if (isShowCheckBox()) {
            gridBagConstraints = new GridBagConstraints();
            gridBagConstraints.gridx = 1;
            gridBagConstraints.gridy = 0;
            gridBagConstraints.insets.left = 3;
            gridBagConstraints.anchor = GridBagConstraints.LINE_START;

            add(getJCheckBox(), gridBagConstraints);
        }
    }

    /**
     * @return boolean
     */
    public boolean isEditable() {
        return _editable;
    }

    /**
     * Gets the showCheckBox property (boolean) value.
     * 
     * @return The showCheckBox property value.
     * @see #setShowCheckBox
     */
    public boolean isShowCheckBox() {
        return fieldShowCheckBox;
    }

    /**
     * main entrypoint - starts the part when it is run as an application
     * 
     * @param args
     *            String[]
     */
    public static void main(String[] args) {
        try {
            JFrame frame = new JFrame();
            JDocumentablePanel aJDocumentablePanel;
            aJDocumentablePanel = new JDocumentablePanel();
            frame.setContentPane(aJDocumentablePanel);
            frame.setSize(aJDocumentablePanel.getSize());
            frame.addWindowListener(new java.awt.event.WindowAdapter() {

                public void windowClosing(java.awt.event.WindowEvent e) {
                    System.exit(0);
                }
            });
            frame.show();
            java.awt.Insets insets = frame.getInsets();
            frame.setSize(frame.getWidth() + insets.left + insets.right, frame
                    .getHeight()
                    + insets.top + insets.bottom);
            frame.setVisible(true);
        } catch (Throwable exception) {
            System.err.println("Exception occurred in main() of JPanel");
            exception.printStackTrace(System.out);
        }
    }

    /**
     * Method generated to support the promotion of the documentable attribute.
     * 
     * @param arg1
     *            de.uniwue.ki.util.IDocumentable
     */
    public void setDocumentable(IDocumentable arg1) {
        setDocumentableIntern(arg1);
    }

    /**
     * Set the DocumentableIntern to a new value.
     * 
     * @param newValue
     *            de.uniwue.ki.util.IDocumentable
     */
    private void setDocumentableIntern(IDocumentable newValue) {
        if (_documentableIntern != newValue) {
            try {
                IDocumentable oldValue = getDocumentableIntern();
                if ((oldValue != null) && (newValue != null)) {
                    oldValue.removeChangeListener(ivjEventHandler);
                    oldValue.removePropertyChangeListener(ivjEventHandler);
                }
                _documentableIntern = newValue;

                if (_documentableIntern != null) {
                    _documentableIntern.addChangeListener(ivjEventHandler);
                    _documentableIntern
                            .addPropertyChangeListener(ivjEventHandler);
                }
                connEtoC1(_documentableIntern);
                connPtoP1SetTarget();
                connPtoP2SetTarget();
                firePropertyChange("documentable", oldValue, newValue);
            } catch (Throwable ivjExc) {
                handleException(ivjExc);
            }
        }
    }

    /**
     * @param isEditable
     *            boolean
     */
    public void setEditable(boolean isEditable) {
        _editable = isEditable;

        if (getDocumentable() == null)
            getJTextFieldShortDescription().setEditable(isEditable);
        else
            getJTextFieldShortDescription().setEditable(
                    isEditable && getDocumentable().getUsesShortDescription());
    }

    /**
     * @param isEnabled
     *            boolean
     */
    public void setEnabled(boolean isEnabled) {
        super.setEnabled(isEnabled);

        getJTextFieldShortDescription().setEnabled(isEnabled);
        getJCheckBox().setEnabled(isEnabled);
    }

    /**
     * Sets the showCheckBox property (boolean) value.
     * 
     * @param showCheckBox
     *            The new value for the property.
     * @see #isShowCheckBox
     */
    public void setShowCheckBox(boolean showCheckBox) {
        boolean oldValue = fieldShowCheckBox;

        fieldShowCheckBox = showCheckBox;

        removeAll();

        addComponents();

        firePropertyChange("showCheckBox", Boolean.valueOf(oldValue), Boolean
                .valueOf(showCheckBox));
    }

    public void dispose() {
        connPtoP2SetTarget();
        _disposed = true;
    }

    public boolean isDisposed() {
        return _disposed;
    }
}