package de.uniwue.ki.gui.util;
import java.awt.Component;

import javax.swing.Icon;
import javax.swing.JComponent;
import javax.swing.JTree;
import javax.swing.tree.DefaultTreeCellRenderer;

import de.uniwue.ki.gui.util.lookAndFeel.LookAndFeelManagerAuxiliary;
import de.uniwue.ki.util.Utils;
import de.uniwue.ki.util.name.INamed;
/**
 * Creation date: (05.10.2001 10:41:30)
 * @author Christoph Oechslein
 */
public class NamedTreeCellRenderer extends DefaultTreeCellRenderer {

	public Component getTreeCellRendererComponent(
		JTree tree,
		Object value,
		boolean cellSelected,
		boolean expanded,
		boolean leaf,
		int row,
		boolean cellHasFocus) {

		Component comp;
		
		if (value instanceof INamed) {
			comp =
				super.getTreeCellRendererComponent(
					tree,
					((INamed) value).getName(),
					cellSelected,
					expanded,
					leaf,
					row,
					cellHasFocus);
			return comp;
		} else {
			comp =
				super.getTreeCellRendererComponent(
					tree,
					value,
					cellSelected,
					expanded,
					leaf,
					row,
					cellHasFocus);
		}
		
		if ((comp instanceof JComponent) && LookAndFeelManagerAuxiliary.isCurrentKunststoffLookAndFeel()) {
			((JComponent) comp).setOpaque(cellSelected);
		}

		return comp;
	}

	public void setDisabledIcon(Icon disabledIcon) {
		if (disabledIcon != getDisabledIcon())
			super.setDisabledIcon(disabledIcon);
	}

	public void setIcon(Icon icon) {
		if (icon != getIcon())
			super.setIcon(icon);
	}

	public void setText(String text) {
		if (!Utils.equals(text, getText()))
			super.setText(text);
	}

	public void setToolTipText(String text) {
		if (!Utils.equals(text, getToolTipText()))
			super.setToolTipText(text);
	}
}