package de.uniwue.ki.gui.util;

import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;

import javax.swing.JPanel;

/**
 * @author Reinhard Hatko
 *
 * Created on 09.01.2004
 */
public class PictureDisplayPanel extends JPanel {
	
	private Image _image;
	
	protected void paintComponent(Graphics g) {
		super.paintComponent(g);
		
		Graphics2D g2d = (Graphics2D) g;
		
		g2d.setColor( getBackground() );
		Dimension d = getSize();
		g2d.fillRect( 0, 0, d.width, d.height );
		
		if (_image != null)
			g2d.drawImage( _image, (d.width - _image.getWidth(null)) / 2,
						 (d.height - _image.getHeight(null)) / 2,
						 null );
	}

	public void setImage(Image image){
		_image = image;
		repaint();
	}
	
	public Dimension getPreferredSize() {
		if (_image == null) {
			return new Dimension(420, 320);

		} else
			return new Dimension(
				_image.getWidth(null) + 20,
				_image.getHeight(null) + 20);
	}

}
