/*
 * Created on 31.10.2003
 */

package de.uniwue.ki.gui.util;

import java.awt.Component;
import java.awt.Container;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import javax.swing.JOptionPane;

/**
 * @author herrler
 * 
 * This child of JOptionPane tries to automatically resize the dialog
 * if a propertyChangeEvent has been captured.
 */
public class ResizeableOptionPane extends JOptionPane {
	public ResizeableOptionPane(final Component panel) {
		super(panel, JOptionPane.PLAIN_MESSAGE, JOptionPane.OK_CANCEL_OPTION);
		panel.addPropertyChangeListener(new PropertyChangeListener() {
			public void propertyChange(PropertyChangeEvent arg0) {
				getDialog().setSize(getPreferredSize().width+10, getPreferredSize().height+10);
			}
			
			/**
			 * TODO: extremly ugly, change when time!
			 */
			public Container getDialog() {
				// JPanel, JLayeredPOane JRootPane JDialog
				return getParent().getParent().getParent().getParent();
			}
		});
	}
}
