package de.uniwue.ki.gui.util.bound;

import java.awt.Graphics;
import java.text.Format;

import javax.swing.JFormattedTextField;

/**
 * @author herrler
 *
 *  Cares about selecting everything when it is shown the first time.
 */
public abstract class AbstractBoundTextField extends JFormattedTextField {

	public AbstractBoundTextField(Format format) {
		super(format);
	}
	
	public AbstractBoundTextField() {
		super();
	}

	public void selectAll() {
		getCaret().setDot(0);
		getCaret().moveDot(getText().length());
	}
	
	private boolean firstTimeShown = false;
	public void paint(Graphics g) {
		//selectAll();
		super.paint(g);
		if (!firstTimeShown) {
			firstTimeShown = true;
			selectAll();
		}
	}
}