package de.uniwue.ki.gui.util.bound;
import javax.swing.BoundedRangeModel;
import javax.swing.JFrame;
import javax.swing.JSlider;
/**
 * Creation date: (16.11.2000 11:10:04)
 * @author Christoph Oechslein
 */
public class BoundJSlider extends JSlider {

private final class IvjEventHandler implements javax.swing.event.ChangeListener {
		public void stateChanged(javax.swing.event.ChangeEvent e) {
			if (e.getSource() == BoundJSlider.this)
				connEtoC1(e);
		}
	}
	private final IvjEventHandler ivjEventHandler = new IvjEventHandler();

	/**
	 * BoundJSlider constructor comment.
	 */
	public BoundJSlider() {
	    super();
	    initialize();
	}

	/**
	 * BoundJSlider constructor comment.
	 * @param orientation int
	 */
	public BoundJSlider(int orientation) {
	    super(orientation);
	}

	/**
	 * BoundJSlider constructor comment.
	 * @param min int
	 * @param max int
	 */
	public BoundJSlider(int min, int max) {
	    super(min, max);
	}

	/**
	 * BoundJSlider constructor comment.
	 * @param min int
	 * @param max int
	 * @param value int
	 */
	public BoundJSlider(int min, int max, int value) {
	    super(min, max, value);
	}

	/**
	 * BoundJSlider constructor comment.
	 * @param orientation int
	 * @param min int
	 * @param max int
	 * @param value int
	 */
	public BoundJSlider(int orientation, int min, int max, int value) {
	    super(orientation, min, max, value);
	}

	/**
	 * BoundJSlider constructor comment.
	 * @param brm javax.swing.BoundedRangeModel
	 */
	public BoundJSlider(BoundedRangeModel brm) {
	    super(brm);
	}

	/**
	 * connEtoC1:  (BoundJSlider.change.stateChanged(javax.swing.event.ChangeEvent) --> BoundJSlider.firePropertyChange(Ljava.lang.String;II)V)
	 * @param arg1 javax.swing.event.ChangeEvent
	 */
	/* WARNING: THIS METHOD WILL BE REGENERATED. */
	private void connEtoC1(javax.swing.event.ChangeEvent arg1) {
	    try {
	        // user code begin {1}
	        // user code end
	        this.firePropertyChange("value", -1, this.getValue());
	        // user code begin {2}
	        // user code end
	    } catch (java.lang.Throwable ivjExc) {
	        // user code begin {3}
	        // user code end
	        handleException(ivjExc);
	    }
	}


	/**
	 * Called whenever the bean information class throws an exception.
	 * @param exception java.lang.Throwable
	 */
	private void handleException(java.lang.Throwable exception) {
	
	    /* Uncomment the following lines to print uncaught exceptions to stdout */
	    System.out.println("--------- UNCAUGHT EXCEPTION ---------");
	    exception.printStackTrace(System.out);
	}

	/**
	 * Initializes connections
	 * @exception java.lang.Exception The exception description.
	 */
	/* WARNING: THIS METHOD WILL BE REGENERATED. */
	private void initConnections() throws java.lang.Exception {
	    // user code begin {1}
	    // user code end
	    this.addChangeListener(ivjEventHandler);
	}

	/**
	 * Initialize the class.
	 */
	/* WARNING: THIS METHOD WILL BE REGENERATED. */
	private void initialize() {
	    try {
	        // user code begin {1}
	        // user code end
	        setName("BoundJSlider");
	        setSize(200, 16);
	        initConnections();
	    } catch (java.lang.Throwable ivjExc) {
	        handleException(ivjExc);
	    }
	    // user code begin {2}
	    // user code end
	}

	/**
	 * main entrypoint - starts the part when it is run as an application
	 * @param args java.lang.String[]
	 */
	public static void main(java.lang.String[] args) {
	    try {
	        JFrame frame = new javax.swing.JFrame();
	        BoundJSlider aBoundJSlider;
	        aBoundJSlider = new BoundJSlider();
	        frame.setContentPane(aBoundJSlider);
	        frame.setSize(aBoundJSlider.getSize());
	        frame.addWindowListener(new java.awt.event.WindowAdapter() {
	            public void windowClosing(java.awt.event.WindowEvent e) {
	                System.exit(0);
	            }
	        });
	        frame.show();
	        java.awt.Insets insets = frame.getInsets();
	        frame.setSize(frame.getWidth() + insets.left + insets.right, frame.getHeight() + insets.top + insets.bottom);
	        frame.setVisible(true);
	    } catch (Throwable exception) {
	        System.err.println("Exception occurred in main() of de.uniwue.ki.gui.generic.BoundJSlider");
	        exception.printStackTrace(System.out);
	    }
	}
}