package de.uniwue.ki.gui.util.bound;
import java.text.ParseException;

import javax.swing.InputVerifier;
import javax.swing.JComponent;
import javax.swing.JFormattedTextField;

/**
 * Creation date: 31.01.2003, 18:50:31
 * @author oechslein
 */
final class FormattedTextFieldVerifier extends InputVerifier {
	public boolean verify(JComponent input) {
		if (input instanceof JFormattedTextField) {
			JFormattedTextField ftf = (JFormattedTextField) input;
			JFormattedTextField.AbstractFormatter formatter = ftf.getFormatter();
			if (formatter != null) {
				String text = ftf.getText();
				try {
					formatter.stringToValue(text);
					return true;
				} catch (ParseException pe) {
					return false;
				}
			}
		}
		return true;
	}
	public boolean shouldYieldFocus(JComponent input) {
		return verify(input);
	}
}