package de.uniwue.ki.gui.util.dnd;

import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.io.IOException;
import java.util.HashMap;

import javax.swing.JComponent;
import javax.swing.TransferHandler;

import de.uniwue.ki.util.copy.ICopyable;

/**
 * Creation date: 01.10.2002, 17:11:09
 * @author oechslein
 */
public class CopyableTransferHandler extends TransferHandler {

	static class CopyTransferable implements Transferable {
		private final Transferable _transferable;

		public CopyTransferable(Transferable transferable) {
			_transferable = transferable;
		}

		public Object getTransferData(DataFlavor flavor) throws UnsupportedFlavorException, IOException {
			return ((ICopyable) _transferable.getTransferData(flavor)).copy(new HashMap());
		}

		public boolean isDataFlavorSupported(DataFlavor flavor) {
			return _transferable.isDataFlavorSupported(flavor);
		}

		public DataFlavor[] getTransferDataFlavors() {
			return _transferable.getTransferDataFlavors();
		}
	}

	public CopyableTransferHandler(String property) {
		super(property);
	}

	public CopyableTransferHandler() {
		super();
	}

	protected Transferable createTransferable(JComponent c) {
		return super.createTransferable(c);
	}

	protected Transferable createTransferable(JComponent c, boolean copyAction) {
		return super.createTransferable(c);
	}

	public int getSourceActions(JComponent c) {
		return COPY_OR_MOVE;
	}

	public boolean importData(JComponent comp, Transferable t) {
		return super.importData(comp, t);
	}

	protected void exportDone(JComponent source, Transferable data, int action) {
		super.exportDone(source, data, action);
	}
}
