package de.uniwue.ki.gui.util.dnd;
import java.awt.datatransfer.StringSelection;
import java.awt.datatransfer.Transferable;
import java.awt.dnd.DragGestureEvent;
import java.awt.dnd.DragGestureListener;
import java.awt.dnd.DragSource;
/**
 * Creation date: (08.05.2001 14:43:28)
 * @author Christoph Oechslein
 */
public class DragGestureListenerAdapter implements DragGestureListener {
   private DragAndDropSupport _dragAndDropSupport;

	/**
	 * DragGestureListenerAdapter constructor comment.
	 */
	public DragGestureListenerAdapter() {
	   super();
	}

	/**
	 * DragGestureListenerAdapter constructor comment.
	 * @param dragAndDropSupport DragAndDropSupport
	 */
	public DragGestureListenerAdapter(DragAndDropSupport dragAndDropSupport) {
	   super();
	
	   _dragAndDropSupport = dragAndDropSupport;
	}

	/**
	 * @see java.awt.dnd.DragGestureListener
	 */
	public void dragGestureRecognized(DragGestureEvent dge) {
	   Object dragObject = getGestureRecognizedObject(dge);
	   if (dragObject != null) {
	      Transferable transferable = getTransferable(dge, dragObject);
	
	      getDragSource().startDrag(dge, getDragCursor(dge), transferable, getDragSourceListener());
	   }
	}

	/**
	 * Insert the method's description here.
	 * Creation date: (08.05.2001 15:22:50)
	 * @return de.uniwue.ki.gui.generic.dnd.DragAndDropSupport
	 */
	public DragAndDropSupport getDragAndDropSupport() {
	   return _dragAndDropSupport;
	}

	protected java.awt.Cursor getDragCursor(DragGestureEvent dge) {
	   return DragSource.DefaultMoveDrop;
	}

	/**
	 * Insert the method's description here.
	 * Creation date: (08.05.2001 15:18:49)
	 * @return java.awt.dnd.DragSource
	 */
	public java.awt.dnd.DragSource getDragSource() {
	   return _dragAndDropSupport.getDragSource();
	}

	/**
	 * Insert the method's description here.
	 * Creation date: (08.05.2001 15:18:49)
	 * @return java.awt.dnd.DragSourceListener
	 */
	public java.awt.dnd.DragSourceListener getDragSourceListener() {
	   return _dragAndDropSupport.getDragSourceListener();
	}

	protected Object getGestureRecognizedObject(DragGestureEvent dge) {
	   return null;
	}

	protected Transferable getTransferable(DragGestureEvent dge, Object transferable) {
	   return new StringSelection(transferable + "");
	}

	/**
	 * Insert the method's description here.
	 * Creation date: (08.05.2001 15:22:50)
	 * @param newDragAndDropSupport de.uniwue.ki.gui.generic.dnd.DragAndDropSupport
	 */
	public void setDragAndDropSupport(DragAndDropSupport newDragAndDropSupport) {
	   _dragAndDropSupport = newDragAndDropSupport;
	}
}