package de.uniwue.ki.gui.util.dnd;
import java.awt.datatransfer.DataFlavor;
import java.io.Serializable;

import de.uniwue.ki.gui.util.bound.BetterBoundJList;
/**
 * Creation date: (08.05.2001 14:36:22)
 * @author Christoph Oechslein
 */
public class JDnDBetterBoundJList extends BetterBoundJList {
    private boolean _editable = true;
    private DataFlavor _dataFlavor = null;

	/**
	 * DnDBetterBoundJList constructor comment.
	 */
	public JDnDBetterBoundJList() {
	    super();
	    initialize();
	}

	/**
	 * @param dataFlavor DataFlavor
	 */
	public void enableDnDSupport(DataFlavor dataFlavor) {
	    _dataFlavor = dataFlavor;
	    
	    // for drag and drop
	    new MutableListModelInJDnDBetterBoundJListDnDListenerAdapter(this);
	}


	public DataFlavor getDataFlavor() {
	    if (_dataFlavor != null) {
	        return _dataFlavor;
	
	    } else if (getModel().getSize() > 0) {
	        return ObjectDataFlavor.getDataFlavor(getModel().getElementAt(0).getClass());
	
	    } else {
	        return ObjectDataFlavor.getDataFlavor(Serializable.class);
	    }
	}

	/**
	 * Called whenever the part throws an exception.
	 * @param exception java.lang.Throwable
	 */
	private void handleException(java.lang.Throwable exception) {
	
	    /* Uncomment the following lines to print uncaught exceptions to stdout */
	    System.out.println("--------- UNCAUGHT EXCEPTION ---------");
	    exception.printStackTrace(System.out);
	}

	/**
	 * Initialize the class.
	 */
	/* WARNING: THIS METHOD WILL BE REGENERATED. */
	private void initialize() {
	    try {
	        // user code begin {1}
	        // user code end
	        setName("DnDBetterBoundJList");
	        setSize(142, 195);
	    } catch (java.lang.Throwable ivjExc) {
	        handleException(ivjExc);
	    }
	    // user code begin {2}
	    // user code end
	}

	public boolean isEditable() {
	    return _editable;
	}

	/**
	 * main entrypoint - starts the part when it is run as an application
	 * @param args java.lang.String[]
	 */
	public static void main(java.lang.String[] args) {
	    try {
	        javax.swing.JFrame frame = new javax.swing.JFrame();
	        JDnDBetterBoundJList aDnDBetterBoundJList;
	        aDnDBetterBoundJList = new JDnDBetterBoundJList();
	
	        javax.swing.DefaultListModel defaultListModel = new javax.swing.DefaultListModel();
	        defaultListModel.addElement("1");
	        defaultListModel.addElement("2");
	        defaultListModel.addElement("3");
	        aDnDBetterBoundJList.setModel(defaultListModel);
	
	        frame.setContentPane(aDnDBetterBoundJList);
	        frame.setSize(aDnDBetterBoundJList.getSize());
	        frame.addWindowListener(new java.awt.event.WindowAdapter() {
	            public void windowClosing(java.awt.event.WindowEvent e) {
	                System.exit(0);
	            }
	        });
	        frame.show();
	        java.awt.Insets insets = frame.getInsets();
	        frame.setSize(frame.getWidth() + insets.left + insets.right, frame.getHeight() + insets.top + insets.bottom);
	        frame.setVisible(true);
	    } catch (Throwable exception) {
	        System.err.println("Exception occurred in main() of de.uniwue.ki.gui.util.DnDBetterBoundJList");
	        exception.printStackTrace(System.out);
	    }
	}

	/**
	 * @param editable boolean
	 */
	public void setEditable(boolean editable) {
	    boolean oldValue = _editable;
	    _editable = editable;
	
	    firePropertyChange("editable", Boolean.valueOf(oldValue), Boolean.valueOf(editable));
	}
}