package de.uniwue.ki.gui.util.hexagon;

/**
 * Creation date: (23.05.00 10:01:56)
 * @author Christoph Oechslein
 */
public abstract class AbstractHexagonalMapModel implements IHexagonalMapModel {
	protected transient HexagonalMapModelListener aHexagonalMapModelListener = null;

	public AbstractHexagonalMapModel() {
		super();
	}

	public void addHexagonalMapModelListener(HexagonalMapModelListener newListener) {
		aHexagonalMapModelListener =
			HexagonalMapModelEventMulticaster.add(aHexagonalMapModelListener, newListener);
	}

	protected void fireContentChanged(HexagonalMapModelEvent event) {
		if (aHexagonalMapModelListener != null) {
			aHexagonalMapModelListener.contentChanged(event);
		}
	}

	protected void fireListOfTilesUpdate(HexagonalMapModelEvent event) {
		if (aHexagonalMapModelListener != null) {
			aHexagonalMapModelListener.listOfTilesUpdate(event);
		}
	}

	protected void fireTileUpdate(HexagonalMapModelEvent event) {
		if (aHexagonalMapModelListener != null) {
			aHexagonalMapModelListener.tileUpdate(event);
		}
	}

	/**
	 *
	 * @param newListener HexagonalMapModelListener
	 * @see de.uniwue.ki.gui.util.hexagon.IHexagonalMapModel#removeHexagonalMapModelListener(HexagonalMapModelListener)
	 */
	public void removeHexagonalMapModelListener(HexagonalMapModelListener newListener) {
		aHexagonalMapModelListener =
			HexagonalMapModelEventMulticaster.remove(aHexagonalMapModelListener, newListener);
	}
}