package de.uniwue.ki.gui.util.hexagon;
import java.util.List;
/**
 * This is the event class to support the HexagonalMapModelListener interface.
 * @author oechslein
 */
public class HexagonalMapModelEvent extends java.util.EventObject {
	private static final int TILEUPDATE = 0;
	private static final int LISTOFTILESUPDATE = 1;
	private static final int ALLUPDATE = 2;
	//
	private final int type;
	private final List listOfTiles;
	private final HexCoor hCoor;

	/**
	 * HexagonalMapModelEvent constructor comment.
	 * @param source java.lang.Object
	 */
	public HexagonalMapModelEvent(java.lang.Object source) {
	    super(source);
	    this.type = ALLUPDATE;
	    this.hCoor = null;
	    this.listOfTiles = null;
	}

	/**
	 * HexagonalMapModelEvent constructor comment.
	 * @param source java.lang.Object
	 */
	public HexagonalMapModelEvent(java.lang.Object source, HexCoor hexCoor) {
	    super(source);
	    this.type = TILEUPDATE;
	    this.hCoor = hexCoor;
	    this.listOfTiles = null;
	}

	/**
	 * HexagonalMapModelEvent constructor comment.
	 * @param source java.lang.Object
	 * @param listOfTiles List
	 */
	public HexagonalMapModelEvent(java.lang.Object source, List listOfTiles) {
	    super(source);
	    this.type = LISTOFTILESUPDATE;
	    this.hCoor = null;
	    this.listOfTiles = listOfTiles;
	}

	/**
	 * Insert the method's description here.
	 * Creation date: (23.05.00 11:26:38)
	 * @author Christoph Oechslein
	 * @return de.uniwue.ki.hexagonaltiles.HexCoor
	 */
	public final HexCoor getHCoor() {
	    return hCoor;
	}

	/**
	 * Insert the method's description here.
	 * Creation date: (23.05.00 11:26:38)
	 * @author Christoph Oechslein
	 * @return de.uniwue.ki.hexagonaltiles.HexCoor
	 */
	public final HexCoor getHexCoor() {
	    return hCoor;
	}

	/**
	 * Insert the method's description here.
	 * Creation date: (23.05.00 11:26:38)
	 * @author Christoph Oechslein
	 * @return java.util.Iterator
	 */
	public final java.util.Iterator getListOfTiles() {
	    return listOfTiles.iterator();
	}

	/**
	 * Insert the method's description here.
	 * Creation date: (23.05.00 11:26:38)
	 * @author Christoph Oechslein
	 * @return int
	 */
	public final int getType() {
	    return type;
	}
}