package de.uniwue.ki.gui.util.hexagon;
import java.awt.Graphics2D;
import java.awt.Polygon;

import javax.swing.SwingUtilities;
/**
 * Creation date: (22.05.00 15:03:26)
 * @author Christoph Oechslein
 */
public class NullTileRenderer implements ITileRenderer {

	/**
	 * DefaultTileRenderer constructor comment.
	 */
	public NullTileRenderer() {
	    super();
	}

	/**
	 * Insert the method's description here.
	 * Creation date: (24.05.00 15:34:11)
	 * @author Christoph Oechslein
	 * @param g2d java.awt.Graphics2D
	 * @param clipPolygon java.awt.Polygon
	 * @param value ITile
	 * @param indexX int
	 * @param indexY int
	 * @see de.uniwue.ki.gui.util.hexagon.ITileRenderer#drawTile(Graphics2D, Polygon, ITile, int, int)
	 */
	public void drawTile(java.awt.Graphics2D g2d, java.awt.Polygon clipPolygon, ITile value, int indexX, int indexY) {
	    java.awt.Rectangle polygonBounds = clipPolygon.getBounds();
	    String str = "(" + indexX + "," + indexY + ")";
	    int strWidth = SwingUtilities.computeStringWidth(g2d.getFontMetrics(), str);
	    int strHeight = g2d.getFontMetrics().getHeight() / 2 - g2d.getFontMetrics().getDescent();
	    g2d.drawString(str, (int) polygonBounds.getCenterX() - strWidth / 2, (int) polygonBounds.getCenterY() + strHeight);
	}

	/**
	 * getTileRendererComponent method comment.
	 * @param hTilesPanel HexagonalTilesPanel
	 * @param clipPolygon java.awt.Polygon
	 * @param value ITile
	 * @param indexX int
	 * @param indexY int
	 * @param isSelected boolean
	 * @param cellHasFocus boolean
	 * @return java.awt.Component
	 * @see de.uniwue.ki.gui.util.hexagon.ITileRenderer#getTileRendererComponent(HexagonalTilesPanel, Polygon, ITile, int, int, boolean, boolean)
	 */
	public java.awt.Component getTileRendererComponent(
	    HexagonalTilesPanel hTilesPanel,
	    java.awt.Polygon clipPolygon,
	    ITile value,
	    int indexX,
	    int indexY,
	    boolean isSelected,
	    boolean cellHasFocus) {
	    return null;
	}
}