// $Id: LookAndFeelManagerTest.java,v 1.2 2004/05/25 09:27:20 herrler Exp $
package de.uniwue.ki.gui.util.lookAndFeel;
import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JCheckBoxMenuItem;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JScrollPane;
import javax.swing.JTree;
/**
 * DISCLAIMER - No guarantees. Use at your own risk.
 * A simple test program.
 *
 * @author Sandip Chitale (schitale@selectica.com)
 * @version 1.0 (Mar 2000)
 * @since JDK1.2
 */
public class LookAndFeelManagerTest
{

	public static void main(String args[]) {
	    final JFrame mainFrame = new JFrame("Main Frame");
	
	    mainFrame.getContentPane().add(LookAndFeelManager.getDefaultLookAndFeelManager().getLookAndFeelButtonPanel(), BorderLayout.NORTH);
	    mainFrame.getContentPane().add(new JScrollPane(new JTree()), BorderLayout.CENTER);
	    mainFrame.setBounds(100, 100, 300, 500);
	    JMenuBar mb = new JMenuBar();
	
	    JMenu optionsMenu = new JMenu("Options");
	
	    JMenuItem regMain = new JMenuItem("Register Main Frame");
		regMain.addActionListener(
			new ActionListener() {
				public void actionPerformed(ActionEvent ae) {
				    LookAndFeelManager.getDefaultLookAndFeelManager().registerFrame(mainFrame);
				}
			}
		);
		optionsMenu.add(regMain);
	
	    JMenuItem unregMain = new JMenuItem("Unregister Main Frame");
		unregMain.addActionListener(
			new ActionListener() {
				public void actionPerformed(ActionEvent ae) {
				    LookAndFeelManager.getDefaultLookAndFeelManager().unregisterFrame(mainFrame);
				}
			}
		);
		optionsMenu.add(unregMain);
	
		optionsMenu.addSeparator();
	
	    JMenuItem update = new JMenuItem("Update");
		update.addActionListener(
			new ActionListener() {
				public void actionPerformed(ActionEvent ae) {
				    LookAndFeelManager.getDefaultLookAndFeelManager().update();
				}
			}
		);
		optionsMenu.add(update);
	
		optionsMenu.addSeparator();
	
	    JCheckBoxMenuItem allPolicy = new JCheckBoxMenuItem("Update All Frames policy",
	        LookAndFeelManager.getDefaultLookAndFeelManager().getFrameUpdatePolicy().equals(LookAndFeelManager.ALL_FRAMES));
		allPolicy.addActionListener(
			new ActionListener() {
				public void actionPerformed(ActionEvent ae) {
					if (((JCheckBoxMenuItem) ae.getSource()).isSelected()) {
				        LookAndFeelManager.getDefaultLookAndFeelManager().setFrameUpdatePolicy(LookAndFeelManager.ALL_FRAMES);
				    } else {
				        LookAndFeelManager.getDefaultLookAndFeelManager().setFrameUpdatePolicy(LookAndFeelManager.REGISTERED_FRAMES);
				    }
				}
			}
		);
		optionsMenu.add(allPolicy);
	
	    JCheckBoxMenuItem immediatePolicy = new JCheckBoxMenuItem("Update Immediately", LookAndFeelManager.getDefaultLookAndFeelManager().isUpdateImmediately());
		immediatePolicy.addActionListener(
			new ActionListener() {
				public void actionPerformed(ActionEvent ae) {
				    LookAndFeelManager.getDefaultLookAndFeelManager().setUpdateImmediately(((JCheckBoxMenuItem) ae.getSource()).isSelected());
				}
			}
		);
		optionsMenu.add(immediatePolicy);
	
		optionsMenu.addSeparator();
	
	    JMenuItem exit = new JMenuItem("Exit");
		exit.addActionListener(
			new ActionListener() {
				public void actionPerformed(ActionEvent ae) {
					System.exit(0);
				}
			}
		);
		optionsMenu.add(exit);
	
		mb.add(optionsMenu);
	
	    mb.add(LookAndFeelManager.getDefaultLookAndFeelManager().getLookAndFeelMenu());
	
	    mainFrame.setJMenuBar(mb);
	    mainFrame.setVisible(true);
	
	    mainFrame.addWindowListener(
	        new WindowAdapter() {
	            public void windowClosing(WindowEvent we) {
	                System.exit(0);
	            }
	        }
	    );
	
	
	    JFrame otherFrame = new JFrame("Other Frame");
	    otherFrame.getContentPane().add(new JScrollPane(new JTree()), BorderLayout.CENTER);
	    otherFrame.setBounds(500, 100, 300, 500);
	    otherFrame.setVisible(true);
	
	    LookAndFeelManager.getDefaultLookAndFeelManager().registerFrame(otherFrame);
	
	    JDialog jdMain = new JDialog(mainFrame, "MainFrame Dialog", false);
	    jdMain.getContentPane().add(new JTree());
	    jdMain.pack();
	    jdMain.setLocation(300, 300);
	    jdMain.setVisible(true);
	
	    JDialog jdOther = new JDialog(otherFrame, "OtherFrame Dialog", false);
	    jdOther.getContentPane().add(new JTree());
	    jdOther.pack();
	    jdOther.setLocation(600, 300);
	    jdOther.setVisible(true);
	
	    // try with following line commented out
	    //LookAndFeelManager.getDefaultLookAndFeelManager().setFrameUpdatePolicy(LookAndFeelManager.ALL_FRAMES);
	
	    // try with following line commented out
	
	}
}