package de.uniwue.ki.gui.util.rectangular;

import de.uniwue.ki.util.name.AbstractNamed;
/**
 * Creation date: (30.11.2000 16:36:40)
 * @author Christoph Oechslein
 */
public abstract class AbstractRectangularMapPanelState extends AbstractNamed implements IRectangularMapPanelState {
	private JRectangularMap fieldRectangularMap = new JRectangularMap();

	public AbstractRectangularMapPanelState() {
		super();
	}

	public AbstractRectangularMapPanelState(JRectangularMap rectangularMap) {
		super();

		setRectangularMap(rectangularMap);
	}

	protected java.awt.Point convertMousePointToModelPoint(java.awt.Point point) {
		return new java.awt.Point(
			getRectangularMap().getColumnIndexAtX(point.x),
			getRectangularMap().getRowIndexAtX(point.y));
	}

	public javax.swing.Icon getIcon() {
		return null;
	}

	public JRectangularMap getRectangularMap() {
		return fieldRectangularMap;
	}

	public void mouseClicked(java.awt.event.MouseEvent e) {
		if (!e.isConsumed()) {
			if (javax.swing.SwingUtilities.isLeftMouseButton(e)) {
				if (e.getClickCount() == 1)
					mouseSingleClicked(e);
				else if (e.getClickCount() == 2)
					mouseDoubleClicked(e);
			}
		}
	}

	protected void mouseDoubleClicked(java.awt.event.MouseEvent e) {
	}

	/**
	 * @param e java.awt.event.MouseEvent
	 * @see java.awt.event.MouseListener
	 */
	public void mouseEntered(java.awt.event.MouseEvent e) {
	}

	/**
	 * @param e java.awt.event.MouseEvent
	 * @see java.awt.event.MouseListener
	 */
	public void mouseExited(java.awt.event.MouseEvent e) {
	}

	protected void mousePopupClicked(java.awt.event.MouseEvent e) {
	}

	/**
	 * @see java.awt.event.MouseListener
	 */
	public void mousePressed(java.awt.event.MouseEvent e) {
		if (!e.isConsumed()) {
			if (javax.swing.SwingUtilities.isRightMouseButton(e) && e.isPopupTrigger()) {
				mousePopupClicked(e);
			}
		}
	}

	/**
	 * @param e java.awt.event.MouseEvent
	 * @see java.awt.event.MouseListener
	 */
	public void mouseReleased(java.awt.event.MouseEvent e) {
		if (!e.isConsumed()) {
			if (javax.swing.SwingUtilities.isRightMouseButton(e) && e.isPopupTrigger()) {
				mousePopupClicked(e);
			}
		}
	}

	protected void mouseSingleClicked(java.awt.event.MouseEvent e) {
	}

	/**
	 * Sets the rectangularMap property (de.uniwue.ki.gui.generic.rectangular.JRectangularMap) value.
	 * @param rectangularMap The new value for the property.
	 * @see #getRectangularMap
	 */
	public void setRectangularMap(JRectangularMap rectangularMap) {
		fieldRectangularMap = rectangularMap;
	}
}