package de.uniwue.ki.gui.util.rectangular;
import java.awt.Font;
/**
 * Creation date: (15.11.2000 15:51:25)
 * @author Christoph Oechslein
 */
public class DefaultRectangularMapCellRenderer implements IRectangularMapCellRenderer {

	public java.awt.Component getRectangularMapCellRendererComponent(
		JRectangularMap jRectangularMap,
		java.util.Iterator value,
		boolean isSelected,
		boolean hasFocus,
		int column,
		int row) {

		return null;

	}

	public void renderCellInGraphics(
		JRectangularMap jRectangularMap,
		java.awt.Rectangle rectangle,
		java.awt.Graphics2D g2d,
		boolean isSelected,
		boolean hasFocus,
		int column,
		int row) {

		Font currFont = g2d.getFont();

		float fontSize = jRectangularMap.getRectangleWidth() * 0.25f;

		if (currFont.getSize2D() != fontSize) {
			Font newFont = currFont.deriveFont(fontSize);
			g2d.setFont(newFont);
		}

		String str =
			(isSelected ? "[" : "(")
				+ jRectangularMap.getRectangularMapModel().getObjectCount(column, row)
				+ ", "
				+ row
				+ ", "
				+ column
				+ (isSelected ? "]" : ")");
		int baseline = g2d.getFontMetrics().getAscent();
		int height = g2d.getFontMetrics().getHeight();

		g2d.drawString(str, rectangle.x, rectangle.y + (rectangle.height - height) * 0.5f + baseline);
	}
}