package de.uniwue.ki.gui.util.rectangular;
import java.awt.Component;

/**
 * Creation date: (15.11.2000 15:52:01)
 * @author Christoph Oechslein
 */
public interface IRectangularMapCellRenderer {

	/**
	     *  This method is sent to the renderer by the drawing Rectangular Map to
	     *  configure the renderer appropriately before drawing.  Return
	     *  the Component used for drawing.
	     *
	     * @parammapthe JRectangularMap that is asking the renderer to draw.
	     * @paramiteratorthe value of the cell to be rendered.
	     *can be null (should be the same as if !value.hasNext())
	     * @paramisSelectedtrue is the cell is to be renderer with
	     *selection highlighting
	     * @paramrow        the row index of the cell being drawn.
	     * @paramcolumn        the column index of the cell being drawn
	     */
	Component getRectangularMapCellRendererComponent(
	    JRectangularMap jRectangularMap,
	    java.util.Iterator value,
	    boolean isSelected,
	    boolean hasFocus,
	    int column,
	    int row);

	void renderCellInGraphics(
	    JRectangularMap jRectangularMap,
	    java.awt.Rectangle rectangle,
	    java.awt.Graphics2D g2d,
	    boolean isSelected,
	    boolean hasFocus,
	    int column,
	    int row);
}