package de.uniwue.ki.gui.util.rectangular;
import javax.swing.JFrame;
import javax.swing.JScrollPane;
/**
 * Creation date: (25.01.2002 14:49:42)
 * @author Christoph Oechslein
 */
public class JScrollRectangularMap extends JScrollPane {
	private JRectangularMap ivjJRectangularMapIntern = null;

	/**
	 * JScrollRectangularMap constructor comment.
	 */
	public JScrollRectangularMap() {
	    super();
	    initialize();
	}

	/**
	 * JScrollRectangularMap constructor comment.
	 * @param vsbPolicy int
	 * @param hsbPolicy int
	 */
	public JScrollRectangularMap(int vsbPolicy, int hsbPolicy) {
	    super(vsbPolicy, hsbPolicy);
	}

	/**
	 * JScrollRectangularMap constructor comment.
	 * @param view java.awt.Component
	 */
	public JScrollRectangularMap(java.awt.Component view) {
	    super(view);
	}

	/**
	 * JScrollRectangularMap constructor comment.
	 * @param view java.awt.Component
	 * @param vsbPolicy int
	 * @param hsbPolicy int
	 */
	public JScrollRectangularMap(java.awt.Component view, int vsbPolicy, int hsbPolicy) {
	    super(view, vsbPolicy, hsbPolicy);
	}

	public void doEqualSize() {
	    if (getJRectangularMap() != null) {
	        java.awt.Dimension scrollDim = getSize();
	        java.awt.Insets scrollInsets = getInsets();
	
	        java.awt.Insets mapInsets = getJRectangularMap().getInsets();
	
	        double scrollHeight =
	            scrollDim.getHeight() - scrollInsets.top - scrollInsets.bottom - mapInsets.top - mapInsets.bottom - getHorizontalScrollBar().getHeight();
	        double scrollWidth =
	            scrollDim.getWidth() - scrollInsets.left - scrollInsets.right - mapInsets.left - mapInsets.right - getVerticalScrollBar().getWidth();
	
	        int newRectHeight = (int) Math.ceil(scrollHeight / getJRectangularMap().getRectangularMapModel().getRowsCount());
	        int newRectWidth = (int) Math.ceil(scrollWidth / getJRectangularMap().getRectangularMapModel().getColsCount());
	
	        int newRect = Math.min(newRectHeight, newRectWidth);
	
	        getJRectangularMap().setRectangleHeight(newRect);
	        getJRectangularMap().setRectangleWidth(newRect);
	    }
	}


	/**
	 * Method generated to support the promotion of the jRectangularMap attribute.
	 * @return de.uniwue.ki.gui.util.rectangular.JRectangularMap
	 */
	public JRectangularMap getJRectangularMap() {
	    return getJRectangularMapIntern();
	}

	/**
	 * Return the JRectangularMapIntern property value.
	 * @return de.uniwue.ki.gui.util.rectangular.JRectangularMap
	 */
	/* WARNING: THIS METHOD WILL BE REGENERATED. */
	private JRectangularMap getJRectangularMapIntern() {
	    if (ivjJRectangularMapIntern == null) {
	        try {
	            ivjJRectangularMapIntern = new de.uniwue.ki.gui.util.rectangular.JRectangularMap();
	            ivjJRectangularMapIntern.setName("JRectangularMapIntern");
	            ivjJRectangularMapIntern.setLocation(0, 0);
	            // user code begin {1}
	            // user code end
	        } catch (java.lang.Throwable ivjExc) {
	            // user code begin {2}
	            // user code end
	            handleException(ivjExc);
	        }
	    }
	    return ivjJRectangularMapIntern;
	}

	/**
	 * Called whenever the part throws an exception.
	 * @param exception java.lang.Throwable
	 */
	private void handleException(java.lang.Throwable exception) {
	    exception.printStackTrace(System.out);
	}

	/**
	 * Initialize the class.
	 */
	/* WARNING: THIS METHOD WILL BE REGENERATED. */
	private void initialize() {
	    try {
	        // user code begin {1}
	        // user code end
	        setName("JScrollRectangularMap");
	        setSize(278, 242);
	        setViewportView(getJRectangularMapIntern());
	    } catch (java.lang.Throwable ivjExc) {
	        handleException(ivjExc);
	    }
	    // user code begin {2}
	    // user code end
	}

	/**
	 * main entrypoint - starts the part when it is run as an application
	 * @param args java.lang.String[]
	 */
	public static void main(java.lang.String[] args) {
	    try {
	        JFrame frame = new javax.swing.JFrame();
	        JScrollRectangularMap aJScrollRectangularMap;
	        aJScrollRectangularMap = new JScrollRectangularMap();
	        frame.setContentPane(aJScrollRectangularMap);
	        frame.setSize(aJScrollRectangularMap.getSize());
	        frame.addWindowListener(new java.awt.event.WindowAdapter() {
	            public void windowClosing(java.awt.event.WindowEvent e) {
	                System.exit(0);
	            }
	        });
	        frame.show();
	        java.awt.Insets insets = frame.getInsets();
	        frame.setSize(frame.getWidth() + insets.left + insets.right, frame.getHeight() + insets.top + insets.bottom);
	        frame.setVisible(true);
	    } catch (Throwable exception) {
	        System.err.println("Exception occurred in main() of de.uniwue.ki.gui.util.rectangular.JScrollRectangularMap");
	        exception.printStackTrace(System.out);
	    }
	}
}