package de.uniwue.ki.gui.util.timetable;

import java.util.Calendar;
import java.util.Iterator;
import java.util.List;

import javax.swing.event.ChangeListener;

import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * @author schoerger, herrler
 *  
 */
public class AnnotedTimeTableModel {

    ITimeTable timeTable = null;

    private IAppointmentRenderer appointmentRenderer = new DefaultAppointmentRenderer();

    //private IAppointmentBackgroundRenderer BackgroundRenderer;
    private Calendar startDay;

    private int pixelPerMinute = 1;

    private int startHourInTheMorning = 7;

    private int endHourinTheEvening = 18;

    private int slotSize = 30;

    //private int NumberOfDays = 7;
    private int numberOfWeeks = 1;

    private int columnWidth = 100;

    private double scaleFactor = 1;

    public AnnotedTimeTableModel(ITimeTable table) {
        super();
    }

    public AnnotedTimeTableModel() {
        super();
        timeTable = new ITimeTable() {
            public void addAppointment(IAppointment appointment) {
                return;
            }

            public Iterator getAppointments() {
                return CollectionsHelper.EMPTY_ITERATOR;
            }

            public void addChangeListener(ChangeListener listener) {
            }
            
            public void removeChangeListener(ChangeListener listener) {
            }
        };
    }

    public int getColumnWidth() {
        return columnWidth;
    }

    public int getEndHourinTheEvening() {
        return endHourinTheEvening;
    }

    public int getPixelPerMinute() {
        return pixelPerMinute;
    }

    public double getScaleFactor() {
        return scaleFactor;
    }

    public int getSlotSize() {
        return slotSize;
    }

    public Calendar getStartDay() {
        return startDay;
    }

    public int getStartHourInTheMorning() {
        return startHourInTheMorning;
    }

    public void setAppointmentList(List list) {
        Iterator it = list.iterator();
        while (it.hasNext())
            timeTable.addAppointment((IAppointment) it.next());
    }

    public void setColumnWidth(int i) {
        columnWidth = i;
    }

    public void setEndHourinTheEvening(int i) {
        endHourinTheEvening = i;
    }

    public void setPixelPerMinute(int i) {
        pixelPerMinute = i;
    }

    public void setScaleFactor(double d) {
        scaleFactor = d;
    }

    public void setSlotSize(int i) {
        slotSize = i;
    }

    public void setStartDay(Calendar calendar) {
        startDay = calendar;
    }

    public void setStartHourInTheMorning(int i) {
        startHourInTheMorning = i;
    }

    public IAppointmentRenderer getAppointmentRenderer() {
        return appointmentRenderer;
    }

    public void setAppointmentRenderer(IAppointmentRenderer renderer) {
        appointmentRenderer = renderer;
    }

    public int getNumberOfWeeks() {
        return numberOfWeeks;
    }

    public void setNumberOfWeeks(int i) {
        numberOfWeeks = i;
    }

    public ITimeTable getTimeTable() {
        return timeTable;
    }

    public void setTimeTable(ITimeTable timeTable) {
        this.timeTable = timeTable;
    }
}