package de.uniwue.ki.mas.application.remote;

import java.io.*;

import de.uniwue.ki.mas.xml.castor.v01.remote.*;
import de.uniwue.ki.util.name.INamed;

/**
 * Creation date: 04.09.2002, 19:19:00
 * @author oechslein
 */
public interface ISimulationControlConnection extends INamed {
	void closeConnection() throws IOException;

	boolean isConnected();

	XMLRemoteInfo getXMLRemoteInfo() throws IOException;

	XMLDetailedRemoteInfo getXMLDetailedRemoteInfo() throws IOException;

	boolean loadModelFile(File modelFile) throws IOException;

	boolean loadModelStream(String remoteModelFileName, Reader reader) throws IOException;

	boolean startSimulation(String name) throws IOException;

	boolean stopSimulation() throws IOException;

	boolean pause() throws IOException;

	boolean unpause() throws IOException;

	boolean setAllowSimulation(boolean allowSimulation) throws IOException;

	void restart(File jarFile) throws IOException;

	void quit() throws IOException;

	File getAnalysisAsZipFile() throws IOException;

	void removeAnalysisFromLastZipFile() throws IOException;
	
	void removeAllUnfinishedFiles() throws IOException;

	boolean setXMLTimeSchedule(XMLRemoteTimeSchedule xmlRemoteTimeSchedule) throws IOException;

	XMLRemoteTimeSchedule getXMLTimeSchedule() throws IOException;
}