package de.uniwue.ki.mas.application.remote;

import java.io.*;

public class RemoteAnswer implements Serializable {

	private final String _answerToMessageId;
	private final boolean _successful;
	private final Object _answer;

	public RemoteAnswer(RemoteCommand toCommand, boolean successful, Object answer) {
		this(toCommand.getMessageId(), successful, answer);
	}

	public RemoteAnswer(RemoteCommand toCommand, Object answer) {
		this(toCommand.getMessageId(), true, answer);
	}

	public RemoteAnswer(RemoteCommand toCommand, boolean successful) {
		this(toCommand.getMessageId(), successful, null);
	}

	public RemoteAnswer(String answerToMessageId, boolean successful, Object answer) {
		super();

		_answerToMessageId = answerToMessageId;
		_successful = successful;
		_answer = answer;
	}

	public Object getAnswerToMessageId() {
		return _answerToMessageId;
	}

	public boolean isSuccessful() {
		return _successful;
	}

	public Object getAnswer() {
		return _answer;
	}

	public void writeObject(DataOutputStream out) throws IOException {
		RemoteReaderWriter.outputObject(_answerToMessageId, out);
		RemoteReaderWriter.outputObject(Boolean.valueOf(_successful), out);
		RemoteReaderWriter.outputObject(_answer, out);
	}

	public static RemoteAnswer readObject(DataInputStream in) throws IOException {
		return new RemoteAnswer(
			(String) RemoteReaderWriter.inputObject(in),
			((Boolean) RemoteReaderWriter.inputObject(in)).booleanValue(),
			RemoteReaderWriter.inputObject(in));
	}

}
