package de.uniwue.ki.mas.application.remote;

import de.uniwue.ki.util.name.AbstractNamed;
import de.uniwue.ki.util.name.INamed;
/**
 * Creation date: 30.10.2002, 11:26:45
 * @author oechslein
 */public final class RemoteClientState extends AbstractNamed implements INamed, IRemoteProtocolConstants {
	private final String _name;
	private final int _id;

	RemoteClientState(String name, int id) {
		_name = name;
		_id = id;
	}

	public boolean equals(Object obj) {
		if (obj == this)
			return true;
		else
			return (obj instanceof RemoteClientState) && (((RemoteClientState)obj).getId() == getId());
	}

	public int hashCode() {
		return getId();
	}

	public static RemoteClientState getState(int id) {
		switch (id) {
			case -1 :
				return ERROR_STATE;
			case 0 :
				return NO_MODEL_STATE;
			case 1 :
				return HAS_MODEL_STATE;
			case 2 :
				return RUNNING_STATE;
			case 3 :
				return FINISHED_STATE;
			case 4 :
				return PAUSED_STATE;
			case 5 :
				return DISALLOW_SIMULATION_STATE;
			case 6 :
				return INITIALIZED_STATE;
			case 7 :
				return FINISHED_WITH_ERRORS_STATE;

			default :
				return null;
		}
	}

	public static String getStateName(int id) {
		RemoteClientState state = getState(id);
		if (state == null)
			return"UNKNOWN (id: "+id +")";
else
	return getStateName(state);
}

public static String getStateName(RemoteClientState state) {
	if (state == null)
		return"UNKNOWN";
else
	return state.getName();
}

public boolean equals(int id) {
	return getId() == id;
}

public int getId() {
	return _id;
}

public String getName() {
	return _name;
}
}
