package de.uniwue.ki.mas.basics.action;
import de.uniwue.ki.mas.basics.functionCall.*;
import de.uniwue.ki.mas.basics.type.VoidType;
import de.uniwue.ki.mas.util.declaration.AbstractDeclarationFactory;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: (07.11.2000 13:16:12)
 * @author Christoph Oechslein
 */
public final class FunctionActionCallDeclarationFactory
	extends AbstractDeclarationFactory
	implements IFunctionCallDeclarationFactory {
		
	private static final FunctionActionCallDeclarationFactory _instance =
		new FunctionActionCallDeclarationFactory();

	private FunctionActionCallDeclarationFactory() {
		super();
	}

	/**
	 * @return IDeclaration
	 * @see de.uniwue.ki.mas.util.declaration.IDeclarationFactory#createDeclaration()
	 */
	public final IDeclaration createDeclaration() {
		return createFunctionActionCallDeclaration();
	}

	/**
	 * @return IFunctionCallDeclaration
	 * @see de.uniwue.ki.mas.basics.functionCall.IFunctionCallDeclarationFactory#createFunctionCallDeclaration()
	 */
	public final IFunctionCallDeclaration createFunctionCallDeclaration() {
		return FunctionCallDeclarationFactory.getInstance().createFunctionCallDeclaration(
			VoidType.getInstance());
	}

	/**
	 * @return IFunctionCallDeclaration
	 */
	public final IFunctionCallDeclaration createFunctionActionCallDeclaration() {
		return FunctionCallDeclarationFactory.getInstance().createFunctionCallDeclaration(
			VoidType.getInstance());
	}

	/**
	 * @return FunctionActionCallDeclarationFactory
	 */
	public static final FunctionActionCallDeclarationFactory getInstance() {
		return _instance;
	}
}