package de.uniwue.ki.mas.basics.action;
import de.uniwue.ki.mas.basics.action.debugging.FunctionActionDebuggingDeclarationFactory;
import de.uniwue.ki.mas.basics.action.rest.FunctionActionRestDeclarationFactory;
import de.uniwue.ki.mas.basics.action.simulation.FunctionActionSimulationDeclarationFactory;
import de.uniwue.ki.mas.basics.functionDeclaration.list.FunctionDeclarationList;
import de.uniwue.ki.mas.basics.functionDeclaration.list.IFunctionDeclarationList;
/**
 * Creation date: (30.07.2001 14:41:09)
 * @author Christoph Oechslein
 */

public class FunctionActionDeclarationFactory {
	private static IFunctionDeclarationList _cachedFunctionDeclarationList;

	public synchronized static void insertFunctions(IFunctionDeclarationList functionDeclarationList) {
		if (_cachedFunctionDeclarationList == null) {
			_cachedFunctionDeclarationList = generateFunctions();
		}
		functionDeclarationList.addAll(_cachedFunctionDeclarationList);
	}

	private static IFunctionDeclarationList generateFunctions() {
		IFunctionDeclarationList functionDeclarationList = new FunctionDeclarationList();

		FunctionActionRestDeclarationFactory.insertFunctions(functionDeclarationList);

		FunctionActionDebuggingDeclarationFactory.insertFunctions(functionDeclarationList);

		FunctionActionSimulationDeclarationFactory.insertFunctions(functionDeclarationList);

		return functionDeclarationList;
	}
}