package de.uniwue.ki.mas.basics.action.debugging;
import junit.framework.Assert;
import de.uniwue.ki.mas.basics.action.FunctionActionFactory;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionCall.IFunctionCallInternDeclaration;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionArgsDeclaration;
import de.uniwue.ki.mas.basics.type.*;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Creation date: (01.10.2001 16:25:22)
 * @author Christoph Oechslein
 */

final class AssertSpecificFunctionDeclaration extends AbstractSpecificFunctionArgsDeclaration {
	public AssertSpecificFunctionDeclaration() {
		super(
			"Assert",
			VoidType.getInstance(),
			CollectionsHelper.createList(BooleanType.getInstance(), StringType.getInstance()));

		setExpertFunctionDeclaration(true);
		setDocumentation("Halts the simulation and prints the message (Arg2) if the condition (Arg1) is 'false'");
	}

	public IFunctionCallInternDeclaration createDefaultFunctionCallInternDeclarationAt(int index) {
		return super.createDefaultFunctionCallInternDeclarationAt(index);
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions) {
		if (Assert.ASSERTION_ON)
			Assert.assertEquals(2, functions.size());

		if (!Assert.ASSERTION_ON || !FunctionActionDebuggingDeclarationFactory.isCompileDebugFunctions())
			return FunctionActionFactory.getNoopFunction();
		//TODO special Case if first arg ist constant
		//		else if (!(functions.get(0) instanceof IArgument))
		//			return new FunctionAssert(functions.getFunction(0), functions.getFunction(1));
		else
			return new FunctionAssert(functions.getFunction(0), functions.getFunction(1));
	}
}