package de.uniwue.ki.mas.basics.action.debugging;
import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionCall.IFunctionCallInternDeclaration;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionArgsDeclaration;
import de.uniwue.ki.mas.basics.type.StringType;
import de.uniwue.ki.mas.basics.type.VoidType;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Creation date: (01.10.2001 16:25:22)
 * @author Christoph Oechslein
 */

final class FailSpecificFunctionDeclaration extends AbstractSpecificFunctionArgsDeclaration {
	public FailSpecificFunctionDeclaration() {
		super("Fail", VoidType.getInstance(), CollectionsHelper.createList(StringType.getInstance()));

		setExpertFunctionDeclaration(true);
		setDocumentation("Stops the simulation and prints the message (Arg1).");
	}

	public IFunctionCallInternDeclaration createDefaultFunctionCallInternDeclarationAt(int index) {
		return super.createDefaultFunctionCallInternDeclarationAt(index);
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions) {
		Assert.assertEquals(1, functions.size());

		return new FunctionFail(functions.getFunction(0));
	}
}