package de.uniwue.ki.mas.basics.action.debugging;
import junit.framework.Assert;
import de.uniwue.ki.mas.basics.action.AbstractFunctionAction;
import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.model.SimulationRuntimeException;
import de.uniwue.ki.util.Utils;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class FunctionActionInspect extends AbstractFunctionAction implements IFunction {
	private final IFunction _functionValue;

	public FunctionActionInspect(IFunction functionValue) {
		super();
		_functionValue = functionValue;
	}

	public void act(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
		if (Assert.ASSERTION_ON && FunctionActionDebuggingDeclarationFactory.isRunDebugFunctions())
			Utils.inspect(_functionValue.execute(executeFunctionArgs));
	}

	public String getName() {
		return "Inspect(" + _functionValue.getName() + ")";
	}
}