package de.uniwue.ki.mas.basics.action.debugging;
import junit.framework.Assert;
import de.uniwue.ki.mas.basics.action.AbstractFunctionAction;
import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class FunctionAssert extends AbstractFunctionAction {
	private final IFunction _functionTest;
	private final IFunction _functionString;

	public FunctionAssert(IFunction functionBoolean, IFunction functionString) {
		super();

		_functionTest = functionBoolean;
		_functionString = functionString;
	}

	public void act(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
		if (Assert.ASSERTION_ON && FunctionActionDebuggingDeclarationFactory.isRunDebugFunctions()) {
			if (!_functionTest.executeForBoolean(executeFunctionArgs)) {
				throw new SimulationRuntimeException(
					"Assertion Error: "
						+ _functionString.execute(executeFunctionArgs)
						+ " "
						+ _functionTest.getName());
			}
		}
	}

	public String getName() {
		return "Assert(" + _functionTest.getName() + ", " + _functionString.getName() + ")";
	}
}