package de.uniwue.ki.mas.basics.action.debugging;
import de.uniwue.ki.mas.basics.action.AbstractFunctionAction;
import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class FunctionFail extends AbstractFunctionAction {
	private final IFunction _functionString;

	public FunctionFail(IFunction functionString) {
		super();

		_functionString = functionString;
	}

	public void act(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
		throw new SimulationRuntimeException("Fail: " + _functionString.execute(executeFunctionArgs));
	}

	public String getName() {
		return "Fail(" + _functionString.getName() + ")";
	}
}