package de.uniwue.ki.mas.basics.action.debugging;

import junit.framework.Assert;
import de.uniwue.ki.mas.basics.action.AbstractFunctionActionDeclaration;
import de.uniwue.ki.mas.basics.action.FunctionActionFactory;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionCall.IComposedFunctionCallInternDeclaration;
import de.uniwue.ki.mas.basics.type.StringType;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * @author oechslein
 * 
 * Creation date: 06.05.2003
 */
final class PrintSpecificFunctionDelaration extends AbstractFunctionActionDeclaration {
	public PrintSpecificFunctionDelaration() {
		super("Print", CollectionsHelper.createList(StringType.getInstance()), true);

		setDocumentation("Prints its operand onto the console");
	}

	public IFunction createFunction(
		ICreateFunctionArgs createFunctionArgs,
		IComposedFunctionCallInternDeclaration composedFunctionCallInternDeclaration)
		throws ModelCompilingException {

		if (Assert.ASSERTION_ON)
			return super.createFunction(createFunctionArgs, composedFunctionCallInternDeclaration);
		else
			return FunctionActionFactory.getNoopFunction();
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions) {

		if (Assert.ASSERTION_ON)
			Assert.assertEquals(1, functions.size());

		if (Assert.ASSERTION_ON)
			Assert.assertEquals(1, functions.size());

		if (Assert.ASSERTION_ON && FunctionActionDebuggingDeclarationFactory.isCompileDebugFunctions())
			return new FunctionActionPrint(functions.getFunction(0));
		else
			return FunctionActionFactory.getNoopFunction();
	}
}