package de.uniwue.ki.mas.basics.action.rest;
import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionCall.FunctionCallDeclarationFactory;
import de.uniwue.ki.mas.basics.functionCall.IFunctionCallInternDeclaration;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionAdapterGenericFunctionDeclaration;
import de.uniwue.ki.mas.basics.type.*;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Creation date: (01.10.2001 16:25:22)
 * @author Christoph Oechslein
 */

// TODO change to IntegerType
final class ForTimesSpecificFunctionDeclaration
	extends AbstractSpecificFunctionAdapterGenericFunctionDeclaration {

	private final ISpecificType _ouputType;

	public ForTimesSpecificFunctionDeclaration(
		ForTimesGenericFunctionDeclaration timesGenericFunctionDeclaration,
		ISpecificType ouputType) {

		super(timesGenericFunctionDeclaration, 3);

		setDocumentation("Repeats function (Arg1) ((Arg3) - (Arg2))-times often, Arg2 and Arg3 are rounded.");

		_ouputType = ouputType;

	}

	public IFunctionCallInternDeclaration createDefaultFunctionCallInternDeclarationAt(int index) {
		if (index == 2) {
			return FunctionCallDeclarationFactory.getInstance().createAtomicFunctionCallInternDeclaration(
				null,
				DoubleType.getInstance(),
				new Double(10));

		} else {
			return super.createDefaultFunctionCallInternDeclarationAt(index);
		}
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions) {
		if (Assert.ASSERTION_ON)
			Assert.assertEquals(3, functions.size());

		return new FunctionForTimes(
			functions.getFunction(0),
			functions.getFunction(1),
			functions.getFunction(2));
	}

	public String getSpecificInputTypeNameAt(int index) {
		if (index == 0) {
			// return getSpecificInputTypeAt(index).getName();
			return super.getSpecificInputTypeNameAt(0);

		} else if (index == 1) {
			return "from";

		} else if (index == 2) {
			return "to";

		} else {
			Assert.fail();
			return "";
		}
	}

	public ISpecificType getSpecificOutputType() {
		return _ouputType;
	}

	public ISpecificType getSpecificInputTypeAt(int index) {
		if (index == 0) {
			return GenericFunctionType.getInstance().createSpecificFunctionType(
				_ouputType,
				CollectionsHelper.createList(DoubleType.getInstance()));

		} else if (index == 1) {
			return DoubleType.getInstance();

		} else {
			Assert.assertEquals(2, index);
			return DoubleType.getInstance();
		}
	}
}