package de.uniwue.ki.mas.basics.action.rest;
import de.uniwue.ki.mas.basics.action.AbstractFunctionAction;
import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * <BR>Creation date: (26.04.00 16:31:20)
 *
 * @author Christoph Oechslein
 */

public final class FunctionActionNoop extends AbstractFunctionAction implements IFunction {
   private static final FunctionActionNoop instance = new FunctionActionNoop();

private FunctionActionNoop() {
   super();
}


/**
 * @param executeFunctionArgs IExecuteFunctionArgs
 * @throws SimulationRuntimeException
 * @see de.uniwue.ki.mas.basics.function.IFunction#act(IExecuteFunctionArgs)
 */
public void act(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
}


/**
 * @return FunctionActionNoop
 */
public static final FunctionActionNoop getInstance() {
   return instance;
}


/**
 * @return String
 * @see de.uniwue.ki.util.INamed#getName()
 */
public String getName() {
   return "Noop";
}
}