package de.uniwue.ki.mas.basics.action.rest;

import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * @author herrler
 *
 */

public class FunctionProg1 extends AbstractFunctionDynamic {
	private final IFunction _actionFunction;
	private final IFunction _resultFunction;

	public FunctionProg1(IFunction resultFunction, IFunction actionFunction) {
		super();

		_actionFunction = actionFunction;
		_resultFunction = resultFunction;
	}

	public void act(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
		_resultFunction.act(executeFunctionArgs);
		_actionFunction.act(executeFunctionArgs);
	}

	public Object execute(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
		Object retObj = _resultFunction.execute(executeFunctionArgs); 
		_actionFunction.act(executeFunctionArgs);
		return retObj; 
	}

	public final boolean executeForBoolean(IExecuteFunctionArgs executeFunctionArgs)
		throws SimulationRuntimeException {
		boolean retBool = _resultFunction.executeForBoolean(executeFunctionArgs); 
		_actionFunction.act(executeFunctionArgs);
		return retBool;
	}

	public final double executeForDouble(IExecuteFunctionArgs executeFunctionArgs)
		throws SimulationRuntimeException {
		double retDouble = _resultFunction.executeForDouble(executeFunctionArgs); 
		_actionFunction.act(executeFunctionArgs);
		return retDouble;
	}

	public final int executeForInt(IExecuteFunctionArgs executeFunctionArgs)
		throws SimulationRuntimeException {
			int retInteger = _resultFunction.executeForInt(executeFunctionArgs); 
		_actionFunction.act(executeFunctionArgs);
		return retInteger;
	}

	public String getName() {
		return "Prog1(" + _resultFunction.getName() + ", " + _actionFunction.getName() + ")";
	}
}
