package de.uniwue.ki.mas.basics.action.rest;

import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * @author herrler
 *
 */

public class FunctionProgn extends AbstractFunctionDynamic {
	private final IFunction _actionFunction;
	private final IFunction _resultFunction;

	public FunctionProgn(IFunction actionFunction, IFunction resultFunction) {
		super();

		_actionFunction = actionFunction;
		_resultFunction = resultFunction;
	}

	public void act(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
		_actionFunction.act(executeFunctionArgs);
		_resultFunction.act(executeFunctionArgs);
	}

	public Object execute(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
		_actionFunction.act(executeFunctionArgs);
		return _resultFunction.execute(executeFunctionArgs);
	}

	public final boolean executeForBoolean(IExecuteFunctionArgs executeFunctionArgs)
		throws SimulationRuntimeException {
		_actionFunction.act(executeFunctionArgs);
		return _resultFunction.executeForBoolean(executeFunctionArgs);
	}

	public final double executeForDouble(IExecuteFunctionArgs executeFunctionArgs)
		throws SimulationRuntimeException {
		_actionFunction.act(executeFunctionArgs);
		return _resultFunction.executeForDouble(executeFunctionArgs);
	}

	public final int executeForInt(IExecuteFunctionArgs executeFunctionArgs)
		throws SimulationRuntimeException {
		_actionFunction.act(executeFunctionArgs);
		return _resultFunction.executeForInt(executeFunctionArgs);
	}

	public String getName() {
		return "Progn(" + _actionFunction.getName() + ", " + _resultFunction.getName() + ")";
	}
}
