package de.uniwue.ki.mas.basics.action.rest;

import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionArgsDeclaration;
import de.uniwue.ki.mas.basics.type.*;
import de.uniwue.ki.util.collection.CollectionsHelper;


/**
 * Creation date: (01.10.2001 16:25:22)
 * @author Christoph Oechslein
 */

final class InheritFeatureVariablesSpecificFunctionDeclaration extends AbstractSpecificFunctionArgsDeclaration {
public InheritFeatureVariablesSpecificFunctionDeclaration() {
    super(
        "InheritFeatureVars",
        VoidType.getInstance(),
        CollectionsHelper.createList(FeatureClassDeclarationType.getInstance(), GenericSimObjectType.getGeneralSimObjectType()));
    
    setDocumentation("Inherits the (varialble holding) feature (Arg1) to its child (Arg2) (which must have the same feature available!)");
}
/**
 * @param createFunctionArgs ICreateFunctionArgs
 * @param functions IFunctionList
 * @return IFunction
 * @see de.uniwue.ki.mas.basics.functionDeclaration.ISpecificFunctionDeclaration#createFunction(ICreateFunctionArgs, IFunctionList)
 */
public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions) {
    if (Assert.ASSERTION_ON)
        Assert.assertEquals(2, functions.size());

    return new FunctionInheritFeatureVariables(functions.getFunction(0), functions.getFunction(1));
}
/**
 * @param index int
 * @return String
 * @see de.uniwue.ki.mas.basics.functionDeclaration.ISpecificFunctionDeclaration#getSpecificInputTypeNameAt(int)
 */
public String getSpecificInputTypeNameAt(int index) {
    if (index == 1) {
        return "child";

    } else {
        return super.getSpecificInputTypeNameAt(index);
    }
}
}
