package de.uniwue.ki.mas.basics.action.rest;

import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionAdapterGenericFunctionDeclaration;
import de.uniwue.ki.mas.basics.type.ISpecificType;
import de.uniwue.ki.mas.basics.type.VoidType;
import de.uniwue.ki.mas.model.ModelCompilingException;

/**
 * @author herrler
 */
public class Prog1SpecificFunctionDeclaration
	extends AbstractSpecificFunctionAdapterGenericFunctionDeclaration {
	private final ISpecificType _outputType;

	public Prog1SpecificFunctionDeclaration(
		Prog1GenericFunctionDeclaration prog1GenericFunctionDeclaration,
		ISpecificType outputType) {
		super(prog1GenericFunctionDeclaration, 2);

		_outputType = outputType;
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions)
		throws ModelCompilingException {
		if (Assert.ASSERTION_ON)
			Assert.assertEquals(2, functions.size());

		return new FunctionProg1(functions.getFunction(0), functions.getFunction(1));
	}

	public ISpecificType getSpecificInputTypeAt(int index) {
		if (index == 0) {
			return _outputType;
			
		} else if (index == 1) {
			return VoidType.getInstance();
			
		} else {
			Assert.fail();
			return null;
		}
	}

	public ISpecificType getSpecificOutputType() {
		return _outputType;
	}
}
