package de.uniwue.ki.mas.basics.action.rest;

import java.util.Iterator;

import de.uniwue.ki.mas.basics.functionDeclaration.AbstractGenericFunctionDeclarationWithoutDependents;
import de.uniwue.ki.mas.basics.functionDeclaration.ISpecificFunctionDeclaration;
import de.uniwue.ki.mas.basics.type.*;
import de.uniwue.ki.mas.basics.type.composed.ISpecificComposedType;

/**
 * @author herrler
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
final class PrognGenericFunctionDeclaration extends AbstractGenericFunctionDeclarationWithoutDependents {

	public PrognGenericFunctionDeclaration() {
		super("Progn", GenericType.getInstance(), true);

		setDocumentation("Executes a block and returns the value of the last instruction");
	}

	public boolean canCreateFunctionDeclarationWith(ISpecificType outputType) {
		return super.canCreateFunctionDeclarationWith(outputType)
			&& (TypeManager.getInstance().isInAllTypes(outputType)
				|| (GenericIteratorType.getInstance().canCreate(outputType)));

	}

	public ISpecificFunctionDeclaration createFunctionDeclaration(ISpecificType outputType) {
		outputType = convertIteratorType(outputType);

		return new PrognSpecificFunctionDeclaration(this, outputType);
	}

	public ISpecificFunctionDeclaration createFunctionDeclaration(Iterator inputArgs) {
		/* <T> progn(void, <T>) */

		ISpecificType specificType = getNextSpecificType(inputArgs);
		if (specificType != VoidType.getInstance())
			return null;

		specificType = getNextSpecificType(inputArgs);

		if ((TypeManager.getInstance().isInAllTypes(specificType))
			|| (specificType instanceof ISpecificComposedType)
			|| (GenericIteratorType.getInstance().canCreate(specificType)))
			return createFunctionDeclaration(specificType);
		else
			return null;
	}

	public String getSignatureWithoutNameAndOutputType(ISpecificType outputType) {
		outputType = convertIteratorType(outputType);

		return "(Progn<" + outputType.getName() + ">)";
	}

	/** 
	 * was macht das denn ??
	 */
	private ISpecificType convertIteratorType(ISpecificType outputType) {
		if (outputType instanceof SpecificIteratorType) {
			SpecificIteratorType specificIteratorType = (SpecificIteratorType) outputType;
			return GenericListType.getInstance().createSpecificListType(
				specificIteratorType.getIteratorSpecificType());

		} else {
			return outputType;
		}
	}
}