package de.uniwue.ki.mas.basics.action.rest;

import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionAdapterGenericFunctionDeclaration;
import de.uniwue.ki.mas.basics.type.ISpecificType;
import de.uniwue.ki.mas.basics.type.VoidType;
import de.uniwue.ki.mas.model.ModelCompilingException;

/**
 * @author herrler
 */
public class PrognSpecificFunctionDeclaration
	extends AbstractSpecificFunctionAdapterGenericFunctionDeclaration {
	private final ISpecificType _outputType;

	public PrognSpecificFunctionDeclaration(
		PrognGenericFunctionDeclaration prognGenericFunctionDeclaration,
		ISpecificType outputType) {
		super(prognGenericFunctionDeclaration, 2);

		_outputType = outputType;
	}

	/**
	 */
	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions)
		throws ModelCompilingException {
		if (Assert.ASSERTION_ON)
			Assert.assertEquals(2, functions.size());

		IFunction eins = functions.getFunction(0);
		IFunction zwei = functions.getFunction(1);

		return new FunctionProgn(eins,zwei);
	}

	/**
	public IFunction createFunction(
		ICreateFunctionArgs createFunctionArgs,
		IComposedFunctionCallInternDeclaration composedFunctionCallInternDeclaration)
		throws ModelCompilingException {

		if (Assert.ASSERTION_ON)
			Assert.assertEquals(2, composedFunctionCallInternDeclaration.getChildCount());

		    if (isConstant(createFunctionArgs, composedFunctionCallInternDeclaration)) {
			try {
				return createConstantFunction(
					createFunctionArgs.createCreateAndExecuteFunctionArgs(),
					composedFunctionCallInternDeclaration.getChild(0));

			} catch (SimulationRuntimeException exception) {
				throw new ModelCompilingException(exception);
			}

		} else {

		return super.createFunction(createFunctionArgs, composedFunctionCallInternDeclaration);
	}
    */	


	/**
	 * @param index int
	 * @return ISpecificType
	 * @see de.uniwue.ki.mas.basics.functionDeclaration.ISpecificFunctionDeclaration#getSpecificInputTypeAt(int)
	 */
	public ISpecificType getSpecificInputTypeAt(int index) {
        if (index == 0) {
			return VoidType.getInstance();

		} 
		
		if (index == 1) {
			return _outputType;

		} 
			
		Assert.fail();
		return null;
	}

	/**
	 * @return ISpecificType
	 * @see de.uniwue.ki.mas.basics.functionDeclaration.ISpecificFunctionDeclaration#getSpecificOutputType()
	 */
	public ISpecificType getSpecificOutputType() {
		return _outputType;
	}

	/*
	 private IBodyVariableInstanceDeclaration getBodyVariableInstanceDeclaration(
		IObject simObject,
		IFunctionCallInternDeclaration variableFunctionCallInternDeclaration)
		throws ModelCompilingException {

		return SpecificVariableClassDeclarationType.getBodyVariableInstanceDeclaration(
			simObject.getObjectInstanceDeclaration(),
			((IAtomicFunctionCallInternDeclaration) variableFunctionCallInternDeclaration)
				.getArgumentDeclaration()
				.getObject());
	}
	*/

}
