package de.uniwue.ki.mas.basics.action.rest;
import java.util.Iterator;

import de.uniwue.ki.mas.basics.functionDeclaration.AbstractGenericFunctionDeclarationWithoutDependents;
import de.uniwue.ki.mas.basics.functionDeclaration.ISpecificFunctionDeclaration;
import de.uniwue.ki.mas.basics.type.*;

/**
 * Creation date: (04.09.2001 16:53:35)
 * @author Christoph Oechslein
 */

final class WhileGenericFunctionDeclaration extends AbstractGenericFunctionDeclarationWithoutDependents {
	public WhileGenericFunctionDeclaration() {
		super("While", GenericType.getInstance(),true);

		setDocumentation("Executes the instruction (Arg2) while condition (Arg1) is 'true'");
	}

	public ISpecificFunctionDeclaration createFunctionDeclaration(ISpecificType outputType) {
		return new WhileSpecificFunctionDeclaration(this, outputType);
	}

	public ISpecificFunctionDeclaration createFunctionDeclaration(Iterator inputTypes) {
		ISpecificType specificTypeA = getNextSpecificType(inputTypes);
		ISpecificType specificTypeB = getNextSpecificType(inputTypes);

		if ((specificTypeA == null) || (specificTypeB == null) || inputTypes.hasNext())
			return null;

		if (!BooleanType.getInstance().equals(specificTypeA))
			return null;
		else
			return createFunctionDeclaration(specificTypeB);
	}

	public String getSignatureWithoutNameAndOutputType(ISpecificType outputType) {
		return "(Boolean, " + outputType.getName() + ")";
	}

	public boolean canCreateFunctionDeclarationWith(ISpecificType outputType) {
		return true;
	}

}