package de.uniwue.ki.mas.basics.action.simulation;

import junit.framework.Assert;
import de.uniwue.ki.mas.basics.action.AbstractFunctionActionDeclaration;
import de.uniwue.ki.mas.basics.action.FunctionActionFactory;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.type.*;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Creation date: 11.09.2002, 12:53:25
 * @author oechslein
 */
final class FunctionActionDeclarationCreateObjectAndRemember extends AbstractFunctionActionDeclaration {

	public FunctionActionDeclarationCreateObjectAndRemember() {
		super(
			FunctionActionCreateObjectAndRemember.NAME,
			CollectionsHelper.createList(
				ObjectInstanceDeclarationType.getInstance(),
				GenericFunctionType.getInstance().createSpecificFunctionType(
					VoidType.getInstance(),
					CollectionsHelper.createList(GenericSimObjectType.getGeneralSimObjectType()))));

		setDocumentation(
			"Creates a new object of object class (Arg1)"
				+ " and a function (Arg2) to change given standard values of new object");
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions) {

		Assert.assertEquals(2, functions.size());

		IFunction functionObjectInstanceClassDeclaration = (IFunction) functions.get(0);
		IFunction functionFunctionBodyDeclaration = (IFunction) functions.get(1);

		if (FunctionActionFactory.isNoopFunction(functionFunctionBodyDeclaration))
			return new FunctionActionCreateObject(functionObjectInstanceClassDeclaration);
		else
			return new FunctionActionCreateObjectAndRemember(
				functionObjectInstanceClassDeclaration,
				functionFunctionBodyDeclaration);
	}
}
