package de.uniwue.ki.mas.basics.action.simulation;

import junit.framework.Assert;
import de.uniwue.ki.mas.basics.action.AbstractFunctionActionDeclaration;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.type.GenericSimObjectType;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Creation date: 11.09.2002, 12:53:25
 * @author oechslein
 */
final class FunctionActionDeclarationKillObject extends AbstractFunctionActionDeclaration {

	public FunctionActionDeclarationKillObject() {
		super("Kill", CollectionsHelper.createList(GenericSimObjectType.getGeneralSimObjectType()), true);

		setDocumentation("Kills an object so that it won't do any more actions and after ist 'IsDead' returns 'true'");
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions) {
		if (Assert.ASSERTION_ON)
			Assert.assertEquals(1, functions.size());
		return new FunctionActionKill(functions.getFunction(0));
	}
}
