package de.uniwue.ki.mas.basics.action.simulation;
import de.uniwue.ki.mas.basics.action.AbstractFunctionAction;
import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.model.SimulationRuntimeException;
import de.uniwue.ki.mas.sim.simulation.*;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Chripauseh Oechslein
 */

final class FunctionActionPause extends AbstractFunctionAction implements IFunction {
    private static final FunctionActionPause _instance = new FunctionActionPause();
    static final String NAME = "Pause";

    private FunctionActionPause() {
        super();
    }


/**
 * @param executeFunctionArgs IExecuteFunctionArgs
 * @throws SimulationRuntimeException
 * @see de.uniwue.ki.mas.basics.function.IFunction#act(IExecuteFunctionArgs)
 */
public void act(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
    ISimulationExecuteFunctionArgs simulationExecuteFunctionArgs = (ISimulationExecuteFunctionArgs) executeFunctionArgs;

    ISimulation sim = simulationExecuteFunctionArgs.getSimulation();

    if (sim instanceof IThreadedSimulation)
         ((IThreadedSimulation) sim).pauseInThread();
}


    /**
     * @return FunctionActionPause
     */
    public static final FunctionActionPause getInstance() {
        return _instance;
    }


    /**
     * @return String
     * @see de.uniwue.ki.util.INamed#getName()
     */
    public String getName() {
        return NAME;
    }
}