package de.uniwue.ki.mas.basics.action.simulation;
import de.uniwue.ki.mas.basics.functionDeclaration.ISpecificFunctionDeclaration;
import de.uniwue.ki.mas.basics.functionDeclaration.list.FunctionDeclarationList;
import de.uniwue.ki.mas.basics.functionDeclaration.list.IFunctionDeclarationList;

/**
 * Creation date: (30.07.2001 14:42:36)
 * @author Christoph Oechslein
 */

public class FunctionActionSimulationDeclarationFactory {

	public static final ISpecificFunctionDeclaration CREATE_OBJECT_FUN_DECL =
		new FunctionActionDeclarationCreateObject();

	private static final IFunctionDeclarationList _cachedFunctionDeclarationList =
		new FunctionDeclarationList();

	static {
		// Kill
		_cachedFunctionDeclarationList.add(new FunctionActionDeclarationKillObject());

		// pause
		_cachedFunctionDeclarationList.add(new FunctionActionDeclarationPause());

		// createObject(object)
		_cachedFunctionDeclarationList.add(CREATE_OBJECT_FUN_DECL);

		// CreateAndRemember(object, Void function(BodyImageType) )
		_cachedFunctionDeclarationList.add(new FunctionActionDeclarationCreateObjectAndRemember());
	}

	/**
	 * @param functionDeclarationList IFunctionDeclarationList
	 */
	public static void insertFunctions(IFunctionDeclarationList functionDeclarationList) {
		functionDeclarationList.addAll(_cachedFunctionDeclarationList);
	}
}