package de.uniwue.ki.mas.basics.action.simulation;

import de.uniwue.ki.mas.basics.action.AbstractFunctionAction;
import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.model.SimulationRuntimeException;
import de.uniwue.ki.mas.sim.simulation.ISimulationExecuteFunctionArgs;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

public final class FunctionActionSuicide extends AbstractFunctionAction implements IFunction {
	private static final FunctionActionSuicide _instance = new FunctionActionSuicide();

	public static final FunctionActionSuicide getInstance() {
		return _instance;
	}

	public void act(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
		ISimulationExecuteFunctionArgs simulationExecuteFunctionArgs =
			(ISimulationExecuteFunctionArgs) executeFunctionArgs;

		simulationExecuteFunctionArgs.getSimulation().getSituation().getWorld().removeObjectInSimulation(
			simulationExecuteFunctionArgs.getObject(),
			simulationExecuteFunctionArgs);
	}

	protected FunctionActionSuicide() {
		super();
	}

	public String getName() {
		return "Suicide";
	}
}
