package de.uniwue.ki.mas.basics.feature;
import java.util.Iterator;

import de.uniwue.ki.mas.entity.objectclass.IObjectClassDeclaration;
import de.uniwue.ki.mas.util.declaration.AbstractDocumentableDeclaration;
import de.uniwue.ki.util.collection.CollectionsHelper;
import de.uniwue.ki.util.hash.IIsomorphicHashable;

/**
 * Creation date: (22.10.2001 13:00:21)
 * @author Christoph Oechslein
 */

public abstract class AbstractFeatureClassDeclaration
	extends AbstractDocumentableDeclaration
	implements IFeatureClassDeclaration {

	public AbstractFeatureClassDeclaration() {
		this("Untitled Feature");
	}

	public AbstractFeatureClassDeclaration(String name) {
		super(name);
	}

	public boolean canAddFeatureClassDeclarationTo(IObjectClassDeclaration objectClassDeclaration) {
		return true;
	}

	public Iterator getDefaultFunctionDeclarations() {
		return CollectionsHelper.EMPTY_ITERATOR;
	}

	public boolean isDefaultFeatureClassDeclarationFor(IObjectClassDeclaration objectClassDeclaration) {
		return false;
	}

	public boolean isomorphicEquals(IIsomorphicHashable anObject) {
		return equals(anObject);
	}

	public int isomorphicHashCode() {
		return hashCode();
	}
}