package de.uniwue.ki.mas.basics.feature;

import java.util.Iterator;

import de.uniwue.ki.mas.basics.functionDeclaration.IFunctionDeclaration;
import de.uniwue.ki.mas.basics.type.BooleanType;
import de.uniwue.ki.mas.entity.object.IObjectInstanceDeclaration;
import de.uniwue.ki.mas.entity.objectclass.IObjectClassDeclaration;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Creation date: (22.10.2001 13:01:33)
 * @author Christoph Oechslein
 */

public abstract class AbstractFeaturePlusObjectFeatureClassDeclaration
	extends AbstractFeatureClassDeclaration
	implements IObjectFeatureClassDeclaration {

	public AbstractFeaturePlusObjectFeatureClassDeclaration() {
		super();
	}

	public AbstractFeaturePlusObjectFeatureClassDeclaration(String name) {
		super(name);
	}

	public IObjectFeatureClassDeclaration createObjectFeatureClassDeclaration(IObjectClassDeclaration objectClassDeclaration) {
		return this;
	}

	public IObjectFeatureInstanceDeclaration createObjectFeatureInstanceDeclaration(IObjectInstanceDeclaration objectInstanceDeclaration) {
		return null;
	}

	public IFeatureClassDeclaration getFeatureClassDeclaration() {
		return this;
	}
	
	public String createHTMLDocu() {
		String ret = "";
		Iterator it = CollectionsHelper.concatenate(getDefaultFunctionDeclarations(),getFunctionDeclarations());
		while (it.hasNext()) {
			IFunctionDeclaration element = (IFunctionDeclaration)it.next();
			ret += element.getName()
				+ element.getSignatureWithoutNameAndOutputType(BooleanType.getInstance())
				+ "\t\t"
				+ element.getDocumentation()
				+ "\n";
		}
		return ret;
	}
	
	public String createHTMLDocu2() {
			String ret = "<html><head><title>"+getName()+"</title></head><body><font face=\"Arial, Helvetica, sans-serif\"><h3>"+getName()+"</h3><br>";
			ret += getDocumentation()+"<br>";
			Iterator it = CollectionsHelper.concatenate(getDefaultFunctionDeclarations(),getFunctionDeclarations());
			while (it.hasNext()) {
				IFunctionDeclaration element = (IFunctionDeclaration)it.next();
				ret += "<b><i>"+element.getName()
					+ element.getSignatureWithoutNameAndOutputType(BooleanType.getInstance())+"</i></b><br>"
					+ element.getDocumentation()
					+ "<br><br>";
			}
			ret += "</body></html>";
			return ret;
		}
}