package de.uniwue.ki.mas.basics.feature;

import de.uniwue.ki.mas.util.declaration.AbstractDeclaration;
import de.uniwue.ki.util.hash.IIsomorphicHashable;

/**
 * Creation date: (22.10.2001 13:03:26)
 * @author Christoph Oechslein
 */

public abstract class AbstractObjectFeatureInstanceDeclaration
	extends AbstractDeclaration
	implements IObjectFeatureInstanceDeclaration {

	private final IObjectFeatureClassDeclaration _objectFeatureClassDeclaration;

	public AbstractObjectFeatureInstanceDeclaration(IObjectFeatureClassDeclaration objectFeatureClassDeclaration) {
		super();

		_objectFeatureClassDeclaration = objectFeatureClassDeclaration;
	}

	public final String getName() {
		return getName(getObjectFeatureClassDeclaration());
	}

	public IObjectFeatureClassDeclaration getObjectFeatureClassDeclaration() {
		return _objectFeatureClassDeclaration;
	}

	public boolean isomorphicEquals(IIsomorphicHashable anObject) {
		return equals(anObject);
	}

	public int isomorphicHashCode() {
		return hashCode();
	}
}