package de.uniwue.ki.mas.basics.feature;
import java.io.Serializable;

import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.model.SimulationRuntimeException;
import de.uniwue.ki.util.IRemoveable;
import de.uniwue.ki.util.name.INamed;

/**
 * An object has many features, for example a world could have a spatial map as feature.
 * Creation date: (07.12.2000 11:04:23)
 *
 * @author Christoph Oechslein
 */

public interface IObjectFeature extends IRemoveable, Serializable, INamed {

	/**
	 * Resets the body to default values.
	 */
	void reset(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException;

	/**
	 * Updates this feature under the given executing bindings.
	 */
	void update(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException;
}