package de.uniwue.ki.mas.basics.feature.evolution;
import java.io.Serializable;

import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.entity.object.IObject;
import de.uniwue.ki.mas.entity.object.IObjectExecuteFunctionArgs;
import de.uniwue.ki.mas.model.SimulationRuntimeException;
import de.uniwue.ki.util.math.RandomHelper;
/**
 * Creation date: 04.12.2002, 01:46:35
 * @author oechslein
 */
class BitStringInheritHelper implements Serializable {
	public static void inherit(IObjectExecuteFunctionArgs executeFunctionArgs, IObject parent, IObject child)
		throws SimulationRuntimeException {

		BitStringEvolutionObjectFeature parentBitStringEvolutionObjectFeature =
			getBitStringEvolutionObjectFeature(executeFunctionArgs, parent);
		BitStringEvolutionObjectFeature childBitStringEvolutionObjectFeature =
			getBitStringEvolutionObjectFeature(executeFunctionArgs, child);

		BitString parentBitString1 = parentBitStringEvolutionObjectFeature.getBitString();
		if (parentBitString1.getLength()
			!= childBitStringEvolutionObjectFeature.getBitString().getLength()) {
			throw new SimulationRuntimeException(
				"Child '"
					+ child.getName()
					+ "' can not inherit genes from '"
					+ parent
					+ "' since amount of genes differs.");
		}

		if (parentBitStringEvolutionObjectFeature instanceof DiploidBitStringEvolutionObjectFeature) {
			DiploidBitStringEvolutionObjectFeature parentDiploidBitStringEvolutionObjectFeature =
				(DiploidBitStringEvolutionObjectFeature) parentBitStringEvolutionObjectFeature;

			if (childBitStringEvolutionObjectFeature instanceof DiploidBitStringEvolutionObjectFeature) {

				DiploidBitStringEvolutionObjectFeature childDiploidBitStringEvolutionObjectFeature =
					(DiploidBitStringEvolutionObjectFeature) childBitStringEvolutionObjectFeature;

				BitString parentBitString2 = parentDiploidBitStringEvolutionObjectFeature.getBitString2();

				if (RandomHelper.getRandomBoolean())
					childDiploidBitStringEvolutionObjectFeature.setBitStrings(
						parentBitString1,
						parentBitString2);
				else
					childDiploidBitStringEvolutionObjectFeature.setBitStrings(
						parentBitString2,
						parentBitString1);

			} else {
				parentDiploidBitStringEvolutionObjectFeature.setToDominantBitString(
					childBitStringEvolutionObjectFeature.getBitString());
			}

		} else {
			childBitStringEvolutionObjectFeature.setBitString(parentBitString1);

			if (childBitStringEvolutionObjectFeature instanceof DiploidBitStringEvolutionObjectFeature) {
				DiploidBitStringEvolutionObjectFeature childDiploidBitStringEvolutionObjectFeature =
					(DiploidBitStringEvolutionObjectFeature) childBitStringEvolutionObjectFeature;

				childDiploidBitStringEvolutionObjectFeature.setBitString2(parentBitString1);
			}
		}

		childBitStringEvolutionObjectFeature.writeBitStringToVariables(executeFunctionArgs, child);
	}

	private static BitStringEvolutionObjectFeature getBitStringEvolutionObjectFeature(
		IExecuteFunctionArgs executeFunctionArgs,
		IObject parent)
		throws SimulationRuntimeException {

		IBitStringEvolutionObjectFeature parentBitStringEvolutionObjectFeature =
			CrossoverFunction.getBitStringEvolutionObjectFeature(executeFunctionArgs, parent);

		if (parentBitStringEvolutionObjectFeature instanceof ChangeableBitStringEvolutionObjectFeature) {
			return ((ChangeableBitStringEvolutionObjectFeature) parentBitStringEvolutionObjectFeature)
				.getCurrentBitStringEvolutionObjectFeature();

		} else {
			return (BitStringEvolutionObjectFeature) parentBitStringEvolutionObjectFeature;
		}
	}
}