package de.uniwue.ki.mas.basics.feature.evolution;
import java.io.Serializable;

import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.entity.object.IObject;
import de.uniwue.ki.mas.entity.object.IObjectExecuteFunctionArgs;
import de.uniwue.ki.mas.model.SimulationRuntimeException;
/**
 * Creation date: 29.02.2004, 
 * @author kluegl
 */
class BitStringSetGenesHelper implements Serializable {
	
	public static void resetGenes(IObjectExecuteFunctionArgs executeFunctionArgs, IObject agent)
		throws SimulationRuntimeException {

		BitStringEvolutionObjectFeature agentBitStringEvolutionObjectFeature =
			getBitStringEvolutionObjectFeature(executeFunctionArgs, agent);

		agentBitStringEvolutionObjectFeature.writeVariablesToBitString(agent);
	}

	private static BitStringEvolutionObjectFeature getBitStringEvolutionObjectFeature(
		IExecuteFunctionArgs executeFunctionArgs,
		IObject parent)
		throws SimulationRuntimeException {

		IBitStringEvolutionObjectFeature parentBitStringEvolutionObjectFeature =
			CrossoverFunction.getBitStringEvolutionObjectFeature(executeFunctionArgs, parent);

		if (parentBitStringEvolutionObjectFeature instanceof ChangeableBitStringEvolutionObjectFeature) {
			return ((ChangeableBitStringEvolutionObjectFeature) parentBitStringEvolutionObjectFeature)
				.getCurrentBitStringEvolutionObjectFeature();

		} else {
			return (BitStringEvolutionObjectFeature) parentBitStringEvolutionObjectFeature;
		}
	}
}