package de.uniwue.ki.mas.basics.feature.evolution;
import java.util.Map;

import junit.framework.Assert;

import de.uniwue.ki.mas.basics.feature.*;
import de.uniwue.ki.mas.entity.object.IObjectCreateFunctionArgs;
import de.uniwue.ki.util.copy.ICopyable;
/**
 * Insert the type's description here.
 * Creation date: (20.02.2002 14:38:10)
 * @author Christoph Oechslein
 */
final class EvolutionObjectFeatureInstanceDeclaration
	extends AbstractObjectFeatureInstanceDeclaration
	implements IObjectFeatureInstanceDeclaration {

	public EvolutionObjectFeatureInstanceDeclaration(EvolutionObjectFeatureClassDeclaration evolutionObjectFeatureClassDeclaration) {
		super(evolutionObjectFeatureClassDeclaration);
	}

	public ICopyable copy(Map objectMapping) {
		if ((objectMapping != null)
			&& (objectMapping.containsKey(getEvolutionObjectFeatureClassDeclaration()))) {
			return new EvolutionObjectFeatureInstanceDeclaration(
				(EvolutionObjectFeatureClassDeclaration) objectMapping.get(
					getEvolutionObjectFeatureClassDeclaration()));

		} else {
			return new EvolutionObjectFeatureInstanceDeclaration(getEvolutionObjectFeatureClassDeclaration());
		}
	}

	public void copyInto(Object intoObject, Map objectMapping) {
		if (intoObject == this)
			return;

		super.copyInto(intoObject, objectMapping);

		EvolutionObjectFeatureInstanceDeclaration evolutionObjectFeatureInstanceDeclaration =
			(EvolutionObjectFeatureInstanceDeclaration) intoObject;

		Assert.assertEquals(
			getEvolutionObjectFeatureClassDeclaration(),
			evolutionObjectFeatureInstanceDeclaration.getEvolutionObjectFeatureClassDeclaration());
	}

	/**
	 * Compiles for an runtime instance of an IFeatureDeclaration,
	 * can produce null if no instance specific runtime information is required
	 *
	 * @param createObjectFunctionArgs IObjectCreateFunctionArgs
	 * @return IObjectFeature
	 * @see de.uniwue.ki.mas.basics.feature.IObjectFeatureInstanceDeclaration#createObjectFeature(IObjectCreateFunctionArgs)
	 */
	public IObjectFeature createObjectFeature(IObjectCreateFunctionArgs createObjectFunctionArgs) {
		return new ChangeableBitStringEvolutionObjectFeature(
		getEvolutionObjectFeatureClassDeclaration().isDiploid(),
		getEvolutionObjectFeatureClassDeclaration().getDominantType(),
			getBitStringEvolutionObjectFeatureHelper(createObjectFunctionArgs));
	}

	private BitStringEvolutionObjectFeatureHelper getBitStringEvolutionObjectFeatureHelper(IObjectCreateFunctionArgs createObjectFunctionArgs) {
		if (createObjectFunctionArgs
			.existsCompilationObject(getEvolutionObjectFeatureClassDeclaration(), false)) {
			return (BitStringEvolutionObjectFeatureHelper) createObjectFunctionArgs.getCompilationObject(
				getEvolutionObjectFeatureClassDeclaration(),
				false);

		} else {
			BitStringEvolutionObjectFeatureHelper bitStringEvolutionObjectFeatureHelper =
				new BitStringEvolutionObjectFeatureHelper(
					getEvolutionObjectFeatureClassDeclaration().createEvoEntryArray());

			createObjectFunctionArgs.addCompilationObject(
				getEvolutionObjectFeatureClassDeclaration(),
				bitStringEvolutionObjectFeatureHelper,
				false);

			return bitStringEvolutionObjectFeatureHelper;
		}
	}

	public final EvolutionObjectFeatureClassDeclaration getEvolutionObjectFeatureClassDeclaration() {
		return (EvolutionObjectFeatureClassDeclaration) getObjectFeatureClassDeclaration();
	}
}