package de.uniwue.ki.mas.basics.feature.evolution;

import de.uniwue.ki.mas.basics.action.AbstractFunctionActionDeclaration;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.type.GenericSimObjectType;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Insert the class' description here.
 * Creation date: (04.09.2001 13:15:18)
 * @author Christoph Oechslein
 */

final class InheritSpecificFunctionDeclaration extends AbstractFunctionActionDeclaration {

	public InheritSpecificFunctionDeclaration(boolean hasEvolutionFeature) {
		super(
			"Inherit",
			hasEvolutionFeature
				? CollectionsHelper.createList(GenericSimObjectType.getGeneralSimObjectType())
				: CollectionsHelper.createList(
					GenericSimObjectType.getGeneralSimObjectType(),
					GenericSimObjectType.getGeneralSimObjectType()),
			!hasEvolutionFeature);

		if (hasEvolutionFeature)
			setDocumentation("Inherits all gene values to the given child.");
		else
			setDocumentation("Inherits all gene values from the parent (Arg1) to the given child (Arg2).");
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions)
		throws ModelCompilingException {

		if (getSpecificInputDefaultArgsLength() == 1)
			return new InheritFunction(functions.getFunction(0));
		else
			return new InheritFunction(functions.getFunction(0), functions.getFunction(1));
	}

	public String getSpecificInputTypeNameAt(int index) {
		if (getSpecificInputDefaultArgsLength() == 1)
			return "child";
		else if (index == 0)
			return "parent";
		else
			return "child";
	}
}