package de.uniwue.ki.mas.basics.feature.evolution;
import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.basics.function.bool.AbstractBooleanFunction;
import de.uniwue.ki.mas.entity.object.IObject;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Insert the class' description here.
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class IsDiploidFunction extends AbstractBooleanFunction implements IFunction {
	private final IFunction _objectFunction;

	public IsDiploidFunction(IFunction objectFunction) {
		super();
		_objectFunction = objectFunction;
	}

	//	public Object execute(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
	//		return new Boolean(executeForBoolean(executeFunctionArgs));
	//	}

	public boolean executeForBoolean(IExecuteFunctionArgs executeFunctionArgs)
		throws SimulationRuntimeException {

		IObject objectToTest = (IObject) _objectFunction.execute(executeFunctionArgs);

		BitStringEvolutionObjectFeature objectBitStringEvolutionObjectFeature =
			getBitStringEvolutionObjectFeature(executeFunctionArgs, objectToTest);

		return (objectBitStringEvolutionObjectFeature instanceof DiploidBitStringEvolutionObjectFeature);
	}

	private static BitStringEvolutionObjectFeature getBitStringEvolutionObjectFeature(
		IExecuteFunctionArgs executeFunctionArgs,
		IObject parent)
		throws SimulationRuntimeException {

		IBitStringEvolutionObjectFeature parentBitStringEvolutionObjectFeature =
			CrossoverFunction.getBitStringEvolutionObjectFeature(executeFunctionArgs, parent);

		if (parentBitStringEvolutionObjectFeature instanceof ChangeableBitStringEvolutionObjectFeature) {
			return ((ChangeableBitStringEvolutionObjectFeature) parentBitStringEvolutionObjectFeature)
				.getCurrentBitStringEvolutionObjectFeature();

		} else {
			return (BitStringEvolutionObjectFeature) parentBitStringEvolutionObjectFeature;
		}
	}

	public String getName() {
		return "IsDiploid(" + _objectFunction.getName() + ")";
	}
}