package de.uniwue.ki.mas.basics.feature.evolution;

import junit.framework.Assert;

import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionArgsDeclaration;
import de.uniwue.ki.mas.basics.type.BooleanType;
import de.uniwue.ki.mas.basics.type.GenericSimObjectType;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Creation date: (04.09.2001 13:15:18)
 * @author Christoph Oechslein
 */

final class IsDiploidSpecificFunctionDeclaration extends AbstractSpecificFunctionArgsDeclaration {

	public IsDiploidSpecificFunctionDeclaration(boolean hasEvolutionFeature) {
		super(
			"IsDiploid",
			BooleanType.getInstance(),
			CollectionsHelper.createList(GenericSimObjectType.getGeneralSimObjectType()),
			true); 

		setDocumentation("returns true if the given SimObject has diploid settings.");
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions)
		throws ModelCompilingException {

		if (Assert.ASSERTION_ON)
			Assert.assertEquals(1, functions.size());

		return new IsDiploidFunction(functions.getFunction(0));
	}
}