package de.uniwue.ki.mas.basics.feature.evolution;
import de.uniwue.ki.mas.basics.action.AbstractFunctionActionDeclaration;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.type.GenericSimObjectType;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Insert the class' description here.
 * Creation date: (13.11.2003 13:15:18)
 * @author Franziska Kluegl
 */

final class MeltingSpecificFunctionDeclaration extends AbstractFunctionActionDeclaration {

	public MeltingSpecificFunctionDeclaration(boolean hasEvolutionFeature) {
		super(
			"Melt",
			hasEvolutionFeature
				? CollectionsHelper.createList(
					GenericSimObjectType.getGeneralSimObjectType(),
					GenericSimObjectType.getGeneralSimObjectType())
				: CollectionsHelper.createList(
					GenericSimObjectType.getGeneralSimObjectType(),
					GenericSimObjectType.getGeneralSimObjectType(),
					GenericSimObjectType.getGeneralSimObjectType()),
			!hasEvolutionFeature);

		if (hasEvolutionFeature)
			setDocumentation(
				"Creates diploid gen from melting the two genstrings from "
					+ "my genes and the parent2 (Arg1) genes and sets it to the child (Arg2).");
		else
			setDocumentation("Melts parent1 (Arg1) genes with the parent2 (Arg2) genes to the child (Arg3).");
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions)
		throws ModelCompilingException {

		if (getSpecificInputDefaultArgsLength() == 2)
			return new MeltingFunction(functions.getFunction(0), functions.getFunction(1));
		else
			return new MeltingFunction(
				functions.getFunction(0),
				functions.getFunction(1),
				functions.getFunction(2));
	}

	public String getSpecificInputTypeNameAt(int index) {
		if (getSpecificInputDefaultArgsLength() == 2) {
			if (index == 0)
				return "parent2";
			else
				return "child";
		} else {
			if (index == 0)
				return "parent1";
			else if (index == 1)
				return "parent2";
			else
				return "child";
		}
	}
}