package de.uniwue.ki.mas.basics.feature.evolution;
import de.uniwue.ki.mas.basics.action.AbstractFunctionAction;
import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.entity.object.IObject;
import de.uniwue.ki.mas.entity.object.IObjectExecuteFunctionArgs;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Insert the class' description here.
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class MutateAllFunction extends AbstractFunctionAction {
	private final IFunction _probFunction;
	private final IFunction _child;

	public MutateAllFunction(IFunction child, IFunction probFunction) {
		super();

		_child = child;
		_probFunction = probFunction;
	}

	public void act(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {

		IObjectExecuteFunctionArgs objectExecuteFunctionArgs =
			(IObjectExecuteFunctionArgs) executeFunctionArgs;

		IObject objectToMutate = (IObject) _child.execute(executeFunctionArgs);

		if (objectToMutate == null)
			throw new SimulationRuntimeException("Object in " + getName() + " is null.");

		IBitStringEvolutionObjectFeature evolutionObjectFeature =
			CrossoverFunction.getBitStringEvolutionObjectFeature(executeFunctionArgs, objectToMutate);

		evolutionObjectFeature.mutateAll(
			objectExecuteFunctionArgs,
			objectToMutate,
			_probFunction.executeForDouble(executeFunctionArgs));
	}

	public String getName() {
		return "MutateAll(" + _child.getName() + ", " + _probFunction.getName() + ")";
	}
}