package de.uniwue.ki.mas.basics.feature.evolution;
import junit.framework.Assert;

import de.uniwue.ki.mas.basics.action.AbstractFunctionActionDeclaration;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.type.DoubleType;
import de.uniwue.ki.mas.basics.type.GenericSimObjectType;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Insert the class' description here.
 * Creation date: (04.09.2001 13:15:18)
 * @author Christoph Oechslein
 */

final class MutateAllSpecificFunctionDeclaration extends AbstractFunctionActionDeclaration {

	public MutateAllSpecificFunctionDeclaration() {
		super(
			"MutateAll",
			CollectionsHelper.createList(
				GenericSimObjectType.getGeneralSimObjectType(),
				DoubleType.getInstance()));

		setDocumentation("Mutates all genes of Arg1 with the given probability (Arg2).");
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions)
		throws ModelCompilingException {

		if (Assert.ASSERTION_ON)
			Assert.assertEquals(2, functions.size());

		return new MutateAllFunction(functions.getFunction(0), functions.getFunction(1));
	}

	public String getSpecificInputTypeNameAt(int index) {
		if (index == 0)
			return "child";
		else
			return "prob";
	}
}