package de.uniwue.ki.mas.basics.feature.evolution;
import de.uniwue.ki.mas.basics.action.AbstractFunctionAction;
import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.entity.object.IObject;
import de.uniwue.ki.mas.entity.object.IObjectExecuteFunctionArgs;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Insert the class' description here.
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class SetDiploidFunction extends AbstractFunctionAction {
	private final IFunction _diploidFunction;
	private final IFunction _objectFunction;

	public SetDiploidFunction(IFunction objectFunction, IFunction diploidFunction) {
		super();

		_objectFunction = objectFunction;
		_diploidFunction = diploidFunction;
	}

	public void act(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {

		IObject objectToMutate = (IObject) _objectFunction.execute(executeFunctionArgs);

		ChangeableBitStringEvolutionObjectFeature evolutionObjectFeature =
			(ChangeableBitStringEvolutionObjectFeature) CrossoverFunction.getBitStringEvolutionObjectFeature(
				executeFunctionArgs,
				objectToMutate);

		evolutionObjectFeature.setDiploid(
			(IObjectExecuteFunctionArgs) executeFunctionArgs,
			objectToMutate,
			_diploidFunction.executeForBoolean(executeFunctionArgs));
	}

	public String getName() {
		return "SetDiploid(" + _objectFunction.getName() + ", " + _diploidFunction.getName() + ")";
	}
}