package de.uniwue.ki.mas.basics.feature.evolution;

import junit.framework.Assert;

import de.uniwue.ki.mas.basics.action.AbstractFunctionActionDeclaration;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.type.BooleanType;
import de.uniwue.ki.mas.basics.type.GenericSimObjectType;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Insert the class' description here.
 * Creation date: (04.09.2001 13:15:18)
 * @author Christoph Oechslein
 */

final class SetDiploidSpecificFunctionDeclaration extends AbstractFunctionActionDeclaration {

	public SetDiploidSpecificFunctionDeclaration() {
		super(
			"SetDiploid",
			CollectionsHelper.createList(GenericSimObjectType.getGeneralSimObjectType(), BooleanType.getInstance()));

		setDocumentation("Changes the diploid settings.");
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions)
		throws ModelCompilingException {

		if (Assert.ASSERTION_ON)
			Assert.assertEquals(2, functions.size());

		return new SetDiploidFunction(functions.getFunction(0), functions.getFunction(1));
	}
}