package de.uniwue.ki.mas.basics.feature.evolution;

import de.uniwue.ki.mas.basics.action.AbstractFunctionAction;
import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.entity.object.IObject;
import de.uniwue.ki.mas.entity.object.IObjectExecuteFunctionArgs;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Insert the class' description here.
 * Creation date: 29.02.2004,
 * @author kluegl
 */

final class SetGeneValueFunction extends AbstractFunctionAction {
	private final IFunction _agentFunction;

	public SetGeneValueFunction(IFunction agentFunction) {
		super();
		_agentFunction= agentFunction;
	}

	public void act(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {

		IObjectExecuteFunctionArgs objectExecuteFunctionArgs =
			(IObjectExecuteFunctionArgs) executeFunctionArgs;

		IObject agent;

		if (_agentFunction == null) {
			agent = objectExecuteFunctionArgs.getObject();

		} else {
			agent = (IObject) _agentFunction.execute(executeFunctionArgs);

			if (agent == null)
				throw new SimulationRuntimeException("Agent in " + getName() + " is null.");
		}

		BitStringSetGenesHelper.resetGenes(objectExecuteFunctionArgs, agent);
	}


	public String getName() {
		return "ResetGenes(" + _agentFunction.getName() + ")";
	}

}