package de.uniwue.ki.mas.basics.feature.evolution;

import de.uniwue.ki.mas.basics.action.AbstractFunctionActionDeclaration;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.type.GenericSimObjectType;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Insert the class' description here.
 *Creation date: 29.02.2004,
 * @author kluegl
 */
final class SetGeneValueSpecificFunctionDeclaration extends AbstractFunctionActionDeclaration {

	public SetGeneValueSpecificFunctionDeclaration(boolean hasEvolutionFeature) {
		super(
			"ResetGeneValue",
			CollectionsHelper.createList(
				GenericSimObjectType.getGeneralSimObjectType()));
		setDocumentation("Newly sets the genes of the given individual (arg1) to the variable values");
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions)
		throws ModelCompilingException {
		return new SetGeneValueFunction(functions.getFunction(0));
	}
	


	public String getSpecificInputTypeNameAt(int index) {
			return "agent";
	}
}