package de.uniwue.ki.mas.basics.feature.focus;
import java.util.Iterator;
import java.util.Map;

import de.uniwue.ki.mas.basics.feature.*;
import de.uniwue.ki.mas.basics.feature.IObjectFeatureInstanceDeclaration;
import de.uniwue.ki.mas.basics.functionDeclaration.list.FunctionDeclarationList;
import de.uniwue.ki.mas.basics.functionDeclaration.list.IFunctionDeclarationList;
import de.uniwue.ki.mas.entity.object.IObjectCreateFunctionArgs;
import de.uniwue.ki.mas.entity.object.IObjectInstanceDeclaration;
import de.uniwue.ki.util.collection.CollectionsHelper;
import de.uniwue.ki.util.copy.ICopyable;

public final class FocusFeatureClassDeclaration extends AbstractFeaturePlusAllDeclaration {

	private static final FocusFeatureClassDeclaration _instance = new FocusFeatureClassDeclaration();
	private IFunctionDeclarationList _functionDeclarationList;

	private FocusFeatureClassDeclaration() {
		super("Focus");
	}
	
	public IObjectFeature createObjectFeature(IObjectCreateFunctionArgs createObjectFunctionArgs) {
		return new FocusObjectFeature();
	}
	
	public ICopyable copy(Map objectMapping) {
		return this;
	}
	
	public void copyInto(Object dstObject, Map objectMapping) {
	}

	public static final FocusFeatureClassDeclaration getInstance() {
		return _instance;
	}

	public IObjectFeatureInstanceDeclaration createObjectFeatureInstanceDeclaration(IObjectInstanceDeclaration objectInstanceDeclaration) {
		return null;
	}

	public Iterator getFunctionDeclarations() {
		if (_functionDeclarationList == null) {
			_functionDeclarationList = new FunctionDeclarationList();
			_functionDeclarationList.add(new FocusObjectFunctionDeclaration());
			_functionDeclarationList.add(new GetFocusObjectFunctionDeclaration());
		}
		return _functionDeclarationList.iterator();
	}

	public Iterator getVariableClassDeclarations() {
		return CollectionsHelper.EMPTY_ITERATOR;
	}
}