package de.uniwue.ki.mas.basics.feature.focus;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import de.uniwue.ki.mas.basics.feature.AbstractObjectFeature;
import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.entity.object.IObject;
import de.uniwue.ki.mas.model.SimulationRuntimeException;
import de.uniwue.ki.mas.util.declaration.IDeclaration;
import de.uniwue.ki.util.event.StateChangeMulticaster;
/**
 * Creation date: (19.11.2001 19:05:08)
 * @author Christoph Oechslein
 */
final class FocusObjectFeature extends AbstractObjectFeature {
	private IObject _fokusedObject;
	private transient ChangeListener _changeListener = null;
	
	public FocusObjectFeature() {
		super();
	}
	
	public void addChangeListener(ChangeListener newListener) {
		_changeListener = StateChangeMulticaster.add(_changeListener, newListener);
	}

	public void remove() {
		setFocusedObject(null);
		super.remove();
	}

	public void reset(IExecuteFunctionArgs executeFunctionArgs)
		throws SimulationRuntimeException {
			setFocusedObject(null);
	}

	public final String getName() {
		return "focus " + ((getFocusedObject() == null) ? null : getFocusedObject().getName());
	}

	void setFocusedObject(IObject _object) {
		if (_changeListener!=null) _changeListener.stateChanged(new ChangeEvent(this));
		this._fokusedObject = _object;
	}

	IObject getFocusedObject() {
		return _fokusedObject;
	}
}