package de.uniwue.ki.mas.basics.feature.focus;
import de.uniwue.ki.mas.basics.action.AbstractFunctionAction;
import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.entity.object.IObject;
import de.uniwue.ki.mas.entity.object.agent.IAgentExecuteFunctionArgs;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (19.11.2001 19:06:45)
 * @author Christoph Oechslein
 */
final class FocusObjectFunctionAction extends AbstractFunctionAction {
	static String NAME = "Focus Body";
	private final IFunction _bodyFunction;

	public FocusObjectFunctionAction(IFunction bodyFunction) {
		super();

		_bodyFunction = bodyFunction;
	}

	public void act(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
		((FocusObjectFeature)(getObject(executeFunctionArgs).getObjectFeature(FocusObjectFeature.class))).setFocusedObject(
			(IObject) _bodyFunction.execute(executeFunctionArgs));
	}

	public String getName() {
		return NAME;
	}

	private IObject getObject(IExecuteFunctionArgs executeFunctionArgs) {
		return ((IAgentExecuteFunctionArgs) executeFunctionArgs).getObject();
	}
}