package de.uniwue.ki.mas.basics.feature.focus;

import junit.framework.Assert;
import de.uniwue.ki.mas.basics.action.AbstractFunctionActionDeclaration;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.type.GenericSimObjectType;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.util.collection.CollectionsHelper;

public class FocusObjectFunctionDeclaration extends AbstractFunctionActionDeclaration {
	public FocusObjectFunctionDeclaration() {
		super(
			FocusObjectFunctionAction.NAME,
			CollectionsHelper.createList(GenericSimObjectType.getGeneralSimObjectType()));
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions)
		throws ModelCompilingException {
		if (Assert.ASSERTION_ON)
			Assert.assertEquals(1, functions.size());
		return new FocusObjectFunctionAction(functions.getFunction(0));
	}

	public String getDocumentation() {
		return "Put an object into the focus";
	}

}
