package de.uniwue.ki.mas.basics.feature.focus;
import de.uniwue.ki.mas.basics.function.AbstractFunction;
import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.entity.object.IObject;
import de.uniwue.ki.mas.entity.object.agent.IAgentExecuteFunctionArgs;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

final class GetFocusObjectFunctionAction extends AbstractFunction {
	private static final GetFocusObjectFunctionAction _instance = new GetFocusObjectFunctionAction();
	static String NAME = "Focused Body";
	private GetFocusObjectFunctionAction() {
		super();
	}
	
	public Object execute(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
		IObject activeAgent = ((IAgentExecuteFunctionArgs)executeFunctionArgs).getObject();
		FocusObjectFeature feature = (FocusObjectFeature)activeAgent.getObjectFeature(FocusObjectFeature.class);
	
		return feature.getFocusedObject();
	}
	
	static final GetFocusObjectFunctionAction getInstance() {
		return _instance;
	}
	
	public String getName() {
		return NAME;
	}
	private IObject getObject(IExecuteFunctionArgs executeFunctionArgs) {
		return ((IAgentExecuteFunctionArgs) executeFunctionArgs).getObject();
	}
}