package de.uniwue.ki.mas.basics.feature.focus;

import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionArgsDeclaration;
import de.uniwue.ki.mas.basics.type.GenericSimObjectType;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.util.collection.CollectionsHelper;

public class GetFocusObjectFunctionDeclaration extends AbstractSpecificFunctionArgsDeclaration {
	public GetFocusObjectFunctionDeclaration() {
		super(
			GetFocusObjectFunctionAction.NAME,
			GenericSimObjectType.getGeneralSimObjectType(),
			CollectionsHelper.EMPTY_LIST,
			false);
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions)
		throws ModelCompilingException {
		Assert.assertEquals(0, functions.size());
		return GetFocusObjectFunctionAction.getInstance();
	}
	public String getDocumentation() {
		return "Returns the focused object";
	}

}
