package de.uniwue.ki.mas.basics.feature.spatial;
import java.awt.Image;
import java.awt.Shape;
import java.awt.geom.Point2D;
import java.io.File;
import java.io.Serializable;

import de.uniwue.ki.util.Position2D;
import de.uniwue.ki.util.copy.ICopyable;
import de.uniwue.ki.util.name.INamed;

/**
 * Creation date: (04.12.2000 20:06:57)
 * @author Christoph Oechslein
 */

public interface ISpatialInfo extends INamed, ICopyable, Serializable {

	/**
	  * Copies non immutable value (direction, radius, speed, position) to <code>spatialInfo</code>.
	  */
	void copyInto(ISpatialInfo spatialInfo);

	/**
	  * Returns direction in rad, 0 is east and clockwise.
	  */
	double getDirection();

	Image getImage();

	File getImagePath();

	Object getObject();

	Position2D getPosition();

	double getRadius();

	double getSpeed();
	
	double getDrawPriority();

	/**
	  * Sets direction in rad, 0 is east and clockwise.
	  */
	void setDirection(double newDirection);

	void setImage(java.awt.Image newImage);

	void setImagePath(java.io.File newFile);

	void setRadius(double newRadius);

	void setSpeed(double newSpeed);
	
	void setPosition(Point2D newPos);
	
	void setDrawPriority(double drawPriority);
	
	Shape getShape();
	
	void setObject(Object anObject);
}