package de.uniwue.ki.mas.basics.feature.spatial;
import java.util.Iterator;

import de.uniwue.ki.mas.basics.feature.AbstractFeatureClassDeclaration;
import de.uniwue.ki.mas.basics.feature.IObjectFeatureClassDeclaration;
import de.uniwue.ki.mas.basics.feature.spatial.function.FunctionDeclarationSpatialFactory;
import de.uniwue.ki.mas.basics.feature.spatial.position.FunctionDeclarationPosition2DFactory;
import de.uniwue.ki.mas.basics.functionDeclaration.list.FunctionDeclarationList;
import de.uniwue.ki.mas.entity.objectclass.IObjectClassDeclaration;
import de.uniwue.ki.mas.entity.objectclass.worldclass.IWorldClassDeclaration;

/**
 * Creation date: 04.09.2002, 18:40:18
 * @author oechslein
 */
public final class SpatialInfoFeatureClassDeclaration extends AbstractFeatureClassDeclaration {

	private final FunctionDeclarationList _defaultFunctionDeclarationList = new FunctionDeclarationList();

	private static final SpatialInfoFeatureClassDeclaration instance =
		new SpatialInfoFeatureClassDeclaration();
		
	private static final FunctionDeclarationList _functionDeclarationList = new FunctionDeclarationList();

	static {
		FunctionDeclarationSpatialFactory.insertSpatialFeatureFunctions(_functionDeclarationList);
	}

	protected SpatialInfoFeatureClassDeclaration() {
		super("SpatialInfo");

		FunctionDeclarationSpatialFactory.insertDefaultFunctions(_defaultFunctionDeclarationList);
		FunctionDeclarationPosition2DFactory.insertFunctions(_defaultFunctionDeclarationList);
	}

	public Iterator getDefaultFunctionDeclarations() {
		return _defaultFunctionDeclarationList.iterator();
	}
	
	public Iterator getFunctionDeclarations() {
			return _functionDeclarationList.iterator();
		}

	public static final SpatialInfoFeatureClassDeclaration getInstance() {
		return instance;
	}

	public boolean isDefaultFeatureClassDeclarationFor(IObjectClassDeclaration objectClassDeclaration) {
		return !(objectClassDeclaration instanceof IWorldClassDeclaration);
	}

	public IObjectFeatureClassDeclaration createObjectFeatureClassDeclaration(IObjectClassDeclaration objectClassDeclaration) {
		return new SpatialInfoObjectFeatureClassDeclaration(this);
	}
}