package de.uniwue.ki.mas.basics.feature.spatial;
import java.util.Map;

import junit.framework.Assert;
import de.uniwue.ki.mas.basics.feature.IObjectFeature;
import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.entity.object.IObject;
import de.uniwue.ki.mas.model.SimulationRuntimeException;
import de.uniwue.ki.util.copy.ICopyable;

/**
 * Creation date: (25.01.2001 11:33:48)
 * @author Christoph Oechslein
 */

final class SpatialInfoObjectFeature extends CircularSpatialInfo implements IObjectFeature, ISpatialInfo {
	private final SpatialInfoObjectFeatureInstDeclaration _spatialInfoBuildinObjectFeatureInstanceDeclaration;

	public SpatialInfoObjectFeature(
		SpatialInfoObjectFeatureInstDeclaration spatialInfoBuildinFeatureInstanceDeclaration,
		IObject simObject,
		ISpatialInfo spatialInfo) {

		super(spatialInfo, simObject);

		_spatialInfoBuildinObjectFeatureInstanceDeclaration = spatialInfoBuildinFeatureInstanceDeclaration;
	}

	public ICopyable copy(Map objectMapping) {
		throw new RuntimeException("Don't copy this");
	}

	public ISpatialInfo getSpatialInfo() {
		return this;
	}

	public static ISpatialInfo getSpatialInfo(IObject simObject) {

		if (Assert.ASSERTION_ON)
			Assert.assertNotNull(simObject);

		for (int i = 0; i < simObject.getObjectFeaturesCount(); i++) {
			IObjectFeature currIObjectFeature = simObject.getObjectFeatureAt(i);

			if (currIObjectFeature instanceof SpatialInfoObjectFeature) {
				return (SpatialInfoObjectFeature) currIObjectFeature;
			}
		}

		return null;
	}

	ISpatialInfo getStartSpatialInfo() {
		return _spatialInfoBuildinObjectFeatureInstanceDeclaration.getSpatialInfo();
	}

	public void remove() {
	}

	public void reset(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {

	}

	public void update(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
	}
}