package de.uniwue.ki.mas.basics.feature.spatial;

import java.util.Iterator;

import de.uniwue.ki.mas.basics.feature.*;
import de.uniwue.ki.mas.entity.object.IObjectInstanceDeclaration;
import de.uniwue.ki.mas.util.declaration.AbstractDeclaration;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * @author oechslein
 * 
 * Creation date: 13.07.2003
 */

final class SpatialInfoObjectFeatureClassDeclaration
	extends AbstractDeclaration
	implements IObjectFeatureClassDeclaration, IHasSpatialInfoDeclaration {

	SpatialInfoFeatureClassDeclaration _classDeclaration;

	public SpatialInfoObjectFeatureClassDeclaration(SpatialInfoFeatureClassDeclaration classDeclaration) {
		_classDeclaration = classDeclaration;
	}

	private final ISpatialInfo _spatialInfo = new CircularSpatialInfo(this);

	public IObjectFeatureInstanceDeclaration createObjectFeatureInstanceDeclaration(IObjectInstanceDeclaration objectInstanceDeclaration) {
		return new SpatialInfoObjectFeatureInstDeclaration(this, objectInstanceDeclaration, getSpatialInfo());
	}

	public IFeatureClassDeclaration getFeatureClassDeclaration() {
		return SpatialInfoFeatureClassDeclaration.getInstance();
	}

	public Iterator getFunctionDeclarations() {
		return _classDeclaration.getFunctionDeclarations();
	}

	public String getName() {
		return SpatialInfoFeatureClassDeclaration.getInstance().getName();
	}

	public ISpatialInfo getSpatialInfo() {
		return _spatialInfo;
	}

	public ISpatialMapModel getSpatialMapModel() {
		return null;
	}

	public Iterator getVariableClassDeclarations() {
		return CollectionsHelper.EMPTY_ITERATOR;
	}
}
