/*
 * Created on 24.06.2003
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package de.uniwue.ki.mas.basics.feature.spatial;

import java.util.*;

import de.uniwue.ki.mas.basics.feature.AbstractObjectFeature;
import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.entity.object.world.*;
import de.uniwue.ki.mas.model.SimulationRuntimeException;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * @author muehlberger
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class SpatialMapObjectFeature extends AbstractObjectFeature implements ISpatialMapObjectFeature {

	private final ISpatialMapModel _spatialMapModel;
	private final WorldListener _worldListener;
	private final IWorld _world;

	public SpatialMapObjectFeature(ISpatialMapModel spatialMapModel, IWorld world) {
		super();

		_spatialMapModel = spatialMapModel;
		_world = world;
		_worldListener = new WorldListener() {
			public void addedObject(WorldEvent event) {
				_spatialMapModel.addSpatialInfo(SpatialInfoObjectFeature.getSpatialInfo(event.getObject()));
			}

			public void removedObject(WorldEvent event) {
				_spatialMapModel.removeSpatialInfo(SpatialInfoObjectFeature.getSpatialInfo(event.getObject()));
			}
		};
		world.addWorldListener(_worldListener);
	}

	public ISpatialMapModel getSpatialMapModel() {
		return _spatialMapModel;
	}

	public void reset(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {

		IWorldExecuteFunctionArgs worldExecuteFunctionArgs = (IWorldExecuteFunctionArgs) executeFunctionArgs;
		IWorld world = worldExecuteFunctionArgs.getWorld();

		List objectsInWorld = new ArrayList(world.getObjectCount(false, false));
		CollectionsHelper.addAll(objectsInWorld, world.getAllObjects(false, false));

		Iterator it = _spatialMapModel.getAllSpatialInfoList().iterator();

		while (it.hasNext()) {
			SpatialInfoObjectFeature currISpatialInfo = (SpatialInfoObjectFeature) it.next();

			if (!objectsInWorld.contains(currISpatialInfo.getObject())) {

				ISpatialInfo startISpatialInfo = currISpatialInfo.getStartSpatialInfo();

				_spatialMapModel.removeSpatialInfo(startISpatialInfo);
			}
		}

	}

	public String getName() {
		return "SpatialMapModell";
	}

	public void remove() {
		_world.removeWorldListener(_worldListener);
		_spatialMapModel.remove();

		super.remove();
	}
}
