package de.uniwue.ki.mas.basics.feature.spatial.function;

import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.type.ISpecificType;
import de.uniwue.ki.mas.basics.type.VoidType;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * @author oechslein
 * 
 * Creation date: 07.05.2003
 */
abstract class AbstractChangeAnySpatialFeatureSpecificFunctionDeclaration
	extends AbstractHasSpatialFeatureSpecificFunctionDeclaration {

		public AbstractChangeAnySpatialFeatureSpecificFunctionDeclaration(
			boolean hasSpatialFeature,
			String name,
			ISpecificType changeType,
			String documentation) {
			super(
				hasSpatialFeature,
				name,
				VoidType.getInstance(),
				CollectionsHelper.createIterator(changeType),
				false);

			setDocumentation(documentation);
		}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions)
		throws ModelCompilingException {

		Assert.assertEquals(2, functions.size());

		return createNewFunction(functions.getFunction(0), functions.getFunction(1));
	}

	protected abstract IFunction createNewFunction(IFunction spatialInfoFunction, IFunction changeFunction);
}
