package de.uniwue.ki.mas.basics.feature.spatial.function;

import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.type.DoubleType;
import de.uniwue.ki.mas.basics.type.ISpecificType;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * @author oechslein
 * 
 * Creation date: 07.05.2003
 */
abstract class AbstractGetAnySpatialFeatureSpecificFunctionDeclaration
	extends AbstractHasSpatialFeatureSpecificFunctionDeclaration {

	public AbstractGetAnySpatialFeatureSpecificFunctionDeclaration(
		boolean hasSpatialFeature,
		String name,
		String documentation) {

		this(hasSpatialFeature, name, DoubleType.getInstance(), documentation);
	}

	public AbstractGetAnySpatialFeatureSpecificFunctionDeclaration(
		boolean hasSpatialFeature,
		String name,
		ISpecificType outputType,
		String documentation) {
		this(hasSpatialFeature, name, outputType, documentation, false);
	}

	public AbstractGetAnySpatialFeatureSpecificFunctionDeclaration(
		boolean hasSpatialFeature,
		String name,
		ISpecificType outputType,
		String documentation,
		boolean constant) {
		super(hasSpatialFeature, name, outputType, CollectionsHelper.EMPTY_ITERATOR, constant);

		setDocumentation(documentation);
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions)
		throws ModelCompilingException {

		if (Assert.ASSERTION_ON)
			Assert.assertEquals(1, functions.size());

		return createNewFunction(functions.getFunction(0));
	}

	protected abstract IFunction createNewFunction(IFunction spatialFunction);
}
