package de.uniwue.ki.mas.basics.feature.spatial.function;
import junit.framework.Assert;
import de.uniwue.ki.mas.basics.feature.spatial.ISpatialInfo;
import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.basics.function.number.AbstractDoubleFunction;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

abstract class AbstractGetDoubleFunction extends AbstractDoubleFunction {
	private final IFunction _spatialInfoFunction;

	public AbstractGetDoubleFunction(IFunction spatialInfoFunction) {
		super();

		Assert.assertNotNull(spatialInfoFunction);

		_spatialInfoFunction = spatialInfoFunction;
	}

	public double executeForDouble(IExecuteFunctionArgs executeFunctionArgs)
		throws SimulationRuntimeException {
		return getInfo((ISpatialInfo) _spatialInfoFunction.execute(executeFunctionArgs));
	}

	protected abstract double getInfo(ISpatialInfo spatialInfo);

	public String getName() {
		return getFunctionName() + "(" + _spatialInfoFunction.getName() + ")";
	}

	protected abstract String getFunctionName();
}