package de.uniwue.ki.mas.basics.feature.spatial.function;
import junit.framework.Assert;
import de.uniwue.ki.mas.basics.feature.spatial.ISpatialInfo;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

abstract class AbstractGetObjectFunction extends AbstractFunction {
	private final IFunction _spatialInfoFunction;

	public AbstractGetObjectFunction(IFunction spatialInfoFunction) {
		super();

		Assert.assertNotNull(spatialInfoFunction);

		_spatialInfoFunction = spatialInfoFunction;
	}

	public Object execute(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
		return getInfo((ISpatialInfo) _spatialInfoFunction.execute(executeFunctionArgs));
	}

	protected abstract Object getInfo(ISpatialInfo spatialInfo);

	public String getName() {
		return getFunctionName() + "(" + _spatialInfoFunction.getName() + ")";
	}

	protected abstract String getFunctionName();
}