package de.uniwue.ki.mas.basics.feature.spatial.function;
import de.uniwue.ki.mas.basics.action.AbstractFunctionAction;
import de.uniwue.ki.mas.basics.feature.spatial.*;
import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.entity.object.world.IWorldExecuteFunctionArgs;
import de.uniwue.ki.mas.model.SimulationRuntimeException;
import de.uniwue.ki.util.Position2D;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */
final class BeamSpatialInfoToPositionFunction extends AbstractFunctionAction {
	private final IFunction _spatialInfoFunction;
	private final IFunction _toPositionFunction;

	public BeamSpatialInfoToPositionFunction(IFunction spatialInfoFunction, IFunction toPositionFunction) {
		super();

		_spatialInfoFunction = spatialInfoFunction;
		_toPositionFunction = toPositionFunction;
	}

	public void act(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {

		IWorldExecuteFunctionArgs worldExecuteFunctionArgs = (IWorldExecuteFunctionArgs) executeFunctionArgs;

		ISpatialInfo spatialInfo =
			AbstractChangeFunction.getSpatialInfo(worldExecuteFunctionArgs, _spatialInfoFunction, this);

		Position2D toPosition = (Position2D) _toPositionFunction.execute(executeFunctionArgs);

		ISpatialMapModel mapModel =
			SpatialMapFeatureClassDeclaration.getSpatialMapModel(worldExecuteFunctionArgs.getWorld());

		mapModel.changePosition(spatialInfo, toPosition);
	}

	public String getName() {
		return getNameIntern();
	}

	public void appendName(StringBuffer buff, int currDepth, int maxDepth) {
		AbstractChangeFunction.appendFunctionName(
			buff,
			currDepth,
			maxDepth,
			"BeamSpatialInfoTo",
			_spatialInfoFunction,
			_toPositionFunction);
	}

}