package de.uniwue.ki.mas.basics.feature.spatial.function;
import de.uniwue.ki.mas.basics.feature.spatial.ISpatialInfo;
import de.uniwue.ki.mas.basics.feature.spatial.ISpatialMapModel;
import de.uniwue.ki.mas.basics.function.IFunction;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class ChangeDirectionByFunction extends AbstractChangeFunction {
	public ChangeDirectionByFunction(IFunction spatialFunction, IFunction changeFunction) {
		super(spatialFunction, changeFunction);
	}

	protected void changeSpatialInfo(
		ISpatialMapModel mapModel,
		ISpatialInfo spatialInfo,
		double byDirectionInDegree) {
			
		double newDirection = Math.toRadians(byDirectionInDegree % 360.0) + spatialInfo.getDirection();
		mapModel.changeDirection(spatialInfo, newDirection);
	}

	protected String getFunctionName() {
		return "ChangeDirectionBy";
	}
}