package de.uniwue.ki.mas.basics.feature.spatial.function;
import de.uniwue.ki.mas.basics.feature.spatial.ISpatialInfo;
import de.uniwue.ki.mas.basics.feature.spatial.ISpatialMapModel;
import de.uniwue.ki.mas.basics.function.IFunction;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class ChangeSpeedByFunction extends AbstractChangeFunction {
	public ChangeSpeedByFunction(IFunction spatialFunction, IFunction changeFunction) {
		super(spatialFunction, changeFunction);
	}

	protected void changeSpatialInfo(ISpatialMapModel mapModel, ISpatialInfo spatialInfo, double bySpeed) {
		double newSpeed = spatialInfo.getSpeed() + bySpeed;
		mapModel.changeSpeed(spatialInfo, newSpeed);
	}

	protected String getFunctionName() {
		return "ChangeSpeedBy";
	}
}