package de.uniwue.ki.mas.basics.feature.spatial.function;
import de.uniwue.ki.mas.basics.functionDeclaration.list.FunctionDeclarationList;
import de.uniwue.ki.mas.basics.functionDeclaration.list.IFunctionDeclarationList;

/**
 * Creation date: (17.09.2001 14:03:54)
 * @author Christoph Oechslein
 */

public final class FunctionDeclarationSpatialFactory {
	public static final BeamSpatialInfoToPositionSpecificFunctionDeclaration BEAM_FUN_DECL_HAS_NO_SPATIAL_INFO =
		new BeamSpatialInfoToPositionSpecificFunctionDeclaration(false);

	public static final BeamSpatialInfoToPositionSpecificFunctionDeclaration BEAM_FUN_DECL_HAS_SPATIAL_INFO =
		new BeamSpatialInfoToPositionSpecificFunctionDeclaration(true);
	public static final ChangeDirectionBySpecificFunctionDeclaration CHANGE_DIRECTION_BY_SPECIFIC_FUN_DECL_HAS_NO_SPATIAL_INFO =
		new ChangeDirectionBySpecificFunctionDeclaration(false);
	public static final ChangeDirectionBySpecificFunctionDeclaration CHANGE_DIRECTION_BY_SPECIFIC_FUN_DECL_HAS_SPATIAL_INFO =
		new ChangeDirectionBySpecificFunctionDeclaration(true);
	public static final ChangeDirectionToSpecificFunctionDeclaration CHANGE_DIRECTION_TO_SPECIFIC_FUN_DECL_HAS_NO_SPATIAL_INFO =
		new ChangeDirectionToSpecificFunctionDeclaration(false);

	public static final ChangeDirectionToSpecificFunctionDeclaration CHANGE_DIRECTION_TO_SPECIFIC_FUN_DECL_HAS_SPATIAL_INFO =
		new ChangeDirectionToSpecificFunctionDeclaration(true);
	public static final ChangeDrawPrioritySpecificFunctionDeclaration CHANGE_DRAWPRIO_SPECIFIC_FUN_DECL_HAS_SPATIAL_INFO =
		new ChangeDrawPrioritySpecificFunctionDeclaration(true);
	public static final ChangeImageSpecificFunctionDeclaration CHANGE_IMAGE_SPECIFIC_FUN_DECL_HAS_NO_SPATIAL_INFO =
		new ChangeImageSpecificFunctionDeclaration(false);
	public static final ChangeImageSpecificFunctionDeclaration CHANGE_IMAGE_SPECIFIC_FUN_DECL_HAS_SPATIAL_INFO =
		new ChangeImageSpecificFunctionDeclaration(true);
	public static final ChangeRadiusBySpecificFunctionDeclaration CHANGE_RADIUS_BY_SPECIFIC_FUN_DECL_HAS_NO_SPATIAL_INFO =
		new ChangeRadiusBySpecificFunctionDeclaration(false);
	public static final ChangeRadiusBySpecificFunctionDeclaration CHANGE_RADIUS_BY_SPECIFIC_FUN_DECL_HAS_SPATIAL_INFO =
		new ChangeRadiusBySpecificFunctionDeclaration(true);
	public static final ChangeRadiusToSpecificFunctionDeclaration CHANGE_RADIUS_TO_SPECIFIC_FUN_DECL_HAS_NO_SPATIAL_INFO =
		new ChangeRadiusToSpecificFunctionDeclaration(false);
	public static final ChangeRadiusToSpecificFunctionDeclaration CHANGE_RADIUS_TO_SPECIFIC_FUN_DECL_HAS_SPATIAL_INFO =
		new ChangeRadiusToSpecificFunctionDeclaration(true);
	public static final ChangeSpeedBySpecificFunctionDeclaration CHANGE_SPEED_BY_SPECIFIC_FUN_DECL_HAS_NO_SPATIAL_INFO =
		new ChangeSpeedBySpecificFunctionDeclaration(false);
	public static final ChangeSpeedBySpecificFunctionDeclaration CHANGE_SPEED_BY_SPECIFIC_FUN_DECL_HAS_SPATIAL_INFO =
		new ChangeSpeedBySpecificFunctionDeclaration(true);
	public static final ChangeSpeedToSpecificFunctionDeclaration CHANGE_SPEED_TO_SPECIFIC_FUN_DECL_HAS_NO_SPATIAL_INFO =
		new ChangeSpeedToSpecificFunctionDeclaration(false);
	public static final ChangeSpeedToSpecificFunctionDeclaration CHANGE_SPEED_TO_SPECIFIC_FUN_DECL_HAS_SPATIAL_INFO =
		new ChangeSpeedToSpecificFunctionDeclaration(true);
	public static final CreateOverlayImageSpecificFunctionDeclaration CREATE_OVERLAY_IMAGE_SPEC_FUN_DECL =
		new CreateOverlayImageSpecificFunctionDeclaration();

	public static final GetDirectionInDegreeSpecificFunctionDeclaration GET_DIRECTION_IN_DEGREE_FUNCTION_DECL_HAS_NO_SPATIAL_INFO =
		new GetDirectionInDegreeSpecificFunctionDeclaration(false);

	public static final GetDirectionInDegreeSpecificFunctionDeclaration GET_DIRECTION_IN_DEGREE_FUNCTION_DECL_HAS_SPATIAL_INFO =
		new GetDirectionInDegreeSpecificFunctionDeclaration(true);

	public static final GetMapDimensionSpecificFunctionDeclaration GET_MAP_FUN_DECL =
		new GetMapDimensionSpecificFunctionDeclaration();

	public static final GetMyPositionSpecificFunctionDeclaration GET_MY_POSITION_FUNCTION_DECL =
		new GetMyPositionSpecificFunctionDeclaration();
	public static final GetMySpatialInfoSpecificFunctionDeclaration GET_MY_SPATIAL_FUNCTION_DECL =
		new GetMySpatialInfoSpecificFunctionDeclaration();

	public static final GetDiscreteMapPatchSpecificFunctionDeclaration GET_PATCH_FUN_DECL =
		new GetDiscreteMapPatchSpecificFunctionDeclaration();

	public static final GetSpatialInfoSpecificFunctionDeclaration GET_SPATIAL_INFO_FUN_DECL =
		new GetSpatialInfoSpecificFunctionDeclaration();

	public static final GetSpeedSpecificFunctionDeclaration GET_SPEED_FUNCTION_DECL_HAS_NO_SPATIAL_INFO =
		new GetSpeedSpecificFunctionDeclaration(false);
	public static final GetSpeedSpecificFunctionDeclaration GET_SPEED_FUNCTION_DECL_HAS_SPATIAL_INFO =
		new GetSpeedSpecificFunctionDeclaration(true);
	public static final MoveSpatialInfoSpecificFunctionDeclaration MOVE_SPECIFIC_FUN_DECL_HAS_NO_SPATIAL_INFO =
		new MoveSpatialInfoSpecificFunctionDeclaration(false);

	public static final MoveSpatialInfoSpecificFunctionDeclaration MOVE_SPECIFIC_FUN_DECL_HAS_SPATIAL_INFO =
		new MoveSpatialInfoSpecificFunctionDeclaration(true);
	public static final MoveTowardsPosSpatialInfoSpecificFunctionDeclaration MOVE_TOWARDS_POS_SPECIFIC_FUN_DECL_HAS_NO_SPATIAL_INFO =
		new MoveTowardsPosSpatialInfoSpecificFunctionDeclaration(false);
	public static final MoveTowardsPosSpatialInfoSpecificFunctionDeclaration MOVE_TOWARDS_POS_SPECIFIC_FUN_DECL_HAS_SPATIAL_INFO =
		new MoveTowardsPosSpatialInfoSpecificFunctionDeclaration(true);

	private static final IFunctionDeclarationList _cachedDefaultFunctionDeclarationList =
		new FunctionDeclarationList();
	private static final IFunctionDeclarationList _cachedDefaultSpatialFunDeclsWithoutSpatialInfo =
		new FunctionDeclarationList();

	private static final IFunctionDeclarationList _cachedDefaultSpatialFunDeclsWithSpatialInfo =
		new FunctionDeclarationList();
	private static final IFunctionDeclarationList _cachedFunctionDeclarationList =
		new FunctionDeclarationList();
	private static final IFunctionDeclarationList _cachedMapFeatureFunctionDeclarationList =
		new FunctionDeclarationList();

	static {
		insertDefaultSpatialFunctionsIntern(_cachedDefaultSpatialFunDeclsWithSpatialInfo, true);
		insertDefaultSpatialFunctionsIntern(_cachedDefaultSpatialFunDeclsWithoutSpatialInfo, false);

		insertDefaultFunctionsIntern();
		insertDefaultSpatialFunctions(_cachedFunctionDeclarationList, true);
		insertMapFeatureFunctionsIntern();
	}

	public static void insertDefaultFunctions(IFunctionDeclarationList functionDeclarationList) {
		functionDeclarationList.addAll(_cachedDefaultFunctionDeclarationList);
	}

	private static void insertDefaultFunctionsIntern() {
		insertDefaultSpatialFunctions(_cachedDefaultFunctionDeclarationList, false);
	}

	private static void insertDefaultSpatialFunctions(
		IFunctionDeclarationList functionDeclList,
		boolean hasSpatialInfoFeature) {

		if (hasSpatialInfoFeature)
			functionDeclList.addAll(_cachedDefaultSpatialFunDeclsWithSpatialInfo);
		else
			functionDeclList.addAll(_cachedDefaultSpatialFunDeclsWithoutSpatialInfo);
	}

	private static void insertDefaultSpatialFunctionsIntern(
		IFunctionDeclarationList functionDeclList,
		boolean hasSpatialInfoFeature) {

		// Spatial Info Functions:

		// Functions:

		// get spatial info
		functionDeclList.add(GET_SPATIAL_INFO_FUN_DECL);

		// get info from spatial info

		functionDeclList.add(new GetPositionSpecificFunctionDeclaration(hasSpatialInfoFeature));
		functionDeclList.add(
			hasSpatialInfoFeature
				? GET_SPEED_FUNCTION_DECL_HAS_SPATIAL_INFO
				: GET_SPEED_FUNCTION_DECL_HAS_NO_SPATIAL_INFO);
		functionDeclList.add(new GetRadiusSpecificFunctionDeclaration(hasSpatialInfoFeature));

		functionDeclList.add(
			hasSpatialInfoFeature
				? GET_DIRECTION_IN_DEGREE_FUNCTION_DECL_HAS_SPATIAL_INFO
				: GET_DIRECTION_IN_DEGREE_FUNCTION_DECL_HAS_NO_SPATIAL_INFO);

		functionDeclList.add(new GetImageSpecificFunctionDeclaration(hasSpatialInfoFeature));

		// get objects on position with radius
		functionDeclList.add(new GetObjectsOnPositionSpecificFunctionDeclaration(hasSpatialInfoFeature));

		// get objects in direction
		functionDeclList.add(new GetObjectsInDirectionSpecificFunctionDeclaration(hasSpatialInfoFeature));

		// get dimension of map
		functionDeclList.add(GET_MAP_FUN_DECL);

		// get patch dimension of map
		functionDeclList.add(GET_PATCH_FUN_DECL);

		// Create new overlay image
		functionDeclList.add(CREATE_OVERLAY_IMAGE_SPEC_FUN_DECL);

		// Actions:

		if (hasSpatialInfoFeature) {
			functionDeclList.add(BEAM_FUN_DECL_HAS_SPATIAL_INFO);
			functionDeclList.add(MOVE_SPECIFIC_FUN_DECL_HAS_SPATIAL_INFO);
			functionDeclList.add(MOVE_TOWARDS_POS_SPECIFIC_FUN_DECL_HAS_SPATIAL_INFO);

			functionDeclList.add(CHANGE_IMAGE_SPECIFIC_FUN_DECL_HAS_SPATIAL_INFO);
			functionDeclList.add(CHANGE_SPEED_BY_SPECIFIC_FUN_DECL_HAS_SPATIAL_INFO);
			functionDeclList.add(CHANGE_SPEED_TO_SPECIFIC_FUN_DECL_HAS_SPATIAL_INFO);
			functionDeclList.add(CHANGE_RADIUS_BY_SPECIFIC_FUN_DECL_HAS_SPATIAL_INFO);
			functionDeclList.add(CHANGE_RADIUS_TO_SPECIFIC_FUN_DECL_HAS_SPATIAL_INFO);
			functionDeclList.add(CHANGE_DIRECTION_BY_SPECIFIC_FUN_DECL_HAS_SPATIAL_INFO);
			functionDeclList.add(CHANGE_DIRECTION_TO_SPECIFIC_FUN_DECL_HAS_SPATIAL_INFO);
			functionDeclList.add(CHANGE_DRAWPRIO_SPECIFIC_FUN_DECL_HAS_SPATIAL_INFO);

			functionDeclList.add(GET_MY_SPATIAL_FUNCTION_DECL);
			functionDeclList.add(GET_MY_POSITION_FUNCTION_DECL);

		} else {
			functionDeclList.add(BEAM_FUN_DECL_HAS_NO_SPATIAL_INFO);
			functionDeclList.add(MOVE_SPECIFIC_FUN_DECL_HAS_NO_SPATIAL_INFO);
			functionDeclList.add(MOVE_TOWARDS_POS_SPECIFIC_FUN_DECL_HAS_NO_SPATIAL_INFO);

			functionDeclList.add(CHANGE_IMAGE_SPECIFIC_FUN_DECL_HAS_NO_SPATIAL_INFO);
			functionDeclList.add(CHANGE_SPEED_BY_SPECIFIC_FUN_DECL_HAS_NO_SPATIAL_INFO);
			functionDeclList.add(CHANGE_SPEED_TO_SPECIFIC_FUN_DECL_HAS_NO_SPATIAL_INFO);
			functionDeclList.add(CHANGE_RADIUS_BY_SPECIFIC_FUN_DECL_HAS_NO_SPATIAL_INFO);
			functionDeclList.add(CHANGE_RADIUS_TO_SPECIFIC_FUN_DECL_HAS_NO_SPATIAL_INFO);
			functionDeclList.add(CHANGE_DIRECTION_BY_SPECIFIC_FUN_DECL_HAS_NO_SPATIAL_INFO);
			functionDeclList.add(CHANGE_DIRECTION_TO_SPECIFIC_FUN_DECL_HAS_NO_SPATIAL_INFO);
		}
	}

	public static void insertMapFeatureFunctions(IFunctionDeclarationList functionDeclarationList) {
		functionDeclarationList.addAll(_cachedMapFeatureFunctionDeclarationList);
	}

	private static void insertMapFeatureFunctionsIntern() {
		insertDefaultSpatialFunctions(_cachedMapFeatureFunctionDeclarationList, false);
	}

	public static void insertSpatialFeatureFunctions(IFunctionDeclarationList functionDeclarationList) {
		functionDeclarationList.addAll(_cachedFunctionDeclarationList);
	}
}