package de.uniwue.ki.mas.basics.feature.spatial.function;
import junit.framework.Assert;
import de.uniwue.ki.mas.basics.feature.spatial.position.Position2DType;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionArgsDeclaration;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Creation date: (25.10.2001 16:26:30)
 * @author Christoph Oechslein
 */

final class GetDiscreteMapPatchSpecificFunctionDeclaration extends AbstractSpecificFunctionArgsDeclaration {

	public GetDiscreteMapPatchSpecificFunctionDeclaration() {
		super(GetDiscreteMapPatchFunction.NAME, Position2DType.getInstance(), CollectionsHelper.EMPTY_LIST);

		setDocumentation("Returns the x-size and y-size of one patch (cell) in the map.");
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions)
		throws ModelCompilingException {

		if (Assert.ASSERTION_ON)
			Assert.assertEquals(0, functions.size());

		return GetDiscreteMapPatchFunction.getInstance();
	}
}
