package de.uniwue.ki.mas.basics.feature.spatial.function;
import de.uniwue.ki.mas.basics.feature.spatial.ISpatialMapModel;
import de.uniwue.ki.mas.basics.feature.spatial.SpatialMapFeatureClassDeclaration;
import de.uniwue.ki.mas.basics.function.AbstractFunction;
import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.entity.object.world.IWorldExecuteFunctionArgs;
import de.uniwue.ki.mas.model.SimulationRuntimeException;
import de.uniwue.ki.util.Position2D;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class GetMapDimensionFunction extends AbstractFunction {

	static final String NAME = "GetMapDimension";
	private static final GetMapDimensionFunction _instance = new GetMapDimensionFunction();

	private GetMapDimensionFunction() {
		super();
	}

	public Object execute(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {

		IWorldExecuteFunctionArgs worldExecuteFunctionArgs = (IWorldExecuteFunctionArgs) executeFunctionArgs;
		ISpatialMapModel mapModel =
			SpatialMapFeatureClassDeclaration.getSpatialMapModel(worldExecuteFunctionArgs.getWorld());

		return new Position2D(mapModel.getWidth(), mapModel.getHeight());
	}

	public static final GetMapDimensionFunction getInstance() {
		return _instance;
	}

	public String getName() {
		return NAME + "()";
	}
}