package de.uniwue.ki.mas.basics.feature.spatial.function;
import junit.framework.Assert;
import de.uniwue.ki.mas.basics.feature.spatial.position.Position2DType;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionArgsDeclaration;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Creation date: (25.10.2001 16:26:30)
 * @author Christoph Oechslein
 */

class GetMapDimensionSpecificFunctionDeclaration extends AbstractSpecificFunctionArgsDeclaration {

	public GetMapDimensionSpecificFunctionDeclaration() {
		super(GetMapDimensionFunction.NAME, Position2DType.getInstance(), CollectionsHelper.EMPTY_LIST);

		setDocumentation("Returns the maximum x-size and maximum y-size of the Map.");
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions)
		throws ModelCompilingException {

		if (Assert.ASSERTION_ON)
			Assert.assertEquals(0, functions.size());

		return GetMapDimensionFunction.getInstance();
	}
}
