package de.uniwue.ki.mas.basics.feature.spatial.function;
import junit.framework.Assert;
import de.uniwue.ki.mas.basics.feature.spatial.position.Position2DType;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionArgsDeclaration;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Creation date: (17.09.2001 14:08:27)
 * @author Christoph Oechslein
  */

class GetMyPositionSpecificFunctionDeclaration extends AbstractSpecificFunctionArgsDeclaration {

	public GetMyPositionSpecificFunctionDeclaration() {
		super("GetMyPosition", Position2DType.getInstance(), CollectionsHelper.EMPTY_LIST, false);

		setDocumentation("Returns the position of the current acting agent.");
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions)
		throws ModelCompilingException {

		Assert.assertEquals(0, functions.size());

		return GetMyPositionFunction.getInstance();
	}
}