package de.uniwue.ki.mas.basics.feature.spatial.function;
import de.uniwue.ki.mas.basics.feature.spatial.ISpatialInfo;
import de.uniwue.ki.mas.basics.feature.spatial.SpatialInfoObjectFeatureHelper;
import de.uniwue.ki.mas.basics.function.AbstractFunction;
import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.entity.object.IObject;
import de.uniwue.ki.mas.entity.object.agent.IAgentExecuteFunctionArgs;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class GetMySpatialInfoFunction extends AbstractFunction {

	private static final GetMySpatialInfoFunction _instance = new GetMySpatialInfoFunction();

	protected GetMySpatialInfoFunction() {
		super();
	}

	public Object execute(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {

		IAgentExecuteFunctionArgs objectExecuteFunctionArgs = (IAgentExecuteFunctionArgs)executeFunctionArgs;
		IObject simObject = objectExecuteFunctionArgs.getObject();

		ISpatialInfo spatialInfo = SpatialInfoObjectFeatureHelper.getSpatialInfo(simObject);

		return spatialInfo;
	}

	public static final GetMySpatialInfoFunction getInstance() {
		return _instance;
	}

	public String getName() {
		return "GetMySpatialInfo()";
	}
}