package de.uniwue.ki.mas.basics.feature.spatial.function;
import junit.framework.Assert;
import de.uniwue.ki.mas.basics.feature.spatial.SpatialInfoType;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionArgsDeclaration;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Creation date: (17.09.2001 13:58:51)
 * @author Christoph Oechslein
  */

class GetMySpatialInfoSpecificFunctionDeclaration extends AbstractSpecificFunctionArgsDeclaration {

	public GetMySpatialInfoSpecificFunctionDeclaration() {
		super("GetMySpatialInfo", SpatialInfoType.getInstance(), CollectionsHelper.EMPTY_LIST, false);
		
		setDocumentation("Returns the spatial info of the current acting agent.");
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions)
		throws ModelCompilingException {

		if (Assert.ASSERTION_ON)
			Assert.assertEquals(0, functions.size());

		return GetMySpatialInfoFunction.getInstance();
	}
}