package de.uniwue.ki.mas.basics.feature.spatial.function;
import de.uniwue.ki.mas.basics.feature.spatial.SpatialInfoObjectFeatureHelper;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.entity.object.IObject;
import de.uniwue.ki.mas.entity.object.IObjectExecuteFunctionArgs;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class GetSpatialInfoFunction extends AbstractFunction {
	private final IFunction _simObjectFunction;

	public GetSpatialInfoFunction(IFunction simObjectFunction) {
		super();

		_simObjectFunction = simObjectFunction;
	}

	public Object execute(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {

		IObject object;

		if (_simObjectFunction == null) {
			object = ((IObjectExecuteFunctionArgs)executeFunctionArgs).getObject();
		} else {
			object = (IObject)_simObjectFunction.execute(executeFunctionArgs);
		}

		if (object == null)
			throw new SimulationRuntimeException("Object is null in " + getName());

		return SpatialInfoObjectFeatureHelper.getSpatialInfo(object);
	}

	public String getName() {
		if (_simObjectFunction == null) {
			return "GetMySpatialInfo()";
		} else {
			return "GetSpatialInfo(" + _simObjectFunction.getName() + ")";
		}
	}
}