package de.uniwue.ki.mas.basics.feature.spatial.function;
import junit.framework.Assert;
import de.uniwue.ki.mas.basics.feature.spatial.SpatialInfoType;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionArgsDeclaration;
import de.uniwue.ki.mas.basics.type.GenericSimObjectType;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Creation date: (17.09.2001 13:58:51)
 * @author Christoph Oechslein
 */

class GetSpatialInfoSpecificFunctionDeclaration extends AbstractSpecificFunctionArgsDeclaration {

	public GetSpatialInfoSpecificFunctionDeclaration() {
		super(
			"GetSpatialInfo",
			SpatialInfoType.getInstance(),
			CollectionsHelper.createList(GenericSimObjectType.getGeneralSimObjectType()));

		setDocumentation("Returns the spatial info of the given object");
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions)
		throws ModelCompilingException {

		if (Assert.ASSERTION_ON)
			Assert.assertEquals(1, functions.size());

		return new GetSpatialInfoFunction(functions.getFunction(0));
	}
}