package de.uniwue.ki.mas.basics.feature.spatial.function;
import de.uniwue.ki.mas.basics.action.AbstractFunctionAction;
import de.uniwue.ki.mas.basics.feature.spatial.*;
import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.entity.object.world.IWorldExecuteFunctionArgs;
import de.uniwue.ki.mas.model.SimulationRuntimeException;
import de.uniwue.ki.util.Position2D;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class MoveSpatialInfoFunction extends AbstractFunctionAction {

	private final IFunction _spatialInfoFunction;

	public MoveSpatialInfoFunction(IFunction spatialInfoFunction) {
		super();

		_spatialInfoFunction = spatialInfoFunction;
	}

	public void act(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {

		IWorldExecuteFunctionArgs worldExecuteFunctionArgs = (IWorldExecuteFunctionArgs) executeFunctionArgs;

		ISpatialInfo spatialInfo =
			AbstractChangeFunction.getSpatialInfo(worldExecuteFunctionArgs, _spatialInfoFunction, this);

		ISpatialMapModel mapModel =
			SpatialMapFeatureClassDeclaration.getSpatialMapModel(worldExecuteFunctionArgs.getWorld());

		Position2D toPosition =
			Position2D.addWithDirectionAndLength(
				spatialInfo.getPosition(),
				spatialInfo.getDirection(),
				spatialInfo.getSpeed());

		mapModel.changePosition(spatialInfo, toPosition);
	}

	public String getName() {
		return "Move(" + _spatialInfoFunction.getName() + ")";
	}
}