package de.uniwue.ki.mas.basics.feature.spatial.function;
import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.type.VoidType;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Creation date: (04.09.2001 13:16:02)
 * @author Christoph Oechslein
 */

class MoveSpatialInfoSpecificFunctionDeclaration
	extends AbstractHasSpatialFeatureSpecificFunctionDeclaration {

	public MoveSpatialInfoSpecificFunctionDeclaration(boolean hasSpatialInfo) {
		super(hasSpatialInfo, "Move", VoidType.getInstance(), CollectionsHelper.EMPTY_ITERATOR);

		setDocumentation("Moves the given spatial info");
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions)
		throws de.uniwue.ki.mas.model.ModelCompilingException {

		if (Assert.ASSERTION_ON)
			Assert.assertEquals(1, functions.size());

		return new MoveSpatialInfoFunction(functions.getFunction(0));
	}
}