package de.uniwue.ki.mas.basics.feature.spatial.position;
import de.uniwue.ki.mas.basics.functionDeclaration.list.FunctionDeclarationList;
import de.uniwue.ki.mas.basics.functionDeclaration.list.IFunctionDeclarationList;
/**
 * Creation date: (05.09.2001 10:46:37)
 * @author Christoph Oechslein
 */public final class FunctionDeclarationPosition2DFactory {

	private static IFunctionDeclarationList _cachedFunctionDeclarationList;

	public synchronized static void insertFunctions(IFunctionDeclarationList functionDeclarationList) {
		if (_cachedFunctionDeclarationList == null) {
			_cachedFunctionDeclarationList = new FunctionDeclarationList();
			insertFunctionsIntern(_cachedFunctionDeclarationList);
		}

		functionDeclarationList.addAll(_cachedFunctionDeclarationList);
	}

	private static void insertFunctionsIntern(IFunctionDeclarationList functionDeclarationList) {
		// Create
        functionDeclarationList.add(new PosCreateSpecificFunctionArgsDeclaration());

        // GetX
        functionDeclarationList.add(new PosGetXSpecificFunctionArgsDeclaration());

        // GetY
        functionDeclarationList.add(new PosGetYSpecificFunctionArgsDeclaration());

        // +
        functionDeclarationList.add(new PosPlusSpecificFunctionUnlimitedArgsDeclaration());

        // -
        functionDeclarationList.add(new PosMinusSpecificFunctionArgsDeclaration());

        // distance
        functionDeclarationList.add(new PosDistanceSpecificFunctionArgsDeclaration());

        // + (const number)
        functionDeclarationList.add(new PosPlusNumberSpecificFunctionArgsDeclaration());

        // - (const number)
        functionDeclarationList.add(new PosMinusNumberSpecificFunctionArgsDeclaration());

        // * (const number)
        functionDeclarationList.add(new PosMultiplyNumberSpecificFunctionArgsDeclaration());

        // / (const number)
        functionDeclarationList.add(new PosDivideNumberSpecificFunctionArgsDeclaration());

        // abs
        functionDeclarationList.add(new PosAbsSpecificFunctionArgsDeclaration());

        // get Direction
        functionDeclarationList.add(new PosGetDirectionSpecificFunctionArgsDeclaration());

        // getLength
        functionDeclarationList.add(new PosGetLengthSpecificFunctionArgsDeclaration());
    }
}