package de.uniwue.ki.mas.basics.feature.spatial.position;
import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.function.number.AbstractDoubleFunction;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionArgsDeclaration;
import de.uniwue.ki.mas.basics.type.DoubleType;
import de.uniwue.ki.mas.model.SimulationRuntimeException;
import de.uniwue.ki.util.Position2D;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Creation date: (05.09.2001 10:46:37)
 * @author Christoph Oechslein
 */

final class PosGetYSpecificFunctionArgsDeclaration extends AbstractSpecificFunctionArgsDeclaration {
	private static final String NAME = "PosGetY";

	public PosGetYSpecificFunctionArgsDeclaration() {
		super(
			NAME,
			DoubleType.getInstance(),
			CollectionsHelper.createList(Position2DType.getInstance()),
			true,
			false);

		setDocumentation("Returns the y-coordinate of its position (Arg1)");
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, final IFunctionList functions) {
		if (Assert.ASSERTION_ON)
			Assert.assertEquals(1, functions.size());

		return new AbstractDoubleFunction() {
			private final IFunction _posFunction = functions.getFunction(0);

			public String getName() {
				return NAME + "(" + _posFunction.getName() + ")";
			}

			public double executeForDouble(IExecuteFunctionArgs executeFunctionArgs)
				throws SimulationRuntimeException {
				return ((Position2D) _posFunction.execute(executeFunctionArgs)).y;
			}
		};
	}
}
