package de.uniwue.ki.mas.basics.feature.spatial.position;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionUnlimitedArgsDeclaration;
import de.uniwue.ki.mas.model.SimulationRuntimeException;
import de.uniwue.ki.util.Position2D;
import de.uniwue.ki.util.collection.IteratorWithException;

/**
 * Creation date: (05.09.2001 10:46:37)
 * @author Christoph Oechslein
 */

final class PosPlusSpecificFunctionUnlimitedArgsDeclaration
	extends AbstractSpecificFunctionUnlimitedArgsDeclaration {
	private static final String NAME = "Pos+";

	public PosPlusSpecificFunctionUnlimitedArgsDeclaration() {
		super(NAME, Position2DType.getInstance(), Position2DType.getInstance(), 0, 2, true);

		setDocumentation("Summates position (Arg1) with position (Arg2)");
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, final IFunctionList functions) {
		return new AbstractFunction() {
			public String getName() {
				return NAME + functions.getName();
			}

			public Object execute(IExecuteFunctionArgs executeFunctionArgs)
				throws SimulationRuntimeException {
				double x = 0.0;
				double y = 0.0;
				
				IteratorWithException it = mapFunctionsToObjects(executeFunctionArgs, functions.iterator(), false);
				while (it.hasNext()) {
					try {
						Position2D point = (Position2D) it.nextWithException();
						x += point.getX();
						y += point.getY();
					} catch (SimulationRuntimeException exp) {
						throw exp;
					} catch (Exception e) {
						throw new RuntimeException(e);
					}
				}
				return new Position2D(x, y);
			}
		};
	}
}