package de.uniwue.ki.mas.basics.feature.user;

import java.util.Iterator;

import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import de.uniwue.ki.mas.basics.functionDeclaration.list.FunctionDeclarationList;
import de.uniwue.ki.mas.basics.functionUser.IUserFunctionDeclaration;
import de.uniwue.ki.mas.basics.functionUser.UserFunctionDeclarationList;
import de.uniwue.ki.mas.util.declaration.DeclarationListEvent;
import de.uniwue.ki.mas.util.declaration.DeclarationListListener;

/**
 * Creation date: 02.08.2002, 11:42:12
 * @author oechslein
 */
public final class UserFunctionsOfAllUserFeatureDeclarationList extends FunctionDeclarationList {
	protected final transient ChangeListener _userFunctionDeclarationListChangeListener =
		new ChangeListener() {
		public void stateChanged(ChangeEvent e) {
			userFunctionDeclarationListChanged((UserFunctionDeclarationList) e.getSource());
		}
	};
	protected final DeclarationListListener _featureDeclarationListListener = new DeclarationListListener() {
		public void declarationAdded(DeclarationListEvent event) {
			userFeatureDeclarationAdded((IUserFeatureClassDeclaration) event.getDeclaration());
		}

		public void declarationRemoved(DeclarationListEvent event) {
			userFeatureDeclarationRemoved((IUserFeatureClassDeclaration) event.getDeclaration());
		}
	};
	protected final DeclarationListListener _functionDeclarationListListener =
		new DeclarationListListener() {
		public void declarationAdded(DeclarationListEvent event) {
			userFunctionDeclarationAdded((IUserFunctionDeclaration) event.getDeclaration());
		}

		public void declarationRemoved(DeclarationListEvent event) {
			userFunctionDeclarationRemoved((IUserFunctionDeclaration) event.getDeclaration());
		}
	};

	protected final UserFeatureClassDeclarationList _userFeatureClassDeclarationList;

	public UserFunctionsOfAllUserFeatureDeclarationList(UserFeatureClassDeclarationList userFeatureClassDeclarationList) {
		super();

		_userFeatureClassDeclarationList = userFeatureClassDeclarationList;
		userFeatureClassDeclarationList.addDeclarationListListener(_featureDeclarationListListener);

		Iterator it = userFeatureClassDeclarationList.iterator();

		while (it.hasNext()) {
			userFeatureDeclarationAdded((IUserFeatureClassDeclaration) it.next());
		}
	}

	protected void userFeatureDeclarationAdded(IUserFeatureClassDeclaration featureClassDeclaration) {
		UserFunctionDeclarationList userFunDeclList =
			featureClassDeclaration
				.getUserFunctionDeclarationListAndFactory()
				.getUserFunctionDeclarationList();
		userFunDeclList.addChangeListener(_userFunctionDeclarationListChangeListener);
		userFunDeclList.addDeclarationListListener(_functionDeclarationListListener);

		Iterator it = userFunDeclList.iterator();
		while (it.hasNext()) {
			userFunctionDeclarationAdded((IUserFunctionDeclaration) it.next());
		}
	}

	protected void userFeatureDeclarationRemoved(IUserFeatureClassDeclaration featureClassDeclaration) {
		UserFunctionDeclarationList userFunDeclList =
			featureClassDeclaration
				.getUserFunctionDeclarationListAndFactory()
				.getUserFunctionDeclarationList();
		userFunDeclList.removeChangeListener(_userFunctionDeclarationListChangeListener);
		userFunDeclList.removeDeclarationListListener(_functionDeclarationListListener);

		Iterator it = userFunDeclList.iterator();
		while (it.hasNext()) {
			userFunctionDeclarationRemoved((IUserFunctionDeclaration) it.next());
		}
	}

	protected void userFunctionDeclarationAdded(IUserFunctionDeclaration userFunctionDeclaration) {
		add(userFunctionDeclaration);
	}

	protected void userFunctionDeclarationRemoved(IUserFunctionDeclaration userFunctionDeclaration) {
		remove(userFunctionDeclaration);
	}

	protected void userFunctionDeclarationListChanged(UserFunctionDeclarationList userFunctionDeclarationList) {
		fireStateChanged();
	}

	public void remove() {
		super.remove();

		clear();
		_userFeatureClassDeclarationList.removeDeclarationListListener(_featureDeclarationListListener);
	}
}
