package de.uniwue.ki.mas.basics.featureList;
import java.util.Iterator;

import de.uniwue.ki.mas.basics.feature.IFeatureClassDeclaration;
import de.uniwue.ki.mas.entity.objectclass.IObjectClassDeclaration;
import de.uniwue.ki.mas.util.declaration.TwoUnmodifiableDeclarationList;
import de.uniwue.ki.util.collection.CollectionsHelper;
import de.uniwue.ki.util.functions.IMapFunction;

/**
 * Creation date: (30.07.2001 14:24:43)
 * @author Christoph Oechslein
 */
class TwoUnmodifiableFeatureDeclarationList
	extends TwoUnmodifiableDeclarationList
	implements IFeatureClassDeclarationList {

	public TwoUnmodifiableFeatureDeclarationList(
		IFeatureClassDeclarationList declarationListA,
		IFeatureClassDeclarationList declarationListB,
		boolean composition) {
		super(declarationListA, declarationListB, composition);
	}

	public boolean canAddFeatureClassDeclarationTo(IObjectClassDeclaration objectClassDeclaration) {
		Iterator it = getFeatureClassDeclarations();
		while (it.hasNext()) {
			IFeatureClassDeclaration featureClassDeclaration = (IFeatureClassDeclaration) it.next();
			if (!featureClassDeclaration.canAddFeatureClassDeclarationTo(objectClassDeclaration)) {
				return false;
			}
		}
		return true;
	}

	public Iterator getFeatureClassDeclarations() {
		return iterator();
	}

	public String getName() {
		return "Features";
	}

	public boolean isDefaultFeatureClassDeclarationFor(IObjectClassDeclaration objectClassDeclaration) {
		Iterator it = getFeatureClassDeclarations();
		while (it.hasNext()) {
			IFeatureClassDeclaration featureClassDeclaration = (IFeatureClassDeclaration) it.next();
			if (!featureClassDeclaration.isDefaultFeatureClassDeclarationFor(objectClassDeclaration)) {
				return false;
			}
		}
		return true;
	}

	public Iterator getDefaultFunctionDeclarations() {
		Iterator iteratorOfIterator =
			CollectionsHelper.map(getFeatureClassDeclarations(), new IMapFunction() {
			public Object map(Object anObject) {
				return ((IFeatureClassDeclaration) anObject).getDefaultFunctionDeclarations();
			}
		});

		return CollectionsHelper.removeDuplicates(CollectionsHelper.flatten(iteratorOfIterator));
	}
}