package de.uniwue.ki.mas.basics.function;
import de.uniwue.ki.mas.model.SimulationRuntimeException;
import de.uniwue.ki.util.collection.AbstractIteratorWithException;
/**
 * Creation date: (28.03.2002 19:32:38)
 * @author Christoph Oechslein
 */
public abstract class AbstractExecuteIterator
	extends AbstractIteratorWithException
	implements IExecuteIterator {

	public abstract Object nextExecute() throws SimulationRuntimeException;

	public boolean nextExecuteForBoolean() throws SimulationRuntimeException {
		return ((Boolean) nextExecute()).booleanValue();
	}

	public double nextExecuteForDouble() throws SimulationRuntimeException {
		return ((Number) nextExecute()).doubleValue();
	}

	public int nextExecuteForInt() throws SimulationRuntimeException {
		return ((Number) nextExecute()).intValue();
	}

	public Object nextWithException() throws Exception {
		return nextExecute();
	}
}