package de.uniwue.ki.mas.basics.function;
import de.uniwue.ki.mas.model.SimulationRuntimeException;
/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

public abstract class AbstractFunctionDynamic extends AbstractFunction {

	public AbstractFunctionDynamic() {
		super();
	}

	public void act(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
		execute(executeFunctionArgs);
	}

	public boolean executeForBoolean(IExecuteFunctionArgs executeFunctionArgs)
		throws SimulationRuntimeException {

		Object obj = execute(executeFunctionArgs);

		if (obj instanceof Boolean) {
			return ((Boolean) obj).booleanValue();

		} else {
			throw new WrongFunctionTypeException("Function does not return a Boolean!");
		}
	}

	public double executeForDouble(IExecuteFunctionArgs executeFunctionArgs)
		throws SimulationRuntimeException {

		Object obj = execute(executeFunctionArgs);

		if (obj instanceof Number) {
			return ((Number) obj).doubleValue();

		} else {
			throw new WrongFunctionTypeException("Function does not return a number!");
		}
	}

	public int executeForInt(IExecuteFunctionArgs executeFunctionArgs)
		throws SimulationRuntimeException {

		Object obj = execute(executeFunctionArgs);

		if (obj instanceof Number) {
			return ((Number) obj).intValue();

		} else {
			throw new WrongFunctionTypeException("Function does not return a number!");
		}
	}
}