package de.uniwue.ki.mas.basics.function;
import java.util.AbstractList;
import java.util.List;

import de.uniwue.ki.util.name.AbstractNamed;

/**
 * Creation date: (16.01.2002 19:55:01)
 * @author Christoph Oechslein
 */

public abstract class AbstractMapFunctionList extends AbstractList implements IFunctionList {
	private final List _delegate;

	public AbstractMapFunctionList(List delegate) {
		super();

		_delegate = delegate;
	}

	public Object get(int index) {
		return map(_delegate.get(index));
	}

	public IFunction getFunction(int index) {
		return (IFunction) get(index);
	}

	public void appendName(StringBuffer buff, int currDepth, int maxDepth) {
		buff.append("(");
		AbstractNamed.append(iterator(), buff, currDepth, maxDepth);
		buff.append(")");
	}

	protected abstract IFunction map(Object anObject);

	public int size() {
		return _delegate.size();
	}

	public String getName() {
		StringBuffer buff = new StringBuffer();
		appendName(buff, 0, 10);
		return buff.toString();
	}
}