package de.uniwue.ki.mas.basics.function;
import java.util.*;

import junit.framework.Assert;
import de.uniwue.ki.util.name.AbstractNamed;

/**
 * Creation date: (16.01.2002 19:50:21)
 * @author Christoph Oechslein
 */

public class FunctionList extends ArrayList implements IFunctionList {

	public FunctionList() {
		super();
	}

	public FunctionList(int size) {
		super(size);
	}

	public FunctionList(IFunction function) {
		super();
		add(function);
	}

	public FunctionList(IFunction function1, IFunction function2) {
		super();
		add(function1);
		add(function2);
	}

	public FunctionList(IFunction function1, IFunction function2, IFunction function3) {
		super();
		add(function1);
		add(function2);
		add(function3);
	}

	public FunctionList(Iterator functions) {
		super();

		while (functions.hasNext()) {
			add(functions.next());
		}
	}

	public FunctionList(List functionList) {
		super(functionList);

		Iterator it = functionList.iterator();
		while (it.hasNext()) {
			if (Assert.ASSERTION_ON)
				Assert.assertTrue(it.next() instanceof IFunction);
		}
	}

	public void add(int index, Object element) {
		Assert.assertTrue(element instanceof IFunction);

		super.add(index, element);
	}

	public boolean add(Object element) {
		Assert.assertTrue(element instanceof IFunction);

		return super.add(element);
	}

	public IFunction getFunction(int index) {
		return (IFunction) get(index);
	}

	public String getName() {
		StringBuffer buff = new StringBuffer();
		appendName(buff, 0, 10);
		return buff.toString();
	}

	public void appendName(StringBuffer buff, int currDepth, int maxDepth) {
		buff.append("(");
		AbstractNamed.append(iterator(), buff, currDepth, maxDepth);
		buff.append(")");
	}

	public Object set(int index, Object element) {
		Assert.assertTrue(element instanceof IFunction);

		return super.set(index, element);
	}
}