package de.uniwue.ki.mas.basics.function;
import de.uniwue.ki.mas.basics.functionArgument.IArgumentBindings;
import de.uniwue.ki.mas.basics.functionArgument.IFunctionArgument;
import de.uniwue.ki.mas.model.SimulationRuntimeException;
/**
 * For executing <code>IFunction</code>s.
 * Creation date: (06.12.2000 10:05:04)
 *
 * @see IFunction#execute(IExecuteFunctionArgs)
 * @author Christoph Oechslein
 */

public interface IExecuteFunctionArgs extends IFunctionArgs {

	Object getArgumentValueFor(IFunctionArgument functionArgument) throws SimulationRuntimeException;

	void popArgumentBindings() throws SimulationRuntimeException;

	void pushArgumentBindings(IArgumentBindings argumentBindings) throws SimulationRuntimeException;

	IArgumentBindings saveCurrentArgumentBindings();
	
	public void clearArgumentBindings();
	
	public boolean hasArgumentBindings();
}