package de.uniwue.ki.mas.basics.function;

import java.io.Serializable;

import de.uniwue.ki.mas.basics.functionDeclaration.FunctionDeclarationCompiler;
import de.uniwue.ki.util.IRemoveable;

/**
 * Encapsulate a binding environment for compiling, executing or interpreting <code>IFunction</code>s.
 * Creation date: (06.12.2000 10:05:04)
 * @author Christoph Oechslein
 */

public interface IFunctionArgs extends IRemoveable, Serializable {

	/**
	 * Gets an <code>ICreateAndExecuteFunctionArgs</code> object
	 * for compiling (or interpreting) new <code>IFunction</code>s.
	 */
	ICreateAndExecuteFunctionArgs createCreateAndExecuteFunctionArgs();

	FunctionDeclarationCompiler getFunctionDeclarationCompiler();
}