package de.uniwue.ki.mas.basics.function;
import java.io.Serializable;
import java.util.*;

import de.uniwue.ki.util.collection.CollectionsHelper;
import de.uniwue.ki.util.name.INamed;
/**
 * A List of <code>IFunction</code>s.
 * <BR>Creation date: (11.05.00 09:52:10)
 *
 * @author Christoph Oechslein
 * @see IFunction
 */

public interface IFunctionList extends List, INamed, Serializable {
	/**
	* An empty list like {@link java.util.Collections#EMPTY_LIST EMPTY_LIST}.
	*/
	IFunctionList EMPTY_FUNCTION_LIST = new IFunctionList() {
		public void add(int index, Object element) {
			throw new UnsupportedOperationException();
		}
		public boolean add(Object o) {
			throw new UnsupportedOperationException();
		}
		public boolean addAll(int index, Collection c) {
			throw new UnsupportedOperationException();
		}
		public boolean addAll(Collection c) {
			throw new UnsupportedOperationException();
		}
		public void clear() {
		}
		public boolean contains(Object o) {
			return false;
		}
		public boolean containsAll(Collection c) {
			return false;
		}
		public Object get(int index) {
			throw new IndexOutOfBoundsException();
		}
		public IFunction getFunction(int index) {
			throw new IndexOutOfBoundsException();
		}

		public int indexOf(Object o) {
			return -1;
		}
		public boolean isEmpty() {
			return true;
		}
		public Iterator iterator() {
			return CollectionsHelper.EMPTY_ITERATOR;
		}
		public int lastIndexOf(Object o) {
			throw new UnsupportedOperationException();
		}
		public ListIterator listIterator() {
			return CollectionsHelper.EMPTY_LISTITERATOR;
		}
		public ListIterator listIterator(int index) {
			return CollectionsHelper.EMPTY_LISTITERATOR;
		}
		public Object remove(int index) {
			throw new UnsupportedOperationException();
		}
		public boolean remove(Object o) {
			throw new UnsupportedOperationException();
		}
		public boolean removeAll(Collection c) {
			if (c.isEmpty()) {
				return false;
			} else {
				throw new UnsupportedOperationException();
			}
		}
		public boolean retainAll(Collection c) {
			if (c.isEmpty()) {
				return false;
			} else {
				throw new UnsupportedOperationException();
			}
		}
		public Object set(int index, Object element) {
			throw new UnsupportedOperationException();
		}
		public int size() {
			return 0;
		}
		public List subList(int fromIndex, int toIndex) {
			if (fromIndex == 0 && toIndex == 0) {
				return this;
			} else {
				throw new IndexOutOfBoundsException();
			}
		}
		public Object[] toArray() {
			return new Object[] {
			};
		}
		public Object[] toArray(Object[] a) {
			return a;
		}

		public String getName() {
			return "()";
		}

		public void appendName(StringBuffer buff, int currDepth, int maxDepth) {
			buff.append("()");
		}
	};

	IFunction getFunction(int index);
}