package de.uniwue.ki.mas.basics.function;
import java.util.AbstractList;
import java.util.RandomAccess;
/**
 * Creation date: (20.12.2001 11:08:42)
 * @author Christoph Oechslein
 */

public class SingletonFunctionList extends AbstractList implements IFunctionList, RandomAccess {
	private final IFunction _function;

	public SingletonFunctionList(IFunction function) {
		super();

		_function = function;
	}

	public Object get(int index) {
		if (index != 0) {
			throw new IndexOutOfBoundsException();
		}

		return getFunction();
	}

	private final IFunction getFunction() {
		return _function;
	}

	public IFunction getFunction(int index) {
		if (index != 0) {
			throw new IndexOutOfBoundsException();
		}

		return getFunction();
	}

	public String getName() {
		return "(" + _function.getName() + ")";
	}

	public void appendName(StringBuffer buff, int currDepth, int maxDepth) {
		if (currDepth >= maxDepth) {
			buff.append("...");
		} else {
			buff.append("(");
			_function.appendName(buff, currDepth + 1, maxDepth);
			buff.append(")");
		}
	}

	public int size() {
		return 1;
	}
}