package de.uniwue.ki.mas.basics.function;
import java.util.AbstractList;
import java.util.RandomAccess;
/**
 * Creation date: (16.01.2002 19:56:45)
 * @author Christoph Oechslein
 */

public class TwoFunctionList extends AbstractList implements IFunctionList, RandomAccess {
	private final IFunction _functionA;
	private final IFunction _functionB;

	public TwoFunctionList(IFunction functionA, IFunction functionB) {
		super();

		_functionA = functionA;
		_functionB = functionB;
	}

	public Object get(int index) {
		if (index == 0) {
			return getFunctionA();

		} else if (index == 1) {
			return getFunctionB();

		} else {
			throw new IndexOutOfBoundsException();
		}
	}

	public IFunction getFunction(int index) {
		return (IFunction) get(index);
	}

	private final IFunction getFunctionA() {
		return _functionA;
	}

	private final IFunction getFunctionB() {
		return _functionB;
	}

	public String getName() {
		StringBuffer buff = new StringBuffer();
		appendName(buff, 0, 10);
		return buff.toString();
	}

	public void appendName(StringBuffer buff, int currDepth, int maxDepth) {
		if (currDepth >= maxDepth) {
			buff.append("...");
		} else {
			buff.append("(");
			getFunctionA().appendName(buff, currDepth + 1, maxDepth);
			buff.append(", ");
			getFunctionB().appendName(buff, currDepth + 1, maxDepth);
			buff.append(")");
		}
	}

	public int size() {
		return 2;
	}
}