package de.uniwue.ki.mas.basics.function;

import junit.framework.TestSuite;
import de.uniwue.ki.mas.basics.functionDeclaration.FunctionDeclarationCompiler;

/**
 * @author oechslein
 * 
 * Creation date: 20.05.2003
 */
public class WithAllCompilerSettingsTestSuite extends TestSuite {
	public WithAllCompilerSettingsTestSuite(String name) {
		super(name);
	}

	public void addTestSuite(Class testClass) {
		boolean oldCompileSetting = FunctionDeclarationCompiler.isDefaultCompileOn();
		boolean oldInlineSetting = FunctionDeclarationCompiler.isDefaultInlineOn();

		try {
			setCompilerSettings(true, true);
			super.addTestSuite(testClass);

			setCompilerSettings(true, false);
			super.addTestSuite(testClass);

			setCompilerSettings(false, false);
			super.addTestSuite(testClass);

		} finally {
			FunctionDeclarationCompiler.setDefaultCompileOn(oldCompileSetting);
			FunctionDeclarationCompiler.setDefaultInlineOn(oldInlineSetting);
		}
	}

	private void setCompilerSettings(boolean compileOn, boolean inlineOn) {
		FunctionDeclarationCompiler.setDefaultCompileOn(compileOn);
		FunctionDeclarationCompiler.setDefaultInlineOn(inlineOn);
	}
}
