package de.uniwue.ki.mas.basics.function.bool;

import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

public abstract class AbstractBooleanFunction extends AbstractFunction implements IFunction {

/**
 * Just return the result of {@link #executeForBoolean(IExecuteFunctionArgs)}.
 */
public final Object execute(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
    return executeForBoolean(executeFunctionArgs) ? Boolean.TRUE : Boolean.FALSE;
}

/**
 * Explicitly make this method abstract since {@link #execute(IExecuteFunctionArgs)}
 * calls it.
 */
public abstract boolean executeForBoolean(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException;
}
