package de.uniwue.ki.mas.basics.function.bool;

import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.IFunctionList;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class FunctionAnd extends AbstractBooleanFunction {
	private final IFunctionList _functions;

	public FunctionAnd(IFunctionList functions) {
		super();
		this._functions = functions;
	}

	/**
	 * @param executeFunctionArgs IExecuteFunctionArgs
	 * @return boolean
	 * @throws SimulationRuntimeException
	 * @see de.uniwue.ki.mas.basics.function.IFunction#executeForBoolean(IExecuteFunctionArgs)
	 */
	public boolean executeForBoolean(IExecuteFunctionArgs executeFunctionArgs)
		throws SimulationRuntimeException {
		return executeForBoolean(_functions, executeFunctionArgs);
	}

	/**
	 * @return String
	 * @see de.uniwue.ki.util.INamed#getName()
	 */
	public String getName() {
		return "And" + _functions.getName();
	}

	/**
	 * @param functions IFunctionList
	 * @param executeFunctionArgs IExecuteFunctionArgs
	 * @return boolean
	 * @throws SimulationRuntimeException
	 */
	public static final boolean executeForBoolean(
		IFunctionList functions,
		IExecuteFunctionArgs executeFunctionArgs)
		throws SimulationRuntimeException {

		for (int i = 0; i < functions.size(); i++) {
			if (!functions.getFunction(i).executeForBoolean(executeFunctionArgs)) {
				return false;
			}

		}

		return true;
	}
}
