// $Id: FunctionEqualDouble.java,v 1.2 2004/02/03 15:17:51 herrler Exp $
package de.uniwue.ki.mas.basics.function.bool;

import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.model.SimulationRuntimeException;
import de.uniwue.ki.util.math.MathHelper;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class FunctionEqualDouble extends AbstractBooleanFunction {
	private final IFunction _doubleFunction1;
	private final IFunction _doubleFunction2;

	public FunctionEqualDouble(IFunction doubleFunction1, IFunction doubleFunction2) {
		super();

		_doubleFunction1 = doubleFunction1;
		_doubleFunction2 = doubleFunction2;
	}

	public final boolean executeForBoolean(IExecuteFunctionArgs executeFunctionArgs)
		throws SimulationRuntimeException {
		return MathHelper.doubleEqual(
			_doubleFunction1.executeForDouble(executeFunctionArgs),
			_doubleFunction2.executeForDouble(executeFunctionArgs));
	}

	public String getName() {
		return "(" + _doubleFunction1.getName() + " == " + _doubleFunction2.getName() + ")";
	}
}
