// $Id: FunctionEqualInteger.java,v 1.2 2004/02/03 15:17:51 herrler Exp $
package de.uniwue.ki.mas.basics.function.bool;

import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class FunctionEqualInteger extends AbstractBooleanFunction {
	private final IFunction _intFunction1;
	private final IFunction _intFunction2;

	public FunctionEqualInteger(IFunction intFunction1, IFunction intFunction2) {
		super();

		_intFunction1 = intFunction1;
		_intFunction2 = intFunction2;
	}

	public final boolean executeForBoolean(IExecuteFunctionArgs executeFunctionArgs)
		throws SimulationRuntimeException {
		return _intFunction1.executeForInt(executeFunctionArgs)
			== _intFunction2.executeForInt(executeFunctionArgs);
	}

	public String getName() {
		return "(" + _intFunction1.getName() + " == " + _intFunction2.getName() + ")";
	}
}
