package de.uniwue.ki.mas.basics.function.bool;

import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.model.SimulationRuntimeException;
import de.uniwue.ki.util.math.MathHelper;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class FunctionLessOrEqual extends AbstractBooleanFunction {
	private final IFunction numberFunction1;
	private final IFunction numberFunction2;

	public FunctionLessOrEqual(IFunction numberFunction1, IFunction numberFunction2) {
		super();
		this.numberFunction1 = numberFunction1;
		this.numberFunction2 = numberFunction2;
	}

	public final boolean executeForBoolean(IExecuteFunctionArgs executeFunctionArgs)
		throws SimulationRuntimeException {
		return MathHelper.doubleLowerEqual(
			numberFunction1.executeForDouble(executeFunctionArgs),
			numberFunction2.executeForDouble(executeFunctionArgs));
	}

	public String getName() {
		return "(" + numberFunction1.getName() + " <= " + numberFunction2.getName() + ")";
	}
}
