package de.uniwue.ki.mas.basics.function.bool;

import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class FunctionNot extends AbstractBooleanFunction {
	private final IFunction _booleanFunction;

	public FunctionNot(IFunction booleanFunction) {
		super();

		_booleanFunction = booleanFunction;
	}

	public boolean executeForBoolean(IExecuteFunctionArgs executeFunctionArgs)
		throws SimulationRuntimeException {
		return !getBooleanFunction().executeForBoolean(executeFunctionArgs);
	}

	public String getName() {
		return "Not(" + getBooleanFunction().getName() + ")";
	}

	final IFunction getBooleanFunction() {
		return _booleanFunction;
	}
}
