package de.uniwue.ki.mas.basics.function.bool;

import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.IFunctionList;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class FunctionOr extends AbstractBooleanFunction {
	private final IFunctionList _functions;

	public FunctionOr(IFunctionList functions) {
		super();

		_functions = functions;
	}

	public final boolean executeForBoolean(IExecuteFunctionArgs executeFunctionArgs)
		throws SimulationRuntimeException {
		return executeForBoolean(_functions, executeFunctionArgs);
	}

	public String getName() {
		return "Or" + _functions.getName();
	}

	public static final boolean executeForBoolean(
		IFunctionList functions,
		IExecuteFunctionArgs executeFunctionArgs)
		throws SimulationRuntimeException {

		for (int i = 0; i < functions.size(); i++) {
			if (functions.getFunction(i).executeForBoolean(executeFunctionArgs)) {
				return true;
			}

		}

		return false;
	}
	public IFunctionList getFunctions() {
		return _functions;
	}
}
