package de.uniwue.ki.mas.basics.function.expertlist;
import java.util.Collection;
import java.util.Iterator;

import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.model.SimulationRuntimeException;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * @author Rainer Herrler
 */
public class CopyListFunction extends AbstractFunctionDynamic {
	private final IFunction _functionList;

	public CopyListFunction(IFunction functionList) {
		super();

		_functionList = functionList;
	}

	public Object execute(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
		Object obj = _functionList.execute(executeFunctionArgs);

		if (obj instanceof Collection)
			return CollectionsHelper.copyCollection((Collection)obj);
		else if (obj instanceof Iterator)
			return CollectionsHelper.asArrayList((Iterator)obj);
		else
			throw new SimulationRuntimeException(
				"Expected List and got " + obj.getClass() + " as Parameter ");
	}

	public String getName() {
		return "CopyList (" + _functionList.getName() + ")";
	}
}