package de.uniwue.ki.mas.basics.function.expertlist;
import java.util.Iterator;

import de.uniwue.ki.mas.basics.functionDeclaration.AbstractGenericFunctionDeclarationWithoutDependents;
import de.uniwue.ki.mas.basics.functionDeclaration.ISpecificFunctionDeclaration;
import de.uniwue.ki.mas.basics.type.*;
/**
 * @author Rainer Herrler
 */

final class CopyListGenericFunctionDeclaration extends AbstractGenericFunctionDeclarationWithoutDependents {
	private static final CopyListGenericFunctionDeclaration _instance = new CopyListGenericFunctionDeclaration();

	public CopyListGenericFunctionDeclaration() {
		super("CopyList", GenericListType.getInstance());

		setDocumentation("Creates a copy (be carefull not a deep copy) of the list");
	}

	public ISpecificFunctionDeclaration createFunctionDeclaration(ISpecificType outputType) {
		SpecificListType outputSpecificSetType;

		if (outputType == ObjectType.getInstance()) {
			outputSpecificSetType =
				GenericListType.getInstance().createSpecificListType(ObjectType.getInstance());
		} else {
			outputSpecificSetType = (SpecificListType) outputType;
		}

		return new CopyListSpecificFunctionDeclaration(outputSpecificSetType);
	}

	public ISpecificFunctionDeclaration createFunctionDeclaration(Iterator inputArgs) {
		
		ISpecificType specificTypeB = getNextSpecificType(inputArgs);
		if (inputArgs.hasNext()) return null;

		if (!(specificTypeB instanceof SpecificListType))
			return null;

		SpecificListType specificSetType = (SpecificListType) specificTypeB;

		return createFunctionDeclaration(specificSetType);
	}

	public String getSignatureWithoutNameAndOutputType(ISpecificType outputType) {
		
		SpecificListType specificSetType;

		if (outputType == ObjectType.getInstance()) {
			specificSetType =
				GenericListType.getInstance().createSpecificListType(ObjectType.getInstance());
		} else {
			specificSetType = (SpecificListType) outputType;
		}

		return "("
			+ specificSetType.getName()
			+ ")";
	}

	public static final CopyListGenericFunctionDeclaration getInstance() {
		return _instance;
	}
}