package de.uniwue.ki.mas.basics.function.expertlist;
import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionAdapterGenericFunctionDeclaration;
import de.uniwue.ki.mas.basics.type.ISpecificType;
import de.uniwue.ki.mas.basics.type.SpecificListType;

/**
* @author Rainer Herrler
*/
final class CopyListSpecificFunctionDeclaration
	extends AbstractSpecificFunctionAdapterGenericFunctionDeclaration {
	private final SpecificListType _specificSetOutputType;

	public CopyListSpecificFunctionDeclaration(SpecificListType specificSetOutputType) {
		super(CopyListGenericFunctionDeclaration.getInstance(), 1);

		_specificSetOutputType = specificSetOutputType;
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions) {
		if (Assert.ASSERTION_ON)
			Assert.assertEquals(1, functions.size());
		return new CopyListFunction((IFunction) functions.get(0));
	}

	public ISpecificType getSpecificInputTypeAt(int index) {
		if (index == 0) {
			return _specificSetOutputType;

		} else {
			Assert.fail();
			return null;
		}
	}

	public ISpecificType getSpecificOutputType() {
		return _specificSetOutputType;
	}
}