// $Id: ExpertListFeatureClassDeclaration.java,v 1.1 2004/02/02 10:34:52 herrler Exp $
package de.uniwue.ki.mas.basics.function.expertlist;
import java.util.Iterator;

import de.uniwue.ki.mas.basics.feature.AbstractFeaturePlusObjectFeatureClassDeclaration;
import de.uniwue.ki.mas.basics.feature.IFeatureClassDeclaration;
import de.uniwue.ki.mas.basics.functionDeclaration.list.FunctionDeclarationList;
import de.uniwue.ki.mas.basics.functionDeclaration.list.IFunctionDeclarationList;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * @author Rainer Herrler  
 */

public final class ExpertListFeatureClassDeclaration extends AbstractFeaturePlusObjectFeatureClassDeclaration implements IFeatureClassDeclaration{

	private static final ExpertListFeatureClassDeclaration _instance = new ExpertListFeatureClassDeclaration();
	private IFunctionDeclarationList _functionDeclarationList;
	private IFunctionDeclarationList _defaultFunctionDeclarationList;

	public ExpertListFeatureClassDeclaration() {
		super("ExpertListFunctions");
	}

	private IFunctionDeclarationList getFunctionDeclarationList() {
		if (_functionDeclarationList == null) {
			synchronized (this) {
				if (_functionDeclarationList == null) {
					_functionDeclarationList = new FunctionDeclarationList();
					//_functionDeclarationList.add(new FunctionDeclarationStartJade());
				}
			}
		}
		return _functionDeclarationList;
	}
	
	public Iterator getFunctionDeclarations() {
		return getFunctionDeclarationList().iterator();
	}

	
	private IFunctionDeclarationList getDefaultFunctionDeclarationList() {
		if (_defaultFunctionDeclarationList == null) {
			synchronized (this) {
				if (_defaultFunctionDeclarationList == null) {
					// Expert List Functions Declarations
					_defaultFunctionDeclarationList = new FunctionDeclarationList();
					
					_defaultFunctionDeclarationList.add(new RemoveDuplicatesGenericFunctionDeclaration());
					_defaultFunctionDeclarationList.add(new CopyListGenericFunctionDeclaration());
					_defaultFunctionDeclarationList.add(new PopAndReturnFirstGenericFunctionDeclaration());
				}
			}
		}

		return _defaultFunctionDeclarationList;
	}


	public Iterator getDefaultFunctionDeclarations() {
		return getDefaultFunctionDeclarationList().iterator();
	}


	public static final ExpertListFeatureClassDeclaration getInstance() {
		return _instance;
	}

	public Iterator getVariableClassDeclarations() {
		return CollectionsHelper.EMPTY_ITERATOR;
	}
}