package de.uniwue.ki.mas.basics.function.expertlist;
import java.util.LinkedList;
import java.util.List;

import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.function.iterator.EmptyIteratorSimulationRuntimeException;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

class FunctionPopAndReturnFirst extends AbstractFunctionDynamic implements IFunction {
	private final IFunction _functionList;

	public FunctionPopAndReturnFirst(IFunction functionList) {
		super();

		_functionList = functionList;
	}


	public Object execute(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
		List list = (List) _functionList.execute(executeFunctionArgs);

		if (list == null)
			throw new SimulationRuntimeException("List is null");

		if (list.isEmpty()) {
			throw new EmptyIteratorSimulationRuntimeException();
		}

		if (list instanceof LinkedList)
			return ((LinkedList) list).removeFirst();
		else
			return list.remove(0);
	}


	public String getName() {
		return getFunctionName() + "(" + _functionList.getName() + ")";
	}

	protected String getFunctionName() {
		return "Pop&ReturnFirst";
	}
}