package de.uniwue.ki.mas.basics.function.expertlist;
import java.util.Collection;
import java.util.Iterator;

import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.model.SimulationRuntimeException;
import de.uniwue.ki.util.collection.CollectionsHelper;
/**
 * @author Rainer Herrler
 */
public class RemoveDuplicatesFunction extends AbstractFunctionDynamic {
	private final IFunction _functionList;

	public RemoveDuplicatesFunction(IFunction functionList) {
		super();

		_functionList = functionList;
	}

	public Object execute(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
		Object obj = _functionList.execute(executeFunctionArgs);
		Iterator list = null;

		if (obj instanceof Collection)
			list = ((Collection)obj).iterator();
		else if (obj instanceof Iterator)
			list = (Iterator)obj;
		else
			throw new SimulationRuntimeException(
				"Expected List and got " + obj.getClass() + " as Parameter ");

		if (list == null)
			throw new SimulationRuntimeException("List is empty in " + getName());

		return CollectionsHelper.removeDuplicates(list);
	}

	public String getName() {
		return "RemoveDuplicates (" + _functionList.getName() + ")";
	}
}