package de.uniwue.ki.mas.basics.function.expertlist;
import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionArgsDeclaration;
import de.uniwue.ki.mas.basics.functionDeclaration.IGenericFunctionDeclaration;
import de.uniwue.ki.mas.basics.type.SpecificIteratorType;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
* @author Rainer Herrler
*/
final class RemoveDuplicatesSpecificFunctionDeclaration
	extends AbstractSpecificFunctionArgsDeclaration {
	private final SpecificIteratorType _specificSetOutputType;

	public RemoveDuplicatesSpecificFunctionDeclaration(SpecificIteratorType specificSetOutputType) {
		super(RemoveDuplicatesGenericFunctionDeclaration.getInstance().getName(), 
		specificSetOutputType,
		CollectionsHelper.createList(specificSetOutputType)
		);
		
		setDocumentation("dynamic Declaration");

		_specificSetOutputType = specificSetOutputType;
	}
	

	public IGenericFunctionDeclaration getGenericFunctionDeclaration() {
		return RemoveDuplicatesGenericFunctionDeclaration.getInstance();
	}


	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions) {
		if (Assert.ASSERTION_ON)
			Assert.assertEquals(1, functions.size());
		return new RemoveDuplicatesFunction((IFunction) functions.get(0));
	}
}