package de.uniwue.ki.mas.basics.function.function;

import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.type.AbstractSpecificFunctionType;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

final class FuncallFunction extends AbstractFunctionDynamic {
	private final IFunction _functionFunction;

	public FuncallFunction(IFunction functionFunction) {
		super();

		_functionFunction = functionFunction;
	}

	public Object execute(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
		Object parametricFunction = _functionFunction.execute(executeFunctionArgs);

		try {
			return AbstractSpecificFunctionType
				.getParametricFunction(parametricFunction)
				.createFunction(
					executeFunctionArgs.createCreateAndExecuteFunctionArgs(),
					IFunctionList.EMPTY_FUNCTION_LIST)
				.execute(executeFunctionArgs);

		} catch (ModelCompilingException exception) {
			throw new SimulationRuntimeException(exception);
		}
	}

	public String getName() {
		return "Funcall('" + _functionFunction.getName() + "')";
	}
}