package de.uniwue.ki.mas.basics.function.function;

import java.util.Iterator;

import de.uniwue.ki.mas.basics.functionDeclaration.AbstractGenericFunctionDeclarationWithoutDependents;
import de.uniwue.ki.mas.basics.functionDeclaration.ISpecificFunctionDeclaration;
import de.uniwue.ki.mas.basics.type.*;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * funcall: <T1> funcall(<T1> function())
 * T2 is unspecific
 * Creation date: (27.10.2000 17:15:57)
 * @author Christoph Oechslein
 */
class FuncallGenericFunctionDeclaration extends AbstractGenericFunctionDeclarationWithoutDependents {
	public FuncallGenericFunctionDeclaration() {
		super("Funcall", GenericType.getInstance());

		setExpertFunctionDeclaration(true);
		setDocumentation("Calls specified function (Arg1)");
	}

	public ISpecificFunctionDeclaration createFunctionDeclaration(Iterator inputTypes) {

		// funcall: <T1> funcall(<T1> function())
		// T2 is unspecific

		ISpecificType specificTypeA = getNextSpecificType(inputTypes);

		if ((specificTypeA == null) || (inputTypes.hasNext()))
			return null;

		if (!(specificTypeA instanceof ISpecificFunctionType))
			return null;

		ISpecificFunctionType specificFunctionType = (ISpecificFunctionType)specificTypeA;

		if (specificFunctionType.getSpecificInputTypesLength() != 0)
			return null;

		return new FuncallSpecificFunctionArgsDeclaration(this, specificFunctionType);
	}

	public ISpecificFunctionDeclaration createFunctionDeclaration(ISpecificType outputType) {
		return new FuncallSpecificFunctionArgsDeclaration(
			this,
			GenericFunctionType.getInstance().createSpecificFunctionType(
				outputType,
				CollectionsHelper.EMPTY_LIST));
	}

	public String getSignatureWithoutNameAndOutputType(ISpecificType outputType) {
		return "(Fun<() " + outputType.getName() + ">)";
	}
}