package de.uniwue.ki.mas.basics.function.function;

import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionCall.IComposedFunctionCallInternDeclaration;
import de.uniwue.ki.mas.basics.functionCall.IFunctionCallInternDeclaration;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionAdapterGenericFunctionDeclaration;
import de.uniwue.ki.mas.basics.type.*;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

// funcall: <T1> funcall(<T1> function(<T2>), <T2>)
// T2 is unspecific

final class FuncallSpecificFunctionArgsDeclaration
	extends AbstractSpecificFunctionAdapterGenericFunctionDeclaration {

	private final ISpecificFunctionType _specificFunctionType;

	public FuncallSpecificFunctionArgsDeclaration(
		FuncallGenericFunctionDeclaration funcallGenericFunctionDeclaration,
		ISpecificFunctionType specificFunctionType) {
		super(funcallGenericFunctionDeclaration, 1);

		_specificFunctionType = specificFunctionType;
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions)
		throws ModelCompilingException {

		throw new UnsupportedOperationException();
	}

	public ISpecificType getSpecificInputTypeAt(int index) {
		if (index == 0)
			return _specificFunctionType;

		else {
			Assert.fail();
			return null;
		}
	}

	public IFunction createFunction(
		ICreateFunctionArgs createFunctionArgs,
		IComposedFunctionCallInternDeclaration composedFunctionCallInternDeclaration)
		throws ModelCompilingException {

		Assert.assertEquals(1, composedFunctionCallInternDeclaration.getChildCount());
		IFunctionCallInternDeclaration functionFunctionCallDeclaration =
			composedFunctionCallInternDeclaration.getChild(0);

		if (functionFunctionCallDeclaration.isConstant(createFunctionArgs)) {
			try {
				Object parametricFunction =
					functionFunctionCallDeclaration.createFunction(createFunctionArgs).execute(
						createFunctionArgs.createCreateAndExecuteFunctionArgs());

				return AbstractSpecificFunctionType.getParametricFunction(parametricFunction).createFunction(
					createFunctionArgs,
					IFunctionList.EMPTY_FUNCTION_LIST);

			} catch (SimulationRuntimeException exception) {
				throw new ModelCompilingException(exception);
			}

		} else {
			return new FuncallFunction(functionFunctionCallDeclaration.createFunction(createFunctionArgs));
		}
	}

	public ISpecificType getSpecificOutputType() {
		return _specificFunctionType.getSpecificOutputType();
	}
}