package de.uniwue.ki.mas.basics.function.function;
import de.uniwue.ki.mas.basics.functionDeclaration.list.FunctionDeclarationList;
import de.uniwue.ki.mas.basics.functionDeclaration.list.IFunctionDeclarationList;

/**
 * Creation date: (19.12.2001 11:13:47)
 * @author Christoph Oechslein
 */

public final class FunctionDeclarationFunctionFactory {

    private static IFunctionDeclarationList _cachedFunctionDeclarationList;

    public static void insertFunctions(IFunctionDeclarationList functionDeclarationList) {
                if (_cachedFunctionDeclarationList == null) {
                    _cachedFunctionDeclarationList = new FunctionDeclarationList();
                    insertFunctionsIntern(_cachedFunctionDeclarationList);
                }

        functionDeclarationList.addAll(_cachedFunctionDeclarationList);
    }

    private static void insertFunctionsIntern(IFunctionDeclarationList functionDeclarationList) {
        // bindFirst: <T1> function(<T2>) bindFirst (<T3>, <T1> function(<T3>,<T2>))
        // T3 is unspecific
        functionDeclarationList.add(new BindFirstGenericFunctionDeclaration());

        // bindSecond: <T1> function(<T2>) bindFirst (<T3>, <T1> function(<T3>,<T2>))
        // T3 is unspecific
        functionDeclarationList.add(new BindSecondGenericFunctionDeclaration());

        // rotateArgs: <T1> function(<T3>, <T2>) rotateArgs (<T1> function(<T2>, <T3>))
        // T2, T3 are unspecific
        functionDeclarationList.add(new RotateArgsGenericFunctionDeclaration());

        // funcall: <T1> funcall(<T1> function())
        // T2 is unspecific
        functionDeclarationList.add(new FuncallGenericFunctionDeclaration());

        // TwoArgsToUnlimitedArgs: <T1> function(&rest <T1>) twoArgsToUnlimitedArgs (<T1> function(<T1>, <T1>)  , <T1>)
        functionDeclarationList.add(TwoArgFunctionToUnlimitedArgsGenericFunctionDeclaration.getInstance());
        
        
    }
}