package de.uniwue.ki.mas.basics.function.function;
import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.type.AbstractSpecificFunctionType;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * // TwoArgsToUnlimitedArgs: <T1> function(&rest <T1>) twoArgsToUnlimitedArgs (<T1> function(<T1>, <T1>)  , <T1>)
 * Creation date: (17.07.2001 10:30:42)
 * @author Christoph Oechslein
 */

final class FunctionTwoArgUnlimArgs extends AbstractFunctionDynamic {

	private final FunctionTwoArgUnlimArgsGenerater _functionTwoArgUnlimArgsGenerater;
	private IFunctionList _functions;
	private final TwoObjectFunctionList _twoObjectFunctionList = new TwoObjectFunctionList();

	public FunctionTwoArgUnlimArgs(
		FunctionTwoArgUnlimArgsGenerater functionTwoArgUnlimArgsGenerater,
		IFunctionList functions) {
		super();

		_functionTwoArgUnlimArgsGenerater = functionTwoArgUnlimArgsGenerater;
		setFunctions(functions);
	}

	public FunctionTwoArgUnlimArgs(FunctionTwoArgUnlimArgsGenerater functionTwoArgUnlimArgsGenerater) {
		super();

		_functionTwoArgUnlimArgsGenerater = functionTwoArgUnlimArgsGenerater;
	}

	public void setFunctions(IFunctionList functions) {
		_functions = functions;
	}

	public Object execute(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {

		Assert.assertNotNull(_functionTwoArgUnlimArgsGenerater._reduceFunctionFunction);
		Assert.assertNotNull(_functionTwoArgUnlimArgsGenerater._startValueFunction);
		Assert.assertNotNull(_functions);

		ICreateAndExecuteFunctionArgs createAndExecuteFunctionArgs =
			executeFunctionArgs.createCreateAndExecuteFunctionArgs();
		Object startValue =
			_functionTwoArgUnlimArgsGenerater._startValueFunction.execute(executeFunctionArgs);
		Object reduceFunction =
			_functionTwoArgUnlimArgsGenerater._reduceFunctionFunction.execute(executeFunctionArgs);

		try {
			Object result = startValue;

			for (int i = 0; i < _functions.size(); i++) {
				IFunction nextFunction = _functions.getFunction(i);

				_twoObjectFunctionList.setFunctionObjectA(result);
				_twoObjectFunctionList.setFunctionB(nextFunction);

				result =
					AbstractSpecificFunctionType.getParametricFunction(reduceFunction).execute(
						createAndExecuteFunctionArgs,
						_twoObjectFunctionList);
			}

			return result;

		} catch (ModelCompilingException exception) {
			throw new SimulationRuntimeException(exception);
		}
	}
}