package de.uniwue.ki.mas.basics.function.function;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionUnlimitedArgsDeclaration;
import de.uniwue.ki.mas.basics.type.ISpecificType;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * // TwoArgsToUnlimitedArgs: <T1> function(&rest <T1>) twoArgsToUnlimitedArgs (<T1> function(<T1>, <T1>)  , <T1>)
 * Creation date: (17.07.2001 10:30:42)
 * @author Christoph Oechslein
 */

final class FunctionTwoArgUnlimArgsGenerater extends AbstractFunction {

	private final ISpecificType _outputType;
	IFunction _startValueFunction;
	IFunction _reduceFunctionFunction;

	public FunctionTwoArgUnlimArgsGenerater(ISpecificType outputType) {

		super();

		_outputType = outputType;
	}

	public Object execute(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
		return new AbstractSpecificFunctionUnlimitedArgsDeclaration(
			"dynamic function",
			_outputType,
			_outputType,
			true) {

			private final FunctionTwoArgUnlimArgs _staticFunctionTwoArgUnlimArgs =
				new FunctionTwoArgUnlimArgs(FunctionTwoArgUnlimArgsGenerater.this);

			public IFunction createFunction(
				ICreateFunctionArgs createFunctionArgs,
				IFunctionList functions) {
				_staticFunctionTwoArgUnlimArgs.setFunctions(functions);
				return _staticFunctionTwoArgUnlimArgs;
			}
		};
	}

	public String getName() {
		return "TwoArgsToUnlimArgs("
			+ _reduceFunctionFunction.getName()
			+ ", "
			+ _startValueFunction.getName()
			+ ")";
	}

	public void setReduceFunctionFunction(IFunction reduceFunctionFunction) {
		_reduceFunctionFunction = reduceFunctionFunction;
	}

	public void setStartValueFunction(IFunction startValueFunction) {
		_startValueFunction = startValueFunction;
	}
}