package de.uniwue.ki.mas.basics.function.function;

import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionAdapterGenericFunctionDeclaration;
import de.uniwue.ki.mas.basics.type.ISpecificFunctionType;
import de.uniwue.ki.mas.basics.type.ISpecificType;

/**
 * @author oechslein
 * 
 * Creation date: 03.06.2003
 */
final class RotateArgsSpecificFunctionDeclaration
	extends AbstractSpecificFunctionAdapterGenericFunctionDeclaration {

	private final ISpecificFunctionType _outputFunctionTypeT1T3T2;
	private final ISpecificFunctionType _inputFunctionTypeT1T2T3;

	public RotateArgsSpecificFunctionDeclaration(
		RotateArgsGenericFunctionDeclaration genericFunctionDeclaration,
		ISpecificFunctionType outputFunctionTypeT1T3T2,
		ISpecificFunctionType inputFunctionTypeT1T2T3) {

		super(genericFunctionDeclaration, 1);

		_outputFunctionTypeT1T3T2 = outputFunctionTypeT1T3T2;
		_inputFunctionTypeT1T2T3 = inputFunctionTypeT1T2T3;
	}

	public ISpecificType getSpecificOutputType() {
		return _outputFunctionTypeT1T3T2;
	}

	public ISpecificType getSpecificInputTypeAt(int index) {
		if (index == 0) {
			return _inputFunctionTypeT1T2T3;
		} else {
			Assert.fail();
			return null;
		}
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions) {
		if (Assert.ASSERTION_ON)
			Assert.assertEquals(1, functions.size());

		return new RotateArgsFunction(functions.getFunction(0), _outputFunctionTypeT1T3T2);
	}
}