package de.uniwue.ki.mas.basics.function.function;
import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionAdapterGenericFunctionDeclaration;
import de.uniwue.ki.mas.basics.functionDeclaration.IGenericFunctionDeclaration;
import de.uniwue.ki.mas.basics.type.*;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * // TwoArgsToUnlimitedArgs: <T1> function(&rest <T1>) twoArgsToUnlimitedArgs (<T1> function(<T1>, <T1>)  , <T1>)
 * Creation date: (17.07.2001 10:30:42)
 * @author Christoph Oechslein
 */

final class TwoArgFunctionToUnlimitedArgsSpecificFunctionDeclaration
	extends AbstractSpecificFunctionAdapterGenericFunctionDeclaration {

	private final FunctionTwoArgUnlimArgsGenerater _staticFunctionTwoArgUnlimArgsGenerater;
	private final ISpecificFunctionType _outputType;

	public TwoArgFunctionToUnlimitedArgsSpecificFunctionDeclaration(
		IGenericFunctionDeclaration genericFunctionDeclaration,
		ISpecificFunctionType outputType) {

		super(genericFunctionDeclaration, 2);

		_outputType = outputType;
		_staticFunctionTwoArgUnlimArgsGenerater = new FunctionTwoArgUnlimArgsGenerater(outputType);
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions) {
		if (Assert.ASSERTION_ON)
			Assert.assertEquals(2, functions.size());

		_staticFunctionTwoArgUnlimArgsGenerater.setStartValueFunction(functions.getFunction(0));
		_staticFunctionTwoArgUnlimArgsGenerater.setReduceFunctionFunction(functions.getFunction(1));

		return _staticFunctionTwoArgUnlimArgsGenerater;
	}

	public ISpecificType getSpecificInputTypeAt(int index) {
		if (index == 0) {
			return _outputType.getSpecificOutputType();

		} else if (index == 1) {
			return GenericFunctionType.getInstance().createSpecificFunctionType(
				_outputType.getSpecificOutputType(),
				CollectionsHelper.createList(
					_outputType.getSpecificOutputType(),
					_outputType.getSpecificOutputType()));

		} else {
			Assert.fail();
			return null;
		}
	}

	public ISpecificType getSpecificOutputType() {
		return _outputType;
	}
}