package de.uniwue.ki.mas.basics.function.hashtable;

import java.util.Map;

import de.uniwue.ki.mas.basics.action.AbstractFunctionAction;
import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

final class ClearHashtableFunction extends AbstractFunctionAction {
	private final IFunction _hashTableFunction;

	public ClearHashtableFunction(IFunction hashTableFunction) {
		super();

		_hashTableFunction = hashTableFunction;
	}

	public void act(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
		Map map = (Map) _hashTableFunction.execute(executeFunctionArgs);

		if (map == null)
			throw new SimulationRuntimeException("Hashtable is null in " + getName());

		map.clear();
	}

	public String getName() {
		return "ClearHashtable(" + _hashTableFunction.getName() + ")";
	}
}
