package de.uniwue.ki.mas.basics.function.hashtable;

import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionAdapterGenericFunctionDeclaration;
import de.uniwue.ki.mas.basics.type.ISpecificType;
import de.uniwue.ki.mas.basics.type.SpecificHashtableType;
import de.uniwue.ki.mas.model.ModelCompilingException;

final class ClearHashtableSpecificFunctionDeclaration
	extends AbstractSpecificFunctionAdapterGenericFunctionDeclaration {

	private final SpecificHashtableType _specificHashtableType;

	public ClearHashtableSpecificFunctionDeclaration(
		ClearHashtableGenericFunctionDeclaration clearHashtableGenericFunctionDeclaration,
		SpecificHashtableType specificHashtableType) {

		super(clearHashtableGenericFunctionDeclaration, 1);

		_specificHashtableType = specificHashtableType;
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions)
		throws ModelCompilingException {

		Assert.assertEquals(1, functions.size());

		return new ClearHashtableFunction(functions.getFunction(0));
	}

	public ISpecificType getSpecificInputTypeAt(int index) {
		if (index == 0) {
			return _specificHashtableType;

		} else {
			Assert.fail();
			return null;
		}
	}
}