package de.uniwue.ki.mas.basics.function.hashtable;

import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionAdapterGenericFunctionDeclaration;
import de.uniwue.ki.mas.basics.type.ISpecificType;
import de.uniwue.ki.mas.basics.type.SpecificHashtableType;
import de.uniwue.ki.mas.model.ModelCompilingException;

/**
 * <T2> GetValue(<T1>, HashTable<T1,T2>)
 */

final class ContainsKeyOrValueSpecificFunctionDeclaration
	extends AbstractSpecificFunctionAdapterGenericFunctionDeclaration {

	private final SpecificHashtableType _specificHashtableType;

	public ContainsKeyOrValueSpecificFunctionDeclaration(
		ContainsKeyOrValueGenericFunctionDeclaration containsKeyOrValueGenericFunctionDeclaration,
		SpecificHashtableType specificHashtableType) {
		super(containsKeyOrValueGenericFunctionDeclaration, 2);

		_specificHashtableType = specificHashtableType;
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions)
		throws ModelCompilingException {

		Assert.assertEquals(2, functions.size());

		if (isContainsKey()) {
			return new ContainsKeyFunction(functions.getFunction(0), functions.getFunction(1));
		} else {
			return new ContainsValueFunction(functions.getFunction(0), functions.getFunction(1));
		}
	}

	public ISpecificType getSpecificInputTypeAt(int index) {
		if (index == 0) {
			return _specificHashtableType.getKeyType();

		} else if (index == 1) {
			return _specificHashtableType;

		} else {
			Assert.fail();
			return null;
		}
	}


	public String getSpecificInputTypeNameAt(int index) {
		if (index == 0) {
			if (isContainsKey()) {
				return "key";
			} else {
				return "value";
			}

		} else if (index == 1) {
			return "hashtable";

		} else {
			Assert.fail();
			return null;
		}
	}

	private boolean isContainsKey() {
		return ((ContainsKeyOrValueGenericFunctionDeclaration) getGenericFunctionDeclaration()).getType()
			== ContainsKeyOrValueGenericFunctionDeclaration.CONTAINS_KEY;
	}
}