package de.uniwue.ki.mas.basics.function.hashtable;

import de.uniwue.ki.mas.basics.functionDeclaration.IGenericFunctionDeclaration;
import de.uniwue.ki.mas.basics.functionDeclaration.list.FunctionDeclarationList;
import de.uniwue.ki.mas.basics.functionDeclaration.list.IFunctionDeclarationList;

public final class FunctionDeclarationHashTableFactory {

	public static final IGenericFunctionDeclaration CREATE_HASHTABLE_GENERIC_FUN_DECL =
		new CreateHashtableGenericFunctionDeclaration();

	private static IFunctionDeclarationList _cachedFunctionDeclarationList = new FunctionDeclarationList();

	static {
		insertFunctionsIntern();
	}

	public static void insertFunctions(IFunctionDeclarationList functionDeclarationList) {
		functionDeclarationList.addAll(_cachedFunctionDeclarationList);
	}

	private static void insertFunctionsIntern() {
		_cachedFunctionDeclarationList.add(new GetValueForKeyGenericFunctionDeclaration());

		_cachedFunctionDeclarationList.add(
			new ContainsKeyOrValueGenericFunctionDeclaration(
				ContainsKeyOrValueGenericFunctionDeclaration.CONTAINS_KEY));

		_cachedFunctionDeclarationList.add(
			new ContainsKeyOrValueGenericFunctionDeclaration(
				ContainsKeyOrValueGenericFunctionDeclaration.CONTAINS_VALUE));

		_cachedFunctionDeclarationList.add(new PutValueForKeyGenericFunctionDeclaration());

		_cachedFunctionDeclarationList.add(CREATE_HASHTABLE_GENERIC_FUN_DECL);

		_cachedFunctionDeclarationList.add(new ClearHashtableGenericFunctionDeclaration());

		_cachedFunctionDeclarationList.add(new RemoveKeyGenericFunctionDeclaration());

		_cachedFunctionDeclarationList.add(new GetValuesFromHashtableGenericFunctionDeclaration());

		_cachedFunctionDeclarationList.add(new GetKeysFromHashtableGenericFunctionDeclaration());
	}
}