package de.uniwue.ki.mas.basics.function.hashtable;

import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionAdapterGenericFunctionDeclaration;
import de.uniwue.ki.mas.basics.type.*;
import de.uniwue.ki.mas.model.ModelCompilingException;

/**
 * List< <T2> > GetKeysFromHashtable(HashTable<T1,T2>)
 */

final class GetKeysFromHashtableSpecificFunctionDeclaration
	extends AbstractSpecificFunctionAdapterGenericFunctionDeclaration {

	private final SpecificHashtableType _specificHashtableType;

	public GetKeysFromHashtableSpecificFunctionDeclaration(
		GetKeysFromHashtableGenericFunctionDeclaration getKeysFromHashtableGenericFunctionDeclaration,
		SpecificHashtableType specificHashtableType) {

		super(getKeysFromHashtableGenericFunctionDeclaration, 1);

		_specificHashtableType = specificHashtableType;
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions)
		throws ModelCompilingException {

		Assert.assertEquals(1, functions.size());

		return new GetKeysFromHashtableFunction(functions.getFunction(0));
	}

	public ISpecificType getSpecificInputTypeAt(int index) {
		if (index == 0) {
			return _specificHashtableType;

		} else {
			Assert.fail();
			return null;
		}
	}

	public ISpecificType getSpecificOutputType() {
		return GenericIteratorType.getInstance().createSpecificIteratorType(_specificHashtableType.getKeyType());
	}
}