package de.uniwue.ki.mas.basics.function.hashtable;

import java.util.Map;

import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

final class GetValueForKeyFunction extends AbstractFunctionDynamic {

	private final IFunction _keyValueFunction;
	private final IFunction _hashTableFunction;

	public GetValueForKeyFunction(IFunction keyValueFunction, IFunction hashTableFunction) {
		super();

		_keyValueFunction = keyValueFunction;
		_hashTableFunction = hashTableFunction;
	}

	public Object execute(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
		Object key = _keyValueFunction.execute(executeFunctionArgs);
		Map map = (Map) _hashTableFunction.execute(executeFunctionArgs);

		if (map == null)
			throw new SimulationRuntimeException("Hashtable is null in " + getName());

		return map.get(key);
	}

	public String getName() {
		return "GetValueForKey(" + _keyValueFunction.getName() + ", " + _hashTableFunction.getName() + ")";
	}
}