package de.uniwue.ki.mas.basics.function.hashtable;

import java.util.Map;

import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

final class GetValuesFromHashtableFunction extends AbstractFunctionDynamic {

	private final IFunction _hashTableFunction;

	public GetValuesFromHashtableFunction(IFunction hashTableFunction) {
		super();

		_hashTableFunction = hashTableFunction;
	}

	public Object execute(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
		Map map = (Map)_hashTableFunction.execute(executeFunctionArgs);

		if (map == null)
			throw new SimulationRuntimeException("Hashtable is null in " + getName());

		return map.values().iterator();
	}

	public String getName() {
		return "GetValuesFromHashtable(" + _hashTableFunction.getName() + ")";
	}
}