package de.uniwue.ki.mas.basics.function.hashtable;

import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionAdapterGenericFunctionDeclaration;
import de.uniwue.ki.mas.basics.type.ISpecificType;
import de.uniwue.ki.mas.basics.type.SpecificHashtableType;
import de.uniwue.ki.mas.model.ModelCompilingException;

final  class PutValueForKeySpecificFunctionDeclaration
	extends AbstractSpecificFunctionAdapterGenericFunctionDeclaration {

	private final SpecificHashtableType _specificHashtableType;

	public PutValueForKeySpecificFunctionDeclaration(
		PutValueForKeyGenericFunctionDeclaration putValueForKeyGenericFunctionDeclaration,
		SpecificHashtableType specificHashtableType) {
			
		super(putValueForKeyGenericFunctionDeclaration, 3);

		_specificHashtableType = specificHashtableType;
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions)
		throws ModelCompilingException {

		Assert.assertEquals(3, functions.size());

		return new PutValueForKeyFunction(
			functions.getFunction(0),
			functions.getFunction(1),
			functions.getFunction(2));
	}

	public ISpecificType getSpecificInputTypeAt(int index) {
		if (index == 0) {
			return _specificHashtableType.getKeyType();

		} else if (index == 1) {
			return _specificHashtableType.getValueType();

		} else if (index == 2) {
			return _specificHashtableType;

		} else {
			Assert.fail();
			return null;
		}
	}

	/**
	 * @param index int
	 * @return String
	 * @see de.uniwue.ki.mas.basics.functionDeclaration.ISpecificFunctionDeclaration#getSpecificInputTypeNameAt(int)
	 */
	public String getSpecificInputTypeNameAt(int index) {
		if (index == 0) {
			return "key";

		} else if (index == 1) {
			return "value";

		} else if (index == 2) {
			return "hashtable";

		} else {
			Assert.fail();
			return null;
		}
	}

}