package de.uniwue.ki.mas.basics.function.hashtable;

import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionAdapterGenericFunctionDeclaration;
import de.uniwue.ki.mas.basics.type.ISpecificType;
import de.uniwue.ki.mas.basics.type.SpecificHashtableType;
import de.uniwue.ki.mas.model.ModelCompilingException;

final  class RemoveKeySpecificFunctionDeclaration
	extends AbstractSpecificFunctionAdapterGenericFunctionDeclaration {

	private final SpecificHashtableType _specificHashtableType;

	public RemoveKeySpecificFunctionDeclaration(
		RemoveKeyGenericFunctionDeclaration removeKeyGenericFunctionDeclaration,
		SpecificHashtableType specificHashtableType) {
			
		super(removeKeyGenericFunctionDeclaration, 2);

		_specificHashtableType = specificHashtableType;
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions)
		throws ModelCompilingException {

		Assert.assertEquals(2, functions.size());

		return new RemoveKeyFunction(
			functions.getFunction(0),
			functions.getFunction(1));
	}

	public ISpecificType getSpecificInputTypeAt(int index) {
		if (index == 0) {
			return _specificHashtableType.getKeyType();

		} else if (index == 1) {
			return _specificHashtableType;

		} else {
			Assert.fail();
			return null;
		}
	}

	public String getSpecificInputTypeNameAt(int index) {
		if (index == 0) {
			return "key";

		} else if (index == 1) {
			return "hashtable";

		} else {
			Assert.fail();
			return null;
		}
	}
}