package de.uniwue.ki.mas.basics.function.iterator;

import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * @author oechslein
 * 
 * Creation date: 13.05.2003
 */
abstract class Abstract2ArgsIteratorFunction extends AbstractFunction {
	private final IFunction _functionA;
	private final IFunction _functionB;

	public Abstract2ArgsIteratorFunction(IFunction functionA, IFunction functionB) {
		super();

		_functionA = functionA;
		_functionB = functionB;
	}

	public String getName() {
		return getFunName() + "(" + _functionA.getName() + ", " + _functionB.getName() + ")";
	}

	protected abstract String getFunName();

	public Object execute(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
		try {
			IExecuteIterator iteratorA =
				ExecuteIteratorFactory.createExecuteIterator(executeFunctionArgs, _functionA);
			IExecuteIterator iteratorB =
				ExecuteIteratorFactory.createExecuteIterator(executeFunctionArgs, _functionB);
			return createFunction(iteratorA, iteratorB);
		} catch (SimulationRuntimeException e) {
			throw e;
		} catch (Exception e) {
			throw new RuntimeException(e);
		}
	}

	protected abstract Object createFunction(IExecuteIterator iteratorA, IExecuteIterator iteratorB)
		throws Exception;
}
