package de.uniwue.ki.mas.basics.function.iterator;
import java.util.Iterator;

import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.*;
import de.uniwue.ki.mas.basics.type.*;
/**
 * getFirst: <T> getFirst(set<T>)
 * Creation date: (04.09.2001 16:53:35)
 * @author Christoph Oechslein
 */

public abstract class AbstractGetAnyGenericFunctionDeclaration
	extends AbstractGenericFunctionDeclarationWithoutDependents {

	protected static class GetAnySpecificFunctionDeclaration
		extends AbstractSpecificFunctionAdapterGenericFunctionDeclaration {
		private final SpecificIteratorType _inputType;

		public GetAnySpecificFunctionDeclaration(
			AbstractGetAnyGenericFunctionDeclaration abstractGetAnyGenericFunctionDeclaration,
			SpecificIteratorType inputType) {
			super(abstractGetAnyGenericFunctionDeclaration, 1);

			_inputType = inputType;
		}

		public ISpecificType getSpecificOutputType() {
			return _inputType.getIteratorSpecificType();
		}
		public ISpecificType getSpecificInputTypeAt(int index) {
			if (Assert.ASSERTION_ON)
				Assert.assertEquals(0, index);
			return _inputType;
		}

		protected AbstractGetAnyGenericFunctionDeclaration getAbstractGetAnyGenericFunctionDeclaration() {
			return (AbstractGetAnyGenericFunctionDeclaration) getGenericFunctionDeclaration();
		}

		public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions) {
			Assert.assertEquals(1, functions.size());

			return getAbstractGetAnyGenericFunctionDeclaration().generateFunction(functions.getFunction(0));
		}

		public boolean isConstant(ICreateFunctionArgs createFunctionArgs) {
			return getAbstractGetAnyGenericFunctionDeclaration().isConstant(getSpecificOutputType());
		}

	}

	public AbstractGetAnyGenericFunctionDeclaration(String name) {
		super(name, GenericType.getInstance());
	}


	public ISpecificFunctionDeclaration createFunctionDeclaration(final ISpecificType outputType) {

		return createFunctionDeclarationSetType(
			GenericIteratorType.getInstance().createSpecificIteratorType(outputType));
	}

	public ISpecificFunctionDeclaration createFunctionDeclaration(Iterator inputArgs) {

		SpecificIteratorType specificSetType = getSpecificSetType(inputArgs);

		if (specificSetType == null) {
			return null;
		}

		if (inputArgs.hasNext()) {
			return null;
		}

		return createFunctionDeclarationSetType(specificSetType);
	}

	public ISpecificFunctionDeclaration createFunctionDeclarationSetType(final SpecificIteratorType inputType) {
		return new GetAnySpecificFunctionDeclaration(this, inputType);
	}

	protected abstract IFunction generateFunction(IFunction function);


	public String getSignatureWithoutNameAndOutputType(ISpecificType outputType) {
		return "(Iterator<" + outputType.getName() + ">)";
	}

	protected SpecificIteratorType getSpecificSetType(Iterator inputArgs) {
		ISpecificType specificType = getNextSpecificType(inputArgs);

		if ((specificType == null) || !(specificType instanceof SpecificIteratorType))
			return null;
		else
			return (SpecificIteratorType) specificType;
	}

	public boolean isConstant(ISpecificType outputType) {
		return !VoidType.getInstance().equals(outputType);
	}
}