package de.uniwue.ki.mas.basics.function.iterator;
import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionAdapterGenericFunctionDeclaration;
import de.uniwue.ki.mas.basics.type.*;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.util.collection.CollectionsHelper;
/**
 * Creation date: (26.02.2002 20:10:23)
 * @author Christoph Oechslein
 */
public class Aggregate2ArgsFunSpecificFunctionDeclaration
	extends AbstractSpecificFunctionAdapterGenericFunctionDeclaration {
	private final ISpecificType _outputType;

	public Aggregate2ArgsFunSpecificFunctionDeclaration(
		Aggregate2ArgsFunGenericFunctionDeclaration genericFunctionDeclaration,
		ISpecificType outputType) {

		super(genericFunctionDeclaration, 3);

		_outputType = outputType;
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions)
		throws ModelCompilingException {

		Assert.assertEquals(3, functions.size());

		return new FunctionAggregate2ArgsFun(
			functions.getFunction(0),
			functions.getFunction(1),
			functions.getFunction(2));
	}

	public ISpecificType getSpecificInputTypeAt(int index) {
		if (index == 0) {
			return GenericFunctionType.getInstance().createSpecificFunctionType(
				_outputType,
				CollectionsHelper.createList(_outputType, _outputType));

		} else if (index == 1) {
			return _outputType;

		} else {
			return GenericIteratorType.getInstance().createSpecificIteratorType(_outputType);
		}
	}

	public ISpecificType getSpecificOutputType() {
		return _outputType;
	}
}