package de.uniwue.ki.mas.basics.function.iterator;
import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionAdapterGenericFunctionDeclaration;
import de.uniwue.ki.mas.basics.type.*;

/**
* Creation date: (18.12.2001 10:05:36)
* @author Christoph Oechslein
*/
final class AsIteratorSpecificFunctionDeclaration
	extends AbstractSpecificFunctionAdapterGenericFunctionDeclaration {
	private final SpecificIteratorType _specificIteratorType;

	public AsIteratorSpecificFunctionDeclaration(SpecificIteratorType specificIteratorType) {
		super(AsIteratorGenericFunctionDeclaration.getInstance(), 1);

		_specificIteratorType = specificIteratorType;
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions) {
		if (Assert.ASSERTION_ON)
			Assert.assertEquals(1, functions.size());

		return new FunctionListAsIterator(functions.getFunction(0));
	}

	public ISpecificType getSpecificInputTypeAt(int index) {
		if (index == 0) {
			return GenericListType.getInstance().createSpecificListType(
				_specificIteratorType.getIteratorSpecificType());

		} else {
			Assert.fail();
			return null;
		}
	}

	public ISpecificType getSpecificOutputType() {
		return _specificIteratorType;
	}
}