package de.uniwue.ki.mas.basics.function.iterator;

import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionArgsDeclaration;
import de.uniwue.ki.mas.basics.type.*;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * @author oechslein
 * 
 * Creation date: 06.05.2003
 */
public class CartesianProductSpecificFunctionDeclaration extends AbstractSpecificFunctionArgsDeclaration {

	public CartesianProductSpecificFunctionDeclaration(
		ISpecificType specificInnerIteratorType1,
		ISpecificType specificInnerIteratorType2,
		SpecificIteratorType outputType) {

		this(
			GenericIteratorType.getInstance().createSpecificIteratorType(specificInnerIteratorType1),
			GenericIteratorType.getInstance().createSpecificIteratorType(specificInnerIteratorType2),
			outputType);
	}

	private CartesianProductSpecificFunctionDeclaration(
		SpecificIteratorType specificIteratorType1,
		SpecificIteratorType specificIteratorType2,
		SpecificIteratorType outputType) {
		super(
			"CartesianProduct",
			outputType,
			CollectionsHelper.createList(
				GenericFunctionType.getInstance().createSpecificFunctionType(
					outputType.getIteratorSpecificType(),
					CollectionsHelper.createList(
						specificIteratorType1.getIteratorSpecificType(),
						specificIteratorType2.getIteratorSpecificType())),
				specificIteratorType1,
				specificIteratorType2));

		setExpertFunctionDeclaration(true);
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions)
		throws ModelCompilingException {
		Assert.assertEquals(3, functions.size());

		return new CartesianProductFunction(
			functions.getFunction(0),
			functions.getFunction(1),
			functions.getFunction(2));
	}

}
