package de.uniwue.ki.mas.basics.function.iterator;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.type.SpecificIteratorType;
/**
 * concatenate: set<T> concatenate (set<T> set<T>)

 * Creation date: (27.10.2000 17:49:45)
 * @author Christoph Oechslein
 */

final class ConcatenateGenericFunctionDeclaration
	extends AbstractIteratorUnlimArgsGenericFunctionDeclaration {

	public ConcatenateGenericFunctionDeclaration() {
		super("Concatenate");

		setDocumentation("Concatenates iterator (Arg1) with iterator (Arg2)");
	}

	protected IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions) {
		if (functions.size() == 0) {
			return SpecificIteratorType.EMPTY_ITERATOR_ARGUMENT;
			
		} else if (functions.size() == 1) {
			return functions.getFunction(0);
			
		} else if (functions.size() == 2) {
			return new FunctionIteratorConcatenate2Args(functions.getFunction(0), functions.getFunction(1));
			
		} else {
			return new FunctionIteratorConcatenate(functions);
		}
	}
}