// $id:$
package de.uniwue.ki.mas.basics.function.iterator;

import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionCall.IComposedFunctionCallInternDeclaration;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionAdapterGenericFunctionDeclaration;
import de.uniwue.ki.mas.basics.functionDeclaration.ISpecificFunctionDeclaration;
import de.uniwue.ki.mas.basics.type.ISpecificType;
import de.uniwue.ki.mas.basics.type.SpecificIteratorType;
import de.uniwue.ki.mas.model.ModelCompilingException;

/**
 * @author oechslein
 * 
 * Creation date: 04.06.2003
 */
final class CreateIteratorSpecificFunctionDeclaration
	extends AbstractSpecificFunctionAdapterGenericFunctionDeclaration {
	private final SpecificIteratorType _specificSetType;

	public CreateIteratorSpecificFunctionDeclaration(
		CreateIteratorGenericFunctionDeclaration genericFunctionDeclaration,
		int defaultArgLength,
		SpecificIteratorType specificSetType) {

		super(genericFunctionDeclaration, defaultArgLength);
		_specificSetType = specificSetType;
	}
	
	public ISpecificType getSpecificOutputType() {
		return _specificSetType;
	}
	
	public ISpecificType getSpecificInputTypeAt(int index) {
		return _specificSetType.getIteratorSpecificType();
	}
	
	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions) {
		return new FunctionIteratorCreate(functions);
	}
	
	public int getSpecificInputMaxArgsLength() {
		return ISpecificFunctionDeclaration.UNLIMITED_ARGUMENT_COUNT;
	}
	
	public int getSpecificInputMinArgsLength() {
		return 0;
	}
	
	public int getSpecificInputDefaultArgsLength() {
		return 1;
	}
	
	public boolean isConstant(
		ICreateFunctionArgs createFunctionArgs,
		IComposedFunctionCallInternDeclaration composedFunctionCallInternDeclaration)
		throws ModelCompilingException {

		return false;
	}
}