package de.uniwue.ki.mas.basics.function.iterator;
import java.util.List;

import de.uniwue.ki.mas.basics.action.AbstractFunctionAction;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.model.SimulationRuntimeException;
import de.uniwue.ki.util.math.RandomHelper;

/**
 * Creation date: (30.07.2001 14:16:30)
 * @author Christoph Oechslein
 */

final class FunctionActionShuffle extends AbstractFunctionAction {
	private final IFunction _functionSet;

	public FunctionActionShuffle(IFunction functionSet) {
		super();

		_functionSet = functionSet;
	}

	public void act(final IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
		List list = (List) _functionSet.execute(executeFunctionArgs);

		RandomHelper.shuffle(list);
	}

	public void appendName(StringBuffer buff, int currDepth, int maxDepth) {
		AbstractFunction.appendFunctionName(buff, "Shuffle", _functionSet, currDepth, maxDepth);
	}

	public String getName() {
		return getNameIntern();
	}
}