package de.uniwue.ki.mas.basics.function.iterator;
import java.util.List;

import de.uniwue.ki.mas.basics.action.AbstractFunctionAction;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (30.07.2001 14:16:30)
 * @author Christoph Oechslein
 */

final class FunctionActionSort extends AbstractFunctionAction {
	private final IFunction _functionFunction;
	private final IFunction _functionSet;

	private final TwoObjectFunctionList _twoObjectFunctionList = new TwoObjectFunctionList();

	public FunctionActionSort(IFunction functionFunction, IFunction functionSet) {
		super();

		_functionFunction = functionFunction;
		_functionSet = functionSet;
	}

	public void act(final IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
		Object compareFunction =
			 _functionFunction.execute(executeFunctionArgs);

		List list = (List) _functionSet.execute(executeFunctionArgs);

		ParametricFunctionComparator.sortList(
			executeFunctionArgs.createCreateAndExecuteFunctionArgs(),
			compareFunction,
			_twoObjectFunctionList,
			list);
	}

	public void appendName(StringBuffer buff, int currDepth, int maxDepth) {
		if (currDepth >= maxDepth) {
			buff.append("...");
		} else {
			buff.append("Sort");
			buff.append("('");
			_functionFunction.appendName(buff, currDepth + 1, maxDepth);
			buff.append("', ");
			_functionSet.appendName(buff, currDepth + 1, maxDepth);
			buff.append(')');
		}
	}

	public String getName() {
		return getNameIntern();
	}
}