package de.uniwue.ki.mas.basics.function.iterator;
import de.uniwue.ki.mas.basics.functionDeclaration.IGenericFunctionDeclaration;
import de.uniwue.ki.mas.basics.functionDeclaration.list.FunctionDeclarationList;
import de.uniwue.ki.mas.basics.functionDeclaration.list.IFunctionDeclarationList;
/**
 * Creation date: (04.09.2001 16:51:57)
 * @author Christoph Oechslein
 */

public final class FunctionDeclarationIteratorFactory {
	public static final IGenericFunctionDeclaration SELECT_GENERIC_FUN_DECL =
		SelectGenericFunctionDeclaration.getInstance();
	public static final IGenericFunctionDeclaration CREATE_ITERATOR_GENERIC_FUN_DECL =
		new CreateIteratorGenericFunctionDeclaration();
	private static IFunctionDeclarationList _cachedFunctionDeclarationList = new FunctionDeclarationList();

	static {
		_cachedFunctionDeclarationList.add(new IsEmptyGenericFunctionDeclaration());
		_cachedFunctionDeclarationList.add(new CountGenericFunctionDeclaration());
		_cachedFunctionDeclarationList.add(new ConcatenateGenericFunctionDeclaration());
		_cachedFunctionDeclarationList.add(new UnionGenericFunctionDeclaration());
		_cachedFunctionDeclarationList.add(new IntersectionGenericFunctionDeclaration());
		_cachedFunctionDeclarationList.add(new SetDifferenceGenericFunctionDeclaration());
		_cachedFunctionDeclarationList.add(SELECT_GENERIC_FUN_DECL);
		_cachedFunctionDeclarationList.add(CREATE_ITERATOR_GENERIC_FUN_DECL);
		_cachedFunctionDeclarationList.add(new MapGenericFunctionDeclaration());
		_cachedFunctionDeclarationList.add(new AggregateGenericFunctionDeclaration());
		_cachedFunctionDeclarationList.add(new Aggregate2ArgsFunGenericFunctionDeclaration());
		_cachedFunctionDeclarationList.add(new GetFirstGenericFunctionDeclaration());
		_cachedFunctionDeclarationList.add(new GetNthGenericFunctionDeclaration());
		_cachedFunctionDeclarationList.add(new GetLastGenericFunctionDeclaration());
		_cachedFunctionDeclarationList.add(new GetRestGenericFunctionDeclaration());
		_cachedFunctionDeclarationList.add(AsIteratorGenericFunctionDeclaration.getInstance());
		_cachedFunctionDeclarationList.add(new CartesianProductGenericFunctionDeclaration());
		_cachedFunctionDeclarationList.add(new SumGenericFunctionDeclaration());
		_cachedFunctionDeclarationList.add(new MaximizeGenericFunctionDeclaration());
		_cachedFunctionDeclarationList.add(new SortGenericFunctionDeclaration());
		_cachedFunctionDeclarationList.add(new ShuffleGenericFunctionDeclaration());
		_cachedFunctionDeclarationList.add(new CreateEnumIteratorGenericFunctionDeclaration());
	}

	public static void insertFunctions(IFunctionDeclarationList functionDeclarationList) {
		functionDeclarationList.addAll(_cachedFunctionDeclarationList);
	}
}