package de.uniwue.ki.mas.basics.function.iterator;
import java.util.List;

import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.function.number.AbstractIntegerFunction;
import de.uniwue.ki.mas.model.SimulationRuntimeException;
/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class FunctionIteratorCount extends AbstractIntegerFunction {
	private final IFunction _setFunction;

	public FunctionIteratorCount(IFunction setFunction) {
		super();

		_setFunction = setFunction;
	}

	public final int executeForInt(IExecuteFunctionArgs executeFunctionArgs)
		throws SimulationRuntimeException {
		Object object = _setFunction.execute(executeFunctionArgs);
		
		if (object instanceof List) {
			return ((List) object).size();
			
		} else {
			IExecuteIterator it = ExecuteIteratorFactory.createExecuteIterator(object);

			int sum = 0;

			while (it.hasNext()) {
				ExecuteIteratorHelper.nextExecuteWithoutValue(it);
				sum++;
			}

			return sum;
		}
	}

	public String getName() {
		return "Count(" + _setFunction.getName() + ")";
	}
}