package de.uniwue.ki.mas.basics.function.iterator;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class FunctionIteratorGetFirst extends AbstractFunctionDynamic {
    private final IFunction _setFunction;

	public FunctionIteratorGetFirst(IFunction setFunction) {
	    super();
	    _setFunction = setFunction;
	}

	public String getName() {
	    return "GetFirst(" + _setFunction.getName() + ")";
	}

	public final Object execute(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
		IExecuteIterator it =
			ExecuteIteratorFactory.createExecuteIterator(executeFunctionArgs, _setFunction);
	    
	    if (!it.hasNext()) {
	        throw new EmptyIteratorSimulationRuntimeException("Empty List error in GetFirst");
	    }
	    
	    return ExecuteIteratorHelper.nextExecute(it);
	}
}