package de.uniwue.ki.mas.basics.function.iterator;

import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class FunctionIteratorGetLast extends AbstractFunctionDynamic {
	private final IFunction _setFunction;

	public FunctionIteratorGetLast(IFunction setFunction) {
		super();

		_setFunction = setFunction;
	}

	public String getName() {
		return "GetLast(" + _setFunction.getName() + ")";
	}

	public final Object execute(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
		IExecuteIterator it =
			ExecuteIteratorFactory.createExecuteIterator(executeFunctionArgs, _setFunction);

		while (it.hasNext()) {
			Object currObject = ExecuteIteratorHelper.nextExecute(it);

			if (!it.hasNext()) {
				return currObject;
			}
		}

		throw new EmptyIteratorSimulationRuntimeException("Empty List error in GetFirst");
	}
}