package de.uniwue.ki.mas.basics.function.iterator;

import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.model.SimulationRuntimeException;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class FunctionIteratorGetRest extends AbstractFunctionDynamic {
	private final IFunction _setFunction;

	public FunctionIteratorGetRest(IFunction setFunction) {
		super();

		_setFunction = setFunction;
	}

	public final Object execute(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
		IExecuteIterator it =
			ExecuteIteratorFactory.createExecuteIterator(executeFunctionArgs, _setFunction);
			
		if (CollectionsHelper.isEmpty(it)) {
			throw new EmptyIteratorSimulationRuntimeException("Empty iterator in " + getName());
		}

		ExecuteIteratorHelper.nextExecuteWithoutValue(it);
		
		return it;
	}

	public String getName() {
		return "GetRest(" + _setFunction.getName() + ")";
	}
}