package de.uniwue.ki.mas.basics.function.iterator;
import java.util.List;

import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.model.SimulationRuntimeException;
import de.uniwue.ki.util.math.RandomHelper;

/**
 * Creation date: (30.07.2001 14:16:30)
 * @author Christoph Oechslein
 */

final class FunctionIteratorShuffle extends AbstractFunction {

	private final IFunction _functionSet;

	public FunctionIteratorShuffle(IFunction functionSet) {
		super();

		_functionSet = functionSet;
	}

	public Object execute(final IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
		List list = ExecuteIteratorFactory.createList(executeFunctionArgs, _functionSet);

		RandomHelper.shuffle(list);

		return list.iterator();
	}

	public void appendName(StringBuffer buff, int currDepth, int maxDepth) {
		AbstractFunction.appendFunctionName(buff, "Shuffle", _functionSet, currDepth, maxDepth);
	}

	public String getName() {
		return getNameIntern();
	}
}