package de.uniwue.ki.mas.basics.function.iterator;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.function.number.AbstractDoubleFunction;
import de.uniwue.ki.mas.model.SimulationRuntimeException;
/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class FunctionIteratorSum extends AbstractDoubleFunction {
	static final String NAME = "Sum";
	private final IFunction _setFunction;

	public FunctionIteratorSum(IFunction setFunction) {
		super();

		_setFunction = setFunction;
	}

	public final double executeForDouble(IExecuteFunctionArgs executeFunctionArgs)
		throws SimulationRuntimeException {
		IExecuteIterator setIterator =
			ExecuteIteratorFactory.createExecuteIterator(executeFunctionArgs, _setFunction);

		double sum = 0.0;

		while (setIterator.hasNext()) {
			sum += ExecuteIteratorHelper.nextExecuteForDouble(setIterator);
		}

		return sum;
	}

	public final int executeForInt(IExecuteFunctionArgs executeFunctionArgs)
		throws SimulationRuntimeException {
		IExecuteIterator setIterator =
			ExecuteIteratorFactory.createExecuteIterator(executeFunctionArgs, _setFunction);

		int sum = 0;

		while (setIterator.hasNext()) {
			sum += ExecuteIteratorHelper.nextExecuteForInt(setIterator);
		}

		return sum;
	}

	public String getName() {
		return NAME + " (" + _setFunction.getName() + ")";
	}
}