package de.uniwue.ki.mas.basics.function.iterator;

import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */
final class FunctionListAsIterator extends AbstractFunction {
	static final String NAME = "AsIterator";
	private final IFunction _listFunction;

	public FunctionListAsIterator(IFunction listFunction) {
		super();

		_listFunction = listFunction;
	}

	public final Object execute(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
		return ExecuteIteratorFactory.createExecuteIterator(executeFunctionArgs, _listFunction);
	}

	public String getName() {
		return NAME + " (" + _listFunction.getName() + ")";
	}
}