package de.uniwue.ki.mas.basics.function.iterator;
import java.util.Iterator;

import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionAdapterGenericFunctionDeclaration;
import de.uniwue.ki.mas.basics.functionDeclaration.ISpecificFunctionDeclaration;
import de.uniwue.ki.mas.basics.type.ISpecificType;
import de.uniwue.ki.mas.basics.type.SpecificIteratorType;
import de.uniwue.ki.mas.model.ModelCompilingException;
/**
 * Creation date: (18.12.2001 09:27:51)
 * @author Christoph Oechslein
 */
final class GetRestGenericFunctionDeclaration extends AbstractIteratorGenericFunctionDeclaration {

	public GetRestGenericFunctionDeclaration() {
		super("GetRest");

		setDocumentation("Returns the rest of its Set");
	}

	public ISpecificFunctionDeclaration createFunctionDeclaration(final ISpecificType outputType) {
		Assert.assertTrue(outputType instanceof SpecificIteratorType);

		return new AbstractSpecificFunctionAdapterGenericFunctionDeclaration(this, 1) {
			public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions)
				throws ModelCompilingException {

				Assert.assertEquals(1, functions.size());

				return new FunctionIteratorGetRest(functions.getFunction(0));
			}

			public ISpecificType getSpecificInputTypeAt(int index) {
				return outputType;
			}

			public ISpecificType getSpecificOutputType() {
				return outputType;
			}
		};
	}

	public ISpecificFunctionDeclaration createFunctionDeclaration(Iterator inputTypes) {
		ISpecificType type = getNextSpecificType(inputTypes);

		if ((inputTypes.hasNext()) || (type == null) || !(type instanceof SpecificIteratorType))
			return null;

		return createFunctionDeclaration(type);
	}

	public String getSignatureWithoutNameAndOutputType(ISpecificType outputType) {
		return "(" + outputType.getName() + ")";
	}
}