package de.uniwue.ki.mas.basics.function.iterator;
import de.uniwue.ki.mas.basics.function.*;

/**
 * intersect: set<T> intersect (Iterator<T> Iterator<T>)

 * Creation date: (27.10.2000 17:49:45)
 * @author Christoph Oechslein
 */

final class IntersectionGenericFunctionDeclaration
	extends AbstractIteratorUnlimArgsGenericFunctionDeclaration {

	public IntersectionGenericFunctionDeclaration() {
		super("Intersection");

		setDocumentation("Returns the intersection of its iterators.");
	}

	/*
		public boolean canCreateFunctionDeclarationWith(ISpecificType outputType) {
		   if (!super.canCreateFunctionDeclarationWith(outputType)) {
		      return false;
		   } else if (outputType instanceof SpecificIteratorType) {
		      return ((SpecificIteratorType) outputType).getIteratorSpecificType().isSimpleType();
		   } else {
		      return false;
		   }
		}
	*/

	protected IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions) {
		if (functions.size() == 2)
			return new FunctionIteratorIntersection2Args(functions.getFunction(0), functions.getFunction(1));
		else
			return new FunctionIteratorIntersection(functions);
	}
}