package de.uniwue.ki.mas.basics.function.iterator;

import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionAdapterGenericFunctionDeclaration;
import de.uniwue.ki.mas.basics.type.*;
import de.uniwue.ki.mas.model.ModelCompilingException;

/**
 * Iterator<T> sort(<bool fun(T,T), Iterator<T>)
 * Creation date: 30.09.2002, 08:30:38
 * @author oechslein
 */
public class MaximizeSpecificFunctionDeclaration
	extends AbstractSpecificFunctionAdapterGenericFunctionDeclaration {

	private final SpecificIteratorType _specificIteratorType;
	private final ISpecificFunctionType _specificFunctionType;

	public MaximizeSpecificFunctionDeclaration(
		MaximizeGenericFunctionDeclaration maximizeGenericFunctionDeclaration,
		SpecificIteratorType specificIteratorType,
		ISpecificFunctionType specificFunctionType) {
		super(maximizeGenericFunctionDeclaration, 2);

		_specificIteratorType = specificIteratorType;
		_specificFunctionType = specificFunctionType;
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions)
		throws ModelCompilingException {
		Assert.assertEquals(2, functions.size());

		return new FunctionIteratorMaximize(functions.getFunction(0), functions.getFunction(1));
	}

	public ISpecificType getSpecificInputTypeAt(int index) {
		if (index == 0)
			return _specificFunctionType;
		else if (index == 1)
			return _specificIteratorType;

		Assert.fail();
		return null;
	}

	public ISpecificType getSpecificOutputType() {
		return _specificIteratorType.getIteratorSpecificType();
	}
}
