package de.uniwue.ki.mas.basics.function.iterator;
import java.util.Map;

import de.uniwue.ki.mas.basics.function.ICreateAndExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.SingletonObjectFunctionList;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: 29.01.2003, 14:45:32
 * @author oechslein
 */
public class ParametricFunctionHashedValueComparator extends ParametricFunctionValueComparator {
	private final Map _valueMap;

	public ParametricFunctionHashedValueComparator(
		Object valueFunction,
		ICreateAndExecuteFunctionArgs executeFunctionArgs,
		SingletonObjectFunctionList singletonObjectFunctionList,
		Map valueMap) {
		super(valueFunction, executeFunctionArgs, singletonObjectFunctionList);

		_valueMap = valueMap;
	}

	protected double executeForDouble(Object anObject)
		throws SimulationRuntimeException, ModelCompilingException {

		if (_valueMap.containsKey(anObject)) {
			return ((Double) _valueMap.get(anObject)).doubleValue();
			
		} else {
			double result = super.executeForDouble(anObject);

			_valueMap.put(anObject, new Double(result));

			return result;
		}
	}
}