package de.uniwue.ki.mas.basics.function.iterator;
import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionAdapterGenericFunctionDeclaration;
import de.uniwue.ki.mas.basics.type.*;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Creation date: (18.12.2001 10:05:36)
 * @author Christoph Oechslein
 */

final class SelectSpecificFunctionDeclaration
	extends AbstractSpecificFunctionAdapterGenericFunctionDeclaration {
	private final SpecificIteratorType _specificSetOutputType;

	public SelectSpecificFunctionDeclaration(SpecificIteratorType specificSetOutputType) {
		super(SelectGenericFunctionDeclaration.getInstance(), 2);

		_specificSetOutputType = specificSetOutputType;
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions) {
		if (Assert.ASSERTION_ON)
			Assert.assertEquals(2, functions.size());
		return new FunctionIteratorSelect((IFunction) functions.get(0), (IFunction) functions.get(1));
	}
	
	public String getSpecificInputTypeNameAt(int index) {
		if (index==0) return "Filter function";
		
		if (index==1) return "Iterator";
		
		Assert.fail("Select has just two arguments");
		return null;
	}


	public ISpecificType getSpecificInputTypeAt(int index) {
		if (index == 0) {
			return GenericFunctionType.getInstance().createSpecificFunctionType(
				BooleanType.getInstance(),
				CollectionsHelper.createList(_specificSetOutputType.getIteratorSpecificType()));

		} else if (index == 1) {
			return _specificSetOutputType;

		} else {
			Assert.fail();
			return null;
		}

	}

	public ISpecificType getSpecificOutputType() {
		return _specificSetOutputType;
	}
}