package de.uniwue.ki.mas.basics.function.iterator;

import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionAdapterGenericFunctionDeclaration;
import de.uniwue.ki.mas.basics.type.GenericIteratorType;
import de.uniwue.ki.mas.basics.type.ISpecificType;
import de.uniwue.ki.mas.model.ModelCompilingException;

/**
 * Iterator<T> Shuffle(<bool fun(T,T), Iterator<T>)
 * Creation date: 30.09.2002, 08:30:38
 * @author oechslein
 */
public class ShuffleIteratorSpecificFunctionDeclaration
	extends AbstractSpecificFunctionAdapterGenericFunctionDeclaration {

	private final ISpecificType _type;

	public ShuffleIteratorSpecificFunctionDeclaration(
		ShuffleGenericFunctionDeclaration shuffleGenericFunctionDeclaration,
		ISpecificType type) {
		super(shuffleGenericFunctionDeclaration, 1);

		_type = type;
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions)
		throws ModelCompilingException {
		Assert.assertEquals(1, functions.size());

		return new FunctionIteratorShuffle(functions.getFunction(0));
	}

	public ISpecificType getSpecificInputTypeAt(int index) {
		return getSpecificOutputType();
	}

	public ISpecificType getSpecificOutputType() {
		return GenericIteratorType.getInstance().createSpecificIteratorType(_type);
	}
	
	public boolean isConstant(ICreateFunctionArgs createFunctionArgs) {
		return false;
	}

}
