package de.uniwue.ki.mas.basics.function.iterator;

import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionAdapterGenericFunctionDeclaration;
import de.uniwue.ki.mas.basics.type.*;
import de.uniwue.ki.mas.model.ModelCompilingException;

/**
 * void Shuffle(<bool fun(T,T), List<T>)
 * Creation date: 30.09.2002, 08:30:38
 * @author oechslein
 */
public class ShuffleVoidSpecificFunctionDeclaration
	extends AbstractSpecificFunctionAdapterGenericFunctionDeclaration {

	private final ISpecificType _type;

	public ShuffleVoidSpecificFunctionDeclaration(
		ShuffleGenericFunctionDeclaration ShuffleGenericFunctionDeclaration,
		ISpecificType type) {
		super(ShuffleGenericFunctionDeclaration, 1);

		_type = type;
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions)
		throws ModelCompilingException {
		Assert.assertEquals(1, functions.size());

		return new FunctionActionShuffle(functions.getFunction(0));
	}

	public ISpecificType getSpecificInputTypeAt(int index) {
		return GenericListType.getInstance().createSpecificListType(_type);
	}

	public ISpecificType getSpecificOutputType() {
		return VoidType.getInstance();
	}
}
