package de.uniwue.ki.mas.basics.function.iterator;

import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionAdapterGenericFunctionDeclaration;
import de.uniwue.ki.mas.basics.type.*;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Iterator<T> sort(<bool fun(T,T), Iterator<T>)
 * Creation date: 30.09.2002, 08:30:38
 * @author oechslein
 */
public class SortIteratorSpecificFunctionDeclaration
	extends AbstractSpecificFunctionAdapterGenericFunctionDeclaration {

	private final ISpecificType _type;

	public SortIteratorSpecificFunctionDeclaration(
		SortGenericFunctionDeclaration sortGenericFunctionDeclaration,
		ISpecificType type) {
		super(sortGenericFunctionDeclaration, 2);

		_type = type;
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions)
		throws ModelCompilingException {
		Assert.assertEquals(2, functions.size());

		return new FunctionIteratorSort(functions.getFunction(0), functions.getFunction(1));
	}

	public ISpecificType getSpecificInputTypeAt(int index) {
		if (index == 0)
			return GenericFunctionType.getInstance().createSpecificFunctionType(
				BooleanType.getInstance(),
				CollectionsHelper.createList(_type, _type));
		else if (index == 1)
			return getSpecificOutputType();

		Assert.fail();
		return null;
	}
	
	public String getSpecificInputTypeNameAt(int index) {
		if (index==0) return "Comparison function";
		
		if (index==1) return "Iterator";
		
		Assert.fail("Sort has just two arguments");
		return null;
	}


	public ISpecificType getSpecificOutputType() {
		return GenericIteratorType.getInstance().createSpecificIteratorType(_type);
	}
}
