package de.uniwue.ki.mas.basics.function.iterator;

import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionAdapterGenericFunctionDeclaration;
import de.uniwue.ki.mas.basics.type.*;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * void sort(<bool fun(T,T), List<T>)
 * Creation date: 30.09.2002, 08:30:38
 * @author oechslein
 */
public class SortVoidSpecificFunctionDeclaration
	extends AbstractSpecificFunctionAdapterGenericFunctionDeclaration {

	private final ISpecificType _type;

	public SortVoidSpecificFunctionDeclaration(
		SortGenericFunctionDeclaration sortGenericFunctionDeclaration,
		ISpecificType type) {
		super(sortGenericFunctionDeclaration, 2);

		_type = type;
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions)
		throws ModelCompilingException {
		Assert.assertEquals(2, functions.size());

		return new FunctionActionSort(functions.getFunction(0), functions.getFunction(1));
	}

	public ISpecificType getSpecificInputTypeAt(int index) {
		if (index == 0)
			return GenericFunctionType.getInstance().createSpecificFunctionType(
				BooleanType.getInstance(),
				CollectionsHelper.createList(_type, _type));
		else if (index == 1)
			return GenericListType.getInstance().createSpecificListType(_type);

		Assert.fail();
		return null;
	}
	
	public String getSpecificInputTypeNameAt(int index) {
			if (index==0) return "Comparison function";
		
			if (index==1) return "List";
		
			Assert.fail("Sort has just two arguments");
			return null;
		}

	public ISpecificType getSpecificOutputType() {
		return VoidType.getInstance();
	}
}
