package de.uniwue.ki.mas.basics.function.iterator;
import de.uniwue.ki.mas.basics.function.*;
/**
 * union: set<T> union(set<T>, ...)

 * Creation date: (27.10.2000 17:49:45)
 * @author Christoph Oechslein
 */

final class UnionGenericFunctionDeclaration extends AbstractIteratorUnlimArgsGenericFunctionDeclaration {

	public UnionGenericFunctionDeclaration() {
		super("Union");

		setDocumentation("Returns the union of its Sets");
	}

	protected IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions) {
		if (functions.size() == 2)
			return new FunctionIteratorUnion2Args(functions.getFunction(0), functions.getFunction(1));
		else
			return new FunctionIteratorUnion(functions);
	}
}