package de.uniwue.ki.mas.basics.function.list;
import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionAdapterGenericFunctionDeclaration;
import de.uniwue.ki.mas.basics.type.*;

/**
* Creation date: (18.12.2001 10:05:36)
* @author Christoph Oechslein
*/
final class AsListSpecificFunctionDeclaration
	extends AbstractSpecificFunctionAdapterGenericFunctionDeclaration {
	private final SpecificListType _specificListType;

	public AsListSpecificFunctionDeclaration(SpecificListType specificListType) {
		super(AsListGenericFunctionDeclaration.getInstance(), 1);

		_specificListType = specificListType;
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions) {
		if (Assert.ASSERTION_ON)
			Assert.assertEquals(1, functions.size());

		return new FunctionIteratorAsList(functions.getFunction(0));
	}

	public ISpecificType getSpecificInputTypeAt(int index) {
		if (index == 0) {
			return GenericIteratorType.getInstance().createSpecificIteratorType(
				_specificListType.getListSpecificType());

		} else {
			Assert.fail();
			return null;
		}
	}

	public ISpecificType getSpecificOutputType() {
		return _specificListType;
	}

	public boolean isConstant(ICreateFunctionArgs createFunctionArgs) {
		return false;
	}
}