// $id:$
package de.uniwue.ki.mas.basics.function.list;

import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionAdapterGenericFunctionDeclaration;
import de.uniwue.ki.mas.basics.functionDeclaration.ISpecificFunctionDeclaration;
import de.uniwue.ki.mas.basics.type.ISpecificType;
import de.uniwue.ki.mas.basics.type.SpecificListType;

/**
 * @author oechslein
 * 
 * Creation date: 06.05.2003
 */
final class CreateListSpecificFunctionDeclaration
	extends AbstractSpecificFunctionAdapterGenericFunctionDeclaration {
	private final SpecificListType _specificSetType;

	public CreateListSpecificFunctionDeclaration(
		CreateListGenericFunctionDeclaration genericFunctionDeclaration,
		int defaultArgLength,
		SpecificListType specificSetType) {
		super(genericFunctionDeclaration, defaultArgLength);

		_specificSetType = specificSetType;
	}
	
	public ISpecificType getSpecificOutputType() {
		return _specificSetType;
	}
	
	public ISpecificType getSpecificInputTypeAt(int index) {
		return _specificSetType.getIteratorSpecificType();
	}
	
	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions) {
		return new FunctionListCreate(functions);
	}
	
	public int getSpecificInputMaxArgsLength() {
		return ISpecificFunctionDeclaration.UNLIMITED_ARGUMENT_COUNT;
	}
	
	public int getSpecificInputMinArgsLength() {
		return 0;
	}
	
	public int getSpecificInputDefaultArgsLength() {
		return 1;
	}
	
	public boolean isConstant(ICreateFunctionArgs createFunctionArgs) {
		return false;
	}
}