package de.uniwue.ki.mas.basics.function.list;
import java.util.List;

import de.uniwue.ki.mas.basics.action.AbstractFunctionAction;
import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.model.SimulationRuntimeException;
/**
 * Creation date: (19.03.2002 14:26:32)
 * @author Christoph Oechslein
 */
public class FunctionActionClearList extends AbstractFunctionAction {
	private final IFunction _functionList;

	public FunctionActionClearList(IFunction functionList) {
		super();

		_functionList = functionList;
	}

	public void act(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
		List list = (List) _functionList.execute(executeFunctionArgs);

		if (list == null)
			throw new SimulationRuntimeException("List is empty in " + getName());

		list.clear();
	}

	public String getName() {
		return "ClearList(" + _functionList.getName() + ")";
	}
}