package de.uniwue.ki.mas.basics.function.list;
import java.util.List;

import de.uniwue.ki.mas.basics.action.AbstractFunctionAction;
import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

class FunctionActionPush extends AbstractFunctionAction {
	private final IFunction _functionValue;
	private final IFunction _functionList;

	public FunctionActionPush(IFunction functionValue, IFunction functionList) {
		super();
		_functionValue = functionValue;
		_functionList = functionList;
	}

	public void act(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {

		Object newValue = _functionValue.execute(executeFunctionArgs);
		List list = (List) _functionList.execute(executeFunctionArgs);

		if (list == null)
			throw new SimulationRuntimeException("List is null");

		list.add(newValue);
	}

	public String getName() {
		return "Push(" + _functionValue.getName()+ ", " + _functionList.getName() + ")";
	}
}