package de.uniwue.ki.mas.basics.function.list;
import java.util.List;

import de.uniwue.ki.mas.basics.action.AbstractFunctionAction;
import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.model.SimulationRuntimeException;
/**
 * Creation date: (19.03.2002 14:26:32)
 * @author Christoph Oechslein
 */
public class FunctionActionRemove extends AbstractFunctionAction {
	private final IFunction _functionList;
	private final IFunction _functionValue;

	public FunctionActionRemove(IFunction functionList, IFunction functionValue) {
		super();

		_functionList = functionList;
		_functionValue = functionValue;
	}

	public void act(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {

		List list = (List) _functionList.execute(executeFunctionArgs);

		if (list == null)
			throw new SimulationRuntimeException("List is empty in " + getName());

		Object value = _functionValue.execute(executeFunctionArgs);

		list.remove(value);
	}

	public String getName() {
		return "Remove (" + _functionList.getName() + ", " + _functionValue.getName() + ")";
	}
}