package de.uniwue.ki.mas.basics.function.list;
import de.uniwue.ki.mas.basics.functionDeclaration.IGenericFunctionDeclaration;
import de.uniwue.ki.mas.basics.functionDeclaration.list.FunctionDeclarationList;
import de.uniwue.ki.mas.basics.functionDeclaration.list.IFunctionDeclarationList;
/**
 * Creation date: (04.09.2001 16:51:57)
 * @author Christoph Oechslein
 */

public final class FunctionDeclarationListFunctionsFactory {
	public static final IGenericFunctionDeclaration CREATE_LIST_GENERIC_FUNCTION_DECL =
		new CreateListGenericFunctionDeclaration();
	public static final IGenericFunctionDeclaration AS_LIST_GENERIC_FUNCTION_DECL =
		AsListGenericFunctionDeclaration.getInstance();
	public static final IGenericFunctionDeclaration POP_GENERIC_FUNCTION_DECL =
		new PopGenericFunctionDeclaration();
	public static final IGenericFunctionDeclaration POP_RETURN_GENERIC_FUNCTION_DECL =
		new PopAndReturnGenericFunctionDeclaration();
	public static final IGenericFunctionDeclaration PUSH_GENERIC_FUNCTION_DECL =
		new PushGenericFunctionDeclaration();
	public static final IGenericFunctionDeclaration CLEAR_LIST_GENERIC_FUNCTION_DECL =
		new ClearListGenericFunctionDeclaration();

	private static IFunctionDeclarationList _cachedFunctionDeclarationList = new FunctionDeclarationList();

	static {
		insertFunctionsIntern();
	}

	public static void insertFunctions(IFunctionDeclarationList functionDeclarationList) {
		functionDeclarationList.addAll(_cachedFunctionDeclarationList);
	}

	private static void insertFunctionsIntern() {
		_cachedFunctionDeclarationList.add(AS_LIST_GENERIC_FUNCTION_DECL);
		_cachedFunctionDeclarationList.add(new SetNthGenericFunctionDeclaration());
		_cachedFunctionDeclarationList.add(POP_GENERIC_FUNCTION_DECL);
		_cachedFunctionDeclarationList.add(POP_RETURN_GENERIC_FUNCTION_DECL);
		_cachedFunctionDeclarationList.add(PUSH_GENERIC_FUNCTION_DECL);
		_cachedFunctionDeclarationList.add(new RemoveGenericFunctionDeclaration());
		_cachedFunctionDeclarationList.add(new ListContainsGenericFunctionDeclaration());
		_cachedFunctionDeclarationList.add(new IndexOfGenericFunctionDeclaration());
		_cachedFunctionDeclarationList.add(CREATE_LIST_GENERIC_FUNCTION_DECL);
		_cachedFunctionDeclarationList.add(CLEAR_LIST_GENERIC_FUNCTION_DECL);
	}
}