package de.uniwue.ki.mas.basics.function.list;
import java.util.List;

import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.basics.function.number.AbstractIntegerFunction;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

class FunctionIndexOf extends AbstractIntegerFunction implements IFunction {
	private final IFunction _functionList;
	private final IFunction _functionObj;

	public FunctionIndexOf(IFunction functionList, IFunction functionObj) {
		super();

		_functionList = functionList;
		_functionObj = functionObj;
	}

	public int executeForInt(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
		List list = (List) _functionList.execute(executeFunctionArgs);
		Object obj = _functionObj.execute(executeFunctionArgs);

		if (list == null)
			throw new SimulationRuntimeException("List is null");

		return list.indexOf(obj);
	}

	public String getName() {
		return getFunctionName() + "(" + _functionList.getName() + ", " + _functionObj.getName() + ")";
	}

	protected String getFunctionName() {
		return "IndexOf";
	}
}