package de.uniwue.ki.mas.basics.function.list;

import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class FunctionIteratorAsList extends AbstractFunction {
	static final String NAME = "AsList";
	private final IFunction _iteratorFunction;

	public FunctionIteratorAsList(IFunction iteratorFunction) {
		super();

		_iteratorFunction = iteratorFunction;
	}

	public final Object execute(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
		return ExecuteIteratorFactory.createList(executeFunctionArgs, _iteratorFunction);
	}

	public String getName() {
		return NAME + " (" + _iteratorFunction.getName() + ")";
	}
}