package de.uniwue.ki.mas.basics.function.list;

import java.util.List;

import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.basics.function.bool.AbstractBooleanFunction;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * @author herrler
 */

public class FunctionListContains  extends AbstractBooleanFunction {
	private final IFunction _functionList;
	private final IFunction _functionValue;

	public FunctionListContains(IFunction functionList, IFunction functionValue) {
		super();

		_functionList = functionList;
		_functionValue = functionValue;
	}

	/**
	 * @param executeFunctionArgs IExecuteFunctionArgs
	 * @throws SimulationRuntimeException
	 * @see de.uniwue.ki.mas.basics.function.IFunction#act(IExecuteFunctionArgs)
	 */
	public boolean executeForBoolean(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {

		List list = (List) _functionList.execute(executeFunctionArgs);
		Object value = _functionValue.execute(executeFunctionArgs);

		return list.contains(value);
	}
	
	/**
	 * @return String
	 * @see de.uniwue.ki.util.INamed#getName()
	 */
	public String getName() {
		return "Contains(" + _functionList.getName() + ", " + _functionValue.getName() + ")";
	}
}
