package de.uniwue.ki.mas.basics.function.list;
import java.util.Iterator;
import java.util.List;

import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.type.SpecificListType;
import de.uniwue.ki.mas.model.SimulationRuntimeException;
/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class FunctionListCreate extends AbstractFunction {
	private final IFunctionList _functions;

	public FunctionListCreate(IFunctionList functions) {
		super();

		_functions = functions;
	}

	public Object execute(final IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
		List newList = SpecificListType.createNewList();

		Iterator it = _functions.iterator();
		while (it.hasNext()) {
			IFunction element = (IFunction) it.next();
			Object value = element.execute(executeFunctionArgs);
			newList.add(value);
		}

		return newList;
	}

	public String getName() {
		return "CreateList" + _functions.getName();
	}
}