package de.uniwue.ki.mas.basics.function.number;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionUnlimitedArgsDeclaration;
import de.uniwue.ki.mas.basics.functionDeclaration.IGenericFunctionDeclaration;
import de.uniwue.ki.mas.basics.type.*;

/**
 * Creation date: (01.10.2001 16:25:22)
 * @author Christoph Oechslein
 */

abstract class AbstractDoubleIntSpecificFunctionUnlimArgsDeclaration
	extends AbstractSpecificFunctionUnlimitedArgsDeclaration {
	private final IGenericFunctionDeclaration _genericFunctionDeclaration;

	public AbstractDoubleIntSpecificFunctionUnlimArgsDeclaration(
		IGenericFunctionDeclaration genericFunctionDeclaration,
		ISpecificType specificType,
		String documentation) {
		super(genericFunctionDeclaration.getName(), specificType, specificType, 2, 2, true);

		setDocumentation(documentation);
		_genericFunctionDeclaration = genericFunctionDeclaration;
	}

	public AbstractDoubleIntSpecificFunctionUnlimArgsDeclaration(
		IGenericFunctionDeclaration genericFunctionDeclaration,
		boolean forDoubleValues,
		String documentation) {
		this(
			genericFunctionDeclaration,
			forDoubleValues
				? (ISpecificType) DoubleType.getInstance()
				: (ISpecificType) IntegerType.getInstance(),
			documentation);
	}

	public IGenericFunctionDeclaration getGenericFunctionDeclaration() {
		return _genericFunctionDeclaration;
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions) {
		boolean intTyp = IntegerType.getInstance().equals(getSpecificOutputType());
		return createFunction(intTyp, functions);
	}

	protected abstract IFunction createFunction(boolean intTyp, IFunctionList functions);
}