package de.uniwue.ki.mas.basics.function.number;

import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

public abstract class AbstractIntegerFunction extends AbstractFunction implements IFunction {

	/**
	 * Just return the result of {@link #executeForDouble(IExecuteFunctionArgs)}.
	 */
	public final Object execute(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
		return new Integer(executeForInt(executeFunctionArgs));
	}

	/**
	 * Explicitly make this method abstract since {@link #execute(IExecuteFunctionArgs)}
	 * calls it.
	 */
	public abstract int executeForInt(IExecuteFunctionArgs executeFunctionArgs)
		throws SimulationRuntimeException;

	/**
	 * Just return the result of {@link #executeForDouble(IExecuteFunctionArgs)}.
	 */
	public final double executeForDouble(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
		return executeForInt(executeFunctionArgs);
	}
}
