package de.uniwue.ki.mas.basics.function.number;
import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionArgsDeclaration;
import de.uniwue.ki.mas.basics.type.DoubleType;
import de.uniwue.ki.mas.basics.type.IntegerType;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Creation date: 31.01.2003, 15:02:38
 * @author oechslein
 */
final class FloorSpecificFunctionDeclaration extends AbstractSpecificFunctionArgsDeclaration {
	public FloorSpecificFunctionDeclaration() {
		super("Floor", IntegerType.getInstance(), CollectionsHelper.createList(DoubleType.getInstance()));

		setExpertFunctionDeclaration(true);
		setDocumentation("Returns the largest (closest to positive infinity) value that is not greater than the argument.");

	}
	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions) {
		Assert.assertEquals(1, functions.size());
		return new FunctionFloor(functions.getFunction(0));
	}
}