package de.uniwue.ki.mas.basics.function.number;

import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class FunctionDivide extends AbstractDoubleFunction {
	private final IFunction numberFunction1;
	private final IFunction numberFunction2;

	public FunctionDivide(IFunction numberFunction1, IFunction numberFunction2) {
		super();
		this.numberFunction1 = numberFunction1;
		this.numberFunction2 = numberFunction2;
	}

	public final double executeForDouble(IExecuteFunctionArgs executeFunctionArgs)
		throws SimulationRuntimeException {

		double value1 = numberFunction1.executeForDouble(executeFunctionArgs);
		double value2 = numberFunction2.executeForDouble(executeFunctionArgs);

		return value1 / value2;
	}

	public String getName() {
		return "(" + numberFunction1.getName() + " / " + numberFunction2.getName() + ")";
	}
}