package de.uniwue.ki.mas.basics.function.number;
import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class FunctionExp extends AbstractDoubleFunction {
    private final IFunction numberFunction;

    /**
     * @param numberFunction IFunction
     */
    public FunctionExp(IFunction numberFunction) {
        super();
        this.numberFunction = numberFunction;
    }


    public final double executeForDouble(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
        return Math.exp(numberFunction.executeForDouble(executeFunctionArgs));
    }


    /**
     * @return String
     * @see de.uniwue.ki.util.INamed#getName()
     */
    public String getName() {
        return "Exp(" + numberFunction.getName() + ")";
    }
}