package de.uniwue.ki.mas.basics.function.number;

import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.basics.function.bool.AbstractBooleanFunction;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class FunctionIsNaN extends AbstractBooleanFunction {
	private final IFunction _numberFunction;

	public FunctionIsNaN(IFunction numberFunction) {
		super();

		_numberFunction = numberFunction;
	}

	public final boolean executeForBoolean(IExecuteFunctionArgs executeFunctionArgs)
		throws SimulationRuntimeException {
		return Double.isNaN(_numberFunction.executeForDouble(executeFunctionArgs));
	}

	public String getName() {
		return "IsNaN(" + _numberFunction.getName() + ")";
	}

}