package de.uniwue.ki.mas.basics.function.number;

import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class FunctionLn extends AbstractDoubleFunction {
    private final IFunction _numberFunction;

    /**
     * @param numberFunction IFunction
     */
    public FunctionLn(IFunction numberFunction) {
        super();

        _numberFunction = numberFunction;
    }

    /**
     * @param executeFunctionArgs IExecuteFunctionArgs
     * @return double
     * @throws SimulationRuntimeException
     * @see de.uniwue.ki.mas.basics.function.IFunction#executeForDouble(IExecuteFunctionArgs)
     */
    public final double executeForDouble(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
        return Math.log(_numberFunction.executeForDouble(executeFunctionArgs));
    }

    /**
     * @return String
     * @see de.uniwue.ki.util.INamed#getName()
     */
    public String getName() {
        return "Ln(" + _numberFunction.getName() + ")";
    }
}