package de.uniwue.ki.mas.basics.function.number;

import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class FunctionLog extends AbstractDoubleFunction {
    private final IFunction numberFunction1;
    private final IFunction numberFunction2;

    public FunctionLog(IFunction numberFunction1, IFunction numberFunction2) {
        super();

        this.numberFunction1 = numberFunction1;
        this.numberFunction2 = numberFunction2;
    }

    /**
     * @param executeFunctionArgs IExecuteFunctionArgs
     * @return double
     * @throws SimulationRuntimeException
     * @see de.uniwue.ki.mas.basics.function.IFunction#executeForDouble(IExecuteFunctionArgs)
     */
    public final double executeForDouble(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
        return Math.log(numberFunction1.executeForDouble(executeFunctionArgs) / Math.log(numberFunction2.executeForDouble(executeFunctionArgs)));
    }
    public String getName() {
        return "Log(" + numberFunction1.getName() + ", " + numberFunction2.getName() + ")";
    }
}