package de.uniwue.ki.mas.basics.function.number;

import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class FunctionMinusUnary extends AbstractDoubleFunction {
	private final IFunction _numberFunction;

	public FunctionMinusUnary(IFunction numberFunction) {
		super();
		_numberFunction = numberFunction;
	}

	public final double executeForDouble(IExecuteFunctionArgs executeFunctionArgs)
		throws SimulationRuntimeException {
		return -_numberFunction.executeForDouble(executeFunctionArgs);
	}

	public String getName() {
		return "- (" + _numberFunction.getName() + ")";
	}
}