package de.uniwue.ki.mas.basics.function.number;

import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class FunctionModuloInt extends AbstractIntegerFunction {
	private final IFunction numberFunction1;
	private final IFunction numberFunction2;

	public FunctionModuloInt(IFunction numberFunction1, IFunction numberFunction2) {
		super();
		this.numberFunction1 = numberFunction1;
		this.numberFunction2 = numberFunction2;
	}

	public final int executeForInt(IExecuteFunctionArgs executeFunctionArgs)
		throws SimulationRuntimeException {
		return numberFunction1.executeForInt(executeFunctionArgs)
			% numberFunction2.executeForInt(executeFunctionArgs);
	}

	public String getName() {
		return "(" + numberFunction1.getName() + " mod " + numberFunction2.getName() + ")";
	}

}
