package de.uniwue.ki.mas.basics.function.number;
import java.util.Iterator;

import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class FunctionMultiply extends AbstractDoubleFunction {
	private final IFunctionList functions;

	public FunctionMultiply(IFunctionList functions) {
		super();
		this.functions = functions;
	}

	public double executeForDouble(IExecuteFunctionArgs executeFunctionArgs)
		throws SimulationRuntimeException {
		return executeForDouble(functions.iterator(), executeFunctionArgs);
	}

	public static final double executeForDouble(Iterator functions, IExecuteFunctionArgs executeFunctionArgs)
		throws SimulationRuntimeException {
		double summe = 1.0;
		while (functions.hasNext()) {
			IFunction function = (IFunction) functions.next();
			summe *= function.executeForDouble(executeFunctionArgs);
		}
		return summe;
	}

	public void appendName(StringBuffer buff, int currDepth, int maxDepth) {
		AbstractFunction.appendFunctionName(buff, "*", functions, currDepth, maxDepth);
	}

	public String getName() {
		return getNameIntern();
	}
}