package de.uniwue.ki.mas.basics.function.number;
import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class FunctionMultiply2Args extends AbstractDoubleFunction {
	private final IFunction _function1;
	private final IFunction _function2;

	public FunctionMultiply2Args(IFunction function1, IFunction function2) {
		super();

		_function1 = function1;
		_function2 = function2;
	}

	public static final double executeForDouble(
		IFunction function1,
		IFunction function2,
		IExecuteFunctionArgs executeFunctionArgs)
		throws SimulationRuntimeException {

		return function1.executeForDouble(executeFunctionArgs)
			* function2.executeForDouble(executeFunctionArgs);
	}

	public double executeForDouble(IExecuteFunctionArgs executeFunctionArgs)
		throws SimulationRuntimeException {

		return executeForDouble(_function1, _function2, executeFunctionArgs);
	}

	public String getName() {
		return "(" + _function1.getName() + " * " + _function2.getName() + ")";
	}

}