package de.uniwue.ki.mas.basics.function.number;
import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class FunctionMultiply2ArgsInt extends AbstractIntegerFunction {
	private final IFunction _function1;
	private final IFunction _function2;

	public FunctionMultiply2ArgsInt(IFunction function1, IFunction function2) {
		super();

		_function1 = function1;
		_function2 = function2;
	}

	public static final int executeForInt(
		IFunction function1,
		IFunction function2,
		IExecuteFunctionArgs executeFunctionArgs)
		throws SimulationRuntimeException {

		return function1.executeForInt(executeFunctionArgs) * function2.executeForInt(executeFunctionArgs);
	}

	public int executeForInt(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
		return executeForInt(_function1, _function2, executeFunctionArgs);
	}

	public String getName() {
		return "(" + _function1.getName() + " * " + _function2.getName() + ")";
	}

}