package de.uniwue.ki.mas.basics.function.number;
import java.util.Iterator;

import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class FunctionMultiplyInt extends AbstractIntegerFunction {
	private final IFunctionList functions;

	public FunctionMultiplyInt(IFunctionList functions) {
		super();
		this.functions = functions;
	}

	public int executeForInt(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
		return executeForInt(functions.iterator(), executeFunctionArgs);
	}

	public static final int executeForInt(Iterator functions, IExecuteFunctionArgs executeFunctionArgs)
		throws SimulationRuntimeException {
		int summe = 1;
		while (functions.hasNext()) {
			IFunction function = (IFunction) functions.next();
			summe *= function.executeForInt(executeFunctionArgs);
		}
		return summe;
	}

	public void appendName(StringBuffer buff, int currDepth, int maxDepth) {
		AbstractFunction.appendFunctionName(buff, "*", functions, currDepth, maxDepth);
	}

	public String getName() {
		return getNameIntern();
	}
}