package de.uniwue.ki.mas.basics.function.number;

import java.util.Iterator;

import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class FunctionPlus extends AbstractDoubleFunction {
	private final IFunctionList _functions;

	public FunctionPlus(IFunctionList functions) {
		super();

		_functions = functions;
	}

	public static final double executeForDouble(Iterator functions, IExecuteFunctionArgs executeFunctionArgs)
		throws SimulationRuntimeException {
		double summe = 0.0;
		while (functions.hasNext()) {
			IFunction function = (IFunction) functions.next();
			summe += function.executeForDouble(executeFunctionArgs);
		}
		return summe;
	}

	public double executeForDouble(IExecuteFunctionArgs executeFunctionArgs)
		throws SimulationRuntimeException {
		return executeForDouble(_functions.iterator(), executeFunctionArgs);
	}

	public void appendName(StringBuffer buff, int currDepth, int maxDepth) {
		AbstractFunction.appendFunctionName(buff, "+", _functions, currDepth, maxDepth);
	}

	public String getName() {
		return getNameIntern();
	}

}