package de.uniwue.ki.mas.basics.function.number;

import java.util.Iterator;

import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class FunctionPlusInt extends AbstractIntegerFunction {
	private final IFunctionList _functions;

	public FunctionPlusInt(IFunctionList functions) {
		super();

		_functions = functions;
	}

	public static final int executeForInt(Iterator functions, IExecuteFunctionArgs executeFunctionArgs)
		throws SimulationRuntimeException {
		int sum = 0;
		while (functions.hasNext()) {
			IFunction function = (IFunction) functions.next();
			sum += function.executeForInt(executeFunctionArgs);
		}
		return sum;
	}

	public int executeForInt(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
		return executeForInt(_functions.iterator(), executeFunctionArgs);
	}

	public void appendName(StringBuffer buff, int currDepth, int maxDepth) {
		AbstractFunction.appendFunctionName(buff, "+", _functions, currDepth, maxDepth);
	}

	public String getName() {
		return getNameIntern();
	}

}