package de.uniwue.ki.mas.basics.function.number;

import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class FunctionRound extends AbstractIntegerFunction {
    private final IFunction numberFunction;

    public FunctionRound(IFunction numberFunction) {
        super();
        this.numberFunction = numberFunction;
    }

    public final int executeForInt(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
        return (int) Math.round(numberFunction.executeForDouble(executeFunctionArgs));
    }

    public String getName() {
        return "Round(" + numberFunction.getName() + ")";
    }
}