package de.uniwue.ki.mas.basics.function.number;
import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class FunctionSqInt extends AbstractIntegerFunction {
	private final IFunction numberFunction;

	public FunctionSqInt(IFunction numberFunction) {
		super();
		this.numberFunction = numberFunction;
	}

	public final int executeForInt(IExecuteFunctionArgs executeFunctionArgs)
		throws SimulationRuntimeException {
		int value = numberFunction.executeForInt(executeFunctionArgs);
		return value * value;
	}

	public String getName() {
		return "Sq(" + numberFunction.getName() + ")";
	}
}