package de.uniwue.ki.mas.basics.function.number;

import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class FunctionSqrt extends AbstractDoubleFunction {
    private final IFunction numberFunction;

    public FunctionSqrt(IFunction numberFunction) {
        super();
        this.numberFunction = numberFunction;
    }
public final double executeForDouble(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
    return Math.sqrt(numberFunction.executeForDouble(executeFunctionArgs));
}
public String getName() {
    return "Sqrt(" + numberFunction.getName() + ")";
}
}
