package de.uniwue.ki.mas.basics.function.number;
import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionArgsDeclaration;
import de.uniwue.ki.mas.basics.type.ISpecificType;
import de.uniwue.ki.mas.basics.type.IntegerType;
import de.uniwue.ki.util.collection.CollectionsHelper;
/**
 * Creation date: 31.01.2003, 17:41:23
 * @author oechslein
 */
final class MinusUnarySpecificFunctionDeclaration extends AbstractSpecificFunctionArgsDeclaration {

	public MinusUnarySpecificFunctionDeclaration(ISpecificType specificType) {
		super("-Unary", specificType, CollectionsHelper.createList(specificType));
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions) {
		Assert.assertEquals(1, functions.size());

		if (IntegerType.getInstance().equals(getSpecificOutputType()))
			return new FunctionMinusUnaryInt(functions.getFunction(0));
		else
			return new FunctionMinusUnary(functions.getFunction(0));
	}
}