package de.uniwue.ki.mas.basics.function.number;
import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionArgsDeclaration;
import de.uniwue.ki.mas.basics.type.ISpecificType;
import de.uniwue.ki.mas.basics.type.IntegerType;
import de.uniwue.ki.util.collection.CollectionsHelper;
/**
 * Creation date: 31.01.2003, 17:41:23
 * @author oechslein
 */
final class ModuloSpecificFunctionDeclaration extends AbstractSpecificFunctionArgsDeclaration {

	public ModuloSpecificFunctionDeclaration(ISpecificType specificType) {
		super("%", specificType, CollectionsHelper.createList(specificType, specificType));
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions) {
		Assert.assertEquals(2, functions.size());

		if (IntegerType.getInstance().equals(getSpecificOutputType()))
			return new FunctionModuloInt(functions.getFunction(0), functions.getFunction(1));
		else
			return new FunctionModulo(functions.getFunction(0), functions.getFunction(1));
	}
}