package de.uniwue.ki.mas.basics.function.number;
import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionArgsDeclaration;
import de.uniwue.ki.mas.basics.type.DoubleType;
import de.uniwue.ki.util.collection.CollectionsHelper;
/**
 * Creation date: 31.01.2003, 17:41:23
 * @author oechslein
 */
final class PowerSpecificFunctionDeclaration extends AbstractSpecificFunctionArgsDeclaration {

	public PowerSpecificFunctionDeclaration() {
		super(
			"Power",
			DoubleType.getInstance(),
			CollectionsHelper.createList(DoubleType.getInstance(), DoubleType.getInstance()));

		setDocumentation("Returns the value of number (Arg1) raised to the power of number (Arg2)");
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions) {
		Assert.assertEquals(2, functions.size());

		return new FunctionPower(functions.getFunction(0), functions.getFunction(1));
	}
}