package de.uniwue.ki.mas.basics.function.number;

import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.basics.function.IFunctionList;
import de.uniwue.ki.mas.basics.functionDeclaration.IGenericFunctionDeclaration;
import de.uniwue.ki.mas.basics.type.ISpecificType;

/**
 * Creation date: (01.10.2001 16:25:22)
 * @author Christoph Oechslein
 */

final class SpecificFunctionDeclarationMin extends AbstractDoubleIntSpecificFunctionUnlimArgsDeclaration {
	public SpecificFunctionDeclarationMin(
		IGenericFunctionDeclaration genericFunctionDeclaration,
		ISpecificType specificType) {
		super(
			genericFunctionDeclaration,
			specificType,
			genericFunctionDeclaration.getDocumentation());
	}

	protected IFunction createFunction(boolean intTyp, IFunctionList functions) {
		if (functions.size() == 1) {
			return functions.getFunction(0);
		} else if (intTyp)
			return new FunctionMinInt(functions);
		else
			return new FunctionMin(functions);
	}
}