package de.uniwue.ki.mas.basics.function.number;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.basics.function.IFunctionList;
import de.uniwue.ki.mas.basics.functionDeclaration.IGenericFunctionDeclaration;
import de.uniwue.ki.mas.basics.type.ISpecificType;

/**
 * Creation date: (01.10.2001 16:25:22)
 * @author Christoph Oechslein
 */

final class SpecificFunctionDeclarationMultiply
	extends AbstractDoubleIntSpecificFunctionUnlimArgsDeclaration {

	public SpecificFunctionDeclarationMultiply(
		IGenericFunctionDeclaration genericFunctionDeclaration,
		ISpecificType specificType) {
		super(genericFunctionDeclaration, specificType, genericFunctionDeclaration.getDocumentation());
	}

	protected IFunction createFunction(boolean intTyp, IFunctionList functions) {
		if (functions.size() == 1) {
			return functions.getFunction(0);
		} else if (functions.size() == 2) {
			if (intTyp)
				return new FunctionMultiply2ArgsInt(functions.getFunction(0), functions.getFunction(1));
			else
				return new FunctionMultiply2Args(functions.getFunction(0), functions.getFunction(1));

		} else if (intTyp) {
			return new FunctionMultiplyInt(functions);

		} else {
			return new FunctionMultiply(functions);
		}
	}
}