package de.uniwue.ki.mas.basics.function.object;

import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionArgsDeclaration;
import de.uniwue.ki.mas.basics.functionDeclaration.IFunctionDeclaration;
import de.uniwue.ki.mas.basics.type.GenericSimObjectType;
import de.uniwue.ki.mas.basics.type.ObjectInstanceDeclarationType;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * @author Rainer Herrler
 * de.uniwue.ki.mas.basics.function.object.FindSimObjectFunctionDeclaration
 */

public final class FindSimObjectFunctionDeclaration extends AbstractSpecificFunctionArgsDeclaration implements IFunctionDeclaration {

	public FindSimObjectFunctionDeclaration() {
		super(
			"FindSimObject",
			GenericSimObjectType.getGeneralSimObjectType(),
			CollectionsHelper.createList(ObjectInstanceDeclarationType.getInstance()),
			false,
			true);
			
		setDocumentation("Returns the SimObject that was declared by a InstanceDeclaration");
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions)
		throws ModelCompilingException {

		if (Assert.ASSERTION_ON)
			Assert.assertEquals(1, functions.size());

		return new FindSimObjectFunction(functions.getFunction(0));
	}
}