package de.uniwue.ki.mas.basics.function.object;
import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.entity.objectclass.IObjectClassDeclaration;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class GetAllObjectsFunction extends AbstractGetAllObjectsFunction {

	private IObjectClassDeclaration objectClassDeclaration = null;

	public GetAllObjectsFunction(IFunction includingAddedFunction, IFunction excludingRemovedFunction) {
		super(includingAddedFunction, excludingRemovedFunction);
	}

	public GetAllObjectsFunction(
		IObjectClassDeclaration declaration,
		IFunction includingAddedFunction,
		IFunction excludingRemovedFunction) {
		super(includingAddedFunction, excludingRemovedFunction);
		objectClassDeclaration = declaration;
	}

	public Object execute(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
		if (objectClassDeclaration == null)
			return getAllObjects(executeFunctionArgs);
		else
			return selectByType(executeFunctionArgs, objectClassDeclaration);
	}

	public String getName() {
		return "GetAllObjects(" + getAddedAndRemovedName() + ")";
	}
}