package de.uniwue.ki.mas.basics.function.object;

import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.entity.objectclass.IObjectClassDeclaration;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class GetAllObjectsOfTypeFunction extends AbstractGetAllObjectsFunction {
	private final IFunction _objectClassDeclarationFunction;

	public GetAllObjectsOfTypeFunction(
		IFunction objectClassDeclarationFunction,
		IFunction includingAddedFunction,
		IFunction excludingRemovedFunction) {
		super(includingAddedFunction, excludingRemovedFunction);

		_objectClassDeclarationFunction = objectClassDeclarationFunction;
	}

	public Object execute(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {

		final IObjectClassDeclaration objectClassDeclaration =
			(IObjectClassDeclaration)_objectClassDeclarationFunction.execute(executeFunctionArgs);

		return selectByType(executeFunctionArgs, objectClassDeclaration);
	}

	public String getName() {
		return "GetAllObjectsOfType("
			+ _objectClassDeclarationFunction.getName()
			+ ", "
			+ getAddedAndRemovedName()
			+ ")";
	}
}