package de.uniwue.ki.mas.basics.function.object;
import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.type.*;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Creation date: (04.09.2001 17:26:30)
 * @author Christoph Oechslein
 */

final class GetAllObjectsOfTypeSpecificFunctionDeclaration
	extends AbstractGetAllObjectsSpecificFunctionDeclaration {
	public GetAllObjectsOfTypeSpecificFunctionDeclaration() {
		this(GenericSimObjectType.getGeneralSimObjectType());
	}

	public GetAllObjectsOfTypeSpecificFunctionDeclaration(ISimObjectType bodyImageType) {
		super(
			"GetAllObjectsOfType",
			CollectionsHelper.createList(
				ObjectClassDeclarationType.getInstance(),
				BooleanType.getInstance(),
				BooleanType.getInstance()));

		setDocumentation(
			"Returns all objects of object class (Arg1) (including the in this tick added objects and excluding the killed objects)."
				+ "The order is not specified and also not random.");
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions)
		throws ModelCompilingException {

		if (Assert.ASSERTION_ON)
			Assert.assertEquals(3, functions.size());

		return new GetAllObjectsOfTypeFunction(
			functions.getFunction(0),
			functions.getFunction(1),
			functions.getFunction(2));
	}
}