package de.uniwue.ki.mas.basics.function.object;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.entity.object.IObject;
import de.uniwue.ki.mas.entity.object.agent.IActivityAgent;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

//TODO remove this function -> is in activity decl
final class GetCurrentActivityFunction extends AbstractFunction {
	private final IFunction _bodyFunction;

	public GetCurrentActivityFunction(IFunction bodyFunction) {
		super();

		_bodyFunction = bodyFunction;
	}

	public final Object execute(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
		IObject object = (IObject)_bodyFunction.execute(executeFunctionArgs);

		if (object == null)
			throw new SimulationRuntimeException("Object is null!");

		if (!(object instanceof IActivityAgent))
			throw new SimulationRuntimeException("Object is no activity agent: " + object.getName());

		IActivityAgent agent = (IActivityAgent)object;

		return agent.getCurrentActivityGraphLeafs()[0].getActivityGraphNodeDeclaration();
	}

	public String getName() {
		return "GetCurrentActivity(" + _bodyFunction.getName() + ")";
	}
}