package de.uniwue.ki.mas.basics.function.object;
import de.uniwue.ki.mas.basics.function.AbstractFunction;
import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.entity.object.agent.IAgent;
import de.uniwue.ki.mas.entity.object.world.IWorldExecuteFunctionArgs;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class GetCurrentSimObjectFunction extends AbstractFunction {

	private static final GetCurrentSimObjectFunction _instance = new GetCurrentSimObjectFunction();

	public GetCurrentSimObjectFunction() {
		super();
	}

	public static final GetCurrentSimObjectFunction getInstance() {
		return _instance;
	}

	public final Object execute(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
		IWorldExecuteFunctionArgs worldExecuteFunctionArgs = (IWorldExecuteFunctionArgs) executeFunctionArgs;

		IAgent observingAgent = (IAgent) worldExecuteFunctionArgs.getObject();

		return observingAgent;
	}

	public String getName() {
		return "GetCurrentSimObject()";
	}
}
