package de.uniwue.ki.mas.basics.function.object;
import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.basics.function.number.AbstractIntegerFunction;
import de.uniwue.ki.mas.entity.object.IObject;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class GetObjectIdFunction extends AbstractIntegerFunction {
	private final IFunction _objectFunction;

	public GetObjectIdFunction(IFunction objectFunction) {
		super();

		_objectFunction = objectFunction;
	}

	public int executeForInt(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
		IObject object = (IObject) _objectFunction.execute(executeFunctionArgs);

		if (object == null)
			throw new SimulationRuntimeException("Object is null!");
			
		return object.getId();
	}

	public String getName() {
		return "ObjectId(" + _objectFunction.getName() + ")";
	}
}