package de.uniwue.ki.mas.basics.function.object;
import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.number.AbstractIntegerFunction;
import de.uniwue.ki.mas.model.SimulationRuntimeException;
import de.uniwue.ki.mas.sim.simulation.ISimulationExecuteFunctionArgs;
import de.uniwue.ki.mas.sim.situation.ISituation;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class GetTimeFunction extends AbstractIntegerFunction {

	private static final GetTimeFunction _instance = new GetTimeFunction();

	public GetTimeFunction() {
		super();
	}

	public static final GetTimeFunction getInstance() {
		return _instance;
	}

	public final int executeForInt(IExecuteFunctionArgs executeFunctionArgs)
		throws SimulationRuntimeException {
		ISimulationExecuteFunctionArgs simulationExecuteFunctionArgs =
			(ISimulationExecuteFunctionArgs) executeFunctionArgs;

		ISituation situation = simulationExecuteFunctionArgs.getSimulation().getSituation();
		if (situation == null)
			return 0;
		else
			return situation.getTimeDurationInTicks();
	}

	public String getName() {
		return "GetTime()";
	}
}