package de.uniwue.ki.mas.basics.function.object;
import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.AbstractFunction;
import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.entity.object.world.IWorldExecuteFunctionArgs;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class GetWorldFunction extends AbstractFunction {

	private static final GetWorldFunction _instance = new GetWorldFunction();

	public GetWorldFunction() {
		super();
	}

	public static final GetWorldFunction getInstance() {
		return _instance;
	}

	public final Object execute(IExecuteFunctionArgs executeFunctionArgs)
		throws SimulationRuntimeException {
		IWorldExecuteFunctionArgs worldExecuteFunctionArgs =
			(IWorldExecuteFunctionArgs) executeFunctionArgs;

		Assert.assertNotNull(worldExecuteFunctionArgs.getWorld());

		return worldExecuteFunctionArgs.getWorld();
	}

	public String getName() {
		return "GetWorld()";
	}
}