package de.uniwue.ki.mas.basics.function.object;

import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.basics.function.bool.AbstractBooleanFunction;
import de.uniwue.ki.mas.entity.object.IObject;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (06.09.2001 20:09:38)
 * @author Christoph Oechslein
 */
public final class IsDeadFunction extends AbstractBooleanFunction {
	private final IFunction _objectFunction;

	public IsDeadFunction(IFunction objectFunction) {
		super();

		_objectFunction = objectFunction;
	}

	public boolean executeForBoolean(IExecuteFunctionArgs executeFunctionArgs)
		throws SimulationRuntimeException {

		IObject object = (IObject) _objectFunction.execute(executeFunctionArgs);

		if (object == null)
			throw new SimulationRuntimeException("Body is null!");

		return object.isDead();
	}

	public String getName() {
		return "IsDead(" + _objectFunction.getName() + ")";
	}
}