package de.uniwue.ki.mas.basics.function.random;
import de.uniwue.ki.mas.basics.functionDeclaration.ISpecificFunctionDeclaration;
import de.uniwue.ki.mas.basics.functionDeclaration.list.FunctionDeclarationList;
import de.uniwue.ki.mas.basics.functionDeclaration.list.IFunctionDeclarationList;

/**
 * Creation date: (16.01.2002 13:39:36)
 * @author Christoph Oechslein
 */

public class FunctionDeclarationRandomFactory {

	public static final ISpecificFunctionDeclaration RANDOM_INT_SPECIFIC_FUN_DECL =
		new RandomIntSpecificFunctionArgsDeclaration();
	public static final ISpecificFunctionDeclaration RANDOM_BOOLEAN_SPECIFIC_FUN_DECL =
		new RandomBooleanSpecificFunctionArgsDeclaration();

	private static IFunctionDeclarationList _cachedFunctionDeclarationList = new FunctionDeclarationList();

	static {
		// randomDouble
		_cachedFunctionDeclarationList.add(new RandomDoubleSpecificFunctionArgsDeclaration());

		// randomInt
		_cachedFunctionDeclarationList.add(RANDOM_INT_SPECIFIC_FUN_DECL);

		// randomNormal
		_cachedFunctionDeclarationList.add(new RandomNormalSpecificFunctionArgsDeclaration());

		// randomBoolean
		_cachedFunctionDeclarationList.add(RANDOM_BOOLEAN_SPECIFIC_FUN_DECL);

		// getRandom
		_cachedFunctionDeclarationList.add(new GetRandomGenericFunctionDeclaration());

		// randomPoisson
		_cachedFunctionDeclarationList.add(new RandomPoissonSpecificFunctionArgsDeclaration());

		// randomExp
		_cachedFunctionDeclarationList.add(new RandomExpSpecificFunctionArgsDeclaration());

		// randomGamma
		_cachedFunctionDeclarationList.add(new RandomGammaSpecificFunctionArgsDeclaration());
	}

	public static void insertFunctions(IFunctionDeclarationList functionDeclarationList) {
		functionDeclarationList.addAll(_cachedFunctionDeclarationList);
	}

}