package de.uniwue.ki.mas.basics.function.random;
import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.basics.function.bool.AbstractBooleanFunction;
import de.uniwue.ki.mas.model.SimulationRuntimeException;
import de.uniwue.ki.util.math.RandomHelper;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class FunctionRandomBoolean extends AbstractBooleanFunction {
    private final IFunction _probNumberFunction;

    public FunctionRandomBoolean(IFunction probNumberFunction) {
        super();

        _probNumberFunction = probNumberFunction;
    }


public final boolean executeForBoolean(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
    return executeForBooleanStatic(executeFunctionArgs, _probNumberFunction);
}


/**
 * @param executeFunctionArgs IExecuteFunctionArgs
 * @param probNumberFunction IFunction
 * @return boolean
 * @throws SimulationRuntimeException
 */
public static final boolean executeForBooleanStatic(IExecuteFunctionArgs executeFunctionArgs, IFunction probNumberFunction)
    throws SimulationRuntimeException {
    return RandomHelper.getRandomBoolean(probNumberFunction.executeForDouble(executeFunctionArgs));
}


    /**
     * @return String
     * @see de.uniwue.ki.util.INamed#getName()
     */
    public String getName() {
        return "RandomBoolean(" + _probNumberFunction.getName() + ")";
    }
}