package de.uniwue.ki.mas.basics.function.random;
import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.basics.function.number.AbstractDoubleFunction;
import de.uniwue.ki.mas.model.SimulationRuntimeException;
import de.uniwue.ki.util.math.RandomHelper;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class FunctionRandomExp extends AbstractDoubleFunction {
	private final IFunction _lambdaNumberFunction;

	public FunctionRandomExp(IFunction lambdaNumberFunction) {
		super();

		_lambdaNumberFunction = lambdaNumberFunction;
	}

	public final double executeForDouble(IExecuteFunctionArgs executeFunctionArgs)
		throws SimulationRuntimeException {

		double lambda = _lambdaNumberFunction.executeForDouble(executeFunctionArgs);

		return RandomHelper.getRandomExp(lambda);
	}

	public String getName() {
		return "RandomExp(" + _lambdaNumberFunction.getName() + ")";
	}
}