package de.uniwue.ki.mas.basics.function.random;
import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.basics.function.number.AbstractDoubleFunction;
import de.uniwue.ki.mas.model.SimulationRuntimeException;
import de.uniwue.ki.util.math.RandomHelper;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class FunctionRandomGamma extends AbstractDoubleFunction {
	private final IFunction _alphaNumberFunction;
	private final IFunction _lambdaNumberFunction;

	public FunctionRandomGamma(IFunction alphaNumberFunction, IFunction lambdaNumberFunction) {
		super();

		_alphaNumberFunction = alphaNumberFunction;
		_lambdaNumberFunction = lambdaNumberFunction;
	}

	public final double executeForDouble(IExecuteFunctionArgs executeFunctionArgs)
		throws SimulationRuntimeException {

		double alpha = _alphaNumberFunction.executeForDouble(executeFunctionArgs);
		double lambda = _lambdaNumberFunction.executeForDouble(executeFunctionArgs);

		return RandomHelper.getRandomGamma(alpha, lambda);
	}

	public String getName() {
		return "RandomGamma(" + _alphaNumberFunction.getName() + _lambdaNumberFunction.getName() + ")";
	}
}