package de.uniwue.ki.mas.basics.function.random;
import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.ICreateFunctionArgs;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.basics.function.iterator.AbstractGetAnyGenericFunctionDeclaration;
import de.uniwue.ki.mas.basics.functionCall.IComposedFunctionCallInternDeclaration;
import de.uniwue.ki.mas.basics.functionCall.IFunctionCallInternDeclaration;
import de.uniwue.ki.mas.basics.functionDeclaration.ISpecificFunctionDeclaration;
import de.uniwue.ki.mas.basics.type.*;
import de.uniwue.ki.mas.model.ModelCompilingException;
/**
 * Creation date: (18.12.2001 09:27:51)
 * @author Christoph Oechslein
 */
final class GetRandomGenericFunctionDeclaration extends AbstractGetAnyGenericFunctionDeclaration {
	protected static class GetRandomSpecificFunctionDeclaration extends GetAnySpecificFunctionDeclaration {
		public GetRandomSpecificFunctionDeclaration(
			GetRandomGenericFunctionDeclaration getRandomGenericFunctionDeclaration,
			SpecificIteratorType inputType) {
			super(getRandomGenericFunctionDeclaration, inputType);
		}

		public IFunction createFunction(
			ICreateFunctionArgs createFunctionArgs,
			IComposedFunctionCallInternDeclaration call)
			throws ModelCompilingException {

			Assert.assertEquals(1, call.getChildCount());

			IFunctionCallInternDeclaration child = call.getChild(0);

			if (GenericIteratorType.getInstance().canCreate(child.getSpecificOutputType())) {
				return new FunctionIteratorGetRandom(child.createFunction(createFunctionArgs));
			} else {
				Assert.assertTrue(GenericListType.getInstance().canCreate(child.getSpecificOutputType()));
				return new FunctionListGetRandom(child.createFunction(createFunctionArgs));
			}
		}
		
		public String getSpecificInputTypeNameAt(int index) {
			if (index==0) return "list";
			return super.getSpecificInputTypeNameAt(index);
		}


	}

	public GetRandomGenericFunctionDeclaration() {
		super("GetRandom");
		setDocumentation("Returns a random element of its Set");
	}

	public ISpecificFunctionDeclaration createFunctionDeclarationSetType(final SpecificIteratorType inputType) {
		return new GetRandomSpecificFunctionDeclaration(this, inputType);
	}

	protected IFunction generateFunction(IFunction function) {
		throw new UnsupportedOperationException();
	}

	public boolean isConstant(ISpecificType outputType) {
		return false;
	}
}