package de.uniwue.ki.mas.basics.function.random;

import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionArgsDeclaration;
import de.uniwue.ki.mas.basics.type.DoubleType;
import de.uniwue.ki.mas.model.SimulationRuntimeException;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Creation date: (16.01.2002 13:39:36)
 * @author Christoph Oechslein
 */

final class RandomDoubleSpecificFunctionArgsDeclaration extends AbstractSpecificFunctionArgsDeclaration {
	public RandomDoubleSpecificFunctionArgsDeclaration() {
		super(
			"RandomDouble",
			DoubleType.getInstance(),
			CollectionsHelper.createList(DoubleType.getInstance(), DoubleType.getInstance()),
			false);

		setDocumentation("Returns a random double in the interval [arg1, arg2].");
	}


	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions) {
		Assert.assertEquals(2, functions.size());
		return new FunctionRandomDouble(functions.getFunction(0), functions.getFunction(1));
	}

	// just for faster dynamic calling
	public double executeForDouble(
		ICreateAndExecuteFunctionArgs createAndExecuteFunctionArgs,
		IFunctionList functions)
		throws SimulationRuntimeException {
		return FunctionRandomDouble.executeForDoubleStatic(
			createAndExecuteFunctionArgs,
			functions.getFunction(0),
			functions.getFunction(1));
	}


	public String getSpecificInputTypeNameAt(int index) {
		if (index == 0)
			return "from";
		else
			return "to";
	}
}