package de.uniwue.ki.mas.basics.function.random;

import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionArgsDeclaration;
import de.uniwue.ki.mas.basics.type.DoubleType;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Creation date: (16.01.2002 13:39:36)
 * @author Christoph Oechslein
 */

final class RandomGammaSpecificFunctionArgsDeclaration extends AbstractSpecificFunctionArgsDeclaration {
	public RandomGammaSpecificFunctionArgsDeclaration() {
		super(
			"RandomGamma",
			DoubleType.getInstance(),
			CollectionsHelper.createList(DoubleType.getInstance(), DoubleType.getInstance()),
			false);

		setDocumentation(
			"Draws a random double of the Gamma distribution with parameter alpha and lambda."
				+ " E(X)=alpha/lambda ; Var(X)=alpha/lambda^2.");
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions) {
		Assert.assertEquals(2, functions.size());
		return new FunctionRandomGamma(functions.getFunction(0), functions.getFunction(1));
	}

	public String getSpecificInputTypeNameAt(int index) {
		if (index == 0)
			return "alpha";
		else if (index == 1)
			return "lambda";
		else
			return super.getSpecificInputTypeNameAt(index);
	}

}