package de.uniwue.ki.mas.basics.function.random;

import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionArgsDeclaration;
import de.uniwue.ki.mas.basics.type.IntegerType;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Creation date: (16.01.2002 13:39:36)
 * @author Christoph Oechslein
 */

final class RandomIntSpecificFunctionArgsDeclaration extends AbstractSpecificFunctionArgsDeclaration {
	public RandomIntSpecificFunctionArgsDeclaration() {
		super(
			"RandomInt",
			IntegerType.getInstance(),
			CollectionsHelper.createList(IntegerType.getInstance(), IntegerType.getInstance()),
			false);

		setDocumentation("Returns a random int in the interval [arg1, arg2), i.e. excluding arg2, including arg1.");
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions) {
		Assert.assertEquals(2, functions.size());
		return new FunctionRandomInt(functions.getFunction(0), functions.getFunction(1));
	}

	public String getSpecificInputTypeNameAt(int index) {
		if (index == 0)
			return "from";
		else
			return "to";
	}

}