package de.uniwue.ki.mas.basics.function.random;

import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionArgsDeclaration;
import de.uniwue.ki.mas.basics.type.DoubleType;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Creation date: (16.01.2002 13:39:36)
 * @author Christoph Oechslein
 */

final class RandomPoissonSpecificFunctionArgsDeclaration extends AbstractSpecificFunctionArgsDeclaration {
	public RandomPoissonSpecificFunctionArgsDeclaration() {
		super(
			"RandomPoisson",
			DoubleType.getInstance(),
			CollectionsHelper.createList(DoubleType.getInstance()),
			false);

		setDocumentation(
			"Draws a random int of the poisson distribution with parameter lambda."
				+ " E(X)=lambda and Var(X)=lambda.");
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions) {
		Assert.assertEquals(1, functions.size());
		return new FunctionRandomPoisson(functions.getFunction(0));
	}

	public String getSpecificInputTypeNameAt(int index) {
		if (index == 0)
			return "lambda";
		else
			return super.getSpecificInputTypeNameAt(index);
	}

}