package de.uniwue.ki.mas.basics.function.rest;
import de.uniwue.ki.mas.basics.functionDeclaration.IGenericFunctionDeclaration;
import de.uniwue.ki.mas.basics.functionDeclaration.list.FunctionDeclarationList;
import de.uniwue.ki.mas.basics.functionDeclaration.list.IFunctionDeclarationList;

/**
 * Creation date: (20.11.2001 16:08:46)
 * @author Christoph Oechslein
 */

public final class FunctionDeclarationRestFactory {

	private static IFunctionDeclarationList _cachedFunctionDeclarationList =
		new FunctionDeclarationList();

	public static final IGenericFunctionDeclaration IF_THEN_ELSE_GENERIC_FUNCTION_DECLARATION =
		new IfThenElseGenericFunctionDeclaration();
	public static final IGenericFunctionDeclaration DO_WITH_GENERIC_FUNCTION_DECL =
		new DoWithGenericFunctionDeclaration();

	static {
		// cast: <T1> cast(<T2>)
		// T2 is unspecific
		_cachedFunctionDeclarationList.add(new CastGenericFunctionDeclaration());
		
		_cachedFunctionDeclarationList.add(new InstanceOfGenericFunctionDeclaration());

		// if then else
		_cachedFunctionDeclarationList.add(IF_THEN_ELSE_GENERIC_FUNCTION_DECLARATION);
		IF_THEN_ELSE_GENERIC_FUNCTION_DECLARATION.setDocumentation(
			"Possibility to use function (Arg2) or function (Arg3) - depending on verity content (Arg1)");

		// DoWith(fun<(T) Void>, T)
		_cachedFunctionDeclarationList.add(DO_WITH_GENERIC_FUNCTION_DECL);

	}

	/**
	 * @param functionDeclarationList IFunctionDeclarationList
	 */
	public static void insertFunctions(IFunctionDeclarationList functionDeclarationList) {
		functionDeclarationList.addAll(_cachedFunctionDeclarationList);
	}

}