package de.uniwue.ki.mas.basics.function.string;
import java.util.Iterator;

import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class FunctionAppendStrings extends AbstractFunctionDynamic {
    private final IFunctionList _stringFunctions;

/**
 * @param stringFunctions IFunctionList
 */
public FunctionAppendStrings(IFunctionList stringFunctions) {
    super();

    _stringFunctions = stringFunctions;
}


/**
 * @param executeFunctionArgs IExecuteFunctionArgs
 * @return Object
 * @throws SimulationRuntimeException
 * @see de.uniwue.ki.mas.basics.function.IFunction#execute(IExecuteFunctionArgs)
 */
public Object execute(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
    return executeStatic(_stringFunctions.iterator(), executeFunctionArgs);
}


/**
 * @param functions Iterator
 * @param executeFunctionArgs IExecuteFunctionArgs
 * @return String
 * @throws SimulationRuntimeException
 */
public static final String executeStatic(Iterator functions, IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {

    StringBuffer buff = new StringBuffer();

    while (functions.hasNext()) {
        IFunction function = (IFunction) functions.next();

        buff.append((String) function.execute(executeFunctionArgs));
    }

    return buff.toString();
}


/**
 * @return String
 * @see de.uniwue.ki.util.INamed#getName()
 */
public String getName() {
    return "Append" + _stringFunctions.getName();
}
}