package de.uniwue.ki.mas.basics.function.string;
import de.uniwue.ki.mas.basics.functionDeclaration.list.FunctionDeclarationList;
import de.uniwue.ki.mas.basics.functionDeclaration.list.IFunctionDeclarationList;

/**
 * Creation date: (16.01.2002 13:39:36)
 * @author Christoph Oechslein
 */

public class FunctionDeclarationStringFactory {
	private static IFunctionDeclarationList _cachedFunctionDeclarationList;

	public synchronized static void insertFunctions(IFunctionDeclarationList functionDeclarationList) {
				if (_cachedFunctionDeclarationList == null) {
					_cachedFunctionDeclarationList = new FunctionDeclarationList();
					insertFunctionsIntern(_cachedFunctionDeclarationList);
		}

		functionDeclarationList.addAll(_cachedFunctionDeclarationList);
	}

	private static void insertFunctionsIntern(IFunctionDeclarationList functionDeclarationList) {
		functionDeclarationList.add(new SpecificFunctionDeclarationToString());
		functionDeclarationList.add(new SpecificFunctionDeclarationAppend());
		functionDeclarationList.add(new SpecificFunctionDeclarationSubstring());
		functionDeclarationList.add(new SpecificFunctionDeclarationLength());
		functionDeclarationList.add(new SpecificFunctionDeclarationGreater());
		functionDeclarationList.add(new SpecificFunctionDeclarationGreaterOrEquals());
		functionDeclarationList.add(new SpecificFunctionDeclarationToLowerCase());
	}
}