package de.uniwue.ki.mas.basics.function.string;
import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.basics.function.bool.AbstractBooleanFunction;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class FunctionStringGreater extends AbstractBooleanFunction {
	private final IFunction _stringAFunction;
	private final IFunction _stringBFunction;

	public FunctionStringGreater(IFunction stringAFunction, IFunction stringBFunction) {
		super();

		_stringAFunction = stringAFunction;
		_stringBFunction = stringBFunction;
	}

	public boolean executeForBoolean(IExecuteFunctionArgs executeFunctionArgs)
		throws SimulationRuntimeException {
		String stringA = (String) _stringAFunction.execute(executeFunctionArgs);
		String stringB = (String) _stringBFunction.execute(executeFunctionArgs);
		return stringA.compareTo(stringB) >= 0;
	}

	public void appendName(StringBuffer buff, int currDepth, int maxDepth) {
		if (currDepth >= maxDepth) {
			buff.append("...");
		} else {
			buff.append("GreaterOrEquals(");
			_stringAFunction.appendName(buff, currDepth + 1, maxDepth);
			buff.append(", ");
			_stringBFunction.appendName(buff, currDepth + 1, maxDepth);
			buff.append(')');
		}
	}

	public String getName() {
		return getNameIntern();
	}
}