package de.uniwue.ki.mas.basics.function.string;
import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.basics.function.number.AbstractIntegerFunction;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class FunctionStringLength extends AbstractIntegerFunction {
	private final IFunction _stringIndexFunction;

	public FunctionStringLength(IFunction stringIndexFunction) {
		super();

		_stringIndexFunction = stringIndexFunction;
	}

	public int executeForInt(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
		String string = (String) _stringIndexFunction.execute(executeFunctionArgs);

		return string.length();
	}

	public void appendName(StringBuffer buff, int currDepth, int maxDepth) {
		if (currDepth >= maxDepth) {
			buff.append("...");
		} else {
			buff.append("Length(");
			_stringIndexFunction.appendName(buff, currDepth + 1, maxDepth);
			buff.append(')');
		}
	}

	public String getName() {
		return getNameIntern();
	}
}