package de.uniwue.ki.mas.basics.function.string;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.type.ISpecificType;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class FunctionToString extends AbstractFunctionDynamic {
	private final ISpecificType _type;
	private final IFunction _objectFunction;

	public FunctionToString(ISpecificType type, IFunction objectFunction) {
		super();

		_type = type;
		_objectFunction = objectFunction;
	}

	public Object execute(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
		StringBuffer buff = new StringBuffer();
		
		_type.appendNameForArgumentObject(buff, _objectFunction.execute(executeFunctionArgs), 0, 30);
		
		return buff.toString();
	}

	public String getName() {
		return "ToString(" + _objectFunction.getName() + ")";
	}
}