package de.uniwue.ki.mas.basics.function.string;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionUnlimitedArgsDeclaration;
import de.uniwue.ki.mas.basics.type.StringType;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (01.10.2001 16:25:22)
 * @author Christoph Oechslein
 */

final class SpecificFunctionDeclarationAppend extends AbstractSpecificFunctionUnlimitedArgsDeclaration {
	public SpecificFunctionDeclarationAppend() {
		super("Append", StringType.getInstance(), StringType.getInstance(), 0, 2, true);

		setDocumentation("Appends its Strings in given order e.g. Append('Hallo', ' World') = 'Hallo World'");
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions) {
		return new FunctionAppendStrings(functions);
	}

	// just for faster dynamic calling
	public Object execute(
		ICreateAndExecuteFunctionArgs createAndExecuteFunctionArgs,
		IFunctionList functions)
		throws SimulationRuntimeException {

		if (functions.size() == 0) {
			return "";

		} else if (functions.size() == 1) {
			return (String) functions.getFunction(0).execute(createAndExecuteFunctionArgs);

		} else if (functions.size() == 2) {
			return ((String) functions.getFunction(0).execute(createAndExecuteFunctionArgs))
				+ ((String) functions.getFunction(1).execute(createAndExecuteFunctionArgs));

		} else {
			return FunctionAppendStrings.executeStatic(functions.iterator(), createAndExecuteFunctionArgs);
		}
	}
}