package de.uniwue.ki.mas.basics.function.string;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionArgsDeclaration;
import de.uniwue.ki.mas.basics.type.BooleanType;
import de.uniwue.ki.mas.basics.type.StringType;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Creation date: (01.10.2001 16:25:22)
 * @author Christoph Oechslein
 */

final class SpecificFunctionDeclarationGreaterOrEquals extends AbstractSpecificFunctionArgsDeclaration {
	public SpecificFunctionDeclarationGreaterOrEquals() {
		super(
			"GreaterOrEquals",
			BooleanType.getInstance(),
			CollectionsHelper.createList(StringType.getInstance(), StringType.getInstance()),
			true,
			false);

		setDocumentation("Returns true if Arg1 is equal to or lexocraphically greater than Arg2.");
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions) {
		return new FunctionStringGreaterOrEquals(functions.getFunction(0), functions.getFunction(1));
	}
}