package de.uniwue.ki.mas.basics.function.string;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionArgsDeclaration;
import de.uniwue.ki.mas.basics.type.IntegerType;
import de.uniwue.ki.mas.basics.type.StringType;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Creation date: (01.10.2001 16:25:22)
 * @author Christoph Oechslein
 */

final class SpecificFunctionDeclarationLength extends AbstractSpecificFunctionArgsDeclaration {
	public SpecificFunctionDeclarationLength() {
		super(
			"Length",
			IntegerType.getInstance(),
			CollectionsHelper.createList(StringType.getInstance()),
			true,
			false);

		setDocumentation("Returns length of the given string.");
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions) {
		return new FunctionStringLength(functions.getFunction(0));
	}
}