package de.uniwue.ki.mas.basics.function.string;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionArgsDeclaration;
import de.uniwue.ki.mas.basics.type.IntegerType;
import de.uniwue.ki.mas.basics.type.StringType;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Creation date: (01.10.2001 16:25:22)
 * @author Christoph Oechslein
 */

final class SpecificFunctionDeclarationSubstring extends AbstractSpecificFunctionArgsDeclaration {
	public SpecificFunctionDeclarationSubstring() {
		super(
			"Substring",
			StringType.getInstance(),
			CollectionsHelper.createList(
				StringType.getInstance(),
				IntegerType.getInstance(),
				IntegerType.getInstance()),
			true,
			false);

		setDocumentation("Returns the substring from Arg2 to Arg3 of the given string (Arg1).");
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions) {
		return new FunctionSubstring(
			functions.getFunction(0),
			functions.getFunction(1),
			functions.getFunction(2));
	}

	public String getSpecificInputTypeNameAt(int index) {
		if (index == 1) {
			return "Begin";

		} else if (index == 2) {
			return "End";

		} else {

			return super.getSpecificInputTypeNameAt(index);
		}
	}

}