package de.uniwue.ki.mas.basics.function.string;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionArgsDeclaration;
import de.uniwue.ki.mas.basics.type.StringType;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Creation date: (01.10.2001 16:25:22)
 * @author Christoph Oechslein
 */

final class SpecificFunctionDeclarationToLowerCase extends AbstractSpecificFunctionArgsDeclaration {
	public SpecificFunctionDeclarationToLowerCase() {
		super(
			"ToLowerCase",
			StringType.getInstance(),
			CollectionsHelper.createList(StringType.getInstance()),
			true,
			false);

		setDocumentation("Converts all of the characters in the given string to lower case.");
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions) {
		return new FunctionToLowerCase(functions.getFunction(0));
	}
}