package de.uniwue.ki.mas.basics.function.string;
import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionCall.IComposedFunctionCallInternDeclaration;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionArgsDeclaration;
import de.uniwue.ki.mas.basics.type.ObjectType;
import de.uniwue.ki.mas.basics.type.StringType;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Creation date: (01.10.2001 16:25:22)
 * @author Christoph Oechslein
 */

final class SpecificFunctionDeclarationToString extends AbstractSpecificFunctionArgsDeclaration {
	public SpecificFunctionDeclarationToString() {
		super(
			"ToString",
			StringType.getInstance(),
			CollectionsHelper.createList(ObjectType.getInstance()),
			true,
			false);

		setDocumentation("Converts its operand to a String object");
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions) {
		throw new UnsupportedOperationException();
	}

	public IFunction createFunction(
		ICreateFunctionArgs createFunctionArgs,
		IComposedFunctionCallInternDeclaration composedFunctionCallInternDeclaration)
		throws ModelCompilingException {

		Assert.assertEquals(1, composedFunctionCallInternDeclaration.getChildCount());

		return new FunctionToString(
			composedFunctionCallInternDeclaration.getChild(0).getSpecificOutputType(),
			composedFunctionCallInternDeclaration.getChild(0).createFunction(createFunctionArgs));
	}
}