package de.uniwue.ki.mas.basics.function.variable;
import de.uniwue.ki.mas.basics.functionDeclaration.IGenericFunctionDeclaration;
import de.uniwue.ki.mas.basics.functionDeclaration.list.FunctionDeclarationList;
import de.uniwue.ki.mas.basics.functionDeclaration.list.IFunctionDeclarationList;

/**
 * Creation date: (22.08.2001 14:07:52)
 * @author Christoph Oechslein
 */

public class FunctionDeclarationVariableFactory {

	public static final IGenericFunctionDeclaration GET_VARIABLE_GENERIC_FUNCTION_DECLARATION =
		new GetVariableGenericFunctionDeclaration();
	public static final IGenericFunctionDeclaration GET_VARIABLE_OF_GENERIC_FUNCTION_DECLARATION =
		new GetVariableOfGenericFunctionDeclaration();
	public static final IGenericFunctionDeclaration SET_VARIABLE_GENERIC_FUNCTION_DECLARATION =
		new SetVariableGenericFunctionDeclaration();
	public static final IGenericFunctionDeclaration SET_VARIABLE_OF_GENERIC_FUNCTION_DECLARATION =
		new SetVariableOfGenericFunctionDeclaration();

	private static IFunctionDeclarationList _cachedFunctionDeclarationList = new FunctionDeclarationList();

	static {
		insertFunctionsIntern();
	}

	public static void insertFunctions(IFunctionDeclarationList functionDeclarationList) {
		functionDeclarationList.addAll(_cachedFunctionDeclarationList);
	}

	private static void insertFunctionsIntern() {
		// <T> get_var(variable<T>)
		_cachedFunctionDeclarationList.add(GET_VARIABLE_GENERIC_FUNCTION_DECLARATION);
		//
		// <T> get_var_from(variable<T>)
		_cachedFunctionDeclarationList.add(GET_VARIABLE_OF_GENERIC_FUNCTION_DECLARATION);

		_cachedFunctionDeclarationList.add(SET_VARIABLE_GENERIC_FUNCTION_DECLARATION);

		_cachedFunctionDeclarationList.add(SET_VARIABLE_OF_GENERIC_FUNCTION_DECLARATION);

		// increment
		_cachedFunctionDeclarationList.add(new IncrementVarGenericFunctionDeclaration());
		_cachedFunctionDeclarationList.add(new IncrementVarOfGenericFunctionDeclaration());
	}
}