package de.uniwue.ki.mas.basics.function.variable;

import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionAdapterGenericFunctionDeclaration;
import de.uniwue.ki.mas.basics.type.*;
/**
 * Creation date: (01.02.2002 10:52:31)
 * @author Christoph Oechslein
 */
public class GetVariableOfSpecificFunctionDeclaration
	extends AbstractSpecificFunctionAdapterGenericFunctionDeclaration {
	private final ISpecificType _outputType;

	/**
	 * @param getVariableOfGenericFunctionDeclaration GetVariableOfGenericFunctionDeclaration
	 * @param outputType ISpecificType
	 */
	public GetVariableOfSpecificFunctionDeclaration(
		GetVariableOfGenericFunctionDeclaration getVariableOfGenericFunctionDeclaration,
		ISpecificType outputType) {
		super(getVariableOfGenericFunctionDeclaration, 2);

		_outputType = outputType;
	}

	public ISpecificType getSpecificOutputType() {
		return _outputType;
	}

	public ISpecificType getSpecificInputTypeAt(int index) {
		if (index == 0) {
			return GenericVariableClassDeclarationType.getInstance(true, false).createSpecificVariableType(_outputType);

		} else if (index == 1) {
			return GenericSimObjectType.getGeneralSimObjectType();

		} else {
			Assert.fail();
			return null;
		}
	}
	
	public String getSpecificInputTypeNameAt(int index) {
		if (index == 0) {
			return "variable class";
		} else if (index == 1) {
			return "simObject";
		} else {
			Assert.fail();
			return null;
		}
	}


	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions) {
		if (Assert.ASSERTION_ON)
			Assert.assertEquals(2, functions.size());

		return new FunctionGetVariableOf(functions.getFunction(0), functions.getFunction(1));
	}

}