package de.uniwue.ki.mas.basics.function.variable;
import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionCall.FunctionCallDeclarationFactory;
import de.uniwue.ki.mas.basics.functionCall.IFunctionCallInternDeclaration;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionArgsDeclaration;
import de.uniwue.ki.mas.basics.type.*;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Creation date: (22.08.2001 14:07:52)
 * @author Christoph Oechslein
 */

public final class IncrementVariableOfSpecificFunctionDeclaration
	extends AbstractSpecificFunctionArgsDeclaration {

	public IncrementVariableOfSpecificFunctionDeclaration(ISpecificType numberType) {
		super(
			"IncrementVarOf",
			VoidType.getInstance(),
			CollectionsHelper.createList(
				GenericVariableClassDeclarationType.getInstance(true, true).createSpecificVariableType(
					numberType),
				numberType,
				GenericSimObjectType.getGeneralSimObjectType()));
	}

	public IFunctionCallInternDeclaration createDefaultFunctionCallInternDeclarationAt(int index) {
		if (index == 1) {
			return FunctionCallDeclarationFactory.getInstance().createAtomicFunctionCallInternDeclaration(
				null,
				getNumberType(),
				new Integer(1));

		} else {
			return super.createDefaultFunctionCallInternDeclarationAt(index);
		}
	}

	private ISpecificType getNumberType() {
		return getSpecificInputTypeAt(1);
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions) {
		Assert.assertEquals(3, functions.size());

		return new FunctionActionIncrementVariableOf(
			functions.getFunction(0),
			functions.getFunction(1),
			functions.getFunction(2),
			getNumberType());
	}
}