package de.uniwue.ki.mas.basics.function.variable;

import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionAdapterGenericFunctionDeclaration;
import de.uniwue.ki.mas.basics.type.*;

/**
 * @author oechslein
 * 
 * Creation date: 04.06.2003
 */
final class SetVariableOfSpecificFunctionDeclaration
	extends AbstractSpecificFunctionAdapterGenericFunctionDeclaration {

	private final ISpecificType _specificTypeT;

	public SetVariableOfSpecificFunctionDeclaration(
		SetVariableOfGenericFunctionDeclaration genericFunctionDeclaration,
		int defaultArgLength,
		ISpecificType specificTypeT) {
		super(genericFunctionDeclaration, defaultArgLength);
		_specificTypeT = specificTypeT;
	}
	public ISpecificType getSpecificOutputType() {
		return VoidType.getInstance();
	}
	public ISpecificType getSpecificInputTypeAt(int index) {
		if (index == 0) {
			return GenericVariableClassDeclarationType.getInstance(
				true,
				true).createSpecificVariableType(
				_specificTypeT);

		} else if (index == 1) {
			return _specificTypeT;

		} else if (index == 2) {
			return GenericSimObjectType.getGeneralSimObjectType();

		} else {
			Assert.fail();
			return null;
		}
	}
		
	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions) {
		if (Assert.ASSERTION_ON)
			Assert.assertEquals(3, functions.size());

		return new FunctionActionSetVariableOf(
			_specificTypeT,
			functions.getFunction(0),
			functions.getFunction(1),
			functions.getFunction(2));
	}
	
	public String getSpecificInputTypeNameAt(int index) {
//		if (!GenericSimObjectType.getGeneralSimObjectType().equals(_specificTypeT)) {
//			return super.getSpecificInputTypeNameAt(index);
//
//		} else 
		if (index == 0) {
			return "variable";

		} else if (index == 1) {
			return "new value";

		} else if (index == 2) {
			return "body";

		} else {
			Assert.fail();
			return null;
		}
	}
}