package de.uniwue.ki.mas.basics.function.variable;

import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionAdapterGenericFunctionDeclaration;
import de.uniwue.ki.mas.basics.type.*;

/**
 * @author oechslein
 * 
 * Creation date: 04.06.2003
 */
final class SetVariableSpecificFunctionDeclaration
	extends AbstractSpecificFunctionAdapterGenericFunctionDeclaration {

	private final ISpecificType _typeT;

	public SetVariableSpecificFunctionDeclaration(
		SetVariableGenericFunctionDeclaration genericFunctionDeclaration,
		int defaultArgLength,
		ISpecificType typeT) {
		super(genericFunctionDeclaration, defaultArgLength);
		_typeT = typeT;
	}

	public ISpecificType getSpecificOutputType() {
		return VoidType.getInstance();
	}

	public ISpecificType getSpecificInputTypeAt(int index) {
		if (index == 0) {
			return GenericVariableClassDeclarationType.getInstance(false, true).createSpecificVariableType(
				_typeT);
		} else if (index == 1) {
			return _typeT;
		} else {
			Assert.fail();
			return null;
		}
	}

	public String getSpecificInputTypeNameAt(int index) {
		if (index == 0)
			return "variable";
		else if (index == 1)
			return "value";
		else
			return super.getSpecificInputTypeNameAt(index);
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions) {
		if (Assert.ASSERTION_ON)
			Assert.assertEquals(2, functions.size());

		return new FunctionActionSetVariable(
			_typeT,
			(IFunction) functions.get(0),
			(IFunction) functions.get(1));
	}
}