package de.uniwue.ki.mas.basics.functionArgument;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.model.SimulationRuntimeException;
import de.uniwue.ki.util.name.AbstractNamed;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

abstract class AbstractArgumentBindings extends AbstractNamed implements IArgumentBindings {

	public AbstractArgumentBindings() {
		super();
	}

	public boolean containsBindingFor(IFunctionArgument functionArgument) {
		return false;
	}

	public Object getArgumentValueFor(IFunctionArgument functionArgument) throws SimulationRuntimeException {
		throw new SimulationRuntimeException("Argument '" + functionArgument.getName() + "' not found!");
	}

	public final String getName() {
		return getNameIntern();
	}

	public final void appendName(StringBuffer buff, int currDepth, int maxDepth) {
		if (currDepth > maxDepth) {
			buff.append("...");
		} else {
			appendNameIntern(buff);
		}
	}

	protected abstract void appendNameIntern(StringBuffer buff);

	public static void appendName(
		StringBuffer buff,
		IFunctionArgument functionArgument,
		IFunction function) {
		buff.append(functionArgument.getName());
		buff.append("=");

		if (function == null) {
			buff.append("<unknown>");
		} else {
			buff.append(function.getName());
		}
	}

}