package de.uniwue.ki.mas.basics.functionArgument;

import junit.framework.Assert;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * @author oechslein
 * 
 * Creation date: 16.06.2003
 */
public class ArgumentBindingsArray extends AbstractArgumentBindings {
	private final IArgumentBindings[] _argumentBindingsArray;

	public ArgumentBindingsArray(IArgumentBindings[] argumentBindingsArray) {
		Assert.assertNotNull(argumentBindingsArray);
		_argumentBindingsArray = argumentBindingsArray;
	}

	public IArgumentBindings saveCurrentArgumentBindings() {
		IArgumentBindings[] newArgumentBindingArray = null;

		for (int i = 0; i < _argumentBindingsArray.length; i++) {
			IArgumentBindings savedCurrentArgumentBindings =
				_argumentBindingsArray[i].saveCurrentArgumentBindings();

			if (savedCurrentArgumentBindings != _argumentBindingsArray[i]) {
				if (newArgumentBindingArray == null) {
					newArgumentBindingArray = new IArgumentBindings[_argumentBindingsArray.length];
				}
				newArgumentBindingArray[i] = savedCurrentArgumentBindings;
			}
		}

		if (newArgumentBindingArray == null)
			return this;
		else
			return new ArgumentBindingsArray(newArgumentBindingArray);
	}

	public boolean containsBindingFor(IFunctionArgument functionArgument) {
		for (int i = 0; i < _argumentBindingsArray.length; i++) {
			if (_argumentBindingsArray[i].containsBindingFor(functionArgument))
				return true;
		}

		return false;
	}

	public Object getArgumentValueFor(IFunctionArgument functionArgument) throws SimulationRuntimeException {
		for (int i = 0; i < _argumentBindingsArray.length; i++) {
			if (_argumentBindingsArray[i].containsBindingFor(functionArgument))
				return _argumentBindingsArray[i].getArgumentValueFor(functionArgument);
		}

		throw new SimulationRuntimeException(
			"Function Argument '" + functionArgument.getName() + "' not found!");
	}

	protected void appendNameIntern(StringBuffer buff) {
		for (int i = 0; i < _argumentBindingsArray.length; i++) {
			_argumentBindingsArray[i].appendName(buff, 0, 10);
		}
	}
}
