package de.uniwue.ki.mas.basics.functionArgument;
import java.util.Iterator;

import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.AbstractFunctionDynamic;
import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class FunctionArgument extends AbstractFunctionDynamic implements IFunctionArgument {
	private Object _currentValue;
	private final IFunctionArgumentDeclaration _functionArgumentDeclaration;

	public FunctionArgument(IFunctionArgumentDeclaration functionArgumentDeclaration) {
		super();

		_functionArgumentDeclaration = functionArgumentDeclaration;
	}

	public final Object execute(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
		return executeFunctionArgs.getArgumentValueFor(this);
	}

	public final String getName() {
		return _functionArgumentDeclaration.getName() + "_" + (System.identityHashCode(this) % 100);
	}

	public Object getObject() {
		return _currentValue;
	}

	public void setObject(Object object) {
		Assert.assertTrue(!(object instanceof Iterator));

		_currentValue = object;
	}
}