package de.uniwue.ki.mas.basics.functionArgument;
import de.uniwue.ki.mas.basics.type.ISpecificType;
import de.uniwue.ki.mas.basics.type.TypeManager;
import de.uniwue.ki.mas.util.declaration.AbstractDeclarationFactory;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: (04.09.2001 16:05:27)
 * @author Christoph Oechslein
 */

public final class FunctionArgumentDeclarationFactory extends AbstractDeclarationFactory {
	private static FunctionArgumentDeclarationFactory instance = new FunctionArgumentDeclarationFactory();

	public FunctionArgumentDeclarationFactory() {
		super();
	}

	public IFunctionArgumentDeclaration createArgumentDeclaration() {
		return createArgumentDeclaration(TypeManager.getInstance().getDefaultType());
	}

	public IFunctionArgumentDeclaration createArgumentDeclaration(ISpecificType type) {
		return new FunctionArgumentDeclaration(type);
	}

	public IFunctionArgumentDeclaration createArgumentDeclaration(String name, ISpecificType type) {
		return new FunctionArgumentDeclaration(name, type);
	}

	public IDeclaration createDeclaration() {
		return createArgumentDeclaration();
	}

	public static final FunctionArgumentDeclarationFactory getInstance() {
		return instance;
	}
}