package de.uniwue.ki.mas.basics.functionArgument;
import java.util.*;

import de.uniwue.ki.mas.util.declaration.DefaultDeclarationList;

/**
 * Creation date: (25.10.2001 16:42:45)
 * @author Christoph Oechslein
 */

public class FunctionArgumentDeclarationList
	extends DefaultDeclarationList
	implements IFunctionArgumentDeclarationList {

	public FunctionArgumentDeclarationList(int size) {
		super(size);
	}

	public FunctionArgumentDeclarationList(IFunctionArgumentDeclarationList functionArgumentDeclarationList) {
		super(functionArgumentDeclarationList);
	}

	public FunctionArgumentDeclarationList() {
		super();
	}

	public boolean accept(Object declaration) {
		return declaration instanceof IFunctionArgumentDeclaration;
	}

	public void copyInto(Object intoObject, Map objectMapping) {
		if (objectMapping == null) {
			objectMapping = new HashMap();
		}

		FunctionArgumentDeclarationList dstFunctionArgumentDeclarationList =
			(FunctionArgumentDeclarationList)intoObject;

		dstFunctionArgumentDeclarationList.clear();

		Iterator it = iterator();

		while (it.hasNext()) {
			IFunctionArgumentDeclaration currFunctionArgumentDeclaration =
				(IFunctionArgumentDeclaration)it.next();

			if (objectMapping.containsKey(currFunctionArgumentDeclaration)) {
				dstFunctionArgumentDeclarationList.add(objectMapping.get(currFunctionArgumentDeclaration));

			} else {
				IFunctionArgumentDeclaration copyCurrDeclaration =
					new FunctionArgumentDeclaration(
						currFunctionArgumentDeclaration.getName(),
						currFunctionArgumentDeclaration.getSpecificType());

				objectMapping.put(currFunctionArgumentDeclaration, copyCurrDeclaration);

				dstFunctionArgumentDeclarationList.add(copyCurrDeclaration);
			}
		}
	}

	public int hashCode() {
		return super.hashCode();
	}
}