package de.uniwue.ki.mas.basics.functionArgument;
import java.io.Serializable;

import de.uniwue.ki.mas.model.SimulationRuntimeException;
import de.uniwue.ki.util.name.INamed;

/**
 * Encapsulate values for arguments, a binding environment.
 * Creation date: (12.06.2001 10:19:47)
 * @author Christoph Oechslein
 */

public interface IArgumentBindings extends Serializable, INamed {

	final class NullArgumentBindings extends AbstractArgumentBindings {
		protected NullArgumentBindings() {
		}

		public Object getArgumentValueFor(IFunctionArgument functionArgument) {
			return null;
		}

		public IArgumentBindings saveCurrentArgumentBindings() {
			return this;
		}

		protected void appendNameIntern(StringBuffer buff) {
			buff.append("[]");
		}
	}

	IArgumentBindings NULL_ARGUMENT_BINDINGS = new NullArgumentBindings();

	boolean containsBindingFor(IFunctionArgument functionArgument);

	Object getArgumentValueFor(IFunctionArgument functionArgument) throws SimulationRuntimeException;

	IArgumentBindings saveCurrentArgumentBindings();
}