package de.uniwue.ki.mas.basics.functionArgument;
import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.IFunctionList;
import de.uniwue.ki.mas.model.SimulationRuntimeException;
/**
 * Creation date: (22.02.2002 09:53:26)
 * @author Christoph Oechslein
 */
interface IMutableArgumentBindings extends IArgumentBindings {
	final class NullMutableArgumentBindings extends AbstractMutableArgumentBindings {
		protected NullMutableArgumentBindings() {
		}

		public void appendNameIntern(StringBuffer buff) {
		}

		public IArgumentBindings saveCurrentArgumentBindings() {
			return this;
		}

		public void calculateArguments(IExecuteFunctionArgs executeFunctionArgs)
			throws SimulationRuntimeException {
		}

		public Object getArgumentValueFor(IFunctionArgument functionArgument)
			throws SimulationRuntimeException {

			throw new SimulationRuntimeException(
				"Function Argument '" + functionArgument.getName() + "' not found!");
		}

		public boolean containsBindingFor(IFunctionArgument functionArgument) {
			return false;
		}

		public void setFunctionList(IFunctionList newFunctionList) {
			Assert.assertEquals(0, newFunctionList.size());
		}
	}

	IMutableArgumentBindings NULL_MUTABLE_ARGUMENT_BINDINGS = new NullMutableArgumentBindings();

	void setFunctionList(IFunctionList newFunctionList);
	void calculateArguments(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException;
}