package de.uniwue.ki.mas.basics.functionArgument;
import java.util.Iterator;

import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionCall.IComposedFunctionCallInternDeclaration;
import de.uniwue.ki.mas.basics.functionCall.IFunctionCallDeclaration;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Enhance IFunctionCallDeclaration by adding argument declarations for creating a parametric function,
 *
 * Creation date: (12.06.2001 10:28:21)
 * @author Christoph Oechslein
 */

public interface IParametricFunctionCallDeclaration extends IDeclaration {

	IParametricFunction createParametricFunction(ICreateFunctionArgs createFunctionArgs)
		throws ModelCompilingException;

	IFunctionArgumentDeclarationList getFunctionArgumentDeclarationList();

	IFunctionCallDeclaration getFunctionCallDeclaration();

	IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions)
		throws ModelCompilingException;

	IFunction createFunction(
		ICreateFunctionArgs createFunctionArgs,
		IComposedFunctionCallInternDeclaration composedFunctionCallInternDeclaration)
		throws ModelCompilingException;
		
	boolean isInlinePossible();
	void setInlinePossible(boolean inlinePossible);
	
	Iterator getReferencedSpecificTypes();
}