package de.uniwue.ki.mas.basics.functionArgument;
import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionCall.IFunctionCallDeclaration;

/**
 * Creation date: (12.06.2001 14:20:58)
 * @author Christoph Oechslein
 */

final class NullArgumentsParametricFunction extends AbstractParametricFunction implements IParametricFunctionDeferred {

	private IFunction _function;
	private final IParametricFunctionCallDeclaration _parametricFunctionCallDeclaration;

	public NullArgumentsParametricFunction(
		IParametricFunctionCallDeclaration parametricFunctionCallDeclaration,
		IFunction function) {
		super();

		_parametricFunctionCallDeclaration = parametricFunctionCallDeclaration;
		setRealFunction(function);
	}

	public NullArgumentsParametricFunction(IParametricFunctionCallDeclaration parametricFunctionCallDeclaration) {
		super();

		_parametricFunctionCallDeclaration = parametricFunctionCallDeclaration;
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions) {
		// also possible that there are only _unused_ arguments!
		// if (Assert.ASSERTION_ON) Assert.assertTrue(functions.isEmpty());

		Assert.assertNotNull(_function);

		return _function;
	}

	public void setRealFunction(IFunction function) {
		Assert.assertNull(_function);
		
		_function = function;
	}

	public final IFunctionCallDeclaration getFunctionCallDeclaration() {
		return _parametricFunctionCallDeclaration.getFunctionCallDeclaration();
	}

	public final String getName() {
		return _parametricFunctionCallDeclaration.getName();
	}

	public void remove() {
	}
}