package de.uniwue.ki.mas.basics.functionArgument;
import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.ICreateFunctionArgs;
/**
 * Creation date: (22.02.2002 09:48:48)
 * @author Christoph Oechslein
 */
public class ParametricFunctionArgumentBindingsFactory {

	public static IMutableArgumentBindings createMutableArgumentBindings(
		ICreateFunctionArgs createFunctionArgs,
		IFunctionArgumentDeclarationList functionArgumentDeclarationList) {

		switch (functionArgumentDeclarationList.size()) {
			case 0 :
				Assert.assertFalse(createFunctionArgs.getFunctionDeclarationCompiler().isCompileOn());
				return IMutableArgumentBindings.NULL_MUTABLE_ARGUMENT_BINDINGS;

			case 1 :
				return new OneArgumentArgumentBindings(
					(IFunctionArgumentDeclaration) functionArgumentDeclarationList.get(0));

			default :
				return new ArgumentBindings(functionArgumentDeclarationList);
		}
	}
}