package de.uniwue.ki.mas.basics.functionArgument;

import junit.framework.Assert;
import de.uniwue.ki.mas.basics.functionCall.NamedFunctionCallDeclaration;
import de.uniwue.ki.util.hash.IIsomorphicHashable;

/**
 * Creation date: 03.07.2002, 09:01:59
 * @author oechslein
 */
public final class ParametricFunctionCallDeclarationHelper extends NamedFunctionCallDeclaration {
	private final ParametricFunctionCallDeclaration _parametricFunctionCallDeclaration;

	public ParametricFunctionCallDeclarationHelper(ParametricFunctionCallDeclaration parametricFunctionCallDeclaration) {
		super();

		_parametricFunctionCallDeclaration = parametricFunctionCallDeclaration;
	}

	private IFunctionArgumentDeclarationList getFunctionArgumentDeclarationList() {
		return _parametricFunctionCallDeclaration.getFunctionArgumentDeclarationList();
	}

	public int isomorphicHashCode() {
		Assert.assertNotNull(getFunctionArgumentDeclarationList());
		Assert.assertNotNull(_parametricFunctionCallDeclaration.getFunctionArgumentDeclarationList());

		return 3 * super.isomorphicHashCode() + getFunctionArgumentDeclarationList().isomorphicHashCode();
	}

	public boolean isomorphicEquals(IIsomorphicHashable obj) {
		if (obj == this)
			return true;

		if (!super.isomorphicEquals(obj))
			return false;

		if (!(obj instanceof ParametricFunctionCallDeclarationHelper))
			return false;

		ParametricFunctionCallDeclarationHelper parametricFunctionCallDeclarationHelper =
			(ParametricFunctionCallDeclarationHelper) obj;
		
		return getFunctionArgumentDeclarationList().isomorphicEquals(parametricFunctionCallDeclarationHelper.getFunctionArgumentDeclarationList());
		/* War komischerweise auskommentiert! Rainer Nov 2003
		 * return Utils.equals(
			getFunctionArgumentDeclarationList(),
			parametricFunctionCallDeclarationHelper.getFunctionArgumentDeclarationList());*/
			
	}
}
