package de.uniwue.ki.mas.basics.functionArgument;
import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;

/**
 * Creation date: (12.06.2001 14:20:58)
 * @author Christoph Oechslein
 */

final class ParametricFunctionNotReuseable extends AbstractParametricFunction {
	private final FunctionWithArgumentBinds _functionWithArgumentBinds;

	public ParametricFunctionNotReuseable(
		ICreateFunctionArgs createFunctionArgs,
		String name,
		IFunctionArgumentDeclarationList functionArgumentDeclarationList,
		IFunction function) {
		super();

		if (Assert.ASSERTION_ON)
			Assert.assertTrue(functionArgumentDeclarationList.size() > 0);

		_functionWithArgumentBinds =
			new FunctionWithArgumentBinds(
				name,
				function,
				ParametricFunctionArgumentBindingsFactory.createMutableArgumentBindings(
					createFunctionArgs,
					functionArgumentDeclarationList));
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions) {
		_functionWithArgumentBinds.getMutableArgumentBindings().setFunctionList(functions);

		return _functionWithArgumentBinds;
	}

	public final String getName() {
		return _functionWithArgumentBinds.getNameWithoutRealAndBindings();
	}

	public FunctionWithArgumentBinds getFunctionWithArgumentBinds() {
		return _functionWithArgumentBinds;
	}

}