package de.uniwue.ki.mas.basics.functionArgument;
import de.uniwue.ki.mas.basics.function.*;

/**
 * Creation date: (12.06.2001 14:20:58)
 * @author Christoph Oechslein
 */

final class ParametricFunctionReuseable extends AbstractParametricFunction {
	private final IFunctionArgumentDeclarationList _functionArgumentDeclarationList;
	private final IFunction _function;
	private final String _name;

	public ParametricFunctionReuseable(
		String name,
		IFunctionArgumentDeclarationList functionArgumentDeclarationList,
		IFunction function) {
		super();

		_name = name;
		_functionArgumentDeclarationList = functionArgumentDeclarationList;
		_function = function;

	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions) {
		IMutableArgumentBindings parametricFunctionArgumentBindings =
			ParametricFunctionArgumentBindingsFactory.createMutableArgumentBindings(
				createFunctionArgs,
				_functionArgumentDeclarationList);

		parametricFunctionArgumentBindings.setFunctionList(functions);

		return new FunctionWithArgumentBinds(_name, _function, parametricFunctionArgumentBindings);

	}

	public final String getName() {
		return _name;
	}
}