package de.uniwue.ki.mas.basics.functionArgument;
import de.uniwue.ki.mas.basics.function.*;

/**
 * Creation date: (12.06.2001 14:20:58)
 * @author Christoph Oechslein
 */

final class ParametricFunctionWithFunctionArgument extends AbstractParametricFunction {

	private final IFunctionArgument _functionArgument;
	private final String _name;

	public ParametricFunctionWithFunctionArgument(String name, IFunctionArgument functionArgument) {
		super();

		_functionArgument = functionArgument;
		_name = name;
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions) {
		return functions.getFunction(0);
	}

	public final String getName() {
		if (_name == null)
			return _functionArgument.getName();
		else
			return _name;
	}
}