package de.uniwue.ki.mas.basics.functionArgument;

import de.uniwue.ki.mas.model.SimulationRuntimeException;
import de.uniwue.ki.util.name.AbstractNamed;
/**
 * @author oechslein
 * 
 * Creation date: 20.05.2003
 */final class SavedOneArgumentBindings extends AbstractNamed implements IArgumentBindings {
	private final IFunctionArgument _functionArgument;
	private final Object _value;

	public SavedOneArgumentBindings(IFunctionArgument functionArgument, Object value) {
		_functionArgument = functionArgument;
		_value = value;
	}

	public String getName() {
		return getNameIntern();
	}

	public Object getArgumentValueFor(IFunctionArgument functionArgument) throws SimulationRuntimeException {
		if (_functionArgument == functionArgument) {
			return _value;
		}

		throw new SimulationRuntimeException("Argument '"+functionArgument.getName() +"' not found!");
}

public boolean containsBindingFor(IFunctionArgument functionArgument) {
	return _functionArgument == functionArgument;
}

public void appendName(StringBuffer buff, int currDepth, int maxDepth) {
	_functionArgument.appendName(buff, currDepth, maxDepth);
	buff.append(" = ");
buff.append(_value);
}

public IArgumentBindings saveCurrentArgumentBindings() {
	return this;
}

public boolean equals(Object obj) {
	if (this == obj) {
		return true;
	} else if (!(obj instanceof SavedOneArgumentBindings)) {
		return false;
	} else {
		SavedOneArgumentBindings savedArgumentBindings = (SavedOneArgumentBindings)obj;
		return (_functionArgument == savedArgumentBindings._functionArgument)
			&& (_value == savedArgumentBindings._value);
	}
}

public int hashCode() {
	return 3 * _functionArgument.hashCode() + (_value == null ? 31 : _value.hashCode());
}
}
