package de.uniwue.ki.mas.basics.functionArgument;
import junit.framework.*;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.function.number.FunctionDeclarationNumberFactory;
import de.uniwue.ki.mas.basics.functionCall.FunctionCallDeclarationFactory;
import de.uniwue.ki.mas.basics.type.DoubleType;
import de.uniwue.ki.mas.basics.type.argument.Argument;
import de.uniwue.ki.mas.sim.simulation.SimulationFunctionArgs;
import de.uniwue.ki.util.collection.CollectionsHelper;
public final class TestParametricFunction extends TestCase {

	/**
	 * TestParametricFunction constructor comment.
	 * @param name java.lang.String
	 */
	public TestParametricFunction(String name) {
		super(name);
	}

	public static void main(String[] args) {
		junit.swingui.TestRunner.run(TestParametricFunction.class);
	}

	public static Test suite() {
		TestSuite anSuite = new TestSuite("ParametricFunction");
		anSuite.addTest(new TestParametricFunction("testParametricFunction"));
		return anSuite;
	}

	public void testParametricFunction() throws Exception {

		SpecificFunctionDeclarationWithArgDeclBinds specificFunctionDeclarationWithArgDeclBinds =
			new SpecificFunctionDeclarationWithArgDeclBinds(DoubleType.getInstance());

		IParametricFunctionCallDeclaration parametricFunctionCallDeclaration =
			specificFunctionDeclarationWithArgDeclBinds.getParametricFunctionCallDeclaration();

		IFunctionArgumentDeclarationList argumentDeclarationList =
			parametricFunctionCallDeclaration.getFunctionArgumentDeclarationList();

		IFunctionArgumentDeclaration argumentDeclarationA =
			new FunctionArgumentDeclaration("Argument A", DoubleType.getInstance());
		IFunctionArgumentDeclaration argumentDeclarationB =
			new FunctionArgumentDeclaration("Argument B", DoubleType.getInstance());

		argumentDeclarationList.add(argumentDeclarationA);
		argumentDeclarationList.add(argumentDeclarationB);

		parametricFunctionCallDeclaration.getFunctionCallDeclaration().setFunctionCallInternDeclaration(
			FunctionCallDeclarationFactory.getInstance().createComposedFunctionCallInternDeclaration(
				null,
				FunctionDeclarationNumberFactory.PLUS_FUNCTION_DECLARATION.createFunctionDeclaration(
					DoubleType.getInstance(),
					CollectionsHelper.createIterator(DoubleType.getInstance(), DoubleType.getInstance())),
				CollectionsHelper.createIterator(
					FunctionCallDeclarationFactory.getInstance().createAtomicFunctionCallInternDeclaration(
						null,
						argumentDeclarationA),
					FunctionCallDeclarationFactory.getInstance().createAtomicFunctionCallInternDeclaration(
						null,
						argumentDeclarationB))));

		ICreateAndExecuteFunctionArgs createAndExecuteFunctionArgs = new SimulationFunctionArgs(null);

		//   ParametricFunction parametricFunction =
		//      parametricFunctionCallDeclaration.createParametricFunction(createAndExecuteFunctionArgs);

		IFunction function =
			specificFunctionDeclarationWithArgDeclBinds
				.createParametricFunction(createAndExecuteFunctionArgs)
				.createFunction(
					createAndExecuteFunctionArgs,
					new FunctionList(new Argument(new Double(1.0)), new Argument(new Double(2.0))));

		double value = function.executeForDouble(createAndExecuteFunctionArgs);

		if (Assert.ASSERTION_ON)
			Assert.assertEquals(3.0, value, 0.0);

	}
}