package de.uniwue.ki.mas.basics.functionCall;

import de.uniwue.ki.mas.model.ModelCompilingException;

/**
* Insert the type's description here.
* Creation date: (06.09.2001 21:41:14)
* @author Christoph Oechslein
*/
public class FunctionCallDeclCompileException extends ModelCompilingException {
   private final IFunctionCallDeclaration _functionCallDeclaration;

/**
 * @param functionCallDeclaration IFunctionCallDeclaration
 * @param nestedException Exception
 */
public FunctionCallDeclCompileException(IFunctionCallDeclaration functionCallDeclaration, Exception nestedException) {
   super(nestedException);

   _functionCallDeclaration = functionCallDeclaration;
}

/**
 * @param functionCallDeclaration IFunctionCallDeclaration
 * @param s String
 */
public FunctionCallDeclCompileException(IFunctionCallDeclaration functionCallDeclaration, String s) {
   super(s);

   _functionCallDeclaration = functionCallDeclaration;
}

/**
 * @return IFunctionCallDeclaration
 */
public final IFunctionCallDeclaration getFunctionCallDeclaration() {
   return _functionCallDeclaration;
}

/**
 * @return String
 */
public String toString() {
   return "In function call: '" + getFunctionCallDeclaration().getName() + "'\n" + super.toString();
}
}
