package de.uniwue.ki.mas.basics.functionCall;

import de.uniwue.ki.mas.model.ModelCompilingException;

/**
   * Creation date: (06.09.2001 21:40:32)
  * @author Christoph Oechslein
  */
public class FunctionCallInternDeclCompileException extends ModelCompilingException {
   private final IFunctionCallInternDeclaration _functionCallInternDeclaration;

/**
 * FunctionCallInternDeclCompileException constructor comment.
 * @param nestedException java.lang.Exception
 */
public FunctionCallInternDeclCompileException(IFunctionCallInternDeclaration functionCallInternDeclaration, Exception nestedException) {
   super(nestedException);

   _functionCallInternDeclaration = functionCallInternDeclaration;
}

/**
 * FunctionCallInternDeclCompileException constructor comment.
 * @param s java.lang.String
 */
public FunctionCallInternDeclCompileException(IFunctionCallInternDeclaration functionCallInternDeclaration, String s) {
   super(s);

   _functionCallInternDeclaration = functionCallInternDeclaration;
}

/**
 *
 * @return de.uniwue.ki.mas.model.basics.functionCall.IFunctionCallInternDeclaration
 */
public final IFunctionCallInternDeclaration getFunctionCallInternDeclaration() {
   return _functionCallInternDeclaration;
}

public String toString() {
   return "In function call intern: '" + getFunctionCallInternDeclaration().getName() + "'\n" + super.toString();
}
}
