package de.uniwue.ki.mas.basics.functionDeclaration;
import de.uniwue.ki.mas.util.declaration.AbstractDocumentableDeclaration;
import de.uniwue.ki.util.hash.IIsomorphicHashable;
/**
 * Creation date: (19.03.2002 14:46:20)
 * @author Christoph Oechslein
 */

public abstract class AbstractFunctionDeclaration
	extends AbstractDocumentableDeclaration
	implements IFunctionDeclaration {

	public AbstractFunctionDeclaration(String name) {
		super(name);
	}

	public AbstractFunctionDeclaration() {
		super();
	}

	public boolean isomorphicEquals(IIsomorphicHashable anObject) {
		if (!super.isomorphicEquals(anObject)) {
			return false;
		}

		if (!(anObject instanceof IFunctionDeclaration)) {
			return false;
		}

		IFunctionDeclaration functionDeclaration = (IFunctionDeclaration)anObject;

		return getOutputType().equals(functionDeclaration.getOutputType());
	}

	public int isomorphicHashCode() {
		return 5 * super.isomorphicHashCode() + 3 * getOutputType().hashCode();
	}
}