package de.uniwue.ki.mas.basics.functionDeclaration;
import java.util.Iterator;
import java.util.List;

import de.uniwue.ki.mas.basics.type.ISpecificType;
import de.uniwue.ki.mas.basics.type.IType;
/**
 * Creation date: (12.03.2002 11:43:07)
 * @author Christoph Oechslein
 */

public abstract class AbstractGenericFunctionDeclarationWithUnspecificDependents
	extends AbstractGenericFunctionDeclaration {
	private final List _dependentTypes;

	protected AbstractGenericFunctionDeclarationWithUnspecificDependents(
		String name,
		IType outputType,
		List dependentTypes) {

		this(name, outputType, dependentTypes, false);
	}

	protected AbstractGenericFunctionDeclarationWithUnspecificDependents(
		String name,
		IType outputType,
		List dependentTypes,
		boolean isExpertFunctionDeclaration) {

		super(name, outputType, isExpertFunctionDeclaration);

		_dependentTypes = dependentTypes;
	}

	public final Iterator getDependentTypes(ISpecificType outputSpecificType) {
		return _dependentTypes.iterator();
	}
}