package de.uniwue.ki.mas.basics.functionDeclaration;
import java.util.Iterator;

import de.uniwue.ki.mas.basics.type.*;
import de.uniwue.ki.mas.basics.type.dependent.DependentTypeBindings;
import de.uniwue.ki.util.collection.CollectionsHelper;
/**
 * Creation date: (12.03.2002 11:42:56)
 * @author Christoph Oechslein
 */

public abstract class AbstractGenericFunctionDeclarationWithoutDependents extends AbstractGenericFunctionDeclaration {

	protected AbstractGenericFunctionDeclarationWithoutDependents(String name, IGenericType genericOutputType) {
	
	    super(name, genericOutputType);
	}

	protected AbstractGenericFunctionDeclarationWithoutDependents(
	    String name,
	    IGenericType genericOutputType,
	    boolean isExpertFunctionDeclaration) {
	
	    super(name, genericOutputType, isExpertFunctionDeclaration);
	}

	protected AbstractGenericFunctionDeclarationWithoutDependents(String name, IType outputType) {
	    super(name, outputType);
	}

	protected AbstractGenericFunctionDeclarationWithoutDependents(
	    String name,
	    IType outputType,
	    boolean isExpertFunctionDeclaration) {
	
	    super(name, outputType, isExpertFunctionDeclaration);
	}

	public abstract ISpecificFunctionDeclaration createFunctionDeclaration(ISpecificType outputType);

	public ISpecificFunctionDeclaration createFunctionDeclaration(ISpecificType outputType, DependentTypeBindings bindings) {
	    return createFunctionDeclaration(outputType);
	}

	public Iterator getDependentTypes(ISpecificType outputSpecificType) {
	    return CollectionsHelper.EMPTY_ITERATOR;
	}
}