package de.uniwue.ki.mas.basics.functionDeclaration;
import de.uniwue.ki.mas.basics.type.*;
/**
 * Creation date: (20.03.2002 11:10:56)
 * @author Christoph Oechslein
 */

public abstract class AbstractSpecificFunctionUnlimitedArgsDeclaration
	extends AbstractDefaultSpecificFunctionDeclaration {

	private final ISpecificType _inputType;
	private final int _defaultInputArgsLength;
	private final int _minInputArgsLength;

	public AbstractSpecificFunctionUnlimitedArgsDeclaration(
		String name,
		ISpecificType outputType,
		ISpecificType inputType,
		int minInputArgsLength,
		int defaultInputArgsLength,
		boolean constant) {

		this(name, outputType, inputType, minInputArgsLength, defaultInputArgsLength);

		setConstant(constant);
	}

	public AbstractSpecificFunctionUnlimitedArgsDeclaration(
		String name,
		ISpecificType outputType,
		ISpecificType inputType,
		int minInputArgsLength,
		int defaultInputArgsLength) {

		super(name, outputType);

		_inputType = inputType;
		_minInputArgsLength = minInputArgsLength;
		_defaultInputArgsLength = defaultInputArgsLength;
	}

	public AbstractSpecificFunctionUnlimitedArgsDeclaration(
		String name,
		ISpecificType outputType,
		ISpecificType inputType,
		int minInputArgsLength,
		boolean constant) {

		this(name, outputType, inputType, minInputArgsLength, 2, constant);
	}

	public AbstractSpecificFunctionUnlimitedArgsDeclaration(
		String name,
		ISpecificType outputType,
		ISpecificType inputType,
		boolean constant) {

		this(name, outputType, inputType, 0, 2, constant);
	}

	public final int getSpecificInputDefaultArgsLength() {
		return _defaultInputArgsLength;
	}

	public final int getSpecificInputMaxArgsLength() {
		return ISpecificFunctionDeclaration.UNLIMITED_ARGUMENT_COUNT;
	}

	public final int getSpecificInputMinArgsLength() {
		return _minInputArgsLength;
	}

	public IType getInputType() {
		return _inputType;
	}

	protected String getSignatureWithoutNameAndOutputType() {
		return "(" + getInputType().getName() + " ... )";
	}

	public ISpecificFunctionType getSpecificFunctionType() {
		return GenericFunctionType.getInstance().createSpecificFunctionType(
			getSpecificOutputType(),
			getSpecificOutputType());
	}

	public ISpecificType getSpecificInputTypeAt(int index) {
		return _inputType;
	}

	public final String getSpecificInputTypeNameAt(int index) {
		return null;
	}
}