package de.uniwue.ki.mas.basics.functionDeclaration.list;

import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import de.uniwue.ki.util.Utils;

/**
 * Creation date: 31.07.2002, 11:01:59
 * @author oechslein
 */
public abstract class AbstractDelegateFunctionDeclarationListAble
	extends AbstractFunctionDeclarationListAble {

	protected final transient ChangeListener _changeListener = new ChangeListener() {
		public void stateChanged(ChangeEvent e) {
			AbstractDelegateFunctionDeclarationListAble.this.stateChanged();
		}
	};
	
	private IFunctionDeclarationListAble _delegate;
	private boolean _composition = true;

	public AbstractDelegateFunctionDeclarationListAble(
		IFunctionDeclarationListAble delegate,
		boolean composition) {

		setDelegateFunctionDeclarationListAble(delegate);
		_composition = composition;
	}

	public final IFunctionDeclarationListAble getDelegateFunctionDeclarationListAble() {
		return _delegate;
	}

	public void setDelegateFunctionDeclarationListAble(IFunctionDeclarationListAble functionDeclarationListAble) {
		IFunctionDeclarationListAble oldFunctionDeclarationListAble =
			getDelegateFunctionDeclarationListAble();

		if (Utils.equals(oldFunctionDeclarationListAble, functionDeclarationListAble))
			return;

		if (oldFunctionDeclarationListAble != null) {
			oldFunctionDeclarationListAble.removeChangeListener(_changeListener);
			if (_composition)
				oldFunctionDeclarationListAble.remove();
		}

		_delegate = functionDeclarationListAble;

		if (functionDeclarationListAble != null)
			functionDeclarationListAble.addChangeListener(_changeListener);

		stateChanged();
	}

	public void remove() {
		setDelegateFunctionDeclarationListAble(null);

		super.remove();
	}

}
