package de.uniwue.ki.mas.basics.functionDeclaration.list;

import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import de.uniwue.ki.util.event.StateChangeMulticaster;

/**
 * Creation date: 31.07.2002, 10:57:18
 * @author oechslein
 */
public abstract class AbstractFunctionDeclarationListAble implements IFunctionDeclarationListAble {

	private transient ChangeListener _changeListener = null;

	public void addChangeListener(ChangeListener changeListenerToAdd) {
		_changeListener = StateChangeMulticaster.add(_changeListener, changeListenerToAdd);
	}

	public void removeChangeListener(ChangeListener changeListenerToRemove) {
		_changeListener = StateChangeMulticaster.remove(_changeListener, changeListenerToRemove);
	}

	protected void stateChanged() {
		if (_changeListener != null) {
			stateChanged(new ChangeEvent(this));
		}
	}

	protected final void stateChanged(ChangeEvent changeEvent) {
		if (_changeListener != null) {
			_changeListener.stateChanged(changeEvent);
		}
	}
	
	public void remove() {
		_changeListener = null;
	}
}
