package de.uniwue.ki.mas.basics.functionDeclaration.list;

import java.util.Iterator;

import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import de.uniwue.ki.util.Utils;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Creation date: 31.07.2002, 11:01:59
 * @author oechslein
 */
public class ConcatenateFunctionDeclarationListAble extends AbstractFunctionDeclarationListAble {
	private IFunctionDeclarationListAble _functionDeclarationListAbleA;
	private IFunctionDeclarationListAble _functionDeclarationListAbleB;
	private boolean _composite;

	protected final transient ChangeListener _changeListener = new ChangeListener() {
		public void stateChanged(ChangeEvent e) {
			ConcatenateFunctionDeclarationListAble.this.stateChanged();
		}
	};

	public ConcatenateFunctionDeclarationListAble(
		IFunctionDeclarationListAble functionDeclarationListAbleA,
		IFunctionDeclarationListAble functionDeclarationListAbleB,
		boolean composite) {

		super();

		_composite = composite;
		setFunctionDeclarationListAbleA(functionDeclarationListAbleA);
		setFunctionDeclarationListAbleB(functionDeclarationListAbleB);
	}

	public Iterator getFunctionDeclarations() {
		return CollectionsHelper.concatenate(
			getFunctionDeclarationsIntern(getFunctionDeclarationListAbleA()),
			getFunctionDeclarationsIntern(getFunctionDeclarationListAbleB()));
	}

	private static Iterator getFunctionDeclarationsIntern(IFunctionDeclarationListAble functionDeclarationListAble) {
		if (functionDeclarationListAble == null) {
			return CollectionsHelper.EMPTY_ITERATOR;
		} else {
			return functionDeclarationListAble.getFunctionDeclarations();
		}
	}

	public IFunctionDeclarationListAble getFunctionDeclarationListAbleA() {
		return _functionDeclarationListAbleA;
	}

	public void setFunctionDeclarationListAbleA(IFunctionDeclarationListAble functionDeclarationListAbleA) {
		IFunctionDeclarationListAble oldFunctionDeclarationListAble = getFunctionDeclarationListAbleA();

		if (Utils.equals(oldFunctionDeclarationListAble, functionDeclarationListAbleA))
			return;

		if (oldFunctionDeclarationListAble != null) {
			oldFunctionDeclarationListAble.removeChangeListener(_changeListener);
			if (_composite) {
				oldFunctionDeclarationListAble.remove();
			}
		}

		_functionDeclarationListAbleA = functionDeclarationListAbleA;

		if (functionDeclarationListAbleA != null)
			functionDeclarationListAbleA.addChangeListener(_changeListener);
	}

	public IFunctionDeclarationListAble getFunctionDeclarationListAbleB() {
		return _functionDeclarationListAbleB;
	}

	public void setFunctionDeclarationListAbleB(IFunctionDeclarationListAble functionDeclarationListAbleB) {
		IFunctionDeclarationListAble oldFunctionDeclarationListAble = getFunctionDeclarationListAbleB();

		if (Utils.equals(oldFunctionDeclarationListAble, functionDeclarationListAbleB))
			return;

		if (oldFunctionDeclarationListAble != null) {
			oldFunctionDeclarationListAble.removeChangeListener(_changeListener);
			if (_composite) {
				oldFunctionDeclarationListAble.remove();
			}
		}

		_functionDeclarationListAbleB = functionDeclarationListAbleB;

		if (functionDeclarationListAbleB != null)
			functionDeclarationListAbleB.addChangeListener(_changeListener);
	}

	public void remove() {
		setFunctionDeclarationListAbleA(null);
		setFunctionDeclarationListAbleB(null);

		super.remove();
	}

}
