package de.uniwue.ki.mas.basics.functionDeclaration.list;
import java.util.Iterator;
import java.util.List;

import de.uniwue.ki.mas.basics.functionDeclaration.ISpecificFunctionDeclaration;
import de.uniwue.ki.mas.basics.type.ISpecificType;
import de.uniwue.ki.mas.util.declaration.TwoUnmodifiableDeclarationList;
import de.uniwue.ki.util.collection.CollectionsHelper;
/**
* View two declaration lists as one list (read only).
* Creation date: (18.12.2000 11:44:09)
*
* @author Christoph Oechslein
*/
public class TwoUnmodifiableFunctionDeclarationList
	extends TwoUnmodifiableDeclarationList
	implements IFunctionDeclarationList {

	public TwoUnmodifiableFunctionDeclarationList(
		IFunctionDeclarationList functionDeclarationListA,
		IFunctionDeclarationList functionDeclarationListB,
		boolean composition) {
		super(functionDeclarationListA, functionDeclarationListB, composition);
	}

	public Iterator getFunctionDeclarations(ISpecificType outputType) {
		return CollectionsHelper.concatenate(
			getFunctionDeclarationListA().getFunctionDeclarations(outputType),
			getFunctionDeclarationListB().getFunctionDeclarations(outputType));
	}

	public ISpecificFunctionDeclaration getSpecificFunctionDeclaration(
		String name,
		ISpecificType outputType,
		List inputTypes) {

		ISpecificFunctionDeclaration specificFunctionDeclaration =
			getFunctionDeclarationListA().getSpecificFunctionDeclaration(name, outputType, inputTypes);

		if (specificFunctionDeclaration != null)
			return specificFunctionDeclaration;
		else
			return getFunctionDeclarationListB().getSpecificFunctionDeclaration(name, outputType, inputTypes);
	}

	public ISpecificFunctionDeclaration getSpecificFunctionDeclaration(
		String name,
		ISpecificType outputType) {

		ISpecificFunctionDeclaration specificFunctionDeclaration =
			getFunctionDeclarationListA().getSpecificFunctionDeclaration(name, outputType);

		if (specificFunctionDeclaration != null)
			return specificFunctionDeclaration;
		else
			return getFunctionDeclarationListB().getSpecificFunctionDeclaration(name, outputType);
	}

	public Iterator getFunctionDeclarations() {
		return iterator();
	}

	public void stateChanged() {
		fireStateChanged();
	}

	public IFunctionDeclarationList getFunctionDeclarationListA() {
		return (IFunctionDeclarationList) getDeclarationListA();
	}

	public IFunctionDeclarationList getFunctionDeclarationListB() {
		return (IFunctionDeclarationList) getDeclarationListB();
	}
}