package de.uniwue.ki.mas.basics.functionUser;
import de.uniwue.ki.mas.basics.type.ISpecificType;
import de.uniwue.ki.mas.util.declaration.AbstractDeclarationFactory;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: (04.09.2001 16:05:27)
 * @author Christoph Oechslein
 */

public final class UserFunctionDeclarationFactory
	extends AbstractDeclarationFactory
	implements IUserFunctionDeclarationFactory {

	private final boolean _defaultExternSetting;

	private static final UserFunctionDeclarationFactory _externalDefaultInstance =
		new UserFunctionDeclarationFactory(true);

	private static final UserFunctionDeclarationFactory _internalDefaultInstance =
		new UserFunctionDeclarationFactory(false);

	public UserFunctionDeclarationFactory(boolean defaultExternSetting) {
		super();

		_defaultExternSetting = defaultExternSetting;
	}

	public final IDeclaration createDeclaration() {
		return createUserFunctionDeclaration();
	}

	public final IUserFunctionDeclaration createUserFunctionDeclaration() {
		UserFunctionDeclaration newUserFunctionDeclaration = new UserFunctionDeclaration();

		newUserFunctionDeclaration.setExternal(_defaultExternSetting);

		return newUserFunctionDeclaration;
	}

	public final IUserFunctionDeclaration createUserFunctionDeclaration(ISpecificType specificType) {
		UserFunctionDeclaration newUserFunctionDeclaration = new UserFunctionDeclaration(specificType);

		newUserFunctionDeclaration.setExternal(_defaultExternSetting);

		return newUserFunctionDeclaration;
	}

	public static final UserFunctionDeclarationFactory getInstance(boolean defaultExternSetting) {
		if (defaultExternSetting)
			return _externalDefaultInstance;
		else
			return _internalDefaultInstance;
	}
}