package de.uniwue.ki.mas.basics.functionUser;

import java.util.Iterator;
import java.util.Map;

import de.uniwue.ki.mas.basics.functionDeclaration.list.FunctionDeclarationList;

/**
 * Creation date: 04.09.2002, 18:40:19
 * @author oechslein
 */
public class UserFunctionDeclarationList extends FunctionDeclarationList {

	public UserFunctionDeclarationList() {
		super();
	}

	public boolean accept(Object declaration) {
		return declaration instanceof IUserFunctionDeclaration;
	}

	public String getName() {
		return "User Functions";
	}

	public void copyInto(Object intoObject, Map objectMapping) {
		UserFunctionDeclarationList dstUserFunctionDeclarationList = (UserFunctionDeclarationList)intoObject;

		dstUserFunctionDeclarationList.clear();

		Iterator it = iterator();

		if (objectMapping == null) {
			while (it.hasNext()) {
				IUserFunctionDeclaration userFunctionDeclaration = (IUserFunctionDeclaration)it.next();
				dstUserFunctionDeclarationList.add(userFunctionDeclaration.copy(objectMapping));
			}

		} else {
			while (it.hasNext()) {
				IUserFunctionDeclaration userFunctionDeclaration = (IUserFunctionDeclaration)it.next();
				if (objectMapping.containsKey(userFunctionDeclaration)) {
					dstUserFunctionDeclarationList.add(objectMapping.get(userFunctionDeclaration));

				} else {
					Object copyOfCopyable = userFunctionDeclaration.copy(objectMapping);
					objectMapping.put(userFunctionDeclaration, copyOfCopyable);
					dstUserFunctionDeclarationList.add(copyOfCopyable);
				}
			}
		}
	}
}
