package de.uniwue.ki.mas.basics.type;

import de.uniwue.ki.util.name.AbstractNamed;


/**
 * Creation date: (07.01.2002 15:56:18)
 * @author Christoph Oechslein
 */

public abstract class AbstractType extends AbstractNamed implements IType {
	public AbstractType() {
		super();
	}

	/**
	 * Compares two objects for equality. Returns a boolean that indicates
	 * whether this object is equivalent to the specified object. This method
	 * is used when an object is stored in a hashtable.
	 * @param obj the Object to compare with
	 * @return true if these Objects are equal; false otherwise.
	 * @see java.util.Hashtable
	 */
	public boolean equals(Object obj) {
		// NOTE: obj might be an instance of any class
		if (obj == null) {
			return false;
			
		} else if (this == obj) {
			return true;
			
		} else {
			return getClass().equals(obj.getClass());
		}
	}

	/**
	 * Generates a hash code for the receiver.
	 * This method is supported primarily for
	 * hash tables, such as those provided in java.util.
	 * @return an integer hash code for the receiver
	 * @see java.util.Hashtable
	 */
	public int hashCode() {
		// NOTE: if two objects are equal (equals(Object) returns true) they must have the same hash code
		return getClass().hashCode();
	}
}