package de.uniwue.ki.mas.basics.type;
import de.uniwue.ki.mas.basics.feature.IFeatureClassDeclaration;

/**
 * Creation date: (05.11.2001 16:39:33)
 * @author Christoph Oechslein
 */

public final class FeatureClassDeclarationType extends AbstractSpecificType {
	private static final FeatureClassDeclarationType instance = new FeatureClassDeclarationType();

	protected FeatureClassDeclarationType() {
		super();

		ObjectType.getInstance().addSubType(this);
	}

	public static final FeatureClassDeclarationType getInstance() {
		return instance;
	}

	public String getName() {
		return "Feature Class";
	}

	public void appendNameForArgumentObject(
		StringBuffer buff,
		Object anObject,
		int currDepth,
		int maxDepth) {

		if (currDepth >= maxDepth) {
			buff.append("...");
		} else {
			appendNameForNamedObject(buff, (IFeatureClassDeclaration) anObject, currDepth, maxDepth);
		}
	}

	public boolean isArgumentDeclarationValueOk(Object value) {
		return ((value == null) || (value instanceof IFeatureClassDeclaration));
	}
}