package de.uniwue.ki.mas.basics.type;

/**
 * Creation date: 04.09.2002, 18:40:19
 * @author oechslein
 */
public class GenericHashtableType extends AbstractGenericType {
	private static final GenericHashtableType _instance = new GenericHashtableType();

	public GenericHashtableType() {
		super();
	}

	public static final GenericHashtableType getInstance() {
		return _instance;
	}


	public final boolean canCreate(ISpecificType keyType) {
		return (keyType instanceof SpecificHashtableType) || (keyType == ObjectType.getInstance());
	}

	public final SpecificHashtableType createSpecificHashtableType(ISpecificType keyType,ISpecificType valueType) {
		return new SpecificHashtableType(keyType, valueType);
	}


	public boolean equals(Object obj) {
		return obj == this;
	}


	public String getName() {
		return "Hashtable<T,T>";
	}

	public ISpecificType createDefaultSpecificType() {
		return createSpecificHashtableType(StringType.getInstance(), ObjectType.getInstance());
	}
}