package de.uniwue.ki.mas.basics.type;

import java.util.HashMap;
import java.util.Map;

/**
 * Creation date: 04.09.2002, 18:40:19
 * @author oechslein
 */
public class GenericIteratorType extends AbstractGenericType {
	private static final GenericIteratorType instance = new GenericIteratorType();

	private final Map _map = new HashMap();

	public GenericIteratorType() {
		super();
	}

	public static final GenericIteratorType getInstance() {
		return instance;
	}

	public boolean canCreate(ISpecificType type) {
		if (type instanceof SpecificIteratorType) {
			return !(type instanceof SpecificListType);
		} else if (type == ObjectType.getInstance()) {
			return true;
		} else {
			return false;
		}
	}

	public SpecificIteratorType createSpecificIteratorType(ISpecificType type) {
		if (_map.containsKey(type))
			return (SpecificIteratorType) _map.get(type);
		else {
			SpecificIteratorType newSpecificIteratorType = new SpecificIteratorType(type);
			_map.put(type, newSpecificIteratorType);
			return newSpecificIteratorType;
		}
	}

	public String getName() {
		return "Iterator<T>";
	}

	public ISpecificType createDefaultSpecificType() {
		return createSpecificIteratorType(DoubleType.getInstance());
	}
}