package de.uniwue.ki.mas.basics.type;

import java.util.HashMap;
import java.util.Map;

/**
 * Creation date: 04.09.2002, 18:40:19
 * @author oechslein
 */
public class GenericListType extends AbstractGenericType {
	private static final GenericListType instance = new GenericListType();
	private final Map _map = new HashMap();

	public GenericListType() {
		super();
	}

	public static final GenericListType getInstance() {
		return instance;
	}

	public boolean canCreate(ISpecificType type) {
		if (type instanceof SpecificListType) {
			return true;
		} else if (type == ObjectType.getInstance()) {
			return true;
		} else {
			return false;
		}
	}

	public SpecificListType createSpecificListType(ISpecificType type) {
		if (_map.containsKey(type))
			return (SpecificListType) _map.get(type);
		else {
			SpecificListType newSpecificListType = new SpecificListType(type);
			_map.put(type, newSpecificListType);
			return newSpecificListType;
		}
	}

	public String getName() {
		return "List<T>";
	}

	public ISpecificType createDefaultSpecificType() {
		return createSpecificListType(DoubleType.getInstance());
	}
}