package de.uniwue.ki.mas.basics.type;

/**
 * Creation date: 03.02.2003, 09:03:56
 * @author oechslein
 */
public final class GenericNumberType extends AbstractGenericGroupType {
	private static final GenericNumberType _instance = new GenericNumberType();
	
	private GenericNumberType() {
		addGroupItem(DoubleType.getInstance());
		addGroupItem(IntegerType.getInstance());
	}
	 
	public boolean canCreate(ISpecificType type) {
		return DoubleType.getInstance().isMoreSpecific(type);
	}

	public ISpecificType createDefaultSpecificType() {
		return DoubleType.getInstance();
	}

	public String getName() {
		return "Number";
	}

	public static GenericNumberType getInstance() {
		return _instance;
	}

}
