package de.uniwue.ki.mas.basics.type;

import de.uniwue.ki.mas.model.ISeSAmDeclaration;

/**
 * For example <code>set<T></code> is a generic type and can
 * produce specific types like <code>set_boolean</code>.
 * Creation date: (29.08.2000 14:59:37)
 *
 * @author Christoph Oechslein
 */

public interface IGenericType extends IType {

	/**
	 * Can this generic type produce the specific type.
	 * @see #createSpecificType
	 */
	boolean canCreate(ISpecificType type);

	/**
	 * Creates a default specificType, calling {@link #canCreate(ISpecificType)}
	 * with the result of this function must return <code>true</code>.
	 * 
	 * @see #canCreate(ISpecificType)
	 */
	ISpecificType createDefaultSpecificType();
	
	/**
	 * Sometimes this is model-dependent
	 */
	ISpecificType createDefaultSpecificType(ISeSAmDeclaration declaration);
}