package de.uniwue.ki.mas.basics.type;

import de.uniwue.ki.mas.basics.functionDeclaration.ISpecificFunctionDeclaration;

/**
 * A specific function type which mainly for functions with limited
 * and umlimited argument lists.
 * Creation date: (29.11.2000 18:14:44)
 *
 * @author Christoph Oechslein
 */

public interface ISpecificFunctionType extends ISpecificType {

	/**
	  * See ISpecificFunctionDeclaration#getSpecificInputTypeAt(int)
	  */
	ISpecificType getSpecificInputTypeAt(int index);

	/**
	  * See ISpecificFunctionDeclaration#getSpecificInputTypesLength()
	  */
	int getSpecificInputTypesLength();

	/**
	 * Returns the return type of this function type.
	 */
	ISpecificType getSpecificOutputType();

	/**
	 * Returns <code>true</code> if <code>specificFunctionDeclaration</code>
	 * has same Signature as this function type, a same signature means for example,
	 *     same output type, same argument types and length.
	 */
	boolean hasSameSignature(ISpecificFunctionDeclaration specificFunctionDeclaration);
}
