package de.uniwue.ki.mas.basics.type;

import java.io.Serializable;

import de.uniwue.ki.util.name.INamed;

/**
 * Encapsulate type information, like a type for numbers ({@link NumberType})
 * or booleans ({@link BooleanType}).
 * <br>There are {@link ISpecificType ISpecificTypes} which are
 * and there are {@link IGenericType IGenericTypes}  (like the generic set)
 * which can produce ISpecificTypes (like a specific BooleanType set type).
 * IGenericTypes are mainly for {@link IGenericFunctionDelaration IGenericFunctionDelarations}.
 * Creation date: (29.08.2000 14:59:58)
 *
 * @author Christoph Oechslein
 */

public interface IType extends INamed, Serializable {

}
