package de.uniwue.ki.mas.basics.type;
import de.uniwue.ki.mas.entity.objectclass.IObjectClassDeclaration;

/**
 * Creation date: (05.11.2001 16:39:33)
 * @author Christoph Oechslein
 */

public final class ObjectClassDeclarationType extends AbstractSpecificType {
	private static final ObjectClassDeclarationType instance = new ObjectClassDeclarationType();

	protected ObjectClassDeclarationType() {
		super();

		ObjectType.getInstance().addSubType(this);
	}

	public static final ObjectClassDeclarationType getInstance() {
		return instance;
	}

	public String getName() {
		return "Object Class";
	}

	public void appendNameForArgumentObject(
		StringBuffer buff,
		Object anObject,
		int currDepth,
		int maxDepth) {

		if (currDepth >= maxDepth) {
			buff.append("...");
		} else {
			appendNameForNamedObject(buff, (IObjectClassDeclaration) anObject, currDepth, maxDepth);
		}
	}

	public boolean isArgumentDeclarationValueOk(Object value) {
		return ((value == null) || (value instanceof IObjectClassDeclaration));
	}
}