package de.uniwue.ki.mas.basics.type;

import de.uniwue.ki.mas.basics.function.ICreateFunctionArgs;
import de.uniwue.ki.mas.basics.type.argument.Argument;
import de.uniwue.ki.mas.basics.type.argument.IArgument;
import de.uniwue.ki.util.name.INamed;

/**
 * Creation date: 04.09.2002, 18:40:19
 * @author oechslein
 */
public final class ObjectType extends AbstractSpecificType {
	private static final ObjectType instance = new ObjectType();

	/**
	 * @return ObjectType
	 */
	public static final ObjectType getInstance() {
		return instance;
	}

	/**
	 * @param type ISpecificType
	 * @return boolean
	 */
	public boolean canCreate(ISpecificType type) {
		return equals(type);
	}

	public IArgument createArgument(ICreateFunctionArgs createFunctionArgs, Object anObject) {
		return new Argument(anObject);
	}

	public Object getArgumentDeclarationDefaultValue() {
		return null;
	}

	public IGenericType getGenericType() {
		return null;
	}

	public String getName() {
		return "Object";
	}

	public void appendNameForArgumentObject(
		StringBuffer buff,
		Object anObject,
		int currDepth,
		int maxDepth) {

		if (currDepth >= maxDepth) {
			buff.append("...");

		} else if (anObject instanceof INamed) {
			appendNameForNamedObject(buff, (INamed) anObject, currDepth, maxDepth);

		} else {
			super.appendNameForArgumentObject(buff, anObject, currDepth, maxDepth);
		}
	}

	public boolean isArgumentDeclarationValueOk(Object value) {
		return true;
	}

	protected ObjectType() {
		super();
	}
}
