package de.uniwue.ki.mas.basics.type;
import de.uniwue.ki.mas.basics.function.ICreateFunctionArgs;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.mas.sim.simulation.ISimulation;

/**
 * Creation date: (28.01.2002 19:42:38)
 * @author Christoph Oechslein
 */
public final class SimulationType extends AbstractSpecificType {
	private static final SimulationType _instance = new SimulationType();

	private SimulationType() {
		super();
	}

	public static final SimulationType getInstance() {
		return _instance;
	}

	public String getName() {
		return "Simulation";
	}

	public void appendNameForArgumentObject(
		StringBuffer buff,
		Object anObject,
		int currDepth,
		int maxDepth) {

		if (currDepth >= maxDepth) {
			buff.append("...");
		} else {
			appendNameForNamedObject(buff, (ISimulation) anObject, currDepth + 1, maxDepth);
		}
	}

	public boolean isArgumentDeclarationValueOk(Object value) {
		return (value == null) || (value instanceof ISimulation);
	}

	public boolean isConstant(ICreateFunctionArgs createFunctionArgs, Object anObject)
		throws ModelCompilingException {

		return anObject == null;
	}
}