package de.uniwue.ki.mas.basics.type;

/**
 * Creation date: 04.09.2002, 18:40:19
 * @author oechslein
 */
public final class StringType extends AbstractSpecificType {
	private static final StringType instance = new StringType();

	public static final StringType getInstance() {
		return instance;
	}

	public Object getArgumentDeclarationDefaultValue() {
		return "";
	}

	public String getName() {
		return "String";
	}

	public boolean isArgumentDeclarationValueOk(Object value) {
		return value instanceof String;
	}

	protected StringType() {
		super();

		ObjectType.getInstance().addSubType(this);
	}

	public void appendNameForArgumentObject(
		StringBuffer buff,
		Object anObject,
		int currDepth,
		int maxDepth) {

		if (currDepth >= maxDepth) {
			buff.append("...");
			
		} else {
			buff.append('"');
			buff.append(anObject);
			buff.append('"');
		}
	}
}