package de.uniwue.ki.mas.basics.type.argument;

import de.uniwue.ki.mas.basics.type.ISpecificType;
import de.uniwue.ki.mas.basics.type.TypeManager;
import de.uniwue.ki.mas.util.declaration.AbstractDeclarationFactory;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: (04.09.2001 16:05:27)
 * @author Christoph Oechslein
 */

public final class ArgumentDeclarationFactory extends AbstractDeclarationFactory {
	private static ArgumentDeclarationFactory _instance = new ArgumentDeclarationFactory();

	protected ArgumentDeclarationFactory() {
	}

	public final IArgumentDeclaration createArgumentDeclaration() {
		return createArgumentDeclaration(TypeManager.getInstance().getDefaultType());
	}


	public final IArgumentDeclaration createArgumentDeclaration(ISpecificType type) {
		return createArgumentDeclaration(type, type.getArgumentDeclarationDefaultValue());
	}

	public final IArgumentDeclaration createArgumentDeclaration(ISpecificType type, Object value) {
		return type.createArgumentDeclaration(value);
	}


	public final IDeclaration createDeclaration() {
		return createArgumentDeclaration();
	}

	public static final ArgumentDeclarationFactory getInstance() {
		return _instance;
	}
}
