package de.uniwue.ki.mas.basics.type.argument;
import de.uniwue.ki.mas.basics.type.ISpecificType;
import de.uniwue.ki.mas.util.declaration.IDeclaration;
import de.uniwue.ki.mas.util.declaration.NeverRemoveVetoListener;

/**
 * Creation date: (05.11.2001 16:39:33)
 * @author Christoph Oechslein
 */

public class ArgumentDeclarationWithNeverRemoveVetoListener extends ArgumentDeclaration {
	private final NeverRemoveVetoListener _neverRemoveVetoListener = new NeverRemoveVetoListener(this);

	public ArgumentDeclarationWithNeverRemoveVetoListener(ISpecificType type, IDeclaration declaration) {
		super(type, declaration);

		setDeclaration(declaration);
	}

	public final IDeclaration getDeclaration() {
		return (IDeclaration) super.getObject();
	}

	public void remove() {
		setDeclaration(null);

		super.remove();
	}

	public void setDeclaration(IDeclaration newDeclaration) {
		IDeclaration oldDeclaration = getDeclaration();

		if (oldDeclaration != null) {
			oldDeclaration.removeRemoveVetoListener(_neverRemoveVetoListener);
		}

		super.setObject(newDeclaration);

		if (newDeclaration != null) {
			newDeclaration.addRemoveVetoListener(_neverRemoveVetoListener);
		}
	}

	public void setObject(Object newObject) {
		if (_neverRemoveVetoListener != null) {
			// _neverRemoveVetoListener can be == null during iniatilization (if constructor of super class calls setObject!!)
			setDeclaration((IDeclaration) newObject);
		}
	}
}