package de.uniwue.ki.mas.basics.type.composed;

import javax.swing.event.ChangeEvent;

/**
 * @author Reinhard Hatko
 *
 * Created on: 06.04.2004
 */
public class ComposedTypeChangeEvent extends ChangeEvent{
	
	public static final int FATHER_CHANGED = 0;
	public static final int COMPOSEDTYPE_REMOVED = 1;
	public static final int NAME_CHANGED = 2;
	public static final int CHILD_ADDED = 3;
	public static final int CHILD_REMOVED = 4;
	
	private int _changeType;

	public ComposedTypeChangeEvent(Object source, int changeType){
		super(source);
		setChangeType(changeType);
	}

	private void setChangeType(int changeType){
		if(changeType < 0 || changeType > 4){
			throw new IllegalArgumentException();
		} else{
			_changeType = changeType;
			return;
		}
	}

	public int getChangeType(){
		return _changeType;
	}


}