package de.uniwue.ki.mas.basics.type.composed;

import de.uniwue.ki.mas.basics.type.AbstractGenericType;
import de.uniwue.ki.mas.basics.type.ISpecificType;

/**
 * Creation date: 17.06.2002, 15:44:24
 * @author oechslein
 */
public class GenericComposedType extends AbstractGenericType {
	private static final GenericComposedType  _instance = new GenericComposedType();
	
	private GenericComposedType() {
		super();
	}

	public boolean canCreate(ISpecificType type) {
		return type instanceof ISpecificComposedType;
	}

	public ISpecificType createDefaultSpecificType() {
		return ISpecificComposedType.NULL_COMPOSED_TYPE;
	}

	public String getName() {
		return "Composed<T>";
	}

	public static final GenericComposedType getInstance() {
		return _instance;
	}

}
