/*
 * Created on 20.05.2003
 *
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package de.uniwue.ki.mas.basics.type.composed;

import java.util.Iterator;

import de.uniwue.ki.mas.basics.type.ISpecificType;
import de.uniwue.ki.mas.basics.type.user.IUserTypeDeclaration;
import de.uniwue.ki.mas.model.SimulationRuntimeException;
import de.uniwue.ki.mas.util.declaration.IDeclaration;
import de.uniwue.ki.util.collection.IteratorWithException;
import de.uniwue.ki.util.copy.ICopyable;

/**
 * @author herrler
 */
public interface ISpecificComposedType extends ISpecificType, ICopyable {
	SpecificComposedType NULL_COMPOSED_TYPE = new SpecificComposedType("Empty Composed Type", false);

	IComposedTypeValue createComposedTypeValue(IteratorWithException values)
		throws SimulationRuntimeException;

	void setDeclaration(IUserTypeDeclaration decl);
	
	/**
     * returns the declaration if the composed type is created by one
	 */
	IDeclaration getDeclaration();

	IComposedTypeValue createEmptyComposedTypeValue();
	Object getArgumentDeclarationDefaultValue();
	IComposedTypeAttribute getAttributeAt(int index);
	int getAttributeListSize();

	/**
	 * Get inherited and own attributes 
	 */
	Iterator getAttributes();

	/**
	 * Get father of this type 
	 */
	ISpecificComposedType getFather();

	/**
	 * Get attributes without inherited attributes
	 */
	public Iterator getOwnAttributes();
	boolean hasWriteableAttributes();

	/**
	 * Remove a existing subtype.
	 */
	void removeSubType(ISpecificType newSubType);

}