package de.uniwue.ki.mas.basics.type.composed.function;

import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.type.composed.ISpecificComposedType;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: 13.06.2002, 18:32:46
 * @author oechslein
 */
final class CreateComposedTypeValueFunction extends AbstractFunctionDynamic {

	private final ISpecificComposedType _composedType;
	private final IFunctionList _functions;

	public CreateComposedTypeValueFunction(ISpecificComposedType composedType, IFunctionList functions) {
		super();

		_composedType = composedType;
		_functions = functions;
	}

	public Object execute(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {

		if (_functions.size() > _composedType.getAttributeListSize()) {
			throw new SimulationRuntimeException("To many attributes in " + getName());
		} else if (_functions.size() < _composedType.getAttributeListSize()) {
			throw new SimulationRuntimeException("To few attributes in " + getName());
		}

		return _composedType.createComposedTypeValue(
			mapFunctionsToObjects(executeFunctionArgs, _functions.iterator(), false));
	}

	public String getName() {
		return "CreateComposedTypeValue" + _functions.getName();
	}
}
