package de.uniwue.ki.mas.basics.type.composed.function;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractGenericFunctionDeclarationWithUnspecificDependents;
import de.uniwue.ki.mas.basics.functionDeclaration.list.FunctionDeclarationList;
import de.uniwue.ki.mas.basics.functionDeclaration.list.IFunctionDeclarationList;

/**
 * Creation date: (20.11.2001 16:08:46)
 * @author Christoph Oechslein
 */

public final class FunctionDeclarationComposedTypeFactory {
	private static IFunctionDeclarationList _cachedFunctionDeclarationList = new FunctionDeclarationList();

	public static final AbstractGenericFunctionDeclarationWithUnspecificDependents CREATE_COMPOSED_TYPE_VALUE_GENERIC_FUN_DECL =
		new CreateComposedTypeValueGenericFunctionDeclaration(false);

	public static final AbstractGenericFunctionDeclarationWithUnspecificDependents CREATE_EMPTY_COMPOSED_TYPE_VALUE_GENERIC_FUN_DECL =
		new CreateComposedTypeValueGenericFunctionDeclaration(true);

	public static final AbstractGenericFunctionDeclarationWithUnspecificDependents GET_COMPOSED_TYPE_VALUE_GENERIC_FUN_DECL =
		new GetComposedTypeValueGenericFunctionDeclaration();

	public static final AbstractGenericFunctionDeclarationWithUnspecificDependents SET_COMPOSED_TYPE_VALUE_GENERIC_FUN_DECL =
		new SetComposedTypeValueGenericFunctionDeclaration();

	static {
		_cachedFunctionDeclarationList.add(CREATE_COMPOSED_TYPE_VALUE_GENERIC_FUN_DECL);

		_cachedFunctionDeclarationList.add(CREATE_EMPTY_COMPOSED_TYPE_VALUE_GENERIC_FUN_DECL);

		_cachedFunctionDeclarationList.add(GET_COMPOSED_TYPE_VALUE_GENERIC_FUN_DECL);

		_cachedFunctionDeclarationList.add(SET_COMPOSED_TYPE_VALUE_GENERIC_FUN_DECL);
	}

	public static void insertFunctions(IFunctionDeclarationList functionDeclarationList) {
		functionDeclarationList.addAll(_cachedFunctionDeclarationList);
	}

}