package de.uniwue.ki.mas.basics.type.composed.function;

import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionAdapterGenericFunctionDeclaration;
import de.uniwue.ki.mas.basics.type.ISpecificType;
import de.uniwue.ki.mas.basics.type.composed.ComposedTypeAttribute;
import de.uniwue.ki.mas.basics.type.composed.IComposedTypeAttribute;
import de.uniwue.ki.mas.basics.type.composed.SpecificComposedTypeAttributeType;
import de.uniwue.ki.mas.model.ModelCompilingException;

/**
 * Creation date: 13.06.2002, 17:39:15
 * @author oechslein
 */
final class GetComposedTypeValueSpecificFunctionDeclaration
	extends AbstractSpecificFunctionAdapterGenericFunctionDeclaration implements IGetComposedTypeValueSpecificFunctionDeclaration {

	private final SpecificComposedTypeAttributeType _composedTypeAttributeType;

	public GetComposedTypeValueSpecificFunctionDeclaration(
		GetComposedTypeValueGenericFunctionDeclaration genericFunctionDeclaration,
		SpecificComposedTypeAttributeType composedTypeAttributeType) {

		super(genericFunctionDeclaration, 2);

		_composedTypeAttributeType = composedTypeAttributeType;
		addRemoveVetoListernerTo(composedTypeAttributeType.getComposedType().getDeclaration());
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions)
		throws ModelCompilingException {
		Assert.assertEquals(2, functions.size());

		return new GetComposedTypeValueFunction(functions.getFunction(0), functions.getFunction(1));
	}

	public ISpecificType getSpecificInputTypeAt(int index) {
		if (index == 0)
			return _composedTypeAttributeType.getComposedType();
		else
			return _composedTypeAttributeType;
	}

	public String getSpecificInputTypeNameAt(int index) {
		if (index == 0)
			return "object";
		else if (index == 1)
			return "attribut";
		else
			return super.getSpecificInputTypeNameAt(index);
	}

	public ISpecificType getSpecificOutputType() {
		return _composedTypeAttributeType.getComposedTypeAttribute().getAttributeType();
	}

	public IComposedTypeAttribute getComposedTypeAttribute() {
		return _composedTypeAttributeType.getComposedTypeAttribute();
	}
}
