package de.uniwue.ki.mas.basics.type.composed.function;

import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionAdapterGenericFunctionDeclaration;
import de.uniwue.ki.mas.basics.type.ISpecificType;
import de.uniwue.ki.mas.basics.type.composed.SpecificComposedTypeAttributeType;
import de.uniwue.ki.mas.model.ModelCompilingException;

/**
 * Creation date: 13.06.2002, 17:39:15
 * @author oechslein
 */
final class SetComposedTypeValueSpecificFunctionDeclaration
	extends AbstractSpecificFunctionAdapterGenericFunctionDeclaration {

	private final SpecificComposedTypeAttributeType _composedTypeAttributeType;

	public SetComposedTypeValueSpecificFunctionDeclaration(
		SetComposedTypeValueGenericFunctionDeclaration genericFunctionDeclaration,
		SpecificComposedTypeAttributeType composedTypeAttributeType) {

		super(genericFunctionDeclaration, 3);

		_composedTypeAttributeType = composedTypeAttributeType;
		addRemoveVetoListernerTo(_composedTypeAttributeType.getComposedType().getDeclaration());
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions)
		throws ModelCompilingException {
		Assert.assertEquals(3, functions.size());

		return new SetComposedTypeValueFunction(
			functions.getFunction(0),
			functions.getFunction(1),
			functions.getFunction(2));
	}

	public ISpecificType getSpecificInputTypeAt(int index) {
		if (index == 0)
			return _composedTypeAttributeType.getComposedType();
		else if (index == 1)
			return _composedTypeAttributeType;
		else if (index== 2)
			return _composedTypeAttributeType.getComposedTypeAttribute().getAttributeType();
		else {
			Assert.fail("Unsupported attribute");
			return null;
		}
	}
	
	public String getSpecificInputTypeNameAt(int index) {
		if (index == 0)
			return "object";
		else if (index == 1)
			return "attribute";
		else
			return "new value";
	}

}
