package de.uniwue.ki.mas.basics.type.dependent;

import de.uniwue.ki.mas.basics.type.ISpecificType;
import de.uniwue.ki.mas.basics.type.TypeManager;
import de.uniwue.ki.mas.model.ISeSAmDeclaration;
import de.uniwue.ki.util.name.AbstractNamed;

/**
 * Creation date: (05.12.2001 09:55:05)
 * @author Christoph Oechslein
 */

public class ConstrainedToSubtypesDependentType extends AbstractNamed implements IDependentType {
	private final String _name;
	private ISpecificType _defaultType;

	public ConstrainedToSubtypesDependentType(String name) {
		this(name, TypeManager.getInstance().getDefaultType());
	}

	public ConstrainedToSubtypesDependentType(String name, ISpecificType defaultType) {
		super();

		_name = name;
		_defaultType = defaultType;
	}
	
	public ISpecificType getDefaultSpecificType(ISeSAmDeclaration declaration) {
		return getDefaultSpecificType();
	}
	
	public ISpecificType getDefaultSpecificType() {
		return _defaultType;
	}

	public String getName() {
		return _name;
	}
	
	public void setOutputType(ISpecificType type) {
		_defaultType = type;
	}
}