package de.uniwue.ki.mas.basics.type.dependent;

import de.uniwue.ki.mas.basics.type.IGenericType;
import de.uniwue.ki.mas.basics.type.ISpecificType;
import de.uniwue.ki.mas.model.ISeSAmDeclaration;
import de.uniwue.ki.util.name.AbstractNamed;

/**
 * Creation date: (05.12.2001 09:55:05)
 * @author Christoph Oechslein
 */

public class ConstraintGenericDependentType extends AbstractNamed implements IDependentType {
	private final String _name;
	private final IGenericType _genericType;

	public ConstraintGenericDependentType(String name, IGenericType genericType) {
		_name = name;
		_genericType = genericType;
	}

	public ISpecificType getDefaultSpecificType(ISeSAmDeclaration declaration) {
		return _genericType.createDefaultSpecificType(declaration);
	}

	public ISpecificType getDefaultSpecificType() {
		return _genericType.createDefaultSpecificType();
	}

	public String getName() {
		return _name;
	}

	public IGenericType getGenericType() {
		return _genericType;
	}
}