package de.uniwue.ki.mas.basics.type.dependent;

import java.util.*;

import de.uniwue.ki.mas.basics.type.ISpecificType;
public class DependentTypeBindings {
	private final Map map = new HashMap();
	public static final DependentTypeBindings EMPTY_BINDINGS = new DependentTypeBindings();

	public DependentTypeBindings() {
		super();
	}

	public DependentTypeBindings(Iterator dependTypes) {
		super();

		while (dependTypes.hasNext()) {
			IDependentType currDependentType = (IDependentType) dependTypes.next();
			setBindingFor(currDependentType, currDependentType.getDefaultSpecificType());
		}
	}

	/**
	 * @param type IDependentType
	 * @return ISpecificType
	 */
	public ISpecificType getBindingFor(IDependentType type) {
		if (map.containsKey(type)) {
			return (ISpecificType) map.get(type);
		} else {
			return null;
		}
	}

	public void setBindingFor(IDependentType dependentType, ISpecificType specificType) {
		map.put(dependentType, specificType);
	}
}
