package de.uniwue.ki.mas.basics.type.enum;
import java.util.Map;

import de.uniwue.ki.mas.basics.type.*;

/**
 * A specific Enumeration Type that can be modified 
 * (Items added, Name changed)
 * 
 * Creation date: (03.12.2001 17:20:08)
 * @author Rainer Herrler
 */
public abstract class AbstractSpecificEnumType
	extends AbstractCopyAbleSpecificType
	implements ISpecificType, ISpecificEnumType {

	public void appendNameForArgumentObject(
		StringBuffer buff,
		Object anObject,
		int currDepth,
		int maxDepth) {

		if (currDepth >= maxDepth) {
			buff.append("...");
		} else {
			appendNameForNamedObject(buff, (EnumItem)anObject, currDepth, maxDepth);
		}
	}

	public Object copyArgumentObject(Object anObject, Map objectMapping) {
		if (anObject == null)
			return null;
		else
			return ((EnumItem)anObject);
	}

	public boolean equals(Object obj) {
		return obj == this;
	}

	public Object getArgumentDeclarationDefaultValue() {
		try {
			return (EnumItem)getItemList().get(0);
		} catch (Exception e) {
			// shouldn't occur since function calls (indirectly) createItem
			throw new RuntimeException(e);
		}
	}

	public IGenericType getGenericType() {
		return GenericEnumType.getInstance();
	}

	public int hashCode() {
		return System.identityHashCode(this);
	}

	public boolean isArgumentDeclarationValueOk(Object value) {
		if (value == null)
			return true;

		else if (!(value instanceof EnumItem))
			return false;

		else
			return ((EnumItem)value).getSpecificEnumType().equals(this);
	}

	public boolean isMoreSpecific(ISpecificType type) {
		return super.isMoreSpecific(type);
	}
}