package de.uniwue.ki.mas.basics.type.enum;

import java.io.Serializable;
import java.util.Map;

import junit.framework.Assert;
import de.uniwue.ki.util.copy.AbstractCopyable;
import de.uniwue.ki.util.copy.ICopyable;

/**
 * Creation date: 13.06.2002, 17:41:59
 * @author oechslein
 */
public final class EnumItem extends AbstractCopyable implements Serializable {
	private String _enumName = "Untitled";
	private ISpecificEnumType _specificEnumType;

	public EnumItem(ISpecificEnumType specificEnumType) {
		super();

		_specificEnumType = specificEnumType;
	}
	
	public EnumItem(ISpecificEnumType specificEnumType, String enumName) {
			super();

			_specificEnumType = specificEnumType;
			_enumName = enumName;
		}

	public String getName() {
		return _enumName;
	}

	public final ISpecificEnumType getSpecificEnumType() {
		return _specificEnumType;
	}

	public void setName(String newName) {
		_enumName = newName;
	}

	/**
	 * @param objectMapping Map
	 * @return Object
	 * @see de.uniwue.ki.util.ICopyable#copy(Map)
	 */
	public ICopyable copy(Map objectMapping) {
		return this;
	}

	/**
	 * @param dstObject Object
	 * @param objectMapping Map
	 * @see de.uniwue.ki.util.ICopyable#copyInto(Object, Map)
	 */
	public void copyInto(Object dstObject, Map objectMapping) {
		Assert.fail();
	}
}
