package de.uniwue.ki.mas.basics.type.enum;

import de.uniwue.ki.mas.basics.type.AbstractGenericType;
import de.uniwue.ki.mas.basics.type.ISpecificType;

/**
 * Creation date: 17.06.2002, 15:44:24
 * @author oechslein
 */
public class GenericEnumType extends AbstractGenericType {
	private static final GenericEnumType  _instance = new GenericEnumType();
	
	private GenericEnumType() {
		super();
	}

	public boolean canCreate(ISpecificType type) {
		return type instanceof ISpecificEnumType;
	}

	public ISpecificType createDefaultSpecificType() {
		return ISpecificEnumType.NULL_ENUM_TYPE;
	}

	public String getName() {
		return "Enum<T>";
	}

	public static final GenericEnumType getInstance() {
		return _instance;
	}

}
