package de.uniwue.ki.mas.basics.type.enum;

import java.util.List;

import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionAdapterGenericFunctionDeclaration;
import de.uniwue.ki.mas.basics.type.ISpecificType;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.util.Utils;

/**
 * Creation date: 05.07.2002, 11:45:29
 * @author oechslein
 */
final class SwitchOnEnumerationSpecificFunctionDeclarationWithUnspecificDependents
	extends AbstractSpecificFunctionAdapterGenericFunctionDeclaration {

	private final SpecificEnumType _specificEnumType;
	private final ISpecificType _outputType;

	public SwitchOnEnumerationSpecificFunctionDeclarationWithUnspecificDependents(
		SwitchOnEnumerationGenericFunctionDeclarationWithUnspecificDependents genericFunctionDeclaration,
		SpecificEnumType specificEnumType,
		ISpecificType outputType) {

		super(genericFunctionDeclaration, getCurrentItemListSize(specificEnumType) + 1);

		_specificEnumType = specificEnumType;
		_outputType = outputType;
	}

	private static int getCurrentItemListSize(ISpecificEnumType specificEnumType) {
		return specificEnumType.getItemList().size();
	}

	public ISpecificType getSpecificInputTypeAt(int index) {
		if (index == 0)
			return _specificEnumType;
		else
			return _outputType;
	}

	public String getSpecificInputTypeNameAt(int index) {
		if (index == 0)
			return "switch";

		else if (index < getSpecificInputDefaultArgsLength())
			return "case " + getItemAt(index - 1).getName();

		else
			return "Removed Item";
	}

	private EnumItem getItemAt(int index) {
		return (EnumItem) _specificEnumType.getItemListAndFactory().getMutableListModel().get(index);
	}

	public ISpecificType getSpecificOutputType() {
		return _outputType;
	}

	public int getSpecificInputDefaultArgsLength() {
		return getCurrentItemListSize(_specificEnumType) + 1;
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions)
		throws ModelCompilingException {

		return new SwitchOnEnumerationFunction(_specificEnumType, functions);
	}

	public boolean equals(Object obj) {
		if (obj == this)
			return true;

		if (!(obj instanceof SwitchOnEnumerationSpecificFunctionDeclarationWithUnspecificDependents)) {
			return false;
		}

		SwitchOnEnumerationSpecificFunctionDeclarationWithUnspecificDependents swicthSpecFuncDecl =
			(SwitchOnEnumerationSpecificFunctionDeclarationWithUnspecificDependents) obj;

		return Utils.equals(_specificEnumType, swicthSpecFuncDecl._specificEnumType)
			&& Utils.equals(_outputType, swicthSpecFuncDecl._outputType);
	}


	public int hashCode() {
		return 3*_specificEnumType.hashCode() + _outputType.hashCode(); 
	}
	
		public boolean isSpecificFunctionDeclOk(ISpecificType outputType, List inputTypes) {
		// maybe one item was added or removed!
		if (inputTypes.isEmpty())
			return false;

		if ((outputType != null) && (!Utils.equals(outputType, _outputType)))
			return false;

		return _specificEnumType.equals(inputTypes.get(0));
	}
}
