package de.uniwue.ki.mas.basics.type.user;
import de.uniwue.ki.mas.util.declaration.AbstractDeclarationFactory;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: (04.09.2001 16:05:27)
 * @author Christoph Oechslein
 */

public final class UserTypeDeclarationFactory extends AbstractDeclarationFactory {

	private static final UserTypeDeclarationFactory _instance =
		new UserTypeDeclarationFactory();

	public UserTypeDeclarationFactory() {
		super();
	}

	public final IDeclaration createDeclaration() {
		return createUserTypeDeclaration();
	}

	public final IUserTypeDeclaration createUserTypeDeclaration() {
		return new UserTypeDeclaration();
	}

	public final IUserTypeDeclaration createUserTypeDeclaration(boolean composedType) {
		return new UserTypeDeclaration(composedType);
	}

	public static final UserTypeDeclarationFactory getInstance() {
		return _instance;
	}
}