package de.uniwue.ki.mas.basics.type.user;
import de.uniwue.ki.mas.util.declaration.DefaultDeclarationListAndFactory;

/**
 * Creation date: (14.11.2001 11:02:00)
 * @author Christoph Oechslein
 */
public class UserTypeDeclarationListAndFactory extends DefaultDeclarationListAndFactory {
	public UserTypeDeclarationListAndFactory() {
		this(new UserTypeDeclarationList(), new UserTypeDeclarationFactory());
	}

	UserTypeDeclarationListAndFactory(
		UserTypeDeclarationList userDefinedTypeDeclarationList,
		UserTypeDeclarationFactory userDefinedTypeDeclarationFactory) {

		super(userDefinedTypeDeclarationList, userDefinedTypeDeclarationFactory);
	}

	public UserTypeDeclarationFactory getUserTypeDeclarationFactory() {
		return (UserTypeDeclarationFactory) getDeclarationFactory();
	}

	public UserTypeDeclarationList getUserTypeDeclarationList() {
		return (UserTypeDeclarationList) getDeclarationList();
	}

	/**
	 * returns the first user type of this List and Factory or
	 * creates and returnes one, if there is none existing.
	 */
	public IUserTypeDeclaration getUserTypeCreateIfEmpty(boolean composed) {
		IUserTypeDeclaration userTypeDeclaration =
			getUserTypeDeclarationList().getUserTypeDeclaration(composed);

		if (userTypeDeclaration == null) {
			userTypeDeclaration = getUserTypeDeclarationFactory().createUserTypeDeclaration(composed);
			getUserTypeDeclarationList().add(userTypeDeclaration);
		}

		return userTypeDeclaration;
	}
}