package de.uniwue.ki.mas.behaviour.activityGraph;

import de.uniwue.ki.mas.behaviour.activityGraphDeclaration.IActivityGraphDeclaration;
import de.uniwue.ki.mas.behaviour.activityGraphDeclaration.IActivityGraphNodeDeclaration;
import de.uniwue.ki.util.name.AbstractNamed;

/**
 * Creation date: (13.09.2001 15:12:35)
 * @author Christoph Oechslein
 */
abstract class AbstractActivityGraphNode extends AbstractNamed implements IActivityGraphNode {
	private final IActivityGraphNodeDeclaration _activityDeclaration;

	public AbstractActivityGraphNode(IActivityGraphNodeDeclaration activityDeclaration) {
		super();

		_activityDeclaration = activityDeclaration;
	}

	public final IActivityGraphNodeDeclaration getActivityGraphNodeDeclaration() {
		return _activityDeclaration;
	}

	public final String getName() {
		return getNameIntern();
	}

	public void appendName(StringBuffer buff, int currDepth, int maxDepth) {
		if (currDepth >= maxDepth) {
			buff.append("...");

		} else if (getActivityGraphNodeDeclaration() == null) {
			buff.append("NULL");

		} else {
			getActivityGraphNodeDeclaration().appendName(buff, currDepth, maxDepth);
			appendName(
				buff,
				getActivityGraphNodeDeclaration().getActivityGraphDeclaration(),
				currDepth + 1,
				maxDepth);
		}
	}

	public static void appendName(
		StringBuffer buff,
		IActivityGraphDeclaration parent,
		int currDepth,
		int maxDepth) {

		if ((parent != null) && (parent.getParentActivityGraphComposedNodeDeclaration() != null)) {
			if (currDepth >= maxDepth) {
				buff.append("...");
			} else {
				buff.append(" [");
				parent.appendName(buff, currDepth, maxDepth);
				appendName(
					buff,
					parent.getParentActivityGraphComposedNodeDeclaration().getActivityGraphDeclaration(),
					currDepth + 1,
					maxDepth);
				buff.append("]");
			}
		}
	}
}