package de.uniwue.ki.mas.behaviour.activityGraph;

import junit.framework.Assert;
import de.uniwue.ki.mas.basics.action.FunctionActionTwoFactory;
import de.uniwue.ki.mas.basics.action.IFunctionActionTwo;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.behaviour.activityGraphDeclaration.IActionActivityGraphLeafDeclaration;

/**
 * Creation date: (27.07.2001 18:33:34)
 * @author Christoph Oechslein
 */

final class ActionActivityGraphLeaf extends InstantlyActivityGraphLeaf {

	private final IFunction _exitAction;
	private final IFunctionActionTwo _entryAndNormalAction;

	public ActionActivityGraphLeaf(
		IActionActivityGraphLeafDeclaration activityDeclaration,
		boolean instantlyActivity,
		IFunction entryAction,
		IFunction action,
		IFunction exitAction) {

		super(activityDeclaration, instantlyActivity);

		if (Assert.ASSERTION_ON) {
			Assert.assertNotNull(action);
			Assert.assertNotNull(entryAction);
			Assert.assertNotNull(exitAction);
		}

		_exitAction = exitAction;
		_entryAndNormalAction = FunctionActionTwoFactory.createFunctionAction(entryAction, action);
	}

	public IFunction getEntryAndNormalFunctionAction() {
		return _entryAndNormalAction;
	}

	protected IFunction getExitFunctionAction() {
		return _exitAction;
	}

	protected IFunction getFunctionAction() {
		return _entryAndNormalAction.getFunctionAction2();
	}
}
