package de.uniwue.ki.mas.behaviour.activityGraph;

import de.uniwue.ki.mas.basics.action.FunctionActionFactory;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.behaviour.activityGraphDeclaration.*;

/**
 * Creation date: 03.07.2002, 11:00:22
 * @author oechslein
 */
public final class ActivityFactory {
	public static final IActivityGraphLeaf createActionAtomicActivity(
		IActionActivityGraphLeafDeclaration activityDeclaration,
		boolean instantlyActivity,
		IFunction entryAction,
		IFunction action,
		IFunction exitAction) {

		if (FunctionActionFactory.isNoopFunction(entryAction)
			&& FunctionActionFactory.isNoopFunction(action)
			&& FunctionActionFactory.isNoopFunction(exitAction)) {
			return new NoopActionActivityGraphLeaf(activityDeclaration, instantlyActivity);

		} else {
			return new ActionActivityGraphLeaf(
				activityDeclaration,
				instantlyActivity,
				entryAction,
				action,
				exitAction);
		}
	}

	public static final IActivityGraph createActivityGraph(IActivityGraphDeclaration declaration) {
		return new ActivityGraph(declaration);
	}

	public static final IActivityGraphLeaf createDecisionActivityGraphLeaf(IDecisionGraphLeafDeclaration declaration) {
		return new DecisionActivityGraphLeaf(declaration);
	}

	public static final IActivityGraphLeaf createEmergencyActivityGraphLeaf(IEmergencyActivityGraphLeafDeclaration declaration) {
		return new EmergencyActivityGraphLeaf(declaration);
	}

	public static final IActivityGraphLeaf createEntryActivityGraphLeaf(IEntryActivityGraphLeafDeclaration declaration) {
		return new EntryActivityGraphLeaf(declaration);
	}

	public static final IActivityGraphLeaf createExitActivityGraphLeaf(IExitActivityGraphLeafDeclaration declaration) {
		return new ExitActivityGraphLeaf(declaration);
	}

	public static final IActivityGraphLeaf createSuicideExitActivityGraphLeaf(IExitActivityGraphLeafDeclaration declaration) {
		return new SuicideExitActivityGraphLeaf(declaration);
	}
}
