package de.uniwue.ki.mas.behaviour.activityGraph;

import java.util.Iterator;

import de.uniwue.ki.mas.basics.function.ICreateFunctionArgs;
import de.uniwue.ki.mas.behaviour.activityGraphDeclaration.*;
import de.uniwue.ki.mas.behaviour.rule.IActivityGraphEdgeDeclaration;
import de.uniwue.ki.mas.behaviour.rule.IActivityGraphRuleDeclaration;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * @author oechslein
 * 
 * Creation date: 21.05.2003
 */
public class ActivityGraphNoopHelper {

	public static boolean isNoop(
		ICreateFunctionArgs createFunctionArgs,
		IActivityGraph activityGraph,
		IActivityGraphDeclaration activityGraphDeclaration)
		throws ModelCompilingException {

		Iterator it = activityGraphDeclaration.getNodes();
		while (it.hasNext()) {
			IActivityGraphNodeDeclaration element = (IActivityGraphNodeDeclaration)it.next();
			if (!isNoop(createFunctionArgs, activityGraph, element)) {
				return false;
			}
		}

		it = activityGraphDeclaration.getActivityGraphEdgeDeclarationList().iterator();
		while (it.hasNext()) {
			IActivityGraphEdgeDeclaration element = (IActivityGraphEdgeDeclaration)it.next();

			if ((element instanceof IActivityGraphRuleDeclaration)
				&& !((IActivityGraphRuleDeclaration)element).getConditionFunctionCallDeclaration().isReadOnly(
					createFunctionArgs)) {
				return false;
			}
		}

		return CollectionsHelper.isEmpty(
			activityGraphDeclaration.getExitActivityGraphLeafDeclaration().getIncomingNodeEdges());
	}

	private static boolean isNoop(
		ICreateFunctionArgs createFunctionArgs,
		IActivityGraph activityGraph,
		IActivityGraphNodeDeclaration graphNodeDeclaration)
		throws ModelCompilingException {

		if (graphNodeDeclaration instanceof IActivityGraphDeclaration) {
			return isNoop(createFunctionArgs, activityGraph, (IActivityGraphDeclaration)graphNodeDeclaration);

		} else if (graphNodeDeclaration instanceof IActionActivityGraphLeafDeclaration) {
			return (
				activityGraph.getActivityGraphLeafForDeclaration(graphNodeDeclaration)
					instanceof NoopActionActivityGraphLeaf);

		} else {
			return true;
		}
	}
}
