package de.uniwue.ki.mas.behaviour.activityGraph;
import de.uniwue.ki.mas.entity.object.agent.IAgentExecuteFunctionArgs;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (23.08.2001 19:41:37)
 * @author Christoph Oechslein
 */

final class DefaultCalculateNextActivityGraphLeaf extends AbstractCalculateNextActivityGraphLeaf {
	private final AbstractActivityGraphLeaf _atomicActivity;

	public DefaultCalculateNextActivityGraphLeaf(AbstractActivityGraphLeaf atomicActivity) {
		_atomicActivity = atomicActivity;
	}

	public IActivityGraphLeaf calculateNextActivityGraphLeaf(IAgentExecuteFunctionArgs objectExecuteFunctionArgs)
		throws SimulationRuntimeException {

		IActivityGraphLeaf nextAtomicActivity =
			calculateActivityGraphLeafInRuleList(
				_atomicActivity.getEmergencyRules(),
				objectExecuteFunctionArgs);

		if (nextAtomicActivity == null) {
			nextAtomicActivity =
				calculateActivityGraphLeafInRuleList(
					_atomicActivity.getChainRules(),
					objectExecuteFunctionArgs);

			if (nextAtomicActivity == null) {
				nextAtomicActivity = _atomicActivity.getOtherwiseToAtomicActivity();
			}
		}

		return nextAtomicActivity;
	}
}