package de.uniwue.ki.mas.behaviour.activityGraph;

import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.behaviour.activityGraphDeclaration.IActivityGraphLeafDeclaration;
import de.uniwue.ki.mas.behaviour.rule.IActivityGraphRule;
import de.uniwue.ki.mas.entity.object.agent.IAgentExecuteFunctionArgs;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (11.09.2000 11:25:11)
 *
 * @see IActivityGraphLeafDeclaration
 * @author Christoph Oechslein
 */

public interface IActivityGraphLeaf extends IActivityGraphNode {

	/**
	 * Returns the a list of the linked edges ({@link IActivityGrapRule IActivityRules}),
	 * used by the compilation process for generating the actibvity graph.
	 */
	IActivityGraphRule[] getChainRules();

	/**
	 * Calculate what to do next in this activity, the result is saved
	 * in the reasonResult argument.
	 */
	void calculateResult(
		IAgentExecuteFunctionArgs objectExecuteFunctionArgs,
		IActivityGraphLeafReasonResult atomicActivityReasonResult)
		throws SimulationRuntimeException;

	/**
	 * Returns the a list of the emergency {link IActivityGrapRule IActivityRules},
	 * used by the compilation process for generating the actibvity graph.
	 */
	IActivityGraphRule[] getEmergencyRules();

	/**
	 * Returns a function of the entry functions and the normal functions.
	 */
	IFunction getEntryAndNormalFunctionAction();

	/**
	 * @see IActivityGraphLeafDeclaration#isInstantly()
	 */
	boolean isInstantly();
}