package de.uniwue.ki.mas.behaviour.activityGraph;

import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.behaviour.reasoning.IActivityReasoningEngineResult;
import de.uniwue.ki.mas.entity.object.IObjectExecuteFunctionArgs;

/**
 * Used by {@link IActivityGraphLeaf#calculateResult(IObjectExecuteFunctionArgs, IActivityGraphLeafReasonResult)
 * to return a result.
 * Creation date: (11.09.2000 09:49:37)
 *
 * @author Christoph Oechslein
 */

interface IActivityGraphLeafReasonResult extends IActivityReasoningEngineResult {
	/**
	 * Sets result action function.
	 *
	 * @see #getAction(IFunction)
	 */
	void setAction(IFunction newFunctionAction);

	/**
	 * Sets result action functions.
	 *
	 * @see #getAction(IFunction)
	 */
	void setAction(IFunction newFunctionAction1, IFunction newFunctionAction2);

	/**
	 * @see #hasCurrentActivityGraphLeafEnded()
	 */
	void setCurrentActivityGraphLeafHasEnded(boolean hasEnded);

	/**
	 * @see #getNextActivityGraphLeaf()
	 */
	void setNextActivityGraphLeaf(IActivityGraphLeaf nextActivityGraphLeaf);
}
