package de.uniwue.ki.mas.behaviour.activityGraph;
import de.uniwue.ki.mas.entity.object.agent.IAgentExecuteFunctionArgs;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (23.08.2001 19:41:37)
 * @author Christoph Oechslein
 */

final class SequenceCalculateNextActivity extends AbstractCalculateNextActivityGraphLeaf {
	private final AbstractActivityGraphLeaf _atomicActivity;
	private final IActivityGraphLeaf _nextAtomicActivity;

	public SequenceCalculateNextActivity(
		AbstractActivityGraphLeaf atomicActivity,
		IActivityGraphLeaf nextAtomicActivity) {

		_atomicActivity = atomicActivity;
		_nextAtomicActivity = nextAtomicActivity;
	}

	public IActivityGraphLeaf calculateNextActivityGraphLeaf(IAgentExecuteFunctionArgs objectExecuteFunctionArgs)
		throws SimulationRuntimeException {

		IActivityGraphLeaf nextAtomicActivity =
			calculateActivityGraphLeafInRuleList(
				_atomicActivity.getEmergencyRules(),
				objectExecuteFunctionArgs);

		if (nextAtomicActivity == null) {
			nextAtomicActivity = _nextAtomicActivity;
		}

		return nextAtomicActivity;
	}
}