package de.uniwue.ki.mas.behaviour.activityGraphDeclaration;
import mygale.mcge.net.INetNode;
import mygale.mcge.net.INetNodeFactory;
import de.uniwue.ki.mas.util.declaration.AbstractDeclarationFactory;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: (04.09.2001 16:05:27)
 * @author Christoph Oechslein
 */

public final class ActionActivityGraphLeafDeclarationFactory
	extends AbstractDeclarationFactory
	implements IActivityGraphNodeDeclarationFactory, INetNodeFactory {

	private final IActivityGraphDeclaration _activityGraphDeclaration;
	private final IActivityGraphNodeDeclarationTypeable.Type _type;

	public ActionActivityGraphLeafDeclarationFactory(IActivityGraphDeclaration parentComposedActivityDeclaration) {
		this(parentComposedActivityDeclaration, IActivityGraphNodeDeclarationTypeable.ACTIVITY_LIKE);
	}

	public ActionActivityGraphLeafDeclarationFactory(
		IActivityGraphDeclaration parentComposedActivityDeclaration,
		IActivityGraphNodeDeclarationTypeable.Type type) {

		super();

		_type = type;
		_activityGraphDeclaration = parentComposedActivityDeclaration;
	}

	public static final IActionActivityGraphLeafDeclaration createActionActivityGraphLeafDeclaration(IActivityGraphDeclaration parentComposedActivityDeclaration) {
		return new ActionActivityGraphLeafDeclaration(parentComposedActivityDeclaration);
	}

	public IActivityGraphNodeDeclaration createActivityGraphNodeDeclaration() {
		return createActionActivityGraphLeafDeclaration(_activityGraphDeclaration, _type);
	}

	public final IDeclaration createDeclaration() {
		return createActivityGraphNodeDeclaration();
	}

	public final INetNode createNetNode() {
		return createActivityGraphNodeDeclaration();
	}

	public static final IActionActivityGraphLeafDeclaration createActionActivityGraphLeafDeclaration(
		IActivityGraphDeclaration parentComposedActivityDeclaration,
		IActivityGraphNodeDeclarationTypeable.Type type) {

		IActionActivityGraphLeafDeclaration newActionAtomicActivityDeclaration =
			createActionActivityGraphLeafDeclaration(parentComposedActivityDeclaration);

		newActionAtomicActivityDeclaration.setType(type);

		return newActionAtomicActivityDeclaration;
	}
}