package de.uniwue.ki.mas.behaviour.activityGraphDeclaration;
import de.uniwue.ki.mas.util.declaration.AbstractDeclarationFactory;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: (30.07.2001 17:59:57)
 * @author Christoph Oechslein
 */

public final class ActivityGraphDeclarationFactory extends AbstractDeclarationFactory {

	private static final ActivityGraphDeclarationFactory _instance = new ActivityGraphDeclarationFactory();

	private ActivityGraphDeclarationFactory() {
		super();
	}

	public static void addIdleActivity(IActivityGraphDeclaration activityGraphDeclaration) {
		IActionActivityGraphLeafDeclaration newActionAtomicActivityDeclaration =
			ActionActivityGraphLeafDeclarationFactory.createActionActivityGraphLeafDeclaration(
				activityGraphDeclaration);

		newActionAtomicActivityDeclaration.setUsesShortDescription(true);
		newActionAtomicActivityDeclaration.setShortDescription("Idle");
		newActionAtomicActivityDeclaration.setInstantly(false);
		newActionAtomicActivityDeclaration.setType(IActivityGraphNodeDeclarationTypeable.STATE_LIKE);

		activityGraphDeclaration.addActivityGraphNodeDeclaration(newActionAtomicActivityDeclaration);

		activityGraphDeclaration.addActivityGraphEdgeDeclaration(
			activityGraphDeclaration.getEntryActivityGraphLeafDeclaration(),
			newActionAtomicActivityDeclaration);
	}

	public static final IActivityGraphDeclaration createActivityGraphDeclaration() {
		IActivityGraphDeclaration composedActivityDeclaration = createEmptyActivityGraphDeclaration();

		addIdleActivity(composedActivityDeclaration);

		return composedActivityDeclaration;
	}

	public final IDeclaration createDeclaration() {
		return createActivityGraphDeclaration();
	}

	public static final IActivityGraphDeclaration createEmptyActivityGraphDeclaration() {
		return new ActivityGraphDeclaration();
	}

	public static final ActivityGraphDeclarationFactory getInstance() {
		return _instance;
	}
}