package de.uniwue.ki.mas.behaviour.activityGraphDeclaration;

import mygale.mcge.net.INetNode;
import mygale.mcge.net.INetNodeFactory;
import de.uniwue.ki.mas.util.declaration.AbstractDeclarationFactory;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: (04.09.2001 16:05:27)
 * @author Christoph Oechslein
 */

public final class DecisionGraphLeafDeclarationFactory
	extends AbstractDeclarationFactory
	implements IActivityGraphNodeDeclarationFactory, INetNodeFactory {
	private final IActivityGraphDeclaration _activityGraphDeclaration;

	public DecisionGraphLeafDeclarationFactory(IActivityGraphDeclaration activityGraphDeclaration) {
		super();
		_activityGraphDeclaration = activityGraphDeclaration;
	}

	public static final IDecisionGraphLeafDeclaration createDecisionActivityGraphLeafDeclaration(IActivityGraphDeclaration parentComposedActivityDeclaration) {
		return new DecisionGraphLeafDeclaration(parentComposedActivityDeclaration);
	}

	public IActivityGraphNodeDeclaration createActivityGraphNodeDeclaration() {
		return createDecisionActivityGraphLeafDeclaration(_activityGraphDeclaration);
	}

	public IDeclaration createDeclaration() {
		return null;
	}

	public INetNode createNetNode() {
		return createActivityGraphNodeDeclaration();
	}

	protected String getDefaultName() {
		return "Untitled Decision Activity Declaration";
	}
}
