package de.uniwue.ki.mas.behaviour.activityGraphDeclaration;

import java.util.Map;

import mygale.mcge.net.INetEdge;
import mygale.mcge.net.INetNode;
import de.uniwue.ki.mas.behaviour.activityGraph.ActivityFactory;
import de.uniwue.ki.mas.behaviour.activityGraph.IActivityGraphLeaf;
import de.uniwue.ki.mas.behaviour.rule.IGraphDocumentEdgeDeclaration;
import de.uniwue.ki.mas.entity.object.IObjectCreateFunctionArgs;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.util.copy.ICopyable;

/**
 * Creation date: 19.12.2002, 10:27:26
 * @author oechslein
 */
class EmergencyActivityGraphLeafDeclaration
	extends AbstractActivityGraphNodeDeclaration
	implements IEmergencyActivityGraphLeafDeclaration {

	public EmergencyActivityGraphLeafDeclaration(IActivityGraphDeclaration parentComposedActivityDeclaration) {
		super(parentComposedActivityDeclaration);

		setShortDescription("Emergency Activity");
	}

	public boolean canBeRemoved() {
		return false;
	}

	/** 
	 * Reply if an Port can be the ending of an NetEdge.
	 *  By default all Edges can be connected to this Port.
	 *  Subclasses must override this method to have a more
	 *  restrictive managing.
	 *
	 * @param edge the classname of the Edge to connect.
	 * @param port the NetPort in the other
	 *             side of the given Edge.
	 * @return <code>true</code> if this Port can be
	 *         connected to the given Edge.
	 */
	public boolean canConnect(INetEdge edge, INetNode otherNode) {
		//return false;
		return edge instanceof IGraphDocumentEdgeDeclaration;
	}

	public IActivityGraphLeaf createActivityGraphLeaf(IObjectCreateFunctionArgs objectCreateFunctionArgs)
		throws ModelCompilingException {
		return ActivityFactory.createEmergencyActivityGraphLeaf(this);
	}

	public boolean isInstantly() {
		throw new UnsupportedOperationException();
	}

	protected ICopyable createInstance(Map objectMapping) {
		return new EmergencyActivityGraphLeafDeclaration(getActivityGraphDeclaration());
	}

	protected String getDefaultName() {
		return "Emergency Activity Declaration";
	}
}
