package de.uniwue.ki.mas.behaviour.activityGraphDeclaration;

import java.util.Map;

import mygale.mcge.net.INetEdge;
import mygale.mcge.net.INetNode;
import de.uniwue.ki.mas.behaviour.activityGraph.ActivityFactory;
import de.uniwue.ki.mas.behaviour.activityGraph.IActivityGraphLeaf;
import de.uniwue.ki.mas.behaviour.rule.IGraphDocumentEdgeDeclaration;
import de.uniwue.ki.mas.entity.object.IObjectCreateFunctionArgs;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.util.copy.ICopyable;

class EntryActivityGraphLeafDeclaration
	extends AbstractActivityGraphLeafDeclaration
	implements IEntryActivityGraphLeafDeclaration {

	public EntryActivityGraphLeafDeclaration(IActivityGraphDeclaration parentComposedActivityDeclaration) {

		super(parentComposedActivityDeclaration);

		setShortDescription("Entry Activity");
	}

	public boolean canBeRemoved() {
		return false;
	}

	public boolean canConnect(INetEdge edge, INetNode otherNode) {
		//return false;
		return edge instanceof IGraphDocumentEdgeDeclaration;
	}

	public IActivityGraphLeaf createActivityGraphLeaf(IObjectCreateFunctionArgs objectCreateFunctionArgs)
		throws ModelCompilingException {

		return ActivityFactory.createEntryActivityGraphLeaf(this);
	}

	public boolean isInstantly() {
		return true;
	}

	protected ICopyable createInstance(Map objectMapping) {
		return new EntryActivityGraphLeafDeclaration(getActivityGraphDeclaration());
	}

	protected String getDefaultName() {
		return "Entry Activity Declaration";
	}
}
