package de.uniwue.ki.mas.behaviour.activityGraphDeclaration;
import java.util.Map;

import junit.framework.Assert;
import mygale.mcge.net.INetEdge;
import de.uniwue.ki.mas.behaviour.activityGraph.ActivityFactory;
import de.uniwue.ki.mas.behaviour.activityGraph.IActivityGraphLeaf;
import de.uniwue.ki.mas.behaviour.rule.IGraphDocumentEdgeDeclaration;
import de.uniwue.ki.mas.entity.object.IObjectCreateFunctionArgs;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.util.copy.ICopyable;

/**
 * Creation date: (14.09.2001 09:34:28)
 * @author Christoph Oechslein
 */

class ExitActivityGraphLeafDeclaration
	extends AbstractActivityGraphLeafDeclaration
	implements IExitActivityGraphLeafDeclaration {

	public ExitActivityGraphLeafDeclaration(IActivityGraphDeclaration parentComposedActivityDeclaration) {

		super(parentComposedActivityDeclaration);

		setShortDescription("Exit Activity");
	}

	public boolean canBeRemoved() {
		return false;
	}

	public boolean canConnect(INetEdge edge) {
		return (edge instanceof IGraphDocumentEdgeDeclaration);
	}

	public IActivityGraphLeaf createActivityGraphLeaf(IObjectCreateFunctionArgs objectCreateFunctionArgs)
		throws ModelCompilingException {

		if (isInTopLevelActivityGraphDeclaration()) {
			return ActivityFactory.createSuicideExitActivityGraphLeaf(this);

		} else {
			return ActivityFactory.createExitActivityGraphLeaf(this);
		}
	}

	protected ICopyable createInstance(Map objectMapping) {
		return new ExitActivityGraphLeafDeclaration(getActivityGraphDeclaration());
	}

	protected String getDefaultName() {
		return "Exit Activity Declaration";
	}

	private boolean isInTopLevelActivityGraphDeclaration() {
		if (Assert.ASSERTION_ON)
			Assert.assertNotNull(getActivityGraphDeclaration());

		return getActivityGraphDeclaration().getParentActivityGraphComposedNodeDeclaration() == null;
	}

	public boolean isInstantly() {
		return !isInTopLevelActivityGraphDeclaration();
	}
}