package de.uniwue.ki.mas.behaviour.activityGraphDeclaration;
import mygale.mcge.net.INetNode;
import mygale.mcge.net.INetNodeFactory;
import de.uniwue.ki.mas.util.declaration.AbstractDeclarationFactory;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: (04.09.2001 16:05:27)
 * @author Christoph Oechslein
 */

public final class GraphDocumentationLeafDeclarationFactory
	extends AbstractDeclarationFactory
	implements IActivityGraphNodeDeclarationFactory, INetNodeFactory {

	private final IActivityGraphDeclaration _activityGraphDeclaration;

	public GraphDocumentationLeafDeclarationFactory(IActivityGraphDeclaration parentComposedActivityDeclaration) {
		super();

		_activityGraphDeclaration = parentComposedActivityDeclaration;
	}

	public static final GraphDocumentationLeafDeclaration createGraphDocumentationLeafDeclaration(IActivityGraphDeclaration parentComposedActivityDeclaration) {
		return new GraphDocumentationLeafDeclaration(parentComposedActivityDeclaration);
	}

	public IActivityGraphNodeDeclaration createActivityGraphNodeDeclaration() {
		return createGraphDocumentationLeafDeclaration(_activityGraphDeclaration);
	}

	public final IDeclaration createDeclaration() {
		return createActivityGraphNodeDeclaration();
	}

	public final INetNode createNetNode() {
		return createActivityGraphNodeDeclaration();
	}

	public static final GraphDocumentationLeafDeclaration createGraphDocumentationLeafDeclaration(
		IActivityGraphDeclaration parentComposedActivityDeclaration,
		IActivityGraphNodeDeclarationTypeable.Type type) {

		GraphDocumentationLeafDeclaration newActivityGraphDocumentationNodeDeclaration =
			createGraphDocumentationLeafDeclaration(parentComposedActivityDeclaration);

		return newActivityGraphDocumentationNodeDeclaration;
	}
}