package de.uniwue.ki.mas.behaviour.activityGraphDeclaration;
import de.uniwue.ki.mas.basics.action.FunctionActionCallDeclarationListAndFactory;
import de.uniwue.ki.mas.util.declaration.IDocumentableDeclaration;

/**
 * Enhance <code>IActivityGraphLeafDeclaration</code> by adding action rules
 * (see {@link IFunctionActionCallRuleDeclaration}) for entering, leaving and
 * beeing in this activity.
 * Creation date: (09.11.2000 09:48:13)
 *
 * @author Christoph Oechslein
 */

public interface IActionActivityGraphLeafDeclaration
	extends IActivityGraphLeafDeclaration, IActivityGraphNodeDeclarationTypeable, IDocumentableDeclaration {

	/**
	 * Returns a list of action rules which are executed if this activity gets activated.
	 */
	FunctionActionCallDeclarationListAndFactory getEntryFunctionActionCallDeclarationListAndFactory();

	/**
	 * Returns a list of action rules which are executed if this activity is finished.
	 */
	FunctionActionCallDeclarationListAndFactory getExitFunctionActionCallDeclarationListAndFactory();

	/**
	 * Returns a list of action rules which are executed if this activity is activ.
	 */
	FunctionActionCallDeclarationListAndFactory getFunctionActionCallDeclarationListAndFactory();

	/**
	 * In an instant activity no time is spent for executing the actions
	 *
	 * @see #setInstantly(boolean)
	 */
	boolean isInstantly();

	/**
	 * Sets if this is an instant activity.
	 *
	 * @see isInstantly()
	 */
	void setInstantly(boolean instantly);
}