package de.uniwue.ki.mas.behaviour.activityGraphDeclaration;
import java.util.Iterator;

import mygale.mcge.net.INetNode;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * An <code>IActivityGraphNodeDeclaration</code> is a node in an {@link IActivityGraphDeclaration activity declaration graph}, an
 * <code>IActivityGraphNodeDeclaration</code> can only be an {@link IActivityGraphDeclaration} or an {@link
 * IActivityGraphLeafDeclaration}.
 * Creation date: (17.05.00 15:39:04)
 *
 * @author Christoph Oechslein
 */

public interface IActivityGraphNodeDeclaration extends IDeclarationNetNode {

	Iterator getActivityGraphEdgeDeclarations();

	/**
	 * Returns the surrounding graph of this node,
	 * returns <code>null</code> if no graph exists.
	 */
	IActivityGraphDeclaration getActivityGraphDeclaration();

	/**
	 * In an instant activity no time is spent for executing the actions
	 *
	 * @see #setInstantly(boolean)
	 */
	boolean isInstantly();

	/**
	 * Sets the surrounding graph of this node,
	 */
	void setActivityGraphDeclaration(IActivityGraphDeclaration composedActivityDeclaration);
}