package de.uniwue.ki.mas.behaviour.activityGraphDeclaration;
import java.io.Serializable;

import de.uniwue.ki.mas.util.declaration.IDeclaration;
import de.uniwue.ki.util.name.AbstractNamed;

/**
 * Creation date: 19.12.2002, 10:18:33
 * @author oechslein
 */
public interface IActivityGraphNodeDeclarationTypeable extends IDeclaration {
	public class Type extends AbstractNamed implements Serializable {
		private final String _name;

		protected Type(String name) {
			_name = name;
		}

		public String getName() {
			return _name;
		}
	}

	Type ACTIVITY_LIKE = new Type("Activity like");
	Type STATE_LIKE = new Type("State like");
	Type SIGNAL_IN_LIKE = new Type("Signal in like");
	Type SIGNAL_OUT_LIKE = new Type("Signal out like");

	/*
	 * Returns any of: ACTIVITY_LIKE, STATE_LIKE, SIGNAL_IN_LIKE, SIGNAL_OUT_LIKE.
	 */
	Type getType();

	/*
	 * Must be any of: ACTIVITY_LIKE, STATE_LIKE, SIGNAL_IN_LIKE, SIGNAL_OUT_LIKE.
	 */
	void setType(Type newType);
}