package de.uniwue.ki.mas.behaviour.reasoning;
import de.uniwue.ki.mas.entity.object.IObjectCreateFunctionArgs;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.mas.util.declaration.AbstractDeclaration;

/**
 * <BR>Creation date: (30.03.00 15:49:27)
 * @author Christoph Oechslein
 */

abstract class AbstractReasoningEngineDeclaration
	extends AbstractDeclaration
	implements IReasoningEngineDeclaration {

	public AbstractReasoningEngineDeclaration() {
		super();
	}

	protected abstract IReasoningEngine createNewReasoningEngine(IObjectCreateFunctionArgs objectCreateFunctionArgs)
		throws ModelCompilingException;

	public final IReasoningEngine createReasoningEngine(IObjectCreateFunctionArgs objectCreateFunctionArgs)
		throws ModelCompilingException {

		if (objectCreateFunctionArgs.existsCompilationObject(this, false))
			return (IReasoningEngine) objectCreateFunctionArgs.getCompilationObject(this, false);

		else {
			IReasoningEngine reasoningEngine = createNewReasoningEngine(objectCreateFunctionArgs);
			objectCreateFunctionArgs.addCompilationObject(this, reasoningEngine, false);
			return reasoningEngine;
		}
	}

	public void remove() {
		super.remove();
	}
}