package de.uniwue.ki.mas.behaviour.reasoning;

import java.util.Map;

import de.uniwue.ki.mas.behaviour.activityGraph.IActivityGraph;
import de.uniwue.ki.mas.behaviour.activityGraph.IActivityGraphLeaf;
import de.uniwue.ki.mas.behaviour.activityGraphDeclaration.IActivityGraphNodeDeclaration;
import de.uniwue.ki.mas.entity.object.IObjectCreateFunctionArgs;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.mas.model.SimulationRuntimeException;
import de.uniwue.ki.util.copy.ICopyable;

final class ActivityReasoningEngine extends AbstractReasoningEngine implements IActivityReasoningEngine {
	private IActivityGraph _activityGraph;

	public ActivityReasoningEngine(
		IActivityReasoningEngineDeclaration activityReasoningEngineDeclaration,
		IObjectCreateFunctionArgs objectCreateFunctionArgs)
		throws ModelCompilingException {

		super(activityReasoningEngineDeclaration);

		_activityGraph =
			activityReasoningEngineDeclaration.getRootActivityGraphDeclaration().createActivityGraph(
				objectCreateFunctionArgs);
	}

	public IReasoningEngineResult calculateReasoningEngineResult(IReasoningEngineCalculationArgs reasoningEngineCalculationArgs)
		throws SimulationRuntimeException {
		return getActivityGraph().calculateReasoningEngineResult(
			(IActivityReasoningEngineCalculationArgs) reasoningEngineCalculationArgs);
	}

	public ICopyable copy(Map objectMapping) {
		return this;
	}

	public final IActivityGraphLeaf getAtomicActivityForDeclaration(IActivityGraphNodeDeclaration activityDeclaration) {
		return getActivityGraph().getActivityGraphLeafForDeclaration(activityDeclaration);
	}

	public IActivityGraph getActivityGraph() {
		return _activityGraph;
	}

	public void setComposedActivity(IActivityGraph composedActivity) {
		_activityGraph = composedActivity;
	}

	public void remove() {
		// fieldComposedActivity.remove();

		super.remove();
	}

	public void init(IObjectCreateFunctionArgs objectCreateFunctionArgs) throws ModelCompilingException {
		getActivityGraph().init(objectCreateFunctionArgs);
	}
}
