package de.uniwue.ki.mas.behaviour.reasoning;
import de.uniwue.ki.mas.behaviour.activityGraphDeclaration.ActivityGraphDeclarationFactory;
import de.uniwue.ki.mas.behaviour.activityGraphDeclaration.IActivityGraphDeclaration;
import de.uniwue.ki.mas.util.declaration.AbstractDeclarationFactory;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: (04.09.2001 16:05:27)
 * @author Christoph Oechslein
 */

public final class ActivityReasoningEngineDeclarationFactory extends AbstractDeclarationFactory {
	
	private static final ActivityReasoningEngineDeclarationFactory _instance =
		new ActivityReasoningEngineDeclarationFactory();

	private ActivityReasoningEngineDeclarationFactory() {
		super();
	}

	public static final IReasoningEngineDeclaration createActivityReasoningEngineDeclaration() {
		
		IActivityGraphDeclaration rootComposedActivityDeclaration =
			ActivityGraphDeclarationFactory.createActivityGraphDeclaration();
			
		rootComposedActivityDeclaration.setShortDescription("Reasoning");

		return createActivityReasoningEngineDeclaration(rootComposedActivityDeclaration);
	}

	public static final IActivityReasoningEngineDeclaration createActivityReasoningEngineDeclaration(IActivityGraphDeclaration rootComposedActivityDeclaration) {
		return new ActivityReasoningEngineDeclaration(rootComposedActivityDeclaration);
	}

	public IDeclaration createDeclaration() {
		return createActivityReasoningEngineDeclaration();
	}

	
	public static final ActivityReasoningEngineDeclarationFactory getInstance() {
		return _instance;
	}
}