package de.uniwue.ki.mas.behaviour.reasoning;

import de.uniwue.ki.mas.behaviour.activityGraph.IActivityGraphLeaf;

/**
 * @author oechslein
 */
public interface IActivityReasoningEngineResult extends IReasoningEngineResult {
	/**
	 * Returns the next atomic activity, the current activity must have ended.
	 *
	 * @see #hasCurrentActivityGraphLeafEnded()
	 * @see #setNextActivityGraphLeaf(IActivityGraphLeaf)
	 */
	IActivityGraphLeaf getNextActivityGraphLeaf();

	/**
	 * Returns <code>true</code> if current atomic activity has ended,
	 * for example due to an emergency or a chain rule.
	 *
	 * @see #getNextActivityGraphLeaf()
	 * @see #setCurrentActivityGraphLeafHasEnded(boolean)
	 */
	boolean hasCurrentActivityGraphLeafEnded();

}
