package de.uniwue.ki.mas.behaviour.reasoning;

import de.uniwue.ki.mas.entity.object.IObjectCreateFunctionArgs;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.mas.model.SimulationRuntimeException;
import de.uniwue.ki.util.IRemoveable;
import de.uniwue.ki.util.copy.ICopyable;

/**
 * Agents reason with this engine.
 */
public interface IReasoningEngine extends ICopyable, IRemoveable, java.io.Serializable {

	IReasoningEngineResult calculateReasoningEngineResult(IReasoningEngineCalculationArgs reasoningEngineCalculationArgs)
		throws SimulationRuntimeException;

	IReasoningEngineDeclaration getDeclaration();

	void init(IObjectCreateFunctionArgs objectCreateFunctionArgs) throws ModelCompilingException;
}