package de.uniwue.ki.mas.behaviour.reasoning;

import de.uniwue.ki.mas.entity.object.IObjectCreateFunctionArgs;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.mas.util.declaration.IDeclaration;
/**
 * A reasoning engine declaration can generate {@link IReasoningEngine IReasoningEngines}
 * which can reason und calculate next actions.
 *
 * @author Christoph Oechslein
 */

public interface IReasoningEngineDeclaration extends IDeclaration {

	/**
	 * Compiles new reasoning engine in the given compilation environment.
	 */

	IReasoningEngine createReasoningEngine(IObjectCreateFunctionArgs objectCreateFunctionArgs)
		throws ModelCompilingException;
}
