package de.uniwue.ki.mas.behaviour.rule;

import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.basics.function.iterator.EmptyIteratorSimulationRuntimeException;
import de.uniwue.ki.mas.behaviour.activityGraph.IActivityGraphLeaf;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (18.12.2001 15:21:00)
 * @author Christoph Oechslein
 */

class ActivityGraphConditionRule extends ActivityGraphTrueRule {
	private final IFunction _conditionFunction;

	public ActivityGraphConditionRule(IFunction conditionFunction, IActivityGraphLeaf activity) {
		super(activity);
		_conditionFunction = conditionFunction;
	}

	public boolean isExecuteable(IExecuteFunctionArgs executeFunctionArgs)
		throws SimulationRuntimeException {

		try {
			return _conditionFunction.executeForBoolean(executeFunctionArgs);

		} catch (EmptyIteratorSimulationRuntimeException e) {
			return false;
		}
	}

	public String getName() {
		return _conditionFunction.getName() + " " + super.getName();
	}

	public final boolean isAlwaysExecuteable() {
		return false;
	}
}