package de.uniwue.ki.mas.behaviour.rule;

import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.behaviour.activityGraph.IActivityGraphLeaf;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (18.12.2001 15:21:00)
 * @author Christoph Oechslein
 */

class ActivityGraphTrueRule extends AbstractActivityGrapRule {
	private final IActivityGraphLeaf _activityGraphLeaf;

	public ActivityGraphTrueRule(IActivityGraphLeaf activityGraphLeaf) {
		super();
		_activityGraphLeaf = activityGraphLeaf;
	}

	public final IActivityGraphLeaf getActivityGraphLeaf() {
		return _activityGraphLeaf;
	}

	public boolean isExecuteable(IExecuteFunctionArgs executeFunctionArgs)
		throws SimulationRuntimeException {
		return true;
	}

	public String getName() {
		return "-> " + _activityGraphLeaf.getName();
	}

	public boolean isAlwaysExecuteable() {
		return true;
	}
}
