package de.uniwue.ki.mas.behaviour.rule;
import de.uniwue.ki.mas.model.ModelCompilingException;

/**
 * Creation date: (06.09.2001 21:53:49)
 * @author Christoph Oechslein
 */

public class ActivityRuleDeclarationCompilingException extends ModelCompilingException {
    private final IActivityGraphRuleDeclaration _activityRuleDeclaration;

    public ActivityRuleDeclarationCompilingException(IActivityGraphRuleDeclaration activityRuleDeclaration, Exception nestedException) {
        super(nestedException);

        _activityRuleDeclaration = activityRuleDeclaration;
    }

    public ActivityRuleDeclarationCompilingException(IActivityGraphRuleDeclaration activityRuleDeclaration, String s) {
        super(s);

        _activityRuleDeclaration = activityRuleDeclaration;
    }

    public final IActivityGraphRuleDeclaration getActivityRuleDeclaration() {
        return _activityRuleDeclaration;
    }

    public String toString() {
        return "In rule: '" + getActivityRuleDeclaration().getName() + "'\n" + super.toString();
    }
}