/**
 * Created on 11.02.2003
 *
 * This class is responsible for //insert purpose here//
 * 
 * @author glueckselig
 */
package de.uniwue.ki.mas.behaviour.rule;

import mygale.mcge.net.INetEdge;
import de.uniwue.ki.mas.util.declaration.AbstractDeclarationFactory;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

public class DocumentEdgeDeclerationFactory
	extends AbstractDeclarationFactory
	implements IActivityGraphEdgeDeclarationFactory {

	private static final DocumentEdgeDeclerationFactory _instance = new DocumentEdgeDeclerationFactory();

	private DocumentEdgeDeclerationFactory() {
		super();
	}

	public final IActivityGraphEdgeDeclaration createActivityGraphEdgeDeclaration() {
		return new DocumentGraphEdgeDeclaration();
	}

	public final IDeclaration createDeclaration() {
		return createActivityGraphEdgeDeclaration();
	}

	public final INetEdge createNetEdge() {
		return createActivityGraphEdgeDeclaration();
	}

	public static final DocumentEdgeDeclerationFactory getInstance() {
		return _instance;
	}

}
