package de.uniwue.ki.mas.behaviour.rule;
import mygale.mcge.net.INetEdge;
import de.uniwue.ki.mas.behaviour.activityGraphDeclaration.IActivityGraphNodeDeclaration;
import de.uniwue.ki.mas.behaviour.activityGraphDeclaration.IDeclarationNetEdge;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Enhance <code>IRuleDeclaration</code> by having a from and a to part,
 * it's therefore a conditial edge between to {@link IActivityGraphNodeDeclaration IActivityDeclarations}
 *
 * Creation date: (08.11.2000 18:11:37)
 * @author Christoph Oechslein
 */

public interface IActivityGraphEdgeDeclaration extends IDeclarationNetEdge {
	/**
	 * Returns the from <code>IActivityGraphNodeDeclaration</code>.
	 */
	IActivityGraphNodeDeclaration getFromActivityGraphNodeDeclaration();

	/**
	 * Returns the to <code>IActivityGraphNodeDeclaration</code>.
	 */
	IActivityGraphNodeDeclaration getToActivityGraphNodeDeclaration();

	/**
	 * Only set from activity and don't add to port, this had to be done by calling setBeginPort(fromActivityDeclaration.getChainRulePort());
	 */
	void setFromActivityGraphNodeDeclaration(IActivityGraphNodeDeclaration activityDeclaration);

	/**
	 * Only set to activity and don't add to port, this had to be done by calling setEndPort(toActivityDeclaration.getChainRulePort());
	 */
	void setToActivityGraphNodeDeclaration(IActivityGraphNodeDeclaration activityDeclaration);
}