package de.uniwue.ki.mas.behaviour.rule;
import de.uniwue.ki.mas.basics.function.ICreateFunctionArgs;
import de.uniwue.ki.mas.basics.functionCall.IFunctionCallDeclaration;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.mas.util.declaration.IDocumentableDeclaration;
import de.uniwue.ki.util.hash.IIsomorphicHashable;

/**
 * Enhance <code>IRuleDeclaration</code> by having a from and a to part,
 * it's therefore a conditional edge between two {@link IActivityGraphNodeDeclaration IActivityDeclarations}
 *
 * Creation date: (08.11.2000 18:11:37)
 * @author Christoph Oechslein
 */

public interface IActivityGraphRuleDeclaration
	extends IActivityGraphTransitionEdgeDeclaration, IDocumentableDeclaration, IIsomorphicHashable {

	IRule createRule(ICreateFunctionArgs createFunctionArgs) throws ModelCompilingException;

	/**
	 * Returns the precondition function declaration.
	 */
	IFunctionCallDeclaration getConditionFunctionCallDeclaration();
}