package de.uniwue.ki.mas.behaviour.rule;
import java.io.Serializable;

import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.model.SimulationRuntimeException;
import de.uniwue.ki.util.name.INamed;

/**
 * A rule can be asked if it is executable under certain execute bindings. 
 * Creation date: (05.12.2000 15:02:05)
 *
 * @author Christoph Oechslein
 */

public interface IRule extends INamed, Serializable {

	/**
	 * Tests if rule is executeable under the given execute bindings.
	 */
	boolean isExecuteable(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException;

	/**
	 * Retruns true if isExecuteable returns true under all execute bindings
	 */
	boolean isAlwaysExecuteable();
}