package de.uniwue.ki.mas.behaviour.rule;
import mygale.mcge.net.INetEdge;
import de.uniwue.ki.mas.util.declaration.AbstractDeclarationFactory;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: (04.09.2001 16:05:27)
 * @author Christoph Oechslein
 */

public final class OtherwiseActivityEdgeDeclarationFactory
	extends AbstractDeclarationFactory
	implements IActivityGraphEdgeDeclarationFactory {
	private static final OtherwiseActivityEdgeDeclarationFactory _instance =
		new OtherwiseActivityEdgeDeclarationFactory();

	private OtherwiseActivityEdgeDeclarationFactory() {
		super();
	}

	public final IActivityGraphEdgeDeclaration createActivityGraphEdgeDeclaration() {
		return new OtherwiseActivityGraphEdgeDeclaration();
	}

	public final IDeclaration createDeclaration() {
		return createActivityGraphEdgeDeclaration();
	}

	public final INetEdge createNetEdge() {
		return createActivityGraphEdgeDeclaration();
	}

	public static final OtherwiseActivityEdgeDeclarationFactory getInstance() {
		return _instance;
	}
}