package de.uniwue.ki.mas.entity.body;

import de.uniwue.ki.mas.entity.variableclass.IBodyVariableClassDeclaration;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

public class BodyVariableNotAvailibleException extends SimulationRuntimeException {
	private final IBodyVariableClassDeclaration bodyVariableClassDeclaration;
	private final IBody body;

	public BodyVariableNotAvailibleException(
		IBodyVariableClassDeclaration bodyVariableClassDeclaration,
		IBody body) {
		super();

		this.bodyVariableClassDeclaration = bodyVariableClassDeclaration;
		this.body = body;
	}

	public BodyVariableNotAvailibleException(
		String s,
		IBodyVariableClassDeclaration bodyVariableClassDeclaration,
		IBody body) {
		super(s);
		this.bodyVariableClassDeclaration = bodyVariableClassDeclaration;
		this.body = body;
	}

	public String getMessage() {
		return "Variable " + bodyVariableClassDeclaration + " not available in " + body + super.getMessage();
	}
}