package de.uniwue.ki.mas.entity.body;

import de.uniwue.ki.mas.entity.variable.IBodyVariable;
import de.uniwue.ki.mas.entity.variable.IBodyVariableInstanceDeclaration;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: 04.10.2002, 16:01:07
 * @author oechslein
 */
public class BodyVariableNotInitialized extends SimulationRuntimeException {

	public BodyVariableNotInitialized() {
		super();
	}

	public BodyVariableNotInitialized(Throwable nestedException) {
		super(nestedException);
	}

	public BodyVariableNotInitialized(String s) {
		super(s);
	}

	public BodyVariableNotInitialized(IBody body, int index) {
		this(body, body.getBodyVariableAt(index));
	}

	public BodyVariableNotInitialized(IBody body, IBodyVariable bodyVariable) {
		this(body, body.getBodyVariableInstanceDeclarationFor(bodyVariable));
	}

	public BodyVariableNotInitialized(
		IBody body,
		IBodyVariableInstanceDeclaration bodyVariableInstanceDeclaration) {
		this(
			"Trying to access uninitialized variable '"
				+ bodyVariableInstanceDeclaration.getName()
				+ "' in Body '"
				+ body.getName()
				+ "'. This is normally caused by an incorrect default value "
				+ "from an other body variable.");
	}
}
