package de.uniwue.ki.mas.entity.body;

import de.uniwue.ki.mas.entity.bodyclass.IBodyClassDeclaration;
import de.uniwue.ki.mas.entity.object.IObjectCreateFunctionArgs;
import de.uniwue.ki.mas.entity.variable.BodyVariableInstanceDeclarationList;
import de.uniwue.ki.mas.entity.variable.IBodyVariableInstanceDeclaration;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.mas.util.declaration.IDeclaration;
/**
 * A Body instance declaration is an instance of a {@link IBodyClassDeclaration}.
 * Creation date: (31.10.2000 18:11:26)
 *
 * @author Christoph Oechslein
 */

public interface IBodyInstanceDeclaration extends IDeclaration {

	/**
	 * Compiles runtime body object under the given compilation bindings.
	 */

	IBody createBody(IObjectCreateFunctionArgs objectCreateFunctionArgs) throws ModelCompilingException;

	/**
	 * Returns body class declaration, which generated this.
	 */

	IBodyClassDeclaration getBodyClassDeclaration();

	/**
	 * Returns list of {@link IBodyVariableInstanceDeclaration body variable instance declarations}
	 */

	BodyVariableInstanceDeclarationList getBodyVariableInstanceDeclarationList();
}
