package de.uniwue.ki.mas.entity.bodyclass;
import de.uniwue.ki.mas.entity.variable.VariableCompileException;
import de.uniwue.ki.mas.entity.variableclass.*;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * A Body class declaration consists of {@link IBodyVariableClassDeclaration body variable class declarations}.
 * Creation date: (19.10.2000 12:56:39)
 *
 * @author Christoph Oechslein
 */

public interface IBodyClassDeclaration extends IDeclaration {

	BodyVariableClassDeclarationListAndFactory getBodyVariableClassDeclarationListAndFactory();

	IBodyVariableClassDeclaration getBodyVariableClassDeclaration(IVariableClassDeclaration variableClassDeclaration)
		throws VariableCompileException;

	/**
	  * Returns the index of the corresponding @see IBodyVariable, used in <code>getBodyVariableAt</code>.
	  */
	int getBodyVariableIndexOf(IBodyVariableClassDeclaration bodyVariableClassDeclaration)
		throws ModelCompilingException;

	/**
	  * Returns the index of the corresponding @see IBodyVariable, used in <code>getBodyVariableAt</code>.
	  */
	int getBodyVariableIndexOf(IVariableClassDeclaration variableClassDeclaration)
		throws ModelCompilingException;
}