package de.uniwue.ki.mas.entity.object;

import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.entity.variable.IBodyVariable;
import de.uniwue.ki.mas.sim.listener.IObjectsListener;
import de.uniwue.ki.mas.sim.listener.IObjectsVariableListener;
/**
* Object executing binding.
* Creation date: (06.12.2000 15:36:44)
*
* @author Christoph Oechslein
*/
public interface IObjectExecuteFunctionArgs extends IExecuteFunctionArgs {

	/**
	 * Returns simulation runtime object of this execution environment.
	 *
	 * @see #setObject(IObject)
	 */

	IObject getObject();

	/**
	 * Sets the simulation runtime object of this execution environment.
	 *
	 * @see #getObject()
	 */
	void setObject(IObject newSimObject);

	void fireStartsUpdate(IObject object);

	void fireFinishedUpdate(IObject object);

	void fireVariableValueChanged(
		IObject inObject,
		IObject settingAgent,
		IBodyVariable bodyVariable,
		Object oldValue,
		Object newValue);

	void addObjectsListener(IObjectsListener objectsListener);
	void removeObjectsListener(IObjectsListener objectsListener);
	boolean hasObjectsListener();

	void addObjectsVariableListener(IObjectsVariableListener objectsListener);

	void removeObjectsVariableListener(IObjectsVariableListener objectsListener);

	boolean hasObjectsVariableListener();

}
