package de.uniwue.ki.mas.entity.object;
import de.uniwue.ki.mas.basics.featureList.ObjectFeatureInstanceDeclarationList;
import de.uniwue.ki.mas.entity.body.IBodyInstanceDeclaration;
import de.uniwue.ki.mas.entity.objectclass.IObjectClassDeclaration;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.mas.util.declaration.IDocumentableDeclaration;
/**
* An <code>IObjectInstanceDeclaration</code> is an instance of an {@link IObjectClassDeclaration}.
* Creation date: (30.10.2000 10:40:41)
*
* @author Christoph Oechslein
*/
public interface IObjectInstanceDeclaration extends IDocumentableDeclaration {
	/**
	 * Creates new <code>IObject</code> under the given compilation bindings.
	 * The Body is not going to be compiled
	 */
	IObject createObject(IObjectCreateFunctionArgs objectCreateFunctionArgs)
		throws ModelCompilingException;

	/**
	 * Returns declaration of the body of this object instance declaration.
	 */
	IBodyInstanceDeclaration getBodyInstanceDeclaration();

	/**
	 * Returns 'class' declaration of this instance declaration, which created this object.
	 */
	IObjectClassDeclaration getObjectClassDeclaration();

	/**
	 * Returns declaration of the features of this object instance declaration.
	 */
	ObjectFeatureInstanceDeclarationList getObjectFeatureInstanceDeclarationList();
}