package de.uniwue.ki.mas.entity.object;

import java.util.HashMap;
import java.util.Map;

import de.uniwue.ki.mas.entity.objectclass.IObjectClassDeclaration;

/**
 * Creation date: 15.10.2002, 15:08:24
 * @author oechslein
 */
final class ObjectIdHelper {
	public static int getNextId(
		IObjectInstanceDeclaration objectInstanceDeclaration,
		IObjectCreateFunctionArgs objectCreateFunctionArgs) {

		return getNextId(objectInstanceDeclaration.getObjectClassDeclaration(), objectCreateFunctionArgs);
	}

	public static int getNextId(
		IObjectClassDeclaration objectClassDeclaration,
		IObjectCreateFunctionArgs objectCreateFunctionArgs) {
			
		int currId = getCurrId(objectClassDeclaration, objectCreateFunctionArgs);
		
		getIdMap(objectCreateFunctionArgs).put(objectClassDeclaration, new Integer(currId + 1));
		
		return currId + 1;
	}

	public static int getCurrId(
		IObjectClassDeclaration objectClassDeclaration,
		IObjectCreateFunctionArgs objectCreateFunctionArgs) {

		Integer maxIdInteger = (Integer) getIdMap(objectCreateFunctionArgs).get(objectClassDeclaration);

		if (maxIdInteger == null) {
			return -1;
		} else {
			return maxIdInteger.intValue();
		}
	}

	public static Map getIdMap(IObjectCreateFunctionArgs objectCreateFunctionArgs) {
		if (objectCreateFunctionArgs.existsCompilationObject(ObjectIdHelper.class, false)) {
			return (Map) objectCreateFunctionArgs.getCompilationObject(ObjectIdHelper.class, false);

		} else {
			Map newMap = new HashMap();
			objectCreateFunctionArgs.addCompilationObject(ObjectIdHelper.class, newMap, false);
			return newMap;
		}
	}
}
