package de.uniwue.ki.mas.entity.object;

import de.uniwue.ki.mas.entity.objectclass.IRessourceClassDeclaration;
import de.uniwue.ki.mas.util.declaration.AbstractDeclarationFactory;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: (04.09.2001 16:05:27)
 * @author Christoph Oechslein
 */

public final class RessourceInstanceDeclarationFactory
	extends AbstractDeclarationFactory
	implements IRessourceInstanceDeclarationFactory {
	private final IRessourceClassDeclaration _ressourceClassDeclaration;

	public RessourceInstanceDeclarationFactory(IRessourceClassDeclaration ressourceClassDeclaration) {
		super();

		_ressourceClassDeclaration = ressourceClassDeclaration;
	}

	public static IRessourceInstanceDeclaration createRessourceInstanceDeclaration(IRessourceClassDeclaration ressourceClassDeclaration) {
		return new RessourceInstanceDeclaration(ressourceClassDeclaration);
	}

	public IRessourceInstanceDeclaration createRessourceInstanceDeclaration() {
		return createRessourceInstanceDeclaration(getRessourceClassDeclaration());
	}
	public IDeclaration createDeclaration() {
		return createRessourceInstanceDeclaration();
	}

	public IObjectInstanceDeclaration createObjectInstanceDeclaration() {
		return createRessourceInstanceDeclaration();
	}

	protected IRessourceClassDeclaration getRessourceClassDeclaration() {
		return _ressourceClassDeclaration;
	}
}