package de.uniwue.ki.mas.entity.object.agent;
import de.uniwue.ki.mas.entity.object.*;
import de.uniwue.ki.mas.entity.objectclass.agentclass.IActivityAgentClassDeclaration;
import de.uniwue.ki.mas.entity.objectclass.agentclass.IAgentClassDeclaration;
import de.uniwue.ki.mas.model.ModelCompilingException;

/**
 * Creation date: (08.01.2002 15:26:49)
 * @author Christoph Oechslein
 */

public abstract class AbstractActivityAgentInstanceDeclaration
	extends AbstractObjectInstanceDeclaration
	implements IActivityAgentInstanceDeclaration {

	public AbstractActivityAgentInstanceDeclaration(IActivityAgentClassDeclaration objectClassDeclaration) {
		super(objectClassDeclaration);
	}

	public IObject createObject(IObjectCreateFunctionArgs objectCreateFunctionArgs)
		throws ModelCompilingException {
		return new ActivityAgent(this, objectCreateFunctionArgs);
	}

	public IActivityAgentClassDeclaration getActivityAgentClassDeclaration() {
		return (IActivityAgentClassDeclaration) getAgentClassDeclaration();
	}

	public IAgentClassDeclaration getAgentClassDeclaration() {
		return (IAgentClassDeclaration) getObjectClassDeclaration();
	}
}