package de.uniwue.ki.mas.entity.object.agent;
import de.uniwue.ki.mas.entity.object.IObjectInstanceDeclaration;
import de.uniwue.ki.mas.entity.objectclass.agentclass.IActivityAgentClassDeclaration;
import de.uniwue.ki.mas.util.declaration.AbstractDeclarationFactory;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: (04.09.2001 16:05:27)
 * @author Christoph Oechslein
 */

public class ActivityAgentInstanceDeclarationFactory extends AbstractDeclarationFactory implements
	IAgentInstanceDeclarationFactory {
		private final IActivityAgentClassDeclaration activityAgentClassDeclaration;

/**
 * ActivityWorldInstanceDeclarationFactory constructor comment.
 */
public ActivityAgentInstanceDeclarationFactory(IActivityAgentClassDeclaration activityAgentClassDeclaration) {
    super();
    this.activityAgentClassDeclaration = activityAgentClassDeclaration;
}


/**
 * @return IActivityAgentInstanceDeclaration
 */
public IActivityAgentInstanceDeclaration createActivityAgentInstanceDeclaration() {
   return createActivityAgentInstanceDeclaration(getActivityAgentClassDeclaration());
}


/**
 * @param activityAgentInstanceDeclaration IActivityAgentClassDeclaration
 * @return IActivityAgentInstanceDeclaration
 * @see de.uniwue.ki.mas.model.util.declaration.IDeclarationFactory
 */
public static IActivityAgentInstanceDeclaration createActivityAgentInstanceDeclaration(IActivityAgentClassDeclaration activityAgentInstanceDeclaration) {
   return new ActivityAgentInstanceDeclaration(activityAgentInstanceDeclaration);
}


public final IAgentInstanceDeclaration createAgentInstanceDeclaration() {
    return createActivityAgentInstanceDeclaration();
}


/**
 * @return IDeclaration
 * @see de.uniwue.ki.mas.util.declaration.IDeclarationFactory#createDeclaration()
 */
public final IDeclaration createDeclaration() {
   return createActivityAgentInstanceDeclaration();
}


public final IObjectInstanceDeclaration createObjectInstanceDeclaration() {
    return createAgentInstanceDeclaration();
}


protected IActivityAgentClassDeclaration getActivityAgentClassDeclaration() {
    return activityAgentClassDeclaration;
}
}