package de.uniwue.ki.mas.entity.object.agent;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.behaviour.reasoning.IReasoningEngine;
import de.uniwue.ki.mas.entity.object.IObject;

/**
  * An agent enhance an {@link IObject} by adding a sensing and reasoning capability.
  * Creation date: (13.11.2000 10:42:56)
  *
  * @author Christoph Oechslein
  */

public interface IAgent extends IObject {
	/**
	 * Returns the current action of this agent.
	 */
	IFunction getCurrentAction();

	/**
	 * Set the current action of this agent.
	 */
	void setCurrentAction(IFunction action);

	/**
	 * Returns count of reasoning engines.
	 */
	int getReasoningEngineCount();

	/**
	 * Returns reasoning engine at index.
	 */
	IReasoningEngine getReasoningEngineAt(int index);
}