package de.uniwue.ki.mas.entity.object.world;
import de.uniwue.ki.mas.entity.object.agent.ActivityAgentInstanceDeclarationFactory;
import de.uniwue.ki.mas.entity.object.agent.IActivityAgentInstanceDeclaration;
import de.uniwue.ki.mas.entity.objectclass.agentclass.IActivityWorldClassDeclaration;

/**
 * Creation date: (04.09.2001 16:05:27)
 * @author Christoph Oechslein
 */

public final class ActivityWorldInstanceDeclarationFactory extends ActivityAgentInstanceDeclarationFactory  implements
	IWorldInstanceDeclarationFactory {
/**
 * @param activityWorldClassDeclaration IActivityWorldClassDeclaration
 */
public ActivityWorldInstanceDeclarationFactory(IActivityWorldClassDeclaration activityWorldClassDeclaration) {
    super(activityWorldClassDeclaration);
}


public final IActivityAgentInstanceDeclaration createActivityAgentInstanceDeclaration() {
   return createActivityWorldInstanceDeclaration ();
}


/**
 * @return IActivityWorldInstanceDeclaration
 */
public IActivityWorldInstanceDeclaration createActivityWorldInstanceDeclaration() {
   return createActivityWorldInstanceDeclaration(getActivityWorldClassDeclaration());
}


public static IActivityWorldInstanceDeclaration createActivityWorldInstanceDeclaration(IActivityWorldClassDeclaration activityWorldInstanceDeclaration) {
   return new ActivityWorldInstanceDeclaration(activityWorldInstanceDeclaration);
}


public final IWorldInstanceDeclaration createWorldInstanceDeclaration() {
    return createActivityWorldInstanceDeclaration();
}


protected final IActivityWorldClassDeclaration getActivityWorldClassDeclaration() {
    return (IActivityWorldClassDeclaration ) getActivityAgentClassDeclaration();
}
}