package de.uniwue.ki.mas.entity.object.world;
import java.util.EventObject;

import de.uniwue.ki.mas.entity.object.IObject;

/**
 * Creation date: (20.02.2002 15:54:25)
 * @author Christoph Oechslein
 */

public class WorldEvent extends EventObject {
    private final IObject _object;
    private final IObject _activeObject;

    /**
     * @param source IWorld
     * @param activeObject IObject
     * @param object IObject
     */
    public WorldEvent(IWorld source, IObject activeObject, IObject object) {
        super(source);

        _object = object;
        _activeObject = activeObject;
    }

    public final IObject getObject() {
        return _object;
    }

/**
 * @return IObject
 */
public final IObject getActiveObject() {
    return _activeObject;
}


public final IWorld getWorld() {
    return (IWorld) getSource();
}
}