package de.uniwue.ki.mas.entity.object.world;

import java.awt.AWTEventMulticaster;
import java.util.EventListener;
/**
 * Creation date: 04.09.2002, 18:40:20
 * @author oechslein
 */
public class WorldEventMulticaster extends AWTEventMulticaster implements WorldListener {

	public static WorldListener add(WorldListener a, WorldListener b) {
		return (WorldListener)addInternal(a, b);
	}

	public static WorldListener remove(WorldListener l, WorldListener oldl) {
		if (l == oldl || l == null) {
			return null;
		}
		if (l instanceof WorldEventMulticaster) {
			return (WorldListener) ((WorldEventMulticaster)l).remove(oldl);
		}
		return l;
	}

	public void addedObject(WorldEvent event) {
		((WorldListener)a).addedObject(event);
		((WorldListener)b).addedObject(event);
	}

	public void removedObject(WorldEvent event) {
		((WorldListener)a).removedObject(event);
		((WorldListener)b).removedObject(event);
	}

	protected WorldEventMulticaster(EventListener a, EventListener b) {
		super(a, b);
	}

	protected static EventListener addInternal(EventListener a, EventListener b) {
		if (a == null) {
			return b;
		}
		if (b == null) {
			return a;
		}
		return new WorldEventMulticaster(a, b);
	}

	protected EventListener remove(WorldListener oldl) {
		if (oldl == a) {
			return b;
		}
		if (oldl == b) {
			return a;
		}
		EventListener a2 = removeInternal(a, oldl);
		EventListener b2 = removeInternal(b, oldl);
		if (a2 == a && b2 == b) {
			return this;
		}
		return addInternal(a2, b2);
	}
}
