package de.uniwue.ki.mas.entity.objectclass;

import de.uniwue.ki.mas.basics.feature.IFeatureClassDeclaration;
import de.uniwue.ki.mas.basics.featureList.IObjectFeatureClassDeclarationList;
import de.uniwue.ki.mas.entity.bodyclass.IBodyClassDeclaration;
import de.uniwue.ki.mas.entity.object.IObjectInstanceDeclaration;
import de.uniwue.ki.mas.util.declaration.IDocumentableDeclaration;

/**
 * An <code>IObjectClassDeclaration</code> generates {@link IObjectInstanceDeclaration} and
 * has a body class declaration.
 * <BR>Creation date: (31.03.00 13:41:59)
 *
 * @author Christoph Oechslein
 */

public interface IObjectClassDeclaration extends IDocumentableDeclaration {
	/**
	 * Compiles a new <code>IObjectInstanceDeclaration</code> object.
	 */
	IObjectInstanceDeclaration createObjectInstanceDeclaration();

	/**
	 * Returns the declaration of the body class.
	 */
	IBodyClassDeclaration getBodyClassDeclaration();

	/**
	 * Returns the {@link IFeatureClassDeclaration feature class declarations}
	 * of the object.
	 */
	IObjectFeatureClassDeclarationList getObjectFeatureClassDeclarationList();
	
	/*public IObjectFeatureClassDeclaration getFeatureClassDeclarationByName(
            String name);*/
}