package de.uniwue.ki.mas.entity.objectclass;
import de.uniwue.ki.mas.entity.object.IObjectInstanceDeclaration;
import de.uniwue.ki.mas.entity.object.IObjectInstanceDeclarationFactory;
import de.uniwue.ki.mas.util.declaration.IDeclarationFactory;

/**
 * Creates new <code>IObjectClassDeclaration</code> objects and
 * can create a factory for {@link IObjectInstanceDeclaration} objects.
 * Creation date: (02.11.2000 18:58:29)
 * @author Christoph Oechslein
 */

public interface IObjectClassDeclarationFactory extends IDeclarationFactory {

   /**
    * Creates new <code>IObjectClassDeclaration</code> object.
    *
    * @directed
    * @label creates
    */

   /*#IObjectClassDeclaration lnkIObjectClassDeclaration;*/

   IObjectClassDeclaration createObjectClassDeclaration();

   /**
    * Creates a new factory for <code>IObjectInstanceDeclaration</code> objects.
    *
    * @directed
    * @label creates
    */

   /*#IObjectInstanceDeclarationFactory lnkIObjectInstanceDeclarationFactory;*/

   IObjectInstanceDeclarationFactory createObjectInstanceDeclarationFactory();
}