package de.uniwue.ki.mas.entity.objectclass;

import de.uniwue.ki.mas.entity.object.IRessourceInstanceDeclaration;
import de.uniwue.ki.mas.entity.object.IRessourceInstanceDeclarationFactory;

/**
 * Creates new <code>IRessourceClassDeclaration</code> objects and
 * can create a factory for {@link IRessourceInstanceDeclaration} objects.
 * Creation date: (02.11.2000 18:58:29)
 * @author Christoph Oechslein
 */

public interface IRessourceClassDeclarationFactory extends IObjectClassDeclarationFactory {

    /**
     * Creates new <code>IRessourceClassDeclaration</code> object.
     *
     * @directed
     * @label creates
     */

    /*#IRessourceClassDeclaration lnkIRessourceClassDeclaration;*/

    IRessourceClassDeclaration createRessourceClassDeclaration();
    /**
     * Creates a new factory for <code>IRessourceInstanceDeclaration</code> objects.
     *
     * @directed
     * @label creates
     */

    /*#IRessourceInstanceDeclarationFactory lnkIRessourceInstanceDeclarationFactory;*/

    IRessourceInstanceDeclarationFactory createRessourceInstanceDeclarationFactory();
}