package de.uniwue.ki.mas.entity.objectclass.agentclass;
import java.util.Map;

import junit.framework.Assert;
import de.uniwue.ki.mas.behaviour.reasoning.*;
import de.uniwue.ki.mas.entity.bodyclass.BodyClassDeclarationFactory;
import de.uniwue.ki.mas.entity.object.IObjectInstanceDeclaration;
import de.uniwue.ki.mas.entity.object.agent.*;
import de.uniwue.ki.util.copy.ICopyable;

/**
 * Creation date: (20.03.2002 10:36:09)
 * @author Christoph Oechslein
 */

public class ActivityAgentClassDeclaration
	extends AbstractAgentClassDeclaration
	implements IActivityAgentClassDeclaration {

	public ActivityAgentClassDeclaration() {
		super(
			BodyClassDeclarationFactory.createBodyClassDeclaration(),
			new ReasoningEngineDeclarationListAndFactory(
				new ReasoningEngineDeclarationList(),
				ActivityReasoningEngineDeclarationFactory.getInstance()));

		getReasoningEngineDeclarationListAndFactory().getFirstDeclarationOrCreateNewIfEmpty();
	}

	public IActivityAgentInstanceDeclaration createActivityAgentInstanceDeclaration() {
		return ActivityAgentInstanceDeclarationFactory.createActivityAgentInstanceDeclaration(this);
	}

	public IAgentInstanceDeclaration createAgentInstanceDeclaration() {
		return createActivityAgentInstanceDeclaration();
	}

	protected ICopyable createInstance(Map objectMapping) {
		if (Assert.ASSERTION_ON)
			Assert.assertEquals(getClass(), ActivityAgentClassDeclaration.class);

		return new ActivityAgentClassDeclaration();
	}

	public IObjectInstanceDeclaration createObjectInstanceDeclaration() {
		return createAgentInstanceDeclaration();
	}


}