package de.uniwue.ki.mas.entity.objectclass.agentclass;
import de.uniwue.ki.mas.entity.object.IObjectInstanceDeclarationFactory;
import de.uniwue.ki.mas.entity.object.agent.ActivityAgentInstanceDeclarationFactory;
import de.uniwue.ki.mas.entity.object.agent.IAgentInstanceDeclarationFactory;
import de.uniwue.ki.mas.entity.objectclass.IObjectClassDeclaration;
import de.uniwue.ki.mas.util.declaration.AbstractDeclarationFactory;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: (04.09.2001 16:05:27)
 * @author Christoph Oechslein
 */

public class ActivityAgentClassDeclarationFactory extends AbstractDeclarationFactory implements IAgentClassDeclarationFactory {
	private IAgentClassDeclarationListAndFactory _agentClassDeclarationListAndFactory;

public ActivityAgentClassDeclarationFactory() {
    super();
}


public static final IActivityAgentClassDeclaration createActivityAgentClassDeclaration() {
    return new ActivityAgentClassDeclaration();
}


public IAgentClassDeclaration createAgentClassDeclaration() {
    return createActivityAgentClassDeclaration();
}


public IAgentInstanceDeclarationFactory createAgentInstanceDeclarationFactory() {
   return new ActivityAgentInstanceDeclarationFactory((IActivityAgentClassDeclaration) getAgentClassDeclarationListAndFactory().getFirstDeclarationOrCreateNewIfEmpty());
}


/**
 * @return IDeclaration
 * @see de.uniwue.ki.mas.util.declaration.IDeclarationFactory#createDeclaration()
 */
public final IDeclaration createDeclaration() {
    return createAgentClassDeclaration();
}


/**
 * @return IObjectClassDeclaration
 * @see de.uniwue.ki.mas.entity.objectclass.IObjectClassDeclarationFactory#createObjectClassDeclaration()
 */
public final IObjectClassDeclaration createObjectClassDeclaration() {
   return createAgentClassDeclaration();
}


public IObjectInstanceDeclarationFactory createObjectInstanceDeclarationFactory() {
   return createAgentInstanceDeclarationFactory();
}


public final IAgentClassDeclarationListAndFactory getAgentClassDeclarationListAndFactory() {
	return _agentClassDeclarationListAndFactory;
}


/**
 * @param newAgentClassDeclarationListAndFactory IAgentClassDeclarationListAndFactory
 */
public void setAgentClassDeclarationListAndFactory(IAgentClassDeclarationListAndFactory newAgentClassDeclarationListAndFactory) {
    _agentClassDeclarationListAndFactory = newAgentClassDeclarationListAndFactory;
}
}