package de.uniwue.ki.mas.entity.objectclass.agentclass;

import java.beans.PropertyChangeListener;

import de.uniwue.ki.mas.entity.object.agent.IActivityAgentInstanceDeclaration;

/**
 * An <code>IActivityAgentClassDeclaration</code> generates {@link IActivityAgentInstanceDeclaration}
 * and enhance <code>IAgentClassDeclaration</code> by specialicing type of the reasoning engine.
 * Creation date: (03.08.2000 16:14:49)
 *
 * @author Christoph Oechslein
 */

public interface IActivityAgentClassDeclaration extends IAgentClassDeclaration {

	/**
	 * Adds property change listener.
	 *
	 * @see #removePropertyChangeListener(PropertyChangeListener)
	 */
	void addPropertyChangeListener(PropertyChangeListener listener);

	/**
	 * Creates a new <code>IActivityAgentInstanceDeclaration</code> object.
	 */
	IActivityAgentInstanceDeclaration createActivityAgentInstanceDeclaration();


	/**
	 * Removes property change listener.
	 *
	 * @see #addPropertyChangeListener(PropertyChangeListener)
	 */

	void removePropertyChangeListener(PropertyChangeListener listener);
}
