package de.uniwue.ki.mas.entity.objectclass.agentclass;

import de.uniwue.ki.mas.behaviour.reasoning.ReasoningEngineDeclarationListAndFactory;
import de.uniwue.ki.mas.entity.object.agent.IAgentInstanceDeclaration;
import de.uniwue.ki.mas.entity.objectclass.IObjectClassDeclaration;

/**
 * An <code>IAgentClassDeclaration</code> generates {@link IAgentInstanceDeclaration}
 * and enhance <code>IObjectClassDeclaration</code> by adding a declaration for a
 * reasoning engine.
 * Creation date: (03.08.2000 15:26:22)
 *
 * @author Christoph Oechslein
 */

public interface IAgentClassDeclaration extends IObjectClassDeclaration {

	/**
	 * Compiles new <code>IAgentInstanceDeclaration</code> object.
	 */
	IAgentInstanceDeclaration createAgentInstanceDeclaration();

	ReasoningEngineDeclarationListAndFactory getReasoningEngineDeclarationListAndFactory();

}
