package de.uniwue.ki.mas.entity.objectclass.agentclass;
import de.uniwue.ki.mas.entity.object.agent.IAgentInstanceDeclaration;
import de.uniwue.ki.mas.entity.object.agent.IAgentInstanceDeclarationFactory;
import de.uniwue.ki.mas.entity.objectclass.IObjectClassDeclarationFactory;

/**
 * Creates new <code>IAgentClassDeclaration</code> objects and
 * can create a factory for {@link IAgentInstanceDeclaration} objects.
 * Creation date: (02.11.2000 18:58:29)
 * @author Christoph Oechslein
 */

public interface IAgentClassDeclarationFactory extends IObjectClassDeclarationFactory {

/**
 * Creates new <code>IAgentClassDeclaration</code> object.
 *
 * @directed
 * @label creates
 */

/*#IAgentClassDeclaration lnkIAgentClassDeclaration;*/

IAgentClassDeclaration createAgentClassDeclaration();


/**
 * Creates a new factory for <code>IAgentInstanceDeclaration</code> objects.
 *
 * @directed
 * @label creates
 */

/*#IAgentInstanceDeclarationFactory lnkIAgentInstanceDeclarationFactory;*/

IAgentInstanceDeclarationFactory createAgentInstanceDeclarationFactory();
}