package de.uniwue.ki.mas.entity.objectclass.worldclass;
import de.uniwue.ki.mas.entity.object.IObjectInstanceDeclarationFactory;
import de.uniwue.ki.mas.entity.object.agent.IAgentInstanceDeclarationFactory;
import de.uniwue.ki.mas.entity.object.world.ActivityWorldInstanceDeclarationFactory;
import de.uniwue.ki.mas.entity.object.world.IWorldInstanceDeclarationFactory;
import de.uniwue.ki.mas.entity.objectclass.agentclass.*;

/**
 * Creation date: (04.09.2001 16:05:27)
 * @author Christoph Oechslein
 */

public final class ActivityWorldClassDeclarationFactory
   extends ActivityAgentClassDeclarationFactory
   implements IWorldClassDeclarationFactory {
public ActivityWorldClassDeclarationFactory() {
   super();
}


public static final IActivityWorldClassDeclaration createActivityWorldClassDeclaration() {
   return new ActivityWorldClassDeclaration();
}


public IAgentClassDeclaration createAgentClassDeclaration() {
    return createActivityWorldClassDeclaration();
}


   /**
    * @return IAgentInstanceDeclarationFactory
    * @see de.uniwue.ki.mas.entity.objectclass.IAgentClassDeclarationFactory#createAgentInstanceDeclarationFactory()
    */
   public final IAgentInstanceDeclarationFactory createAgentInstanceDeclarationFactory() {
      return createWorldInstanceDeclarationFactory();
   }


   public IObjectInstanceDeclarationFactory createObjectInstanceDeclarationFactory() {
      return createAgentInstanceDeclarationFactory();
   }


public final IWorldClassDeclaration createWorldClassDeclaration() {
   return createActivityWorldClassDeclaration();
}


public final IWorldInstanceDeclarationFactory createWorldInstanceDeclarationFactory() {
   return new ActivityWorldInstanceDeclarationFactory((IActivityWorldClassDeclaration)
	   getWorldClassDeclarationListAndFactory().getFirstDeclarationOrCreateNewIfEmpty());
}


/**
 * @return IWorldClassDeclarationListAndFactory
 */
public IWorldClassDeclarationListAndFactory getWorldClassDeclarationListAndFactory() {
	return (IWorldClassDeclarationListAndFactory ) getAgentClassDeclarationListAndFactory();
}


public void setWorldClassDeclarationListAndFactory(IWorldClassDeclarationListAndFactory newWorldClassDeclarationListAndFactory) {
	setAgentClassDeclarationListAndFactory(newWorldClassDeclarationListAndFactory);
}
}