package de.uniwue.ki.mas.entity.objectclass.worldclass;

import de.uniwue.ki.mas.entity.object.agent.IAgentInstanceDeclaration;
import de.uniwue.ki.mas.entity.object.world.IWorldInstanceDeclaration;
import de.uniwue.ki.mas.entity.objectclass.agentclass.IAgentClassDeclaration;

/**
 * An <code>IWorldClassDeclaration</code> generates {@link IAgentInstanceDeclaration}
 * and enhance <code>IAgentClassDeclaration</code> by specializing the type of the
 * object instance declaration.
 *
 * @author Christoph Oechslein
 */

public interface IWorldClassDeclaration extends IAgentClassDeclaration {

	/**
	 * Compiles a new <code>IWorldInstanceDeclaration</code> object.
	 */

	IWorldInstanceDeclaration createWorldInstanceDeclaration();

	boolean isUpdateBeforeAllObjects();

	void setUpdateBeforeAllObjects(boolean updateBeforeAllObjects);

}
