package de.uniwue.ki.mas.entity.objectclass.worldclass;
import de.uniwue.ki.mas.entity.object.world.IWorldInstanceDeclaration;
import de.uniwue.ki.mas.entity.object.world.IWorldInstanceDeclarationFactory;
import de.uniwue.ki.mas.entity.objectclass.agentclass.IAgentClassDeclarationFactory;

/**
 * Creates new <code>IWorldClassDeclaration</code> objects and
 * can create a factory for {@link IWorldInstanceDeclaration} objects.
 * Creation date: (02.11.2000 18:58:29)
 * @author Christoph Oechslein
 */

public interface IWorldClassDeclarationFactory extends IAgentClassDeclarationFactory {

/**
 * Creates new <code>IWorldClassDeclaration</code> object.
 *
 * @directed
 * @label creates
 */

/*#IWorldClassDeclaration lnkIWorldClassDeclaration;*/

IWorldClassDeclaration createWorldClassDeclaration();


/**
 * Creates a new factory for <code>IWorldInstanceDeclaration</code> objects.
 *
 * @directed
 * @label creates
 */

/*#IWorldInstanceDeclarationFactory lnkIWorldInstanceDeclarationFactory;*/

IWorldInstanceDeclarationFactory createWorldInstanceDeclarationFactory();
}