package de.uniwue.ki.mas.entity.variable;
import java.util.Iterator;

import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.ICreateFunctionArgs;
import de.uniwue.ki.mas.basics.function.iterator.EmptyIteratorSimulationRuntimeException;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (12.05.00 18:09:34)
 * @author Christoph Oechslein
 */

class BodyVariable extends AbstractBodyVariable implements IBodyVariable {
	private Object _value;

	public BodyVariable(boolean writeable, boolean partOfName) {
		super(writeable, partOfName);
	}

	public Object getValue() {
		return _value;
	}

	public final void setValue(Object newValue) {
		if (Assert.ASSERTION_ON) {
			Assert.assertTrue(isWriteable());
			Assert.assertTrue(!(newValue instanceof Iterator));
		}

		setValueIntern(newValue);
	}

	protected final void setValueIntern(Object newValue) {
		_value = newValue;
	}

	public void initializeDefaultValue(
		IBodyVariableInstanceDeclaration bodyVariableInstanceDeclaration,
		ICreateFunctionArgs createFunctionArgs)
		throws ModelCompilingException, SimulationRuntimeException {

		try {
			setValueIntern(
				bodyVariableInstanceDeclaration
					.getSpecificFunctionCallDeclaration()
					.createFunction(createFunctionArgs)
					.execute(createFunctionArgs.createCreateAndExecuteFunctionArgs()));
		} catch (EmptyIteratorSimulationRuntimeException e) {
		}
	}
}