package de.uniwue.ki.mas.entity.variable;

import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.function.iterator.EmptyIteratorSimulationRuntimeException;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Adds a function for the next value of this dynamic variable.
 * Creation date: (24.01.2001 13:48:27)
 *
 * @author Christoph Oechslein
 */

class BodyVariableWithUpdateFunction extends BodyVariable {
	private IFunction _nextValueFunction;

	public BodyVariableWithUpdateFunction(boolean writeable, boolean partOfName) {
		super(writeable, partOfName);
	}

	public boolean isDynamicVariable() {
		return true;
	}

	public Object update(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
		Object oldValue = getValue();

		try {
			setValueIntern(_nextValueFunction.execute(executeFunctionArgs));
		} catch (EmptyIteratorSimulationRuntimeException e) {
		}

		return oldValue;
	}

	public void initializeNextValueFunction(
		IBodyVariableInstanceDeclaration bodyVariableInstanceDeclaration,
		ICreateFunctionArgs createFunctionArgs)
		throws ModelCompilingException {

		super.initializeNextValueFunction(bodyVariableInstanceDeclaration, createFunctionArgs);

		_nextValueFunction = createNextValueFunction(bodyVariableInstanceDeclaration, createFunctionArgs);
	}
}