package de.uniwue.ki.mas.entity.variable;
import de.uniwue.ki.mas.basics.function.ICreateFunctionArgs;
import de.uniwue.ki.mas.basics.functionCall.IFunctionCallDeclaration;
import de.uniwue.ki.mas.entity.variableclass.IBodyVariableClassDeclaration;
import de.uniwue.ki.mas.entity.variableclass.IOwnDefaultValueFunctionCallDeclarationAble;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.mas.model.SimulationRuntimeException;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * An <code>IBodyVariableInstanceDeclaration</code> can create {@link IBodyVariable IBodyVariables}
 * and can have an own default value.
 * Creation date: (31.10.2000 17:14:00)
 *
 * @author Christoph Oechslein
 */

public interface IBodyVariableInstanceDeclaration
	extends IDeclaration, IOwnDefaultValueFunctionCallDeclarationAble {

	/**
	 * Compiles a new runtime body variable under the given compilation environment without setting the default value.
	 *
	 * @see IBodyVariable.initializeFunctions
	 */

	IBodyVariable createBodyVariable(ICreateFunctionArgs createFunctionArgs) throws ModelCompilingException;

	/**
	 * Returns class declaration which creates this instance declaration.
	 */

	IBodyVariableClassDeclaration getBodyVariableClassDeclaration();

	IFunctionCallDeclaration getSpecificFunctionCallDeclaration()
		throws SimulationRuntimeException, ModelCompilingException;

	boolean isConstant(ICreateFunctionArgs createFunctionArgs) throws ModelCompilingException;
}