package de.uniwue.ki.mas.entity.variable;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Creation date: (22.02.2002 13:41:08)
 * @author Christoph Oechslein
 */
final class IntegerBodyVariableWithUpdateFunction extends IntegerBodyVariable {
	private IFunction _nextValueFunction;

	public IntegerBodyVariableWithUpdateFunction(boolean writeable) {
		super(writeable);
	}

	public boolean isDynamicVariable() {
		return true;
	}

	public Object update(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
		throw new UnsupportedOperationException();
	}

	public double updateDouble(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
		throw new UnsupportedOperationException();
	}

	public int updateInt(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
		int oldValue = getIntValue();

		setIntValueIntern(_nextValueFunction.executeForInt(executeFunctionArgs));

		return oldValue;
	}

	public void initializeNextValueFunction(
		IBodyVariableInstanceDeclaration bodyVariableInstanceDeclaration,
		ICreateFunctionArgs createFunctionArgs)
		throws ModelCompilingException {

		super.initializeNextValueFunction(bodyVariableInstanceDeclaration, createFunctionArgs);

		_nextValueFunction = createNextValueFunction(bodyVariableInstanceDeclaration, createFunctionArgs);
	}
}