package de.uniwue.ki.mas.entity.variableclass;
import java.util.Iterator;
import java.util.Map;

import de.uniwue.ki.mas.util.declaration.DefaultDeclarationList;

/**
 * Creation date: 04.09.2002, 18:40:20
 * @author oechslein
 */
public class BodyVariableClassDeclarationList extends DefaultDeclarationList {

	public BodyVariableClassDeclarationList() {
		super();
	}

	public boolean accept(Object declaration) {
		return (declaration instanceof IBodyVariableClassDeclaration);
	}

	public boolean canBeRemoved(boolean recursive) {
		return true;
	}

	public IBodyVariableClassDeclaration getBodyVariableClassDeclaration(IVariableClassDeclaration variableClassDeclaration) {
		Iterator it = iterator();
		while (it.hasNext()) {
			IBodyVariableClassDeclaration currentBodyVariableClassDeclaration =
				(IBodyVariableClassDeclaration) it.next();
			if (currentBodyVariableClassDeclaration
				.getVariableClassDeclaration()
				.equals(variableClassDeclaration)) {
				return currentBodyVariableClassDeclaration;
			}
		}
		return null;
	}

	public String getName() {
		return "Body Variables";
	}

	public void copyInto(Object dstObject, Map objectMapping) {
		BodyVariableClassDeclarationList dstBodyVariableClassDeclarationList =
			(BodyVariableClassDeclarationList) dstObject;

		dstBodyVariableClassDeclarationList.clear();

		Iterator it = iterator();

		while (it.hasNext()) {
			IBodyVariableClassDeclaration bodyVariableClassDeclaration =
				(IBodyVariableClassDeclaration) it.next();

			if (objectMapping == null) {
				dstBodyVariableClassDeclarationList.add(bodyVariableClassDeclaration.copy(objectMapping));

			} else if (objectMapping.containsKey(bodyVariableClassDeclaration)) {
				IBodyVariableClassDeclaration copyBodyVarDecl =
					(IBodyVariableClassDeclaration) objectMapping.get(bodyVariableClassDeclaration);
				if (!dstBodyVariableClassDeclarationList.contains(copyBodyVarDecl))
					dstBodyVariableClassDeclarationList.add(copyBodyVarDecl);

			} else {
				Object copyOfCopyable = bodyVariableClassDeclaration.copy(objectMapping);
				objectMapping.put(bodyVariableClassDeclaration, copyOfCopyable);
				dstBodyVariableClassDeclarationList.add(copyOfCopyable);
			}
		}
	}
}