package de.uniwue.ki.mas.entity.variableclass;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import de.uniwue.ki.mas.basics.functionCall.FunctionCallDeclarationFactory;
import de.uniwue.ki.mas.basics.functionCall.IFunctionCallDeclaration;
import de.uniwue.ki.mas.util.declaration.IDeclaration;
import de.uniwue.ki.util.event.StateChangeMulticaster;
/**
 * Creation date: (22.11.2001 13:50:00)
 * 
 * @author Christoph Oechslein
 */
public class DefaultOwnDefaultValueFunctionCallDeclaration
		implements
			IOwnDefaultValueFunctionCallDeclarationAble, ChangeListener {
	
	private final IFunctionCallDeclaration fieldDefaultValueFunctionCallDeclaration = FunctionCallDeclarationFactory
			.getInstance().createFunctionCallDeclaration();

	private boolean fieldUsesOwnDefaulValueFunctionCallDeclaration = false;
	
	ChangeListener changeListenerMulticaster = null;
	
	public void addChangeListener(ChangeListener listener) {
		changeListenerMulticaster = StateChangeMulticaster.add(changeListenerMulticaster, listener);
	}

	public void removeChangeListener(ChangeListener listener) {
		changeListenerMulticaster = StateChangeMulticaster.remove(changeListenerMulticaster, listener);
	}
	
	private void fireStateChanged() {
		if(changeListenerMulticaster == null)
			return;
		changeListenerMulticaster.stateChanged(new ChangeEvent(this));
	}
	
	public DefaultOwnDefaultValueFunctionCallDeclaration() {
		super();
		fieldDefaultValueFunctionCallDeclaration.addChangeListener(this);
	}

	public IFunctionCallDeclaration getDefaultValueFunctionCallDeclaration() {
		return fieldDefaultValueFunctionCallDeclaration;
	}

	public IFunctionCallDeclaration getRightDefaulValueFunctionCallDeclaration(
			IFunctionCallDeclaration defaultFunctionCallDeclaration) {

		if (getUsesOwnDefaulValueFunctionCallDeclaration()) {
			return getDefaultValueFunctionCallDeclaration();

		} else {
			return defaultFunctionCallDeclaration;
		}
	}

	public IFunctionCallDeclaration getRightDefaulValueFunctionCallDeclaration(
			IOwnDefaultValueFunctionCallDeclarationAble parent,
			IFunctionCallDeclaration defaultFunctionCallDeclaration) {

		if (getUsesOwnDefaulValueFunctionCallDeclaration()) {
			return getDefaultValueFunctionCallDeclaration();

		} else if (parent.getUsesOwnDefaulValueFunctionCallDeclaration()) {
			return parent.getDefaultValueFunctionCallDeclaration();

		} else {
			return defaultFunctionCallDeclaration;
		}
	}

	public boolean getUsesOwnDefaulValueFunctionCallDeclaration() {
		return fieldUsesOwnDefaulValueFunctionCallDeclaration;
	}

	public void setUsesOwnDefaulValueFunctionCallDeclaration(
			boolean usesOwnDefaulValue) {
		if (fieldUsesOwnDefaulValueFunctionCallDeclaration != usesOwnDefaulValue) 
			fireStateChanged();
		
		//Sollte nicht zuerst gendert und dann gefeuert werden?? Hatko, 13.06.04
		fieldUsesOwnDefaulValueFunctionCallDeclaration = usesOwnDefaulValue;
	}

	/**
	 * forward event
	 */
	public void stateChanged(ChangeEvent e) {
		if (changeListenerMulticaster != null)
			changeListenerMulticaster.stateChanged(e);
	}
}