package de.uniwue.ki.mas.entity.variableclass;
import de.uniwue.ki.mas.basics.type.ISpecificType;
import de.uniwue.ki.mas.util.declaration.AbstractDeclarationFactory;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: (04.09.2001 16:05:27)
 * @author Christoph Oechslein
 */

public final class FeatureVariableClassDeclarationFactory
	extends AbstractDeclarationFactory
	implements IVariableClassDeclarationFactory {
	private static final FeatureVariableClassDeclarationFactory _instance =
		new FeatureVariableClassDeclarationFactory();

	public FeatureVariableClassDeclarationFactory() {
		super();
	}

	/**
	 * @return IDeclaration
	 * @see de.uniwue.ki.mas.util.declaration.IDeclarationFactory#createDeclaration()
	 */
	public final IDeclaration createDeclaration() {
		return createFeatureVariableClassDeclaration();
	}

	public static final IFeatureVariableClassDeclaration createFeatureVariableClassDeclaration() {
		return new FeatureVariableClassDeclaration();
	}

	public static final IFeatureVariableClassDeclaration createFeatureVariableClassDeclaration(ISpecificType type) {
		return new FeatureVariableClassDeclaration(type);
	}

	public final IVariableClassDeclaration createVariableClassDeclaration() {
		return createFeatureVariableClassDeclaration();
	}

	public final IVariableClassDeclaration createVariableClassDeclaration(ISpecificType type) {
		return createFeatureVariableClassDeclaration(type);
	}

	/**
	 * @return FeatureVariableClassDeclarationFactory
	 */
	public static final FeatureVariableClassDeclarationFactory getInstance() {
		return _instance;
	}
}