package de.uniwue.ki.mas.entity.variableclass;

import java.util.Iterator;

import de.uniwue.ki.mas.basics.function.ICreateFunctionArgs;
import de.uniwue.ki.mas.entity.variable.IBodyVariableInstanceDeclaration;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * An <code>IBodyVariableClassDeclaration</code> is a
 * instance variable declaration for exactly one body (agent).
 * @author oechslein
 */

public interface IBodyVariableClassDeclaration extends IDeclaration {

	/**
	 * Creates a new instance declaration of this class declaration.
	 */

	IBodyVariableInstanceDeclaration createBodyVariableInstanceDeclaration();

	/**
	 * Returns the variable class declaration of this declaration,
	 * for example look there for type information.
	 */

	IVariableClassDeclaration getVariableClassDeclaration();

	boolean isConstant(ICreateFunctionArgs createFunctionArgs) throws ModelCompilingException;

	void addBodyVariableInstanceDeclaration(IBodyVariableInstanceDeclaration bodyVariableInstanceDeclaration);
	void removeBodyVariableInstanceDeclaration(IBodyVariableInstanceDeclaration bodyVariableInstanceDeclaration);
	Iterator getBodyVariableInstanceDeclarations();
	
	/**
	 * Used to check if we can inline this value, since there is only one world in an experiment 
	 * and therefore only _used_ IBodyVariableInstDecl. 
	 * @return boolean
	 */
	boolean isInWorldClassDeclaration();
	void setInWorldClassDeclaration(boolean inWorldClassDeclaration);
}