package de.uniwue.ki.mas.entity.variableclass;
import java.io.Serializable;

import de.uniwue.ki.mas.basics.functionCall.IFunctionCallDeclaration;

/**
 * Creation date: (22.11.2001 13:48:57)
 * @author Christoph Oechslein
 */

public interface IOwnDefaultValueFunctionCallDeclarationAble extends Serializable {

	/**
	 * Returns default value of this instance declaration.
	 *
	 * @see #getUsesOwnDefaulValueFunctionCallDeclaration()
	 * @see #setUsesOwnDefaulValueFunctionCallDeclaration(boolean)
	 */
	IFunctionCallDeclaration getDefaultValueFunctionCallDeclaration();

	/**
	 * Returns <code>true</code> if this body declaration has its own
	 * default value, if <code>false</code> the defaut value of its variable
	 * declaration is used.
	 *
	 * @see #getDefaultValueFunctionCallDeclaration()
	 * @see #setUsesOwnDefaulValueFunctionCallDeclaration(boolean)
	 */
	boolean getUsesOwnDefaulValueFunctionCallDeclaration();

	/**
	 * Use its own default value or share it from the variable class declaration.
	 *
	 * @see #getDefaultValueFunctionCallDeclaration()
	 * @see #getUsesOwnDefaulValueFunctionCallDeclaration()
	 */
	void setUsesOwnDefaulValueFunctionCallDeclaration(boolean usesOwnDefaulValueFunctionCallDeclaration);
}