package de.uniwue.ki.mas.entity.variableclass;
import de.uniwue.ki.mas.basics.type.ISpecificType;
import de.uniwue.ki.mas.util.declaration.AbstractDeclarationFactory;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: (04.09.2001 16:05:27)
 * @author Christoph Oechslein
 */

public final class VariableClassDeclarationFactory extends AbstractDeclarationFactory implements IVariableClassDeclarationFactory {
	private static final VariableClassDeclarationFactory instance = new VariableClassDeclarationFactory();

public VariableClassDeclarationFactory() {
    super();
}


public final IDeclaration createDeclaration() {
    return createVariableClassDeclaration();
}


public final IVariableClassDeclaration createVariableClassDeclaration() {
    return new VariableClassDeclaration();
}


public final IVariableClassDeclaration createVariableClassDeclaration(ISpecificType type) {
   return new VariableClassDeclaration(type);
}


/**
 * Insert the method's description here.
 * Creation date: (16.05.00 17:09:08)
 * @author Christoph Oechslein
 * @return de.uniwue.ki.mas.model.util.declaration.IDeclarationFactory
 */
public static final VariableClassDeclarationFactory getInstance() {
   return instance;
}
}