package de.uniwue.ki.mas.model;

import de.uniwue.ki.mas.model.userInterface.UserInterfaceDeclarationListAndFactory;
import de.uniwue.ki.mas.sim.analysis.AnalysisDeclarationListAndFactory;
import de.uniwue.ki.mas.sim.experiment.ExperimentDeclarationListAndFactory;
import de.uniwue.ki.mas.sim.simulation.SimulationDeclarationListAndFactory;
import de.uniwue.ki.mas.sim.situation.SituationDeclarationListAndFactory;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Encapsulte {@link de.uniwue.ki.mas.model.sim.analysis.IAnalysisDeclaration analysis}, 
 * {@link de.uniwue.ki.mas.model.sim.situation.ISituationDeclaration situations}, 
 * {@link de.uniwue.ki.mas.model.sim.simulation.ISimulationDeclaration simulations}
 * and {@link de.uniwue.ki.mas.model.sim.experiment.IExperimentDeclaration experiments}.
 * 
 * @author Christoph Oechslein
 */
public interface ISimulationElementsDeclaration extends IDeclaration {
	void clear();

	AnalysisDeclarationListAndFactory getAnalysisDeclarationListAndFactory();

	ExperimentDeclarationListAndFactory getExperimentDeclarationListAndFactory();

	SimulationDeclarationListAndFactory getSimulationDeclarationListAndFactory();

	SituationDeclarationListAndFactory getSituationDeclarationListAndFactory();
	
	UserInterfaceDeclarationListAndFactory getUserInterfaceDeclarationListAndFactory();
}