package de.uniwue.ki.mas.model;

import de.uniwue.ki.mas.util.declaration.AbstractDeclarationFactory;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: (04.09.2001 16:05:27)
 * @author Christoph Oechslein
 */

public final class SeSAmDeclarationFactory extends AbstractDeclarationFactory {
	private final SeSAmDeclarationFactory instance = new SeSAmDeclarationFactory();

	public static ISeSAmDeclaration createSeSAmDeclaration() {
		return new SeSAmDeclaration();
	}

	public static ISeSAmDeclaration createSeSAmDeclaration(ISeSAmModelDeclaration seSAmModelDeclaration) {
		return new SeSAmDeclaration(seSAmModelDeclaration);
	}

	public static ISeSAmDeclaration createSeSAmDeclaration(boolean withTree) {
		return new SeSAmDeclaration(withTree);
	}

	public static ISeSAmDeclaration createSeSAmDeclaration(
		ISeSAmModelDeclaration seSAmModelDeclaration,
		boolean withTree) {
		return new SeSAmDeclaration(seSAmModelDeclaration, withTree);
	}

	public static ISeSAmModelDeclaration createSeSAmModelDeclaration() {
		return new SeSAmModelDeclaration();
	}

	public final SeSAmDeclarationFactory getInstance() {
		return instance;
	}

	public IDeclaration createDeclaration() {
		return createSeSAmDeclaration();
	}

	protected SeSAmDeclarationFactory() {
		super();
	}
}
