package de.uniwue.ki.mas.model;

import java.text.DateFormat;
import java.util.Date;

/**
 * @author oechslein
 * 
 * Creation date: 09.04.2003
 */
public final class SeSAmVersion {

	private SeSAmVersion() {
	}

	public static String getAntBuildDateString() {
		String dateString = "20040614";
		String timeString = "0844";

		return dateString.substring(0, 4)
			+ "/"
			+ dateString.substring(4, 6)
			+ "/"
			+ dateString.substring(6, 8)
			+ " "
			+ timeString.substring(0, 2)
			+ ":"
			+ timeString.substring(2, 4);
	}

	public static String getBuildNumber() {
		return "1301";
	}

	public static boolean isBuildWithAnt() {
		return !getBuildNumber().startsWith("@BUILD_NUMBER");
	}

	public static String getVersionNumber() {
		return "1.6pre";
	}

	public static String version() {
		return getVersionNumber()
			+ " ("
			+ (isBuildWithAnt()
				? ("build #" + getBuildNumber() + " at " + getAntBuildDateString())
				: DateFormat.getDateTimeInstance().format(new Date()))
			+ ")";
	}
}
