/**
 * Created on 24.07.2003
 *
 * This class is responsible for //insert purpose//.
 * 
 * @author glueckselig
 */
package de.uniwue.ki.mas.model.graph;

import java.util.Hashtable;
import java.util.Iterator;

import de.uniwue.ki.mas.basics.type.ISpecificType;
import de.uniwue.ki.mas.basics.type.SpecificListType;
import de.uniwue.ki.mas.entity.variableclass.IVariableClassDeclaration;
import de.uniwue.ki.util.collection.CollectionsHelper;

public class ListVariable extends Variable {

//	private Variable _typeVar;
	private Hashtable _containedTypes;

	public ListVariable(IVariableClassDeclaration decl) {
		super(decl);
		
		extractSubtypes(decl);
//		_typeVar = VariableFactory.instance().createVariable(getType());
	}

	private void extractSubtypes(IVariableClassDeclaration decl) {
		
		_containedTypes = new Hashtable();
		
		SpecificListType listType = (SpecificListType)decl.getSpecificType();
		Iterator it = listType.getSubTypes();
		while (it.hasNext()) {
			ISpecificType element = (ISpecificType) it.next();
			_containedTypes.put(element, "");
		}
		
	}

	public String getName() {

		if (getVariableClassDeclaration() == null) {
			return "";
		} else {
			return getVariableClassDeclaration().getName();
		}
	}

	public ISpecificType getType() {
		return ((SpecificListType) getVariableClassDeclaration().getSpecificType()).getListSpecificType();
	}

	public Iterator getSubtypeIterator() {
		
		return CollectionsHelper.asIterator(_containedTypes.keys());
	}

//	public Variable getTypeVar() {
//
//		return _typeVar;
//	}

	//	protected IVariableClassDeclaration getVariableClassDeclaration() {
	//
	//		//		return ((SpecificListType)_decl.getVariableClassDeclaration().getSpecificType());
	//	}

}
