/**
 * Created on 27.01.2004
 *
 * This class is responsible for //insert purpose//.
 * 
 * @author glueckselig
 */
package de.uniwue.ki.mas.model.graph;

import java.util.Iterator;

import mygale.mcge.net.*;
import de.uniwue.ki.mas.util.declaration.*;

public class RubberGraphDeclarationWithNetModel
    extends AbstractDocumentableDeclaration
    implements INetGraphModel, IDeclaration, IDocumentableDeclaration {

    // This class implements the INetGraphModel interface and extends the IDocumentableDeclaration interface
    // via AbstractDocumentableDeclaration.
    // This is necessary due to Java's incapability of extending several classes at once multiple
    // inheritance. --steffen
    // The RubberGraphnetGraphModel class is the actual implementator of the INetGraphModel

    private INetGraphModel _model;

    private boolean _allFixed;

    public boolean isFixed() {

        return _allFixed;
    }

    public RubberGraphDeclarationWithNetModel(INetGraphModel model) {
        setShortDescription("RubberGraphDeclaration");

        _model = model;
    }

    // ********************************
    //
    // start: INetGraphMode-methods
    //
    //  ********************************
    public void addEdge(INetEdge edge) {
        _model.addEdge(edge);
    }

    public void addNetGraphModelChangedListener(NetGraphModelChangedListener newListener) {
        _model.addNetGraphModelChangedListener(newListener);
    }

    public void addNode(INetNode node) {
        _model.addNode(node);
    }

    public Iterator getEdges() {
        return _model.getEdges();
    }

    public Iterator getNodes() {
        return _model.getNodes();
    }

    public void removeEdge(INetEdge edge) {
        _model.removeEdge(edge);
    }

    public void removeNetGraphModelChangedListener(NetGraphModelChangedListener newListener) {
        _model.removeNetGraphModelChangedListener(newListener);
    }

    public void removeNode(INetNode node) {

        // remove node from model. This causes the Graph to remove all the associated figs (node and edges),
        // too.
        _model.removeNode(node);

        // Now, remove all edges from the model...
        removeEdgesForNode(node);

    }

    public void removeEdgesForNode(INetNode node) {
        _model.removeEdgesForNode(node);
    }

}
