/**
 * Created on 22.01.2004
 *
 * This class is responsible for //insert purpose//.
 * 
 * @author glueckselig
 */
package de.uniwue.ki.mas.model.graph;

import java.util.Iterator;

import mygale.mcge.net.DefaultNetGraphModel;
import mygale.mcge.net.INetGraphModel;

public class UMLLayoutGraphDeclaration
    extends RubberGraphDeclarationWithNetModel
    implements IUMLLayoutGraphDeclaration {

    public UMLLayoutGraphDeclaration(INetGraphModel model) {

        super(model);
    }

    public UMLLayoutGraphDeclaration() {

        this(new DefaultNetGraphModel());
    }

    public boolean getUsesShortDescription() {

        return true;
    }

    public void overlayWithOtherGraphDeclaration(final IUMLLayoutGraphDeclaration oDecl) {

        UMLLayoutGraphEdgeFactory edgeFactory = UMLLayoutGraphEdgeFactory.getInstance();

        Iterator nodes = getNodes();
        while (nodes.hasNext()) {
            IUMLLayoutGraphNode node = (IUMLLayoutGraphNode) nodes.next();

            IUMLLayoutGraphNode node2 = oDecl.getNodeWithSameDeclaration(node);

            if (node2 == null)
                continue;

            Iterator edges = node2.getNodeEdges();
            while (edges.hasNext()) {
                UMLLayoutGraphEdge edge = (UMLLayoutGraphEdge) edges.next();

                IUMLLayoutGraphNode toN =
                    getNodeWithSameDeclaration((IUMLLayoutGraphNode) edge.getBeginNode());
                IUMLLayoutGraphNode froN =
                    getNodeWithSameDeclaration((IUMLLayoutGraphNode) edge.getEndNode());

                if (toN != null && froN != null) {
                    UMLLayoutGraphEdge newEdge = edgeFactory.createEdge(toN, froN, edge.getName());

                    addEdge(newEdge);
                }
            }
        }

    }

    public IUMLLayoutGraphNode getNodeWithSameDeclaration(IUMLLayoutGraphNode node) {
        Iterator nodes = getNodes();

        while (nodes.hasNext()) {
            IUMLLayoutGraphNode nodeIntern = (IUMLLayoutGraphNode) nodes.next();

            if (node.getDeclaration() == nodeIntern.getDeclaration())
                return nodeIntern;

        }

        return null;
    }

}
