/**
 * Created on 27.01.2004
 *
 * This class is responsible for //insert purpose//.
 * 
 * @author glueckselig
 */
package de.uniwue.ki.mas.model.graph;

import de.uniwue.ki.mas.model.ISeSAmDeclaration;
import de.uniwue.ki.mas.util.declaration.AbstractDeclarationFactory;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

public class UMLLayoutGraphDeclarationFactory extends AbstractDeclarationFactory {

    private ISeSAmDeclaration _seSAmDecl;

    private UMLLayoutGraphDeclarationFactory(ISeSAmDeclaration decl) {

        super();
        _seSAmDecl = decl;
    }

    public static UMLLayoutGraphDeclarationFactory getInstance(ISeSAmDeclaration decl) {
        if (_instance == null) {
            _instance = new UMLLayoutGraphDeclarationFactory(decl);
        }

        return _instance;
    }

    private static UMLLayoutGraphDeclarationFactory _instance;

    public IDeclaration createDeclaration() {

        // for every new graph, parse the model again....

        return new UMLLayoutGraphParser(
            _seSAmDecl.getSeSAmModelDeclaration().getAvailibleObjectClassDeclarationList(),
            _seSAmDecl.getSeSAmModelDeclaration().getAvailibleFeatureClassDeclarationList())
            .getGraphModel();
    }

}
