/**
 * Created on 11.02.2004
 *
 * This class is responsible for //insert purpose//.
 * 
 * @author glueckselig
 */
package de.uniwue.ki.mas.model.graph;

import java.util.*;

import mygale.mcge.net.INetGraphModel;
import de.uniwue.ki.mas.basics.feature.IFeatureClassDeclaration;
import de.uniwue.ki.mas.basics.functionDeclaration.IFunctionDeclaration;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

public class UMLLayoutGraphFeatureNode extends UMLLayoutGraphNode {

    private ArrayList _funcList = null;

    private IFeatureClassDeclaration _featDecl = null;

    protected UMLLayoutGraphFeatureNode(INetGraphModel graphModel) {
        super(graphModel);
    }

    protected UMLLayoutGraphFeatureNode(INetGraphModel graphModel, IFeatureClassDeclaration decl) {
        super(graphModel);

        _featDecl = decl;

        Iterator functionDeclIter = decl.getFunctionDeclarations();
        while (functionDeclIter.hasNext()) {
            IFunctionDeclaration func = (IFunctionDeclaration) functionDeclIter.next();

            Function f = new Function(func);

            addFunction(f);
        }
    }

    public String getName() {

        return _featDecl.getName();
    }

    public void addFunction(Function func) {

        getFunctionList().add(func);
    }

    public Iterator getFunctionIterator() {

        return getFunctionList().iterator();
    }

    private List getFunctionList() {
        if (_funcList == null)
            _funcList = new ArrayList();

        return _funcList;
    }

    public IDeclaration getDeclaration() {

        return _featDecl;
    }

}
