/**
 * Created on 11.02.2004
 *
 * 
 * @author glueckselig
 */
package de.uniwue.ki.mas.model.graph;

import mygale.mcge.net.INetGraphModel;
import de.uniwue.ki.mas.basics.feature.user.IUserFeatureClassDeclaration;
import de.uniwue.ki.mas.entity.objectclass.IObjectClassDeclaration;
import de.uniwue.ki.mas.entity.objectclass.IRessourceClassDeclaration;
import de.uniwue.ki.mas.entity.objectclass.agentclass.IAgentClassDeclaration;
import de.uniwue.ki.mas.entity.objectclass.worldclass.IWorldClassDeclaration;
import de.uniwue.ki.mas.util.declaration.IDocumentableDeclaration;

public class UMLLayoutGraphNodeFactory {

    private static UMLLayoutGraphNodeFactory _instance = new UMLLayoutGraphNodeFactory();
    private UMLLayoutGraphDeclaration _graphModel;

    protected UMLLayoutGraphNodeFactory() {

    }

    public static UMLLayoutGraphNodeFactory getInstance() {

        return _instance;
    }

    public void setGraphModel(INetGraphModel model) {

        _graphModel = (UMLLayoutGraphDeclaration) model;
    }

    public IUMLLayoutGraphNode createNode(IDocumentableDeclaration decl) throws CannotCreateNodeException {

        if (decl instanceof IAgentClassDeclaration) {

            return new UMLLayoutGraphNodeAgent(getGraphModel(), (IObjectClassDeclaration) decl);
        } else if (decl instanceof IRessourceClassDeclaration) {

            return new UMLLayoutGraphNodeRessource(getGraphModel(), (IObjectClassDeclaration) decl);
        } else if (decl instanceof IWorldClassDeclaration) {

            return new UMLLayoutGraphNodeWorld(getGraphModel(), (IObjectClassDeclaration) decl);
        } else if (decl instanceof IUserFeatureClassDeclaration) {
         
            return new UMLLayoutGraphNodeUserFeature(getGraphModel(), (IUserFeatureClassDeclaration) decl);
        }
        
        //throw new CannotCreateNodeException(); // Caused the 'null's on the console when opening a model
        throw new CannotCreateNodeException("Cannot create Node for "+decl.getClass().getName());
    }

    public UMLLayoutGraphDeclaration getGraphModel() {

        return _graphModel;
    }
}
