/**
 * Created on 01.07.2003
 *
 * This class is responsible for //insert purpose//.
 * 
 * @author glueckselig
 */
package de.uniwue.ki.mas.model.graph;

import java.util.ArrayList;
import java.util.Iterator;

import mygale.mcge.net.INetGraphModel;
import de.uniwue.ki.mas.entity.objectclass.IObjectClassDeclaration;
import de.uniwue.ki.mas.entity.variableclass.IBodyVariableClassDeclaration;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

public abstract class UMLLayoutGraphObjectNode extends UMLLayoutGraphNode {

    private ArrayList _variableList = null;

    private IObjectClassDeclaration _objDecl = null;

    protected UMLLayoutGraphObjectNode(INetGraphModel graphModel) {
        super(graphModel);

        //        getVariableList();
    }

    protected UMLLayoutGraphObjectNode(INetGraphModel graphModel, IObjectClassDeclaration decl) {
        super(graphModel);

        _objDecl = decl;

        Iterator bodyVariableIterator =
            decl
                .getBodyClassDeclaration()
                .getBodyVariableClassDeclarationListAndFactory()
                .getBodyVariableClassDeclarationList()
                .iterator();
        while (bodyVariableIterator.hasNext()) {
            IBodyVariableClassDeclaration bodyVar =
                (IBodyVariableClassDeclaration) bodyVariableIterator.next();

            Variable var = VariableFactory.instance().createVariable(bodyVar.getVariableClassDeclaration());

            addVariable(var);
        }
    }

    public String getName() {

        return _objDecl.getName();
    }

    private ArrayList getVariableList() {

        if (_variableList == null)
            _variableList = new ArrayList();

        return _variableList;
    }

    public Iterator variableIterator() {

        return getVariableList().iterator();
    }

    private void addVariable(Variable var) {
        getVariableList().add(var);
    }

    public IDeclaration getDeclaration() {

        return _objDecl;
    }

}
