/**
 * Created on 23.07.2003
 *
 * This class is responsible for //insert purpose//.
 * 
 * @author glueckselig
 */
package de.uniwue.ki.mas.model.graph;

import junit.framework.Assert;
import de.uniwue.ki.mas.basics.type.ISpecificType;
import de.uniwue.ki.mas.entity.variableclass.IVariableClassDeclaration;

public abstract class Variable {

	protected IVariableClassDeclaration _varDecl;

	public Variable(IVariableClassDeclaration decl) {
		Assert.assertNotNull(decl);
		
		_varDecl = decl;
	}

	public Variable() {
		
		Assert.fail("trying to set Variable w/o variableClassDecl");

	}

	public String getName() {

		if (getVariableClassDeclaration() == null) {
			return "";
		} else {
			return getVariableClassDeclaration().getName();
		}
	}

	public ISpecificType getType() {

		return getVariableClassDeclaration().getSpecificType();
	}

	protected IVariableClassDeclaration getVariableClassDeclaration() {

		return _varDecl;
	}

}
