/**
 * Created on 24.07.2003
 *
 * This class is responsible for //insert purpose//.
 * 
 * @author glueckselig
 */
package de.uniwue.ki.mas.model.graph;

import de.uniwue.ki.mas.basics.type.ISimObjectType;
import de.uniwue.ki.mas.basics.type.SpecificListType;
import de.uniwue.ki.mas.entity.variableclass.IVariableClassDeclaration;

public class VariableFactory {

	private static final VariableFactory _factory = new VariableFactory();

	public static VariableFactory instance() {

		return _factory;
	}

	public Variable createVariable(IVariableClassDeclaration decl) {

		if (decl.getSpecificType() instanceof ISimObjectType) {
//			System.out.println("VariableFactory.createVariable(): "+decl.getName()+" is simObject.");
			return new SimObjectTypeVariable(decl);
			
		} else if (decl.getSpecificType() instanceof SpecificListType) {
//			System.out.println("VariableFactory.createVariable(): "+decl.getName()+" is list.");
			return new ListVariable(decl);
			
		} else {
//			System.out.println("VariableFactory.createVariable(): "+decl.getName()+" is standard.");
			return new StandardVariable(decl);
			
		}

	}

}
