package de.uniwue.ki.mas.model.tree;
import java.util.Iterator;
import java.util.List;

import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import de.uniwue.ki.mas.util.declaration.IDeclaration;
import de.uniwue.ki.util.tree.DefaultObjectTreeNode;
import de.uniwue.ki.util.tree.IObjectTreeNode;

/**
 * Creation date: (18.03.2002 15:13:55)
 * @author Christoph Oechslein
 */
public class DefaultDeclarationTreeNode extends DefaultObjectTreeNode {
	private final transient ChangeListener _changeListener = new ChangeListener() {
		public void stateChanged(ChangeEvent e) {
			DefaultDeclarationTreeNode.this.stateChanged(e);
		}
	};

	public DefaultDeclarationTreeNode(IObjectTreeNode parent, IDeclaration declaration) {
		super(parent, declaration);

		declaration.addChangeListener(_changeListener);
	}

	public DefaultDeclarationTreeNode(IObjectTreeNode parent, IDeclaration declaration, Iterator childrens) {
		super(parent, declaration, childrens);

		declaration.addChangeListener(_changeListener);
	}

	public DefaultDeclarationTreeNode(IObjectTreeNode parent, IDeclaration declaration, List childrenList) {
		super(parent, declaration, childrenList);

		declaration.addChangeListener(_changeListener);
	}

	public IDeclaration getDeclaration() {
		return (IDeclaration) getUserObject();
	}

	public void remove() {
		getDeclaration().removeChangeListener(_changeListener);

		super.remove();
	}

	protected void stateChanged(ChangeEvent e) {
		SeSAmDeclarationTreeModelAdapter seSAmDeclarationTreeModelAdapter =
			SeSAmDeclarationTreeModelCreater.getSeSAmDeclarationTreeModelAdapter(this);

		if (seSAmDeclarationTreeModelAdapter != null)
			seSAmDeclarationTreeModelAdapter.reloadNode(this, false);
	}
}