package de.uniwue.ki.mas.model.tree;

import de.uniwue.ki.mas.util.declaration.IDeclaration;
import de.uniwue.ki.util.tree.*;

/**
 * Creation date: 05.09.2002, 14:34:17
 * @author oechslein
 */
public class DefaultDeclarationTreeNodeLeafFactory implements IObjectTreeNodeFactory {
	private static final DefaultDeclarationTreeNodeLeafFactory _instance = new DefaultDeclarationTreeNodeLeafFactory();

	public static final DefaultDeclarationTreeNodeLeafFactory getInstance() {
		return _instance;
	}

	public IObjectTreeNode createObjectTreeNode(IObjectTreeNode parent, Object userObject) {
		if (userObject instanceof IDeclaration)
			return new DefaultDeclarationTreeNodeLeaf(parent, (IDeclaration) userObject);
		else
			return new DefaultObjectTreeNodeLeaf(parent, userObject);
	}

}
