package de.uniwue.ki.mas.model.tree;

import javax.swing.event.ListDataEvent;

import de.uniwue.ki.util.list.IMutableListModel;
import de.uniwue.ki.util.tree.*;

/**
 * Creation date: 05.09.2002, 15:45:18
 * @author oechslein
 */
final class MutableListModelTreeNodeAdapterWithUpdate extends MutableListModelTreeNodeAdapter {
	public MutableListModelTreeNodeAdapterWithUpdate(
		IObjectTreeNode parent,
		IMutableListModel mutableListModel,
		IObjectTreeNodeFactory treeNodeFactory) {
		super(parent, mutableListModel, treeNodeFactory);
	}

	protected void contentsChanged(ListDataEvent e) {
		if (isChildrenNodesCreated()) {
			super.contentsChanged(e);

			SeSAmDeclarationTreeModelCreater.getSeSAmDeclarationTreeModelAdapter(this).reloadNode(this);
		}
	}

	protected void intervalAdded(ListDataEvent e) {
		if (isChildrenNodesCreated()) {
			super.intervalAdded(e);

			int index0 = e.getIndex0();
			int index1 = e.getIndex1();

			SeSAmDeclarationTreeModelCreater.getSeSAmDeclarationTreeModelAdapter(this).nodesWereInserted(
				this,
				index0,
				index1);
		}
	}

	protected void intervalRemoved(ListDataEvent e) {
		if (isChildrenNodesCreated()) {
			int index0 = e.getIndex0();
			int index1 = e.getIndex1();

			IObjectTreeNode[] childrenArray = new IObjectTreeNode[index1 - index0 + 1];

			for (int i = 0; i <= index1 - index0; i++) {
				childrenArray[i] = (IObjectTreeNode) getChildrenNodes().remove(index0);
			}

			SeSAmDeclarationTreeModelCreater.getSeSAmDeclarationTreeModelAdapter(this).nodesWereRemoved(
				this,
				index0,
				index1,
				childrenArray);

			for (int i = 0; i < childrenArray.length; i++) {
				childrenArray[i].remove();
			}
		}
	}
}
