/*
 * Created on 05.06.2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package de.uniwue.ki.mas.model.tree;

import java.util.Iterator;
import java.util.List;

import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import de.uniwue.ki.mas.basics.functionCall.IFunctionCallInternDeclaration;
import de.uniwue.ki.mas.basics.functionUser.IUserFunctionDeclaration;
import de.uniwue.ki.mas.util.declaration.IDeclaration;
import de.uniwue.ki.util.tree.DefaultObjectTreeNode;
import de.uniwue.ki.util.tree.IObjectTreeNode;
import de.uniwue.ki.util.tree.IObjectTreeNodeFactory;


final class UserFunctionDeclarationTreeNodeFactory implements IObjectTreeNodeFactory {
	public class UserFunctionDeclarationTreeNode
	extends DefaultObjectTreeNode
	implements IUpdateChildrenAbleNode {
	private final transient ChangeListener _changeListener = new ChangeListener() {
		public void stateChanged(ChangeEvent e) {
			UserFunctionDeclarationTreeNode.this.stateChanged(e);
		}
	};

	public UserFunctionDeclarationTreeNode(IObjectTreeNode parent, IUserFunctionDeclaration declaration) {
		super(parent, declaration);

		initialize(declaration);
	}

	public UserFunctionDeclarationTreeNode(
		IObjectTreeNode parent,
		IUserFunctionDeclaration declaration,
		Iterator childrens) {
		super(parent, declaration, childrens);

		initialize(declaration);
	}

	public UserFunctionDeclarationTreeNode(
		IObjectTreeNode parent,
		IUserFunctionDeclaration declaration,
		List childrenList) {
		super(parent, declaration, childrenList);

		initialize(declaration);
	}

	private void initialize(IUserFunctionDeclaration declaration) {
		updateChildrenIntern();

		declaration.addChangeListener(_changeListener);

		//updateChildrenDeffered();
	}

	private void updateChildrenDeffered() {
		UpdateChildrenAbleNodeThread.getInstance().addNode(this);
	}

	private void updateChildrenIntern() {
		IUserFunctionDeclaration declaration = (IUserFunctionDeclaration) getDeclaration();
		removeChildren();

		IFunctionCallInternDeclaration functionCallInternDeclaration =
			declaration
				.getParametricFunctionCallDeclaration()
				.getFunctionCallDeclaration()
				.getFunctionCallInternDeclaration();
				
		if (functionCallInternDeclaration != null) {
			addChild(
				new FunctionCallInternalTreeNode(
					UserFunctionDeclarationTreeNode.this,
					functionCallInternDeclaration));
		}
	}

	public void updateChildren() {
		updateChildrenIntern();
		SeSAmDeclarationTreeModelAdapter seSAmDeclarationTreeModelAdapter =
			SeSAmDeclarationTreeModelCreater.getSeSAmDeclarationTreeModelAdapter(this);

		if (seSAmDeclarationTreeModelAdapter != null)
			seSAmDeclarationTreeModelAdapter.reloadNode(this, true);
	}

	public IDeclaration getDeclaration() {
		return (IDeclaration) getUserObject();
	}

	public void remove() {
		getDeclaration().removeChangeListener(_changeListener);

		super.remove();
	}

	protected void stateChanged(ChangeEvent e) {
		updateChildrenDeffered();
	}
}

	
	public IObjectTreeNode createObjectTreeNode(IObjectTreeNode parent,
			Object userObject) {
		return new UserFunctionDeclarationTreeNode(parent,
				(IUserFunctionDeclaration) userObject);
	}
	
	private static final UserFunctionDeclarationTreeNodeFactory instance = new UserFunctionDeclarationTreeNodeFactory();
	
	public static UserFunctionDeclarationTreeNodeFactory getInstance() {
		return instance;
	}
}