/*
 * Created on 10.03.2004
 */
package de.uniwue.ki.mas.model.tree;

import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import de.uniwue.ki.mas.model.userInterface.IUserInterfaceDeclaration;
import de.uniwue.ki.util.collection.CollectionsHelper;
import de.uniwue.ki.util.tree.IObjectTreeNode;

class UserInterfaceTreeNode extends DefaultDeclarationTreeNode {
	private final SeSAmDeclarationTreeModelCreater creater;
	public final transient ChangeListener _changeListener =
		new ChangeListener() {
		public void stateChanged(ChangeEvent e) {
			UserInterfaceTreeNode.this.removeChildren();
			UserInterfaceTreeNode.this.initialize();

			SeSAmDeclarationTreeModelAdapter seSAmDeclarationTreeModelAdapter =
				SeSAmDeclarationTreeModelCreater
					.getSeSAmDeclarationTreeModelAdapter(
					UserInterfaceTreeNode.this);

			if (seSAmDeclarationTreeModelAdapter != null)
				seSAmDeclarationTreeModelAdapter.reloadNode(
					UserInterfaceTreeNode.this,
					false);
		}
	};

	public UserInterfaceTreeNode(
		SeSAmDeclarationTreeModelCreater creater,
		IObjectTreeNode parent,
		IUserInterfaceDeclaration userObject) {
		super(parent, userObject);
		this.creater = creater;

		initialize();

		userObject.addChangeListener(_changeListener);
	}

	void initialize() {
	    if (getUserObject()!=null && ((IUserInterfaceDeclaration)getUserObject()).getSimulationDeclaration()!=null) 
		addChildrens(
			CollectionsHelper.createIterator(
				SimulationDeclarationTreeNodeFactory.getInstance().createObjectTreeNode(
					this,
					((IUserInterfaceDeclaration) getUserObject())
						.getSimulationDeclaration())));
	}
}