/*
 * Created on 05.06.2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package de.uniwue.ki.mas.model.tree;

import java.util.Iterator;

import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import de.uniwue.ki.mas.basics.type.composed.IComposedTypeAttribute;
import de.uniwue.ki.mas.basics.type.composed.SpecificComposedType;
import de.uniwue.ki.mas.basics.type.enum.EnumItem;
import de.uniwue.ki.mas.basics.type.enum.ISpecificEnumType;
import de.uniwue.ki.mas.basics.type.user.IUserTypeDeclaration;
import de.uniwue.ki.mas.util.declaration.IDeclaration;
import de.uniwue.ki.util.tree.DefaultObjectTreeNode;
import de.uniwue.ki.util.tree.DefaultObjectTreeNodeLeaf;
import de.uniwue.ki.util.tree.IObjectTreeNode;
import de.uniwue.ki.util.tree.IObjectTreeNodeFactory;


final class UserTypeDeclarationTreeNodeFactory implements IObjectTreeNodeFactory {
	public class UserTypeDeclarationTreeNode extends DefaultObjectTreeNode {
		private final transient ChangeListener _changeListener = new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				UserTypeDeclarationTreeNode.this.stateChanged(e);
			}
		};

		public boolean isLeaf() {
			return false;
		}

		public UserTypeDeclarationTreeNode(IObjectTreeNode parent, IUserTypeDeclaration declaration) {
			super(parent, declaration);

			initialize(declaration);
		}

		public UserTypeDeclarationTreeNode(
			IObjectTreeNode parent,
			IUserTypeDeclaration declaration,
			Iterator childrens) {
			super(parent, declaration, childrens);

			initialize(declaration);
		}

		public UserTypeDeclarationTreeNode(
			IObjectTreeNode parent,
			IUserTypeDeclaration declaration,
			java.util.List childrenList) {
			super(parent, declaration, childrenList);

			initialize(declaration);
		}

		/**
		 * Extracted from constructor
		 */
		private void initialize(IUserTypeDeclaration declaration) {
			declaration.addChangeListener(_changeListener);

			updateChildrenIntern();
		}

		private void updateChildren() {
			updateChildrenIntern();

			SeSAmDeclarationTreeModelAdapter seSAmDeclarationTreeModelAdapter =
				SeSAmDeclarationTreeModelCreater.getSeSAmDeclarationTreeModelAdapter(this);

			if (seSAmDeclarationTreeModelAdapter != null)
				seSAmDeclarationTreeModelAdapter.reloadNode(this, true);
		}

		private void updateChildrenIntern() {
			IUserTypeDeclaration userTypeDeclaration = (IUserTypeDeclaration) getDeclaration();

			removeChildren();

			if (userTypeDeclaration.isComposedType()) {
				SpecificComposedType composedType = userTypeDeclaration.getSpecificComposedType();

				Iterator attributeIterator = composedType.getOwnAttributes();

				while (attributeIterator.hasNext()) {
					IComposedTypeAttribute element = (IComposedTypeAttribute) attributeIterator.next();
					addChild(new DefaultObjectTreeNodeLeaf(this, element));
				}

			} else {
				ISpecificEnumType specificEnumType = userTypeDeclaration.getSpecificEnumType();

				Iterator it = specificEnumType.getItemList().iterator();
				while (it.hasNext()) {
					EnumItem element = (EnumItem) it.next();
					addChild(new DefaultObjectTreeNodeLeaf(this, element));
				}
			}
		}

		public IDeclaration getDeclaration() {
			return (IDeclaration) getUserObject();
		}

		public void remove() {
			getDeclaration().removeChangeListener(_changeListener);
			((IUserTypeDeclaration) getDeclaration()).removeChangeListener(_changeListener);

			super.remove();
		}

		protected void stateChanged(ChangeEvent e) {
			updateChildren();
		}
	}

	
	public IObjectTreeNode createObjectTreeNode(IObjectTreeNode parent,
			Object userObject) {
		UserTypeDeclarationTreeNode userTypeTreeNode = new UserTypeDeclarationTreeNode(
				parent, (IUserTypeDeclaration) userObject);

		return userTypeTreeNode;
	}
	
	private static final UserTypeDeclarationTreeNodeFactory instance = new UserTypeDeclarationTreeNodeFactory();
	
	public static UserTypeDeclarationTreeNodeFactory getInstance() {
		return instance;
	}
}