/*
 * Created on 05.06.2004 @author Herrler
 */
package de.uniwue.ki.mas.model.tree;

import javax.swing.event.ChangeEvent;

import de.uniwue.ki.mas.entity.variableclass.IBodyVariableClassDeclaration;
import de.uniwue.ki.mas.entity.variableclass.IOwnDefaultValueFunctionCallDeclarationAble;
import de.uniwue.ki.mas.entity.variableclass.IVariableClassDeclaration;
import de.uniwue.ki.mas.util.declaration.IDeclaration;
import de.uniwue.ki.util.collection.CollectionsHelper;
import de.uniwue.ki.util.tree.IObjectTreeNode;
import de.uniwue.ki.util.tree.IObjectTreeNodeFactory;

final class VariableDeclarationTreeNodeFactory
		implements
			IObjectTreeNodeFactory {
	public class BodyVariableInstanceDeclarationTreeNode
			extends
				DefaultDeclarationTreeNode implements IUpdateChildrenAbleNode {

		public BodyVariableInstanceDeclarationTreeNode(IObjectTreeNode parent,
				IDeclaration declaration) {
			super(parent, declaration);
			updateChildren();
		}

		protected void stateChanged(ChangeEvent e) {
			updateChildrenDeffered();
			super.stateChanged(e);
		}

		public void updateChildren() {
			removeChildren();
			IDeclaration userObject = (IDeclaration) getUserObject();
			if ((userObject instanceof IOwnDefaultValueFunctionCallDeclarationAble)
					&& ((IOwnDefaultValueFunctionCallDeclarationAble) userObject)
							.getUsesOwnDefaulValueFunctionCallDeclaration())

				addChild(new FunctionCallInternalTreeNode(
						this,
						(((IOwnDefaultValueFunctionCallDeclarationAble) userObject)
								.getDefaultValueFunctionCallDeclaration())
								.getFunctionCallInternDeclaration()));
			else if (userObject instanceof IBodyVariableClassDeclaration) {
				IVariableClassDeclaration varClassDecl = ((IBodyVariableClassDeclaration) userObject)
						.getVariableClassDeclaration();
				addChild(new FunctionCallInternalTreeNode(this, varClassDecl
						.getDefaultValueFunctionCallDeclaration()
						.getFunctionCallInternDeclaration()));
				if (varClassDecl.getHasNextValueFunctionCallDeclaration()) {
					addChild(new FunctionCallInternalTreeNode(this,
							varClassDecl.getNextValueFunctionCallDeclaration()
									.getFunctionCallInternDeclaration()));
				}
			}
		}

		private void updateChildrenDeffered() {
			UpdateChildrenAbleNodeThread.getInstance().addNode(this);
		}
	}

	public IObjectTreeNode createObjectTreeNode(IObjectTreeNode parent,
			Object obj) {
		IDeclaration userObject = (IDeclaration) obj;
		DefaultDeclarationTreeNode bodyVariableClassdeclarationTreeNode = new BodyVariableInstanceDeclarationTreeNode(
				parent, userObject);

		return bodyVariableClassdeclarationTreeNode;
	}
	private static final VariableDeclarationTreeNodeFactory instance = new VariableDeclarationTreeNodeFactory();

	public static VariableDeclarationTreeNodeFactory getInstance() {
		return instance;
	}
}