package de.uniwue.ki.mas.model.userInterface;
import java.util.ArrayList;
import java.util.Map;

import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import de.uniwue.ki.mas.sim.simulation.ISimulationDeclaration;
import de.uniwue.ki.mas.util.declaration.*;
import de.uniwue.ki.util.copy.ICopyable;
import de.uniwue.ki.util.hash.IIsomorphicHashable;

/**
 * Creation date: 03.03.2004
 * @author Hartmann
 */

class UserInterfaceDeclaration extends AbstractDocumentableDeclaration implements IUserInterfaceDeclaration {
	private final transient ChangeListener _changeListener = new ChangeListener() {
		public void stateChanged(ChangeEvent e) {
			fireStateChanged();
		}
	};

//	private final DeclarationListListener _declarationListListener = new DeclarationListListener() {
//		public void declarationAdded(DeclarationListEvent event) {
//			IAnalysisDeclaration analysisDeclaration = (IAnalysisDeclaration)event.getDeclaration();
//			analysisDeclaration.addRemoveVetoListener(_neverRemoveVetoListener);
//
//		}
//		public void declarationRemoved(DeclarationListEvent event) {
//			IAnalysisDeclaration analysisDeclaration = (IAnalysisDeclaration)event.getDeclaration();
//			analysisDeclaration.removeRemoveVetoListener(_neverRemoveVetoListener);
//		}
//	};

//	private final DefaultDeclarationListAndFactory _endFunctionDeclarationListAndFactory =
//		new DefaultDeclarationListAndFactory(new DefaultDeclarationList() {
//		public boolean accept(Object anObject) {
//			return super.accept(anObject)
//				&& (anObject instanceof NamedFunctionCallDeclaration)
//				&& Utils.equals(
//					((NamedFunctionCallDeclaration)anObject).getMostGeneralOutputType(),
//					BooleanType.getInstance());
//		}
//		public String getName() {
//			return "End Function List";
//		}
//	}, new NamedFunctionCallDeclarationFactory(BooleanType.getInstance(), Boolean.FALSE));

	protected final RemoveVetoListener _neverRemoveVetoListener = new NeverRemoveVetoListener(this);
	private ISimulationDeclaration _simulationDeclaration;

//	private boolean _testSimulationDeclaration;
//	private final IDeclarationList _afterRunTestActionDefinitionList = new DefaultDeclarationList();
//	private final IDeclarationList _duringRunTestActionDefinitionList = new DefaultDeclarationList();

	protected UserInterfaceDeclaration() {
		super();
//
//		_analysisDeclarationList = new AnalysisDeclarationList();
//		_analysisDeclarationList.setComposition(false);
//		_analysisDeclarationList.addDeclarationListListener(_declarationListListener);
//
//		getAnalysisDeclarationList().addChangeListener(_changeListener);
//		getEndFunctionDeclarationListAndFactory().getDeclarationList().addChangeListener(_changeListener);
	}

	public UserInterfaceDeclaration(ISimulationDeclaration simulationDeclaration) {
		this();

		setSimulationDeclaration(simulationDeclaration);
	}

	public void copyInto(Object intoObject, Map objectMapping) {
		super.copyInto(intoObject, objectMapping);

		IUserInterfaceDeclaration intoUserInterfaceDeclaration = (IUserInterfaceDeclaration)intoObject;

//		intoSimulationDeclaration.setTestSimulationDeclaration(isTestSimulationDeclaration());
//		getAfterRunTestActionDefinitionList().copyInto(
//			intoSimulationDeclaration.getAfterRunTestActionDefinitionList(),
//			objectMapping);
//		getDuringRunTestActionDefinitionList().copyInto(
//			intoSimulationDeclaration.getDuringRunTestActionDefinitionList(),
//			objectMapping);

		if (intoUserInterfaceDeclaration.getSimulationDeclaration() == null)
			intoUserInterfaceDeclaration.setSimulationDeclaration(getSimulationDeclaration());

		// don't copy the individual analysis declarations
		//getAnalysisDeclarationList().copyInto(intoSimulationDeclaration.getAnalysisDeclarationList());

//		Assert.assertFalse(intoSimulationDeclaration.getAnalysisDeclarationList().isComposition());
//
//		intoSimulationDeclaration.getAnalysisDeclarationList().clear();
//
//		Iterator it = getAnalysisDeclarationList().iterator();
//		while (it.hasNext()) {
//			IAnalysisDeclaration analysisDeclaration = (IAnalysisDeclaration)it.next();
//
//			IAnalysisDeclaration copyAnalysisDeclaration;
//
//			if ((objectMapping != null) && (objectMapping.containsKey(analysisDeclaration))) {
//				copyAnalysisDeclaration = (IAnalysisDeclaration)objectMapping.get(analysisDeclaration);
//
//			} else {
//				copyAnalysisDeclaration = analysisDeclaration;
//			}
//
//			if (!intoSimulationDeclaration.getAnalysisDeclarationList().contains(copyAnalysisDeclaration)) {
//				intoSimulationDeclaration.getAnalysisDeclarationList().add(copyAnalysisDeclaration);
//			}
//		}
//
//		getEndFunctionDeclarationListAndFactory().copyInto(
//			intoSimulationDeclaration.getEndFunctionDeclarationListAndFactory(),
//			objectMapping);
	}

	protected ICopyable createInstance(Map objectMapping) {
		return new UserInterfaceDeclaration();
	}

	protected void fireStateChanged() {
		super.fireStateChanged();
	}

//	public IDeclarationList getAfterRunTestActionDefinitionList() {
//		return _afterRunTestActionDefinitionList;
//	}
//
//	public final AnalysisDeclarationList getAnalysisDeclarationList() {
//		return _analysisDeclarationList;
//	}

	protected String getDefaultName() {
		if (getSimulationDeclaration() == null)
			return "UserInterface [no simulation given]";
		else
			return "UserInterface [" + getSimulationDeclaration().getName() + "]";
	}

//	public IDeclarationList getDuringRunTestActionDefinitionList() {
//		return _duringRunTestActionDefinitionList;
//	}
//
//	public final IDeclarationListAndFactory getEndFunctionDeclarationListAndFactory() {
//		return _endFunctionDeclarationListAndFactory;
//	}

	public ISimulationDeclaration getSimulationDeclaration() {
		return _simulationDeclaration;
	}

	public boolean isomorphicEquals(IIsomorphicHashable anObject) {
		if (anObject == this)
			return true;

		if (!super.isomorphicEquals(anObject)) {
			return false;
		}

		if (!(anObject instanceof IUserInterfaceDeclaration)) {
			return false;
		}

		IUserInterfaceDeclaration userInterfaceDeclaration = (IUserInterfaceDeclaration)anObject;

		return 
//			   isTestSimulationDeclaration() == simulationDeclaration.isTestSimulationDeclaration()
//			&& getAfterRunTestActionDefinitionList().isomorphicEquals(
//				simulationDeclaration.getAfterRunTestActionDefinitionList())
//			&& getDuringRunTestActionDefinitionList().isomorphicEquals(
//				simulationDeclaration.getDuringRunTestActionDefinitionList())
//			&& getAnalysisDeclarationList().isomorphicEquals(simulationDeclaration.getAnalysisDeclarationList())
			   isomorphicEquals(getSimulationDeclaration(), userInterfaceDeclaration.getSimulationDeclaration());
//			&& getEndFunctionDeclarationListAndFactory().isomorphicEquals(
//				simulationDeclaration.getEndFunctionDeclarationListAndFactory());
	}

	public int isomorphicHashCode() {
		return
//			  13 * getDuringRunTestActionDefinitionList().isomorphicHashCode()
//			+ 11 * getAfterRunTestActionDefinitionList().isomorphicHashCode()
			  7 * getSimulationDeclaration().isomorphicHashCode();
//			+ 5 * getAnalysisDeclarationList().isomorphicHashCode()
//			+ 3 * getEndFunctionDeclarationListAndFactory().isomorphicHashCode()
//			+ isomorphicHashCode(isTestSimulationDeclaration());
	}

//	public boolean isTestSimulationDeclaration() {
//		return _testSimulationDeclaration;
//	}

	public void remove() {
//		getAnalysisDeclarationList().removeChangeListener(_changeListener);
//		getAnalysisDeclarationList().clear();
//		getEndFunctionDeclarationListAndFactory().getDeclarationList().removeChangeListener(_changeListener);
//
//		getAfterRunTestActionDefinitionList().remove();
//		getDuringRunTestActionDefinitionList().remove();

		setSimulationDeclaration(null);

		super.remove();
	}

	public void setSimulationDeclaration(ISimulationDeclaration simulationDeclaration) {
		ISimulationDeclaration oldValue = _simulationDeclaration;

		_simulationDeclaration = simulationDeclaration;

		if (oldValue != null) {
			oldValue.removeRemoveVetoListener(_neverRemoveVetoListener);
			oldValue.removeChangeListener(_changeListener);
		}

		if (simulationDeclaration != null) {
			simulationDeclaration.addRemoveVetoListener(_neverRemoveVetoListener);
			simulationDeclaration.addChangeListener(_changeListener);
		}

		firePropertyChange("simulationDeclaration", oldValue, simulationDeclaration);
		fireStateChanged();
	}

	/* (non-Javadoc)
	 * @see de.uniwue.ki.mas.model.userInterface.IUserInterfaceDeclaration#getInterfaceItems()
	 */
	public ArrayList getInterfaceItemDeclarationList() {
		// TODO Auto-generated method stub
		return null;
	}

//	public void setTestSimulationDeclaration(boolean testSimulationDeclaration) {
//		_testSimulationDeclaration = testSimulationDeclaration;
//
//		fireStateChanged();
//	}
}