package de.uniwue.ki.mas.model.userInterface;
import de.uniwue.ki.mas.sim.simulation.*;
import de.uniwue.ki.mas.util.declaration.AbstractDeclarationFactory;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: 03.03.2004
 * @author Hartmann
 */

public class UserInterfaceDeclarationFactory extends AbstractDeclarationFactory {
	private final SimulationDeclarationFactory _simulationDeclarationFactory;
	private final SimulationDeclarationList _simulationDeclarationList;

	public UserInterfaceDeclarationFactory(
		SimulationDeclarationList simulationDeclarationList,
		SimulationDeclarationFactory simulationDeclarationFactory) {
		super();

		_simulationDeclarationList = simulationDeclarationList;
		_simulationDeclarationFactory = simulationDeclarationFactory;
	}

	public IDeclaration createDeclaration() {
		return createUserInterfaceDeclaration();
	}

	public IUserInterfaceDeclaration createUserInterfaceDeclaration() {
		if (_simulationDeclarationList.size() > 0)
			return createUserInterfaceDeclaration(
				(ISimulationDeclaration) _simulationDeclarationList.getElementAt(0));
		else {
			ISimulationDeclaration newSimulationDeclaration =
				_simulationDeclarationFactory.createSimulationDeclaration();
			_simulationDeclarationList.add(newSimulationDeclaration);

			return createUserInterfaceDeclaration(newSimulationDeclaration);
		}
	}

	public IUserInterfaceDeclaration createUserInterfaceDeclaration(ISimulationDeclaration simulationDeclaration) {
		IUserInterfaceDeclaration userInterfaceDeclaration = new UserInterfaceDeclaration(simulationDeclaration);

		//addDefaultAnalysisDeclarations(simulationDeclaration);

		return userInterfaceDeclaration;
	}

//	public ISimulationWithNameFunctionCallDeclDeclaration createSimulationWithNameFunctionCallDeclDeclaration(ISituationDeclaration situationDeclaration) {
//		ISimulationWithNameFunctionCallDeclDeclaration simulationDeclaration =
//			new SimulationWithNameFunctionCallDeclDeclaration(situationDeclaration);
//
//		addDefaultAnalysisDeclarations(simulationDeclaration);
//
//		return simulationDeclaration;
//	}
//
//	public ISimulationWithNameFunctionCallDeclDeclaration createSimulationWithNameFunctionCallDeclDeclaration(ISimulationDeclaration simulationDeclaration) {
//		HashMap objectMapping = new HashMap();
//
//		if (simulationDeclaration instanceof ISimulationWithNameFunctionCallDeclDeclaration) {
//			return (ISimulationWithNameFunctionCallDeclDeclaration) simulationDeclaration.copy(objectMapping);
//
//		} else {
//			SimulationWithNameFunctionCallDeclDeclaration declaration =
//				new SimulationWithNameFunctionCallDeclDeclaration(
//					(ISituationDeclaration) simulationDeclaration.getSituationDeclaration().copy(
//						objectMapping));
//
//			simulationDeclaration.copyInto(declaration, objectMapping);
//
//			return declaration;
//		}
//	}
//
//	public ISimulationWithNameFunctionCallDeclDeclaration createSimulationWithNameFunctionCallDeclDeclaration() {
//		ISimulationWithNameFunctionCallDeclDeclaration simulationDeclaration =
//			new SimulationWithNameFunctionCallDeclDeclaration(
//				_simulationDeclarationFactory.createSituationDeclaration());
//
//		addDefaultAnalysisDeclarations(simulationDeclaration);
//
//		return simulationDeclaration;
//	}
}