package de.uniwue.ki.mas.model.userInterface;
import de.uniwue.ki.mas.sim.simulation.*;
import de.uniwue.ki.mas.util.declaration.DefaultDeclarationListAndFactory;

/**
 * Creation date: 03.03.2004
 * @author Hartmann
 */
public class UserInterfaceDeclarationListAndFactory extends DefaultDeclarationListAndFactory {
	public UserInterfaceDeclarationListAndFactory(
		UserInterfaceDeclarationList userInterfaceDeclarationList,
		UserInterfaceDeclarationFactory userInterfaceDeclarationFactory) {

		super(userInterfaceDeclarationList, userInterfaceDeclarationFactory);
	}

	public UserInterfaceDeclarationListAndFactory(
		SimulationDeclarationList simulationDeclarationList,
		SimulationDeclarationFactory simulationDeclarationFactory) {

		this(
			new UserInterfaceDeclarationList(),
			new UserInterfaceDeclarationFactory(
				simulationDeclarationList,
				simulationDeclarationFactory));
	}

	public UserInterfaceDeclarationListAndFactory(
		SimulationDeclarationListAndFactory simulationDeclarationListAndFactory) {
		this(
			simulationDeclarationListAndFactory.getSimulationDeclarationList(),
			simulationDeclarationListAndFactory.getSimulationDeclarationFactory());
	}

	public UserInterfaceDeclarationFactory getUserInterfaceDeclarationFactory() {
		return (UserInterfaceDeclarationFactory) getDeclarationFactory();
	}

	/**
	 * @return UserInterfaceDeclarationList
	 */
	public UserInterfaceDeclarationList getUserInterfaceDeclarationList() {
		return (UserInterfaceDeclarationList) getDeclarationList();
	}
}