/**
 * Created on 29.08.2002
 *
 * This class is responsible for //insert purpose here//
 * 
 * @author glueckselig
 */
package de.uniwue.ki.mas.modelprint;

import de.uniwue.ki.mas.modelprint.auxiliary.UniqueAnchorGenerator;
import de.uniwue.ki.mas.modelprint.exceptions.CreateNoLinkException;

public class Base {
		protected static UniqueAnchorGenerator _idMap;
		
		
/** escaped Strings, d.h. wandelt < und > in entsprechende HTML-Entities um
	 */
	public static String escape(String string) {
		return string
			.replaceAll("<", "&lt;")
			.replaceAll(">", "&gt;")
			.replaceAll("", "&ouml;")
			.replaceAll("", "&uuml;")
			.replaceAll("", "&auml;")
			.replaceAll("", "&Ouml;")
			.replaceAll("", "&Uuml;")
			.replaceAll("", "&Auml;")
			.replaceAll("", "&szlig;");
	}
	
	protected static String createLink(Object anchor, String title) {

		if (anchor instanceof String)
			return "<a href=\"#" + escape((String) anchor) + "\">" + escape(title) + "</a>";
		else
			try {
				return "<a href=\"#" + _idMap.getReference(anchor) + "\">" + title + "</a>";
			} catch (CreateNoLinkException e) {
				return title;
			}
	}
}
