/**
 * Created on 04.07.2002
 *
 * This class is supposed to encapsulate all the protected-variables for all the subclasses.
 * Furthermore it implementes all the auxiliary-methods like write(String) and the Anchor/Link-Methods
 * 
 * @author glueckselig
 */

package de.uniwue.ki.mas.modelprint;

import de.uniwue.ki.mas.modelprint.auxiliary.TagStack;
import de.uniwue.ki.mas.modelprint.exceptions.CreateNoLinkException;

public class HTMLModelWriterBase extends Base{
	protected static TagStack _tags;


	protected static BufferedHTMLWriter _htmlWriter;

	protected HTMLFunctionsWriter _functionsWriter;

	// ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

	protected static final String CLASS_HEADING = "<h3 style=\"margin-left: -3em;\">";
	protected static final String SUB1_HEADING = "<h4 style=\"margin-left: -2em;\">";
	protected static final String SUB2_HEADING = "<h5 style=\"margin-left: -1em;\">";
	protected static final String SUB3_HEADING = "<h5 style=\"margin-left: -0.3em; font-weight:lighter;\">";

	protected static final String BOXED = "<div style=\"border: silver thin solid;\">";

	protected static final String BOXED_COMPOSED =
		"<div style=\"border: silver thin solid;margin: 0.5em 0;\">";

	protected static final String BOXED_ATOMIC = "<div style=\"border: green thin solid;margin: 0.5em 0;\">";

	protected static final String INVISIBLE_BOX_AFTER_FUNCTION_NAME = "<div style=\"margin-left:1em;\">";

	//	protected static final String SPACE_PARAMETER = "<span style=\"margin-left:3em\">";
	protected static final String SPACE_TO_FUNCTION_NAME = "<span style=\"margin-left:1em;\">";

	protected static final String CSV_BLOCK = "<div style=\"margin-left:1em;padding: 0.5em 0em;\">";
	protected static final String ANALYSIS_ITEM_MARGIN_TOP = "<div style=\"margin-top:2em\">";

	//	FunctionDisplayWrapper :::::::::::::::::::::::::::::::::::::::::
	protected static final String USER_FUNCTION_MARGIN_TOP = "<div style=\"margin-top:2em\">";
	protected static final String USER_FUNCTION_PARAMETER_BOX =
		//		"<div style=\"margin-top:0; margin-left:5em;\">";
	"<span style=\"margin-top:0; margin-left:2em;\">";
	//	FunctionDisplayWrapper :::::::::::::::::::::::::::::::::::::::::

	// ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

	protected final String _emptyTableRow = "<tr><td height=\"15\" colspan=\"2\"></td></tr>";

	protected static final String FILE_OUT = "c:\\temp\\sesam-print.html";

	protected static final String ROOT_FUNCTION =
		"<div style=\"margin-left:0.5; border: blue thin dashed;margin: 2% 0%;\">";

	protected void writeAnchor(Object anchor) {
		write(createAnchor(anchor));
	}

	protected static String createAnchor(Object anchor) {

		if (anchor instanceof String)
			return "<a name=\"" + escape((String) anchor) + "\"></a>";
		else
			try {
				return "<a name=\"" + _idMap.getReference(anchor) + "\"></a>";
			} catch (CreateNoLinkException e) {
				return "";
			}
	}

	protected void writeLink(Object anchor, String title) {
		write(createLink(anchor, title));
	}

	protected static String createLink(Object anchor, String title) {

		if (anchor instanceof String)
			return "<a href=\"#" + escape((String) anchor) + "\">" + escape(title) + "</a>";
		else
			try {
				return "<a href=\"#" + _idMap.getReference(anchor) + "\">" + title + "</a>";
			} catch (CreateNoLinkException e) {
				return title;
			}
	}

	

	protected void write(String message) {
		_htmlWriter.write(message);
	}
}
