package de.uniwue.ki.mas.modelprint;

import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

import javax.swing.JFileChooser;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;

import de.uniwue.ki.gui.mas.model.IGUISeSAmDeclaration;
import de.uniwue.ki.gui.mas.model.plugin.ISeSAmMenuPlugin;
import de.uniwue.ki.gui.util.ExtensionsFileFilter;
import de.uniwue.ki.gui.util.SwingMoreUtilities;
import de.uniwue.ki.mas.model.ISeSAmDeclaration;
import de.uniwue.ki.util.file.FileUtilities;

/**
 * @author Scholz Marcus
 * 17.12.2003	01:57:07
 */
public class SaveMenuPlugin implements ISeSAmMenuPlugin {
	private Component _parent;
	private File _oldDirectory = null;
	private IGUISeSAmDeclaration _guiSeSAmDeclaration;

	public void setGUISeSAmDeclaration(IGUISeSAmDeclaration guiSeSAmDeclaration) {
		_guiSeSAmDeclaration = guiSeSAmDeclaration;
	}

	public JMenuItem createJMenuItemForPlugin() {

		JMenuItem item = new JMenuItem();

		item.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				saveAsModelHTML();
		}});
		item.setText("SaveAsHTML");
		return item;
	}
	
	protected ISeSAmDeclaration getSeSAmDeclaration() {
		return _guiSeSAmDeclaration.getSeSAmDeclaration();
		
	}
	private IGUISeSAmDeclaration getGUISeSAmDeclaration() {
					return _guiSeSAmDeclaration;
				
				}private File choiceFile(File oldFile, ExtensionsFileFilter extensionsFileFilter) {
	JFileChooser fileChooser = new JFileChooser();
	fileChooser.addChoosableFileFilter(extensionsFileFilter);

	if (oldFile != null) {
		fileChooser.setSelectedFile(oldFile);

	} else if (_oldDirectory != null) {
		fileChooser.setCurrentDirectory(_oldDirectory);
	}

	if (fileChooser.showSaveDialog(null) != JFileChooser.APPROVE_OPTION) {
		return null;

	} else {
		return fileChooser.getSelectedFile();
	}
}
	public void setParent(Component parent) {
		_parent = parent;
	}
	
	public Component getParent(){
		return _parent;
	}
	
	
		public boolean saveAsModelHTML() {

			File modelFile = getSeSAmDeclaration().getFile();
			File oldHTMLFile =
				(modelFile == null) ? null : FileUtilities.changeFileStringSuffix(modelFile, "html");

			File htmlFile = choiceFile(oldHTMLFile, new ExtensionsFileFilter("HTML (*.html)", "html"));

			if (htmlFile == null) {
				return false;
			}

			htmlFile = FileUtilities.getFileWithSuffix(htmlFile, "html");

			if (!htmlFile.exists()) {
				HTMLModelWriter.writeHTMLFile(htmlFile, getSeSAmDeclaration());
				return true;

			} else {
				JOptionPane optionPane =
					new JOptionPane(
						"Replace existing file?",
						JOptionPane.QUESTION_MESSAGE,
						JOptionPane.YES_NO_CANCEL_OPTION);

				getGUISeSAmDeclaration().getFrameFactory().addModalPanel(
//					getSeSAmMainDesktopFrame(),
					getParent(),
					"Saving into '" + htmlFile.getName() + "'",
					optionPane);

				if (SwingMoreUtilities.userChoiceOption(optionPane, JOptionPane.YES_OPTION)) {
					HTMLModelWriter.writeHTMLFile(htmlFile, getSeSAmDeclaration());
					return true;

				} else if (SwingMoreUtilities.userChoiceOption(optionPane, JOptionPane.NO_OPTION)) {
					return saveAsModelHTML();

				} else {
					return false;
				}
			}
		}

}
