/**
 * Created on 07.10.2002
 *
 * This class is responsible for //insert purpose here//
 * 
 * @author glueckselig
 */
package de.uniwue.ki.mas.modelprint;

import java.io.File;
import java.io.IOException;

import junit.framework.TestCase;
import junit.framework.TestSuite;
import de.uniwue.ki.mas.model.ISeSAmDeclaration;
import de.uniwue.ki.mas.model.SeSAmDeclarationFactory;
import de.uniwue.ki.mas.test.TestXMLTestModels;
import de.uniwue.ki.mas.xml.XMLReader;
import de.uniwue.ki.mas.xml.reader.XMLReadException;

public class TestHTMLWriter extends TestCase {

	private File _sourceFile;

	public TestHTMLWriter(String name, File sourceFile) {
		super(name);

		_sourceFile = sourceFile;
	}

	public static void main(String[] args) {
		junit.textui.TestRunner.run(TestHTMLWriter.class);
	}

	public void testGenerateHTMLmodel() throws IOException {
		ISeSAmDeclaration seSAmDeclaration = SeSAmDeclarationFactory.createSeSAmDeclaration(false);

		seSAmDeclaration.setFile(_sourceFile);

		try {
			XMLReader.readModelInto(_sourceFile, seSAmDeclaration, null, true);

		} catch (XMLReadException e) {
		} catch (IOException e) {
		}

		File htmlFile = File.createTempFile("sesamHTMLtest", "html");

		HTMLModelWriter.writeHTMLFile(htmlFile, seSAmDeclaration);

		System.out.println("Fertig mit '" + htmlFile.getName() + "'.\n");

		htmlFile.delete();
	}

	private static File getDirectory(String name) {
		return new File(TestHTMLWriter.class.getPackage().getName().replace('.', '/') + "/" + name);
	}

	public static TestSuite suite() {
		TestSuite anSuite = new TestSuite("HTMLModels");

		addModelFiles(anSuite, TestXMLTestModels.LOAD_MODEL_DIRECTORY);
		addModelFiles(anSuite, TestXMLTestModels.SIMULATE_MODEL_DIRECTORY);

		return anSuite;
	}

	public static void addModelFiles(TestSuite anSuite, String dir) {
		File[] files = getDirectory(dir).listFiles();
		
		if (files != null) {
			for (int i = 0; i < files.length; i++) {
				if (files[i].getName().endsWith(".xml")) {
					anSuite.addTest(new TestHTMLWriter("testGenerateHTMLmodel", files[i]));
				}
			}
		}
	}

	public String getName() {
		return super.getName() + " (" + _sourceFile.getName() + ")";
	}

}
