package de.uniwue.ki.mas.modelprint.auxiliary;

import java.util.Stack;

/**
 * @author glueckselig
 * 
 * Just matches the starting-tag automatically. This is quite comfortable when changing 
 * elements in one of the static final Strings. The closing tag will be changed automatically.
 *  
 */
public class TagStack extends Stack {

	public String closeTag() {
		return "</" + (String) pop() + ">";
	}

	public String openTag(String item) {
		int indexSpace = item.indexOf(" ");
		int indexBrace = item.indexOf(">");
		
		if (indexSpace < 0)
			indexSpace = Integer.MAX_VALUE;
		if (indexBrace < 0)
			indexBrace = Integer.MAX_VALUE;
			
		push(item.substring(1, indexSpace > indexBrace ? indexBrace : indexSpace));
		return item;
	}
}
