/**
 * Created on 27.08.2002
 *
 * This class is responsible for //insert purpose here//
 * 
 * @author glueckselig
 */
package de.uniwue.ki.mas.modelprint.layouter;

import java.util.LinkedList;

import de.uniwue.ki.mas.modelprint.Base;
import de.uniwue.ki.mas.modelprint.auxiliary.TagStack;

abstract public class Layouter extends Base {
	
	public String toString(){
		return toString(0,0);
	}

	abstract public String toString(int indentationDepth, int lengthLine);

	//::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::	

	protected String openTags(String tag, int depth) {
		StringBuffer result = new StringBuffer();
		while (depth > 0) {
			result.append(_tags.openTag(tag));
			depth--;
		}
		return result.toString();
	}

	protected String closeTags(int depth) {
		StringBuffer result = new StringBuffer();
		while (depth > 0) {
			result.append(_tags.closeTag());
			depth--;
		}
		return result.toString();
	}

	//::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::	

	protected String embrace(int index, int indentationDepth, int lengthLine) {
		if (((Layouter) _levelBelow.get(index)).getChildCount() == 0) {
			// type >= SIMPLE_THRESHOLD || 
			return get(index, indentationDepth, lengthLine);
		} else {
			return "[" + get(index, indentationDepth, lengthLine) + "]";
		}
	}

	protected int getChildCount() {
		return _levelBelow.size();
	}

	//::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::	

	protected static final String ONE_LEVEL =
		"<div style=\"margin-left:2em;margin-top:0em;border: silver solid thin;\">";
	//	protected static final String USER_FUNCTION_MARGIN_TOP = "<div style=\"margin-top:2em\">";
	//	protected static final String USER_FUNCTION_PARAMETER_BOX =
	//		"<span style=\"margin-top:0; margin-left:2em;\">";
	//	protected static final String FUNCTION_NAME_LAYOUT = "<span style=\"margin-top:2em;\">";
	protected static final String FUNCTION_LAYOUT = "<div style=\"margin-top:2em;\">";
	//::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

	//	protected int getTypeOfChild(int index) {
	//		return ((FunctionLayoutWrapper) _levelBelow.get(index)).getType();
	//	}

	protected String get(int index, int indentationDepth, int lengthLine) {
		return ((Layouter) _levelBelow.get(index)).toString(indentationDepth + 1, lengthLine);
	}

	protected String getNoIndent(int index) {
		return ((Layouter) _levelBelow.get(index)).toString(0, 0);
	}

	public void addChild(Layouter sibl) {
		_levelBelow.add(sibl);
	}

	//::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

	protected LinkedList _levelBelow;
	protected String _beginValue;
	protected String _endValue;
	//	protected int _type;

	protected static TagStack _tags = new TagStack();

	public Layouter() {
		this("", "");
	}

	public Layouter(String value1, String value2) {
		_levelBelow = new LinkedList();

		_beginValue = value1;
		_endValue = value2;
	}

}
