package de.uniwue.ki.mas.refactoring;
import java.util.HashMap;

import de.uniwue.ki.mas.basics.functionCall.IComposedFunctionCallInternDeclaration;
import de.uniwue.ki.mas.basics.functionCall.IFunctionCallInternDeclaration;
import de.uniwue.ki.mas.basics.functionUser.IUserFunctionDeclaration;
import de.uniwue.ki.mas.model.ISeSAmDeclaration;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * @author Rainer Herrler
 */
public class InlineMethod extends AbstractRefactoring {

	protected InlineMethod(ISeSAmDeclaration seSAmDeclaration, Object _refactoringSubject) {
		super(seSAmDeclaration, _refactoringSubject);
		this.name = "Inline Method";
	}

	public boolean execute(IRefactoringUI ui) {
		IComposedFunctionCallInternDeclaration declToModify = getComposedFunctionCallInternDecl();
		IUserFunctionDeclaration funToInline =
			(IUserFunctionDeclaration)declToModify.getSpecificFunctionDeclaration();

		Morpher morpher =
			new Morpher(
				CollectionsHelper.asArrayList(funToInline.getFunctionArgumentDeclarationList().iterator()),
				CollectionsHelper.asArrayList(getComposedFunctionCallInternDecl().getChildren()));

		IFunctionCallInternDeclaration funCopy =
			(IFunctionCallInternDeclaration)funToInline
				.getParametricFunctionCallDeclaration()
				.getFunctionCallDeclaration()
				.getFunctionCallInternDeclaration()
				.copy(new HashMap());

		Morpher.replaceInternCall(declToModify, funCopy);
		
		morpher.morph(funCopy);
		

		return true;
	}

	public boolean isApplicable() {
		return (
			(getRefactoringSubject() instanceof IComposedFunctionCallInternDeclaration)
				&& ((getComposedFunctionCallInternDecl()).getSpecificFunctionDeclaration()
					instanceof IUserFunctionDeclaration));
	}

	private IComposedFunctionCallInternDeclaration getComposedFunctionCallInternDecl() {
		if (getRefactoringSubject() instanceof IComposedFunctionCallInternDeclaration)
			return (IComposedFunctionCallInternDeclaration)getRefactoringSubject();
		return null;
	}
}
