package de.uniwue.ki.mas.refactoring;

import java.util.AbstractList;
import java.util.Iterator;

import de.uniwue.ki.mas.basics.functionUser.IUserFunctionDeclaration;
import de.uniwue.ki.mas.model.ISeSAmDeclaration;

/**
 * @author Michael Scherer
 */
public class MoveToUserFunctions extends MoveToUserFeature {

	public MoveToUserFunctions(ISeSAmDeclaration seSAmDeclaration, Object _refactoringSubject) {
		super(seSAmDeclaration, _refactoringSubject);
		this.name = "Move To User Functions";
	}
	
	public boolean isApplicable() {
		return (
				isUserFunctionWithoutInternalReferences(getRefactoringSubject()) &&
				isUserFeatureFunction(getRefactoringSubject()));
	}

	public boolean execute(IRefactoringUI ui) {
		return execute(getSeSAmDeclaration().getSeSAmModelDeclaration()
				.getSeSAmModelBasicsDeclaration().getUserFunctionDeclarationListAndFactory()
				.getUserFunctionDeclarationList());
	}
	
	private boolean isUserFeatureFunction(Object function) {
		if (!(function instanceof IUserFunctionDeclaration))
			return false;
		
		Iterator declarationLists = getUserFeatureFunctionDeclarationLists().iterator();

		while(declarationLists.hasNext())
			if (((AbstractList) declarationLists.next()).contains(function))
				return true;
			
		return false;
	}
}
