package de.uniwue.ki.mas.sim.analysis;

import java.util.Iterator;

import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.basics.type.ISpecificType;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.mas.sim.simulation.ISimulationCreateFunctionArgs;
import de.uniwue.ki.mas.util.declaration.AbstractDeclaration;

/**
 * Creation date: 05.07.2002, 14:07:03
 * @author oechslein
 */
public abstract class AbstractAnalysisTypeDeclaration
	extends AbstractDeclaration
	implements IAnalysisTypeDeclaration {

	protected IFunction[] createValueFunctionArray(
		ISimulationCreateFunctionArgs createFunctionArgs,
		IAnalysisDeclaration analysisDeclaration)
		throws ModelCompilingException {

		AnalysisItemDeclarationList analysisItemDeclarationList =
			getAnalysisItemDeclarationList(analysisDeclaration);

		IFunction[] valueFunctions = new IFunction[analysisItemDeclarationList.size()];
		int index = 0;
		Iterator it = analysisItemDeclarationList.iterator();
		while (it.hasNext()) {
			IAnalysisItemDeclaration currIAnalysisItemDeclaration = (IAnalysisItemDeclaration) it.next();

			valueFunctions[index] =
				currIAnalysisItemDeclaration.getValueFunctionCallDeclaration().createFunction(
					createFunctionArgs);

			index++;
		}
		return valueFunctions;
	}

	protected AnalysisItemDeclarationList getAnalysisItemDeclarationList(IAnalysisDeclaration analysisDeclaration) {
		return analysisDeclaration
			.getAnalysisItemDeclarationListAndFactory()
			.getAnalysisItemDeclarationList();
	}

	protected String[] createStringArray(IAnalysisDeclaration analysisDeclaration) {
		AnalysisItemDeclarationList analysisItemDeclarationList =
			getAnalysisItemDeclarationList(analysisDeclaration);

		String[] names = new String[analysisItemDeclarationList.size()];

		int index = 0;
		Iterator it = analysisItemDeclarationList.iterator();
		while (it.hasNext()) {
			IAnalysisItemDeclaration currIAnalysisItemDeclaration = (IAnalysisItemDeclaration) it.next();

			names[index] = currIAnalysisItemDeclaration.getName();

			index++;
		}

		return names;
	}

	protected ISpecificType[] createValueTypeArray(IAnalysisDeclaration analysisDeclaration) {
		AnalysisItemDeclarationList analysisItemDeclarationList =
			getAnalysisItemDeclarationList(analysisDeclaration);

		ISpecificType[] types = new ISpecificType[analysisItemDeclarationList.size()];

		int index = 0;
		Iterator it = analysisItemDeclarationList.iterator();
		while (it.hasNext()) {
			IAnalysisItemDeclaration currIAnalysisItemDeclaration = (IAnalysisItemDeclaration) it.next();

			types[index] =
				currIAnalysisItemDeclaration.getValueFunctionCallDeclaration().getSpecificOutputType();

			index++;
		}

		return types;
	}
}
