package de.uniwue.ki.mas.sim.analysis;

import de.uniwue.ki.mas.util.declaration.*;

public class AnalysisItemDeclarationListAndFactory
	extends AbstractDeclarationListAndFactory
	implements IDeclarationListAndFactory {

	private final AnalysisDeclaration _analysisDeclaration;

	public AnalysisItemDeclarationListAndFactory(AnalysisDeclaration analysisDeclaration) {
		super();

		_analysisDeclaration = analysisDeclaration;
	}

	public AnalysisItemDeclarationList getAnalysisItemDeclarationList() {
		return _analysisDeclaration.getAnalysisItemDeclarationList();
	}

	public IAnalysisItemDeclarationFactory getAnalysisItemDeclarationFactory() {
		return _analysisDeclaration.getAnalysisTypeDeclaration().getAnalysisItemDeclarationFactory();
	}

	public IDeclarationFactory getDeclarationFactory() {
		return getAnalysisItemDeclarationFactory();
	}

	public IDeclarationList getDeclarationList() {
		return getAnalysisItemDeclarationList();
	}
}
