package de.uniwue.ki.mas.sim.analysis;
import java.util.*;

import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.mas.sim.simulation.ISimulationCreateFunctionArgs;
import de.uniwue.ki.util.hash.IIsomorphicHashable;
/**
 * Creation date: (28.11.2001 17:20:13)
 * @author Christoph Oechslein
 */
public class BlockChartAnalysisTypeDeclaration
	extends AbstractAnalysisTypeDeclaration
	implements IAnalysisTypeDeclaration {

	public BlockChartAnalysisTypeDeclaration() {
		super();
	}

	public void copyInto(Object intoObject, java.util.Map objectMapping) {
		super.copyInto(intoObject, objectMapping);

		// BlockChartAnalysisTypeDeclaration intoBlockChartAnalysisTypeDeclaration = (BlockChartAnalysisTypeDeclaration) intoObject;

		// intoBlockChartAnalysisTypeDeclaration.setFileString(getFileString());
	}


	public IAnalysis createAnalysis(
		ISimulationCreateFunctionArgs createFunctionArgs,
		IAnalysisDeclaration analysisDeclaration)
		throws ModelCompilingException {

		AnalysisItemDeclarationList analysisItemDeclarationList =
			getAnalysisItemDeclarationList(analysisDeclaration);

		List nameFunctions = new ArrayList(analysisItemDeclarationList.size());
		List valueFunctions = new ArrayList(analysisItemDeclarationList.size());

		Iterator it = analysisItemDeclarationList.iterator();
		while (it.hasNext()) {
			IAnalysisItemDeclaration currIAnalysisItemDeclaration = (IAnalysisItemDeclaration) it.next();

			nameFunctions.add(currIAnalysisItemDeclaration.getName());
			valueFunctions.add(
				currIAnalysisItemDeclaration.getValueFunctionCallDeclaration().createFunction(
					createFunctionArgs));
		}

		return new BlockChartAnalysis(
			analysisDeclaration,
			createFunctionArgs,
			createStringArray(analysisDeclaration),
			createValueFunctionArray(createFunctionArgs, analysisDeclaration));
	}


	public IAnalysisItemDeclarationFactory getAnalysisItemDeclarationFactory() {
		return ChartAnalysisItemDeclarationFactory.getInstance();
	}


	public String getName() {
		return "Block Chart";
	}


	public boolean isomorphicEquals(IIsomorphicHashable anObject) {
		return equals(anObject);
	}


	public int isomorphicHashCode() {
		return hashCode();
	}
}