package de.uniwue.ki.mas.sim.analysis;
import java.util.LinkedList;
/**
 * Creation date: (05.03.2002 10:34:34)
 * @author Christoph Oechslein
 */
public final class BoundedStack {
    private final int _windowSize;
    private final LinkedList _array;

public BoundedStack(int windowSize) {
    this(new LinkedList(), windowSize);
}


private BoundedStack(LinkedList array, int windowSize) {
    super();

    _windowSize = windowSize;
    _array = array;
}


/**
 * @param element Object
 */
public synchronized void addValue(Object element) {
    _array.addFirst(element);

    if ((_windowSize > 0) && (size() > _windowSize)) {
        _array.removeLast();
    }
}


public synchronized Object get(int index) {
    return _array.get(index);
}


public synchronized int size() {
    return _array.size();
}
}