package de.uniwue.ki.mas.sim.analysis;
import de.uniwue.ki.mas.basics.type.DoubleType;
import de.uniwue.ki.mas.util.declaration.AbstractDeclarationFactory;
import de.uniwue.ki.mas.util.declaration.IDeclaration;
/**
 * Creation date: (28.11.2001 17:20:13)
 * @author Christoph Oechslein
 */
final class ChartAnalysisItemDeclarationFactory
	extends AbstractDeclarationFactory
	implements IAnalysisItemDeclarationFactory {
		
	private static final ChartAnalysisItemDeclarationFactory _instance =
		new ChartAnalysisItemDeclarationFactory();

	private ChartAnalysisItemDeclarationFactory() {
		super();
	}

	public final IAnalysisItemDeclaration createAnalysisItemDeclaration() {
		return new ColorAnalysisItemDeclaration(DoubleType.getInstance());
	}

	public final IDeclaration createDeclaration() {
		return createAnalysisItemDeclaration();
	}

	/**
	 * @return IAnalysisItemDeclarationFactory
	 */
	public static final IAnalysisItemDeclarationFactory getInstance() {
		return _instance;
	}
}