package de.uniwue.ki.mas.sim.analysis;
import java.awt.Color;
import java.util.Map;

import de.uniwue.ki.mas.basics.functionCall.IFunctionCallDeclaration;
import de.uniwue.ki.mas.basics.type.ISpecificType;
import de.uniwue.ki.util.copy.ICopyable;
import de.uniwue.ki.util.math.RandomHelper;

/**
 * Creation date: (15.10.2001 16:55:56)
 * @author: Christoph Oechslein
 */
public class ColorAnalysisItemDeclaration extends DefaultAnalysisItemDeclaration {
	private Color _color =
		new Color(
			RandomHelper.getRandomInt(256),
			RandomHelper.getRandomInt(256),
			RandomHelper.getRandomInt(256));

	public ColorAnalysisItemDeclaration(ISpecificType specificType) {
		super(specificType);
	}

	public ColorAnalysisItemDeclaration(IFunctionCallDeclaration valueFunctionCallDeclaration) {
		super(valueFunctionCallDeclaration);
	}

	public ColorAnalysisItemDeclaration() {
		super();
	}

	/**
	 * @param intoObject Object
	 * @param objectMapping Map
	 * @see de.uniwue.ki.util.ICopyable#copyInto(Object, Map)
	 */
	public void copyInto(Object intoObject, Map objectMapping) {
		super.copyInto(intoObject, objectMapping);

		if (intoObject instanceof ColorAnalysisItemDeclaration) {
			ColorAnalysisItemDeclaration intoChartAnalysisItemDeclaration =
				(ColorAnalysisItemDeclaration) intoObject;

			intoChartAnalysisItemDeclaration.setColor(getColor());
		}
	}

	protected ICopyable createInstance(Map objectMapping) {
		return new ColorAnalysisItemDeclaration();
	}

	/**
	 * @return Color
	 */
	public Color getColor() {
		return _color;
	}

	public void setColor(Color newColor) {
		Color oldValue = getColor();

		_color = newColor;

		firePropertyChange("color", oldValue, newColor);
	}
}