package de.uniwue.ki.mas.sim.analysis;
import de.uniwue.ki.mas.util.declaration.AbstractDeclarationFactory;
import de.uniwue.ki.mas.util.declaration.IDeclaration;
/**
 * Creation date: (28.11.2001 17:20:13)
 * @author Christoph Oechslein
 */
final class DefaultAnalysisItemDeclarationFactory
	extends AbstractDeclarationFactory
	implements IAnalysisItemDeclarationFactory {

	private static final DefaultAnalysisItemDeclarationFactory _instance =
		new DefaultAnalysisItemDeclarationFactory();

	private DefaultAnalysisItemDeclarationFactory() {
		super();
	}

	public final IAnalysisItemDeclaration createAnalysisItemDeclaration() {
		return new DefaultAnalysisItemDeclaration();
	}

	public final IDeclaration createDeclaration() {
		return createAnalysisItemDeclaration();
	}

	public static final IAnalysisItemDeclarationFactory getInstance() {
		return _instance;
	}
}