package de.uniwue.ki.mas.sim.analysis;
import java.beans.PropertyChangeListener;

import de.uniwue.ki.mas.basics.functionCall.IFunctionCallDeclaration;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: (15.10.2001 16:53:45)
 * @author Christoph Oechslein
 */

public interface IAnalysisItemDeclaration extends IDeclaration {

    /**
     * Adds property change listener.
     *
     * @see #removePropertyChangeListener(PropertyChangeListener)
     */
    void addPropertyChangeListener(PropertyChangeListener listener);


    /**
    * Adds property listener for <code>propertyName</code> property change events.
    *
    * @see #removePropertyChangeListener(String,PropertyChangeListener)
    */
    void addPropertyChangeListener(String propertyName, PropertyChangeListener listener);


    String getName();


    IFunctionCallDeclaration getValueFunctionCallDeclaration();


    /**
     * Removes property change listener.
     *
     * @see #addPropertyChangeListener(PropertyChangeListener)
     */

    void removePropertyChangeListener(PropertyChangeListener listener);


    /**
     * Removes property listener for <code>propertyName</code> property change events.
     *
     * @see #addPropertyChangeListener(String,PropertyChangeListener)
     */
    void removePropertyChangeListener(String propertyName, PropertyChangeListener listener);


    void setName(String newName);
}