package de.uniwue.ki.mas.sim.analysis;
import java.util.Map;

import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.mas.sim.simulation.ISimulationCreateFunctionArgs;
import de.uniwue.ki.util.hash.IIsomorphicHashable;
/**
 * Creation date: (28.11.2001 17:20:13)
 * @author Christoph Oechslein
 */
public class TableAnalysisTypeDeclaration
	extends AbstractAnalysisTypeDeclaration
	implements IAnalysisTypeDeclaration {

	public TableAnalysisTypeDeclaration() {
		super();
	}

	public void copyInto(Object intoObject, Map objectMapping) {
		super.copyInto(intoObject, objectMapping);

		// TableAnalysisTypeDeclaration intoTableAnalysisTypeDeclaration = (TableAnalysisTypeDeclaration) intoObject;
	}

	public IAnalysis createAnalysis(
		ISimulationCreateFunctionArgs createFunctionArgs,
		IAnalysisDeclaration analysisDeclaration)
		throws ModelCompilingException {

//		AnalysisItemDeclarationList analysisItemDeclarationList =
//			getAnalysisItemDeclarationList(analysisDeclaration);
//
//		List nameFunctions = new ArrayList(analysisItemDeclarationList.size());
//		List valueFunctions = new ArrayList(analysisItemDeclarationList.size());
//
//		Iterator it = analysisItemDeclarationList.iterator();
//		while (it.hasNext()) {
//			IAnalysisItemDeclaration currIAnalysisItemDeclaration = (IAnalysisItemDeclaration) it.next();
//
//			nameFunctions.add(currIAnalysisItemDeclaration.getName());
//			valueFunctions.add(
//				currIAnalysisItemDeclaration.getValueFunctionCallDeclaration().createFunction(
//					createFunctionArgs));
//		}

		return new TableModelAnalysis(
			analysisDeclaration,
			createFunctionArgs,
			createStringArray(analysisDeclaration),
			createValueFunctionArray(createFunctionArgs, analysisDeclaration),
			createValueTypeArray(analysisDeclaration));
	}

	public IAnalysisItemDeclarationFactory getAnalysisItemDeclarationFactory() {
		return DefaultAnalysisItemDeclarationFactory.getInstance();
	}

	public String getName() {
		return "Table";
	}

	/**
	 * @param anObject IIsomorphicHashable
	 * @return boolean
	 * @see de.uniwue.ki.util.hash.IIsomorphicHashable#isomorphicEquals(IIsomorphicHashable)
	 */
	public boolean isomorphicEquals(IIsomorphicHashable anObject) {
		return equals(anObject);
	}

	/**
	 * @return int
	 * @see de.uniwue.ki.util.hash.IIsomorphicHashable#isomorphicHashCode()
	 */
	public int isomorphicHashCode() {
		return hashCode();
	}
}