package de.uniwue.ki.mas.sim.experiment;
import java.util.EventObject;

import de.uniwue.ki.mas.sim.simulation.ISimulation;

/**
 * Creation date: (14.11.2001 09:22:50)
 * @author Christoph Oechslein
 */

public class ExperimentCurrentSimulationChangedEvent extends EventObject {
	private final ISimulation _oldSimulation;
	private final ISimulation _newSimulation;

	/**
	 * @param source IExperiment
	 * @param oldSimulation ISimulation
	 * @param newSimulation ISimulation
	 */
	public ExperimentCurrentSimulationChangedEvent(
		IExperiment source,
		ISimulation oldSimulation,
		ISimulation newSimulation) {
		super(source);

		_oldSimulation = oldSimulation;
		_newSimulation = newSimulation;
	}

	public final IExperiment getExperiment() {
		return (IExperiment) getSource();
	}

	public final ISimulation getNewSimulation() {
		return _newSimulation;
	}

	/**
	 * @return ISimulation
	 */
	public final ISimulation getOldSimulation() {
		return _oldSimulation;
	}
}