package de.uniwue.ki.mas.sim.experiment;
import de.uniwue.ki.mas.basics.functionCall.IFunctionCallDeclaration;
import de.uniwue.ki.mas.sim.simulation.ISimulationDeclaration;
import de.uniwue.ki.mas.sim.simulation.SimulationDeclarationListAndFactory;
import de.uniwue.ki.mas.util.declaration.AbstractDeclarationFactory;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: (04.09.2001 16:05:27)
 * @author Christoph Oechslein
 */

public class ExperimentDeclarationFactory extends AbstractDeclarationFactory {
	private final SimulationDeclarationListAndFactory _simulationDeclarationListAndFactory;

public ExperimentDeclarationFactory(SimulationDeclarationListAndFactory simulationDeclarationListAndFactory) {
    super();

    _simulationDeclarationListAndFactory = simulationDeclarationListAndFactory;
}


    public IDeclaration createDeclaration() {
        return createExperimentDeclaration();
    }


public IExperimentDeclaration createExperimentDeclaration() {
    return createExperimentDeclaration((ISimulationDeclaration) _simulationDeclarationListAndFactory.getFirstDeclarationOrCreateNewIfEmpty());
}


/**
 * @param functionCallDeclaration IFunctionCallDeclaration
 * @return IExperimentDeclaration
 */
public static IExperimentDeclaration createExperimentDeclaration(IFunctionCallDeclaration functionCallDeclaration) {
    return new ExperimentDeclaration(functionCallDeclaration);
}


/**
 * @param simulationDeclaration ISimulationDeclaration
 * @return IExperimentDeclaration
 */
public static IExperimentDeclaration createExperimentDeclaration(ISimulationDeclaration simulationDeclaration) {
    return new ExperimentDeclaration(simulationDeclaration);
}
}