package de.uniwue.ki.mas.sim.experiment;
import de.uniwue.ki.mas.sim.simulation.SimulationDeclarationListAndFactory;
import de.uniwue.ki.mas.util.declaration.DefaultDeclarationListAndFactory;

/**
 * Creation date: (14.11.2001 11:02:00)
 * @author Christoph Oechslein
 */
public class ExperimentDeclarationListAndFactory extends DefaultDeclarationListAndFactory {
	public ExperimentDeclarationListAndFactory(
		ExperimentDeclarationList experimentDeclarationList,
		ExperimentDeclarationFactory experimentDeclarationFactory) {

		super(experimentDeclarationList, experimentDeclarationFactory);
	}

	public ExperimentDeclarationListAndFactory(SimulationDeclarationListAndFactory simulationDeclarationListAndFactory) {

		this(
			new ExperimentDeclarationList(),
			new ExperimentDeclarationFactory(simulationDeclarationListAndFactory));
	}

	/**
	 * @return ExperimentDeclarationFactory
	 */
	public ExperimentDeclarationFactory getExperimentDeclarationFactory() {
		return (ExperimentDeclarationFactory)getDeclarationFactory();
	}

	public ExperimentDeclarationList getExperimentDeclarationList() {
		return (ExperimentDeclarationList)getDeclarationList();
	}
}