package de.uniwue.ki.mas.sim.experiment;
import java.util.EventListener;

import de.uniwue.ki.mas.sim.simulation.StartPauseFinishEventMulticaster;

/**
 * Creation date: (31.01.2002 09:36:40)
 * @author Christoph Oechslein
 */

public class ExperimentEventMulticaster
	extends StartPauseFinishEventMulticaster
	implements ExperimentListener {

	protected ExperimentEventMulticaster(ExperimentListener a, ExperimentListener b) {
		super(a, b);
	}

	public static ExperimentListener add(ExperimentListener a, ExperimentListener b) {
		return (ExperimentListener) addInternal(a, b);
	}

	protected static EventListener addInternal(EventListener a, EventListener b) {
		if (a == null)
			return b;
		if (b == null)
			return a;
		return new ExperimentEventMulticaster((ExperimentListener) a, (ExperimentListener) b);
	}

	public void currentSimulationChanged(ExperimentCurrentSimulationChangedEvent event) {
		((ExperimentListener) _a).currentSimulationChanged(event);
		((ExperimentListener) _b).currentSimulationChanged(event);
	}

	/**
	 *
	 * @return java.util.EventListener
	 * @param oldl de.uniwue.ki.mas.model.sim.experiment.ExperimentListener
	 */
	protected EventListener remove(ExperimentListener oldl) {
		if (oldl == _a)
			return _b;
		if (oldl == _b)
			return _a;
		EventListener a2 = removeInternal(_a, oldl);
		EventListener b2 = removeInternal(_b, oldl);
		if (a2 == _a && b2 == _b)
			return this;
		return addInternal(a2, b2);
	}

	/**
	 * Remove listener to support multicast events.
	 * @param l de.uniwue.ki.mas.model.sim.experiment.ExperimentListener
	 * @param oldl de.uniwue.ki.mas.model.sim.experiment.ExperimentListener
	 * @return de.uniwue.ki.mas.model.sim.experiment.ExperimentListener
	 */
	public static ExperimentListener remove(ExperimentListener l, ExperimentListener oldl) {
		if (l == oldl || l == null)
			return null;
		if (l instanceof ExperimentEventMulticaster)
			return (ExperimentListener) ((ExperimentEventMulticaster) l).remove(oldl);
		return l;
	}
}