package de.uniwue.ki.mas.sim.experiment;
import de.uniwue.ki.mas.model.ISeSAmDeclaration;
import de.uniwue.ki.mas.model.SimulationRuntimeException;
import de.uniwue.ki.mas.sim.simulation.ISimulation;
import de.uniwue.ki.mas.sim.simulation.SimulationFunctionArgs;
/**
 * Creation date: (29.01.2002 15:49:45)
 * @author Christoph Oechslein
 */
public class ExperimentFunctionArgs
	extends SimulationFunctionArgs
	implements IExperimentCreateFunctionArgs, IExperimentExecuteFunctionArgs {

	private IExperiment _experiment;

	public ExperimentFunctionArgs(ISeSAmDeclaration seSAmDeclaration, IExperiment experiment) {
		super(seSAmDeclaration);

		_experiment = experiment;
	}

	public ExperimentFunctionArgs(ExperimentFunctionArgs experimentFunctionArgs)
		throws SimulationRuntimeException {
		super(experimentFunctionArgs.getSeSAmDeclaration());

		_experiment = experimentFunctionArgs.getExperiment();

		pushArgumentBindings(experimentFunctionArgs.saveCurrentArgumentBindings());
	}

	public IExperiment getExperiment() {
		return _experiment;
	}

	public void setSimulation(ISimulation newSimulation) {
		ISimulation oldSimulation = getSimulation();
		if (newSimulation != oldSimulation) {
			super.setSimulation(newSimulation);

			_experiment.fireCurrentSimulationChanged(oldSimulation, newSimulation);
		}
	}

	public void remove() {
		_experiment = null;

		super.remove();
	}
}