package de.uniwue.ki.mas.sim.experiment;
import de.uniwue.ki.mas.model.ISeSAmDeclaration;
import de.uniwue.ki.mas.sim.simulation.SimulationDeclarationListAndFactory;
import de.uniwue.ki.util.list.DefaultMutableListModelAndFactory;

/**
 * Creation date: (28.11.2001 13:41:29)
 * @author Christoph Oechslein
 */
public class ExperimentListAndFactory extends DefaultMutableListModelAndFactory {
	public ExperimentListAndFactory(
		ISeSAmDeclaration seSAmDeclaration,
		ExperimentDeclarationList experimentDeclarationList,
		SimulationDeclarationListAndFactory simulationDeclarationListAndFactory) {

		this(
			new ExperimentList(),
			new ExperimentFactory(
				seSAmDeclaration,
				experimentDeclarationList,
				simulationDeclarationListAndFactory));
	}

	public ExperimentListAndFactory(ExperimentFactory experimentFactory) {

		this(new ExperimentList(), experimentFactory);
	}

	public ExperimentListAndFactory(
		ISeSAmDeclaration seSAmDeclaration,
		ExperimentList experimentList,
		ExperimentDeclarationList experimentDeclarationList,
		SimulationDeclarationListAndFactory simulationDeclarationListAndFactory) {

		this(
			experimentList,
			new ExperimentFactory(
				seSAmDeclaration,
				experimentDeclarationList,
				simulationDeclarationListAndFactory));
	}

	public ExperimentListAndFactory(ExperimentList experimentList, ExperimentFactory experimentFactory) {

		super(experimentList, experimentFactory);

	}

	public ExperimentFactory getExperimentFactory() {
		return (ExperimentFactory) getObjectFactory();
	}

	public ExperimentList getExperimentList() {
		return (ExperimentList) getMutableListModel();
	}

}