package de.uniwue.ki.mas.sim.experiment;
import java.io.File;

import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.mas.model.SimulationRuntimeException;
import de.uniwue.ki.mas.sim.simulation.*;
import de.uniwue.ki.util.IRemoveable;
import de.uniwue.ki.util.name.INamed;
/**
 * Creation date: (29.01.2002 15:45:06)
 * @author Christoph Oechslein
 */

public interface IExperiment
	extends INamed, IRemoveable, IStartPauseFinishInThreadAble, java.io.Serializable {
	void addExperimentListener(ExperimentListener newListener);

	ISimulation createSimulation(ISimulationDeclaration simulationDeclaration)
		throws ModelCompilingException;

	void fireCurrentSimulationChanged(ISimulation oldSimulation, ISimulation newSimulation);

	File getConfigurationFile();

	ISimulation getCurrentSimulation();

	Throwable getException();

	void removeExperimentListener(ExperimentListener newListener);

	void startSimulation(ISimulation simulation) throws SimulationRuntimeException;

	IExperimentDeclaration getExperimentDeclaration();
	
	void removeSimulation(ISimulation simulation);
}