package de.uniwue.ki.mas.sim.experiment.function;
import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionArgsDeclaration;
import de.uniwue.ki.mas.basics.type.SimulationDeclarationType;
import de.uniwue.ki.mas.basics.type.SimulationType;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Creation date: (01.10.2001 16:25:22)
 * @author Christoph Oechslein
 */

final class CreateSimulationSpecificFunctionDeclaration extends AbstractSpecificFunctionArgsDeclaration {

	public CreateSimulationSpecificFunctionDeclaration() {
		super(
			FunctionCreateSimulation.NAME,
			SimulationType.getInstance(),
			CollectionsHelper.createList(SimulationDeclarationType.getInstance()),
			false);

		setDocumentation("Creates a new simulation from the given simulation declaration.");
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions) {
		if (Assert.ASSERTION_ON)
			Assert.assertEquals(1, functions.size());

		return new FunctionCreateSimulation(functions.getFunction(0));
	}
}