package de.uniwue.ki.mas.sim.experiment.function;
import de.uniwue.ki.mas.basics.action.AbstractFunctionAction;
import de.uniwue.ki.mas.basics.function.IExecuteFunctionArgs;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.model.SimulationRuntimeException;
import de.uniwue.ki.mas.sim.simulation.ISimulation;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Chripauseh Oechslein
 */

final class FunctionActionSetSimulationName extends AbstractFunctionAction implements IFunction {
    static final String NAME = "SetName";

    private final IFunction _simulationFunction;
    private final IFunction _stringFunction;

    public FunctionActionSetSimulationName(IFunction simulationFunction, IFunction stringFunction) {
        super();

        _simulationFunction = simulationFunction;
        _stringFunction = stringFunction;
    }

public void act(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
    ISimulation simulation = (ISimulation) _simulationFunction.execute(executeFunctionArgs);
    String string = (String) _stringFunction.execute(executeFunctionArgs);

    simulation.setName(string);
}

/**
 * @return String
 * @see de.uniwue.ki.util.INamed#getName()
 */
public String getName() {
    return NAME + "(" + _simulationFunction.getName() + ", " + _stringFunction.getName() + ")";
}
}