package de.uniwue.ki.mas.sim.experiment.function;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.type.SimulationDeclarationType;
import de.uniwue.ki.mas.model.*;
import de.uniwue.ki.mas.sim.experiment.IExperimentExecuteFunctionArgs;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class FunctionCreateSimulation extends AbstractFunction {
	static final String NAME = "CreateSimulation";

	private final IFunction _simulationDeclarationFunction;

	public FunctionCreateSimulation(IFunction simulationDeclarationFunction) {
		super();

		_simulationDeclarationFunction = simulationDeclarationFunction;
	}

	public final Object execute(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
		try {
			return SimulationDeclarationType.createSimulation(
				_simulationDeclarationFunction,
				(IExperimentExecuteFunctionArgs) executeFunctionArgs);

		} catch (ModelCompilingException e) {
			throw new SimulationRuntimeCausedByModelCompileException(e);
		}
	}

	public String getName() {
		return NAME + "(" + _simulationDeclarationFunction.getName() + ")";
	}
}