package de.uniwue.ki.mas.sim.experiment.function;
import de.uniwue.ki.mas.basics.functionDeclaration.ISpecificFunctionDeclaration;
import de.uniwue.ki.mas.basics.functionDeclaration.list.FunctionDeclarationList;
import de.uniwue.ki.mas.basics.functionDeclaration.list.IFunctionDeclarationList;
/**
 * Creation date: (28.01.2002 18:43:45)
 * @author Christoph Oechslein
 */
public final class FunctionDeclarationExperimentFactory {

	public static final ISpecificFunctionDeclaration GET_WORLD_FROM_SIMULATION_SPECIFIC_FUNCTION_DECL =
		new GetWorldFromSimSpecificFunctionDeclaration();

	public static final ISpecificFunctionDeclaration SIM_SIMULATION_SPECIFIC_FUNCTION_DECL =
		new SimulateSimulationSpecificFunctionDeclaration();

	public static final ISpecificFunctionDeclaration SET_SIMULATION_NAME_SPECIFIC_FUNCTION_DECL =
		new SetSimulationNameSpecificFunctionDeclaration();

	public static final ISpecificFunctionDeclaration GET_SIMULATION_NAME_SPECIFIC_FUNCTION_DECL =
		new GetSimulationNameSpecificFunctionDeclaration();

	public static final ISpecificFunctionDeclaration CREATE_SIMULATION_SPECIFIC_FUNCTION_DECL =
		new CreateSimulationSpecificFunctionDeclaration();

	private static IFunctionDeclarationList _cachedFunctionDeclarationList = new FunctionDeclarationList();

	static {
		_cachedFunctionDeclarationList.add(SIM_SIMULATION_SPECIFIC_FUNCTION_DECL);

		_cachedFunctionDeclarationList.add(SET_SIMULATION_NAME_SPECIFIC_FUNCTION_DECL);
		_cachedFunctionDeclarationList.add(GET_SIMULATION_NAME_SPECIFIC_FUNCTION_DECL);

		_cachedFunctionDeclarationList.add(GET_WORLD_FROM_SIMULATION_SPECIFIC_FUNCTION_DECL);

		_cachedFunctionDeclarationList.add(CREATE_SIMULATION_SPECIFIC_FUNCTION_DECL);
	}

	public static void insertFunctions(IFunctionDeclarationList functionDeclarationList) {
		functionDeclarationList.addAll(_cachedFunctionDeclarationList);
	}
}