package de.uniwue.ki.mas.sim.experiment.function;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.model.SimulationRuntimeException;
import de.uniwue.ki.mas.sim.simulation.ISimulation;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class FunctionGetSimulationName extends AbstractFunction {
    static final String NAME = "GetSimulationName";

    private final IFunction _simulationFunction;

    public FunctionGetSimulationName(IFunction simulationFunction) {
        super();

        _simulationFunction = simulationFunction;
    }


public final Object execute(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
    ISimulation simulation = (ISimulation) _simulationFunction.execute(executeFunctionArgs);

    return simulation.getName();
}


    public String getName() {
        return NAME + "(" + _simulationFunction.getName() + ")";
    }
}