package de.uniwue.ki.mas.sim.experiment.function;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.entity.object.agent.IAgentExecuteFunctionArgs;
import de.uniwue.ki.mas.model.SimulationRuntimeException;
import de.uniwue.ki.mas.sim.simulation.ISimulation;

/**
 * Creation date: (04.09.2001 15:46:50)
 * @author Christoph Oechslein
 */

final class FunctionGetWorldFromSim extends AbstractFunction {
	static final String NAME = "GetWorldFromSim";

	private final IFunction _simulationFunction;

	public FunctionGetWorldFromSim(IFunction simulationFunction) {
		super();

		_simulationFunction = simulationFunction;
	}

	public final Object execute(IExecuteFunctionArgs executeFunctionArgs) throws SimulationRuntimeException {
		IAgentExecuteFunctionArgs objectExecuteFunctionArgs =
			(IAgentExecuteFunctionArgs) executeFunctionArgs;

		ISimulation simulation = (ISimulation) _simulationFunction.execute(objectExecuteFunctionArgs);

		return simulation.getSituation().getWorld();

	}

	public String getName() {
		return NAME + "(" + _simulationFunction.getName() + ")";
	}
}