package de.uniwue.ki.mas.sim.experiment.function;

import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionArgsDeclaration;
import de.uniwue.ki.mas.basics.type.SimulationType;
import de.uniwue.ki.mas.basics.type.StringType;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Creation date: (01.10.2001 16:25:22)
 * @author Christoph Oechslein
 */

final class GetSimulationNameSpecificFunctionDeclaration extends AbstractSpecificFunctionArgsDeclaration {

	public GetSimulationNameSpecificFunctionDeclaration() {
		super(
			FunctionGetSimulationName.NAME,
			StringType.getInstance(),
			CollectionsHelper.createList(SimulationType.getInstance()),
			false);

		setDocumentation("Returns the name of the simulation");
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions) {
		if (Assert.ASSERTION_ON)
			Assert.assertEquals(1, functions.size());

		return new FunctionGetSimulationName(functions.getFunction(0));
	}
}