package de.uniwue.ki.mas.sim.experiment.function;
import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionArgsDeclaration;
import de.uniwue.ki.mas.basics.type.GenericSimObjectType;
import de.uniwue.ki.mas.basics.type.SimulationType;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Creation date: (01.10.2001 16:25:22)
 * @author Christoph Oechslein
 */

final class GetWorldFromSimSpecificFunctionDeclaration extends AbstractSpecificFunctionArgsDeclaration {

	public GetWorldFromSimSpecificFunctionDeclaration() {
		super(
			FunctionGetWorldFromSim.NAME,
			GenericSimObjectType.getGeneralSimObjectType(),
			CollectionsHelper.createList(SimulationType.getInstance()));

		setDocumentation("Returns the body of the world from the simulation");
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions) {
		if (Assert.ASSERTION_ON)
			Assert.assertEquals(1, functions.size());

		return new FunctionGetWorldFromSim(functions.getFunction(0));
	}
}