package de.uniwue.ki.mas.sim.experiment.function;

import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionArgsDeclaration;
import de.uniwue.ki.mas.basics.type.*;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Creation date: (01.10.2001 16:25:22)
 * @author Christoph Oechslein
 */

final class SetSimulationNameSpecificFunctionDeclaration extends AbstractSpecificFunctionArgsDeclaration {
	public SetSimulationNameSpecificFunctionDeclaration() {
		super(
			FunctionActionSetSimulationName.NAME,
			VoidType.getInstance(),
			CollectionsHelper.createList(SimulationType.getInstance(), StringType.getInstance()));

		setDocumentation("Changes the name of the simulation to name (Arg1)");
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions) {
		if (Assert.ASSERTION_ON)
			Assert.assertEquals(2, functions.size());

		return new FunctionActionSetSimulationName(functions.getFunction(0), functions.getFunction(1));
	}
}