package de.uniwue.ki.mas.sim.experiment.function;
import junit.framework.Assert;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionArgsDeclaration;
import de.uniwue.ki.mas.basics.type.*;
import de.uniwue.ki.mas.sim.experiment.IExperimentCreateFunctionArgs;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Creation date: (01.10.2001 16:25:22)
 * @author Christoph Oechslein
 */

final class SimulateSimulationSpecificFunctionDeclaration extends AbstractSpecificFunctionArgsDeclaration {
	public SimulateSimulationSpecificFunctionDeclaration() {
		super(
			FunctionActionSimulateSimulation.NAME,
			VoidType.getInstance(),
			CollectionsHelper.createList(SimulationType.getInstance(), BooleanType.getInstance()));

		setDocumentation("Simulates the simulation (Arg1) and outputs its configuration if (Arg2) is 'true'");
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions) {
		if (Assert.ASSERTION_ON)
			Assert.assertEquals(2, functions.size());

		IExperimentCreateFunctionArgs experimentCreateFunctionArgs =
			(IExperimentCreateFunctionArgs) createFunctionArgs;

		return new FunctionActionSimulateSimulation(
			new SimulationRunConfigurationAndResults(experimentCreateFunctionArgs.getExperiment()),
			functions.getFunction(0),
			functions.getFunction(1));
	}
}