package de.uniwue.ki.mas.sim.listener;
import de.uniwue.ki.mas.basics.function.IFunction;
import de.uniwue.ki.mas.entity.object.agent.IAgent;

/**
 * Creation date: (30.10.2001 16:50:44)
 * @author Christoph Oechslein
 */

public class AgentActionChangedEvent extends AgentEvent {
	private final IFunction oldCurrentAction;
	private final IFunction newCurrentAction;

	/**
	 * @param source IAgent
	 * @param oldCurrentAction IFunction
	 * @param newCurrentAction IFunction
	 */
	public AgentActionChangedEvent(IAgent source, IFunction oldCurrentAction, IFunction newCurrentAction) {
	    super(source);
	    
	    this.oldCurrentAction = oldCurrentAction;
	    this.newCurrentAction = newCurrentAction;
	}

	/**
	 * Return the new action the agent does.
	 */
	public final IFunction getNewCurrentAction() {
	    return newCurrentAction;
	}

	/**
	 * Return the old action the agent did.
	 */
	public final IFunction getOldCurrentAction() {
	    return oldCurrentAction;
	}

}
