package de.uniwue.ki.mas.sim.listener;

import de.uniwue.ki.mas.behaviour.activityGraph.IActivityGraphLeaf;
import de.uniwue.ki.mas.entity.object.agent.IActivityAgent;
/**
 * Creation date: 04.09.2002, 18:40:20
 * @author oechslein
 */
public class CurrentActivityGraphLeafChangedEvent extends ActivityAgentEvent {

	private final IActivityGraphLeaf _oldActivityGraphLeaf;
	private final IActivityGraphLeaf _newActivityGraphLeaf;

	public CurrentActivityGraphLeafChangedEvent(
		IActivityAgent activityAgent,
		IActivityGraphLeaf oldAtomicActivity,
		IActivityGraphLeaf newAtomicActivity,
		int currActivityReasoningEngineIndex) {

		super(activityAgent, currActivityReasoningEngineIndex);

		_oldActivityGraphLeaf = oldAtomicActivity;
		_newActivityGraphLeaf = newAtomicActivity;
	}

	/**
	 * Returns the new activity the activity agent is in.
	 */
	public final IActivityGraphLeaf getNewActivityGraphLeaf() {
		return _newActivityGraphLeaf;
	}

	/**
	 * Returns the oldactivity the activity agent was in.
	 */
	public final IActivityGraphLeaf getOldActivityGraphLeaf() {
		return _oldActivityGraphLeaf;
	}
}
