package de.uniwue.ki.mas.sim.simulation;

import junit.framework.Assert;
import de.uniwue.ki.util.name.AbstractNamed;
/**
 * @author oechslein
 * 
 * Creation date: 28.08.2003
 */
public abstract class AbstractStartPauseFinishAble extends AbstractNamed implements IStartPauseFinishAble {

	private StartPauseFinishListener _startPauseFinishListener = null;

	public void addStartPauseFinishListener(StartPauseFinishListener newListener) {
		_startPauseFinishListener =
			StartPauseFinishEventMulticaster.add(_startPauseFinishListener, newListener);
	}


	public void removeStartPauseFinishListener(StartPauseFinishListener newListener) {
		_startPauseFinishListener =
			StartPauseFinishEventMulticaster.remove(_startPauseFinishListener, newListener);
	}
	
	protected void fireStarted() {
		if (_startPauseFinishListener != null)
			_startPauseFinishListener.started(new StartPauseFinishEvent(this));
	}
	
	protected void firePaused() {
		if (_startPauseFinishListener != null)
			_startPauseFinishListener.paused(new StartPauseFinishEvent(this));
	}
	
	protected void fireFinished(Throwable exception) {
		Assert.assertNotNull(exception);

		if (_startPauseFinishListener != null)
			_startPauseFinishListener.finished(new StartPauseFinishEvent(this, exception));}
			
	protected void fireFinished() {
		if (_startPauseFinishListener != null)
			_startPauseFinishListener.finished(new StartPauseFinishEvent(this));
	}
}
	