package de.uniwue.ki.mas.sim.simulation;
import de.uniwue.ki.mas.sim.analysis.AnalysisDeclarationList;
import de.uniwue.ki.mas.sim.situation.ISituationDeclaration;
import de.uniwue.ki.mas.util.declaration.*;

/**
 * A simulation declaration specifies a simulation run
 * (the most important part is a {@link ISituationDeclaration situation declaration}).
 * Creation date: (30.10.2000 10:31:38)
 *
 * @author Christoph Oechslein
 */

public interface ISimulationDeclaration extends ITestableDeclaration {

	AnalysisDeclarationList getAnalysisDeclarationList();

	IDeclarationListAndFactory getEndFunctionDeclarationListAndFactory();

	/**
	 * Returns situation declaration of this simulation declaration
	 */

	ISituationDeclaration getSituationDeclaration();

	/**
	 * Sets situation declaration of this simulation declaration
	 *
	 * @see #getSituationDeclaration()
	 */
	void setSituationDeclaration(ISituationDeclaration situationDeclaration);

	IDeclarationList getAfterRunTestActionDefinitionList();
	IDeclarationList getDuringRunTestActionDefinitionList();
}