package de.uniwue.ki.mas.sim.simulation;

import de.uniwue.ki.mas.entity.object.agent.IActivityAgentExecuteFunctionArgs;
import de.uniwue.ki.mas.entity.object.world.IWorldExecuteFunctionArgs;
import de.uniwue.ki.mas.model.ISeSAmDeclaration;
import de.uniwue.ki.mas.sim.analysis.IAnalysis;

/**
 * Simulation executing environment.
 * Creation date: (06.12.2000 17:16:48)
 * @author Christoph Oechslein
 */

public interface ISimulationExecuteFunctionArgs
	extends IWorldExecuteFunctionArgs, IActivityAgentExecuteFunctionArgs {

	/**
	 * Returns associated simulation.
	 */
	ISimulation getSimulation();

	void setSimulation(ISimulation simulation);

	ISeSAmDeclaration getSeSAmDeclaration();
	
	void addAnalysisListener(IAnalysisListener analysisListener);
	void removeAnalysisListener(IAnalysisListener analysisListener);
	boolean hasAnalysisListeners();
	void fireStartedAnalysis(IAnalysis analysis, ISimulation simulation);
	void fireFinishedAnalysis(IAnalysis analysis, ISimulation simulation);
}
