package de.uniwue.ki.mas.sim.simulation;

import java.io.Serializable;

import de.uniwue.ki.mas.model.SimulationRuntimeException;

/**
 * Determines the order of update to world and agents:
 * when to sense, order of agents...
 * <BR>Creation date: (26.04.00 14:37:54)
 *
 * @author Christoph Oechslein
 */

public interface ISimulationStrategie extends Serializable {

	/**
	 * Simulate one step depending on the specific update strategie.
	 */
	void simulateOneStep(ISimulationExecuteFunctionArgs simulationExecuteFunctionArgs)
		throws SimulationRuntimeException;
}
