package de.uniwue.ki.mas.sim.simulation;
import de.uniwue.ki.mas.sim.analysis.AnalysisDeclarationList;
import de.uniwue.ki.mas.sim.situation.*;
import de.uniwue.ki.mas.util.declaration.DefaultDeclarationListAndFactory;

/**
 * Creation date: (14.11.2001 11:02:00)
 * @author Christoph Oechslein
 */
public class SimulationDeclarationListAndFactory extends DefaultDeclarationListAndFactory {
	public SimulationDeclarationListAndFactory(
		SimulationDeclarationList simulationDeclarationList,
		SimulationDeclarationFactory simulationDeclarationFactory) {

		super(simulationDeclarationList, simulationDeclarationFactory);
	}

	public SimulationDeclarationListAndFactory(
		SituationDeclarationList situationDeclarationList,
		SituationDeclarationFactory situationDeclarationFactory,
		AnalysisDeclarationList analysisDeclarationList) {

		this(
			new SimulationDeclarationList(),
			new SimulationDeclarationFactory(
				situationDeclarationList,
				situationDeclarationFactory,
				analysisDeclarationList));
	}

	public SimulationDeclarationListAndFactory(
		SituationDeclarationListAndFactory simulationDeclarationListAndFactory,
		AnalysisDeclarationList analysisDeclarationList) {
		this(
			simulationDeclarationListAndFactory.getSituationDeclarationList(),
			simulationDeclarationListAndFactory.getSituationDeclarationFactory(),
			analysisDeclarationList);
	}

	public SimulationDeclarationFactory getSimulationDeclarationFactory() {
		return (SimulationDeclarationFactory) getDeclarationFactory();
	}

	/**
	 * @return SimulationDeclarationList
	 */
	public SimulationDeclarationList getSimulationDeclarationList() {
		return (SimulationDeclarationList) getDeclarationList();
	}
}