package de.uniwue.ki.mas.sim.simulation;
import junit.framework.Assert;
import de.uniwue.ki.mas.entity.object.IObject;
import de.uniwue.ki.mas.entity.object.world.IWorld;

/**
 * Creation date: (14.11.2001 09:22:50)
 * @author Christoph Oechslein
 */

public class SimulationEvent extends StartPauseFinishEvent {
	private final SimulationFunctionArgs _simulationFunctionArgs;

	public SimulationEvent(ISimulation simulation, SimulationFunctionArgs simulationFunctionArgs) {
		this(simulation, null, simulationFunctionArgs);
	}

	public SimulationEvent(
		ISimulation simulation,
		Throwable exception,
		SimulationFunctionArgs simulationFunctionArgs) {
		super(simulation, exception);

		Assert.assertNotNull(simulationFunctionArgs);

		_simulationFunctionArgs = simulationFunctionArgs;
	}

	public final IObject getObject() {
		return _simulationFunctionArgs.getObject();
	}

	public final ISimulation getSimulation() {
		return _simulationFunctionArgs.getSimulation();
	}

	public final IWorld getWorld() {
		return _simulationFunctionArgs.getWorld();
	}
}