package de.uniwue.ki.mas.sim.simulation;
import java.util.Map;

import junit.framework.Assert;
import de.uniwue.ki.mas.basics.functionCall.FunctionCallDeclarationFactory;
import de.uniwue.ki.mas.basics.functionCall.IFunctionCallDeclaration;
import de.uniwue.ki.mas.basics.type.StringType;
import de.uniwue.ki.mas.sim.situation.ISituationDeclaration;
import de.uniwue.ki.util.copy.ICopyable;

/**
 * Creation date: (30.07.2001 18:37:16)
 * @author Christoph Oechslein
 */

class SimulationWithNameFunctionCallDeclDeclaration
	extends SimulationDeclaration
	implements ISimulationWithNameFunctionCallDeclDeclaration {

	private final IFunctionCallDeclaration _nameFunctionCallDeclaration =
		FunctionCallDeclarationFactory.getInstance().createFunctionCallDeclaration(StringType.getInstance());

	protected SimulationWithNameFunctionCallDeclDeclaration() {
		super();
	}

	public SimulationWithNameFunctionCallDeclDeclaration(ISituationDeclaration situationDeclaration) {
		super(situationDeclaration);
	}

	public IFunctionCallDeclaration getNameFunctionCallDeclaration() {
		return _nameFunctionCallDeclaration;
	}

	protected ICopyable createInstance(Map objectMapping) {
		return new SimulationWithNameFunctionCallDeclDeclaration();
	}

	public void copyInto(Object dstObject, Map objectMapping) {
		SimulationWithNameFunctionCallDeclDeclaration dstSimulationWithNameFunctionCallDeclDeclaration =
			(SimulationWithNameFunctionCallDeclDeclaration) dstObject;

		getNameFunctionCallDeclaration().copyInto(
			dstSimulationWithNameFunctionCallDeclDeclaration.getNameFunctionCallDeclaration(),
			objectMapping);

		dstSimulationWithNameFunctionCallDeclDeclaration.setSituationDeclaration(
			(ISituationDeclaration) getSituationDeclaration().copy(objectMapping));

		super.copyInto(dstObject, objectMapping);
	}

	public void setSituationDeclaration(ISituationDeclaration situationDeclaration) {
		ISituationDeclaration oldSituationDeclaration = getSituationDeclaration();

		super.setSituationDeclaration(situationDeclaration);

		if (oldSituationDeclaration != null) {
			Assert.assertNotSame(oldSituationDeclaration, getSituationDeclaration());
			oldSituationDeclaration.remove();
		}
	}

	public String getName() {
		return "Experiment Simulation [" + getNameFunctionCallDeclaration().getName() + "]";
	}
}