package de.uniwue.ki.mas.sim.simulation;
import java.io.Serializable;
import java.util.EventListener;

/**
 * The event set listener interface for the experiment feature:
 * listening for (re)starting, pausing and finishing the experiment.
 */

public interface StartPauseFinishListener extends EventListener, Serializable {
	/**
	 * Gets called if the experiment is finished.
	 *
	 * @param event de.uniwue.ki.mas.model.sim.experiment.ExperimentEvent
	 */
	void finished(StartPauseFinishEvent event);

	/**
	 * Gets called if the experiment is paused.
	 *
	 * @param event de.uniwue.ki.mas.model.sim.experiment.ExperimentEvent
	 */
	void paused(StartPauseFinishEvent event);

	/**
	 * Gets called if the experiment is started.
	 *
	 * @param event de.uniwue.ki.mas.model.sim.experiment.ExperimentEvent
	 */
	void started(StartPauseFinishEvent event);
}