package de.uniwue.ki.mas.sim.situation;
import de.uniwue.ki.mas.entity.object.world.IWorldInstanceDeclaration;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.mas.sim.simulation.ISimulationCreateFunctionArgs;
import de.uniwue.ki.mas.util.declaration.IDocumentableDeclaration;

/**
 * A situation declaration has a world instance declaration.
 * Creation date: (30.10.2000 10:36:21)
 *
 * @author Christoph Oechslein
 */

public interface ISituationDeclaration extends IDocumentableDeclaration {

/**
 * Compiles new situation under the given compilation bindings.
 *
 * @label compiles
 * @directed
 */

/*#ISituation lnkISituation;*/

ISituation createSituation(ISimulationCreateFunctionArgs simulationCreateFunctionArgs) throws ModelCompilingException;


/**
 * Returns world instance declaration.
 *
 * @directed
 * @link aggregationByValue
 */
IWorldInstanceDeclaration getWorldInstanceDeclaration();


/**
 * Sets world instance declaration.
 */
void setWorldInstanceDeclaration(IWorldInstanceDeclaration worldInstanceDeclaration);
}