package de.uniwue.ki.mas.sim.situation;

import de.uniwue.ki.mas.entity.object.world.IWorldInstanceDeclaration;
import de.uniwue.ki.mas.entity.objectclass.worldclass.*;
import de.uniwue.ki.mas.util.declaration.AbstractDeclarationFactory;
import de.uniwue.ki.mas.util.declaration.IDeclaration;

/**
 * Creation date: (04.09.2001 16:05:27)
 * @author Christoph Oechslein
 */

public final class SituationDeclarationFactory extends AbstractDeclarationFactory {
	private final IWorldClassDeclarationFactory worldClassDeclarationFactory;
	private final WorldClassDeclarationList worldClassDeclarationList;

/**
 * SituationDeclarationFactory constructor comment.
 */
public SituationDeclarationFactory(WorldClassDeclarationList worldClassDeclarationList,
    IWorldClassDeclarationFactory worldClassDeclarationFactory) {
        super();
        this.worldClassDeclarationList = worldClassDeclarationList;
        this.worldClassDeclarationFactory = worldClassDeclarationFactory;
}

/**
 * @see de.uniwue.ki.mas.model.util.declaration.IDeclarationFactory
 */
public static ISituationDeclaration createSituationDeclaration(IWorldInstanceDeclaration worldInstanceDeclaration) {
   return new SituationDeclaration(worldInstanceDeclaration);
}

/**
 * @see de.uniwue.ki.mas.model.util.declaration.IDeclarationFactory
 */
public static ISituationDeclaration createSituationDeclaration(IWorldClassDeclaration worldClassDeclaration) {
   return new SituationDeclaration(worldClassDeclaration);
}

/**
 * @return IDeclaration
 * @see de.uniwue.ki.mas.model.util.declaration.IDeclarationFactory
 */
public IDeclaration createDeclaration() {
   return createSituationDeclaration();
}

/**
 * @return ISituationDeclaration
 * @see de.uniwue.ki.mas.model.util.declaration.IDeclarationFactory
 */
public ISituationDeclaration createSituationDeclaration() {
   if (worldClassDeclarationList.size() > 0)
      return createSituationDeclaration((IWorldClassDeclaration) worldClassDeclarationList.getElementAt(0));
   else {
      IWorldClassDeclaration newWorldClassDeclaration = worldClassDeclarationFactory.createWorldClassDeclaration();
      worldClassDeclarationList.add(newWorldClassDeclaration);
      return createSituationDeclaration(newWorldClassDeclaration);
   }
}
}
