package de.uniwue.ki.mas.sim.situation;
import de.uniwue.ki.mas.entity.objectclass.worldclass.*;
import de.uniwue.ki.mas.util.declaration.DefaultDeclarationListAndFactory;

/**
 * Creation date: (14.11.2001 11:02:00)
 * @author Christoph Oechslein
 */
public class SituationDeclarationListAndFactory extends DefaultDeclarationListAndFactory {
/**
 * @param worldClassDeclarationListAndFactory IWorldClassDeclarationListAndFactory
 */
public SituationDeclarationListAndFactory(IWorldClassDeclarationListAndFactory worldClassDeclarationListAndFactory) {
   this(
      worldClassDeclarationListAndFactory.getWorldClassDeclarationList(),
      worldClassDeclarationListAndFactory.getWorldClassDeclarationFactory());
}


public SituationDeclarationListAndFactory(
   WorldClassDeclarationList worldClassDeclarationList,
   IWorldClassDeclarationFactory worldClassDeclarationFactory) {

   this(
      new SituationDeclarationList(),
      new SituationDeclarationFactory(worldClassDeclarationList, worldClassDeclarationFactory));
}


public SituationDeclarationListAndFactory(
    SituationDeclarationList situationDeclarationList,
    SituationDeclarationFactory situationDeclarationFactory) {

    super(situationDeclarationList, situationDeclarationFactory);
}


/**
 * @return SituationDeclarationFactory
 */
public SituationDeclarationFactory getSituationDeclarationFactory() {
    return (SituationDeclarationFactory) getDeclarationFactory();
}


public SituationDeclarationList getSituationDeclarationList() {
    return (SituationDeclarationList) getDeclarationList();
}
}