package de.uniwue.ki.mas.util.declaration;

/**
 * Creation date: (02.11.2000 12:47:31)
 * @author Christoph Oechslein
 */
public abstract class AbstractCopyDeclarationList extends AbstractDelegateDeclarationList {
	private final DefaultDeclarationList copyDeclarationList;

	public AbstractCopyDeclarationList(IDeclarationList delegateDeclarationList) {
		super(delegateDeclarationList);
		this.copyDeclarationList = createDeclarationList();
	}

	public final Object get(int index) {
		return getCopyDeclarationList().get(index);
	}

	public void remove() {
		super.remove();
	}

	/**
	 * @return int
	 * @see java.util.List#size()
	 */
	public final int size() {
		return getCopyDeclarationList().size();
	}

	protected final DefaultDeclarationList getCopyDeclarationList() {
		return copyDeclarationList;
	}

	protected DefaultDeclarationList createDeclarationList() {
		return new DefaultDeclarationList();
	}
	public boolean isComposition() {
		return getCopyDeclarationList().isComposition();
	}

	/**
	 * @param newIsComposition boolean
	 * @see de.uniwue.ki.mas.util.declaration.IDeclarationList#setComposition(boolean)
	 */
	public void setComposition(boolean newIsComposition) {
		getCopyDeclarationList().setComposition(newIsComposition);
	}

	/**
	 * @param index int
	 * @return Object
	 * @see javax.swing.ListModel#getElementAt(int)
	 */
	public final Object getElementAt(int index) {
		return getCopyDeclarationList().get(index);
	}

	public final int getSize() {
		return getCopyDeclarationList().size();
	}
}