package de.uniwue.ki.mas.util.declaration;
import de.uniwue.ki.util.factory.IObjectFactory;
import de.uniwue.ki.util.hash.IIsomorphicHashable;
import de.uniwue.ki.util.list.AbstractMutableListModelAndFactory;
import de.uniwue.ki.util.list.IMutableListModel;

/**
 * Creation date: (14.11.2001 13:03:30)
 * @author Christoph Oechslein
 */
public abstract class AbstractDeclarationListAndFactory
	extends AbstractMutableListModelAndFactory
	implements IDeclarationListAndFactory {

	public final boolean isomorphicEquals(IIsomorphicHashable anObject) {
		if (anObject instanceof IDeclarationListAndFactory) {
			return getDeclarationList().isomorphicEquals(
				((IDeclarationListAndFactory) anObject).getDeclarationList());

		} else {
			return false;
		}
	}

	public final int isomorphicHashCode() {
		return getDeclarationList().isomorphicHashCode();
	}

	public final void remove() {
		getDeclarationList().remove();
	}

	public final IDeclaration getFirstDeclarationOrCreateNewIfEmpty() {
		if (getDeclarationList().isEmpty()) {
			IDeclaration newDeclaration = getDeclarationFactory().createDeclaration();

			getDeclarationList().add(newDeclaration);

			return newDeclaration;

		} else {
			return (IDeclaration) getDeclarationList().get(0);
		}
	}
	public final IMutableListModel getMutableListModel() {
		return getDeclarationList();
	}

	public final IObjectFactory getObjectFactory() {
		return getDeclarationFactory();
	}
}