package de.uniwue.ki.mas.util.declaration;
import java.lang.ref.WeakReference;
import java.util.Iterator;

import de.uniwue.ki.util.event.AbstractListenerMulticaster;

/**
 * Creation date: (15.02.2002 17:28:10)
 * @author Christoph Oechslein
 */

public final class DeclarationListEventMulticaster
	extends AbstractListenerMulticaster
	implements DeclarationListListener {

	private static final ListenerMulticasterFactory _listenerMulticasterFactory =
		new ListenerMulticasterFactory() {
		public AbstractListenerMulticaster createAbstractListenerMulticaster() {
			return new DeclarationListEventMulticaster();
		}

		public Object createObject() {
			return createAbstractListenerMulticaster();
		}

		public String getName() {
			return "DeclarationListEventMulticasterFactory";
		}
	};

	protected DeclarationListEventMulticaster() {
		super();
	}

	public static final DeclarationListListener add(
		DeclarationListListener removeVetoListener,
		DeclarationListListener removeVetoListenerToAdd) {

		return (DeclarationListListener)AbstractListenerMulticaster.add(
			removeVetoListener,
			removeVetoListenerToAdd,
			_listenerMulticasterFactory);
	}

	public static final DeclarationListListener remove(
		DeclarationListListener removeVetoListener,
		DeclarationListListener removeVetoListenerToRemove) {

		return (DeclarationListListener)AbstractListenerMulticaster.remove(
			removeVetoListener,
			removeVetoListenerToRemove);
	}

	public void declarationAdded(DeclarationListEvent event) {
		Iterator it = getListeners();
		while (it.hasNext()) {
			WeakReference reference = (WeakReference)it.next();
			DeclarationListListener element = (DeclarationListListener)reference.get();
			if (element == null)
				it.remove();
			else
				element.declarationAdded(event);
		}
	}

	public void declarationRemoved(DeclarationListEvent event) {
		Iterator it = getListeners();
		while (it.hasNext()) {
			WeakReference reference = (WeakReference)it.next();
			DeclarationListListener element = (DeclarationListListener)reference.get();
			if (element == null)
				it.remove();
			else
				element.declarationRemoved(event);
		}
	}
}