package de.uniwue.ki.mas.util.declaration;

import java.io.Serializable;
import java.util.EventListener;

/**
 * Creation date: 04.09.2002, 18:40:20
 * @author oechslein
 */
public interface DeclarationListListener extends EventListener, Serializable {

	/**
	 * Gets called if the given {@link IDeclaration declaration}
	 * was added to a {@link IDeclarationList declaration list}.
	 *
	 * @see #declarationRemoved(DeclarationListEvent)
	 */
	void declarationAdded(DeclarationListEvent event);

	/**
	 * Gets called if the given {@link IDeclaration declaration}
	 * is was removed from a {@link IDeclarationList declaration list}.
	 *
	 * @see #declarationAdded(DeclarationListEvent)
	 */
	void declarationRemoved(DeclarationListEvent event);
}
