package de.uniwue.ki.mas.xml;
import java.io.*;

import mygale.mcge.fig.IFigMapper;
import de.uniwue.ki.mas.model.ISeSAmDeclaration;
import de.uniwue.ki.mas.xml.reader.XMLModelReader;
import de.uniwue.ki.mas.xml.reader.XMLReadException;

/**
 * Insert the type's description here.
 * Creation date: (18.10.2000 20:52:57)
 * @author Christoph Oechslein
 */
public class XMLReader {

	private XMLReader() {
		super();
	}

	public static void readModelInto(
		File modelFile,
		ISeSAmDeclaration seSAmDeclaration,
		IFigMapper figMapper,
		boolean setCompileFlags)
		throws XMLReadException, IOException {

		File oldModelFile = seSAmDeclaration.getFile();
		seSAmDeclaration.setFile(modelFile);
		try {
			readModelInto(
				new BufferedReader(new FileReader(modelFile)),
				seSAmDeclaration,
				figMapper,
				setCompileFlags);

		} catch (XMLReadException e) {
			seSAmDeclaration.setFile(oldModelFile);
			throw e;
		} catch (IOException e) {
			seSAmDeclaration.setFile(oldModelFile);
			throw e;
		}
	}

	public static void readModelInto(
		Reader reader,
		ISeSAmDeclaration seSAmDeclaration,
		IFigMapper figMapper,
		boolean setCompileFlags)
		throws XMLReadException, IOException {

		seSAmDeclaration.clear();
		if (figMapper != null)
			figMapper.clear();

		XMLModelReader xMLModelReader = new XMLModelReader(seSAmDeclaration, figMapper, setCompileFlags);
		xMLModelReader.readXMLFile(reader);
	}

	public static void readModelInto(
		String fileString,
		ISeSAmDeclaration seSAmDeclaration,
		IFigMapper figMapper,
		boolean setCompileFlags)
		throws XMLReadException, IOException {

		readModelInto(new File(fileString), seSAmDeclaration, figMapper, setCompileFlags);
	}
}