package de.uniwue.ki.mas.xml.reader;

import java.util.*;

import de.uniwue.ki.mas.basics.functionDeclaration.IFunctionDeclaration;
import de.uniwue.ki.mas.basics.functionDeclaration.list.AbstractFunctionDeclarationListAble;
import de.uniwue.ki.mas.basics.functionDeclaration.list.IFunctionDeclarationListAble;
import de.uniwue.ki.mas.entity.objectclass.IObjectClassDeclaration;
import de.uniwue.ki.mas.model.ISeSAmModelDeclaration;
import de.uniwue.ki.util.collection.CollectionsHelper;

final class CacheObjectClassDeclFunctionDeclarationListAble
	extends AbstractFunctionDeclarationListAble
	implements IFunctionDeclarationListAble {

	private Collection _cachedSet;

	private final IObjectClassDeclaration _objectClassDeclaration;
	private final ISeSAmModelDeclaration _seSAmModelDeclaration;

	public CacheObjectClassDeclFunctionDeclarationListAble(
		ISeSAmModelDeclaration seSAmModelDeclaration,
		IObjectClassDeclaration objectClassDeclaration) {
		super();

		_objectClassDeclaration = objectClassDeclaration;
		_seSAmModelDeclaration = seSAmModelDeclaration;
	}

	public Collection getFunctionDeclarationList() {
		if (_cachedSet == null) {
			_cachedSet = new LinkedHashSet();

			IFunctionDeclarationListAble able =
				_seSAmModelDeclaration.getAvailibleFunctionDeclarationListFor(_objectClassDeclaration);

			CollectionsHelper.addAll(_cachedSet, able.getFunctionDeclarations());
			able.remove();

			Iterator it = _seSAmModelDeclaration.getAllAvailibleFunctionDeclarations();
			while (it.hasNext()) {
				IFunctionDeclaration element = (IFunctionDeclaration) it.next();
				if (!_cachedSet.contains(element))
					_cachedSet.add(element);
			}
		}

		return _cachedSet;
	}

	public Iterator getFunctionDeclarations() {
		return getFunctionDeclarationList().iterator();
	}

	public void update() {
		_cachedSet = null;

		stateChanged();
	}
}
