package de.uniwue.ki.mas.xml.reader;

import java.util.HashMap;
import java.util.Map;

import junit.framework.Assert;
import de.uniwue.ki.mas.util.declaration.IDeclaration;
import de.uniwue.ki.mas.xml.castor.XMLRootObject;


/**
 * Insert the type's description here.
 * Creation date: (05.09.2001 17:54:34)
 * @author Christoph Oechslein
 */
final class XMLObjectToDeclaration
   implements IXMLObjectToDeclaration {

   private final Map _map = new HashMap();

   public void changeDeclaration(XMLRootObject object, IDeclaration oldDeclaration, 
                                 IDeclaration newDeclaration) {
      Assert.assertEquals(oldDeclaration, getDeclaration(object));
      _map.put(object, newDeclaration);
   }


   public boolean containsXMLObject(XMLRootObject object) {

      if (Assert.ASSERTION_ON) {
         Assert.assertNotNull("object", object);
      }

      return _map.containsKey(object);
   }

   public IDeclaration getDeclaration(XMLRootObject object) {
      Assert.assertNotNull(object);
      Assert.assertTrue(containsXMLObject(object));

      return (IDeclaration)_map.get(object);
   }

   public void setDeclaration(XMLRootObject object, IDeclaration declaration) {
      Assert.assertNotNull(declaration);
      Assert.assertNotNull(object);
      Assert.assertTrue(!containsXMLObject(object));
      _map.put(object, declaration);
   }
}