package de.uniwue.ki.mas.xml.reader.oldfunctions;
import de.uniwue.ki.mas.basics.action.AbstractFunctionActionDeclaration;
import de.uniwue.ki.mas.basics.feature.spatial.function.FunctionDeclarationSpatialFactory;
import de.uniwue.ki.mas.basics.feature.spatial.position.Position2DType;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionCall.FunctionCallDeclarationFactory;
import de.uniwue.ki.mas.basics.functionCall.IComposedFunctionCallInternDeclaration;
import de.uniwue.ki.mas.basics.type.GenericSimObjectType;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.mas.xml.reader.XMLModelReader;
import de.uniwue.ki.mas.xml.reader.XMLReadException;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Insert the class' description here.
 * Creation date: (04.09.2001 13:16:34)
 * @author Christoph Oechslein
 */

class BeamBodyToPositionSpecificFunctionDeclaration
	extends AbstractFunctionActionDeclaration
	implements RemovedFunctionDeclarationList.ITransformer {

	public BeamBodyToPositionSpecificFunctionDeclaration() {
		super(
			"BeamBodyTo",
			CollectionsHelper.createList(GenericSimObjectType.getGeneralSimObjectType(), Position2DType.getInstance()));
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions)
		throws ModelCompilingException {

		throw new UnsupportedOperationException();
	}

	public IComposedFunctionCallInternDeclaration transform(
		IComposedFunctionCallInternDeclaration composedFunctionCallInternDeclaration,
		XMLModelReader xmlModelReader)
		throws XMLReadException {

		return FunctionCallDeclarationFactory.getInstance().createComposedFunctionCallInternDeclaration(
			composedFunctionCallInternDeclaration.getParent(),
			FunctionDeclarationSpatialFactory.BEAM_FUN_DECL_HAS_NO_SPATIAL_INFO,
			CollectionsHelper.createList(
				FunctionCallDeclarationFactory.getInstance().createComposedFunctionCallInternDeclaration(
					null,
					FunctionDeclarationSpatialFactory.GET_SPATIAL_INFO_FUN_DECL,
					CollectionsHelper.createList(composedFunctionCallInternDeclaration.getChild(0))),
				composedFunctionCallInternDeclaration.getChild(1)));
	}
}