package de.uniwue.ki.mas.xml.reader.oldfunctions;
import java.util.Iterator;

import de.uniwue.ki.mas.basics.functionCall.IComposedFunctionCallInternDeclaration;
import de.uniwue.ki.mas.basics.functionDeclaration.*;
import de.uniwue.ki.mas.basics.type.ISpecificType;
import de.uniwue.ki.mas.basics.type.IType;
import de.uniwue.ki.mas.basics.type.dependent.DependentTypeBindings;
import de.uniwue.ki.mas.model.ISeSAmDeclaration;
import de.uniwue.ki.mas.xml.reader.XMLModelReader;
/**
 * filter: set<T> filter(boolean function(<T>), set<T>)
 * Insert the class' description here.
 * Creation date: (27.10.2000 17:49:45)
 * @author Christoph Oechslein
 */

class ChangeNameGenericFunctionDeclaration
	extends AbstractFunctionDeclaration
	implements IGenericFunctionDeclaration, RemovedFunctionDeclarationList.ITransformer {

	private final IGenericFunctionDeclaration _newGenericFunctionDeclaration;

	public ChangeNameGenericFunctionDeclaration(
		String oldName,
		IGenericFunctionDeclaration newGenericFunctionDeclaration) {

		super(oldName);

		_newGenericFunctionDeclaration = newGenericFunctionDeclaration;
	}

	public boolean canCreateFunctionDeclarationWith(ISpecificType outputType) {
		return _newGenericFunctionDeclaration.canCreateFunctionDeclarationWith(outputType);
	}
	
	public boolean canCreateFunctionDeclarationWith(
		ISeSAmDeclaration sesamDeclaration,
		ISpecificType outputType) {
		return canCreateFunctionDeclarationWith(outputType);
	}


	public ISpecificFunctionDeclaration createFunctionDeclaration(
		ISpecificType outputType,
		Iterator inputTypes) {

		return _newGenericFunctionDeclaration.createFunctionDeclaration(outputType, inputTypes);
	}

	public String getSignatureWithoutNameAndOutputType(ISpecificType outputType) {
		return _newGenericFunctionDeclaration.getSignatureWithoutNameAndOutputType(outputType);
	}

	public IComposedFunctionCallInternDeclaration transform(
		IComposedFunctionCallInternDeclaration composedFunctionCallInternDeclaration,
		XMLModelReader xmlModelReader) {

		return composedFunctionCallInternDeclaration;
	}

	public ISpecificFunctionDeclaration createFunctionDeclaration(
		ISpecificType outputType,
		DependentTypeBindings bindings) {

		return _newGenericFunctionDeclaration.createFunctionDeclaration(outputType, bindings);
	}

	public Iterator getDependentTypes(ISpecificType outputSpecificType) {
		return _newGenericFunctionDeclaration.getDependentTypes(outputSpecificType);
	}

	public boolean needSpecificOutputTypeToCreateSpecificFunctionDeclaration(IComposedFunctionCallInternDeclaration composedFunctionCallInternDeclaration) {
		return _newGenericFunctionDeclaration.needSpecificOutputTypeToCreateSpecificFunctionDeclaration(
			composedFunctionCallInternDeclaration);
	}

	public IType getOutputType() {
		return _newGenericFunctionDeclaration.getOutputType();
	}

	public boolean isExpertFunctionDeclaration() {
		return _newGenericFunctionDeclaration.isExpertFunctionDeclaration();
	}

	public String getFullSignature() {
		return null;
	}
}