package de.uniwue.ki.mas.xml.reader.oldfunctions;

import java.util.HashMap;

import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionCall.*;
import de.uniwue.ki.mas.basics.functionDeclaration.*;
import de.uniwue.ki.mas.basics.type.*;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.mas.xml.reader.XMLModelReader;
import de.uniwue.ki.mas.xml.reader.XMLReadException;
import de.uniwue.ki.util.collection.CollectionsHelper;
import de.uniwue.ki.util.functions.IMapFunction;

/**
 * Creation date: 13.12.2002, 16:15:15
 * @author oechslein
 */
public class ChangeNameSpecificFunctionDeclaration
	extends AbstractSpecificFunctionDeclaration
	implements RemovedFunctionDeclarationList.ITransformer {

	private final ISpecificFunctionDeclaration _newSpecificFunctionDeclaration;

	public ChangeNameSpecificFunctionDeclaration(
		String name,
		ISpecificFunctionDeclaration newSpecificFunctionDeclaration) {
		super(name);

		_newSpecificFunctionDeclaration = newSpecificFunctionDeclaration;
	}

	public IComposedFunctionCallInternDeclaration transform(
		IComposedFunctionCallInternDeclaration composedFunctionCallInternDeclaration,
		XMLModelReader xmlModelReader)
		throws XMLReadException {

		final HashMap objectMapping = new HashMap();

		return FunctionCallDeclarationFactory
			.getInstance()
			.createComposedFunctionCallInternDeclaration(
				composedFunctionCallInternDeclaration.getParent(),
				_newSpecificFunctionDeclaration,
				CollectionsHelper
					.map(composedFunctionCallInternDeclaration.getChildren(), new IMapFunction() {

			public Object map(Object obj) throws Exception {
				IFunctionCallInternDeclaration child = (IFunctionCallInternDeclaration) obj;
				return (IFunctionCallInternDeclaration) child.copy(objectMapping);
			}
		}));
	}

	public IFunctionCallInternDeclaration createDefaultFunctionCallInternDeclarationAt(int index) {
		return _newSpecificFunctionDeclaration.createDefaultFunctionCallInternDeclarationAt(index);
	}

	public IFunction createFunction(
		ICreateFunctionArgs createFunctionArgs,
		IComposedFunctionCallInternDeclaration composedFunctionCallInternDeclaration)
		throws ModelCompilingException {

		return _newSpecificFunctionDeclaration.createFunction(
			createFunctionArgs,
			composedFunctionCallInternDeclaration);
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions)
		throws ModelCompilingException {

		return _newSpecificFunctionDeclaration.createFunction(createFunctionArgs, functions);
	}

	public IParametricFunction createParametricFunction(ICreateFunctionArgs createFunctionArgs)
		throws ModelCompilingException {

		return _newSpecificFunctionDeclaration.createParametricFunction(createFunctionArgs);
	}

	public IGenericFunctionDeclaration getGenericFunctionDeclaration() {
		return _newSpecificFunctionDeclaration.getGenericFunctionDeclaration();
	}

	public ISpecificFunctionType getSpecificFunctionType() {
		return _newSpecificFunctionDeclaration.getSpecificFunctionType();
	}

	public int getSpecificInputDefaultArgsLength() {
		return _newSpecificFunctionDeclaration.getSpecificInputDefaultArgsLength();
	}

	public int getSpecificInputMaxArgsLength() {
		return _newSpecificFunctionDeclaration.getSpecificInputMaxArgsLength();
	}

	public int getSpecificInputMinArgsLength() {
		return _newSpecificFunctionDeclaration.getSpecificInputMinArgsLength();
	}

	public ISpecificType getSpecificInputTypeAt(int index) {
		return _newSpecificFunctionDeclaration.getSpecificInputTypeAt(index);
	}

	public String getSpecificInputTypeNameAt(int index) {
		return _newSpecificFunctionDeclaration.getSpecificInputTypeNameAt(index);
	}

	public ISpecificType getSpecificOutputType() {
		return _newSpecificFunctionDeclaration.getSpecificOutputType();
	}

	public IType getOutputType() {
		return _newSpecificFunctionDeclaration.getOutputType();
	}

	public boolean isExpertFunctionDeclaration() {
		return _newSpecificFunctionDeclaration.isExpertFunctionDeclaration();
	}

	protected String getSignatureWithoutNameAndOutputType() {
		return null;
	}
}
