package de.uniwue.ki.mas.xml.reader.oldfunctions;
import junit.framework.Assert;

import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.function.object.FunctionDeclarationObjectFactory;
import de.uniwue.ki.mas.basics.functionCall.FunctionCallDeclarationFactory;
import de.uniwue.ki.mas.basics.functionCall.IComposedFunctionCallInternDeclaration;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionArgsDeclaration;
import de.uniwue.ki.mas.basics.type.*;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.mas.xml.reader.XMLModelReader;
import de.uniwue.ki.util.collection.CollectionsHelper;
/**
 * Insert the class' description here.
 * Creation date: (04.09.2001 17:26:30)
 * @author Christoph Oechslein
 */

final class GetAllObjectsOfTypeSpecificFunctionDeclaration
	extends AbstractSpecificFunctionArgsDeclaration
	implements RemovedFunctionDeclarationList.ITransformer {

	public GetAllObjectsOfTypeSpecificFunctionDeclaration() {
		super(
			"GetAllObjectsOfType",
			GenericIteratorType.getInstance().createSpecificIteratorType(GenericSimObjectType.getGeneralSimObjectType()),
			CollectionsHelper.createList(ObjectClassDeclarationType.getInstance()),
			false);
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions)
		throws ModelCompilingException {

		throw new UnsupportedOperationException();
	}

	public IComposedFunctionCallInternDeclaration transform(
		IComposedFunctionCallInternDeclaration composedFunctionCallInternDeclaration,
		XMLModelReader xmlModelReader) {

		Assert.assertEquals(1, composedFunctionCallInternDeclaration.getChildCount());

		return FunctionCallDeclarationFactory.getInstance().createComposedFunctionCallInternDeclaration(
			composedFunctionCallInternDeclaration.getParent(),
			FunctionDeclarationObjectFactory.GET_ALL_OBJECTS_OF_TYPE_SPECIFIC_FUNCTION_DECLARATION,
			CollectionsHelper.createList(
				composedFunctionCallInternDeclaration.getChild(0),
				FunctionCallDeclarationFactory.getInstance().createAtomicFunctionCallInternDeclaration(
					null,
					BooleanType.getInstance(),
					Boolean.TRUE),
				FunctionCallDeclarationFactory.getInstance().createAtomicFunctionCallInternDeclaration(
					null,
					BooleanType.getInstance(),
					Boolean.TRUE)));
	}
}