package de.uniwue.ki.mas.xml.reader.oldfunctions;
import junit.framework.Assert;

import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.function.object.FunctionDeclarationObjectFactory;
import de.uniwue.ki.mas.basics.function.object.GetAllObjectsGenericFunctionDeclaration;
import de.uniwue.ki.mas.basics.functionCall.FunctionCallDeclarationFactory;
import de.uniwue.ki.mas.basics.functionCall.IComposedFunctionCallInternDeclaration;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionArgsDeclaration;
import de.uniwue.ki.mas.basics.functionDeclaration.IGenericFunctionDeclaration;
import de.uniwue.ki.mas.basics.type.*;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.mas.xml.reader.XMLModelReader;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Creation date: (04.09.2001 17:26:30)
 * @author Christoph Oechslein
 */

final class GetAllObjectsSpecificFunctionDeclaration
	extends AbstractSpecificFunctionArgsDeclaration
	implements RemovedFunctionDeclarationList.ITransformer {

	public GetAllObjectsSpecificFunctionDeclaration() {
		super(
			"GetAllObjects",
			GenericIteratorType.getInstance().createSpecificIteratorType(
				GenericSimObjectType.getGeneralSimObjectType()),
			CollectionsHelper.EMPTY_LIST,
			false);

		setDocumentation(
			"Returns all current objects (including the in this tick added objects and excluding the killed objects)."
				+ "The order is not specified and also not random.");
	}

	public IGenericFunctionDeclaration getGenericFunctionDeclaration() {
		return FunctionDeclarationObjectFactory.GET_ALL_OBJECTS_GENERIC_FUNCTION_DECLARATION;
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions)
		throws ModelCompilingException {

		throw new UnsupportedOperationException();
	}

	public IComposedFunctionCallInternDeclaration transform(
		IComposedFunctionCallInternDeclaration composedFunctionCallInternDeclaration,
		XMLModelReader xmlModelReader) {

		Assert.assertEquals(0, composedFunctionCallInternDeclaration.getChildCount());

		return FunctionCallDeclarationFactory.getInstance().createComposedFunctionCallInternDeclaration(
			composedFunctionCallInternDeclaration.getParent(),
			FunctionDeclarationObjectFactory
				.GET_ALL_OBJECTS_GENERIC_FUNCTION_DECLARATION
				.createFunctionDeclaration(
				GenericIteratorType.getInstance().createSpecificIteratorType(
					GenericSimObjectType.getGeneralSimObjectType()),
				CollectionsHelper.createIterator(BooleanType.getInstance(), BooleanType.getInstance())),
			CollectionsHelper.createList(
				FunctionCallDeclarationFactory.getInstance().createAtomicFunctionCallInternDeclaration(
					null,
					BooleanType.getInstance(),
					Boolean.TRUE),
				FunctionCallDeclarationFactory.getInstance().createAtomicFunctionCallInternDeclaration(
					null,
					BooleanType.getInstance(),
					Boolean.TRUE)));
	}
}