package de.uniwue.ki.mas.xml.reader.oldfunctions;
import java.util.List;

import de.uniwue.ki.mas.basics.action.AbstractFunctionActionDeclaration;
import de.uniwue.ki.mas.basics.feature.spatial.function.FunctionDeclarationSpatialFactory;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionCall.FunctionCallDeclarationFactory;
import de.uniwue.ki.mas.basics.functionCall.IComposedFunctionCallInternDeclaration;
import de.uniwue.ki.mas.basics.functionDeclaration.ISpecificFunctionDeclaration;
import de.uniwue.ki.mas.basics.type.ISpecificType;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.mas.xml.reader.XMLModelReader;
import de.uniwue.ki.mas.xml.reader.XMLReadException;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Insert the class' description here.
 * Creation date: (04.09.2001 13:16:34)
 * @author Christoph Oechslein
 */

class InsertGetSpatialInfoSpecificFunctionDeclaration
	extends AbstractFunctionActionDeclaration
	implements RemovedFunctionDeclarationList.ITransformer {

	private final ISpecificFunctionDeclaration _newSpecificFunDecl;

	public InsertGetSpatialInfoSpecificFunctionDeclaration(
		String name,
		List inputTypes,
		ISpecificFunctionDeclaration newSpecificFunDecl) {
		super(name, inputTypes);

		_newSpecificFunDecl = newSpecificFunDecl;
	}

	public InsertGetSpatialInfoSpecificFunctionDeclaration(
		List inputTypes,
		ISpecificFunctionDeclaration newSpecificFunDecl) {
		this(newSpecificFunDecl.getName(), inputTypes, newSpecificFunDecl);
	}

	public InsertGetSpatialInfoSpecificFunctionDeclaration(
		String name,
		ISpecificType inputType,
		ISpecificFunctionDeclaration newSpecificFunDecl) {
		this(name, CollectionsHelper.createList(inputType), newSpecificFunDecl);
	}

	public InsertGetSpatialInfoSpecificFunctionDeclaration(
		ISpecificType inputType,
		ISpecificFunctionDeclaration newSpecificFunDecl) {
		this(newSpecificFunDecl.getName(), CollectionsHelper.createList(inputType), newSpecificFunDecl);
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions)
		throws ModelCompilingException {

		throw new UnsupportedOperationException();
	}

	public IComposedFunctionCallInternDeclaration transform(
		IComposedFunctionCallInternDeclaration composedFunctionCallInternDeclaration,
		XMLModelReader xmlModelReader)
		throws XMLReadException {

		List childList = CollectionsHelper.asLinkedList(composedFunctionCallInternDeclaration.getChildren());

		childList.add(
			0,
			FunctionCallDeclarationFactory.getInstance().createComposedFunctionCallInternDeclaration(
				null,
				FunctionDeclarationSpatialFactory.GET_MY_SPATIAL_FUNCTION_DECL));

		return FunctionCallDeclarationFactory.getInstance().createComposedFunctionCallInternDeclaration(
			composedFunctionCallInternDeclaration.getParent(),
			_newSpecificFunDecl,
			childList);
	}
}