package de.uniwue.ki.mas.xml.reader.oldfunctions;
import de.uniwue.ki.mas.basics.action.rest.FunctionActionRestDeclarationFactory;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionArgument.ISpecificFunctionDeclarationWithArgDeclBinds;
import de.uniwue.ki.mas.basics.functionCall.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionArgsDeclaration;
import de.uniwue.ki.mas.basics.type.*;
import de.uniwue.ki.mas.model.ModelCompilingException;
import de.uniwue.ki.mas.xml.reader.XMLModelReader;
import de.uniwue.ki.mas.xml.reader.XMLReadException;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Insert the type's description here.
 * Creation date: (01.10.2001 16:25:22)
 * @author Christoph Oechslein
 */

final class OldWhileSpecificFunctionDeclaration
	extends AbstractSpecificFunctionArgsDeclaration
	implements RemovedFunctionDeclarationList.ITransformer {

	public OldWhileSpecificFunctionDeclaration() {
		super(
			"While",
			VoidType.getInstance(),
			CollectionsHelper.createList(
				GenericFunctionType.getInstance().createSpecificFunctionType(
					BooleanType.getInstance(),
					CollectionsHelper.EMPTY_LIST),
				GenericFunctionType.getInstance().createSpecificFunctionType(
					VoidType.getInstance(),
					CollectionsHelper.EMPTY_LIST)));
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions)
		throws ModelCompilingException {
		throw new UnsupportedOperationException();
	}

	public IComposedFunctionCallInternDeclaration transform(
		IComposedFunctionCallInternDeclaration composedFunctionCallInternDeclaration,
		XMLModelReader xmlModelReader)
		throws XMLReadException {

		IAtomicFunctionCallInternDeclaration testCall =
			(IAtomicFunctionCallInternDeclaration) composedFunctionCallInternDeclaration.getChild(0);
		IAtomicFunctionCallInternDeclaration doCall =
			(IAtomicFunctionCallInternDeclaration) composedFunctionCallInternDeclaration.getChild(1);

		IFunctionCallDeclaration realTestCall =
			((ISpecificFunctionDeclarationWithArgDeclBinds) testCall.getArgumentDeclaration().getObject())
				.getParametricFunctionCallDeclaration()
				.getFunctionCallDeclaration();

		IFunctionCallDeclaration realDoCall =
			((ISpecificFunctionDeclarationWithArgDeclBinds) doCall.getArgumentDeclaration().getObject())
				.getParametricFunctionCallDeclaration()
				.getFunctionCallDeclaration();

		xmlModelReader.doDelaySettingsIfAvailible(realTestCall);
		xmlModelReader.doDelaySettingsIfAvailible(realDoCall);

		return FunctionCallDeclarationFactory.getInstance().createComposedFunctionCallInternDeclaration(
			composedFunctionCallInternDeclaration.getParent(),
			FunctionActionRestDeclarationFactory.WHILE_GENERIC_FUNCTION_DECL.createFunctionDeclaration(
				realDoCall.getSpecificOutputType(),
				CollectionsHelper.createIterator(
					realTestCall.getSpecificOutputType(),
					realDoCall.getSpecificOutputType())),
			CollectionsHelper.createList(
				realTestCall.getFunctionCallInternDeclaration(),
				realDoCall.getFunctionCallInternDeclaration()));
	}

}