package de.uniwue.ki.mas.xml.reader.oldfunctions;

import java.util.Iterator;

import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.function.number.FunctionDeclarationNumberFactory;
import de.uniwue.ki.mas.basics.function.random.FunctionDeclarationRandomFactory;
import de.uniwue.ki.mas.basics.functionCall.*;
import de.uniwue.ki.mas.basics.functionDeclaration.*;
import de.uniwue.ki.mas.basics.type.*;
import de.uniwue.ki.mas.xml.reader.XMLModelReader;
import de.uniwue.ki.mas.xml.reader.XMLReadException;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * @author oechslein
 * 
 * Creation date: 26.05.2003
 */
public class RandomIntGenericFunctionArgsDeclaration
	extends AbstractGenericFunctionDeclarationWithoutDependents
	implements RemovedFunctionDeclarationList.ITransformer {

	protected RandomIntGenericFunctionArgsDeclaration() {
		super(
			FunctionDeclarationRandomFactory.RANDOM_INT_SPECIFIC_FUN_DECL.getName(),
			DoubleType.getInstance());
	}

	public ISpecificFunctionDeclaration createFunctionDeclaration(ISpecificType outputType) {
		throw new UnsupportedOperationException();
	}

	public ISpecificFunctionDeclaration createFunctionDeclaration(Iterator inputTypes) {
		ISpecificType type1 = getNextSpecificType(inputTypes);
		ISpecificType type2 = getNextSpecificType(inputTypes);

		if (inputTypes.hasNext() || type1 == null || type2 == null) {
			return null;
		}

		if (((DoubleType.getInstance().equals(type1)) && (DoubleType.getInstance().equals(type2)))
			|| ((IntegerType.getInstance().equals(type1)) && (DoubleType.getInstance().equals(type2)))
			|| ((DoubleType.getInstance().equals(type1)) && (IntegerType.getInstance().equals(type2)))) {
			return new RandomIntSpecificFunctionArgsDeclaration();
		} else
			return null;
	}

	public IComposedFunctionCallInternDeclaration transform(
		IComposedFunctionCallInternDeclaration composedFunctionCallInternDeclaration,
		XMLModelReader xmlModelReader)
		throws XMLReadException {
		IComposedFunctionCallInternDeclaration composedFunctionCallInternDeclaration1 =
			composedFunctionCallInternDeclaration;

		return FunctionCallDeclarationFactory.getInstance().createComposedFunctionCallInternDeclaration(
			composedFunctionCallInternDeclaration.getParent(),
			FunctionDeclarationRandomFactory.RANDOM_INT_SPECIFIC_FUN_DECL,
			CollectionsHelper.createList(
				createNewChild(composedFunctionCallInternDeclaration1.getChild(0)),
				createNewChild(composedFunctionCallInternDeclaration.getChild(1))));
	}

	private IFunctionCallInternDeclaration createNewChild(IFunctionCallInternDeclaration child) {
		if (child instanceof IComposedFunctionCallInternDeclaration) {
			if (IntegerType.getInstance().equals(child.getSpecificOutputType()))
				return child;
			else
				return FunctionCallDeclarationFactory
					.getInstance()
					.createComposedFunctionCallInternDeclaration(
					null,
					FunctionDeclarationNumberFactory.FLOOR_FUNCTION_DECLARATION,
					CollectionsHelper.createList(child));
		} else {
			double value =
				((Number) ((IAtomicFunctionCallInternDeclaration) child)
					.getArgumentDeclaration()
					.getObject())
					.doubleValue();
			return FunctionCallDeclarationFactory.getInstance().createAtomicFunctionCallInternDeclaration(
				null,
				IntegerType.getInstance(),
				new Integer((int) Math.floor(value)));
		}
	}

	private final class RandomIntSpecificFunctionArgsDeclaration
		extends AbstractSpecificFunctionArgsDeclaration {

		public RandomIntSpecificFunctionArgsDeclaration() {
			super(
				"RandomInt",
				IntegerType.getInstance(),
				CollectionsHelper.createList(DoubleType.getInstance(), DoubleType.getInstance()),
				false);
		}

		public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions) {
			throw new UnsupportedOperationException();
		}

		public IGenericFunctionDeclaration getGenericFunctionDeclaration() {
			return RandomIntGenericFunctionArgsDeclaration.this;
		}
	}

	public String getSignatureWithoutNameAndOutputType(ISpecificType outputType) {
		return null;
	}
}
