package de.uniwue.ki.mas.xml.reader.oldfunctions;

import java.util.Iterator;

import junit.framework.Assert;

import de.uniwue.ki.mas.basics.functionCall.IComposedFunctionCallInternDeclaration;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractGenericFunctionDeclarationWithUnspecificDependents;
import de.uniwue.ki.mas.basics.functionDeclaration.ISpecificFunctionDeclaration;
import de.uniwue.ki.mas.basics.type.ISpecificType;
import de.uniwue.ki.mas.basics.type.VoidType;
import de.uniwue.ki.mas.basics.type.composed.GenericComposedTypeAttributeType;
import de.uniwue.ki.mas.basics.type.composed.function.FunctionDeclarationComposedTypeFactory;
import de.uniwue.ki.mas.basics.type.dependent.*;
import de.uniwue.ki.mas.xml.reader.XMLModelReader;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * void SetValueOfUserType(comp<A1,T1;...;An,Tn>, <Aj,Tj>, Tj)
 * Creation date: 13.06.2002, 18:44:26
 * @author oechslein
 */
final class SetValueOfComposedTypeGenericFunctionDeclaration
	extends AbstractGenericFunctionDeclarationWithUnspecificDependents
	implements RemovedFunctionDeclarationList.ITransformer {

	private static final IDependentType _dependentComposedTypeAttributeType =
		new ConstraintGenericDependentType(
			"User Type",
			GenericComposedTypeAttributeType.getInstanceWriteable());

	public SetValueOfComposedTypeGenericFunctionDeclaration() {

		super(
			"SetValueOfUserType",
			VoidType.getInstance(),
			CollectionsHelper.createList(_dependentComposedTypeAttributeType));
	}

	/**
	 * @param outputType ISpecificType
	 * @param bindings DependentTypeBindings
	 * @return ISpecificFunctionDeclaration
	 * @see de.uniwue.ki.mas.basics.functionDeclaration.IGenericFunctionDeclaration#createFunctionDeclaration(ISpecificType, DependentTypeBindings)
	 */
	public ISpecificFunctionDeclaration createFunctionDeclaration(
		ISpecificType outputType,
		DependentTypeBindings bindings) {

		Assert.fail();

		return null;
	}

	public ISpecificFunctionDeclaration createFunctionDeclaration(Iterator inputTypes) {
		return FunctionDeclarationComposedTypeFactory
			.SET_COMPOSED_TYPE_VALUE_GENERIC_FUN_DECL
			.createFunctionDeclaration(inputTypes);
	}

		public IComposedFunctionCallInternDeclaration transform(
		IComposedFunctionCallInternDeclaration composedFunctionCallInternDeclaration,
		XMLModelReader xmlModelReader) {
			
	return composedFunctionCallInternDeclaration;
	}

		public String getSignatureWithoutNameAndOutputType(ISpecificType outputType) {
			return null;
		}
}
