package de.uniwue.ki.mas.xml.reader.oldfunctions;
import de.uniwue.ki.mas.basics.action.rest.FunctionActionRestDeclarationFactory;
import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionArgument.*;
import de.uniwue.ki.mas.basics.functionCall.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionArgsDeclaration;
import de.uniwue.ki.mas.basics.type.*;
import de.uniwue.ki.mas.sim.experiment.function.FunctionDeclarationExperimentFactory;
import de.uniwue.ki.mas.xml.reader.XMLModelReader;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Insert the type's description here.
 * Creation date: (01.10.2001 16:25:22)
 * @author Christoph Oechslein
 */

final class SimulateNTimesSimulationSpecificFunctionDeclarationOld
	extends AbstractSpecificFunctionArgsDeclaration
	implements RemovedFunctionDeclarationList.ITransformer {

	public SimulateNTimesSimulationSpecificFunctionDeclarationOld() {
		super(
			"SimulateNTimesSimulation",
			VoidType.getInstance(),
			CollectionsHelper.createList(
				SimulationDeclarationType.getInstance(),
				DoubleType.getInstance(),
				BooleanType.getInstance()));
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions) {
		throw new UnsupportedOperationException();
	}

	private ISpecificFunctionDeclarationWithArgDeclBinds createParametricFunctionCallDecl(IComposedFunctionCallInternDeclaration oldComposedFunctionCallInternDeclaration) {

		ISpecificFunctionDeclarationWithArgDeclBinds specificFunctionDeclarationWithArgDeclBinds =
			new SpecificFunctionDeclarationWithArgDeclBinds(VoidType.getInstance());

		specificFunctionDeclarationWithArgDeclBinds.getFunctionArgumentDeclarationList().add(
			FunctionArgumentDeclarationFactory.getInstance().createArgumentDeclaration(
				DoubleType.getInstance()));

		specificFunctionDeclarationWithArgDeclBinds
			.getParametricFunctionCallDeclaration()
			.getFunctionCallDeclaration()
			.setFunctionCallInternDeclaration(
				createSimulateFunctionCallDecl(oldComposedFunctionCallInternDeclaration));

		return specificFunctionDeclarationWithArgDeclBinds;
	}

	private IComposedFunctionCallInternDeclaration createSimulateFunctionCallDecl(IComposedFunctionCallInternDeclaration oldComposedFunctionCallInternDeclaration) {
		return FunctionCallDeclarationFactory.getInstance().createComposedFunctionCallInternDeclaration(
			null,
			FunctionDeclarationExperimentFactory.SIM_SIMULATION_SPECIFIC_FUNCTION_DECL,
			CollectionsHelper.createList(
				oldComposedFunctionCallInternDeclaration.getChild(0),
				oldComposedFunctionCallInternDeclaration.getChild(2)));
	}

	public IComposedFunctionCallInternDeclaration transform(
		IComposedFunctionCallInternDeclaration composedFunctionCallInternDeclaration,
		XMLModelReader xmlModelReader) {

		if (composedFunctionCallInternDeclaration.getChild(1)
			instanceof IAtomicFunctionCallInternDeclaration) {
			if (((IAtomicFunctionCallInternDeclaration) composedFunctionCallInternDeclaration.getChild(1))
				.getArgumentDeclaration()
				.getObject()
				.equals(new Double(1.0))) {
				return createSimulateFunctionCallDecl(composedFunctionCallInternDeclaration);
			}
		}

		ISpecificFunctionDeclarationWithArgDeclBinds specificFunctionDeclarationWithArgDeclBinds =
			createParametricFunctionCallDecl(composedFunctionCallInternDeclaration);

		return FunctionCallDeclarationFactory.getInstance().createComposedFunctionCallInternDeclaration(
			composedFunctionCallInternDeclaration.getParent(),
			FunctionActionRestDeclarationFactory.FOR_TIMES_GENERIC_FUNCTION_DECL.createFunctionDeclaration(
				VoidType.getInstance(),
				CollectionsHelper.createIterator(
					GenericFunctionType.getInstance().createSpecificFunctionType(
						VoidType.getInstance(),
						CollectionsHelper.createList(DoubleType.getInstance())),
					DoubleType.getInstance(),
					DoubleType.getInstance())),
			CollectionsHelper.createList(
				FunctionCallDeclarationFactory.getInstance().createAtomicFunctionCallInternDeclaration(
					null,
					specificFunctionDeclarationWithArgDeclBinds.getSpecificFunctionType(),
					specificFunctionDeclarationWithArgDeclBinds),
				FunctionCallDeclarationFactory.getInstance().createAtomicFunctionCallInternDeclaration(
					null,
					DoubleType.getInstance(),
					new Double(0.0)),
				composedFunctionCallInternDeclaration.getChild(1)));
	}
}