package de.uniwue.ki.mas.xml.reader.oldfunctions;

import java.util.*;

import de.uniwue.ki.mas.basics.function.*;
import de.uniwue.ki.mas.basics.functionCall.*;
import de.uniwue.ki.mas.basics.functionDeclaration.AbstractSpecificFunctionArgsDeclaration;
import de.uniwue.ki.mas.basics.functionDeclaration.ISpecificFunctionDeclaration;
import de.uniwue.ki.mas.basics.type.ISpecificType;
import de.uniwue.ki.mas.basics.type.SimulationDeclarationType;
import de.uniwue.ki.mas.sim.experiment.function.FunctionDeclarationExperimentFactory;
import de.uniwue.ki.mas.xml.reader.XMLModelReader;
import de.uniwue.ki.mas.xml.reader.XMLReadException;
import de.uniwue.ki.util.collection.CollectionsHelper;

/**
 * Insert the type's description here.
 * Creation date: (01.10.2001 16:25:22)
 * @author Christoph Oechslein
 */

final class SimulationTransformSpecificFunctionDeclaration
	extends AbstractSpecificFunctionArgsDeclaration
	implements RemovedFunctionDeclarationList.ITransformer {

	private final ISpecificFunctionDeclaration _decl;

	public SimulationTransformSpecificFunctionDeclaration(
		ISpecificFunctionDeclaration decl,
		ISpecificType outputType) {
		this(decl, outputType, CollectionsHelper.createList(SimulationDeclarationType.getInstance()));
	}

	public SimulationTransformSpecificFunctionDeclaration(
		ISpecificFunctionDeclaration decl,
		ISpecificType outputType,
		List inputTypeList) {
		this(decl, decl.getName(), outputType, inputTypeList);
	}

	public SimulationTransformSpecificFunctionDeclaration(
		ISpecificFunctionDeclaration decl,
		String name,
		ISpecificType outputType,
		List inputTypeList) {

		super(name, outputType, inputTypeList);

		_decl = decl;
	}

	public IFunction createFunction(ICreateFunctionArgs createFunctionArgs, IFunctionList functions) {
		throw new UnsupportedOperationException();
	}

	public IComposedFunctionCallInternDeclaration transform(
		IComposedFunctionCallInternDeclaration composedFunctionCallInternDeclaration,
		XMLModelReader xmlModelReader)
		throws XMLReadException {

		List newChilds = new LinkedList();

		Iterator it = composedFunctionCallInternDeclaration.getChildren();
		while (it.hasNext()) {
			IFunctionCallInternDeclaration element = (IFunctionCallInternDeclaration) it.next();

			if (SimulationDeclarationType.getInstance().equals(element.getSpecificOutputType())) {
				newChilds.add(
					FunctionCallDeclarationFactory.getInstance().createComposedFunctionCallInternDeclaration(
						element.getParent(),
						FunctionDeclarationExperimentFactory.CREATE_SIMULATION_SPECIFIC_FUNCTION_DECL,
						CollectionsHelper.createList(element)));

			} else {
				newChilds.add(element);
			}
		}

		return FunctionCallDeclarationFactory.getInstance().createComposedFunctionCallInternDeclaration(
			composedFunctionCallInternDeclaration.getParent(),
			_decl,
			newChilds);
	}
}