package de.uniwue.ki.mas.xml.writer;
import java.util.HashMap;
import java.util.Map;

import junit.framework.Assert;

import de.uniwue.ki.mas.util.declaration.IDeclaration;
import de.uniwue.ki.mas.xml.castor.XMLRootObject;

/**
 * Insert the type's description here.
 * Creation date: (06.09.2001 11:24:58)
 * @author Christoph Oechslein
 */
final class DeclarationToXMLObject implements IDeclarationToXMLObject {

	private final Map _map = new HashMap();

	public boolean containsDeclaration(IDeclaration declaration) {
		if (Assert.ASSERTION_ON)
			Assert.assertNotNull(declaration);
		return _map.containsKey(declaration);
	}

	public XMLRootObject getObject(IDeclaration declaration) throws XMLWriteException {
		if (declaration == null)
			throw new XMLWriteException("Referenced Object = null");
		if (!containsDeclaration(declaration))
			throw new XMLWriteException("Referenced Object not availible: " + declaration.getName());

		return (XMLRootObject) _map.get(declaration);
	}

	public void setObject(IDeclaration declaration, XMLRootObject object) {
		Assert.assertNotNull(declaration);
		Assert.assertNotNull(object);

		Assert.assertTrue(!containsDeclaration(declaration));

		_map.put(declaration, object);

	}
}