package de.uniwue.ki.mas.xml.writer;

import java.util.ArrayList;
import java.util.List;

import de.uniwue.ki.mas.basics.functionCall.IFunctionCallDeclaration;
import de.uniwue.ki.mas.xml.IDelaySettings;
import de.uniwue.ki.mas.xml.castor.v01.model.XMLFunctionCall;

/**
 * Insert the type's description here.
 * Creation date: (22.08.2001 08:49:46)
 * @author Christoph Oechslein
 */
final class DelaySetterHelper {

	protected final XMLModelWriter _xmlModelWriter;
	private final List _delaySettingsList = new ArrayList();

	public DelaySetterHelper(XMLModelWriter xmlModelWriter) {
		super();

		_xmlModelWriter = xmlModelWriter;
	}

	public void addDelaySettings(
		Object outerObject,
		XMLFunctionCall functionCall,
		IFunctionCallDeclaration functionCallDeclaration) {

		addDelaySettings(
			new FunctionDelaySettings(_xmlModelWriter, outerObject, functionCall, functionCallDeclaration));
	}

	public void addDelaySettings(IDelaySettings delaySettings) {
		_delaySettingsList.add(delaySettings);
	}

	public void doAllDelaySettings() throws XMLWriteException {
		// the _delaySettingsList can become longer during doSetting evaluation, e.g. an atomic parametric function declaration

		while (_delaySettingsList.size() > 0) {
			IDelaySettings delaySettings = (IDelaySettings)_delaySettingsList.get(0);
			_delaySettingsList.remove(0);
			try {
				delaySettings.doSetting();
			} catch (XMLWriteException e) {
				throw e;
			} catch (Exception e) {
				throw new RuntimeException(e);
			}
		}
	}
}
