// $id:$
package de.uniwue.ki.mas.xml.writer;

import de.uniwue.ki.mas.basics.functionCall.IFunctionCallDeclaration;
import de.uniwue.ki.mas.xml.IDelaySettings;
import de.uniwue.ki.mas.xml.castor.v01.model.XMLFunctionCall;

/**
 * @author oechslein
 * 
 * Creation date: 30.05.2003
 */
public class FunctionDelaySettings implements IDelaySettings {

	private final Object _outerObject;
	private final XMLFunctionCall _functionCall;
	private final IFunctionCallDeclaration _functionCallDeclaration;
	protected final XMLModelWriter _xmlModelWriter;

	public FunctionDelaySettings(
		XMLModelWriter xmlModelWriter,
		Object outerObject,
		XMLFunctionCall functionCall,
		IFunctionCallDeclaration functionCallDeclaration) {

		super();

		_xmlModelWriter = xmlModelWriter;
		_outerObject = outerObject;
		_functionCall = functionCall;
		_functionCallDeclaration = functionCallDeclaration;
	}

	public void doSetting() throws XMLWriteException {
		_xmlModelWriter.setXMLFunctionCall(_outerObject, _functionCall, _functionCallDeclaration);
	}
}