package de.uniwue.ki.mas.xml.writer;

import java.util.HashMap;
import java.util.Map;

import junit.framework.Assert;

import de.uniwue.ki.util.ClassSequenceKeyGenerator;

/**
 * Creation date: (25.07.2001 17:03:51)
 * @author Christoph Oechslein
 */
public class UniqueIdMapper {
   private final Map _idMap = new HashMap();
   private final ClassSequenceKeyGenerator _sequenceKeyGenerator = new ClassSequenceKeyGenerator();

public UniqueIdMapper() {
   super();
}

public String getId(Object anObject) {
   if (Assert.ASSERTION_ON) Assert.assertNotNull(anObject);

   if (!_idMap.containsKey(anObject)) {
      _idMap.put(anObject, createString(anObject));
   }

   return (String) _idMap.get(anObject);
}

private String createString(Object anObject) {
   String className = anObject.getClass().getName();
   String classNameWithoutPackage = className.substring(className.lastIndexOf(".") + 1);
   int id = _sequenceKeyGenerator.getNextId(anObject);

   if (classNameWithoutPackage.endsWith("Declaration"))
      return classNameWithoutPackage.substring(0, classNameWithoutPackage.length() - "Declaration".length()) + "_" + id;
   else
      return classNameWithoutPackage + "_" + id;
}
}
