package de.uniwue.ki.util;
import java.util.HashMap;
import java.util.Map;/**
 * Creation date: (19.09.2000 17:06:43)
 * @author Christoph Oechslein
 */
public class ClassSequenceKeyGenerator {
	private final Map nextIdMap = new HashMap();

	/**
	 * SequenceKeyGenerator constructor comment.
	 */
	public ClassSequenceKeyGenerator() {
	   super();
	}

	/**
	 * @param anObject Object
	 * @return int
	 */
	public final int getNextId(Object anObject) {
	   Class aClass = anObject.getClass();
	   if (nextIdMap.containsKey(aClass)) {
	      Integer oldValue = (Integer) nextIdMap.get(aClass);
	      nextIdMap.put(aClass, new Integer(oldValue.intValue() + 1));
	      return oldValue.intValue();
	   } else {
	      nextIdMap.put(aClass, new Integer(1));
	      return 0;
	   }
	}

	/**
	 * Insert the method's description here.
	 * Creation date: (19.10.2000 17:35:05)
	 * @author Christoph Oechslein
	 * @param anObject Object
	 * @param usedId Integer
	 */
	public void setUsedId(Object anObject, Integer usedId) {
	    Class aClass = anObject.getClass();
	    nextIdMap.put(aClass, usedId);
	}

	/**
	 * Insert the method's description here.
	 * Creation date: (19.09.2000 17:07:57)
	 * @return java.util.Map
	 */
	protected final Map getNextIdMap() {
	   return nextIdMap;
	}
}