package de.uniwue.ki.util;
import edu.oswego.cs.dl.util.concurrent.ThreadFactory;
/**
 * @author oechslein
 *
 */
public final class DefaultThreadFactory implements ThreadFactory {
	private final String _name;
	private final int _priority;
	private final boolean _daemon;

	public DefaultThreadFactory() {
		this("Background Thread", Thread.MIN_PRIORITY, true);
	}

	public DefaultThreadFactory(String name, int priority, boolean daemon) {
		super();

		_name = name;
		_priority = priority;
		_daemon = daemon;
	}

	public Thread newThread(Runnable command) {
		Thread thread = new Thread(command, _name);
		thread.setPriority(_priority);
		thread.setDaemon(_daemon);
		return thread;
	}
}