package de.uniwue.ki.util;

/**
 * Creation date: 12.06.2002, 17:50:26
 * @author oechslein
 */
public final class Pair {
	private final Object _objectA;
	private final Object _objectB;

	public Pair(Object objectA, Object objectB) {
		_objectA = objectA;
		_objectB = objectB;
	}

	public boolean equals(Object anObject) {
		if (this == anObject)
			return true;

		if (!(anObject instanceof Pair))
			return false;

		Pair pair = (Pair) anObject;

		return Utils.equals(getObjectA(), pair.getObjectA()) && Utils.equals(getObjectB(), pair.getObjectB());
	}

	public final Object getObjectA() {
		return _objectA;
	}

	public final Object getObjectB() {
		return _objectB;
	}

	public int hashCode() {
		return ((getObjectA() == null) ? 0 : getObjectA().hashCode())
			+ 3 * ((getObjectB() == null) ? 0 : getObjectB().hashCode());
	}
}
