package de.uniwue.ki.util;

/**
 * Creation date: 12.06.2002, 17:50:26
 * @author oechslein
 */
public final class Triple {
	private final Object _objectA;
	private final Object _objectB;
	private final Object _objectC;

	public Triple(Object objectA, Object objectB, Object objectC) {
		_objectA = objectA;
		_objectB = objectB;
		_objectC = objectC;
	}

	public boolean equals(Object anObject) {
		if (this == anObject)
			return true;

		if (!(anObject instanceof Triple))
			return false;

		Triple pair = (Triple) anObject;

		return Utils.equals(getObjectA(), pair.getObjectA())
			&& Utils.equals(getObjectB(), pair.getObjectB())
			&& Utils.equals(getObjectC(), pair.getObjectC());
	}

	public final Object getObjectA() {
		return _objectA;
	}

	public final Object getObjectB() {
		return _objectB;
	}

	public final Object getObjectC() {
		return _objectC;
	}

	public int hashCode() {
		return ((getObjectA() == null) ? 0 : getObjectA().hashCode())
			+ ((getObjectB() == null) ? 0 : 3 * getObjectB().hashCode())
			+ ((getObjectC() == null) ? 0 : 5 * getObjectC().hashCode());
	}
}
