package de.uniwue.ki.util.collection;
import java.util.Iterator;
import java.util.List;/**
 * Insert the class' description here.
 * Creation date: (25.05.00 10:49:18)
 * @author Christoph Oechslein
 */

class ConsIterator extends SingletonIterator implements IConsIterator {
	private final Iterator rest;

	/**
	 * iteratorToConsIterator method comment.
	 * @param it Iterator
	 * @return IConsIterator
	 */
	public static final IConsIterator toConsIterator(Iterator it) {
	   if (it instanceof IConsIterator) {
	      return (IConsIterator) it;
	   } else if (it.hasNext()) {
	      Object nextElement = it.next();
	      if (it.hasNext()) {
	         return new ConsIterator(nextElement, toConsIterator(it));
	      } else {
	         return new SingletonIterator(nextElement);
	      }
	   } else {
	      return IConsIterator.EMPTY_CONS_ITERATOR;
	   }
	}

	/**
	 * iteratorToConsIterator method comment.
	 * @param l List
	 * @return IConsIterator
	 */
	public static final IConsIterator toConsIterator(List l) {
	    return toConsIterator(l.iterator());
	}

	/**
	 * hasNext method comment.
	 * @return boolean
	 * @see java.util.Iterator#hasNext()
	 */
	public final boolean hasNext() {
	   if (super.hasNext())
	      return true;
	   else
	      return rest.hasNext();
	}

	/**
	 * next method comment.
	 * @return Object
	 * @see java.util.Iterator#next()
	 */
	public final Object next() {
	   if (super.hasNext())
	      return super.next();
	   else
	      return rest.next();
	}

	/**
	 * @return IConsIterator
	 * @see de.uniwue.ki.util.collection.IConsIterator#rest()
	 */
	public final IConsIterator rest() {
	    if (rest instanceof IConsIterator)
	        return (IConsIterator) rest;
	    else
	        return toConsIterator(rest);
	}

	protected ConsIterator(Object first, Iterator rest) {
	    super(first);
	
	    this.rest = rest;
	}
}