package de.uniwue.ki.util.collection;
import java.util.List;
/**
 * Creation date: (28.11.2000 13:13:52)
 * @author Christoph Oechslein
 */

public class DelegateListIteratorWithException extends AbstractIteratorWithException {
	protected final List _delegate;

	protected int _cursor = 0;
	protected int _lastRet = -1;

	public boolean hasNext() {
		return _cursor != _delegate.size();
	}

	public Object nextWithException() throws Exception {
		Object next = _delegate.get(_cursor);
		_lastRet = _cursor++;
		return next;
	}

	public void remove() {
		if (_lastRet == -1)
			throw new IllegalStateException();

		_delegate.remove(_lastRet);
		if (_lastRet < _cursor)
			_cursor--;
		_lastRet = -1;
	}

	protected DelegateListIteratorWithException(List delegate) {
		super();

		_delegate = delegate;
	}

	static IteratorWithException createIteratorWithException(List delegate) {
		if (delegate.isEmpty()) {
			return CollectionsHelper.EMPTY_ITERATOR_WITH_EXCEPTION;
		} else {
			return new DelegateListIteratorWithException(delegate);
		}
	}
}