package de.uniwue.ki.util.collection;

import java.util.Iterator;
import java.util.List;

import junit.framework.Assert;

import de.uniwue.ki.util.functions.ITwoArgResultFunction;

/**
 * @author oechslein
 * 
 * Creation date: 13.05.2003
 */
final class FunctionCartesianProductIteratorWithException extends AbstractIteratorWithException {
	private final ITwoArgResultFunction _twoArgResultFunction;
	private final IteratorWithException _iterator1;
	private final List _list2;

	private Iterator _currIterator2;
	private Object _currObjectFrom2;
	private Object _currObjectFrom1;

	public FunctionCartesianProductIteratorWithException(
		ITwoArgResultFunction twoArgResultFunction,
		IteratorWithException iterator1,
		List list2)
		throws Exception {

		Assert.assertTrue(iterator1.hasNext());
		Assert.assertFalse(list2.isEmpty());

		_twoArgResultFunction = twoArgResultFunction;

		_iterator1 = iterator1;
		_list2 = list2;

		_currIterator2 = list2.iterator();
		_currObjectFrom1 = _iterator1.nextWithException();
	}

	protected void nextItem() throws Exception {
		if (!_currIterator2.hasNext()) {
			_currIterator2 = _list2.iterator();
			_currObjectFrom1 = _iterator1.nextWithException();
		}

		_currObjectFrom2 = _currIterator2.next();
	}

	public Object nextWithException() throws Exception {
		nextItem();
		Object currObj1 = _currObjectFrom1;
		Object currObj2 = _currObjectFrom2;
		return _twoArgResultFunction.execute(currObj1, currObj2);
	}

	public boolean hasNext() {
		if (!_iterator1.hasNext()) {
			return _currIterator2.hasNext();
		} else {
			return true;
		}
	}
}
