package de.uniwue.ki.util.collection;
import java.util.Iterator;

/**
 * Creation date: (27.04.00 17:29:04)
 * @author
 */
class IteratorWithExceptionAdapter extends AbstractIterator implements IteratorWithException {
	private Iterator delegateIterator;

	private IteratorWithExceptionAdapter(Iterator delegateIterator) {
		super();
		this.delegateIterator = delegateIterator;
	}

	static IteratorWithException createIteratorWithException(Iterator it) {
		if (it instanceof IteratorWithException) {
			return (IteratorWithException)it;
		} else if (!it.hasNext()) {
			return CollectionsHelper.EMPTY_ITERATOR_WITH_EXCEPTION;
		} else {
			return new IteratorWithExceptionAdapter(it);
		}
	}

	public boolean hasNext() {
		return delegateIterator.hasNext();
	}

	public Object next() {
		return delegateIterator.next();
	}

	public Object nextWithException() throws Exception {
		return next();
	}

	public void remove() {
		delegateIterator.remove();
	}
}