package de.uniwue.ki.util.collection;
import java.util.Iterator;

import de.uniwue.ki.util.functions.IMapFunction;

/**
 * <BR>Creation date: (12.04.00 11:00:19)
 * @author Christoph Oechslein
 */
class MapIterator extends AbstractIterator implements Iterator {
	private Iterator delegateIterator;
	private IMapFunction mapFunction;


	public MapIterator(Iterator delegateIterator, IMapFunction mapFunction) {
		super();
		this.delegateIterator = delegateIterator;
		this.mapFunction = mapFunction;
	}


	public final boolean hasNext() {
		return delegateIterator.hasNext();
	}


	public final Object next() {
		Object delegateObj = delegateIterator.next();
		try {
			return mapFunction.map(delegateObj);

		} catch (Exception e) {
			if (e instanceof RuntimeException)
				throw (RuntimeException) e;
			else
				throw new RuntimeException(e);
		}
	}

	public final void remove() {
		throw new UnsupportedOperationException();
	}
}