package de.uniwue.ki.util.collection;
import de.uniwue.ki.util.functions.IMapFunction;

/**
 * <BR>Creation date: (12.04.00 11:00:19)
 * @author Christoph Oechslein
 */
class MapIteratorWithException extends AbstractIteratorWithException {
	private IteratorWithException _delegateIterator;
	private IMapFunction _mapFunction;

	public MapIteratorWithException(IteratorWithException delegateIterator, IMapFunction mapFunction)
		throws Exception {

		super();

		_delegateIterator = delegateIterator;
		_mapFunction = mapFunction;
	}

	public final boolean hasNext() {
		return _delegateIterator.hasNext();
	}

	public final Object nextWithException() throws Exception {
		Object obj = _delegateIterator.nextWithException();
		return _mapFunction.map(obj);
	}

	public final void remove() {
		throw new UnsupportedOperationException();
	}
}