package de.uniwue.ki.util.collection;
import java.util.Iterator;
import java.util.NoSuchElementException;

import de.uniwue.ki.util.Utils;
/**
 * <BR>Creation date: (14.04.00 16:34:08)
 * @author Christoph Oechslein
 */
class RemoveObjectIterator extends AbstractIterator implements Iterator {
	private Iterator _activeIterator;
	private Object _filterObject;
	private Object _currentElement;

	public RemoveObjectIterator(Iterator iterator, Object filterObject) {
		super();

		_activeIterator = iterator;
		_filterObject = filterObject;

		searchNextElement();
	}

	public boolean hasNext() {
		return (_currentElement != null);
	}

	public Object next() throws NoSuchElementException {
		if (!hasNext())
			throw new NoSuchElementException();
		
		Object oldElement = _currentElement;
		searchNextElement();
		return oldElement;
	}

	public void remove() {
		throw new UnsupportedOperationException();
	}

	private void searchNextElement() {
		try {
			while (_activeIterator.hasNext()) {
				Object currentLocalElement = _activeIterator.next();
				if (!Utils.equals(_filterObject, currentLocalElement)) {
					_currentElement = currentLocalElement;
					return;
				}
			}
		} catch (Exception e) {
			throw new RuntimeException(e);
		}
		_currentElement = null;
		_activeIterator = null;
		_filterObject = null;
	}
}