package de.uniwue.ki.util.collection;
import java.util.NoSuchElementException;

import junit.framework.Assert;

import de.uniwue.ki.util.Utils;
/**
 * <BR>Creation date: (14.04.00 16:34:08)
 * @author Christoph Oechslein
 */class RemoveObjectIteratorWithException extends AbstractIteratorWithException {
	private IteratorWithException _activeIterator;
	private Object _filterObject;
	private Object _currentElement;

	public RemoveObjectIteratorWithException(IteratorWithException activeIterator, Object filterObject)
		throws Exception {
		super();

		Assert.assertNotNull(activeIterator);

		_activeIterator = activeIterator;
		_filterObject = filterObject;

		searchNextElement();
	}

	public boolean hasNext() {
		return (_activeIterator != null);
	}

	public Object nextWithException() throws Exception {
		if (!hasNext())
			throw new NoSuchElementException();

		Object oldElement = _currentElement;
		searchNextElement();
		return oldElement;
	}

	public void remove() {
		throw new UnsupportedOperationException();
	}

	private void searchNextElement() throws Exception {
		while (_activeIterator.hasNext()) {
			Object currentLocalElement = _activeIterator.nextWithException();
			if (!Utils.equals(_filterObject, currentLocalElement)) {
				_currentElement = currentLocalElement;
				return;
			}
		}

		_currentElement = null;
		_activeIterator = null;
		_filterObject = null;
	}
}