package de.uniwue.ki.util.collection;
import java.util.NoSuchElementException;

import junit.framework.Assert;

import de.uniwue.ki.util.functions.IPredicateFunction;

/**
 * <BR>Creation date: (14.04.00 16:34:08)
 * @author Christoph Oechslein
 */

class SelectIteratorWithException extends AbstractIteratorWithException {
	private IteratorWithException _activeIterator;
	private IPredicateFunction _filterFunction;
	private Object _currentElement;

	public SelectIteratorWithException(IteratorWithException iterator, IPredicateFunction filterFunction)
		throws Exception {
		super();

		Assert.assertNotNull(iterator);
		Assert.assertNotNull(filterFunction);

		_activeIterator = iterator;
		_filterFunction = filterFunction;
		searchNextElement();
	}

	public boolean hasNext() {
		return (_activeIterator != null);
	}

	public Object nextWithException() throws Exception {
		if (!hasNext())
			throw new NoSuchElementException();
		
		Object oldElement = _currentElement;
		searchNextElement();
		return oldElement;
	}

	public void remove() {
		throw new UnsupportedOperationException();
	}

	private void searchNextElement() throws Exception {
		while (_activeIterator.hasNext()) {
			Object currentLocalElement = _activeIterator.nextWithException();
			if (_filterFunction.isElementOk(currentLocalElement)) {
				_currentElement = currentLocalElement;
				return;
			}
		}
		_currentElement = null;
		_activeIterator = null;
		_filterFunction = null;
	}
}