package de.uniwue.ki.util.collection;
import java.util.NoSuchElementException;
/**
 * Creation date: (06.04.2001 15:53:00)
 * @author Christoph Oechslein
 */
class SingletonIterator extends AbstractIterator implements IConsIterator {
	private Object _object = null;
	private boolean _hasNext = true;

	public SingletonIterator(Object anObject) {
		super();

		_object = anObject;
	}

	public Object first() {
		return _object;
	}

	public boolean hasNext() {
		return _hasNext;
	}

	public Object next() throws NoSuchElementException {
		if (!_hasNext)
			throw new NoSuchElementException();

		_hasNext = false;
		return _object;
	}

	public void remove() {
		throw new UnsupportedOperationException();
	}

	public IConsIterator rest() {
		return IConsIterator.EMPTY_CONS_ITERATOR;
	}
}