package de.uniwue.ki.util.comparator;
import java.util.Comparator;

import de.uniwue.ki.util.Utils;
import de.uniwue.ki.util.functions.IMapFunction;
/**
 * Creation date: (12.10.2000 18:13:55)
 * @author Christoph Oechslein
 */public class MapComparator implements Comparator {
	private final Comparator _delegate;
	private final IMapFunction _mapFunction;

	public MapComparator(Comparator delegate, IMapFunction mapFunction) {
		super();

		_delegate = delegate;
		_mapFunction = mapFunction;
	}

	public final int compare(Object o1, Object o2) {
		try {
			return _delegate.compare(_mapFunction.map(o1), _mapFunction.map(o2));

		} catch (Exception e) {
			throw new RuntimeException(e);
		}
	}

	public boolean equals(Object obj) {
		if (obj == null)
			return false;
		else
			return (obj.getClass() == getClass())
				&& Utils.equals(((MapComparator)obj)._delegate, _delegate)
				&& Utils.equals(((MapComparator)obj)._mapFunction, _mapFunction);
	}

	public int hashCode() {
		return 5 * getClass().hashCode() + 3 * _delegate.hashCode() + _mapFunction.hashCode();
	}
}