package de.uniwue.ki.util.comparator;
import java.text.Collator;
import java.util.Comparator;

import de.uniwue.ki.util.name.INamed;/**
 * Creation date: (12.10.2000 18:13:55)
 * @author Christoph Oechslein
 */
public class NamedComparator implements Comparator {
	private static final NamedComparator _instance = new NamedComparator();

	public NamedComparator() {
	    super();
	}

	public final int compare(Object o1, Object o2) {
	    return compareNamed((INamed) o1, (INamed) o2);
	}

	private final int compareNamed(INamed o1, INamed o2) {
		return Collator.getInstance().compare(o1.getName(), o2.getName());
	}

	public boolean equals(Object obj) {
		if (obj == null)
			return false;
		else
			return obj.getClass() == getClass();
	}

	public int hashCode() {
		return getClass().hashCode();
	}

	public static final NamedComparator getInstance() {
	    return _instance;
	}
}