package de.uniwue.ki.util.comparator;
import java.util.Comparator;

import de.uniwue.ki.util.Utils;
/**
 * Creation date: (12.10.2000 18:13:55)
 * @author Christoph Oechslein
 */public class ReverseComparator implements Comparator {
	private final Comparator _delegate;

	public ReverseComparator(Comparator delegate) {
		super();

		_delegate = delegate;
	}

	public final int compare(Object o1, Object o2) {
		return _delegate.compare(o2, o1);
	}

	public boolean equals(Object obj) {
		if (obj == null)
			return false;
		else
			return (obj.getClass() == getClass())
				&& Utils.equals(((ReverseComparator)obj)._delegate, _delegate);
	}

	public int hashCode() {
		return 3 * getClass().hashCode() + _delegate.hashCode();
	}
}