package de.uniwue.ki.util.copy;
import java.util.Map;

import de.uniwue.ki.util.name.AbstractNamed;
import de.uniwue.ki.util.name.INamed;

/**
 * Creation date: (11.04.00 15:00:41)
 * @author Christoph Oechslein
 */
public abstract class AbstractCopyable extends AbstractNamed implements ICopyable {

	public AbstractCopyable() {
		super();
	}


	public ICopyable copy(Map objectMapping) {
		if ((objectMapping != null) && (objectMapping.containsKey(this))) {
			return (ICopyable) objectMapping.get(this);
		} else {
			ICopyable newObject = createInstance(objectMapping);

			if (newObject == this)
				return this;

			else {
				copyInto(newObject, objectMapping);

				return newObject;
			}
		}
	}


	public void copyInto(Object intoObject, Map objectMapping) {
		// super.copyInto(intoObject, objectMapping);
	}


	public static String createCopyNameOf(INamed namedObject) {
		return createCopyNameOf(namedObject.getName());
	}

	public static String createCopyNameOf(String name) {
		return "Copy of " + name;
	}

	protected ICopyable createInstance(Map objectMapping) {
		try {
			return (ICopyable) getClass().newInstance();

		} catch (InstantiationException exception) {
			throw new RuntimeException(exception);

		} catch (IllegalAccessException exception) {
			throw new RuntimeException(exception);
		}
	}
}