package de.uniwue.ki.util.event;
import java.lang.ref.WeakReference;
import java.util.Iterator;

import javax.swing.event.ListDataEvent;
import javax.swing.event.ListDataListener;
/**
 * Creation date: (30.10.2001 18:21:16)
 * @author Christoph Oechslein
 */
public final class ListDataMulticaster extends AbstractListenerMulticaster implements ListDataListener {
	private static final ListenerMulticasterFactory _listenerMulticasterFactory =
		new ListenerMulticasterFactory() {
		public AbstractListenerMulticaster createAbstractListenerMulticaster() {
			return new ListDataMulticaster();
		}

		public Object createObject() {
			return createAbstractListenerMulticaster();
		}

		public String getName() {
			return "ListDataMulticasterFactory";
		}
	};

	protected ListDataMulticaster() {
		super();
	}

	public static final ListDataListener add(
		ListDataListener listDataListener,
		ListDataListener listDataListenerToAdd) {

		return (ListDataListener)AbstractListenerMulticaster.add(
			listDataListener,
			listDataListenerToAdd,
			_listenerMulticasterFactory);
	}

	public static final ListDataListener remove(
		ListDataListener listDataListener,
		ListDataListener listDataListenerToRemove) {

		return (ListDataListener)AbstractListenerMulticaster.remove(
			listDataListener,
			listDataListenerToRemove);
	}

	public void intervalAdded(ListDataEvent e) {
		Iterator it = getListeners();
		while (it.hasNext()) {
			WeakReference reference = (WeakReference)it.next();
			ListDataListener element = (ListDataListener)reference.get();
			if (element == null)
				it.remove();
			else
				element.intervalAdded(e);
		}
	}

	public void intervalRemoved(ListDataEvent e) {
		Iterator it = getListeners();
		while (it.hasNext()) {
			WeakReference reference = (WeakReference)it.next();
			ListDataListener element = (ListDataListener)reference.get();
			if (element == null)
				it.remove();
			else
				element.intervalRemoved(e);
		}
	}

	public void contentsChanged(ListDataEvent e) {
		Iterator it = getListeners();
		while (it.hasNext()) {
			WeakReference reference = (WeakReference)it.next();
			ListDataListener element = (ListDataListener)reference.get();
			if (element == null)
				it.remove();
			else
				element.contentsChanged(e);
		}
	}
}