package de.uniwue.ki.util.event;
import java.lang.ref.WeakReference;
import java.util.Iterator;

import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
/**
 * Creation date: (30.10.2001 18:21:16)
 * @author Christoph Oechslein
 */
public final class StateChangeMulticaster extends AbstractListenerMulticaster implements ChangeListener {
	private static final ListenerMulticasterFactory _listenerMulticasterFactory =
		new ListenerMulticasterFactory() {
		public AbstractListenerMulticaster createAbstractListenerMulticaster() {
			return new StateChangeMulticaster();
		}

		public Object createObject() {
			return createAbstractListenerMulticaster();
		}

		public String getName() {
			return "StateChangeMulticasterFactory";
		}
	};

	protected StateChangeMulticaster() {
		super();
	}

	public void stateChanged(ChangeEvent changeEvent) {
		Iterator it = getListeners();
		while (it.hasNext()) {
			WeakReference reference = (WeakReference)it.next();
			ChangeListener element = (ChangeListener)reference.get();
			if (element == null)	
				it.remove();
			else
				element.stateChanged(changeEvent);
		}
	}

	public static final ChangeListener add(
		ChangeListener changeListener,
		ChangeListener changeListenerToAdd) {

		return (ChangeListener)AbstractListenerMulticaster.add(
			changeListener,
			changeListenerToAdd,
			_listenerMulticasterFactory);
	}

	public static final ChangeListener remove(
		ChangeListener changeListener,
		ChangeListener changeListenerToRemove) {

		return (ChangeListener)AbstractListenerMulticaster.remove(changeListener, changeListenerToRemove);
	}
}