package de.uniwue.ki.util.list;

import java.util.Map;

import de.uniwue.ki.util.copy.AbstractCopyable;

/**
 * Creation date: (14.11.2001 13:07:01)
 * @author Christoph Oechslein
 */
public abstract class AbstractMutableListModelAndFactory
	extends AbstractCopyable
	implements IMutableListModelAndFactory {

	public final void copyInto(Object intoObject, Map objectMapping) {
		super.copyInto(intoObject, objectMapping);

		IMutableListModelAndFactory intoMutableListModelAndFactory = (IMutableListModelAndFactory) intoObject;

		getMutableListModel().copyInto(intoMutableListModelAndFactory.getMutableListModel(), objectMapping);
	}

	public String getName() {
		return getMutableListModel().getName();
	}

	public final Object getFirstObjectOrCreateNewIfEmpty() throws Exception {
		if (getMutableListModel().isEmpty()) {
			Object newObject = getObjectFactory().createObject();
			getMutableListModel().add(newObject);
			return newObject;

		} else {
			return getMutableListModel().get(0);
		}
	}
}