package de.uniwue.ki.util.list;
import java.util.ArrayList;
import java.util.List;
/**
 * Creation date: (26.11.2001 16:46:44)
 * @author Christoph Oechslein
 */
public class DefaultMutableListModel extends AbstractMutableListModel {
	private final List _delegate;

	public DefaultMutableListModel() {
		this(new ArrayList());
	}

	public DefaultMutableListModel(int size) {
		this(new ArrayList(size));
	}

	public DefaultMutableListModel(List delegate) {
		super();

		_delegate = delegate;
	}

	public void add(int index, Object newObject) {
		_delegate.add(index, newObject);

		fireIntervalAdded(this, index, index);
	}

	public Object get(int index) {
		return _delegate.get(index);
	}

	public Object remove(int index) {
		return removeIntern(index);
	}

	public Object set(int index, Object newObject) {
		Object oldObject = get(index);

		_delegate.set(index, newObject);

		fireContentsChanged(this, index, index);

		return oldObject;
	}

	public int size() {
		return _delegate.size();
	}

	protected Object removeIntern(int index) {

		Object oldObject = get(index);

		_delegate.remove(index);

		fireIntervalRemoved(this, index, index);

		return oldObject;
	}
}