package de.uniwue.ki.util.name;

import java.util.Iterator;

/**
 * Creation date: 04.09.2002, 18:59:29
 * @author oechslein
 */
public abstract class AbstractNamed implements INamed {
	private static final int MAX_DEPTH = 10;
	public AbstractNamed() {
		super();
	}

	public String toString() {
		StringBuffer buff = new StringBuffer();

		buff.append(super.toString());

		buff.append("[");
		appendName(buff, 0, MAX_DEPTH);
		buff.append("]");

		return buff.toString();
	}

	public void appendName(StringBuffer buff, int currDepth, int maxDepth) {
		if (currDepth >= maxDepth) {
			buff.append("...");
		} else
			buff.append(getName());
	}

	protected String getNameIntern() {
		StringBuffer buff = new StringBuffer();
		appendName(buff, 0, MAX_DEPTH);
		return buff.toString();
	}

	public static void append(Iterator it, StringBuffer buff, int currDepth, int maxDepth) {
		if (currDepth >= maxDepth) {
			buff.append("...");
			
		} else {
			while (it.hasNext()) {
				INamed element = (INamed) it.next();

				if (element instanceof AbstractNamed) {
					((AbstractNamed) element).appendName(buff, currDepth + 1, maxDepth);
				} else {
					buff.append(element.getName());
				}

				if (it.hasNext()) {
					buff.append(", ");
				}
			}
		}
	}
}