package de.uniwue.ki.util.name;
import java.beans.PropertyChangeListener;

import javax.swing.event.ChangeListener;

/**
 * Creation date: (19.10.2000 12:42:52)
 * @author Christoph Oechslein
 */
public interface IDocumentable extends INamed {

	/**
	 * Add a change listener, if something changes in this declaration
	 * (or in dependend declarations) a {@link ChangeEvent change event} is fired.
	 *
	 * @see# removeChangeListener(ChangeListener)
	 */
	void addChangeListener(ChangeListener newListener);

	/**
	 * Adds property change listener.
	 *
	 * @see #removePropertyChangeListener(PropertyChangeListener)
	 */
	void addPropertyChangeListener(PropertyChangeListener listener);

	/**
	 * Adds property listener for <code>propertyName</code> property change events.
	 *
	 * @see #removePropertyChangeListener(String,PropertyChangeListener)
	 */
	void addPropertyChangeListener(String propertyName, PropertyChangeListener listener);

	String getDocumentation();

	/**
	 * Returns a short description of this object.
	 *
	 * @see #setShortDescription(String)
	 */
	String getShortDescription();

	boolean getUsesShortDescription();

	/**
	 * Removes a change listener.
	 *
	 * @see addChangeListener(ChangeListener)
	 */
	void removeChangeListener(ChangeListener newListener);

	/**
	 * Removes property change listener.
	 *
	 * @see #addPropertyChangeListener(PropertyChangeListener)
	 */
	
	void removePropertyChangeListener(PropertyChangeListener listener);

	/**
	 * Removes property listener for <code>propertyName</code> property change events.
	 *
	 * @see #addPropertyChangeListener(String,PropertyChangeListener)
	 */
	void removePropertyChangeListener(String propertyName, PropertyChangeListener listener);

	void setDocumentation(String newDocumentation);

	/**
	 * Returns a short description of this object.
	 *
	 * @see #getShortDescription()
	 */
	void setShortDescription(String newDescription);

	void setUsesShortDescription(boolean shortDescription);
}