package de.uniwue.ki.util.rectangular;
import java.io.Serializable;
import java.util.Iterator;

import de.uniwue.ki.util.IRemoveable;
import de.uniwue.ki.util.rectangular.event.*;
/**
 * Creation date: (15.11.2000 13:34:27)
 * @author Christoph Oechslein
 */
public interface IRectangularMapModel extends Serializable, IRemoveable {

	void addObject(int col, int row, Object anObject);

	void addPropertyChangeListener(java.beans.PropertyChangeListener listener);

	void addRectangularMapChangedListener(RectangularMapChangedListener newListener);

	void addRectangularMapObjectAddedListener(RectangularMapObjectAddedListener newListener);

	void addRectangularMapObjectRemovedListener(RectangularMapObjectRemovedListener newListener);

	void changePosition(int oldCol, int oldRow, int newCol, int newRow, java.lang.Object anObject);

	void fireMapChanged();

	void fireObjectAdded(Object addedObject, int col, int row);

	void fireObjectRemoved(Object removedObject, int col, int row);

	void firePositionChanged(int col, int row);

	Iterator getAllObjects();

	Iterator getAllObjects(int startX, int startY, int endX, int endY);

	int getColsCount();

	Object getObjectAt(int col, int row, int index);

	int getObjectCount(int col, int row);

	Iterator getObjectsAt(int col, int row);

	int getRowsCount();

	boolean isAdjustable();

	boolean isTorus();

	void removeObject(int col, int row, Object anObject);

	void removeObjectAt(int col, int row, int index);

	void removePropertyChangeListener(java.beans.PropertyChangeListener listener);

	void removeRectangularMapChangedListener(RectangularMapChangedListener newListener);

	void removeRectangularMapObjectAddedListener(RectangularMapObjectAddedListener newListener);

	void removeRectangularMapObjectRemovedListener(RectangularMapObjectRemovedListener newListener);

	void setColsCount(int newColsCount);

	void setRowsCount(int newRowsCount);

	void setTorus(boolean newSetting);
}