package de.uniwue.ki.util.rectangular;/**
 * Creation date: (15.11.2000 14:54:52)
 * @author Christoph Oechslein
 */
public class RectangularMapIndexOutOfBoundException extends RuntimeException {





	private final int col;
	private final int row;

	/**
	 * RectangularMapIndexOutOfBoundException constructor comment.
	 */
	public RectangularMapIndexOutOfBoundException() {
	    this(-1, -1);
	}

	/**
	 * RectangularMapIndexOutOfBoundException constructor comment.
	 * @param col int
	 * @param row int
	 */
	public RectangularMapIndexOutOfBoundException(int col, int row) {
	    super("Index out of Bounds");
	
	    this.col = col;
	    this.row = row;
	}

	/**
	 * RectangularMapIndexOutOfBoundException constructor comment.
	 * @param s java.lang.String
	 */
	public RectangularMapIndexOutOfBoundException(String s) {
	    this(s, -1, -1);
	}

	/**
	 * RectangularMapIndexOutOfBoundException constructor comment.
	 * @param message String
	 * @param col int
	 * @param row int
	 */
	public RectangularMapIndexOutOfBoundException(String message, int col, int row) {
	    super(message);
	
	    this.col = col;
	    this.row = row;
	}

	/**
	     * Returns the errort message string of this throwable object.
	     *
	    @link #Throwable(String) created} with an
	     *          error message string; or <code>null</code> if it was
	     *          {@link #Throwable() created} with no error message.
	     *
	     * @return  the error message string of this <code>Throwable</code>
	     *          object if it was { */
	public String getMessage() {
	    if ((col == -1) && (row == -1))
	        return super.getMessage();
	    else
	        return super.getMessage() + " [col=" + col + ", row=" + row + "]";
	}
}