package de.uniwue.ki.util.rectangular.event;/**
 * This is the event class to support the RectangularMapChangedListener interface.
 * @author oechslein
 */
public class RectangularMapChangedEvent extends java.util.EventObject {
	private final int eventType;
	public static final int MAP_CHANGED = 0;
	public static final int POSITION_CHANGED = 1;
	private final int row;
	private final int col;

	/**
	 * RectangularMapChangedEvent constructor comment.
	 * @param source java.lang.Object
	 */
	public RectangularMapChangedEvent(java.lang.Object source) {
	    this(source, -1, -1, MAP_CHANGED);
	}

	/**
	 * RectangularMapChangedEvent constructor comment.
	 * @param source java.lang.Object
	 * @param col int
	 * @param row int
	 */
	public RectangularMapChangedEvent(java.lang.Object source, int col, int row) {
	    this(source, col, row, POSITION_CHANGED);
	}

	/**
	     * RectangularMapChangedEvent constructor comment.
	     * @param source java.lang.Object
	     */
	protected RectangularMapChangedEvent(java.lang.Object source, int col, int row, int type) {
	    super(source);
	
	    this.eventType = type;
	
	    this.row = row;
	    this.col = col;
	}

	/**
	 * Insert the method's description here.
	 * Creation date: (15.11.2000 15:47:59)
	 * @author Christoph Oechslein
	 * @return int
	 */
	public final int getCol() {
	    return col;
	}

	/**
	 * Insert the method's description here.
	 * Creation date: (15.11.2000 15:47:59)
	 * @author Christoph Oechslein
	 * @return int
	 */
	public final int getRow() {
	    return row;
	}

	/**
	 * Insert the method's description here.
	 * Creation date: (15.11.2000 15:47:59)
	 * @author Christoph Oechslein
	 * @return int
	 */
	public final int getType() {
	    return eventType;
	}
}