package de.uniwue.ki.util.rectangular.event;/**
 * This is the event multicaster class to support the RectangularMapObjectAddedListenerinterface.
 */
public class RectangularMapObjectAddedEventMulticaster extends java.awt.AWTEventMulticaster implements RectangularMapObjectAddedListener {

	/**
	 * Constructor to support multicast events.
	 * @param a java.util.EventListener
	 * @param b java.util.EventListener
	 */
	protected RectangularMapObjectAddedEventMulticaster(java.util.EventListener a, java.util.EventListener b) {
	    super(a, b);
	}

	/**
	 * Add new listener to support multicast events.
	 * @param a RectangularMapObjectAddedListener
	 * @param b RectangularMapObjectAddedListener
	 * @return RectangularMapObjectAddedListener
	 */
	public static RectangularMapObjectAddedListener add(
	    RectangularMapObjectAddedListener a,
	    RectangularMapObjectAddedListener b) {
	    return (RectangularMapObjectAddedListener) addInternal(a, b);
	}

	/**
	 * Add new listener to support multicast events.
	 * @return java.util.EventListener
	 * @param a java.util.EventListener
	 * @param b java.util.EventListener
	 */
	protected static java.util.EventListener addInternal(java.util.EventListener a, java.util.EventListener b) {
	    if (a == null)
	        return b;
	    if (b == null)
	        return a;
	    return new RectangularMapObjectAddedEventMulticaster(a, b);
	}

	/**
	 *
	 * @param event RectangularMapObjectAddedEvent
	 * @see de.uniwue.ki.util.rectangular.event.RectangularMapObjectAddedListener#objectAdded(RectangularMapObjectAddedEvent)
	 */
	public void objectAdded(RectangularMapObjectAddedEvent event) {
	    ((RectangularMapObjectAddedListener) a).objectAdded(event);
	    ((RectangularMapObjectAddedListener) b).objectAdded(event);
	}

	/**
	 *
	 * @return java.util.EventListener
	 * @param oldl RectangularMapObjectAddedListener
	 */
	protected java.util.EventListener remove(RectangularMapObjectAddedListener oldl) {
	    if (oldl == a)
	        return b;
	    if (oldl == b)
	        return a;
	    java.util.EventListener a2 = removeInternal(a, oldl);
	    java.util.EventListener b2 = removeInternal(b, oldl);
	    if (a2 == a && b2 == b)
	        return this;
	    return addInternal(a2, b2);
	}

	/**
	 * Remove listener to support multicast events.
	 * @param l RectangularMapObjectAddedListener
	 * @param oldl RectangularMapObjectAddedListener
	 * @return RectangularMapObjectAddedListener
	 */
	public static RectangularMapObjectAddedListener remove(
	    RectangularMapObjectAddedListener l,
	    RectangularMapObjectAddedListener oldl) {
	    if (l == oldl || l == null)
	        return null;
	    if (l instanceof RectangularMapObjectAddedEventMulticaster)
	        return (RectangularMapObjectAddedListener)
	            ((RectangularMapObjectAddedEventMulticaster) l).remove(oldl);
	    return l;
	}
}