package de.uniwue.ki.util.rectangular.event;/**
 * This is the event multicaster class to support the RectangularMapObjectRemovedListenerinterface.
 */
public class RectangularMapObjectRemovedEventMulticaster extends java.awt.AWTEventMulticaster implements RectangularMapObjectRemovedListener {

	/**
	 * Constructor to support multicast events.
	 * @param a java.util.EventListener
	 * @param b java.util.EventListener
	 */
	protected RectangularMapObjectRemovedEventMulticaster(java.util.EventListener a, java.util.EventListener b) {
	    super(a, b);
	}

	/**
	 * Add new listener to support multicast events.
	 * @param a RectangularMapObjectRemovedListener
	 * @param b RectangularMapObjectRemovedListener
	 * @return RectangularMapObjectRemovedListener
	 */
	public static RectangularMapObjectRemovedListener add(
	    RectangularMapObjectRemovedListener a,
	    RectangularMapObjectRemovedListener b) {
	    return (RectangularMapObjectRemovedListener) addInternal(a, b);
	}

	/**
	 * Add new listener to support multicast events.
	 * @return java.util.EventListener
	 * @param a java.util.EventListener
	 * @param b java.util.EventListener
	 */
	protected static java.util.EventListener addInternal(java.util.EventListener a, java.util.EventListener b) {
	    if (a == null)
	        return b;
	    if (b == null)
	        return a;
	    return new RectangularMapObjectRemovedEventMulticaster(a, b);
	}

	/**
	 *
	 * @param event RectangularMapObjectRemovedEvent
	 */
	public void objectRemoved(RectangularMapObjectRemovedEvent event) {
	    ((RectangularMapObjectRemovedListener) a).objectRemoved(event);
	    ((RectangularMapObjectRemovedListener) b).objectRemoved(event);
	}

	/**
	 *
	 * @return java.util.EventListener
	 * @param oldl RectangularMapObjectRemovedListener
	 */
	protected java.util.EventListener remove(
	    RectangularMapObjectRemovedListener oldl) {
	    if (oldl == a)
	        return b;
	    if (oldl == b)
	        return a;
	    java.util.EventListener a2 = removeInternal(a, oldl);
	    java.util.EventListener b2 = removeInternal(b, oldl);
	    if (a2 == a && b2 == b)
	        return this;
	    return addInternal(a2, b2);
	}

	/**
	 * Remove listener to support multicast events.
	 * @param l RectangularMapObjectRemovedListener
	 * @param oldl RectangularMapObjectRemovedListener
	 * @return RectangularMapObjectRemovedListener
	 */
	public static RectangularMapObjectRemovedListener remove(
	    RectangularMapObjectRemovedListener l,
	    RectangularMapObjectRemovedListener oldl) {
	    if (l == oldl || l == null)
	        return null;
	    if (l instanceof RectangularMapObjectRemovedEventMulticaster)
	        return (RectangularMapObjectRemovedListener)
	            ((RectangularMapObjectRemovedEventMulticaster) l).remove(oldl);
	    return l;
	}
}