package de.uniwue.ki.util.table;

import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.table.DefaultTableModel;

import junit.framework.Assert;

import org.jfree.ui.SortableTable;

/**
 * @author oechslein
 * 
 * Creation date: 10.06.2003
 */
public class DisableColumnsTableModelTest {

	public static void main(String[] args) {
		JFrame frame = new JFrame();
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		DefaultTableModel tableModel =
			new DefaultTableModel(new Object[][] {
				new Object[] { "Row1-1", "Row1-2", "Row1-3", "Row1-4" },
				new Object[] { "Row2-1", "Row2-2", "Row2-3", "Row2-4" }

		}, new Object[] { "Col1", "Col2", "Col3", "Col4" });

		DisableColumnsTableModel disableColumnsTableModel = new DisableColumnsTableModel(tableModel);

		Assert.assertEquals(4, disableColumnsTableModel.getColumnCount());
		Assert.assertEquals(tableModel.getRowCount(), disableColumnsTableModel.getRowCount());

		Assert.assertSame(tableModel.getValueAt(0, 0), disableColumnsTableModel.getValueAt(0, 0));

		disableColumnsTableModel.setDisabled(0, true);

		Assert.assertEquals(3, disableColumnsTableModel.getColumnCount());
		Assert.assertEquals(tableModel.getRowCount(), disableColumnsTableModel.getRowCount());

		Assert.assertSame(tableModel.getValueAt(0, 1), disableColumnsTableModel.getValueAt(0, 0));

		//		disableColumnsTableModel.setDisabled(0, false);
		//
		//		Assert.assertEquals(4, disableColumnsTableModel.getColumnCount());
		//		Assert.assertEquals(tableModel.getRowCount(), disableColumnsTableModel.getRowCount());
		//
		//		Assert.assertSame(tableModel.getValueAt(0, 0), disableColumnsTableModel.getValueAt(0, 0));

		disableColumnsTableModel.setDisabled(2, true);


		SortableTable table = new SortableTable(disableColumnsTableModel);
		table.setAutoCreateColumnsFromModel(true);

		frame.setContentPane(new JScrollPane(table));
		frame.pack();
		frame.show();
	}
}
