package mygale.mcge.cmd;


import java.awt.*;

import mygale.mcge.core.JGraphEditor;
import mygale.mcge.fig.IFig;

/** Cmd to align to the bottom selected objects.
 *
 */
public class CmdAlignBottom extends CmdAlign {


    /** Construct a new CmdAlignBottom.
     *
     * @param editor a reference to the current editor.
     * @param iconSize int
 */
    public CmdAlignBottom(JGraphEditor editor, int iconSize) {
    super(editor, "Align Bottom", iconSize, "general/AlignBottom" );
    }


protected Point getNewLocation(IFig fig, Point oldLocation) {
   Rectangle rSelect = getGraph().getSelection().getBounds();
   int bottom = rSelect.y + rSelect.height;

   int new_y = bottom - fig.getHeight();
   return new Point(oldLocation.x, new_y);
}


/** Return the tooltip text associated to the command.
     *
     * @return a string that is the tooltip of this command.
     */
    public String getToolTipText() {
    return "align objects to the bottom" ;
    }
}