package mygale.mcge.cmd;



import java.awt.*;

import mygale.mcge.core.JGraphEditor;
import mygale.mcge.fig.IFig;

/** Cmd to align verticaly to the center selected objects.
 *
 */
public class CmdAlignHCenter extends CmdAlign {



/** Return the tooltip text associated to the command.
     *
     * @return a string that is the tooltip of this command.
     */
    public String getToolTipText() {
    return "horizontaly center objects" ;
    }

protected Point getNewLocation(IFig fig, Point oldLocation) {
   Rectangle rSelect = getGraph().getSelection().getBounds();

   int middle = rSelect.x + rSelect.width / 2;
   int new_x = middle - fig.getWidth() / 2;

   return new Point(new_x, oldLocation.y);
}


     /** Construct a new CmdAlignHCenter.
     *
     * @param editor a reference to the current editor.
     * @param iconSize int
 */
    public CmdAlignHCenter(JGraphEditor editor, int iconSize) {
    super(editor, "Center Horizontal", iconSize, "general/AlignJustifyHorizontal" );
    }
}
