package mygale.mcge.cmd;



import java.awt.*;

import mygale.mcge.core.JGraphEditor;
import mygale.mcge.fig.IFig;

/** Cmd to align to the left selected objects.
 *
 */
public class CmdAlignLeft extends CmdAlign {



/** Return the tooltip text associated to the command.
     *
     * @return a string that is the tooltip of this command.
     */
    public String getToolTipText() {
    return "align objects to the left" ;
    }

protected Point getNewLocation(IFig fig, Point oldLocation) {
   Rectangle rSelect = getGraph().getSelection().getBounds();

   return new Point(rSelect.x, oldLocation.y);
}


    /** Construct a new CmdAlignLeft.
     *
     * @param editor a reference to the current editor.
     * @param iconSize int
 */
    public CmdAlignLeft(JGraphEditor editor, int iconSize) {
    super(editor, "AlignLeft", iconSize, "general/AlignLeft" );
    }
}
