package mygale.mcge.cmd;



import java.awt.*;

import mygale.mcge.core.JGraphEditor;
import mygale.mcge.fig.IFig;

/** Cmd to align to the right selected objects.
 *
 */
public class CmdAlignRight extends CmdAlign {



/** Return the tooltip text associated to the command.
     *
     * @return a string that is the tooltip of this command.
     */
    public String getToolTipText() {
    return "align objects to the right" ;
    }

protected Point getNewLocation(IFig fig, Point oldLocation) {
   Rectangle rSelect = getGraph().getSelection().getBounds();

   int right = rSelect.x + rSelect.width;
   int new_x = right - fig.getWidth();

   return new Point(new_x, oldLocation.y);
}


    /** Construct a new CmdAlignRight.
     *
     * @param editor a reference to the current editor.
     * @param iconSize int
 */
    public CmdAlignRight(JGraphEditor editor, int iconSize) {
    super(editor, "Align Right", iconSize, "general/AlignRight" );
    }
}
