package mygale.mcge.cmd;



import java.awt.*;

import mygale.mcge.core.JGraphEditor;
import mygale.mcge.fig.IFig;

/** Cmd to align to the top selected objects.
 *
 */
public class CmdAlignTop extends CmdAlign {



/** Return the tooltip text associated to the command.
     *
     * @return a string that is the tooltip of this command.
     */
    public String getToolTipText() {
    return "align objects to the top" ;
    }

protected Point getNewLocation(IFig fig, Point oldLocation) {
   Rectangle rSelect = getGraph().getSelection().getBounds();

   return new Point(oldLocation.x, rSelect.y);
}


    /** Construct a new CmdAlignTop.
     *
     * @param editor a reference to the current editor.
     * @param iconSize int
 */
    public CmdAlignTop(JGraphEditor editor, int iconSize) {
    super(editor, "Align Top", iconSize, "general/AlignTop" );
    }
}
