package mygale.mcge.cmd;



import java.awt.*;

import mygale.mcge.core.JGraphEditor;
import mygale.mcge.fig.IFig;

/** Cmd to align verticaly to the center selected objects.
 *
 */
public class CmdAlignVCenter extends CmdAlign {



/** Return the tooltip text associated to the command.
     *
     * @return a string that is the tooltip of this command.
     */
    public String getToolTipText() {
    return "verticaly center objects" ;
    }

protected Point getNewLocation(IFig fig, Point oldLocation) {
   Rectangle rSelect = getGraph().getSelection().getBounds();

   int middle = rSelect.y + rSelect.height / 2;
   int new_y = middle - fig.getHeight() / 2;

   return new Point(oldLocation.x, new_y);
}


    /** Construct a new CmdAlignVCenter.
     *
     * @param editor a reference to the current editor.
     * @param iconSize int
 */
    public CmdAlignVCenter(JGraphEditor editor, int iconSize) {
    super(editor, "Center Vertically", iconSize, "general/AlignJustifyVertical" );
    }
}
