package mygale.mcge.cmd;



import java.util.Vector;

import mygale.mcge.core.*;
import mygale.mcge.sel.Selection;

/** Cmd to deselect all objects in the workspace.
 *
*/
public class CmdDeselectAll extends CmdGraphEditor {

	/** This is the old selection that will be used
	 *  to undoing/redoing this command.
	 */
	protected Vector _oldSelection = null;


    /** Construct a new CmdDeselectAll.
     *
     * @param editor a reference to the current editor.
     */
    public CmdDeselectAll(JGraphEditor editor) {
    super(editor, null);
    }

/** Perform whatever Cmd this Cmd is meant to do. Subclasses
     *  should override this to do whatever is intended.
     *
     * @throws mygale.mcge.throwable.MCGEInternalError something wrong !
     */
public void doIt() {
   JGraph graph = getGraph();
   Selection sel = graph.getSelection();
   sel.deselectAll();
}

/** Return the tooltip text associated to the command.
     *
     * @return a string that is the tooltip of this command.
     */
    public String getToolTipText() {
    return "select all objects" ;
    }

/** Return <code>true</code> if this action should be available
     *  to the user. Sublass implementations of this method should
     *  always call <code>super.shouldBeEnabled()</code> first.
     *
     * @return <code>true</code> if this command is enabled,
     *         otherwise <code>false</code>.
     */
public boolean shouldBeEnabled() {
   // at initializing
    if (getGraph() == null)
        return false;
    else
   return (getGraph().getSelection().size() > 0);
}
}
