package mygale.mcge.cmd;
// Copyright (C) 2000  Mahdi Hannoun, Stphane Galland
//
// This program is free software; you can redistribute it and/or modify


import mygale.mcge.core.*;
import mygale.mcge.fig.IFigEdge;
import mygale.mcge.mode.ModeModifyEdgeCtrlPoint;
import mygale.mcge.sel.Selection;

/** Cmd to lock Figs from view.

 */
public class CmdModifyEdgeCtrlPoint extends CmdGraphEditor {




/** Perform whatever Cmd this Cmd is meant to do. Subclasses
     *  should override this to do whatever is intended.
     *
     * @throws mygale.mcge.throwable.MCGEInternalError something wrong !
     */
    public void doIt() {
   JGraph graph = getGraph();

        graph.beginMode( new ModeModifyEdgeCtrlPoint(graph.getModeManager()) ) ;
    }


/** Return the tooltip text associated to the command.
     *
     * @return a string that is the tooltip of this command.
     */
    public String getToolTipText() {
    return "modify the control points of an edge" ;
    }


/** Return <code>true</code> if this action should be available
     *  to the user. Sublass implementations of this method should
     *  always call <code>super.shouldBeEnabled()</code> first.
     *
     * @return <code>true</code> if this command is enabled,
     *         otherwise <code>false</code>.
     */
public boolean shouldBeEnabled() {
   JGraph graph = getGraph();

   // at initializing
    if (getGraph() == null)
        return false;
    else {
         Selection sel = graph.getSelection();
         if (sel.size() == 1) {
            if (sel.getAllFigs().next() instanceof IFigEdge) {
               return super.shouldBeEnabled();
            }
           }
           return false;
    }}

/** Construct a new CmdModifyEdgeCtrlPoint.
     *
     * @param editor a reference to the current editor.
     * @param iconSize int
 */
    public CmdModifyEdgeCtrlPoint(JGraphEditor editor, int iconSize) {
	    
    super(editor, "Modify Ctrl Points", iconSize, "mygale/CtrlPoint.gif");
    }
}