package mygale.mcge.cmd;



import mygale.mcge.core.*;

/** Cmd to run the selection mode.
 *  This command asks to the
 *  {@link mygale.mcge.mode.ModeManager ModeManager} to
 *  be in the default stable state.

 */
public class CmdSelect extends CmdGraphEditor {



/** Perform whatever Cmd this Cmd is meant to do. Subclasses
     *  should override this to do whatever is intended.
     *
     * @throws mygale.mcge.throwable.MCGEInternalError something wrong !
     */
    public void doIt() {
   JGraph graph = getGraph();

        graph.getModeManager().resetModes();
    }

/** Return the tooltip text associated to the command.
     *
     * @return a string that is the tooltip of this command.
     */
    public String getToolTipText() {
    return "return to the default mode" ;
    }


    /** Construct a new CmdSelect.
     *
     * @param editor a reference to a graph editor
     */
    public CmdSelect(JGraphEditor editor, int iconSize) {
    super(editor, "Select", iconSize, "general/Select" );
    }
}
