package mygale.mcge.cmd;



import java.util.Iterator;

import mygale.mcge.core.*;
import mygale.mcge.fig.IFigLayered;
import mygale.mcge.layer.LayerDiagram;
import mygale.mcge.sel.Selection;

/** Cmd to select all objects in the workspace.
 *
 */
public class CmdSelectAll extends CmdGraphEditor {


    /** Construct a new CmdSelectAll.
     *
     * @param editor a reference to a graph editor.
     */
    public CmdSelectAll(JGraphEditor editor) {
    super(editor, "Select All");
    }

/** Perform whatever Cmd this Cmd is meant to do. Subclasses
     *  should override this to do whatever is intended.
     *
     * @throws mygale.mcge.throwable.MCGEInternalError somthing wrong !
     */
public void doIt() {
   JGraph graph = getGraph();

         Selection sel = graph.getSelection();
         boolean oldInform = sel.setCmdInform(false);
         Iterator it = ((LayerDiagram) graph.getLayerManager().getActiveLayer()).getAllFigs();
         while (it.hasNext()) {
            sel.select((IFigLayered) it.next());
         }
         sel.setCmdInform(oldInform);
         sel.informCmd();
}

/** Return the tooltip text associated to the command.
     *
     * @return a string that is the tooltip of this command.
     */
    public String getToolTipText() {
    return "select all objects" ;
    }

/** Return <code>true</code> if this action should be available
     *  to the user. Sublass implementations of this method should
     *  always call <code>super.shouldBeEnabled()</code> first.
     *
     * @return <code>true</code> if this command is enabled,
     *         otherwise <code>false</code>.
     */
    public boolean  shouldBeEnabled() {
   JGraph graph = getGraph();

   // at initializing
    if (getGraph() == null)
        return false;
    else {
        Selection sel = graph.getSelection();
        return sel.size() < ((LayerDiagram)graph.getLayerManager().getActiveLayer()).getContents().size();
    }}
}
