package mygale.mcge.core;

// Copyright (C) 2000  Mahdi Hannoun, Stphane Galland
//
// This program is free software; you can redistribute it and/or modify


import java.awt.Insets;

import javax.swing.*;

import mygale.mcge.cmd.Cmd;

/** This is a specific implantation of a toolbar.
 *  This one allows tooltips.
 *  <p><center>
 *    <img src="doc-files/JGraphToolBar_uml.gif" width="191" height="84" border="0" usemap="#umlclick">
 *    <map name="umlclick">
 *      <area shape="Rect" coords="117,55,190,83"  href="JGraph.html">
 *      <area shape="Rect" coords="117,0,190,28"  href="JGraphEditor.html">
 *      <area shape="Rect" coords="0,0,72,28"  href="http://java.sun.com/products/jdk/1.2/docs/api/javax/swing/JToolBar.html">
 *    </map>
 *  </center></p>

 */
public class JGraphToolBar extends JToolBar {
//
// Constructor

/** Construct a new JGraphToolBar.
 */
public JGraphToolBar() {
    super();

    putClientProperty("JToolBar.isRollover", Boolean.TRUE);
}

/** Add a Action into the toolbar.
     *  This method automaticaly set the tooltip.
     *
     * @param action the action to add.
     * @return the button that run the given action.
     */
    public JButton add( Action action ) {
    Cmd cmd =  (Cmd) action ;
    JButton button = null ;
    button = super.add(cmd) ;
    button.setToolTipText( cmd.getToolTipText() ) ;
    button.setText("") ;
    button.setMargin(new Insets(0,0,0,0));
    return button ;
    }
}
