package mygale.mcge.demo;



import java.awt.Color;
import java.awt.event.*;

import javax.swing.*;

/** This is a button that permits to choose a color.
 *
 */
public class JColorButton extends JButton {

	/** Title of colorchooser dialog box.
	 */
	protected String _dlgTitle;

	/** Current color.
	 */
	protected Color _theColor;

	/** A reference to a colorchooser.
	 */
	protected JColorChooser _theChooser = null;

/** Construct a new JColorbutton.
     *
     * @param initialColor initial color.
     * @param dlgTitle title of the colorchoose dialog box.
     */
    public JColorButton( Color initialColor, String dlgTitle ) {
    super( getColorText( initialColor ) );

    _dlgTitle = new String( dlgTitle );
    _theColor = new Color(initialColor.getRGB());

    setBackground( _theColor );

    addActionListener
        ( new ActionListener () {
            public void actionPerformed (ActionEvent evt) {
            _theChooser = new JColorChooser( _theColor );
            JDialog dlg = JColorChooser.createDialog( JColorButton.this,
                                  _dlgTitle,
                                  true,
                                  _theChooser,
                                  new ActionListener() {
                                      public void actionPerformed(ActionEvent e) {
                                          JColorButton.this.setColor( _theChooser.getColor() );
                                      }
                                      },
                                  null );
            dlg.show();
            _theChooser = null;
            JColorButton.this.actionPerformed(evt);
            }
        }
          );
    }

/** Reply a text that describes the given
     *  color (RGB quantities).
     *
     * @param c a color.
     * @return a text that describes the RGB
     *         quantites of the given color.
     */
    public static String getColorText(Color c) {
    return new String( "R:" + c.getRed() + ", V:" + c.getGreen() + ", B:" + c.getBlue() );
    }

/**
 * @param evt ActionEvent
 */
public void actionPerformed (ActionEvent evt) { }

/** Return the color.
     *
     * @return the current color.
     */
    public Color getColor() { return _theColor; }

/** Change the current color.
     *
     * @param c the new color.
     */
    public void setColor(Color c) {
    _theColor = new Color( c.getRGB() );
    setText( getColorText(_theColor) );
    setBackground( _theColor );
    }
}
