package mygale.mcge.fig;

/** FigEdgeLinear class for representing edges between
 *  {@link FigPort ports}. It is draw with a only one line (no path).
 *  <p><center>
 *    <img src="doc-files/FigEdgeLinear_uml.gif" width="93" height="83" border="0" usemap="#umlclick">
 *    <map name="umlclick">
 *      <area shape="Rect" coords="10,0,82,28"  href="FigEdge.html">
 *    </map>
 *  </center></p>
 *
 */
//TODO knnte gelscht werden - wird in SeSAm nicht bentigt - nur noch im mcge-Demo
public class FigEdgeLinear extends AbstractFigEdge {

	/** Return the max number of control point for the edge : 2 for
	     * a linear edge.
	     *
	     * @return always 2
	     * @see mygale.mcge.fig.IFigEdge#getMaxAllowedCtrlPoints()
	 */
	public int getMaxAllowedCtrlPoints() {
		return 2;
	}

	/** Construct a new FigEdgeLinear.
	     */
	public FigEdgeLinear() {
		super();
	}

	/** Contruct a new FigEdgeLinear.
	 *
	 * @param xfrom horizontal position of the begin point for this FigEdge.
	 * @param yfrom vertical position of the begin point for this FigEdge.
	 * @param xto horizontal position of the end point for this FigEdge.
	 * @param yto vertical position of the end point for this FigEdge.
	 */
	public FigEdgeLinear(int xfrom, int yfrom, int xto, int yto) {
		super(xfrom, yfrom, xto, yto);
	}
}
