package mygale.mcge.fig;

/** FigEdgePoly classe for representing edges between
 *  {@link FigPort ports}. It is draw with a polyline.
 *  <p><center>
 *    <img src="doc-files/FigEdgePoly_uml.gif" width="93" height="83" border="0" usemap="#umlclick">
 *    <map name="umlclick">
 *      <area shape="Rect" coords="10,0,82,28"  href="FigEdge.html">
 *    </map>
 *  </center></p>
 *
 */

public class FigEdgePoly extends AbstractFigEdge {

	/** Construct a new FigEdgePoly.
	     */
	public FigEdgePoly() {
		super();
	}

	/** Contruct a new FigEdgePoly.
	 *
	 * @param xfrom horizontal position of the begin point for this FigEdge.
	 * @param yfrom vertical position of the begin point for this FigEdge.
	 * @param xto horizontal position of the end point for this FigEdge.
	 * @param yto vertical position of the end point for this FigEdge.
	 */
	public FigEdgePoly(int xfrom, int yfrom, int xto, int yto) {
		super(xfrom, yfrom, xto, yto);
	}

	/** return the max number of control point for the edge :
	 *  <code>Interger.MAX_VALUE</code> for a poly edge.
	 *
	 * @return always <code>Interger.MAX_VALUE</code>.
	 * @see mygale.mcge.fig.IFigEdge#getMaxAllowedCtrlPoints()
	*/
	public int getMaxAllowedCtrlPoints() {
		return Integer.MAX_VALUE;
	}
}
