package mygale.mcge.fig;

import java.awt.*;

import mygale.mcge.util.prefs.Prefs;

/** This class permits to draw a text into the workspace.
 *  <p><center>
 *    <img src="doc-files/FigText_uml.gif" width="75" height="83" border="0" usemap="#umlclick">
 *    <map name="umlclick">
 *      <area shape="Rect" coords="0,0,73,27"  href="FigRect.html">
 *    </map>
 *  </center></p>
 *
 */
//TODO knnte gelscht werden, da nicht von SeSAm verwendet.
public class FigText extends FigRect {

	/** This is the text that must be drawn.
	 */
	protected String _caption = "Please set this text area";

	/** Construct a new FigText.
	     */
	public FigText() {
		super();

		_filled = false;
	}

	/** Return the caption.
	     *
	     * @return the caption.
	     */
	public String getCaption() {
		return _caption;
	}

	/** Change the caption.
	 *
	 * @param caption the new caption.
	 */
	public void setCaption(String caption) {
		_caption = caption;
		if (_caption == null)
			_caption = "Please set this text area";
		fireStateChanged();
	}

	////
	// Painting methods

	/** Method to paint this Fig.
	 *
	 * @param g2d the graphic context.
	 * @param prefs Prefs
	 */
	public void paintContent(Graphics2D g2d, Prefs prefs) {
		super.paintContent(g2d, prefs);
		// Draw the caption
		if (_caption != null) {
			FontMetrics fm = g2d.getFontMetrics();
			int x = getX() + (getWidth() - fm.stringWidth(_caption)) / 2;
			int y = getY() + (getHeight() - fm.getHeight()) / 2;
			drawClippedString(g2d, _caption, x, y);
		}
	}
}