package mygale.mcge.fig;


import mygale.mcge.net.INetObject;

/** This interface represents the model element figures.
 *  <p><center>
 *    <img src="doc-files/FigObject_uml.gif" width="214" height="88" border="0" usemap="#umlclick">
 *    <map name="umlclick">
 *      <area shape="Rect" coords="0,59,100,87"  href="FigModelElement.html">
 *      <area shape="Rect" coords="140,0,212,28"  href="../net/NetObject.html">
 *      <area shape="Rect" coords="140,59,212,87"  href="FigInternal.html">
 *    </map>
 *  </center></p>
 *
 */
public interface IFigObject extends IFig {



   /** Reply the {@link mygale.mcge.net.NetObject NetObject}
    *  that owns this Fig.
    *
    * @return a {@link mygale.mcge.net.NetObject NetObject}.
    */
   INetObject getNetObject();

   /** Set the {@link mygale.mcge.net.NetObject NetObject}
        *  that owns this Fig.
        *
        * @param netobject a {@link mygale.mcge.net.NetObject NetObject}.
        */
   void setNetObject(INetObject netobject);
}