package mygale.mcge.fig.arrow;

/**
 * Creation date: (22.03.2001 16:20:14)
 
 */
public class ArrowFilledArrow extends Arrow {
	/*
		* This is the size of each arrow's branch.
		*/
	protected int _branchLength = 5;
	protected int _arrowLength = 10;

	/**
	 * ArrowFilledArrow constructor comment.
	 */
	public ArrowFilledArrow() {
		super();
	}

	/** Reply the height of the arrow, before the rotation.
	     *
	     * @return an integer that is the height of this arrow.
	     */
	public int getHeight() {
		return 2 * _branchLength + 1;
	}

	/** Reply the width of the arrow, before the rotation.
	 *
	 * @return a integer that is the width of this arrow.
	 */
	public int getWidth() {
		return _arrowLength;
	}

	/** Paint the arrow.
	 *  the point (<var>x</var>,<var>y</var>) is the point
	 *  where the arrow will be connect to a port.
	 *  You must paint the arrow on the <b>right</b> of this
	 *  point to be outside the node
	 *  and to the <b>left</b> to be inside the node.
	 *
	 * @param g the graphical context in which this arrow must be painted.
	 * @param x x coordinate of the "origin".
	 * @param y y coordinate of the "origin".
	 */
	public void paintContent(java.awt.Graphics2D g, int x, int y, mygale.mcge.util.prefs.Prefs prefs) {

		g.setColor(getShapeColor(prefs));

		java.awt.Polygon polygon = new java.awt.Polygon();
		polygon.addPoint(x, y);
		if ((y + _branchLength) % 2 == 0)
			polygon.addPoint(x + _arrowLength, y + _branchLength);
		else
			polygon.addPoint(x + _arrowLength, y + _branchLength - 1);

		polygon.addPoint(x + _arrowLength, y - _branchLength);

		//g.drawPolygon(polygon);
		g.fillPolygon(polygon);
	}
}
