package mygale.mcge.net;


/** Abstract {@link mygale.mcge.net.NetObject NetObject}
 *  class for representing edges between
 *  {@link mygale.mcge.net.NetPort ports}.
 *  <p><center>
 *    <img src="doc-files/NetEdge_uml.gif" width="348" height="157" border="0" usemap="#umlclick">
 *    <map name="umlclick">
 *      <area shape="Rect" coords="118,0,190,28"  href="NetObject.html">
 *      <area shape="Rect" coords="0,59,73,86"  href="../core/JGraph.html">
 *      <area shape="Rect" coords="248,59,356,86"  href="NetEdgeImpl.html">
 *      <area shape="Rect" coords="59,118,131,145"  href="NetPort.html">
 *      <area shape="Rect" coords="172,118,280,145"  href="NetGraphModel.html">
 *    </map>
 *  </center></p>
 *
 */
public interface INetEdge extends INetObject {

   /** Reply the begin {@link mygale.mcge.net.NetPort connection port}.
        *
        * @return {@link mygale.mcge.net.NetPort connection port}.
        */
   INetNode getBeginNode();

   /** Reply the end {@link mygale.mcge.net.NetPort connection port}.
        *
        * @return {@link mygale.mcge.net.NetPort connection port}.
        */
   INetNode getEndNode();



   /** This method is called when the node was removed from the model.
    */
   void removed();

   /** Set the begin {@link mygale.mcge.net.NetPort connection port}.
        *
        * @param port {@link mygale.mcge.net.NetPort connection port}.
        */
   void setBeginNode(INetNode port);

   /** Set the end {@link mygale.mcge.net.NetPort connection port}.
        *
        * @param port {@link mygale.mcge.net.NetPort connection port}.
        */
   void setEndNode(INetNode port);
}