package mygale.mcge.net;

import java.io.Serializable;

import javax.swing.event.ChangeListener;




/** This is the semantic object that composes a graph model.
 *  <p><center>
 *    <img src="doc-files/NetObject_uml.gif" width="349" height="151" border="0" usemap="#umlclick">
 *    <map name="umlclick">
 *      <area shape="Rect" coords="145,0,217,28"  href="../core/JGraph.html">
 *      <area shape="Rect" coords="23,59,95,85"  href="../fig/FigObject.html">
 *      <area shape="Rect" coords="266,59,338,87"  href="NetObjectImpl.html">
 *      <area shape="Rect" coords="0,122,90,150"  href="NetGraphModel.html">
 *      <area shape="Rect" coords="104,122,176,150"  href="NetEdge.html">
 *      <area shape="Rect" coords="190,122,262,150"  href="NetNode.html">
 *      <area shape="Rect" coords="275,122,348,150"  href="NetPort.html">
 *    </map>
 *  </center></p>
 *
 */
public interface INetObject extends Serializable {

   /** This method decides if the node can be deleted.
    */
   boolean canBeRemoved();

   void removeChangeListener(ChangeListener changeListener);

   void addChangeListener(ChangeListener changeListener);
}