package mygale.mcge.undoredo;


/** This interface defined a redoable command.
 *  A redoable command is a command that can be
 *  run by the way of a redo command.
 *  <p><center>
 *    <img src="doc-files/RedoableCmd_uml.gif" width="120" height="156" border="0" usemap="#umlclick">
 *    <map name="umlclick">
 *      <area shape="Rect" coords="10,0,109,28"  href="UndoRedoableCmd.html">
 *      <area shape="Rect" coords="0,127,118,155"  href="UndoRedoManagerImpl.html">
 *    </map>
 *  </center></p>
 *
 */
public interface RedoableCmd extends UndoRedoableCmd {

   /** This method was called by the redo command.
        *  It must redo something.
        */
   void redoIt();
}