package mygale.mcge.undoredo;


/** This interface defined a undoable command.
 *  A undoable command is a command that can be
 *  run by the way of a undo command.
 *  <p><center>
 *    <img src="doc-files/UndoableCmd_uml.gif" width="246" height="156" border="0" usemap="#umlclick">
 *    <map name="umlclick">
 *      <area shape="Rect" coords="10,0,109,28"  href="UndoRedoableCmd.html">
 *      <area shape="Rect" coords="145,64,244,91"  href="UndoRedoManager.html">
 *      <area shape="Rect" coords="0,127,118,155"  href="UndoRedoManagerImpl.html">
 *    </map>
 *  </center></p>
 * */
public interface UndoableCmd extends UndoRedoableCmd {

   /** This method was called by the undo command.
        *  It must undo something.
        */
   void undoIt();
}